export default {
    "info": "This file is sourced from https://github.com/iann0036/iam-dataset",
    "sdk_permissionless_actions": [
        "DynamoDB.DescribeEndpoints",
        "STS.GetCallerIdentity",
        "STS.GetSessionToken"
    ],
    "sdk_method_iam_mappings": {
        "Budgets.CreateBudget": [
            {
                "action": "budgets:ModifyBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${Budget.BudgetName}"
                    }
                }
            }
        ],
        "Budgets.CreateNotification": [
            {
                "action": "budgets:ModifyBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.CreateSubscriber": [
            {
                "action": "budgets:ModifyBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.DeleteBudget": [
            {
                "action": "budgets:ModifyBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.DeleteNotification": [
            {
                "action": "budgets:ModifyBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.DeleteSubscriber": [
            {
                "action": "budgets:ModifyBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.DescribeBudget": [
            {
                "action": "budgets:ViewBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.DescribeBudgetPerformanceHistory": [
            {
                "action": "budgets:ViewBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.DescribeBudgets": [
            {
                "action": "budgets:ViewBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Budgets.DescribeNotificationsForBudget": [
            {
                "action": "budgets:ViewBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.DescribeSubscribersForNotification": [
            {
                "action": "budgets:ViewBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.UpdateBudget": [
            {
                "action": "budgets:ModifyBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${NewBudget.BudgetName}"
                    }
                }
            }
        ],
        "Budgets.UpdateNotification": [
            {
                "action": "budgets:ModifyBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.UpdateSubscriber": [
            {
                "action": "budgets:ModifyBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "CloudSearchDomain.Search": [
            {
                "action": "cloudsearch:search",
                "resource_mappings": {
                    "DomainName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudSearchDomain.Suggest": [
            {
                "action": "cloudsearch:suggest",
                "resource_mappings": {
                    "DomainName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudSearchDomain.UploadDocuments": [
            {
                "action": "cloudsearch:upload",
                "resource_mappings": {}
            }
        ],
        "DynamoDB.BatchExecuteStatement": [
            {
                "action": "dynamodb:PartiQLSelect",
                "conditions": {
                    "lhs": "Statements[].Statement",
                    "op": "IContains",
                    "rhs": "SELECT "
                }
            },
            {
                "action": "dynamodb:PartiQLInsert",
                "conditions": {
                    "lhs": "Statements[].Statement",
                    "op": "IContains",
                    "rhs": "INSERT "
                }
            },
            {
                "action": "dynamodb:PartiQLUpdate",
                "conditions": {
                    "lhs": "Statements[].Statement",
                    "op": "IContains",
                    "rhs": "UPDATE "
                }
            },
            {
                "action": "dynamodb:PartiQLDelete",
                "conditions": {
                    "lhs": "Statements[].Statement",
                    "op": "IContains",
                    "rhs": "DELETE "
                }
            }
        ],
        "DynamoDB.ExecuteStatement": [
            {
                "action": "dynamodb:PartiQLSelect",
                "conditions": {
                    "lhs": "Statement",
                    "op": "IContains",
                    "rhs": "SELECT "
                }
            },
            {
                "action": "dynamodb:PartiQLInsert",
                "conditions": {
                    "lhs": "Statement",
                    "op": "IContains",
                    "rhs": "INSERT "
                }
            },
            {
                "action": "dynamodb:PartiQLUpdate",
                "conditions": {
                    "lhs": "Statement",
                    "op": "IContains",
                    "rhs": "UPDATE "
                }
            },
            {
                "action": "dynamodb:PartiQLDelete",
                "conditions": {
                    "lhs": "Statement",
                    "op": "IContains",
                    "rhs": "DELETE "
                }
            }
        ],
        "DynamoDB.ExecuteTransaction": [
            {
                "action": "dynamodb:PartiQLSelect",
                "conditions": {
                    "lhs": "TransactStatements[].Statement",
                    "op": "IContains",
                    "rhs": "SELECT "
                }
            },
            {
                "action": "dynamodb:PartiQLInsert",
                "conditions": {
                    "lhs": "TransactStatements[].Statement",
                    "op": "IContains",
                    "rhs": "INSERT "
                }
            },
            {
                "action": "dynamodb:PartiQLUpdate",
                "conditions": {
                    "lhs": "TransactStatements[].Statement",
                    "op": "IContains",
                    "rhs": "UPDATE "
                }
            },
            {
                "action": "dynamodb:PartiQLDelete",
                "conditions": {
                    "lhs": "TransactStatements[].Statement",
                    "op": "IContains",
                    "rhs": "DELETE "
                }
            }
        ],
        "DynamoDB.TransactGetItems": [
            {
                "action": "dynamodb:GetItem",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TransactItems[].Get.TableName}"
                    }
                }
            }
        ],
        "DynamoDB.TransactWriteItems": [
            {
                "action": "dynamodb:ConditionCheckItem",
                "conditions": {
                    "lhs": "TransactItems[].ConditionCheck",
                    "op": "Exists"
                }
            },
            {
                "action": "dynamodb:PutItem",
                "conditions": {
                    "lhs": "TransactItems[].Put",
                    "op": "Exists"
                }
            },
            {
                "action": "dynamodb:UpdateItem",
                "conditions": {
                    "lhs": "TransactItems[].Update",
                    "op": "Exists"
                }
            },
            {
                "action": "dynamodb:DeleteItem",
                "conditions": {
                    "lhs": "TransactItems[].Delete",
                    "op": "Exists"
                }
            }
        ],
        "Lambda.GetLayerVersionByArn": [
            {
                "action": "lambda:GetLayerVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "layerVersion": "${Arn}"
                }
            }
        ],
        "Lambda.Invoke": [
            {
                "action": "lambda:InvokeFunction",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "S3.CopyObject": [
            {
                "action": "s3:ListBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            },
            {
                "action": "s3:GetObjectTagging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                },
                "conditions": {
                    "lhs": "TaggingDirective",
                    "op": "NotEquals",
                    "rhs": "REPLACE"
                }
            },
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            },
            {
                "action": "s3:PutObjectTagging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            },
            {
                "action": "s3:PutObjectAcl",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.DeleteBucketAnalyticsConfiguration": [
            {
                "action": "s3:PutAnalyticsConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucketCors": [
            {
                "action": "s3:PutBucketCORS",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucketEncryption": [
            {
                "action": "s3:PutEncryptionConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucketInventoryConfiguration": [
            {
                "action": "s3:PutInventoryConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucketLifecycle": [
            {
                "action": "s3:PutLifecycleConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucketMetricsConfiguration": [
            {
                "action": "s3:PutMetricsConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucketReplication": [
            {
                "action": "s3:PutReplicationConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "S3.DeleteBucketTagging": [
            {
                "action": "s3:PutBucketTagging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteObjects": [
            {
                "action": "s3:DeleteObject",
                "conditions": {
                    "lhs": "Delete.Objects[].VersionId",
                    "op": "NotExists"
                }
            },
            {
                "action": "s3:DeleteObjectVersion",
                "conditions": {
                    "lhs": "Delete.Objects[].VersionId",
                    "op": "Exists"
                }
            }
        ],
        "S3.DeletePublicAccessBlock": [
            {
                "action": "s3:PutBucketPublicAccessBlock",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketAccelerateConfiguration": [
            {
                "action": "s3:GetAccelerateConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketAnalyticsConfiguration": [
            {
                "action": "s3:GetAnalyticsConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketEncryption": [
            {
                "action": "s3:GetEncryptionConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketInventoryConfiguration": [
            {
                "action": "s3:GetInventoryConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketLifecycle": [
            {
                "action": "s3:GetLifecycleConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketLifecycleConfiguration": [
            {
                "action": "s3:GetLifecycleConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketMetricsConfiguration": [
            {
                "action": "s3:GetMetricsConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketNotificationConfiguration": [
            {
                "action": "s3:GetBucketNotification",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketReplication": [
            {
                "action": "s3:GetReplicationConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetPublicAccessBlock": [
            {
                "action": "s3:GetBucketPublicAccessBlock",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.ListBucketAnalyticsConfigurations": [
            {
                "action": "s3:GetAnalyticsConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.ListBucketInventoryConfigurations": [
            {
                "action": "s3:GetInventoryConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.ListBucketMetricsConfigurations": [
            {
                "action": "s3:GetMetricsConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.ListObjects": [
            {
                "action": "s3:ListBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.ListObjectsV2": [
            {
                "action": "s3:ListBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketAccelerateConfiguration": [
            {
                "action": "s3:PutAccelerateConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketAnalyticsConfiguration": [
            {
                "action": "s3:PutAnalyticsConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketEncryption": [
            {
                "action": "s3:PutEncryptionConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketInventoryConfiguration": [
            {
                "action": "s3:PutInventoryConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketLifecycle": [
            {
                "action": "s3:PutLifecycleConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketLifecycleConfiguration": [
            {
                "action": "s3:PutLifecycleConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketMetricsConfiguration": [
            {
                "action": "s3:PutMetricsConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketNotificationConfiguration": [
            {
                "action": "s3:PutBucketNotification",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketReplication": [
            {
                "action": "s3:PutReplicationConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "S3.PutPublicAccessBlock": [
            {
                "action": "s3:PutBucketPublicAccessBlock",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.SelectObjectContent": [
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3Control.DeleteBucketLifecycleConfiguration": [
            {
                "action": "s3-outposts:DeleteLifecycleConfiguration",
                "resource_mappings": {}
            }
        ],
        "S3Control.DeleteBucketTagging": [
            {
                "action": "s3-outposts:PutBucketTagging",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bucket": "${Bucket}"
                }
            }
        ],
        "S3Control.GetBucket": [
            {
                "action": "s3-outposts:GetBucket",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bucket": "${Bucket}"
                }
            }
        ],
        "S3Control.GetBucketLifecycleConfiguration": [
            {
                "action": "s3-outposts:GetLifecycleConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bucket": "${Bucket}"
                }
            }
        ],
        "Greengrass.GetThingRuntimeConfiguration": [
            {
                "action": "greengrass:GetThingRuntimeConfiguration",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${ThingName}"
                    }
                }
            }
        ],
        "Glue.BatchUpdatePartition": [
            {
                "action": "glue:UpdatePartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.CreatePartitionIndex": [
            {
                "action": "glue:UpdateTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.DeleteColumnStatisticsForPartition": [
            {
                "action": "glue:UpdatePartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.DeleteColumnStatisticsForTable": [
            {
                "action": "glue:UpdateTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.DeletePartitionIndex": [
            {
                "action": "glue:UpdateTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.GetColumnStatisticsForPartition": [
            {
                "action": "glue:GetPartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.GetColumnStatisticsForTable": [
            {
                "action": "glue:GetTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.GetPartitionIndexes": [
            {
                "action": "glue:GetTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Mobile.DescribeProject": [
            {
                "action": "mobilehub:GetProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "MediaPackage.ConfigureLogs": [
            {
                "action": "mediapackage:UpdateChannel",
                "resource_mappings": {
                    "ChannelIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "FSx.AssociateFileSystemAliases": [
            {
                "action": "fsx:AssociateFileSystemAliases",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "LexModelsV2.CreateBot": [
            {
                "action": "lex:PutBot",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.CreateBotAlias": [
            {
                "action": "lex:PutBotAlias",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotAlias": {
                        "template": "${botAliasName}"
                    }
                }
            }
        ],
        "LexModelsV2.CreateIntent": [
            {
                "action": "lex:PutIntent",
                "resource_mappings": {
                    "IntentName": {
                        "template": "${intentName}"
                    },
                    "IntentVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.CreateSlotType": [
            {
                "action": "lex:PutSlotType",
                "resource_mappings": {
                    "SlotName": {
                        "template": "${slotTypeName}"
                    },
                    "SlotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeIntent": [
            {
                "action": "lex:GetIntent",
                "resource_mappings": {
                    "IntentName": {
                        "template": "*"
                    },
                    "IntentVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeSlotType": [
            {
                "action": "lex:GetSlotType",
                "resource_mappings": {
                    "SlotName": {
                        "template": "*"
                    },
                    "SlotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.ListBotVersions": [
            {
                "action": "lex:GetBotVersions",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.ListBots": [
            {
                "action": "lex:GetBots",
                "resource_mappings": {}
            }
        ],
        "LexModelsV2.ListBuiltInIntents": [
            {
                "action": "lex:GetBuiltinIntents",
                "resource_mappings": {}
            }
        ],
        "LexModelsV2.ListBuiltInSlotTypes": [
            {
                "action": "lex:GetBuiltinSlotTypes",
                "resource_mappings": {}
            }
        ],
        "LexModelsV2.ListIntents": [
            {
                "action": "lex:GetIntents",
                "resource_mappings": {}
            }
        ],
        "LexModelsV2.ListSlotTypes": [
            {
                "action": "lex:GetSlotTypes",
                "resource_mappings": {}
            }
        ],
        "LexModelsV2.UpdateBot": [
            {
                "action": "lex:PutBot",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.UpdateBotAlias": [
            {
                "action": "lex:PutBotAlias",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotAlias": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.UpdateIntent": [
            {
                "action": "lex:PutIntent",
                "resource_mappings": {
                    "IntentName": {
                        "template": "*"
                    },
                    "IntentVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.UpdateSlotType": [
            {
                "action": "lex:PutSlotType",
                "resource_mappings": {
                    "SlotName": {
                        "template": "*"
                    },
                    "SlotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "S3.ListBuckets": [
            {
                "action": "s3:ListAllMyBuckets",
                "resource_mappings": {}
            }
        ],
        "S3.HeadBucket": [
            {
                "action": "s3:ListBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}",
                        "conditions": {
                            "lhs": "Bucket",
                            "op": "NotStartsWith",
                            "rhs": "arn:"
                        }
                    }
                },
                "condition_mappings": {
                    "s3:ResourceAccount": {
                        "template": "${ExpectedBucketOwner}"
                    },
                    "s3:DataAccessPointArn": {
                        "template": "${Bucket}",
                        "conditions": {
                            "lhs": "Bucket",
                            "op": "Contains",
                            "rhs": ":accesspoint/"
                        }
                    }
                }
            }
        ],
        "S3.HeadObject": [
            {
                "action": "s3:GetObject",
                "conditions": {
                    "lhs": "VersionId",
                    "op": "NotExists"
                },
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}",
                        "conditions": {
                            "lhs": "Bucket",
                            "op": "NotStartsWith",
                            "rhs": "arn:"
                        }
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                },
                "condition_mappings": {
                    "s3:ResourceAccount": {
                        "template": "${ExpectedBucketOwner}"
                    },
                    "s3:DataAccessPointArn": {
                        "template": "${Bucket}",
                        "conditions": {
                            "lhs": "Bucket",
                            "op": "Contains",
                            "rhs": ":accesspoint/"
                        }
                    }
                }
            },
            {
                "action": "s3:GetObjectVersion",
                "conditions": {
                    "lhs": "VersionId",
                    "op": "Exists"
                },
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}",
                        "conditions": {
                            "lhs": "Bucket",
                            "op": "NotStartsWith",
                            "rhs": "arn:"
                        }
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                },
                "condition_mappings": {
                    "s3:versionid": {
                        "template": "${VersionId}"
                    },
                    "s3:ResourceAccount": {
                        "template": "${ExpectedBucketOwner}"
                    },
                    "s3:DataAccessPointArn": {
                        "template": "${Bucket}",
                        "conditions": {
                            "lhs": "Bucket",
                            "op": "Contains",
                            "rhs": ":accesspoint/"
                        }
                    }
                }
            }
        ],
        "TimestreamQuery.Query": [
            {
                "action": "timestream:Select",
                "conditions": {
                    "lhs": "QueryString",
                    "op": "IContains",
                    "rhs": "SELECT ",
                    "andCondition": {
                        "lhs": "QueryString",
                        "op": "INotContains",
                        "rhs": " FROM "
                    }
                }
            },
            {
                "action": "timestream:SelectValues",
                "conditions": {
                    "lhs": "QueryString",
                    "op": "IContains",
                    "rhs": "SELECT ",
                    "andCondition": {
                        "lhs": "QueryString",
                        "op": "IContains",
                        "rhs": " FROM "
                    }
                }
            },
            {
                "action": "timestream:ListDatabases",
                "conditions": {
                    "lhs": "QueryString",
                    "op": "IContains",
                    "rhs": "SHOW DATABASES "
                }
            },
            {
                "action": "timestream:ListTables",
                "conditions": {
                    "lhs": "QueryString",
                    "op": "IContains",
                    "rhs": "SHOW TABLES "
                }
            },
            {
                "action": "timestream:ListMeasures",
                "conditions": {
                    "lhs": "QueryString",
                    "op": "IContains",
                    "rhs": "SHOW MEASURES "
                }
            },
            {
                "action": "timestream:DescribeTable",
                "conditions": {
                    "lhs": "QueryString",
                    "op": "IContains",
                    "rhs": "DESCRIBE "
                }
            }
        ],
        "KMS.ReEncrypt": [
            {
                "action": "kms:ReEncryptFrom",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${SourceKeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            },
            {
                "action": "kms:ReEncryptTo",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${DestinationKeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "Route53.ActivateKeySigningKey": [
            {
                "action": "route53:ActivateKeySigningKey",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.CreateKeySigningKey": [
            {
                "action": "route53:CreateKeySigningKey",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.DeactivateKeySigningKey": [
            {
                "action": "route53:DeactivateKeySigningKey",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.DeleteKeySigningKey": [
            {
                "action": "route53:DeleteKeySigningKey",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.DisableHostedZoneDNSSEC": [
            {
                "action": "route53:DisableHostedZoneDNSSEC",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.EnableHostedZoneDNSSEC": [
            {
                "action": "route53:EnableHostedZoneDNSSEC",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.GetDNSSEC": [
            {
                "action": "route53:GetDNSSEC",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "S3.CompleteMultipartUpload": [
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.CreateMultipartUpload": [
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.GetBucketCors": [
            {
                "action": "s3:GetBucketCORS",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketIntelligentTieringConfiguration": [
            {
                "action": "s3:GetIntelligentTieringConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetObjectLockConfiguration": [
            {
                "action": "s3:GetBucketObjectLockConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.ListMultipartUploads": [
            {
                "action": "s3:ListBucketMultipartUploads",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.ListObjectVersions": [
            {
                "action": "s3:ListBucketVersions",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.ListParts": [
            {
                "action": "s3:ListMultipartUploadParts",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.PutBucketCors": [
            {
                "action": "s3:PutBucketCORS",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketIntelligentTieringConfiguration": [
            {
                "action": "s3:PutIntelligentTieringConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutObjectLockConfiguration": [
            {
                "action": "s3:PutBucketObjectLockConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.UploadPart": [
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Body}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.UploadPartCopy": [
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3Control.CreateJob": [
            {
                "action": "s3:CreateJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "S3Control.DeleteJobTagging": [
            {
                "action": "s3:DeleteJobTagging",
                "resource_mappings": {
                    "JobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "S3Control.DeleteStorageLensConfiguration": [
            {
                "action": "s3:DeleteStorageLensConfiguration",
                "resource_mappings": {
                    "ConfigId": {
                        "template": "${ConfigId}"
                    }
                }
            }
        ],
        "S3Control.DeleteStorageLensConfigurationTagging": [
            {
                "action": "s3:DeleteStorageLensConfigurationTagging",
                "resource_mappings": {
                    "ConfigId": {
                        "template": "${ConfigId}"
                    }
                }
            }
        ],
        "S3Control.GetAccessPointPolicyStatus": [
            {
                "action": "s3:GetAccessPointPolicyStatus",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.GetJobTagging": [
            {
                "action": "s3:GetJobTagging",
                "resource_mappings": {
                    "JobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "S3Control.GetStorageLensConfiguration": [
            {
                "action": "s3:GetStorageLensConfiguration",
                "resource_mappings": {
                    "ConfigId": {
                        "template": "${ConfigId}"
                    }
                }
            }
        ],
        "S3Control.GetStorageLensConfigurationTagging": [
            {
                "action": "s3:GetStorageLensConfigurationTagging",
                "resource_mappings": {
                    "ConfigId": {
                        "template": "${ConfigId}"
                    }
                }
            }
        ],
        "S3Control.ListStorageLensConfigurations": [
            {
                "action": "s3:ListStorageLensConfigurations",
                "resource_mappings": {}
            }
        ],
        "S3Control.PutJobTagging": [
            {
                "action": "s3:PutJobTagging",
                "resource_mappings": {
                    "JobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "S3Control.PutStorageLensConfiguration": [
            {
                "action": "s3:PutStorageLensConfiguration",
                "resource_mappings": {}
            }
        ],
        "S3Control.PutStorageLensConfigurationTagging": [
            {
                "action": "s3:PutStorageLensConfigurationTagging",
                "resource_mappings": {
                    "ConfigId": {
                        "template": "${ConfigId}"
                    }
                }
            }
        ],
        "S3Control.UpdateJobPriority": [
            {
                "action": "s3:UpdateJobPriority",
                "resource_mappings": {
                    "JobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "S3Control.UpdateJobStatus": [
            {
                "action": "s3:UpdateJobStatus",
                "resource_mappings": {
                    "JobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "STS.AssumeRole": [
            {
                "action": "sts:AssumeRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "STS.AssumeRoleWithSAML": [
            {
                "action": "sts:AssumeRoleWithSAML",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "STS.AssumeRoleWithWebIdentity": [
            {
                "action": "sts:AssumeRoleWithWebIdentity",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "STS.DecodeAuthorizationMessage": [
            {
                "action": "sts:DecodeAuthorizationMessage",
                "resource_mappings": {}
            }
        ],
        "STS.GetAccessKeyInfo": [
            {
                "action": "sts:GetAccessKeyInfo",
                "resource_mappings": {}
            }
        ],
        "STS.GetCallerIdentity": [
            {
                "action": "sts:GetCallerIdentity",
                "resource_mappings": {}
            }
        ],
        "STS.GetFederationToken": [
            {
                "action": "sts:GetFederationToken",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "STS.GetSessionToken": [
            {
                "action": "sts:GetSessionToken",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentity.CreateIdentityPool": [
            {
                "action": "cognito-identity:CreateIdentityPool",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentity.DeleteIdentities": [
            {
                "action": "cognito-identity:DeleteIdentities",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentity.DeleteIdentityPool": [
            {
                "action": "cognito-identity:DeleteIdentityPool",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentity.DescribeIdentity": [
            {
                "action": "cognito-identity:DescribeIdentity",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentity.DescribeIdentityPool": [
            {
                "action": "cognito-identity:DescribeIdentityPool",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentity.GetCredentialsForIdentity": [
            {
                "action": "cognito-identity:GetCredentialsForIdentity",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentity.GetId": [
            {
                "action": "cognito-identity:GetId",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentity.GetIdentityPoolRoles": [
            {
                "action": "cognito-identity:GetIdentityPoolRoles",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentity.GetOpenIdToken": [
            {
                "action": "cognito-identity:GetOpenIdToken",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentity.GetOpenIdTokenForDeveloperIdentity": [
            {
                "action": "cognito-identity:GetOpenIdTokenForDeveloperIdentity",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentity.ListIdentities": [
            {
                "action": "cognito-identity:ListIdentities",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentity.ListIdentityPools": [
            {
                "action": "cognito-identity:ListIdentityPools",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentity.ListTagsForResource": [
            {
                "action": "cognito-identity:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "identitypool": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CognitoIdentity.LookupDeveloperIdentity": [
            {
                "action": "cognito-identity:LookupDeveloperIdentity",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentity.MergeDeveloperIdentities": [
            {
                "action": "cognito-identity:MergeDeveloperIdentities",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentity.SetIdentityPoolRoles": [
            {
                "action": "cognito-identity:SetIdentityPoolRoles",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "CognitoIdentity.TagResource": [
            {
                "action": "cognito-identity:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "identitypool": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CognitoIdentity.UnlinkDeveloperIdentity": [
            {
                "action": "cognito-identity:UnlinkDeveloperIdentity",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentity.UnlinkIdentity": [
            {
                "action": "cognito-identity:UnlinkIdentity",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentity.UntagResource": [
            {
                "action": "cognito-identity:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "identitypool": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CognitoIdentity.UpdateIdentityPool": [
            {
                "action": "cognito-identity:UpdateIdentityPool",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "ACM.AddTagsToCertificate": [
            {
                "action": "acm:AddTagsToCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ACM.DeleteCertificate": [
            {
                "action": "acm:DeleteCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ACM.DescribeCertificate": [
            {
                "action": "acm:DescribeCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ACM.ExportCertificate": [
            {
                "action": "acm:ExportCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ACM.GetCertificate": [
            {
                "action": "acm:GetCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ACM.ImportCertificate": [
            {
                "action": "acm:ImportCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ACM.ListCertificates": [
            {
                "action": "acm:ListCertificates",
                "resource_mappings": {}
            }
        ],
        "ACM.ListTagsForCertificate": [
            {
                "action": "acm:ListTagsForCertificate",
                "resource_mappings": {}
            }
        ],
        "ACM.RemoveTagsFromCertificate": [
            {
                "action": "acm:RemoveTagsFromCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ACM.RenewCertificate": [
            {
                "action": "acm:RenewCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ACM.RequestCertificate": [
            {
                "action": "acm:RequestCertificate",
                "resource_mappings": {}
            }
        ],
        "ACM.ResendValidationEmail": [
            {
                "action": "acm:ResendValidationEmail",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ACM.UpdateCertificateOptions": [
            {
                "action": "acm:UpdateCertificateOptions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "ApplicationAutoScaling.DeleteScalingPolicy": [
            {
                "action": "application-autoscaling:DeleteScalingPolicy",
                "resource_mappings": {}
            }
        ],
        "ApplicationAutoScaling.DeleteScheduledAction": [
            {
                "action": "application-autoscaling:DeleteScheduledAction",
                "resource_mappings": {}
            }
        ],
        "ApplicationAutoScaling.DeregisterScalableTarget": [
            {
                "action": "application-autoscaling:DeregisterScalableTarget",
                "resource_mappings": {}
            }
        ],
        "ApplicationAutoScaling.DescribeScalableTargets": [
            {
                "action": "application-autoscaling:DescribeScalableTargets",
                "resource_mappings": {}
            }
        ],
        "ApplicationAutoScaling.DescribeScalingActivities": [
            {
                "action": "application-autoscaling:DescribeScalingActivities",
                "resource_mappings": {}
            }
        ],
        "ApplicationAutoScaling.DescribeScalingPolicies": [
            {
                "action": "application-autoscaling:DescribeScalingPolicies",
                "resource_mappings": {}
            }
        ],
        "ApplicationAutoScaling.DescribeScheduledActions": [
            {
                "action": "application-autoscaling:DescribeScheduledActions",
                "resource_mappings": {}
            }
        ],
        "ApplicationAutoScaling.PutScalingPolicy": [
            {
                "action": "application-autoscaling:PutScalingPolicy",
                "resource_mappings": {}
            }
        ],
        "ApplicationAutoScaling.PutScheduledAction": [
            {
                "action": "application-autoscaling:PutScheduledAction",
                "resource_mappings": {}
            }
        ],
        "ApplicationAutoScaling.RegisterScalableTarget": [
            {
                "action": "application-autoscaling:RegisterScalableTarget",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "AppStream.AssociateFleet": [
            {
                "action": "appstream:AssociateFleet",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${FleetName}"
                    },
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.BatchAssociateUserStack": [
            {
                "action": "appstream:BatchAssociateUserStack",
                "resource_mappings": {
                    "StackName": {
                        "template": "${UserStackAssociations[].StackName}"
                    }
                }
            }
        ],
        "AppStream.BatchDisassociateUserStack": [
            {
                "action": "appstream:BatchDisassociateUserStack",
                "resource_mappings": {
                    "StackName": {
                        "template": "${UserStackAssociations[].StackName}"
                    }
                }
            }
        ],
        "AppStream.CopyImage": [
            {
                "action": "appstream:CopyImage",
                "resource_mappings": {
                    "ImageName": {
                        "template": "%%many%${SourceImageName}%${DestinationImageName}%%"
                    }
                }
            }
        ],
        "AppStream.CreateDirectoryConfig": [
            {
                "action": "appstream:CreateDirectoryConfig",
                "resource_mappings": {}
            }
        ],
        "AppStream.CreateFleet": [
            {
                "action": "appstream:CreateFleet",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${Name}"
                    },
                    "ImageName": {
                        "template": "${ImageName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "AppStream.CreateImageBuilder": [
            {
                "action": "appstream:CreateImageBuilder",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${ImageName}"
                    },
                    "ImageBuilderName": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "AppStream.CreateImageBuilderStreamingURL": [
            {
                "action": "appstream:CreateImageBuilderStreamingURL",
                "resource_mappings": {
                    "ImageBuilderName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.CreateStack": [
            {
                "action": "appstream:CreateStack",
                "resource_mappings": {
                    "StackName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.CreateStreamingURL": [
            {
                "action": "appstream:CreateStreamingURL",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${FleetName}"
                    },
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.CreateUsageReportSubscription": [
            {
                "action": "appstream:CreateUsageReportSubscription",
                "resource_mappings": {}
            }
        ],
        "AppStream.CreateUser": [
            {
                "action": "appstream:CreateUser",
                "resource_mappings": {}
            }
        ],
        "AppStream.DeleteDirectoryConfig": [
            {
                "action": "appstream:DeleteDirectoryConfig",
                "resource_mappings": {}
            }
        ],
        "AppStream.DeleteFleet": [
            {
                "action": "appstream:DeleteFleet",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.DeleteImage": [
            {
                "action": "appstream:DeleteImage",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.DeleteImageBuilder": [
            {
                "action": "appstream:DeleteImageBuilder",
                "resource_mappings": {
                    "ImageBuilderName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.DeleteImagePermissions": [
            {
                "action": "appstream:DeleteImagePermissions",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.DeleteStack": [
            {
                "action": "appstream:DeleteStack",
                "resource_mappings": {
                    "StackName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.DeleteUsageReportSubscription": [
            {
                "action": "appstream:DeleteUsageReportSubscription",
                "resource_mappings": {}
            }
        ],
        "AppStream.DeleteUser": [
            {
                "action": "appstream:DeleteUser",
                "resource_mappings": {}
            }
        ],
        "AppStream.DescribeDirectoryConfigs": [
            {
                "action": "appstream:DescribeDirectoryConfigs",
                "resource_mappings": {}
            }
        ],
        "AppStream.DescribeFleets": [
            {
                "action": "appstream:DescribeFleets",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${Names[]}"
                    }
                }
            }
        ],
        "AppStream.DescribeImageBuilders": [
            {
                "action": "appstream:DescribeImageBuilders",
                "resource_mappings": {
                    "ImageBuilderName": {
                        "template": "${Names[]}"
                    }
                }
            }
        ],
        "AppStream.DescribeImagePermissions": [
            {
                "action": "appstream:DescribeImagePermissions",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.DescribeImages": [
            {
                "action": "appstream:DescribeImages",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${Names[]}"
                    }
                }
            }
        ],
        "AppStream.DescribeSessions": [
            {
                "action": "appstream:DescribeSessions",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${FleetName}"
                    },
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.DescribeStacks": [
            {
                "action": "appstream:DescribeStacks",
                "resource_mappings": {
                    "StackName": {
                        "template": "${Names[]}"
                    }
                }
            }
        ],
        "AppStream.DescribeUsageReportSubscriptions": [
            {
                "action": "appstream:DescribeUsageReportSubscriptions",
                "resource_mappings": {}
            }
        ],
        "AppStream.DescribeUserStackAssociations": [
            {
                "action": "appstream:DescribeUserStackAssociations",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.DescribeUsers": [
            {
                "action": "appstream:DescribeUsers",
                "resource_mappings": {}
            }
        ],
        "AppStream.DisableUser": [
            {
                "action": "appstream:DisableUser",
                "resource_mappings": {}
            }
        ],
        "AppStream.DisassociateFleet": [
            {
                "action": "appstream:DisassociateFleet",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${FleetName}"
                    },
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.EnableUser": [
            {
                "action": "appstream:EnableUser",
                "resource_mappings": {}
            }
        ],
        "AppStream.ExpireSession": [
            {
                "action": "appstream:ExpireSession",
                "resource_mappings": {}
            }
        ],
        "AppStream.ListAssociatedFleets": [
            {
                "action": "appstream:ListAssociatedFleets",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.ListAssociatedStacks": [
            {
                "action": "appstream:ListAssociatedStacks",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${FleetName}"
                    }
                }
            }
        ],
        "AppStream.ListTagsForResource": [
            {
                "action": "appstream:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "AppStream.StartFleet": [
            {
                "action": "appstream:StartFleet",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.StartImageBuilder": [
            {
                "action": "appstream:StartImageBuilder",
                "resource_mappings": {
                    "ImageBuilderName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.StopFleet": [
            {
                "action": "appstream:StopFleet",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.StopImageBuilder": [
            {
                "action": "appstream:StopImageBuilder",
                "resource_mappings": {
                    "ImageBuilderName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.TagResource": [
            {
                "action": "appstream:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "%%iftemplatematch%${ResourceArn}%%",
                    "image": "%%iftemplatematch%${ResourceArn}%%",
                    "image-builder": "%%iftemplatematch%${ResourceArn}%%",
                    "stack": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AppStream.UntagResource": [
            {
                "action": "appstream:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "%%iftemplatematch%${ResourceArn}%%",
                    "image": "%%iftemplatematch%${ResourceArn}%%",
                    "image-builder": "%%iftemplatematch%${ResourceArn}%%",
                    "stack": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AppStream.UpdateDirectoryConfig": [
            {
                "action": "appstream:UpdateDirectoryConfig",
                "resource_mappings": {}
            }
        ],
        "AppStream.UpdateFleet": [
            {
                "action": "appstream:UpdateFleet",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${Name}"
                    },
                    "ImageName": {
                        "template": "${ImageName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "AppStream.UpdateImagePermissions": [
            {
                "action": "appstream:UpdateImagePermissions",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.UpdateStack": [
            {
                "action": "appstream:UpdateStack",
                "resource_mappings": {
                    "StackName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AutoScaling.AttachInstances": [
            {
                "action": "autoscaling:AttachInstances",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.AttachLoadBalancerTargetGroups": [
            {
                "action": "autoscaling:AttachLoadBalancerTargetGroups",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.AttachLoadBalancers": [
            {
                "action": "autoscaling:AttachLoadBalancers",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.BatchDeleteScheduledAction": [
            {
                "action": "autoscaling:BatchDeleteScheduledAction",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.BatchPutScheduledUpdateGroupAction": [
            {
                "action": "autoscaling:BatchPutScheduledUpdateGroupAction",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.CancelInstanceRefresh": [
            {
                "action": "autoscaling:CancelInstanceRefresh",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.CompleteLifecycleAction": [
            {
                "action": "autoscaling:CompleteLifecycleAction",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.CreateAutoScalingGroup": [
            {
                "action": "autoscaling:CreateAutoScalingGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${ServiceLinkedRoleARN}%${LifeCycleHookSpecification.RoleARN}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchConfigurationName}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateName}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${MixedInstancesPolicy.LaunchTemplate.LaunchTemplateSpecification.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${MixedInstancesPolicy.LaunchTemplate.LaunchTemplateSpecification.LaunchTemplateName}%*%%%"
                }
            }
        ],
        "AutoScaling.CreateLaunchConfiguration": [
            {
                "action": "autoscaling:CreateLaunchConfiguration",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    },
                    "LaunchConfigurationName": {
                        "template": "${LaunchConfigurationName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${IamInstanceProfile}%*%%%"
                }
            }
        ],
        "AutoScaling.CreateOrUpdateTags": [
            {
                "action": "autoscaling:CreateOrUpdateTags",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${Tags[].ResourceId}"
                    }
                }
            }
        ],
        "AutoScaling.DeleteAutoScalingGroup": [
            {
                "action": "autoscaling:DeleteAutoScalingGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.DeleteLaunchConfiguration": [
            {
                "action": "autoscaling:DeleteLaunchConfiguration",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    },
                    "LaunchConfigurationName": {
                        "template": "${LaunchConfigurationName}"
                    }
                }
            }
        ],
        "AutoScaling.DeleteLifecycleHook": [
            {
                "action": "autoscaling:DeleteLifecycleHook",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.DeleteNotificationConfiguration": [
            {
                "action": "autoscaling:DeleteNotificationConfiguration",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.DeletePolicy": [
            {
                "action": "autoscaling:DeletePolicy",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.DeleteScheduledAction": [
            {
                "action": "autoscaling:DeleteScheduledAction",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.DeleteTags": [
            {
                "action": "autoscaling:DeleteTags",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${Tags[].ResourceId}"
                    }
                }
            }
        ],
        "AutoScaling.DescribeAccountLimits": [
            {
                "action": "autoscaling:DescribeAccountLimits",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeAdjustmentTypes": [
            {
                "action": "autoscaling:DescribeAdjustmentTypes",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeAutoScalingGroups": [
            {
                "action": "autoscaling:DescribeAutoScalingGroups",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeAutoScalingInstances": [
            {
                "action": "autoscaling:DescribeAutoScalingInstances",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeAutoScalingNotificationTypes": [
            {
                "action": "autoscaling:DescribeAutoScalingNotificationTypes",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeInstanceRefreshes": [
            {
                "action": "autoscaling:DescribeInstanceRefreshes",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeLaunchConfigurations": [
            {
                "action": "autoscaling:DescribeLaunchConfigurations",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeLifecycleHookTypes": [
            {
                "action": "autoscaling:DescribeLifecycleHookTypes",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeLifecycleHooks": [
            {
                "action": "autoscaling:DescribeLifecycleHooks",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeLoadBalancerTargetGroups": [
            {
                "action": "autoscaling:DescribeLoadBalancerTargetGroups",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeLoadBalancers": [
            {
                "action": "autoscaling:DescribeLoadBalancers",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeMetricCollectionTypes": [
            {
                "action": "autoscaling:DescribeMetricCollectionTypes",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeNotificationConfigurations": [
            {
                "action": "autoscaling:DescribeNotificationConfigurations",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribePolicies": [
            {
                "action": "autoscaling:DescribePolicies",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeScalingActivities": [
            {
                "action": "autoscaling:DescribeScalingActivities",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeScalingProcessTypes": [
            {
                "action": "autoscaling:DescribeScalingProcessTypes",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeScheduledActions": [
            {
                "action": "autoscaling:DescribeScheduledActions",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeTags": [
            {
                "action": "autoscaling:DescribeTags",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DescribeTerminationPolicyTypes": [
            {
                "action": "autoscaling:DescribeTerminationPolicyTypes",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.DetachInstances": [
            {
                "action": "autoscaling:DetachInstances",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.DetachLoadBalancerTargetGroups": [
            {
                "action": "autoscaling:DetachLoadBalancerTargetGroups",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.DetachLoadBalancers": [
            {
                "action": "autoscaling:DetachLoadBalancers",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.DisableMetricsCollection": [
            {
                "action": "autoscaling:DisableMetricsCollection",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.EnableMetricsCollection": [
            {
                "action": "autoscaling:EnableMetricsCollection",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.EnterStandby": [
            {
                "action": "autoscaling:EnterStandby",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.ExecutePolicy": [
            {
                "action": "autoscaling:ExecutePolicy",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.ExitStandby": [
            {
                "action": "autoscaling:ExitStandby",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.PutLifecycleHook": [
            {
                "action": "autoscaling:PutLifecycleHook",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "AutoScaling.PutNotificationConfiguration": [
            {
                "action": "autoscaling:PutNotificationConfiguration",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.PutScalingPolicy": [
            {
                "action": "autoscaling:PutScalingPolicy",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.PutScheduledUpdateGroupAction": [
            {
                "action": "autoscaling:PutScheduledUpdateGroupAction",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.RecordLifecycleActionHeartbeat": [
            {
                "action": "autoscaling:RecordLifecycleActionHeartbeat",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.ResumeProcesses": [
            {
                "action": "autoscaling:ResumeProcesses",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.SetDesiredCapacity": [
            {
                "action": "autoscaling:SetDesiredCapacity",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.SetInstanceHealth": [
            {
                "action": "autoscaling:SetInstanceHealth",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "*"
                    }
                }
            }
        ],
        "AutoScaling.SetInstanceProtection": [
            {
                "action": "autoscaling:SetInstanceProtection",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.StartInstanceRefresh": [
            {
                "action": "autoscaling:StartInstanceRefresh",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.SuspendProcesses": [
            {
                "action": "autoscaling:SuspendProcesses",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.TerminateInstanceInAutoScalingGroup": [
            {
                "action": "autoscaling:TerminateInstanceInAutoScalingGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "*"
                    }
                }
            }
        ],
        "AutoScaling.UpdateAutoScalingGroup": [
            {
                "action": "autoscaling:UpdateAutoScalingGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${ServiceLinkedRoleARN}%${LifeCycleHookSpecification.RoleARN}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchConfigurationName}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateName}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${MixedInstancesPolicy.LaunchTemplate.LaunchTemplateSpecification.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${MixedInstancesPolicy.LaunchTemplate.LaunchTemplateSpecification.LaunchTemplateName}%*%%%"
                }
            }
        ],
        "Batch.CancelJob": [
            {
                "action": "batch:CancelJob",
                "resource_mappings": {
                    "jobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Batch.CreateComputeEnvironment": [
            {
                "action": "batch:CreateComputeEnvironment",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/%%regex%${computeResources.instanceRole}%/(?:arn.*/)?(.+)/g%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${computeResources.spotIamFleetRole}%${serviceRole}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${computeResources.launchTemplate.launchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${computeResources.launchTemplate.launchTemplateName}%*%%%"
                }
            }
        ],
        "Batch.CreateJobQueue": [
            {
                "action": "batch:CreateJobQueue",
                "resource_mappings": {
                    "ComputeEnvironmentName": {
                        "template": "${computeEnvironmentOrder[].computeEnvironment}"
                    }
                }
            }
        ],
        "Batch.DeleteComputeEnvironment": [
            {
                "action": "batch:DeleteComputeEnvironment",
                "resource_mappings": {
                    "ComputeEnvironmentName": {
                        "template": "${computeEnvironment}"
                    }
                }
            }
        ],
        "Batch.DeleteJobQueue": [
            {
                "action": "batch:DeleteJobQueue",
                "resource_mappings": {
                    "JobQueueName": {
                        "template": "${jobQueue}"
                    }
                }
            }
        ],
        "Batch.DeregisterJobDefinition": [
            {
                "action": "batch:DeregisterJobDefinition",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "job-definition": "%%iftemplatematch%${jobDefinition}%%"
                }
            }
        ],
        "Batch.DescribeComputeEnvironments": [
            {
                "action": "batch:DescribeComputeEnvironments",
                "resource_mappings": {}
            }
        ],
        "Batch.DescribeJobDefinitions": [
            {
                "action": "batch:DescribeJobDefinitions",
                "resource_mappings": {}
            }
        ],
        "Batch.DescribeJobQueues": [
            {
                "action": "batch:DescribeJobQueues",
                "resource_mappings": {}
            }
        ],
        "Batch.DescribeJobs": [
            {
                "action": "batch:DescribeJobs",
                "resource_mappings": {}
            }
        ],
        "Batch.ListJobs": [
            {
                "action": "batch:ListJobs",
                "resource_mappings": {}
            }
        ],
        "Batch.ListTagsForResource": [
            {
                "action": "batch:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "compute-environment": "%%iftemplatematch%${resourceArn}%%",
                    "job": "%%iftemplatematch%${resourceArn}%%",
                    "job-definition": "%%iftemplatematch%${resourceArn}%%",
                    "job-queue": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Batch.RegisterJobDefinition": [
            {
                "action": "batch:RegisterJobDefinition",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${containerProperties.jobRoleArn}%${containerProperties.executionRoleArn}%%"
                }
            }
        ],
        "Batch.SubmitJob": [
            {
                "action": "batch:SubmitJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "job-definition": "%%iftemplatematch%${jobDefinition}%%",
                    "job-queue": "%%iftemplatematch%${jobQueue}%%"
                }
            }
        ],
        "Batch.TagResource": [
            {
                "action": "batch:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "compute-environment": "%%iftemplatematch%${resourceArn}%%",
                    "job": "%%iftemplatematch%${resourceArn}%%",
                    "job-definition": "%%iftemplatematch%${resourceArn}%%",
                    "job-queue": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Batch.TerminateJob": [
            {
                "action": "batch:TerminateJob",
                "resource_mappings": {
                    "jobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Batch.UntagResource": [
            {
                "action": "batch:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "compute-environment": "%%iftemplatematch%${resourceArn}%%",
                    "job": "%%iftemplatematch%${resourceArn}%%",
                    "job-definition": "%%iftemplatematch%${resourceArn}%%",
                    "job-queue": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Batch.UpdateComputeEnvironment": [
            {
                "action": "batch:UpdateComputeEnvironment",
                "resource_mappings": {
                    "ComputeEnvironmentName": {
                        "template": "${computeEnvironment}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/%%regex%${serviceRole}%/(?:arn.*/)?(.+)/g%%"
                }
            }
        ],
        "Batch.UpdateJobQueue": [
            {
                "action": "batch:UpdateJobQueue",
                "resource_mappings": {
                    "JobQueueName": {
                        "template": "${jobQueue}"
                    }
                }
            }
        ],
        "Budgets.CreateBudgetAction": [
            {
                "action": "budgets:CreateBudgetAction",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    },
                    "ActionId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${Definition.IamActionDefinition.PolicyArn}%${Definition.IamActionDefinition.Roles}%${Definition.IamActionDefinition.Groups}%${Definition.IamActionDefinition.Users}%${ExecutionRoleArn}%%"
                }
            }
        ],
        "Budgets.DeleteBudgetAction": [
            {
                "action": "budgets:DeleteBudgetAction",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    },
                    "ActionId": {
                        "template": "${ActionId}"
                    }
                }
            }
        ],
        "Budgets.DescribeBudgetAction": [
            {
                "action": "budgets:DescribeBudgetAction",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    },
                    "ActionId": {
                        "template": "${ActionId}"
                    }
                }
            }
        ],
        "Budgets.DescribeBudgetActionHistories": [
            {
                "action": "budgets:DescribeBudgetActionHistories",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    },
                    "ActionId": {
                        "template": "${ActionId}"
                    }
                }
            }
        ],
        "Budgets.DescribeBudgetActionsForAccount": [
            {
                "action": "budgets:DescribeBudgetActionsForAccount",
                "resource_mappings": {}
            }
        ],
        "Budgets.DescribeBudgetActionsForBudget": [
            {
                "action": "budgets:DescribeBudgetActionsForBudget",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    }
                }
            }
        ],
        "Budgets.ExecuteBudgetAction": [
            {
                "action": "budgets:ExecuteBudgetAction",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    },
                    "ActionId": {
                        "template": "${ActionId}"
                    }
                }
            }
        ],
        "Budgets.UpdateBudgetAction": [
            {
                "action": "budgets:UpdateBudgetAction",
                "resource_mappings": {
                    "BudgetName": {
                        "template": "${BudgetName}"
                    },
                    "ActionId": {
                        "template": "${ActionId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${Definition.IamActionDefinition.PolicyArn}%${Definition.IamActionDefinition.Roles}%${Definition.IamActionDefinition.Groups}%${Definition.IamActionDefinition.Users}%${ExecutionRoleArn}%%"
                }
            }
        ],
        "CloudDirectory.AddFacetToObject": [
            {
                "action": "clouddirectory:AddFacetToObject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ApplySchema": [
            {
                "action": "clouddirectory:ApplySchema",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}",
                    "publishedSchema": "${PublishedSchemaArn}"
                }
            }
        ],
        "CloudDirectory.AttachObject": [
            {
                "action": "clouddirectory:AttachObject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.AttachPolicy": [
            {
                "action": "clouddirectory:AttachPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.AttachToIndex": [
            {
                "action": "clouddirectory:AttachToIndex",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.AttachTypedLink": [
            {
                "action": "clouddirectory:AttachTypedLink",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.BatchRead": [
            {
                "action": "clouddirectory:BatchRead",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.BatchWrite": [
            {
                "action": "clouddirectory:BatchWrite",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.CreateDirectory": [
            {
                "action": "clouddirectory:CreateDirectory",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "publishedSchema": "${SchemaArn}"
                }
            }
        ],
        "CloudDirectory.CreateFacet": [
            {
                "action": "clouddirectory:CreateFacet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.CreateIndex": [
            {
                "action": "clouddirectory:CreateIndex",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.CreateObject": [
            {
                "action": "clouddirectory:CreateObject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.CreateSchema": [
            {
                "action": "clouddirectory:CreateSchema",
                "resource_mappings": {}
            }
        ],
        "CloudDirectory.CreateTypedLinkFacet": [
            {
                "action": "clouddirectory:CreateTypedLinkFacet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.DeleteDirectory": [
            {
                "action": "clouddirectory:DeleteDirectory",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.DeleteFacet": [
            {
                "action": "clouddirectory:DeleteFacet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.DeleteObject": [
            {
                "action": "clouddirectory:DeleteObject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.DeleteSchema": [
            {
                "action": "clouddirectory:DeleteSchema",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "publishedSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.DeleteTypedLinkFacet": [
            {
                "action": "clouddirectory:DeleteTypedLinkFacet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.DetachFromIndex": [
            {
                "action": "clouddirectory:DetachFromIndex",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.DetachObject": [
            {
                "action": "clouddirectory:DetachObject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.DetachPolicy": [
            {
                "action": "clouddirectory:DetachPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.DetachTypedLink": [
            {
                "action": "clouddirectory:DetachTypedLink",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.DisableDirectory": [
            {
                "action": "clouddirectory:DisableDirectory",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.EnableDirectory": [
            {
                "action": "clouddirectory:EnableDirectory",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.GetDirectory": [
            {
                "action": "clouddirectory:GetDirectory",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.GetFacet": [
            {
                "action": "clouddirectory:GetFacet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "publishedSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.GetLinkAttributes": [
            {
                "action": "clouddirectory:GetLinkAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.GetObjectAttributes": [
            {
                "action": "clouddirectory:GetObjectAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.GetObjectInformation": [
            {
                "action": "clouddirectory:GetObjectInformation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.GetSchemaAsJson": [
            {
                "action": "clouddirectory:GetSchemaAsJson",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "publishedSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.GetTypedLinkFacetInformation": [
            {
                "action": "clouddirectory:GetTypedLinkFacetInformation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "publishedSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.ListAppliedSchemaArns": [
            {
                "action": "clouddirectory:ListAppliedSchemaArns",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListAttachedIndices": [
            {
                "action": "clouddirectory:ListAttachedIndices",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListDevelopmentSchemaArns": [
            {
                "action": "clouddirectory:ListDevelopmentSchemaArns",
                "resource_mappings": {}
            }
        ],
        "CloudDirectory.ListDirectories": [
            {
                "action": "clouddirectory:ListDirectories",
                "resource_mappings": {}
            }
        ],
        "CloudDirectory.ListFacetAttributes": [
            {
                "action": "clouddirectory:ListFacetAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "publishedSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.ListFacetNames": [
            {
                "action": "clouddirectory:ListFacetNames",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "publishedSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.ListIncomingTypedLinks": [
            {
                "action": "clouddirectory:ListIncomingTypedLinks",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListIndex": [
            {
                "action": "clouddirectory:ListIndex",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListObjectAttributes": [
            {
                "action": "clouddirectory:ListObjectAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListObjectChildren": [
            {
                "action": "clouddirectory:ListObjectChildren",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListObjectParentPaths": [
            {
                "action": "clouddirectory:ListObjectParentPaths",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListObjectParents": [
            {
                "action": "clouddirectory:ListObjectParents",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListObjectPolicies": [
            {
                "action": "clouddirectory:ListObjectPolicies",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListOutgoingTypedLinks": [
            {
                "action": "clouddirectory:ListOutgoingTypedLinks",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListPolicyAttachments": [
            {
                "action": "clouddirectory:ListPolicyAttachments",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.ListPublishedSchemaArns": [
            {
                "action": "clouddirectory:ListPublishedSchemaArns",
                "resource_mappings": {}
            }
        ],
        "CloudDirectory.ListTagsForResource": [
            {
                "action": "clouddirectory:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CloudDirectory.ListTypedLinkFacetAttributes": [
            {
                "action": "clouddirectory:ListTypedLinkFacetAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "publishedSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.ListTypedLinkFacetNames": [
            {
                "action": "clouddirectory:ListTypedLinkFacetNames",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "publishedSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.LookupPolicy": [
            {
                "action": "clouddirectory:LookupPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.PublishSchema": [
            {
                "action": "clouddirectory:PublishSchema",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "developmentSchema": "${DevelopmentSchemaArn}"
                }
            }
        ],
        "CloudDirectory.PutSchemaFromJson": [
            {
                "action": "clouddirectory:PutSchemaFromJson",
                "resource_mappings": {}
            }
        ],
        "CloudDirectory.RemoveFacetFromObject": [
            {
                "action": "clouddirectory:RemoveFacetFromObject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.TagResource": [
            {
                "action": "clouddirectory:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CloudDirectory.UntagResource": [
            {
                "action": "clouddirectory:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CloudDirectory.UpdateFacet": [
            {
                "action": "clouddirectory:UpdateFacet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "appliedSchema": "%%iftemplatematch%${SchemaArn}%%",
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.UpdateLinkAttributes": [
            {
                "action": "clouddirectory:UpdateLinkAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.UpdateObjectAttributes": [
            {
                "action": "clouddirectory:UpdateObjectAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "directory": "${DirectoryArn}"
                }
            }
        ],
        "CloudDirectory.UpdateSchema": [
            {
                "action": "clouddirectory:UpdateSchema",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudDirectory.UpdateTypedLinkFacet": [
            {
                "action": "clouddirectory:UpdateTypedLinkFacet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "developmentSchema": "%%iftemplatematch%${SchemaArn}%%"
                }
            }
        ],
        "CloudFormation.CancelUpdateStack": [
            {
                "action": "cloudformation:CancelUpdateStack",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.ContinueUpdateRollback": [
            {
                "action": "cloudformation:ContinueUpdateRollback",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "CloudFormation.CreateChangeSet": [
            {
                "action": "cloudformation:CreateChangeSet",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "CloudFormation.CreateStack": [
            {
                "action": "cloudformation:CreateStack",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "CloudFormation.CreateStackInstances": [
            {
                "action": "cloudformation:CreateStackInstances",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    },
                    "StackSetTarget": {
                        "template": "*"
                    },
                    "Type": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "CloudFormation.CreateStackSet": [
            {
                "action": "cloudformation:CreateStackSet",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${AdministrationRoleARN}%arn:${Partition}:iam::*:role/${ExecutionRoleName}%%"
                }
            }
        ],
        "CloudFormation.DeleteChangeSet": [
            {
                "action": "cloudformation:DeleteChangeSet",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DeleteStack": [
            {
                "action": "cloudformation:DeleteStack",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DeleteStackInstances": [
            {
                "action": "cloudformation:DeleteStackInstances",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    },
                    "StackSetTarget": {
                        "template": "*"
                    },
                    "Type": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DeleteStackSet": [
            {
                "action": "cloudformation:DeleteStackSet",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DeregisterType": [
            {
                "action": "cloudformation:DeregisterType",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.DescribeAccountLimits": [
            {
                "action": "cloudformation:DescribeAccountLimits",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.DescribeChangeSet": [
            {
                "action": "cloudformation:DescribeChangeSet",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DescribeStackDriftDetectionStatus": [
            {
                "action": "cloudformation:DescribeStackDriftDetectionStatus",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.DescribeStackEvents": [
            {
                "action": "cloudformation:DescribeStackEvents",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DescribeStackInstance": [
            {
                "action": "cloudformation:DescribeStackInstance",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DescribeStackResource": [
            {
                "action": "cloudformation:DescribeStackResource",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DescribeStackResourceDrifts": [
            {
                "action": "cloudformation:DescribeStackResourceDrifts",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DescribeStackResources": [
            {
                "action": "cloudformation:DescribeStackResources",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DescribeStackSet": [
            {
                "action": "cloudformation:DescribeStackSet",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DescribeStackSetOperation": [
            {
                "action": "cloudformation:DescribeStackSetOperation",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DescribeStacks": [
            {
                "action": "cloudformation:DescribeStacks",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DescribeType": [
            {
                "action": "cloudformation:DescribeType",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.DescribeTypeRegistration": [
            {
                "action": "cloudformation:DescribeTypeRegistration",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.DetectStackDrift": [
            {
                "action": "cloudformation:DetectStackDrift",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DetectStackResourceDrift": [
            {
                "action": "cloudformation:DetectStackResourceDrift",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.DetectStackSetDrift": [
            {
                "action": "cloudformation:DetectStackSetDrift",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.EstimateTemplateCost": [
            {
                "action": "cloudformation:EstimateTemplateCost",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "CloudFormation.ExecuteChangeSet": [
            {
                "action": "cloudformation:ExecuteChangeSet",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.GetStackPolicy": [
            {
                "action": "cloudformation:GetStackPolicy",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.GetTemplate": [
            {
                "action": "cloudformation:GetTemplate",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.GetTemplateSummary": [
            {
                "action": "cloudformation:GetTemplateSummary",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    },
                    "StackSetName": {
                        "template": "${StackSetName}"
                    }
                }
            }
        ],
        "CloudFormation.ListChangeSets": [
            {
                "action": "cloudformation:ListChangeSets",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.ListExports": [
            {
                "action": "cloudformation:ListExports",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.ListImports": [
            {
                "action": "cloudformation:ListImports",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.ListStackInstances": [
            {
                "action": "cloudformation:ListStackInstances",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.ListStackResources": [
            {
                "action": "cloudformation:ListStackResources",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.ListStackSetOperationResults": [
            {
                "action": "cloudformation:ListStackSetOperationResults",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.ListStackSetOperations": [
            {
                "action": "cloudformation:ListStackSetOperations",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.ListStackSets": [
            {
                "action": "cloudformation:ListStackSets",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.ListStacks": [
            {
                "action": "cloudformation:ListStacks",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.ListTypeRegistrations": [
            {
                "action": "cloudformation:ListTypeRegistrations",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.ListTypeVersions": [
            {
                "action": "cloudformation:ListTypeVersions",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.ListTypes": [
            {
                "action": "cloudformation:ListTypes",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.RegisterType": [
            {
                "action": "cloudformation:RegisterType",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.SetStackPolicy": [
            {
                "action": "cloudformation:SetStackPolicy",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${LoggingConfig.LogRoleArn}%${ExecutionRoleArn}%%"
                }
            }
        ],
        "CloudFormation.SetTypeDefaultVersion": [
            {
                "action": "cloudformation:SetTypeDefaultVersion",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.SignalResource": [
            {
                "action": "cloudformation:SignalResource",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.StopStackSetOperation": [
            {
                "action": "cloudformation:StopStackSetOperation",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.UpdateStack": [
            {
                "action": "cloudformation:UpdateStack",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "CloudFormation.UpdateStackInstances": [
            {
                "action": "cloudformation:UpdateStackInstances",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    },
                    "StackSetTarget": {
                        "template": "*"
                    },
                    "Type": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "CloudFormation.UpdateStackSet": [
            {
                "action": "cloudformation:UpdateStackSet",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    },
                    "StackSetTarget": {
                        "template": "*"
                    },
                    "Type": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${AdministrationRoleARN}%arn:${Partition}:iam::*:role/${ExecutionRoleName}%%"
                }
            }
        ],
        "CloudFormation.UpdateTerminationProtection": [
            {
                "action": "cloudformation:UpdateTerminationProtection",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFormation.ValidateTemplate": [
            {
                "action": "cloudformation:ValidateTemplate",
                "resource_mappings": {}
            }
        ],
        "CloudFront.CreateCachePolicy": [
            {
                "action": "cloudfront:CreateCachePolicy",
                "resource_mappings": {}
            }
        ],
        "CloudFront.CreateCloudFrontOriginAccessIdentity": [
            {
                "action": "cloudfront:CreateCloudFrontOriginAccessIdentity",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFront.CreateDistribution": [
            {
                "action": "cloudfront:CreateDistribution",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFront.CreateDistributionWithTags": [
            {
                "action": "cloudfront:CreateDistributionWithTags",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFront.CreateFieldLevelEncryptionConfig": [
            {
                "action": "cloudfront:CreateFieldLevelEncryptionConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.CreateFieldLevelEncryptionProfile": [
            {
                "action": "cloudfront:CreateFieldLevelEncryptionProfile",
                "resource_mappings": {}
            }
        ],
        "CloudFront.CreateInvalidation": [
            {
                "action": "cloudfront:CreateInvalidation",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${DistributionId}"
                    }
                }
            }
        ],
        "CloudFront.CreateOriginRequestPolicy": [
            {
                "action": "cloudfront:CreateOriginRequestPolicy",
                "resource_mappings": {}
            }
        ],
        "CloudFront.CreatePublicKey": [
            {
                "action": "cloudfront:CreatePublicKey",
                "resource_mappings": {}
            }
        ],
        "CloudFront.CreateStreamingDistribution": [
            {
                "action": "cloudfront:CreateStreamingDistribution",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFront.CreateStreamingDistributionWithTags": [
            {
                "action": "cloudfront:CreateStreamingDistributionWithTags",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFront.DeleteCachePolicy": [
            {
                "action": "cloudfront:DeleteCachePolicy",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeleteCloudFrontOriginAccessIdentity": [
            {
                "action": "cloudfront:DeleteCloudFrontOriginAccessIdentity",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.DeleteDistribution": [
            {
                "action": "cloudfront:DeleteDistribution",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.DeleteFieldLevelEncryptionConfig": [
            {
                "action": "cloudfront:DeleteFieldLevelEncryptionConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeleteFieldLevelEncryptionProfile": [
            {
                "action": "cloudfront:DeleteFieldLevelEncryptionProfile",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeleteOriginRequestPolicy": [
            {
                "action": "cloudfront:DeleteOriginRequestPolicy",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeletePublicKey": [
            {
                "action": "cloudfront:DeletePublicKey",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeleteStreamingDistribution": [
            {
                "action": "cloudfront:DeleteStreamingDistribution",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.GetCachePolicy": [
            {
                "action": "cloudfront:GetCachePolicy",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetCachePolicyConfig": [
            {
                "action": "cloudfront:GetCachePolicyConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetCloudFrontOriginAccessIdentity": [
            {
                "action": "cloudfront:GetCloudFrontOriginAccessIdentity",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.GetCloudFrontOriginAccessIdentityConfig": [
            {
                "action": "cloudfront:GetCloudFrontOriginAccessIdentityConfig",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.GetDistribution": [
            {
                "action": "cloudfront:GetDistribution",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.GetDistributionConfig": [
            {
                "action": "cloudfront:GetDistributionConfig",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.GetFieldLevelEncryption": [
            {
                "action": "cloudfront:GetFieldLevelEncryption",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetFieldLevelEncryptionConfig": [
            {
                "action": "cloudfront:GetFieldLevelEncryptionConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetFieldLevelEncryptionProfile": [
            {
                "action": "cloudfront:GetFieldLevelEncryptionProfile",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetFieldLevelEncryptionProfileConfig": [
            {
                "action": "cloudfront:GetFieldLevelEncryptionProfileConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetInvalidation": [
            {
                "action": "cloudfront:GetInvalidation",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${DistributionId}"
                    }
                }
            }
        ],
        "CloudFront.GetOriginRequestPolicy": [
            {
                "action": "cloudfront:GetOriginRequestPolicy",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetOriginRequestPolicyConfig": [
            {
                "action": "cloudfront:GetOriginRequestPolicyConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetPublicKey": [
            {
                "action": "cloudfront:GetPublicKey",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetPublicKeyConfig": [
            {
                "action": "cloudfront:GetPublicKeyConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetStreamingDistribution": [
            {
                "action": "cloudfront:GetStreamingDistribution",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.GetStreamingDistributionConfig": [
            {
                "action": "cloudfront:GetStreamingDistributionConfig",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.ListCachePolicies": [
            {
                "action": "cloudfront:ListCachePolicies",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListCloudFrontOriginAccessIdentities": [
            {
                "action": "cloudfront:ListCloudFrontOriginAccessIdentities",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListDistributions": [
            {
                "action": "cloudfront:ListDistributions",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListDistributionsByCachePolicyId": [
            {
                "action": "cloudfront:ListDistributionsByCachePolicyId",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListDistributionsByOriginRequestPolicyId": [
            {
                "action": "cloudfront:ListDistributionsByOriginRequestPolicyId",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListDistributionsByWebACLId": [
            {
                "action": "cloudfront:ListDistributionsByWebACLId",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListFieldLevelEncryptionConfigs": [
            {
                "action": "cloudfront:ListFieldLevelEncryptionConfigs",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListFieldLevelEncryptionProfiles": [
            {
                "action": "cloudfront:ListFieldLevelEncryptionProfiles",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListInvalidations": [
            {
                "action": "cloudfront:ListInvalidations",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${DistributionId}"
                    }
                }
            }
        ],
        "CloudFront.ListOriginRequestPolicies": [
            {
                "action": "cloudfront:ListOriginRequestPolicies",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListPublicKeys": [
            {
                "action": "cloudfront:ListPublicKeys",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListStreamingDistributions": [
            {
                "action": "cloudfront:ListStreamingDistributions",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListTagsForResource": [
            {
                "action": "cloudfront:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "distribution": "%%iftemplatematch%${Resource}%%",
                    "streaming-distribution": "%%iftemplatematch%${Resource}%%"
                }
            }
        ],
        "CloudFront.TagResource": [
            {
                "action": "cloudfront:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "distribution": "%%iftemplatematch%${Resource}%%",
                    "streaming-distribution": "%%iftemplatematch%${Resource}%%"
                }
            }
        ],
        "CloudFront.UntagResource": [
            {
                "action": "cloudfront:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "distribution": "%%iftemplatematch%${Resource}%%",
                    "streaming-distribution": "%%iftemplatematch%${Resource}%%"
                }
            }
        ],
        "CloudFront.UpdateCachePolicy": [
            {
                "action": "cloudfront:UpdateCachePolicy",
                "resource_mappings": {}
            }
        ],
        "CloudFront.UpdateCloudFrontOriginAccessIdentity": [
            {
                "action": "cloudfront:UpdateCloudFrontOriginAccessIdentity",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.UpdateDistribution": [
            {
                "action": "cloudfront:UpdateDistribution",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.UpdateFieldLevelEncryptionConfig": [
            {
                "action": "cloudfront:UpdateFieldLevelEncryptionConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.UpdateFieldLevelEncryptionProfile": [
            {
                "action": "cloudfront:UpdateFieldLevelEncryptionProfile",
                "resource_mappings": {}
            }
        ],
        "CloudFront.UpdateOriginRequestPolicy": [
            {
                "action": "cloudfront:UpdateOriginRequestPolicy",
                "resource_mappings": {}
            }
        ],
        "CloudFront.UpdatePublicKey": [
            {
                "action": "cloudfront:UpdatePublicKey",
                "resource_mappings": {}
            }
        ],
        "CloudFront.UpdateStreamingDistribution": [
            {
                "action": "cloudfront:UpdateStreamingDistribution",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudHSM.AddTagsToResource": [
            {
                "action": "cloudhsm:AddTagsToResource",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.CreateHapg": [
            {
                "action": "cloudhsm:CreateHapg",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.CreateHsm": [
            {
                "action": "cloudhsm:CreateHsm",
                "resource_mappings": {
                    "CloudHsmClusterInstanceName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "CloudHSM.CreateLunaClient": [
            {
                "action": "cloudhsm:CreateLunaClient",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.DeleteHapg": [
            {
                "action": "cloudhsm:DeleteHapg",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.DeleteHsm": [
            {
                "action": "cloudhsm:DeleteHsm",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.DeleteLunaClient": [
            {
                "action": "cloudhsm:DeleteLunaClient",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.DescribeHapg": [
            {
                "action": "cloudhsm:DescribeHapg",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.DescribeHsm": [
            {
                "action": "cloudhsm:DescribeHsm",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.DescribeLunaClient": [
            {
                "action": "cloudhsm:DescribeLunaClient",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.GetConfig": [
            {
                "action": "cloudhsm:GetConfig",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.ListAvailableZones": [
            {
                "action": "cloudhsm:ListAvailableZones",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.ListHapgs": [
            {
                "action": "cloudhsm:ListHapgs",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.ListHsms": [
            {
                "action": "cloudhsm:ListHsms",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.ListLunaClients": [
            {
                "action": "cloudhsm:ListLunaClients",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.ListTagsForResource": [
            {
                "action": "cloudhsm:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.ModifyHapg": [
            {
                "action": "cloudhsm:ModifyHapg",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.ModifyHsm": [
            {
                "action": "cloudhsm:ModifyHsm",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "CloudHSM.ModifyLunaClient": [
            {
                "action": "cloudhsm:ModifyLunaClient",
                "resource_mappings": {}
            }
        ],
        "CloudHSM.RemoveTagsFromResource": [
            {
                "action": "cloudhsm:RemoveTagsFromResource",
                "resource_mappings": {}
            }
        ],
        "CloudSearch.BuildSuggesters": [
            {
                "action": "cloudsearch:BuildSuggesters",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.CreateDomain": [
            {
                "action": "cloudsearch:CreateDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DefineAnalysisScheme": [
            {
                "action": "cloudsearch:DefineAnalysisScheme",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DefineExpression": [
            {
                "action": "cloudsearch:DefineExpression",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DefineIndexField": [
            {
                "action": "cloudsearch:DefineIndexField",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DefineSuggester": [
            {
                "action": "cloudsearch:DefineSuggester",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DeleteAnalysisScheme": [
            {
                "action": "cloudsearch:DeleteAnalysisScheme",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DeleteDomain": [
            {
                "action": "cloudsearch:DeleteDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DeleteExpression": [
            {
                "action": "cloudsearch:DeleteExpression",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DeleteIndexField": [
            {
                "action": "cloudsearch:DeleteIndexField",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DeleteSuggester": [
            {
                "action": "cloudsearch:DeleteSuggester",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DescribeAnalysisSchemes": [
            {
                "action": "cloudsearch:DescribeAnalysisSchemes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DescribeAvailabilityOptions": [
            {
                "action": "cloudsearch:DescribeAvailabilityOptions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DescribeDomainEndpointOptions": [
            {
                "action": "cloudsearch:DescribeDomainEndpointOptions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DescribeDomains": [
            {
                "action": "cloudsearch:DescribeDomains",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainNames[]}"
                    }
                }
            }
        ],
        "CloudSearch.DescribeExpressions": [
            {
                "action": "cloudsearch:DescribeExpressions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DescribeIndexFields": [
            {
                "action": "cloudsearch:DescribeIndexFields",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DescribeScalingParameters": [
            {
                "action": "cloudsearch:DescribeScalingParameters",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DescribeServiceAccessPolicies": [
            {
                "action": "cloudsearch:DescribeServiceAccessPolicies",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.DescribeSuggesters": [
            {
                "action": "cloudsearch:DescribeSuggesters",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.IndexDocuments": [
            {
                "action": "cloudsearch:IndexDocuments",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.ListDomainNames": [
            {
                "action": "cloudsearch:ListDomainNames",
                "resource_mappings": {
                    "DomainName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudSearch.UpdateAvailabilityOptions": [
            {
                "action": "cloudsearch:UpdateAvailabilityOptions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.UpdateDomainEndpointOptions": [
            {
                "action": "cloudsearch:UpdateDomainEndpointOptions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.UpdateScalingParameters": [
            {
                "action": "cloudsearch:UpdateScalingParameters",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudSearch.UpdateServiceAccessPolicies": [
            {
                "action": "cloudsearch:UpdateServiceAccessPolicies",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CloudTrail.AddTags": [
            {
                "action": "cloudtrail:AddTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "trail": "${ResourceId}"
                }
            }
        ],
        "CloudTrail.CreateTrail": [
            {
                "action": "cloudtrail:CreateTrail",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${S3BucketName}"
                    },
                    "ObjectName": {
                        "template": "${S3KeyPrefix}*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${CloudWatchLogsRoleArn}"
                }
            }
        ],
        "CloudTrail.DeleteTrail": [
            {
                "action": "cloudtrail:DeleteTrail",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudTrail.DescribeTrails": [
            {
                "action": "cloudtrail:DescribeTrails",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.GetEventSelectors": [
            {
                "action": "cloudtrail:GetEventSelectors",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${TrailName}"
                    }
                }
            }
        ],
        "CloudTrail.GetInsightSelectors": [
            {
                "action": "cloudtrail:GetInsightSelectors",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${TrailName}"
                    }
                }
            }
        ],
        "CloudTrail.GetTrail": [
            {
                "action": "cloudtrail:GetTrail",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.GetTrailStatus": [
            {
                "action": "cloudtrail:GetTrailStatus",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudTrail.ListPublicKeys": [
            {
                "action": "cloudtrail:ListPublicKeys",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.ListTags": [
            {
                "action": "cloudtrail:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "trail": "${ResourceIdList[]}"
                }
            }
        ],
        "CloudTrail.ListTrails": [
            {
                "action": "cloudtrail:ListTrails",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.LookupEvents": [
            {
                "action": "cloudtrail:LookupEvents",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.PutEventSelectors": [
            {
                "action": "cloudtrail:PutEventSelectors",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${TrailName}"
                    }
                }
            }
        ],
        "CloudTrail.PutInsightSelectors": [
            {
                "action": "cloudtrail:PutInsightSelectors",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${TrailName}"
                    }
                }
            }
        ],
        "CloudTrail.RemoveTags": [
            {
                "action": "cloudtrail:RemoveTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "trail": "${ResourceId}"
                }
            }
        ],
        "CloudTrail.StartLogging": [
            {
                "action": "cloudtrail:StartLogging",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudTrail.StopLogging": [
            {
                "action": "cloudtrail:StopLogging",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudTrail.UpdateTrail": [
            {
                "action": "cloudtrail:UpdateTrail",
                "resource_mappings": {
                    "TrailName": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${CloudWatchLogsRoleArn}"
                }
            }
        ],
        "CloudWatch.DeleteAlarms": [
            {
                "action": "cloudwatch:DeleteAlarms",
                "resource_mappings": {
                    "AlarmName": {
                        "template": "${AlarmNames[]}"
                    }
                }
            }
        ],
        "CloudWatch.DeleteAnomalyDetector": [
            {
                "action": "cloudwatch:DeleteAnomalyDetector",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.DeleteDashboards": [
            {
                "action": "cloudwatch:DeleteDashboards",
                "resource_mappings": {
                    "DashboardName": {
                        "template": "${DashboardNames[]}"
                    }
                }
            }
        ],
        "CloudWatch.DeleteInsightRules": [
            {
                "action": "cloudwatch:DeleteInsightRules",
                "resource_mappings": {
                    "InsightRuleName": {
                        "template": "${RuleNames[]}"
                    }
                }
            }
        ],
        "CloudWatch.DescribeAlarmHistory": [
            {
                "action": "cloudwatch:DescribeAlarmHistory",
                "resource_mappings": {
                    "AlarmName": {
                        "template": "${AlarmName}"
                    }
                }
            }
        ],
        "CloudWatch.DescribeAlarms": [
            {
                "action": "cloudwatch:DescribeAlarms",
                "resource_mappings": {
                    "AlarmName": {
                        "template": "%%many%${AlarmNames[]}%${AlarmNamePrefix}*%%"
                    }
                }
            }
        ],
        "CloudWatch.DescribeAlarmsForMetric": [
            {
                "action": "cloudwatch:DescribeAlarmsForMetric",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.DescribeAnomalyDetectors": [
            {
                "action": "cloudwatch:DescribeAnomalyDetectors",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.DescribeInsightRules": [
            {
                "action": "cloudwatch:DescribeInsightRules",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.DisableAlarmActions": [
            {
                "action": "cloudwatch:DisableAlarmActions",
                "resource_mappings": {
                    "AlarmName": {
                        "template": "${AlarmNames[]}"
                    }
                }
            }
        ],
        "CloudWatch.DisableInsightRules": [
            {
                "action": "cloudwatch:DisableInsightRules",
                "resource_mappings": {
                    "InsightRuleName": {
                        "template": "${RuleNames[]}"
                    }
                }
            }
        ],
        "CloudWatch.EnableAlarmActions": [
            {
                "action": "cloudwatch:EnableAlarmActions",
                "resource_mappings": {
                    "AlarmName": {
                        "template": "${AlarmNames[]}"
                    }
                }
            }
        ],
        "CloudWatch.EnableInsightRules": [
            {
                "action": "cloudwatch:EnableInsightRules",
                "resource_mappings": {
                    "InsightRuleName": {
                        "template": "${RuleNames[]}"
                    }
                }
            }
        ],
        "CloudWatch.GetDashboard": [
            {
                "action": "cloudwatch:GetDashboard",
                "resource_mappings": {
                    "DashboardName": {
                        "template": "${DashboardName}"
                    }
                }
            }
        ],
        "CloudWatch.GetInsightRuleReport": [
            {
                "action": "cloudwatch:GetInsightRuleReport",
                "resource_mappings": {
                    "InsightRuleName": {
                        "template": "${RuleName}"
                    }
                }
            }
        ],
        "CloudWatch.GetMetricData": [
            {
                "action": "cloudwatch:GetMetricData",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.GetMetricStatistics": [
            {
                "action": "cloudwatch:GetMetricStatistics",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.GetMetricWidgetImage": [
            {
                "action": "cloudwatch:GetMetricWidgetImage",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.ListDashboards": [
            {
                "action": "cloudwatch:ListDashboards",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.ListMetrics": [
            {
                "action": "cloudwatch:ListMetrics",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.ListTagsForResource": [
            {
                "action": "cloudwatch:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "alarm": "%%iftemplatematch%${ResourceARN}%%",
                    "insight-rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "CloudWatch.PutAnomalyDetector": [
            {
                "action": "cloudwatch:PutAnomalyDetector",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.PutCompositeAlarm": [
            {
                "action": "cloudwatch:PutCompositeAlarm",
                "resource_mappings": {
                    "AlarmName": {
                        "template": "${AlarmName}"
                    }
                }
            }
        ],
        "CloudWatch.PutDashboard": [
            {
                "action": "cloudwatch:PutDashboard",
                "resource_mappings": {
                    "DashboardName": {
                        "template": "${DashboardName}"
                    }
                }
            }
        ],
        "CloudWatch.PutInsightRule": [
            {
                "action": "cloudwatch:PutInsightRule",
                "resource_mappings": {
                    "InsightRuleName": {
                        "template": "${RuleName}"
                    }
                }
            }
        ],
        "CloudWatch.PutMetricAlarm": [
            {
                "action": "cloudwatch:PutMetricAlarm",
                "resource_mappings": {
                    "AlarmName": {
                        "template": "${AlarmName}"
                    }
                }
            }
        ],
        "CloudWatch.PutMetricData": [
            {
                "action": "cloudwatch:PutMetricData",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.SetAlarmState": [
            {
                "action": "cloudwatch:SetAlarmState",
                "resource_mappings": {
                    "AlarmName": {
                        "template": "${AlarmName}"
                    }
                }
            }
        ],
        "CloudWatch.TagResource": [
            {
                "action": "cloudwatch:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "alarm": "%%iftemplatematch%${ResourceARN}%%",
                    "insight-rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "CloudWatch.UntagResource": [
            {
                "action": "cloudwatch:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "alarm": "%%iftemplatematch%${ResourceARN}%%",
                    "insight-rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "CloudWatchEvents.ActivateEventSource": [
            {
                "action": "events:ActivateEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.CancelReplay": [
            {
                "action": "events:CancelReplay",
                "resource_mappings": {
                    "ReplayName": {
                        "template": "${ReplayName}"
                    }
                }
            }
        ],
        "CloudWatchEvents.CreateArchive": [
            {
                "action": "events:CreateArchive",
                "resource_mappings": {
                    "ArchiveName": {
                        "template": "${ArchiveName}"
                    }
                }
            }
        ],
        "CloudWatchEvents.CreateEventBus": [
            {
                "action": "events:CreateEventBus",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.CreatePartnerEventSource": [
            {
                "action": "events:CreatePartnerEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DeactivateEventSource": [
            {
                "action": "events:DeactivateEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DeleteArchive": [
            {
                "action": "events:DeleteArchive",
                "resource_mappings": {
                    "ArchiveName": {
                        "template": "${ArchiveName}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DeleteEventBus": [
            {
                "action": "events:DeleteEventBus",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DeletePartnerEventSource": [
            {
                "action": "events:DeletePartnerEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DeleteRule": [
            {
                "action": "events:DeleteRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DescribeArchive": [
            {
                "action": "events:DescribeArchive",
                "resource_mappings": {
                    "ArchiveName": {
                        "template": "${ArchiveName}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DescribeEventBus": [
            {
                "action": "events:DescribeEventBus",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DescribeEventSource": [
            {
                "action": "events:DescribeEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DescribePartnerEventSource": [
            {
                "action": "events:DescribePartnerEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DescribeReplay": [
            {
                "action": "events:DescribeReplay",
                "resource_mappings": {
                    "ReplayName": {
                        "template": "${ReplayName}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DescribeRule": [
            {
                "action": "events:DescribeRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DisableRule": [
            {
                "action": "events:DisableRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.EnableRule": [
            {
                "action": "events:EnableRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.ListArchives": [
            {
                "action": "events:ListArchives",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.ListEventBuses": [
            {
                "action": "events:ListEventBuses",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.ListEventSources": [
            {
                "action": "events:ListEventSources",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.ListPartnerEventSourceAccounts": [
            {
                "action": "events:ListPartnerEventSourceAccounts",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${EventSourceName}"
                    }
                }
            }
        ],
        "CloudWatchEvents.ListPartnerEventSources": [
            {
                "action": "events:ListPartnerEventSources",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.ListReplays": [
            {
                "action": "events:ListReplays",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.ListRuleNamesByTarget": [
            {
                "action": "events:ListRuleNamesByTarget",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.ListRules": [
            {
                "action": "events:ListRules",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.ListTagsForResource": [
            {
                "action": "events:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-bus": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "CloudWatchEvents.ListTargetsByRule": [
            {
                "action": "events:ListTargetsByRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Rule}"
                    }
                }
            }
        ],
        "CloudWatchEvents.PutEvents": [
            {
                "action": "events:PutEvents",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${Entries[].EventBusName}"
                    }
                }
            }
        ],
        "CloudWatchEvents.PutPartnerEvents": [
            {
                "action": "events:PutPartnerEvents",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.PutPermission": [
            {
                "action": "events:PutPermission",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.PutRule": [
            {
                "action": "events:PutRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.PutTargets": [
            {
                "action": "events:PutTargets",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Rule}"
                    }
                }
            }
        ],
        "CloudWatchEvents.RemovePermission": [
            {
                "action": "events:RemovePermission",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.RemoveTargets": [
            {
                "action": "events:RemoveTargets",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Rule}"
                    }
                }
            }
        ],
        "CloudWatchEvents.StartReplay": [
            {
                "action": "events:StartReplay",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "archive": "${EventSourceArn}"
                }
            }
        ],
        "CloudWatchEvents.TagResource": [
            {
                "action": "events:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-bus": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "CloudWatchEvents.TestEventPattern": [
            {
                "action": "events:TestEventPattern",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.UntagResource": [
            {
                "action": "events:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-bus": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "CloudWatchEvents.UpdateArchive": [
            {
                "action": "events:UpdateArchive",
                "resource_mappings": {
                    "ArchiveName": {
                        "template": "${ArchiveName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.AssociateKmsKey": [
            {
                "action": "logs:AssociateKmsKey",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.CancelExportTask": [
            {
                "action": "logs:CancelExportTask",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.CreateExportTask": [
            {
                "action": "logs:CreateExportTask",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.CreateLogGroup": [
            {
                "action": "logs:CreateLogGroup",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.CreateLogStream": [
            {
                "action": "logs:CreateLogStream",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DeleteDestination": [
            {
                "action": "logs:DeleteDestination",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.DeleteLogGroup": [
            {
                "action": "logs:DeleteLogGroup",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DeleteLogStream": [
            {
                "action": "logs:DeleteLogStream",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    },
                    "LogStreamName": {
                        "template": "${logStreamName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DeleteMetricFilter": [
            {
                "action": "logs:DeleteMetricFilter",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DeleteResourcePolicy": [
            {
                "action": "logs:DeleteResourcePolicy",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.DeleteRetentionPolicy": [
            {
                "action": "logs:DeleteRetentionPolicy",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DeleteSubscriptionFilter": [
            {
                "action": "logs:DeleteSubscriptionFilter",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DescribeDestinations": [
            {
                "action": "logs:DescribeDestinations",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.DescribeExportTasks": [
            {
                "action": "logs:DescribeExportTasks",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.DescribeLogGroups": [
            {
                "action": "logs:DescribeLogGroups",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupNamePrefix}*"
                    }
                }
            }
        ],
        "CloudWatchLogs.DescribeLogStreams": [
            {
                "action": "logs:DescribeLogStreams",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DescribeMetricFilters": [
            {
                "action": "logs:DescribeMetricFilters",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DescribeQueries": [
            {
                "action": "logs:DescribeQueries",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.DescribeResourcePolicies": [
            {
                "action": "logs:DescribeResourcePolicies",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.DescribeSubscriptionFilters": [
            {
                "action": "logs:DescribeSubscriptionFilters",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DisassociateKmsKey": [
            {
                "action": "logs:DisassociateKmsKey",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.FilterLogEvents": [
            {
                "action": "logs:FilterLogEvents",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.GetLogEvents": [
            {
                "action": "logs:GetLogEvents",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    },
                    "LogStreamName": {
                        "template": "${logStreamName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.GetLogGroupFields": [
            {
                "action": "logs:GetLogGroupFields",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.GetLogRecord": [
            {
                "action": "logs:GetLogRecord",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.GetQueryResults": [
            {
                "action": "logs:GetQueryResults",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.ListTagsLogGroup": [
            {
                "action": "logs:ListTagsLogGroup",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.PutDestination": [
            {
                "action": "logs:PutDestination",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "CloudWatchLogs.PutDestinationPolicy": [
            {
                "action": "logs:PutDestinationPolicy",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.PutLogEvents": [
            {
                "action": "logs:PutLogEvents",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    },
                    "LogStreamName": {
                        "template": "${logStreamName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.PutMetricFilter": [
            {
                "action": "logs:PutMetricFilter",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.PutResourcePolicy": [
            {
                "action": "logs:PutResourcePolicy",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.PutRetentionPolicy": [
            {
                "action": "logs:PutRetentionPolicy",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.PutSubscriptionFilter": [
            {
                "action": "logs:PutSubscriptionFilter",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "CloudWatchLogs.StartQuery": [
            {
                "action": "logs:StartQuery",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "%%many%${logGroupName}%${logGroupName[]}%%"
                    }
                }
            }
        ],
        "CloudWatchLogs.StopQuery": [
            {
                "action": "logs:StopQuery",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.TagLogGroup": [
            {
                "action": "logs:TagLogGroup",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CloudWatchLogs.TestMetricFilter": [
            {
                "action": "logs:TestMetricFilter",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.UntagLogGroup": [
            {
                "action": "logs:UntagLogGroup",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logGroupName}"
                    }
                }
            }
        ],
        "CodeBuild.BatchDeleteBuilds": [
            {
                "action": "codebuild:BatchDeleteBuilds",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "%%regex%${ids[]}%/\\:(.+)$/g%%"
                    }
                }
            }
        ],
        "CodeBuild.BatchGetBuildBatches": [
            {
                "action": "codebuild:BatchGetBuildBatches",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "%%regex%${ids[]}%/\\:(.+)$/g%%"
                    }
                }
            }
        ],
        "CodeBuild.BatchGetBuilds": [
            {
                "action": "codebuild:BatchGetBuilds",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "%%regex%${ids[]}%/\\:(.+)$/g%%"
                    }
                }
            }
        ],
        "CodeBuild.BatchGetProjects": [
            {
                "action": "codebuild:BatchGetProjects",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${names[]}"
                    }
                }
            }
        ],
        "CodeBuild.BatchGetReportGroups": [
            {
                "action": "codebuild:BatchGetReportGroups",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "report-group": "${reportGroupArns[]}"
                }
            }
        ],
        "CodeBuild.BatchGetReports": [
            {
                "action": "codebuild:BatchGetReports",
                "resource_mappings": {
                    "ReportGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeBuild.CreateProject": [
            {
                "action": "codebuild:CreateProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${serviceRole}%${buildBatchConfig.serviceRole}%%"
                }
            }
        ],
        "CodeBuild.CreateReportGroup": [
            {
                "action": "codebuild:CreateReportGroup",
                "resource_mappings": {
                    "ReportGroupName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "CodeBuild.CreateWebhook": [
            {
                "action": "codebuild:CreateWebhook",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "CodeBuild.DeleteBuildBatch": [
            {
                "action": "codebuild:DeleteBuildBatch",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "%%regex%${ids[]}%/\\:(.+)$/g%%"
                    }
                }
            }
        ],
        "CodeBuild.DeleteProject": [
            {
                "action": "codebuild:DeleteProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "CodeBuild.DeleteReport": [
            {
                "action": "codebuild:DeleteReport",
                "resource_mappings": {
                    "ReportGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeBuild.DeleteReportGroup": [
            {
                "action": "codebuild:DeleteReportGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "report-group": "${arn}"
                }
            }
        ],
        "CodeBuild.DeleteResourcePolicy": [
            {
                "action": "codebuild:DeleteResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "%%iftemplatematch%${resourceArn}%%",
                    "report-group": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeBuild.DeleteSourceCredentials": [
            {
                "action": "codebuild:DeleteSourceCredentials",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.DeleteWebhook": [
            {
                "action": "codebuild:DeleteWebhook",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "CodeBuild.DescribeCodeCoverages": [
            {
                "action": "codebuild:DescribeCodeCoverages",
                "resource_mappings": {
                    "ReportGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeBuild.DescribeTestCases": [
            {
                "action": "codebuild:DescribeTestCases",
                "resource_mappings": {
                    "ReportGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeBuild.GetResourcePolicy": [
            {
                "action": "codebuild:GetResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "%%iftemplatematch%${resourceArn}%%",
                    "report-group": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeBuild.ImportSourceCredentials": [
            {
                "action": "codebuild:ImportSourceCredentials",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.InvalidateProjectCache": [
            {
                "action": "codebuild:InvalidateProjectCache",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "CodeBuild.ListBuildBatches": [
            {
                "action": "codebuild:ListBuildBatches",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.ListBuildBatchesForProject": [
            {
                "action": "codebuild:ListBuildBatchesForProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "CodeBuild.ListBuilds": [
            {
                "action": "codebuild:ListBuilds",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.ListBuildsForProject": [
            {
                "action": "codebuild:ListBuildsForProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "CodeBuild.ListCuratedEnvironmentImages": [
            {
                "action": "codebuild:ListCuratedEnvironmentImages",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.ListProjects": [
            {
                "action": "codebuild:ListProjects",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.ListReportGroups": [
            {
                "action": "codebuild:ListReportGroups",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.ListReports": [
            {
                "action": "codebuild:ListReports",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.ListReportsForReportGroup": [
            {
                "action": "codebuild:ListReportsForReportGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "report-group": "${reportGroupArn}"
                }
            }
        ],
        "CodeBuild.ListSharedProjects": [
            {
                "action": "codebuild:ListSharedProjects",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.ListSharedReportGroups": [
            {
                "action": "codebuild:ListSharedReportGroups",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.ListSourceCredentials": [
            {
                "action": "codebuild:ListSourceCredentials",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.PutResourcePolicy": [
            {
                "action": "codebuild:PutResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "%%iftemplatematch%${resourceArn}%%",
                    "report-group": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeBuild.RetryBuild": [
            {
                "action": "codebuild:RetryBuild",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "%%regex%${id}%/\\:(.+)$/g%%"
                    }
                }
            }
        ],
        "CodeBuild.RetryBuildBatch": [
            {
                "action": "codebuild:RetryBuildBatch",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "%%regex%${id}%/\\:(.+)$/g%%"
                    }
                }
            }
        ],
        "CodeBuild.StartBuild": [
            {
                "action": "codebuild:StartBuild",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${serviceRoleOverride}"
                }
            }
        ],
        "CodeBuild.StartBuildBatch": [
            {
                "action": "codebuild:StartBuildBatch",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${serviceRoleOverride}%${buildBatchConfigOverride.serviceRole}%%"
                }
            }
        ],
        "CodeBuild.StopBuild": [
            {
                "action": "codebuild:StopBuild",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "%%regex%${id}%\\:(.+)$/g%%"
                    }
                }
            }
        ],
        "CodeBuild.StopBuildBatch": [
            {
                "action": "codebuild:StopBuildBatch",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "%%regex%${id}%\\:(.+)$/g%%"
                    }
                }
            }
        ],
        "CodeBuild.UpdateProject": [
            {
                "action": "codebuild:UpdateProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${serviceRole}%${buildBatchConfig.serviceRole}%%"
                }
            }
        ],
        "CodeBuild.UpdateReportGroup": [
            {
                "action": "codebuild:UpdateReportGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "report-group": "${arn}"
                }
            }
        ],
        "CodeBuild.UpdateWebhook": [
            {
                "action": "codebuild:UpdateWebhook",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "CodeCommit.AssociateApprovalRuleTemplateWithRepository": [
            {
                "action": "codecommit:AssociateApprovalRuleTemplateWithRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.BatchAssociateApprovalRuleTemplateWithRepositories": [
            {
                "action": "codecommit:BatchAssociateApprovalRuleTemplateWithRepositories",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryNames[]}"
                    }
                }
            }
        ],
        "CodeCommit.BatchDescribeMergeConflicts": [
            {
                "action": "codecommit:BatchDescribeMergeConflicts",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.BatchDisassociateApprovalRuleTemplateFromRepositories": [
            {
                "action": "codecommit:BatchDisassociateApprovalRuleTemplateFromRepositories",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryNames[]}"
                    }
                }
            }
        ],
        "CodeCommit.BatchGetCommits": [
            {
                "action": "codecommit:BatchGetCommits",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.BatchGetRepositories": [
            {
                "action": "codecommit:BatchGetRepositories",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryNames[]}"
                    }
                }
            }
        ],
        "CodeCommit.CreateApprovalRuleTemplate": [
            {
                "action": "codecommit:CreateApprovalRuleTemplate",
                "resource_mappings": {}
            }
        ],
        "CodeCommit.CreateBranch": [
            {
                "action": "codecommit:CreateBranch",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.CreateCommit": [
            {
                "action": "codecommit:CreateCommit",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.CreatePullRequest": [
            {
                "action": "codecommit:CreatePullRequest",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${targets[].repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.CreatePullRequestApprovalRule": [
            {
                "action": "codecommit:CreatePullRequestApprovalRule",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.CreateRepository": [
            {
                "action": "codecommit:CreateRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.CreateUnreferencedMergeCommit": [
            {
                "action": "codecommit:CreateUnreferencedMergeCommit",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.DeleteApprovalRuleTemplate": [
            {
                "action": "codecommit:DeleteApprovalRuleTemplate",
                "resource_mappings": {}
            }
        ],
        "CodeCommit.DeleteBranch": [
            {
                "action": "codecommit:DeleteBranch",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.DeleteCommentContent": [
            {
                "action": "codecommit:DeleteCommentContent",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.DeleteFile": [
            {
                "action": "codecommit:DeleteFile",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.DeletePullRequestApprovalRule": [
            {
                "action": "codecommit:DeletePullRequestApprovalRule",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.DeleteRepository": [
            {
                "action": "codecommit:DeleteRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.DescribeMergeConflicts": [
            {
                "action": "codecommit:DescribeMergeConflicts",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.DescribePullRequestEvents": [
            {
                "action": "codecommit:DescribePullRequestEvents",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.DisassociateApprovalRuleTemplateFromRepository": [
            {
                "action": "codecommit:DisassociateApprovalRuleTemplateFromRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.EvaluatePullRequestApprovalRules": [
            {
                "action": "codecommit:EvaluatePullRequestApprovalRules",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.GetApprovalRuleTemplate": [
            {
                "action": "codecommit:GetApprovalRuleTemplate",
                "resource_mappings": {}
            }
        ],
        "CodeCommit.GetBlob": [
            {
                "action": "codecommit:GetBlob",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetBranch": [
            {
                "action": "codecommit:GetBranch",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetComment": [
            {
                "action": "codecommit:GetComment",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.GetCommentReactions": [
            {
                "action": "codecommit:GetCommentReactions",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.GetCommentsForComparedCommit": [
            {
                "action": "codecommit:GetCommentsForComparedCommit",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetCommentsForPullRequest": [
            {
                "action": "codecommit:GetCommentsForPullRequest",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetCommit": [
            {
                "action": "codecommit:GetCommit",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetDifferences": [
            {
                "action": "codecommit:GetDifferences",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetFile": [
            {
                "action": "codecommit:GetFile",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetFolder": [
            {
                "action": "codecommit:GetFolder",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetMergeCommit": [
            {
                "action": "codecommit:GetMergeCommit",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetMergeConflicts": [
            {
                "action": "codecommit:GetMergeConflicts",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetMergeOptions": [
            {
                "action": "codecommit:GetMergeOptions",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetPullRequest": [
            {
                "action": "codecommit:GetPullRequest",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.GetPullRequestApprovalStates": [
            {
                "action": "codecommit:GetPullRequestApprovalStates",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.GetPullRequestOverrideState": [
            {
                "action": "codecommit:GetPullRequestOverrideState",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.GetRepository": [
            {
                "action": "codecommit:GetRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.GetRepositoryTriggers": [
            {
                "action": "codecommit:GetRepositoryTriggers",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.ListApprovalRuleTemplates": [
            {
                "action": "codecommit:ListApprovalRuleTemplates",
                "resource_mappings": {}
            }
        ],
        "CodeCommit.ListAssociatedApprovalRuleTemplatesForRepository": [
            {
                "action": "codecommit:ListAssociatedApprovalRuleTemplatesForRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.ListBranches": [
            {
                "action": "codecommit:ListBranches",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.ListPullRequests": [
            {
                "action": "codecommit:ListPullRequests",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.ListRepositories": [
            {
                "action": "codecommit:ListRepositories",
                "resource_mappings": {}
            }
        ],
        "CodeCommit.ListRepositoriesForApprovalRuleTemplate": [
            {
                "action": "codecommit:ListRepositoriesForApprovalRuleTemplate",
                "resource_mappings": {}
            }
        ],
        "CodeCommit.ListTagsForResource": [
            {
                "action": "codecommit:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "repository": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeCommit.MergeBranchesByFastForward": [
            {
                "action": "codecommit:MergeBranchesByFastForward",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.MergeBranchesBySquash": [
            {
                "action": "codecommit:MergeBranchesBySquash",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.MergeBranchesByThreeWay": [
            {
                "action": "codecommit:MergeBranchesByThreeWay",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.MergePullRequestByFastForward": [
            {
                "action": "codecommit:MergePullRequestByFastForward",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.MergePullRequestBySquash": [
            {
                "action": "codecommit:MergePullRequestBySquash",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.MergePullRequestByThreeWay": [
            {
                "action": "codecommit:MergePullRequestByThreeWay",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.OverridePullRequestApprovalRules": [
            {
                "action": "codecommit:OverridePullRequestApprovalRules",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.PostCommentForComparedCommit": [
            {
                "action": "codecommit:PostCommentForComparedCommit",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.PostCommentForPullRequest": [
            {
                "action": "codecommit:PostCommentForPullRequest",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.PostCommentReply": [
            {
                "action": "codecommit:PostCommentReply",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.PutCommentReaction": [
            {
                "action": "codecommit:PutCommentReaction",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.PutFile": [
            {
                "action": "codecommit:PutFile",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.PutRepositoryTriggers": [
            {
                "action": "codecommit:PutRepositoryTriggers",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.TagResource": [
            {
                "action": "codecommit:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "repository": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeCommit.TestRepositoryTriggers": [
            {
                "action": "codecommit:TestRepositoryTriggers",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.UntagResource": [
            {
                "action": "codecommit:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "repository": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeCommit.UpdateApprovalRuleTemplateContent": [
            {
                "action": "codecommit:UpdateApprovalRuleTemplateContent",
                "resource_mappings": {}
            }
        ],
        "CodeCommit.UpdateApprovalRuleTemplateDescription": [
            {
                "action": "codecommit:UpdateApprovalRuleTemplateDescription",
                "resource_mappings": {}
            }
        ],
        "CodeCommit.UpdateApprovalRuleTemplateName": [
            {
                "action": "codecommit:UpdateApprovalRuleTemplateName",
                "resource_mappings": {}
            }
        ],
        "CodeCommit.UpdateComment": [
            {
                "action": "codecommit:UpdateComment",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.UpdateDefaultBranch": [
            {
                "action": "codecommit:UpdateDefaultBranch",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.UpdatePullRequestApprovalRuleContent": [
            {
                "action": "codecommit:UpdatePullRequestApprovalRuleContent",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.UpdatePullRequestApprovalState": [
            {
                "action": "codecommit:UpdatePullRequestApprovalState",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.UpdatePullRequestDescription": [
            {
                "action": "codecommit:UpdatePullRequestDescription",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.UpdatePullRequestStatus": [
            {
                "action": "codecommit:UpdatePullRequestStatus",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.UpdatePullRequestTitle": [
            {
                "action": "codecommit:UpdatePullRequestTitle",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeCommit.UpdateRepositoryDescription": [
            {
                "action": "codecommit:UpdateRepositoryDescription",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "CodeCommit.UpdateRepositoryName": [
            {
                "action": "codecommit:UpdateRepositoryName",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "%%many%${oldName}%${newName}%%"
                    }
                }
            }
        ],
        "CodeDeploy.AddTagsToOnPremisesInstances": [
            {
                "action": "codedeploy:AddTagsToOnPremisesInstances",
                "resource_mappings": {
                    "InstanceName": {
                        "template": "${instanceNames[]}"
                    }
                }
            }
        ],
        "CodeDeploy.BatchGetApplicationRevisions": [
            {
                "action": "codedeploy:BatchGetApplicationRevisions",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    }
                }
            }
        ],
        "CodeDeploy.BatchGetApplications": [
            {
                "action": "codedeploy:BatchGetApplications",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationNames[]}"
                    }
                }
            }
        ],
        "CodeDeploy.BatchGetDeploymentGroups": [
            {
                "action": "codedeploy:BatchGetDeploymentGroups",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    },
                    "DeploymentGroupName": {
                        "template": "${deploymentGroupNames[]}"
                    }
                }
            }
        ],
        "CodeDeploy.BatchGetDeploymentInstances": [
            {
                "action": "codedeploy:BatchGetDeploymentInstances",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "DeploymentGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeDeploy.BatchGetDeploymentTargets": [
            {
                "action": "codedeploy:BatchGetDeploymentTargets",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.BatchGetDeployments": [
            {
                "action": "codedeploy:BatchGetDeployments",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "DeploymentGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeDeploy.BatchGetOnPremisesInstances": [
            {
                "action": "codedeploy:BatchGetOnPremisesInstances",
                "resource_mappings": {
                    "InstanceName": {
                        "template": "${instanceNames[]}"
                    }
                }
            }
        ],
        "CodeDeploy.ContinueDeployment": [
            {
                "action": "codedeploy:ContinueDeployment",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.CreateApplication": [
            {
                "action": "codedeploy:CreateApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    }
                }
            }
        ],
        "CodeDeploy.CreateDeployment": [
            {
                "action": "codedeploy:CreateDeployment",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    },
                    "DeploymentGroupName": {
                        "template": "${deploymentGroupName}"
                    }
                }
            }
        ],
        "CodeDeploy.CreateDeploymentConfig": [
            {
                "action": "codedeploy:CreateDeploymentConfig",
                "resource_mappings": {
                    "DeploymentConfigurationName": {
                        "template": "${deploymentConfigName}"
                    }
                }
            }
        ],
        "CodeDeploy.CreateDeploymentGroup": [
            {
                "action": "codedeploy:CreateDeploymentGroup",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    },
                    "DeploymentGroupName": {
                        "template": "${deploymentGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${serviceRoleArn}"
                }
            }
        ],
        "CodeDeploy.DeleteApplication": [
            {
                "action": "codedeploy:DeleteApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    }
                }
            }
        ],
        "CodeDeploy.DeleteDeploymentConfig": [
            {
                "action": "codedeploy:DeleteDeploymentConfig",
                "resource_mappings": {
                    "DeploymentConfigurationName": {
                        "template": "${deploymentConfigName}"
                    }
                }
            }
        ],
        "CodeDeploy.DeleteDeploymentGroup": [
            {
                "action": "codedeploy:DeleteDeploymentGroup",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    },
                    "DeploymentGroupName": {
                        "template": "${deploymentGroupName}"
                    }
                }
            }
        ],
        "CodeDeploy.DeleteGitHubAccountToken": [
            {
                "action": "codedeploy:DeleteGitHubAccountToken",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.DeleteResourcesByExternalId": [
            {
                "action": "codedeploy:DeleteResourcesByExternalId",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.DeregisterOnPremisesInstance": [
            {
                "action": "codedeploy:DeregisterOnPremisesInstance",
                "resource_mappings": {
                    "InstanceName": {
                        "template": "${instanceName}"
                    }
                }
            }
        ],
        "CodeDeploy.GetApplication": [
            {
                "action": "codedeploy:GetApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    }
                }
            }
        ],
        "CodeDeploy.GetApplicationRevision": [
            {
                "action": "codedeploy:GetApplicationRevision",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    }
                }
            }
        ],
        "CodeDeploy.GetDeployment": [
            {
                "action": "codedeploy:GetDeployment",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "DeploymentGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeDeploy.GetDeploymentConfig": [
            {
                "action": "codedeploy:GetDeploymentConfig",
                "resource_mappings": {
                    "DeploymentConfigurationName": {
                        "template": "${deploymentConfigName}"
                    }
                }
            }
        ],
        "CodeDeploy.GetDeploymentGroup": [
            {
                "action": "codedeploy:GetDeploymentGroup",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    },
                    "DeploymentGroupName": {
                        "template": "${deploymentGroupName}"
                    }
                }
            }
        ],
        "CodeDeploy.GetDeploymentInstance": [
            {
                "action": "codedeploy:GetDeploymentInstance",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "DeploymentGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeDeploy.GetDeploymentTarget": [
            {
                "action": "codedeploy:GetDeploymentTarget",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.GetOnPremisesInstance": [
            {
                "action": "codedeploy:GetOnPremisesInstance",
                "resource_mappings": {
                    "InstanceName": {
                        "template": "${instanceName}"
                    }
                }
            }
        ],
        "CodeDeploy.ListApplicationRevisions": [
            {
                "action": "codedeploy:ListApplicationRevisions",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    }
                }
            }
        ],
        "CodeDeploy.ListApplications": [
            {
                "action": "codedeploy:ListApplications",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.ListDeploymentConfigs": [
            {
                "action": "codedeploy:ListDeploymentConfigs",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.ListDeploymentGroups": [
            {
                "action": "codedeploy:ListDeploymentGroups",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    }
                }
            }
        ],
        "CodeDeploy.ListDeploymentInstances": [
            {
                "action": "codedeploy:ListDeploymentInstances",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "DeploymentGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeDeploy.ListDeploymentTargets": [
            {
                "action": "codedeploy:ListDeploymentTargets",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.ListDeployments": [
            {
                "action": "codedeploy:ListDeployments",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    },
                    "DeploymentGroupName": {
                        "template": "${deploymentGroupName}"
                    }
                }
            }
        ],
        "CodeDeploy.ListGitHubAccountTokenNames": [
            {
                "action": "codedeploy:ListGitHubAccountTokenNames",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.ListOnPremisesInstances": [
            {
                "action": "codedeploy:ListOnPremisesInstances",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.ListTagsForResource": [
            {
                "action": "codedeploy:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceArn}%%",
                    "deploymentgroup": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CodeDeploy.PutLifecycleEventHookExecutionStatus": [
            {
                "action": "codedeploy:PutLifecycleEventHookExecutionStatus",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.RegisterApplicationRevision": [
            {
                "action": "codedeploy:RegisterApplicationRevision",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    }
                }
            }
        ],
        "CodeDeploy.RegisterOnPremisesInstance": [
            {
                "action": "codedeploy:RegisterOnPremisesInstance",
                "resource_mappings": {
                    "InstanceName": {
                        "template": "${instanceName}"
                    }
                }
            }
        ],
        "CodeDeploy.RemoveTagsFromOnPremisesInstances": [
            {
                "action": "codedeploy:RemoveTagsFromOnPremisesInstances",
                "resource_mappings": {
                    "InstanceName": {
                        "template": "${instanceNames[]}"
                    }
                }
            }
        ],
        "CodeDeploy.SkipWaitTimeForInstanceTermination": [
            {
                "action": "codedeploy:SkipWaitTimeForInstanceTermination",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.StopDeployment": [
            {
                "action": "codedeploy:StopDeployment",
                "resource_mappings": {}
            }
        ],
        "CodeDeploy.TagResource": [
            {
                "action": "codedeploy:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceArn}%%",
                    "deploymentgroup": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CodeDeploy.UntagResource": [
            {
                "action": "codedeploy:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceArn}%%",
                    "deploymentgroup": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CodeDeploy.UpdateApplication": [
            {
                "action": "codedeploy:UpdateApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "%%many%${applicationName}%${newApplicationName}%%"
                    }
                }
            }
        ],
        "CodeDeploy.UpdateDeploymentGroup": [
            {
                "action": "codedeploy:UpdateDeploymentGroup",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${applicationName}"
                    },
                    "DeploymentGroupName": {
                        "template": "%many:${currentDeploymentGroupName}:${newDeploymentGroupName}%"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${serviceRoleArn}"
                }
            }
        ],
        "CodePipeline.AcknowledgeJob": [
            {
                "action": "codepipeline:AcknowledgeJob",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.AcknowledgeThirdPartyJob": [
            {
                "action": "codepipeline:AcknowledgeThirdPartyJob",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.CreateCustomActionType": [
            {
                "action": "codepipeline:CreateCustomActionType",
                "resource_mappings": {
                    "Owner": {
                        "template": "Custom"
                    },
                    "Category": {
                        "template": "${category}"
                    },
                    "Provider": {
                        "template": "${provider}"
                    },
                    "Version": {
                        "template": "${version}"
                    }
                }
            }
        ],
        "CodePipeline.CreatePipeline": [
            {
                "action": "codepipeline:CreatePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipeline.name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${pipeline.roleArn}"
                }
            }
        ],
        "CodePipeline.DeleteCustomActionType": [
            {
                "action": "codepipeline:DeleteCustomActionType",
                "resource_mappings": {
                    "Owner": {
                        "template": "ThirdParty"
                    },
                    "Category": {
                        "template": "${category}"
                    },
                    "Provider": {
                        "template": "${provider}"
                    },
                    "Version": {
                        "template": "${version}"
                    }
                }
            }
        ],
        "CodePipeline.DeletePipeline": [
            {
                "action": "codepipeline:DeletePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "CodePipeline.DeleteWebhook": [
            {
                "action": "codepipeline:DeleteWebhook",
                "resource_mappings": {
                    "WebhookName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "CodePipeline.DeregisterWebhookWithThirdParty": [
            {
                "action": "codepipeline:DeregisterWebhookWithThirdParty",
                "resource_mappings": {
                    "WebhookName": {
                        "template": "${webhookName}"
                    }
                }
            }
        ],
        "CodePipeline.DisableStageTransition": [
            {
                "action": "codepipeline:DisableStageTransition",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    },
                    "StageName": {
                        "template": "${stageName}"
                    }
                }
            }
        ],
        "CodePipeline.EnableStageTransition": [
            {
                "action": "codepipeline:EnableStageTransition",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    },
                    "StageName": {
                        "template": "${stageName}"
                    }
                }
            }
        ],
        "CodePipeline.GetJobDetails": [
            {
                "action": "codepipeline:GetJobDetails",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.GetPipeline": [
            {
                "action": "codepipeline:GetPipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "CodePipeline.GetPipelineExecution": [
            {
                "action": "codepipeline:GetPipelineExecution",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "CodePipeline.GetPipelineState": [
            {
                "action": "codepipeline:GetPipelineState",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "CodePipeline.GetThirdPartyJobDetails": [
            {
                "action": "codepipeline:GetThirdPartyJobDetails",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.ListActionExecutions": [
            {
                "action": "codepipeline:ListActionExecutions",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "CodePipeline.ListActionTypes": [
            {
                "action": "codepipeline:ListActionTypes",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.ListPipelineExecutions": [
            {
                "action": "codepipeline:ListPipelineExecutions",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "CodePipeline.ListPipelines": [
            {
                "action": "codepipeline:ListPipelines",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.ListTagsForResource": [
            {
                "action": "codepipeline:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "actiontype": "%%iftemplatematch%${resourceArn}%%",
                    "pipeline": "%%iftemplatematch%${resourceArn}%%",
                    "webhook": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodePipeline.ListWebhooks": [
            {
                "action": "codepipeline:ListWebhooks",
                "resource_mappings": {
                    "WebhookName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodePipeline.PollForJobs": [
            {
                "action": "codepipeline:PollForJobs",
                "resource_mappings": {
                    "Owner": {
                        "template": "${actionTypeId.owner}"
                    },
                    "Category": {
                        "template": "${actionTypeId.category}"
                    },
                    "Provider": {
                        "template": "${actionTypeId.provider}"
                    },
                    "Version": {
                        "template": "${actionTypeId.version}"
                    }
                }
            }
        ],
        "CodePipeline.PollForThirdPartyJobs": [
            {
                "action": "codepipeline:PollForThirdPartyJobs",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.PutActionRevision": [
            {
                "action": "codepipeline:PutActionRevision",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    },
                    "StageName": {
                        "template": "${stageName}"
                    },
                    "ActionName": {
                        "template": "${actionName}"
                    }
                }
            }
        ],
        "CodePipeline.PutApprovalResult": [
            {
                "action": "codepipeline:PutApprovalResult",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    },
                    "StageName": {
                        "template": "${stageName}"
                    },
                    "ActionName": {
                        "template": "${actionName}"
                    }
                }
            }
        ],
        "CodePipeline.PutJobFailureResult": [
            {
                "action": "codepipeline:PutJobFailureResult",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.PutJobSuccessResult": [
            {
                "action": "codepipeline:PutJobSuccessResult",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.PutThirdPartyJobFailureResult": [
            {
                "action": "codepipeline:PutThirdPartyJobFailureResult",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.PutThirdPartyJobSuccessResult": [
            {
                "action": "codepipeline:PutThirdPartyJobSuccessResult",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.PutWebhook": [
            {
                "action": "codepipeline:PutWebhook",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${webhook.targetPipeline}"
                    },
                    "WebhookName": {
                        "template": "${webhook.name}"
                    }
                }
            }
        ],
        "CodePipeline.RegisterWebhookWithThirdParty": [
            {
                "action": "codepipeline:RegisterWebhookWithThirdParty",
                "resource_mappings": {
                    "WebhookName": {
                        "template": "${webhookName}"
                    }
                }
            }
        ],
        "CodePipeline.RetryStageExecution": [
            {
                "action": "codepipeline:RetryStageExecution",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    },
                    "StageName": {
                        "template": "${stageName}"
                    }
                }
            }
        ],
        "CodePipeline.StartPipelineExecution": [
            {
                "action": "codepipeline:StartPipelineExecution",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "CodePipeline.StopPipelineExecution": [
            {
                "action": "codepipeline:StopPipelineExecution",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "CodePipeline.TagResource": [
            {
                "action": "codepipeline:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "actiontype": "%%iftemplatematch%${resourceArn}%%",
                    "pipeline": "%%iftemplatematch%${resourceArn}%%",
                    "webhook": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodePipeline.UntagResource": [
            {
                "action": "codepipeline:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "actiontype": "%%iftemplatematch%${resourceArn}%%",
                    "pipeline": "%%iftemplatematch%${resourceArn}%%",
                    "webhook": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodePipeline.UpdatePipeline": [
            {
                "action": "codepipeline:UpdatePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipeline.name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${pipeline.roleArn}"
                }
            }
        ],
        "CognitoIdentityServiceProvider.AddCustomAttributes": [
            {
                "action": "cognito-idp:AddCustomAttributes",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminAddUserToGroup": [
            {
                "action": "cognito-idp:AdminAddUserToGroup",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminConfirmSignUp": [
            {
                "action": "cognito-idp:AdminConfirmSignUp",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminCreateUser": [
            {
                "action": "cognito-idp:AdminCreateUser",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminDeleteUser": [
            {
                "action": "cognito-idp:AdminDeleteUser",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminDeleteUserAttributes": [
            {
                "action": "cognito-idp:AdminDeleteUserAttributes",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminDisableProviderForUser": [
            {
                "action": "cognito-idp:AdminDisableProviderForUser",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminDisableUser": [
            {
                "action": "cognito-idp:AdminDisableUser",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminEnableUser": [
            {
                "action": "cognito-idp:AdminEnableUser",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminForgetDevice": [
            {
                "action": "cognito-idp:AdminForgetDevice",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminGetDevice": [
            {
                "action": "cognito-idp:AdminGetDevice",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminGetUser": [
            {
                "action": "cognito-idp:AdminGetUser",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminInitiateAuth": [
            {
                "action": "cognito-idp:AdminInitiateAuth",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminLinkProviderForUser": [
            {
                "action": "cognito-idp:AdminLinkProviderForUser",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminListDevices": [
            {
                "action": "cognito-idp:AdminListDevices",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminListGroupsForUser": [
            {
                "action": "cognito-idp:AdminListGroupsForUser",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminListUserAuthEvents": [
            {
                "action": "cognito-idp:AdminListUserAuthEvents",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminRemoveUserFromGroup": [
            {
                "action": "cognito-idp:AdminRemoveUserFromGroup",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminResetUserPassword": [
            {
                "action": "cognito-idp:AdminResetUserPassword",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminRespondToAuthChallenge": [
            {
                "action": "cognito-idp:AdminRespondToAuthChallenge",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminSetUserMFAPreference": [
            {
                "action": "cognito-idp:AdminSetUserMFAPreference",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminSetUserPassword": [
            {
                "action": "cognito-idp:AdminSetUserPassword",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminSetUserSettings": [
            {
                "action": "cognito-idp:AdminSetUserSettings",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminUpdateAuthEventFeedback": [
            {
                "action": "cognito-idp:AdminUpdateAuthEventFeedback",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminUpdateDeviceStatus": [
            {
                "action": "cognito-idp:AdminUpdateDeviceStatus",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminUpdateUserAttributes": [
            {
                "action": "cognito-idp:AdminUpdateUserAttributes",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AdminUserGlobalSignOut": [
            {
                "action": "cognito-idp:AdminUserGlobalSignOut",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.AssociateSoftwareToken": [
            {
                "action": "cognito-idp:AssociateSoftwareToken",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.ChangePassword": [
            {
                "action": "cognito-idp:ChangePassword",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.ConfirmDevice": [
            {
                "action": "cognito-idp:ConfirmDevice",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.ConfirmForgotPassword": [
            {
                "action": "cognito-idp:ConfirmForgotPassword",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.ConfirmSignUp": [
            {
                "action": "cognito-idp:ConfirmSignUp",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.CreateGroup": [
            {
                "action": "cognito-idp:CreateGroup",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "CognitoIdentityServiceProvider.CreateIdentityProvider": [
            {
                "action": "cognito-idp:CreateIdentityProvider",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.CreateResourceServer": [
            {
                "action": "cognito-idp:CreateResourceServer",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.CreateUserImportJob": [
            {
                "action": "cognito-idp:CreateUserImportJob",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${CloudWatchLogsRoleArn}"
                }
            }
        ],
        "CognitoIdentityServiceProvider.CreateUserPool": [
            {
                "action": "cognito-idp:CreateUserPool",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.CreateUserPoolClient": [
            {
                "action": "cognito-idp:CreateUserPoolClient",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${AnalyticsConfiguration.RoleArn}"
                }
            }
        ],
        "CognitoIdentityServiceProvider.CreateUserPoolDomain": [
            {
                "action": "cognito-idp:CreateUserPoolDomain",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DeleteGroup": [
            {
                "action": "cognito-idp:DeleteGroup",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DeleteIdentityProvider": [
            {
                "action": "cognito-idp:DeleteIdentityProvider",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DeleteResourceServer": [
            {
                "action": "cognito-idp:DeleteResourceServer",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DeleteUser": [
            {
                "action": "cognito-idp:DeleteUser",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.DeleteUserAttributes": [
            {
                "action": "cognito-idp:DeleteUserAttributes",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.DeleteUserPool": [
            {
                "action": "cognito-idp:DeleteUserPool",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DeleteUserPoolClient": [
            {
                "action": "cognito-idp:DeleteUserPoolClient",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DeleteUserPoolDomain": [
            {
                "action": "cognito-idp:DeleteUserPoolDomain",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DescribeIdentityProvider": [
            {
                "action": "cognito-idp:DescribeIdentityProvider",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DescribeResourceServer": [
            {
                "action": "cognito-idp:DescribeResourceServer",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DescribeRiskConfiguration": [
            {
                "action": "cognito-idp:DescribeRiskConfiguration",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DescribeUserImportJob": [
            {
                "action": "cognito-idp:DescribeUserImportJob",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DescribeUserPool": [
            {
                "action": "cognito-idp:DescribeUserPool",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DescribeUserPoolClient": [
            {
                "action": "cognito-idp:DescribeUserPoolClient",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.DescribeUserPoolDomain": [
            {
                "action": "cognito-idp:DescribeUserPoolDomain",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.ForgetDevice": [
            {
                "action": "cognito-idp:ForgetDevice",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.ForgotPassword": [
            {
                "action": "cognito-idp:ForgotPassword",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.GetCSVHeader": [
            {
                "action": "cognito-idp:GetCSVHeader",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.GetDevice": [
            {
                "action": "cognito-idp:GetDevice",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.GetGroup": [
            {
                "action": "cognito-idp:GetGroup",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.GetIdentityProviderByIdentifier": [
            {
                "action": "cognito-idp:GetIdentityProviderByIdentifier",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.GetSigningCertificate": [
            {
                "action": "cognito-idp:GetSigningCertificate",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.GetUICustomization": [
            {
                "action": "cognito-idp:GetUICustomization",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.GetUser": [
            {
                "action": "cognito-idp:GetUser",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.GetUserAttributeVerificationCode": [
            {
                "action": "cognito-idp:GetUserAttributeVerificationCode",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.GetUserPoolMfaConfig": [
            {
                "action": "cognito-idp:GetUserPoolMfaConfig",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.GlobalSignOut": [
            {
                "action": "cognito-idp:GlobalSignOut",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.InitiateAuth": [
            {
                "action": "cognito-idp:InitiateAuth",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.ListDevices": [
            {
                "action": "cognito-idp:ListDevices",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.ListGroups": [
            {
                "action": "cognito-idp:ListGroups",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.ListIdentityProviders": [
            {
                "action": "cognito-idp:ListIdentityProviders",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.ListResourceServers": [
            {
                "action": "cognito-idp:ListResourceServers",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.ListTagsForResource": [
            {
                "action": "cognito-idp:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "userpool": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CognitoIdentityServiceProvider.ListUserImportJobs": [
            {
                "action": "cognito-idp:ListUserImportJobs",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.ListUserPoolClients": [
            {
                "action": "cognito-idp:ListUserPoolClients",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.ListUserPools": [
            {
                "action": "cognito-idp:ListUserPools",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.ListUsers": [
            {
                "action": "cognito-idp:ListUsers",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.ListUsersInGroup": [
            {
                "action": "cognito-idp:ListUsersInGroup",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.ResendConfirmationCode": [
            {
                "action": "cognito-idp:ResendConfirmationCode",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.RespondToAuthChallenge": [
            {
                "action": "cognito-idp:RespondToAuthChallenge",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.SetRiskConfiguration": [
            {
                "action": "cognito-idp:SetRiskConfiguration",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.SetUICustomization": [
            {
                "action": "cognito-idp:SetUICustomization",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.SetUserMFAPreference": [
            {
                "action": "cognito-idp:SetUserMFAPreference",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.SetUserPoolMfaConfig": [
            {
                "action": "cognito-idp:SetUserPoolMfaConfig",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.SetUserSettings": [
            {
                "action": "cognito-idp:SetUserSettings",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.SignUp": [
            {
                "action": "cognito-idp:SignUp",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.StartUserImportJob": [
            {
                "action": "cognito-idp:StartUserImportJob",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.StopUserImportJob": [
            {
                "action": "cognito-idp:StopUserImportJob",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.TagResource": [
            {
                "action": "cognito-idp:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "userpool": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CognitoIdentityServiceProvider.UntagResource": [
            {
                "action": "cognito-idp:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "userpool": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CognitoIdentityServiceProvider.UpdateAuthEventFeedback": [
            {
                "action": "cognito-idp:UpdateAuthEventFeedback",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.UpdateDeviceStatus": [
            {
                "action": "cognito-idp:UpdateDeviceStatus",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.UpdateGroup": [
            {
                "action": "cognito-idp:UpdateGroup",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "CognitoIdentityServiceProvider.UpdateIdentityProvider": [
            {
                "action": "cognito-idp:UpdateIdentityProvider",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.UpdateResourceServer": [
            {
                "action": "cognito-idp:UpdateResourceServer",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.UpdateUserAttributes": [
            {
                "action": "cognito-idp:UpdateUserAttributes",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.UpdateUserPool": [
            {
                "action": "cognito-idp:UpdateUserPool",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.UpdateUserPoolClient": [
            {
                "action": "cognito-idp:UpdateUserPoolClient",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${AnalyticsConfiguration.RoleArn}"
                }
            }
        ],
        "CognitoIdentityServiceProvider.UpdateUserPoolDomain": [
            {
                "action": "cognito-idp:UpdateUserPoolDomain",
                "resource_mappings": {
                    "UserPoolId": {
                        "template": "${UserPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentityServiceProvider.VerifySoftwareToken": [
            {
                "action": "cognito-idp:VerifySoftwareToken",
                "resource_mappings": {}
            }
        ],
        "CognitoIdentityServiceProvider.VerifyUserAttribute": [
            {
                "action": "cognito-idp:VerifyUserAttribute",
                "resource_mappings": {}
            }
        ],
        "CognitoSync.BulkPublish": [
            {
                "action": "cognito-sync:BulkPublish",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoSync.DeleteDataset": [
            {
                "action": "cognito-sync:DeleteDataset",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    },
                    "IdentityId": {
                        "template": "${IdentityId}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    }
                }
            }
        ],
        "CognitoSync.DescribeDataset": [
            {
                "action": "cognito-sync:DescribeDataset",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    },
                    "IdentityId": {
                        "template": "${IdentityId}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    }
                }
            }
        ],
        "CognitoSync.DescribeIdentityPoolUsage": [
            {
                "action": "cognito-sync:DescribeIdentityPoolUsage",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoSync.DescribeIdentityUsage": [
            {
                "action": "cognito-sync:DescribeIdentityUsage",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    },
                    "IdentityId": {
                        "template": "${IdentityId}"
                    }
                }
            }
        ],
        "CognitoSync.GetBulkPublishDetails": [
            {
                "action": "cognito-sync:GetBulkPublishDetails",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoSync.GetCognitoEvents": [
            {
                "action": "cognito-sync:GetCognitoEvents",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoSync.GetIdentityPoolConfiguration": [
            {
                "action": "cognito-sync:GetIdentityPoolConfiguration",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoSync.ListDatasets": [
            {
                "action": "cognito-sync:ListDatasets",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    },
                    "IdentityId": {
                        "template": "${IdentityId}"
                    },
                    "DatasetName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CognitoSync.ListIdentityPoolUsage": [
            {
                "action": "cognito-sync:ListIdentityPoolUsage",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CognitoSync.ListRecords": [
            {
                "action": "cognito-sync:ListRecords",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    },
                    "IdentityId": {
                        "template": "${IdentityId}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    }
                }
            }
        ],
        "CognitoSync.RegisterDevice": [
            {
                "action": "cognito-sync:RegisterDevice",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    },
                    "IdentityId": {
                        "template": "${IdentityId}"
                    }
                }
            }
        ],
        "CognitoSync.SetCognitoEvents": [
            {
                "action": "cognito-sync:SetCognitoEvents",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoSync.SetIdentityPoolConfiguration": [
            {
                "action": "cognito-sync:SetIdentityPoolConfiguration",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${PushSync.RoleArn}%${CognitoStreams.RoleArn}%%"
                }
            }
        ],
        "CognitoSync.SubscribeToDataset": [
            {
                "action": "cognito-sync:SubscribeToDataset",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    },
                    "IdentityId": {
                        "template": "${IdentityId}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    }
                }
            }
        ],
        "CognitoSync.UnsubscribeFromDataset": [
            {
                "action": "cognito-sync:UnsubscribeFromDataset",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    },
                    "IdentityId": {
                        "template": "${IdentityId}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    }
                }
            }
        ],
        "CognitoSync.UpdateRecords": [
            {
                "action": "cognito-sync:UpdateRecords",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    },
                    "IdentityId": {
                        "template": "${IdentityId}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    }
                }
            }
        ],
        "ConfigService.BatchGetAggregateResourceConfig": [
            {
                "action": "config:BatchGetAggregateResourceConfig",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.BatchGetResourceConfig": [
            {
                "action": "config:BatchGetResourceConfig",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeleteAggregationAuthorization": [
            {
                "action": "config:DeleteAggregationAuthorization",
                "resource_mappings": {
                    "AggregatorAccount": {
                        "template": "${AuthorizedAccountId}"
                    },
                    "AggregatorRegion": {
                        "template": "${AuthorizedAwsRegion}"
                    }
                }
            }
        ],
        "ConfigService.DeleteConfigRule": [
            {
                "action": "config:DeleteConfigRule",
                "resource_mappings": {
                    "ConfigRuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DeleteConfigurationAggregator": [
            {
                "action": "config:DeleteConfigurationAggregator",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DeleteConfigurationRecorder": [
            {
                "action": "config:DeleteConfigurationRecorder",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeleteConformancePack": [
            {
                "action": "config:DeleteConformancePack",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeleteDeliveryChannel": [
            {
                "action": "config:DeleteDeliveryChannel",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeleteEvaluationResults": [
            {
                "action": "config:DeleteEvaluationResults",
                "resource_mappings": {
                    "ConfigRuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DeleteOrganizationConfigRule": [
            {
                "action": "config:DeleteOrganizationConfigRule",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeleteOrganizationConformancePack": [
            {
                "action": "config:DeleteOrganizationConformancePack",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeletePendingAggregationRequest": [
            {
                "action": "config:DeletePendingAggregationRequest",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeleteRemediationConfiguration": [
            {
                "action": "config:DeleteRemediationConfiguration",
                "resource_mappings": {
                    "RemediationConfigurationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DeleteRemediationExceptions": [
            {
                "action": "config:DeleteRemediationExceptions",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeleteResourceConfig": [
            {
                "action": "config:DeleteResourceConfig",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeleteRetentionConfiguration": [
            {
                "action": "config:DeleteRetentionConfiguration",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DeleteStoredQuery": [
            {
                "action": "config:DeleteStoredQuery",
                "resource_mappings": {
                    "StoredQueryName": {
                        "template": "${QueryName}"
                    },
                    "StoredQueryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DeliverConfigSnapshot": [
            {
                "action": "config:DeliverConfigSnapshot",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeAggregateComplianceByConfigRules": [
            {
                "action": "config:DescribeAggregateComplianceByConfigRules",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DescribeAggregationAuthorizations": [
            {
                "action": "config:DescribeAggregationAuthorizations",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeComplianceByConfigRule": [
            {
                "action": "config:DescribeComplianceByConfigRule",
                "resource_mappings": {
                    "ConfigRuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DescribeComplianceByResource": [
            {
                "action": "config:DescribeComplianceByResource",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeConfigRuleEvaluationStatus": [
            {
                "action": "config:DescribeConfigRuleEvaluationStatus",
                "resource_mappings": {
                    "ConfigRuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DescribeConfigRules": [
            {
                "action": "config:DescribeConfigRules",
                "resource_mappings": {
                    "ConfigRuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DescribeConfigurationAggregatorSourcesStatus": [
            {
                "action": "config:DescribeConfigurationAggregatorSourcesStatus",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DescribeConfigurationAggregators": [
            {
                "action": "config:DescribeConfigurationAggregators",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeConfigurationRecorderStatus": [
            {
                "action": "config:DescribeConfigurationRecorderStatus",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeConfigurationRecorders": [
            {
                "action": "config:DescribeConfigurationRecorders",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeConformancePackCompliance": [
            {
                "action": "config:DescribeConformancePackCompliance",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeConformancePackStatus": [
            {
                "action": "config:DescribeConformancePackStatus",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeConformancePacks": [
            {
                "action": "config:DescribeConformancePacks",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeDeliveryChannelStatus": [
            {
                "action": "config:DescribeDeliveryChannelStatus",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeDeliveryChannels": [
            {
                "action": "config:DescribeDeliveryChannels",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeOrganizationConfigRuleStatuses": [
            {
                "action": "config:DescribeOrganizationConfigRuleStatuses",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeOrganizationConfigRules": [
            {
                "action": "config:DescribeOrganizationConfigRules",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeOrganizationConformancePackStatuses": [
            {
                "action": "config:DescribeOrganizationConformancePackStatuses",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeOrganizationConformancePacks": [
            {
                "action": "config:DescribeOrganizationConformancePacks",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribePendingAggregationRequests": [
            {
                "action": "config:DescribePendingAggregationRequests",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeRemediationConfigurations": [
            {
                "action": "config:DescribeRemediationConfigurations",
                "resource_mappings": {
                    "RemediationConfigurationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DescribeRemediationExceptions": [
            {
                "action": "config:DescribeRemediationExceptions",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeRemediationExecutionStatus": [
            {
                "action": "config:DescribeRemediationExecutionStatus",
                "resource_mappings": {
                    "RemediationConfigurationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.DescribeRetentionConfigurations": [
            {
                "action": "config:DescribeRetentionConfigurations",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetAggregateComplianceDetailsByConfigRule": [
            {
                "action": "config:GetAggregateComplianceDetailsByConfigRule",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.GetAggregateConfigRuleComplianceSummary": [
            {
                "action": "config:GetAggregateConfigRuleComplianceSummary",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.GetAggregateDiscoveredResourceCounts": [
            {
                "action": "config:GetAggregateDiscoveredResourceCounts",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.GetAggregateResourceConfig": [
            {
                "action": "config:GetAggregateResourceConfig",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.GetComplianceDetailsByConfigRule": [
            {
                "action": "config:GetComplianceDetailsByConfigRule",
                "resource_mappings": {
                    "ConfigRuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.GetComplianceDetailsByResource": [
            {
                "action": "config:GetComplianceDetailsByResource",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetComplianceSummaryByConfigRule": [
            {
                "action": "config:GetComplianceSummaryByConfigRule",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetComplianceSummaryByResourceType": [
            {
                "action": "config:GetComplianceSummaryByResourceType",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetConformancePackComplianceDetails": [
            {
                "action": "config:GetConformancePackComplianceDetails",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetConformancePackComplianceSummary": [
            {
                "action": "config:GetConformancePackComplianceSummary",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetDiscoveredResourceCounts": [
            {
                "action": "config:GetDiscoveredResourceCounts",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetOrganizationConfigRuleDetailedStatus": [
            {
                "action": "config:GetOrganizationConfigRuleDetailedStatus",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetOrganizationConformancePackDetailedStatus": [
            {
                "action": "config:GetOrganizationConformancePackDetailedStatus",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetResourceConfigHistory": [
            {
                "action": "config:GetResourceConfigHistory",
                "resource_mappings": {}
            }
        ],
        "ConfigService.GetStoredQuery": [
            {
                "action": "config:GetStoredQuery",
                "resource_mappings": {
                    "StoredQueryName": {
                        "template": "${QueryName}"
                    },
                    "StoredQueryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.ListAggregateDiscoveredResources": [
            {
                "action": "config:ListAggregateDiscoveredResources",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.ListDiscoveredResources": [
            {
                "action": "config:ListDiscoveredResources",
                "resource_mappings": {}
            }
        ],
        "ConfigService.ListStoredQueries": [
            {
                "action": "config:ListStoredQueries",
                "resource_mappings": {
                    "StoredQueryName": {
                        "template": "*"
                    },
                    "StoredQueryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.ListTagsForResource": [
            {
                "action": "config:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AggregationAuthorization": "%%iftemplatematch%${ResourceArn}%%",
                    "ConfigRule": "%%iftemplatematch%${ResourceArn}%%",
                    "ConfigurationAggregator": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ConfigService.PutAggregationAuthorization": [
            {
                "action": "config:PutAggregationAuthorization",
                "resource_mappings": {
                    "AggregatorAccount": {
                        "template": "${AuthorizedAccountId}"
                    },
                    "AggregatorRegion": {
                        "template": "${AuthorizedAwsRegion}"
                    }
                }
            }
        ],
        "ConfigService.PutConfigRule": [
            {
                "action": "config:PutConfigRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ConfigRule": "${ConfigRule.ConfigRuleArn}"
                }
            }
        ],
        "ConfigService.PutConfigurationAggregator": [
            {
                "action": "config:PutConfigurationAggregator",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${OrganizationAggregationSource.RoleArn}"
                }
            }
        ],
        "ConfigService.PutConfigurationRecorder": [
            {
                "action": "config:PutConfigurationRecorder",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ConfigurationRecorder.roleARN}"
                }
            }
        ],
        "ConfigService.PutConformancePack": [
            {
                "action": "config:PutConformancePack",
                "resource_mappings": {}
            }
        ],
        "ConfigService.PutDeliveryChannel": [
            {
                "action": "config:PutDeliveryChannel",
                "resource_mappings": {}
            }
        ],
        "ConfigService.PutEvaluations": [
            {
                "action": "config:PutEvaluations",
                "resource_mappings": {}
            }
        ],
        "ConfigService.PutExternalEvaluation": [
            {
                "action": "config:PutExternalEvaluation",
                "resource_mappings": {}
            }
        ],
        "ConfigService.PutOrganizationConfigRule": [
            {
                "action": "config:PutOrganizationConfigRule",
                "resource_mappings": {}
            }
        ],
        "ConfigService.PutOrganizationConformancePack": [
            {
                "action": "config:PutOrganizationConformancePack",
                "resource_mappings": {}
            }
        ],
        "ConfigService.PutRemediationConfigurations": [
            {
                "action": "config:PutRemediationConfigurations",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "RemediationConfiguration": "${RemediationConfigurations[].Arn}"
                }
            }
        ],
        "ConfigService.PutRemediationExceptions": [
            {
                "action": "config:PutRemediationExceptions",
                "resource_mappings": {}
            }
        ],
        "ConfigService.PutResourceConfig": [
            {
                "action": "config:PutResourceConfig",
                "resource_mappings": {}
            }
        ],
        "ConfigService.PutRetentionConfiguration": [
            {
                "action": "config:PutRetentionConfiguration",
                "resource_mappings": {}
            }
        ],
        "ConfigService.PutStoredQuery": [
            {
                "action": "config:PutStoredQuery",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "StoredQuery": "${StoredQuery.QueryArn}"
                }
            }
        ],
        "ConfigService.SelectAggregateResourceConfig": [
            {
                "action": "config:SelectAggregateResourceConfig",
                "resource_mappings": {}
            }
        ],
        "ConfigService.SelectResourceConfig": [
            {
                "action": "config:SelectResourceConfig",
                "resource_mappings": {}
            }
        ],
        "ConfigService.StartConfigRulesEvaluation": [
            {
                "action": "config:StartConfigRulesEvaluation",
                "resource_mappings": {
                    "ConfigRuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.StartConfigurationRecorder": [
            {
                "action": "config:StartConfigurationRecorder",
                "resource_mappings": {}
            }
        ],
        "ConfigService.StartRemediationExecution": [
            {
                "action": "config:StartRemediationExecution",
                "resource_mappings": {
                    "RemediationConfigurationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.StopConfigurationRecorder": [
            {
                "action": "config:StopConfigurationRecorder",
                "resource_mappings": {}
            }
        ],
        "ConfigService.TagResource": [
            {
                "action": "config:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AggregationAuthorization": "%%iftemplatematch%${ResourceArn}%%",
                    "ConfigRule": "%%iftemplatematch%${ResourceArn}%%",
                    "ConfigurationAggregator": "%%iftemplatematch%${ResourceArn}%%",
                    "ConformancePack": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ConfigService.UntagResource": [
            {
                "action": "config:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AggregationAuthorization": "%%iftemplatematch%${ResourceArn}%%",
                    "ConfigRule": "%%iftemplatematch%${ResourceArn}%%",
                    "ConfigurationAggregator": "%%iftemplatematch%${ResourceArn}%%",
                    "ConformancePack": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CUR.DeleteReportDefinition": [
            {
                "action": "cur:DeleteReportDefinition",
                "resource_mappings": {
                    "ReportName": {
                        "template": "${ReportName}"
                    }
                }
            }
        ],
        "CUR.DescribeReportDefinitions": [
            {
                "action": "cur:DescribeReportDefinitions",
                "resource_mappings": {}
            }
        ],
        "CUR.ModifyReportDefinition": [
            {
                "action": "cur:ModifyReportDefinition",
                "resource_mappings": {
                    "ReportName": {
                        "template": "${ReportName}"
                    }
                }
            }
        ],
        "CUR.PutReportDefinition": [
            {
                "action": "cur:PutReportDefinition",
                "resource_mappings": {
                    "ReportName": {
                        "template": "${ReportDefinition.ReportName}"
                    }
                }
            }
        ],
        "DataPipeline.ActivatePipeline": [
            {
                "action": "datapipeline:ActivatePipeline",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.AddTags": [
            {
                "action": "datapipeline:AddTags",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.CreatePipeline": [
            {
                "action": "datapipeline:CreatePipeline",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.DeactivatePipeline": [
            {
                "action": "datapipeline:DeactivatePipeline",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.DeletePipeline": [
            {
                "action": "datapipeline:DeletePipeline",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.DescribeObjects": [
            {
                "action": "datapipeline:DescribeObjects",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.DescribePipelines": [
            {
                "action": "datapipeline:DescribePipelines",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.EvaluateExpression": [
            {
                "action": "datapipeline:EvaluateExpression",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.GetPipelineDefinition": [
            {
                "action": "datapipeline:GetPipelineDefinition",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.ListPipelines": [
            {
                "action": "datapipeline:ListPipelines",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.PollForTask": [
            {
                "action": "datapipeline:PollForTask",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.PutPipelineDefinition": [
            {
                "action": "datapipeline:PutPipelineDefinition",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "DataPipeline.QueryObjects": [
            {
                "action": "datapipeline:QueryObjects",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.RemoveTags": [
            {
                "action": "datapipeline:RemoveTags",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.ReportTaskProgress": [
            {
                "action": "datapipeline:ReportTaskProgress",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.ReportTaskRunnerHeartbeat": [
            {
                "action": "datapipeline:ReportTaskRunnerHeartbeat",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.SetStatus": [
            {
                "action": "datapipeline:SetStatus",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.SetTaskStatus": [
            {
                "action": "datapipeline:SetTaskStatus",
                "resource_mappings": {}
            }
        ],
        "DataPipeline.ValidatePipelineDefinition": [
            {
                "action": "datapipeline:ValidatePipelineDefinition",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "DeviceFarm.CreateDevicePool": [
            {
                "action": "devicefarm:CreateDevicePool",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${projectArn}"
                }
            }
        ],
        "DeviceFarm.CreateInstanceProfile": [
            {
                "action": "devicefarm:CreateInstanceProfile",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.CreateNetworkProfile": [
            {
                "action": "devicefarm:CreateNetworkProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${projectArn}"
                }
            }
        ],
        "DeviceFarm.CreateProject": [
            {
                "action": "devicefarm:CreateProject",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.CreateRemoteAccessSession": [
            {
                "action": "devicefarm:CreateRemoteAccessSession",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "device": "${deviceArn}",
                    "project": "${projectArn}"
                }
            }
        ],
        "DeviceFarm.CreateTestGridProject": [
            {
                "action": "devicefarm:CreateTestGridProject",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.CreateTestGridUrl": [
            {
                "action": "devicefarm:CreateTestGridUrl",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "testgrid-project": "${projectArn}"
                }
            }
        ],
        "DeviceFarm.CreateUpload": [
            {
                "action": "devicefarm:CreateUpload",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${projectArn}"
                }
            }
        ],
        "DeviceFarm.CreateVPCEConfiguration": [
            {
                "action": "devicefarm:CreateVPCEConfiguration",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.DeleteDevicePool": [
            {
                "action": "devicefarm:DeleteDevicePool",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "devicepool": "${arn}"
                }
            }
        ],
        "DeviceFarm.DeleteInstanceProfile": [
            {
                "action": "devicefarm:DeleteInstanceProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "instanceprofile": "${arn}"
                }
            }
        ],
        "DeviceFarm.DeleteNetworkProfile": [
            {
                "action": "devicefarm:DeleteNetworkProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkprofile": "${arn}"
                }
            }
        ],
        "DeviceFarm.DeleteProject": [
            {
                "action": "devicefarm:DeleteProject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${arn}"
                }
            }
        ],
        "DeviceFarm.DeleteRemoteAccessSession": [
            {
                "action": "devicefarm:DeleteRemoteAccessSession",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "session": "${arn}"
                }
            }
        ],
        "DeviceFarm.DeleteRun": [
            {
                "action": "devicefarm:DeleteRun",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "run": "${arn}"
                }
            }
        ],
        "DeviceFarm.DeleteTestGridProject": [
            {
                "action": "devicefarm:DeleteTestGridProject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "testgrid-project": "${projectArn}"
                }
            }
        ],
        "DeviceFarm.DeleteUpload": [
            {
                "action": "devicefarm:DeleteUpload",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "upload": "${arn}"
                }
            }
        ],
        "DeviceFarm.DeleteVPCEConfiguration": [
            {
                "action": "devicefarm:DeleteVPCEConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "vpceconfiguration": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetAccountSettings": [
            {
                "action": "devicefarm:GetAccountSettings",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.GetDevice": [
            {
                "action": "devicefarm:GetDevice",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetDeviceInstance": [
            {
                "action": "devicefarm:GetDeviceInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deviceinstance": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetDevicePool": [
            {
                "action": "devicefarm:GetDevicePool",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "devicepool": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetDevicePoolCompatibility": [
            {
                "action": "devicefarm:GetDevicePoolCompatibility",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "devicepool": "${devicePoolArn}"
                }
            }
        ],
        "DeviceFarm.GetInstanceProfile": [
            {
                "action": "devicefarm:GetInstanceProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "instanceprofile": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetJob": [
            {
                "action": "devicefarm:GetJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "job": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetNetworkProfile": [
            {
                "action": "devicefarm:GetNetworkProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkprofile": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetOfferingStatus": [
            {
                "action": "devicefarm:GetOfferingStatus",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.GetProject": [
            {
                "action": "devicefarm:GetProject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetRemoteAccessSession": [
            {
                "action": "devicefarm:GetRemoteAccessSession",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "session": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetRun": [
            {
                "action": "devicefarm:GetRun",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "run": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetSuite": [
            {
                "action": "devicefarm:GetSuite",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "suite": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetTest": [
            {
                "action": "devicefarm:GetTest",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "test": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetTestGridProject": [
            {
                "action": "devicefarm:GetTestGridProject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "testgrid-project": "${projectArn}"
                }
            }
        ],
        "DeviceFarm.GetTestGridSession": [
            {
                "action": "devicefarm:GetTestGridSession",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "testgrid-project": "${projectArn}",
                    "testgrid-session": "${sessionArn}"
                }
            }
        ],
        "DeviceFarm.GetUpload": [
            {
                "action": "devicefarm:GetUpload",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "upload": "${arn}"
                }
            }
        ],
        "DeviceFarm.GetVPCEConfiguration": [
            {
                "action": "devicefarm:GetVPCEConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "vpceconfiguration": "${arn}"
                }
            }
        ],
        "DeviceFarm.InstallToRemoteAccessSession": [
            {
                "action": "devicefarm:InstallToRemoteAccessSession",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "session": "${remoteAccessSessionArn}"
                }
            }
        ],
        "DeviceFarm.ListArtifacts": [
            {
                "action": "devicefarm:ListArtifacts",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "job": "%%iftemplatematch%${arn}%%",
                    "run": "%%iftemplatematch%${arn}%%",
                    "suite": "%%iftemplatematch%${arn}%%",
                    "test": "%%iftemplatematch%${arn}%%"
                }
            }
        ],
        "DeviceFarm.ListDeviceInstances": [
            {
                "action": "devicefarm:ListDeviceInstances",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.ListDevicePools": [
            {
                "action": "devicefarm:ListDevicePools",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListDevices": [
            {
                "action": "devicefarm:ListDevices",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.ListInstanceProfiles": [
            {
                "action": "devicefarm:ListInstanceProfiles",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.ListJobs": [
            {
                "action": "devicefarm:ListJobs",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "run": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListNetworkProfiles": [
            {
                "action": "devicefarm:ListNetworkProfiles",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListOfferingPromotions": [
            {
                "action": "devicefarm:ListOfferingPromotions",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.ListOfferingTransactions": [
            {
                "action": "devicefarm:ListOfferingTransactions",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.ListOfferings": [
            {
                "action": "devicefarm:ListOfferings",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.ListProjects": [
            {
                "action": "devicefarm:ListProjects",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.ListRemoteAccessSessions": [
            {
                "action": "devicefarm:ListRemoteAccessSessions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListRuns": [
            {
                "action": "devicefarm:ListRuns",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListSamples": [
            {
                "action": "devicefarm:ListSamples",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "job": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListSuites": [
            {
                "action": "devicefarm:ListSuites",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "job": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListTagsForResource": [
            {
                "action": "devicefarm:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${ResourceARN}%%",
                    "deviceinstance": "%%iftemplatematch%${ResourceARN}%%",
                    "devicepool": "%%iftemplatematch%${ResourceARN}%%",
                    "instanceprofile": "%%iftemplatematch%${ResourceARN}%%",
                    "networkprofile": "%%iftemplatematch%${ResourceARN}%%",
                    "project": "%%iftemplatematch%${ResourceARN}%%",
                    "run": "%%iftemplatematch%${ResourceARN}%%",
                    "session": "%%iftemplatematch%${ResourceARN}%%",
                    "testgrid-project": "%%iftemplatematch%${ResourceARN}%%",
                    "testgrid-session": "%%iftemplatematch%${ResourceARN}%%",
                    "vpceconfiguration": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "DeviceFarm.ListTestGridProjects": [
            {
                "action": "devicefarm:ListTestGridProjects",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.ListTestGridSessionActions": [
            {
                "action": "devicefarm:ListTestGridSessionActions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "testgrid-session": "${sessionArn}"
                }
            }
        ],
        "DeviceFarm.ListTestGridSessionArtifacts": [
            {
                "action": "devicefarm:ListTestGridSessionArtifacts",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "testgrid-session": "${sessionArn}"
                }
            }
        ],
        "DeviceFarm.ListTestGridSessions": [
            {
                "action": "devicefarm:ListTestGridSessions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "testgrid-project": "${projectArn}"
                }
            }
        ],
        "DeviceFarm.ListTests": [
            {
                "action": "devicefarm:ListTests",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "suite": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListUniqueProblems": [
            {
                "action": "devicefarm:ListUniqueProblems",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "run": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListUploads": [
            {
                "action": "devicefarm:ListUploads",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${arn}"
                }
            }
        ],
        "DeviceFarm.ListVPCEConfigurations": [
            {
                "action": "devicefarm:ListVPCEConfigurations",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.PurchaseOffering": [
            {
                "action": "devicefarm:PurchaseOffering",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.RenewOffering": [
            {
                "action": "devicefarm:RenewOffering",
                "resource_mappings": {}
            }
        ],
        "DeviceFarm.ScheduleRun": [
            {
                "action": "devicefarm:ScheduleRun",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "project": "${projectArn}",
                    "devicepool": "${devicePoolArn}"
                }
            }
        ],
        "DeviceFarm.StopJob": [
            {
                "action": "devicefarm:StopJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "job": "${arn}"
                }
            }
        ],
        "DeviceFarm.StopRemoteAccessSession": [
            {
                "action": "devicefarm:StopRemoteAccessSession",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "session": "${arn}"
                }
            }
        ],
        "DeviceFarm.StopRun": [
            {
                "action": "devicefarm:StopRun",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "run": "${arn}"
                }
            }
        ],
        "DeviceFarm.TagResource": [
            {
                "action": "devicefarm:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${ResourceARN}%%",
                    "deviceinstance": "%%iftemplatematch%${ResourceARN}%%",
                    "devicepool": "%%iftemplatematch%${ResourceARN}%%",
                    "instanceprofile": "%%iftemplatematch%${ResourceARN}%%",
                    "networkprofile": "%%iftemplatematch%${ResourceARN}%%",
                    "project": "%%iftemplatematch%${ResourceARN}%%",
                    "run": "%%iftemplatematch%${ResourceARN}%%",
                    "session": "%%iftemplatematch%${ResourceARN}%%",
                    "testgrid-project": "%%iftemplatematch%${ResourceARN}%%",
                    "testgrid-session": "%%iftemplatematch%${ResourceARN}%%",
                    "vpceconfiguration": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "DeviceFarm.UntagResource": [
            {
                "action": "devicefarm:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${ResourceARN}%%",
                    "deviceinstance": "%%iftemplatematch%${ResourceARN}%%",
                    "devicepool": "%%iftemplatematch%${ResourceARN}%%",
                    "instanceprofile": "%%iftemplatematch%${ResourceARN}%%",
                    "networkprofile": "%%iftemplatematch%${ResourceARN}%%",
                    "project": "%%iftemplatematch%${ResourceARN}%%",
                    "run": "%%iftemplatematch%${ResourceARN}%%",
                    "session": "%%iftemplatematch%${ResourceARN}%%",
                    "testgrid-project": "%%iftemplatematch%${ResourceARN}%%",
                    "testgrid-session": "%%iftemplatematch%${ResourceARN}%%",
                    "vpceconfiguration": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "DeviceFarm.UpdateDeviceInstance": [
            {
                "action": "devicefarm:UpdateDeviceInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deviceinstance": "${arn}",
                    "instanceprofile": "${profileArn}"
                }
            }
        ],
        "DeviceFarm.UpdateDevicePool": [
            {
                "action": "devicefarm:UpdateDevicePool",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "devicepool": "${arn}"
                }
            }
        ],
        "DeviceFarm.UpdateInstanceProfile": [
            {
                "action": "devicefarm:UpdateInstanceProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "instanceprofile": "${arn}"
                }
            }
        ],
        "DeviceFarm.UpdateNetworkProfile": [
            {
                "action": "devicefarm:UpdateNetworkProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkprofile": "${arn}"
                }
            }
        ],
        "DeviceFarm.UpdateProject": [
            {
                "action": "devicefarm:UpdateProject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${arn}"
                }
            }
        ],
        "DeviceFarm.UpdateTestGridProject": [
            {
                "action": "devicefarm:UpdateTestGridProject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "testgrid-project": "${projectArn}"
                }
            }
        ],
        "DeviceFarm.UpdateUpload": [
            {
                "action": "devicefarm:UpdateUpload",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "upload": "${arn}"
                }
            }
        ],
        "DeviceFarm.UpdateVPCEConfiguration": [
            {
                "action": "devicefarm:UpdateVPCEConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "vpceconfiguration": "${arn}"
                }
            }
        ],
        "DirectConnect.AcceptDirectConnectGatewayAssociationProposal": [
            {
                "action": "directconnect:AcceptDirectConnectGatewayAssociationProposal",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "DirectConnect.AllocateConnectionOnInterconnect": [
            {
                "action": "directconnect:AllocateConnectionOnInterconnect",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.AllocateHostedConnection": [
            {
                "action": "directconnect:AllocateHostedConnection",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.AllocatePrivateVirtualInterface": [
            {
                "action": "directconnect:AllocatePrivateVirtualInterface",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.AllocatePublicVirtualInterface": [
            {
                "action": "directconnect:AllocatePublicVirtualInterface",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.AllocateTransitVirtualInterface": [
            {
                "action": "directconnect:AllocateTransitVirtualInterface",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.AssociateConnectionWithLag": [
            {
                "action": "directconnect:AssociateConnectionWithLag",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "${lagId}"
                    }
                }
            }
        ],
        "DirectConnect.AssociateHostedConnection": [
            {
                "action": "directconnect:AssociateHostedConnection",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${parentConnectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.AssociateVirtualInterface": [
            {
                "action": "directconnect:AssociateVirtualInterface",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    },
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.ConfirmConnection": [
            {
                "action": "directconnect:ConfirmConnection",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    }
                }
            }
        ],
        "DirectConnect.ConfirmPrivateVirtualInterface": [
            {
                "action": "directconnect:ConfirmPrivateVirtualInterface",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.ConfirmPublicVirtualInterface": [
            {
                "action": "directconnect:ConfirmPublicVirtualInterface",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.ConfirmTransitVirtualInterface": [
            {
                "action": "directconnect:ConfirmTransitVirtualInterface",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.CreateBGPPeer": [
            {
                "action": "directconnect:CreateBGPPeer",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.CreateConnection": [
            {
                "action": "directconnect:CreateConnection",
                "resource_mappings": {
                    "LagId": {
                        "template": "${lagId}"
                    }
                }
            }
        ],
        "DirectConnect.CreateDirectConnectGateway": [
            {
                "action": "directconnect:CreateDirectConnectGateway",
                "resource_mappings": {}
            }
        ],
        "DirectConnect.CreateDirectConnectGatewayAssociation": [
            {
                "action": "directconnect:CreateDirectConnectGatewayAssociation",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "DirectConnect.CreateDirectConnectGatewayAssociationProposal": [
            {
                "action": "directconnect:CreateDirectConnectGatewayAssociationProposal",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "DirectConnect.CreateInterconnect": [
            {
                "action": "directconnect:CreateInterconnect",
                "resource_mappings": {
                    "LagId": {
                        "template": "${lagId}"
                    }
                }
            }
        ],
        "DirectConnect.CreateLag": [
            {
                "action": "directconnect:CreateLag",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    }
                }
            }
        ],
        "DirectConnect.CreatePrivateVirtualInterface": [
            {
                "action": "directconnect:CreatePrivateVirtualInterface",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.CreatePublicVirtualInterface": [
            {
                "action": "directconnect:CreatePublicVirtualInterface",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.CreateTransitVirtualInterface": [
            {
                "action": "directconnect:CreateTransitVirtualInterface",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.DeleteBGPPeer": [
            {
                "action": "directconnect:DeleteBGPPeer",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.DeleteConnection": [
            {
                "action": "directconnect:DeleteConnection",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    }
                }
            }
        ],
        "DirectConnect.DeleteDirectConnectGateway": [
            {
                "action": "directconnect:DeleteDirectConnectGateway",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "DirectConnect.DeleteDirectConnectGatewayAssociation": [
            {
                "action": "directconnect:DeleteDirectConnectGatewayAssociation",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "DirectConnect.DeleteDirectConnectGatewayAssociationProposal": [
            {
                "action": "directconnect:DeleteDirectConnectGatewayAssociationProposal",
                "resource_mappings": {}
            }
        ],
        "DirectConnect.DeleteInterconnect": [
            {
                "action": "directconnect:DeleteInterconnect",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${interconnectId}"
                    }
                }
            }
        ],
        "DirectConnect.DeleteLag": [
            {
                "action": "directconnect:DeleteLag",
                "resource_mappings": {
                    "LagId": {
                        "template": "${lagId}"
                    }
                }
            }
        ],
        "DirectConnect.DeleteVirtualInterface": [
            {
                "action": "directconnect:DeleteVirtualInterface",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeConnectionLoa": [
            {
                "action": "directconnect:DescribeConnectionLoa",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeConnections": [
            {
                "action": "directconnect:DescribeConnections",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeConnectionsOnInterconnect": [
            {
                "action": "directconnect:DescribeConnectionsOnInterconnect",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${interconnectId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeDirectConnectGatewayAssociationProposals": [
            {
                "action": "directconnect:DescribeDirectConnectGatewayAssociationProposals",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeDirectConnectGatewayAssociations": [
            {
                "action": "directconnect:DescribeDirectConnectGatewayAssociations",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeDirectConnectGatewayAttachments": [
            {
                "action": "directconnect:DescribeDirectConnectGatewayAttachments",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeDirectConnectGateways": [
            {
                "action": "directconnect:DescribeDirectConnectGateways",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeHostedConnections": [
            {
                "action": "directconnect:DescribeHostedConnections",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.DescribeInterconnectLoa": [
            {
                "action": "directconnect:DescribeInterconnectLoa",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${interconnectId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeInterconnects": [
            {
                "action": "directconnect:DescribeInterconnects",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${interconnectId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeLags": [
            {
                "action": "directconnect:DescribeLags",
                "resource_mappings": {
                    "LagId": {
                        "template": "${lagId}"
                    }
                }
            }
        ],
        "DirectConnect.DescribeLoa": [
            {
                "action": "directconnect:DescribeLoa",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.DescribeLocations": [
            {
                "action": "directconnect:DescribeLocations",
                "resource_mappings": {}
            }
        ],
        "DirectConnect.DescribeTags": [
            {
                "action": "directconnect:DescribeTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dxcon": "%%iftemplatematch%${ResourceArns[]}%%",
                    "dxlag": "%%iftemplatematch%${ResourceArns[]}%%",
                    "dxvif": "%%iftemplatematch%${ResourceArns[]}%%"
                }
            }
        ],
        "DirectConnect.DescribeVirtualGateways": [
            {
                "action": "directconnect:DescribeVirtualGateways",
                "resource_mappings": {}
            }
        ],
        "DirectConnect.DescribeVirtualInterfaces": [
            {
                "action": "directconnect:DescribeVirtualInterfaces",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    },
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.DisassociateConnectionFromLag": [
            {
                "action": "directconnect:DisassociateConnectionFromLag",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "${lagId}"
                    }
                }
            }
        ],
        "DirectConnect.ListVirtualInterfaceTestHistory": [
            {
                "action": "directconnect:ListVirtualInterfaceTestHistory",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.StartBgpFailoverTest": [
            {
                "action": "directconnect:StartBgpFailoverTest",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.StopBgpFailoverTest": [
            {
                "action": "directconnect:StopBgpFailoverTest",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.TagResource": [
            {
                "action": "directconnect:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dxcon": "%%iftemplatematch%${resourceArn}%%",
                    "dxlag": "%%iftemplatematch%${resourceArn}%%",
                    "dxvif": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "DirectConnect.UntagResource": [
            {
                "action": "directconnect:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dxcon": "%%iftemplatematch%${resourceArn}%%",
                    "dxlag": "%%iftemplatematch%${resourceArn}%%",
                    "dxvif": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "DirectConnect.UpdateDirectConnectGatewayAssociation": [
            {
                "action": "directconnect:UpdateDirectConnectGatewayAssociation",
                "resource_mappings": {}
            }
        ],
        "DirectConnect.UpdateLag": [
            {
                "action": "directconnect:UpdateLag",
                "resource_mappings": {
                    "LagId": {
                        "template": "${lagId}"
                    }
                }
            }
        ],
        "DirectConnect.UpdateVirtualInterfaceAttributes": [
            {
                "action": "directconnect:UpdateVirtualInterfaceAttributes",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectoryService.AcceptSharedDirectory": [
            {
                "action": "ds:AcceptSharedDirectory",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${SharedDirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.AddIpRoutes": [
            {
                "action": "ds:AddIpRoutes",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            },
            {
                "action": "ec2:AuthorizeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectoryService.AddTagsToResource": [
            {
                "action": "ds:AddTagsToResource",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "capacity-reservation": "%%iftemplatematch%${ResourceId}%%",
                    "client-vpn-endpoint": "%%iftemplatematch%${ResourceId}%%",
                    "customer-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "dedicated-host": "%%iftemplatematch%${ResourceId}%%",
                    "dhcp-options": "%%iftemplatematch%${ResourceId}%%",
                    "egress-only-internet-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "elastic-gpu": "%%iftemplatematch%${ResourceId}%%",
                    "elastic-ip": "%%iftemplatematch%${ResourceId}%%",
                    "export-image-task": "%%iftemplatematch%${ResourceId}%%",
                    "export-instance-task": "%%iftemplatematch%${ResourceId}%%",
                    "fleet": "%%iftemplatematch%${ResourceId}%%",
                    "fpga-image": "%%iftemplatematch%${ResourceId}%%",
                    "host-reservation": "%%iftemplatematch%${ResourceId}%%",
                    "image": "%%iftemplatematch%${ResourceId}%%",
                    "import-image-task": "%%iftemplatematch%${ResourceId}%%",
                    "import-snapshot-task": "%%iftemplatematch%${ResourceId}%%",
                    "instance": "%%iftemplatematch%${ResourceId}%%",
                    "internet-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "ipv4pool-ec2": "%%iftemplatematch%${ResourceId}%%",
                    "ipv6pool-ec2": "%%iftemplatematch%${ResourceId}%%",
                    "key-pair": "%%iftemplatematch%${ResourceId}%%",
                    "launch-template": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-route-table": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-route-table-virtual-interface-group-association": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-route-table-vpc-association": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-virtual-interface": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-virtual-interface-group": "%%iftemplatematch%${ResourceId}%%",
                    "natgateway": "%%iftemplatematch%${ResourceId}%%",
                    "network-acl": "%%iftemplatematch%${ResourceId}%%",
                    "network-interface": "%%iftemplatematch%${ResourceId}%%",
                    "placement-group": "%%iftemplatematch%${ResourceId}%%",
                    "prefix-list": "%%iftemplatematch%${ResourceId}%%",
                    "reserved-instances": "%%iftemplatematch%${ResourceId}%%",
                    "route-table": "%%iftemplatematch%${ResourceId}%%",
                    "security-group": "%%iftemplatematch%${ResourceId}%%",
                    "snapshot": "%%iftemplatematch%${ResourceId}%%",
                    "spot-fleet-request": "%%iftemplatematch%${ResourceId}%%",
                    "spot-instances-request": "%%iftemplatematch%${ResourceId}%%",
                    "subnet": "%%iftemplatematch%${ResourceId}%%",
                    "traffic-mirror-filter": "%%iftemplatematch%${ResourceId}%%",
                    "traffic-mirror-session": "%%iftemplatematch%${ResourceId}%%",
                    "traffic-mirror-target": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway-attachment": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway-connect-peer": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway-multicast-domain": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway-route-table": "%%iftemplatematch%${ResourceId}%%",
                    "volume": "%%iftemplatematch%${ResourceId}%%",
                    "vpc": "%%iftemplatematch%${ResourceId}%%",
                    "vpc-endpoint": "%%iftemplatematch%${ResourceId}%%",
                    "vpc-endpoint-service": "%%iftemplatematch%${ResourceId}%%",
                    "vpc-flow-log": "%%iftemplatematch%${ResourceId}%%",
                    "vpc-peering-connection": "%%iftemplatematch%${ResourceId}%%",
                    "vpn-connection": "%%iftemplatematch%${ResourceId}%%",
                    "vpn-gateway": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "DirectoryService.CancelSchemaExtension": [
            {
                "action": "ds:CancelSchemaExtension",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.ConnectDirectory": [
            {
                "action": "ds:ConnectDirectory",
                "resource_mappings": {}
            },
            {
                "action": "ec2:AuthorizeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectoryService.CreateAlias": [
            {
                "action": "ds:CreateAlias",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.CreateComputer": [
            {
                "action": "ds:CreateComputer",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.CreateConditionalForwarder": [
            {
                "action": "ds:CreateConditionalForwarder",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.CreateDirectory": [
            {
                "action": "ds:CreateDirectory",
                "resource_mappings": {}
            },
            {
                "action": "ec2:AuthorizeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectoryService.CreateLogSubscription": [
            {
                "action": "ds:CreateLogSubscription",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.CreateMicrosoftAD": [
            {
                "action": "ds:CreateMicrosoftAD",
                "resource_mappings": {}
            },
            {
                "action": "ec2:AuthorizeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectoryService.CreateSnapshot": [
            {
                "action": "ds:CreateSnapshot",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.CreateTrust": [
            {
                "action": "ds:CreateTrust",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DeleteConditionalForwarder": [
            {
                "action": "ds:DeleteConditionalForwarder",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DeleteDirectory": [
            {
                "action": "ds:DeleteDirectory",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectoryService.DeleteLogSubscription": [
            {
                "action": "ds:DeleteLogSubscription",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DeleteSnapshot": [
            {
                "action": "ds:DeleteSnapshot",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "DirectoryService.DeleteTrust": [
            {
                "action": "ds:DeleteTrust",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectoryService.DeregisterCertificate": [
            {
                "action": "ds:DeregisterCertificate",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DeregisterEventTopic": [
            {
                "action": "ds:DeregisterEventTopic",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DescribeCertificate": [
            {
                "action": "ds:DescribeCertificate",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DescribeConditionalForwarders": [
            {
                "action": "ds:DescribeConditionalForwarders",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DescribeDirectories": [
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "DirectoryService.DescribeDomainControllers": [
            {
                "action": "ds:DescribeDomainControllers",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DescribeEventTopics": [
            {
                "action": "ds:DescribeEventTopics",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DescribeLDAPSSettings": [
            {
                "action": "ds:DescribeLDAPSSettings",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DescribeSharedDirectories": [
            {
                "action": "ds:DescribeSharedDirectories",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "%%many%${OwnerDirectoryId}%${SharedDirectoryIds[]}%%"
                    }
                }
            }
        ],
        "DirectoryService.DescribeSnapshots": [
            {
                "action": "ds:DescribeSnapshots",
                "resource_mappings": {}
            }
        ],
        "DirectoryService.DescribeTrusts": [
            {
                "action": "ds:DescribeTrusts",
                "resource_mappings": {}
            }
        ],
        "DirectoryService.DisableLDAPS": [
            {
                "action": "ds:DisableLDAPS",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DisableRadius": [
            {
                "action": "ds:DisableRadius",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DisableSso": [
            {
                "action": "ds:DisableSso",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.EnableLDAPS": [
            {
                "action": "ds:EnableLDAPS",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.EnableRadius": [
            {
                "action": "ds:EnableRadius",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.EnableSso": [
            {
                "action": "ds:EnableSso",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.GetDirectoryLimits": [
            {
                "action": "ds:GetDirectoryLimits",
                "resource_mappings": {}
            }
        ],
        "DirectoryService.GetSnapshotLimits": [
            {
                "action": "ds:GetSnapshotLimits",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.ListCertificates": [
            {
                "action": "ds:ListCertificates",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.ListIpRoutes": [
            {
                "action": "ds:ListIpRoutes",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.ListLogSubscriptions": [
            {
                "action": "ds:ListLogSubscriptions",
                "resource_mappings": {}
            }
        ],
        "DirectoryService.ListSchemaExtensions": [
            {
                "action": "ds:ListSchemaExtensions",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.ListTagsForResource": [
            {
                "action": "ds:ListTagsForResource",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "DirectoryService.RegisterCertificate": [
            {
                "action": "ds:RegisterCertificate",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.RegisterEventTopic": [
            {
                "action": "ds:RegisterEventTopic",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            },
            {
                "action": "sns:GetTopicAttributes",
                "resource_mappings": {
                    "TopicName": {
                        "template": "${TopicName}"
                    }
                }
            }
        ],
        "DirectoryService.RejectSharedDirectory": [
            {
                "action": "ds:RejectSharedDirectory",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${SharedDirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.RemoveIpRoutes": [
            {
                "action": "ds:RemoveIpRoutes",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.RemoveTagsFromResource": [
            {
                "action": "ds:RemoveTagsFromResource",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            },
            {
                "action": "ec2:DeleteTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "capacity-reservation": "%%iftemplatematch%${ResourceId}%%",
                    "client-vpn-endpoint": "%%iftemplatematch%${ResourceId}%%",
                    "customer-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "dedicated-host": "%%iftemplatematch%${ResourceId}%%",
                    "dhcp-options": "%%iftemplatematch%${ResourceId}%%",
                    "egress-only-internet-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "elastic-gpu": "%%iftemplatematch%${ResourceId}%%",
                    "elastic-ip": "%%iftemplatematch%${ResourceId}%%",
                    "export-image-task": "%%iftemplatematch%${ResourceId}%%",
                    "export-instance-task": "%%iftemplatematch%${ResourceId}%%",
                    "fleet": "%%iftemplatematch%${ResourceId}%%",
                    "fpga-image": "%%iftemplatematch%${ResourceId}%%",
                    "host-reservation": "%%iftemplatematch%${ResourceId}%%",
                    "image": "%%iftemplatematch%${ResourceId}%%",
                    "import-image-task": "%%iftemplatematch%${ResourceId}%%",
                    "import-snapshot-task": "%%iftemplatematch%${ResourceId}%%",
                    "instance": "%%iftemplatematch%${ResourceId}%%",
                    "internet-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "ipv4pool-ec2": "%%iftemplatematch%${ResourceId}%%",
                    "ipv6pool-ec2": "%%iftemplatematch%${ResourceId}%%",
                    "key-pair": "%%iftemplatematch%${ResourceId}%%",
                    "launch-template": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-route-table": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-route-table-virtual-interface-group-association": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-route-table-vpc-association": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-virtual-interface": "%%iftemplatematch%${ResourceId}%%",
                    "local-gateway-virtual-interface-group": "%%iftemplatematch%${ResourceId}%%",
                    "natgateway": "%%iftemplatematch%${ResourceId}%%",
                    "network-acl": "%%iftemplatematch%${ResourceId}%%",
                    "network-interface": "%%iftemplatematch%${ResourceId}%%",
                    "placement-group": "%%iftemplatematch%${ResourceId}%%",
                    "prefix-list": "%%iftemplatematch%${ResourceId}%%",
                    "reserved-instances": "%%iftemplatematch%${ResourceId}%%",
                    "route-table": "%%iftemplatematch%${ResourceId}%%",
                    "security-group": "%%iftemplatematch%${ResourceId}%%",
                    "snapshot": "%%iftemplatematch%${ResourceId}%%",
                    "spot-fleet-request": "%%iftemplatematch%${ResourceId}%%",
                    "spot-instances-request": "%%iftemplatematch%${ResourceId}%%",
                    "subnet": "%%iftemplatematch%${ResourceId}%%",
                    "traffic-mirror-filter": "%%iftemplatematch%${ResourceId}%%",
                    "traffic-mirror-session": "%%iftemplatematch%${ResourceId}%%",
                    "traffic-mirror-target": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway-attachment": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway-connect-peer": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway-multicast-domain": "%%iftemplatematch%${ResourceId}%%",
                    "transit-gateway-route-table": "%%iftemplatematch%${ResourceId}%%",
                    "volume": "%%iftemplatematch%${ResourceId}%%",
                    "vpc": "%%iftemplatematch%${ResourceId}%%",
                    "vpc-endpoint": "%%iftemplatematch%${ResourceId}%%",
                    "vpc-endpoint-service": "%%iftemplatematch%${ResourceId}%%",
                    "vpc-flow-log": "%%iftemplatematch%${ResourceId}%%",
                    "vpc-peering-connection": "%%iftemplatematch%${ResourceId}%%",
                    "vpn-connection": "%%iftemplatematch%${ResourceId}%%",
                    "vpn-gateway": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "DirectoryService.ResetUserPassword": [
            {
                "action": "ds:ResetUserPassword",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.RestoreFromSnapshot": [
            {
                "action": "ds:RestoreFromSnapshot",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectoryService.ShareDirectory": [
            {
                "action": "ds:ShareDirectory",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.StartSchemaExtension": [
            {
                "action": "ds:StartSchemaExtension",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.UnshareDirectory": [
            {
                "action": "ds:UnshareDirectory",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.UpdateConditionalForwarder": [
            {
                "action": "ds:UpdateConditionalForwarder",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.UpdateNumberOfDomainControllers": [
            {
                "action": "ds:UpdateNumberOfDomainControllers",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.UpdateRadius": [
            {
                "action": "ds:UpdateRadius",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.UpdateTrust": [
            {
                "action": "ds:UpdateTrust",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectoryService.VerifyTrust": [
            {
                "action": "ds:VerifyTrust",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Discovery.AssociateConfigurationItemsToApplication": [
            {
                "action": "discovery:AssociateConfigurationItemsToApplication",
                "resource_mappings": {}
            }
        ],
        "Discovery.BatchDeleteImportData": [
            {
                "action": "discovery:BatchDeleteImportData",
                "resource_mappings": {}
            }
        ],
        "Discovery.CreateApplication": [
            {
                "action": "discovery:CreateApplication",
                "resource_mappings": {}
            }
        ],
        "Discovery.CreateTags": [
            {
                "action": "discovery:CreateTags",
                "resource_mappings": {}
            }
        ],
        "Discovery.DeleteApplications": [
            {
                "action": "discovery:DeleteApplications",
                "resource_mappings": {}
            }
        ],
        "Discovery.DeleteTags": [
            {
                "action": "discovery:DeleteTags",
                "resource_mappings": {}
            }
        ],
        "Discovery.DescribeAgents": [
            {
                "action": "discovery:DescribeAgents",
                "resource_mappings": {}
            }
        ],
        "Discovery.DescribeConfigurations": [
            {
                "action": "discovery:DescribeConfigurations",
                "resource_mappings": {}
            }
        ],
        "Discovery.DescribeContinuousExports": [
            {
                "action": "discovery:DescribeContinuousExports",
                "resource_mappings": {}
            }
        ],
        "Discovery.DescribeExportConfigurations": [
            {
                "action": "discovery:DescribeExportConfigurations",
                "resource_mappings": {}
            }
        ],
        "Discovery.DescribeExportTasks": [
            {
                "action": "discovery:DescribeExportTasks",
                "resource_mappings": {}
            }
        ],
        "Discovery.DescribeImportTasks": [
            {
                "action": "discovery:DescribeImportTasks",
                "resource_mappings": {}
            }
        ],
        "Discovery.DescribeTags": [
            {
                "action": "discovery:DescribeTags",
                "resource_mappings": {}
            }
        ],
        "Discovery.DisassociateConfigurationItemsFromApplication": [
            {
                "action": "discovery:DisassociateConfigurationItemsFromApplication",
                "resource_mappings": {}
            }
        ],
        "Discovery.ExportConfigurations": [
            {
                "action": "discovery:ExportConfigurations",
                "resource_mappings": {}
            }
        ],
        "Discovery.GetDiscoverySummary": [
            {
                "action": "discovery:GetDiscoverySummary",
                "resource_mappings": {}
            }
        ],
        "Discovery.ListConfigurations": [
            {
                "action": "discovery:ListConfigurations",
                "resource_mappings": {}
            }
        ],
        "Discovery.ListServerNeighbors": [
            {
                "action": "discovery:ListServerNeighbors",
                "resource_mappings": {}
            }
        ],
        "Discovery.StartContinuousExport": [
            {
                "action": "discovery:StartContinuousExport",
                "resource_mappings": {}
            }
        ],
        "Discovery.StartDataCollectionByAgentIds": [
            {
                "action": "discovery:StartDataCollectionByAgentIds",
                "resource_mappings": {}
            }
        ],
        "Discovery.StartExportTask": [
            {
                "action": "discovery:StartExportTask",
                "resource_mappings": {}
            }
        ],
        "Discovery.StartImportTask": [
            {
                "action": "discovery:StartImportTask",
                "resource_mappings": {}
            }
        ],
        "Discovery.StopContinuousExport": [
            {
                "action": "discovery:StopContinuousExport",
                "resource_mappings": {}
            }
        ],
        "Discovery.StopDataCollectionByAgentIds": [
            {
                "action": "discovery:StopDataCollectionByAgentIds",
                "resource_mappings": {}
            }
        ],
        "Discovery.UpdateApplication": [
            {
                "action": "discovery:UpdateApplication",
                "resource_mappings": {}
            }
        ],
        "DMS.AddTagsToResource": [
            {
                "action": "dms:AddTagsToResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Certificate": "%%iftemplatematch%${ResourceArn}%%",
                    "Endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "EventSubscription": "%%iftemplatematch%${ResourceArn}%%",
                    "ReplicationInstance": "%%iftemplatematch%${ResourceArn}%%",
                    "ReplicationSubnetGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "ReplicationTask": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DMS.ApplyPendingMaintenanceAction": [
            {
                "action": "dms:ApplyPendingMaintenanceAction",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationInstance": "${ReplicationInstanceArn}"
                }
            }
        ],
        "DMS.CancelReplicationTaskAssessmentRun": [
            {
                "action": "dms:CancelReplicationTaskAssessmentRun",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTaskAssessmentRun": "${ReplicationTaskAssessmentRunArn}"
                }
            }
        ],
        "DMS.CreateEndpoint": [
            {
                "action": "dms:CreateEndpoint",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${ServiceAccessRoleArn}%${DynamoDbSettings.ServiceAccessRoleArn}%${S3Settings.ServiceAccessRoleArn}%${DmsTransferSettings.ServiceAccessRoleArn}%${KinesisSettings.ServiceAccessRoleArn}%${ElasticsearchSettings.ServiceAccessRoleArn}%${NeptuneSettings.ServiceAccessRoleArn}%${NeptuneSettings.IamAuthEnabled}%${RedshiftSettings.ServiceAccessRoleArn}%%"
                }
            }
        ],
        "DMS.CreateEventSubscription": [
            {
                "action": "dms:CreateEventSubscription",
                "resource_mappings": {}
            }
        ],
        "DMS.CreateReplicationInstance": [
            {
                "action": "dms:CreateReplicationInstance",
                "resource_mappings": {}
            }
        ],
        "DMS.CreateReplicationSubnetGroup": [
            {
                "action": "dms:CreateReplicationSubnetGroup",
                "resource_mappings": {}
            }
        ],
        "DMS.CreateReplicationTask": [
            {
                "action": "dms:CreateReplicationTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Endpoint": "%%many%${SourceEndpointArn}%${TargetEndpointArn}%%",
                    "ReplicationInstance": "${ReplicationInstanceArn}"
                }
            }
        ],
        "DMS.DeleteCertificate": [
            {
                "action": "dms:DeleteCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Certificate": "${CertificateArn}"
                }
            }
        ],
        "DMS.DeleteEndpoint": [
            {
                "action": "dms:DeleteEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Endpoint": "${EndpointArn}"
                }
            }
        ],
        "DMS.DeleteEventSubscription": [
            {
                "action": "dms:DeleteEventSubscription",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "EventSubscription": "arn:${Partition}:dms:${Region}:${Account}:es:*"
                }
            }
        ],
        "DMS.DeleteReplicationInstance": [
            {
                "action": "dms:DeleteReplicationInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationInstance": "${ReplicationInstanceArn}"
                }
            }
        ],
        "DMS.DeleteReplicationSubnetGroup": [
            {
                "action": "dms:DeleteReplicationSubnetGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationSubnetGroup": "arn:${Partition}:dms:${Region}:${Account}:subgrp:${ReplicationSubnetGroupIdentifier}"
                }
            }
        ],
        "DMS.DeleteReplicationTask": [
            {
                "action": "dms:DeleteReplicationTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.DeleteReplicationTaskAssessmentRun": [
            {
                "action": "dms:DeleteReplicationTaskAssessmentRun",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTaskAssessmentRun": "${ReplicationTaskAssessmentRunArn}"
                }
            }
        ],
        "DMS.DescribeAccountAttributes": [
            {
                "action": "dms:DescribeAccountAttributes",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeApplicableIndividualAssessments": [
            {
                "action": "dms:DescribeApplicableIndividualAssessments",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationInstance": "${ReplicationInstanceArn}",
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.DescribeCertificates": [
            {
                "action": "dms:DescribeCertificates",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeConnections": [
            {
                "action": "dms:DescribeConnections",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeEndpointTypes": [
            {
                "action": "dms:DescribeEndpointTypes",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeEndpoints": [
            {
                "action": "dms:DescribeEndpoints",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeEventCategories": [
            {
                "action": "dms:DescribeEventCategories",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeEventSubscriptions": [
            {
                "action": "dms:DescribeEventSubscriptions",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeEvents": [
            {
                "action": "dms:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeOrderableReplicationInstances": [
            {
                "action": "dms:DescribeOrderableReplicationInstances",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeRefreshSchemasStatus": [
            {
                "action": "dms:DescribeRefreshSchemasStatus",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Endpoint": "${EndpointArn}"
                }
            }
        ],
        "DMS.DescribeReplicationInstanceTaskLogs": [
            {
                "action": "dms:DescribeReplicationInstanceTaskLogs",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationInstance": "${ReplicationInstanceArn}"
                }
            }
        ],
        "DMS.DescribeReplicationInstances": [
            {
                "action": "dms:DescribeReplicationInstances",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeReplicationSubnetGroups": [
            {
                "action": "dms:DescribeReplicationSubnetGroups",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeReplicationTaskAssessmentResults": [
            {
                "action": "dms:DescribeReplicationTaskAssessmentResults",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.DescribeReplicationTaskAssessmentRuns": [
            {
                "action": "dms:DescribeReplicationTaskAssessmentRuns",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationInstance": "arn:${Partition}:dms:${Region}:${Account}:rep:*",
                    "ReplicationTask": "arn:${Partition}:dms:${Region}:${Account}:task:*",
                    "ReplicationTaskAssessmentRun": "arn:${Partition}:dms:${Region}:${Account}:assessment-run:*"
                }
            }
        ],
        "DMS.DescribeReplicationTaskIndividualAssessments": [
            {
                "action": "dms:DescribeReplicationTaskIndividualAssessments",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "arn:${Partition}:dms:${Region}:${Account}:task:*",
                    "ReplicationTaskAssessmentRun": "arn:${Partition}:dms:${Region}:${Account}:assessment-run:*"
                }
            }
        ],
        "DMS.DescribeReplicationTasks": [
            {
                "action": "dms:DescribeReplicationTasks",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribeSchemas": [
            {
                "action": "dms:DescribeSchemas",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Endpoint": "${EndpointArn}"
                }
            }
        ],
        "DMS.DescribeTableStatistics": [
            {
                "action": "dms:DescribeTableStatistics",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.ImportCertificate": [
            {
                "action": "dms:ImportCertificate",
                "resource_mappings": {}
            }
        ],
        "DMS.ListTagsForResource": [
            {
                "action": "dms:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Certificate": "%%iftemplatematch%${ResourceArn}%%",
                    "Endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "EventSubscription": "%%iftemplatematch%${ResourceArn}%%",
                    "ReplicationInstance": "%%iftemplatematch%${ResourceArn}%%",
                    "ReplicationSubnetGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "ReplicationTask": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DMS.ModifyEndpoint": [
            {
                "action": "dms:ModifyEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Endpoint": "${EndpointArn}",
                    "Certificate": "${CertificateArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${ServiceAccessRoleArn}%${DynamoDbSettings.ServiceAccessRoleArn}%${S3Settings.ServiceAccessRoleArn}%${DmsTransferSettings.ServiceAccessRoleArn}%${KinesisSettings.ServiceAccessRoleArn}%${ElasticsearchSettings.ServiceAccessRoleArn}%${NeptuneSettings.ServiceAccessRoleArn}%${NeptuneSettings.IamAuthEnabled}%${RedshiftSettings.ServiceAccessRoleArn}%%"
                }
            }
        ],
        "DMS.ModifyEventSubscription": [
            {
                "action": "dms:ModifyEventSubscription",
                "resource_mappings": {}
            }
        ],
        "DMS.ModifyReplicationInstance": [
            {
                "action": "dms:ModifyReplicationInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationInstance": "${ReplicationInstanceArn}"
                }
            }
        ],
        "DMS.ModifyReplicationSubnetGroup": [
            {
                "action": "dms:ModifyReplicationSubnetGroup",
                "resource_mappings": {}
            }
        ],
        "DMS.ModifyReplicationTask": [
            {
                "action": "dms:ModifyReplicationTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.RebootReplicationInstance": [
            {
                "action": "dms:RebootReplicationInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationInstance": "${ReplicationInstanceArn}"
                }
            }
        ],
        "DMS.RefreshSchemas": [
            {
                "action": "dms:RefreshSchemas",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Endpoint": "${EndpointArn}",
                    "ReplicationInstance": "${ReplicationInstanceArn}"
                }
            }
        ],
        "DMS.ReloadTables": [
            {
                "action": "dms:ReloadTables",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.RemoveTagsFromResource": [
            {
                "action": "dms:RemoveTagsFromResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Certificate": "%%iftemplatematch%${ResourceArn}%%",
                    "Endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "EventSubscription": "%%iftemplatematch%${ResourceArn}%%",
                    "ReplicationInstance": "%%iftemplatematch%${ResourceArn}%%",
                    "ReplicationSubnetGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "ReplicationTask": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DMS.StartReplicationTask": [
            {
                "action": "dms:StartReplicationTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.StartReplicationTaskAssessment": [
            {
                "action": "dms:StartReplicationTaskAssessment",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.StartReplicationTaskAssessmentRun": [
            {
                "action": "dms:StartReplicationTaskAssessmentRun",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.StopReplicationTask": [
            {
                "action": "dms:StopReplicationTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "DMS.TestConnection": [
            {
                "action": "dms:TestConnection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Endpoint": "${EndpointArn}",
                    "ReplicationInstance": "${ReplicationInstanceArn}"
                }
            }
        ],
        "DynamoDB.BatchGetItem": [
            {
                "action": "dynamodb:BatchGetItem",
                "resource_mappings": {
                    "TableName": {
                        "template": "*"
                    }
                }
            }
        ],
        "DynamoDB.BatchWriteItem": [
            {
                "action": "dynamodb:BatchWriteItem",
                "resource_mappings": {
                    "TableName": {
                        "template": "*"
                    }
                }
            }
        ],
        "DynamoDB.CreateBackup": [
            {
                "action": "dynamodb:CreateBackup",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.CreateGlobalTable": [
            {
                "action": "dynamodb:CreateGlobalTable",
                "resource_mappings": {
                    "GlobalTableName": {
                        "template": "${GlobalTableName}"
                    },
                    "TableName": {
                        "template": "${GlobalTableName}"
                    }
                }
            }
        ],
        "DynamoDB.CreateTable": [
            {
                "action": "dynamodb:CreateTable",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.DeleteBackup": [
            {
                "action": "dynamodb:DeleteBackup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "backup": "${BackupArn}"
                }
            }
        ],
        "DynamoDB.DeleteItem": [
            {
                "action": "dynamodb:DeleteItem",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.DeleteTable": [
            {
                "action": "dynamodb:DeleteTable",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.DescribeBackup": [
            {
                "action": "dynamodb:DescribeBackup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "backup": "${BackupArn}"
                }
            }
        ],
        "DynamoDB.DescribeContinuousBackups": [
            {
                "action": "dynamodb:DescribeContinuousBackups",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.DescribeContributorInsights": [
            {
                "action": "dynamodb:DescribeContributorInsights",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    },
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "DynamoDB.DescribeExport": [
            {
                "action": "dynamodb:DescribeExport",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "export": "${ExportArn}"
                }
            }
        ],
        "DynamoDB.DescribeGlobalTable": [
            {
                "action": "dynamodb:DescribeGlobalTable",
                "resource_mappings": {
                    "GlobalTableName": {
                        "template": "${GlobalTableName}"
                    }
                }
            }
        ],
        "DynamoDB.DescribeGlobalTableSettings": [
            {
                "action": "dynamodb:DescribeGlobalTableSettings",
                "resource_mappings": {
                    "GlobalTableName": {
                        "template": "${GlobalTableName}"
                    }
                }
            }
        ],
        "DynamoDB.DescribeKinesisStreamingDestination": [
            {
                "action": "dynamodb:DescribeKinesisStreamingDestination",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.DescribeLimits": [
            {
                "action": "dynamodb:DescribeLimits",
                "resource_mappings": {}
            }
        ],
        "DynamoDB.DescribeTable": [
            {
                "action": "dynamodb:DescribeTable",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.DescribeTableReplicaAutoScaling": [
            {
                "action": "dynamodb:DescribeTableReplicaAutoScaling",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.DescribeTimeToLive": [
            {
                "action": "dynamodb:DescribeTimeToLive",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.DisableKinesisStreamingDestination": [
            {
                "action": "dynamodb:DisableKinesisStreamingDestination",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.EnableKinesisStreamingDestination": [
            {
                "action": "dynamodb:EnableKinesisStreamingDestination",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.ExportTableToPointInTime": [
            {
                "action": "dynamodb:ExportTableToPointInTime",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "table": "${TableArn}"
                }
            }
        ],
        "DynamoDB.GetItem": [
            {
                "action": "dynamodb:GetItem",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.ListBackups": [
            {
                "action": "dynamodb:ListBackups",
                "resource_mappings": {}
            }
        ],
        "DynamoDB.ListContributorInsights": [
            {
                "action": "dynamodb:ListContributorInsights",
                "resource_mappings": {}
            }
        ],
        "DynamoDB.ListExports": [
            {
                "action": "dynamodb:ListExports",
                "resource_mappings": {}
            }
        ],
        "DynamoDB.ListGlobalTables": [
            {
                "action": "dynamodb:ListGlobalTables",
                "resource_mappings": {}
            }
        ],
        "DynamoDB.ListTables": [
            {
                "action": "dynamodb:ListTables",
                "resource_mappings": {}
            }
        ],
        "DynamoDB.ListTagsOfResource": [
            {
                "action": "dynamodb:ListTagsOfResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "table": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DynamoDB.PutItem": [
            {
                "action": "dynamodb:PutItem",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.Query": [
            {
                "action": "dynamodb:Query",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    },
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "DynamoDB.RestoreTableFromBackup": [
            {
                "action": "dynamodb:RestoreTableFromBackup",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TargetTableName}"
                    }
                },
                "resourcearn_mappings": {
                    "backup": "${BackupArn}"
                }
            }
        ],
        "DynamoDB.RestoreTableToPointInTime": [
            {
                "action": "dynamodb:RestoreTableToPointInTime",
                "resource_mappings": {
                    "TableName": {
                        "template": "%%many%${SourceTableName}%${TargetTableName}%%"
                    }
                }
            },
            {
                "action": "dynamodb:RestoreTableToPointInTime",
                "arn_override": {
                    "template": "${SourceTableArn}"
                }
            }
        ],
        "DynamoDB.Scan": [
            {
                "action": "dynamodb:Scan",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    },
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "DynamoDB.TagResource": [
            {
                "action": "dynamodb:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "table": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DynamoDB.UntagResource": [
            {
                "action": "dynamodb:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "table": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DynamoDB.UpdateContinuousBackups": [
            {
                "action": "dynamodb:UpdateContinuousBackups",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.UpdateContributorInsights": [
            {
                "action": "dynamodb:UpdateContributorInsights",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    },
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "DynamoDB.UpdateGlobalTable": [
            {
                "action": "dynamodb:UpdateGlobalTable",
                "resource_mappings": {
                    "GlobalTableName": {
                        "template": "${GlobalTableName}"
                    },
                    "TableName": {
                        "template": "${GlobalTableName}"
                    }
                }
            }
        ],
        "DynamoDB.UpdateGlobalTableSettings": [
            {
                "action": "dynamodb:UpdateGlobalTableSettings",
                "resource_mappings": {
                    "GlobalTableName": {
                        "template": "${GlobalTableName}"
                    },
                    "TableName": {
                        "template": "${GlobalTableName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${GlobalTableProvisionedWriteCapacityAutoScalingSettingsUpdate.AutoScalingRoleArn}"
                }
            }
        ],
        "DynamoDB.UpdateItem": [
            {
                "action": "dynamodb:UpdateItem",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.UpdateTable": [
            {
                "action": "dynamodb:UpdateTable",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDB.UpdateTableReplicaAutoScaling": [
            {
                "action": "dynamodb:UpdateTableReplicaAutoScaling",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ProvisionedWriteCapacityAutoScalingUpdate.AutoScalingRoleArn}"
                }
            }
        ],
        "DynamoDB.UpdateTimeToLive": [
            {
                "action": "dynamodb:UpdateTimeToLive",
                "resource_mappings": {
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DynamoDBStreams.DescribeStream": [
            {
                "action": "dynamodb:DescribeStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamArn}"
                }
            }
        ],
        "DynamoDBStreams.GetRecords": [
            {
                "action": "dynamodb:GetRecords",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "%%regex%${ShardIterator}%/^(.+)\\|/g%%"
                }
            }
        ],
        "DynamoDBStreams.GetShardIterator": [
            {
                "action": "dynamodb:GetShardIterator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamArn}"
                }
            }
        ],
        "DynamoDBStreams.ListStreams": [
            {
                "action": "dynamodb:ListStreams",
                "resource_mappings": {}
            }
        ],
        "EC2.AcceptTransitGatewayMulticastDomainAssociations": [
            {
                "action": "ec2:AcceptTransitGatewayMulticastDomainAssociations",
                "resource_mappings": {
                    "SubnetId": {
                        "template": "${SubnetIds[]}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.AcceptTransitGatewayPeeringAttachment": [
            {
                "action": "ec2:AcceptTransitGatewayPeeringAttachment",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.AcceptTransitGatewayVpcAttachment": [
            {
                "action": "ec2:AcceptTransitGatewayVpcAttachment",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.AcceptVpcEndpointConnections": [
            {
                "action": "ec2:AcceptVpcEndpointConnections",
                "resource_mappings": {
                    "VpcEndpointId": {
                        "template": "${VpcEndpointIds[]}"
                    },
                    "VpcEndpointServiceId": {
                        "template": "${ServiceId}"
                    }
                }
            }
        ],
        "EC2.AcceptVpcPeeringConnection": [
            {
                "action": "ec2:AcceptVpcPeeringConnection",
                "resource_mappings": {
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "${VpcPeeringConnectionId}"
                    }
                }
            }
        ],
        "EC2.AdvertiseByoipCidr": [
            {
                "action": "ec2:AdvertiseByoipCidr",
                "resource_mappings": {}
            }
        ],
        "EC2.AllocateAddress": [
            {
                "action": "ec2:AllocateAddress",
                "resource_mappings": {
                    "Ipv4PoolEc2Id": {
                        "template": "${CustomerOwnedIpv4Pool}"
                    }
                }
            }
        ],
        "EC2.AllocateHosts": [
            {
                "action": "ec2:AllocateHosts",
                "resource_mappings": {
                    "DedicatedHostId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.ApplySecurityGroupsToClientVpnTargetNetwork": [
            {
                "action": "ec2:ApplySecurityGroupsToClientVpnTargetNetwork",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    },
                    "SecurityGroupId": {
                        "template": "${SecurityGroupIds[]}"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.AssignIpv6Addresses": [
            {
                "action": "ec2:AssignIpv6Addresses",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.AssignPrivateIpAddresses": [
            {
                "action": "ec2:AssignPrivateIpAddresses",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.AssociateAddress": [
            {
                "action": "ec2:AssociateAddress",
                "resource_mappings": {
                    "AllocationId": {
                        "template": "${AllocationId}"
                    },
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.AssociateClientVpnTargetNetwork": [
            {
                "action": "ec2:AssociateClientVpnTargetNetwork",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    },
                    "SubnetId": {
                        "template": "${SubnetId}"
                    }
                }
            }
        ],
        "EC2.AssociateDhcpOptions": [
            {
                "action": "ec2:AssociateDhcpOptions",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.AssociateEnclaveCertificateIamRole": [
            {
                "action": "ec2:AssociateEnclaveCertificateIamRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}",
                    "role": "${RoleArn}"
                }
            }
        ],
        "EC2.AssociateIamInstanceProfile": [
            {
                "action": "ec2:AssociateIamInstanceProfile",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamInstanceProfile.Arn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${IamInstanceProfile.Name}%*%%%"
                }
            }
        ],
        "EC2.AssociateRouteTable": [
            {
                "action": "ec2:AssociateRouteTable",
                "resource_mappings": {
                    "RouteTableId": {
                        "template": "${RouteTableId}"
                    },
                    "InternetGatewayId": {
                        "template": "%%regex%${GatewayId}%/^(igw.+)$/g%%"
                    },
                    "SubnetId": {
                        "template": "${SubnetId}"
                    },
                    "VpnGatewayId": {
                        "template": "%%regex%${GatewayId}%/^(vgw.+)$/g%%"
                    }
                }
            }
        ],
        "EC2.AssociateSubnetCidrBlock": [
            {
                "action": "ec2:AssociateSubnetCidrBlock",
                "resource_mappings": {
                    "SubnetId": {
                        "template": "${SubnetId}"
                    }
                }
            }
        ],
        "EC2.AssociateTransitGatewayMulticastDomain": [
            {
                "action": "ec2:AssociateTransitGatewayMulticastDomain",
                "resource_mappings": {
                    "SubnetId": {
                        "template": "${SubnetIds[]}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.AssociateTransitGatewayRouteTable": [
            {
                "action": "ec2:AssociateTransitGatewayRouteTable",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.AssociateVpcCidrBlock": [
            {
                "action": "ec2:AssociateVpcCidrBlock",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "${Ipv6Pool}"
                    }
                }
            }
        ],
        "EC2.AttachClassicLinkVpc": [
            {
                "action": "ec2:AttachClassicLinkVpc",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "SecurityGroupId": {
                        "template": "${Groups[]}"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.AttachInternetGateway": [
            {
                "action": "ec2:AttachInternetGateway",
                "resource_mappings": {
                    "InternetGatewayId": {
                        "template": "${InternetGatewayId}"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.AttachNetworkInterface": [
            {
                "action": "ec2:AttachNetworkInterface",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.AttachVolume": [
            {
                "action": "ec2:AttachVolume",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "VolumeId": {
                        "template": "${VolumeId}"
                    }
                }
            }
        ],
        "EC2.AttachVpnGateway": [
            {
                "action": "ec2:AttachVpnGateway",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    },
                    "VpnGatewayId": {
                        "template": "${VpnGatewayId}"
                    }
                }
            }
        ],
        "EC2.AuthorizeClientVpnIngress": [
            {
                "action": "ec2:AuthorizeClientVpnIngress",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    }
                }
            }
        ],
        "EC2.AuthorizeSecurityGroupEgress": [
            {
                "action": "ec2:AuthorizeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "EC2.AuthorizeSecurityGroupIngress": [
            {
                "action": "ec2:AuthorizeSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "EC2.BundleInstance": [
            {
                "action": "ec2:BundleInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.CancelBundleTask": [
            {
                "action": "ec2:CancelBundleTask",
                "resource_mappings": {}
            }
        ],
        "EC2.CancelCapacityReservation": [
            {
                "action": "ec2:CancelCapacityReservation",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "${CapacityReservationId}"
                    }
                }
            }
        ],
        "EC2.CancelConversionTask": [
            {
                "action": "ec2:CancelConversionTask",
                "resource_mappings": {}
            }
        ],
        "EC2.CancelExportTask": [
            {
                "action": "ec2:CancelExportTask",
                "resource_mappings": {
                    "ExportImageTaskId": {
                        "template": "%%regex%${ExportTaskId}%/^(export-ami-.+)$/g%%"
                    },
                    "ExportTaskId": {
                        "template": "%%regex%${ExportTaskId}%/^(export-i-.+)$/g%%"
                    }
                }
            }
        ],
        "EC2.CancelImportTask": [
            {
                "action": "ec2:CancelImportTask",
                "resource_mappings": {
                    "ImportImageTaskId": {
                        "template": "%%regex%${ExportTaskId}%/^(export-ami-.+)$/g%%"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "%%regex%${ExportTaskId}%/^(export-i-.+)$/g%%"
                    }
                }
            }
        ],
        "EC2.CancelReservedInstancesListing": [
            {
                "action": "ec2:CancelReservedInstancesListing",
                "resource_mappings": {}
            }
        ],
        "EC2.CancelSpotFleetRequests": [
            {
                "action": "ec2:CancelSpotFleetRequests",
                "resource_mappings": {
                    "SpotFleetRequestId": {
                        "template": "${SpotFleetRequestIds[]}"
                    }
                }
            }
        ],
        "EC2.CancelSpotInstanceRequests": [
            {
                "action": "ec2:CancelSpotInstanceRequests",
                "resource_mappings": {
                    "SpotInstanceRequestId": {
                        "template": "${SpotInstanceRequestIds[]}"
                    }
                }
            }
        ],
        "EC2.ConfirmProductInstance": [
            {
                "action": "ec2:ConfirmProductInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.CopyFpgaImage": [
            {
                "action": "ec2:CopyFpgaImage",
                "resource_mappings": {
                    "FpgaImageId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CopyImage": [
            {
                "action": "ec2:CopyImage",
                "resource_mappings": {
                    "ImageId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CopySnapshot": [
            {
                "action": "ec2:CopySnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SourceSnapshotId}"
                    }
                }
            }
        ],
        "EC2.CreateCapacityReservation": [
            {
                "action": "ec2:CreateCapacityReservation",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateCarrierGateway": [
            {
                "action": "ec2:CreateCarrierGateway",
                "resource_mappings": {
                    "CarrierGatewayId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.CreateClientVpnEndpoint": [
            {
                "action": "ec2:CreateClientVpnEndpoint",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "${SecurityGroupIds[]}"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.CreateClientVpnRoute": [
            {
                "action": "ec2:CreateClientVpnRoute",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    },
                    "SubnetId": {
                        "template": "${TargetVpcSubnetId}"
                    }
                }
            }
        ],
        "EC2.CreateCustomerGateway": [
            {
                "action": "ec2:CreateCustomerGateway",
                "resource_mappings": {
                    "CustomerGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateDefaultSubnet": [
            {
                "action": "ec2:CreateDefaultSubnet",
                "resource_mappings": {}
            }
        ],
        "EC2.CreateDefaultVpc": [
            {
                "action": "ec2:CreateDefaultVpc",
                "resource_mappings": {}
            }
        ],
        "EC2.CreateDhcpOptions": [
            {
                "action": "ec2:CreateDhcpOptions",
                "resource_mappings": {
                    "DhcpOptionsId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateEgressOnlyInternetGateway": [
            {
                "action": "ec2:CreateEgressOnlyInternetGateway",
                "resource_mappings": {
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.CreateFleet": [
            {
                "action": "ec2:CreateFleet",
                "resource_mappings": {
                    "FleetId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "${LaunchTemplateConfigs[].LaunchTemplateSpecification.LaunchTemplateId}"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "${LaunchTemplateConfigs[].Overrides[].SubnetId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplateConfigs[].LaunchTemplateSpecification.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplateConfigs[].LaunchTemplateSpecification.LaunchTemplateName}%*%%%"
                }
            }
        ],
        "EC2.CreateFlowLogs": [
            {
                "action": "ec2:CreateFlowLogs",
                "resource_mappings": {
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DeliverLogsPermissionArn}"
                }
            }
        ],
        "EC2.CreateFpgaImage": [
            {
                "action": "ec2:CreateFpgaImage",
                "resource_mappings": {
                    "FpgaImageId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateImage": [
            {
                "action": "ec2:CreateImage",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.CreateInstanceExportTask": [
            {
                "action": "ec2:CreateInstanceExportTask",
                "resource_mappings": {
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.CreateInternetGateway": [
            {
                "action": "ec2:CreateInternetGateway",
                "resource_mappings": {
                    "InternetGatewayId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "vpc": "%%iftruthy%${TagSpecifications[].ResourceType}%arn:${Partition}:ec2:${Region}:${Account}:internet-gateway/*%%%"
                }
            }
        ],
        "EC2.CreateKeyPair": [
            {
                "action": "ec2:CreateKeyPair",
                "resource_mappings": {
                    "KeyPairName": {
                        "template": "${KeyName}"
                    }
                }
            }
        ],
        "EC2.CreateLaunchTemplate": [
            {
                "action": "ec2:CreateLaunchTemplate",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "${LaunchTemplateData.CapacityReservationSpecification.CapacityReservationTarget.CapacityReservationId}"
                    },
                    "DedicatedHostId": {
                        "template": "${LaunchTemplateData.Placement.HostId}"
                    },
                    "ImageId": {
                        "template": "${LaunchTemplateData.ImageId}"
                    },
                    "KeyPairName": {
                        "template": "${LaunchTemplateData.KeyName}"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "${LaunchTemplateData.Placement.GroupName}"
                    },
                    "SecurityGroupId": {
                        "template": "%%many%${LaunchTemplateData.NetworkInterfaces[].Groups[]}%${LaunchTemplateData.SecurityGroupIds[]}%%"
                    },
                    "SnapshotId": {
                        "template": "${LaunchTemplateData.BlockDeviceMappings[].Ebs.SnapshotId}"
                    },
                    "SubnetId": {
                        "template": "${LaunchTemplateData.NetworkInterfaces[].SubnetId}"
                    }
                }
            }
        ],
        "EC2.CreateLaunchTemplateVersion": [
            {
                "action": "ec2:CreateLaunchTemplateVersion",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "${LaunchTemplateId}"
                    },
                    "CapacityReservationId": {
                        "template": "${LaunchTemplateData.CapacityReservationSpecification.CapacityReservationTarget.CapacityReservationId}"
                    },
                    "DedicatedHostId": {
                        "template": "${LaunchTemplateData.Placement.HostId}"
                    },
                    "ImageId": {
                        "template": "${LaunchTemplateData.ImageId}"
                    },
                    "KeyPairName": {
                        "template": "${LaunchTemplateData.KeyName}"
                    },
                    "NetworkInterfaceId": {
                        "template": "${LaunchTemplateData.NetworkInterfaces[].NetworkInterfaceId}"
                    },
                    "PlacementGroupName": {
                        "template": "${LaunchTemplateData.Placement.GroupName}"
                    },
                    "SecurityGroupId": {
                        "template": "%%many%${LaunchTemplateData.NetworkInterfaces[].Groups[]}%${LaunchTemplateData.SecurityGroupIds[]}%%"
                    },
                    "SnapshotId": {
                        "template": "${LaunchTemplateData.BlockDeviceMappings[].Ebs.SnapshotId}"
                    },
                    "SubnetId": {
                        "template": "${LaunchTemplateData.NetworkInterfaces[].SubnetId}"
                    }
                }
            }
        ],
        "EC2.CreateLocalGatewayRoute": [
            {
                "action": "ec2:CreateLocalGatewayRoute",
                "resource_mappings": {
                    "LocalGatewayRoutetableId": {
                        "template": "${LocalGatewayRouteTableId}"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "${LocalGatewayVirtualInterfaceGroupId}"
                    }
                }
            }
        ],
        "EC2.CreateLocalGatewayRouteTableVpcAssociation": [
            {
                "action": "ec2:CreateLocalGatewayRouteTableVpcAssociation",
                "resource_mappings": {
                    "LocalGatewayRoutetableId": {
                        "template": "${LocalGatewayRouteTableId}"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.CreateManagedPrefixList": [
            {
                "action": "ec2:CreateManagedPrefixList",
                "resource_mappings": {
                    "PrefixListId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateNatGateway": [
            {
                "action": "ec2:CreateNatGateway",
                "resource_mappings": {
                    "AllocationId": {
                        "template": "${AllocationId}"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "${SubnetId}"
                    }
                }
            }
        ],
        "EC2.CreateNetworkAcl": [
            {
                "action": "ec2:CreateNetworkAcl",
                "resource_mappings": {
                    "NaclId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.CreateNetworkAclEntry": [
            {
                "action": "ec2:CreateNetworkAclEntry",
                "resource_mappings": {
                    "NaclId": {
                        "template": "${NetworkAclId}"
                    }
                }
            }
        ],
        "EC2.CreateNetworkInsightsPath": [
            {
                "action": "ec2:CreateNetworkInsightsPath",
                "resource_mappings": {
                    "NetworkInsightsPathId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateNetworkInterface": [
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "${SubnetId}"
                    },
                    "SecurityGroupId": {
                        "template": "${Groups[]}"
                    }
                }
            }
        ],
        "EC2.CreateNetworkInterfacePermission": [
            {
                "action": "ec2:CreateNetworkInterfacePermission",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.CreatePlacementGroup": [
            {
                "action": "ec2:CreatePlacementGroup",
                "resource_mappings": {
                    "PlacementGroupName": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "EC2.CreateReservedInstancesListing": [
            {
                "action": "ec2:CreateReservedInstancesListing",
                "resource_mappings": {
                    "ReservationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateRoute": [
            {
                "action": "ec2:CreateRoute",
                "resource_mappings": {
                    "RouteTableId": {
                        "template": "${RouteTableId}"
                    },
                    "CarrierGatewayId": {
                        "template": "${CarrierGatewayId}"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "${EgressOnlyInternetGatewayId}"
                    },
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "InternetGatewayId": {
                        "template": "%%regex%${GatewayId}%/^(igw.+)$/g%%"
                    },
                    "LocalGatewayId": {
                        "template": "${LocalGatewayId}"
                    },
                    "NatGatewayId": {
                        "template": "${NatGatewayId}"
                    },
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    },
                    "PrefixListId": {
                        "template": "${DestinationPrefixListId}"
                    },
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "${VpcPeeringConnectionId}"
                    },
                    "VpnGatewayId": {
                        "template": "%%regex%${GatewayId}%/^(vgw.+)$/g%%"
                    }
                }
            }
        ],
        "EC2.CreateRouteTable": [
            {
                "action": "ec2:CreateRouteTable",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.CreateSecurityGroup": [
            {
                "action": "ec2:CreateSecurityGroup",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.CreateSnapshot": [
            {
                "action": "ec2:CreateSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "${VolumeId}"
                    }
                }
            }
        ],
        "EC2.CreateSnapshots": [
            {
                "action": "ec2:CreateSnapshots",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceSpecification.InstanceId}"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateSpotDatafeedSubscription": [
            {
                "action": "ec2:CreateSpotDatafeedSubscription",
                "resource_mappings": {}
            }
        ],
        "EC2.CreateSubnet": [
            {
                "action": "ec2:CreateSubnet",
                "resource_mappings": {
                    "SubnetId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "vpc": "%%iftruthy%${TagSpecifications[].ResourceType}%arn:${Partition}:ec2:${Region}:${Account}:subnet/*%%%"
                }
            }
        ],
        "EC2.CreateTags": [
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "capacity-reservation": "%%iftemplatematch%${Resources[]}%%",
                    "client-vpn-endpoint": "%%iftemplatematch%${Resources[]}%%",
                    "customer-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "dedicated-host": "%%iftemplatematch%${Resources[]}%%",
                    "dhcp-options": "%%iftemplatematch%${Resources[]}%%",
                    "egress-only-internet-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "elastic-gpu": "%%iftemplatematch%${Resources[]}%%",
                    "elastic-ip": "%%iftemplatematch%${Resources[]}%%",
                    "export-image-task": "%%iftemplatematch%${Resources[]}%%",
                    "export-instance-task": "%%iftemplatematch%${Resources[]}%%",
                    "fleet": "%%iftemplatematch%${Resources[]}%%",
                    "fpga-image": "%%iftemplatematch%${Resources[]}%%",
                    "host-reservation": "%%iftemplatematch%${Resources[]}%%",
                    "image": "%%iftemplatematch%${Resources[]}%%",
                    "import-image-task": "%%iftemplatematch%${Resources[]}%%",
                    "import-snapshot-task": "%%iftemplatematch%${Resources[]}%%",
                    "instance": "%%iftemplatematch%${Resources[]}%%",
                    "internet-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "ipv4pool-ec2": "%%iftemplatematch%${Resources[]}%%",
                    "ipv6pool-ec2": "%%iftemplatematch%${Resources[]}%%",
                    "key-pair": "%%iftemplatematch%${Resources[]}%%",
                    "launch-template": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-route-table": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-route-table-virtual-interface-group-association": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-route-table-vpc-association": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-virtual-interface": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-virtual-interface-group": "%%iftemplatematch%${Resources[]}%%",
                    "natgateway": "%%iftemplatematch%${Resources[]}%%",
                    "network-acl": "%%iftemplatematch%${Resources[]}%%",
                    "network-interface": "%%iftemplatematch%${Resources[]}%%",
                    "placement-group": "%%iftemplatematch%${Resources[]}%%",
                    "prefix-list": "%%iftemplatematch%${Resources[]}%%",
                    "reserved-instances": "%%iftemplatematch%${Resources[]}%%",
                    "route-table": "%%iftemplatematch%${Resources[]}%%",
                    "security-group": "%%iftemplatematch%${Resources[]}%%",
                    "snapshot": "%%iftemplatematch%${Resources[]}%%",
                    "spot-fleet-request": "%%iftemplatematch%${Resources[]}%%",
                    "spot-instances-request": "%%iftemplatematch%${Resources[]}%%",
                    "subnet": "%%iftemplatematch%${Resources[]}%%",
                    "traffic-mirror-filter": "%%iftemplatematch%${Resources[]}%%",
                    "traffic-mirror-session": "%%iftemplatematch%${Resources[]}%%",
                    "traffic-mirror-target": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway-attachment": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway-connect-peer": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway-multicast-domain": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway-route-table": "%%iftemplatematch%${Resources[]}%%",
                    "volume": "%%iftemplatematch%${Resources[]}%%",
                    "vpc": "%%iftemplatematch%${Resources[]}%%",
                    "vpc-endpoint": "%%iftemplatematch%${Resources[]}%%",
                    "vpc-endpoint-service": "%%iftemplatematch%${Resources[]}%%",
                    "vpc-flow-log": "%%iftemplatematch%${Resources[]}%%",
                    "vpc-peering-connection": "%%iftemplatematch%${Resources[]}%%",
                    "vpn-connection": "%%iftemplatematch%${Resources[]}%%",
                    "vpn-gateway": "%%iftemplatematch%${Resources[]}%%"
                }
            }
        ],
        "EC2.CreateTrafficMirrorFilter": [
            {
                "action": "ec2:CreateTrafficMirrorFilter",
                "resource_mappings": {
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateTrafficMirrorFilterRule": [
            {
                "action": "ec2:CreateTrafficMirrorFilterRule",
                "resource_mappings": {
                    "TrafficMirrorFilterId": {
                        "template": "${TrafficMirrorFilterId}"
                    },
                    "TrafficMirrorFilterRuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateTrafficMirrorSession": [
            {
                "action": "ec2:CreateTrafficMirrorSession",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "${TrafficMirrorFilterId}"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "${TrafficMirrorTargetId}"
                    }
                }
            }
        ],
        "EC2.CreateTrafficMirrorTarget": [
            {
                "action": "ec2:CreateTrafficMirrorTarget",
                "resource_mappings": {
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.CreateTransitGateway": [
            {
                "action": "ec2:CreateTransitGateway",
                "resource_mappings": {
                    "TransitGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateTransitGatewayConnect": [
            {
                "action": "ec2:CreateTransitGatewayConnect",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransportTransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.CreateTransitGatewayConnectPeer": [
            {
                "action": "ec2:CreateTransitGatewayConnectPeer",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.CreateTransitGatewayMulticastDomain": [
            {
                "action": "ec2:CreateTransitGatewayMulticastDomain",
                "resource_mappings": {
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateTransitGatewayPeeringAttachment": [
            {
                "action": "ec2:CreateTransitGatewayPeeringAttachment",
                "resource_mappings": {
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateTransitGatewayPrefixListReference": [
            {
                "action": "ec2:CreateTransitGatewayPrefixListReference",
                "resource_mappings": {
                    "PrefixListId": {
                        "template": "${PrefixListId}"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.CreateTransitGatewayRoute": [
            {
                "action": "ec2:CreateTransitGatewayRoute",
                "resource_mappings": {
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.CreateTransitGatewayRouteTable": [
            {
                "action": "ec2:CreateTransitGatewayRouteTable",
                "resource_mappings": {
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateTransitGatewayVpcAttachment": [
            {
                "action": "ec2:CreateTransitGatewayVpcAttachment",
                "resource_mappings": {
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    },
                    "SubnetId": {
                        "template": "${SubnetIds[]}"
                    }
                }
            }
        ],
        "EC2.CreateVolume": [
            {
                "action": "ec2:CreateVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EC2.CreateVpc": [
            {
                "action": "ec2:CreateVpc",
                "resource_mappings": {
                    "VpcId": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "${Ipv6Pool}"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "vpc": "%%iftruthy%${TagSpecifications[].ResourceType}%arn:${Partition}:ec2:${Region}:${Account}:vpc/*%%%"
                }
            }
        ],
        "EC2.CreateVpcEndpoint": [
            {
                "action": "ec2:CreateVpcEndpoint",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "${RouteTableIds[]}"
                    },
                    "SecurityGroupId": {
                        "template": "${SecurityGroupIds[]}"
                    },
                    "SubnetId": {
                        "template": "${SubnetIds[]}"
                    }
                }
            },
            {
                "action": "route53:AssociateVPCWithHostedZone",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "EC2.CreateVpcEndpointConnectionNotification": [
            {
                "action": "ec2:CreateVpcEndpointConnectionNotification",
                "resource_mappings": {
                    "VpcEndpointId": {
                        "template": "${VpcEndpointId}"
                    },
                    "VpcEndpointServiceId": {
                        "template": "${ServiceId}"
                    }
                }
            }
        ],
        "EC2.CreateVpcEndpointServiceConfiguration": [
            {
                "action": "ec2:CreateVpcEndpointServiceConfiguration",
                "resource_mappings": {
                    "VpcEndpointServiceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateVpcPeeringConnection": [
            {
                "action": "ec2:CreateVpcPeeringConnection",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateVpnConnection": [
            {
                "action": "ec2:CreateVpnConnection",
                "resource_mappings": {
                    "CustomerGatewayId": {
                        "template": "${CustomerGatewayId}"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    },
                    "VpnGatewayId": {
                        "template": "${VpnGatewayId}"
                    }
                }
            }
        ],
        "EC2.CreateVpnConnectionRoute": [
            {
                "action": "ec2:CreateVpnConnectionRoute",
                "resource_mappings": {
                    "VpnConnectionId": {
                        "template": "${VpnConnectionId}"
                    }
                }
            }
        ],
        "EC2.CreateVpnGateway": [
            {
                "action": "ec2:CreateVpnGateway",
                "resource_mappings": {
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.DeleteCarrierGateway": [
            {
                "action": "ec2:DeleteCarrierGateway",
                "resource_mappings": {
                    "CarrierGatewayId": {
                        "template": "${CarrierGatewayId}"
                    }
                }
            }
        ],
        "EC2.DeleteClientVpnEndpoint": [
            {
                "action": "ec2:DeleteClientVpnEndpoint",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    }
                }
            }
        ],
        "EC2.DeleteClientVpnRoute": [
            {
                "action": "ec2:DeleteClientVpnRoute",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    },
                    "SubnetId": {
                        "template": "${TargetVpcSubnetId}"
                    }
                }
            }
        ],
        "EC2.DeleteCustomerGateway": [
            {
                "action": "ec2:DeleteCustomerGateway",
                "resource_mappings": {
                    "CustomerGatewayId": {
                        "template": "${CustomerGatewayId}"
                    }
                }
            }
        ],
        "EC2.DeleteDhcpOptions": [
            {
                "action": "ec2:DeleteDhcpOptions",
                "resource_mappings": {
                    "DhcpOptionsId": {
                        "template": "${DhcpOptionsId}"
                    }
                }
            }
        ],
        "EC2.DeleteEgressOnlyInternetGateway": [
            {
                "action": "ec2:DeleteEgressOnlyInternetGateway",
                "resource_mappings": {
                    "EgressOnlyInternetGatewayId": {
                        "template": "${EgressOnlyInternetGatewayId}"
                    }
                }
            }
        ],
        "EC2.DeleteFleets": [
            {
                "action": "ec2:DeleteFleets",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetIds[]}"
                    }
                }
            }
        ],
        "EC2.DeleteFlowLogs": [
            {
                "action": "ec2:DeleteFlowLogs",
                "resource_mappings": {
                    "VpcFlowLogId": {
                        "template": "${FlowLogIds[]}"
                    }
                }
            }
        ],
        "EC2.DeleteFpgaImage": [
            {
                "action": "ec2:DeleteFpgaImage",
                "resource_mappings": {
                    "FpgaImageId": {
                        "template": "${FpgaImageId}"
                    }
                }
            }
        ],
        "EC2.DeleteInternetGateway": [
            {
                "action": "ec2:DeleteInternetGateway",
                "resource_mappings": {
                    "InternetGatewayId": {
                        "template": "${InternetGatewayId}"
                    }
                }
            }
        ],
        "EC2.DeleteKeyPair": [
            {
                "action": "ec2:DeleteKeyPair",
                "resource_mappings": {
                    "KeyPairName": {
                        "template": "${KeyName}"
                    }
                }
            }
        ],
        "EC2.DeleteLaunchTemplate": [
            {
                "action": "ec2:DeleteLaunchTemplate",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "${LaunchTemplateId}"
                    }
                }
            }
        ],
        "EC2.DeleteLaunchTemplateVersions": [
            {
                "action": "ec2:DeleteLaunchTemplateVersions",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "${LaunchTemplateId}"
                    }
                }
            }
        ],
        "EC2.DeleteLocalGatewayRoute": [
            {
                "action": "ec2:DeleteLocalGatewayRoute",
                "resource_mappings": {
                    "LocalGatewayRoutetableId": {
                        "template": "${LocalGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.DeleteLocalGatewayRouteTableVpcAssociation": [
            {
                "action": "ec2:DeleteLocalGatewayRouteTableVpcAssociation",
                "resource_mappings": {
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "${LocalGatewayRouteTableVpcAssociationId}"
                    }
                }
            }
        ],
        "EC2.DeleteManagedPrefixList": [
            {
                "action": "ec2:DeleteManagedPrefixList",
                "resource_mappings": {
                    "PrefixListId": {
                        "template": "${PrefixListId}"
                    }
                }
            }
        ],
        "EC2.DeleteNatGateway": [
            {
                "action": "ec2:DeleteNatGateway",
                "resource_mappings": {
                    "NatGatewayId": {
                        "template": "${NatGatewayId}"
                    }
                }
            }
        ],
        "EC2.DeleteNetworkAcl": [
            {
                "action": "ec2:DeleteNetworkAcl",
                "resource_mappings": {
                    "NaclId": {
                        "template": "${NetworkAclId}"
                    }
                }
            }
        ],
        "EC2.DeleteNetworkAclEntry": [
            {
                "action": "ec2:DeleteNetworkAclEntry",
                "resource_mappings": {
                    "NaclId": {
                        "template": "${NetworkAclId}"
                    }
                }
            }
        ],
        "EC2.DeleteNetworkInsightsAnalysis": [
            {
                "action": "ec2:DeleteNetworkInsightsAnalysis",
                "resource_mappings": {
                    "NetworkInsightsAnalysisId": {
                        "template": "${NetworkInsightsAnalysisId}"
                    }
                }
            }
        ],
        "EC2.DeleteNetworkInsightsPath": [
            {
                "action": "ec2:DeleteNetworkInsightsPath",
                "resource_mappings": {
                    "NetworkInsightsPathId": {
                        "template": "${NetworkInsightsPathId}"
                    }
                }
            }
        ],
        "EC2.DeleteNetworkInterface": [
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.DeleteNetworkInterfacePermission": [
            {
                "action": "ec2:DeleteNetworkInterfacePermission",
                "resource_mappings": {}
            }
        ],
        "EC2.DeletePlacementGroup": [
            {
                "action": "ec2:DeletePlacementGroup",
                "resource_mappings": {}
            }
        ],
        "EC2.DeleteQueuedReservedInstances": [
            {
                "action": "ec2:DeleteQueuedReservedInstances",
                "resource_mappings": {
                    "ReservationId": {
                        "template": "${ReservedInstancesIds[]}"
                    }
                }
            }
        ],
        "EC2.DeleteRoute": [
            {
                "action": "ec2:DeleteRoute",
                "resource_mappings": {
                    "RouteTableId": {
                        "template": "${RouteTableId}"
                    },
                    "PrefixListId": {
                        "template": "${DestinationPrefixListId}"
                    }
                }
            }
        ],
        "EC2.DeleteRouteTable": [
            {
                "action": "ec2:DeleteRouteTable",
                "resource_mappings": {
                    "RouteTableId": {
                        "template": "${RouteTableId}"
                    }
                }
            }
        ],
        "EC2.DeleteSecurityGroup": [
            {
                "action": "ec2:DeleteSecurityGroup",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "EC2.DeleteSnapshot": [
            {
                "action": "ec2:DeleteSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EC2.DeleteSpotDatafeedSubscription": [
            {
                "action": "ec2:DeleteSpotDatafeedSubscription",
                "resource_mappings": {}
            }
        ],
        "EC2.DeleteSubnet": [
            {
                "action": "ec2:DeleteSubnet",
                "resource_mappings": {
                    "SubnetId": {
                        "template": "${SubnetId}"
                    }
                }
            }
        ],
        "EC2.DeleteTags": [
            {
                "action": "ec2:DeleteTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "capacity-reservation": "%%iftemplatematch%${Resources[]}%%",
                    "client-vpn-endpoint": "%%iftemplatematch%${Resources[]}%%",
                    "customer-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "dedicated-host": "%%iftemplatematch%${Resources[]}%%",
                    "dhcp-options": "%%iftemplatematch%${Resources[]}%%",
                    "egress-only-internet-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "elastic-gpu": "%%iftemplatematch%${Resources[]}%%",
                    "elastic-ip": "%%iftemplatematch%${Resources[]}%%",
                    "export-image-task": "%%iftemplatematch%${Resources[]}%%",
                    "export-instance-task": "%%iftemplatematch%${Resources[]}%%",
                    "fleet": "%%iftemplatematch%${Resources[]}%%",
                    "fpga-image": "%%iftemplatematch%${Resources[]}%%",
                    "host-reservation": "%%iftemplatematch%${Resources[]}%%",
                    "image": "%%iftemplatematch%${Resources[]}%%",
                    "import-image-task": "%%iftemplatematch%${Resources[]}%%",
                    "import-snapshot-task": "%%iftemplatematch%${Resources[]}%%",
                    "instance": "%%iftemplatematch%${Resources[]}%%",
                    "internet-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "ipv4pool-ec2": "%%iftemplatematch%${Resources[]}%%",
                    "ipv6pool-ec2": "%%iftemplatematch%${Resources[]}%%",
                    "key-pair": "%%iftemplatematch%${Resources[]}%%",
                    "launch-template": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-route-table": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-route-table-virtual-interface-group-association": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-route-table-vpc-association": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-virtual-interface": "%%iftemplatematch%${Resources[]}%%",
                    "local-gateway-virtual-interface-group": "%%iftemplatematch%${Resources[]}%%",
                    "natgateway": "%%iftemplatematch%${Resources[]}%%",
                    "network-acl": "%%iftemplatematch%${Resources[]}%%",
                    "network-interface": "%%iftemplatematch%${Resources[]}%%",
                    "placement-group": "%%iftemplatematch%${Resources[]}%%",
                    "prefix-list": "%%iftemplatematch%${Resources[]}%%",
                    "reserved-instances": "%%iftemplatematch%${Resources[]}%%",
                    "route-table": "%%iftemplatematch%${Resources[]}%%",
                    "security-group": "%%iftemplatematch%${Resources[]}%%",
                    "snapshot": "%%iftemplatematch%${Resources[]}%%",
                    "spot-fleet-request": "%%iftemplatematch%${Resources[]}%%",
                    "spot-instances-request": "%%iftemplatematch%${Resources[]}%%",
                    "subnet": "%%iftemplatematch%${Resources[]}%%",
                    "traffic-mirror-filter": "%%iftemplatematch%${Resources[]}%%",
                    "traffic-mirror-session": "%%iftemplatematch%${Resources[]}%%",
                    "traffic-mirror-target": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway-attachment": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway-connect-peer": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway-multicast-domain": "%%iftemplatematch%${Resources[]}%%",
                    "transit-gateway-route-table": "%%iftemplatematch%${Resources[]}%%",
                    "volume": "%%iftemplatematch%${Resources[]}%%",
                    "vpc": "%%iftemplatematch%${Resources[]}%%",
                    "vpc-endpoint": "%%iftemplatematch%${Resources[]}%%",
                    "vpc-endpoint-service": "%%iftemplatematch%${Resources[]}%%",
                    "vpc-flow-log": "%%iftemplatematch%${Resources[]}%%",
                    "vpc-peering-connection": "%%iftemplatematch%${Resources[]}%%",
                    "vpn-connection": "%%iftemplatematch%${Resources[]}%%",
                    "vpn-gateway": "%%iftemplatematch%${Resources[]}%%"
                }
            }
        ],
        "EC2.DeleteTrafficMirrorFilter": [
            {
                "action": "ec2:DeleteTrafficMirrorFilter",
                "resource_mappings": {
                    "TrafficMirrorFilterId": {
                        "template": "${TrafficMirrorFilterId}"
                    }
                }
            }
        ],
        "EC2.DeleteTrafficMirrorFilterRule": [
            {
                "action": "ec2:DeleteTrafficMirrorFilterRule",
                "resource_mappings": {
                    "TrafficMirrorFilterRuleId": {
                        "template": "${TrafficMirrorFilterRuleId}"
                    }
                }
            }
        ],
        "EC2.DeleteTrafficMirrorSession": [
            {
                "action": "ec2:DeleteTrafficMirrorSession",
                "resource_mappings": {
                    "TrafficMirrorSessionId": {
                        "template": "${TrafficMirrorSessionId}"
                    }
                }
            }
        ],
        "EC2.DeleteTrafficMirrorTarget": [
            {
                "action": "ec2:DeleteTrafficMirrorTarget",
                "resource_mappings": {
                    "TrafficMirrorTargetId": {
                        "template": "${TrafficMirrorTargetId}"
                    }
                }
            }
        ],
        "EC2.DeleteTransitGateway": [
            {
                "action": "ec2:DeleteTransitGateway",
                "resource_mappings": {
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    }
                }
            }
        ],
        "EC2.DeleteTransitGatewayConnect": [
            {
                "action": "ec2:DeleteTransitGatewayConnect",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.DeleteTransitGatewayConnectPeer": [
            {
                "action": "ec2:DeleteTransitGatewayConnectPeer",
                "resource_mappings": {
                    "TransitGatewayConnectPeerId": {
                        "template": "${TransitGatewayConnectPeerId}"
                    }
                }
            }
        ],
        "EC2.DeleteTransitGatewayMulticastDomain": [
            {
                "action": "ec2:DeleteTransitGatewayMulticastDomain",
                "resource_mappings": {
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.DeleteTransitGatewayPeeringAttachment": [
            {
                "action": "ec2:DeleteTransitGatewayPeeringAttachment",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.DeleteTransitGatewayPrefixListReference": [
            {
                "action": "ec2:DeleteTransitGatewayPrefixListReference",
                "resource_mappings": {
                    "PrefixListId": {
                        "template": "${PrefixListId}"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.DeleteTransitGatewayRoute": [
            {
                "action": "ec2:DeleteTransitGatewayRoute",
                "resource_mappings": {
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.DeleteTransitGatewayRouteTable": [
            {
                "action": "ec2:DeleteTransitGatewayRouteTable",
                "resource_mappings": {
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.DeleteTransitGatewayVpcAttachment": [
            {
                "action": "ec2:DeleteTransitGatewayVpcAttachment",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.DeleteVolume": [
            {
                "action": "ec2:DeleteVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "${VolumeId}"
                    }
                }
            }
        ],
        "EC2.DeleteVpc": [
            {
                "action": "ec2:DeleteVpc",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.DeleteVpcEndpointConnectionNotifications": [
            {
                "action": "ec2:DeleteVpcEndpointConnectionNotifications",
                "resource_mappings": {
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.DeleteVpcEndpointServiceConfigurations": [
            {
                "action": "ec2:DeleteVpcEndpointServiceConfigurations",
                "resource_mappings": {
                    "VpcEndpointServiceId": {
                        "template": "${ServiceIds[]}"
                    }
                }
            }
        ],
        "EC2.DeleteVpcEndpoints": [
            {
                "action": "ec2:DeleteVpcEndpoints",
                "resource_mappings": {
                    "VpcEndpointId": {
                        "template": "${VpcEndpointIds[]}"
                    }
                }
            }
        ],
        "EC2.DeleteVpcPeeringConnection": [
            {
                "action": "ec2:DeleteVpcPeeringConnection",
                "resource_mappings": {
                    "VpcPeeringConnectionId": {
                        "template": "${VpcPeeringConnectionId}"
                    }
                }
            }
        ],
        "EC2.DeleteVpnConnection": [
            {
                "action": "ec2:DeleteVpnConnection",
                "resource_mappings": {
                    "VpnConnectionId": {
                        "template": "${VpnConnectionId}"
                    }
                }
            }
        ],
        "EC2.DeleteVpnConnectionRoute": [
            {
                "action": "ec2:DeleteVpnConnectionRoute",
                "resource_mappings": {
                    "VpnConnectionId": {
                        "template": "${VpnConnectionId}"
                    }
                }
            }
        ],
        "EC2.DeleteVpnGateway": [
            {
                "action": "ec2:DeleteVpnGateway",
                "resource_mappings": {
                    "VpnGatewayId": {
                        "template": "${VpnGatewayId}"
                    }
                }
            }
        ],
        "EC2.DeprovisionByoipCidr": [
            {
                "action": "ec2:DeprovisionByoipCidr",
                "resource_mappings": {}
            }
        ],
        "EC2.DeregisterImage": [
            {
                "action": "ec2:DeregisterImage",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "EC2.DeregisterInstanceEventNotificationAttributes": [
            {
                "action": "ec2:DeregisterInstanceEventNotificationAttributes",
                "resource_mappings": {}
            }
        ],
        "EC2.DeregisterTransitGatewayMulticastGroupMembers": [
            {
                "action": "ec2:DeregisterTransitGatewayMulticastGroupMembers",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceIds[]}"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.DeregisterTransitGatewayMulticastGroupSources": [
            {
                "action": "ec2:DeregisterTransitGatewayMulticastGroupSources",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceIds[]}"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.DescribeAccountAttributes": [
            {
                "action": "ec2:DescribeAccountAttributes",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeAddresses": [
            {
                "action": "ec2:DescribeAddresses",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeAggregateIdFormat": [
            {
                "action": "ec2:DescribeAggregateIdFormat",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeAvailabilityZones": [
            {
                "action": "ec2:DescribeAvailabilityZones",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeBundleTasks": [
            {
                "action": "ec2:DescribeBundleTasks",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeByoipCidrs": [
            {
                "action": "ec2:DescribeByoipCidrs",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeCapacityReservations": [
            {
                "action": "ec2:DescribeCapacityReservations",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeCarrierGateways": [
            {
                "action": "ec2:DescribeCarrierGateways",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeClassicLinkInstances": [
            {
                "action": "ec2:DescribeClassicLinkInstances",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeClientVpnAuthorizationRules": [
            {
                "action": "ec2:DescribeClientVpnAuthorizationRules",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeClientVpnConnections": [
            {
                "action": "ec2:DescribeClientVpnConnections",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeClientVpnEndpoints": [
            {
                "action": "ec2:DescribeClientVpnEndpoints",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeClientVpnRoutes": [
            {
                "action": "ec2:DescribeClientVpnRoutes",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeClientVpnTargetNetworks": [
            {
                "action": "ec2:DescribeClientVpnTargetNetworks",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeCoipPools": [
            {
                "action": "ec2:DescribeCoipPools",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeConversionTasks": [
            {
                "action": "ec2:DescribeConversionTasks",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeCustomerGateways": [
            {
                "action": "ec2:DescribeCustomerGateways",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeDhcpOptions": [
            {
                "action": "ec2:DescribeDhcpOptions",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeEgressOnlyInternetGateways": [
            {
                "action": "ec2:DescribeEgressOnlyInternetGateways",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeElasticGpus": [
            {
                "action": "ec2:DescribeElasticGpus",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeExportImageTasks": [
            {
                "action": "ec2:DescribeExportImageTasks",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeExportTasks": [
            {
                "action": "ec2:DescribeExportTasks",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeFastSnapshotRestores": [
            {
                "action": "ec2:DescribeFastSnapshotRestores",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeFleetHistory": [
            {
                "action": "ec2:DescribeFleetHistory",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeFleetInstances": [
            {
                "action": "ec2:DescribeFleetInstances",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeFleets": [
            {
                "action": "ec2:DescribeFleets",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeFlowLogs": [
            {
                "action": "ec2:DescribeFlowLogs",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeFpgaImageAttribute": [
            {
                "action": "ec2:DescribeFpgaImageAttribute",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeFpgaImages": [
            {
                "action": "ec2:DescribeFpgaImages",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeHostReservationOfferings": [
            {
                "action": "ec2:DescribeHostReservationOfferings",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeHostReservations": [
            {
                "action": "ec2:DescribeHostReservations",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeHosts": [
            {
                "action": "ec2:DescribeHosts",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeIamInstanceProfileAssociations": [
            {
                "action": "ec2:DescribeIamInstanceProfileAssociations",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeIdFormat": [
            {
                "action": "ec2:DescribeIdFormat",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeIdentityIdFormat": [
            {
                "action": "ec2:DescribeIdentityIdFormat",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeImageAttribute": [
            {
                "action": "ec2:DescribeImageAttribute",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeImages": [
            {
                "action": "ec2:DescribeImages",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeImportImageTasks": [
            {
                "action": "ec2:DescribeImportImageTasks",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeImportSnapshotTasks": [
            {
                "action": "ec2:DescribeImportSnapshotTasks",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeInstanceAttribute": [
            {
                "action": "ec2:DescribeInstanceAttribute",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeInstanceCreditSpecifications": [
            {
                "action": "ec2:DescribeInstanceCreditSpecifications",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeInstanceEventNotificationAttributes": [
            {
                "action": "ec2:DescribeInstanceEventNotificationAttributes",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeInstanceStatus": [
            {
                "action": "ec2:DescribeInstanceStatus",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeInstanceTypeOfferings": [
            {
                "action": "ec2:DescribeInstanceTypeOfferings",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeInstanceTypes": [
            {
                "action": "ec2:DescribeInstanceTypes",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeInstances": [
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeInternetGateways": [
            {
                "action": "ec2:DescribeInternetGateways",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeIpv6Pools": [
            {
                "action": "ec2:DescribeIpv6Pools",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeKeyPairs": [
            {
                "action": "ec2:DescribeKeyPairs",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeLaunchTemplateVersions": [
            {
                "action": "ec2:DescribeLaunchTemplateVersions",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeLaunchTemplates": [
            {
                "action": "ec2:DescribeLaunchTemplates",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations": [
            {
                "action": "ec2:DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeLocalGatewayRouteTableVpcAssociations": [
            {
                "action": "ec2:DescribeLocalGatewayRouteTableVpcAssociations",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeLocalGatewayRouteTables": [
            {
                "action": "ec2:DescribeLocalGatewayRouteTables",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeLocalGatewayVirtualInterfaceGroups": [
            {
                "action": "ec2:DescribeLocalGatewayVirtualInterfaceGroups",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeLocalGatewayVirtualInterfaces": [
            {
                "action": "ec2:DescribeLocalGatewayVirtualInterfaces",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeLocalGateways": [
            {
                "action": "ec2:DescribeLocalGateways",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeManagedPrefixLists": [
            {
                "action": "ec2:DescribeManagedPrefixLists",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeMovingAddresses": [
            {
                "action": "ec2:DescribeMovingAddresses",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeNatGateways": [
            {
                "action": "ec2:DescribeNatGateways",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeNetworkAcls": [
            {
                "action": "ec2:DescribeNetworkAcls",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeNetworkInsightsAnalyses": [
            {
                "action": "ec2:DescribeNetworkInsightsAnalyses",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeNetworkInsightsPaths": [
            {
                "action": "ec2:DescribeNetworkInsightsPaths",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeNetworkInterfaceAttribute": [
            {
                "action": "ec2:DescribeNetworkInterfaceAttribute",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeNetworkInterfacePermissions": [
            {
                "action": "ec2:DescribeNetworkInterfacePermissions",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeNetworkInterfaces": [
            {
                "action": "ec2:DescribeNetworkInterfaces",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribePlacementGroups": [
            {
                "action": "ec2:DescribePlacementGroups",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribePrefixLists": [
            {
                "action": "ec2:DescribePrefixLists",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribePrincipalIdFormat": [
            {
                "action": "ec2:DescribePrincipalIdFormat",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribePublicIpv4Pools": [
            {
                "action": "ec2:DescribePublicIpv4Pools",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeRegions": [
            {
                "action": "ec2:DescribeRegions",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeReservedInstances": [
            {
                "action": "ec2:DescribeReservedInstances",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeReservedInstancesListings": [
            {
                "action": "ec2:DescribeReservedInstancesListings",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeReservedInstancesModifications": [
            {
                "action": "ec2:DescribeReservedInstancesModifications",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeReservedInstancesOfferings": [
            {
                "action": "ec2:DescribeReservedInstancesOfferings",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeRouteTables": [
            {
                "action": "ec2:DescribeRouteTables",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeScheduledInstanceAvailability": [
            {
                "action": "ec2:DescribeScheduledInstanceAvailability",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeScheduledInstances": [
            {
                "action": "ec2:DescribeScheduledInstances",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSecurityGroupReferences": [
            {
                "action": "ec2:DescribeSecurityGroupReferences",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSecurityGroups": [
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSnapshotAttribute": [
            {
                "action": "ec2:DescribeSnapshotAttribute",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSnapshots": [
            {
                "action": "ec2:DescribeSnapshots",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSpotDatafeedSubscription": [
            {
                "action": "ec2:DescribeSpotDatafeedSubscription",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSpotFleetInstances": [
            {
                "action": "ec2:DescribeSpotFleetInstances",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSpotFleetRequestHistory": [
            {
                "action": "ec2:DescribeSpotFleetRequestHistory",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSpotFleetRequests": [
            {
                "action": "ec2:DescribeSpotFleetRequests",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSpotInstanceRequests": [
            {
                "action": "ec2:DescribeSpotInstanceRequests",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSpotPriceHistory": [
            {
                "action": "ec2:DescribeSpotPriceHistory",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeStaleSecurityGroups": [
            {
                "action": "ec2:DescribeStaleSecurityGroups",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSubnets": [
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTags": [
            {
                "action": "ec2:DescribeTags",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTrafficMirrorFilters": [
            {
                "action": "ec2:DescribeTrafficMirrorFilters",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTrafficMirrorSessions": [
            {
                "action": "ec2:DescribeTrafficMirrorSessions",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTrafficMirrorTargets": [
            {
                "action": "ec2:DescribeTrafficMirrorTargets",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTransitGatewayAttachments": [
            {
                "action": "ec2:DescribeTransitGatewayAttachments",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTransitGatewayConnectPeers": [
            {
                "action": "ec2:DescribeTransitGatewayConnectPeers",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTransitGatewayConnects": [
            {
                "action": "ec2:DescribeTransitGatewayConnects",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTransitGatewayMulticastDomains": [
            {
                "action": "ec2:DescribeTransitGatewayMulticastDomains",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTransitGatewayPeeringAttachments": [
            {
                "action": "ec2:DescribeTransitGatewayPeeringAttachments",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTransitGatewayRouteTables": [
            {
                "action": "ec2:DescribeTransitGatewayRouteTables",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTransitGatewayVpcAttachments": [
            {
                "action": "ec2:DescribeTransitGatewayVpcAttachments",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTransitGateways": [
            {
                "action": "ec2:DescribeTransitGateways",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVolumeAttribute": [
            {
                "action": "ec2:DescribeVolumeAttribute",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVolumeStatus": [
            {
                "action": "ec2:DescribeVolumeStatus",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVolumes": [
            {
                "action": "ec2:DescribeVolumes",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVolumesModifications": [
            {
                "action": "ec2:DescribeVolumesModifications",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcAttribute": [
            {
                "action": "ec2:DescribeVpcAttribute",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcClassicLink": [
            {
                "action": "ec2:DescribeVpcClassicLink",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcClassicLinkDnsSupport": [
            {
                "action": "ec2:DescribeVpcClassicLinkDnsSupport",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcEndpointConnectionNotifications": [
            {
                "action": "ec2:DescribeVpcEndpointConnectionNotifications",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcEndpointConnections": [
            {
                "action": "ec2:DescribeVpcEndpointConnections",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcEndpointServiceConfigurations": [
            {
                "action": "ec2:DescribeVpcEndpointServiceConfigurations",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcEndpointServicePermissions": [
            {
                "action": "ec2:DescribeVpcEndpointServicePermissions",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcEndpointServices": [
            {
                "action": "ec2:DescribeVpcEndpointServices",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcEndpoints": [
            {
                "action": "ec2:DescribeVpcEndpoints",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcPeeringConnections": [
            {
                "action": "ec2:DescribeVpcPeeringConnections",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpcs": [
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpnConnections": [
            {
                "action": "ec2:DescribeVpnConnections",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeVpnGateways": [
            {
                "action": "ec2:DescribeVpnGateways",
                "resource_mappings": {}
            }
        ],
        "EC2.DetachClassicLinkVpc": [
            {
                "action": "ec2:DetachClassicLinkVpc",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.DetachInternetGateway": [
            {
                "action": "ec2:DetachInternetGateway",
                "resource_mappings": {
                    "InternetGatewayId": {
                        "template": "${InternetGatewayId}"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.DetachNetworkInterface": [
            {
                "action": "ec2:DetachNetworkInterface",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.DetachVolume": [
            {
                "action": "ec2:DetachVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "${VolumeId}"
                    },
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.DetachVpnGateway": [
            {
                "action": "ec2:DetachVpnGateway",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    },
                    "VpnGatewayId": {
                        "template": "${VpnGatewayId}"
                    }
                }
            }
        ],
        "EC2.DisableEbsEncryptionByDefault": [
            {
                "action": "ec2:DisableEbsEncryptionByDefault",
                "resource_mappings": {}
            }
        ],
        "EC2.DisableFastSnapshotRestores": [
            {
                "action": "ec2:DisableFastSnapshotRestores",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SourceSnapshotIds[]}"
                    }
                }
            }
        ],
        "EC2.DisableTransitGatewayRouteTablePropagation": [
            {
                "action": "ec2:DisableTransitGatewayRouteTablePropagation",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.DisableVgwRoutePropagation": [
            {
                "action": "ec2:DisableVgwRoutePropagation",
                "resource_mappings": {
                    "RouteTableId": {
                        "template": "${RouteTableId}"
                    },
                    "VpnGatewayId": {
                        "template": "${GatewayId}"
                    }
                }
            }
        ],
        "EC2.DisableVpcClassicLink": [
            {
                "action": "ec2:DisableVpcClassicLink",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.DisableVpcClassicLinkDnsSupport": [
            {
                "action": "ec2:DisableVpcClassicLinkDnsSupport",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.DisassociateAddress": [
            {
                "action": "ec2:DisassociateAddress",
                "resource_mappings": {
                    "AllocationId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.DisassociateClientVpnTargetNetwork": [
            {
                "action": "ec2:DisassociateClientVpnTargetNetwork",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    }
                }
            }
        ],
        "EC2.DisassociateEnclaveCertificateIamRole": [
            {
                "action": "ec2:DisassociateEnclaveCertificateIamRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}",
                    "role": "${RoleArn}"
                }
            }
        ],
        "EC2.DisassociateIamInstanceProfile": [
            {
                "action": "ec2:DisassociateIamInstanceProfile",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.DisassociateRouteTable": [
            {
                "action": "ec2:DisassociateRouteTable",
                "resource_mappings": {
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.DisassociateSubnetCidrBlock": [
            {
                "action": "ec2:DisassociateSubnetCidrBlock",
                "resource_mappings": {
                    "SubnetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.DisassociateTransitGatewayMulticastDomain": [
            {
                "action": "ec2:DisassociateTransitGatewayMulticastDomain",
                "resource_mappings": {
                    "SubnetId": {
                        "template": "${SubnetIds[]}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.DisassociateTransitGatewayRouteTable": [
            {
                "action": "ec2:DisassociateTransitGatewayRouteTable",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.DisassociateVpcCidrBlock": [
            {
                "action": "ec2:DisassociateVpcCidrBlock",
                "resource_mappings": {}
            }
        ],
        "EC2.EnableEbsEncryptionByDefault": [
            {
                "action": "ec2:EnableEbsEncryptionByDefault",
                "resource_mappings": {}
            }
        ],
        "EC2.EnableFastSnapshotRestores": [
            {
                "action": "ec2:EnableFastSnapshotRestores",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SourceSnapshotIds[]}"
                    }
                }
            }
        ],
        "EC2.EnableTransitGatewayRouteTablePropagation": [
            {
                "action": "ec2:EnableTransitGatewayRouteTablePropagation",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.EnableVgwRoutePropagation": [
            {
                "action": "ec2:EnableVgwRoutePropagation",
                "resource_mappings": {
                    "RouteTableId": {
                        "template": "${RouteTableId}"
                    },
                    "VpnGatewayId": {
                        "template": "${GatewayId}"
                    }
                }
            }
        ],
        "EC2.EnableVolumeIO": [
            {
                "action": "ec2:EnableVolumeIO",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "${VolumeId}"
                    }
                }
            }
        ],
        "EC2.EnableVpcClassicLink": [
            {
                "action": "ec2:EnableVpcClassicLink",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.EnableVpcClassicLinkDnsSupport": [
            {
                "action": "ec2:EnableVpcClassicLinkDnsSupport",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.ExportClientVpnClientCertificateRevocationList": [
            {
                "action": "ec2:ExportClientVpnClientCertificateRevocationList",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    }
                }
            }
        ],
        "EC2.ExportClientVpnClientConfiguration": [
            {
                "action": "ec2:ExportClientVpnClientConfiguration",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    }
                }
            }
        ],
        "EC2.ExportImage": [
            {
                "action": "ec2:ExportImage",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "EC2.ExportTransitGatewayRoutes": [
            {
                "action": "ec2:ExportTransitGatewayRoutes",
                "resource_mappings": {
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.GetAssociatedEnclaveCertificateIamRoles": [
            {
                "action": "ec2:GetAssociatedEnclaveCertificateIamRoles",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate": "${CertificateArn}"
                }
            }
        ],
        "EC2.GetAssociatedIpv6PoolCidrs": [
            {
                "action": "ec2:GetAssociatedIpv6PoolCidrs",
                "resource_mappings": {
                    "Ipv6PoolEc2Id": {
                        "template": "${PoolId}"
                    }
                }
            }
        ],
        "EC2.GetCapacityReservationUsage": [
            {
                "action": "ec2:GetCapacityReservationUsage",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "${CapacityReservationId}"
                    }
                }
            }
        ],
        "EC2.GetCoipPoolUsage": [
            {
                "action": "ec2:GetCoipPoolUsage",
                "resource_mappings": {}
            }
        ],
        "EC2.GetConsoleOutput": [
            {
                "action": "ec2:GetConsoleOutput",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.GetConsoleScreenshot": [
            {
                "action": "ec2:GetConsoleScreenshot",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.GetDefaultCreditSpecification": [
            {
                "action": "ec2:GetDefaultCreditSpecification",
                "resource_mappings": {}
            }
        ],
        "EC2.GetEbsDefaultKmsKeyId": [
            {
                "action": "ec2:GetEbsDefaultKmsKeyId",
                "resource_mappings": {}
            }
        ],
        "EC2.GetEbsEncryptionByDefault": [
            {
                "action": "ec2:GetEbsEncryptionByDefault",
                "resource_mappings": {}
            }
        ],
        "EC2.GetGroupsForCapacityReservation": [
            {
                "action": "ec2:GetGroupsForCapacityReservation",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "${CapacityReservationId}"
                    }
                }
            }
        ],
        "EC2.GetHostReservationPurchasePreview": [
            {
                "action": "ec2:GetHostReservationPurchasePreview",
                "resource_mappings": {
                    "DedicatedHostId": {
                        "template": "${HostIdSet[]}"
                    }
                }
            }
        ],
        "EC2.GetLaunchTemplateData": [
            {
                "action": "ec2:GetLaunchTemplateData",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.GetManagedPrefixListAssociations": [
            {
                "action": "ec2:GetManagedPrefixListAssociations",
                "resource_mappings": {
                    "PrefixListId": {
                        "template": "${PrefixListId}"
                    }
                }
            }
        ],
        "EC2.GetManagedPrefixListEntries": [
            {
                "action": "ec2:GetManagedPrefixListEntries",
                "resource_mappings": {
                    "PrefixListId": {
                        "template": "${PrefixListId}"
                    }
                }
            }
        ],
        "EC2.GetPasswordData": [
            {
                "action": "ec2:GetPasswordData",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.GetReservedInstancesExchangeQuote": [
            {
                "action": "ec2:GetReservedInstancesExchangeQuote",
                "resource_mappings": {
                    "ReservationId": {
                        "template": "${ReservedInstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.GetTransitGatewayAttachmentPropagations": [
            {
                "action": "ec2:GetTransitGatewayAttachmentPropagations",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.GetTransitGatewayMulticastDomainAssociations": [
            {
                "action": "ec2:GetTransitGatewayMulticastDomainAssociations",
                "resource_mappings": {
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.GetTransitGatewayPrefixListReferences": [
            {
                "action": "ec2:GetTransitGatewayPrefixListReferences",
                "resource_mappings": {
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.GetTransitGatewayRouteTableAssociations": [
            {
                "action": "ec2:GetTransitGatewayRouteTableAssociations",
                "resource_mappings": {
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.GetTransitGatewayRouteTablePropagations": [
            {
                "action": "ec2:GetTransitGatewayRouteTablePropagations",
                "resource_mappings": {
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.ImportClientVpnClientCertificateRevocationList": [
            {
                "action": "ec2:ImportClientVpnClientCertificateRevocationList",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    }
                }
            }
        ],
        "EC2.ImportImage": [
            {
                "action": "ec2:ImportImage",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${DiskContainers[].SnapshotId}"
                    }
                }
            }
        ],
        "EC2.ImportInstance": [
            {
                "action": "ec2:ImportInstance",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "${LaunchSpecification.GroupIds[]}"
                    },
                    "SubnetId": {
                        "template": "${LaunchSpecification.SubnetId}"
                    }
                }
            }
        ],
        "EC2.ImportKeyPair": [
            {
                "action": "ec2:ImportKeyPair",
                "resource_mappings": {
                    "KeyPairName": {
                        "template": "${KeyName}"
                    }
                }
            }
        ],
        "EC2.ImportSnapshot": [
            {
                "action": "ec2:ImportSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.ImportVolume": [
            {
                "action": "ec2:ImportVolume",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifyAvailabilityZoneGroup": [
            {
                "action": "ec2:ModifyAvailabilityZoneGroup",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifyCapacityReservation": [
            {
                "action": "ec2:ModifyCapacityReservation",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "${CapacityReservationId}"
                    }
                }
            }
        ],
        "EC2.ModifyClientVpnEndpoint": [
            {
                "action": "ec2:ModifyClientVpnEndpoint",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    },
                    "SecurityGroupId": {
                        "template": "${SecurityGroupIds[]}"
                    },
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.ModifyDefaultCreditSpecification": [
            {
                "action": "ec2:ModifyDefaultCreditSpecification",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifyEbsDefaultKmsKeyId": [
            {
                "action": "ec2:ModifyEbsDefaultKmsKeyId",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifyFleet": [
            {
                "action": "ec2:ModifyFleet",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplateConfigs[].LaunchTemplateSpecification.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplateConfigs[].LaunchTemplateSpecification.LaunchTemplateName}%*%%%"
                }
            }
        ],
        "EC2.ModifyFpgaImageAttribute": [
            {
                "action": "ec2:ModifyFpgaImageAttribute",
                "resource_mappings": {
                    "FpgaImageId": {
                        "template": "${FpgaImageId}"
                    }
                }
            }
        ],
        "EC2.ModifyHosts": [
            {
                "action": "ec2:ModifyHosts",
                "resource_mappings": {
                    "DedicatedHostId": {
                        "template": "${HostIds[]}"
                    }
                }
            }
        ],
        "EC2.ModifyIdFormat": [
            {
                "action": "ec2:ModifyIdFormat",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifyIdentityIdFormat": [
            {
                "action": "ec2:ModifyIdentityIdFormat",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifyImageAttribute": [
            {
                "action": "ec2:ModifyImageAttribute",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "EC2.ModifyInstanceAttribute": [
            {
                "action": "ec2:ModifyInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "SecurityGroupId": {
                        "template": "${Groups[]}"
                    },
                    "VolumeId": {
                        "template": "${BlockDeviceMappings[].Ebs.VolumeId}"
                    }
                }
            }
        ],
        "EC2.ModifyInstanceCapacityReservationAttributes": [
            {
                "action": "ec2:ModifyInstanceCapacityReservationAttributes",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "CapacityReservationId": {
                        "template": "${CapacityReservationSpecification.CapacityReservationTarget.CapacityReservationId}"
                    }
                }
            }
        ],
        "EC2.ModifyInstanceCreditSpecification": [
            {
                "action": "ec2:ModifyInstanceCreditSpecification",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceCreditSpecifications[].InstanceId}"
                    }
                }
            }
        ],
        "EC2.ModifyInstanceEventStartTime": [
            {
                "action": "ec2:ModifyInstanceEventStartTime",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.ModifyInstanceMetadataOptions": [
            {
                "action": "ec2:ModifyInstanceMetadataOptions",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.ModifyInstancePlacement": [
            {
                "action": "ec2:ModifyInstancePlacement",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "DedicatedHostId": {
                        "template": "${HostId}"
                    },
                    "PlacementGroupName": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "EC2.ModifyLaunchTemplate": [
            {
                "action": "ec2:ModifyLaunchTemplate",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "${LaunchTemplateId}"
                    }
                }
            }
        ],
        "EC2.ModifyManagedPrefixList": [
            {
                "action": "ec2:ModifyManagedPrefixList",
                "resource_mappings": {
                    "PrefixListId": {
                        "template": "${PrefixListId}"
                    }
                }
            }
        ],
        "EC2.ModifyNetworkInterfaceAttribute": [
            {
                "action": "ec2:ModifyNetworkInterfaceAttribute",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "${Groups[]}"
                    }
                }
            }
        ],
        "EC2.ModifyReservedInstances": [
            {
                "action": "ec2:ModifyReservedInstances",
                "resource_mappings": {
                    "ReservationId": {
                        "template": "${ReservedInstancesIds[]}"
                    }
                }
            }
        ],
        "EC2.ModifySnapshotAttribute": [
            {
                "action": "ec2:ModifySnapshotAttribute",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EC2.ModifySpotFleetRequest": [
            {
                "action": "ec2:ModifySpotFleetRequest",
                "resource_mappings": {
                    "SpotFleetRequestId": {
                        "template": "${SpotFleetRequestId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplateConfigs[].LaunchTemplateSpecification.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplateConfigs[].LaunchTemplateSpecification.LaunchTemplateName}%*%%%"
                }
            }
        ],
        "EC2.ModifySubnetAttribute": [
            {
                "action": "ec2:ModifySubnetAttribute",
                "resource_mappings": {
                    "SubnetId": {
                        "template": "${SubnetId}"
                    }
                }
            }
        ],
        "EC2.ModifyTrafficMirrorFilterNetworkServices": [
            {
                "action": "ec2:ModifyTrafficMirrorFilterNetworkServices",
                "resource_mappings": {
                    "TrafficMirrorFilterId": {
                        "template": "${TrafficMirrorFilterId}"
                    }
                }
            }
        ],
        "EC2.ModifyTrafficMirrorFilterRule": [
            {
                "action": "ec2:ModifyTrafficMirrorFilterRule",
                "resource_mappings": {
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterRuleId": {
                        "template": "${TrafficMirrorFilterRuleId}"
                    }
                }
            }
        ],
        "EC2.ModifyTrafficMirrorSession": [
            {
                "action": "ec2:ModifyTrafficMirrorSession",
                "resource_mappings": {
                    "TrafficMirrorSessionId": {
                        "template": "${TrafficMirrorSessionId}"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "${TrafficMirrorTargetId}"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "${TrafficMirrorFilterId}"
                    }
                }
            }
        ],
        "EC2.ModifyTransitGateway": [
            {
                "action": "ec2:ModifyTransitGateway",
                "resource_mappings": {
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "%%many%${Options.AssociationDefaultRouteTableId}%${Options.PropagationDefaultRouteTableId}%%"
                    }
                }
            }
        ],
        "EC2.ModifyTransitGatewayPrefixListReference": [
            {
                "action": "ec2:ModifyTransitGatewayPrefixListReference",
                "resource_mappings": {
                    "PrefixListId": {
                        "template": "${PrefixListId}"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.ModifyTransitGatewayVpcAttachment": [
            {
                "action": "ec2:ModifyTransitGatewayVpcAttachment",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    },
                    "SubnetId": {
                        "template": "%%many%${AddSubnetIds[]}%${RemoveSubnetIds[]}%%"
                    }
                }
            }
        ],
        "EC2.ModifyVolume": [
            {
                "action": "ec2:ModifyVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "${VolumeId}"
                    }
                }
            }
        ],
        "EC2.ModifyVolumeAttribute": [
            {
                "action": "ec2:ModifyVolumeAttribute",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "${VolumeId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpcAttribute": [
            {
                "action": "ec2:ModifyVpcAttribute",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpcEndpoint": [
            {
                "action": "ec2:ModifyVpcEndpoint",
                "resource_mappings": {
                    "VpcEndpointId": {
                        "template": "${VpcEndpointId}"
                    },
                    "RouteTableId": {
                        "template": "%%many%${AddRouteTableIds[]}%${RemoveRouteTableIds[]}%%"
                    },
                    "SecurityGroupId": {
                        "template": "%%many%${AddSecurityGroupIds[]}%${RemoveSecurityGroupIds[]}%%"
                    },
                    "SubnetId": {
                        "template": "%%many%${AddSubnetIds[]}%${RemoveSubnetIds}%%"
                    }
                }
            }
        ],
        "EC2.ModifyVpcEndpointConnectionNotification": [
            {
                "action": "ec2:ModifyVpcEndpointConnectionNotification",
                "resource_mappings": {
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.ModifyVpcEndpointServiceConfiguration": [
            {
                "action": "ec2:ModifyVpcEndpointServiceConfiguration",
                "resource_mappings": {
                    "VpcEndpointServiceId": {
                        "template": "${ServiceId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpcEndpointServicePermissions": [
            {
                "action": "ec2:ModifyVpcEndpointServicePermissions",
                "resource_mappings": {
                    "VpcEndpointServiceId": {
                        "template": "${ServiceId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpcPeeringConnectionOptions": [
            {
                "action": "ec2:ModifyVpcPeeringConnectionOptions",
                "resource_mappings": {
                    "VpcPeeringConnectionId": {
                        "template": "${VpcPeeringConnectionId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpcTenancy": [
            {
                "action": "ec2:ModifyVpcTenancy",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VpcId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpnConnection": [
            {
                "action": "ec2:ModifyVpnConnection",
                "resource_mappings": {
                    "VpnConnectionId": {
                        "template": "${VpnConnectionId}"
                    },
                    "CustomerGatewayId": {
                        "template": "${CustomerGatewayId}"
                    },
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    },
                    "VpnGatewayId": {
                        "template": "${VpnGatewayId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpnConnectionOptions": [
            {
                "action": "ec2:ModifyVpnConnectionOptions",
                "resource_mappings": {
                    "VpnConnectionId": {
                        "template": "${VpnConnectionId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpnTunnelCertificate": [
            {
                "action": "ec2:ModifyVpnTunnelCertificate",
                "resource_mappings": {
                    "VpnConnectionId": {
                        "template": "${VpnConnectionId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpnTunnelOptions": [
            {
                "action": "ec2:ModifyVpnTunnelOptions",
                "resource_mappings": {
                    "VpnConnectionId": {
                        "template": "${VpnConnectionId}"
                    }
                }
            }
        ],
        "EC2.MonitorInstances": [
            {
                "action": "ec2:MonitorInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.MoveAddressToVpc": [
            {
                "action": "ec2:MoveAddressToVpc",
                "resource_mappings": {}
            }
        ],
        "EC2.ProvisionByoipCidr": [
            {
                "action": "ec2:ProvisionByoipCidr",
                "resource_mappings": {}
            }
        ],
        "EC2.PurchaseHostReservation": [
            {
                "action": "ec2:PurchaseHostReservation",
                "resource_mappings": {
                    "DedicatedHostId": {
                        "template": "${HostIdSet[]}"
                    }
                }
            }
        ],
        "EC2.PurchaseReservedInstancesOffering": [
            {
                "action": "ec2:PurchaseReservedInstancesOffering",
                "resource_mappings": {
                    "ReservationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.PurchaseScheduledInstances": [
            {
                "action": "ec2:PurchaseScheduledInstances",
                "resource_mappings": {}
            }
        ],
        "EC2.RebootInstances": [
            {
                "action": "ec2:RebootInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.RegisterImage": [
            {
                "action": "ec2:RegisterImage",
                "resource_mappings": {}
            }
        ],
        "EC2.RegisterInstanceEventNotificationAttributes": [
            {
                "action": "ec2:RegisterInstanceEventNotificationAttributes",
                "resource_mappings": {}
            }
        ],
        "EC2.RegisterTransitGatewayMulticastGroupMembers": [
            {
                "action": "ec2:RegisterTransitGatewayMulticastGroupMembers",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceIds[]}"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.RegisterTransitGatewayMulticastGroupSources": [
            {
                "action": "ec2:RegisterTransitGatewayMulticastGroupSources",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceIds[]}"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.RejectTransitGatewayMulticastDomainAssociations": [
            {
                "action": "ec2:RejectTransitGatewayMulticastDomainAssociations",
                "resource_mappings": {
                    "SubnetId": {
                        "template": "${SubnetIds[]}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.RejectTransitGatewayPeeringAttachment": [
            {
                "action": "ec2:RejectTransitGatewayPeeringAttachment",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.RejectTransitGatewayVpcAttachment": [
            {
                "action": "ec2:RejectTransitGatewayVpcAttachment",
                "resource_mappings": {
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.RejectVpcEndpointConnections": [
            {
                "action": "ec2:RejectVpcEndpointConnections",
                "resource_mappings": {
                    "VpcEndpointId": {
                        "template": "${VpcEndpointIds[]}"
                    },
                    "VpcEndpointServiceId": {
                        "template": "${ServiceId}"
                    }
                }
            }
        ],
        "EC2.RejectVpcPeeringConnection": [
            {
                "action": "ec2:RejectVpcPeeringConnection",
                "resource_mappings": {
                    "VpcPeeringConnectionId": {
                        "template": "${VpcPeeringConnectionId}"
                    }
                }
            }
        ],
        "EC2.ReleaseAddress": [
            {
                "action": "ec2:ReleaseAddress",
                "resource_mappings": {
                    "AllocationId": {
                        "template": "${AllocationId}"
                    }
                }
            }
        ],
        "EC2.ReleaseHosts": [
            {
                "action": "ec2:ReleaseHosts",
                "resource_mappings": {
                    "DedicatedHostId": {
                        "template": "${HostIds[]}"
                    }
                }
            }
        ],
        "EC2.ReplaceIamInstanceProfileAssociation": [
            {
                "action": "ec2:ReplaceIamInstanceProfileAssociation",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamInstanceProfile.Arn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${IamInstanceProfile.Name}%*%%%"
                }
            }
        ],
        "EC2.ReplaceNetworkAclAssociation": [
            {
                "action": "ec2:ReplaceNetworkAclAssociation",
                "resource_mappings": {
                    "NaclId": {
                        "template": "${NetworkAclId}"
                    }
                }
            }
        ],
        "EC2.ReplaceNetworkAclEntry": [
            {
                "action": "ec2:ReplaceNetworkAclEntry",
                "resource_mappings": {
                    "NaclId": {
                        "template": "${NetworkAclId}"
                    }
                }
            }
        ],
        "EC2.ReplaceRoute": [
            {
                "action": "ec2:ReplaceRoute",
                "resource_mappings": {
                    "RouteTableId": {
                        "template": "${RouteTableId}"
                    },
                    "CarrierGatewayId": {
                        "template": "${CarrierGatewayId}"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "${EgressOnlyInternetGatewayId}"
                    },
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "InternetGatewayId": {
                        "template": "%%iftemplatematch%${GatewayId}%%"
                    },
                    "LocalGatewayId": {
                        "template": "${LocalGatewayId}"
                    },
                    "NatGatewayId": {
                        "template": "${NatGatewayId}"
                    },
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    },
                    "PrefixListId": {
                        "template": "${DestinationPrefixListId}"
                    },
                    "TransitGatewayId": {
                        "template": "${TransitGatewayId}"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "${VpcPeeringConnectionId}"
                    },
                    "VpnGatewayId": {
                        "template": "%%iftemplatematch%${GatewayId}%%"
                    }
                }
            }
        ],
        "EC2.ReplaceRouteTableAssociation": [
            {
                "action": "ec2:ReplaceRouteTableAssociation",
                "resource_mappings": {
                    "RouteTableId": {
                        "template": "${RouteTableId}"
                    }
                }
            }
        ],
        "EC2.ReplaceTransitGatewayRoute": [
            {
                "action": "ec2:ReplaceTransitGatewayRoute",
                "resource_mappings": {
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "${TransitGatewayAttachmentId}"
                    }
                }
            }
        ],
        "EC2.ReportInstanceStatus": [
            {
                "action": "ec2:ReportInstanceStatus",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${Instances[]}"
                    }
                }
            }
        ],
        "EC2.RequestSpotFleet": [
            {
                "action": "ec2:RequestSpotFleet",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${SpotFleetRequestConfig.IamFleetRole}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${SpotFleetRequestConfig.LaunchTemplateConfigs[].LaunchTemplateSpecification.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${SpotFleetRequestConfig.LaunchTemplateConfigs[].LaunchTemplateSpecification.LaunchTemplateName}%*%%%"
                }
            }
        ],
        "EC2.RequestSpotInstances": [
            {
                "action": "ec2:RequestSpotInstances",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${LaunchSpecification.ImageId}"
                    },
                    "KeyPairName": {
                        "template": "${LaunchSpecification.KeyName}"
                    },
                    "SecurityGroupId": {
                        "template": "%%many%${LaunchSpecification.NetworkInterfaces[].Groups[]}%${LaunchSpecification.SecurityGroupIds[]}%%"
                    },
                    "SubnetId": {
                        "template": "%%many%${LaunchSpecification.NetworkInterfaces[].SubnetId}%${LaunchSpecification.SubnetId}%%"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${LaunchSpecification.IamInstanceProfile.Arn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchSpecification.IamInstanceProfile.Name}%*%%%"
                }
            }
        ],
        "EC2.ResetEbsDefaultKmsKeyId": [
            {
                "action": "ec2:ResetEbsDefaultKmsKeyId",
                "resource_mappings": {}
            }
        ],
        "EC2.ResetFpgaImageAttribute": [
            {
                "action": "ec2:ResetFpgaImageAttribute",
                "resource_mappings": {
                    "FpgaImageId": {
                        "template": "${FpgaImageId}"
                    }
                }
            }
        ],
        "EC2.ResetImageAttribute": [
            {
                "action": "ec2:ResetImageAttribute",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "EC2.ResetInstanceAttribute": [
            {
                "action": "ec2:ResetInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.ResetNetworkInterfaceAttribute": [
            {
                "action": "ec2:ResetNetworkInterfaceAttribute",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.ResetSnapshotAttribute": [
            {
                "action": "ec2:ResetSnapshotAttribute",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EC2.RestoreAddressToClassic": [
            {
                "action": "ec2:RestoreAddressToClassic",
                "resource_mappings": {}
            }
        ],
        "EC2.RestoreManagedPrefixListVersion": [
            {
                "action": "ec2:RestoreManagedPrefixListVersion",
                "resource_mappings": {
                    "PrefixListId": {
                        "template": "${PrefixListId}"
                    }
                }
            }
        ],
        "EC2.RevokeClientVpnIngress": [
            {
                "action": "ec2:RevokeClientVpnIngress",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    }
                }
            }
        ],
        "EC2.RevokeSecurityGroupEgress": [
            {
                "action": "ec2:RevokeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "EC2.RevokeSecurityGroupIngress": [
            {
                "action": "ec2:RevokeSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "EC2.RunInstances": [
            {
                "action": "ec2:RunInstances",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaces[].NetworkInterfaceId}"
                    },
                    "SecurityGroupId": {
                        "template": "${SecurityGroupIds[]}"
                    },
                    "SubnetId": {
                        "template": "${SubnetId}"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "${CapacityReservationSpecification.CapacityReservationTarget.CapacityReservationId}"
                    },
                    "ElasticGpuId": {
                        "template": "%%iftruthy%${ElasticGpuSpecification[].Type}%*%%%"
                    },
                    "ElasticInferenceAcceleratorId": {
                        "template": "%%iftruthy%${ElasticInferenceAccelerators[].Type}%*%%%"
                    },
                    "KeyPairName": {
                        "template": "${KeyName}"
                    },
                    "LaunchTemplateId": {
                        "template": "${LaunchTemplate.LaunchTemplateId}"
                    },
                    "PlacementGroupName": {
                        "template": "${Placement.GroupName}"
                    },
                    "SnapshotId": {
                        "template": "${BlockDeviceMappings[].Ebs.SnapshotId}"
                    }
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${SecurityGroups[]}%arn:${Partition}:ec2:${Region}:${Account}:security-group/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::image/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::instance/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::network-interface/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::security-group/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::subnet/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::volume/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::capacity-reservation/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::elastic-gpu/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:elastic-inference:${Region}::elastic-inference-accelerator/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::key-pair/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::launch-template/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::placement-group/*%%%"
                }
            },
            {
                "action": "ec2:RunInstances",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%arn:${Partition}:ec2:${Region}::snapshot/*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${IamInstanceProfile.Arn}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${IamInstanceProfile.Name}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateName}%*%%%"
                }
            }
        ],
        "EC2.RunScheduledInstances": [
            {
                "action": "ec2:RunScheduledInstances",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${LaunchSpecification.ImageId}"
                    },
                    "KeyPairName": {
                        "template": "${LaunchSpecification.KeyName}"
                    },
                    "NetworkInterfaceId": {
                        "template": "%%iftruthy%${LaunchSpecification.NetworkInterfaces[].NetworkInterfaceId}%${LaunchSpecification.NetworkInterfaces[].NetworkInterfaceId}%*%%"
                    },
                    "PlacementGroupName": {
                        "template": "${LaunchSpecification.Placement.GroupName}"
                    },
                    "SecurityGroupId": {
                        "template": "%%many%${LaunchSpecification.SecurityGroupIds[]}%${LaunchSpecification.NetworkInterfaces[].Groups[]}%%"
                    },
                    "SnapshotId": {
                        "template": "${LaunchSpecification.BlockDeviceMappings[].Ebs.SnapshotId}"
                    },
                    "SubnetId": {
                        "template": "%%many%${LaunchSpecification.SubnetId}%${LaunchSpecification.NetworkInterfaces[].SubnetId}%%"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${LaunchSpecification.IamInstanceProfile.Arn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchSpecification.IamInstanceProfile.Name}%*%%%"
                }
            }
        ],
        "EC2.SearchLocalGatewayRoutes": [
            {
                "action": "ec2:SearchLocalGatewayRoutes",
                "resource_mappings": {
                    "LocalGatewayRoutetableId": {
                        "template": "${LocalGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.SearchTransitGatewayMulticastGroups": [
            {
                "action": "ec2:SearchTransitGatewayMulticastGroups",
                "resource_mappings": {
                    "TransitGatewayMulticastDomainId": {
                        "template": "${TransitGatewayMulticastDomainId}"
                    }
                }
            }
        ],
        "EC2.SearchTransitGatewayRoutes": [
            {
                "action": "ec2:SearchTransitGatewayRoutes",
                "resource_mappings": {
                    "TransitGatewayRouteTableId": {
                        "template": "${TransitGatewayRouteTableId}"
                    }
                }
            }
        ],
        "EC2.SendDiagnosticInterrupt": [
            {
                "action": "ec2:SendDiagnosticInterrupt",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.StartInstances": [
            {
                "action": "ec2:StartInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.StartNetworkInsightsAnalysis": [
            {
                "action": "ec2:StartNetworkInsightsAnalysis",
                "resource_mappings": {
                    "NetworkInsightsPathId": {
                        "template": "${NetworkInsightsPathId}"
                    }
                }
            }
        ],
        "EC2.StartVpcEndpointServicePrivateDnsVerification": [
            {
                "action": "ec2:StartVpcEndpointServicePrivateDnsVerification",
                "resource_mappings": {
                    "VpcEndpointServiceId": {
                        "template": "${ServiceId}"
                    }
                }
            }
        ],
        "EC2.StopInstances": [
            {
                "action": "ec2:StopInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.TerminateClientVpnConnections": [
            {
                "action": "ec2:TerminateClientVpnConnections",
                "resource_mappings": {
                    "ClientVpnEndpointId": {
                        "template": "${ClientVpnEndpointId}"
                    },
                    "VpnConnectionId": {
                        "template": "${ConnectionId}"
                    }
                }
            }
        ],
        "EC2.TerminateInstances": [
            {
                "action": "ec2:TerminateInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.UnassignIpv6Addresses": [
            {
                "action": "ec2:UnassignIpv6Addresses",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.UnassignPrivateIpAddresses": [
            {
                "action": "ec2:UnassignPrivateIpAddresses",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "${NetworkInterfaceId}"
                    }
                }
            }
        ],
        "EC2.UnmonitorInstances": [
            {
                "action": "ec2:UnmonitorInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.UpdateSecurityGroupRuleDescriptionsEgress": [
            {
                "action": "ec2:UpdateSecurityGroupRuleDescriptionsEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "EC2.UpdateSecurityGroupRuleDescriptionsIngress": [
            {
                "action": "ec2:UpdateSecurityGroupRuleDescriptionsIngress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "EC2.WithdrawByoipCidr": [
            {
                "action": "ec2:WithdrawByoipCidr",
                "resource_mappings": {}
            }
        ],
        "ECR.BatchCheckLayerAvailability": [
            {
                "action": "ecr:BatchCheckLayerAvailability",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.BatchDeleteImage": [
            {
                "action": "ecr:BatchDeleteImage",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.BatchGetImage": [
            {
                "action": "ecr:BatchGetImage",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.CompleteLayerUpload": [
            {
                "action": "ecr:CompleteLayerUpload",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.CreateRepository": [
            {
                "action": "ecr:CreateRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.DeleteLifecyclePolicy": [
            {
                "action": "ecr:DeleteLifecyclePolicy",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.DeleteRegistryPolicy": [
            {
                "action": "ecr:DeleteRegistryPolicy",
                "resource_mappings": {}
            }
        ],
        "ECR.DeleteRepository": [
            {
                "action": "ecr:DeleteRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.DeleteRepositoryPolicy": [
            {
                "action": "ecr:DeleteRepositoryPolicy",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.DescribeImageScanFindings": [
            {
                "action": "ecr:DescribeImageScanFindings",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.DescribeImages": [
            {
                "action": "ecr:DescribeImages",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.DescribeRegistry": [
            {
                "action": "ecr:DescribeRegistry",
                "resource_mappings": {}
            }
        ],
        "ECR.DescribeRepositories": [
            {
                "action": "ecr:DescribeRepositories",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryNames[]}"
                    }
                }
            }
        ],
        "ECR.GetAuthorizationToken": [
            {
                "action": "ecr:GetAuthorizationToken",
                "resource_mappings": {}
            }
        ],
        "ECR.GetDownloadUrlForLayer": [
            {
                "action": "ecr:GetDownloadUrlForLayer",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.GetLifecyclePolicy": [
            {
                "action": "ecr:GetLifecyclePolicy",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.GetLifecyclePolicyPreview": [
            {
                "action": "ecr:GetLifecyclePolicyPreview",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.GetRegistryPolicy": [
            {
                "action": "ecr:GetRegistryPolicy",
                "resource_mappings": {}
            }
        ],
        "ECR.GetRepositoryPolicy": [
            {
                "action": "ecr:GetRepositoryPolicy",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.InitiateLayerUpload": [
            {
                "action": "ecr:InitiateLayerUpload",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.ListImages": [
            {
                "action": "ecr:ListImages",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.ListTagsForResource": [
            {
                "action": "ecr:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "repository": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "ECR.PutImage": [
            {
                "action": "ecr:PutImage",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.PutImageScanningConfiguration": [
            {
                "action": "ecr:PutImageScanningConfiguration",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.PutImageTagMutability": [
            {
                "action": "ecr:PutImageTagMutability",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.PutLifecyclePolicy": [
            {
                "action": "ecr:PutLifecyclePolicy",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.PutRegistryPolicy": [
            {
                "action": "ecr:PutRegistryPolicy",
                "resource_mappings": {}
            }
        ],
        "ECR.PutReplicationConfiguration": [
            {
                "action": "ecr:PutReplicationConfiguration",
                "resource_mappings": {}
            }
        ],
        "ECR.SetRepositoryPolicy": [
            {
                "action": "ecr:SetRepositoryPolicy",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.StartImageScan": [
            {
                "action": "ecr:StartImageScan",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.StartLifecyclePolicyPreview": [
            {
                "action": "ecr:StartLifecyclePolicyPreview",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECR.TagResource": [
            {
                "action": "ecr:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "repository": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "ECR.UntagResource": [
            {
                "action": "ecr:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "repository": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "ECR.UploadLayerPart": [
            {
                "action": "ecr:UploadLayerPart",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECS.CreateCapacityProvider": [
            {
                "action": "ecs:CreateCapacityProvider",
                "resource_mappings": {}
            }
        ],
        "ECS.CreateCluster": [
            {
                "action": "ecs:CreateCluster",
                "resource_mappings": {}
            }
        ],
        "ECS.CreateService": [
            {
                "action": "ecs:CreateService",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${serviceName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "ECS.CreateTaskSet": [
            {
                "action": "ecs:CreateTaskSet",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "ECS.DeleteAccountSetting": [
            {
                "action": "ecs:DeleteAccountSetting",
                "resource_mappings": {}
            }
        ],
        "ECS.DeleteAttributes": [
            {
                "action": "ecs:DeleteAttributes",
                "resource_mappings": {
                    "ContainerInstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ECS.DeleteCapacityProvider": [
            {
                "action": "ecs:DeleteCapacityProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "capacity-provider": "%%iftemplatematch%${capacityProvider}%%"
                }
            }
        ],
        "ECS.DeleteCluster": [
            {
                "action": "ecs:DeleteCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+?\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.DeleteService": [
            {
                "action": "ecs:DeleteService",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${service}"
                    }
                }
            }
        ],
        "ECS.DeleteTaskSet": [
            {
                "action": "ecs:DeleteTaskSet",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    },
                    "ServiceName": {
                        "template": "%%regex%${service}%/^(?:.+\\/)?(.+)$/g%%"
                    },
                    "TaskSetId": {
                        "template": "%%regex%${taskSet}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.DeregisterContainerInstance": [
            {
                "action": "ecs:DeregisterContainerInstance",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.DeregisterTaskDefinition": [
            {
                "action": "ecs:DeregisterTaskDefinition",
                "resource_mappings": {}
            }
        ],
        "ECS.DescribeCapacityProviders": [
            {
                "action": "ecs:DescribeCapacityProviders",
                "resource_mappings": {
                    "CapacityProviderName": {
                        "template": "%%regex%${capacityProviders[]}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.DescribeClusters": [
            {
                "action": "ecs:DescribeClusters",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${clusters[]}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.DescribeContainerInstances": [
            {
                "action": "ecs:DescribeContainerInstances",
                "resource_mappings": {
                    "ContainerInstanceId": {
                        "template": "%%regex%${containerInstances[]}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.DescribeServices": [
            {
                "action": "ecs:DescribeServices",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "%%regex%${services[]}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.DescribeTaskDefinition": [
            {
                "action": "ecs:DescribeTaskDefinition",
                "resource_mappings": {}
            }
        ],
        "ECS.DescribeTaskSets": [
            {
                "action": "ecs:DescribeTaskSets",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    },
                    "ServiceName": {
                        "template": "%%regex%${service}%/^(?:.+\\/)?(.+)$/g%%"
                    },
                    "TaskSetId": {
                        "template": "%%regex%${taskSets[]}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.DescribeTasks": [
            {
                "action": "ecs:DescribeTasks",
                "resource_mappings": {
                    "TaskId": {
                        "template": "%%regex%${tasks[]}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.DiscoverPollEndpoint": [
            {
                "action": "ecs:DiscoverPollEndpoint",
                "resource_mappings": {}
            }
        ],
        "ECS.ListAccountSettings": [
            {
                "action": "ecs:ListAccountSettings",
                "resource_mappings": {}
            }
        ],
        "ECS.ListAttributes": [
            {
                "action": "ecs:ListAttributes",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.ListClusters": [
            {
                "action": "ecs:ListClusters",
                "resource_mappings": {}
            }
        ],
        "ECS.ListContainerInstances": [
            {
                "action": "ecs:ListContainerInstances",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.ListServices": [
            {
                "action": "ecs:ListServices",
                "resource_mappings": {}
            }
        ],
        "ECS.ListTagsForResource": [
            {
                "action": "ecs:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${resourceArn}%%",
                    "container-instance": "%%iftemplatematch%${resourceArn}%%",
                    "task": "%%iftemplatematch%${resourceArn}%%",
                    "task-definition": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "ECS.ListTaskDefinitionFamilies": [
            {
                "action": "ecs:ListTaskDefinitionFamilies",
                "resource_mappings": {}
            }
        ],
        "ECS.ListTaskDefinitions": [
            {
                "action": "ecs:ListTaskDefinitions",
                "resource_mappings": {}
            }
        ],
        "ECS.ListTasks": [
            {
                "action": "ecs:ListTasks",
                "resource_mappings": {
                    "ContainerInstanceId": {
                        "template": "%%regex%${containerInstance}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.PutAccountSetting": [
            {
                "action": "ecs:PutAccountSetting",
                "resource_mappings": {}
            }
        ],
        "ECS.PutAccountSettingDefault": [
            {
                "action": "ecs:PutAccountSettingDefault",
                "resource_mappings": {}
            }
        ],
        "ECS.PutAttributes": [
            {
                "action": "ecs:PutAttributes",
                "resource_mappings": {
                    "ContainerInstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ECS.PutClusterCapacityProviders": [
            {
                "action": "ecs:PutClusterCapacityProviders",
                "resource_mappings": {
                    "CapacityProviderName": {
                        "template": "%%regex%${capacityProviders[]}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.RegisterContainerInstance": [
            {
                "action": "ecs:RegisterContainerInstance",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.RegisterTaskDefinition": [
            {
                "action": "ecs:RegisterTaskDefinition",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${taskRoleArn}%${executionRoleArn}%%"
                }
            }
        ],
        "ECS.RunTask": [
            {
                "action": "ecs:RunTask",
                "resource_mappings": {
                    "TaskDefinitionFamilyName": {
                        "template": "%%regex%${taskDefinition}%/(?:.*\\/)?([^:]+)(?:\\:[^:]+)?$/g%%"
                    },
                    "TaskDefinitionRevisionNumber": {
                        "template": "%%regex%${taskDefinition}%/\\:([^:]+)$/g%%"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${overrides.executionRoleArn}%${overrides.executionRoleArn}%*%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${overrides.taskRoleArn}%${overrides.taskRoleArn}%*%%"
                }
            }
        ],
        "ECS.StartTask": [
            {
                "action": "ecs:StartTask",
                "resource_mappings": {
                    "TaskDefinitionFamilyName": {
                        "template": "%%regex%${taskDefinition}%/(?:.*\\/)?([^:]+)(?:\\:[^:]+)?$/g%%"
                    },
                    "TaskDefinitionRevisionNumber": {
                        "template": "%%regex%${taskDefinition}%/\\:([^:]+)$/g%%"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${overrides.executionRoleArn}%${overrides.executionRoleArn}%*%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${overrides.taskRoleArn}%${overrides.taskRoleArn}%*%%"
                }
            }
        ],
        "ECS.StopTask": [
            {
                "action": "ecs:StopTask",
                "resource_mappings": {
                    "TaskId": {
                        "template": "%%regex%${task}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.SubmitAttachmentStateChanges": [
            {
                "action": "ecs:SubmitAttachmentStateChanges",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.SubmitContainerStateChange": [
            {
                "action": "ecs:SubmitContainerStateChange",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.SubmitTaskStateChange": [
            {
                "action": "ecs:SubmitTaskStateChange",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.TagResource": [
            {
                "action": "ecs:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${resourceArn}%%",
                    "container-instance": "%%iftemplatematch%${resourceArn}%%",
                    "service": "%%iftemplatematch%${resourceArn}%%",
                    "task": "%%iftemplatematch%${resourceArn}%%",
                    "task-definition": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "ECS.UntagResource": [
            {
                "action": "ecs:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${resourceArn}%%",
                    "container-instance": "%%iftemplatematch%${resourceArn}%%",
                    "service": "%%iftemplatematch%${resourceArn}%%",
                    "task": "%%iftemplatematch%${resourceArn}%%",
                    "task-definition": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "ECS.UpdateClusterSettings": [
            {
                "action": "ecs:UpdateClusterSettings",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.UpdateContainerAgent": [
            {
                "action": "ecs:UpdateContainerAgent",
                "resource_mappings": {
                    "ContainerInstanceId": {
                        "template": "%%regex%${containerInstance}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.UpdateContainerInstancesState": [
            {
                "action": "ecs:UpdateContainerInstancesState",
                "resource_mappings": {
                    "ContainerInstanceId": {
                        "template": "%%regex%${containerInstances[]}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.UpdateService": [
            {
                "action": "ecs:UpdateService",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "%%regex%${service}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.UpdateServicePrimaryTaskSet": [
            {
                "action": "ecs:UpdateServicePrimaryTaskSet",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "%%regex%${service}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.UpdateTaskSet": [
            {
                "action": "ecs:UpdateTaskSet",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+\\/)?(.+)$/g%%"
                    },
                    "ServiceName": {
                        "template": "%%regex%${service}%/^(?:.+\\/)?(.+)$/g%%"
                    },
                    "TaskSetId": {
                        "template": "%%regex%${taskSet}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "EFS.CreateAccessPoint": [
            {
                "action": "elasticfilesystem:CreateAccessPoint",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.CreateFileSystem": [
            {
                "action": "elasticfilesystem:CreateFileSystem",
                "resource_mappings": {}
            }
        ],
        "EFS.CreateMountTarget": [
            {
                "action": "elasticfilesystem:CreateMountTarget",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.CreateTags": [
            {
                "action": "elasticfilesystem:CreateTags",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.DeleteAccessPoint": [
            {
                "action": "elasticfilesystem:DeleteAccessPoint",
                "resource_mappings": {
                    "AccessPointId": {
                        "template": "${AccessPointId}"
                    }
                }
            }
        ],
        "EFS.DeleteFileSystem": [
            {
                "action": "elasticfilesystem:DeleteFileSystem",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.DeleteFileSystemPolicy": [
            {
                "action": "elasticfilesystem:DeleteFileSystemPolicy",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.DeleteMountTarget": [
            {
                "action": "elasticfilesystem:DeleteMountTarget",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EFS.DeleteTags": [
            {
                "action": "elasticfilesystem:DeleteTags",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.DescribeAccessPoints": [
            {
                "action": "elasticfilesystem:DescribeAccessPoints",
                "resource_mappings": {
                    "AccessPointId": {
                        "template": "${AccessPointId}"
                    },
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.DescribeBackupPolicy": [
            {
                "action": "elasticfilesystem:DescribeBackupPolicy",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.DescribeFileSystemPolicy": [
            {
                "action": "elasticfilesystem:DescribeFileSystemPolicy",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.DescribeFileSystems": [
            {
                "action": "elasticfilesystem:DescribeFileSystems",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.DescribeLifecycleConfiguration": [
            {
                "action": "elasticfilesystem:DescribeLifecycleConfiguration",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.DescribeMountTargetSecurityGroups": [
            {
                "action": "elasticfilesystem:DescribeMountTargetSecurityGroups",
                "resource_mappings": {}
            }
        ],
        "EFS.DescribeMountTargets": [
            {
                "action": "elasticfilesystem:DescribeMountTargets",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    },
                    "AccessPointId": {
                        "template": "${AccessPointId}"
                    }
                }
            }
        ],
        "EFS.DescribeTags": [
            {
                "action": "elasticfilesystem:DescribeTags",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.ListTagsForResource": [
            {
                "action": "elasticfilesystem:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "access-point": "%%iftemplatematch%${ResourceId}%%",
                    "file-system": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "EFS.ModifyMountTargetSecurityGroups": [
            {
                "action": "elasticfilesystem:ModifyMountTargetSecurityGroups",
                "resource_mappings": {}
            }
        ],
        "EFS.PutBackupPolicy": [
            {
                "action": "elasticfilesystem:PutBackupPolicy",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.PutFileSystemPolicy": [
            {
                "action": "elasticfilesystem:PutFileSystemPolicy",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.PutLifecycleConfiguration": [
            {
                "action": "elasticfilesystem:PutLifecycleConfiguration",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "EFS.TagResource": [
            {
                "action": "elasticfilesystem:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "access-point": "%%iftemplatematch%${ResourceId}%%",
                    "file-system": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "EFS.UntagResource": [
            {
                "action": "elasticfilesystem:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "access-point": "%%iftemplatematch%${ResourceId}%%",
                    "file-system": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "EFS.UpdateFileSystem": [
            {
                "action": "elasticfilesystem:UpdateFileSystem",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "ElastiCache.AddTagsToResource": [
            {
                "action": "elasticache:AddTagsToResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "ElastiCache.AuthorizeCacheSecurityGroupIngress": [
            {
                "action": "elasticache:AuthorizeCacheSecurityGroupIngress",
                "resource_mappings": {
                    "CacheSecurityGroupName": {
                        "template": "${CacheSecurityGroupName}"
                    }
                }
            },
            {
                "action": "ec2:AuthorizeSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.BatchApplyUpdateAction": [
            {
                "action": "elasticache:BatchApplyUpdateAction",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "${CacheClusterIds[]}"
                    },
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupIds[]}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.BatchStopUpdateAction": [
            {
                "action": "elasticache:BatchStopUpdateAction",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "${CacheClusterIds[]}"
                    },
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupIds[]}"
                    }
                }
            }
        ],
        "ElastiCache.CompleteMigration": [
            {
                "action": "elasticache:CompleteMigration",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "*"
                    },
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.CopySnapshot": [
            {
                "action": "elasticache:CopySnapshot",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "%%many%${SourceSnapshotName}%${TargetSnapshotName}%%"
                    }
                }
            },
            {
                "action": "elasticache:AddTagsToResource",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "%%many%${SourceSnapshotName}%${TargetSnapshotName}%%"
                    }
                }
            }
        ],
        "ElastiCache.CreateCacheCluster": [
            {
                "action": "elasticache:CreateCacheCluster",
                "resource_mappings": {
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    },
                    "CacheClusterId": {
                        "template": "${CacheClusterId}"
                    },
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    },
                    "CacheSecurityGroupName": {
                        "template": "${CacheSecurityGroupNames[]}"
                    },
                    "SnapshotName": {
                        "template": "%%many%${SnapshotArns[]}%arn:${Partition}:elasticache:${Region}:${Account}:snapshot:${SnapshotName}%%"
                    },
                    "CacheSubnetGroupName": {
                        "template": "${CacheSubnetGroupName}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "${SecurityGroupIds[]}"
                    }
                }
            }
        ],
        "ElastiCache.CreateCacheParameterGroup": [
            {
                "action": "elasticache:CreateCacheParameterGroup",
                "resource_mappings": {
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    }
                }
            },
            {
                "action": "elasticache:AddTagsToResource",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.CreateCacheSecurityGroup": [
            {
                "action": "elasticache:CreateCacheSecurityGroup",
                "resource_mappings": {
                    "CacheSecurityGroupName": {
                        "template": "${CacheSecurityGroupName}"
                    }
                }
            },
            {
                "action": "elasticache:AddTagsToResource",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.CreateCacheSubnetGroup": [
            {
                "action": "elasticache:CreateCacheSubnetGroup",
                "resource_mappings": {
                    "CacheSubnetGroupName": {
                        "template": "${CacheSubnetGroupName}"
                    }
                }
            },
            {
                "action": "elasticache:AddTagsToResource",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.CreateGlobalReplicationGroup": [
            {
                "action": "elasticache:CreateGlobalReplicationGroup",
                "resource_mappings": {
                    "GlobalReplicationGroupId": {
                        "template": "*${GlobalReplicationGroupIdSuffix}"
                    },
                    "ReplicationGroupId": {
                        "template": "${PrimaryReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.CreateReplicationGroup": [
            {
                "action": "elasticache:CreateReplicationGroup",
                "resource_mappings": {
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    },
                    "CacheClusterId": {
                        "template": "*"
                    },
                    "GlobalReplicationGroupId": {
                        "template": "${GlobalReplicationGroupId}"
                    },
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    },
                    "CacheSecurityGroupName": {
                        "template": "${CacheSecurityGroupNames[]}"
                    },
                    "CacheSubnetGroupName": {
                        "template": "${CacheSubnetGroupName}"
                    },
                    "UserGroupId": {
                        "template": "${UserGroupIds[]}"
                    }
                },
                "resourcearn_mappings": {
                    "snapshot": "${SnapshotArns[]}"
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "${SecurityGroupIds[]}"
                    }
                }
            }
        ],
        "ElastiCache.CreateSnapshot": [
            {
                "action": "elasticache:CreateSnapshot",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${SnapshotName}"
                    },
                    "CacheClusterId": {
                        "template": "${CacheClusterId}"
                    },
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    }
                }
            },
            {
                "action": "elasticache:AddTagsToResource",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "${CacheClusterId}"
                    },
                    "SnapshotName": {
                        "template": "${SnapshotName}"
                    }
                }
            }
        ],
        "ElastiCache.CreateUser": [
            {
                "action": "elasticache:CreateUser",
                "resource_mappings": {
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "ElastiCache.DecreaseNodeGroupsInGlobalReplicationGroup": [
            {
                "action": "elasticache:DecreaseNodeGroupsInGlobalReplicationGroup",
                "resource_mappings": {
                    "GlobalReplicationGroupId": {
                        "template": "${GlobalReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.DecreaseReplicaCount": [
            {
                "action": "elasticache:DecreaseReplicaCount",
                "resource_mappings": {
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.DeleteCacheCluster": [
            {
                "action": "elasticache:DeleteCacheCluster",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "${CacheClusterId}"
                    },
                    "SnapshotName": {
                        "template": "${FinalSnapshotIdentifier}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.DeleteCacheParameterGroup": [
            {
                "action": "elasticache:DeleteCacheParameterGroup",
                "resource_mappings": {
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.DeleteCacheSecurityGroup": [
            {
                "action": "elasticache:DeleteCacheSecurityGroup",
                "resource_mappings": {
                    "CacheSecurityGroupName": {
                        "template": "${CacheSecurityGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.DeleteCacheSubnetGroup": [
            {
                "action": "elasticache:DeleteCacheSubnetGroup",
                "resource_mappings": {
                    "CacheSubnetGroupName": {
                        "template": "${CacheSubnetGroupName}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.DeleteGlobalReplicationGroup": [
            {
                "action": "elasticache:DeleteGlobalReplicationGroup",
                "resource_mappings": {
                    "GlobalReplicationGroupId": {
                        "template": "${GlobalReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.DeleteReplicationGroup": [
            {
                "action": "elasticache:DeleteReplicationGroup",
                "resource_mappings": {
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    },
                    "SnapshotName": {
                        "template": "${FinalSnapshotIdentifier}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.DeleteSnapshot": [
            {
                "action": "elasticache:DeleteSnapshot",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${SnapshotName}"
                    }
                }
            }
        ],
        "ElastiCache.DeleteUser": [
            {
                "action": "elasticache:DeleteUser",
                "resource_mappings": {
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "ElastiCache.DeleteUserGroup": [
            {
                "action": "elasticache:DeleteUserGroup",
                "resource_mappings": {
                    "UserGroupId": {
                        "template": "${UserGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeCacheClusters": [
            {
                "action": "elasticache:DescribeCacheClusters",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "${CacheClusterId}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeCacheEngineVersions": [
            {
                "action": "elasticache:DescribeCacheEngineVersions",
                "resource_mappings": {}
            }
        ],
        "ElastiCache.DescribeCacheParameterGroups": [
            {
                "action": "elasticache:DescribeCacheParameterGroups",
                "resource_mappings": {
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeCacheParameters": [
            {
                "action": "elasticache:DescribeCacheParameters",
                "resource_mappings": {
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeCacheSecurityGroups": [
            {
                "action": "elasticache:DescribeCacheSecurityGroups",
                "resource_mappings": {
                    "CacheSecurityGroupName": {
                        "template": "${CacheSecurityGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeCacheSubnetGroups": [
            {
                "action": "elasticache:DescribeCacheSubnetGroups",
                "resource_mappings": {
                    "CacheSubnetGroupName": {
                        "template": "${CacheSubnetGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeEngineDefaultParameters": [
            {
                "action": "elasticache:DescribeEngineDefaultParameters",
                "resource_mappings": {}
            }
        ],
        "ElastiCache.DescribeEvents": [
            {
                "action": "elasticache:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "ElastiCache.DescribeGlobalReplicationGroups": [
            {
                "action": "elasticache:DescribeGlobalReplicationGroups",
                "resource_mappings": {
                    "GlobalReplicationGroupId": {
                        "template": "${GlobalReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeReplicationGroups": [
            {
                "action": "elasticache:DescribeReplicationGroups",
                "resource_mappings": {
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeReservedCacheNodes": [
            {
                "action": "elasticache:DescribeReservedCacheNodes",
                "resource_mappings": {
                    "ReservedCacheNodeId": {
                        "template": "${ReservedCacheNodeId}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeReservedCacheNodesOfferings": [
            {
                "action": "elasticache:DescribeReservedCacheNodesOfferings",
                "resource_mappings": {}
            }
        ],
        "ElastiCache.DescribeServiceUpdates": [
            {
                "action": "elasticache:DescribeServiceUpdates",
                "resource_mappings": {}
            }
        ],
        "ElastiCache.DescribeSnapshots": [
            {
                "action": "elasticache:DescribeSnapshots",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${SnapshotName}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeUpdateActions": [
            {
                "action": "elasticache:DescribeUpdateActions",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "${CacheClusterIds[]}"
                    },
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupIds[]}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeUserGroups": [
            {
                "action": "elasticache:DescribeUserGroups",
                "resource_mappings": {
                    "UserGroupId": {
                        "template": "${UserGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.DescribeUsers": [
            {
                "action": "elasticache:DescribeUsers",
                "resource_mappings": {
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "ElastiCache.DisassociateGlobalReplicationGroup": [
            {
                "action": "elasticache:DisassociateGlobalReplicationGroup",
                "resource_mappings": {
                    "GlobalReplicationGroupId": {
                        "template": "${GlobalReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.FailoverGlobalReplicationGroup": [
            {
                "action": "elasticache:FailoverGlobalReplicationGroup",
                "resource_mappings": {
                    "GlobalReplicationGroupId": {
                        "template": "${GlobalReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.IncreaseNodeGroupsInGlobalReplicationGroup": [
            {
                "action": "elasticache:IncreaseNodeGroupsInGlobalReplicationGroup",
                "resource_mappings": {
                    "GlobalReplicationGroupId": {
                        "template": "${GlobalReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.IncreaseReplicaCount": [
            {
                "action": "elasticache:IncreaseReplicaCount",
                "resource_mappings": {
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.ListAllowedNodeTypeModifications": [
            {
                "action": "elasticache:ListAllowedNodeTypeModifications",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "${CacheClusterId}"
                    },
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.ListTagsForResource": [
            {
                "action": "elasticache:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "ElastiCache.ModifyCacheCluster": [
            {
                "action": "elasticache:ModifyCacheCluster",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "${CacheClusterId}"
                    },
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    },
                    "CacheSecurityGroupName": {
                        "template": "${CacheSecurityGroupNames[]}"
                    }
                }
            }
        ],
        "ElastiCache.ModifyCacheParameterGroup": [
            {
                "action": "elasticache:ModifyCacheParameterGroup",
                "resource_mappings": {
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.ModifyCacheSubnetGroup": [
            {
                "action": "elasticache:ModifyCacheSubnetGroup",
                "resource_mappings": {
                    "CacheSubnetGroupName": {
                        "template": "${CacheSubnetGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.ModifyGlobalReplicationGroup": [
            {
                "action": "elasticache:ModifyGlobalReplicationGroup",
                "resource_mappings": {
                    "GlobalReplicationGroupId": {
                        "template": "${GlobalReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.ModifyReplicationGroup": [
            {
                "action": "elasticache:ModifyReplicationGroup",
                "resource_mappings": {
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    },
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    },
                    "CacheSecurityGroupName": {
                        "template": "${CacheSecurityGroupNames[]}"
                    },
                    "UserGroupId": {
                        "template": "%%many%${UserGroupIdsToAdd[]}%${UserGroupIdsToRemove[]}%%"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "${SecurityGroupIds[]}"
                    }
                }
            }
        ],
        "ElastiCache.ModifyReplicationGroupShardConfiguration": [
            {
                "action": "elasticache:ModifyReplicationGroupShardConfiguration",
                "resource_mappings": {
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.ModifyUser": [
            {
                "action": "elasticache:ModifyUser",
                "resource_mappings": {
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "ElastiCache.ModifyUserGroup": [
            {
                "action": "elasticache:ModifyUserGroup",
                "resource_mappings": {
                    "UserId": {
                        "template": "%%many%${UserIdsToAdd[]}%${UserIdsToRemove[]}%%"
                    },
                    "UserGroupId": {
                        "template": "${UserGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.PurchaseReservedCacheNodesOffering": [
            {
                "action": "elasticache:PurchaseReservedCacheNodesOffering",
                "resource_mappings": {
                    "ReservedCacheNodeId": {
                        "template": "${ReservedCacheNodeId}"
                    }
                }
            },
            {
                "action": "elasticache:AddTagsToResource",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElastiCache.RebalanceSlotsInGlobalReplicationGroup": [
            {
                "action": "elasticache:RebalanceSlotsInGlobalReplicationGroup",
                "resource_mappings": {
                    "GlobalReplicationGroupId": {
                        "template": "${GlobalReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.RebootCacheCluster": [
            {
                "action": "elasticache:RebootCacheCluster",
                "resource_mappings": {
                    "CacheClusterId": {
                        "template": "${CacheClusterId}"
                    }
                }
            }
        ],
        "ElastiCache.RemoveTagsFromResource": [
            {
                "action": "elasticache:RemoveTagsFromResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "ElastiCache.ResetCacheParameterGroup": [
            {
                "action": "elasticache:ResetCacheParameterGroup",
                "resource_mappings": {
                    "CacheParameterGroupName": {
                        "template": "${CacheParameterGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.RevokeCacheSecurityGroupIngress": [
            {
                "action": "elasticache:RevokeCacheSecurityGroupIngress",
                "resource_mappings": {
                    "CacheSecurityGroupName": {
                        "template": "${CacheSecurityGroupName}"
                    }
                }
            }
        ],
        "ElastiCache.StartMigration": [
            {
                "action": "elasticache:StartMigration",
                "resource_mappings": {
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    }
                }
            }
        ],
        "ElastiCache.TestFailover": [
            {
                "action": "elasticache:TestFailover",
                "resource_mappings": {
                    "ReplicationGroupId": {
                        "template": "${ReplicationGroupId}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElasticBeanstalk.AbortEnvironmentUpdate": [
            {
                "action": "elasticbeanstalk:AbortEnvironmentUpdate",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.ApplyEnvironmentManagedAction": [
            {
                "action": "elasticbeanstalk:ApplyEnvironmentManagedAction",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.AssociateEnvironmentOperationsRole": [
            {
                "action": "elasticbeanstalk:AssociateEnvironmentOperationsRole",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${OperationsRole}"
                }
            }
        ],
        "ElasticBeanstalk.CheckDNSAvailability": [
            {
                "action": "elasticbeanstalk:CheckDNSAvailability",
                "resource_mappings": {}
            }
        ],
        "ElasticBeanstalk.ComposeEnvironments": [
            {
                "action": "elasticbeanstalk:ComposeEnvironments",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "VersionLabel": {
                        "template": "${VersionLabels[]}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.CreateApplication": [
            {
                "action": "elasticbeanstalk:CreateApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ResourceLifecycleConfig.ServiceRole}"
                }
            }
        ],
        "ElasticBeanstalk.CreateApplicationVersion": [
            {
                "action": "elasticbeanstalk:CreateApplicationVersion",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "VersionLabel": {
                        "template": "${VersionLabel}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.CreateConfigurationTemplate": [
            {
                "action": "elasticbeanstalk:CreateConfigurationTemplate",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "TemplateName": {
                        "template": "${TemplateName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${BuildConfiguration.CodeBuildServiceRole}"
                }
            }
        ],
        "ElasticBeanstalk.CreateEnvironment": [
            {
                "action": "elasticbeanstalk:CreateEnvironment",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${OperationsRole}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${TemplateName}%*%%%"
                }
            }
        ],
        "ElasticBeanstalk.CreatePlatformVersion": [
            {
                "action": "elasticbeanstalk:CreatePlatformVersion",
                "resource_mappings": {
                    "PlatformNameWithVersion": {
                        "template": "${PlatformName}/${PlatformVersion}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.CreateStorageLocation": [
            {
                "action": "elasticbeanstalk:CreateStorageLocation",
                "resource_mappings": {}
            }
        ],
        "ElasticBeanstalk.DeleteApplication": [
            {
                "action": "elasticbeanstalk:DeleteApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DeleteApplicationVersion": [
            {
                "action": "elasticbeanstalk:DeleteApplicationVersion",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "VersionLabel": {
                        "template": "${VersionLabel}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DeleteConfigurationTemplate": [
            {
                "action": "elasticbeanstalk:DeleteConfigurationTemplate",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "TemplateName": {
                        "template": "${TemplateName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DeleteEnvironmentConfiguration": [
            {
                "action": "elasticbeanstalk:DeleteEnvironmentConfiguration",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DeletePlatformVersion": [
            {
                "action": "elasticbeanstalk:DeletePlatformVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "platform": "${PlatformArn}"
                }
            }
        ],
        "ElasticBeanstalk.DescribeAccountAttributes": [
            {
                "action": "elasticbeanstalk:DescribeAccountAttributes",
                "resource_mappings": {}
            }
        ],
        "ElasticBeanstalk.DescribeApplicationVersions": [
            {
                "action": "elasticbeanstalk:DescribeApplicationVersions",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "VersionLabel": {
                        "template": "${VersionLabels[]}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeApplications": [
            {
                "action": "elasticbeanstalk:DescribeApplications",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationNames[]}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeConfigurationOptions": [
            {
                "action": "elasticbeanstalk:DescribeConfigurationOptions",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    },
                    "SolutionStackName": {
                        "template": "${SolutionStackName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeConfigurationSettings": [
            {
                "action": "elasticbeanstalk:DescribeConfigurationSettings",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeEnvironmentHealth": [
            {
                "action": "elasticbeanstalk:DescribeEnvironmentHealth",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeEnvironmentManagedActionHistory": [
            {
                "action": "elasticbeanstalk:DescribeEnvironmentManagedActionHistory",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeEnvironmentManagedActions": [
            {
                "action": "elasticbeanstalk:DescribeEnvironmentManagedActions",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeEnvironmentResources": [
            {
                "action": "elasticbeanstalk:DescribeEnvironmentResources",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeEnvironments": [
            {
                "action": "elasticbeanstalk:DescribeEnvironments",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentNames[]}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeEvents": [
            {
                "action": "elasticbeanstalk:DescribeEvents",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "VersionLabel": {
                        "template": "${VersionLabel}"
                    },
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribeInstancesHealth": [
            {
                "action": "elasticbeanstalk:DescribeInstancesHealth",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.DescribePlatformVersion": [
            {
                "action": "elasticbeanstalk:DescribePlatformVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "platform": "${PlatformArn}"
                }
            }
        ],
        "ElasticBeanstalk.DisassociateEnvironmentOperationsRole": [
            {
                "action": "elasticbeanstalk:DisassociateEnvironmentOperationsRole",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.ListAvailableSolutionStacks": [
            {
                "action": "elasticbeanstalk:ListAvailableSolutionStacks",
                "resource_mappings": {
                    "SolutionStackName": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElasticBeanstalk.ListPlatformBranches": [
            {
                "action": "elasticbeanstalk:ListPlatformBranches",
                "resource_mappings": {}
            }
        ],
        "ElasticBeanstalk.ListPlatformVersions": [
            {
                "action": "elasticbeanstalk:ListPlatformVersions",
                "resource_mappings": {
                    "PlatformNameWithVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElasticBeanstalk.ListTagsForResource": [
            {
                "action": "elasticbeanstalk:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceArn}%%",
                    "applicationversion": "%%iftemplatematch%${ResourceArn}%%",
                    "configurationtemplate": "%%iftemplatematch%${ResourceArn}%%",
                    "environment": "%%iftemplatematch%${ResourceArn}%%",
                    "platform": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ElasticBeanstalk.RebuildEnvironment": [
            {
                "action": "elasticbeanstalk:RebuildEnvironment",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.RequestEnvironmentInfo": [
            {
                "action": "elasticbeanstalk:RequestEnvironmentInfo",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.RestartAppServer": [
            {
                "action": "elasticbeanstalk:RestartAppServer",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.RetrieveEnvironmentInfo": [
            {
                "action": "elasticbeanstalk:RetrieveEnvironmentInfo",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.SwapEnvironmentCNAMEs": [
            {
                "action": "elasticbeanstalk:SwapEnvironmentCNAMEs",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "%%many%${SourceEnvironmentName}%${DestinationEnvironmentName}%%"
                    }
                }
            }
        ],
        "ElasticBeanstalk.TerminateEnvironment": [
            {
                "action": "elasticbeanstalk:TerminateEnvironment",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "*"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.UpdateApplication": [
            {
                "action": "elasticbeanstalk:UpdateApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.UpdateApplicationResourceLifecycle": [
            {
                "action": "elasticbeanstalk:UpdateApplicationResourceLifecycle",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${esourceLifecycleConfig.ServiceRole}"
                }
            }
        ],
        "ElasticBeanstalk.UpdateApplicationVersion": [
            {
                "action": "elasticbeanstalk:UpdateApplicationVersion",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "VersionLabel": {
                        "template": "${VersionLabel}"
                    }
                }
            }
        ],
        "ElasticBeanstalk.UpdateConfigurationTemplate": [
            {
                "action": "elasticbeanstalk:UpdateConfigurationTemplate",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "TemplateName": {
                        "template": "${TemplateName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${TemplateName}%*%%%"
                }
            }
        ],
        "ElasticBeanstalk.UpdateEnvironment": [
            {
                "action": "elasticbeanstalk:UpdateEnvironment",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${TemplateName}%*%%%"
                }
            }
        ],
        "ElasticBeanstalk.ValidateConfigurationSettings": [
            {
                "action": "elasticbeanstalk:ValidateConfigurationSettings",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    },
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "ELB.AddTags": [
            {
                "action": "elasticloadbalancing:AddTags",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerNames[]}"
                    },
                    "LoadBalancerId": {
                        "template": "*"
                    },
                    "ListenerId": {
                        "template": "*"
                    },
                    "ListenerRuleId": {
                        "template": "*"
                    },
                    "TargetGroupName": {
                        "template": "${LoadBalancerNames[]}"
                    },
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ELB.ApplySecurityGroupsToLoadBalancer": [
            {
                "action": "elasticloadbalancing:ApplySecurityGroupsToLoadBalancer",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.AttachLoadBalancerToSubnets": [
            {
                "action": "elasticloadbalancing:AttachLoadBalancerToSubnets",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.ConfigureHealthCheck": [
            {
                "action": "elasticloadbalancing:ConfigureHealthCheck",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.CreateAppCookieStickinessPolicy": [
            {
                "action": "elasticloadbalancing:CreateAppCookieStickinessPolicy",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.CreateLBCookieStickinessPolicy": [
            {
                "action": "elasticloadbalancing:CreateLBCookieStickinessPolicy",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.CreateLoadBalancer": [
            {
                "action": "elasticloadbalancing:CreateLoadBalancer",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    },
                    "LoadBalancerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ELB.CreateLoadBalancerListeners": [
            {
                "action": "elasticloadbalancing:CreateLoadBalancerListeners",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.CreateLoadBalancerPolicy": [
            {
                "action": "elasticloadbalancing:CreateLoadBalancerPolicy",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.DeleteLoadBalancer": [
            {
                "action": "elasticloadbalancing:DeleteLoadBalancer",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    },
                    "LoadBalancerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ELB.DeleteLoadBalancerListeners": [
            {
                "action": "elasticloadbalancing:DeleteLoadBalancerListeners",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.DeleteLoadBalancerPolicy": [
            {
                "action": "elasticloadbalancing:DeleteLoadBalancerPolicy",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.DeregisterInstancesFromLoadBalancer": [
            {
                "action": "elasticloadbalancing:DeregisterInstancesFromLoadBalancer",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.DescribeAccountLimits": [
            {
                "action": "elasticloadbalancing:DescribeAccountLimits",
                "resource_mappings": {}
            }
        ],
        "ELB.DescribeInstanceHealth": [
            {
                "action": "elasticloadbalancing:DescribeInstanceHealth",
                "resource_mappings": {}
            }
        ],
        "ELB.DescribeLoadBalancerAttributes": [
            {
                "action": "elasticloadbalancing:DescribeLoadBalancerAttributes",
                "resource_mappings": {}
            }
        ],
        "ELB.DescribeLoadBalancerPolicies": [
            {
                "action": "elasticloadbalancing:DescribeLoadBalancerPolicies",
                "resource_mappings": {}
            }
        ],
        "ELB.DescribeLoadBalancerPolicyTypes": [
            {
                "action": "elasticloadbalancing:DescribeLoadBalancerPolicyTypes",
                "resource_mappings": {}
            }
        ],
        "ELB.DescribeLoadBalancers": [
            {
                "action": "elasticloadbalancing:DescribeLoadBalancers",
                "resource_mappings": {}
            }
        ],
        "ELB.DescribeTags": [
            {
                "action": "elasticloadbalancing:DescribeTags",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerNames[]}"
                    },
                    "LoadBalancerId": {
                        "template": "*"
                    },
                    "ListenerId": {
                        "template": "*"
                    },
                    "ListenerRuleId": {
                        "template": "*"
                    },
                    "TargetGroupName": {
                        "template": "*"
                    },
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ELB.DetachLoadBalancerFromSubnets": [
            {
                "action": "elasticloadbalancing:DetachLoadBalancerFromSubnets",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.DisableAvailabilityZonesForLoadBalancer": [
            {
                "action": "elasticloadbalancing:DisableAvailabilityZonesForLoadBalancer",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.EnableAvailabilityZonesForLoadBalancer": [
            {
                "action": "elasticloadbalancing:EnableAvailabilityZonesForLoadBalancer",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.ModifyLoadBalancerAttributes": [
            {
                "action": "elasticloadbalancing:ModifyLoadBalancerAttributes",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    },
                    "LoadBalancerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ELB.RegisterInstancesWithLoadBalancer": [
            {
                "action": "elasticloadbalancing:RegisterInstancesWithLoadBalancer",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.RemoveTags": [
            {
                "action": "elasticloadbalancing:RemoveTags",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerNames[]}"
                    },
                    "LoadBalancerId": {
                        "template": "*"
                    },
                    "ListenerId": {
                        "template": "*"
                    },
                    "ListenerRuleId": {
                        "template": "*"
                    },
                    "TargetGroupName": {
                        "template": "*"
                    },
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ELB.SetLoadBalancerListenerSSLCertificate": [
            {
                "action": "elasticloadbalancing:SetLoadBalancerListenerSSLCertificate",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.SetLoadBalancerPoliciesForBackendServer": [
            {
                "action": "elasticloadbalancing:SetLoadBalancerPoliciesForBackendServer",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELB.SetLoadBalancerPoliciesOfListener": [
            {
                "action": "elasticloadbalancing:SetLoadBalancerPoliciesOfListener",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${LoadBalancerName}"
                    }
                }
            }
        ],
        "ELBv2.AddListenerCertificates": [
            {
                "action": "elasticloadbalancing:AddListenerCertificates",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener/app": "%%iftemplatematch%${ListenerArn}%%",
                    "listener/net": "%%iftemplatematch%${ListenerArn}%%"
                }
            }
        ],
        "ELBv2.AddTags": [
            {
                "action": "elasticloadbalancing:AddTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener-rule/app": "%%iftemplatematch%${ResourceArns[]}%%",
                    "listener-rule/net": "%%iftemplatematch%${ResourceArns[]}%%",
                    "listener/app": "%%iftemplatematch%${ResourceArns[]}%%",
                    "listener/net": "%%iftemplatematch%${ResourceArns[]}%%",
                    "loadbalancer/app/": "%%iftemplatematch%${ResourceArns[]}%%",
                    "loadbalancer/net/": "%%iftemplatematch%${ResourceArns[]}%%",
                    "targetgroup": "%%iftemplatematch%${ResourceArns[]}%%",
                    "loadbalancer": "%%iftemplatematch%${ResourceArns[]}%%"
                }
            }
        ],
        "ELBv2.CreateListener": [
            {
                "action": "elasticloadbalancing:CreateListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "loadbalancer/app/": "%%iftemplatematch%${LoadBalancerArn}%%",
                    "loadbalancer/net/": "%%iftemplatematch%${LoadBalancerArn}%%"
                }
            }
        ],
        "ELBv2.CreateLoadBalancer": [
            {
                "action": "elasticloadbalancing:CreateLoadBalancer",
                "resource_mappings": {
                    "LoadBalancerName": {
                        "template": "${Name}"
                    },
                    "LoadBalancerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ELBv2.CreateRule": [
            {
                "action": "elasticloadbalancing:CreateRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener/app": "%%iftemplatematch%${ListenerArn}%%",
                    "listener/net": "%%iftemplatematch%${ListenerArn}%%"
                }
            }
        ],
        "ELBv2.CreateTargetGroup": [
            {
                "action": "elasticloadbalancing:CreateTargetGroup",
                "resource_mappings": {
                    "TargetGroupName": {
                        "template": "${Name}"
                    },
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ELBv2.DeleteListener": [
            {
                "action": "elasticloadbalancing:DeleteListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener/app": "%%iftemplatematch%${ListenerArn}%%",
                    "listener/net": "%%iftemplatematch%${ListenerArn}%%"
                }
            }
        ],
        "ELBv2.DeleteLoadBalancer": [
            {
                "action": "elasticloadbalancing:DeleteLoadBalancer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "loadbalancer/app/": "%%iftemplatematch%${LoadBalancerArn}%%",
                    "loadbalancer/net/": "%%iftemplatematch%${LoadBalancerArn}%%",
                    "loadbalancer": "%%iftemplatematch%${LoadBalancerArn}%%"
                }
            }
        ],
        "ELBv2.DeleteRule": [
            {
                "action": "elasticloadbalancing:DeleteRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener-rule/app": "%%iftemplatematch%${RuleArn}%%",
                    "listener-rule/net": "%%iftemplatematch%${RuleArn}%%"
                }
            }
        ],
        "ELBv2.DeleteTargetGroup": [
            {
                "action": "elasticloadbalancing:DeleteTargetGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "targetgroup": "${TargetGroupArn}"
                }
            }
        ],
        "ELBv2.DeregisterTargets": [
            {
                "action": "elasticloadbalancing:DeregisterTargets",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "targetgroup": "${TargetGroupArn}"
                }
            }
        ],
        "ELBv2.DescribeAccountLimits": [
            {
                "action": "elasticloadbalancing:DescribeAccountLimits",
                "resource_mappings": {}
            }
        ],
        "ELBv2.DescribeListenerCertificates": [
            {
                "action": "elasticloadbalancing:DescribeListenerCertificates",
                "resource_mappings": {}
            }
        ],
        "ELBv2.DescribeListeners": [
            {
                "action": "elasticloadbalancing:DescribeListeners",
                "resource_mappings": {}
            }
        ],
        "ELBv2.DescribeLoadBalancerAttributes": [
            {
                "action": "elasticloadbalancing:DescribeLoadBalancerAttributes",
                "resource_mappings": {}
            }
        ],
        "ELBv2.DescribeLoadBalancers": [
            {
                "action": "elasticloadbalancing:DescribeLoadBalancers",
                "resource_mappings": {}
            }
        ],
        "ELBv2.DescribeRules": [
            {
                "action": "elasticloadbalancing:DescribeRules",
                "resource_mappings": {}
            }
        ],
        "ELBv2.DescribeSSLPolicies": [
            {
                "action": "elasticloadbalancing:DescribeSSLPolicies",
                "resource_mappings": {}
            }
        ],
        "ELBv2.DescribeTags": [
            {
                "action": "elasticloadbalancing:DescribeTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener-rule/app": "%%iftemplatematch%${ResourceArns[]}%%",
                    "listener-rule/net": "%%iftemplatematch%${ResourceArns[]}%%",
                    "listener/app": "%%iftemplatematch%${ResourceArns[]}%%",
                    "listener/net": "%%iftemplatematch%${ResourceArns[]}%%",
                    "loadbalancer/app/": "%%iftemplatematch%${ResourceArns[]}%%",
                    "loadbalancer/net/": "%%iftemplatematch%${ResourceArns[]}%%",
                    "targetgroup": "%%iftemplatematch%${ResourceArns[]}%%",
                    "loadbalancer": "%%iftemplatematch%${ResourceArns[]}%%"
                }
            }
        ],
        "ELBv2.DescribeTargetGroupAttributes": [
            {
                "action": "elasticloadbalancing:DescribeTargetGroupAttributes",
                "resource_mappings": {}
            }
        ],
        "ELBv2.DescribeTargetGroups": [
            {
                "action": "elasticloadbalancing:DescribeTargetGroups",
                "resource_mappings": {}
            }
        ],
        "ELBv2.DescribeTargetHealth": [
            {
                "action": "elasticloadbalancing:DescribeTargetHealth",
                "resource_mappings": {}
            }
        ],
        "ELBv2.ModifyListener": [
            {
                "action": "elasticloadbalancing:ModifyListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener/app": "%%iftemplatematch%${ListenerArn}%%",
                    "listener/net": "%%iftemplatematch%${ListenerArn}%%"
                }
            }
        ],
        "ELBv2.ModifyLoadBalancerAttributes": [
            {
                "action": "elasticloadbalancing:ModifyLoadBalancerAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "loadbalancer/app/": "%%iftemplatematch%${LoadBalancerArn}%%",
                    "loadbalancer/net/": "%%iftemplatematch%${LoadBalancerArn}%%",
                    "loadbalancer": "%%iftemplatematch%${LoadBalancerArn}%%"
                }
            }
        ],
        "ELBv2.ModifyRule": [
            {
                "action": "elasticloadbalancing:ModifyRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener-rule/app": "%%iftemplatematch%${RuleArn}%%",
                    "listener-rule/net": "%%iftemplatematch%${RuleArn}%%"
                }
            }
        ],
        "ELBv2.ModifyTargetGroup": [
            {
                "action": "elasticloadbalancing:ModifyTargetGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "targetgroup": "${TargetGroupArn}"
                }
            }
        ],
        "ELBv2.ModifyTargetGroupAttributes": [
            {
                "action": "elasticloadbalancing:ModifyTargetGroupAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "targetgroup": "${TargetGroupArn}"
                }
            }
        ],
        "ELBv2.RegisterTargets": [
            {
                "action": "elasticloadbalancing:RegisterTargets",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "targetgroup": "${TargetGroupArn}"
                }
            }
        ],
        "ELBv2.RemoveListenerCertificates": [
            {
                "action": "elasticloadbalancing:RemoveListenerCertificates",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener/app": "%%iftemplatematch%${ListenerArn}%%",
                    "listener/net": "%%iftemplatematch%${ListenerArn}%%"
                }
            }
        ],
        "ELBv2.RemoveTags": [
            {
                "action": "elasticloadbalancing:RemoveTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener-rule/app": "%%iftemplatematch%${ResourceArns[]}%%",
                    "listener-rule/net": "%%iftemplatematch%${ResourceArns[]}%%",
                    "listener/app": "%%iftemplatematch%${ResourceArns[]}%%",
                    "listener/net": "%%iftemplatematch%${ResourceArns[]}%%",
                    "loadbalancer/app/": "%%iftemplatematch%${ResourceArns[]}%%",
                    "loadbalancer/net/": "%%iftemplatematch%${ResourceArns[]}%%",
                    "targetgroup": "%%iftemplatematch%${ResourceArns[]}%%",
                    "loadbalancer": "%%iftemplatematch%${ResourceArns[]}%%"
                }
            }
        ],
        "ELBv2.SetIpAddressType": [
            {
                "action": "elasticloadbalancing:SetIpAddressType",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "loadbalancer/app/": "%%iftemplatematch%${LoadBalancerArn}%%",
                    "loadbalancer/net/": "%%iftemplatematch%${LoadBalancerArn}%%"
                }
            }
        ],
        "ELBv2.SetRulePriorities": [
            {
                "action": "elasticloadbalancing:SetRulePriorities",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener-rule/app": "%%iftemplatematch%${RulePriorities[].RuleArn}%%",
                    "listener-rule/net": "%%iftemplatematch%${RulePriorities[].RuleArn}%%"
                }
            }
        ],
        "ELBv2.SetSecurityGroups": [
            {
                "action": "elasticloadbalancing:SetSecurityGroups",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "loadbalancer/app/": "%%iftemplatematch%${LoadBalancerArn}%%",
                    "loadbalancer/net/": "%%iftemplatematch%${LoadBalancerArn}%%"
                }
            }
        ],
        "ELBv2.SetSubnets": [
            {
                "action": "elasticloadbalancing:SetSubnets",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "loadbalancer/app/": "%%iftemplatematch%${LoadBalancerArn}%%",
                    "loadbalancer/net/": "%%iftemplatematch%${LoadBalancerArn}%%"
                }
            }
        ],
        "EMR.AddJobFlowSteps": [
            {
                "action": "elasticmapreduce:AddJobFlowSteps",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EMR.AddTags": [
            {
                "action": "elasticmapreduce:AddTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceId}%%",
                    "editor": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "EMR.CancelSteps": [
            {
                "action": "elasticmapreduce:CancelSteps",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.CreateSecurityConfiguration": [
            {
                "action": "elasticmapreduce:CreateSecurityConfiguration",
                "resource_mappings": {}
            }
        ],
        "EMR.DeleteSecurityConfiguration": [
            {
                "action": "elasticmapreduce:DeleteSecurityConfiguration",
                "resource_mappings": {}
            }
        ],
        "EMR.DescribeCluster": [
            {
                "action": "elasticmapreduce:DescribeCluster",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.DescribeJobFlows": [
            {
                "action": "elasticmapreduce:DescribeJobFlows",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EMR.DescribeSecurityConfiguration": [
            {
                "action": "elasticmapreduce:DescribeSecurityConfiguration",
                "resource_mappings": {}
            }
        ],
        "EMR.DescribeStep": [
            {
                "action": "elasticmapreduce:DescribeStep",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.GetBlockPublicAccessConfiguration": [
            {
                "action": "elasticmapreduce:GetBlockPublicAccessConfiguration",
                "resource_mappings": {}
            }
        ],
        "EMR.GetManagedScalingPolicy": [
            {
                "action": "elasticmapreduce:GetManagedScalingPolicy",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.ListBootstrapActions": [
            {
                "action": "elasticmapreduce:ListBootstrapActions",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.ListClusters": [
            {
                "action": "elasticmapreduce:ListClusters",
                "resource_mappings": {}
            }
        ],
        "EMR.ListInstanceFleets": [
            {
                "action": "elasticmapreduce:ListInstanceFleets",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.ListInstanceGroups": [
            {
                "action": "elasticmapreduce:ListInstanceGroups",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.ListInstances": [
            {
                "action": "elasticmapreduce:ListInstances",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.ListSecurityConfigurations": [
            {
                "action": "elasticmapreduce:ListSecurityConfigurations",
                "resource_mappings": {}
            }
        ],
        "EMR.ListSteps": [
            {
                "action": "elasticmapreduce:ListSteps",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.ModifyCluster": [
            {
                "action": "elasticmapreduce:ModifyCluster",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.ModifyInstanceFleet": [
            {
                "action": "elasticmapreduce:ModifyInstanceFleet",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.ModifyInstanceGroups": [
            {
                "action": "elasticmapreduce:ModifyInstanceGroups",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.PutAutoScalingPolicy": [
            {
                "action": "elasticmapreduce:PutAutoScalingPolicy",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.PutBlockPublicAccessConfiguration": [
            {
                "action": "elasticmapreduce:PutBlockPublicAccessConfiguration",
                "resource_mappings": {}
            }
        ],
        "EMR.PutManagedScalingPolicy": [
            {
                "action": "elasticmapreduce:PutManagedScalingPolicy",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.RemoveAutoScalingPolicy": [
            {
                "action": "elasticmapreduce:RemoveAutoScalingPolicy",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.RemoveManagedScalingPolicy": [
            {
                "action": "elasticmapreduce:RemoveManagedScalingPolicy",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.RemoveTags": [
            {
                "action": "elasticmapreduce:RemoveTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceId}%%",
                    "editor": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "EMR.RunJobFlow": [
            {
                "action": "elasticmapreduce:RunJobFlow",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${JobFlowRole}%${ServiceRole}%${AutoScalingRole}%%"
                }
            }
        ],
        "EMR.SetTerminationProtection": [
            {
                "action": "elasticmapreduce:SetTerminationProtection",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EMR.TerminateJobFlows": [
            {
                "action": "elasticmapreduce:TerminateJobFlows",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ES.AcceptInboundCrossClusterSearchConnection": [
            {
                "action": "es:AcceptInboundCrossClusterSearchConnection",
                "resource_mappings": {}
            }
        ],
        "ES.AddTags": [
            {
                "action": "es:AddTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${ARN}%%"
                }
            }
        ],
        "ES.CreateElasticsearchDomain": [
            {
                "action": "es:CreateElasticsearchDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${CognitoOptions.RoleArn}%${AdvancedSecurityOptions.SAMLOptions.MasterBackendRole}%%"
                }
            }
        ],
        "ES.CreateOutboundCrossClusterSearchConnection": [
            {
                "action": "es:CreateOutboundCrossClusterSearchConnection",
                "resource_mappings": {
                    "DomainName": {
                        "template": "%%many%${SourceDomainInfo.DomainName}%${DestinationDomainInfo.DomainName}%%"
                    }
                }
            }
        ],
        "ES.DeleteElasticsearchDomain": [
            {
                "action": "es:DeleteElasticsearchDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.DeleteElasticsearchServiceRole": [
            {
                "action": "es:DeleteElasticsearchServiceRole",
                "resource_mappings": {}
            }
        ],
        "ES.DeleteInboundCrossClusterSearchConnection": [
            {
                "action": "es:DeleteInboundCrossClusterSearchConnection",
                "resource_mappings": {}
            }
        ],
        "ES.DeleteOutboundCrossClusterSearchConnection": [
            {
                "action": "es:DeleteOutboundCrossClusterSearchConnection",
                "resource_mappings": {}
            }
        ],
        "ES.DescribeElasticsearchDomain": [
            {
                "action": "es:DescribeElasticsearchDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.DescribeElasticsearchDomainConfig": [
            {
                "action": "es:DescribeElasticsearchDomainConfig",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.DescribeElasticsearchDomains": [
            {
                "action": "es:DescribeElasticsearchDomains",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainNames[]}"
                    }
                }
            }
        ],
        "ES.DescribeElasticsearchInstanceTypeLimits": [
            {
                "action": "es:DescribeElasticsearchInstanceTypeLimits",
                "resource_mappings": {}
            }
        ],
        "ES.DescribeInboundCrossClusterSearchConnections": [
            {
                "action": "es:DescribeInboundCrossClusterSearchConnections",
                "resource_mappings": {}
            }
        ],
        "ES.DescribeOutboundCrossClusterSearchConnections": [
            {
                "action": "es:DescribeOutboundCrossClusterSearchConnections",
                "resource_mappings": {}
            }
        ],
        "ES.DescribeReservedElasticsearchInstanceOfferings": [
            {
                "action": "es:DescribeReservedElasticsearchInstanceOfferings",
                "resource_mappings": {}
            }
        ],
        "ES.DescribeReservedElasticsearchInstances": [
            {
                "action": "es:DescribeReservedElasticsearchInstances",
                "resource_mappings": {}
            }
        ],
        "ES.GetCompatibleElasticsearchVersions": [
            {
                "action": "es:GetCompatibleElasticsearchVersions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.GetUpgradeHistory": [
            {
                "action": "es:GetUpgradeHistory",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.GetUpgradeStatus": [
            {
                "action": "es:GetUpgradeStatus",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.ListDomainNames": [
            {
                "action": "es:ListDomainNames",
                "resource_mappings": {}
            }
        ],
        "ES.ListElasticsearchInstanceTypes": [
            {
                "action": "es:ListElasticsearchInstanceTypes",
                "resource_mappings": {}
            }
        ],
        "ES.ListElasticsearchVersions": [
            {
                "action": "es:ListElasticsearchVersions",
                "resource_mappings": {}
            }
        ],
        "ES.ListTags": [
            {
                "action": "es:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${ARN}%%"
                }
            }
        ],
        "ES.PurchaseReservedElasticsearchInstanceOffering": [
            {
                "action": "es:PurchaseReservedElasticsearchInstanceOffering",
                "resource_mappings": {}
            }
        ],
        "ES.RejectInboundCrossClusterSearchConnection": [
            {
                "action": "es:RejectInboundCrossClusterSearchConnection",
                "resource_mappings": {}
            }
        ],
        "ES.RemoveTags": [
            {
                "action": "es:RemoveTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${ARN}%%"
                }
            }
        ],
        "ES.UpdateElasticsearchDomainConfig": [
            {
                "action": "es:UpdateElasticsearchDomainConfig",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${CognitoOptions.RoleArn}%${AdvancedSecurityOptions.SAMLOptions.MasterBackendRole}%%"
                }
            }
        ],
        "ES.UpgradeElasticsearchDomain": [
            {
                "action": "es:UpgradeElasticsearchDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ElasticTranscoder.CancelJob": [
            {
                "action": "elastictranscoder:CancelJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ElasticTranscoder.CreateJob": [
            {
                "action": "elastictranscoder:CreateJob",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "${PipelineId}"
                    },
                    "PresetId": {
                        "template": "%%many%${Output.PresetId}%${Outputs[].PresetId}%%"
                    }
                }
            }
        ],
        "ElasticTranscoder.CreatePipeline": [
            {
                "action": "elastictranscoder:CreatePipeline",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "ElasticTranscoder.CreatePreset": [
            {
                "action": "elastictranscoder:CreatePreset",
                "resource_mappings": {
                    "PresetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ElasticTranscoder.DeletePipeline": [
            {
                "action": "elastictranscoder:DeletePipeline",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ElasticTranscoder.DeletePreset": [
            {
                "action": "elastictranscoder:DeletePreset",
                "resource_mappings": {
                    "PresetId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ElasticTranscoder.ListJobsByPipeline": [
            {
                "action": "elastictranscoder:ListJobsByPipeline",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "${PipelineId}"
                    }
                }
            }
        ],
        "ElasticTranscoder.ListJobsByStatus": [
            {
                "action": "elastictranscoder:ListJobsByStatus",
                "resource_mappings": {}
            }
        ],
        "ElasticTranscoder.ListPipelines": [
            {
                "action": "elastictranscoder:ListPipelines",
                "resource_mappings": {}
            }
        ],
        "ElasticTranscoder.ListPresets": [
            {
                "action": "elastictranscoder:ListPresets",
                "resource_mappings": {}
            }
        ],
        "ElasticTranscoder.ReadJob": [
            {
                "action": "elastictranscoder:ReadJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ElasticTranscoder.ReadPipeline": [
            {
                "action": "elastictranscoder:ReadPipeline",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ElasticTranscoder.ReadPreset": [
            {
                "action": "elastictranscoder:ReadPreset",
                "resource_mappings": {
                    "PresetId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ElasticTranscoder.TestRole": [
            {
                "action": "elastictranscoder:TestRole",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "ElasticTranscoder.UpdatePipeline": [
            {
                "action": "elastictranscoder:UpdatePipeline",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "${Id}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "ElasticTranscoder.UpdatePipelineNotifications": [
            {
                "action": "elastictranscoder:UpdatePipelineNotifications",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ElasticTranscoder.UpdatePipelineStatus": [
            {
                "action": "elastictranscoder:UpdatePipeline",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "${Id}"
                    }
                }
            },
            {
                "action": "elastictranscoder:UpdatePipelineNotifications",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "${Id}"
                    }
                }
            },
            {
                "action": "elastictranscoder:UpdatePipelineStatus",
                "resource_mappings": {
                    "PipelineId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Firehose.CreateDeliveryStream": [
            {
                "action": "firehose:CreateDeliveryStream",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${KinesisStreamSourceConfiguration.RoleARN}%${S3DestinationConfiguration.RoleARN}%${ExtendedS3DestinationConfiguration.RoleARN}%${ExtendedS3DestinationConfiguration.S3BackupConfiguration.RoleARN}%${ExtendedS3DestinationConfiguration.DataFormatConversionConfiguration.SchemaConfiguration.RoleARN}%${RedshiftDestinationConfiguration.RoleARN}%${RedshiftDestinationConfiguration.S3Configuration.RoleARN}%${RedshiftDestinationConfiguration.S3BackupConfiguration.RoleARN}%${ElasticsearchDestinationConfiguration.RoleARN}%${ElasticsearchDestinationConfiguration.S3Configuration.RoleARN}%${ElasticsearchDestinationConfiguration.VpcConfiguration.RoleARN}%${SplunkDestinationConfiguration.S3Configuration.RoleARN}%%"
                }
            }
        ],
        "Firehose.DeleteDeliveryStream": [
            {
                "action": "firehose:DeleteDeliveryStream",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            }
        ],
        "Firehose.DescribeDeliveryStream": [
            {
                "action": "firehose:DescribeDeliveryStream",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            }
        ],
        "Firehose.ListDeliveryStreams": [
            {
                "action": "firehose:ListDeliveryStreams",
                "resource_mappings": {}
            }
        ],
        "Firehose.ListTagsForDeliveryStream": [
            {
                "action": "firehose:ListTagsForDeliveryStream",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            }
        ],
        "Firehose.PutRecord": [
            {
                "action": "firehose:PutRecord",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            }
        ],
        "Firehose.PutRecordBatch": [
            {
                "action": "firehose:PutRecordBatch",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            }
        ],
        "Firehose.StartDeliveryStreamEncryption": [
            {
                "action": "firehose:StartDeliveryStreamEncryption",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            }
        ],
        "Firehose.StopDeliveryStreamEncryption": [
            {
                "action": "firehose:StopDeliveryStreamEncryption",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            }
        ],
        "Firehose.TagDeliveryStream": [
            {
                "action": "firehose:TagDeliveryStream",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            }
        ],
        "Firehose.UntagDeliveryStream": [
            {
                "action": "firehose:UntagDeliveryStream",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            }
        ],
        "Firehose.UpdateDestination": [
            {
                "action": "firehose:UpdateDestination",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${DeliveryStreamName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${S3DestinationUpdate.RoleARN}%${ExtendedS3DestinationUpdate.RoleARN}%${ExtendedS3DestinationUpdate.S3BackupUpdate.RoleARN}%${ExtendedS3DestinationUpdate.DataFormatConversionConfiguration.SchemaConfiguration.RoleARN}%${RedshiftDestinationUpdate.RoleARN}%${RedshiftDestinationUpdate.S3Update.RoleARN}%${RedshiftDestinationUpdate.S3BackupUpdate.RoleARN}%${ElasticsearchDestinationUpdate.RoleARN}%${ElasticsearchDestinationUpdate.S3Update.RoleARN}%${SplunkDestinationUpdate.S3Update.RoleARN}%${HttpEndpointDestinationUpdate.RoleARN}%${HttpEndpointDestinationUpdate.S3Update.RoleARN}%%"
                }
            }
        ],
        "GameLift.AcceptMatch": [
            {
                "action": "gamelift:AcceptMatch",
                "resource_mappings": {}
            }
        ],
        "GameLift.ClaimGameServer": [
            {
                "action": "gamelift:ClaimGameServer",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.CreateAlias": [
            {
                "action": "gamelift:CreateAlias",
                "resource_mappings": {}
            }
        ],
        "GameLift.CreateBuild": [
            {
                "action": "gamelift:CreateBuild",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${StorageLocation.RoleArn}"
                }
            }
        ],
        "GameLift.CreateFleet": [
            {
                "action": "gamelift:CreateFleet",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${InstanceRoleArn}"
                }
            }
        ],
        "GameLift.CreateGameServerGroup": [
            {
                "action": "gamelift:CreateGameServerGroup",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateId}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${LaunchTemplate.LaunchTemplateName}%*%%%"
                }
            }
        ],
        "GameLift.CreateGameSession": [
            {
                "action": "gamelift:CreateGameSession",
                "resource_mappings": {}
            }
        ],
        "GameLift.CreateGameSessionQueue": [
            {
                "action": "gamelift:CreateGameSessionQueue",
                "resource_mappings": {}
            }
        ],
        "GameLift.CreateMatchmakingConfiguration": [
            {
                "action": "gamelift:CreateMatchmakingConfiguration",
                "resource_mappings": {}
            }
        ],
        "GameLift.CreateMatchmakingRuleSet": [
            {
                "action": "gamelift:CreateMatchmakingRuleSet",
                "resource_mappings": {}
            }
        ],
        "GameLift.CreatePlayerSession": [
            {
                "action": "gamelift:CreatePlayerSession",
                "resource_mappings": {}
            }
        ],
        "GameLift.CreatePlayerSessions": [
            {
                "action": "gamelift:CreatePlayerSessions",
                "resource_mappings": {}
            }
        ],
        "GameLift.CreateScript": [
            {
                "action": "gamelift:CreateScript",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${StorageLocation.RoleArn}"
                }
            }
        ],
        "GameLift.CreateVpcPeeringAuthorization": [
            {
                "action": "gamelift:CreateVpcPeeringAuthorization",
                "resource_mappings": {}
            }
        ],
        "GameLift.CreateVpcPeeringConnection": [
            {
                "action": "gamelift:CreateVpcPeeringConnection",
                "resource_mappings": {}
            }
        ],
        "GameLift.DeleteAlias": [
            {
                "action": "gamelift:DeleteAlias",
                "resource_mappings": {
                    "AliasId": {
                        "template": "${AliasId}"
                    }
                }
            }
        ],
        "GameLift.DeleteBuild": [
            {
                "action": "gamelift:DeleteBuild",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "BuildId": {
                        "template": "${BuildId}"
                    }
                }
            }
        ],
        "GameLift.DeleteFleet": [
            {
                "action": "gamelift:DeleteFleet",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DeleteGameServerGroup": [
            {
                "action": "gamelift:DeleteGameServerGroup",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.DeleteGameSessionQueue": [
            {
                "action": "gamelift:DeleteGameSessionQueue",
                "resource_mappings": {
                    "GameSessionQueueName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "GameLift.DeleteMatchmakingConfiguration": [
            {
                "action": "gamelift:DeleteMatchmakingConfiguration",
                "resource_mappings": {
                    "MatchmakingConfigurationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "GameLift.DeleteMatchmakingRuleSet": [
            {
                "action": "gamelift:DeleteMatchmakingRuleSet",
                "resource_mappings": {
                    "MatchmakingRuleSetName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "GameLift.DeleteScalingPolicy": [
            {
                "action": "gamelift:DeleteScalingPolicy",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DeleteScript": [
            {
                "action": "gamelift:DeleteScript",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "ScriptId": {
                        "template": "${ScriptId}"
                    }
                }
            }
        ],
        "GameLift.DeleteVpcPeeringAuthorization": [
            {
                "action": "gamelift:DeleteVpcPeeringAuthorization",
                "resource_mappings": {}
            }
        ],
        "GameLift.DeleteVpcPeeringConnection": [
            {
                "action": "gamelift:DeleteVpcPeeringConnection",
                "resource_mappings": {}
            }
        ],
        "GameLift.DeregisterGameServer": [
            {
                "action": "gamelift:DeregisterGameServer",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.DescribeAlias": [
            {
                "action": "gamelift:DescribeAlias",
                "resource_mappings": {
                    "AliasId": {
                        "template": "${AliasId}"
                    }
                }
            }
        ],
        "GameLift.DescribeBuild": [
            {
                "action": "gamelift:DescribeBuild",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "BuildId": {
                        "template": "${BuildId}"
                    }
                }
            }
        ],
        "GameLift.DescribeEC2InstanceLimits": [
            {
                "action": "gamelift:DescribeEC2InstanceLimits",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeFleetAttributes": [
            {
                "action": "gamelift:DescribeFleetAttributes",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeFleetCapacity": [
            {
                "action": "gamelift:DescribeFleetCapacity",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeFleetEvents": [
            {
                "action": "gamelift:DescribeFleetEvents",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DescribeFleetPortSettings": [
            {
                "action": "gamelift:DescribeFleetPortSettings",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DescribeFleetUtilization": [
            {
                "action": "gamelift:DescribeFleetUtilization",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeGameServer": [
            {
                "action": "gamelift:DescribeGameServer",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.DescribeGameServerGroup": [
            {
                "action": "gamelift:DescribeGameServerGroup",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.DescribeGameServerInstances": [
            {
                "action": "gamelift:DescribeGameServerInstances",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.DescribeGameSessionDetails": [
            {
                "action": "gamelift:DescribeGameSessionDetails",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeGameSessionPlacement": [
            {
                "action": "gamelift:DescribeGameSessionPlacement",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeGameSessionQueues": [
            {
                "action": "gamelift:DescribeGameSessionQueues",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeGameSessions": [
            {
                "action": "gamelift:DescribeGameSessions",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeInstances": [
            {
                "action": "gamelift:DescribeInstances",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DescribeMatchmaking": [
            {
                "action": "gamelift:DescribeMatchmaking",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeMatchmakingConfigurations": [
            {
                "action": "gamelift:DescribeMatchmakingConfigurations",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeMatchmakingRuleSets": [
            {
                "action": "gamelift:DescribeMatchmakingRuleSets",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribePlayerSessions": [
            {
                "action": "gamelift:DescribePlayerSessions",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeRuntimeConfiguration": [
            {
                "action": "gamelift:DescribeRuntimeConfiguration",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DescribeScalingPolicies": [
            {
                "action": "gamelift:DescribeScalingPolicies",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DescribeScript": [
            {
                "action": "gamelift:DescribeScript",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "ScriptId": {
                        "template": "${ScriptId}"
                    }
                }
            }
        ],
        "GameLift.DescribeVpcPeeringAuthorizations": [
            {
                "action": "gamelift:DescribeVpcPeeringAuthorizations",
                "resource_mappings": {}
            }
        ],
        "GameLift.DescribeVpcPeeringConnections": [
            {
                "action": "gamelift:DescribeVpcPeeringConnections",
                "resource_mappings": {}
            }
        ],
        "GameLift.GetGameSessionLogUrl": [
            {
                "action": "gamelift:GetGameSessionLogUrl",
                "resource_mappings": {}
            }
        ],
        "GameLift.GetInstanceAccess": [
            {
                "action": "gamelift:GetInstanceAccess",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.ListAliases": [
            {
                "action": "gamelift:ListAliases",
                "resource_mappings": {}
            }
        ],
        "GameLift.ListBuilds": [
            {
                "action": "gamelift:ListBuilds",
                "resource_mappings": {}
            }
        ],
        "GameLift.ListFleets": [
            {
                "action": "gamelift:ListFleets",
                "resource_mappings": {}
            }
        ],
        "GameLift.ListGameServerGroups": [
            {
                "action": "gamelift:ListGameServerGroups",
                "resource_mappings": {}
            }
        ],
        "GameLift.ListGameServers": [
            {
                "action": "gamelift:ListGameServers",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.ListScripts": [
            {
                "action": "gamelift:ListScripts",
                "resource_mappings": {}
            }
        ],
        "GameLift.ListTagsForResource": [
            {
                "action": "gamelift:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "alias": "%%iftemplatematch%${ResourceARN}%%",
                    "build": "%%iftemplatematch%${ResourceARN}%%",
                    "fleet": "%%iftemplatematch%${ResourceARN}%%",
                    "gameServerGroup": "%%iftemplatematch%${ResourceARN}%%",
                    "gameSessionQueue": "%%iftemplatematch%${ResourceARN}%%",
                    "matchmakingConfiguration": "%%iftemplatematch%${ResourceARN}%%",
                    "matchmakingRuleSet": "%%iftemplatematch%${ResourceARN}%%",
                    "script": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "GameLift.PutScalingPolicy": [
            {
                "action": "gamelift:PutScalingPolicy",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.RegisterGameServer": [
            {
                "action": "gamelift:RegisterGameServer",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.RequestUploadCredentials": [
            {
                "action": "gamelift:RequestUploadCredentials",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "BuildId": {
                        "template": "${BuildId}"
                    }
                }
            }
        ],
        "GameLift.ResolveAlias": [
            {
                "action": "gamelift:ResolveAlias",
                "resource_mappings": {
                    "AliasId": {
                        "template": "${AliasId}"
                    }
                }
            }
        ],
        "GameLift.ResumeGameServerGroup": [
            {
                "action": "gamelift:ResumeGameServerGroup",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.SearchGameSessions": [
            {
                "action": "gamelift:SearchGameSessions",
                "resource_mappings": {}
            }
        ],
        "GameLift.StartFleetActions": [
            {
                "action": "gamelift:StartFleetActions",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.StartGameSessionPlacement": [
            {
                "action": "gamelift:StartGameSessionPlacement",
                "resource_mappings": {
                    "GameSessionQueueName": {
                        "template": "${GameSessionQueueName}"
                    }
                }
            }
        ],
        "GameLift.StartMatchBackfill": [
            {
                "action": "gamelift:StartMatchBackfill",
                "resource_mappings": {}
            }
        ],
        "GameLift.StartMatchmaking": [
            {
                "action": "gamelift:StartMatchmaking",
                "resource_mappings": {}
            }
        ],
        "GameLift.StopFleetActions": [
            {
                "action": "gamelift:StopFleetActions",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.StopGameSessionPlacement": [
            {
                "action": "gamelift:StopGameSessionPlacement",
                "resource_mappings": {}
            }
        ],
        "GameLift.StopMatchmaking": [
            {
                "action": "gamelift:StopMatchmaking",
                "resource_mappings": {}
            }
        ],
        "GameLift.SuspendGameServerGroup": [
            {
                "action": "gamelift:SuspendGameServerGroup",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.TagResource": [
            {
                "action": "gamelift:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "alias": "%%iftemplatematch%${ResourceARN}%%",
                    "build": "%%iftemplatematch%${ResourceARN}%%",
                    "fleet": "%%iftemplatematch%${ResourceARN}%%",
                    "gameServerGroup": "%%iftemplatematch%${ResourceARN}%%",
                    "gameSessionQueue": "%%iftemplatematch%${ResourceARN}%%",
                    "matchmakingConfiguration": "%%iftemplatematch%${ResourceARN}%%",
                    "matchmakingRuleSet": "%%iftemplatematch%${ResourceARN}%%",
                    "script": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "GameLift.UntagResource": [
            {
                "action": "gamelift:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "alias": "%%iftemplatematch%${ResourceARN}%%",
                    "build": "%%iftemplatematch%${ResourceARN}%%",
                    "fleet": "%%iftemplatematch%${ResourceARN}%%",
                    "gameServerGroup": "%%iftemplatematch%${ResourceARN}%%",
                    "gameSessionQueue": "%%iftemplatematch%${ResourceARN}%%",
                    "matchmakingConfiguration": "%%iftemplatematch%${ResourceARN}%%",
                    "matchmakingRuleSet": "%%iftemplatematch%${ResourceARN}%%",
                    "script": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "GameLift.UpdateAlias": [
            {
                "action": "gamelift:UpdateAlias",
                "resource_mappings": {
                    "AliasId": {
                        "template": "${AliasId}"
                    }
                }
            }
        ],
        "GameLift.UpdateBuild": [
            {
                "action": "gamelift:UpdateBuild",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "BuildId": {
                        "template": "${BuildId}"
                    }
                }
            }
        ],
        "GameLift.UpdateFleetAttributes": [
            {
                "action": "gamelift:UpdateFleetAttributes",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.UpdateFleetCapacity": [
            {
                "action": "gamelift:UpdateFleetCapacity",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.UpdateFleetPortSettings": [
            {
                "action": "gamelift:UpdateFleetPortSettings",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.UpdateGameServer": [
            {
                "action": "gamelift:UpdateGameServer",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            }
        ],
        "GameLift.UpdateGameServerGroup": [
            {
                "action": "gamelift:UpdateGameServerGroup",
                "resource_mappings": {
                    "GameServerGroupName": {
                        "template": "${GameServerGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "GameLift.UpdateGameSession": [
            {
                "action": "gamelift:UpdateGameSession",
                "resource_mappings": {}
            }
        ],
        "GameLift.UpdateGameSessionQueue": [
            {
                "action": "gamelift:UpdateGameSessionQueue",
                "resource_mappings": {
                    "GameSessionQueueName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "GameLift.UpdateMatchmakingConfiguration": [
            {
                "action": "gamelift:UpdateMatchmakingConfiguration",
                "resource_mappings": {
                    "MatchmakingConfigurationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "GameLift.UpdateRuntimeConfiguration": [
            {
                "action": "gamelift:UpdateRuntimeConfiguration",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.UpdateScript": [
            {
                "action": "gamelift:UpdateScript",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "ScriptId": {
                        "template": "${ScriptId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${StorageLocation.RoleArn}"
                }
            }
        ],
        "GameLift.ValidateMatchmakingRuleSet": [
            {
                "action": "gamelift:ValidateMatchmakingRuleSet",
                "resource_mappings": {}
            }
        ],
        "Glacier.AbortMultipartUpload": [
            {
                "action": "glacier:AbortMultipartUpload",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.AbortVaultLock": [
            {
                "action": "glacier:AbortVaultLock",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.AddTagsToVault": [
            {
                "action": "glacier:AddTagsToVault",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.CompleteMultipartUpload": [
            {
                "action": "glacier:CompleteMultipartUpload",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.CompleteVaultLock": [
            {
                "action": "glacier:CompleteVaultLock",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.CreateVault": [
            {
                "action": "glacier:CreateVault",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.DeleteArchive": [
            {
                "action": "glacier:DeleteArchive",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.DeleteVault": [
            {
                "action": "glacier:DeleteVault",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.DeleteVaultAccessPolicy": [
            {
                "action": "glacier:DeleteVaultAccessPolicy",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.DeleteVaultNotifications": [
            {
                "action": "glacier:DeleteVaultNotifications",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.DescribeJob": [
            {
                "action": "glacier:DescribeJob",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.DescribeVault": [
            {
                "action": "glacier:DescribeVault",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.GetDataRetrievalPolicy": [
            {
                "action": "glacier:GetDataRetrievalPolicy",
                "resource_mappings": {}
            }
        ],
        "Glacier.GetJobOutput": [
            {
                "action": "glacier:GetJobOutput",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.GetVaultAccessPolicy": [
            {
                "action": "glacier:GetVaultAccessPolicy",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.GetVaultLock": [
            {
                "action": "glacier:GetVaultLock",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.GetVaultNotifications": [
            {
                "action": "glacier:GetVaultNotifications",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.InitiateJob": [
            {
                "action": "glacier:InitiateJob",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.InitiateMultipartUpload": [
            {
                "action": "glacier:InitiateMultipartUpload",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.InitiateVaultLock": [
            {
                "action": "glacier:InitiateVaultLock",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.ListJobs": [
            {
                "action": "glacier:ListJobs",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.ListMultipartUploads": [
            {
                "action": "glacier:ListMultipartUploads",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.ListParts": [
            {
                "action": "glacier:ListParts",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.ListProvisionedCapacity": [
            {
                "action": "glacier:ListProvisionedCapacity",
                "resource_mappings": {}
            }
        ],
        "Glacier.ListTagsForVault": [
            {
                "action": "glacier:ListTagsForVault",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.ListVaults": [
            {
                "action": "glacier:ListVaults",
                "resource_mappings": {}
            }
        ],
        "Glacier.PurchaseProvisionedCapacity": [
            {
                "action": "glacier:PurchaseProvisionedCapacity",
                "resource_mappings": {}
            }
        ],
        "Glacier.RemoveTagsFromVault": [
            {
                "action": "glacier:RemoveTagsFromVault",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.SetDataRetrievalPolicy": [
            {
                "action": "glacier:SetDataRetrievalPolicy",
                "resource_mappings": {}
            }
        ],
        "Glacier.SetVaultAccessPolicy": [
            {
                "action": "glacier:SetVaultAccessPolicy",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.SetVaultNotifications": [
            {
                "action": "glacier:SetVaultNotifications",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.UploadArchive": [
            {
                "action": "glacier:UploadArchive",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Glacier.UploadMultipartPart": [
            {
                "action": "glacier:UploadMultipartPart",
                "resource_mappings": {
                    "VaultName": {
                        "template": "${vaultName}"
                    }
                }
            }
        ],
        "Health.DescribeAffectedAccountsForOrganization": [
            {
                "action": "health:DescribeAffectedAccountsForOrganization",
                "resource_mappings": {}
            },
            {
                "action": "organizations:ListAccounts",
                "resource_mappings": {}
            }
        ],
        "Health.DescribeAffectedEntities": [
            {
                "action": "health:DescribeAffectedEntities",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event": "${filter.eventArns[]}"
                }
            }
        ],
        "Health.DescribeAffectedEntitiesForOrganization": [
            {
                "action": "health:DescribeAffectedEntitiesForOrganization",
                "resource_mappings": {}
            },
            {
                "action": "organizations:ListAccounts",
                "resource_mappings": {}
            }
        ],
        "Health.DescribeEntityAggregates": [
            {
                "action": "health:DescribeEntityAggregates",
                "resource_mappings": {}
            }
        ],
        "Health.DescribeEventAggregates": [
            {
                "action": "health:DescribeEventAggregates",
                "resource_mappings": {}
            }
        ],
        "Health.DescribeEventDetails": [
            {
                "action": "health:DescribeEventDetails",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event": "${eventArns}"
                }
            }
        ],
        "Health.DescribeEventDetailsForOrganization": [
            {
                "action": "health:DescribeEventDetailsForOrganization",
                "resource_mappings": {}
            },
            {
                "action": "organizations:ListAccounts",
                "resource_mappings": {}
            }
        ],
        "Health.DescribeEventTypes": [
            {
                "action": "health:DescribeEventTypes",
                "resource_mappings": {}
            }
        ],
        "Health.DescribeEvents": [
            {
                "action": "health:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "Health.DescribeEventsForOrganization": [
            {
                "action": "health:DescribeEventsForOrganization",
                "resource_mappings": {}
            },
            {
                "action": "organizations:ListAccounts",
                "resource_mappings": {}
            }
        ],
        "Health.DescribeHealthServiceStatusForOrganization": [
            {
                "action": "health:DescribeHealthServiceStatusForOrganization",
                "resource_mappings": {}
            },
            {
                "action": "organizations:ListAccounts",
                "resource_mappings": {}
            }
        ],
        "Health.DisableHealthServiceAccessForOrganization": [
            {
                "action": "health:DisableHealthServiceAccessForOrganization",
                "resource_mappings": {}
            },
            {
                "action": "organizations:DisableAWSServiceAccess",
                "resource_mappings": {}
            }
        ],
        "Health.EnableHealthServiceAccessForOrganization": [
            {
                "action": "health:EnableHealthServiceAccessForOrganization",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.AddClientIDToOpenIDConnectProvider": [
            {
                "action": "iam:AddClientIDToOpenIDConnectProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "oidc-provider": "${OpenIDConnectProviderArn}"
                }
            }
        ],
        "IAM.AddRoleToInstanceProfile": [
            {
                "action": "iam:AddRoleToInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "${InstanceProfileName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${RoleName}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${InstanceProfileName}%*%%%"
                }
            }
        ],
        "IAM.AddUserToGroup": [
            {
                "action": "iam:AddUserToGroup",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.AttachGroupPolicy": [
            {
                "action": "iam:AttachGroupPolicy",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.AttachRolePolicy": [
            {
                "action": "iam:AttachRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.AttachUserPolicy": [
            {
                "action": "iam:AttachUserPolicy",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ChangePassword": [
            {
                "action": "iam:ChangePassword",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${aws:username}"
                    }
                }
            }
        ],
        "IAM.CreateAccessKey": [
            {
                "action": "iam:CreateAccessKey",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.CreateAccountAlias": [
            {
                "action": "iam:CreateAccountAlias",
                "resource_mappings": {}
            }
        ],
        "IAM.CreateGroup": [
            {
                "action": "iam:CreateGroup",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "%%regex%${Path}%/^\\/(.+)$/g%%${GroupName}"
                    }
                }
            }
        ],
        "IAM.CreateInstanceProfile": [
            {
                "action": "iam:CreateInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "%%regex%${Path}%/^\\/(.+)$/g%%${InstanceProfileName}"
                    }
                }
            }
        ],
        "IAM.CreateLoginProfile": [
            {
                "action": "iam:CreateLoginProfile",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.CreateOpenIDConnectProvider": [
            {
                "action": "iam:CreateOpenIDConnectProvider",
                "resource_mappings": {
                    "OidcProviderName": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.CreatePolicy": [
            {
                "action": "iam:CreatePolicy",
                "resource_mappings": {
                    "PolicyNameWithPath": {
                        "template": "%%regex%${Path}%/^\\/(.+)$/g%%${PolicyName}"
                    }
                }
            }
        ],
        "IAM.CreatePolicyVersion": [
            {
                "action": "iam:CreatePolicyVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.CreateRole": [
            {
                "action": "iam:CreateRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "%%regex%${Path}%/^\\/(.+)$/g%%${RoleName}"
                    }
                }
            }
        ],
        "IAM.CreateSAMLProvider": [
            {
                "action": "iam:CreateSAMLProvider",
                "resource_mappings": {
                    "SamlProviderName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "IAM.CreateServiceLinkedRole": [
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.CreateServiceSpecificCredential": [
            {
                "action": "iam:CreateServiceSpecificCredential",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.CreateUser": [
            {
                "action": "iam:CreateUser",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "%%regex%${Path}%/^\\/(.+)$/g%%${UserName}"
                    }
                }
            }
        ],
        "IAM.CreateVirtualMFADevice": [
            {
                "action": "iam:CreateVirtualMFADevice",
                "resource_mappings": {
                    "MfaTokenIdWithPath": {
                        "template": "%%regex%${Path}%/^\\/(.+)$/g%%*"
                    }
                }
            }
        ],
        "IAM.DeactivateMFADevice": [
            {
                "action": "iam:DeactivateMFADevice",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.DeleteAccessKey": [
            {
                "action": "iam:DeleteAccessKey",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.DeleteAccountAlias": [
            {
                "action": "iam:DeleteAccountAlias",
                "resource_mappings": {}
            }
        ],
        "IAM.DeleteAccountPasswordPolicy": [
            {
                "action": "iam:DeleteAccountPasswordPolicy",
                "resource_mappings": {}
            }
        ],
        "IAM.DeleteGroup": [
            {
                "action": "iam:DeleteGroup",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.DeleteGroupPolicy": [
            {
                "action": "iam:DeleteGroupPolicy",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.DeleteInstanceProfile": [
            {
                "action": "iam:DeleteInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "${InstanceProfileName}"
                    }
                }
            }
        ],
        "IAM.DeleteLoginProfile": [
            {
                "action": "iam:DeleteLoginProfile",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.DeleteOpenIDConnectProvider": [
            {
                "action": "iam:DeleteOpenIDConnectProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "oidc-provider": "${OpenIDConnectProviderArn}"
                }
            }
        ],
        "IAM.DeletePolicy": [
            {
                "action": "iam:DeletePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.DeletePolicyVersion": [
            {
                "action": "iam:DeletePolicyVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.DeleteRole": [
            {
                "action": "iam:DeleteRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.DeleteRolePermissionsBoundary": [
            {
                "action": "iam:DeleteRolePermissionsBoundary",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.DeleteRolePolicy": [
            {
                "action": "iam:DeleteRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.DeleteSAMLProvider": [
            {
                "action": "iam:DeleteSAMLProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "saml-provider": "${SAMLProviderArn}"
                }
            }
        ],
        "IAM.DeleteSSHPublicKey": [
            {
                "action": "iam:DeleteSSHPublicKey",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.DeleteServerCertificate": [
            {
                "action": "iam:DeleteServerCertificate",
                "resource_mappings": {
                    "CertificateNameWithPath": {
                        "template": "${ServerCertificateName}"
                    }
                }
            }
        ],
        "IAM.DeleteServiceLinkedRole": [
            {
                "action": "iam:DeleteServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.DeleteServiceSpecificCredential": [
            {
                "action": "iam:DeleteServiceSpecificCredential",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.DeleteSigningCertificate": [
            {
                "action": "iam:DeleteSigningCertificate",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.DeleteUser": [
            {
                "action": "iam:DeleteUser",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.DeleteUserPermissionsBoundary": [
            {
                "action": "iam:DeleteUserPermissionsBoundary",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.DeleteUserPolicy": [
            {
                "action": "iam:DeleteUserPolicy",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.DeleteVirtualMFADevice": [
            {
                "action": "iam:DeleteVirtualMFADevice",
                "resource_mappings": {
                    "MfaTokenIdWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.DetachGroupPolicy": [
            {
                "action": "iam:DetachGroupPolicy",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.DetachRolePolicy": [
            {
                "action": "iam:DetachRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.DetachUserPolicy": [
            {
                "action": "iam:DetachUserPolicy",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.EnableMFADevice": [
            {
                "action": "iam:EnableMFADevice",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.GenerateCredentialReport": [
            {
                "action": "iam:GenerateCredentialReport",
                "resource_mappings": {}
            }
        ],
        "IAM.GenerateOrganizationsAccessReport": [
            {
                "action": "iam:GenerateOrganizationsAccessReport",
                "resource_mappings": {
                    "EntityPath": {
                        "template": "${EntityPath}"
                    }
                }
            },
            {
                "action": "organizations:DescribePolicy",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "%%regex%${OrganizationsPolicyId}%/^(?:p-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "IAM.GenerateServiceLastAccessedDetails": [
            {
                "action": "iam:GenerateServiceLastAccessedDetails",
                "resource_mappings": {}
            }
        ],
        "IAM.GetAccessKeyLastUsed": [
            {
                "action": "iam:GetAccessKeyLastUsed",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.GetAccountAuthorizationDetails": [
            {
                "action": "iam:GetAccountAuthorizationDetails",
                "resource_mappings": {}
            }
        ],
        "IAM.GetAccountPasswordPolicy": [
            {
                "action": "iam:GetAccountPasswordPolicy",
                "resource_mappings": {}
            }
        ],
        "IAM.GetAccountSummary": [
            {
                "action": "iam:GetAccountSummary",
                "resource_mappings": {}
            }
        ],
        "IAM.GetContextKeysForCustomPolicy": [
            {
                "action": "iam:GetContextKeysForCustomPolicy",
                "resource_mappings": {}
            }
        ],
        "IAM.GetContextKeysForPrincipalPolicy": [
            {
                "action": "iam:GetContextKeysForPrincipalPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "%%iftemplatematch%${PolicySourceArn}%%",
                    "role": "%%iftemplatematch%${PolicySourceArn}%%",
                    "user": "%%iftemplatematch%${PolicySourceArn}%%"
                }
            }
        ],
        "IAM.GetCredentialReport": [
            {
                "action": "iam:GetCredentialReport",
                "resource_mappings": {}
            }
        ],
        "IAM.GetGroup": [
            {
                "action": "iam:GetGroup",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.GetGroupPolicy": [
            {
                "action": "iam:GetGroupPolicy",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.GetInstanceProfile": [
            {
                "action": "iam:GetInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "${InstanceProfileName}"
                    }
                }
            }
        ],
        "IAM.GetLoginProfile": [
            {
                "action": "iam:GetLoginProfile",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.GetOpenIDConnectProvider": [
            {
                "action": "iam:GetOpenIDConnectProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "oidc-provider": "${OpenIDConnectProviderArn}"
                }
            }
        ],
        "IAM.GetOrganizationsAccessReport": [
            {
                "action": "iam:GetOrganizationsAccessReport",
                "resource_mappings": {}
            }
        ],
        "IAM.GetPolicy": [
            {
                "action": "iam:GetPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.GetPolicyVersion": [
            {
                "action": "iam:GetPolicyVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.GetRole": [
            {
                "action": "iam:GetRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.GetRolePolicy": [
            {
                "action": "iam:GetRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.GetSAMLProvider": [
            {
                "action": "iam:GetSAMLProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "saml-provider": "${SAMLProviderArn}"
                }
            }
        ],
        "IAM.GetSSHPublicKey": [
            {
                "action": "iam:GetSSHPublicKey",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.GetServerCertificate": [
            {
                "action": "iam:GetServerCertificate",
                "resource_mappings": {
                    "CertificateNameWithPath": {
                        "template": "${ServerCertificateName}"
                    }
                }
            }
        ],
        "IAM.GetServiceLastAccessedDetails": [
            {
                "action": "iam:GetServiceLastAccessedDetails",
                "resource_mappings": {}
            }
        ],
        "IAM.GetServiceLastAccessedDetailsWithEntities": [
            {
                "action": "iam:GetServiceLastAccessedDetailsWithEntities",
                "resource_mappings": {}
            }
        ],
        "IAM.GetServiceLinkedRoleDeletionStatus": [
            {
                "action": "iam:GetServiceLinkedRoleDeletionStatus",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.GetUser": [
            {
                "action": "iam:GetUser",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.GetUserPolicy": [
            {
                "action": "iam:GetUserPolicy",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ListAccessKeys": [
            {
                "action": "iam:ListAccessKeys",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ListAccountAliases": [
            {
                "action": "iam:ListAccountAliases",
                "resource_mappings": {}
            }
        ],
        "IAM.ListAttachedGroupPolicies": [
            {
                "action": "iam:ListAttachedGroupPolicies",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "%%regex%${PathPrefix}%/^\\/?(.+)\\/?$/g%%/${GroupName}"
                    }
                }
            }
        ],
        "IAM.ListAttachedRolePolicies": [
            {
                "action": "iam:ListAttachedRolePolicies",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "%%regex%${PathPrefix}%/^\\/?(.+)\\/?$/g%%/${RoleName}"
                    }
                }
            }
        ],
        "IAM.ListAttachedUserPolicies": [
            {
                "action": "iam:ListAttachedUserPolicies",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "%%regex%${PathPrefix}%/^\\/?(.+)\\/?$/g%%/${UserName}"
                    }
                }
            }
        ],
        "IAM.ListEntitiesForPolicy": [
            {
                "action": "iam:ListEntitiesForPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.ListGroupPolicies": [
            {
                "action": "iam:ListGroupPolicies",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.ListGroups": [
            {
                "action": "iam:ListGroups",
                "resource_mappings": {}
            }
        ],
        "IAM.ListGroupsForUser": [
            {
                "action": "iam:ListGroupsForUser",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ListInstanceProfiles": [
            {
                "action": "iam:ListInstanceProfiles",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "%%regex%${PathPrefix}%/^\\/?(.+)\\/?$/g%%/*"
                    }
                }
            }
        ],
        "IAM.ListInstanceProfilesForRole": [
            {
                "action": "iam:ListInstanceProfilesForRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.ListMFADevices": [
            {
                "action": "iam:ListMFADevices",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ListOpenIDConnectProviders": [
            {
                "action": "iam:ListOpenIDConnectProviders",
                "resource_mappings": {}
            }
        ],
        "IAM.ListPolicies": [
            {
                "action": "iam:ListPolicies",
                "resource_mappings": {}
            }
        ],
        "IAM.ListPoliciesGrantingServiceAccess": [
            {
                "action": "iam:ListPoliciesGrantingServiceAccess",
                "resource_mappings": {}
            }
        ],
        "IAM.ListPolicyVersions": [
            {
                "action": "iam:ListPolicyVersions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.ListRolePolicies": [
            {
                "action": "iam:ListRolePolicies",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.ListRoleTags": [
            {
                "action": "iam:ListRoleTags",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.ListRoles": [
            {
                "action": "iam:ListRoles",
                "resource_mappings": {}
            }
        ],
        "IAM.ListSAMLProviders": [
            {
                "action": "iam:ListSAMLProviders",
                "resource_mappings": {}
            }
        ],
        "IAM.ListSSHPublicKeys": [
            {
                "action": "iam:ListSSHPublicKeys",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ListServerCertificates": [
            {
                "action": "iam:ListServerCertificates",
                "resource_mappings": {}
            }
        ],
        "IAM.ListServiceSpecificCredentials": [
            {
                "action": "iam:ListServiceSpecificCredentials",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ListSigningCertificates": [
            {
                "action": "iam:ListSigningCertificates",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ListUserPolicies": [
            {
                "action": "iam:ListUserPolicies",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ListUserTags": [
            {
                "action": "iam:ListUserTags",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ListUsers": [
            {
                "action": "iam:ListUsers",
                "resource_mappings": {}
            }
        ],
        "IAM.ListVirtualMFADevices": [
            {
                "action": "iam:ListVirtualMFADevices",
                "resource_mappings": {}
            }
        ],
        "IAM.PutGroupPolicy": [
            {
                "action": "iam:PutGroupPolicy",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.PutRolePermissionsBoundary": [
            {
                "action": "iam:PutRolePermissionsBoundary",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.PutRolePolicy": [
            {
                "action": "iam:PutRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.PutUserPermissionsBoundary": [
            {
                "action": "iam:PutUserPermissionsBoundary",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.PutUserPolicy": [
            {
                "action": "iam:PutUserPolicy",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.RemoveClientIDFromOpenIDConnectProvider": [
            {
                "action": "iam:RemoveClientIDFromOpenIDConnectProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "oidc-provider": "${OpenIDConnectProviderArn}"
                }
            }
        ],
        "IAM.RemoveRoleFromInstanceProfile": [
            {
                "action": "iam:RemoveRoleFromInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "${InstanceProfileName}"
                    }
                }
            }
        ],
        "IAM.RemoveUserFromGroup": [
            {
                "action": "iam:RemoveUserFromGroup",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "IAM.ResetServiceSpecificCredential": [
            {
                "action": "iam:ResetServiceSpecificCredential",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.ResyncMFADevice": [
            {
                "action": "iam:ResyncMFADevice",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.SetDefaultPolicyVersion": [
            {
                "action": "iam:SetDefaultPolicyVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.SetSecurityTokenServicePreferences": [
            {
                "action": "iam:SetSecurityTokenServicePreferences",
                "resource_mappings": {}
            }
        ],
        "IAM.SimulateCustomPolicy": [
            {
                "action": "iam:SimulateCustomPolicy",
                "resource_mappings": {}
            }
        ],
        "IAM.SimulatePrincipalPolicy": [
            {
                "action": "iam:SimulatePrincipalPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "%%iftemplatematch%${PolicySourceArn}%%",
                    "role": "%%iftemplatematch%${PolicySourceArn}%%",
                    "user": "%%iftemplatematch%${PolicySourceArn}%%"
                }
            }
        ],
        "IAM.TagRole": [
            {
                "action": "iam:TagRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.TagUser": [
            {
                "action": "iam:TagUser",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.UntagRole": [
            {
                "action": "iam:UntagRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.UntagUser": [
            {
                "action": "iam:UntagUser",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.UpdateAccessKey": [
            {
                "action": "iam:UpdateAccessKey",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.UpdateAccountPasswordPolicy": [
            {
                "action": "iam:UpdateAccountPasswordPolicy",
                "resource_mappings": {}
            }
        ],
        "IAM.UpdateAssumeRolePolicy": [
            {
                "action": "iam:UpdateAssumeRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.UpdateGroup": [
            {
                "action": "iam:UpdateGroup",
                "resource_mappings": {
                    "GroupNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.UpdateLoginProfile": [
            {
                "action": "iam:UpdateLoginProfile",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.UpdateOpenIDConnectProviderThumbprint": [
            {
                "action": "iam:UpdateOpenIDConnectProviderThumbprint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "oidc-provider": "${OpenIDConnectProviderArn}"
                }
            }
        ],
        "IAM.UpdateRole": [
            {
                "action": "iam:UpdateRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.UpdateRoleDescription": [
            {
                "action": "iam:UpdateRoleDescription",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "${RoleName}"
                    }
                }
            }
        ],
        "IAM.UpdateSAMLProvider": [
            {
                "action": "iam:UpdateSAMLProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "saml-provider": "${SAMLProviderArn}"
                }
            }
        ],
        "IAM.UpdateSSHPublicKey": [
            {
                "action": "iam:UpdateSSHPublicKey",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.UpdateServerCertificate": [
            {
                "action": "iam:UpdateServerCertificate",
                "resource_mappings": {
                    "CertificateNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.UpdateServiceSpecificCredential": [
            {
                "action": "iam:UpdateServiceSpecificCredential",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.UpdateSigningCertificate": [
            {
                "action": "iam:UpdateSigningCertificate",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.UpdateUser": [
            {
                "action": "iam:UpdateUser",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.UploadSSHPublicKey": [
            {
                "action": "iam:UploadSSHPublicKey",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "IAM.UploadServerCertificate": [
            {
                "action": "iam:UploadServerCertificate",
                "resource_mappings": {
                    "CertificateNameWithPath": {
                        "template": "%%regex%${Path}%/^\\/(.+)$/g%%${ServerCertificateName}"
                    }
                }
            }
        ],
        "IAM.UploadSigningCertificate": [
            {
                "action": "iam:UploadSigningCertificate",
                "resource_mappings": {
                    "UserNameWithPath": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "ImportExport.CancelJob": [
            {
                "action": "importexport:CancelJob",
                "resource_mappings": {}
            }
        ],
        "ImportExport.CreateJob": [
            {
                "action": "importexport:CreateJob",
                "resource_mappings": {}
            }
        ],
        "ImportExport.GetShippingLabel": [
            {
                "action": "importexport:GetShippingLabel",
                "resource_mappings": {}
            }
        ],
        "ImportExport.GetStatus": [
            {
                "action": "importexport:GetStatus",
                "resource_mappings": {}
            }
        ],
        "ImportExport.ListJobs": [
            {
                "action": "importexport:ListJobs",
                "resource_mappings": {}
            }
        ],
        "ImportExport.UpdateJob": [
            {
                "action": "importexport:UpdateJob",
                "resource_mappings": {}
            }
        ],
        "Inspector.AddAttributesToFindings": [
            {
                "action": "inspector:AddAttributesToFindings",
                "resource_mappings": {}
            }
        ],
        "Inspector.CreateAssessmentTarget": [
            {
                "action": "inspector:CreateAssessmentTarget",
                "resource_mappings": {}
            }
        ],
        "Inspector.CreateAssessmentTemplate": [
            {
                "action": "inspector:CreateAssessmentTemplate",
                "resource_mappings": {}
            }
        ],
        "Inspector.CreateResourceGroup": [
            {
                "action": "inspector:CreateResourceGroup",
                "resource_mappings": {}
            }
        ],
        "Inspector.DeleteAssessmentRun": [
            {
                "action": "inspector:DeleteAssessmentRun",
                "resource_mappings": {}
            }
        ],
        "Inspector.DeleteAssessmentTarget": [
            {
                "action": "inspector:DeleteAssessmentTarget",
                "resource_mappings": {}
            }
        ],
        "Inspector.DeleteAssessmentTemplate": [
            {
                "action": "inspector:DeleteAssessmentTemplate",
                "resource_mappings": {}
            }
        ],
        "Inspector.DescribeAssessmentRuns": [
            {
                "action": "inspector:DescribeAssessmentRuns",
                "resource_mappings": {}
            }
        ],
        "Inspector.DescribeAssessmentTargets": [
            {
                "action": "inspector:DescribeAssessmentTargets",
                "resource_mappings": {}
            }
        ],
        "Inspector.DescribeAssessmentTemplates": [
            {
                "action": "inspector:DescribeAssessmentTemplates",
                "resource_mappings": {}
            }
        ],
        "Inspector.DescribeCrossAccountAccessRole": [
            {
                "action": "inspector:DescribeCrossAccountAccessRole",
                "resource_mappings": {}
            }
        ],
        "Inspector.DescribeFindings": [
            {
                "action": "inspector:DescribeFindings",
                "resource_mappings": {}
            }
        ],
        "Inspector.DescribeResourceGroups": [
            {
                "action": "inspector:DescribeResourceGroups",
                "resource_mappings": {}
            }
        ],
        "Inspector.DescribeRulesPackages": [
            {
                "action": "inspector:DescribeRulesPackages",
                "resource_mappings": {}
            }
        ],
        "Inspector.GetTelemetryMetadata": [
            {
                "action": "inspector:GetTelemetryMetadata",
                "resource_mappings": {}
            }
        ],
        "Inspector.ListAssessmentRunAgents": [
            {
                "action": "inspector:ListAssessmentRunAgents",
                "resource_mappings": {}
            }
        ],
        "Inspector.ListAssessmentRuns": [
            {
                "action": "inspector:ListAssessmentRuns",
                "resource_mappings": {}
            }
        ],
        "Inspector.ListAssessmentTargets": [
            {
                "action": "inspector:ListAssessmentTargets",
                "resource_mappings": {}
            }
        ],
        "Inspector.ListAssessmentTemplates": [
            {
                "action": "inspector:ListAssessmentTemplates",
                "resource_mappings": {}
            }
        ],
        "Inspector.ListEventSubscriptions": [
            {
                "action": "inspector:ListEventSubscriptions",
                "resource_mappings": {}
            }
        ],
        "Inspector.ListFindings": [
            {
                "action": "inspector:ListFindings",
                "resource_mappings": {}
            }
        ],
        "Inspector.ListRulesPackages": [
            {
                "action": "inspector:ListRulesPackages",
                "resource_mappings": {}
            }
        ],
        "Inspector.ListTagsForResource": [
            {
                "action": "inspector:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Inspector.PreviewAgents": [
            {
                "action": "inspector:PreviewAgents",
                "resource_mappings": {}
            }
        ],
        "Inspector.RegisterCrossAccountAccessRole": [
            {
                "action": "inspector:RegisterCrossAccountAccessRole",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Inspector.RemoveAttributesFromFindings": [
            {
                "action": "inspector:RemoveAttributesFromFindings",
                "resource_mappings": {}
            }
        ],
        "Inspector.SetTagsForResource": [
            {
                "action": "inspector:SetTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Inspector.StartAssessmentRun": [
            {
                "action": "inspector:StartAssessmentRun",
                "resource_mappings": {}
            }
        ],
        "Inspector.StopAssessmentRun": [
            {
                "action": "inspector:StopAssessmentRun",
                "resource_mappings": {}
            }
        ],
        "Inspector.SubscribeToEvent": [
            {
                "action": "inspector:SubscribeToEvent",
                "resource_mappings": {}
            }
        ],
        "Inspector.UnsubscribeFromEvent": [
            {
                "action": "inspector:UnsubscribeFromEvent",
                "resource_mappings": {}
            }
        ],
        "Inspector.UpdateAssessmentTarget": [
            {
                "action": "inspector:UpdateAssessmentTarget",
                "resource_mappings": {}
            }
        ],
        "Iot.AcceptCertificateTransfer": [
            {
                "action": "iot:AcceptCertificateTransfer",
                "resource_mappings": {
                    "Certificate": {
                        "template": "${certificateId}"
                    }
                }
            }
        ],
        "Iot.AddThingToBillingGroup": [
            {
                "action": "iot:AddThingToBillingGroup",
                "resource_mappings": {
                    "BillingGroupName": {
                        "template": "${billingGroupName}"
                    },
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.AddThingToThingGroup": [
            {
                "action": "iot:AddThingToThingGroup",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    },
                    "ThingGroupName": {
                        "template": "${thingGroupName}"
                    }
                }
            }
        ],
        "Iot.AssociateTargetsWithJob": [
            {
                "action": "iot:AssociateTargetsWithJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    }
                },
                "resourcearn_mappings": {
                    "thing": "%%iftemplatematch%${targets[]}%%",
                    "thinggroup": "%%iftemplatematch%${targets[]}%%"
                }
            }
        ],
        "Iot.AttachPolicy": [
            {
                "action": "iot:AttachPolicy",
                "resource_mappings": {
                    "Certificate": {
                        "template": "*"
                    },
                    "ThingGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Iot.AttachPrincipalPolicy": [
            {
                "action": "iot:AttachPrincipalPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cert": "%%iftemplatematch%${principal}%%"
                }
            }
        ],
        "Iot.AttachSecurityProfile": [
            {
                "action": "iot:AttachSecurityProfile",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    },
                    "DimensionName": {
                        "template": "*"
                    },
                    "ThingGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Iot.AttachThingPrincipal": [
            {
                "action": "iot:AttachThingPrincipal",
                "resource_mappings": {}
            }
        ],
        "Iot.CancelAuditMitigationActionsTask": [
            {
                "action": "iot:CancelAuditMitigationActionsTask",
                "resource_mappings": {}
            }
        ],
        "Iot.CancelAuditTask": [
            {
                "action": "iot:CancelAuditTask",
                "resource_mappings": {}
            }
        ],
        "Iot.CancelCertificateTransfer": [
            {
                "action": "iot:CancelCertificateTransfer",
                "resource_mappings": {
                    "Certificate": {
                        "template": "${certificateId}"
                    }
                }
            }
        ],
        "Iot.CancelJob": [
            {
                "action": "iot:CancelJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Iot.CancelJobExecution": [
            {
                "action": "iot:CancelJobExecution",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    },
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.ClearDefaultAuthorizer": [
            {
                "action": "iot:ClearDefaultAuthorizer",
                "resource_mappings": {}
            }
        ],
        "Iot.CreateAuditSuppression": [
            {
                "action": "iot:CreateAuditSuppression",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${resourceIdentifier.iamRoleArn}"
                }
            }
        ],
        "Iot.CreateAuthorizer": [
            {
                "action": "iot:CreateAuthorizer",
                "resource_mappings": {
                    "AuthorizerName": {
                        "template": "${authorizerName}"
                    }
                }
            }
        ],
        "Iot.CreateBillingGroup": [
            {
                "action": "iot:CreateBillingGroup",
                "resource_mappings": {
                    "BillingGroupName": {
                        "template": "${billingGroupName}"
                    }
                }
            }
        ],
        "Iot.CreateCertificateFromCsr": [
            {
                "action": "iot:CreateCertificateFromCsr",
                "resource_mappings": {}
            }
        ],
        "Iot.CreateDimension": [
            {
                "action": "iot:CreateDimension",
                "resource_mappings": {
                    "DimensionName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Iot.CreateDomainConfiguration": [
            {
                "action": "iot:CreateDomainConfiguration",
                "resource_mappings": {
                    "domainConfigurationName": {
                        "template": "${domainConfigurationName}"
                    }
                }
            }
        ],
        "Iot.CreateDynamicThingGroup": [
            {
                "action": "iot:CreateDynamicThingGroup",
                "resource_mappings": {
                    "ThingGroupName": {
                        "template": "${thingGroupName}"
                    }
                }
            }
        ],
        "Iot.CreateJob": [
            {
                "action": "iot:CreateJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    }
                },
                "resourcearn_mappings": {
                    "thing": "%%iftemplatematch%${targets[]}%%",
                    "thinggroup": "%%iftemplatematch%${targets[]}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${presignedUrlConfig.roleArn}"
                }
            }
        ],
        "Iot.CreateKeysAndCertificate": [
            {
                "action": "iot:CreateKeysAndCertificate",
                "resource_mappings": {}
            }
        ],
        "Iot.CreateMitigationAction": [
            {
                "action": "iot:CreateMitigationAction",
                "resource_mappings": {
                    "MitigationActionName": {
                        "template": "${actionName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${roleArn}%${actionParams.enableIoTLoggingParams.roleArnForLogging}%%"
                }
            }
        ],
        "Iot.CreateOTAUpdate": [
            {
                "action": "iot:CreateOTAUpdate",
                "resource_mappings": {
                    "otaUpdateId": {
                        "template": "${otaUpdateId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Iot.CreatePolicy": [
            {
                "action": "iot:CreatePolicy",
                "resource_mappings": {
                    "PolicyName": {
                        "template": "${policyName}"
                    }
                }
            }
        ],
        "Iot.CreatePolicyVersion": [
            {
                "action": "iot:CreatePolicyVersion",
                "resource_mappings": {
                    "PolicyName": {
                        "template": "${policyName}"
                    }
                }
            }
        ],
        "Iot.CreateProvisioningClaim": [
            {
                "action": "iot:CreateProvisioningClaim",
                "resource_mappings": {
                    "provisioningTemplate": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Iot.CreateProvisioningTemplateVersion": [
            {
                "action": "iot:CreateProvisioningTemplateVersion",
                "resource_mappings": {
                    "provisioningTemplate": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Iot.CreateScheduledAudit": [
            {
                "action": "iot:CreateScheduledAudit",
                "resource_mappings": {
                    "ScheduleName": {
                        "template": "${scheduledAuditName}"
                    }
                }
            }
        ],
        "Iot.CreateSecurityProfile": [
            {
                "action": "iot:CreateSecurityProfile",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    },
                    "DimensionName": {
                        "template": "%%many%${behaviors[].metricDimension.dimensionName}%${additionalMetricsToRetainV2[].metricDimension.dimensionName}%%"
                    }
                }
            }
        ],
        "Iot.CreateStream": [
            {
                "action": "iot:CreateStream",
                "resource_mappings": {
                    "streamId": {
                        "template": "${streamId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Iot.CreateThing": [
            {
                "action": "iot:CreateThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    },
                    "BillingGroupName": {
                        "template": "${billingGroupName}"
                    }
                }
            }
        ],
        "Iot.CreateThingGroup": [
            {
                "action": "iot:CreateThingGroup",
                "resource_mappings": {
                    "ThingGroupName": {
                        "template": "%%many%${thingGroupName}%${parentGroupName}%%"
                    }
                }
            }
        ],
        "Iot.CreateThingType": [
            {
                "action": "iot:CreateThingType",
                "resource_mappings": {
                    "ThingTypeName": {
                        "template": "${thingTypeName}"
                    }
                }
            }
        ],
        "Iot.CreateTopicRule": [
            {
                "action": "iot:CreateTopicRule",
                "resource_mappings": {
                    "ruleName": {
                        "template": "${ruleName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${topicRulePayload.errorAction.dynamoDB.roleArn}%${topicRulePayload.errorAction.dynamoDBv2.roleArn}%${topicRulePayload.errorAction.sns.roleArn}%${topicRulePayload.errorAction.sqs.roleArn}%${topicRulePayload.errorAction.kinesis.roleArn}%${topicRulePayload.errorAction.republish.roleArn}%${topicRulePayload.errorAction.s3.roleArn}%${topicRulePayload.errorAction.firehose.roleArn}%${topicRulePayload.errorAction.cloudwatchMetric.roleArn}%${topicRulePayload.errorAction.cloudwatchAlarm.roleArn}%${topicRulePayload.errorAction.cloudwatchLogs.roleArn}%${topicRulePayload.errorAction.elasticsearch.roleArn}%%"
                }
            }
        ],
        "Iot.DeleteAccountAuditConfiguration": [
            {
                "action": "iot:DeleteAccountAuditConfiguration",
                "resource_mappings": {}
            }
        ],
        "Iot.DeleteAuditSuppression": [
            {
                "action": "iot:DeleteAuditSuppression",
                "resource_mappings": {}
            }
        ],
        "Iot.DeleteAuthorizer": [
            {
                "action": "iot:DeleteAuthorizer",
                "resource_mappings": {
                    "AuthorizerName": {
                        "template": "${authorizerName}"
                    }
                }
            }
        ],
        "Iot.DeleteBillingGroup": [
            {
                "action": "iot:DeleteBillingGroup",
                "resource_mappings": {
                    "BillingGroupName": {
                        "template": "${billingGroupName}"
                    }
                }
            }
        ],
        "Iot.DeleteCACertificate": [
            {
                "action": "iot:DeleteCACertificate",
                "resource_mappings": {
                    "CACertificate": {
                        "template": "${certificateId}"
                    }
                }
            }
        ],
        "Iot.DeleteCertificate": [
            {
                "action": "iot:DeleteCertificate",
                "resource_mappings": {
                    "Certificate": {
                        "template": "${certificateId}"
                    }
                }
            }
        ],
        "Iot.DeleteDimension": [
            {
                "action": "iot:DeleteDimension",
                "resource_mappings": {
                    "DimensionName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Iot.DeleteDomainConfiguration": [
            {
                "action": "iot:DeleteDomainConfiguration",
                "resource_mappings": {
                    "domainConfigurationName": {
                        "template": "${domainConfigurationName}"
                    }
                }
            }
        ],
        "Iot.DeleteDynamicThingGroup": [
            {
                "action": "iot:DeleteDynamicThingGroup",
                "resource_mappings": {
                    "ThingGroupName": {
                        "template": "${thingGroupName}"
                    }
                }
            }
        ],
        "Iot.DeleteJob": [
            {
                "action": "iot:DeleteJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Iot.DeleteJobExecution": [
            {
                "action": "iot:DeleteJobExecution",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    },
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.DeleteMitigationAction": [
            {
                "action": "iot:DeleteMitigationAction",
                "resource_mappings": {
                    "MitigationActionName": {
                        "template": "${actionName}"
                    }
                }
            }
        ],
        "Iot.DeleteOTAUpdate": [
            {
                "action": "iot:DeleteOTAUpdate",
                "resource_mappings": {
                    "otaUpdateId": {
                        "template": "${otaUpdateId}"
                    }
                }
            }
        ],
        "Iot.DeletePolicy": [
            {
                "action": "iot:DeletePolicy",
                "resource_mappings": {
                    "PolicyName": {
                        "template": "${policyName}"
                    }
                }
            }
        ],
        "Iot.DeletePolicyVersion": [
            {
                "action": "iot:DeletePolicyVersion",
                "resource_mappings": {
                    "PolicyName": {
                        "template": "${policyName}"
                    }
                }
            }
        ],
        "Iot.DeleteProvisioningTemplate": [
            {
                "action": "iot:DeleteProvisioningTemplate",
                "resource_mappings": {
                    "provisioningTemplate": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Iot.DeleteProvisioningTemplateVersion": [
            {
                "action": "iot:DeleteProvisioningTemplateVersion",
                "resource_mappings": {
                    "provisioningTemplate": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Iot.DeleteRegistrationCode": [
            {
                "action": "iot:DeleteRegistrationCode",
                "resource_mappings": {}
            }
        ],
        "Iot.DeleteRoleAlias": [
            {
                "action": "iot:DeleteRoleAlias",
                "resource_mappings": {
                    "RoleAlias": {
                        "template": "${roleAlias}"
                    }
                }
            }
        ],
        "Iot.DeleteScheduledAudit": [
            {
                "action": "iot:DeleteScheduledAudit",
                "resource_mappings": {
                    "ScheduleName": {
                        "template": "${scheduledAuditName}"
                    }
                }
            }
        ],
        "Iot.DeleteSecurityProfile": [
            {
                "action": "iot:DeleteSecurityProfile",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    },
                    "DimensionName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Iot.DeleteStream": [
            {
                "action": "iot:DeleteStream",
                "resource_mappings": {
                    "streamId": {
                        "template": "${streamId}"
                    }
                }
            }
        ],
        "Iot.DeleteThing": [
            {
                "action": "iot:DeleteThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.DeleteThingGroup": [
            {
                "action": "iot:DeleteThingGroup",
                "resource_mappings": {
                    "ThingGroupName": {
                        "template": "${thingGroupName}"
                    }
                }
            }
        ],
        "Iot.DeleteThingType": [
            {
                "action": "iot:DeleteThingType",
                "resource_mappings": {
                    "ThingTypeName": {
                        "template": "${thingTypeName}"
                    }
                }
            }
        ],
        "Iot.DeleteTopicRule": [
            {
                "action": "iot:DeleteTopicRule",
                "resource_mappings": {
                    "ruleName": {
                        "template": "${ruleName}"
                    }
                }
            }
        ],
        "Iot.DeleteV2LoggingLevel": [
            {
                "action": "iot:DeleteV2LoggingLevel",
                "resource_mappings": {}
            }
        ],
        "Iot.DeprecateThingType": [
            {
                "action": "iot:DeprecateThingType",
                "resource_mappings": {
                    "ThingTypeName": {
                        "template": "${thingTypeName}"
                    }
                }
            }
        ],
        "Iot.DescribeAccountAuditConfiguration": [
            {
                "action": "iot:DescribeAccountAuditConfiguration",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeAuditFinding": [
            {
                "action": "iot:DescribeAuditFinding",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeAuditMitigationActionsTask": [
            {
                "action": "iot:DescribeAuditMitigationActionsTask",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeAuditSuppression": [
            {
                "action": "iot:DescribeAuditSuppression",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeAuditTask": [
            {
                "action": "iot:DescribeAuditTask",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeAuthorizer": [
            {
                "action": "iot:DescribeAuthorizer",
                "resource_mappings": {
                    "AuthorizerName": {
                        "template": "${authorizerName}"
                    }
                }
            }
        ],
        "Iot.DescribeBillingGroup": [
            {
                "action": "iot:DescribeBillingGroup",
                "resource_mappings": {
                    "BillingGroupName": {
                        "template": "${billingGroupName}"
                    }
                }
            }
        ],
        "Iot.DescribeCACertificate": [
            {
                "action": "iot:DescribeCACertificate",
                "resource_mappings": {
                    "CACertificate": {
                        "template": "${certificateId}"
                    }
                }
            }
        ],
        "Iot.DescribeCertificate": [
            {
                "action": "iot:DescribeCertificate",
                "resource_mappings": {
                    "Certificate": {
                        "template": "${certificateId}"
                    }
                }
            }
        ],
        "Iot.DescribeDefaultAuthorizer": [
            {
                "action": "iot:DescribeDefaultAuthorizer",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeDimension": [
            {
                "action": "iot:DescribeDimension",
                "resource_mappings": {
                    "DimensionName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Iot.DescribeDomainConfiguration": [
            {
                "action": "iot:DescribeDomainConfiguration",
                "resource_mappings": {
                    "domainConfigurationName": {
                        "template": "${domainConfigurationName}"
                    }
                }
            }
        ],
        "Iot.DescribeEndpoint": [
            {
                "action": "iot:DescribeEndpoint",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeEventConfigurations": [
            {
                "action": "iot:DescribeEventConfigurations",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeIndex": [
            {
                "action": "iot:DescribeIndex",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${indexName}"
                    }
                }
            }
        ],
        "Iot.DescribeJob": [
            {
                "action": "iot:DescribeJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Iot.DescribeJobExecution": [
            {
                "action": "iot:DescribeJobExecution",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    },
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.DescribeMitigationAction": [
            {
                "action": "iot:DescribeMitigationAction",
                "resource_mappings": {
                    "MitigationActionName": {
                        "template": "${actionName}"
                    }
                }
            }
        ],
        "Iot.DescribeProvisioningTemplate": [
            {
                "action": "iot:DescribeProvisioningTemplate",
                "resource_mappings": {
                    "provisioningTemplate": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Iot.DescribeProvisioningTemplateVersion": [
            {
                "action": "iot:DescribeProvisioningTemplateVersion",
                "resource_mappings": {
                    "provisioningTemplate": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Iot.DescribeRoleAlias": [
            {
                "action": "iot:DescribeRoleAlias",
                "resource_mappings": {
                    "RoleAlias": {
                        "template": "${roleAlias}"
                    }
                }
            }
        ],
        "Iot.DescribeScheduledAudit": [
            {
                "action": "iot:DescribeScheduledAudit",
                "resource_mappings": {
                    "ScheduleName": {
                        "template": "${scheduledAuditName}"
                    }
                }
            }
        ],
        "Iot.DescribeSecurityProfile": [
            {
                "action": "iot:DescribeSecurityProfile",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    }
                }
            }
        ],
        "Iot.DescribeStream": [
            {
                "action": "iot:DescribeStream",
                "resource_mappings": {
                    "streamId": {
                        "template": "${streamId}"
                    }
                }
            }
        ],
        "Iot.DescribeThing": [
            {
                "action": "iot:DescribeThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.DescribeThingGroup": [
            {
                "action": "iot:DescribeThingGroup",
                "resource_mappings": {
                    "ThingGroupName": {
                        "template": "${thingGroupName}"
                    }
                }
            }
        ],
        "Iot.DescribeThingRegistrationTask": [
            {
                "action": "iot:DescribeThingRegistrationTask",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeThingType": [
            {
                "action": "iot:DescribeThingType",
                "resource_mappings": {
                    "ThingTypeName": {
                        "template": "${thingTypeName}"
                    }
                }
            }
        ],
        "Iot.DetachPolicy": [
            {
                "action": "iot:DetachPolicy",
                "resource_mappings": {
                    "Certificate": {
                        "template": "*"
                    },
                    "ThingGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Iot.DetachPrincipalPolicy": [
            {
                "action": "iot:DetachPrincipalPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cert": "%%iftemplatematch%${principal}%%"
                }
            }
        ],
        "Iot.DetachSecurityProfile": [
            {
                "action": "iot:DetachSecurityProfile",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    },
                    "DimensionName": {
                        "template": "*"
                    },
                    "ThingGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Iot.DetachThingPrincipal": [
            {
                "action": "iot:DetachThingPrincipal",
                "resource_mappings": {}
            }
        ],
        "Iot.DisableTopicRule": [
            {
                "action": "iot:DisableTopicRule",
                "resource_mappings": {
                    "ruleName": {
                        "template": "${ruleName}"
                    }
                }
            }
        ],
        "Iot.EnableTopicRule": [
            {
                "action": "iot:EnableTopicRule",
                "resource_mappings": {
                    "ruleName": {
                        "template": "${ruleName}"
                    }
                }
            }
        ],
        "Iot.GetCardinality": [
            {
                "action": "iot:GetCardinality",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${indexName}"
                    }
                }
            }
        ],
        "Iot.GetEffectivePolicies": [
            {
                "action": "iot:GetEffectivePolicies",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cert": "%%iftemplatematch%${principal}%%"
                }
            }
        ],
        "Iot.GetIndexingConfiguration": [
            {
                "action": "iot:GetIndexingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Iot.GetJobDocument": [
            {
                "action": "iot:GetJobDocument",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Iot.GetLoggingOptions": [
            {
                "action": "iot:GetLoggingOptions",
                "resource_mappings": {}
            }
        ],
        "Iot.GetOTAUpdate": [
            {
                "action": "iot:GetOTAUpdate",
                "resource_mappings": {
                    "otaUpdateId": {
                        "template": "${otaUpdateId}"
                    }
                }
            }
        ],
        "Iot.GetPercentiles": [
            {
                "action": "iot:GetPercentiles",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${indexName}"
                    }
                }
            }
        ],
        "Iot.GetPolicy": [
            {
                "action": "iot:GetPolicy",
                "resource_mappings": {
                    "PolicyName": {
                        "template": "${policyName}"
                    }
                }
            }
        ],
        "Iot.GetPolicyVersion": [
            {
                "action": "iot:GetPolicyVersion",
                "resource_mappings": {
                    "PolicyName": {
                        "template": "${policyName}"
                    }
                }
            }
        ],
        "Iot.GetRegistrationCode": [
            {
                "action": "iot:GetRegistrationCode",
                "resource_mappings": {}
            }
        ],
        "Iot.GetStatistics": [
            {
                "action": "iot:GetStatistics",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${indexName}"
                    }
                }
            }
        ],
        "Iot.GetTopicRule": [
            {
                "action": "iot:GetTopicRule",
                "resource_mappings": {
                    "ruleName": {
                        "template": "${ruleName}"
                    }
                }
            }
        ],
        "Iot.GetV2LoggingOptions": [
            {
                "action": "iot:GetV2LoggingOptions",
                "resource_mappings": {}
            }
        ],
        "Iot.ListActiveViolations": [
            {
                "action": "iot:ListActiveViolations",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    },
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.ListAttachedPolicies": [
            {
                "action": "iot:ListAttachedPolicies",
                "resource_mappings": {}
            }
        ],
        "Iot.ListAuditFindings": [
            {
                "action": "iot:ListAuditFindings",
                "resource_mappings": {}
            }
        ],
        "Iot.ListAuditMitigationActionsExecutions": [
            {
                "action": "iot:ListAuditMitigationActionsExecutions",
                "resource_mappings": {}
            }
        ],
        "Iot.ListAuditMitigationActionsTasks": [
            {
                "action": "iot:ListAuditMitigationActionsTasks",
                "resource_mappings": {}
            }
        ],
        "Iot.ListAuditSuppressions": [
            {
                "action": "iot:ListAuditSuppressions",
                "resource_mappings": {}
            }
        ],
        "Iot.ListAuditTasks": [
            {
                "action": "iot:ListAuditTasks",
                "resource_mappings": {}
            }
        ],
        "Iot.ListAuthorizers": [
            {
                "action": "iot:ListAuthorizers",
                "resource_mappings": {}
            }
        ],
        "Iot.ListBillingGroups": [
            {
                "action": "iot:ListBillingGroups",
                "resource_mappings": {}
            }
        ],
        "Iot.ListCACertificates": [
            {
                "action": "iot:ListCACertificates",
                "resource_mappings": {}
            }
        ],
        "Iot.ListCertificates": [
            {
                "action": "iot:ListCertificates",
                "resource_mappings": {}
            }
        ],
        "Iot.ListCertificatesByCA": [
            {
                "action": "iot:ListCertificatesByCA",
                "resource_mappings": {}
            }
        ],
        "Iot.ListDimensions": [
            {
                "action": "iot:ListDimensions",
                "resource_mappings": {}
            }
        ],
        "Iot.ListDomainConfigurations": [
            {
                "action": "iot:ListDomainConfigurations",
                "resource_mappings": {}
            }
        ],
        "Iot.ListIndices": [
            {
                "action": "iot:ListIndices",
                "resource_mappings": {}
            }
        ],
        "Iot.ListJobExecutionsForJob": [
            {
                "action": "iot:ListJobExecutionsForJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Iot.ListJobExecutionsForThing": [
            {
                "action": "iot:ListJobExecutionsForThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.ListJobs": [
            {
                "action": "iot:ListJobs",
                "resource_mappings": {}
            }
        ],
        "Iot.ListMitigationActions": [
            {
                "action": "iot:ListMitigationActions",
                "resource_mappings": {}
            }
        ],
        "Iot.ListOTAUpdates": [
            {
                "action": "iot:ListOTAUpdates",
                "resource_mappings": {}
            }
        ],
        "Iot.ListOutgoingCertificates": [
            {
                "action": "iot:ListOutgoingCertificates",
                "resource_mappings": {}
            }
        ],
        "Iot.ListPolicies": [
            {
                "action": "iot:ListPolicies",
                "resource_mappings": {}
            }
        ],
        "Iot.ListPolicyPrincipals": [
            {
                "action": "iot:ListPolicyPrincipals",
                "resource_mappings": {}
            }
        ],
        "Iot.ListPolicyVersions": [
            {
                "action": "iot:ListPolicyVersions",
                "resource_mappings": {
                    "PolicyName": {
                        "template": "${policyName}"
                    }
                }
            }
        ],
        "Iot.ListPrincipalPolicies": [
            {
                "action": "iot:ListPrincipalPolicies",
                "resource_mappings": {}
            }
        ],
        "Iot.ListPrincipalThings": [
            {
                "action": "iot:ListPrincipalThings",
                "resource_mappings": {}
            }
        ],
        "Iot.ListProvisioningTemplateVersions": [
            {
                "action": "iot:ListProvisioningTemplateVersions",
                "resource_mappings": {
                    "provisioningTemplate": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Iot.ListProvisioningTemplates": [
            {
                "action": "iot:ListProvisioningTemplates",
                "resource_mappings": {}
            }
        ],
        "Iot.ListRoleAliases": [
            {
                "action": "iot:ListRoleAliases",
                "resource_mappings": {}
            }
        ],
        "Iot.ListScheduledAudits": [
            {
                "action": "iot:ListScheduledAudits",
                "resource_mappings": {}
            }
        ],
        "Iot.ListSecurityProfiles": [
            {
                "action": "iot:ListSecurityProfiles",
                "resource_mappings": {
                    "DimensionName": {
                        "template": "${dimensionName}"
                    }
                }
            }
        ],
        "Iot.ListSecurityProfilesForTarget": [
            {
                "action": "iot:ListSecurityProfilesForTarget",
                "resource_mappings": {
                    "ThingGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Iot.ListStreams": [
            {
                "action": "iot:ListStreams",
                "resource_mappings": {}
            }
        ],
        "Iot.ListTagsForResource": [
            {
                "action": "iot:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "authorizer": "%%iftemplatematch%${resourceArn}%%",
                    "billinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "cacert": "%%iftemplatematch%${resourceArn}%%",
                    "dimension": "%%iftemplatematch%${resourceArn}%%",
                    "domainconfiguration": "%%iftemplatematch%${resourceArn}%%",
                    "dynamicthinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "fleetmetric": "%%iftemplatematch%${resourceArn}%%",
                    "job": "%%iftemplatematch%${resourceArn}%%",
                    "mitigationaction": "%%iftemplatematch%${resourceArn}%%",
                    "otaupdate": "%%iftemplatematch%${resourceArn}%%",
                    "policy": "%%iftemplatematch%${resourceArn}%%",
                    "provisioningtemplate": "%%iftemplatematch%${resourceArn}%%",
                    "rolealias": "%%iftemplatematch%${resourceArn}%%",
                    "rule": "%%iftemplatematch%${resourceArn}%%",
                    "scheduledaudit": "%%iftemplatematch%${resourceArn}%%",
                    "securityprofile": "%%iftemplatematch%${resourceArn}%%",
                    "stream": "%%iftemplatematch%${resourceArn}%%",
                    "thinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "thingtype": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Iot.ListTargetsForPolicy": [
            {
                "action": "iot:ListTargetsForPolicy",
                "resource_mappings": {
                    "PolicyName": {
                        "template": "${policyName}"
                    }
                }
            }
        ],
        "Iot.ListTargetsForSecurityProfile": [
            {
                "action": "iot:ListTargetsForSecurityProfile",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    }
                }
            }
        ],
        "Iot.ListThingGroups": [
            {
                "action": "iot:ListThingGroups",
                "resource_mappings": {}
            }
        ],
        "Iot.ListThingGroupsForThing": [
            {
                "action": "iot:ListThingGroupsForThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.ListThingPrincipals": [
            {
                "action": "iot:ListThingPrincipals",
                "resource_mappings": {}
            }
        ],
        "Iot.ListThingRegistrationTaskReports": [
            {
                "action": "iot:ListThingRegistrationTaskReports",
                "resource_mappings": {}
            }
        ],
        "Iot.ListThingRegistrationTasks": [
            {
                "action": "iot:ListThingRegistrationTasks",
                "resource_mappings": {}
            }
        ],
        "Iot.ListThingTypes": [
            {
                "action": "iot:ListThingTypes",
                "resource_mappings": {}
            }
        ],
        "Iot.ListThings": [
            {
                "action": "iot:ListThings",
                "resource_mappings": {}
            }
        ],
        "Iot.ListThingsInBillingGroup": [
            {
                "action": "iot:ListThingsInBillingGroup",
                "resource_mappings": {
                    "BillingGroupName": {
                        "template": "${billingGroupName}"
                    }
                }
            }
        ],
        "Iot.ListThingsInThingGroup": [
            {
                "action": "iot:ListThingsInThingGroup",
                "resource_mappings": {
                    "ThingGroupName": {
                        "template": "${thingGroupName}"
                    }
                }
            }
        ],
        "Iot.ListTopicRules": [
            {
                "action": "iot:ListTopicRules",
                "resource_mappings": {}
            }
        ],
        "Iot.ListV2LoggingLevels": [
            {
                "action": "iot:ListV2LoggingLevels",
                "resource_mappings": {}
            }
        ],
        "Iot.ListViolationEvents": [
            {
                "action": "iot:ListViolationEvents",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    },
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.RegisterCertificate": [
            {
                "action": "iot:RegisterCertificate",
                "resource_mappings": {}
            }
        ],
        "Iot.RegisterCertificateWithoutCA": [
            {
                "action": "iot:RegisterCertificateWithoutCA",
                "resource_mappings": {}
            }
        ],
        "Iot.RegisterThing": [
            {
                "action": "iot:RegisterThing",
                "resource_mappings": {}
            }
        ],
        "Iot.RejectCertificateTransfer": [
            {
                "action": "iot:RejectCertificateTransfer",
                "resource_mappings": {
                    "Certificate": {
                        "template": "${certificateId}"
                    }
                }
            }
        ],
        "Iot.RemoveThingFromBillingGroup": [
            {
                "action": "iot:RemoveThingFromBillingGroup",
                "resource_mappings": {
                    "BillingGroupName": {
                        "template": "${billingGroupName}"
                    },
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.RemoveThingFromThingGroup": [
            {
                "action": "iot:RemoveThingFromThingGroup",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    },
                    "ThingGroupName": {
                        "template": "${thingGroupName}"
                    }
                }
            }
        ],
        "Iot.ReplaceTopicRule": [
            {
                "action": "iot:ReplaceTopicRule",
                "resource_mappings": {
                    "ruleName": {
                        "template": "${ruleName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${topicRulePayload.errorAction.dynamoDB.roleArn}%${topicRulePayload.errorAction.dynamoDBv2.roleArn}%${topicRulePayload.errorAction.sns.roleArn}%${topicRulePayload.errorAction.sqs.roleArn}%${topicRulePayload.errorAction.kinesis.roleArn}%${topicRulePayload.errorAction.republish.roleArn}%${topicRulePayload.errorAction.s3.roleArn}%${topicRulePayload.errorAction.firehose.roleArn}%${topicRulePayload.errorAction.cloudwatchMetric.roleArn}%${topicRulePayload.errorAction.cloudwatchAlarm.roleArn}%${topicRulePayload.errorAction.cloudwatchLogs.roleArn}%${topicRulePayload.errorAction.elasticsearch.roleArn}%%"
                }
            }
        ],
        "Iot.SearchIndex": [
            {
                "action": "iot:SearchIndex",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${indexName}"
                    }
                }
            }
        ],
        "Iot.SetDefaultAuthorizer": [
            {
                "action": "iot:SetDefaultAuthorizer",
                "resource_mappings": {
                    "AuthorizerName": {
                        "template": "${authorizerName}"
                    }
                }
            }
        ],
        "Iot.SetDefaultPolicyVersion": [
            {
                "action": "iot:SetDefaultPolicyVersion",
                "resource_mappings": {
                    "PolicyName": {
                        "template": "${policyName}"
                    }
                }
            }
        ],
        "Iot.SetLoggingOptions": [
            {
                "action": "iot:SetLoggingOptions",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${loggingOptionsPayload.roleArn}"
                }
            }
        ],
        "Iot.SetV2LoggingLevel": [
            {
                "action": "iot:SetV2LoggingLevel",
                "resource_mappings": {}
            }
        ],
        "Iot.SetV2LoggingOptions": [
            {
                "action": "iot:SetV2LoggingOptions",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Iot.StartAuditMitigationActionsTask": [
            {
                "action": "iot:StartAuditMitigationActionsTask",
                "resource_mappings": {}
            }
        ],
        "Iot.StartOnDemandAuditTask": [
            {
                "action": "iot:StartOnDemandAuditTask",
                "resource_mappings": {}
            }
        ],
        "Iot.StartThingRegistrationTask": [
            {
                "action": "iot:StartThingRegistrationTask",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Iot.StopThingRegistrationTask": [
            {
                "action": "iot:StopThingRegistrationTask",
                "resource_mappings": {}
            }
        ],
        "Iot.TagResource": [
            {
                "action": "iot:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "authorizer": "%%iftemplatematch%${resourceArn}%%",
                    "billinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "cacert": "%%iftemplatematch%${resourceArn}%%",
                    "dimension": "%%iftemplatematch%${resourceArn}%%",
                    "domainconfiguration": "%%iftemplatematch%${resourceArn}%%",
                    "dynamicthinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "fleetmetric": "%%iftemplatematch%${resourceArn}%%",
                    "job": "%%iftemplatematch%${resourceArn}%%",
                    "mitigationaction": "%%iftemplatematch%${resourceArn}%%",
                    "otaupdate": "%%iftemplatematch%${resourceArn}%%",
                    "policy": "%%iftemplatematch%${resourceArn}%%",
                    "provisioningtemplate": "%%iftemplatematch%${resourceArn}%%",
                    "rolealias": "%%iftemplatematch%${resourceArn}%%",
                    "rule": "%%iftemplatematch%${resourceArn}%%",
                    "scheduledaudit": "%%iftemplatematch%${resourceArn}%%",
                    "securityprofile": "%%iftemplatematch%${resourceArn}%%",
                    "stream": "%%iftemplatematch%${resourceArn}%%",
                    "thinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "thingtype": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Iot.TestAuthorization": [
            {
                "action": "iot:TestAuthorization",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cert": "%%iftemplatematch%${principal}%%"
                }
            }
        ],
        "Iot.TestInvokeAuthorizer": [
            {
                "action": "iot:TestInvokeAuthorizer",
                "resource_mappings": {
                    "AuthorizerName": {
                        "template": "${authorizerName}"
                    }
                }
            }
        ],
        "Iot.TransferCertificate": [
            {
                "action": "iot:TransferCertificate",
                "resource_mappings": {
                    "Certificate": {
                        "template": "${certificateId}"
                    }
                }
            }
        ],
        "Iot.UntagResource": [
            {
                "action": "iot:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "authorizer": "%%iftemplatematch%${resourceArn}%%",
                    "billinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "cacert": "%%iftemplatematch%${resourceArn}%%",
                    "dimension": "%%iftemplatematch%${resourceArn}%%",
                    "domainconfiguration": "%%iftemplatematch%${resourceArn}%%",
                    "dynamicthinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "fleetmetric": "%%iftemplatematch%${resourceArn}%%",
                    "job": "%%iftemplatematch%${resourceArn}%%",
                    "mitigationaction": "%%iftemplatematch%${resourceArn}%%",
                    "otaupdate": "%%iftemplatematch%${resourceArn}%%",
                    "policy": "%%iftemplatematch%${resourceArn}%%",
                    "provisioningtemplate": "%%iftemplatematch%${resourceArn}%%",
                    "rolealias": "%%iftemplatematch%${resourceArn}%%",
                    "rule": "%%iftemplatematch%${resourceArn}%%",
                    "scheduledaudit": "%%iftemplatematch%${resourceArn}%%",
                    "securityprofile": "%%iftemplatematch%${resourceArn}%%",
                    "stream": "%%iftemplatematch%${resourceArn}%%",
                    "thinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "thingtype": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Iot.UpdateAccountAuditConfiguration": [
            {
                "action": "iot:UpdateAccountAuditConfiguration",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Iot.UpdateAuditSuppression": [
            {
                "action": "iot:UpdateAuditSuppression",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${resourceIdentifier.iamRoleArn}"
                }
            }
        ],
        "Iot.UpdateAuthorizer": [
            {
                "action": "iot:UpdateAuthorizer",
                "resource_mappings": {
                    "AuthorizerName": {
                        "template": "${authorizerName}"
                    }
                }
            }
        ],
        "Iot.UpdateBillingGroup": [
            {
                "action": "iot:UpdateBillingGroup",
                "resource_mappings": {
                    "BillingGroupName": {
                        "template": "${billingGroupName}"
                    }
                }
            }
        ],
        "Iot.UpdateCertificate": [
            {
                "action": "iot:UpdateCertificate",
                "resource_mappings": {
                    "Certificate": {
                        "template": "${certificateId}"
                    }
                }
            }
        ],
        "Iot.UpdateDimension": [
            {
                "action": "iot:UpdateDimension",
                "resource_mappings": {
                    "DimensionName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Iot.UpdateDomainConfiguration": [
            {
                "action": "iot:UpdateDomainConfiguration",
                "resource_mappings": {
                    "domainConfigurationName": {
                        "template": "${domainConfigurationName}"
                    }
                }
            }
        ],
        "Iot.UpdateDynamicThingGroup": [
            {
                "action": "iot:UpdateDynamicThingGroup",
                "resource_mappings": {
                    "ThingGroupName": {
                        "template": "${thingGroupName}"
                    }
                }
            }
        ],
        "Iot.UpdateEventConfigurations": [
            {
                "action": "iot:UpdateEventConfigurations",
                "resource_mappings": {}
            }
        ],
        "Iot.UpdateIndexingConfiguration": [
            {
                "action": "iot:UpdateIndexingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Iot.UpdateJob": [
            {
                "action": "iot:UpdateJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${presignedUrlConfig.roleArn}"
                }
            }
        ],
        "Iot.UpdateMitigationAction": [
            {
                "action": "iot:UpdateMitigationAction",
                "resource_mappings": {
                    "MitigationActionName": {
                        "template": "${actionName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${roleArn}%${actionParams.enableIoTLoggingParams.roleArnForLogging}%%"
                }
            }
        ],
        "Iot.UpdateScheduledAudit": [
            {
                "action": "iot:UpdateScheduledAudit",
                "resource_mappings": {
                    "ScheduleName": {
                        "template": "${scheduledAuditName}"
                    }
                }
            }
        ],
        "Iot.UpdateSecurityProfile": [
            {
                "action": "iot:UpdateSecurityProfile",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    },
                    "DimensionName": {
                        "template": "%%many%${behaviors[].metricDimension.dimensionName}%${additionalMetricsToRetainV2[].metricDimension.dimensionName}%%"
                    }
                }
            }
        ],
        "Iot.UpdateStream": [
            {
                "action": "iot:UpdateStream",
                "resource_mappings": {
                    "streamId": {
                        "template": "${streamId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Iot.UpdateThing": [
            {
                "action": "iot:UpdateThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.UpdateThingGroup": [
            {
                "action": "iot:UpdateThingGroup",
                "resource_mappings": {
                    "ThingGroupName": {
                        "template": "${thingGroupName}"
                    }
                }
            }
        ],
        "Iot.UpdateThingGroupsForThing": [
            {
                "action": "iot:UpdateThingGroupsForThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    },
                    "ThingGroupName": {
                        "template": "%%many%${thingGroupsToAdd[]}%${thingGroupsToRemove[]}%%"
                    }
                }
            }
        ],
        "Iot.ValidateSecurityProfileBehaviors": [
            {
                "action": "iot:ValidateSecurityProfileBehaviors",
                "resource_mappings": {}
            }
        ],
        "IotData.DeleteThingShadow": [
            {
                "action": "iot:DeleteThingShadow",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "IotData.GetThingShadow": [
            {
                "action": "iot:GetThingShadow",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "IotData.ListNamedShadowsForThing": [
            {
                "action": "iot:ListNamedShadowsForThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "IotData.Publish": [
            {
                "action": "iot:Publish",
                "resource_mappings": {
                    "TopicName": {
                        "template": "${topic}"
                    }
                }
            }
        ],
        "IotData.UpdateThingShadow": [
            {
                "action": "iot:UpdateThingShadow",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Kinesis.AddTagsToStream": [
            {
                "action": "kinesis:AddTagsToStream",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.CreateStream": [
            {
                "action": "kinesis:CreateStream",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.DecreaseStreamRetentionPeriod": [
            {
                "action": "kinesis:DecreaseStreamRetentionPeriod",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.DeleteStream": [
            {
                "action": "kinesis:DeleteStream",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.DeregisterStreamConsumer": [
            {
                "action": "kinesis:DeregisterStreamConsumer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "consumer": "${ConsumerARN}",
                    "stream": "${StreamARN}"
                }
            }
        ],
        "Kinesis.DescribeLimits": [
            {
                "action": "kinesis:DescribeLimits",
                "resource_mappings": {}
            }
        ],
        "Kinesis.DescribeStream": [
            {
                "action": "kinesis:DescribeStream",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.DescribeStreamConsumer": [
            {
                "action": "kinesis:DescribeStreamConsumer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "consumer": "${ConsumerARN}",
                    "stream": "${StreamARN}"
                }
            }
        ],
        "Kinesis.DescribeStreamSummary": [
            {
                "action": "kinesis:DescribeStreamSummary",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.DisableEnhancedMonitoring": [
            {
                "action": "kinesis:DisableEnhancedMonitoring",
                "resource_mappings": {}
            }
        ],
        "Kinesis.EnableEnhancedMonitoring": [
            {
                "action": "kinesis:EnableEnhancedMonitoring",
                "resource_mappings": {}
            }
        ],
        "Kinesis.GetRecords": [
            {
                "action": "kinesis:GetRecords",
                "resource_mappings": {
                    "StreamName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Kinesis.GetShardIterator": [
            {
                "action": "kinesis:GetShardIterator",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.IncreaseStreamRetentionPeriod": [
            {
                "action": "kinesis:IncreaseStreamRetentionPeriod",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.ListShards": [
            {
                "action": "kinesis:ListShards",
                "resource_mappings": {}
            }
        ],
        "Kinesis.ListStreamConsumers": [
            {
                "action": "kinesis:ListStreamConsumers",
                "resource_mappings": {}
            }
        ],
        "Kinesis.ListStreams": [
            {
                "action": "kinesis:ListStreams",
                "resource_mappings": {}
            }
        ],
        "Kinesis.ListTagsForStream": [
            {
                "action": "kinesis:ListTagsForStream",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.MergeShards": [
            {
                "action": "kinesis:MergeShards",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.PutRecord": [
            {
                "action": "kinesis:PutRecord",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.PutRecords": [
            {
                "action": "kinesis:PutRecords",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.RegisterStreamConsumer": [
            {
                "action": "kinesis:RegisterStreamConsumer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "consumer": "${ConsumerName}",
                    "stream": "${StreamARN}"
                }
            }
        ],
        "Kinesis.RemoveTagsFromStream": [
            {
                "action": "kinesis:RemoveTagsFromStream",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.SplitShard": [
            {
                "action": "kinesis:SplitShard",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.StopStreamEncryption": [
            {
                "action": "kinesis:StopStreamEncryption",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${KeyId}"
                    },
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Kinesis.UpdateShardCount": [
            {
                "action": "kinesis:UpdateShardCount",
                "resource_mappings": {}
            }
        ],
        "KinesisAnalytics.AddApplicationCloudWatchLoggingOption": [
            {
                "action": "kinesisanalytics:AddApplicationCloudWatchLoggingOption",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${CloudWatchLoggingOption.RoleARN}"
                }
            }
        ],
        "KinesisAnalytics.AddApplicationInput": [
            {
                "action": "kinesisanalytics:AddApplicationInput",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${Input.InputProcessingConfiguration.InputLambdaProcessor.RoleARN}%${Input.KinesisStreamsInput.RoleARN}%${Input.KinesisFirehoseInput.RoleARN}%%"
                }
            }
        ],
        "KinesisAnalytics.AddApplicationInputProcessingConfiguration": [
            {
                "action": "kinesisanalytics:AddApplicationInputProcessingConfiguration",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${InputProcessingConfiguration.InputLambdaProcessor.RoleARN}"
                }
            }
        ],
        "KinesisAnalytics.AddApplicationOutput": [
            {
                "action": "kinesisanalytics:AddApplicationOutput",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${Output.KinesisStreamsOutput.RoleARN}%${Output.KinesisFirehoseOutput.RoleARN}%${Output.LambdaOutput.RoleARN}%%"
                }
            }
        ],
        "KinesisAnalytics.AddApplicationReferenceDataSource": [
            {
                "action": "kinesisanalytics:AddApplicationReferenceDataSource",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalytics.CreateApplication": [
            {
                "action": "kinesisanalytics:CreateApplication",
                "resource_mappings": {}
            }
        ],
        "KinesisAnalytics.DeleteApplication": [
            {
                "action": "kinesisanalytics:DeleteApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalytics.DeleteApplicationCloudWatchLoggingOption": [
            {
                "action": "kinesisanalytics:DeleteApplicationCloudWatchLoggingOption",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalytics.DeleteApplicationInputProcessingConfiguration": [
            {
                "action": "kinesisanalytics:DeleteApplicationInputProcessingConfiguration",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalytics.DeleteApplicationOutput": [
            {
                "action": "kinesisanalytics:DeleteApplicationOutput",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalytics.DeleteApplicationReferenceDataSource": [
            {
                "action": "kinesisanalytics:DeleteApplicationReferenceDataSource",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalytics.DescribeApplication": [
            {
                "action": "kinesisanalytics:DescribeApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalytics.DiscoverInputSchema": [
            {
                "action": "kinesisanalytics:DiscoverInputSchema",
                "resource_mappings": {}
            }
        ],
        "KinesisAnalytics.ListApplications": [
            {
                "action": "kinesisanalytics:ListApplications",
                "resource_mappings": {}
            }
        ],
        "KinesisAnalytics.ListTagsForResource": [
            {
                "action": "kinesisanalytics:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "KinesisAnalytics.StartApplication": [
            {
                "action": "kinesisanalytics:StartApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalytics.StopApplication": [
            {
                "action": "kinesisanalytics:StopApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalytics.TagResource": [
            {
                "action": "kinesisanalytics:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "KinesisAnalytics.UntagResource": [
            {
                "action": "kinesisanalytics:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "KinesisAnalytics.UpdateApplication": [
            {
                "action": "kinesisanalytics:UpdateApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KMS.CancelKeyDeletion": [
            {
                "action": "kms:CancelKeyDeletion",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.ConnectCustomKeyStore": [
            {
                "action": "kms:ConnectCustomKeyStore",
                "resource_mappings": {}
            }
        ],
        "KMS.CreateAlias": [
            {
                "action": "kms:CreateAlias",
                "resource_mappings": {
                    "Alias": {
                        "template": "${AliasName}"
                    },
                    "KeyId": {
                        "template": "%%regex%${TargetKeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.CreateCustomKeyStore": [
            {
                "action": "kms:CreateCustomKeyStore",
                "resource_mappings": {}
            },
            {
                "action": "cloudhsm:DescribeClusters",
                "resource_mappings": {}
            }
        ],
        "KMS.CreateGrant": [
            {
                "action": "kms:CreateGrant",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.CreateKey": [
            {
                "action": "kms:CreateKey",
                "resource_mappings": {}
            }
        ],
        "KMS.Decrypt": [
            {
                "action": "kms:Decrypt",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.DeleteAlias": [
            {
                "action": "kms:DeleteAlias",
                "resource_mappings": {
                    "Alias": {
                        "template": "${AliasName}"
                    },
                    "KeyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "KMS.DeleteCustomKeyStore": [
            {
                "action": "kms:DeleteCustomKeyStore",
                "resource_mappings": {}
            }
        ],
        "KMS.DeleteImportedKeyMaterial": [
            {
                "action": "kms:DeleteImportedKeyMaterial",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.DescribeCustomKeyStores": [
            {
                "action": "kms:DescribeCustomKeyStores",
                "resource_mappings": {}
            }
        ],
        "KMS.DescribeKey": [
            {
                "action": "kms:DescribeKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.DisableKey": [
            {
                "action": "kms:DisableKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.DisableKeyRotation": [
            {
                "action": "kms:DisableKeyRotation",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.DisconnectCustomKeyStore": [
            {
                "action": "kms:DisconnectCustomKeyStore",
                "resource_mappings": {}
            }
        ],
        "KMS.EnableKey": [
            {
                "action": "kms:EnableKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.EnableKeyRotation": [
            {
                "action": "kms:EnableKeyRotation",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.Encrypt": [
            {
                "action": "kms:Encrypt",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.GenerateDataKey": [
            {
                "action": "kms:GenerateDataKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.GenerateDataKeyPair": [
            {
                "action": "kms:GenerateDataKeyPair",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.GenerateDataKeyPairWithoutPlaintext": [
            {
                "action": "kms:GenerateDataKeyPairWithoutPlaintext",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.GenerateDataKeyWithoutPlaintext": [
            {
                "action": "kms:GenerateDataKeyWithoutPlaintext",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.GenerateRandom": [
            {
                "action": "kms:GenerateRandom",
                "resource_mappings": {}
            }
        ],
        "KMS.GetKeyPolicy": [
            {
                "action": "kms:GetKeyPolicy",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.GetKeyRotationStatus": [
            {
                "action": "kms:GetKeyRotationStatus",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.GetParametersForImport": [
            {
                "action": "kms:GetParametersForImport",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.GetPublicKey": [
            {
                "action": "kms:GetPublicKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.ImportKeyMaterial": [
            {
                "action": "kms:ImportKeyMaterial",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.ListAliases": [
            {
                "action": "kms:ListAliases",
                "resource_mappings": {}
            }
        ],
        "KMS.ListGrants": [
            {
                "action": "kms:ListGrants",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.ListKeyPolicies": [
            {
                "action": "kms:ListKeyPolicies",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.ListKeys": [
            {
                "action": "kms:ListKeys",
                "resource_mappings": {}
            }
        ],
        "KMS.ListResourceTags": [
            {
                "action": "kms:ListResourceTags",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.ListRetirableGrants": [
            {
                "action": "kms:ListRetirableGrants",
                "resource_mappings": {
                    "KeyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "KMS.PutKeyPolicy": [
            {
                "action": "kms:PutKeyPolicy",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.RetireGrant": [
            {
                "action": "kms:RetireGrant",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.RevokeGrant": [
            {
                "action": "kms:RevokeGrant",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.ScheduleKeyDeletion": [
            {
                "action": "kms:ScheduleKeyDeletion",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.Sign": [
            {
                "action": "kms:Sign",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.TagResource": [
            {
                "action": "kms:TagResource",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.UntagResource": [
            {
                "action": "kms:UntagResource",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.UpdateAlias": [
            {
                "action": "kms:UpdateAlias",
                "resource_mappings": {
                    "Alias": {
                        "template": "${AliasName}"
                    },
                    "KeyId": {
                        "template": "%%regex%${TargetKeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.UpdateCustomKeyStore": [
            {
                "action": "kms:UpdateCustomKeyStore",
                "resource_mappings": {}
            }
        ],
        "KMS.UpdateKeyDescription": [
            {
                "action": "kms:UpdateKeyDescription",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "KMS.Verify": [
            {
                "action": "kms:Verify",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "Lambda.AddLayerVersionPermission": [
            {
                "action": "lambda:AddLayerVersionPermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "layerVersion": "%%iftemplatematch%${LayerName}%%"
                }
            }
        ],
        "Lambda.AddPermission": [
            {
                "action": "lambda:AddPermission",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.CreateAlias": [
            {
                "action": "lambda:CreateAlias",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.CreateCodeSigningConfig": [
            {
                "action": "lambda:CreateCodeSigningConfig",
                "resource_mappings": {
                    "CodeSigningConfigId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lambda.CreateEventSourceMapping": [
            {
                "action": "lambda:CreateEventSourceMapping",
                "resource_mappings": {}
            }
        ],
        "Lambda.CreateFunction": [
            {
                "action": "lambda:CreateFunction",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "Lambda.DeleteAlias": [
            {
                "action": "lambda:DeleteAlias",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.DeleteCodeSigningConfig": [
            {
                "action": "lambda:DeleteCodeSigningConfig",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "code signing config": "${CodeSigningConfigArn}"
                }
            }
        ],
        "Lambda.DeleteEventSourceMapping": [
            {
                "action": "lambda:DeleteEventSourceMapping",
                "resource_mappings": {
                    "UUID": {
                        "template": "${UUID}"
                    }
                }
            }
        ],
        "Lambda.DeleteFunction": [
            {
                "action": "lambda:DeleteFunction",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.DeleteFunctionCodeSigningConfig": [
            {
                "action": "lambda:DeleteFunctionCodeSigningConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.DeleteFunctionConcurrency": [
            {
                "action": "lambda:DeleteFunctionConcurrency",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.DeleteFunctionEventInvokeConfig": [
            {
                "action": "lambda:DeleteFunctionEventInvokeConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.DeleteLayerVersion": [
            {
                "action": "lambda:DeleteLayerVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "layerVersion": "%%iftemplatematch%${LayerName}%%"
                }
            }
        ],
        "Lambda.DeleteProvisionedConcurrencyConfig": [
            {
                "action": "lambda:DeleteProvisionedConcurrencyConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    },
                    "Alias": {
                        "template": "%%regex%${Qualifier}%/^(?!^[0-9]+$)([a-zA-Z0-9-_]+)$/g%%"
                    },
                    "Version": {
                        "template": "%%regex%${Qualifier}%/^([0-9]+)$/g%%"
                    }
                }
            }
        ],
        "Lambda.GetAccountSettings": [
            {
                "action": "lambda:GetAccountSettings",
                "resource_mappings": {}
            }
        ],
        "Lambda.GetAlias": [
            {
                "action": "lambda:GetAlias",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.GetCodeSigningConfig": [
            {
                "action": "lambda:GetCodeSigningConfig",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "code signing config": "${CodeSigningConfigArn}"
                }
            }
        ],
        "Lambda.GetEventSourceMapping": [
            {
                "action": "lambda:GetEventSourceMapping",
                "resource_mappings": {
                    "UUID": {
                        "template": "${UUID}"
                    }
                }
            }
        ],
        "Lambda.GetFunction": [
            {
                "action": "lambda:GetFunction",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.GetFunctionCodeSigningConfig": [
            {
                "action": "lambda:GetFunctionCodeSigningConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.GetFunctionConcurrency": [
            {
                "action": "lambda:GetFunctionConcurrency",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.GetFunctionConfiguration": [
            {
                "action": "lambda:GetFunctionConfiguration",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.GetFunctionEventInvokeConfig": [
            {
                "action": "lambda:GetFunctionEventInvokeConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.GetLayerVersion": [
            {
                "action": "lambda:GetLayerVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "layerVersion": "%%iftemplatematch%${LayerName}%%"
                }
            }
        ],
        "Lambda.GetLayerVersionPolicy": [
            {
                "action": "lambda:GetLayerVersionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "layerVersion": "%%iftemplatematch%${LayerName}%%"
                }
            }
        ],
        "Lambda.GetPolicy": [
            {
                "action": "lambda:GetPolicy",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.GetProvisionedConcurrencyConfig": [
            {
                "action": "lambda:GetProvisionedConcurrencyConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    },
                    "Alias": {
                        "template": "%%regex%${Qualifier}%/^(?!^[0-9]+$)([a-zA-Z0-9-_]+)$/g%%"
                    },
                    "Version": {
                        "template": "%%regex%${Qualifier}%/^([0-9]+)$/g%%"
                    }
                }
            }
        ],
        "Lambda.InvokeAsync": [
            {
                "action": "lambda:InvokeAsync",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.ListAliases": [
            {
                "action": "lambda:ListAliases",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.ListCodeSigningConfigs": [
            {
                "action": "lambda:ListCodeSigningConfigs",
                "resource_mappings": {}
            }
        ],
        "Lambda.ListEventSourceMappings": [
            {
                "action": "lambda:ListEventSourceMappings",
                "resource_mappings": {}
            }
        ],
        "Lambda.ListFunctionEventInvokeConfigs": [
            {
                "action": "lambda:ListFunctionEventInvokeConfigs",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.ListFunctions": [
            {
                "action": "lambda:ListFunctions",
                "resource_mappings": {}
            }
        ],
        "Lambda.ListFunctionsByCodeSigningConfig": [
            {
                "action": "lambda:ListFunctionsByCodeSigningConfig",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "code signing config": "${CodeSigningConfigArn}"
                }
            }
        ],
        "Lambda.ListLayerVersions": [
            {
                "action": "lambda:ListLayerVersions",
                "resource_mappings": {}
            }
        ],
        "Lambda.ListLayers": [
            {
                "action": "lambda:ListLayers",
                "resource_mappings": {}
            }
        ],
        "Lambda.ListProvisionedConcurrencyConfigs": [
            {
                "action": "lambda:ListProvisionedConcurrencyConfigs",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.ListTags": [
            {
                "action": "lambda:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "function": "%%iftemplatematch%${Resource}%%"
                }
            }
        ],
        "Lambda.ListVersionsByFunction": [
            {
                "action": "lambda:ListVersionsByFunction",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.PublishLayerVersion": [
            {
                "action": "lambda:PublishLayerVersion",
                "resource_mappings": {
                    "LayerName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.PublishVersion": [
            {
                "action": "lambda:PublishVersion",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.PutFunctionCodeSigningConfig": [
            {
                "action": "lambda:PutFunctionCodeSigningConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                },
                "resourcearn_mappings": {
                    "code signing config": "${CodeSigningConfigArn}"
                }
            }
        ],
        "Lambda.PutFunctionConcurrency": [
            {
                "action": "lambda:PutFunctionConcurrency",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.PutFunctionEventInvokeConfig": [
            {
                "action": "lambda:PutFunctionEventInvokeConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.PutProvisionedConcurrencyConfig": [
            {
                "action": "lambda:PutProvisionedConcurrencyConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    },
                    "Alias": {
                        "template": "%%regex%${Qualifier}%/^(?!^[0-9]+$)([a-zA-Z0-9-_]+)$/g%%"
                    },
                    "Version": {
                        "template": "%%regex%${Qualifier}%/^([0-9]+)$/g%%"
                    }
                }
            }
        ],
        "Lambda.RemoveLayerVersionPermission": [
            {
                "action": "lambda:RemoveLayerVersionPermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "layerVersion": "%%iftemplatematch%${LayerName}%%"
                }
            }
        ],
        "Lambda.RemovePermission": [
            {
                "action": "lambda:RemovePermission",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.TagResource": [
            {
                "action": "lambda:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "function": "%%iftemplatematch%${Resource}%%"
                }
            }
        ],
        "Lambda.UntagResource": [
            {
                "action": "lambda:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "function": "%%iftemplatematch%${Resource}%%"
                }
            }
        ],
        "Lambda.UpdateAlias": [
            {
                "action": "lambda:UpdateAlias",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.UpdateCodeSigningConfig": [
            {
                "action": "lambda:UpdateCodeSigningConfig",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "code signing config": "${CodeSigningConfigArn}"
                }
            }
        ],
        "Lambda.UpdateEventSourceMapping": [
            {
                "action": "lambda:UpdateEventSourceMapping",
                "resource_mappings": {
                    "UUID": {
                        "template": "${UUID}"
                    }
                }
            }
        ],
        "Lambda.UpdateFunctionCode": [
            {
                "action": "lambda:UpdateFunctionCode",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "Lambda.UpdateFunctionConfiguration": [
            {
                "action": "lambda:UpdateFunctionConfiguration",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "Lambda.UpdateFunctionEventInvokeConfig": [
            {
                "action": "lambda:UpdateFunctionEventInvokeConfig",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "%%regex%${FunctionName}%/^(?:^arn\\:aws\\:.+function\\:|^[0-9]{12}\\:function\\:)?([^:]+?)(?:\\:[^:]+)?$/g%%"
                    }
                }
            }
        ],
        "LexRuntime.DeleteSession": [
            {
                "action": "lex:DeleteSession",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${botAlias}"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "*"
                    },
                    "BotAliasId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexRuntime.GetSession": [
            {
                "action": "lex:GetSession",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${botAlias}"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "*"
                    },
                    "BotAliasId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexRuntime.PostContent": [
            {
                "action": "lex:PostContent",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${botAlias}"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexRuntime.PostText": [
            {
                "action": "lex:PostText",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${botAlias}"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexRuntime.PutSession": [
            {
                "action": "lex:PutSession",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${botAlias}"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "*"
                    },
                    "BotAliasId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.AllocateStaticIp": [
            {
                "action": "lightsail:AllocateStaticIp",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.AttachDisk": [
            {
                "action": "lightsail:AttachDisk",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.AttachInstancesToLoadBalancer": [
            {
                "action": "lightsail:AttachInstancesToLoadBalancer",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.AttachLoadBalancerTlsCertificate": [
            {
                "action": "lightsail:AttachLoadBalancerTlsCertificate",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.AttachStaticIp": [
            {
                "action": "lightsail:AttachStaticIp",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CloseInstancePublicPorts": [
            {
                "action": "lightsail:CloseInstancePublicPorts",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateCloudFormationStack": [
            {
                "action": "lightsail:CreateCloudFormationStack",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateDisk": [
            {
                "action": "lightsail:CreateDisk",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateDiskFromSnapshot": [
            {
                "action": "lightsail:CreateDiskFromSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateDiskSnapshot": [
            {
                "action": "lightsail:CreateDiskSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateDomain": [
            {
                "action": "lightsail:CreateDomain",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateDomainEntry": [
            {
                "action": "lightsail:CreateDomainEntry",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateInstanceSnapshot": [
            {
                "action": "lightsail:CreateInstanceSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateInstances": [
            {
                "action": "lightsail:CreateInstances",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateInstancesFromSnapshot": [
            {
                "action": "lightsail:CreateInstancesFromSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateKeyPair": [
            {
                "action": "lightsail:CreateKeyPair",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateLoadBalancer": [
            {
                "action": "lightsail:CreateLoadBalancer",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateLoadBalancerTlsCertificate": [
            {
                "action": "lightsail:CreateLoadBalancerTlsCertificate",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateRelationalDatabase": [
            {
                "action": "lightsail:CreateRelationalDatabase",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateRelationalDatabaseFromSnapshot": [
            {
                "action": "lightsail:CreateRelationalDatabaseFromSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateRelationalDatabaseSnapshot": [
            {
                "action": "lightsail:CreateRelationalDatabaseSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteDisk": [
            {
                "action": "lightsail:DeleteDisk",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteDiskSnapshot": [
            {
                "action": "lightsail:DeleteDiskSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteDomain": [
            {
                "action": "lightsail:DeleteDomain",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteDomainEntry": [
            {
                "action": "lightsail:DeleteDomainEntry",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteInstance": [
            {
                "action": "lightsail:DeleteInstance",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteInstanceSnapshot": [
            {
                "action": "lightsail:DeleteInstanceSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteKeyPair": [
            {
                "action": "lightsail:DeleteKeyPair",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteKnownHostKeys": [
            {
                "action": "lightsail:DeleteKnownHostKeys",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteLoadBalancer": [
            {
                "action": "lightsail:DeleteLoadBalancer",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteLoadBalancerTlsCertificate": [
            {
                "action": "lightsail:DeleteLoadBalancerTlsCertificate",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteRelationalDatabase": [
            {
                "action": "lightsail:DeleteRelationalDatabase",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteRelationalDatabaseSnapshot": [
            {
                "action": "lightsail:DeleteRelationalDatabaseSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DetachDisk": [
            {
                "action": "lightsail:DetachDisk",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DetachInstancesFromLoadBalancer": [
            {
                "action": "lightsail:DetachInstancesFromLoadBalancer",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DetachStaticIp": [
            {
                "action": "lightsail:DetachStaticIp",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DownloadDefaultKeyPair": [
            {
                "action": "lightsail:DownloadDefaultKeyPair",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.ExportSnapshot": [
            {
                "action": "lightsail:ExportSnapshot",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetActiveNames": [
            {
                "action": "lightsail:GetActiveNames",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetBlueprints": [
            {
                "action": "lightsail:GetBlueprints",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetBundles": [
            {
                "action": "lightsail:GetBundles",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetCloudFormationStackRecords": [
            {
                "action": "lightsail:GetCloudFormationStackRecords",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetDisk": [
            {
                "action": "lightsail:GetDisk",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetDiskSnapshot": [
            {
                "action": "lightsail:GetDiskSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetDiskSnapshots": [
            {
                "action": "lightsail:GetDiskSnapshots",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetDisks": [
            {
                "action": "lightsail:GetDisks",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetDomain": [
            {
                "action": "lightsail:GetDomain",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetDomains": [
            {
                "action": "lightsail:GetDomains",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetExportSnapshotRecords": [
            {
                "action": "lightsail:GetExportSnapshotRecords",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetInstance": [
            {
                "action": "lightsail:GetInstance",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetInstanceAccessDetails": [
            {
                "action": "lightsail:GetInstanceAccessDetails",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetInstanceMetricData": [
            {
                "action": "lightsail:GetInstanceMetricData",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetInstancePortStates": [
            {
                "action": "lightsail:GetInstancePortStates",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetInstanceSnapshot": [
            {
                "action": "lightsail:GetInstanceSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetInstanceSnapshots": [
            {
                "action": "lightsail:GetInstanceSnapshots",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetInstanceState": [
            {
                "action": "lightsail:GetInstanceState",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetInstances": [
            {
                "action": "lightsail:GetInstances",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetKeyPair": [
            {
                "action": "lightsail:GetKeyPair",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetKeyPairs": [
            {
                "action": "lightsail:GetKeyPairs",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetLoadBalancer": [
            {
                "action": "lightsail:GetLoadBalancer",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetLoadBalancerMetricData": [
            {
                "action": "lightsail:GetLoadBalancerMetricData",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetLoadBalancerTlsCertificates": [
            {
                "action": "lightsail:GetLoadBalancerTlsCertificates",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetLoadBalancers": [
            {
                "action": "lightsail:GetLoadBalancers",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetOperation": [
            {
                "action": "lightsail:GetOperation",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetOperations": [
            {
                "action": "lightsail:GetOperations",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetOperationsForResource": [
            {
                "action": "lightsail:GetOperationsForResource",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetRegions": [
            {
                "action": "lightsail:GetRegions",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetRelationalDatabase": [
            {
                "action": "lightsail:GetRelationalDatabase",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetRelationalDatabaseBlueprints": [
            {
                "action": "lightsail:GetRelationalDatabaseBlueprints",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetRelationalDatabaseBundles": [
            {
                "action": "lightsail:GetRelationalDatabaseBundles",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetRelationalDatabaseEvents": [
            {
                "action": "lightsail:GetRelationalDatabaseEvents",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetRelationalDatabaseLogEvents": [
            {
                "action": "lightsail:GetRelationalDatabaseLogEvents",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetRelationalDatabaseLogStreams": [
            {
                "action": "lightsail:GetRelationalDatabaseLogStreams",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetRelationalDatabaseMasterUserPassword": [
            {
                "action": "lightsail:GetRelationalDatabaseMasterUserPassword",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetRelationalDatabaseMetricData": [
            {
                "action": "lightsail:GetRelationalDatabaseMetricData",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetRelationalDatabaseParameters": [
            {
                "action": "lightsail:GetRelationalDatabaseParameters",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetRelationalDatabaseSnapshot": [
            {
                "action": "lightsail:GetRelationalDatabaseSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetRelationalDatabaseSnapshots": [
            {
                "action": "lightsail:GetRelationalDatabaseSnapshots",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetRelationalDatabases": [
            {
                "action": "lightsail:GetRelationalDatabases",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetStaticIp": [
            {
                "action": "lightsail:GetStaticIp",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetStaticIps": [
            {
                "action": "lightsail:GetStaticIps",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.ImportKeyPair": [
            {
                "action": "lightsail:ImportKeyPair",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.IsVpcPeered": [
            {
                "action": "lightsail:IsVpcPeered",
                "resource_mappings": {}
            }
        ],
        "Lightsail.OpenInstancePublicPorts": [
            {
                "action": "lightsail:OpenInstancePublicPorts",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.PeerVpc": [
            {
                "action": "lightsail:PeerVpc",
                "resource_mappings": {}
            }
        ],
        "Lightsail.PutInstancePublicPorts": [
            {
                "action": "lightsail:PutInstancePublicPorts",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.RebootInstance": [
            {
                "action": "lightsail:RebootInstance",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.RebootRelationalDatabase": [
            {
                "action": "lightsail:RebootRelationalDatabase",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.ReleaseStaticIp": [
            {
                "action": "lightsail:ReleaseStaticIp",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.StartInstance": [
            {
                "action": "lightsail:StartInstance",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.StartRelationalDatabase": [
            {
                "action": "lightsail:StartRelationalDatabase",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.StopInstance": [
            {
                "action": "lightsail:StopInstance",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.StopRelationalDatabase": [
            {
                "action": "lightsail:StopRelationalDatabase",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.TagResource": [
            {
                "action": "lightsail:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Disk": "%%iftemplatematch%${resourceArn}%%",
                    "DiskSnapshot": "%%iftemplatematch%${resourceArn}%%",
                    "Domain": "%%iftemplatematch%${resourceArn}%%",
                    "Instance": "%%iftemplatematch%${resourceArn}%%",
                    "InstanceSnapshot": "%%iftemplatematch%${resourceArn}%%",
                    "KeyPair": "%%iftemplatematch%${resourceArn}%%",
                    "LoadBalancer": "%%iftemplatematch%${resourceArn}%%",
                    "RelationalDatabase": "%%iftemplatematch%${resourceArn}%%",
                    "RelationalDatabaseSnapshot": "%%iftemplatematch%${resourceArn}%%",
                    "StaticIp": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Lightsail.UnpeerVpc": [
            {
                "action": "lightsail:UnpeerVpc",
                "resource_mappings": {}
            }
        ],
        "Lightsail.UntagResource": [
            {
                "action": "lightsail:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Disk": "%%iftemplatematch%${resourceArn}%%",
                    "DiskSnapshot": "%%iftemplatematch%${resourceArn}%%",
                    "Domain": "%%iftemplatematch%${resourceArn}%%",
                    "Instance": "%%iftemplatematch%${resourceArn}%%",
                    "InstanceSnapshot": "%%iftemplatematch%${resourceArn}%%",
                    "KeyPair": "%%iftemplatematch%${resourceArn}%%",
                    "LoadBalancer": "%%iftemplatematch%${resourceArn}%%",
                    "RelationalDatabase": "%%iftemplatematch%${resourceArn}%%",
                    "RelationalDatabaseSnapshot": "%%iftemplatematch%${resourceArn}%%",
                    "StaticIp": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Lightsail.UpdateDomainEntry": [
            {
                "action": "lightsail:UpdateDomainEntry",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.UpdateLoadBalancerAttribute": [
            {
                "action": "lightsail:UpdateLoadBalancerAttribute",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.UpdateRelationalDatabase": [
            {
                "action": "lightsail:UpdateRelationalDatabase",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.UpdateRelationalDatabaseParameters": [
            {
                "action": "lightsail:UpdateRelationalDatabaseParameters",
                "resource_mappings": {}
            }
        ],
        "MachineLearning.AddTags": [
            {
                "action": "machinelearning:AddTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "batchprediction": "%%iftemplatematch%${ResourceId}%%",
                    "datasource": "%%iftemplatematch%${ResourceId}%%",
                    "evaluation": "%%iftemplatematch%${ResourceId}%%",
                    "mlmodel": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "MachineLearning.CreateBatchPrediction": [
            {
                "action": "machinelearning:CreateBatchPrediction",
                "resource_mappings": {
                    "BatchPredictionId": {
                        "template": "${BatchPredictionId}"
                    },
                    "DatasourceId": {
                        "template": "${BatchPredictionDataSourceId}"
                    },
                    "MlModelId": {
                        "template": "${MLModelId}"
                    }
                }
            }
        ],
        "MachineLearning.CreateDataSourceFromRDS": [
            {
                "action": "machinelearning:CreateDataSourceFromRDS",
                "resource_mappings": {
                    "DatasourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${RDSData.ResourceRole}%${RDSData.ServiceRole}%${RoleARN}%%"
                }
            }
        ],
        "MachineLearning.CreateDataSourceFromRedshift": [
            {
                "action": "machinelearning:CreateDataSourceFromRedshift",
                "resource_mappings": {
                    "DatasourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "MachineLearning.CreateDataSourceFromS3": [
            {
                "action": "machinelearning:CreateDataSourceFromS3",
                "resource_mappings": {
                    "DatasourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "MachineLearning.CreateEvaluation": [
            {
                "action": "machinelearning:CreateEvaluation",
                "resource_mappings": {
                    "DatasourceId": {
                        "template": "${EvaluationDataSourceId}"
                    },
                    "EvaluationId": {
                        "template": "${EvaluationId}"
                    },
                    "MlModelId": {
                        "template": "${MLModelId}"
                    }
                }
            }
        ],
        "MachineLearning.CreateMLModel": [
            {
                "action": "machinelearning:CreateMLModel",
                "resource_mappings": {
                    "DatasourceId": {
                        "template": "${TrainingDataSourceId}"
                    },
                    "MlModelId": {
                        "template": "${MLModelId}"
                    }
                }
            }
        ],
        "MachineLearning.CreateRealtimeEndpoint": [
            {
                "action": "machinelearning:CreateRealtimeEndpoint",
                "resource_mappings": {
                    "MlModelId": {
                        "template": "${MLModelId}"
                    }
                }
            }
        ],
        "MachineLearning.DeleteBatchPrediction": [
            {
                "action": "machinelearning:DeleteBatchPrediction",
                "resource_mappings": {
                    "BatchPredictionId": {
                        "template": "${BatchPredictionId}"
                    }
                }
            }
        ],
        "MachineLearning.DeleteDataSource": [
            {
                "action": "machinelearning:DeleteDataSource",
                "resource_mappings": {
                    "DatasourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "MachineLearning.DeleteEvaluation": [
            {
                "action": "machinelearning:DeleteEvaluation",
                "resource_mappings": {
                    "EvaluationId": {
                        "template": "${EvaluationId}"
                    }
                }
            }
        ],
        "MachineLearning.DeleteMLModel": [
            {
                "action": "machinelearning:DeleteMLModel",
                "resource_mappings": {
                    "MlModelId": {
                        "template": "${MLModelId}"
                    }
                }
            }
        ],
        "MachineLearning.DeleteRealtimeEndpoint": [
            {
                "action": "machinelearning:DeleteRealtimeEndpoint",
                "resource_mappings": {
                    "MlModelId": {
                        "template": "${MLModelId}"
                    }
                }
            }
        ],
        "MachineLearning.DeleteTags": [
            {
                "action": "machinelearning:DeleteTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "batchprediction": "%%iftemplatematch%${ResourceId}%%",
                    "datasource": "%%iftemplatematch%${ResourceId}%%",
                    "evaluation": "%%iftemplatematch%${ResourceId}%%",
                    "mlmodel": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "MachineLearning.DescribeBatchPredictions": [
            {
                "action": "machinelearning:DescribeBatchPredictions",
                "resource_mappings": {}
            }
        ],
        "MachineLearning.DescribeDataSources": [
            {
                "action": "machinelearning:DescribeDataSources",
                "resource_mappings": {}
            }
        ],
        "MachineLearning.DescribeEvaluations": [
            {
                "action": "machinelearning:DescribeEvaluations",
                "resource_mappings": {}
            }
        ],
        "MachineLearning.DescribeMLModels": [
            {
                "action": "machinelearning:DescribeMLModels",
                "resource_mappings": {}
            }
        ],
        "MachineLearning.DescribeTags": [
            {
                "action": "machinelearning:DescribeTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "batchprediction": "%%iftemplatematch%${ResourceId}%%",
                    "datasource": "%%iftemplatematch%${ResourceId}%%",
                    "evaluation": "%%iftemplatematch%${ResourceId}%%",
                    "mlmodel": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "MachineLearning.GetBatchPrediction": [
            {
                "action": "machinelearning:GetBatchPrediction",
                "resource_mappings": {
                    "BatchPredictionId": {
                        "template": "${BatchPredictionId}"
                    }
                }
            }
        ],
        "MachineLearning.GetDataSource": [
            {
                "action": "machinelearning:GetDataSource",
                "resource_mappings": {
                    "DatasourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "MachineLearning.GetEvaluation": [
            {
                "action": "machinelearning:GetEvaluation",
                "resource_mappings": {
                    "DatasourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "MachineLearning.GetMLModel": [
            {
                "action": "machinelearning:GetMLModel",
                "resource_mappings": {
                    "MlModelId": {
                        "template": "${MLModelId}"
                    }
                }
            }
        ],
        "MachineLearning.Predict": [
            {
                "action": "machinelearning:Predict",
                "resource_mappings": {
                    "MlModelId": {
                        "template": "${MLModelId}"
                    }
                }
            }
        ],
        "MachineLearning.UpdateBatchPrediction": [
            {
                "action": "machinelearning:UpdateBatchPrediction",
                "resource_mappings": {
                    "BatchPredictionId": {
                        "template": "${BatchPredictionId}"
                    }
                }
            }
        ],
        "MachineLearning.UpdateDataSource": [
            {
                "action": "machinelearning:UpdateDataSource",
                "resource_mappings": {
                    "DatasourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "MachineLearning.UpdateEvaluation": [
            {
                "action": "machinelearning:UpdateEvaluation",
                "resource_mappings": {
                    "EvaluationId": {
                        "template": "${EvaluationId}"
                    }
                }
            }
        ],
        "MachineLearning.UpdateMLModel": [
            {
                "action": "machinelearning:UpdateMLModel",
                "resource_mappings": {
                    "MlModelId": {
                        "template": "${MLModelId}"
                    }
                }
            }
        ],
        "MarketplaceCommerceAnalytics.GenerateDataSet": [
            {
                "action": "marketplacecommerceanalytics:GenerateDataSet",
                "resource_mappings": {}
            }
        ],
        "MarketplaceCommerceAnalytics.StartSupportDataExport": [
            {
                "action": "marketplacecommerceanalytics:StartSupportDataExport",
                "resource_mappings": {}
            }
        ],
        "MarketplaceMetering.BatchMeterUsage": [
            {
                "action": "aws-marketplace:BatchMeterUsage",
                "resource_mappings": {}
            }
        ],
        "MarketplaceMetering.MeterUsage": [
            {
                "action": "aws-marketplace:MeterUsage",
                "resource_mappings": {}
            }
        ],
        "MarketplaceMetering.RegisterUsage": [
            {
                "action": "aws-marketplace:RegisterUsage",
                "resource_mappings": {}
            }
        ],
        "MarketplaceMetering.ResolveCustomer": [
            {
                "action": "aws-marketplace:ResolveCustomer",
                "resource_mappings": {}
            }
        ],
        "MTurk.AcceptQualificationRequest": [
            {
                "action": "mechanicalturk:AcceptQualificationRequest",
                "resource_mappings": {}
            }
        ],
        "MTurk.ApproveAssignment": [
            {
                "action": "mechanicalturk:ApproveAssignment",
                "resource_mappings": {}
            }
        ],
        "MTurk.AssociateQualificationWithWorker": [
            {
                "action": "mechanicalturk:AssociateQualificationWithWorker",
                "resource_mappings": {}
            }
        ],
        "MTurk.CreateAdditionalAssignmentsForHIT": [
            {
                "action": "mechanicalturk:CreateAdditionalAssignmentsForHIT",
                "resource_mappings": {}
            }
        ],
        "MTurk.CreateHIT": [
            {
                "action": "mechanicalturk:CreateHIT",
                "resource_mappings": {}
            }
        ],
        "MTurk.CreateHITType": [
            {
                "action": "mechanicalturk:CreateHITType",
                "resource_mappings": {}
            }
        ],
        "MTurk.CreateHITWithHITType": [
            {
                "action": "mechanicalturk:CreateHITWithHITType",
                "resource_mappings": {}
            }
        ],
        "MTurk.CreateQualificationType": [
            {
                "action": "mechanicalturk:CreateQualificationType",
                "resource_mappings": {}
            }
        ],
        "MTurk.CreateWorkerBlock": [
            {
                "action": "mechanicalturk:CreateWorkerBlock",
                "resource_mappings": {}
            }
        ],
        "MTurk.DeleteHIT": [
            {
                "action": "mechanicalturk:DeleteHIT",
                "resource_mappings": {}
            }
        ],
        "MTurk.DeleteQualificationType": [
            {
                "action": "mechanicalturk:DeleteQualificationType",
                "resource_mappings": {}
            }
        ],
        "MTurk.DeleteWorkerBlock": [
            {
                "action": "mechanicalturk:DeleteWorkerBlock",
                "resource_mappings": {}
            }
        ],
        "MTurk.DisassociateQualificationFromWorker": [
            {
                "action": "mechanicalturk:DisassociateQualificationFromWorker",
                "resource_mappings": {}
            }
        ],
        "MTurk.GetAccountBalance": [
            {
                "action": "mechanicalturk:GetAccountBalance",
                "resource_mappings": {}
            }
        ],
        "MTurk.GetAssignment": [
            {
                "action": "mechanicalturk:GetAssignment",
                "resource_mappings": {}
            }
        ],
        "MTurk.GetFileUploadURL": [
            {
                "action": "mechanicalturk:GetFileUploadURL",
                "resource_mappings": {}
            }
        ],
        "MTurk.GetHIT": [
            {
                "action": "mechanicalturk:GetHIT",
                "resource_mappings": {}
            }
        ],
        "MTurk.GetQualificationScore": [
            {
                "action": "mechanicalturk:GetQualificationScore",
                "resource_mappings": {}
            }
        ],
        "MTurk.GetQualificationType": [
            {
                "action": "mechanicalturk:GetQualificationType",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListAssignmentsForHIT": [
            {
                "action": "mechanicalturk:ListAssignmentsForHIT",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListBonusPayments": [
            {
                "action": "mechanicalturk:ListBonusPayments",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListHITs": [
            {
                "action": "mechanicalturk:ListHITs",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListHITsForQualificationType": [
            {
                "action": "mechanicalturk:ListHITsForQualificationType",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListQualificationRequests": [
            {
                "action": "mechanicalturk:ListQualificationRequests",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListQualificationTypes": [
            {
                "action": "mechanicalturk:ListQualificationTypes",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListReviewPolicyResultsForHIT": [
            {
                "action": "mechanicalturk:ListReviewPolicyResultsForHIT",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListReviewableHITs": [
            {
                "action": "mechanicalturk:ListReviewableHITs",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListWorkerBlocks": [
            {
                "action": "mechanicalturk:ListWorkerBlocks",
                "resource_mappings": {}
            }
        ],
        "MTurk.ListWorkersWithQualificationType": [
            {
                "action": "mechanicalturk:ListWorkersWithQualificationType",
                "resource_mappings": {}
            }
        ],
        "MTurk.NotifyWorkers": [
            {
                "action": "mechanicalturk:NotifyWorkers",
                "resource_mappings": {}
            }
        ],
        "MTurk.RejectAssignment": [
            {
                "action": "mechanicalturk:RejectAssignment",
                "resource_mappings": {}
            }
        ],
        "MTurk.RejectQualificationRequest": [
            {
                "action": "mechanicalturk:RejectQualificationRequest",
                "resource_mappings": {}
            }
        ],
        "MTurk.SendBonus": [
            {
                "action": "mechanicalturk:SendBonus",
                "resource_mappings": {}
            }
        ],
        "MTurk.SendTestEventNotification": [
            {
                "action": "mechanicalturk:SendTestEventNotification",
                "resource_mappings": {}
            }
        ],
        "MTurk.UpdateExpirationForHIT": [
            {
                "action": "mechanicalturk:UpdateExpirationForHIT",
                "resource_mappings": {}
            }
        ],
        "MTurk.UpdateHITReviewStatus": [
            {
                "action": "mechanicalturk:UpdateHITReviewStatus",
                "resource_mappings": {}
            }
        ],
        "MTurk.UpdateHITTypeOfHIT": [
            {
                "action": "mechanicalturk:UpdateHITTypeOfHIT",
                "resource_mappings": {}
            }
        ],
        "MTurk.UpdateNotificationSettings": [
            {
                "action": "mechanicalturk:UpdateNotificationSettings",
                "resource_mappings": {}
            }
        ],
        "MTurk.UpdateQualificationType": [
            {
                "action": "mechanicalturk:UpdateQualificationType",
                "resource_mappings": {}
            }
        ],
        "MobileAnalytics.PutEvents": [
            {
                "action": "mobileanalytics:PutEvents",
                "resource_mappings": {}
            }
        ],
        "OpsWorks.AssignInstance": [
            {
                "action": "opsworks:AssignInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.AssignVolume": [
            {
                "action": "opsworks:AssignVolume",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.AssociateElasticIp": [
            {
                "action": "opsworks:AssociateElasticIp",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.AttachElasticLoadBalancer": [
            {
                "action": "opsworks:AttachElasticLoadBalancer",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.CloneStack": [
            {
                "action": "opsworks:CloneStack",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ServiceRoleArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${DefaultInstanceProfileArn}%*%%%"
                }
            }
        ],
        "OpsWorks.CreateApp": [
            {
                "action": "opsworks:CreateApp",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.CreateDeployment": [
            {
                "action": "opsworks:CreateDeployment",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.CreateInstance": [
            {
                "action": "opsworks:CreateInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.CreateLayer": [
            {
                "action": "opsworks:CreateLayer",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${CustomInstanceProfileArn}%*%%%"
                }
            }
        ],
        "OpsWorks.CreateStack": [
            {
                "action": "opsworks:CreateStack",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ServiceRoleArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${DefaultInstanceProfileArn}%*%%%"
                }
            }
        ],
        "OpsWorks.CreateUserProfile": [
            {
                "action": "opsworks:CreateUserProfile",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamUserArn}"
                }
            }
        ],
        "OpsWorks.DeleteApp": [
            {
                "action": "opsworks:DeleteApp",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DeleteInstance": [
            {
                "action": "opsworks:DeleteInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DeleteLayer": [
            {
                "action": "opsworks:DeleteLayer",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DeleteStack": [
            {
                "action": "opsworks:DeleteStack",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DeleteUserProfile": [
            {
                "action": "opsworks:DeleteUserProfile",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamUserArn}"
                }
            }
        ],
        "OpsWorks.DeregisterEcsCluster": [
            {
                "action": "opsworks:DeregisterEcsCluster",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DeregisterElasticIp": [
            {
                "action": "opsworks:DeregisterElasticIp",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DeregisterInstance": [
            {
                "action": "opsworks:DeregisterInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DeregisterRdsDbInstance": [
            {
                "action": "opsworks:DeregisterRdsDbInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DeregisterVolume": [
            {
                "action": "opsworks:DeregisterVolume",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DescribeAgentVersions": [
            {
                "action": "opsworks:DescribeAgentVersions",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeApps": [
            {
                "action": "opsworks:DescribeApps",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeCommands": [
            {
                "action": "opsworks:DescribeCommands",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DescribeDeployments": [
            {
                "action": "opsworks:DescribeDeployments",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeEcsClusters": [
            {
                "action": "opsworks:DescribeEcsClusters",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeElasticIps": [
            {
                "action": "opsworks:DescribeElasticIps",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeElasticLoadBalancers": [
            {
                "action": "opsworks:DescribeElasticLoadBalancers",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeInstances": [
            {
                "action": "opsworks:DescribeInstances",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeLayers": [
            {
                "action": "opsworks:DescribeLayers",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeLoadBasedAutoScaling": [
            {
                "action": "opsworks:DescribeLoadBasedAutoScaling",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DescribeMyUserProfile": [
            {
                "action": "opsworks:DescribeMyUserProfile",
                "resource_mappings": {}
            }
        ],
        "OpsWorks.DescribePermissions": [
            {
                "action": "opsworks:DescribePermissions",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeRaidArrays": [
            {
                "action": "opsworks:DescribeRaidArrays",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeRdsDbInstances": [
            {
                "action": "opsworks:DescribeRdsDbInstances",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeServiceErrors": [
            {
                "action": "opsworks:DescribeServiceErrors",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeStackProvisioningParameters": [
            {
                "action": "opsworks:DescribeStackProvisioningParameters",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeStackSummary": [
            {
                "action": "opsworks:DescribeStackSummary",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeStacks": [
            {
                "action": "opsworks:DescribeStacks",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackIds[]}"
                    }
                }
            }
        ],
        "OpsWorks.DescribeTimeBasedAutoScaling": [
            {
                "action": "opsworks:DescribeTimeBasedAutoScaling",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DescribeUserProfiles": [
            {
                "action": "opsworks:DescribeUserProfiles",
                "resource_mappings": {}
            }
        ],
        "OpsWorks.DescribeVolumes": [
            {
                "action": "opsworks:DescribeVolumes",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.DetachElasticLoadBalancer": [
            {
                "action": "opsworks:DetachElasticLoadBalancer",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DisassociateElasticIp": [
            {
                "action": "opsworks:DisassociateElasticIp",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.GetHostnameSuggestion": [
            {
                "action": "opsworks:GetHostnameSuggestion",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.GrantAccess": [
            {
                "action": "opsworks:GrantAccess",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.ListTags": [
            {
                "action": "opsworks:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stack": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "OpsWorks.RebootInstance": [
            {
                "action": "opsworks:RebootInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.RegisterEcsCluster": [
            {
                "action": "opsworks:RegisterEcsCluster",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.RegisterElasticIp": [
            {
                "action": "opsworks:RegisterElasticIp",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.RegisterInstance": [
            {
                "action": "opsworks:RegisterInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.RegisterRdsDbInstance": [
            {
                "action": "opsworks:RegisterRdsDbInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.RegisterVolume": [
            {
                "action": "opsworks:RegisterVolume",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.SetLoadBasedAutoScaling": [
            {
                "action": "opsworks:SetLoadBasedAutoScaling",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.SetPermission": [
            {
                "action": "opsworks:SetPermission",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.SetTimeBasedAutoScaling": [
            {
                "action": "opsworks:SetTimeBasedAutoScaling",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.StartInstance": [
            {
                "action": "opsworks:StartInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.StartStack": [
            {
                "action": "opsworks:StartStack",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.StopInstance": [
            {
                "action": "opsworks:StopInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.StopStack": [
            {
                "action": "opsworks:StopStack",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            }
        ],
        "OpsWorks.TagResource": [
            {
                "action": "opsworks:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stack": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "OpsWorks.UnassignInstance": [
            {
                "action": "opsworks:UnassignInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.UnassignVolume": [
            {
                "action": "opsworks:UnassignVolume",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.UntagResource": [
            {
                "action": "opsworks:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stack": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "OpsWorks.UpdateApp": [
            {
                "action": "opsworks:UpdateApp",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.UpdateElasticIp": [
            {
                "action": "opsworks:UpdateElasticIp",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.UpdateInstance": [
            {
                "action": "opsworks:UpdateInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.UpdateLayer": [
            {
                "action": "opsworks:UpdateLayer",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${CustomInstanceProfileArn}%*%%%"
                }
            }
        ],
        "OpsWorks.UpdateMyUserProfile": [
            {
                "action": "opsworks:UpdateMyUserProfile",
                "resource_mappings": {}
            }
        ],
        "OpsWorks.UpdateRdsDbInstance": [
            {
                "action": "opsworks:UpdateRdsDbInstance",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.UpdateStack": [
            {
                "action": "opsworks:UpdateStack",
                "resource_mappings": {
                    "StackId": {
                        "template": "${StackId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ServiceRoleArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${DefaultInstanceProfileArn}%*%%%"
                }
            }
        ],
        "OpsWorks.UpdateUserProfile": [
            {
                "action": "opsworks:UpdateUserProfile",
                "resource_mappings": {}
            }
        ],
        "OpsWorks.UpdateVolume": [
            {
                "action": "opsworks:UpdateVolume",
                "resource_mappings": {
                    "StackId": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorksCM.AssociateNode": [
            {
                "action": "opsworks-cm:AssociateNode",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.CreateBackup": [
            {
                "action": "opsworks-cm:CreateBackup",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.CreateServer": [
            {
                "action": "opsworks-cm:CreateServer",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ServiceRoleArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${InstanceProfileArn}%*%%%"
                }
            }
        ],
        "OpsWorksCM.DeleteBackup": [
            {
                "action": "opsworks-cm:DeleteBackup",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.DeleteServer": [
            {
                "action": "opsworks-cm:DeleteServer",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.DescribeAccountAttributes": [
            {
                "action": "opsworks-cm:DescribeAccountAttributes",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.DescribeBackups": [
            {
                "action": "opsworks-cm:DescribeBackups",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.DescribeEvents": [
            {
                "action": "opsworks-cm:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.DescribeNodeAssociationStatus": [
            {
                "action": "opsworks-cm:DescribeNodeAssociationStatus",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.DescribeServers": [
            {
                "action": "opsworks-cm:DescribeServers",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.DisassociateNode": [
            {
                "action": "opsworks-cm:DisassociateNode",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.ListTagsForResource": [
            {
                "action": "opsworks-cm:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.RestoreServer": [
            {
                "action": "opsworks-cm:RestoreServer",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.StartMaintenance": [
            {
                "action": "opsworks-cm:StartMaintenance",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.TagResource": [
            {
                "action": "opsworks-cm:TagResource",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.UntagResource": [
            {
                "action": "opsworks-cm:UntagResource",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.UpdateServer": [
            {
                "action": "opsworks-cm:UpdateServer",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.UpdateServerEngineAttributes": [
            {
                "action": "opsworks-cm:UpdateServerEngineAttributes",
                "resource_mappings": {}
            }
        ],
        "Organizations.AcceptHandshake": [
            {
                "action": "organizations:AcceptHandshake",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "HandshakeType": {
                        "template": "*"
                    },
                    "HandshakeId": {
                        "template": "%%regex%${HandshakeId}%/^(?:h-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.AttachPolicy": [
            {
                "action": "organizations:AttachPolicy",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "%%regex%${PolicyId}%/^(?:p-)?(.+)$/g%%"
                    },
                    "AccountId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.CancelHandshake": [
            {
                "action": "organizations:CancelHandshake",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "HandshakeType": {
                        "template": "*"
                    },
                    "HandshakeId": {
                        "template": "%%regex%${HandshakeId}%/^(?:h-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.CreateAccount": [
            {
                "action": "organizations:CreateAccount",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleName}"
                }
            }
        ],
        "Organizations.CreateGovCloudAccount": [
            {
                "action": "organizations:CreateGovCloudAccount",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleName}"
                }
            }
        ],
        "Organizations.CreateOrganization": [
            {
                "action": "organizations:CreateOrganization",
                "resource_mappings": {}
            }
        ],
        "Organizations.CreateOrganizationalUnit": [
            {
                "action": "organizations:CreateOrganizationalUnit",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.CreatePolicy": [
            {
                "action": "organizations:CreatePolicy",
                "resource_mappings": {}
            }
        ],
        "Organizations.DeclineHandshake": [
            {
                "action": "organizations:DeclineHandshake",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "HandshakeType": {
                        "template": "*"
                    },
                    "HandshakeId": {
                        "template": "%%regex%${HandshakeId}%/^(?:h-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.DeleteOrganization": [
            {
                "action": "organizations:DeleteOrganization",
                "resource_mappings": {}
            }
        ],
        "Organizations.DeleteOrganizationalUnit": [
            {
                "action": "organizations:DeleteOrganizationalUnit",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "%%regex%${OrganizationalUnitId}%/^(?:ou-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.DeletePolicy": [
            {
                "action": "organizations:DeletePolicy",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "%%regex%${PolicyId}%/^(?:p-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.DeregisterDelegatedAdministrator": [
            {
                "action": "organizations:DeregisterDelegatedAdministrator",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "${AccountId}"
                    }
                }
            }
        ],
        "Organizations.DescribeAccount": [
            {
                "action": "organizations:DescribeAccount",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "${AccountId}"
                    }
                }
            }
        ],
        "Organizations.DescribeCreateAccountStatus": [
            {
                "action": "organizations:DescribeCreateAccountStatus",
                "resource_mappings": {}
            }
        ],
        "Organizations.DescribeEffectivePolicy": [
            {
                "action": "organizations:DescribeEffectivePolicy",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.DescribeHandshake": [
            {
                "action": "organizations:DescribeHandshake",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "HandshakeType": {
                        "template": "*"
                    },
                    "HandshakeId": {
                        "template": "%%regex%${HandshakeId}%/^(?:h-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.DescribeOrganization": [
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            }
        ],
        "Organizations.DescribeOrganizationalUnit": [
            {
                "action": "organizations:DescribeOrganizationalUnit",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "%%regex%${OrganizationalUnitId}%/^(?:ou-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.DescribePolicy": [
            {
                "action": "organizations:DescribePolicy",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "%%regex%${PolicyId}%/^(?:p-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.DetachPolicy": [
            {
                "action": "organizations:DetachPolicy",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "%%regex%${PolicyId}%/^(?:p-)?(.+)$/g%%"
                    },
                    "AccountId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.DisableAWSServiceAccess": [
            {
                "action": "organizations:DisableAWSServiceAccess",
                "resource_mappings": {}
            }
        ],
        "Organizations.DisablePolicyType": [
            {
                "action": "organizations:DisablePolicyType",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "${RootId}"
                    }
                }
            }
        ],
        "Organizations.EnableAWSServiceAccess": [
            {
                "action": "organizations:EnableAWSServiceAccess",
                "resource_mappings": {}
            }
        ],
        "Organizations.EnableAllFeatures": [
            {
                "action": "organizations:EnableAllFeatures",
                "resource_mappings": {}
            }
        ],
        "Organizations.EnablePolicyType": [
            {
                "action": "organizations:EnablePolicyType",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "${RootId}"
                    }
                }
            }
        ],
        "Organizations.InviteAccountToOrganization": [
            {
                "action": "organizations:InviteAccountToOrganization",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.LeaveOrganization": [
            {
                "action": "organizations:LeaveOrganization",
                "resource_mappings": {}
            }
        ],
        "Organizations.ListAWSServiceAccessForOrganization": [
            {
                "action": "organizations:ListAWSServiceAccessForOrganization",
                "resource_mappings": {}
            }
        ],
        "Organizations.ListAccounts": [
            {
                "action": "organizations:ListAccounts",
                "resource_mappings": {}
            }
        ],
        "Organizations.ListAccountsForParent": [
            {
                "action": "organizations:ListAccountsForParent",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.ListChildren": [
            {
                "action": "organizations:ListChildren",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.ListCreateAccountStatus": [
            {
                "action": "organizations:ListCreateAccountStatus",
                "resource_mappings": {}
            }
        ],
        "Organizations.ListDelegatedAdministrators": [
            {
                "action": "organizations:ListDelegatedAdministrators",
                "resource_mappings": {}
            }
        ],
        "Organizations.ListDelegatedServicesForAccount": [
            {
                "action": "organizations:ListDelegatedServicesForAccount",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "${AccountId}"
                    }
                }
            }
        ],
        "Organizations.ListHandshakesForAccount": [
            {
                "action": "organizations:ListHandshakesForAccount",
                "resource_mappings": {}
            }
        ],
        "Organizations.ListHandshakesForOrganization": [
            {
                "action": "organizations:ListHandshakesForOrganization",
                "resource_mappings": {}
            }
        ],
        "Organizations.ListOrganizationalUnitsForParent": [
            {
                "action": "organizations:ListOrganizationalUnitsForParent",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.ListParents": [
            {
                "action": "organizations:ListParents",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.ListPolicies": [
            {
                "action": "organizations:ListPolicies",
                "resource_mappings": {}
            }
        ],
        "Organizations.ListPoliciesForTarget": [
            {
                "action": "organizations:ListPoliciesForTarget",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.ListRoots": [
            {
                "action": "organizations:ListRoots",
                "resource_mappings": {}
            }
        ],
        "Organizations.ListTagsForResource": [
            {
                "action": "organizations:ListTagsForResource",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.ListTargetsForPolicy": [
            {
                "action": "organizations:ListTargetsForPolicy",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "%%regex%${PolicyId}%/^(?:p-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.MoveAccount": [
            {
                "action": "organizations:MoveAccount",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "${AccountId}"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.RegisterDelegatedAdministrator": [
            {
                "action": "organizations:RegisterDelegatedAdministrator",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "${AccountId}"
                    }
                }
            }
        ],
        "Organizations.RemoveAccountFromOrganization": [
            {
                "action": "organizations:RemoveAccountFromOrganization",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "${AccountId}"
                    }
                }
            }
        ],
        "Organizations.TagResource": [
            {
                "action": "organizations:TagResource",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.UntagResource": [
            {
                "action": "organizations:UntagResource",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "*"
                    },
                    "RootId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Organizations.UpdateOrganizationalUnit": [
            {
                "action": "organizations:UpdateOrganizationalUnit",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "OrganizationalUnitId": {
                        "template": "%%regex%${OrganizationalUnitId}%/^(?:ou-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Organizations.UpdatePolicy": [
            {
                "action": "organizations:UpdatePolicy",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "PolicyType": {
                        "template": "*"
                    },
                    "PolicyId": {
                        "template": "%%regex%${PolicyId}%/^(?:p-)?(.+)$/g%%"
                    }
                }
            }
        ],
        "Pinpoint.CreateApp": [
            {
                "action": "mobiletargeting:CreateApp",
                "resource_mappings": {}
            }
        ],
        "Pinpoint.CreateCampaign": [
            {
                "action": "mobiletargeting:CreateCampaign",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.CreateEmailTemplate": [
            {
                "action": "mobiletargeting:CreateEmailTemplate",
                "resource_mappings": {}
            }
        ],
        "Pinpoint.CreateExportJob": [
            {
                "action": "mobiletargeting:CreateExportJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ExportJobRequest.RoleArn}"
                }
            }
        ],
        "Pinpoint.CreateImportJob": [
            {
                "action": "mobiletargeting:CreateImportJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ImportJobRequest.RoleArn}"
                }
            }
        ],
        "Pinpoint.CreateJourney": [
            {
                "action": "mobiletargeting:CreateJourney",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.CreatePushTemplate": [
            {
                "action": "mobiletargeting:CreatePushTemplate",
                "resource_mappings": {}
            }
        ],
        "Pinpoint.CreateRecommenderConfiguration": [
            {
                "action": "mobiletargeting:CreateRecommenderConfiguration",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${CreateRecommenderConfiguration.RecommendationProviderRoleArn}"
                }
            }
        ],
        "Pinpoint.CreateSegment": [
            {
                "action": "mobiletargeting:CreateSegment",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.CreateSmsTemplate": [
            {
                "action": "mobiletargeting:CreateSmsTemplate",
                "resource_mappings": {}
            }
        ],
        "Pinpoint.CreateVoiceTemplate": [
            {
                "action": "mobiletargeting:CreateVoiceTemplate",
                "resource_mappings": {}
            }
        ],
        "Pinpoint.DeleteAdmChannel": [
            {
                "action": "mobiletargeting:DeleteAdmChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteApnsChannel": [
            {
                "action": "mobiletargeting:DeleteApnsChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteApnsSandboxChannel": [
            {
                "action": "mobiletargeting:DeleteApnsSandboxChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteApnsVoipChannel": [
            {
                "action": "mobiletargeting:DeleteApnsVoipChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteApnsVoipSandboxChannel": [
            {
                "action": "mobiletargeting:DeleteApnsVoipSandboxChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteApp": [
            {
                "action": "mobiletargeting:DeleteApp",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteBaiduChannel": [
            {
                "action": "mobiletargeting:DeleteBaiduChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteCampaign": [
            {
                "action": "mobiletargeting:DeleteCampaign",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "CampaignId": {
                        "template": "${CampaignId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteEmailChannel": [
            {
                "action": "mobiletargeting:DeleteEmailChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteEmailTemplate": [
            {
                "action": "mobiletargeting:DeleteEmailTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.DeleteEndpoint": [
            {
                "action": "mobiletargeting:DeleteEndpoint",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteEventStream": [
            {
                "action": "mobiletargeting:DeleteEventStream",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteGcmChannel": [
            {
                "action": "mobiletargeting:DeleteGcmChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteJourney": [
            {
                "action": "mobiletargeting:DeleteJourney",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "JourneyId": {
                        "template": "${JourneyId}"
                    }
                }
            }
        ],
        "Pinpoint.DeletePushTemplate": [
            {
                "action": "mobiletargeting:DeletePushTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.DeleteRecommenderConfiguration": [
            {
                "action": "mobiletargeting:DeleteRecommenderConfiguration",
                "resource_mappings": {
                    "RecommenderId": {
                        "template": "${RecommenderId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteSegment": [
            {
                "action": "mobiletargeting:DeleteSegment",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "SegmentId": {
                        "template": "${SegmentId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteSmsChannel": [
            {
                "action": "mobiletargeting:DeleteSmsChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteSmsTemplate": [
            {
                "action": "mobiletargeting:DeleteSmsTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.DeleteUserEndpoints": [
            {
                "action": "mobiletargeting:DeleteUserEndpoints",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteVoiceChannel": [
            {
                "action": "mobiletargeting:DeleteVoiceChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.DeleteVoiceTemplate": [
            {
                "action": "mobiletargeting:DeleteVoiceTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.GetAdmChannel": [
            {
                "action": "mobiletargeting:GetAdmChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetApnsChannel": [
            {
                "action": "mobiletargeting:GetApnsChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetApnsSandboxChannel": [
            {
                "action": "mobiletargeting:GetApnsSandboxChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetApnsVoipChannel": [
            {
                "action": "mobiletargeting:GetApnsVoipChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetApnsVoipSandboxChannel": [
            {
                "action": "mobiletargeting:GetApnsVoipSandboxChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetApp": [
            {
                "action": "mobiletargeting:GetApp",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetApplicationSettings": [
            {
                "action": "mobiletargeting:GetApplicationSettings",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetApps": [
            {
                "action": "mobiletargeting:GetApps",
                "resource_mappings": {
                    "AppId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.GetBaiduChannel": [
            {
                "action": "mobiletargeting:GetBaiduChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetCampaign": [
            {
                "action": "mobiletargeting:GetCampaign",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "CampaignId": {
                        "template": "${CampaignId}"
                    }
                }
            }
        ],
        "Pinpoint.GetCampaignActivities": [
            {
                "action": "mobiletargeting:GetCampaignActivities",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "CampaignId": {
                        "template": "${CampaignId}"
                    }
                }
            }
        ],
        "Pinpoint.GetCampaignVersion": [
            {
                "action": "mobiletargeting:GetCampaignVersion",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "CampaignId": {
                        "template": "${CampaignId}"
                    }
                }
            }
        ],
        "Pinpoint.GetCampaignVersions": [
            {
                "action": "mobiletargeting:GetCampaignVersions",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "CampaignId": {
                        "template": "${CampaignId}"
                    }
                }
            }
        ],
        "Pinpoint.GetCampaigns": [
            {
                "action": "mobiletargeting:GetCampaigns",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetChannels": [
            {
                "action": "mobiletargeting:GetChannels",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetEmailChannel": [
            {
                "action": "mobiletargeting:GetEmailChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetEmailTemplate": [
            {
                "action": "mobiletargeting:GetEmailTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.GetEndpoint": [
            {
                "action": "mobiletargeting:GetEndpoint",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetEventStream": [
            {
                "action": "mobiletargeting:GetEventStream",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetExportJob": [
            {
                "action": "mobiletargeting:GetExportJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetExportJobs": [
            {
                "action": "mobiletargeting:GetExportJobs",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetGcmChannel": [
            {
                "action": "mobiletargeting:GetGcmChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetImportJob": [
            {
                "action": "mobiletargeting:GetImportJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetImportJobs": [
            {
                "action": "mobiletargeting:GetImportJobs",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetJourney": [
            {
                "action": "mobiletargeting:GetJourney",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "JourneyId": {
                        "template": "${JourneyId}"
                    }
                }
            }
        ],
        "Pinpoint.GetPushTemplate": [
            {
                "action": "mobiletargeting:GetPushTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.GetRecommenderConfiguration": [
            {
                "action": "mobiletargeting:GetRecommenderConfiguration",
                "resource_mappings": {
                    "RecommenderId": {
                        "template": "${RecommenderId}"
                    }
                }
            }
        ],
        "Pinpoint.GetRecommenderConfigurations": [
            {
                "action": "mobiletargeting:GetRecommenderConfigurations",
                "resource_mappings": {}
            }
        ],
        "Pinpoint.GetSegment": [
            {
                "action": "mobiletargeting:GetSegment",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "SegmentId": {
                        "template": "${SegmentId}"
                    }
                }
            }
        ],
        "Pinpoint.GetSegmentExportJobs": [
            {
                "action": "mobiletargeting:GetSegmentExportJobs",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "SegmentId": {
                        "template": "${SegmentId}"
                    }
                }
            }
        ],
        "Pinpoint.GetSegmentImportJobs": [
            {
                "action": "mobiletargeting:GetSegmentImportJobs",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "SegmentId": {
                        "template": "${SegmentId}"
                    }
                }
            }
        ],
        "Pinpoint.GetSegmentVersion": [
            {
                "action": "mobiletargeting:GetSegmentVersion",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "SegmentId": {
                        "template": "${SegmentId}"
                    }
                }
            }
        ],
        "Pinpoint.GetSegmentVersions": [
            {
                "action": "mobiletargeting:GetSegmentVersions",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "SegmentId": {
                        "template": "${SegmentId}"
                    }
                }
            }
        ],
        "Pinpoint.GetSegments": [
            {
                "action": "mobiletargeting:GetSegments",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetSmsChannel": [
            {
                "action": "mobiletargeting:GetSmsChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetSmsTemplate": [
            {
                "action": "mobiletargeting:GetSmsTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.GetUserEndpoints": [
            {
                "action": "mobiletargeting:GetUserEndpoints",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetVoiceChannel": [
            {
                "action": "mobiletargeting:GetVoiceChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetVoiceTemplate": [
            {
                "action": "mobiletargeting:GetVoiceTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.ListJourneys": [
            {
                "action": "mobiletargeting:ListJourneys",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.ListTagsForResource": [
            {
                "action": "mobiletargeting:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "apps": "%%iftemplatematch%${ResourceArn}%%",
                    "campaigns": "%%iftemplatematch%${ResourceArn}%%",
                    "segments": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Pinpoint.ListTemplateVersions": [
            {
                "action": "mobiletargeting:ListTemplateVersions",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.ListTemplates": [
            {
                "action": "mobiletargeting:ListTemplates",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "*"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.PutEventStream": [
            {
                "action": "mobiletargeting:PutEventStream",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${WriteEventStream.RoleArn}"
                }
            }
        ],
        "Pinpoint.PutEvents": [
            {
                "action": "mobiletargeting:PutEvents",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.RemoveAttributes": [
            {
                "action": "mobiletargeting:RemoveAttributes",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.SendMessages": [
            {
                "action": "mobiletargeting:SendMessages",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.SendUsersMessages": [
            {
                "action": "mobiletargeting:SendUsersMessages",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.TagResource": [
            {
                "action": "mobiletargeting:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "apps": "%%iftemplatematch%${ResourceArn}%%",
                    "campaigns": "%%iftemplatematch%${ResourceArn}%%",
                    "segments": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Pinpoint.UntagResource": [
            {
                "action": "mobiletargeting:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "apps": "%%iftemplatematch%${ResourceArn}%%",
                    "campaigns": "%%iftemplatematch%${ResourceArn}%%",
                    "segments": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Pinpoint.UpdateAdmChannel": [
            {
                "action": "mobiletargeting:UpdateAdmChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateApnsChannel": [
            {
                "action": "mobiletargeting:UpdateApnsChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateApnsSandboxChannel": [
            {
                "action": "mobiletargeting:UpdateApnsSandboxChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateApnsVoipChannel": [
            {
                "action": "mobiletargeting:UpdateApnsVoipChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateApnsVoipSandboxChannel": [
            {
                "action": "mobiletargeting:UpdateApnsVoipSandboxChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateApplicationSettings": [
            {
                "action": "mobiletargeting:UpdateApplicationSettings",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateBaiduChannel": [
            {
                "action": "mobiletargeting:UpdateBaiduChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateCampaign": [
            {
                "action": "mobiletargeting:UpdateCampaign",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "CampaignId": {
                        "template": "${CampaignId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateEmailChannel": [
            {
                "action": "mobiletargeting:UpdateEmailChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${EmailChannelRequest.RoleArn}"
                }
            }
        ],
        "Pinpoint.UpdateEmailTemplate": [
            {
                "action": "mobiletargeting:UpdateEmailTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.UpdateEndpoint": [
            {
                "action": "mobiletargeting:UpdateEndpoint",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateEndpointsBatch": [
            {
                "action": "mobiletargeting:UpdateEndpointsBatch",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateGcmChannel": [
            {
                "action": "mobiletargeting:UpdateGcmChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateJourney": [
            {
                "action": "mobiletargeting:UpdateJourney",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "JourneyId": {
                        "template": "${JourneyId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateJourneyState": [
            {
                "action": "mobiletargeting:UpdateJourneyState",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "JourneyId": {
                        "template": "${JourneyId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdatePushTemplate": [
            {
                "action": "mobiletargeting:UpdatePushTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.UpdateRecommenderConfiguration": [
            {
                "action": "mobiletargeting:UpdateRecommenderConfiguration",
                "resource_mappings": {
                    "RecommenderId": {
                        "template": "${RecommenderId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${UpdateRecommenderConfiguration.RecommendationProviderRoleArn}"
                }
            }
        ],
        "Pinpoint.UpdateSegment": [
            {
                "action": "mobiletargeting:UpdateSegment",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "SegmentId": {
                        "template": "${SegmentId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateSmsChannel": [
            {
                "action": "mobiletargeting:UpdateSmsChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateSmsTemplate": [
            {
                "action": "mobiletargeting:UpdateSmsTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.UpdateTemplateActiveVersion": [
            {
                "action": "mobiletargeting:UpdateTemplateActiveVersion",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.UpdateVoiceChannel": [
            {
                "action": "mobiletargeting:UpdateVoiceChannel",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.UpdateVoiceTemplate": [
            {
                "action": "mobiletargeting:UpdateVoiceTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Polly.DeleteLexicon": [
            {
                "action": "polly:DeleteLexicon",
                "resource_mappings": {
                    "LexiconName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Polly.DescribeVoices": [
            {
                "action": "polly:DescribeVoices",
                "resource_mappings": {}
            }
        ],
        "Polly.GetLexicon": [
            {
                "action": "polly:GetLexicon",
                "resource_mappings": {
                    "LexiconName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Polly.GetSpeechSynthesisTask": [
            {
                "action": "polly:GetSpeechSynthesisTask",
                "resource_mappings": {}
            }
        ],
        "Polly.ListLexicons": [
            {
                "action": "polly:ListLexicons",
                "resource_mappings": {}
            }
        ],
        "Polly.ListSpeechSynthesisTasks": [
            {
                "action": "polly:ListSpeechSynthesisTasks",
                "resource_mappings": {}
            }
        ],
        "Polly.PutLexicon": [
            {
                "action": "polly:PutLexicon",
                "resource_mappings": {
                    "LexiconName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Polly.StartSpeechSynthesisTask": [
            {
                "action": "polly:StartSpeechSynthesisTask",
                "resource_mappings": {
                    "LexiconName": {
                        "template": "${LexiconNames[]}"
                    }
                }
            },
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${OutputS3BucketName}"
                    },
                    "ObjectName": {
                        "template": "${OutputS3KeyPrefix}*"
                    }
                }
            }
        ],
        "Polly.SynthesizeSpeech": [
            {
                "action": "polly:SynthesizeSpeech",
                "resource_mappings": {
                    "LexiconName": {
                        "template": "${LexiconNames[]}"
                    }
                }
            }
        ],
        "RDS.AddRoleToDBCluster": [
            {
                "action": "rds:AddRoleToDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "RDS.AddRoleToDBInstance": [
            {
                "action": "rds:AddRoleToDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "RDS.AddSourceIdentifierToSubscription": [
            {
                "action": "rds:AddSourceIdentifierToSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "RDS.AddTagsToResource": [
            {
                "action": "rds:AddTagsToResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "%%iftemplatematch%${ResourceName}%%",
                    "es": "%%iftemplatematch%${ResourceName}%%",
                    "og": "%%iftemplatematch%${ResourceName}%%",
                    "pg": "%%iftemplatematch%${ResourceName}%%",
                    "proxy": "%%iftemplatematch%${ResourceName}%%",
                    "proxy-endpoint": "%%iftemplatematch%${ResourceName}%%",
                    "ri": "%%iftemplatematch%${ResourceName}%%",
                    "secgrp": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "subgrp": "%%iftemplatematch%${ResourceName}%%",
                    "target-group": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "RDS.ApplyPendingMaintenanceAction": [
            {
                "action": "rds:ApplyPendingMaintenanceAction",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceIdentifier}%%",
                    "db": "%%iftemplatematch%${ResourceIdentifier}%%"
                }
            }
        ],
        "RDS.AuthorizeDBSecurityGroupIngress": [
            {
                "action": "rds:AuthorizeDBSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupName": {
                        "template": "${DBSecurityGroupName}"
                    }
                }
            }
        ],
        "RDS.BacktrackDBCluster": [
            {
                "action": "rds:BacktrackDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.CancelExportTask": [
            {
                "action": "rds:CancelExportTask",
                "resource_mappings": {}
            }
        ],
        "RDS.CopyDBClusterParameterGroup": [
            {
                "action": "rds:CopyDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "%%many%${SourceDBClusterParameterGroupIdentifier}%${TargetDBClusterParameterGroupIdentifier}%%"
                    }
                }
            }
        ],
        "RDS.CopyDBClusterSnapshot": [
            {
                "action": "rds:CopyDBClusterSnapshot",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "%%many%${SourceDBClusterSnapshotIdentifier}%${TargetDBClusterSnapshotIdentifier}%%"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.CopyDBParameterGroup": [
            {
                "action": "rds:CopyDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "%%many%${SourceDBParameterGroupIdentifier}%${TargetDBParameterGroupIdentifier}%%"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.CopyDBSnapshot": [
            {
                "action": "rds:CopyDBSnapshot",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "%%many%${SourceDBSnapshotIdentifier}%${TargetDBSnapshotIdentifier}%%"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.CopyOptionGroup": [
            {
                "action": "rds:CopyOptionGroup",
                "resource_mappings": {
                    "OptionGroupName": {
                        "template": "%%many%${SourceOptionGroupIdentifier}%${TargetOptionGroupIdentifier}%%"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.CreateDBCluster": [
            {
                "action": "rds:CreateDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.CreateDBClusterEndpoint": [
            {
                "action": "rds:CreateDBClusterEndpoint",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "DbClusterEndpoint": {
                        "template": "${DBClusterEndpointIdentifier}"
                    }
                }
            }
        ],
        "RDS.CreateDBClusterParameterGroup": [
            {
                "action": "rds:CreateDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.CreateDBClusterSnapshot": [
            {
                "action": "rds:CreateDBClusterSnapshot",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.CreateDBInstance": [
            {
                "action": "rds:CreateDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    },
                    "SecurityGroupName": {
                        "template": "${DBSecurityGroups[]}"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${MonitoringRoleArn}%arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.CreateDBInstanceReadReplica": [
            {
                "action": "rds:CreateDBInstanceReadReplica",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "%%many%${SourceDBInstanceIdentifier}%${DBInstanceIdentifier}%%"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${MonitoringRoleArn}%arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.CreateDBParameterGroup": [
            {
                "action": "rds:CreateDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.CreateDBProxy": [
            {
                "action": "rds:CreateDBProxy",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "RDS.CreateDBSecurityGroup": [
            {
                "action": "rds:CreateDBSecurityGroup",
                "resource_mappings": {
                    "SecurityGroupName": {
                        "template": "${DBSecurityGroupName}"
                    }
                }
            }
        ],
        "RDS.CreateDBSnapshot": [
            {
                "action": "rds:CreateDBSnapshot",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    },
                    "SnapshotName": {
                        "template": "${DBSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.CreateDBSubnetGroup": [
            {
                "action": "rds:CreateDBSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "RDS.CreateEventSubscription": [
            {
                "action": "rds:CreateEventSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "RDS.CreateGlobalCluster": [
            {
                "action": "rds:CreateGlobalCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${SourceDBClusterIdentifier}"
                    },
                    "GlobalCluster": {
                        "template": "${GlobalClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.CreateOptionGroup": [
            {
                "action": "rds:CreateOptionGroup",
                "resource_mappings": {
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    }
                }
            }
        ],
        "RDS.DeleteDBCluster": [
            {
                "action": "rds:DeleteDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterSnapshotName": {
                        "template": "${FinalDBSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.DeleteDBClusterEndpoint": [
            {
                "action": "rds:DeleteDBClusterEndpoint",
                "resource_mappings": {
                    "DbClusterEndpoint": {
                        "template": "${DBClusterEndpointIdentifier}"
                    }
                }
            }
        ],
        "RDS.DeleteDBClusterParameterGroup": [
            {
                "action": "rds:DeleteDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.DeleteDBClusterSnapshot": [
            {
                "action": "rds:DeleteDBClusterSnapshot",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.DeleteDBInstance": [
            {
                "action": "rds:DeleteDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.DeleteDBInstanceAutomatedBackup": [
            {
                "action": "rds:DeleteDBInstanceAutomatedBackup",
                "resource_mappings": {}
            }
        ],
        "RDS.DeleteDBParameterGroup": [
            {
                "action": "rds:DeleteDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.DeleteDBProxy": [
            {
                "action": "rds:DeleteDBProxy",
                "resource_mappings": {
                    "DbProxyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.DeleteDBSecurityGroup": [
            {
                "action": "rds:DeleteDBSecurityGroup",
                "resource_mappings": {
                    "SecurityGroupName": {
                        "template": "${DBSecurityGroupName}"
                    }
                }
            }
        ],
        "RDS.DeleteDBSnapshot": [
            {
                "action": "rds:DeleteDBSnapshot",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${DBSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.DeleteDBSubnetGroup": [
            {
                "action": "rds:DeleteDBSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "RDS.DeleteEventSubscription": [
            {
                "action": "rds:DeleteEventSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "RDS.DeleteGlobalCluster": [
            {
                "action": "rds:DeleteGlobalCluster",
                "resource_mappings": {
                    "GlobalCluster": {
                        "template": "${GlobalClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.DeleteOptionGroup": [
            {
                "action": "rds:DeleteOptionGroup",
                "resource_mappings": {
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    }
                }
            }
        ],
        "RDS.DeregisterDBProxyTargets": [
            {
                "action": "rds:DeregisterDBProxyTargets",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifiers[]}"
                    },
                    "DbInstanceName": {
                        "template": "${DBClusterIdentifiers[]}"
                    },
                    "DbProxyId": {
                        "template": "*"
                    },
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.DescribeAccountAttributes": [
            {
                "action": "rds:DescribeAccountAttributes",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeCertificates": [
            {
                "action": "rds:DescribeCertificates",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeDBClusterBacktracks": [
            {
                "action": "rds:DescribeDBClusterBacktracks",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBClusterEndpoints": [
            {
                "action": "rds:DescribeDBClusterEndpoints",
                "resource_mappings": {
                    "DbClusterEndpoint": {
                        "template": "${DBClusterEndpointIdentifier}"
                    },
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBClusterParameterGroups": [
            {
                "action": "rds:DescribeDBClusterParameterGroups",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.DescribeDBClusterParameters": [
            {
                "action": "rds:DescribeDBClusterParameters",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.DescribeDBClusterSnapshotAttributes": [
            {
                "action": "rds:DescribeDBClusterSnapshotAttributes",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBClusterSnapshots": [
            {
                "action": "rds:DescribeDBClusterSnapshots",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBClusters": [
            {
                "action": "rds:DescribeDBClusters",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBEngineVersions": [
            {
                "action": "rds:DescribeDBEngineVersions",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeDBInstanceAutomatedBackups": [
            {
                "action": "rds:DescribeDBInstanceAutomatedBackups",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBInstances": [
            {
                "action": "rds:DescribeDBInstances",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBLogFiles": [
            {
                "action": "rds:DescribeDBLogFiles",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBParameterGroups": [
            {
                "action": "rds:DescribeDBParameterGroups",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.DescribeDBParameters": [
            {
                "action": "rds:DescribeDBParameters",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.DescribeDBProxies": [
            {
                "action": "rds:DescribeDBProxies",
                "resource_mappings": {
                    "DbProxyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.DescribeDBProxyTargetGroups": [
            {
                "action": "rds:DescribeDBProxyTargetGroups",
                "resource_mappings": {
                    "DbProxyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.DescribeDBProxyTargets": [
            {
                "action": "rds:DescribeDBProxyTargets",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "*"
                    },
                    "DbInstanceName": {
                        "template": "*"
                    },
                    "DbProxyId": {
                        "template": "*"
                    },
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.DescribeDBSecurityGroups": [
            {
                "action": "rds:DescribeDBSecurityGroups",
                "resource_mappings": {
                    "SecurityGroupName": {
                        "template": "${DBSecurityGroupName}"
                    }
                }
            }
        ],
        "RDS.DescribeDBSnapshotAttributes": [
            {
                "action": "rds:DescribeDBSnapshotAttributes",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${DBSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBSnapshots": [
            {
                "action": "rds:DescribeDBSnapshots",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${DBSnapshotIdentifier}"
                    },
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeDBSubnetGroups": [
            {
                "action": "rds:DescribeDBSubnetGroups",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "RDS.DescribeEngineDefaultClusterParameters": [
            {
                "action": "rds:DescribeEngineDefaultClusterParameters",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeEngineDefaultParameters": [
            {
                "action": "rds:DescribeEngineDefaultParameters",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeEventCategories": [
            {
                "action": "rds:DescribeEventCategories",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeEventSubscriptions": [
            {
                "action": "rds:DescribeEventSubscriptions",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "RDS.DescribeEvents": [
            {
                "action": "rds:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeExportTasks": [
            {
                "action": "rds:DescribeExportTasks",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeGlobalClusters": [
            {
                "action": "rds:DescribeGlobalClusters",
                "resource_mappings": {
                    "GlobalCluster": {
                        "template": "${GlobalClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.DescribeOptionGroupOptions": [
            {
                "action": "rds:DescribeOptionGroupOptions",
                "resource_mappings": {
                    "OptionGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.DescribeOptionGroups": [
            {
                "action": "rds:DescribeOptionGroups",
                "resource_mappings": {
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    }
                }
            }
        ],
        "RDS.DescribeOrderableDBInstanceOptions": [
            {
                "action": "rds:DescribeOrderableDBInstanceOptions",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribePendingMaintenanceActions": [
            {
                "action": "rds:DescribePendingMaintenanceActions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceIdentifier}%%",
                    "db": "%%iftemplatematch%${ResourceIdentifier}%%"
                }
            }
        ],
        "RDS.DescribeReservedDBInstances": [
            {
                "action": "rds:DescribeReservedDBInstances",
                "resource_mappings": {
                    "ReservedDbInstanceName": {
                        "template": "${ReservedDBInstanceId}"
                    }
                }
            }
        ],
        "RDS.DescribeReservedDBInstancesOfferings": [
            {
                "action": "rds:DescribeReservedDBInstancesOfferings",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeSourceRegions": [
            {
                "action": "rds:DescribeSourceRegions",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeValidDBInstanceModifications": [
            {
                "action": "rds:DescribeValidDBInstanceModifications",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.DownloadDBLogFilePortion": [
            {
                "action": "rds:DownloadDBLogFilePortion",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.FailoverDBCluster": [
            {
                "action": "rds:FailoverDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.ListTagsForResource": [
            {
                "action": "rds:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "%%iftemplatematch%${ResourceName}%%",
                    "es": "%%iftemplatematch%${ResourceName}%%",
                    "og": "%%iftemplatematch%${ResourceName}%%",
                    "pg": "%%iftemplatematch%${ResourceName}%%",
                    "proxy": "%%iftemplatematch%${ResourceName}%%",
                    "proxy-endpoint": "%%iftemplatematch%${ResourceName}%%",
                    "ri": "%%iftemplatematch%${ResourceName}%%",
                    "secgrp": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "subgrp": "%%iftemplatematch%${ResourceName}%%",
                    "target-group": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "RDS.ModifyCurrentDBClusterCapacity": [
            {
                "action": "rds:ModifyCurrentDBClusterCapacity",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.ModifyDBCluster": [
            {
                "action": "rds:ModifyDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "%%many%${DBClusterIdentifier}%${NewDBClusterIdentifier}%%"
                    },
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            }
        ],
        "RDS.ModifyDBClusterEndpoint": [
            {
                "action": "rds:ModifyDBClusterEndpoint",
                "resource_mappings": {
                    "DbClusterEndpoint": {
                        "template": "${DBClusterEndpointIdentifier}"
                    }
                }
            }
        ],
        "RDS.ModifyDBClusterParameterGroup": [
            {
                "action": "rds:ModifyDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.ModifyDBClusterSnapshotAttribute": [
            {
                "action": "rds:ModifyDBClusterSnapshotAttribute",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.ModifyDBInstance": [
            {
                "action": "rds:ModifyDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "%%many%${DBInstanceIdentifier}%${NewDBInstanceIdentifier}%%"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    },
                    "SecurityGroupName": {
                        "template": "${DBSecurityGroups[]}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${MonitoringRoleArn}%arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            }
        ],
        "RDS.ModifyDBParameterGroup": [
            {
                "action": "rds:ModifyDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.ModifyDBProxy": [
            {
                "action": "rds:ModifyDBProxy",
                "resource_mappings": {
                    "DbProxyId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "RDS.ModifyDBProxyTargetGroup": [
            {
                "action": "rds:ModifyDBProxyTargetGroup",
                "resource_mappings": {
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.ModifyDBSnapshot": [
            {
                "action": "rds:ModifyDBSnapshot",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${DBSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.ModifyDBSnapshotAttribute": [
            {
                "action": "rds:ModifyDBSnapshotAttribute",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${DBSnapshotIdentifier}"
                    }
                }
            }
        ],
        "RDS.ModifyDBSubnetGroup": [
            {
                "action": "rds:ModifyDBSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "RDS.ModifyEventSubscription": [
            {
                "action": "rds:ModifyEventSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "RDS.ModifyGlobalCluster": [
            {
                "action": "rds:ModifyGlobalCluster",
                "resource_mappings": {
                    "GlobalCluster": {
                        "template": "%%many%${GlobalClusterIdentifier}%${NewGlobalClusterIdentifier}%%"
                    }
                }
            }
        ],
        "RDS.ModifyOptionGroup": [
            {
                "action": "rds:ModifyOptionGroup",
                "resource_mappings": {
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.PromoteReadReplica": [
            {
                "action": "rds:PromoteReadReplica",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.PromoteReadReplicaDBCluster": [
            {
                "action": "rds:PromoteReadReplicaDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.PurchaseReservedDBInstancesOffering": [
            {
                "action": "rds:PurchaseReservedDBInstancesOffering",
                "resource_mappings": {
                    "ReservedDbInstanceName": {
                        "template": "${ReservedDBInstanceId}"
                    }
                }
            }
        ],
        "RDS.RebootDBInstance": [
            {
                "action": "rds:RebootDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.RegisterDBProxyTargets": [
            {
                "action": "rds:RegisterDBProxyTargets",
                "resource_mappings": {
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.RemoveFromGlobalCluster": [
            {
                "action": "rds:RemoveFromGlobalCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DbClusterIdentifier}"
                    },
                    "GlobalCluster": {
                        "template": "${GlobalClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.RemoveRoleFromDBCluster": [
            {
                "action": "rds:RemoveRoleFromDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "RDS.RemoveRoleFromDBInstance": [
            {
                "action": "rds:RemoveRoleFromDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "RDS.RemoveSourceIdentifierFromSubscription": [
            {
                "action": "rds:RemoveSourceIdentifierFromSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "RDS.RemoveTagsFromResource": [
            {
                "action": "rds:RemoveTagsFromResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "%%iftemplatematch%${ResourceName}%%",
                    "es": "%%iftemplatematch%${ResourceName}%%",
                    "og": "%%iftemplatematch%${ResourceName}%%",
                    "pg": "%%iftemplatematch%${ResourceName}%%",
                    "proxy": "%%iftemplatematch%${ResourceName}%%",
                    "proxy-endpoint": "%%iftemplatematch%${ResourceName}%%",
                    "ri": "%%iftemplatematch%${ResourceName}%%",
                    "secgrp": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "subgrp": "%%iftemplatematch%${ResourceName}%%",
                    "target-group": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "RDS.ResetDBClusterParameterGroup": [
            {
                "action": "rds:ResetDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.ResetDBParameterGroup": [
            {
                "action": "rds:ResetDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "RDS.RestoreDBClusterFromS3": [
            {
                "action": "rds:RestoreDBClusterFromS3",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${S3IngestionRoleArn}%arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.RestoreDBClusterFromSnapshot": [
            {
                "action": "rds:RestoreDBClusterFromSnapshot",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterSnapshotName": {
                        "template": "${SnapshotIdentifier}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.RestoreDBClusterToPointInTime": [
            {
                "action": "rds:RestoreDBClusterToPointInTime",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.RestoreDBInstanceFromDBSnapshot": [
            {
                "action": "rds:RestoreDBInstanceFromDBSnapshot",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "SnapshotName": {
                        "template": "${DBSnapshotIdentifier}"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.RestoreDBInstanceFromS3": [
            {
                "action": "rds:RestoreDBInstanceFromS3",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${S3IngestionRoleArn}%${MonitoringRoleArn}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.RestoreDBInstanceToPointInTime": [
            {
                "action": "rds:RestoreDBInstanceToPointInTime",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "%%many%${SourceDBInstanceIdentifier}%${TargetDBInstanceIdentifier}%%"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${DomainIAMRoleName}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${EnableIAMDatabaseAuthentication}%*%%%"
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "RDS.RevokeDBSecurityGroupIngress": [
            {
                "action": "rds:RevokeDBSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupName": {
                        "template": "${DBSecurityGroupName}"
                    }
                }
            }
        ],
        "RDS.StartActivityStream": [
            {
                "action": "rds:StartActivityStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${ResourceArn}"
                }
            }
        ],
        "RDS.StartDBCluster": [
            {
                "action": "rds:StartDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.StartDBInstance": [
            {
                "action": "rds:StartDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "RDS.StartExportTask": [
            {
                "action": "rds:StartExportTask",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "RDS.StopActivityStream": [
            {
                "action": "rds:StopActivityStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${ResourceArn}"
                }
            }
        ],
        "RDS.StopDBCluster": [
            {
                "action": "rds:StopDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.StopDBInstance": [
            {
                "action": "rds:StopDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "Redshift.AcceptReservedNodeExchange": [
            {
                "action": "redshift:AcceptReservedNodeExchange",
                "resource_mappings": {}
            }
        ],
        "Redshift.AuthorizeClusterSecurityGroupIngress": [
            {
                "action": "redshift:AuthorizeClusterSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupName": {
                        "template": "${ClusterSecurityGroupName}"
                    },
                    "Owner": {
                        "template": "*"
                    },
                    "Ec2SecurityGroupId": {
                        "template": "*"
                    },
                    "Ece2SecuritygroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Redshift.AuthorizeSnapshotAccess": [
            {
                "action": "redshift:AuthorizeSnapshotAccess",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${SnapshotClusterIdentifier}"
                    },
                    "SnapshotName": {
                        "template": "${SnapshotIdentifier}"
                    }
                }
            }
        ],
        "Redshift.BatchDeleteClusterSnapshots": [
            {
                "action": "redshift:BatchDeleteClusterSnapshots",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${Identifiers[].SnapshotClusterIdentifier}"
                    },
                    "SnapshotName": {
                        "template": "${Identifiers[].SnapshotIdentifier}"
                    }
                }
            }
        ],
        "Redshift.BatchModifyClusterSnapshots": [
            {
                "action": "redshift:BatchModifyClusterSnapshots",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "snapshot": "%%iftemplatematch%${SnapshotIdentifierList[]}%%"
                }
            }
        ],
        "Redshift.CancelResize": [
            {
                "action": "redshift:CancelResize",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.CopyClusterSnapshot": [
            {
                "action": "redshift:CopyClusterSnapshot",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${SourceSnapshotClusterIdentifier}"
                    },
                    "SnapshotName": {
                        "template": "%%many%${SourceSnapshotIdentifier}%${TargetSnapshotIdentifier}%%"
                    }
                }
            }
        ],
        "Redshift.CreateCluster": [
            {
                "action": "redshift:CreateCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoles[]}"
                }
            }
        ],
        "Redshift.CreateClusterParameterGroup": [
            {
                "action": "redshift:CreateClusterParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "Redshift.CreateClusterSecurityGroup": [
            {
                "action": "redshift:CreateClusterSecurityGroup",
                "resource_mappings": {
                    "SecurityGroupName": {
                        "template": "${ClusterSecurityGroupName}"
                    },
                    "Owner": {
                        "template": "*"
                    },
                    "Ec2SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Redshift.CreateClusterSnapshot": [
            {
                "action": "redshift:CreateClusterSnapshot",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    },
                    "SnapshotName": {
                        "template": "${SnapshotIdentifier}"
                    }
                }
            }
        ],
        "Redshift.CreateClusterSubnetGroup": [
            {
                "action": "redshift:CreateClusterSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${ClusterSubnetGroupName}"
                    }
                }
            }
        ],
        "Redshift.CreateEventSubscription": [
            {
                "action": "redshift:CreateEventSubscription",
                "resource_mappings": {
                    "EventSubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "Redshift.CreateHsmClientCertificate": [
            {
                "action": "redshift:CreateHsmClientCertificate",
                "resource_mappings": {
                    "HSMClientCertificateId": {
                        "template": "${HsmClientCertificateIdentifier}"
                    }
                }
            }
        ],
        "Redshift.CreateHsmConfiguration": [
            {
                "action": "redshift:CreateHsmConfiguration",
                "resource_mappings": {
                    "HSMConfigurationId": {
                        "template": "${HsmConfigurationIdentifier}"
                    }
                }
            }
        ],
        "Redshift.CreateScheduledAction": [
            {
                "action": "redshift:CreateScheduledAction",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRole}"
                }
            }
        ],
        "Redshift.CreateSnapshotCopyGrant": [
            {
                "action": "redshift:CreateSnapshotCopyGrant",
                "resource_mappings": {
                    "SnapshotCopyGrantName": {
                        "template": "${SnapshotCopyGrantName}"
                    }
                }
            }
        ],
        "Redshift.CreateSnapshotSchedule": [
            {
                "action": "redshift:CreateSnapshotSchedule",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ScheduleIdentifier}"
                    }
                }
            }
        ],
        "Redshift.CreateTags": [
            {
                "action": "redshift:CreateTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceName}%%",
                    "dbgroup": "%%iftemplatematch%${ResourceName}%%",
                    "dbname": "%%iftemplatematch%${ResourceName}%%",
                    "dbuser": "%%iftemplatematch%${ResourceName}%%",
                    "eventsubscription": "%%iftemplatematch%${ResourceName}%%",
                    "hsmclientcertificate": "%%iftemplatematch%${ResourceName}%%",
                    "hsmconfiguration": "%%iftemplatematch%${ResourceName}%%",
                    "parametergroup": "%%iftemplatematch%${ResourceName}%%",
                    "securitygroup": "%%iftemplatematch%${ResourceName}%%",
                    "securitygroupingress-cidr": "%%iftemplatematch%${ResourceName}%%",
                    "securitygroupingress-ec2securitygroup": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "snapshotcopygrant": "%%iftemplatematch%${ResourceName}%%",
                    "snapshotschedule": "%%iftemplatematch%${ResourceName}%%",
                    "subnetgroup": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "Redshift.DeleteCluster": [
            {
                "action": "redshift:DeleteCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.DeleteClusterParameterGroup": [
            {
                "action": "redshift:DeleteClusterParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "Redshift.DeleteClusterSecurityGroup": [
            {
                "action": "redshift:DeleteClusterSecurityGroup",
                "resource_mappings": {
                    "SecurityGroupName": {
                        "template": "${ClusterSecurityGroupName}"
                    },
                    "Owner": {
                        "template": "*"
                    },
                    "Ec2SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Redshift.DeleteClusterSnapshot": [
            {
                "action": "redshift:DeleteClusterSnapshot",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${SnapshotClusterIdentifier}"
                    },
                    "SnapshotName": {
                        "template": "${SnapshotIdentifier}"
                    }
                }
            }
        ],
        "Redshift.DeleteClusterSubnetGroup": [
            {
                "action": "redshift:DeleteClusterSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${ClusterSubnetGroupName}"
                    }
                }
            }
        ],
        "Redshift.DeleteEventSubscription": [
            {
                "action": "redshift:DeleteEventSubscription",
                "resource_mappings": {
                    "EventSubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "Redshift.DeleteHsmClientCertificate": [
            {
                "action": "redshift:DeleteHsmClientCertificate",
                "resource_mappings": {
                    "HSMClientCertificateId": {
                        "template": "${HsmClientCertificateIdentifier}"
                    }
                }
            }
        ],
        "Redshift.DeleteHsmConfiguration": [
            {
                "action": "redshift:DeleteHsmConfiguration",
                "resource_mappings": {
                    "HSMConfigurationId": {
                        "template": "${HsmConfigurationIdentifier}"
                    }
                }
            }
        ],
        "Redshift.DeleteScheduledAction": [
            {
                "action": "redshift:DeleteScheduledAction",
                "resource_mappings": {}
            }
        ],
        "Redshift.DeleteSnapshotCopyGrant": [
            {
                "action": "redshift:DeleteSnapshotCopyGrant",
                "resource_mappings": {
                    "SnapshotCopyGrantName": {
                        "template": "${SnapshotCopyGrantName}"
                    }
                }
            }
        ],
        "Redshift.DeleteSnapshotSchedule": [
            {
                "action": "redshift:DeleteSnapshotSchedule",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ScheduleIdentifier}"
                    }
                }
            }
        ],
        "Redshift.DeleteTags": [
            {
                "action": "redshift:DeleteTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceName}%%",
                    "dbgroup": "%%iftemplatematch%${ResourceName}%%",
                    "dbname": "%%iftemplatematch%${ResourceName}%%",
                    "dbuser": "%%iftemplatematch%${ResourceName}%%",
                    "eventsubscription": "%%iftemplatematch%${ResourceName}%%",
                    "hsmclientcertificate": "%%iftemplatematch%${ResourceName}%%",
                    "hsmconfiguration": "%%iftemplatematch%${ResourceName}%%",
                    "parametergroup": "%%iftemplatematch%${ResourceName}%%",
                    "securitygroup": "%%iftemplatematch%${ResourceName}%%",
                    "securitygroupingress-cidr": "%%iftemplatematch%${ResourceName}%%",
                    "securitygroupingress-ec2securitygroup": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "snapshotcopygrant": "%%iftemplatematch%${ResourceName}%%",
                    "snapshotschedule": "%%iftemplatematch%${ResourceName}%%",
                    "subnetgroup": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "Redshift.DescribeAccountAttributes": [
            {
                "action": "redshift:DescribeAccountAttributes",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeClusterDbRevisions": [
            {
                "action": "redshift:DescribeClusterDbRevisions",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeClusterParameterGroups": [
            {
                "action": "redshift:DescribeClusterParameterGroups",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeClusterParameters": [
            {
                "action": "redshift:DescribeClusterParameters",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "Redshift.DescribeClusterSecurityGroups": [
            {
                "action": "redshift:DescribeClusterSecurityGroups",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeClusterSnapshots": [
            {
                "action": "redshift:DescribeClusterSnapshots",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeClusterSubnetGroups": [
            {
                "action": "redshift:DescribeClusterSubnetGroups",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeClusterTracks": [
            {
                "action": "redshift:DescribeClusterTracks",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeClusterVersions": [
            {
                "action": "redshift:DescribeClusterVersions",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeClusters": [
            {
                "action": "redshift:DescribeClusters",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeDefaultClusterParameters": [
            {
                "action": "redshift:DescribeDefaultClusterParameters",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeEventCategories": [
            {
                "action": "redshift:DescribeEventCategories",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeEventSubscriptions": [
            {
                "action": "redshift:DescribeEventSubscriptions",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeEvents": [
            {
                "action": "redshift:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeHsmClientCertificates": [
            {
                "action": "redshift:DescribeHsmClientCertificates",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeHsmConfigurations": [
            {
                "action": "redshift:DescribeHsmConfigurations",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeLoggingStatus": [
            {
                "action": "redshift:DescribeLoggingStatus",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.DescribeNodeConfigurationOptions": [
            {
                "action": "redshift:DescribeNodeConfigurationOptions",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeOrderableClusterOptions": [
            {
                "action": "redshift:DescribeOrderableClusterOptions",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeReservedNodeOfferings": [
            {
                "action": "redshift:DescribeReservedNodeOfferings",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeReservedNodes": [
            {
                "action": "redshift:DescribeReservedNodes",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeResize": [
            {
                "action": "redshift:DescribeResize",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.DescribeScheduledActions": [
            {
                "action": "redshift:DescribeScheduledActions",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeSnapshotCopyGrants": [
            {
                "action": "redshift:DescribeSnapshotCopyGrants",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeSnapshotSchedules": [
            {
                "action": "redshift:DescribeSnapshotSchedules",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ScheduleIdentifier}"
                    }
                }
            }
        ],
        "Redshift.DescribeStorage": [
            {
                "action": "redshift:DescribeStorage",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeTableRestoreStatus": [
            {
                "action": "redshift:DescribeTableRestoreStatus",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeTags": [
            {
                "action": "redshift:DescribeTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceName}%%",
                    "dbgroup": "%%iftemplatematch%${ResourceName}%%",
                    "dbname": "%%iftemplatematch%${ResourceName}%%",
                    "dbuser": "%%iftemplatematch%${ResourceName}%%",
                    "eventsubscription": "%%iftemplatematch%${ResourceName}%%",
                    "hsmclientcertificate": "%%iftemplatematch%${ResourceName}%%",
                    "hsmconfiguration": "%%iftemplatematch%${ResourceName}%%",
                    "parametergroup": "%%iftemplatematch%${ResourceName}%%",
                    "securitygroup": "%%iftemplatematch%${ResourceName}%%",
                    "securitygroupingress-cidr": "%%iftemplatematch%${ResourceName}%%",
                    "securitygroupingress-ec2securitygroup": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "snapshotcopygrant": "%%iftemplatematch%${ResourceName}%%",
                    "snapshotschedule": "%%iftemplatematch%${ResourceName}%%",
                    "subnetgroup": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "Redshift.DisableLogging": [
            {
                "action": "redshift:DisableLogging",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.DisableSnapshotCopy": [
            {
                "action": "redshift:DisableSnapshotCopy",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.EnableLogging": [
            {
                "action": "redshift:EnableLogging",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.EnableSnapshotCopy": [
            {
                "action": "redshift:EnableSnapshotCopy",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.GetClusterCredentials": [
            {
                "action": "redshift:GetClusterCredentials",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    },
                    "DbUser": {
                        "template": "${DbUser}"
                    },
                    "DbGroup": {
                        "template": "${DbGroups[]}"
                    },
                    "DbName": {
                        "template": "${DbName}"
                    }
                }
            }
        ],
        "Redshift.GetReservedNodeExchangeOfferings": [
            {
                "action": "redshift:GetReservedNodeExchangeOfferings",
                "resource_mappings": {}
            }
        ],
        "Redshift.ModifyCluster": [
            {
                "action": "redshift:ModifyCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.ModifyClusterDbRevision": [
            {
                "action": "redshift:ModifyClusterDbRevision",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.ModifyClusterIamRoles": [
            {
                "action": "redshift:ModifyClusterIamRoles",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%many%${AddIamRoles[]}%${RemoveIamRoles[]}%%"
                    }
                }
            }
        ],
        "Redshift.ModifyClusterMaintenance": [
            {
                "action": "redshift:ModifyClusterMaintenance",
                "resource_mappings": {}
            }
        ],
        "Redshift.ModifyClusterParameterGroup": [
            {
                "action": "redshift:ModifyClusterParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "Redshift.ModifyClusterSnapshot": [
            {
                "action": "redshift:ModifyClusterSnapshot",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "snapshot": "%%iftemplatematch%${SnapshotIdentifier}%%"
                }
            }
        ],
        "Redshift.ModifyClusterSnapshotSchedule": [
            {
                "action": "redshift:ModifyClusterSnapshotSchedule",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.ModifyClusterSubnetGroup": [
            {
                "action": "redshift:ModifyClusterSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${ClusterSubnetGroupName}"
                    }
                }
            }
        ],
        "Redshift.ModifyEventSubscription": [
            {
                "action": "redshift:ModifyEventSubscription",
                "resource_mappings": {
                    "EventSubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "Redshift.ModifyScheduledAction": [
            {
                "action": "redshift:ModifyScheduledAction",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRole}"
                }
            }
        ],
        "Redshift.ModifySnapshotCopyRetentionPeriod": [
            {
                "action": "redshift:ModifySnapshotCopyRetentionPeriod",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.ModifySnapshotSchedule": [
            {
                "action": "redshift:ModifySnapshotSchedule",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ScheduleIdentifier}"
                    }
                }
            }
        ],
        "Redshift.PauseCluster": [
            {
                "action": "redshift:PauseCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.PurchaseReservedNodeOffering": [
            {
                "action": "redshift:PurchaseReservedNodeOffering",
                "resource_mappings": {}
            }
        ],
        "Redshift.RebootCluster": [
            {
                "action": "redshift:RebootCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.ResetClusterParameterGroup": [
            {
                "action": "redshift:ResetClusterParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "Redshift.ResizeCluster": [
            {
                "action": "redshift:ResizeCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.RestoreFromClusterSnapshot": [
            {
                "action": "redshift:RestoreFromClusterSnapshot",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${SnapshotClusterIdentifier}"
                    },
                    "SnapshotName": {
                        "template": "${SnapshotIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoles[]}"
                }
            }
        ],
        "Redshift.RestoreTableFromClusterSnapshot": [
            {
                "action": "redshift:RestoreTableFromClusterSnapshot",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    },
                    "SnapshotName": {
                        "template": "${SnapshotIdentifier}"
                    }
                }
            }
        ],
        "Redshift.ResumeCluster": [
            {
                "action": "redshift:ResumeCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Redshift.RevokeClusterSecurityGroupIngress": [
            {
                "action": "redshift:RevokeClusterSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupName": {
                        "template": "${ClusterSecurityGroupName}"
                    },
                    "Owner": {
                        "template": "*"
                    },
                    "Ec2SecurityGroupId": {
                        "template": "*"
                    },
                    "Ece2SecuritygroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Redshift.RevokeSnapshotAccess": [
            {
                "action": "redshift:RevokeSnapshotAccess",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${SnapshotClusterIdentifier}"
                    },
                    "SnapshotName": {
                        "template": "${SnapshotIdentifier}"
                    }
                }
            }
        ],
        "Redshift.RotateEncryptionKey": [
            {
                "action": "redshift:RotateEncryptionKey",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Rekognition.CompareFaces": [
            {
                "action": "rekognition:CompareFaces",
                "resource_mappings": {}
            }
        ],
        "Rekognition.CreateCollection": [
            {
                "action": "rekognition:CreateCollection",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${CollectionId}"
                    }
                }
            }
        ],
        "Rekognition.CreateProject": [
            {
                "action": "rekognition:CreateProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    },
                    "CreationTimestamp": {
                        "template": "*"
                    }
                }
            }
        ],
        "Rekognition.CreateProjectVersion": [
            {
                "action": "rekognition:CreateProjectVersion",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "%%regex%${ProjectArn}%/^.+\\/(.+?)\\/.*$/g%%"
                    },
                    "VersionName": {
                        "template": "${VersionName}"
                    },
                    "CreationTimestamp": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "project": "${ProjectArn}"
                }
            }
        ],
        "Rekognition.CreateStreamProcessor": [
            {
                "action": "rekognition:CreateStreamProcessor",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${Settings.FaceSearch.CollectionId}"
                    },
                    "StreamprocessorId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Rekognition.DeleteCollection": [
            {
                "action": "rekognition:DeleteCollection",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${CollectionId}"
                    }
                }
            }
        ],
        "Rekognition.DeleteFaces": [
            {
                "action": "rekognition:DeleteFaces",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${CollectionId}"
                    }
                }
            }
        ],
        "Rekognition.DeleteStreamProcessor": [
            {
                "action": "rekognition:DeleteStreamProcessor",
                "resource_mappings": {
                    "StreamprocessorId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Rekognition.DescribeCollection": [
            {
                "action": "rekognition:DescribeCollection",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${CollectionId}"
                    }
                }
            }
        ],
        "Rekognition.DescribeProjectVersions": [
            {
                "action": "rekognition:DescribeProjectVersions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${ProjectArn}"
                }
            }
        ],
        "Rekognition.DescribeProjects": [
            {
                "action": "rekognition:DescribeProjects",
                "resource_mappings": {}
            }
        ],
        "Rekognition.DescribeStreamProcessor": [
            {
                "action": "rekognition:DescribeStreamProcessor",
                "resource_mappings": {
                    "StreamprocessorId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Rekognition.DetectCustomLabels": [
            {
                "action": "rekognition:DetectCustomLabels",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "projectversion": "${ProjectVersionArn}"
                }
            }
        ],
        "Rekognition.DetectFaces": [
            {
                "action": "rekognition:DetectFaces",
                "resource_mappings": {}
            }
        ],
        "Rekognition.DetectLabels": [
            {
                "action": "rekognition:DetectLabels",
                "resource_mappings": {}
            }
        ],
        "Rekognition.DetectModerationLabels": [
            {
                "action": "rekognition:DetectModerationLabels",
                "resource_mappings": {}
            }
        ],
        "Rekognition.DetectProtectiveEquipment": [
            {
                "action": "rekognition:DetectProtectiveEquipment",
                "resource_mappings": {}
            }
        ],
        "Rekognition.DetectText": [
            {
                "action": "rekognition:DetectText",
                "resource_mappings": {}
            }
        ],
        "Rekognition.GetCelebrityInfo": [
            {
                "action": "rekognition:GetCelebrityInfo",
                "resource_mappings": {}
            }
        ],
        "Rekognition.GetCelebrityRecognition": [
            {
                "action": "rekognition:GetCelebrityRecognition",
                "resource_mappings": {}
            }
        ],
        "Rekognition.GetContentModeration": [
            {
                "action": "rekognition:GetContentModeration",
                "resource_mappings": {}
            }
        ],
        "Rekognition.GetFaceDetection": [
            {
                "action": "rekognition:GetFaceDetection",
                "resource_mappings": {}
            }
        ],
        "Rekognition.GetFaceSearch": [
            {
                "action": "rekognition:GetFaceSearch",
                "resource_mappings": {}
            }
        ],
        "Rekognition.GetLabelDetection": [
            {
                "action": "rekognition:GetLabelDetection",
                "resource_mappings": {}
            }
        ],
        "Rekognition.GetPersonTracking": [
            {
                "action": "rekognition:GetPersonTracking",
                "resource_mappings": {}
            }
        ],
        "Rekognition.GetSegmentDetection": [
            {
                "action": "rekognition:GetSegmentDetection",
                "resource_mappings": {}
            }
        ],
        "Rekognition.GetTextDetection": [
            {
                "action": "rekognition:GetTextDetection",
                "resource_mappings": {}
            }
        ],
        "Rekognition.IndexFaces": [
            {
                "action": "rekognition:IndexFaces",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${CollectionId}"
                    }
                }
            }
        ],
        "Rekognition.ListCollections": [
            {
                "action": "rekognition:ListCollections",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Rekognition.ListFaces": [
            {
                "action": "rekognition:ListFaces",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${CollectionId}"
                    }
                }
            }
        ],
        "Rekognition.ListStreamProcessors": [
            {
                "action": "rekognition:ListStreamProcessors",
                "resource_mappings": {
                    "StreamprocessorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Rekognition.RecognizeCelebrities": [
            {
                "action": "rekognition:RecognizeCelebrities",
                "resource_mappings": {}
            }
        ],
        "Rekognition.SearchFaces": [
            {
                "action": "rekognition:SearchFaces",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${CollectionId}"
                    }
                }
            }
        ],
        "Rekognition.SearchFacesByImage": [
            {
                "action": "rekognition:SearchFacesByImage",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${CollectionId}"
                    }
                }
            }
        ],
        "Rekognition.StartCelebrityRecognition": [
            {
                "action": "rekognition:StartCelebrityRecognition",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${NotificationChannel.RoleArn}"
                }
            }
        ],
        "Rekognition.StartContentModeration": [
            {
                "action": "rekognition:StartContentModeration",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${NotificationChannel.RoleArn}"
                }
            }
        ],
        "Rekognition.StartFaceDetection": [
            {
                "action": "rekognition:StartFaceDetection",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${NotificationChannel.RoleArn}"
                }
            }
        ],
        "Rekognition.StartFaceSearch": [
            {
                "action": "rekognition:StartFaceSearch",
                "resource_mappings": {
                    "CollectionId": {
                        "template": "${CollectionId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${NotificationChannel.RoleArn}"
                }
            }
        ],
        "Rekognition.StartLabelDetection": [
            {
                "action": "rekognition:StartLabelDetection",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${NotificationChannel.RoleArn}"
                }
            }
        ],
        "Rekognition.StartPersonTracking": [
            {
                "action": "rekognition:StartPersonTracking",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${NotificationChannel.RoleArn}"
                }
            }
        ],
        "Rekognition.StartProjectVersion": [
            {
                "action": "rekognition:StartProjectVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "projectversion": "${ProjectVersionArn}"
                }
            }
        ],
        "Rekognition.StartSegmentDetection": [
            {
                "action": "rekognition:StartSegmentDetection",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${NotificationChannel.RoleArn}"
                }
            }
        ],
        "Rekognition.StartStreamProcessor": [
            {
                "action": "rekognition:StartStreamProcessor",
                "resource_mappings": {
                    "StreamprocessorId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Rekognition.StartTextDetection": [
            {
                "action": "rekognition:StartTextDetection",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${NotificationChannel.RoleArn}"
                }
            }
        ],
        "Rekognition.StopProjectVersion": [
            {
                "action": "rekognition:StopProjectVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "projectversion": "${ProjectVersionArn}"
                }
            }
        ],
        "Rekognition.StopStreamProcessor": [
            {
                "action": "rekognition:StopStreamProcessor",
                "resource_mappings": {
                    "StreamprocessorId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "ResourceGroupsTaggingAPI.DescribeReportCreation": [
            {
                "action": "tag:DescribeReportCreation",
                "resource_mappings": {}
            }
        ],
        "ResourceGroupsTaggingAPI.GetComplianceSummary": [
            {
                "action": "tag:GetComplianceSummary",
                "resource_mappings": {}
            }
        ],
        "ResourceGroupsTaggingAPI.GetResources": [
            {
                "action": "tag:GetResources",
                "resource_mappings": {}
            }
        ],
        "ResourceGroupsTaggingAPI.GetTagKeys": [
            {
                "action": "tag:GetTagKeys",
                "resource_mappings": {}
            }
        ],
        "ResourceGroupsTaggingAPI.GetTagValues": [
            {
                "action": "tag:GetTagValues",
                "resource_mappings": {}
            }
        ],
        "ResourceGroupsTaggingAPI.StartReportCreation": [
            {
                "action": "tag:StartReportCreation",
                "resource_mappings": {}
            }
        ],
        "ResourceGroupsTaggingAPI.TagResources": [
            {
                "action": "tag:TagResources",
                "resource_mappings": {}
            }
        ],
        "ResourceGroupsTaggingAPI.UntagResources": [
            {
                "action": "tag:UntagResources",
                "resource_mappings": {}
            }
        ],
        "Route53.AssociateVPCWithHostedZone": [
            {
                "action": "route53:AssociateVPCWithHostedZone",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VPC.VPCId}"
                    },
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "Route53.ChangeResourceRecordSets": [
            {
                "action": "route53:ChangeResourceRecordSets",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.ChangeTagsForResource": [
            {
                "action": "route53:ChangeTagsForResource",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53.CreateHealthCheck": [
            {
                "action": "route53:CreateHealthCheck",
                "resource_mappings": {}
            }
        ],
        "Route53.CreateHostedZone": [
            {
                "action": "route53:CreateHostedZone",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VPC.VPCId}"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "Route53.CreateQueryLoggingConfig": [
            {
                "action": "route53:CreateQueryLoggingConfig",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.CreateReusableDelegationSet": [
            {
                "action": "route53:CreateReusableDelegationSet",
                "resource_mappings": {}
            }
        ],
        "Route53.CreateTrafficPolicy": [
            {
                "action": "route53:CreateTrafficPolicy",
                "resource_mappings": {}
            }
        ],
        "Route53.CreateTrafficPolicyInstance": [
            {
                "action": "route53:CreateTrafficPolicyInstance",
                "resource_mappings": {
                    "Id": {
                        "template": "${TrafficPolicyId}"
                    }
                }
            }
        ],
        "Route53.CreateTrafficPolicyVersion": [
            {
                "action": "route53:CreateTrafficPolicyVersion",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.CreateVPCAssociationAuthorization": [
            {
                "action": "route53:CreateVPCAssociationAuthorization",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.DeleteHealthCheck": [
            {
                "action": "route53:DeleteHealthCheck",
                "resource_mappings": {
                    "Id": {
                        "template": "${HealthCheckId}"
                    }
                }
            }
        ],
        "Route53.DeleteHostedZone": [
            {
                "action": "route53:DeleteHostedZone",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.DeleteQueryLoggingConfig": [
            {
                "action": "route53:DeleteQueryLoggingConfig",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.DeleteReusableDelegationSet": [
            {
                "action": "route53:DeleteReusableDelegationSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.DeleteTrafficPolicy": [
            {
                "action": "route53:DeleteTrafficPolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.DeleteTrafficPolicyInstance": [
            {
                "action": "route53:DeleteTrafficPolicyInstance",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.DeleteVPCAssociationAuthorization": [
            {
                "action": "route53:DeleteVPCAssociationAuthorization",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.DisassociateVPCFromHostedZone": [
            {
                "action": "route53:DisassociateVPCFromHostedZone",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    },
                    "VpcId": {
                        "template": "${VPC.VPCId}"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "Route53.GetAccountLimit": [
            {
                "action": "route53:GetAccountLimit",
                "resource_mappings": {}
            }
        ],
        "Route53.GetChange": [
            {
                "action": "route53:GetChange",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.GetCheckerIpRanges": [
            {
                "action": "route53:GetCheckerIpRanges",
                "resource_mappings": {}
            }
        ],
        "Route53.GetGeoLocation": [
            {
                "action": "route53:GetGeoLocation",
                "resource_mappings": {}
            }
        ],
        "Route53.GetHealthCheck": [
            {
                "action": "route53:GetHealthCheck",
                "resource_mappings": {
                    "Id": {
                        "template": "${HealthCheckId}"
                    }
                }
            }
        ],
        "Route53.GetHealthCheckCount": [
            {
                "action": "route53:GetHealthCheckCount",
                "resource_mappings": {}
            }
        ],
        "Route53.GetHealthCheckLastFailureReason": [
            {
                "action": "route53:GetHealthCheckLastFailureReason",
                "resource_mappings": {
                    "Id": {
                        "template": "${HealthCheckId}"
                    }
                }
            }
        ],
        "Route53.GetHealthCheckStatus": [
            {
                "action": "route53:GetHealthCheckStatus",
                "resource_mappings": {
                    "Id": {
                        "template": "${HealthCheckId}"
                    }
                }
            }
        ],
        "Route53.GetHostedZone": [
            {
                "action": "route53:GetHostedZone",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.GetHostedZoneCount": [
            {
                "action": "route53:GetHostedZoneCount",
                "resource_mappings": {}
            }
        ],
        "Route53.GetHostedZoneLimit": [
            {
                "action": "route53:GetHostedZoneLimit",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.GetQueryLoggingConfig": [
            {
                "action": "route53:GetQueryLoggingConfig",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.GetReusableDelegationSet": [
            {
                "action": "route53:GetReusableDelegationSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.GetReusableDelegationSetLimit": [
            {
                "action": "route53:GetReusableDelegationSetLimit",
                "resource_mappings": {
                    "Id": {
                        "template": "${DelegationSetId}"
                    }
                }
            }
        ],
        "Route53.GetTrafficPolicy": [
            {
                "action": "route53:GetTrafficPolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.GetTrafficPolicyInstance": [
            {
                "action": "route53:GetTrafficPolicyInstance",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.GetTrafficPolicyInstanceCount": [
            {
                "action": "route53:GetTrafficPolicyInstanceCount",
                "resource_mappings": {}
            }
        ],
        "Route53.ListGeoLocations": [
            {
                "action": "route53:ListGeoLocations",
                "resource_mappings": {}
            }
        ],
        "Route53.ListHealthChecks": [
            {
                "action": "route53:ListHealthChecks",
                "resource_mappings": {}
            }
        ],
        "Route53.ListHostedZones": [
            {
                "action": "route53:ListHostedZones",
                "resource_mappings": {}
            }
        ],
        "Route53.ListHostedZonesByName": [
            {
                "action": "route53:ListHostedZonesByName",
                "resource_mappings": {}
            }
        ],
        "Route53.ListHostedZonesByVPC": [
            {
                "action": "route53:ListHostedZonesByVPC",
                "resource_mappings": {
                    "VpcId": {
                        "template": "${VPCId}"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "Route53.ListQueryLoggingConfigs": [
            {
                "action": "route53:ListQueryLoggingConfigs",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.ListResourceRecordSets": [
            {
                "action": "route53:ListResourceRecordSets",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.ListReusableDelegationSets": [
            {
                "action": "route53:ListReusableDelegationSets",
                "resource_mappings": {}
            }
        ],
        "Route53.ListTagsForResource": [
            {
                "action": "route53:ListTagsForResource",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53.ListTagsForResources": [
            {
                "action": "route53:ListTagsForResources",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53.ListTrafficPolicies": [
            {
                "action": "route53:ListTrafficPolicies",
                "resource_mappings": {}
            }
        ],
        "Route53.ListTrafficPolicyInstances": [
            {
                "action": "route53:ListTrafficPolicyInstances",
                "resource_mappings": {}
            }
        ],
        "Route53.ListTrafficPolicyInstancesByHostedZone": [
            {
                "action": "route53:ListTrafficPolicyInstancesByHostedZone",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.ListTrafficPolicyInstancesByPolicy": [
            {
                "action": "route53:ListTrafficPolicyInstancesByPolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "${TrafficPolicyId}"
                    }
                }
            }
        ],
        "Route53.ListTrafficPolicyVersions": [
            {
                "action": "route53:ListTrafficPolicyVersions",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.ListVPCAssociationAuthorizations": [
            {
                "action": "route53:ListVPCAssociationAuthorizations",
                "resource_mappings": {
                    "Id": {
                        "template": "${HostedZoneId}"
                    }
                }
            }
        ],
        "Route53.TestDNSAnswer": [
            {
                "action": "route53:TestDNSAnswer",
                "resource_mappings": {}
            }
        ],
        "Route53.UpdateHealthCheck": [
            {
                "action": "route53:UpdateHealthCheck",
                "resource_mappings": {
                    "Id": {
                        "template": "${HealthCheckId}"
                    }
                }
            }
        ],
        "Route53.UpdateHostedZoneComment": [
            {
                "action": "route53:UpdateHostedZoneComment",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.UpdateTrafficPolicyComment": [
            {
                "action": "route53:UpdateTrafficPolicyComment",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53.UpdateTrafficPolicyInstance": [
            {
                "action": "route53:UpdateTrafficPolicyInstance",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Route53Domains.CheckDomainAvailability": [
            {
                "action": "route53domains:CheckDomainAvailability",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.DeleteTagsForDomain": [
            {
                "action": "route53domains:DeleteTagsForDomain",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.DisableDomainAutoRenew": [
            {
                "action": "route53domains:DisableDomainAutoRenew",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.DisableDomainTransferLock": [
            {
                "action": "route53domains:DisableDomainTransferLock",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.EnableDomainAutoRenew": [
            {
                "action": "route53domains:EnableDomainAutoRenew",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.EnableDomainTransferLock": [
            {
                "action": "route53domains:EnableDomainTransferLock",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.GetContactReachabilityStatus": [
            {
                "action": "route53domains:GetContactReachabilityStatus",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.GetDomainDetail": [
            {
                "action": "route53domains:GetDomainDetail",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.GetDomainSuggestions": [
            {
                "action": "route53domains:GetDomainSuggestions",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.GetOperationDetail": [
            {
                "action": "route53domains:GetOperationDetail",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.ListDomains": [
            {
                "action": "route53domains:ListDomains",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.ListOperations": [
            {
                "action": "route53domains:ListOperations",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.ListTagsForDomain": [
            {
                "action": "route53domains:ListTagsForDomain",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.RegisterDomain": [
            {
                "action": "route53domains:RegisterDomain",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.RenewDomain": [
            {
                "action": "route53domains:RenewDomain",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.ResendContactReachabilityEmail": [
            {
                "action": "route53domains:ResendContactReachabilityEmail",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.RetrieveDomainAuthCode": [
            {
                "action": "route53domains:RetrieveDomainAuthCode",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.TransferDomain": [
            {
                "action": "route53domains:TransferDomain",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.UpdateDomainContact": [
            {
                "action": "route53domains:UpdateDomainContact",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.UpdateDomainContactPrivacy": [
            {
                "action": "route53domains:UpdateDomainContactPrivacy",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.UpdateDomainNameservers": [
            {
                "action": "route53domains:UpdateDomainNameservers",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.UpdateTagsForDomain": [
            {
                "action": "route53domains:UpdateTagsForDomain",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.ViewBilling": [
            {
                "action": "route53domains:ViewBilling",
                "resource_mappings": {}
            }
        ],
        "S3.AbortMultipartUpload": [
            {
                "action": "s3:AbortMultipartUpload",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.CreateBucket": [
            {
                "action": "s3:CreateBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucket": [
            {
                "action": "s3:DeleteBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucketOwnershipControls": [
            {
                "action": "s3:DeleteBucketOwnershipControls",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucketPolicy": [
            {
                "action": "s3:DeleteBucketPolicy",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteBucketWebsite": [
            {
                "action": "s3:DeleteBucketWebsite",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.DeleteObject": [
            {
                "action": "s3:DeleteObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.DeleteObjectTagging": [
            {
                "action": "s3:DeleteObjectTagging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.GetBucketAcl": [
            {
                "action": "s3:GetBucketAcl",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketLocation": [
            {
                "action": "s3:GetBucketLocation",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketLogging": [
            {
                "action": "s3:GetBucketLogging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketNotification": [
            {
                "action": "s3:GetBucketNotification",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketOwnershipControls": [
            {
                "action": "s3:GetBucketOwnershipControls",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketPolicy": [
            {
                "action": "s3:GetBucketPolicy",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketPolicyStatus": [
            {
                "action": "s3:GetBucketPolicyStatus",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketRequestPayment": [
            {
                "action": "s3:GetBucketRequestPayment",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketTagging": [
            {
                "action": "s3:GetBucketTagging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketVersioning": [
            {
                "action": "s3:GetBucketVersioning",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetBucketWebsite": [
            {
                "action": "s3:GetBucketWebsite",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.GetObject": [
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.GetObjectAcl": [
            {
                "action": "s3:GetObjectAcl",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.GetObjectLegalHold": [
            {
                "action": "s3:GetObjectLegalHold",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.GetObjectRetention": [
            {
                "action": "s3:GetObjectRetention",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.GetObjectTagging": [
            {
                "action": "s3:GetObjectTagging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.GetObjectTorrent": [
            {
                "action": "s3:GetObjectTorrent",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.PutBucketAcl": [
            {
                "action": "s3:PutBucketAcl",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketLogging": [
            {
                "action": "s3:PutBucketLogging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketNotification": [
            {
                "action": "s3:PutBucketNotification",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${NotificationConfiguration.CloudFunctionConfiguration.InvocationRole}"
                }
            }
        ],
        "S3.PutBucketOwnershipControls": [
            {
                "action": "s3:PutBucketOwnershipControls",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketPolicy": [
            {
                "action": "s3:PutBucketPolicy",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketRequestPayment": [
            {
                "action": "s3:PutBucketRequestPayment",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketTagging": [
            {
                "action": "s3:PutBucketTagging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketVersioning": [
            {
                "action": "s3:PutBucketVersioning",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutBucketWebsite": [
            {
                "action": "s3:PutBucketWebsite",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3.PutObject": [
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.PutObjectAcl": [
            {
                "action": "s3:PutObjectAcl",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.PutObjectLegalHold": [
            {
                "action": "s3:PutObjectLegalHold",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.PutObjectRetention": [
            {
                "action": "s3:PutObjectRetention",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.PutObjectTagging": [
            {
                "action": "s3:PutObjectTagging",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3.RestoreObject": [
            {
                "action": "s3:RestoreObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Key}"
                    }
                }
            }
        ],
        "S3Control.CreateAccessPoint": [
            {
                "action": "s3-outposts:CreateAccessPoint",
                "resource_mappings": {
                    "OutpostId": {
                        "template": "%%regex%${Bucket}%/^arn:aws:s3-outposts:.+?:.+?:outpost\\/(.+?)\\//g%%"
                    },
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.CreateBucket": [
            {
                "action": "s3-outposts:CreateBucket",
                "resource_mappings": {
                    "OutpostId": {
                        "template": "${OutpostId}"
                    },
                    "BucketName": {
                        "template": "${Bucket}"
                    }
                }
            }
        ],
        "S3Control.DeleteAccessPoint": [
            {
                "action": "s3-outposts:DeleteAccessPoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accesspoint": "%%iftemplatematch%${Name}%%"
                }
            }
        ],
        "S3Control.DeleteAccessPointPolicy": [
            {
                "action": "s3-outposts:DeleteAccessPointPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accesspoint": "%%iftemplatematch%${Name}%%"
                }
            }
        ],
        "S3Control.DeleteBucket": [
            {
                "action": "s3-outposts:DeleteBucket",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bucket": "%%iftemplatematch%${Bucket}%%"
                }
            }
        ],
        "S3Control.DeleteBucketPolicy": [
            {
                "action": "s3-outposts:DeleteBucketPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bucket": "%%iftemplatematch%${Bucket}%%"
                }
            }
        ],
        "S3Control.GetAccessPoint": [
            {
                "action": "s3-outposts:GetAccessPoint",
                "resource_mappings": {}
            }
        ],
        "S3Control.GetAccessPointPolicy": [
            {
                "action": "s3-outposts:GetAccessPointPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accesspoint": "%%iftemplatematch%${Name}%%"
                }
            }
        ],
        "S3Control.GetBucketPolicy": [
            {
                "action": "s3-outposts:GetBucketPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bucket": "%%iftemplatematch%${Bucket}%%"
                }
            }
        ],
        "S3Control.GetBucketTagging": [
            {
                "action": "s3-outposts:GetBucketTagging",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bucket": "%%iftemplatematch%${Bucket}%%"
                }
            }
        ],
        "S3Control.ListAccessPoints": [
            {
                "action": "s3-outposts:ListAccessPoints",
                "resource_mappings": {}
            }
        ],
        "S3Control.ListRegionalBuckets": [
            {
                "action": "s3-outposts:ListRegionalBuckets",
                "resource_mappings": {}
            }
        ],
        "S3Control.PutAccessPointPolicy": [
            {
                "action": "s3-outposts:PutAccessPointPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accesspoint": "%%iftemplatematch%${Name}%%"
                }
            }
        ],
        "S3Control.PutBucketPolicy": [
            {
                "action": "s3-outposts:PutBucketPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bucket": "%%iftemplatematch%${Bucket}%%"
                }
            }
        ],
        "S3Control.PutBucketTagging": [
            {
                "action": "s3-outposts:PutBucketTagging",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bucket": "%%iftemplatematch%${Bucket}%%"
                }
            }
        ],
        "ServiceCatalog.AcceptPortfolioShare": [
            {
                "action": "servicecatalog:AcceptPortfolioShare",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.AssociateBudgetWithResource": [
            {
                "action": "servicecatalog:AssociateBudgetWithResource",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.AssociatePrincipalWithPortfolio": [
            {
                "action": "servicecatalog:AssociatePrincipalWithPortfolio",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.AssociateProductWithPortfolio": [
            {
                "action": "servicecatalog:AssociateProductWithPortfolio",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.AssociateServiceActionWithProvisioningArtifact": [
            {
                "action": "servicecatalog:AssociateServiceActionWithProvisioningArtifact",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.AssociateTagOptionWithResource": [
            {
                "action": "servicecatalog:AssociateTagOptionWithResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Portfolio": "%%iftemplatematch%${ResourceId}%%",
                    "Product": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "ServiceCatalog.BatchAssociateServiceActionWithProvisioningArtifact": [
            {
                "action": "servicecatalog:BatchAssociateServiceActionWithProvisioningArtifact",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.BatchDisassociateServiceActionFromProvisioningArtifact": [
            {
                "action": "servicecatalog:BatchDisassociateServiceActionFromProvisioningArtifact",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.CopyProduct": [
            {
                "action": "servicecatalog:CopyProduct",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.CreateConstraint": [
            {
                "action": "servicecatalog:CreateConstraint",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.CreatePortfolio": [
            {
                "action": "servicecatalog:CreatePortfolio",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalog.CreatePortfolioShare": [
            {
                "action": "servicecatalog:CreatePortfolioShare",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.CreateProduct": [
            {
                "action": "servicecatalog:CreateProduct",
                "resource_mappings": {
                    "ProductId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalog.CreateProvisionedProductPlan": [
            {
                "action": "servicecatalog:CreateProvisionedProductPlan",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.CreateProvisioningArtifact": [
            {
                "action": "servicecatalog:CreateProvisioningArtifact",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.CreateServiceAction": [
            {
                "action": "servicecatalog:CreateServiceAction",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.CreateTagOption": [
            {
                "action": "servicecatalog:CreateTagOption",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DeleteConstraint": [
            {
                "action": "servicecatalog:DeleteConstraint",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DeletePortfolio": [
            {
                "action": "servicecatalog:DeletePortfolio",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceCatalog.DeletePortfolioShare": [
            {
                "action": "servicecatalog:DeletePortfolioShare",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.DeleteProduct": [
            {
                "action": "servicecatalog:DeleteProduct",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceCatalog.DeleteProvisionedProductPlan": [
            {
                "action": "servicecatalog:DeleteProvisionedProductPlan",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DeleteProvisioningArtifact": [
            {
                "action": "servicecatalog:DeleteProvisioningArtifact",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.DeleteServiceAction": [
            {
                "action": "servicecatalog:DeleteServiceAction",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DeleteTagOption": [
            {
                "action": "servicecatalog:DeleteTagOption",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribeConstraint": [
            {
                "action": "servicecatalog:DescribeConstraint",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribeCopyProductStatus": [
            {
                "action": "servicecatalog:DescribeCopyProductStatus",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribePortfolio": [
            {
                "action": "servicecatalog:DescribePortfolio",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceCatalog.DescribePortfolioShareStatus": [
            {
                "action": "servicecatalog:DescribePortfolioShareStatus",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribeProduct": [
            {
                "action": "servicecatalog:DescribeProduct",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceCatalog.DescribeProductAsAdmin": [
            {
                "action": "servicecatalog:DescribeProductAsAdmin",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceCatalog.DescribeProductView": [
            {
                "action": "servicecatalog:DescribeProductView",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribeProvisionedProduct": [
            {
                "action": "servicecatalog:DescribeProvisionedProduct",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribeProvisionedProductPlan": [
            {
                "action": "servicecatalog:DescribeProvisionedProductPlan",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribeProvisioningArtifact": [
            {
                "action": "servicecatalog:DescribeProvisioningArtifact",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.DescribeProvisioningParameters": [
            {
                "action": "servicecatalog:DescribeProvisioningParameters",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.DescribeRecord": [
            {
                "action": "servicecatalog:DescribeRecord",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribeServiceAction": [
            {
                "action": "servicecatalog:DescribeServiceAction",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribeServiceActionExecutionParameters": [
            {
                "action": "servicecatalog:DescribeServiceActionExecutionParameters",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribeTagOption": [
            {
                "action": "servicecatalog:DescribeTagOption",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DisableAWSOrganizationsAccess": [
            {
                "action": "servicecatalog:DisableAWSOrganizationsAccess",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DisassociateBudgetFromResource": [
            {
                "action": "servicecatalog:DisassociateBudgetFromResource",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DisassociatePrincipalFromPortfolio": [
            {
                "action": "servicecatalog:DisassociatePrincipalFromPortfolio",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.DisassociateProductFromPortfolio": [
            {
                "action": "servicecatalog:DisassociateProductFromPortfolio",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DisassociateServiceActionFromProvisioningArtifact": [
            {
                "action": "servicecatalog:DisassociateServiceActionFromProvisioningArtifact",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.DisassociateTagOptionFromResource": [
            {
                "action": "servicecatalog:DisassociateTagOptionFromResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Portfolio": "%%iftemplatematch%${ResourceId}%%",
                    "Product": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "ServiceCatalog.EnableAWSOrganizationsAccess": [
            {
                "action": "servicecatalog:EnableAWSOrganizationsAccess",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ExecuteProvisionedProductPlan": [
            {
                "action": "servicecatalog:ExecuteProvisionedProductPlan",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ExecuteProvisionedProductServiceAction": [
            {
                "action": "servicecatalog:ExecuteProvisionedProductServiceAction",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.GetAWSOrganizationsAccessStatus": [
            {
                "action": "servicecatalog:GetAWSOrganizationsAccessStatus",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ImportAsProvisionedProduct": [
            {
                "action": "servicecatalog:ImportAsProvisionedProduct",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.ListAcceptedPortfolioShares": [
            {
                "action": "servicecatalog:ListAcceptedPortfolioShares",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListBudgetsForResource": [
            {
                "action": "servicecatalog:ListBudgetsForResource",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListConstraintsForPortfolio": [
            {
                "action": "servicecatalog:ListConstraintsForPortfolio",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListLaunchPaths": [
            {
                "action": "servicecatalog:ListLaunchPaths",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.ListOrganizationPortfolioAccess": [
            {
                "action": "servicecatalog:ListOrganizationPortfolioAccess",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListPortfolioAccess": [
            {
                "action": "servicecatalog:ListPortfolioAccess",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.ListPortfolios": [
            {
                "action": "servicecatalog:ListPortfolios",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListPortfoliosForProduct": [
            {
                "action": "servicecatalog:ListPortfoliosForProduct",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.ListPrincipalsForPortfolio": [
            {
                "action": "servicecatalog:ListPrincipalsForPortfolio",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.ListProvisionedProductPlans": [
            {
                "action": "servicecatalog:ListProvisionedProductPlans",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListProvisioningArtifacts": [
            {
                "action": "servicecatalog:ListProvisioningArtifacts",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.ListProvisioningArtifactsForServiceAction": [
            {
                "action": "servicecatalog:ListProvisioningArtifactsForServiceAction",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListRecordHistory": [
            {
                "action": "servicecatalog:ListRecordHistory",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListResourcesForTagOption": [
            {
                "action": "servicecatalog:ListResourcesForTagOption",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListServiceActions": [
            {
                "action": "servicecatalog:ListServiceActions",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListServiceActionsForProvisioningArtifact": [
            {
                "action": "servicecatalog:ListServiceActionsForProvisioningArtifact",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.ListStackInstancesForProvisionedProduct": [
            {
                "action": "servicecatalog:ListStackInstancesForProvisionedProduct",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ListTagOptions": [
            {
                "action": "servicecatalog:ListTagOptions",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.ProvisionProduct": [
            {
                "action": "servicecatalog:ProvisionProduct",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.RejectPortfolioShare": [
            {
                "action": "servicecatalog:RejectPortfolioShare",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.ScanProvisionedProducts": [
            {
                "action": "servicecatalog:ScanProvisionedProducts",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.SearchProducts": [
            {
                "action": "servicecatalog:SearchProducts",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.SearchProductsAsAdmin": [
            {
                "action": "servicecatalog:SearchProductsAsAdmin",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.SearchProvisionedProducts": [
            {
                "action": "servicecatalog:SearchProvisionedProducts",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.TerminateProvisionedProduct": [
            {
                "action": "servicecatalog:TerminateProvisionedProduct",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.UpdateConstraint": [
            {
                "action": "servicecatalog:UpdateConstraint",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.UpdatePortfolio": [
            {
                "action": "servicecatalog:UpdatePortfolio",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceCatalog.UpdateProduct": [
            {
                "action": "servicecatalog:UpdateProduct",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceCatalog.UpdateProvisionedProduct": [
            {
                "action": "servicecatalog:UpdateProvisionedProduct",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.UpdateProvisionedProductProperties": [
            {
                "action": "servicecatalog:UpdateProvisionedProductProperties",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.UpdateProvisioningArtifact": [
            {
                "action": "servicecatalog:UpdateProvisioningArtifact",
                "resource_mappings": {
                    "ProductId": {
                        "template": "${ProductId}"
                    }
                }
            }
        ],
        "ServiceCatalog.UpdateServiceAction": [
            {
                "action": "servicecatalog:UpdateServiceAction",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.UpdateTagOption": [
            {
                "action": "servicecatalog:UpdateTagOption",
                "resource_mappings": {}
            }
        ],
        "SES.CloneReceiptRuleSet": [
            {
                "action": "ses:CloneReceiptRuleSet",
                "resource_mappings": {}
            }
        ],
        "SES.CreateConfigurationSet": [
            {
                "action": "ses:CreateConfigurationSet",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSet.Name}"
                    }
                }
            }
        ],
        "SES.CreateConfigurationSetEventDestination": [
            {
                "action": "ses:CreateConfigurationSetEventDestination",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${EventDestination.KinesisFirehoseDestination.IAMRoleARN}"
                }
            }
        ],
        "SES.CreateConfigurationSetTrackingOptions": [
            {
                "action": "ses:CreateConfigurationSetTrackingOptions",
                "resource_mappings": {}
            }
        ],
        "SES.CreateReceiptFilter": [
            {
                "action": "ses:CreateReceiptFilter",
                "resource_mappings": {}
            }
        ],
        "SES.CreateReceiptRule": [
            {
                "action": "ses:CreateReceiptRule",
                "resource_mappings": {}
            }
        ],
        "SES.CreateReceiptRuleSet": [
            {
                "action": "ses:CreateReceiptRuleSet",
                "resource_mappings": {}
            }
        ],
        "SES.CreateTemplate": [
            {
                "action": "ses:CreateTemplate",
                "resource_mappings": {}
            }
        ],
        "SES.DeleteConfigurationSet": [
            {
                "action": "ses:DeleteConfigurationSet",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SES.DeleteConfigurationSetEventDestination": [
            {
                "action": "ses:DeleteConfigurationSetEventDestination",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SES.DeleteConfigurationSetTrackingOptions": [
            {
                "action": "ses:DeleteConfigurationSetTrackingOptions",
                "resource_mappings": {}
            }
        ],
        "SES.DeleteCustomVerificationEmailTemplate": [
            {
                "action": "ses:DeleteCustomVerificationEmailTemplate",
                "resource_mappings": {}
            }
        ],
        "SES.DeleteReceiptFilter": [
            {
                "action": "ses:DeleteReceiptFilter",
                "resource_mappings": {}
            }
        ],
        "SES.DeleteReceiptRule": [
            {
                "action": "ses:DeleteReceiptRule",
                "resource_mappings": {}
            }
        ],
        "SES.DeleteReceiptRuleSet": [
            {
                "action": "ses:DeleteReceiptRuleSet",
                "resource_mappings": {}
            }
        ],
        "SES.DeleteTemplate": [
            {
                "action": "ses:DeleteTemplate",
                "resource_mappings": {}
            }
        ],
        "SES.DescribeActiveReceiptRuleSet": [
            {
                "action": "ses:DescribeActiveReceiptRuleSet",
                "resource_mappings": {}
            }
        ],
        "SES.DescribeConfigurationSet": [
            {
                "action": "ses:DescribeConfigurationSet",
                "resource_mappings": {}
            }
        ],
        "SES.DescribeReceiptRule": [
            {
                "action": "ses:DescribeReceiptRule",
                "resource_mappings": {}
            }
        ],
        "SES.DescribeReceiptRuleSet": [
            {
                "action": "ses:DescribeReceiptRuleSet",
                "resource_mappings": {}
            }
        ],
        "SES.GetAccountSendingEnabled": [
            {
                "action": "ses:GetAccountSendingEnabled",
                "resource_mappings": {}
            }
        ],
        "SES.GetCustomVerificationEmailTemplate": [
            {
                "action": "ses:GetCustomVerificationEmailTemplate",
                "resource_mappings": {}
            }
        ],
        "SES.GetIdentityPolicies": [
            {
                "action": "ses:GetIdentityPolicies",
                "resource_mappings": {}
            }
        ],
        "SES.GetSendQuota": [
            {
                "action": "ses:GetSendQuota",
                "resource_mappings": {}
            }
        ],
        "SES.GetSendStatistics": [
            {
                "action": "ses:GetSendStatistics",
                "resource_mappings": {}
            }
        ],
        "SES.GetTemplate": [
            {
                "action": "ses:GetTemplate",
                "resource_mappings": {}
            }
        ],
        "SES.ListConfigurationSets": [
            {
                "action": "ses:ListConfigurationSets",
                "resource_mappings": {}
            }
        ],
        "SES.ListCustomVerificationEmailTemplates": [
            {
                "action": "ses:ListCustomVerificationEmailTemplates",
                "resource_mappings": {}
            }
        ],
        "SES.ListIdentities": [
            {
                "action": "ses:ListIdentities",
                "resource_mappings": {}
            }
        ],
        "SES.ListIdentityPolicies": [
            {
                "action": "ses:ListIdentityPolicies",
                "resource_mappings": {}
            }
        ],
        "SES.ListReceiptFilters": [
            {
                "action": "ses:ListReceiptFilters",
                "resource_mappings": {}
            }
        ],
        "SES.ListReceiptRuleSets": [
            {
                "action": "ses:ListReceiptRuleSets",
                "resource_mappings": {}
            }
        ],
        "SES.ListTemplates": [
            {
                "action": "ses:ListTemplates",
                "resource_mappings": {}
            }
        ],
        "SES.ListVerifiedEmailAddresses": [
            {
                "action": "ses:ListVerifiedEmailAddresses",
                "resource_mappings": {}
            }
        ],
        "SES.PutConfigurationSetDeliveryOptions": [
            {
                "action": "ses:PutConfigurationSetDeliveryOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SES.PutIdentityPolicy": [
            {
                "action": "ses:PutIdentityPolicy",
                "resource_mappings": {}
            }
        ],
        "SES.ReorderReceiptRuleSet": [
            {
                "action": "ses:ReorderReceiptRuleSet",
                "resource_mappings": {}
            }
        ],
        "SES.SendBulkTemplatedEmail": [
            {
                "action": "ses:SendBulkTemplatedEmail",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SendCustomVerificationEmail": [
            {
                "action": "ses:SendCustomVerificationEmail",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SendEmail": [
            {
                "action": "ses:SendEmail",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SendRawEmail": [
            {
                "action": "ses:SendRawEmail",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SetActiveReceiptRuleSet": [
            {
                "action": "ses:SetActiveReceiptRuleSet",
                "resource_mappings": {}
            }
        ],
        "SES.SetReceiptRulePosition": [
            {
                "action": "ses:SetReceiptRulePosition",
                "resource_mappings": {}
            }
        ],
        "SES.TestRenderTemplate": [
            {
                "action": "ses:TestRenderTemplate",
                "resource_mappings": {}
            }
        ],
        "SES.UpdateAccountSendingEnabled": [
            {
                "action": "ses:UpdateAccountSendingEnabled",
                "resource_mappings": {}
            }
        ],
        "SES.UpdateConfigurationSetEventDestination": [
            {
                "action": "ses:UpdateConfigurationSetEventDestination",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${EventDestination.KinesisFirehoseDestination.IAMRoleARN}"
                }
            }
        ],
        "SES.UpdateConfigurationSetReputationMetricsEnabled": [
            {
                "action": "ses:UpdateConfigurationSetReputationMetricsEnabled",
                "resource_mappings": {}
            }
        ],
        "SES.UpdateConfigurationSetSendingEnabled": [
            {
                "action": "ses:UpdateConfigurationSetSendingEnabled",
                "resource_mappings": {}
            }
        ],
        "SES.UpdateConfigurationSetTrackingOptions": [
            {
                "action": "ses:UpdateConfigurationSetTrackingOptions",
                "resource_mappings": {}
            }
        ],
        "SES.UpdateCustomVerificationEmailTemplate": [
            {
                "action": "ses:UpdateCustomVerificationEmailTemplate",
                "resource_mappings": {}
            }
        ],
        "SES.UpdateReceiptRule": [
            {
                "action": "ses:UpdateReceiptRule",
                "resource_mappings": {}
            }
        ],
        "SES.UpdateTemplate": [
            {
                "action": "ses:UpdateTemplate",
                "resource_mappings": {}
            }
        ],
        "SES.VerifyDomainIdentity": [
            {
                "action": "ses:VerifyDomainIdentity",
                "resource_mappings": {}
            }
        ],
        "SES.VerifyEmailAddress": [
            {
                "action": "ses:VerifyEmailAddress",
                "resource_mappings": {}
            }
        ],
        "SES.VerifyEmailIdentity": [
            {
                "action": "ses:VerifyEmailIdentity",
                "resource_mappings": {}
            }
        ],
        "Shield.AssociateDRTLogBucket": [
            {
                "action": "shield:AssociateDRTLogBucket",
                "resource_mappings": {}
            }
        ],
        "Shield.AssociateDRTRole": [
            {
                "action": "shield:AssociateDRTRole",
                "resource_mappings": {}
            },
            {
                "action": "iam:GetRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Shield.CreateSubscription": [
            {
                "action": "shield:CreateSubscription",
                "resource_mappings": {}
            }
        ],
        "Shield.DeleteProtection": [
            {
                "action": "shield:DeleteProtection",
                "resource_mappings": {
                    "Id": {
                        "template": "${ProtectionId}"
                    }
                }
            }
        ],
        "Shield.DeleteSubscription": [
            {
                "action": "shield:DeleteSubscription",
                "resource_mappings": {}
            }
        ],
        "Shield.DescribeAttack": [
            {
                "action": "shield:DescribeAttack",
                "resource_mappings": {
                    "Id": {
                        "template": "${AttackId}"
                    }
                }
            }
        ],
        "Shield.DescribeDRTAccess": [
            {
                "action": "shield:DescribeDRTAccess",
                "resource_mappings": {}
            }
        ],
        "Shield.DescribeEmergencyContactSettings": [
            {
                "action": "shield:DescribeEmergencyContactSettings",
                "resource_mappings": {}
            }
        ],
        "Shield.DescribeProtection": [
            {
                "action": "shield:DescribeProtection",
                "resource_mappings": {
                    "Id": {
                        "template": "${ProtectionId}"
                    }
                }
            }
        ],
        "Shield.DescribeSubscription": [
            {
                "action": "shield:DescribeSubscription",
                "resource_mappings": {}
            }
        ],
        "Shield.DisassociateDRTLogBucket": [
            {
                "action": "shield:DisassociateDRTLogBucket",
                "resource_mappings": {}
            },
            {
                "action": "s3:DeleteBucketPolicy",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${LogBucket}"
                    }
                }
            }
        ],
        "Shield.DisassociateDRTRole": [
            {
                "action": "shield:DisassociateDRTRole",
                "resource_mappings": {}
            }
        ],
        "Shield.GetSubscriptionState": [
            {
                "action": "shield:GetSubscriptionState",
                "resource_mappings": {}
            }
        ],
        "Shield.ListAttacks": [
            {
                "action": "shield:ListAttacks",
                "resource_mappings": {}
            }
        ],
        "Shield.ListProtections": [
            {
                "action": "shield:ListProtections",
                "resource_mappings": {}
            }
        ],
        "Shield.UpdateEmergencyContactSettings": [
            {
                "action": "shield:UpdateEmergencyContactSettings",
                "resource_mappings": {}
            }
        ],
        "Shield.UpdateSubscription": [
            {
                "action": "shield:UpdateSubscription",
                "resource_mappings": {}
            }
        ],
        "SimpleDB.BatchDeleteAttributes": [
            {
                "action": "sdb:BatchDeleteAttributes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "SimpleDB.BatchPutAttributes": [
            {
                "action": "sdb:BatchPutAttributes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "SimpleDB.CreateDomain": [
            {
                "action": "sdb:CreateDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "SimpleDB.DeleteAttributes": [
            {
                "action": "sdb:DeleteAttributes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "SimpleDB.DeleteDomain": [
            {
                "action": "sdb:DeleteDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "SimpleDB.DomainMetadata": [
            {
                "action": "sdb:DomainMetadata",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "SimpleDB.GetAttributes": [
            {
                "action": "sdb:GetAttributes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "SimpleDB.ListDomains": [
            {
                "action": "sdb:ListDomains",
                "resource_mappings": {}
            }
        ],
        "SimpleDB.PutAttributes": [
            {
                "action": "sdb:PutAttributes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "SimpleDB.Select": [
            {
                "action": "sdb:Select",
                "resource_mappings": {
                    "DomainName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SMS.CreateApp": [
            {
                "action": "sms:CreateApp",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${roleName}"
                }
            }
        ],
        "SMS.CreateReplicationJob": [
            {
                "action": "sms:CreateReplicationJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${roleName}"
                }
            }
        ],
        "SMS.DeleteApp": [
            {
                "action": "sms:DeleteApp",
                "resource_mappings": {}
            }
        ],
        "SMS.DeleteAppLaunchConfiguration": [
            {
                "action": "sms:DeleteAppLaunchConfiguration",
                "resource_mappings": {}
            }
        ],
        "SMS.DeleteAppReplicationConfiguration": [
            {
                "action": "sms:DeleteAppReplicationConfiguration",
                "resource_mappings": {}
            }
        ],
        "SMS.DeleteAppValidationConfiguration": [
            {
                "action": "sms:DeleteAppValidationConfiguration",
                "resource_mappings": {}
            }
        ],
        "SMS.DeleteReplicationJob": [
            {
                "action": "sms:DeleteReplicationJob",
                "resource_mappings": {}
            }
        ],
        "SMS.DeleteServerCatalog": [
            {
                "action": "sms:DeleteServerCatalog",
                "resource_mappings": {}
            }
        ],
        "SMS.DisassociateConnector": [
            {
                "action": "sms:DisassociateConnector",
                "resource_mappings": {}
            }
        ],
        "SMS.GenerateChangeSet": [
            {
                "action": "sms:GenerateChangeSet",
                "resource_mappings": {}
            }
        ],
        "SMS.GenerateTemplate": [
            {
                "action": "sms:GenerateTemplate",
                "resource_mappings": {}
            }
        ],
        "SMS.GetApp": [
            {
                "action": "sms:GetApp",
                "resource_mappings": {}
            }
        ],
        "SMS.GetAppLaunchConfiguration": [
            {
                "action": "sms:GetAppLaunchConfiguration",
                "resource_mappings": {}
            }
        ],
        "SMS.GetAppReplicationConfiguration": [
            {
                "action": "sms:GetAppReplicationConfiguration",
                "resource_mappings": {}
            }
        ],
        "SMS.GetAppValidationConfiguration": [
            {
                "action": "sms:GetAppValidationConfiguration",
                "resource_mappings": {}
            }
        ],
        "SMS.GetAppValidationOutput": [
            {
                "action": "sms:GetAppValidationOutput",
                "resource_mappings": {}
            }
        ],
        "SMS.GetConnectors": [
            {
                "action": "sms:GetConnectors",
                "resource_mappings": {}
            }
        ],
        "SMS.GetReplicationJobs": [
            {
                "action": "sms:GetReplicationJobs",
                "resource_mappings": {}
            }
        ],
        "SMS.GetReplicationRuns": [
            {
                "action": "sms:GetReplicationRuns",
                "resource_mappings": {}
            }
        ],
        "SMS.GetServers": [
            {
                "action": "sms:GetServers",
                "resource_mappings": {}
            }
        ],
        "SMS.ImportAppCatalog": [
            {
                "action": "sms:ImportAppCatalog",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${roleName}"
                }
            }
        ],
        "SMS.ImportServerCatalog": [
            {
                "action": "sms:ImportServerCatalog",
                "resource_mappings": {}
            }
        ],
        "SMS.LaunchApp": [
            {
                "action": "sms:LaunchApp",
                "resource_mappings": {}
            }
        ],
        "SMS.ListApps": [
            {
                "action": "sms:ListApps",
                "resource_mappings": {}
            }
        ],
        "SMS.NotifyAppValidationOutput": [
            {
                "action": "sms:NotifyAppValidationOutput",
                "resource_mappings": {}
            }
        ],
        "SMS.PutAppLaunchConfiguration": [
            {
                "action": "sms:PutAppLaunchConfiguration",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "SMS.PutAppReplicationConfiguration": [
            {
                "action": "sms:PutAppReplicationConfiguration",
                "resource_mappings": {}
            }
        ],
        "SMS.PutAppValidationConfiguration": [
            {
                "action": "sms:PutAppValidationConfiguration",
                "resource_mappings": {}
            }
        ],
        "SMS.StartAppReplication": [
            {
                "action": "sms:StartAppReplication",
                "resource_mappings": {}
            }
        ],
        "SMS.StartOnDemandAppReplication": [
            {
                "action": "sms:StartOnDemandAppReplication",
                "resource_mappings": {}
            }
        ],
        "SMS.StartOnDemandReplicationRun": [
            {
                "action": "sms:StartOnDemandReplicationRun",
                "resource_mappings": {}
            }
        ],
        "SMS.StopAppReplication": [
            {
                "action": "sms:StopAppReplication",
                "resource_mappings": {}
            }
        ],
        "SMS.TerminateApp": [
            {
                "action": "sms:TerminateApp",
                "resource_mappings": {}
            }
        ],
        "SMS.UpdateApp": [
            {
                "action": "sms:UpdateApp",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${roleName}"
                }
            }
        ],
        "SMS.UpdateReplicationJob": [
            {
                "action": "sms:UpdateReplicationJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/${roleName}"
                }
            }
        ],
        "Snowball.CancelCluster": [
            {
                "action": "snowball:CancelCluster",
                "resource_mappings": {}
            }
        ],
        "Snowball.CancelJob": [
            {
                "action": "snowball:CancelJob",
                "resource_mappings": {}
            }
        ],
        "Snowball.CreateAddress": [
            {
                "action": "snowball:CreateAddress",
                "resource_mappings": {}
            }
        ],
        "Snowball.CreateCluster": [
            {
                "action": "snowball:CreateCluster",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "Snowball.CreateJob": [
            {
                "action": "snowball:CreateJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "Snowball.DescribeAddress": [
            {
                "action": "snowball:DescribeAddress",
                "resource_mappings": {}
            }
        ],
        "Snowball.DescribeAddresses": [
            {
                "action": "snowball:DescribeAddresses",
                "resource_mappings": {}
            }
        ],
        "Snowball.DescribeCluster": [
            {
                "action": "snowball:DescribeCluster",
                "resource_mappings": {}
            }
        ],
        "Snowball.DescribeJob": [
            {
                "action": "snowball:DescribeJob",
                "resource_mappings": {}
            }
        ],
        "Snowball.GetJobManifest": [
            {
                "action": "snowball:GetJobManifest",
                "resource_mappings": {}
            }
        ],
        "Snowball.GetJobUnlockCode": [
            {
                "action": "snowball:GetJobUnlockCode",
                "resource_mappings": {}
            }
        ],
        "Snowball.GetSnowballUsage": [
            {
                "action": "snowball:GetSnowballUsage",
                "resource_mappings": {}
            }
        ],
        "Snowball.ListClusterJobs": [
            {
                "action": "snowball:ListClusterJobs",
                "resource_mappings": {}
            }
        ],
        "Snowball.ListClusters": [
            {
                "action": "snowball:ListClusters",
                "resource_mappings": {}
            }
        ],
        "Snowball.ListJobs": [
            {
                "action": "snowball:ListJobs",
                "resource_mappings": {}
            }
        ],
        "Snowball.UpdateCluster": [
            {
                "action": "snowball:UpdateCluster",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "Snowball.UpdateJob": [
            {
                "action": "snowball:UpdateJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleARN}"
                }
            }
        ],
        "SNS.AddPermission": [
            {
                "action": "sns:AddPermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${TopicArn}"
                }
            }
        ],
        "SNS.CheckIfPhoneNumberIsOptedOut": [
            {
                "action": "sns:CheckIfPhoneNumberIsOptedOut",
                "resource_mappings": {}
            }
        ],
        "SNS.ConfirmSubscription": [
            {
                "action": "sns:ConfirmSubscription",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${TopicArn}"
                }
            }
        ],
        "SNS.CreatePlatformApplication": [
            {
                "action": "sns:CreatePlatformApplication",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "SNS.CreatePlatformEndpoint": [
            {
                "action": "sns:CreatePlatformEndpoint",
                "resource_mappings": {}
            }
        ],
        "SNS.CreateTopic": [
            {
                "action": "sns:CreateTopic",
                "resource_mappings": {
                    "TopicName": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "SNS.DeleteEndpoint": [
            {
                "action": "sns:DeleteEndpoint",
                "resource_mappings": {}
            }
        ],
        "SNS.DeletePlatformApplication": [
            {
                "action": "sns:DeletePlatformApplication",
                "resource_mappings": {}
            }
        ],
        "SNS.DeleteTopic": [
            {
                "action": "sns:DeleteTopic",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${TopicArn}"
                }
            }
        ],
        "SNS.GetEndpointAttributes": [
            {
                "action": "sns:GetEndpointAttributes",
                "resource_mappings": {}
            }
        ],
        "SNS.GetPlatformApplicationAttributes": [
            {
                "action": "sns:GetPlatformApplicationAttributes",
                "resource_mappings": {}
            }
        ],
        "SNS.GetSMSAttributes": [
            {
                "action": "sns:GetSMSAttributes",
                "resource_mappings": {}
            }
        ],
        "SNS.GetSubscriptionAttributes": [
            {
                "action": "sns:GetSubscriptionAttributes",
                "resource_mappings": {}
            }
        ],
        "SNS.GetTopicAttributes": [
            {
                "action": "sns:GetTopicAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${TopicArn}"
                }
            }
        ],
        "SNS.ListEndpointsByPlatformApplication": [
            {
                "action": "sns:ListEndpointsByPlatformApplication",
                "resource_mappings": {}
            }
        ],
        "SNS.ListPhoneNumbersOptedOut": [
            {
                "action": "sns:ListPhoneNumbersOptedOut",
                "resource_mappings": {}
            }
        ],
        "SNS.ListPlatformApplications": [
            {
                "action": "sns:ListPlatformApplications",
                "resource_mappings": {}
            }
        ],
        "SNS.ListSubscriptions": [
            {
                "action": "sns:ListSubscriptions",
                "resource_mappings": {}
            }
        ],
        "SNS.ListSubscriptionsByTopic": [
            {
                "action": "sns:ListSubscriptionsByTopic",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${TopicArn}"
                }
            }
        ],
        "SNS.ListTagsForResource": [
            {
                "action": "sns:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SNS.ListTopics": [
            {
                "action": "sns:ListTopics",
                "resource_mappings": {}
            }
        ],
        "SNS.OptInPhoneNumber": [
            {
                "action": "sns:OptInPhoneNumber",
                "resource_mappings": {}
            }
        ],
        "SNS.Publish": [
            {
                "action": "sns:Publish",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${TopicArn}"
                }
            }
        ],
        "SNS.RemovePermission": [
            {
                "action": "sns:RemovePermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${TopicArn}"
                }
            }
        ],
        "SNS.SetEndpointAttributes": [
            {
                "action": "sns:SetEndpointAttributes",
                "resource_mappings": {}
            }
        ],
        "SNS.SetPlatformApplicationAttributes": [
            {
                "action": "sns:SetPlatformApplicationAttributes",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "SNS.SetSMSAttributes": [
            {
                "action": "sns:SetSMSAttributes",
                "resource_mappings": {}
            }
        ],
        "SNS.SetSubscriptionAttributes": [
            {
                "action": "sns:SetSubscriptionAttributes",
                "resource_mappings": {}
            }
        ],
        "SNS.SetTopicAttributes": [
            {
                "action": "sns:SetTopicAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${TopicArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "SNS.Subscribe": [
            {
                "action": "sns:Subscribe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${TopicArn}"
                }
            }
        ],
        "SNS.TagResource": [
            {
                "action": "sns:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SNS.Unsubscribe": [
            {
                "action": "sns:Unsubscribe",
                "resource_mappings": {}
            }
        ],
        "SNS.UntagResource": [
            {
                "action": "sns:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SQS.AddPermission": [
            {
                "action": "sqs:AddPermission",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.ChangeMessageVisibility": [
            {
                "action": "sqs:ChangeMessageVisibility",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.ChangeMessageVisibilityBatch": [
            {
                "action": "sqs:ChangeMessageVisibilityBatch",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.CreateQueue": [
            {
                "action": "sqs:CreateQueue",
                "resource_mappings": {
                    "QueueName": {
                        "template": "${QueueName}"
                    }
                }
            },
            {
                "action": "sqs:TagQueue",
                "resource_mappings": {
                    "QueueName": {
                        "template": "${QueueName}"
                    }
                },
                "conditions": {
                    "lhs": "tags",
                    "op": "Exists"
                }
            }
        ],
        "SQS.DeleteMessage": [
            {
                "action": "sqs:DeleteMessage",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.DeleteMessageBatch": [
            {
                "action": "sqs:DeleteMessageBatch",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.DeleteQueue": [
            {
                "action": "sqs:DeleteQueue",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.GetQueueAttributes": [
            {
                "action": "sqs:GetQueueAttributes",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.GetQueueUrl": [
            {
                "action": "sqs:GetQueueUrl",
                "resource_mappings": {
                    "QueueName": {
                        "template": "${QueueName}"
                    }
                }
            }
        ],
        "SQS.ListDeadLetterSourceQueues": [
            {
                "action": "sqs:ListDeadLetterSourceQueues",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.ListQueueTags": [
            {
                "action": "sqs:ListQueueTags",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.ListQueues": [
            {
                "action": "sqs:ListQueues",
                "resource_mappings": {}
            }
        ],
        "SQS.PurgeQueue": [
            {
                "action": "sqs:PurgeQueue",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.ReceiveMessage": [
            {
                "action": "sqs:ReceiveMessage",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.RemovePermission": [
            {
                "action": "sqs:RemovePermission",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.SendMessage": [
            {
                "action": "sqs:SendMessage",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.SendMessageBatch": [
            {
                "action": "sqs:SendMessage",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.SetQueueAttributes": [
            {
                "action": "sqs:SetQueueAttributes",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.TagQueue": [
            {
                "action": "sqs:TagQueue",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SQS.UntagQueue": [
            {
                "action": "sqs:UntagQueue",
                "resource_mappings": {
                    "QueueName": {
                        "template": "%%regex%${QueueUrl}%/^.+\\/(.+?)$/g%%"
                    }
                }
            }
        ],
        "SSM.AddTagsToResource": [
            {
                "action": "ssm:AddTagsToResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${ResourceId}%%",
                    "maintenancewindow": "%%iftemplatematch%${ResourceId}%%",
                    "managed-instance": "%%iftemplatematch%${ResourceId}%%",
                    "parameter": "%%iftemplatematch%${ResourceId}%%",
                    "patchbaseline": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "SSM.CancelCommand": [
            {
                "action": "ssm:CancelCommand",
                "resource_mappings": {}
            }
        ],
        "SSM.CancelMaintenanceWindowExecution": [
            {
                "action": "ssm:CancelMaintenanceWindowExecution",
                "resource_mappings": {}
            }
        ],
        "SSM.CreateActivation": [
            {
                "action": "ssm:CreateActivation",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRole}"
                }
            }
        ],
        "SSM.CreateAssociation": [
            {
                "action": "ssm:CreateAssociation",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${Name}%%"
                }
            }
        ],
        "SSM.CreateAssociationBatch": [
            {
                "action": "ssm:CreateAssociationBatch",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${Entries[].Name}%%"
                }
            }
        ],
        "SSM.CreateDocument": [
            {
                "action": "ssm:CreateDocument",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "SSM.CreateMaintenanceWindow": [
            {
                "action": "ssm:CreateMaintenanceWindow",
                "resource_mappings": {}
            }
        ],
        "SSM.CreateOpsItem": [
            {
                "action": "ssm:CreateOpsItem",
                "resource_mappings": {}
            }
        ],
        "SSM.CreateOpsMetadata": [
            {
                "action": "ssm:CreateOpsMetadata",
                "resource_mappings": {}
            }
        ],
        "SSM.CreatePatchBaseline": [
            {
                "action": "ssm:CreatePatchBaseline",
                "resource_mappings": {}
            }
        ],
        "SSM.CreateResourceDataSync": [
            {
                "action": "ssm:CreateResourceDataSync",
                "resource_mappings": {
                    "SyncName": {
                        "template": "${SyncName}"
                    }
                }
            }
        ],
        "SSM.DeleteActivation": [
            {
                "action": "ssm:DeleteActivation",
                "resource_mappings": {}
            }
        ],
        "SSM.DeleteAssociation": [
            {
                "action": "ssm:DeleteAssociation",
                "resource_mappings": {
                    "AssociationId": {
                        "template": "${AssociationId}"
                    },
                    "InstanceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${Name}%%"
                }
            }
        ],
        "SSM.DeleteDocument": [
            {
                "action": "ssm:DeleteDocument",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.DeleteInventory": [
            {
                "action": "ssm:DeleteInventory",
                "resource_mappings": {}
            }
        ],
        "SSM.DeleteMaintenanceWindow": [
            {
                "action": "ssm:DeleteMaintenanceWindow",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.DeleteOpsMetadata": [
            {
                "action": "ssm:DeleteOpsMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "opsmetadata": "${OpsMetadataArn}"
                }
            }
        ],
        "SSM.DeleteParameter": [
            {
                "action": "ssm:DeleteParameter",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.DeleteParameters": [
            {
                "action": "ssm:DeleteParameters",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "${Names[]}"
                    }
                }
            }
        ],
        "SSM.DeletePatchBaseline": [
            {
                "action": "ssm:DeletePatchBaseline",
                "resource_mappings": {
                    "PatchBaselineIdResourceId": {
                        "template": "${BaselineId}"
                    }
                }
            }
        ],
        "SSM.DeleteResourceDataSync": [
            {
                "action": "ssm:DeleteResourceDataSync",
                "resource_mappings": {
                    "SyncName": {
                        "template": "${SyncName}"
                    }
                }
            }
        ],
        "SSM.DeregisterManagedInstance": [
            {
                "action": "ssm:DeregisterManagedInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "SSM.DeregisterPatchBaselineForPatchGroup": [
            {
                "action": "ssm:DeregisterPatchBaselineForPatchGroup",
                "resource_mappings": {
                    "PatchBaselineIdResourceId": {
                        "template": "${BaselineId}"
                    }
                }
            }
        ],
        "SSM.DeregisterTargetFromMaintenanceWindow": [
            {
                "action": "ssm:DeregisterTargetFromMaintenanceWindow",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.DeregisterTaskFromMaintenanceWindow": [
            {
                "action": "ssm:DeregisterTaskFromMaintenanceWindow",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.DescribeActivations": [
            {
                "action": "ssm:DescribeActivations",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeAssociation": [
            {
                "action": "ssm:DescribeAssociation",
                "resource_mappings": {
                    "AssociationId": {
                        "template": "${AssociationId}"
                    },
                    "InstanceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${Name}%%"
                }
            }
        ],
        "SSM.DescribeAssociationExecutionTargets": [
            {
                "action": "ssm:DescribeAssociationExecutionTargets",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeAssociationExecutions": [
            {
                "action": "ssm:DescribeAssociationExecutions",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeAutomationExecutions": [
            {
                "action": "ssm:DescribeAutomationExecutions",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeAutomationStepExecutions": [
            {
                "action": "ssm:DescribeAutomationStepExecutions",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeAvailablePatches": [
            {
                "action": "ssm:DescribeAvailablePatches",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeDocument": [
            {
                "action": "ssm:DescribeDocument",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.DescribeDocumentPermission": [
            {
                "action": "ssm:DescribeDocumentPermission",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.DescribeEffectiveInstanceAssociations": [
            {
                "action": "ssm:DescribeEffectiveInstanceAssociations",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSM.DescribeEffectivePatchesForPatchBaseline": [
            {
                "action": "ssm:DescribeEffectivePatchesForPatchBaseline",
                "resource_mappings": {
                    "PatchBaselineIdResourceId": {
                        "template": "${BaselineId}"
                    }
                }
            }
        ],
        "SSM.DescribeInstanceAssociationsStatus": [
            {
                "action": "ssm:DescribeInstanceAssociationsStatus",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSM.DescribeInstanceInformation": [
            {
                "action": "ssm:DescribeInstanceInformation",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeInstancePatchStates": [
            {
                "action": "ssm:DescribeInstancePatchStates",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeInstancePatchStatesForPatchGroup": [
            {
                "action": "ssm:DescribeInstancePatchStatesForPatchGroup",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeInstancePatches": [
            {
                "action": "ssm:DescribeInstancePatches",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeInventoryDeletions": [
            {
                "action": "ssm:DescribeInventoryDeletions",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeMaintenanceWindowExecutionTaskInvocations": [
            {
                "action": "ssm:DescribeMaintenanceWindowExecutionTaskInvocations",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeMaintenanceWindowExecutionTasks": [
            {
                "action": "ssm:DescribeMaintenanceWindowExecutionTasks",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeMaintenanceWindowExecutions": [
            {
                "action": "ssm:DescribeMaintenanceWindowExecutions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.DescribeMaintenanceWindowSchedule": [
            {
                "action": "ssm:DescribeMaintenanceWindowSchedule",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeMaintenanceWindowTargets": [
            {
                "action": "ssm:DescribeMaintenanceWindowTargets",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.DescribeMaintenanceWindowTasks": [
            {
                "action": "ssm:DescribeMaintenanceWindowTasks",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.DescribeMaintenanceWindows": [
            {
                "action": "ssm:DescribeMaintenanceWindows",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeMaintenanceWindowsForTarget": [
            {
                "action": "ssm:DescribeMaintenanceWindowsForTarget",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeOpsItems": [
            {
                "action": "ssm:DescribeOpsItems",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeParameters": [
            {
                "action": "ssm:DescribeParameters",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribePatchBaselines": [
            {
                "action": "ssm:DescribePatchBaselines",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribePatchGroupState": [
            {
                "action": "ssm:DescribePatchGroupState",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribePatchGroups": [
            {
                "action": "ssm:DescribePatchGroups",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribePatchProperties": [
            {
                "action": "ssm:DescribePatchProperties",
                "resource_mappings": {}
            }
        ],
        "SSM.DescribeSessions": [
            {
                "action": "ssm:DescribeSessions",
                "resource_mappings": {}
            }
        ],
        "SSM.GetAutomationExecution": [
            {
                "action": "ssm:GetAutomationExecution",
                "resource_mappings": {}
            }
        ],
        "SSM.GetCalendarState": [
            {
                "action": "ssm:GetCalendarState",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSM.GetCommandInvocation": [
            {
                "action": "ssm:GetCommandInvocation",
                "resource_mappings": {}
            }
        ],
        "SSM.GetConnectionStatus": [
            {
                "action": "ssm:GetConnectionStatus",
                "resource_mappings": {}
            }
        ],
        "SSM.GetDefaultPatchBaseline": [
            {
                "action": "ssm:GetDefaultPatchBaseline",
                "resource_mappings": {
                    "PatchBaselineIdResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSM.GetDeployablePatchSnapshotForInstance": [
            {
                "action": "ssm:GetDeployablePatchSnapshotForInstance",
                "resource_mappings": {}
            }
        ],
        "SSM.GetDocument": [
            {
                "action": "ssm:GetDocument",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.GetInventorySchema": [
            {
                "action": "ssm:GetInventory",
                "resource_mappings": {}
            },
            {
                "action": "ssm:GetInventorySchema",
                "resource_mappings": {}
            }
        ],
        "SSM.GetMaintenanceWindow": [
            {
                "action": "ssm:GetMaintenanceWindow",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.GetMaintenanceWindowExecution": [
            {
                "action": "ssm:GetMaintenanceWindowExecution",
                "resource_mappings": {}
            }
        ],
        "SSM.GetMaintenanceWindowExecutionTask": [
            {
                "action": "ssm:GetMaintenanceWindowExecutionTask",
                "resource_mappings": {}
            }
        ],
        "SSM.GetMaintenanceWindowExecutionTaskInvocation": [
            {
                "action": "ssm:GetMaintenanceWindowExecutionTaskInvocation",
                "resource_mappings": {}
            }
        ],
        "SSM.GetMaintenanceWindowTask": [
            {
                "action": "ssm:GetMaintenanceWindowTask",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.GetOpsItem": [
            {
                "action": "ssm:GetOpsItem",
                "resource_mappings": {}
            }
        ],
        "SSM.GetOpsMetadata": [
            {
                "action": "ssm:GetOpsMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "opsmetadata": "${OpsMetadataArn}"
                }
            }
        ],
        "SSM.GetParameter": [
            {
                "action": "ssm:GetParameter",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.GetParameterHistory": [
            {
                "action": "ssm:GetParameterHistory",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.GetParameters": [
            {
                "action": "ssm:GetParameters",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "${Names[]}"
                    }
                }
            }
        ],
        "SSM.GetParametersByPath": [
            {
                "action": "ssm:GetParametersByPath",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "%%regex%${Path}%/^\\/(.+)$/g%%*"
                    }
                }
            }
        ],
        "SSM.GetPatchBaseline": [
            {
                "action": "ssm:GetPatchBaseline",
                "resource_mappings": {
                    "PatchBaselineIdResourceId": {
                        "template": "${BaselineId}"
                    }
                }
            }
        ],
        "SSM.GetPatchBaselineForPatchGroup": [
            {
                "action": "ssm:GetPatchBaselineForPatchGroup",
                "resource_mappings": {
                    "PatchBaselineIdResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSM.GetServiceSetting": [
            {
                "action": "ssm:GetServiceSetting",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SettingId}"
                    }
                }
            }
        ],
        "SSM.LabelParameterVersion": [
            {
                "action": "ssm:LabelParameterVersion",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.ListAssociationVersions": [
            {
                "action": "ssm:ListAssociationVersions",
                "resource_mappings": {}
            }
        ],
        "SSM.ListAssociations": [
            {
                "action": "ssm:ListAssociations",
                "resource_mappings": {}
            }
        ],
        "SSM.ListCommandInvocations": [
            {
                "action": "ssm:ListCommandInvocations",
                "resource_mappings": {}
            }
        ],
        "SSM.ListCommands": [
            {
                "action": "ssm:ListCommands",
                "resource_mappings": {}
            }
        ],
        "SSM.ListComplianceItems": [
            {
                "action": "ssm:ListComplianceItems",
                "resource_mappings": {}
            }
        ],
        "SSM.ListComplianceSummaries": [
            {
                "action": "ssm:ListComplianceSummaries",
                "resource_mappings": {}
            }
        ],
        "SSM.ListDocumentMetadataHistory": [
            {
                "action": "ssm:ListDocumentMetadataHistory",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.ListDocumentVersions": [
            {
                "action": "ssm:ListDocumentVersions",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.ListDocuments": [
            {
                "action": "ssm:ListDocuments",
                "resource_mappings": {}
            }
        ],
        "SSM.ListInventoryEntries": [
            {
                "action": "ssm:ListInventoryEntries",
                "resource_mappings": {}
            }
        ],
        "SSM.ListOpsItemEvents": [
            {
                "action": "ssm:ListOpsItemEvents",
                "resource_mappings": {}
            }
        ],
        "SSM.ListOpsMetadata": [
            {
                "action": "ssm:ListOpsMetadata",
                "resource_mappings": {}
            }
        ],
        "SSM.ListResourceComplianceSummaries": [
            {
                "action": "ssm:ListResourceComplianceSummaries",
                "resource_mappings": {}
            }
        ],
        "SSM.ListResourceDataSync": [
            {
                "action": "ssm:ListResourceDataSync",
                "resource_mappings": {}
            }
        ],
        "SSM.ListTagsForResource": [
            {
                "action": "ssm:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${ResourceId}%%",
                    "maintenancewindow": "%%iftemplatematch%${ResourceId}%%",
                    "managed-instance": "%%iftemplatematch%${ResourceId}%%",
                    "parameter": "%%iftemplatematch%${ResourceId}%%",
                    "patchbaseline": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "SSM.ModifyDocumentPermission": [
            {
                "action": "ssm:ModifyDocumentPermission",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.PutComplianceItems": [
            {
                "action": "ssm:PutComplianceItems",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSM.PutInventory": [
            {
                "action": "ssm:PutInventory",
                "resource_mappings": {}
            }
        ],
        "SSM.PutParameter": [
            {
                "action": "ssm:PutParameter",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.RegisterDefaultPatchBaseline": [
            {
                "action": "ssm:RegisterDefaultPatchBaseline",
                "resource_mappings": {
                    "PatchBaselineIdResourceId": {
                        "template": "${BaselineId}"
                    }
                }
            }
        ],
        "SSM.RegisterPatchBaselineForPatchGroup": [
            {
                "action": "ssm:RegisterPatchBaselineForPatchGroup",
                "resource_mappings": {
                    "PatchBaselineIdResourceId": {
                        "template": "${BaselineId}"
                    }
                }
            }
        ],
        "SSM.RegisterTargetWithMaintenanceWindow": [
            {
                "action": "ssm:RegisterTargetWithMaintenanceWindow",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.RegisterTaskWithMaintenanceWindow": [
            {
                "action": "ssm:RegisterTaskWithMaintenanceWindow",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${ServiceRoleArn}%${TaskInvocationParameters.RunCommand.ServiceRoleArn}%%"
                }
            }
        ],
        "SSM.RemoveTagsFromResource": [
            {
                "action": "ssm:RemoveTagsFromResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${ResourceId}%%",
                    "maintenancewindow": "%%iftemplatematch%${ResourceId}%%",
                    "managed-instance": "%%iftemplatematch%${ResourceId}%%",
                    "parameter": "%%iftemplatematch%${ResourceId}%%",
                    "patchbaseline": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "SSM.ResetServiceSetting": [
            {
                "action": "ssm:ResetServiceSetting",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SettingId}"
                    }
                }
            }
        ],
        "SSM.ResumeSession": [
            {
                "action": "ssm:ResumeSession",
                "resource_mappings": {
                    "SessionId": {
                        "template": "${SessionId}"
                    }
                }
            }
        ],
        "SSM.SendAutomationSignal": [
            {
                "action": "ssm:SendAutomationSignal",
                "resource_mappings": {}
            }
        ],
        "SSM.SendCommand": [
            {
                "action": "ssm:SendCommand",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${OutputS3BucketName}"
                    },
                    "InstanceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${DocumentName}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ServiceRoleArn}"
                }
            }
        ],
        "SSM.StartAssociationsOnce": [
            {
                "action": "ssm:StartAssociationsOnce",
                "resource_mappings": {
                    "AssociationId": {
                        "template": "${AssociationIds[]}"
                    }
                }
            }
        ],
        "SSM.StartSession": [
            {
                "action": "ssm:StartSession",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${DocumentName}"
                    },
                    "TaskId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "instance": "${Target}"
                }
            }
        ],
        "SSM.StopAutomationExecution": [
            {
                "action": "ssm:StopAutomationExecution",
                "resource_mappings": {}
            }
        ],
        "SSM.TerminateSession": [
            {
                "action": "ssm:TerminateSession",
                "resource_mappings": {
                    "SessionId": {
                        "template": "${SessionId}"
                    }
                }
            }
        ],
        "SSM.UpdateAssociation": [
            {
                "action": "ssm:UpdateAssociation",
                "resource_mappings": {
                    "AssociationId": {
                        "template": "${AssociationId}"
                    },
                    "InstanceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${Name}%%"
                }
            }
        ],
        "SSM.UpdateAssociationStatus": [
            {
                "action": "ssm:UpdateAssociationStatus",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "document": "%%iftemplatematch%${Name}%%"
                }
            }
        ],
        "SSM.UpdateDocument": [
            {
                "action": "ssm:UpdateDocument",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.UpdateDocumentDefaultVersion": [
            {
                "action": "ssm:UpdateDocumentDefaultVersion",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.UpdateDocumentMetadata": [
            {
                "action": "ssm:UpdateDocumentMetadata",
                "resource_mappings": {
                    "DocumentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SSM.UpdateMaintenanceWindow": [
            {
                "action": "ssm:UpdateMaintenanceWindow",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.UpdateMaintenanceWindowTarget": [
            {
                "action": "ssm:UpdateMaintenanceWindowTarget",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            }
        ],
        "SSM.UpdateMaintenanceWindowTask": [
            {
                "action": "ssm:UpdateMaintenanceWindowTask",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WindowId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${ServiceRoleArn}%${TaskInvocationParameters.RunCommand.ServiceRoleArn}%%"
                }
            }
        ],
        "SSM.UpdateManagedInstanceRole": [
            {
                "action": "ssm:UpdateManagedInstanceRole",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRole}"
                }
            }
        ],
        "SSM.UpdateOpsItem": [
            {
                "action": "ssm:UpdateOpsItem",
                "resource_mappings": {}
            }
        ],
        "SSM.UpdateOpsMetadata": [
            {
                "action": "ssm:UpdateOpsMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "opsmetadata": "${OpsMetadataArn}"
                }
            }
        ],
        "SSM.UpdatePatchBaseline": [
            {
                "action": "ssm:UpdatePatchBaseline",
                "resource_mappings": {
                    "PatchBaselineIdResourceId": {
                        "template": "${BaselineId}"
                    }
                }
            }
        ],
        "SSM.UpdateResourceDataSync": [
            {
                "action": "ssm:UpdateResourceDataSync",
                "resource_mappings": {
                    "SyncName": {
                        "template": "${SyncName}"
                    }
                }
            }
        ],
        "SSM.UpdateServiceSetting": [
            {
                "action": "ssm:UpdateServiceSetting",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SettingId}"
                    }
                }
            }
        ],
        "StorageGateway.ActivateGateway": [
            {
                "action": "storagegateway:ActivateGateway",
                "resource_mappings": {}
            }
        ],
        "StorageGateway.AddCache": [
            {
                "action": "storagegateway:AddCache",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.AddTagsToResource": [
            {
                "action": "storagegateway:AddTagsToResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "%%iftemplatematch%${ResourceARN}%%",
                    "share": "%%iftemplatematch%${ResourceARN}%%",
                    "tape": "%%iftemplatematch%${ResourceARN}%%",
                    "volume": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "StorageGateway.AddUploadBuffer": [
            {
                "action": "storagegateway:AddUploadBuffer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.AddWorkingStorage": [
            {
                "action": "storagegateway:AddWorkingStorage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.AssignTapePool": [
            {
                "action": "storagegateway:AssignTapePool",
                "resource_mappings": {
                    "PoolId": {
                        "template": "${PoolId}"
                    }
                },
                "resourcearn_mappings": {
                    "tape": "${TapeARN}"
                }
            }
        ],
        "StorageGateway.AttachVolume": [
            {
                "action": "storagegateway:AttachVolume",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}",
                    "volume": "${VolumeARN}"
                }
            }
        ],
        "StorageGateway.CancelArchival": [
            {
                "action": "storagegateway:CancelArchival",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}",
                    "tape": "${TapeARN}"
                }
            }
        ],
        "StorageGateway.CancelRetrieval": [
            {
                "action": "storagegateway:CancelRetrieval",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}",
                    "tape": "${TapeARN}"
                }
            }
        ],
        "StorageGateway.CreateCachediSCSIVolume": [
            {
                "action": "storagegateway:CreateCachediSCSIVolume",
                "resource_mappings": {
                    "GatewayId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.CreateNFSFileShare": [
            {
                "action": "storagegateway:CreateNFSFileShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "StorageGateway.CreateSMBFileShare": [
            {
                "action": "storagegateway:CreateSMBFileShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "StorageGateway.CreateSnapshot": [
            {
                "action": "storagegateway:CreateSnapshot",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARN}"
                }
            }
        ],
        "StorageGateway.CreateSnapshotFromVolumeRecoveryPoint": [
            {
                "action": "storagegateway:CreateSnapshotFromVolumeRecoveryPoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARN}"
                }
            }
        ],
        "StorageGateway.CreateStorediSCSIVolume": [
            {
                "action": "storagegateway:CreateStorediSCSIVolume",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.CreateTapePool": [
            {
                "action": "storagegateway:CreateTapePool",
                "resource_mappings": {}
            }
        ],
        "StorageGateway.CreateTapeWithBarcode": [
            {
                "action": "storagegateway:CreateTapeWithBarcode",
                "resource_mappings": {
                    "PoolId": {
                        "template": "${PoolId}"
                    }
                },
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.CreateTapes": [
            {
                "action": "storagegateway:CreateTapes",
                "resource_mappings": {
                    "PoolId": {
                        "template": "${PoolId}"
                    }
                },
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DeleteAutomaticTapeCreationPolicy": [
            {
                "action": "storagegateway:DeleteAutomaticTapeCreationPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DeleteBandwidthRateLimit": [
            {
                "action": "storagegateway:DeleteBandwidthRateLimit",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DeleteChapCredentials": [
            {
                "action": "storagegateway:DeleteChapCredentials",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "target": "${TargetARN}"
                }
            }
        ],
        "StorageGateway.DeleteFileShare": [
            {
                "action": "storagegateway:DeleteFileShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "share": "${FileShareARN}"
                }
            }
        ],
        "StorageGateway.DeleteGateway": [
            {
                "action": "storagegateway:DeleteGateway",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DeleteSnapshotSchedule": [
            {
                "action": "storagegateway:DeleteSnapshotSchedule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARN}"
                }
            }
        ],
        "StorageGateway.DeleteTape": [
            {
                "action": "storagegateway:DeleteTape",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}",
                    "tape": "${TapeARN}"
                }
            }
        ],
        "StorageGateway.DeleteTapeArchive": [
            {
                "action": "storagegateway:DeleteTapeArchive",
                "resource_mappings": {}
            }
        ],
        "StorageGateway.DeleteTapePool": [
            {
                "action": "storagegateway:DeleteTapePool",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "tapepool": "${PoolARN}"
                }
            }
        ],
        "StorageGateway.DeleteVolume": [
            {
                "action": "storagegateway:DeleteVolume",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARN}"
                }
            }
        ],
        "StorageGateway.DescribeAvailabilityMonitorTest": [
            {
                "action": "storagegateway:DescribeAvailabilityMonitorTest",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeBandwidthRateLimit": [
            {
                "action": "storagegateway:DescribeBandwidthRateLimit",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeBandwidthRateLimitSchedule": [
            {
                "action": "storagegateway:DescribeBandwidthRateLimitSchedule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeCache": [
            {
                "action": "storagegateway:DescribeCache",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeCachediSCSIVolumes": [
            {
                "action": "storagegateway:DescribeCachediSCSIVolumes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARNs}"
                }
            }
        ],
        "StorageGateway.DescribeChapCredentials": [
            {
                "action": "storagegateway:DescribeChapCredentials",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "target": "${TargetARN}"
                }
            }
        ],
        "StorageGateway.DescribeGatewayInformation": [
            {
                "action": "storagegateway:DescribeGatewayInformation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeMaintenanceStartTime": [
            {
                "action": "storagegateway:DescribeMaintenanceStartTime",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeNFSFileShares": [
            {
                "action": "storagegateway:DescribeNFSFileShares",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "share": "${FileShareARNList[]}"
                }
            }
        ],
        "StorageGateway.DescribeSMBFileShares": [
            {
                "action": "storagegateway:DescribeSMBFileShares",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "share": "${FileShareARNList[]}"
                }
            }
        ],
        "StorageGateway.DescribeSMBSettings": [
            {
                "action": "storagegateway:DescribeSMBSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeSnapshotSchedule": [
            {
                "action": "storagegateway:DescribeSnapshotSchedule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARN}"
                }
            }
        ],
        "StorageGateway.DescribeStorediSCSIVolumes": [
            {
                "action": "storagegateway:DescribeStorediSCSIVolumes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARNs[]}"
                }
            }
        ],
        "StorageGateway.DescribeTapeArchives": [
            {
                "action": "storagegateway:DescribeTapeArchives",
                "resource_mappings": {}
            }
        ],
        "StorageGateway.DescribeTapeRecoveryPoints": [
            {
                "action": "storagegateway:DescribeTapeRecoveryPoints",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeTapes": [
            {
                "action": "storagegateway:DescribeTapes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeUploadBuffer": [
            {
                "action": "storagegateway:DescribeUploadBuffer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeVTLDevices": [
            {
                "action": "storagegateway:DescribeVTLDevices",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeWorkingStorage": [
            {
                "action": "storagegateway:DescribeWorkingStorage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DetachVolume": [
            {
                "action": "storagegateway:DetachVolume",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARN}"
                }
            }
        ],
        "StorageGateway.DisableGateway": [
            {
                "action": "storagegateway:DisableGateway",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.JoinDomain": [
            {
                "action": "storagegateway:JoinDomain",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.ListAutomaticTapeCreationPolicies": [
            {
                "action": "storagegateway:ListAutomaticTapeCreationPolicies",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.ListFileShares": [
            {
                "action": "storagegateway:ListFileShares",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.ListGateways": [
            {
                "action": "storagegateway:ListGateways",
                "resource_mappings": {}
            }
        ],
        "StorageGateway.ListLocalDisks": [
            {
                "action": "storagegateway:ListLocalDisks",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.ListTagsForResource": [
            {
                "action": "storagegateway:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "%%iftemplatematch%${ResourceARN}%%",
                    "share": "%%iftemplatematch%${ResourceARN}%%",
                    "tape": "%%iftemplatematch%${ResourceARN}%%",
                    "volume": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "StorageGateway.ListTapePools": [
            {
                "action": "storagegateway:ListTapePools",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "tapepool": "${PoolARNs[]}"
                }
            }
        ],
        "StorageGateway.ListTapes": [
            {
                "action": "storagegateway:ListTapes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "tape": "${TapeARNs[]}"
                }
            }
        ],
        "StorageGateway.ListVolumeInitiators": [
            {
                "action": "storagegateway:ListVolumeInitiators",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARN}"
                }
            }
        ],
        "StorageGateway.ListVolumeRecoveryPoints": [
            {
                "action": "storagegateway:ListVolumeRecoveryPoints",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.ListVolumes": [
            {
                "action": "storagegateway:ListVolumes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.NotifyWhenUploaded": [
            {
                "action": "storagegateway:NotifyWhenUploaded",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "share": "${FileShareARN}"
                }
            }
        ],
        "StorageGateway.RefreshCache": [
            {
                "action": "storagegateway:RefreshCache",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "share": "${FileShareARN}"
                }
            }
        ],
        "StorageGateway.RemoveTagsFromResource": [
            {
                "action": "storagegateway:RemoveTagsFromResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "%%iftemplatematch%${ResourceARN}%%",
                    "share": "%%iftemplatematch%${ResourceARN}%%",
                    "tape": "%%iftemplatematch%${ResourceARN}%%",
                    "volume": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "StorageGateway.ResetCache": [
            {
                "action": "storagegateway:ResetCache",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.RetrieveTapeArchive": [
            {
                "action": "storagegateway:RetrieveTapeArchive",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}",
                    "tape": "${TapeARN}"
                }
            }
        ],
        "StorageGateway.RetrieveTapeRecoveryPoint": [
            {
                "action": "storagegateway:RetrieveTapeRecoveryPoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}",
                    "tape": "${TapeARN}"
                }
            }
        ],
        "StorageGateway.SetLocalConsolePassword": [
            {
                "action": "storagegateway:SetLocalConsolePassword",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.SetSMBGuestPassword": [
            {
                "action": "storagegateway:SetSMBGuestPassword",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.ShutdownGateway": [
            {
                "action": "storagegateway:ShutdownGateway",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.StartAvailabilityMonitorTest": [
            {
                "action": "storagegateway:StartAvailabilityMonitorTest",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.StartGateway": [
            {
                "action": "storagegateway:StartGateway",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateAutomaticTapeCreationPolicy": [
            {
                "action": "storagegateway:UpdateAutomaticTapeCreationPolicy",
                "resource_mappings": {
                    "PoolId": {
                        "template": "${AutomaticTapeCreationRules[].PoolId}"
                    }
                },
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateBandwidthRateLimit": [
            {
                "action": "storagegateway:UpdateBandwidthRateLimit",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateBandwidthRateLimitSchedule": [
            {
                "action": "storagegateway:UpdateBandwidthRateLimitSchedule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateChapCredentials": [
            {
                "action": "storagegateway:UpdateChapCredentials",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "target": "${TargetARN}"
                }
            }
        ],
        "StorageGateway.UpdateGatewayInformation": [
            {
                "action": "storagegateway:UpdateGatewayInformation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateGatewaySoftwareNow": [
            {
                "action": "storagegateway:UpdateGatewaySoftwareNow",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateMaintenanceStartTime": [
            {
                "action": "storagegateway:UpdateMaintenanceStartTime",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateNFSFileShare": [
            {
                "action": "storagegateway:UpdateNFSFileShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "share": "${FileShareARN}"
                }
            }
        ],
        "StorageGateway.UpdateSMBFileShare": [
            {
                "action": "storagegateway:UpdateSMBFileShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "share": "${FileShareARN}"
                }
            }
        ],
        "StorageGateway.UpdateSMBFileShareVisibility": [
            {
                "action": "storagegateway:UpdateSMBFileShareVisibility",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateSMBSecurityStrategy": [
            {
                "action": "storagegateway:UpdateSMBSecurityStrategy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateSnapshotSchedule": [
            {
                "action": "storagegateway:UpdateSnapshotSchedule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "volume": "${VolumeARN}"
                }
            }
        ],
        "StorageGateway.UpdateVTLDeviceType": [
            {
                "action": "storagegateway:UpdateVTLDeviceType",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${VTLDeviceARN}"
                }
            }
        ],
        "StepFunctions.CreateActivity": [
            {
                "action": "states:CreateActivity",
                "resource_mappings": {
                    "ActivityName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "StepFunctions.CreateStateMachine": [
            {
                "action": "states:CreateStateMachine",
                "resource_mappings": {
                    "StateMachineName": {
                        "template": "${name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "StepFunctions.DeleteActivity": [
            {
                "action": "states:DeleteActivity",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "activity": "${activityArn}"
                }
            }
        ],
        "StepFunctions.DeleteStateMachine": [
            {
                "action": "states:DeleteStateMachine",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "statemachine": "${stateMachineArn}"
                }
            }
        ],
        "StepFunctions.DescribeActivity": [
            {
                "action": "states:DescribeActivity",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "activity": "${activityArn}"
                }
            }
        ],
        "StepFunctions.DescribeExecution": [
            {
                "action": "states:DescribeExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "execution": "${executionArn}"
                }
            }
        ],
        "StepFunctions.DescribeStateMachine": [
            {
                "action": "states:DescribeStateMachine",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "statemachine": "${stateMachineArn}"
                }
            }
        ],
        "StepFunctions.DescribeStateMachineForExecution": [
            {
                "action": "states:DescribeStateMachineForExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "execution": "${executionArn}"
                }
            }
        ],
        "StepFunctions.GetActivityTask": [
            {
                "action": "states:GetActivityTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "activity": "${activityArn}"
                }
            }
        ],
        "StepFunctions.GetExecutionHistory": [
            {
                "action": "states:GetExecutionHistory",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "execution": "${executionArn}"
                }
            }
        ],
        "StepFunctions.ListActivities": [
            {
                "action": "states:ListActivities",
                "resource_mappings": {}
            }
        ],
        "StepFunctions.ListExecutions": [
            {
                "action": "states:ListExecutions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "statemachine": "${stateMachineArn}"
                }
            }
        ],
        "StepFunctions.ListStateMachines": [
            {
                "action": "states:ListStateMachines",
                "resource_mappings": {}
            }
        ],
        "StepFunctions.ListTagsForResource": [
            {
                "action": "states:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "activity": "%%iftemplatematch%${resourceArn}%%",
                    "statemachine": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "StepFunctions.SendTaskFailure": [
            {
                "action": "states:SendTaskFailure",
                "resource_mappings": {}
            }
        ],
        "StepFunctions.SendTaskHeartbeat": [
            {
                "action": "states:SendTaskHeartbeat",
                "resource_mappings": {}
            }
        ],
        "StepFunctions.SendTaskSuccess": [
            {
                "action": "states:SendTaskSuccess",
                "resource_mappings": {}
            }
        ],
        "StepFunctions.StartExecution": [
            {
                "action": "states:StartExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "statemachine": "${stateMachineArn}"
                }
            }
        ],
        "StepFunctions.StartSyncExecution": [
            {
                "action": "states:StartSyncExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "statemachine": "${stateMachineArn}"
                }
            }
        ],
        "StepFunctions.StopExecution": [
            {
                "action": "states:StopExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "execution": "${executionArn}"
                }
            }
        ],
        "StepFunctions.TagResource": [
            {
                "action": "states:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "activity": "%%iftemplatematch%${resourceArn}%%",
                    "statemachine": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "StepFunctions.UntagResource": [
            {
                "action": "states:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "activity": "%%iftemplatematch%${resourceArn}%%",
                    "statemachine": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "StepFunctions.UpdateStateMachine": [
            {
                "action": "states:UpdateStateMachine",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "statemachine": "${stateMachineArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Support.AddAttachmentsToSet": [
            {
                "action": "support:AddAttachmentsToSet",
                "resource_mappings": {}
            }
        ],
        "Support.AddCommunicationToCase": [
            {
                "action": "support:AddCommunicationToCase",
                "resource_mappings": {}
            }
        ],
        "Support.CreateCase": [
            {
                "action": "support:CreateCase",
                "resource_mappings": {}
            }
        ],
        "Support.DescribeAttachment": [
            {
                "action": "support:DescribeAttachment",
                "resource_mappings": {}
            }
        ],
        "Support.DescribeCases": [
            {
                "action": "support:DescribeCases",
                "resource_mappings": {}
            }
        ],
        "Support.DescribeCommunications": [
            {
                "action": "support:DescribeCommunications",
                "resource_mappings": {}
            }
        ],
        "Support.DescribeServices": [
            {
                "action": "support:DescribeServices",
                "resource_mappings": {}
            }
        ],
        "Support.DescribeSeverityLevels": [
            {
                "action": "support:DescribeSeverityLevels",
                "resource_mappings": {}
            }
        ],
        "Support.DescribeTrustedAdvisorCheckRefreshStatuses": [
            {
                "action": "support:DescribeTrustedAdvisorCheckRefreshStatuses",
                "resource_mappings": {}
            }
        ],
        "Support.DescribeTrustedAdvisorCheckResult": [
            {
                "action": "support:DescribeTrustedAdvisorCheckResult",
                "resource_mappings": {}
            }
        ],
        "Support.DescribeTrustedAdvisorCheckSummaries": [
            {
                "action": "support:DescribeTrustedAdvisorCheckSummaries",
                "resource_mappings": {}
            }
        ],
        "Support.DescribeTrustedAdvisorChecks": [
            {
                "action": "support:DescribeTrustedAdvisorChecks",
                "resource_mappings": {}
            }
        ],
        "Support.RefreshTrustedAdvisorCheck": [
            {
                "action": "support:RefreshTrustedAdvisorCheck",
                "resource_mappings": {}
            }
        ],
        "Support.ResolveCase": [
            {
                "action": "support:ResolveCase",
                "resource_mappings": {}
            }
        ],
        "SWF.CountClosedWorkflowExecutions": [
            {
                "action": "swf:CountClosedWorkflowExecutions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.CountOpenWorkflowExecutions": [
            {
                "action": "swf:CountOpenWorkflowExecutions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.CountPendingActivityTasks": [
            {
                "action": "swf:CountPendingActivityTasks",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.CountPendingDecisionTasks": [
            {
                "action": "swf:CountPendingDecisionTasks",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.DeprecateActivityType": [
            {
                "action": "swf:DeprecateActivityType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.DeprecateDomain": [
            {
                "action": "swf:DeprecateDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "SWF.DeprecateWorkflowType": [
            {
                "action": "swf:DeprecateWorkflowType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.DescribeActivityType": [
            {
                "action": "swf:DescribeActivityType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.DescribeDomain": [
            {
                "action": "swf:DescribeDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "SWF.DescribeWorkflowExecution": [
            {
                "action": "swf:DescribeWorkflowExecution",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.DescribeWorkflowType": [
            {
                "action": "swf:DescribeWorkflowType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.GetWorkflowExecutionHistory": [
            {
                "action": "swf:GetWorkflowExecutionHistory",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.ListActivityTypes": [
            {
                "action": "swf:ListActivityTypes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.ListClosedWorkflowExecutions": [
            {
                "action": "swf:ListClosedWorkflowExecutions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.ListDomains": [
            {
                "action": "swf:ListDomains",
                "resource_mappings": {}
            }
        ],
        "SWF.ListOpenWorkflowExecutions": [
            {
                "action": "swf:ListOpenWorkflowExecutions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.ListTagsForResource": [
            {
                "action": "swf:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "SWF.ListWorkflowTypes": [
            {
                "action": "swf:ListWorkflowTypes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.PollForActivityTask": [
            {
                "action": "swf:PollForActivityTask",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.PollForDecisionTask": [
            {
                "action": "swf:PollForDecisionTask",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.RecordActivityTaskHeartbeat": [
            {
                "action": "swf:RecordActivityTaskHeartbeat",
                "resource_mappings": {
                    "DomainName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SWF.RegisterActivityType": [
            {
                "action": "swf:RegisterActivityType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.RegisterDomain": [
            {
                "action": "swf:RegisterDomain",
                "resource_mappings": {}
            }
        ],
        "SWF.RegisterWorkflowType": [
            {
                "action": "swf:RegisterWorkflowType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${defaultLambdaRole}"
                }
            }
        ],
        "SWF.RequestCancelWorkflowExecution": [
            {
                "action": "swf:RequestCancelWorkflowExecution",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.RespondActivityTaskCanceled": [
            {
                "action": "swf:RespondActivityTaskCanceled",
                "resource_mappings": {
                    "DomainName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SWF.RespondActivityTaskCompleted": [
            {
                "action": "swf:RespondActivityTaskCompleted",
                "resource_mappings": {
                    "DomainName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SWF.RespondActivityTaskFailed": [
            {
                "action": "swf:RespondActivityTaskFailed",
                "resource_mappings": {
                    "DomainName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SWF.RespondDecisionTaskCompleted": [
            {
                "action": "swf:RespondDecisionTaskCompleted",
                "resource_mappings": {
                    "DomainName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SWF.SignalWorkflowExecution": [
            {
                "action": "swf:SignalWorkflowExecution",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.StartWorkflowExecution": [
            {
                "action": "swf:StartWorkflowExecution",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${lambdaRole}"
                }
            }
        ],
        "SWF.TagResource": [
            {
                "action": "swf:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "SWF.TerminateWorkflowExecution": [
            {
                "action": "swf:TerminateWorkflowExecution",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.UntagResource": [
            {
                "action": "swf:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "XRay.BatchGetTraces": [
            {
                "action": "xray:BatchGetTraces",
                "resource_mappings": {}
            }
        ],
        "XRay.CreateGroup": [
            {
                "action": "xray:CreateGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "${GroupName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "XRay.CreateSamplingRule": [
            {
                "action": "xray:CreateSamplingRule",
                "resource_mappings": {
                    "SamplingRuleName": {
                        "template": "${SamplingRule.RuleName}"
                    }
                }
            }
        ],
        "XRay.DeleteGroup": [
            {
                "action": "xray:DeleteGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "${GroupName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "XRay.DeleteSamplingRule": [
            {
                "action": "xray:DeleteSamplingRule",
                "resource_mappings": {
                    "SamplingRuleName": {
                        "template": "${RuleName}"
                    }
                }
            }
        ],
        "XRay.GetEncryptionConfig": [
            {
                "action": "xray:GetEncryptionConfig",
                "resource_mappings": {}
            }
        ],
        "XRay.GetGroup": [
            {
                "action": "xray:GetGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "${GroupName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "XRay.GetGroups": [
            {
                "action": "xray:GetGroups",
                "resource_mappings": {}
            }
        ],
        "XRay.GetInsight": [
            {
                "action": "xray:GetInsight",
                "resource_mappings": {}
            }
        ],
        "XRay.GetInsightEvents": [
            {
                "action": "xray:GetInsightEvents",
                "resource_mappings": {}
            }
        ],
        "XRay.GetInsightImpactGraph": [
            {
                "action": "xray:GetInsightImpactGraph",
                "resource_mappings": {}
            }
        ],
        "XRay.GetInsightSummaries": [
            {
                "action": "xray:GetInsightSummaries",
                "resource_mappings": {}
            }
        ],
        "XRay.GetSamplingRules": [
            {
                "action": "xray:GetSamplingRules",
                "resource_mappings": {}
            }
        ],
        "XRay.GetSamplingStatisticSummaries": [
            {
                "action": "xray:GetSamplingStatisticSummaries",
                "resource_mappings": {}
            }
        ],
        "XRay.GetSamplingTargets": [
            {
                "action": "xray:GetSamplingTargets",
                "resource_mappings": {}
            }
        ],
        "XRay.GetServiceGraph": [
            {
                "action": "xray:GetServiceGraph",
                "resource_mappings": {}
            }
        ],
        "XRay.GetTimeSeriesServiceStatistics": [
            {
                "action": "xray:GetTimeSeriesServiceStatistics",
                "resource_mappings": {}
            }
        ],
        "XRay.GetTraceGraph": [
            {
                "action": "xray:GetTraceGraph",
                "resource_mappings": {}
            }
        ],
        "XRay.GetTraceSummaries": [
            {
                "action": "xray:GetTraceSummaries",
                "resource_mappings": {}
            }
        ],
        "XRay.ListTagsForResource": [
            {
                "action": "xray:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "%%iftemplatematch%${ResourceARN}%%",
                    "sampling-rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "XRay.PutEncryptionConfig": [
            {
                "action": "xray:PutEncryptionConfig",
                "resource_mappings": {}
            }
        ],
        "XRay.PutTelemetryRecords": [
            {
                "action": "xray:PutTelemetryRecords",
                "resource_mappings": {}
            }
        ],
        "XRay.PutTraceSegments": [
            {
                "action": "xray:PutTraceSegments",
                "resource_mappings": {}
            }
        ],
        "XRay.TagResource": [
            {
                "action": "xray:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "%%iftemplatematch%${ResourceARN}%%",
                    "sampling-rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "XRay.UntagResource": [
            {
                "action": "xray:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "%%iftemplatematch%${ResourceARN}%%",
                    "sampling-rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "XRay.UpdateGroup": [
            {
                "action": "xray:UpdateGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "${GroupName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "XRay.UpdateSamplingRule": [
            {
                "action": "xray:UpdateSamplingRule",
                "resource_mappings": {
                    "SamplingRuleName": {
                        "template": "${SamplingRuleUpdate.RuleName}"
                    }
                }
            }
        ],
        "WAF.CreateByteMatchSet": [
            {
                "action": "waf:CreateByteMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateGeoMatchSet": [
            {
                "action": "waf:CreateGeoMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateIPSet": [
            {
                "action": "waf:CreateIPSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateRateBasedRule": [
            {
                "action": "waf:CreateRateBasedRule",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateRegexMatchSet": [
            {
                "action": "waf:CreateRegexMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateRegexPatternSet": [
            {
                "action": "waf:CreateRegexPatternSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateRule": [
            {
                "action": "waf:CreateRule",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateRuleGroup": [
            {
                "action": "waf:CreateRuleGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateSizeConstraintSet": [
            {
                "action": "waf:CreateSizeConstraintSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateSqlInjectionMatchSet": [
            {
                "action": "waf:CreateSqlInjectionMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateWebACL": [
            {
                "action": "waf:CreateWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateWebACLMigrationStack": [
            {
                "action": "waf:CreateWebACLMigrationStack",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            },
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${S3BucketName}"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.CreateXssMatchSet": [
            {
                "action": "waf:CreateXssMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.DeleteByteMatchSet": [
            {
                "action": "waf:DeleteByteMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${ByteMatchSetId}"
                    }
                }
            }
        ],
        "WAF.DeleteGeoMatchSet": [
            {
                "action": "waf:DeleteGeoMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${GeoMatchSetId}"
                    }
                }
            }
        ],
        "WAF.DeleteIPSet": [
            {
                "action": "waf:DeleteIPSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${IPSetId}"
                    }
                }
            }
        ],
        "WAF.DeleteLoggingConfiguration": [
            {
                "action": "waf:DeleteLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${ResourceArn}"
                }
            }
        ],
        "WAF.DeletePermissionPolicy": [
            {
                "action": "waf:DeletePermissionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rulegroup": "${ResourceArn}"
                }
            }
        ],
        "WAF.DeleteRateBasedRule": [
            {
                "action": "waf:DeleteRateBasedRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAF.DeleteRegexMatchSet": [
            {
                "action": "waf:DeleteRegexMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexMatchSetId}"
                    }
                }
            }
        ],
        "WAF.DeleteRegexPatternSet": [
            {
                "action": "waf:DeleteRegexPatternSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexPatternSetId}"
                    }
                }
            }
        ],
        "WAF.DeleteRule": [
            {
                "action": "waf:DeleteRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAF.DeleteRuleGroup": [
            {
                "action": "waf:DeleteRuleGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleGroupId}"
                    }
                }
            }
        ],
        "WAF.DeleteSizeConstraintSet": [
            {
                "action": "waf:DeleteSizeConstraintSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SizeConstraintSetId}"
                    }
                }
            }
        ],
        "WAF.DeleteSqlInjectionMatchSet": [
            {
                "action": "waf:DeleteSqlInjectionMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SqlInjectionMatchSetId}"
                    }
                }
            }
        ],
        "WAF.DeleteWebACL": [
            {
                "action": "waf:DeleteWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            }
        ],
        "WAF.DeleteXssMatchSet": [
            {
                "action": "waf:DeleteXssMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${XssMatchSetId}"
                    }
                }
            }
        ],
        "WAF.GetByteMatchSet": [
            {
                "action": "waf:GetByteMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${ByteMatchSetId}"
                    }
                }
            }
        ],
        "WAF.GetChangeToken": [
            {
                "action": "waf:GetChangeToken",
                "resource_mappings": {}
            }
        ],
        "WAF.GetChangeTokenStatus": [
            {
                "action": "waf:GetChangeTokenStatus",
                "resource_mappings": {}
            }
        ],
        "WAF.GetGeoMatchSet": [
            {
                "action": "waf:GetGeoMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${GeoMatchSetId}"
                    }
                }
            }
        ],
        "WAF.GetIPSet": [
            {
                "action": "waf:GetIPSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${IPSetId}"
                    }
                }
            }
        ],
        "WAF.GetLoggingConfiguration": [
            {
                "action": "waf:GetLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${ResourceArn}"
                }
            }
        ],
        "WAF.GetPermissionPolicy": [
            {
                "action": "waf:GetPermissionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rulegroup": "${ResourceArn}"
                }
            }
        ],
        "WAF.GetRateBasedRule": [
            {
                "action": "waf:GetRateBasedRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAF.GetRateBasedRuleManagedKeys": [
            {
                "action": "waf:GetRateBasedRuleManagedKeys",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAF.GetRegexMatchSet": [
            {
                "action": "waf:GetRegexMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexMatchSetId}"
                    }
                }
            }
        ],
        "WAF.GetRegexPatternSet": [
            {
                "action": "waf:GetRegexPatternSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexPatternSetId}"
                    }
                }
            }
        ],
        "WAF.GetRule": [
            {
                "action": "waf:GetRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAF.GetRuleGroup": [
            {
                "action": "waf:GetRuleGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleGroupId}"
                    }
                }
            }
        ],
        "WAF.GetSampledRequests": [
            {
                "action": "waf:GetSampledRequests",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebAclId}"
                    }
                }
            }
        ],
        "WAF.GetSizeConstraintSet": [
            {
                "action": "waf:GetSizeConstraintSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SizeConstraintSetId}"
                    }
                }
            }
        ],
        "WAF.GetSqlInjectionMatchSet": [
            {
                "action": "waf:GetSqlInjectionMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SqlInjectionMatchSetId}"
                    }
                }
            }
        ],
        "WAF.GetWebACL": [
            {
                "action": "waf:GetWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            }
        ],
        "WAF.GetXssMatchSet": [
            {
                "action": "waf:GetXssMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${XssMatchSetId}"
                    }
                }
            }
        ],
        "WAF.ListActivatedRulesInRuleGroup": [
            {
                "action": "waf:ListActivatedRulesInRuleGroup",
                "resource_mappings": {}
            }
        ],
        "WAF.ListByteMatchSets": [
            {
                "action": "waf:ListByteMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAF.ListGeoMatchSets": [
            {
                "action": "waf:ListGeoMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAF.ListIPSets": [
            {
                "action": "waf:ListIPSets",
                "resource_mappings": {}
            }
        ],
        "WAF.ListLoggingConfigurations": [
            {
                "action": "waf:ListLoggingConfigurations",
                "resource_mappings": {}
            }
        ],
        "WAF.ListRateBasedRules": [
            {
                "action": "waf:ListRateBasedRules",
                "resource_mappings": {}
            }
        ],
        "WAF.ListRegexMatchSets": [
            {
                "action": "waf:ListRegexMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAF.ListRegexPatternSets": [
            {
                "action": "waf:ListRegexPatternSets",
                "resource_mappings": {}
            }
        ],
        "WAF.ListRuleGroups": [
            {
                "action": "waf:ListRuleGroups",
                "resource_mappings": {}
            }
        ],
        "WAF.ListRules": [
            {
                "action": "waf:ListRules",
                "resource_mappings": {}
            }
        ],
        "WAF.ListSizeConstraintSets": [
            {
                "action": "waf:ListSizeConstraintSets",
                "resource_mappings": {}
            }
        ],
        "WAF.ListSqlInjectionMatchSets": [
            {
                "action": "waf:ListSqlInjectionMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAF.ListSubscribedRuleGroups": [
            {
                "action": "waf:ListSubscribedRuleGroups",
                "resource_mappings": {}
            }
        ],
        "WAF.ListTagsForResource": [
            {
                "action": "waf:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ratebasedrule": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%",
                    "rulegroup": "%%iftemplatematch%${ResourceARN}%%",
                    "webacl": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WAF.ListWebACLs": [
            {
                "action": "waf:ListWebACLs",
                "resource_mappings": {}
            }
        ],
        "WAF.ListXssMatchSets": [
            {
                "action": "waf:ListXssMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAF.PutLoggingConfiguration": [
            {
                "action": "waf:PutLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "%%iftemplatematch%${LoggingConfiguration.ResourceArn}%%"
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAF.PutPermissionPolicy": [
            {
                "action": "waf:PutPermissionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rulegroup": "${ResourceArn}"
                }
            }
        ],
        "WAF.TagResource": [
            {
                "action": "waf:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ratebasedrule": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%",
                    "rulegroup": "%%iftemplatematch%${ResourceARN}%%",
                    "webacl": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WAF.UntagResource": [
            {
                "action": "waf:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ratebasedrule": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%",
                    "rulegroup": "%%iftemplatematch%${ResourceARN}%%",
                    "webacl": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WAF.UpdateByteMatchSet": [
            {
                "action": "waf:UpdateByteMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${ByteMatchSetId}"
                    }
                }
            }
        ],
        "WAF.UpdateGeoMatchSet": [
            {
                "action": "waf:UpdateGeoMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${GeoMatchSetId}"
                    }
                }
            }
        ],
        "WAF.UpdateIPSet": [
            {
                "action": "waf:UpdateIPSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${IPSetId}"
                    }
                }
            }
        ],
        "WAF.UpdateRateBasedRule": [
            {
                "action": "waf:UpdateRateBasedRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAF.UpdateRegexMatchSet": [
            {
                "action": "waf:UpdateRegexMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexMatchSetId}"
                    }
                }
            }
        ],
        "WAF.UpdateRegexPatternSet": [
            {
                "action": "waf:UpdateRegexPatternSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexPatternSetId}"
                    }
                }
            }
        ],
        "WAF.UpdateRule": [
            {
                "action": "waf:UpdateRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAF.UpdateRuleGroup": [
            {
                "action": "waf:UpdateRuleGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleGroupId}"
                    }
                }
            }
        ],
        "WAF.UpdateSizeConstraintSet": [
            {
                "action": "waf:UpdateSizeConstraintSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SizeConstraintSetId}"
                    }
                }
            }
        ],
        "WAF.UpdateSqlInjectionMatchSet": [
            {
                "action": "waf:UpdateSqlInjectionMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SqlInjectionMatchSetId}"
                    }
                }
            }
        ],
        "WAF.UpdateWebACL": [
            {
                "action": "waf:UpdateWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            }
        ],
        "WAF.UpdateXssMatchSet": [
            {
                "action": "waf:UpdateXssMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${XssMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.AssociateWebACL": [
            {
                "action": "waf-regional:AssociateWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                },
                "resourcearn_mappings": {
                    "loadbalancer/app/": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "WAFRegional.CreateByteMatchSet": [
            {
                "action": "waf-regional:CreateByteMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateGeoMatchSet": [
            {
                "action": "waf-regional:CreateGeoMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateIPSet": [
            {
                "action": "waf-regional:CreateIPSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateRateBasedRule": [
            {
                "action": "waf-regional:CreateRateBasedRule",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateRegexMatchSet": [
            {
                "action": "waf-regional:CreateRegexMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateRegexPatternSet": [
            {
                "action": "waf-regional:CreateRegexPatternSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateRule": [
            {
                "action": "waf-regional:CreateRule",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateRuleGroup": [
            {
                "action": "waf-regional:CreateRuleGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateSizeConstraintSet": [
            {
                "action": "waf-regional:CreateSizeConstraintSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateSqlInjectionMatchSet": [
            {
                "action": "waf-regional:CreateSqlInjectionMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateWebACL": [
            {
                "action": "waf-regional:CreateWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateWebACLMigrationStack": [
            {
                "action": "waf-regional:CreateWebACLMigrationStack",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            },
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${S3BucketName}"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.CreateXssMatchSet": [
            {
                "action": "waf-regional:CreateXssMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.DeleteByteMatchSet": [
            {
                "action": "waf-regional:DeleteByteMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${ByteMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteGeoMatchSet": [
            {
                "action": "waf-regional:DeleteGeoMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${GeoMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteIPSet": [
            {
                "action": "waf-regional:DeleteIPSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${IPSetId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteLoggingConfiguration": [
            {
                "action": "waf-regional:DeleteLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${ResourceArn}"
                }
            }
        ],
        "WAFRegional.DeletePermissionPolicy": [
            {
                "action": "waf-regional:DeletePermissionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rulegroup": "${ResourceArn}"
                }
            }
        ],
        "WAFRegional.DeleteRateBasedRule": [
            {
                "action": "waf-regional:DeleteRateBasedRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteRegexMatchSet": [
            {
                "action": "waf-regional:DeleteRegexMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteRegexPatternSet": [
            {
                "action": "waf-regional:DeleteRegexPatternSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexPatternSetId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteRule": [
            {
                "action": "waf-regional:DeleteRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteRuleGroup": [
            {
                "action": "waf-regional:DeleteRuleGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleGroupId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteSizeConstraintSet": [
            {
                "action": "waf-regional:DeleteSizeConstraintSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SizeConstraintSetId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteSqlInjectionMatchSet": [
            {
                "action": "waf-regional:DeleteSqlInjectionMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SqlInjectionMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteWebACL": [
            {
                "action": "waf-regional:DeleteWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            }
        ],
        "WAFRegional.DeleteXssMatchSet": [
            {
                "action": "waf-regional:DeleteXssMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${XssMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.DisassociateWebACL": [
            {
                "action": "waf-regional:DisassociateWebACL",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "loadbalancer/app/": "${ResourceArn}"
                }
            }
        ],
        "WAFRegional.GetByteMatchSet": [
            {
                "action": "waf-regional:GetByteMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${ByteMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.GetChangeToken": [
            {
                "action": "waf-regional:GetChangeToken",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.GetChangeTokenStatus": [
            {
                "action": "waf-regional:GetChangeTokenStatus",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.GetGeoMatchSet": [
            {
                "action": "waf-regional:GetGeoMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${GeoMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.GetIPSet": [
            {
                "action": "waf-regional:GetIPSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${IPSetId}"
                    }
                }
            }
        ],
        "WAFRegional.GetLoggingConfiguration": [
            {
                "action": "waf-regional:GetLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${ResourceArn}"
                }
            }
        ],
        "WAFRegional.GetPermissionPolicy": [
            {
                "action": "waf-regional:GetPermissionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rulegroup": "${ResourceArn}"
                }
            }
        ],
        "WAFRegional.GetRateBasedRule": [
            {
                "action": "waf-regional:GetRateBasedRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAFRegional.GetRateBasedRuleManagedKeys": [
            {
                "action": "waf-regional:GetRateBasedRuleManagedKeys",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAFRegional.GetRegexMatchSet": [
            {
                "action": "waf-regional:GetRegexMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.GetRegexPatternSet": [
            {
                "action": "waf-regional:GetRegexPatternSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexPatternSetId}"
                    }
                }
            }
        ],
        "WAFRegional.GetRule": [
            {
                "action": "waf-regional:GetRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAFRegional.GetRuleGroup": [
            {
                "action": "waf-regional:GetRuleGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleGroupId}"
                    }
                }
            }
        ],
        "WAFRegional.GetSampledRequests": [
            {
                "action": "waf-regional:GetSampledRequests",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebAclId}"
                    }
                }
            }
        ],
        "WAFRegional.GetSizeConstraintSet": [
            {
                "action": "waf-regional:GetSizeConstraintSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SizeConstraintSetId}"
                    }
                }
            }
        ],
        "WAFRegional.GetSqlInjectionMatchSet": [
            {
                "action": "waf-regional:GetSqlInjectionMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SqlInjectionMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.GetWebACL": [
            {
                "action": "waf-regional:GetWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            }
        ],
        "WAFRegional.GetWebACLForResource": [
            {
                "action": "waf-regional:GetWebACLForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "loadbalancer/app/": "${ResourceArn}"
                }
            }
        ],
        "WAFRegional.GetXssMatchSet": [
            {
                "action": "waf-regional:GetXssMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${XssMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.ListActivatedRulesInRuleGroup": [
            {
                "action": "waf-regional:ListActivatedRulesInRuleGroup",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListByteMatchSets": [
            {
                "action": "waf-regional:ListByteMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListGeoMatchSets": [
            {
                "action": "waf-regional:ListGeoMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListIPSets": [
            {
                "action": "waf-regional:ListIPSets",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListLoggingConfigurations": [
            {
                "action": "waf-regional:ListLoggingConfigurations",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListRateBasedRules": [
            {
                "action": "waf-regional:ListRateBasedRules",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListRegexMatchSets": [
            {
                "action": "waf-regional:ListRegexMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListRegexPatternSets": [
            {
                "action": "waf-regional:ListRegexPatternSets",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListResourcesForWebACL": [
            {
                "action": "waf-regional:ListResourcesForWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            }
        ],
        "WAFRegional.ListRuleGroups": [
            {
                "action": "waf-regional:ListRuleGroups",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListRules": [
            {
                "action": "waf-regional:ListRules",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListSizeConstraintSets": [
            {
                "action": "waf-regional:ListSizeConstraintSets",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListSqlInjectionMatchSets": [
            {
                "action": "waf-regional:ListSqlInjectionMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListSubscribedRuleGroups": [
            {
                "action": "waf-regional:ListSubscribedRuleGroups",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListTagsForResource": [
            {
                "action": "waf-regional:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ratebasedrule": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%",
                    "rulegroup": "%%iftemplatematch%${ResourceARN}%%",
                    "webacl": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WAFRegional.ListWebACLs": [
            {
                "action": "waf-regional:ListWebACLs",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.ListXssMatchSets": [
            {
                "action": "waf-regional:ListXssMatchSets",
                "resource_mappings": {}
            }
        ],
        "WAFRegional.PutLoggingConfiguration": [
            {
                "action": "waf-regional:PutLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${LoggingConfiguration.ResourceArn}"
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFRegional.PutPermissionPolicy": [
            {
                "action": "waf-regional:PutPermissionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rulegroup": "${ResourceArn}"
                }
            }
        ],
        "WAFRegional.TagResource": [
            {
                "action": "waf-regional:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ratebasedrule": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%",
                    "rulegroup": "%%iftemplatematch%${ResourceARN}%%",
                    "webacl": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WAFRegional.UntagResource": [
            {
                "action": "waf-regional:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ratebasedrule": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%",
                    "rulegroup": "%%iftemplatematch%${ResourceARN}%%",
                    "webacl": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WAFRegional.UpdateByteMatchSet": [
            {
                "action": "waf-regional:UpdateByteMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${ByteMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateGeoMatchSet": [
            {
                "action": "waf-regional:UpdateGeoMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${GeoMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateIPSet": [
            {
                "action": "waf-regional:UpdateIPSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${IPSetId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateRateBasedRule": [
            {
                "action": "waf-regional:UpdateRateBasedRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateRegexMatchSet": [
            {
                "action": "waf-regional:UpdateRegexMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateRegexPatternSet": [
            {
                "action": "waf-regional:UpdateRegexPatternSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${RegexPatternSetId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateRule": [
            {
                "action": "waf-regional:UpdateRule",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateRuleGroup": [
            {
                "action": "waf-regional:UpdateRuleGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${RuleGroupId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateSizeConstraintSet": [
            {
                "action": "waf-regional:UpdateSizeConstraintSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SizeConstraintSetId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateSqlInjectionMatchSet": [
            {
                "action": "waf-regional:UpdateSqlInjectionMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${SqlInjectionMatchSetId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateWebACL": [
            {
                "action": "waf-regional:UpdateWebACL",
                "resource_mappings": {
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            }
        ],
        "WAFRegional.UpdateXssMatchSet": [
            {
                "action": "waf-regional:UpdateXssMatchSet",
                "resource_mappings": {
                    "Id": {
                        "template": "${XssMatchSetId}"
                    }
                }
            }
        ],
        "WorkDocs.AbortDocumentVersionUpload": [
            {
                "action": "workdocs:AbortDocumentVersionUpload",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.ActivateUser": [
            {
                "action": "workdocs:ActivateUser",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.AddResourcePermissions": [
            {
                "action": "workdocs:AddResourcePermissions",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.CreateComment": [
            {
                "action": "workdocs:CreateComment",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.CreateCustomMetadata": [
            {
                "action": "workdocs:CreateCustomMetadata",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.CreateFolder": [
            {
                "action": "workdocs:CreateFolder",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.CreateLabels": [
            {
                "action": "workdocs:CreateLabels",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.CreateNotificationSubscription": [
            {
                "action": "workdocs:CreateNotificationSubscription",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.CreateUser": [
            {
                "action": "workdocs:CreateUser",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DeactivateUser": [
            {
                "action": "workdocs:DeactivateUser",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DeleteComment": [
            {
                "action": "workdocs:DeleteComment",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DeleteCustomMetadata": [
            {
                "action": "workdocs:DeleteCustomMetadata",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DeleteDocument": [
            {
                "action": "workdocs:DeleteDocument",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DeleteFolder": [
            {
                "action": "workdocs:DeleteFolder",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DeleteFolderContents": [
            {
                "action": "workdocs:DeleteFolderContents",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DeleteLabels": [
            {
                "action": "workdocs:DeleteLabels",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DeleteNotificationSubscription": [
            {
                "action": "workdocs:DeleteNotificationSubscription",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DeleteUser": [
            {
                "action": "workdocs:DeleteUser",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DescribeActivities": [
            {
                "action": "workdocs:DescribeActivities",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DescribeComments": [
            {
                "action": "workdocs:DescribeComments",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DescribeDocumentVersions": [
            {
                "action": "workdocs:DescribeDocumentVersions",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DescribeFolderContents": [
            {
                "action": "workdocs:DescribeFolderContents",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DescribeGroups": [
            {
                "action": "workdocs:DescribeGroups",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DescribeNotificationSubscriptions": [
            {
                "action": "workdocs:DescribeNotificationSubscriptions",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DescribeResourcePermissions": [
            {
                "action": "workdocs:DescribeResourcePermissions",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DescribeRootFolders": [
            {
                "action": "workdocs:DescribeRootFolders",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.DescribeUsers": [
            {
                "action": "workdocs:DescribeUsers",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.GetCurrentUser": [
            {
                "action": "workdocs:GetCurrentUser",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.GetDocument": [
            {
                "action": "workdocs:GetDocument",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.GetDocumentPath": [
            {
                "action": "workdocs:GetDocumentPath",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.GetDocumentVersion": [
            {
                "action": "workdocs:GetDocumentVersion",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.GetFolder": [
            {
                "action": "workdocs:GetFolder",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.GetFolderPath": [
            {
                "action": "workdocs:GetFolderPath",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.GetResources": [
            {
                "action": "workdocs:GetResources",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.InitiateDocumentVersionUpload": [
            {
                "action": "workdocs:InitiateDocumentVersionUpload",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.RemoveAllResourcePermissions": [
            {
                "action": "workdocs:RemoveAllResourcePermissions",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.RemoveResourcePermission": [
            {
                "action": "workdocs:RemoveResourcePermission",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.UpdateDocument": [
            {
                "action": "workdocs:UpdateDocument",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.UpdateDocumentVersion": [
            {
                "action": "workdocs:UpdateDocumentVersion",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.UpdateFolder": [
            {
                "action": "workdocs:UpdateFolder",
                "resource_mappings": {}
            }
        ],
        "WorkDocs.UpdateUser": [
            {
                "action": "workdocs:UpdateUser",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.AuthorizeIpRules": [
            {
                "action": "workspaces:AuthorizeIpRules",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "WorkSpaces.CreateTags": [
            {
                "action": "workspaces:CreateTags",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DeleteIpGroup": [
            {
                "action": "workspaces:DeleteIpGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "WorkSpaces.DeleteTags": [
            {
                "action": "workspaces:DeleteTags",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DescribeAccount": [
            {
                "action": "workspaces:DescribeAccount",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DescribeAccountModifications": [
            {
                "action": "workspaces:DescribeAccountModifications",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DescribeClientProperties": [
            {
                "action": "workspaces:DescribeClientProperties",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceIds[]}"
                    }
                }
            }
        ],
        "WorkSpaces.DescribeIpGroups": [
            {
                "action": "workspaces:DescribeIpGroups",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupIds[]}"
                    }
                }
            }
        ],
        "WorkSpaces.DescribeTags": [
            {
                "action": "workspaces:DescribeTags",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DescribeWorkspaceDirectories": [
            {
                "action": "workspaces:DescribeWorkspaceDirectories",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DescribeWorkspaceImages": [
            {
                "action": "workspaces:DescribeWorkspaceImages",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DescribeWorkspaces": [
            {
                "action": "workspaces:DescribeWorkspaces",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DescribeWorkspacesConnectionStatus": [
            {
                "action": "workspaces:DescribeWorkspacesConnectionStatus",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.ListAvailableManagementCidrRanges": [
            {
                "action": "workspaces:ListAvailableManagementCidrRanges",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.ModifyAccount": [
            {
                "action": "workspaces:ModifyAccount",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.ModifyClientProperties": [
            {
                "action": "workspaces:ModifyClientProperties",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "WorkSpaces.ModifyWorkspaceProperties": [
            {
                "action": "workspaces:ModifyWorkspaceProperties",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${WorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.ModifyWorkspaceState": [
            {
                "action": "workspaces:ModifyWorkspaceState",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${WorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.RebootWorkspaces": [
            {
                "action": "workspaces:RebootWorkspaces",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${RebootWorkspaceRequests[].WorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.RebuildWorkspaces": [
            {
                "action": "workspaces:RebuildWorkspaces",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${RebuildWorkspaceRequests[].WorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.RevokeIpRules": [
            {
                "action": "workspaces:RevokeIpRules",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "WorkSpaces.StartWorkspaces": [
            {
                "action": "workspaces:StartWorkspaces",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${StartWorkspaceRequests[].WorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.StopWorkspaces": [
            {
                "action": "workspaces:StopWorkspaces",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${StopWorkspaceRequests[].WorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.TerminateWorkspaces": [
            {
                "action": "workspaces:TerminateWorkspaces",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${TerminateWorkspaceRequests[].WorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.UpdateRulesOfIpGroup": [
            {
                "action": "workspaces:UpdateRulesOfIpGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "CodeStar.AssociateTeamMember": [
            {
                "action": "codestar:AssociateTeamMember",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "CodeStar.CreateProject": [
            {
                "action": "codestar:CreateProject",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${toolchain.roleArn}"
                }
            }
        ],
        "CodeStar.CreateUserProfile": [
            {
                "action": "codestar:CreateUserProfile",
                "resource_mappings": {
                    "aws:username": {
                        "template": "${aws:username}"
                    }
                }
            }
        ],
        "CodeStar.DeleteProject": [
            {
                "action": "codestar:DeleteProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "CodeStar.DeleteUserProfile": [
            {
                "action": "codestar:DeleteUserProfile",
                "resource_mappings": {
                    "aws:username": {
                        "template": "${aws:username}"
                    }
                }
            }
        ],
        "CodeStar.DescribeProject": [
            {
                "action": "codestar:DescribeProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "CodeStar.DescribeUserProfile": [
            {
                "action": "codestar:DescribeUserProfile",
                "resource_mappings": {}
            }
        ],
        "CodeStar.DisassociateTeamMember": [
            {
                "action": "codestar:DisassociateTeamMember",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "CodeStar.ListProjects": [
            {
                "action": "codestar:ListProjects",
                "resource_mappings": {}
            }
        ],
        "CodeStar.ListResources": [
            {
                "action": "codestar:ListResources",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "CodeStar.ListTagsForProject": [
            {
                "action": "codestar:ListTagsForProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "CodeStar.ListTeamMembers": [
            {
                "action": "codestar:ListTeamMembers",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "CodeStar.ListUserProfiles": [
            {
                "action": "codestar:ListUserProfiles",
                "resource_mappings": {}
            }
        ],
        "CodeStar.TagProject": [
            {
                "action": "codestar:TagProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "CodeStar.UntagProject": [
            {
                "action": "codestar:UntagProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "CodeStar.UpdateProject": [
            {
                "action": "codestar:UpdateProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "CodeStar.UpdateTeamMember": [
            {
                "action": "codestar:UpdateTeamMember",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "CodeStar.UpdateUserProfile": [
            {
                "action": "codestar:UpdateUserProfile",
                "resource_mappings": {
                    "aws:username": {
                        "template": "${aws:username}"
                    }
                }
            }
        ],
        "LexModelBuildingService.CreateBotVersion": [
            {
                "action": "lex:CreateBotVersion",
                "resource_mappings": {
                    "BotName": {
                        "template": "${name}"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.CreateIntentVersion": [
            {
                "action": "lex:CreateIntentVersion",
                "resource_mappings": {
                    "IntentName": {
                        "template": "${name}"
                    },
                    "IntentVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.CreateSlotTypeVersion": [
            {
                "action": "lex:CreateSlotTypeVersion",
                "resource_mappings": {
                    "SlotName": {
                        "template": "${name}"
                    },
                    "SlotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.DeleteBot": [
            {
                "action": "lex:DeleteBot",
                "resource_mappings": {
                    "BotName": {
                        "template": "${name}"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "*"
                    },
                    "BotAliasId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.DeleteBotAlias": [
            {
                "action": "lex:DeleteBotAlias",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${name}"
                    },
                    "BotId": {
                        "template": "*"
                    },
                    "BotAliasId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.DeleteBotChannelAssociation": [
            {
                "action": "lex:DeleteBotChannelAssociation",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${botAlias}"
                    },
                    "ChannelName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "LexModelBuildingService.DeleteBotVersion": [
            {
                "action": "lex:DeleteBotVersion",
                "resource_mappings": {
                    "BotName": {
                        "template": "${name}"
                    },
                    "BotVersion": {
                        "template": "${version}"
                    },
                    "BotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.DeleteIntent": [
            {
                "action": "lex:DeleteIntent",
                "resource_mappings": {
                    "IntentName": {
                        "template": "${name}"
                    },
                    "IntentVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.DeleteIntentVersion": [
            {
                "action": "lex:DeleteIntentVersion",
                "resource_mappings": {
                    "IntentName": {
                        "template": "${name}"
                    },
                    "IntentVersion": {
                        "template": "${version}"
                    }
                }
            }
        ],
        "LexModelBuildingService.DeleteSlotType": [
            {
                "action": "lex:DeleteSlotType",
                "resource_mappings": {
                    "SlotName": {
                        "template": "${name}"
                    },
                    "SlotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.DeleteSlotTypeVersion": [
            {
                "action": "lex:DeleteSlotTypeVersion",
                "resource_mappings": {
                    "SlotName": {
                        "template": "${name}"
                    },
                    "SlotVersion": {
                        "template": "${version}"
                    }
                }
            }
        ],
        "LexModelBuildingService.DeleteUtterances": [
            {
                "action": "lex:DeleteUtterances",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetBot": [
            {
                "action": "lex:GetBot",
                "resource_mappings": {
                    "BotName": {
                        "template": "${name}"
                    },
                    "BotAlias": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetBotAlias": [
            {
                "action": "lex:GetBotAlias",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetBotAliases": [
            {
                "action": "lex:GetBotAliases",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetBotChannelAssociation": [
            {
                "action": "lex:GetBotChannelAssociation",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${botAlias}"
                    },
                    "ChannelName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetBotChannelAssociations": [
            {
                "action": "lex:GetBotChannelAssociations",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${botAlias}"
                    },
                    "ChannelName": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetBotVersions": [
            {
                "action": "lex:GetBotVersions",
                "resource_mappings": {
                    "BotName": {
                        "template": "${name}"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetBots": [
            {
                "action": "lex:GetBots",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetBuiltinIntent": [
            {
                "action": "lex:GetBuiltinIntent",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetBuiltinIntents": [
            {
                "action": "lex:GetBuiltinIntents",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetBuiltinSlotTypes": [
            {
                "action": "lex:GetBuiltinSlotTypes",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetExport": [
            {
                "action": "lex:GetExport",
                "resource_mappings": {
                    "BotName": {
                        "template": "${name}"
                    },
                    "BotVersion": {
                        "template": "${version}"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetImport": [
            {
                "action": "lex:GetImport",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetIntent": [
            {
                "action": "lex:GetIntent",
                "resource_mappings": {
                    "IntentName": {
                        "template": "${name}"
                    },
                    "IntentVersion": {
                        "template": "${version}"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetIntentVersions": [
            {
                "action": "lex:GetIntentVersions",
                "resource_mappings": {
                    "IntentName": {
                        "template": "${name}"
                    },
                    "IntentVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetIntents": [
            {
                "action": "lex:GetIntents",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetSlotType": [
            {
                "action": "lex:GetSlotType",
                "resource_mappings": {
                    "SlotName": {
                        "template": "${name}"
                    },
                    "SlotVersion": {
                        "template": "${version}"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetSlotTypeVersions": [
            {
                "action": "lex:GetSlotTypeVersions",
                "resource_mappings": {
                    "SlotName": {
                        "template": "${name}"
                    },
                    "SlotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.GetSlotTypes": [
            {
                "action": "lex:GetSlotTypes",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetUtterancesView": [
            {
                "action": "lex:GetUtterancesView",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotVersion": {
                        "template": "${botVersions[]}"
                    }
                }
            }
        ],
        "LexModelBuildingService.ListTagsForResource": [
            {
                "action": "lex:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceArn}%%",
                    "bot alias": "%%iftemplatematch%${resourceArn}%%",
                    "channel": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "LexModelBuildingService.PutBot": [
            {
                "action": "lex:PutBot",
                "resource_mappings": {
                    "BotName": {
                        "template": "${name}"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.PutBotAlias": [
            {
                "action": "lex:PutBotAlias",
                "resource_mappings": {
                    "BotName": {
                        "template": "${botName}"
                    },
                    "BotAlias": {
                        "template": "${name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${conversationLogs.iamRoleArn}"
                }
            }
        ],
        "LexModelBuildingService.PutIntent": [
            {
                "action": "lex:PutIntent",
                "resource_mappings": {
                    "IntentName": {
                        "template": "${name}"
                    },
                    "IntentVersion": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${kendraConfiguration.role}"
                }
            }
        ],
        "LexModelBuildingService.PutSlotType": [
            {
                "action": "lex:PutSlotType",
                "resource_mappings": {
                    "SlotName": {
                        "template": "${name}"
                    },
                    "SlotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelBuildingService.StartImport": [
            {
                "action": "lex:StartImport",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.TagResource": [
            {
                "action": "lex:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceArn}%%",
                    "bot alias": "%%iftemplatematch%${resourceArn}%%",
                    "channel": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "LexModelBuildingService.UntagResource": [
            {
                "action": "lex:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceArn}%%",
                    "bot alias": "%%iftemplatematch%${resourceArn}%%",
                    "channel": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "MarketplaceEntitlementService.GetEntitlements": [
            {
                "action": "aws-marketplace:GetEntitlements",
                "resource_mappings": {}
            }
        ],
        "Athena.BatchGetNamedQuery": [
            {
                "action": "athena:BatchGetNamedQuery",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Athena.BatchGetQueryExecution": [
            {
                "action": "athena:BatchGetQueryExecution",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Athena.CreateDataCatalog": [
            {
                "action": "athena:CreateDataCatalog",
                "resource_mappings": {
                    "DataCatalogName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Athena.CreateNamedQuery": [
            {
                "action": "athena:CreateNamedQuery",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Athena.CreateWorkGroup": [
            {
                "action": "athena:CreateWorkGroup",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Athena.DeleteDataCatalog": [
            {
                "action": "athena:DeleteDataCatalog",
                "resource_mappings": {
                    "DataCatalogName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Athena.DeleteNamedQuery": [
            {
                "action": "athena:DeleteNamedQuery",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Athena.DeleteWorkGroup": [
            {
                "action": "athena:DeleteWorkGroup",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Athena.GetDataCatalog": [
            {
                "action": "athena:GetDataCatalog",
                "resource_mappings": {
                    "DataCatalogName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Athena.GetDatabase": [
            {
                "action": "athena:GetDatabase",
                "resource_mappings": {
                    "DataCatalogName": {
                        "template": "${CatalogName}"
                    }
                }
            }
        ],
        "Athena.GetNamedQuery": [
            {
                "action": "athena:GetNamedQuery",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Athena.GetQueryExecution": [
            {
                "action": "athena:GetQueryExecution",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Athena.GetQueryResults": [
            {
                "action": "athena:GetQueryResults",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Athena.GetTableMetadata": [
            {
                "action": "athena:GetTableMetadata",
                "resource_mappings": {
                    "DataCatalogName": {
                        "template": "${CatalogName}"
                    }
                }
            }
        ],
        "Athena.GetWorkGroup": [
            {
                "action": "athena:GetWorkGroup",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Athena.ListDataCatalogs": [
            {
                "action": "athena:ListDataCatalogs",
                "resource_mappings": {}
            }
        ],
        "Athena.ListDatabases": [
            {
                "action": "athena:ListDatabases",
                "resource_mappings": {
                    "DataCatalogName": {
                        "template": "${CatalogName}"
                    }
                }
            }
        ],
        "Athena.ListNamedQueries": [
            {
                "action": "athena:ListNamedQueries",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Athena.ListQueryExecutions": [
            {
                "action": "athena:ListQueryExecutions",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Athena.ListTableMetadata": [
            {
                "action": "athena:ListTableMetadata",
                "resource_mappings": {
                    "DataCatalogName": {
                        "template": "${CatalogName}"
                    }
                }
            }
        ],
        "Athena.ListTagsForResource": [
            {
                "action": "athena:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datacatalog": "%%iftemplatematch%${ResourceARN}%%",
                    "workgroup": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Athena.ListWorkGroups": [
            {
                "action": "athena:ListWorkGroups",
                "resource_mappings": {}
            }
        ],
        "Athena.StartQueryExecution": [
            {
                "action": "athena:StartQueryExecution",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Athena.StopQueryExecution": [
            {
                "action": "athena:StopQueryExecution",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Athena.TagResource": [
            {
                "action": "athena:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datacatalog": "%%iftemplatematch%${ResourceARN}%%",
                    "workgroup": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Athena.UntagResource": [
            {
                "action": "athena:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datacatalog": "%%iftemplatematch%${ResourceARN}%%",
                    "workgroup": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Athena.UpdateDataCatalog": [
            {
                "action": "athena:UpdateDataCatalog",
                "resource_mappings": {
                    "DataCatalogName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Athena.UpdateWorkGroup": [
            {
                "action": "athena:UpdateWorkGroup",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Greengrass.AssociateRoleToGroup": [
            {
                "action": "greengrass:AssociateRoleToGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Greengrass.AssociateServiceRoleToAccount": [
            {
                "action": "greengrass:AssociateServiceRoleToAccount",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Greengrass.CreateConnectorDefinition": [
            {
                "action": "greengrass:CreateConnectorDefinition",
                "resource_mappings": {}
            }
        ],
        "Greengrass.CreateConnectorDefinitionVersion": [
            {
                "action": "greengrass:CreateConnectorDefinitionVersion",
                "resource_mappings": {
                    "ConnectorDefinitionId": {
                        "template": "${ConnectorDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.CreateCoreDefinition": [
            {
                "action": "greengrass:CreateCoreDefinition",
                "resource_mappings": {}
            }
        ],
        "Greengrass.CreateCoreDefinitionVersion": [
            {
                "action": "greengrass:CreateCoreDefinitionVersion",
                "resource_mappings": {
                    "CoreDefinitionId": {
                        "template": "${CoreDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.CreateDeployment": [
            {
                "action": "greengrass:CreateDeployment",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            },
            {
                "action": "iot:CancelJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Greengrass.CreateDeviceDefinition": [
            {
                "action": "greengrass:CreateDeviceDefinition",
                "resource_mappings": {}
            }
        ],
        "Greengrass.CreateDeviceDefinitionVersion": [
            {
                "action": "greengrass:CreateDeviceDefinitionVersion",
                "resource_mappings": {
                    "DeviceDefinitionId": {
                        "template": "${DeviceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.CreateFunctionDefinition": [
            {
                "action": "greengrass:CreateFunctionDefinition",
                "resource_mappings": {}
            }
        ],
        "Greengrass.CreateFunctionDefinitionVersion": [
            {
                "action": "greengrass:CreateFunctionDefinitionVersion",
                "resource_mappings": {
                    "FunctionDefinitionId": {
                        "template": "${FunctionDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.CreateGroup": [
            {
                "action": "greengrass:CreateGroup",
                "resource_mappings": {}
            }
        ],
        "Greengrass.CreateGroupCertificateAuthority": [
            {
                "action": "greengrass:CreateGroupCertificateAuthority",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.CreateGroupVersion": [
            {
                "action": "greengrass:CreateGroupVersion",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.CreateLoggerDefinition": [
            {
                "action": "greengrass:CreateLoggerDefinition",
                "resource_mappings": {}
            }
        ],
        "Greengrass.CreateLoggerDefinitionVersion": [
            {
                "action": "greengrass:CreateLoggerDefinitionVersion",
                "resource_mappings": {
                    "LoggerDefinitionId": {
                        "template": "${LoggerDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.CreateResourceDefinition": [
            {
                "action": "greengrass:CreateResourceDefinition",
                "resource_mappings": {}
            }
        ],
        "Greengrass.CreateResourceDefinitionVersion": [
            {
                "action": "greengrass:CreateResourceDefinitionVersion",
                "resource_mappings": {
                    "ResourceDefinitionId": {
                        "template": "${ResourceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.CreateSoftwareUpdateJob": [
            {
                "action": "greengrass:CreateSoftwareUpdateJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${S3UrlSignerRole}"
                }
            }
        ],
        "Greengrass.CreateSubscriptionDefinition": [
            {
                "action": "greengrass:CreateSubscriptionDefinition",
                "resource_mappings": {}
            }
        ],
        "Greengrass.CreateSubscriptionDefinitionVersion": [
            {
                "action": "greengrass:CreateSubscriptionDefinitionVersion",
                "resource_mappings": {
                    "SubscriptionDefinitionId": {
                        "template": "${SubscriptionDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.DeleteConnectorDefinition": [
            {
                "action": "greengrass:DeleteConnectorDefinition",
                "resource_mappings": {
                    "ConnectorDefinitionId": {
                        "template": "${ConnectorDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.DeleteCoreDefinition": [
            {
                "action": "greengrass:DeleteCoreDefinition",
                "resource_mappings": {
                    "CoreDefinitionId": {
                        "template": "${CoreDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.DeleteDeviceDefinition": [
            {
                "action": "greengrass:DeleteDeviceDefinition",
                "resource_mappings": {
                    "DeviceDefinitionId": {
                        "template": "${DeviceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.DeleteFunctionDefinition": [
            {
                "action": "greengrass:DeleteFunctionDefinition",
                "resource_mappings": {
                    "FunctionDefinitionId": {
                        "template": "${FunctionDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.DeleteGroup": [
            {
                "action": "greengrass:DeleteGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.DeleteLoggerDefinition": [
            {
                "action": "greengrass:DeleteLoggerDefinition",
                "resource_mappings": {
                    "LoggerDefinitionId": {
                        "template": "${LoggerDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.DeleteResourceDefinition": [
            {
                "action": "greengrass:DeleteResourceDefinition",
                "resource_mappings": {
                    "ResourceDefinitionId": {
                        "template": "${ResourceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.DeleteSubscriptionDefinition": [
            {
                "action": "greengrass:DeleteSubscriptionDefinition",
                "resource_mappings": {
                    "SubscriptionDefinitionId": {
                        "template": "${SubscriptionDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.DisassociateRoleFromGroup": [
            {
                "action": "greengrass:DisassociateRoleFromGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.DisassociateServiceRoleFromAccount": [
            {
                "action": "greengrass:DisassociateServiceRoleFromAccount",
                "resource_mappings": {}
            }
        ],
        "Greengrass.GetAssociatedRole": [
            {
                "action": "greengrass:GetAssociatedRole",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.GetBulkDeploymentStatus": [
            {
                "action": "greengrass:GetBulkDeploymentStatus",
                "resource_mappings": {
                    "BulkDeploymentId": {
                        "template": "${BulkDeploymentId}"
                    }
                }
            }
        ],
        "Greengrass.GetConnectivityInfo": [
            {
                "action": "greengrass:GetConnectivityInfo",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${ThingName}"
                    }
                }
            }
        ],
        "Greengrass.GetConnectorDefinition": [
            {
                "action": "greengrass:GetConnectorDefinition",
                "resource_mappings": {
                    "ConnectorDefinitionId": {
                        "template": "${ConnectorDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.GetConnectorDefinitionVersion": [
            {
                "action": "greengrass:GetConnectorDefinitionVersion",
                "resource_mappings": {
                    "ConnectorDefinitionId": {
                        "template": "${ConnectorDefinitionId}"
                    },
                    "VersionId": {
                        "template": "${ConnectorDefinitionVersionId}"
                    }
                }
            }
        ],
        "Greengrass.GetCoreDefinition": [
            {
                "action": "greengrass:GetCoreDefinition",
                "resource_mappings": {
                    "CoreDefinitionId": {
                        "template": "${CoreDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.GetCoreDefinitionVersion": [
            {
                "action": "greengrass:GetCoreDefinitionVersion",
                "resource_mappings": {
                    "CoreDefinitionId": {
                        "template": "${CoreDefinitionId}"
                    },
                    "VersionId": {
                        "template": "${CoreDefinitionVersionId}"
                    }
                }
            }
        ],
        "Greengrass.GetDeploymentStatus": [
            {
                "action": "greengrass:GetDeploymentStatus",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    },
                    "DeploymentId": {
                        "template": "${DeploymentId}"
                    }
                }
            }
        ],
        "Greengrass.GetDeviceDefinition": [
            {
                "action": "greengrass:GetDeviceDefinition",
                "resource_mappings": {
                    "DeviceDefinitionId": {
                        "template": "${DeviceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.GetDeviceDefinitionVersion": [
            {
                "action": "greengrass:GetDeviceDefinitionVersion",
                "resource_mappings": {
                    "DeviceDefinitionId": {
                        "template": "${DeviceDefinitionId}"
                    },
                    "VersionId": {
                        "template": "${DeviceDefinitionVersionId}"
                    }
                }
            }
        ],
        "Greengrass.GetFunctionDefinition": [
            {
                "action": "greengrass:GetFunctionDefinition",
                "resource_mappings": {
                    "FunctionDefinitionId": {
                        "template": "${FunctionDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.GetFunctionDefinitionVersion": [
            {
                "action": "greengrass:GetFunctionDefinitionVersion",
                "resource_mappings": {
                    "FunctionDefinitionId": {
                        "template": "${FunctionDefinitionId}"
                    },
                    "VersionId": {
                        "template": "${FunctionDefinitionVersionId}"
                    }
                }
            }
        ],
        "Greengrass.GetGroup": [
            {
                "action": "greengrass:GetGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.GetGroupCertificateAuthority": [
            {
                "action": "greengrass:GetGroupCertificateAuthority",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    },
                    "CertificateAuthorityId": {
                        "template": "${CertificateAuthorityId}"
                    }
                }
            }
        ],
        "Greengrass.GetGroupCertificateConfiguration": [
            {
                "action": "greengrass:GetGroupCertificateConfiguration",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.GetGroupVersion": [
            {
                "action": "greengrass:GetGroupVersion",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    },
                    "VersionId": {
                        "template": "${GroupVersionId}"
                    }
                }
            }
        ],
        "Greengrass.GetLoggerDefinition": [
            {
                "action": "greengrass:GetLoggerDefinition",
                "resource_mappings": {
                    "LoggerDefinitionId": {
                        "template": "${LoggerDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.GetLoggerDefinitionVersion": [
            {
                "action": "greengrass:GetLoggerDefinitionVersion",
                "resource_mappings": {
                    "LoggerDefinitionId": {
                        "template": "${LoggerDefinitionId}"
                    },
                    "VersionId": {
                        "template": "${LoggerDefinitionVersionId}"
                    }
                }
            }
        ],
        "Greengrass.GetResourceDefinition": [
            {
                "action": "greengrass:GetResourceDefinition",
                "resource_mappings": {
                    "ResourceDefinitionId": {
                        "template": "${ResourceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.GetResourceDefinitionVersion": [
            {
                "action": "greengrass:GetResourceDefinitionVersion",
                "resource_mappings": {
                    "ResourceDefinitionId": {
                        "template": "${ResourceDefinitionId}"
                    },
                    "VersionId": {
                        "template": "${ResourceDefinitionVersionId}"
                    }
                }
            }
        ],
        "Greengrass.GetServiceRoleForAccount": [
            {
                "action": "greengrass:GetServiceRoleForAccount",
                "resource_mappings": {}
            }
        ],
        "Greengrass.GetSubscriptionDefinition": [
            {
                "action": "greengrass:GetSubscriptionDefinition",
                "resource_mappings": {
                    "SubscriptionDefinitionId": {
                        "template": "${SubscriptionDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.GetSubscriptionDefinitionVersion": [
            {
                "action": "greengrass:GetSubscriptionDefinitionVersion",
                "resource_mappings": {
                    "SubscriptionDefinitionId": {
                        "template": "${SubscriptionDefinitionId}"
                    },
                    "VersionId": {
                        "template": "${SubscriptionDefinitionVersionId}"
                    }
                }
            }
        ],
        "Greengrass.ListBulkDeploymentDetailedReports": [
            {
                "action": "greengrass:ListBulkDeploymentDetailedReports",
                "resource_mappings": {
                    "BulkDeploymentId": {
                        "template": "${BulkDeploymentId}"
                    }
                }
            }
        ],
        "Greengrass.ListBulkDeployments": [
            {
                "action": "greengrass:ListBulkDeployments",
                "resource_mappings": {}
            }
        ],
        "Greengrass.ListConnectorDefinitionVersions": [
            {
                "action": "greengrass:ListConnectorDefinitionVersions",
                "resource_mappings": {
                    "ConnectorDefinitionId": {
                        "template": "${ConnectorDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.ListConnectorDefinitions": [
            {
                "action": "greengrass:ListConnectorDefinitions",
                "resource_mappings": {}
            }
        ],
        "Greengrass.ListCoreDefinitionVersions": [
            {
                "action": "greengrass:ListCoreDefinitionVersions",
                "resource_mappings": {
                    "CoreDefinitionId": {
                        "template": "${CoreDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.ListCoreDefinitions": [
            {
                "action": "greengrass:ListCoreDefinitions",
                "resource_mappings": {}
            }
        ],
        "Greengrass.ListDeployments": [
            {
                "action": "greengrass:ListDeployments",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            },
            {
                "action": "iot:DescribeJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Greengrass.ListDeviceDefinitionVersions": [
            {
                "action": "greengrass:ListDeviceDefinitionVersions",
                "resource_mappings": {
                    "DeviceDefinitionId": {
                        "template": "${DeviceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.ListDeviceDefinitions": [
            {
                "action": "greengrass:ListDeviceDefinitions",
                "resource_mappings": {}
            }
        ],
        "Greengrass.ListFunctionDefinitionVersions": [
            {
                "action": "greengrass:ListFunctionDefinitionVersions",
                "resource_mappings": {
                    "FunctionDefinitionId": {
                        "template": "${FunctionDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.ListFunctionDefinitions": [
            {
                "action": "greengrass:ListFunctionDefinitions",
                "resource_mappings": {}
            }
        ],
        "Greengrass.ListGroupCertificateAuthorities": [
            {
                "action": "greengrass:ListGroupCertificateAuthorities",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.ListGroupVersions": [
            {
                "action": "greengrass:ListGroupVersions",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.ListGroups": [
            {
                "action": "greengrass:ListGroups",
                "resource_mappings": {}
            }
        ],
        "Greengrass.ListLoggerDefinitionVersions": [
            {
                "action": "greengrass:ListLoggerDefinitionVersions",
                "resource_mappings": {
                    "LoggerDefinitionId": {
                        "template": "${LoggerDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.ListLoggerDefinitions": [
            {
                "action": "greengrass:ListLoggerDefinitions",
                "resource_mappings": {}
            }
        ],
        "Greengrass.ListResourceDefinitionVersions": [
            {
                "action": "greengrass:ListResourceDefinitionVersions",
                "resource_mappings": {
                    "ResourceDefinitionId": {
                        "template": "${ResourceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.ListResourceDefinitions": [
            {
                "action": "greengrass:ListResourceDefinitions",
                "resource_mappings": {}
            }
        ],
        "Greengrass.ListSubscriptionDefinitionVersions": [
            {
                "action": "greengrass:ListSubscriptionDefinitionVersions",
                "resource_mappings": {
                    "SubscriptionDefinitionId": {
                        "template": "${SubscriptionDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.ListSubscriptionDefinitions": [
            {
                "action": "greengrass:ListSubscriptionDefinitions",
                "resource_mappings": {}
            }
        ],
        "Greengrass.ListTagsForResource": [
            {
                "action": "greengrass:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "%%iftemplatematch%${ResourceArn}%%",
                    "componentVersion": "%%iftemplatematch%${ResourceArn}%%",
                    "coreDevice": "%%iftemplatematch%${ResourceArn}%%",
                    "deployment": "%%iftemplatematch%${ResourceArn}%%",
                    "bulkDeployment": "%%iftemplatematch%${ResourceArn}%%",
                    "connectorDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "coreDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "deviceDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "functionDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "group": "%%iftemplatematch%${ResourceArn}%%",
                    "loggerDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "resourceDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "subscriptionDefinition": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Greengrass.ResetDeployments": [
            {
                "action": "greengrass:ResetDeployments",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.StartBulkDeployment": [
            {
                "action": "greengrass:StartBulkDeployment",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ExecutionRoleArn}"
                }
            }
        ],
        "Greengrass.StopBulkDeployment": [
            {
                "action": "greengrass:StopBulkDeployment",
                "resource_mappings": {
                    "BulkDeploymentId": {
                        "template": "${BulkDeploymentId}"
                    }
                }
            }
        ],
        "Greengrass.TagResource": [
            {
                "action": "greengrass:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "%%iftemplatematch%${ResourceArn}%%",
                    "componentVersion": "%%iftemplatematch%${ResourceArn}%%",
                    "coreDevice": "%%iftemplatematch%${ResourceArn}%%",
                    "deployment": "%%iftemplatematch%${ResourceArn}%%",
                    "bulkDeployment": "%%iftemplatematch%${ResourceArn}%%",
                    "connectorDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "coreDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "deviceDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "functionDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "group": "%%iftemplatematch%${ResourceArn}%%",
                    "loggerDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "resourceDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "subscriptionDefinition": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Greengrass.UntagResource": [
            {
                "action": "greengrass:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "%%iftemplatematch%${ResourceArn}%%",
                    "componentVersion": "%%iftemplatematch%${ResourceArn}%%",
                    "coreDevice": "%%iftemplatematch%${ResourceArn}%%",
                    "deployment": "%%iftemplatematch%${ResourceArn}%%",
                    "bulkDeployment": "%%iftemplatematch%${ResourceArn}%%",
                    "connectorDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "coreDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "deviceDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "functionDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "group": "%%iftemplatematch%${ResourceArn}%%",
                    "loggerDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "resourceDefinition": "%%iftemplatematch%${ResourceArn}%%",
                    "subscriptionDefinition": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Greengrass.UpdateConnectivityInfo": [
            {
                "action": "greengrass:UpdateConnectivityInfo",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${ThingName}"
                    }
                }
            }
        ],
        "Greengrass.UpdateConnectorDefinition": [
            {
                "action": "greengrass:UpdateConnectorDefinition",
                "resource_mappings": {
                    "ConnectorDefinitionId": {
                        "template": "${ConnectorDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.UpdateCoreDefinition": [
            {
                "action": "greengrass:UpdateCoreDefinition",
                "resource_mappings": {
                    "CoreDefinitionId": {
                        "template": "${CoreDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.UpdateDeviceDefinition": [
            {
                "action": "greengrass:UpdateDeviceDefinition",
                "resource_mappings": {
                    "DeviceDefinitionId": {
                        "template": "${DeviceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.UpdateFunctionDefinition": [
            {
                "action": "greengrass:UpdateFunctionDefinition",
                "resource_mappings": {
                    "FunctionDefinitionId": {
                        "template": "${FunctionDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.UpdateGroup": [
            {
                "action": "greengrass:UpdateGroup",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.UpdateGroupCertificateConfiguration": [
            {
                "action": "greengrass:UpdateGroupCertificateConfiguration",
                "resource_mappings": {
                    "GroupId": {
                        "template": "${GroupId}"
                    }
                }
            }
        ],
        "Greengrass.UpdateLoggerDefinition": [
            {
                "action": "greengrass:UpdateLoggerDefinition",
                "resource_mappings": {
                    "LoggerDefinitionId": {
                        "template": "${LoggerDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.UpdateResourceDefinition": [
            {
                "action": "greengrass:UpdateResourceDefinition",
                "resource_mappings": {
                    "ResourceDefinitionId": {
                        "template": "${ResourceDefinitionId}"
                    }
                }
            }
        ],
        "Greengrass.UpdateSubscriptionDefinition": [
            {
                "action": "greengrass:UpdateSubscriptionDefinition",
                "resource_mappings": {
                    "SubscriptionDefinitionId": {
                        "template": "${SubscriptionDefinitionId}"
                    }
                }
            }
        ],
        "DAX.CreateCluster": [
            {
                "action": "dax:CreateCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    }
                }
            },
            {
                "action": "dax:CreateParameterGroup",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "DAX.CreateParameterGroup": [
            {
                "action": "dax:CreateParameterGroup",
                "resource_mappings": {}
            }
        ],
        "DAX.CreateSubnetGroup": [
            {
                "action": "dax:CreateSubnetGroup",
                "resource_mappings": {}
            }
        ],
        "DAX.DecreaseReplicationFactor": [
            {
                "action": "dax:DecreaseReplicationFactor",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    }
                }
            }
        ],
        "DAX.DeleteCluster": [
            {
                "action": "dax:DeleteCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    }
                }
            }
        ],
        "DAX.DeleteParameterGroup": [
            {
                "action": "dax:DeleteParameterGroup",
                "resource_mappings": {}
            }
        ],
        "DAX.DeleteSubnetGroup": [
            {
                "action": "dax:DeleteSubnetGroup",
                "resource_mappings": {}
            }
        ],
        "DAX.DescribeClusters": [
            {
                "action": "dax:DescribeClusters",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterNames[]}"
                    }
                }
            }
        ],
        "DAX.DescribeDefaultParameters": [
            {
                "action": "dax:DescribeDefaultParameters",
                "resource_mappings": {}
            }
        ],
        "DAX.DescribeEvents": [
            {
                "action": "dax:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "DAX.DescribeParameterGroups": [
            {
                "action": "dax:DescribeParameterGroups",
                "resource_mappings": {}
            }
        ],
        "DAX.DescribeParameters": [
            {
                "action": "dax:DescribeParameters",
                "resource_mappings": {}
            }
        ],
        "DAX.DescribeSubnetGroups": [
            {
                "action": "dax:DescribeSubnetGroups",
                "resource_mappings": {}
            }
        ],
        "DAX.IncreaseReplicationFactor": [
            {
                "action": "dax:IncreaseReplicationFactor",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    }
                }
            }
        ],
        "DAX.ListTags": [
            {
                "action": "dax:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "DAX.RebootNode": [
            {
                "action": "dax:RebootNode",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    }
                }
            }
        ],
        "DAX.TagResource": [
            {
                "action": "dax:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "DAX.UntagResource": [
            {
                "action": "dax:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "DAX.UpdateCluster": [
            {
                "action": "dax:UpdateCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    }
                }
            }
        ],
        "DAX.UpdateParameterGroup": [
            {
                "action": "dax:UpdateParameterGroup",
                "resource_mappings": {}
            }
        ],
        "DAX.UpdateSubnetGroup": [
            {
                "action": "dax:UpdateSubnetGroup",
                "resource_mappings": {}
            }
        ],
        "MigrationHub.AssociateCreatedArtifact": [
            {
                "action": "mgh:AssociateCreatedArtifact",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "MigrationHub.AssociateDiscoveredResource": [
            {
                "action": "mgh:AssociateDiscoveredResource",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "MigrationHub.CreateProgressUpdateStream": [
            {
                "action": "mgh:CreateProgressUpdateStream",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStreamName}"
                    }
                }
            }
        ],
        "MigrationHub.DeleteProgressUpdateStream": [
            {
                "action": "mgh:DeleteProgressUpdateStream",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStreamName}"
                    }
                }
            }
        ],
        "MigrationHub.DescribeApplicationState": [
            {
                "action": "mgh:DescribeApplicationState",
                "resource_mappings": {}
            }
        ],
        "MigrationHub.DescribeMigrationTask": [
            {
                "action": "mgh:DescribeMigrationTask",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "MigrationHub.DisassociateCreatedArtifact": [
            {
                "action": "mgh:DisassociateCreatedArtifact",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "MigrationHub.DisassociateDiscoveredResource": [
            {
                "action": "mgh:DisassociateDiscoveredResource",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "MigrationHub.ImportMigrationTask": [
            {
                "action": "mgh:ImportMigrationTask",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "MigrationHub.ListCreatedArtifacts": [
            {
                "action": "mgh:ListCreatedArtifacts",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "MigrationHub.ListDiscoveredResources": [
            {
                "action": "mgh:ListDiscoveredResources",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "MigrationHub.ListMigrationTasks": [
            {
                "action": "mgh:ListMigrationTasks",
                "resource_mappings": {}
            }
        ],
        "MigrationHub.ListProgressUpdateStreams": [
            {
                "action": "mgh:ListProgressUpdateStreams",
                "resource_mappings": {}
            }
        ],
        "MigrationHub.NotifyApplicationState": [
            {
                "action": "mgh:NotifyApplicationState",
                "resource_mappings": {}
            }
        ],
        "MigrationHub.NotifyMigrationTaskState": [
            {
                "action": "mgh:NotifyMigrationTaskState",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "MigrationHub.PutResourceAttributes": [
            {
                "action": "mgh:PutResourceAttributes",
                "resource_mappings": {
                    "Stream": {
                        "template": "${ProgressUpdateStream}"
                    },
                    "Task": {
                        "template": "${MigrationTaskName}"
                    }
                }
            }
        ],
        "CloudHSMV2.CopyBackupToRegion": [
            {
                "action": "cloudhsm:CopyBackupToRegion",
                "resource_mappings": {
                    "CloudHsmBackupInstanceName": {
                        "template": "${BackupId}"
                    }
                }
            }
        ],
        "CloudHSMV2.CreateCluster": [
            {
                "action": "cloudhsm:CreateCluster",
                "resource_mappings": {
                    "CloudHsmBackupInstanceName": {
                        "template": "${SourceBackupId}"
                    }
                }
            }
        ],
        "CloudHSMV2.CreateHsm": [
            {
                "action": "cloudhsm:CreateHsm",
                "resource_mappings": {
                    "CloudHsmClusterInstanceName": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "CloudHSMV2.DeleteBackup": [
            {
                "action": "cloudhsm:DeleteBackup",
                "resource_mappings": {
                    "CloudHsmBackupInstanceName": {
                        "template": "${BackupId}"
                    }
                }
            }
        ],
        "CloudHSMV2.DeleteCluster": [
            {
                "action": "cloudhsm:DeleteCluster",
                "resource_mappings": {
                    "CloudHsmClusterInstanceName": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "CloudHSMV2.DeleteHsm": [
            {
                "action": "cloudhsm:DeleteHsm",
                "resource_mappings": {}
            }
        ],
        "CloudHSMV2.DescribeBackups": [
            {
                "action": "cloudhsm:DescribeBackups",
                "resource_mappings": {}
            }
        ],
        "CloudHSMV2.DescribeClusters": [
            {
                "action": "cloudhsm:DescribeClusters",
                "resource_mappings": {}
            }
        ],
        "CloudHSMV2.InitializeCluster": [
            {
                "action": "cloudhsm:InitializeCluster",
                "resource_mappings": {
                    "CloudHsmClusterInstanceName": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "CloudHSMV2.ListTags": [
            {
                "action": "cloudhsm:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "backup": "%%iftemplatematch%${ResourceId}%%",
                    "cluster": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "CloudHSMV2.RestoreBackup": [
            {
                "action": "cloudhsm:RestoreBackup",
                "resource_mappings": {
                    "CloudHsmBackupInstanceName": {
                        "template": "${BackupId}"
                    }
                }
            }
        ],
        "CloudHSMV2.TagResource": [
            {
                "action": "cloudhsm:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "backup": "%%iftemplatematch%${ResourceId}%%",
                    "cluster": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "CloudHSMV2.UntagResource": [
            {
                "action": "cloudhsm:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "backup": "%%iftemplatematch%${ResourceId}%%",
                    "cluster": "%%iftemplatematch%${ResourceId}%%"
                }
            }
        ],
        "Glue.BatchCreatePartition": [
            {
                "action": "glue:BatchCreatePartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.BatchDeleteConnection": [
            {
                "action": "glue:BatchDeleteConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${ConnectionNameList[]}"
                    }
                }
            }
        ],
        "Glue.BatchDeletePartition": [
            {
                "action": "glue:BatchDeletePartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.BatchDeleteTable": [
            {
                "action": "glue:BatchDeleteTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TablesToDelete[]}"
                    }
                }
            }
        ],
        "Glue.BatchDeleteTableVersion": [
            {
                "action": "glue:BatchDeleteTableVersion",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    },
                    "TableVersionName": {
                        "template": "${VersionIds[]}"
                    }
                }
            }
        ],
        "Glue.BatchGetCrawlers": [
            {
                "action": "glue:BatchGetCrawlers",
                "resource_mappings": {}
            }
        ],
        "Glue.BatchGetDevEndpoints": [
            {
                "action": "glue:BatchGetDevEndpoints",
                "resource_mappings": {}
            }
        ],
        "Glue.BatchGetJobs": [
            {
                "action": "glue:BatchGetJobs",
                "resource_mappings": {}
            }
        ],
        "Glue.BatchGetPartition": [
            {
                "action": "glue:BatchGetPartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.BatchGetTriggers": [
            {
                "action": "glue:BatchGetTriggers",
                "resource_mappings": {}
            }
        ],
        "Glue.BatchGetWorkflows": [
            {
                "action": "glue:BatchGetWorkflows",
                "resource_mappings": {}
            }
        ],
        "Glue.BatchStopJobRun": [
            {
                "action": "glue:BatchStopJobRun",
                "resource_mappings": {}
            }
        ],
        "Glue.CancelMLTaskRun": [
            {
                "action": "glue:CancelMLTaskRun",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            }
        ],
        "Glue.CheckSchemaVersionValidity": [
            {
                "action": "glue:CheckSchemaVersionValidity",
                "resource_mappings": {}
            }
        ],
        "Glue.CreateClassifier": [
            {
                "action": "glue:CreateClassifier",
                "resource_mappings": {}
            }
        ],
        "Glue.CreateConnection": [
            {
                "action": "glue:CreateConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${ConnectionInput.Name}"
                    }
                }
            }
        ],
        "Glue.CreateCrawler": [
            {
                "action": "glue:CreateCrawler",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/%%regex%${Role}%/(?:arn.*/)?(.+)/g%%"
                }
            }
        ],
        "Glue.CreateDatabase": [
            {
                "action": "glue:CreateDatabase",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseInput.Name}"
                    }
                }
            }
        ],
        "Glue.CreateDevEndpoint": [
            {
                "action": "glue:CreateDevEndpoint",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Glue.CreateJob": [
            {
                "action": "glue:CreateJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/%%regex%${Role}%/(?:arn.*/)?(.+)/g%%"
                }
            }
        ],
        "Glue.CreateMLTransform": [
            {
                "action": "glue:CreateMLTransform",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/%%regex%${Role}%/(?:arn.*/)?(.+)/g%%"
                }
            }
        ],
        "Glue.CreatePartition": [
            {
                "action": "glue:CreatePartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.CreateRegistry": [
            {
                "action": "glue:CreateRegistry",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    }
                }
            }
        ],
        "Glue.CreateSchema": [
            {
                "action": "glue:CreateSchema",
                "resource_mappings": {
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                },
                "resourcearn_mappings": {
                    "registry": "${RegistryId.RegistryArn}"
                }
            }
        ],
        "Glue.CreateScript": [
            {
                "action": "glue:CreateScript",
                "resource_mappings": {}
            }
        ],
        "Glue.CreateSecurityConfiguration": [
            {
                "action": "glue:CreateSecurityConfiguration",
                "resource_mappings": {}
            }
        ],
        "Glue.CreateTable": [
            {
                "action": "glue:CreateTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableInput.Name}"
                    }
                }
            }
        ],
        "Glue.CreateTrigger": [
            {
                "action": "glue:CreateTrigger",
                "resource_mappings": {}
            }
        ],
        "Glue.CreateUserDefinedFunction": [
            {
                "action": "glue:CreateUserDefinedFunction",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "UserDefinedFunctionName": {
                        "template": "${FunctionInput.FunctionName}"
                    }
                }
            }
        ],
        "Glue.CreateWorkflow": [
            {
                "action": "glue:CreateWorkflow",
                "resource_mappings": {}
            }
        ],
        "Glue.DeleteClassifier": [
            {
                "action": "glue:DeleteClassifier",
                "resource_mappings": {}
            }
        ],
        "Glue.DeleteConnection": [
            {
                "action": "glue:DeleteConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${ConnectionName}"
                    }
                }
            }
        ],
        "Glue.DeleteCrawler": [
            {
                "action": "glue:DeleteCrawler",
                "resource_mappings": {}
            }
        ],
        "Glue.DeleteDatabase": [
            {
                "action": "glue:DeleteDatabase",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Glue.DeleteDevEndpoint": [
            {
                "action": "glue:DeleteDevEndpoint",
                "resource_mappings": {}
            }
        ],
        "Glue.DeleteJob": [
            {
                "action": "glue:DeleteJob",
                "resource_mappings": {}
            }
        ],
        "Glue.DeleteMLTransform": [
            {
                "action": "glue:DeleteMLTransform",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            }
        ],
        "Glue.DeletePartition": [
            {
                "action": "glue:DeletePartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.DeleteRegistry": [
            {
                "action": "glue:DeleteRegistry",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "registry": "${RegistryId.RegistryArn}"
                }
            }
        ],
        "Glue.DeleteResourcePolicy": [
            {
                "action": "glue:DeleteResourcePolicy",
                "resource_mappings": {}
            }
        ],
        "Glue.DeleteSchema": [
            {
                "action": "glue:DeleteSchema",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.DeleteSchemaVersions": [
            {
                "action": "glue:DeleteSchemaVersions",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.DeleteSecurityConfiguration": [
            {
                "action": "glue:DeleteSecurityConfiguration",
                "resource_mappings": {}
            }
        ],
        "Glue.DeleteTable": [
            {
                "action": "glue:DeleteTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Glue.DeleteTableVersion": [
            {
                "action": "glue:DeleteTableVersion",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    },
                    "TableVersionName": {
                        "template": "${VersionId}"
                    }
                }
            }
        ],
        "Glue.DeleteTrigger": [
            {
                "action": "glue:DeleteTrigger",
                "resource_mappings": {}
            }
        ],
        "Glue.DeleteUserDefinedFunction": [
            {
                "action": "glue:DeleteUserDefinedFunction",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "UserDefinedFunctionName": {
                        "template": "${FunctionName}"
                    }
                }
            }
        ],
        "Glue.DeleteWorkflow": [
            {
                "action": "glue:DeleteWorkflow",
                "resource_mappings": {}
            }
        ],
        "Glue.GetCatalogImportStatus": [
            {
                "action": "glue:GetCatalogImportStatus",
                "resource_mappings": {}
            }
        ],
        "Glue.GetClassifier": [
            {
                "action": "glue:GetClassifier",
                "resource_mappings": {}
            }
        ],
        "Glue.GetClassifiers": [
            {
                "action": "glue:GetClassifiers",
                "resource_mappings": {}
            }
        ],
        "Glue.GetConnection": [
            {
                "action": "glue:GetConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Glue.GetConnections": [
            {
                "action": "glue:GetConnections",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Glue.GetCrawler": [
            {
                "action": "glue:GetCrawler",
                "resource_mappings": {}
            }
        ],
        "Glue.GetCrawlerMetrics": [
            {
                "action": "glue:GetCrawlerMetrics",
                "resource_mappings": {}
            }
        ],
        "Glue.GetCrawlers": [
            {
                "action": "glue:GetCrawlers",
                "resource_mappings": {}
            }
        ],
        "Glue.GetDataCatalogEncryptionSettings": [
            {
                "action": "glue:GetDataCatalogEncryptionSettings",
                "resource_mappings": {}
            }
        ],
        "Glue.GetDatabase": [
            {
                "action": "glue:GetDatabase",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Glue.GetDatabases": [
            {
                "action": "glue:GetDatabases",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Glue.GetDataflowGraph": [
            {
                "action": "glue:GetDataflowGraph",
                "resource_mappings": {}
            }
        ],
        "Glue.GetDevEndpoint": [
            {
                "action": "glue:GetDevEndpoint",
                "resource_mappings": {}
            }
        ],
        "Glue.GetDevEndpoints": [
            {
                "action": "glue:GetDevEndpoints",
                "resource_mappings": {}
            }
        ],
        "Glue.GetJob": [
            {
                "action": "glue:GetJob",
                "resource_mappings": {}
            }
        ],
        "Glue.GetJobBookmark": [
            {
                "action": "glue:GetJobBookmark",
                "resource_mappings": {}
            }
        ],
        "Glue.GetJobRun": [
            {
                "action": "glue:GetJobRun",
                "resource_mappings": {}
            }
        ],
        "Glue.GetJobRuns": [
            {
                "action": "glue:GetJobRuns",
                "resource_mappings": {}
            }
        ],
        "Glue.GetJobs": [
            {
                "action": "glue:GetJobs",
                "resource_mappings": {}
            }
        ],
        "Glue.GetMLTaskRun": [
            {
                "action": "glue:GetMLTaskRun",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            }
        ],
        "Glue.GetMLTaskRuns": [
            {
                "action": "glue:GetMLTaskRuns",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            }
        ],
        "Glue.GetMLTransform": [
            {
                "action": "glue:GetMLTransform",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            }
        ],
        "Glue.GetMLTransforms": [
            {
                "action": "glue:GetMLTransforms",
                "resource_mappings": {}
            }
        ],
        "Glue.GetMapping": [
            {
                "action": "glue:GetMapping",
                "resource_mappings": {}
            }
        ],
        "Glue.GetPartition": [
            {
                "action": "glue:GetPartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.GetPartitions": [
            {
                "action": "glue:GetPartitions",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.GetPlan": [
            {
                "action": "glue:GetPlan",
                "resource_mappings": {}
            }
        ],
        "Glue.GetRegistry": [
            {
                "action": "glue:GetRegistry",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "registry": "${RegistryId.RegistryArn}"
                }
            }
        ],
        "Glue.GetResourcePolicies": [
            {
                "action": "glue:GetResourcePolicies",
                "resource_mappings": {}
            }
        ],
        "Glue.GetResourcePolicy": [
            {
                "action": "glue:GetResourcePolicy",
                "resource_mappings": {}
            }
        ],
        "Glue.GetSchema": [
            {
                "action": "glue:GetSchema",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.GetSchemaByDefinition": [
            {
                "action": "glue:GetSchemaByDefinition",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.GetSchemaVersion": [
            {
                "action": "glue:GetSchemaVersion",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.GetSchemaVersionsDiff": [
            {
                "action": "glue:GetSchemaVersionsDiff",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.GetSecurityConfiguration": [
            {
                "action": "glue:GetSecurityConfiguration",
                "resource_mappings": {}
            }
        ],
        "Glue.GetSecurityConfigurations": [
            {
                "action": "glue:GetSecurityConfigurations",
                "resource_mappings": {}
            }
        ],
        "Glue.GetTable": [
            {
                "action": "glue:GetTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Glue.GetTableVersion": [
            {
                "action": "glue:GetTableVersion",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    },
                    "TableVersionName": {
                        "template": "${VersionId}"
                    }
                }
            }
        ],
        "Glue.GetTableVersions": [
            {
                "action": "glue:GetTableVersions",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    },
                    "TableVersionName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Glue.GetTables": [
            {
                "action": "glue:GetTables",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Glue.GetTags": [
            {
                "action": "glue:GetTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "crawler": "%%iftemplatematch%${ResourceArn}%%",
                    "devendpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "job": "%%iftemplatematch%${ResourceArn}%%",
                    "trigger": "%%iftemplatematch%${ResourceArn}%%",
                    "workflow": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Glue.GetTrigger": [
            {
                "action": "glue:GetTrigger",
                "resource_mappings": {}
            }
        ],
        "Glue.GetTriggers": [
            {
                "action": "glue:GetTriggers",
                "resource_mappings": {}
            }
        ],
        "Glue.GetUserDefinedFunction": [
            {
                "action": "glue:GetUserDefinedFunction",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "UserDefinedFunctionName": {
                        "template": "${FunctionName}"
                    }
                }
            }
        ],
        "Glue.GetUserDefinedFunctions": [
            {
                "action": "glue:GetUserDefinedFunctions",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "UserDefinedFunctionName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Glue.GetWorkflow": [
            {
                "action": "glue:GetWorkflow",
                "resource_mappings": {}
            }
        ],
        "Glue.GetWorkflowRun": [
            {
                "action": "glue:GetWorkflowRun",
                "resource_mappings": {}
            }
        ],
        "Glue.GetWorkflowRunProperties": [
            {
                "action": "glue:GetWorkflowRunProperties",
                "resource_mappings": {}
            }
        ],
        "Glue.GetWorkflowRuns": [
            {
                "action": "glue:GetWorkflowRuns",
                "resource_mappings": {}
            }
        ],
        "Glue.ImportCatalogToGlue": [
            {
                "action": "glue:ImportCatalogToGlue",
                "resource_mappings": {}
            }
        ],
        "Glue.ListCrawlers": [
            {
                "action": "glue:ListCrawlers",
                "resource_mappings": {}
            }
        ],
        "Glue.ListDevEndpoints": [
            {
                "action": "glue:ListDevEndpoints",
                "resource_mappings": {}
            }
        ],
        "Glue.ListJobs": [
            {
                "action": "glue:ListJobs",
                "resource_mappings": {}
            }
        ],
        "Glue.ListMLTransforms": [
            {
                "action": "glue:ListMLTransforms",
                "resource_mappings": {}
            }
        ],
        "Glue.ListRegistries": [
            {
                "action": "glue:ListRegistries",
                "resource_mappings": {}
            }
        ],
        "Glue.ListSchemaVersions": [
            {
                "action": "glue:ListSchemaVersions",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.ListSchemas": [
            {
                "action": "glue:ListSchemas",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "registry": "${RegistryId.RegistryArn}"
                }
            }
        ],
        "Glue.ListTriggers": [
            {
                "action": "glue:ListTriggers",
                "resource_mappings": {}
            }
        ],
        "Glue.ListWorkflows": [
            {
                "action": "glue:ListWorkflows",
                "resource_mappings": {}
            }
        ],
        "Glue.PutDataCatalogEncryptionSettings": [
            {
                "action": "glue:PutDataCatalogEncryptionSettings",
                "resource_mappings": {}
            }
        ],
        "Glue.PutResourcePolicy": [
            {
                "action": "glue:PutResourcePolicy",
                "resource_mappings": {}
            }
        ],
        "Glue.PutSchemaVersionMetadata": [
            {
                "action": "glue:PutSchemaVersionMetadata",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.PutWorkflowRunProperties": [
            {
                "action": "glue:PutWorkflowRunProperties",
                "resource_mappings": {}
            }
        ],
        "Glue.QuerySchemaVersionMetadata": [
            {
                "action": "glue:QuerySchemaVersionMetadata",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.RegisterSchemaVersion": [
            {
                "action": "glue:RegisterSchemaVersion",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.RemoveSchemaVersionMetadata": [
            {
                "action": "glue:RemoveSchemaVersionMetadata",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.ResetJobBookmark": [
            {
                "action": "glue:ResetJobBookmark",
                "resource_mappings": {}
            }
        ],
        "Glue.SearchTables": [
            {
                "action": "glue:SearchTables",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "*"
                    },
                    "TableName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Glue.StartCrawler": [
            {
                "action": "glue:StartCrawler",
                "resource_mappings": {}
            }
        ],
        "Glue.StartCrawlerSchedule": [
            {
                "action": "glue:StartCrawlerSchedule",
                "resource_mappings": {}
            }
        ],
        "Glue.StartExportLabelsTaskRun": [
            {
                "action": "glue:StartExportLabelsTaskRun",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            }
        ],
        "Glue.StartImportLabelsTaskRun": [
            {
                "action": "glue:StartImportLabelsTaskRun",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            }
        ],
        "Glue.StartJobRun": [
            {
                "action": "glue:StartJobRun",
                "resource_mappings": {}
            }
        ],
        "Glue.StartMLEvaluationTaskRun": [
            {
                "action": "glue:StartMLEvaluationTaskRun",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            }
        ],
        "Glue.StartMLLabelingSetGenerationTaskRun": [
            {
                "action": "glue:StartMLLabelingSetGenerationTaskRun",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            }
        ],
        "Glue.StartTrigger": [
            {
                "action": "glue:StartTrigger",
                "resource_mappings": {}
            }
        ],
        "Glue.StartWorkflowRun": [
            {
                "action": "glue:StartWorkflowRun",
                "resource_mappings": {}
            }
        ],
        "Glue.StopCrawler": [
            {
                "action": "glue:StopCrawler",
                "resource_mappings": {}
            }
        ],
        "Glue.StopCrawlerSchedule": [
            {
                "action": "glue:StopCrawlerSchedule",
                "resource_mappings": {}
            }
        ],
        "Glue.StopTrigger": [
            {
                "action": "glue:StopTrigger",
                "resource_mappings": {}
            }
        ],
        "Glue.TagResource": [
            {
                "action": "glue:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "crawler": "%%iftemplatematch%${ResourceArn}%%",
                    "devendpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "job": "%%iftemplatematch%${ResourceArn}%%",
                    "trigger": "%%iftemplatematch%${ResourceArn}%%",
                    "workflow": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Glue.UntagResource": [
            {
                "action": "glue:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "crawler": "%%iftemplatematch%${ResourceArn}%%",
                    "devendpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "job": "%%iftemplatematch%${ResourceArn}%%",
                    "trigger": "%%iftemplatematch%${ResourceArn}%%",
                    "workflow": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Glue.UpdateClassifier": [
            {
                "action": "glue:UpdateClassifier",
                "resource_mappings": {}
            }
        ],
        "Glue.UpdateConnection": [
            {
                "action": "glue:UpdateConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "%%many%${Name}%${ConnectionInput.Name}%%"
                    }
                }
            }
        ],
        "Glue.UpdateCrawler": [
            {
                "action": "glue:UpdateCrawler",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/%%regex%${Role}%/(?:arn.*/)?(.+)/g%%"
                }
            }
        ],
        "Glue.UpdateCrawlerSchedule": [
            {
                "action": "glue:UpdateCrawlerSchedule",
                "resource_mappings": {}
            }
        ],
        "Glue.UpdateDatabase": [
            {
                "action": "glue:UpdateDatabase",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "%%many%${Name}%${DatabaseInput.Name}%%"
                    }
                }
            }
        ],
        "Glue.UpdateDevEndpoint": [
            {
                "action": "glue:UpdateDevEndpoint",
                "resource_mappings": {}
            }
        ],
        "Glue.UpdateJob": [
            {
                "action": "glue:UpdateJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/%%regex%${JobUpdate.Role}%/(?:arn.*/)?(.+)/g%%"
                }
            }
        ],
        "Glue.UpdateMLTransform": [
            {
                "action": "glue:UpdateMLTransform",
                "resource_mappings": {
                    "TransformId": {
                        "template": "${TransformId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "arn:${Partition}:iam::${Account}:role/%%regex%${Role}%/(?:arn.*/)?(.+)/g%%"
                }
            }
        ],
        "Glue.UpdatePartition": [
            {
                "action": "glue:UpdatePartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.UpdateRegistry": [
            {
                "action": "glue:UpdateRegistry",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "registry": "${RegistryId.RegistryArn}"
                }
            }
        ],
        "Glue.UpdateSchema": [
            {
                "action": "glue:UpdateSchema",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${SchemaId.RegistryName}"
                    }
                },
                "resourcearn_mappings": {
                    "schema": "${SchemaId.SchemaArn}"
                }
            }
        ],
        "Glue.UpdateTable": [
            {
                "action": "glue:UpdateTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "%%many%${DatabaseName}%${TableInput.TargetTable.DatabaseName}%%"
                    },
                    "TableName": {
                        "template": "%%many%${TableInput.Name}%${TableInput.TargetTable.Name}%%"
                    }
                }
            }
        ],
        "Glue.UpdateTrigger": [
            {
                "action": "glue:UpdateTrigger",
                "resource_mappings": {}
            }
        ],
        "Glue.UpdateUserDefinedFunction": [
            {
                "action": "glue:UpdateUserDefinedFunction",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "UserDefinedFunctionName": {
                        "template": "%%many%${FunctionName}%${FunctionInput.FunctionName}%%"
                    }
                }
            }
        ],
        "Glue.UpdateWorkflow": [
            {
                "action": "glue:UpdateWorkflow",
                "resource_mappings": {}
            }
        ],
        "Mobile.CreateProject": [
            {
                "action": "mobilehub:CreateProject",
                "resource_mappings": {}
            }
        ],
        "Mobile.DeleteProject": [
            {
                "action": "mobilehub:DeleteProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "Mobile.DescribeBundle": [
            {
                "action": "mobilehub:DescribeBundle",
                "resource_mappings": {}
            }
        ],
        "Mobile.ExportBundle": [
            {
                "action": "mobilehub:ExportBundle",
                "resource_mappings": {}
            }
        ],
        "Mobile.ExportProject": [
            {
                "action": "mobilehub:ExportProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "Mobile.ListBundles": [
            {
                "action": "mobilehub:ListBundles",
                "resource_mappings": {}
            }
        ],
        "Mobile.ListProjects": [
            {
                "action": "mobilehub:ListProjects",
                "resource_mappings": {}
            }
        ],
        "Mobile.UpdateProject": [
            {
                "action": "mobilehub:UpdateProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "Pricing.DescribeServices": [
            {
                "action": "pricing:DescribeServices",
                "resource_mappings": {}
            }
        ],
        "Pricing.GetAttributeValues": [
            {
                "action": "pricing:GetAttributeValues",
                "resource_mappings": {}
            }
        ],
        "Pricing.GetProducts": [
            {
                "action": "pricing:GetProducts",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.CreateAnomalySubscription": [
            {
                "action": "ce:CreateAnomalySubscription",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.DeleteAnomalyMonitor": [
            {
                "action": "ce:DeleteAnomalyMonitor",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.DeleteAnomalySubscription": [
            {
                "action": "ce:DeleteAnomalySubscription",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.DeleteCostCategoryDefinition": [
            {
                "action": "ce:DeleteCostCategoryDefinition",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.DescribeCostCategoryDefinition": [
            {
                "action": "ce:DescribeCostCategoryDefinition",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetAnomalies": [
            {
                "action": "ce:GetAnomalies",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetAnomalyMonitors": [
            {
                "action": "ce:GetAnomalyMonitors",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetAnomalySubscriptions": [
            {
                "action": "ce:GetAnomalySubscriptions",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.ListCostCategoryDefinitions": [
            {
                "action": "ce:ListCostCategoryDefinitions",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.ProvideAnomalyFeedback": [
            {
                "action": "ce:ProvideAnomalyFeedback",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.UpdateAnomalyMonitor": [
            {
                "action": "ce:UpdateAnomalyMonitor",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.UpdateAnomalySubscription": [
            {
                "action": "ce:UpdateAnomalySubscription",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.UpdateCostCategoryDefinition": [
            {
                "action": "ce:UpdateCostCategoryDefinition",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.AssociateCertificate": [
            {
                "action": "mediaconvert:AssociateCertificate",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.CancelJob": [
            {
                "action": "mediaconvert:CancelJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaConvert.CreateJob": [
            {
                "action": "mediaconvert:CreateJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "JobTemplate": "${JobTemplate}",
                    "Preset": "${Settings.OutputGroups[].Outputs[].Preset}",
                    "Queue": "%%many%${Queue}%${HopDestinations[].Queue}%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "MediaConvert.CreateJobTemplate": [
            {
                "action": "mediaconvert:CreateJobTemplate",
                "resource_mappings": {
                    "PresetName": {
                        "template": "*"
                    },
                    "QueueName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MediaConvert.CreatePreset": [
            {
                "action": "mediaconvert:CreatePreset",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.CreateQueue": [
            {
                "action": "mediaconvert:CreateQueue",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.DeleteJobTemplate": [
            {
                "action": "mediaconvert:DeleteJobTemplate",
                "resource_mappings": {
                    "JobTemplateName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaConvert.DeletePreset": [
            {
                "action": "mediaconvert:DeletePreset",
                "resource_mappings": {
                    "PresetName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaConvert.DeleteQueue": [
            {
                "action": "mediaconvert:DeleteQueue",
                "resource_mappings": {
                    "QueueName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaConvert.DescribeEndpoints": [
            {
                "action": "mediaconvert:DescribeEndpoints",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.DisassociateCertificate": [
            {
                "action": "mediaconvert:DisassociateCertificate",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.GetJob": [
            {
                "action": "mediaconvert:GetJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaConvert.GetJobTemplate": [
            {
                "action": "mediaconvert:GetJobTemplate",
                "resource_mappings": {
                    "JobTemplateName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaConvert.GetPreset": [
            {
                "action": "mediaconvert:GetPreset",
                "resource_mappings": {
                    "PresetName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaConvert.GetQueue": [
            {
                "action": "mediaconvert:GetQueue",
                "resource_mappings": {
                    "QueueName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaConvert.ListJobTemplates": [
            {
                "action": "mediaconvert:ListJobTemplates",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.ListJobs": [
            {
                "action": "mediaconvert:ListJobs",
                "resource_mappings": {
                    "QueueName": {
                        "template": "${Queue}"
                    }
                }
            }
        ],
        "MediaConvert.ListPresets": [
            {
                "action": "mediaconvert:ListPresets",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.ListQueues": [
            {
                "action": "mediaconvert:ListQueues",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.ListTagsForResource": [
            {
                "action": "mediaconvert:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "JobTemplate": "%%iftemplatematch%${Arn}%%",
                    "Preset": "%%iftemplatematch%${Arn}%%",
                    "Queue": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "MediaConvert.TagResource": [
            {
                "action": "mediaconvert:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "JobTemplate": "%%iftemplatematch%${Arn}%%",
                    "Preset": "%%iftemplatematch%${Arn}%%",
                    "Queue": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "MediaConvert.UntagResource": [
            {
                "action": "mediaconvert:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "JobTemplate": "%%iftemplatematch%${Arn}%%",
                    "Preset": "%%iftemplatematch%${Arn}%%",
                    "Queue": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "MediaConvert.UpdateJobTemplate": [
            {
                "action": "mediaconvert:UpdateJobTemplate",
                "resource_mappings": {
                    "JobTemplateName": {
                        "template": "${Name}"
                    },
                    "PresetName": {
                        "template": "*"
                    },
                    "QueueName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MediaConvert.UpdatePreset": [
            {
                "action": "mediaconvert:UpdatePreset",
                "resource_mappings": {
                    "PresetName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaConvert.UpdateQueue": [
            {
                "action": "mediaconvert:UpdateQueue",
                "resource_mappings": {
                    "QueueName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaLive.AcceptInputDeviceTransfer": [
            {
                "action": "medialive:AcceptInputDeviceTransfer",
                "resource_mappings": {}
            }
        ],
        "MediaLive.BatchDelete": [
            {
                "action": "medialive:BatchDelete",
                "resource_mappings": {}
            }
        ],
        "MediaLive.BatchStart": [
            {
                "action": "medialive:BatchStart",
                "resource_mappings": {}
            }
        ],
        "MediaLive.BatchStop": [
            {
                "action": "medialive:BatchStop",
                "resource_mappings": {}
            }
        ],
        "MediaLive.BatchUpdateSchedule": [
            {
                "action": "medialive:BatchUpdateSchedule",
                "resource_mappings": {}
            }
        ],
        "MediaLive.CancelInputDeviceTransfer": [
            {
                "action": "medialive:CancelInputDeviceTransfer",
                "resource_mappings": {}
            }
        ],
        "MediaLive.CreateChannel": [
            {
                "action": "medialive:CreateChannel",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "MediaLive.CreateInput": [
            {
                "action": "medialive:CreateInput",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "MediaLive.CreateInputSecurityGroup": [
            {
                "action": "medialive:CreateInputSecurityGroup",
                "resource_mappings": {}
            }
        ],
        "MediaLive.CreateMultiplex": [
            {
                "action": "medialive:CreateMultiplex",
                "resource_mappings": {}
            }
        ],
        "MediaLive.CreateMultiplexProgram": [
            {
                "action": "medialive:CreateMultiplexProgram",
                "resource_mappings": {}
            }
        ],
        "MediaLive.CreateTags": [
            {
                "action": "medialive:CreateTags",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DeleteChannel": [
            {
                "action": "medialive:DeleteChannel",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DeleteInput": [
            {
                "action": "medialive:DeleteInput",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DeleteInputSecurityGroup": [
            {
                "action": "medialive:DeleteInputSecurityGroup",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DeleteMultiplex": [
            {
                "action": "medialive:DeleteMultiplex",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DeleteMultiplexProgram": [
            {
                "action": "medialive:DeleteMultiplexProgram",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DeleteReservation": [
            {
                "action": "medialive:DeleteReservation",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DeleteSchedule": [
            {
                "action": "medialive:DeleteSchedule",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DeleteTags": [
            {
                "action": "medialive:DeleteTags",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeChannel": [
            {
                "action": "medialive:DescribeChannel",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeInput": [
            {
                "action": "medialive:DescribeInput",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeInputDevice": [
            {
                "action": "medialive:DescribeInputDevice",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeInputDeviceThumbnail": [
            {
                "action": "medialive:DescribeInputDeviceThumbnail",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeInputSecurityGroup": [
            {
                "action": "medialive:DescribeInputSecurityGroup",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeMultiplex": [
            {
                "action": "medialive:DescribeMultiplex",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeMultiplexProgram": [
            {
                "action": "medialive:DescribeMultiplexProgram",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeOffering": [
            {
                "action": "medialive:DescribeOffering",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeReservation": [
            {
                "action": "medialive:DescribeReservation",
                "resource_mappings": {}
            }
        ],
        "MediaLive.DescribeSchedule": [
            {
                "action": "medialive:DescribeSchedule",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListChannels": [
            {
                "action": "medialive:ListChannels",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListInputDeviceTransfers": [
            {
                "action": "medialive:ListInputDeviceTransfers",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListInputDevices": [
            {
                "action": "medialive:ListInputDevices",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListInputSecurityGroups": [
            {
                "action": "medialive:ListInputSecurityGroups",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListInputs": [
            {
                "action": "medialive:ListInputs",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListMultiplexPrograms": [
            {
                "action": "medialive:ListMultiplexPrograms",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListMultiplexes": [
            {
                "action": "medialive:ListMultiplexes",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListOfferings": [
            {
                "action": "medialive:ListOfferings",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListReservations": [
            {
                "action": "medialive:ListReservations",
                "resource_mappings": {}
            }
        ],
        "MediaLive.ListTagsForResource": [
            {
                "action": "medialive:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "MediaLive.PurchaseOffering": [
            {
                "action": "medialive:PurchaseOffering",
                "resource_mappings": {}
            }
        ],
        "MediaLive.RejectInputDeviceTransfer": [
            {
                "action": "medialive:RejectInputDeviceTransfer",
                "resource_mappings": {}
            }
        ],
        "MediaLive.StartChannel": [
            {
                "action": "medialive:StartChannel",
                "resource_mappings": {}
            }
        ],
        "MediaLive.StartMultiplex": [
            {
                "action": "medialive:StartMultiplex",
                "resource_mappings": {}
            }
        ],
        "MediaLive.StopChannel": [
            {
                "action": "medialive:StopChannel",
                "resource_mappings": {}
            }
        ],
        "MediaLive.StopMultiplex": [
            {
                "action": "medialive:StopMultiplex",
                "resource_mappings": {}
            }
        ],
        "MediaLive.TransferInputDevice": [
            {
                "action": "medialive:TransferInputDevice",
                "resource_mappings": {}
            }
        ],
        "MediaLive.UpdateChannel": [
            {
                "action": "medialive:UpdateChannel",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "MediaLive.UpdateChannelClass": [
            {
                "action": "medialive:UpdateChannelClass",
                "resource_mappings": {}
            }
        ],
        "MediaLive.UpdateInput": [
            {
                "action": "medialive:UpdateInput",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "MediaLive.UpdateInputDevice": [
            {
                "action": "medialive:UpdateInputDevice",
                "resource_mappings": {}
            }
        ],
        "MediaLive.UpdateInputSecurityGroup": [
            {
                "action": "medialive:UpdateInputSecurityGroup",
                "resource_mappings": {}
            }
        ],
        "MediaLive.UpdateMultiplex": [
            {
                "action": "medialive:UpdateMultiplex",
                "resource_mappings": {}
            }
        ],
        "MediaLive.UpdateMultiplexProgram": [
            {
                "action": "medialive:UpdateMultiplexProgram",
                "resource_mappings": {}
            }
        ],
        "MediaLive.UpdateReservation": [
            {
                "action": "medialive:UpdateReservation",
                "resource_mappings": {}
            }
        ],
        "MediaPackage.CreateChannel": [
            {
                "action": "mediapackage:CreateChannel",
                "resource_mappings": {}
            }
        ],
        "MediaPackage.CreateHarvestJob": [
            {
                "action": "mediapackage:CreateHarvestJob",
                "resource_mappings": {}
            }
        ],
        "MediaPackage.CreateOriginEndpoint": [
            {
                "action": "mediapackage:CreateOriginEndpoint",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${Authorization.SecretsRoleArn}%${CmafPackage.Encryption.SpekeKeyProvider.RoleArn}%${DashPackage.Encryption.SpekeKeyProvider.RoleArn}%${HlsPackage.Encryption.SpekeKeyProvider.RoleArn}%${MssPackage.Encryption.SpekeKeyProvider.RoleArn}%%"
                }
            }
        ],
        "MediaPackage.DeleteChannel": [
            {
                "action": "mediapackage:DeleteChannel",
                "resource_mappings": {
                    "ChannelIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackage.DeleteOriginEndpoint": [
            {
                "action": "mediapackage:DeleteOriginEndpoint",
                "resource_mappings": {
                    "OriginEndpointIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackage.DescribeChannel": [
            {
                "action": "mediapackage:DescribeChannel",
                "resource_mappings": {
                    "ChannelIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackage.DescribeHarvestJob": [
            {
                "action": "mediapackage:DescribeHarvestJob",
                "resource_mappings": {
                    "HarvestJobIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackage.DescribeOriginEndpoint": [
            {
                "action": "mediapackage:DescribeOriginEndpoint",
                "resource_mappings": {
                    "OriginEndpointIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackage.ListChannels": [
            {
                "action": "mediapackage:ListChannels",
                "resource_mappings": {}
            }
        ],
        "MediaPackage.ListHarvestJobs": [
            {
                "action": "mediapackage:ListHarvestJobs",
                "resource_mappings": {}
            }
        ],
        "MediaPackage.ListOriginEndpoints": [
            {
                "action": "mediapackage:ListOriginEndpoints",
                "resource_mappings": {}
            }
        ],
        "MediaPackage.ListTagsForResource": [
            {
                "action": "mediapackage:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channels": "%%iftemplatematch%${ResourceArn}%%",
                    "harvest_jobs": "%%iftemplatematch%${ResourceArn}%%",
                    "origin_endpoints": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MediaPackage.RotateIngestEndpointCredentials": [
            {
                "action": "mediapackage:RotateIngestEndpointCredentials",
                "resource_mappings": {
                    "ChannelIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackage.TagResource": [
            {
                "action": "mediapackage:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channels": "%%iftemplatematch%${ResourceArn}%%",
                    "harvest_jobs": "%%iftemplatematch%${ResourceArn}%%",
                    "origin_endpoints": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MediaPackage.UntagResource": [
            {
                "action": "mediapackage:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channels": "%%iftemplatematch%${ResourceArn}%%",
                    "harvest_jobs": "%%iftemplatematch%${ResourceArn}%%",
                    "origin_endpoints": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MediaPackage.UpdateChannel": [
            {
                "action": "mediapackage:UpdateChannel",
                "resource_mappings": {
                    "ChannelIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackage.UpdateOriginEndpoint": [
            {
                "action": "mediapackage:UpdateOriginEndpoint",
                "resource_mappings": {
                    "OriginEndpointIdentifier": {
                        "template": "${Id}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${Authorization.SecretsRoleArn}%${CmafPackage.Encryption.SpekeKeyProvider.RoleArn}%${DashPackage.Encryption.SpekeKeyProvider.RoleArn}%${HlsPackage.Encryption.SpekeKeyProvider.RoleArn}%${MssPackage.Encryption.SpekeKeyProvider.RoleArn}%%"
                }
            }
        ],
        "MediaStore.CreateContainer": [
            {
                "action": "mediastore:CreateContainer",
                "resource_mappings": {}
            }
        ],
        "MediaStore.DeleteContainer": [
            {
                "action": "mediastore:DeleteContainer",
                "resource_mappings": {}
            }
        ],
        "MediaStore.DeleteContainerPolicy": [
            {
                "action": "mediastore:DeleteContainerPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.DeleteCorsPolicy": [
            {
                "action": "mediastore:DeleteCorsPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.DeleteLifecyclePolicy": [
            {
                "action": "mediastore:DeleteLifecyclePolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.DeleteMetricPolicy": [
            {
                "action": "mediastore:DeleteMetricPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.DescribeContainer": [
            {
                "action": "mediastore:DescribeContainer",
                "resource_mappings": {}
            }
        ],
        "MediaStore.GetContainerPolicy": [
            {
                "action": "mediastore:GetContainerPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.GetCorsPolicy": [
            {
                "action": "mediastore:GetCorsPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.GetLifecyclePolicy": [
            {
                "action": "mediastore:GetLifecyclePolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.GetMetricPolicy": [
            {
                "action": "mediastore:GetMetricPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.ListContainers": [
            {
                "action": "mediastore:ListContainers",
                "resource_mappings": {}
            }
        ],
        "MediaStore.ListTagsForResource": [
            {
                "action": "mediastore:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "MediaStore.PutContainerPolicy": [
            {
                "action": "mediastore:PutContainerPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.PutCorsPolicy": [
            {
                "action": "mediastore:PutCorsPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.PutLifecyclePolicy": [
            {
                "action": "mediastore:PutLifecyclePolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.PutMetricPolicy": [
            {
                "action": "mediastore:PutMetricPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaStore.StartAccessLogging": [
            {
                "action": "mediastore:StartAccessLogging",
                "resource_mappings": {}
            }
        ],
        "MediaStore.StopAccessLogging": [
            {
                "action": "mediastore:StopAccessLogging",
                "resource_mappings": {}
            }
        ],
        "MediaStore.TagResource": [
            {
                "action": "mediastore:TagResource",
                "resource_mappings": {}
            }
        ],
        "MediaStore.UntagResource": [
            {
                "action": "mediastore:UntagResource",
                "resource_mappings": {}
            }
        ],
        "MediaStoreData.DeleteObject": [
            {
                "action": "mediastore:DeleteObject",
                "resource_mappings": {}
            }
        ],
        "MediaStoreData.DescribeObject": [
            {
                "action": "mediastore:DescribeObject",
                "resource_mappings": {}
            }
        ],
        "MediaStoreData.GetObject": [
            {
                "action": "mediastore:GetObject",
                "resource_mappings": {}
            }
        ],
        "MediaStoreData.ListItems": [
            {
                "action": "mediastore:ListItems",
                "resource_mappings": {}
            }
        ],
        "MediaStoreData.PutObject": [
            {
                "action": "mediastore:PutObject",
                "resource_mappings": {}
            }
        ],
        "AppSync.CreateApiKey": [
            {
                "action": "appsync:CreateApiKey",
                "resource_mappings": {}
            }
        ],
        "AppSync.CreateDataSource": [
            {
                "action": "appsync:CreateDataSource",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${serviceRoleArn}%${httpConfig.authorizationConfig.awsIamConfig.signingRegion}%${httpConfig.authorizationConfig.awsIamConfig.signingServiceName}%%"
                }
            }
        ],
        "AppSync.CreateFunction": [
            {
                "action": "appsync:CreateFunction",
                "resource_mappings": {}
            }
        ],
        "AppSync.CreateGraphqlApi": [
            {
                "action": "appsync:CreateGraphqlApi",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "*"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${logConfig.cloudWatchLogsRoleArn}"
                }
            }
        ],
        "AppSync.CreateResolver": [
            {
                "action": "appsync:CreateResolver",
                "resource_mappings": {}
            }
        ],
        "AppSync.CreateType": [
            {
                "action": "appsync:CreateType",
                "resource_mappings": {}
            }
        ],
        "AppSync.DeleteApiKey": [
            {
                "action": "appsync:DeleteApiKey",
                "resource_mappings": {}
            }
        ],
        "AppSync.DeleteDataSource": [
            {
                "action": "appsync:DeleteDataSource",
                "resource_mappings": {}
            }
        ],
        "AppSync.DeleteFunction": [
            {
                "action": "appsync:DeleteFunction",
                "resource_mappings": {}
            }
        ],
        "AppSync.DeleteGraphqlApi": [
            {
                "action": "appsync:DeleteGraphqlApi",
                "resource_mappings": {
                    "GraphQLAPIId": {
                        "template": "${apiId}"
                    }
                }
            }
        ],
        "AppSync.DeleteResolver": [
            {
                "action": "appsync:DeleteResolver",
                "resource_mappings": {}
            }
        ],
        "AppSync.DeleteType": [
            {
                "action": "appsync:DeleteType",
                "resource_mappings": {}
            }
        ],
        "AppSync.GetDataSource": [
            {
                "action": "appsync:GetDataSource",
                "resource_mappings": {}
            }
        ],
        "AppSync.GetFunction": [
            {
                "action": "appsync:GetFunction",
                "resource_mappings": {}
            }
        ],
        "AppSync.GetGraphqlApi": [
            {
                "action": "appsync:GetGraphqlApi",
                "resource_mappings": {
                    "GraphQLAPIId": {
                        "template": "${apiId}"
                    }
                }
            }
        ],
        "AppSync.GetIntrospectionSchema": [
            {
                "action": "appsync:GetIntrospectionSchema",
                "resource_mappings": {}
            }
        ],
        "AppSync.GetResolver": [
            {
                "action": "appsync:GetResolver",
                "resource_mappings": {}
            }
        ],
        "AppSync.GetSchemaCreationStatus": [
            {
                "action": "appsync:GetSchemaCreationStatus",
                "resource_mappings": {}
            }
        ],
        "AppSync.GetType": [
            {
                "action": "appsync:GetType",
                "resource_mappings": {}
            }
        ],
        "AppSync.ListApiKeys": [
            {
                "action": "appsync:ListApiKeys",
                "resource_mappings": {}
            }
        ],
        "AppSync.ListDataSources": [
            {
                "action": "appsync:ListDataSources",
                "resource_mappings": {}
            }
        ],
        "AppSync.ListFunctions": [
            {
                "action": "appsync:ListFunctions",
                "resource_mappings": {}
            }
        ],
        "AppSync.ListGraphqlApis": [
            {
                "action": "appsync:ListGraphqlApis",
                "resource_mappings": {}
            }
        ],
        "AppSync.ListResolvers": [
            {
                "action": "appsync:ListResolvers",
                "resource_mappings": {}
            }
        ],
        "AppSync.ListResolversByFunction": [
            {
                "action": "appsync:ListResolversByFunction",
                "resource_mappings": {}
            }
        ],
        "AppSync.ListTagsForResource": [
            {
                "action": "appsync:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "graphqlapi": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AppSync.ListTypes": [
            {
                "action": "appsync:ListTypes",
                "resource_mappings": {}
            }
        ],
        "AppSync.StartSchemaCreation": [
            {
                "action": "appsync:StartSchemaCreation",
                "resource_mappings": {}
            }
        ],
        "AppSync.TagResource": [
            {
                "action": "appsync:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "graphqlapi": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AppSync.UntagResource": [
            {
                "action": "appsync:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "graphqlapi": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AppSync.UpdateApiKey": [
            {
                "action": "appsync:UpdateApiKey",
                "resource_mappings": {}
            }
        ],
        "AppSync.UpdateDataSource": [
            {
                "action": "appsync:UpdateDataSource",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${serviceRoleArn}%${httpConfig.authorizationConfig.awsIamConfig.signingRegion}%${httpConfig.authorizationConfig.awsIamConfig.signingServiceName}%%"
                }
            }
        ],
        "AppSync.UpdateFunction": [
            {
                "action": "appsync:UpdateFunction",
                "resource_mappings": {}
            }
        ],
        "AppSync.UpdateGraphqlApi": [
            {
                "action": "appsync:UpdateGraphqlApi",
                "resource_mappings": {
                    "GraphQLAPIId": {
                        "template": "${apiId}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${logConfig.cloudWatchLogsRoleArn}"
                }
            }
        ],
        "AppSync.UpdateResolver": [
            {
                "action": "appsync:UpdateResolver",
                "resource_mappings": {}
            }
        ],
        "AppSync.UpdateType": [
            {
                "action": "appsync:UpdateType",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.AcceptInvitation": [
            {
                "action": "guardduty:AcceptInvitation",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.ArchiveFindings": [
            {
                "action": "guardduty:ArchiveFindings",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.CreateDetector": [
            {
                "action": "guardduty:CreateDetector",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.CreateFilter": [
            {
                "action": "guardduty:CreateFilter",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.CreateIPSet": [
            {
                "action": "guardduty:CreateIPSet",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.CreateMembers": [
            {
                "action": "guardduty:CreateMembers",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.CreatePublishingDestination": [
            {
                "action": "guardduty:CreatePublishingDestination",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "GuardDuty.CreateSampleFindings": [
            {
                "action": "guardduty:CreateSampleFindings",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.CreateThreatIntelSet": [
            {
                "action": "guardduty:CreateThreatIntelSet",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.DeclineInvitations": [
            {
                "action": "guardduty:DeclineInvitations",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.DeleteDetector": [
            {
                "action": "guardduty:DeleteDetector",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.DeleteFilter": [
            {
                "action": "guardduty:DeleteFilter",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "FilterName": {
                        "template": "${FilterName}"
                    }
                }
            }
        ],
        "GuardDuty.DeleteIPSet": [
            {
                "action": "guardduty:DeleteIPSet",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "IPSetId": {
                        "template": "${IpSetId}"
                    }
                }
            }
        ],
        "GuardDuty.DeleteInvitations": [
            {
                "action": "guardduty:DeleteInvitations",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.DeleteMembers": [
            {
                "action": "guardduty:DeleteMembers",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.DeletePublishingDestination": [
            {
                "action": "guardduty:DeletePublishingDestination",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "PublishingDestinationId": {
                        "template": "${DestinationId}"
                    }
                }
            }
        ],
        "GuardDuty.DeleteThreatIntelSet": [
            {
                "action": "guardduty:DeleteThreatIntelSet",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "ThreatIntelSetId": {
                        "template": "${ThreatIntelSetId}"
                    }
                }
            }
        ],
        "GuardDuty.DescribeOrganizationConfiguration": [
            {
                "action": "guardduty:DescribeOrganizationConfiguration",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.DescribePublishingDestination": [
            {
                "action": "guardduty:DescribePublishingDestination",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "PublishingDestinationId": {
                        "template": "${DestinationId}"
                    }
                }
            }
        ],
        "GuardDuty.DisableOrganizationAdminAccount": [
            {
                "action": "guardduty:DisableOrganizationAdminAccount",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.DisassociateFromMasterAccount": [
            {
                "action": "guardduty:DisassociateFromMasterAccount",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.DisassociateMembers": [
            {
                "action": "guardduty:DisassociateMembers",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.EnableOrganizationAdminAccount": [
            {
                "action": "guardduty:EnableOrganizationAdminAccount",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.GetDetector": [
            {
                "action": "guardduty:GetDetector",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.GetFilter": [
            {
                "action": "guardduty:GetFilter",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "FilterName": {
                        "template": "${FilterName}"
                    }
                }
            }
        ],
        "GuardDuty.GetFindings": [
            {
                "action": "guardduty:GetFindings",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.GetFindingsStatistics": [
            {
                "action": "guardduty:GetFindingsStatistics",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.GetIPSet": [
            {
                "action": "guardduty:GetIPSet",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "IPSetId": {
                        "template": "${IpSetId}"
                    }
                }
            }
        ],
        "GuardDuty.GetInvitationsCount": [
            {
                "action": "guardduty:GetInvitationsCount",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.GetMasterAccount": [
            {
                "action": "guardduty:GetMasterAccount",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.GetMembers": [
            {
                "action": "guardduty:GetMembers",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.GetThreatIntelSet": [
            {
                "action": "guardduty:GetThreatIntelSet",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "ThreatIntelSetId": {
                        "template": "${ThreatIntelSetId}"
                    }
                }
            }
        ],
        "GuardDuty.InviteMembers": [
            {
                "action": "guardduty:InviteMembers",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.ListDetectors": [
            {
                "action": "guardduty:ListDetectors",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.ListFilters": [
            {
                "action": "guardduty:ListFilters",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.ListFindings": [
            {
                "action": "guardduty:ListFindings",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.ListIPSets": [
            {
                "action": "guardduty:ListIPSets",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.ListInvitations": [
            {
                "action": "guardduty:ListInvitations",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.ListMembers": [
            {
                "action": "guardduty:ListMembers",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.ListOrganizationAdminAccounts": [
            {
                "action": "guardduty:ListOrganizationAdminAccounts",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.ListPublishingDestinations": [
            {
                "action": "guardduty:ListPublishingDestinations",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.ListTagsForResource": [
            {
                "action": "guardduty:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "detector": "%%iftemplatematch%${ResourceArn}%%",
                    "filter": "%%iftemplatematch%${ResourceArn}%%",
                    "ipset": "%%iftemplatematch%${ResourceArn}%%",
                    "threatintelset": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "GuardDuty.ListThreatIntelSets": [
            {
                "action": "guardduty:ListThreatIntelSets",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.StartMonitoringMembers": [
            {
                "action": "guardduty:StartMonitoringMembers",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.StopMonitoringMembers": [
            {
                "action": "guardduty:StopMonitoringMembers",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.TagResource": [
            {
                "action": "guardduty:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "detector": "%%iftemplatematch%${ResourceArn}%%",
                    "filter": "%%iftemplatematch%${ResourceArn}%%",
                    "ipset": "%%iftemplatematch%${ResourceArn}%%",
                    "threatintelset": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "GuardDuty.UnarchiveFindings": [
            {
                "action": "guardduty:UnarchiveFindings",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.UntagResource": [
            {
                "action": "guardduty:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "detector": "%%iftemplatematch%${ResourceArn}%%",
                    "filter": "%%iftemplatematch%${ResourceArn}%%",
                    "ipset": "%%iftemplatematch%${ResourceArn}%%",
                    "threatintelset": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "GuardDuty.UpdateDetector": [
            {
                "action": "guardduty:UpdateDetector",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.UpdateFilter": [
            {
                "action": "guardduty:UpdateFilter",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "FilterName": {
                        "template": "${FilterName}"
                    }
                }
            }
        ],
        "GuardDuty.UpdateFindingsFeedback": [
            {
                "action": "guardduty:UpdateFindingsFeedback",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.UpdateIPSet": [
            {
                "action": "guardduty:UpdateIPSet",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "IPSetId": {
                        "template": "${IpSetId}"
                    }
                }
            }
        ],
        "GuardDuty.UpdateOrganizationConfiguration": [
            {
                "action": "guardduty:UpdateOrganizationConfiguration",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.UpdatePublishingDestination": [
            {
                "action": "guardduty:UpdatePublishingDestination",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "PublishingDestinationId": {
                        "template": "${DestinationId}"
                    }
                }
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "GuardDuty.UpdateThreatIntelSet": [
            {
                "action": "guardduty:UpdateThreatIntelSet",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    },
                    "ThreatIntelSetId": {
                        "template": "${ThreatIntelSetId}"
                    }
                }
            }
        ],
        "MQ.CreateBroker": [
            {
                "action": "mq:CreateBroker",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "${SubnetIds[]}"
                    },
                    "SecurityGroupId": {
                        "template": "${SecurityGroups[]}"
                    }
                }
            }
        ],
        "MQ.CreateConfiguration": [
            {
                "action": "mq:CreateConfiguration",
                "resource_mappings": {}
            }
        ],
        "MQ.CreateTags": [
            {
                "action": "mq:CreateTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "brokers": "%%iftemplatematch%${ResourceArn}%%",
                    "configurations": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MQ.CreateUser": [
            {
                "action": "mq:CreateUser",
                "resource_mappings": {
                    "broker-id": {
                        "template": "${BrokerId}"
                    }
                }
            }
        ],
        "MQ.DeleteBroker": [
            {
                "action": "mq:DeleteBroker",
                "resource_mappings": {
                    "broker-id": {
                        "template": "${BrokerId}"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "MQ.DeleteTags": [
            {
                "action": "mq:DeleteTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "brokers": "%%iftemplatematch%${ResourceArn}%%",
                    "configurations": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MQ.DeleteUser": [
            {
                "action": "mq:DeleteUser",
                "resource_mappings": {
                    "broker-id": {
                        "template": "${BrokerId}"
                    }
                }
            }
        ],
        "MQ.DescribeBroker": [
            {
                "action": "mq:DescribeBroker",
                "resource_mappings": {
                    "broker-id": {
                        "template": "${BrokerId}"
                    }
                }
            }
        ],
        "MQ.DescribeBrokerEngineTypes": [
            {
                "action": "mq:DescribeBrokerEngineTypes",
                "resource_mappings": {}
            }
        ],
        "MQ.DescribeBrokerInstanceOptions": [
            {
                "action": "mq:DescribeBrokerInstanceOptions",
                "resource_mappings": {}
            }
        ],
        "MQ.DescribeConfiguration": [
            {
                "action": "mq:DescribeConfiguration",
                "resource_mappings": {
                    "configuration-id": {
                        "template": "${ConfigurationId}"
                    }
                }
            }
        ],
        "MQ.DescribeConfigurationRevision": [
            {
                "action": "mq:DescribeConfigurationRevision",
                "resource_mappings": {
                    "configuration-id": {
                        "template": "${ConfigurationId}"
                    }
                }
            }
        ],
        "MQ.DescribeUser": [
            {
                "action": "mq:DescribeUser",
                "resource_mappings": {
                    "broker-id": {
                        "template": "${BrokerId}"
                    }
                }
            }
        ],
        "MQ.ListBrokers": [
            {
                "action": "mq:ListBrokers",
                "resource_mappings": {}
            }
        ],
        "MQ.ListConfigurationRevisions": [
            {
                "action": "mq:ListConfigurationRevisions",
                "resource_mappings": {
                    "configuration-id": {
                        "template": "${ConfigurationId}"
                    }
                }
            }
        ],
        "MQ.ListConfigurations": [
            {
                "action": "mq:ListConfigurations",
                "resource_mappings": {}
            }
        ],
        "MQ.ListTags": [
            {
                "action": "mq:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "brokers": "%%iftemplatematch%${ResourceArn}%%",
                    "configurations": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MQ.ListUsers": [
            {
                "action": "mq:ListUsers",
                "resource_mappings": {
                    "broker-id": {
                        "template": "${BrokerId}"
                    }
                }
            }
        ],
        "MQ.RebootBroker": [
            {
                "action": "mq:RebootBroker",
                "resource_mappings": {
                    "broker-id": {
                        "template": "${BrokerId}"
                    }
                }
            }
        ],
        "MQ.UpdateBroker": [
            {
                "action": "mq:UpdateBroker",
                "resource_mappings": {
                    "broker-id": {
                        "template": "${BrokerId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${LdapServerMetadata.RoleBase}%${LdapServerMetadata.RoleName}%${LdapServerMetadata.RoleSearchMatching}%${LdapServerMetadata.RoleSearchSubtree}%${LdapServerMetadata.UserRoleName}%%"
                }
            }
        ],
        "MQ.UpdateConfiguration": [
            {
                "action": "mq:UpdateConfiguration",
                "resource_mappings": {
                    "configuration-id": {
                        "template": "${ConfigurationId}"
                    }
                }
            }
        ],
        "MQ.UpdateUser": [
            {
                "action": "mq:UpdateUser",
                "resource_mappings": {
                    "broker-id": {
                        "template": "${BrokerId}"
                    }
                }
            }
        ],
        "Comprehend.BatchDetectDominantLanguage": [
            {
                "action": "comprehend:BatchDetectDominantLanguage",
                "resource_mappings": {}
            }
        ],
        "Comprehend.BatchDetectEntities": [
            {
                "action": "comprehend:BatchDetectEntities",
                "resource_mappings": {}
            }
        ],
        "Comprehend.BatchDetectKeyPhrases": [
            {
                "action": "comprehend:BatchDetectKeyPhrases",
                "resource_mappings": {}
            }
        ],
        "Comprehend.BatchDetectSentiment": [
            {
                "action": "comprehend:BatchDetectSentiment",
                "resource_mappings": {}
            }
        ],
        "Comprehend.BatchDetectSyntax": [
            {
                "action": "comprehend:BatchDetectSyntax",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ClassifyDocument": [
            {
                "action": "comprehend:ClassifyDocument",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier-endpoint": "${EndpointArn}"
                }
            }
        ],
        "Comprehend.CreateDocumentClassifier": [
            {
                "action": "comprehend:CreateDocumentClassifier",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Comprehend.CreateEndpoint": [
            {
                "action": "comprehend:CreateEndpoint",
                "resource_mappings": {
                    "DocumentClassifierName": {
                        "template": "*"
                    },
                    "EntityRecognizerName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Comprehend.CreateEntityRecognizer": [
            {
                "action": "comprehend:CreateEntityRecognizer",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Comprehend.DeleteDocumentClassifier": [
            {
                "action": "comprehend:DeleteDocumentClassifier",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier": "${DocumentClassifierArn}"
                }
            }
        ],
        "Comprehend.DeleteEndpoint": [
            {
                "action": "comprehend:DeleteEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier-endpoint": "%%iftemplatematch%${EndpointArn}%%",
                    "entity-recognizer-endpoint": "%%iftemplatematch%${EndpointArn}%%"
                }
            }
        ],
        "Comprehend.DeleteEntityRecognizer": [
            {
                "action": "comprehend:DeleteEntityRecognizer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "entity-recognizer": "${EntityRecognizerArn}"
                }
            }
        ],
        "Comprehend.DescribeDocumentClassificationJob": [
            {
                "action": "comprehend:DescribeDocumentClassificationJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DescribeDocumentClassifier": [
            {
                "action": "comprehend:DescribeDocumentClassifier",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier": "${DocumentClassifierArn}"
                }
            }
        ],
        "Comprehend.DescribeDominantLanguageDetectionJob": [
            {
                "action": "comprehend:DescribeDominantLanguageDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DescribeEndpoint": [
            {
                "action": "comprehend:DescribeEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier-endpoint": "%%iftemplatematch%${EndpointArn}%%",
                    "entity-recognizer-endpoint": "%%iftemplatematch%${EndpointArn}%%"
                }
            }
        ],
        "Comprehend.DescribeEntitiesDetectionJob": [
            {
                "action": "comprehend:DescribeEntitiesDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DescribeEntityRecognizer": [
            {
                "action": "comprehend:DescribeEntityRecognizer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "entity-recognizer": "${EntityRecognizerArn}"
                }
            }
        ],
        "Comprehend.DescribeEventsDetectionJob": [
            {
                "action": "comprehend:DescribeEventsDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DescribeKeyPhrasesDetectionJob": [
            {
                "action": "comprehend:DescribeKeyPhrasesDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DescribePiiEntitiesDetectionJob": [
            {
                "action": "comprehend:DescribePiiEntitiesDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DescribeSentimentDetectionJob": [
            {
                "action": "comprehend:DescribeSentimentDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DescribeTopicsDetectionJob": [
            {
                "action": "comprehend:DescribeTopicsDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DetectDominantLanguage": [
            {
                "action": "comprehend:DetectDominantLanguage",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DetectEntities": [
            {
                "action": "comprehend:DetectEntities",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "entity-recognizer-endpoint": "${EndpointArn}"
                }
            }
        ],
        "Comprehend.DetectKeyPhrases": [
            {
                "action": "comprehend:DetectKeyPhrases",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DetectPiiEntities": [
            {
                "action": "comprehend:DetectPiiEntities",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DetectSentiment": [
            {
                "action": "comprehend:DetectSentiment",
                "resource_mappings": {}
            }
        ],
        "Comprehend.DetectSyntax": [
            {
                "action": "comprehend:DetectSyntax",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListDocumentClassificationJobs": [
            {
                "action": "comprehend:ListDocumentClassificationJobs",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListDocumentClassifiers": [
            {
                "action": "comprehend:ListDocumentClassifiers",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListDominantLanguageDetectionJobs": [
            {
                "action": "comprehend:ListDominantLanguageDetectionJobs",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListEndpoints": [
            {
                "action": "comprehend:ListEndpoints",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListEntitiesDetectionJobs": [
            {
                "action": "comprehend:ListEntitiesDetectionJobs",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListEntityRecognizers": [
            {
                "action": "comprehend:ListEntityRecognizers",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListEventsDetectionJobs": [
            {
                "action": "comprehend:ListEventsDetectionJobs",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListKeyPhrasesDetectionJobs": [
            {
                "action": "comprehend:ListKeyPhrasesDetectionJobs",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListPiiEntitiesDetectionJobs": [
            {
                "action": "comprehend:ListPiiEntitiesDetectionJobs",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListSentimentDetectionJobs": [
            {
                "action": "comprehend:ListSentimentDetectionJobs",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListTagsForResource": [
            {
                "action": "comprehend:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier": "%%iftemplatematch%${ResourceArn}%%",
                    "document-classifier-endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "entity-recognizer": "%%iftemplatematch%${ResourceArn}%%",
                    "entity-recognizer-endpoint": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Comprehend.ListTopicsDetectionJobs": [
            {
                "action": "comprehend:ListTopicsDetectionJobs",
                "resource_mappings": {}
            }
        ],
        "Comprehend.StartDocumentClassificationJob": [
            {
                "action": "comprehend:StartDocumentClassificationJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier": "${DocumentClassifierArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Comprehend.StartDominantLanguageDetectionJob": [
            {
                "action": "comprehend:StartDominantLanguageDetectionJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Comprehend.StartEntitiesDetectionJob": [
            {
                "action": "comprehend:StartEntitiesDetectionJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "entity-recognizer": "${EntityRecognizerArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Comprehend.StartEventsDetectionJob": [
            {
                "action": "comprehend:StartEventsDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.StartKeyPhrasesDetectionJob": [
            {
                "action": "comprehend:StartKeyPhrasesDetectionJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Comprehend.StartPiiEntitiesDetectionJob": [
            {
                "action": "comprehend:StartPiiEntitiesDetectionJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Comprehend.StartSentimentDetectionJob": [
            {
                "action": "comprehend:StartSentimentDetectionJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Comprehend.StartTopicsDetectionJob": [
            {
                "action": "comprehend:StartTopicsDetectionJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Comprehend.StopDominantLanguageDetectionJob": [
            {
                "action": "comprehend:StopDominantLanguageDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.StopEntitiesDetectionJob": [
            {
                "action": "comprehend:StopEntitiesDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.StopEventsDetectionJob": [
            {
                "action": "comprehend:StopEventsDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.StopKeyPhrasesDetectionJob": [
            {
                "action": "comprehend:StopKeyPhrasesDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.StopPiiEntitiesDetectionJob": [
            {
                "action": "comprehend:StopPiiEntitiesDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.StopSentimentDetectionJob": [
            {
                "action": "comprehend:StopSentimentDetectionJob",
                "resource_mappings": {}
            }
        ],
        "Comprehend.StopTrainingDocumentClassifier": [
            {
                "action": "comprehend:StopTrainingDocumentClassifier",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier": "${DocumentClassifierArn}"
                }
            }
        ],
        "Comprehend.StopTrainingEntityRecognizer": [
            {
                "action": "comprehend:StopTrainingEntityRecognizer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "entity-recognizer": "${EntityRecognizerArn}"
                }
            }
        ],
        "Comprehend.TagResource": [
            {
                "action": "comprehend:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier": "%%iftemplatematch%${ResourceArn}%%",
                    "document-classifier-endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "entity-recognizer": "%%iftemplatematch%${ResourceArn}%%",
                    "entity-recognizer-endpoint": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Comprehend.UntagResource": [
            {
                "action": "comprehend:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier": "%%iftemplatematch%${ResourceArn}%%",
                    "document-classifier-endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "entity-recognizer": "%%iftemplatematch%${ResourceArn}%%",
                    "entity-recognizer-endpoint": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Comprehend.UpdateEndpoint": [
            {
                "action": "comprehend:UpdateEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "document-classifier-endpoint": "%%iftemplatematch%${EndpointArn}%%",
                    "entity-recognizer-endpoint": "%%iftemplatematch%${EndpointArn}%%"
                }
            }
        ],
        "IoTJobsDataPlane.DescribeJobExecution": [
            {
                "action": "iot:DescribeJobExecution",
                "resource_mappings": {
                    "JobId": {
                        "template": "${jobId}"
                    },
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "IoTJobsDataPlane.GetPendingJobExecutions": [
            {
                "action": "iot:GetPendingJobExecutions",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "IoTJobsDataPlane.StartNextPendingJobExecution": [
            {
                "action": "iot:StartNextPendingJobExecution",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "IoTJobsDataPlane.UpdateJobExecution": [
            {
                "action": "iot:UpdateJobExecution",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "KinesisVideoArchivedMedia.GetClip": [
            {
                "action": "kinesisvideo:GetClip",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideoArchivedMedia.GetDASHStreamingSessionURL": [
            {
                "action": "kinesisvideo:GetDASHStreamingSessionURL",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideoArchivedMedia.GetHLSStreamingSessionURL": [
            {
                "action": "kinesisvideo:GetHLSStreamingSessionURL",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideoArchivedMedia.GetMediaForFragmentList": [
            {
                "action": "kinesisvideo:GetMediaForFragmentList",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideoArchivedMedia.ListFragments": [
            {
                "action": "kinesisvideo:ListFragments",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideoMedia.GetMedia": [
            {
                "action": "kinesisvideo:GetMedia",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideo.CreateSignalingChannel": [
            {
                "action": "kinesisvideo:CreateSignalingChannel",
                "resource_mappings": {
                    "ChannelName": {
                        "template": "${ChannelName}"
                    },
                    "CreationTime": {
                        "template": "*"
                    }
                }
            }
        ],
        "KinesisVideo.CreateStream": [
            {
                "action": "kinesisvideo:CreateStream",
                "resource_mappings": {
                    "StreamName": {
                        "template": "${StreamName}"
                    },
                    "CreationTime": {
                        "template": "*"
                    }
                }
            }
        ],
        "KinesisVideo.DeleteSignalingChannel": [
            {
                "action": "kinesisvideo:DeleteSignalingChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "${ChannelARN}"
                }
            }
        ],
        "KinesisVideo.DeleteStream": [
            {
                "action": "kinesisvideo:DeleteStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideo.DescribeSignalingChannel": [
            {
                "action": "kinesisvideo:DescribeSignalingChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "${ChannelARN}"
                }
            }
        ],
        "KinesisVideo.DescribeStream": [
            {
                "action": "kinesisvideo:DescribeStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideo.GetDataEndpoint": [
            {
                "action": "kinesisvideo:GetDataEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideo.GetSignalingChannelEndpoint": [
            {
                "action": "kinesisvideo:GetSignalingChannelEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "${ChannelARN}"
                }
            }
        ],
        "KinesisVideo.ListSignalingChannels": [
            {
                "action": "kinesisvideo:ListSignalingChannels",
                "resource_mappings": {}
            }
        ],
        "KinesisVideo.ListStreams": [
            {
                "action": "kinesisvideo:ListStreams",
                "resource_mappings": {}
            }
        ],
        "KinesisVideo.ListTagsForResource": [
            {
                "action": "kinesisvideo:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftemplatematch%${ResourceARN}%%",
                    "stream": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "KinesisVideo.ListTagsForStream": [
            {
                "action": "kinesisvideo:ListTagsForStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideo.TagResource": [
            {
                "action": "kinesisvideo:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftemplatematch%${ResourceARN}%%",
                    "stream": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "KinesisVideo.TagStream": [
            {
                "action": "kinesisvideo:TagStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideo.UntagResource": [
            {
                "action": "kinesisvideo:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftemplatematch%${ResourceARN}%%",
                    "stream": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "KinesisVideo.UntagStream": [
            {
                "action": "kinesisvideo:UntagStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideo.UpdateDataRetention": [
            {
                "action": "kinesisvideo:UpdateDataRetention",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "KinesisVideo.UpdateSignalingChannel": [
            {
                "action": "kinesisvideo:UpdateSignalingChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "${ChannelARN}"
                }
            }
        ],
        "KinesisVideo.UpdateStream": [
            {
                "action": "kinesisvideo:UpdateStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "stream": "${StreamARN}"
                }
            }
        ],
        "SageMakerRuntime.InvokeEndpoint": [
            {
                "action": "sagemaker:InvokeEndpoint",
                "resource_mappings": {
                    "EndpointName": {
                        "template": "${EndpointName}"
                    }
                }
            }
        ],
        "SageMaker.AddAssociation": [
            {
                "action": "sagemaker:AddAssociation",
                "resource_mappings": {
                    "ActionName": {
                        "template": "*"
                    },
                    "HashOfArtifactSource": {
                        "template": "*"
                    },
                    "ContextName": {
                        "template": "*"
                    },
                    "ExperimentName": {
                        "template": "*"
                    },
                    "TrialComponentName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SageMaker.AddTags": [
            {
                "action": "sagemaker:AddTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "action": "%%iftemplatematch%${ResourceArn}%%",
                    "algorithm": "%%iftemplatematch%${ResourceArn}%%",
                    "app": "%%iftemplatematch%${ResourceArn}%%",
                    "app-image-config": "%%iftemplatematch%${ResourceArn}%%",
                    "artifact": "%%iftemplatematch%${ResourceArn}%%",
                    "automl-job": "%%iftemplatematch%${ResourceArn}%%",
                    "code-repository": "%%iftemplatematch%${ResourceArn}%%",
                    "context": "%%iftemplatematch%${ResourceArn}%%",
                    "data-quality-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "device-fleet": "%%iftemplatematch%${ResourceArn}%%",
                    "domain": "%%iftemplatematch%${ResourceArn}%%",
                    "edge-packaging-job": "%%iftemplatematch%${ResourceArn}%%",
                    "endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "endpoint-config": "%%iftemplatematch%${ResourceArn}%%",
                    "experiment": "%%iftemplatematch%${ResourceArn}%%",
                    "experiment-trial": "%%iftemplatematch%${ResourceArn}%%",
                    "experiment-trial-component": "%%iftemplatematch%${ResourceArn}%%",
                    "feature-group": "%%iftemplatematch%${ResourceArn}%%",
                    "flow-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "human-task-ui": "%%iftemplatematch%${ResourceArn}%%",
                    "hyper-parameter-tuning-job": "%%iftemplatematch%${ResourceArn}%%",
                    "image": "%%iftemplatematch%${ResourceArn}%%",
                    "labeling-job": "%%iftemplatematch%${ResourceArn}%%",
                    "model": "%%iftemplatematch%${ResourceArn}%%",
                    "model-bias-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "model-explainability-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "model-package": "%%iftemplatematch%${ResourceArn}%%",
                    "model-package-group": "%%iftemplatematch%${ResourceArn}%%",
                    "model-quality-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "monitoring-schedule": "%%iftemplatematch%${ResourceArn}%%",
                    "notebook-instance": "%%iftemplatematch%${ResourceArn}%%",
                    "pipeline": "%%iftemplatematch%${ResourceArn}%%",
                    "processing-job": "%%iftemplatematch%${ResourceArn}%%",
                    "project": "%%iftemplatematch%${ResourceArn}%%",
                    "training-job": "%%iftemplatematch%${ResourceArn}%%",
                    "transform-job": "%%iftemplatematch%${ResourceArn}%%",
                    "user-profile": "%%iftemplatematch%${ResourceArn}%%",
                    "workteam": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SageMaker.AssociateTrialComponent": [
            {
                "action": "sagemaker:AssociateTrialComponent",
                "resource_mappings": {
                    "TrialName": {
                        "template": "${TrialName}"
                    },
                    "TrialComponentName": {
                        "template": "${TrialComponentName}"
                    }
                }
            }
        ],
        "SageMaker.CreateAction": [
            {
                "action": "sagemaker:CreateAction",
                "resource_mappings": {
                    "ActionName": {
                        "template": "${ActionName}"
                    }
                }
            }
        ],
        "SageMaker.CreateAlgorithm": [
            {
                "action": "sagemaker:CreateAlgorithm",
                "resource_mappings": {
                    "AlgorithmName": {
                        "template": "${AlgorithmName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ValidationSpecification.ValidationRole}"
                }
            }
        ],
        "SageMaker.CreateApp": [
            {
                "action": "sagemaker:CreateApp",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    },
                    "UserProfileName": {
                        "template": "${UserProfileName}"
                    },
                    "AppType": {
                        "template": "${AppType}"
                    },
                    "AppName": {
                        "template": "${AppName}"
                    }
                }
            }
        ],
        "SageMaker.CreateAppImageConfig": [
            {
                "action": "sagemaker:CreateAppImageConfig",
                "resource_mappings": {
                    "AppImageConfigName": {
                        "template": "${AppImageConfigName}"
                    }
                }
            }
        ],
        "SageMaker.CreateArtifact": [
            {
                "action": "sagemaker:CreateArtifact",
                "resource_mappings": {
                    "HashOfArtifactSource": {
                        "template": "*"
                    }
                }
            }
        ],
        "SageMaker.CreateAutoMLJob": [
            {
                "action": "sagemaker:CreateAutoMLJob",
                "resource_mappings": {
                    "AutoMLJobJobName": {
                        "template": "${AutoMLJobName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateCodeRepository": [
            {
                "action": "sagemaker:CreateCodeRepository",
                "resource_mappings": {
                    "CodeRepositoryName": {
                        "template": "${CodeRepositoryName}"
                    }
                }
            }
        ],
        "SageMaker.CreateCompilationJob": [
            {
                "action": "sagemaker:CreateCompilationJob",
                "resource_mappings": {
                    "CompilationJobName": {
                        "template": "${CompilationJobName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateContext": [
            {
                "action": "sagemaker:CreateContext",
                "resource_mappings": {
                    "ContextName": {
                        "template": "${ContextName}"
                    }
                }
            }
        ],
        "SageMaker.CreateDataQualityJobDefinition": [
            {
                "action": "sagemaker:CreateDataQualityJobDefinition",
                "resource_mappings": {
                    "DataQualityJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateDeviceFleet": [
            {
                "action": "sagemaker:CreateDeviceFleet",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateDomain": [
            {
                "action": "sagemaker:CreateDomain",
                "resource_mappings": {
                    "DomainId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DefaultUserSettings.ExecutionRole}"
                }
            }
        ],
        "SageMaker.CreateEdgePackagingJob": [
            {
                "action": "sagemaker:CreateEdgePackagingJob",
                "resource_mappings": {
                    "EdgePackagingJobName": {
                        "template": "${EdgePackagingJobName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateEndpoint": [
            {
                "action": "sagemaker:CreateEndpoint",
                "resource_mappings": {
                    "EndpointName": {
                        "template": "${EndpointName}"
                    }
                }
            }
        ],
        "SageMaker.CreateEndpointConfig": [
            {
                "action": "sagemaker:CreateEndpointConfig",
                "resource_mappings": {
                    "EndpointConfigName": {
                        "template": "${EndpointConfigName}"
                    }
                }
            }
        ],
        "SageMaker.CreateExperiment": [
            {
                "action": "sagemaker:CreateExperiment",
                "resource_mappings": {
                    "ExperimentName": {
                        "template": "${ExperimentName}"
                    }
                }
            }
        ],
        "SageMaker.CreateFeatureGroup": [
            {
                "action": "sagemaker:CreateFeatureGroup",
                "resource_mappings": {
                    "FeatureGroupName": {
                        "template": "${FeatureGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateFlowDefinition": [
            {
                "action": "sagemaker:CreateFlowDefinition",
                "resource_mappings": {
                    "FlowDefinitionName": {
                        "template": "${FlowDefinitionName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateHumanTaskUi": [
            {
                "action": "sagemaker:CreateHumanTaskUi",
                "resource_mappings": {
                    "HumanTaskUiName": {
                        "template": "${HumanTaskUiName}"
                    }
                }
            }
        ],
        "SageMaker.CreateHyperParameterTuningJob": [
            {
                "action": "sagemaker:CreateHyperParameterTuningJob",
                "resource_mappings": {
                    "HyperParameterTuningJobName": {
                        "template": "${HyperParameterTuningJobName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${TrainingJobDefinition.RoleArn}"
                }
            }
        ],
        "SageMaker.CreateImage": [
            {
                "action": "sagemaker:CreateImage",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${ImageName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateImageVersion": [
            {
                "action": "sagemaker:CreateImageVersion",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${ImageName}"
                    }
                }
            }
        ],
        "SageMaker.CreateLabelingJob": [
            {
                "action": "sagemaker:CreateLabelingJob",
                "resource_mappings": {
                    "LabelingJobName": {
                        "template": "${LabelingJobName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateModel": [
            {
                "action": "sagemaker:CreateModel",
                "resource_mappings": {
                    "ModelName": {
                        "template": "${ModelName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ExecutionRoleArn}"
                }
            }
        ],
        "SageMaker.CreateModelBiasJobDefinition": [
            {
                "action": "sagemaker:CreateModelBiasJobDefinition",
                "resource_mappings": {
                    "ModelBiasJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateModelExplainabilityJobDefinition": [
            {
                "action": "sagemaker:CreateModelExplainabilityJobDefinition",
                "resource_mappings": {
                    "ModelExplainabilityJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateModelPackage": [
            {
                "action": "sagemaker:CreateModelPackage",
                "resource_mappings": {
                    "ModelPackageName": {
                        "template": "${ModelPackageName}"
                    },
                    "ModelPackageGroupName": {
                        "template": "${ModelPackageGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ValidationSpecification.ValidationRole}"
                }
            }
        ],
        "SageMaker.CreateModelPackageGroup": [
            {
                "action": "sagemaker:CreateModelPackageGroup",
                "resource_mappings": {
                    "ModelPackageGroupName": {
                        "template": "${ModelPackageGroupName}"
                    }
                }
            }
        ],
        "SageMaker.CreateModelQualityJobDefinition": [
            {
                "action": "sagemaker:CreateModelQualityJobDefinition",
                "resource_mappings": {
                    "ModelQualityJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateMonitoringSchedule": [
            {
                "action": "sagemaker:CreateMonitoringSchedule",
                "resource_mappings": {
                    "MonitoringScheduleName": {
                        "template": "${MonitoringScheduleName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${MonitoringScheduleConfig.MonitoringJobDefinition.RoleArn}"
                }
            }
        ],
        "SageMaker.CreateNotebookInstance": [
            {
                "action": "sagemaker:CreateNotebookInstance",
                "resource_mappings": {
                    "NotebookInstanceName": {
                        "template": "${NotebookInstanceName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateNotebookInstanceLifecycleConfig": [
            {
                "action": "sagemaker:CreateNotebookInstanceLifecycleConfig",
                "resource_mappings": {
                    "NotebookInstanceLifecycleConfigName": {
                        "template": "${NotebookInstanceLifecycleConfigName}"
                    }
                }
            }
        ],
        "SageMaker.CreatePipeline": [
            {
                "action": "sagemaker:CreatePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${PipelineName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreatePresignedDomainUrl": [
            {
                "action": "sagemaker:CreatePresignedDomainUrl",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    },
                    "UserProfileName": {
                        "template": "${UserProfileName}"
                    }
                }
            }
        ],
        "SageMaker.CreatePresignedNotebookInstanceUrl": [
            {
                "action": "sagemaker:CreatePresignedNotebookInstanceUrl",
                "resource_mappings": {
                    "NotebookInstanceName": {
                        "template": "${NotebookInstanceName}"
                    }
                }
            }
        ],
        "SageMaker.CreateProcessingJob": [
            {
                "action": "sagemaker:CreateProcessingJob",
                "resource_mappings": {
                    "ProcessingJobName": {
                        "template": "${ProcessingJobName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateProject": [
            {
                "action": "sagemaker:CreateProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    }
                }
            }
        ],
        "SageMaker.CreateTrainingJob": [
            {
                "action": "sagemaker:CreateTrainingJob",
                "resource_mappings": {
                    "TrainingJobName": {
                        "template": "${TrainingJobName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "SageMaker.CreateTransformJob": [
            {
                "action": "sagemaker:CreateTransformJob",
                "resource_mappings": {
                    "TransformJobName": {
                        "template": "${TransformJobName}"
                    }
                }
            }
        ],
        "SageMaker.CreateTrial": [
            {
                "action": "sagemaker:CreateTrial",
                "resource_mappings": {
                    "TrialName": {
                        "template": "${TrialName}"
                    }
                }
            }
        ],
        "SageMaker.CreateTrialComponent": [
            {
                "action": "sagemaker:CreateTrialComponent",
                "resource_mappings": {
                    "TrialComponentName": {
                        "template": "${TrialComponentName}"
                    }
                }
            }
        ],
        "SageMaker.CreateUserProfile": [
            {
                "action": "sagemaker:CreateUserProfile",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    },
                    "UserProfileName": {
                        "template": "${UserProfileName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${UserSettings.ExecutionRole}"
                }
            }
        ],
        "SageMaker.CreateWorkforce": [
            {
                "action": "sagemaker:CreateWorkforce",
                "resource_mappings": {
                    "WorkforceName": {
                        "template": "${WorkforceName}"
                    }
                }
            }
        ],
        "SageMaker.CreateWorkteam": [
            {
                "action": "sagemaker:CreateWorkteam",
                "resource_mappings": {
                    "WorkteamName": {
                        "template": "${WorkteamName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteAction": [
            {
                "action": "sagemaker:DeleteAction",
                "resource_mappings": {
                    "ActionName": {
                        "template": "${ActionName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteAlgorithm": [
            {
                "action": "sagemaker:DeleteAlgorithm",
                "resource_mappings": {
                    "AlgorithmName": {
                        "template": "${AlgorithmName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteApp": [
            {
                "action": "sagemaker:DeleteApp",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    },
                    "UserProfileName": {
                        "template": "${UserProfileName}"
                    },
                    "AppType": {
                        "template": "${AppType}"
                    },
                    "AppName": {
                        "template": "${AppName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteAppImageConfig": [
            {
                "action": "sagemaker:DeleteAppImageConfig",
                "resource_mappings": {
                    "AppImageConfigName": {
                        "template": "${AppImageConfigName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteArtifact": [
            {
                "action": "sagemaker:DeleteArtifact",
                "resource_mappings": {
                    "HashOfArtifactSource": {
                        "template": "*"
                    }
                }
            }
        ],
        "SageMaker.DeleteAssociation": [
            {
                "action": "sagemaker:DeleteAssociation",
                "resource_mappings": {
                    "ActionName": {
                        "template": "*"
                    },
                    "HashOfArtifactSource": {
                        "template": "*"
                    },
                    "ContextName": {
                        "template": "*"
                    },
                    "ExperimentName": {
                        "template": "*"
                    },
                    "TrialComponentName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SageMaker.DeleteCodeRepository": [
            {
                "action": "sagemaker:DeleteCodeRepository",
                "resource_mappings": {
                    "CodeRepositoryName": {
                        "template": "${CodeRepositoryName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteContext": [
            {
                "action": "sagemaker:DeleteContext",
                "resource_mappings": {
                    "ContextName": {
                        "template": "${ContextName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteDataQualityJobDefinition": [
            {
                "action": "sagemaker:DeleteDataQualityJobDefinition",
                "resource_mappings": {
                    "DataQualityJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteDeviceFleet": [
            {
                "action": "sagemaker:DeleteDeviceFleet",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteDomain": [
            {
                "action": "sagemaker:DeleteDomain",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "SageMaker.DeleteEndpoint": [
            {
                "action": "sagemaker:DeleteEndpoint",
                "resource_mappings": {
                    "EndpointName": {
                        "template": "${EndpointName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteEndpointConfig": [
            {
                "action": "sagemaker:DeleteEndpointConfig",
                "resource_mappings": {
                    "EndpointConfigName": {
                        "template": "${EndpointConfigName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteExperiment": [
            {
                "action": "sagemaker:DeleteExperiment",
                "resource_mappings": {
                    "ExperimentName": {
                        "template": "${ExperimentName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteFeatureGroup": [
            {
                "action": "sagemaker:DeleteFeatureGroup",
                "resource_mappings": {
                    "FeatureGroupName": {
                        "template": "${FeatureGroupName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteFlowDefinition": [
            {
                "action": "sagemaker:DeleteFlowDefinition",
                "resource_mappings": {
                    "FlowDefinitionName": {
                        "template": "${FlowDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteImage": [
            {
                "action": "sagemaker:DeleteImage",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${ImageName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteImageVersion": [
            {
                "action": "sagemaker:DeleteImageVersion",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${ImageName}"
                    },
                    "Version": {
                        "template": "${Version}"
                    }
                }
            }
        ],
        "SageMaker.DeleteModel": [
            {
                "action": "sagemaker:DeleteModel",
                "resource_mappings": {
                    "ModelName": {
                        "template": "${ModelName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteModelBiasJobDefinition": [
            {
                "action": "sagemaker:DeleteModelBiasJobDefinition",
                "resource_mappings": {
                    "ModelBiasJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteModelExplainabilityJobDefinition": [
            {
                "action": "sagemaker:DeleteModelExplainabilityJobDefinition",
                "resource_mappings": {
                    "ModelExplainabilityJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteModelPackage": [
            {
                "action": "sagemaker:DeleteModelPackage",
                "resource_mappings": {
                    "ModelPackageName": {
                        "template": "${ModelPackageName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteModelPackageGroup": [
            {
                "action": "sagemaker:DeleteModelPackageGroup",
                "resource_mappings": {
                    "ModelPackageGroupName": {
                        "template": "${ModelPackageGroupName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteModelPackageGroupPolicy": [
            {
                "action": "sagemaker:DeleteModelPackageGroupPolicy",
                "resource_mappings": {
                    "ModelPackageGroupName": {
                        "template": "${ModelPackageGroupName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteModelQualityJobDefinition": [
            {
                "action": "sagemaker:DeleteModelQualityJobDefinition",
                "resource_mappings": {
                    "ModelQualityJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteMonitoringSchedule": [
            {
                "action": "sagemaker:DeleteMonitoringSchedule",
                "resource_mappings": {
                    "MonitoringScheduleName": {
                        "template": "${MonitoringScheduleName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteNotebookInstance": [
            {
                "action": "sagemaker:DeleteNotebookInstance",
                "resource_mappings": {
                    "NotebookInstanceName": {
                        "template": "${NotebookInstanceName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteNotebookInstanceLifecycleConfig": [
            {
                "action": "sagemaker:DeleteNotebookInstanceLifecycleConfig",
                "resource_mappings": {
                    "NotebookInstanceLifecycleConfigName": {
                        "template": "${NotebookInstanceLifecycleConfigName}"
                    }
                }
            }
        ],
        "SageMaker.DeletePipeline": [
            {
                "action": "sagemaker:DeletePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${PipelineName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteProject": [
            {
                "action": "sagemaker:DeleteProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteTags": [
            {
                "action": "sagemaker:DeleteTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "action": "%%iftemplatematch%${ResourceArn}%%",
                    "algorithm": "%%iftemplatematch%${ResourceArn}%%",
                    "app": "%%iftemplatematch%${ResourceArn}%%",
                    "app-image-config": "%%iftemplatematch%${ResourceArn}%%",
                    "artifact": "%%iftemplatematch%${ResourceArn}%%",
                    "automl-job": "%%iftemplatematch%${ResourceArn}%%",
                    "code-repository": "%%iftemplatematch%${ResourceArn}%%",
                    "compilation-job": "%%iftemplatematch%${ResourceArn}%%",
                    "context": "%%iftemplatematch%${ResourceArn}%%",
                    "data-quality-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "device-fleet": "%%iftemplatematch%${ResourceArn}%%",
                    "domain": "%%iftemplatematch%${ResourceArn}%%",
                    "edge-packaging-job": "%%iftemplatematch%${ResourceArn}%%",
                    "endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "endpoint-config": "%%iftemplatematch%${ResourceArn}%%",
                    "experiment": "%%iftemplatematch%${ResourceArn}%%",
                    "experiment-trial": "%%iftemplatematch%${ResourceArn}%%",
                    "experiment-trial-component": "%%iftemplatematch%${ResourceArn}%%",
                    "feature-group": "%%iftemplatematch%${ResourceArn}%%",
                    "flow-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "human-task-ui": "%%iftemplatematch%${ResourceArn}%%",
                    "hyper-parameter-tuning-job": "%%iftemplatematch%${ResourceArn}%%",
                    "image": "%%iftemplatematch%${ResourceArn}%%",
                    "labeling-job": "%%iftemplatematch%${ResourceArn}%%",
                    "model": "%%iftemplatematch%${ResourceArn}%%",
                    "model-bias-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "model-explainability-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "model-package": "%%iftemplatematch%${ResourceArn}%%",
                    "model-package-group": "%%iftemplatematch%${ResourceArn}%%",
                    "model-quality-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "monitoring-schedule": "%%iftemplatematch%${ResourceArn}%%",
                    "notebook-instance": "%%iftemplatematch%${ResourceArn}%%",
                    "pipeline": "%%iftemplatematch%${ResourceArn}%%",
                    "processing-job": "%%iftemplatematch%${ResourceArn}%%",
                    "project": "%%iftemplatematch%${ResourceArn}%%",
                    "training-job": "%%iftemplatematch%${ResourceArn}%%",
                    "transform-job": "%%iftemplatematch%${ResourceArn}%%",
                    "user-profile": "%%iftemplatematch%${ResourceArn}%%",
                    "workteam": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SageMaker.DeleteTrial": [
            {
                "action": "sagemaker:DeleteTrial",
                "resource_mappings": {
                    "TrialName": {
                        "template": "${TrialName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteTrialComponent": [
            {
                "action": "sagemaker:DeleteTrialComponent",
                "resource_mappings": {
                    "TrialComponentName": {
                        "template": "${TrialComponentName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteUserProfile": [
            {
                "action": "sagemaker:DeleteUserProfile",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    },
                    "UserProfileName": {
                        "template": "${UserProfileName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteWorkforce": [
            {
                "action": "sagemaker:DeleteWorkforce",
                "resource_mappings": {
                    "WorkforceName": {
                        "template": "${WorkforceName}"
                    }
                }
            }
        ],
        "SageMaker.DeleteWorkteam": [
            {
                "action": "sagemaker:DeleteWorkteam",
                "resource_mappings": {
                    "WorkteamName": {
                        "template": "${WorkteamName}"
                    }
                }
            }
        ],
        "SageMaker.DeregisterDevices": [
            {
                "action": "sagemaker:DeregisterDevices",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    },
                    "DeviceName": {
                        "template": "${DeviceNames[]}"
                    }
                }
            }
        ],
        "SageMaker.DescribeAction": [
            {
                "action": "sagemaker:DescribeAction",
                "resource_mappings": {
                    "ActionName": {
                        "template": "${ActionName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeAlgorithm": [
            {
                "action": "sagemaker:DescribeAlgorithm",
                "resource_mappings": {
                    "AlgorithmName": {
                        "template": "${AlgorithmName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeApp": [
            {
                "action": "sagemaker:DescribeApp",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    },
                    "UserProfileName": {
                        "template": "${UserProfileName}"
                    },
                    "AppType": {
                        "template": "${AppType}"
                    },
                    "AppName": {
                        "template": "${AppName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeAppImageConfig": [
            {
                "action": "sagemaker:DescribeAppImageConfig",
                "resource_mappings": {
                    "AppImageConfigName": {
                        "template": "${AppImageConfigName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeArtifact": [
            {
                "action": "sagemaker:DescribeArtifact",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "artifact": "${ArtifactArn}"
                }
            }
        ],
        "SageMaker.DescribeAutoMLJob": [
            {
                "action": "sagemaker:DescribeAutoMLJob",
                "resource_mappings": {
                    "AutoMLJobJobName": {
                        "template": "${AutoMLJobName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeCodeRepository": [
            {
                "action": "sagemaker:DescribeCodeRepository",
                "resource_mappings": {
                    "CodeRepositoryName": {
                        "template": "${CodeRepositoryName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeCompilationJob": [
            {
                "action": "sagemaker:DescribeCompilationJob",
                "resource_mappings": {
                    "CompilationJobName": {
                        "template": "${CompilationJobName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeContext": [
            {
                "action": "sagemaker:DescribeContext",
                "resource_mappings": {
                    "ContextName": {
                        "template": "${ContextName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeDataQualityJobDefinition": [
            {
                "action": "sagemaker:DescribeDataQualityJobDefinition",
                "resource_mappings": {
                    "DataQualityJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeDevice": [
            {
                "action": "sagemaker:DescribeDevice",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    },
                    "DeviceName": {
                        "template": "${DeviceName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeDeviceFleet": [
            {
                "action": "sagemaker:DescribeDeviceFleet",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeDomain": [
            {
                "action": "sagemaker:DescribeDomain",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "SageMaker.DescribeEdgePackagingJob": [
            {
                "action": "sagemaker:DescribeEdgePackagingJob",
                "resource_mappings": {
                    "EdgePackagingJobName": {
                        "template": "${EdgePackagingJobName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeEndpoint": [
            {
                "action": "sagemaker:DescribeEndpoint",
                "resource_mappings": {
                    "EndpointName": {
                        "template": "${EndpointName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeEndpointConfig": [
            {
                "action": "sagemaker:DescribeEndpointConfig",
                "resource_mappings": {
                    "EndpointConfigName": {
                        "template": "${EndpointConfigName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeExperiment": [
            {
                "action": "sagemaker:DescribeExperiment",
                "resource_mappings": {
                    "ExperimentName": {
                        "template": "${ExperimentName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeFeatureGroup": [
            {
                "action": "sagemaker:DescribeFeatureGroup",
                "resource_mappings": {
                    "FeatureGroupName": {
                        "template": "${FeatureGroupName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeFlowDefinition": [
            {
                "action": "sagemaker:DescribeFlowDefinition",
                "resource_mappings": {
                    "FlowDefinitionName": {
                        "template": "${FlowDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeHumanTaskUi": [
            {
                "action": "sagemaker:DescribeHumanTaskUi",
                "resource_mappings": {
                    "HumanTaskUiName": {
                        "template": "${HumanTaskUiName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeHyperParameterTuningJob": [
            {
                "action": "sagemaker:DescribeHyperParameterTuningJob",
                "resource_mappings": {
                    "HyperParameterTuningJobName": {
                        "template": "${HyperParameterTuningJobName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeImage": [
            {
                "action": "sagemaker:DescribeImage",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${ImageName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeImageVersion": [
            {
                "action": "sagemaker:DescribeImageVersion",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${ImageName}"
                    },
                    "Version": {
                        "template": "${Version}"
                    }
                }
            }
        ],
        "SageMaker.DescribeLabelingJob": [
            {
                "action": "sagemaker:DescribeLabelingJob",
                "resource_mappings": {
                    "LabelingJobName": {
                        "template": "${LabelingJobName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeModel": [
            {
                "action": "sagemaker:DescribeModel",
                "resource_mappings": {
                    "ModelName": {
                        "template": "${ModelName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeModelBiasJobDefinition": [
            {
                "action": "sagemaker:DescribeModelBiasJobDefinition",
                "resource_mappings": {
                    "ModelBiasJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeModelExplainabilityJobDefinition": [
            {
                "action": "sagemaker:DescribeModelExplainabilityJobDefinition",
                "resource_mappings": {
                    "ModelExplainabilityJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeModelPackage": [
            {
                "action": "sagemaker:DescribeModelPackage",
                "resource_mappings": {
                    "ModelPackageName": {
                        "template": "${ModelPackageName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeModelPackageGroup": [
            {
                "action": "sagemaker:DescribeModelPackageGroup",
                "resource_mappings": {
                    "ModelPackageGroupName": {
                        "template": "${ModelPackageGroupName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeModelQualityJobDefinition": [
            {
                "action": "sagemaker:DescribeModelQualityJobDefinition",
                "resource_mappings": {
                    "ModelQualityJobDefinitionName": {
                        "template": "${JobDefinitionName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeMonitoringSchedule": [
            {
                "action": "sagemaker:DescribeMonitoringSchedule",
                "resource_mappings": {
                    "MonitoringScheduleName": {
                        "template": "${MonitoringScheduleName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeNotebookInstance": [
            {
                "action": "sagemaker:DescribeNotebookInstance",
                "resource_mappings": {
                    "NotebookInstanceName": {
                        "template": "${NotebookInstanceName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeNotebookInstanceLifecycleConfig": [
            {
                "action": "sagemaker:DescribeNotebookInstanceLifecycleConfig",
                "resource_mappings": {
                    "NotebookInstanceLifecycleConfigName": {
                        "template": "${NotebookInstanceLifecycleConfigName}"
                    }
                }
            }
        ],
        "SageMaker.DescribePipeline": [
            {
                "action": "sagemaker:DescribePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${PipelineName}"
                    }
                }
            }
        ],
        "SageMaker.DescribePipelineDefinitionForExecution": [
            {
                "action": "sagemaker:DescribePipelineDefinitionForExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "pipeline-execution": "${PipelineExecutionArn}"
                }
            }
        ],
        "SageMaker.DescribePipelineExecution": [
            {
                "action": "sagemaker:DescribePipelineExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "pipeline-execution": "${PipelineExecutionArn}"
                }
            }
        ],
        "SageMaker.DescribeProcessingJob": [
            {
                "action": "sagemaker:DescribeProcessingJob",
                "resource_mappings": {
                    "ProcessingJobName": {
                        "template": "${ProcessingJobName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeProject": [
            {
                "action": "sagemaker:DescribeProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeSubscribedWorkteam": [
            {
                "action": "sagemaker:DescribeSubscribedWorkteam",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "workteam": "${WorkteamArn}"
                }
            }
        ],
        "SageMaker.DescribeTrainingJob": [
            {
                "action": "sagemaker:DescribeTrainingJob",
                "resource_mappings": {
                    "TrainingJobName": {
                        "template": "${TrainingJobName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeTransformJob": [
            {
                "action": "sagemaker:DescribeTransformJob",
                "resource_mappings": {
                    "TransformJobName": {
                        "template": "${TransformJobName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeTrial": [
            {
                "action": "sagemaker:DescribeTrial",
                "resource_mappings": {
                    "TrialName": {
                        "template": "${TrialName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeTrialComponent": [
            {
                "action": "sagemaker:DescribeTrialComponent",
                "resource_mappings": {
                    "TrialComponentName": {
                        "template": "${TrialComponentName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeUserProfile": [
            {
                "action": "sagemaker:DescribeUserProfile",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    },
                    "UserProfileName": {
                        "template": "${UserProfileName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeWorkforce": [
            {
                "action": "sagemaker:DescribeWorkforce",
                "resource_mappings": {
                    "WorkforceName": {
                        "template": "${WorkforceName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeWorkteam": [
            {
                "action": "sagemaker:DescribeWorkteam",
                "resource_mappings": {
                    "WorkteamName": {
                        "template": "${WorkteamName}"
                    }
                }
            }
        ],
        "SageMaker.DisableSagemakerServicecatalogPortfolio": [
            {
                "action": "sagemaker:DisableSagemakerServicecatalogPortfolio",
                "resource_mappings": {}
            }
        ],
        "SageMaker.DisassociateTrialComponent": [
            {
                "action": "sagemaker:DisassociateTrialComponent",
                "resource_mappings": {
                    "TrialName": {
                        "template": "${TrialName}"
                    },
                    "TrialComponentName": {
                        "template": "${TrialComponentName}"
                    },
                    "ProcessingJobName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SageMaker.EnableSagemakerServicecatalogPortfolio": [
            {
                "action": "sagemaker:EnableSagemakerServicecatalogPortfolio",
                "resource_mappings": {}
            }
        ],
        "SageMaker.GetDeviceFleetReport": [
            {
                "action": "sagemaker:GetDeviceFleetReport",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    }
                }
            }
        ],
        "SageMaker.GetModelPackageGroupPolicy": [
            {
                "action": "sagemaker:GetModelPackageGroupPolicy",
                "resource_mappings": {
                    "ModelPackageGroupName": {
                        "template": "${ModelPackageGroupName}"
                    }
                }
            }
        ],
        "SageMaker.GetSagemakerServicecatalogPortfolioStatus": [
            {
                "action": "sagemaker:GetSagemakerServicecatalogPortfolioStatus",
                "resource_mappings": {}
            }
        ],
        "SageMaker.GetSearchSuggestions": [
            {
                "action": "sagemaker:GetSearchSuggestions",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListActions": [
            {
                "action": "sagemaker:ListActions",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListAlgorithms": [
            {
                "action": "sagemaker:ListAlgorithms",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListAppImageConfigs": [
            {
                "action": "sagemaker:ListAppImageConfigs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListApps": [
            {
                "action": "sagemaker:ListApps",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListArtifacts": [
            {
                "action": "sagemaker:ListArtifacts",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListAssociations": [
            {
                "action": "sagemaker:ListAssociations",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListAutoMLJobs": [
            {
                "action": "sagemaker:ListAutoMLJobs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListCandidatesForAutoMLJob": [
            {
                "action": "sagemaker:ListCandidatesForAutoMLJob",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListCodeRepositories": [
            {
                "action": "sagemaker:ListCodeRepositories",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListCompilationJobs": [
            {
                "action": "sagemaker:ListCompilationJobs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListContexts": [
            {
                "action": "sagemaker:ListContexts",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListDataQualityJobDefinitions": [
            {
                "action": "sagemaker:ListDataQualityJobDefinitions",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListDeviceFleets": [
            {
                "action": "sagemaker:ListDeviceFleets",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListDevices": [
            {
                "action": "sagemaker:ListDevices",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListDomains": [
            {
                "action": "sagemaker:ListDomains",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListEdgePackagingJobs": [
            {
                "action": "sagemaker:ListEdgePackagingJobs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListEndpointConfigs": [
            {
                "action": "sagemaker:ListEndpointConfigs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListEndpoints": [
            {
                "action": "sagemaker:ListEndpoints",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListExperiments": [
            {
                "action": "sagemaker:ListExperiments",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListFeatureGroups": [
            {
                "action": "sagemaker:ListFeatureGroups",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListFlowDefinitions": [
            {
                "action": "sagemaker:ListFlowDefinitions",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListHumanTaskUis": [
            {
                "action": "sagemaker:ListHumanTaskUis",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListHyperParameterTuningJobs": [
            {
                "action": "sagemaker:ListHyperParameterTuningJobs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListImageVersions": [
            {
                "action": "sagemaker:ListImageVersions",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${ImageName}"
                    }
                }
            }
        ],
        "SageMaker.ListImages": [
            {
                "action": "sagemaker:ListImages",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListLabelingJobs": [
            {
                "action": "sagemaker:ListLabelingJobs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListLabelingJobsForWorkteam": [
            {
                "action": "sagemaker:ListLabelingJobsForWorkteam",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "workteam": "${WorkteamArn}"
                }
            }
        ],
        "SageMaker.ListModelBiasJobDefinitions": [
            {
                "action": "sagemaker:ListModelBiasJobDefinitions",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListModelExplainabilityJobDefinitions": [
            {
                "action": "sagemaker:ListModelExplainabilityJobDefinitions",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListModelPackageGroups": [
            {
                "action": "sagemaker:ListModelPackageGroups",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListModelPackages": [
            {
                "action": "sagemaker:ListModelPackages",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListModelQualityJobDefinitions": [
            {
                "action": "sagemaker:ListModelQualityJobDefinitions",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListModels": [
            {
                "action": "sagemaker:ListModels",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListMonitoringExecutions": [
            {
                "action": "sagemaker:ListMonitoringExecutions",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListMonitoringSchedules": [
            {
                "action": "sagemaker:ListMonitoringSchedules",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListNotebookInstanceLifecycleConfigs": [
            {
                "action": "sagemaker:ListNotebookInstanceLifecycleConfigs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListNotebookInstances": [
            {
                "action": "sagemaker:ListNotebookInstances",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListPipelineExecutionSteps": [
            {
                "action": "sagemaker:ListPipelineExecutionSteps",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "pipeline-execution": "${PipelineExecutionArn}"
                }
            }
        ],
        "SageMaker.ListPipelineExecutions": [
            {
                "action": "sagemaker:ListPipelineExecutions",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${PipelineName}"
                    }
                }
            }
        ],
        "SageMaker.ListPipelineParametersForExecution": [
            {
                "action": "sagemaker:ListPipelineParametersForExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "pipeline-execution": "${PipelineExecutionArn}"
                }
            }
        ],
        "SageMaker.ListPipelines": [
            {
                "action": "sagemaker:ListPipelines",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListProcessingJobs": [
            {
                "action": "sagemaker:ListProcessingJobs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListProjects": [
            {
                "action": "sagemaker:ListProjects",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListSubscribedWorkteams": [
            {
                "action": "sagemaker:ListSubscribedWorkteams",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListTags": [
            {
                "action": "sagemaker:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "action": "%%iftemplatematch%${ResourceArn}%%",
                    "algorithm": "%%iftemplatematch%${ResourceArn}%%",
                    "app": "%%iftemplatematch%${ResourceArn}%%",
                    "app-image-config": "%%iftemplatematch%${ResourceArn}%%",
                    "artifact": "%%iftemplatematch%${ResourceArn}%%",
                    "automl-job": "%%iftemplatematch%${ResourceArn}%%",
                    "code-repository": "%%iftemplatematch%${ResourceArn}%%",
                    "context": "%%iftemplatematch%${ResourceArn}%%",
                    "data-quality-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "device-fleet": "%%iftemplatematch%${ResourceArn}%%",
                    "domain": "%%iftemplatematch%${ResourceArn}%%",
                    "edge-packaging-job": "%%iftemplatematch%${ResourceArn}%%",
                    "endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "endpoint-config": "%%iftemplatematch%${ResourceArn}%%",
                    "experiment": "%%iftemplatematch%${ResourceArn}%%",
                    "experiment-trial": "%%iftemplatematch%${ResourceArn}%%",
                    "experiment-trial-component": "%%iftemplatematch%${ResourceArn}%%",
                    "feature-group": "%%iftemplatematch%${ResourceArn}%%",
                    "flow-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "human-task-ui": "%%iftemplatematch%${ResourceArn}%%",
                    "hyper-parameter-tuning-job": "%%iftemplatematch%${ResourceArn}%%",
                    "image": "%%iftemplatematch%${ResourceArn}%%",
                    "labeling-job": "%%iftemplatematch%${ResourceArn}%%",
                    "model": "%%iftemplatematch%${ResourceArn}%%",
                    "model-bias-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "model-explainability-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "model-package": "%%iftemplatematch%${ResourceArn}%%",
                    "model-package-group": "%%iftemplatematch%${ResourceArn}%%",
                    "model-quality-job-definition": "%%iftemplatematch%${ResourceArn}%%",
                    "monitoring-schedule": "%%iftemplatematch%${ResourceArn}%%",
                    "notebook-instance": "%%iftemplatematch%${ResourceArn}%%",
                    "pipeline": "%%iftemplatematch%${ResourceArn}%%",
                    "project": "%%iftemplatematch%${ResourceArn}%%",
                    "training-job": "%%iftemplatematch%${ResourceArn}%%",
                    "transform-job": "%%iftemplatematch%${ResourceArn}%%",
                    "user-profile": "%%iftemplatematch%${ResourceArn}%%",
                    "workteam": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SageMaker.ListTrainingJobs": [
            {
                "action": "sagemaker:ListTrainingJobs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListTrainingJobsForHyperParameterTuningJob": [
            {
                "action": "sagemaker:ListTrainingJobsForHyperParameterTuningJob",
                "resource_mappings": {
                    "HyperParameterTuningJobName": {
                        "template": "${HyperParameterTuningJobName}"
                    }
                }
            }
        ],
        "SageMaker.ListTransformJobs": [
            {
                "action": "sagemaker:ListTransformJobs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListTrialComponents": [
            {
                "action": "sagemaker:ListTrialComponents",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListTrials": [
            {
                "action": "sagemaker:ListTrials",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListUserProfiles": [
            {
                "action": "sagemaker:ListUserProfiles",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListWorkforces": [
            {
                "action": "sagemaker:ListWorkforces",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListWorkteams": [
            {
                "action": "sagemaker:ListWorkteams",
                "resource_mappings": {}
            }
        ],
        "SageMaker.PutModelPackageGroupPolicy": [
            {
                "action": "sagemaker:PutModelPackageGroupPolicy",
                "resource_mappings": {
                    "ModelPackageGroupName": {
                        "template": "${ModelPackageGroupName}"
                    }
                }
            }
        ],
        "SageMaker.RegisterDevices": [
            {
                "action": "sagemaker:RegisterDevices",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    },
                    "DeviceName": {
                        "template": "${Devices[].DeviceName}"
                    }
                }
            }
        ],
        "SageMaker.RenderUiTemplate": [
            {
                "action": "sagemaker:RenderUiTemplate",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "SageMaker.StartMonitoringSchedule": [
            {
                "action": "sagemaker:StartMonitoringSchedule",
                "resource_mappings": {
                    "MonitoringScheduleName": {
                        "template": "${MonitoringScheduleName}"
                    }
                }
            }
        ],
        "SageMaker.StartNotebookInstance": [
            {
                "action": "sagemaker:StartNotebookInstance",
                "resource_mappings": {
                    "NotebookInstanceName": {
                        "template": "${NotebookInstanceName}"
                    }
                }
            }
        ],
        "SageMaker.StartPipelineExecution": [
            {
                "action": "sagemaker:StartPipelineExecution",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${PipelineName}"
                    }
                }
            }
        ],
        "SageMaker.StopAutoMLJob": [
            {
                "action": "sagemaker:StopAutoMLJob",
                "resource_mappings": {
                    "AutoMLJobJobName": {
                        "template": "${AutoMLJobName}"
                    }
                }
            }
        ],
        "SageMaker.StopCompilationJob": [
            {
                "action": "sagemaker:StopCompilationJob",
                "resource_mappings": {
                    "CompilationJobName": {
                        "template": "${CompilationJobName}"
                    }
                }
            }
        ],
        "SageMaker.StopEdgePackagingJob": [
            {
                "action": "sagemaker:StopEdgePackagingJob",
                "resource_mappings": {
                    "EdgePackagingJobName": {
                        "template": "${EdgePackagingJobName}"
                    }
                }
            }
        ],
        "SageMaker.StopHyperParameterTuningJob": [
            {
                "action": "sagemaker:StopHyperParameterTuningJob",
                "resource_mappings": {
                    "HyperParameterTuningJobName": {
                        "template": "${HyperParameterTuningJobName}"
                    }
                }
            }
        ],
        "SageMaker.StopLabelingJob": [
            {
                "action": "sagemaker:StopLabelingJob",
                "resource_mappings": {
                    "LabelingJobName": {
                        "template": "${LabelingJobName}"
                    }
                }
            }
        ],
        "SageMaker.StopMonitoringSchedule": [
            {
                "action": "sagemaker:StopMonitoringSchedule",
                "resource_mappings": {
                    "MonitoringScheduleName": {
                        "template": "${MonitoringScheduleName}"
                    }
                }
            }
        ],
        "SageMaker.StopNotebookInstance": [
            {
                "action": "sagemaker:StopNotebookInstance",
                "resource_mappings": {
                    "NotebookInstanceName": {
                        "template": "${NotebookInstanceName}"
                    }
                }
            }
        ],
        "SageMaker.StopPipelineExecution": [
            {
                "action": "sagemaker:StopPipelineExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "pipeline-execution": "${PipelineExecutionArn}"
                }
            }
        ],
        "SageMaker.StopProcessingJob": [
            {
                "action": "sagemaker:StopProcessingJob",
                "resource_mappings": {
                    "ProcessingJobName": {
                        "template": "${ProcessingJobName}"
                    }
                }
            }
        ],
        "SageMaker.StopTrainingJob": [
            {
                "action": "sagemaker:StopTrainingJob",
                "resource_mappings": {
                    "TrainingJobName": {
                        "template": "${TrainingJobName}"
                    }
                }
            }
        ],
        "SageMaker.StopTransformJob": [
            {
                "action": "sagemaker:StopTransformJob",
                "resource_mappings": {
                    "TransformJobName": {
                        "template": "${TransformJobName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateAction": [
            {
                "action": "sagemaker:UpdateAction",
                "resource_mappings": {
                    "ActionName": {
                        "template": "${ActionName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateAppImageConfig": [
            {
                "action": "sagemaker:UpdateAppImageConfig",
                "resource_mappings": {
                    "AppImageConfigName": {
                        "template": "${AppImageConfigName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateArtifact": [
            {
                "action": "sagemaker:UpdateArtifact",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "artifact": "${ArtifactArn}"
                }
            }
        ],
        "SageMaker.UpdateCodeRepository": [
            {
                "action": "sagemaker:UpdateCodeRepository",
                "resource_mappings": {
                    "CodeRepositoryName": {
                        "template": "${CodeRepositoryName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateContext": [
            {
                "action": "sagemaker:UpdateContext",
                "resource_mappings": {
                    "ContextName": {
                        "template": "${ContextName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateDeviceFleet": [
            {
                "action": "sagemaker:UpdateDeviceFleet",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateDevices": [
            {
                "action": "sagemaker:UpdateDevices",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    },
                    "DeviceName": {
                        "template": "${Devices[].DeviceName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateDomain": [
            {
                "action": "sagemaker:UpdateDomain",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DefaultUserSettings.ExecutionRole}"
                }
            }
        ],
        "SageMaker.UpdateEndpoint": [
            {
                "action": "sagemaker:UpdateEndpoint",
                "resource_mappings": {
                    "EndpointName": {
                        "template": "${EndpointName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateEndpointWeightsAndCapacities": [
            {
                "action": "sagemaker:UpdateEndpointWeightsAndCapacities",
                "resource_mappings": {
                    "EndpointName": {
                        "template": "${EndpointName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateExperiment": [
            {
                "action": "sagemaker:UpdateExperiment",
                "resource_mappings": {
                    "ExperimentName": {
                        "template": "${ExperimentName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateImage": [
            {
                "action": "sagemaker:UpdateImage",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${ImageName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.UpdateModelPackage": [
            {
                "action": "sagemaker:UpdateModelPackage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "model-package": "${ModelPackageArn}"
                }
            }
        ],
        "SageMaker.UpdateMonitoringSchedule": [
            {
                "action": "sagemaker:UpdateMonitoringSchedule",
                "resource_mappings": {
                    "MonitoringScheduleName": {
                        "template": "${MonitoringScheduleName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${MonitoringScheduleConfig.MonitoringJobDefinition.RoleArn}"
                }
            }
        ],
        "SageMaker.UpdateNotebookInstance": [
            {
                "action": "sagemaker:UpdateNotebookInstance",
                "resource_mappings": {
                    "NotebookInstanceName": {
                        "template": "${NotebookInstanceName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "SageMaker.UpdateNotebookInstanceLifecycleConfig": [
            {
                "action": "sagemaker:UpdateNotebookInstanceLifecycleConfig",
                "resource_mappings": {
                    "NotebookInstanceLifecycleConfigName": {
                        "template": "${NotebookInstanceLifecycleConfigName}"
                    }
                }
            }
        ],
        "SageMaker.UpdatePipeline": [
            {
                "action": "sagemaker:UpdatePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${PipelineName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.UpdatePipelineExecution": [
            {
                "action": "sagemaker:UpdatePipelineExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "pipeline-execution": "${PipelineExecutionArn}"
                }
            }
        ],
        "SageMaker.UpdateTrainingJob": [
            {
                "action": "sagemaker:UpdateTrainingJob",
                "resource_mappings": {
                    "TrainingJobName": {
                        "template": "${TrainingJobName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateTrial": [
            {
                "action": "sagemaker:UpdateTrial",
                "resource_mappings": {
                    "TrialName": {
                        "template": "${TrialName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateTrialComponent": [
            {
                "action": "sagemaker:UpdateTrialComponent",
                "resource_mappings": {
                    "TrialComponentName": {
                        "template": "${TrialComponentName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateUserProfile": [
            {
                "action": "sagemaker:UpdateUserProfile",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    },
                    "UserProfileName": {
                        "template": "${UserProfileName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${UserSettings.ExecutionRole}"
                }
            }
        ],
        "SageMaker.UpdateWorkforce": [
            {
                "action": "sagemaker:UpdateWorkforce",
                "resource_mappings": {
                    "WorkforceName": {
                        "template": "${WorkforceName}"
                    }
                }
            }
        ],
        "SageMaker.UpdateWorkteam": [
            {
                "action": "sagemaker:UpdateWorkteam",
                "resource_mappings": {
                    "WorkteamName": {
                        "template": "${WorkteamName}"
                    }
                }
            }
        ],
        "Translate.CreateParallelData": [
            {
                "action": "translate:CreateParallelData",
                "resource_mappings": {}
            }
        ],
        "Translate.DeleteParallelData": [
            {
                "action": "translate:DeleteParallelData",
                "resource_mappings": {}
            }
        ],
        "Translate.DeleteTerminology": [
            {
                "action": "translate:DeleteTerminology",
                "resource_mappings": {}
            }
        ],
        "Translate.DescribeTextTranslationJob": [
            {
                "action": "translate:DescribeTextTranslationJob",
                "resource_mappings": {}
            }
        ],
        "Translate.GetParallelData": [
            {
                "action": "translate:GetParallelData",
                "resource_mappings": {}
            }
        ],
        "Translate.GetTerminology": [
            {
                "action": "translate:GetTerminology",
                "resource_mappings": {}
            }
        ],
        "Translate.ImportTerminology": [
            {
                "action": "translate:ImportTerminology",
                "resource_mappings": {}
            }
        ],
        "Translate.ListParallelData": [
            {
                "action": "translate:ListParallelData",
                "resource_mappings": {}
            }
        ],
        "Translate.ListTerminologies": [
            {
                "action": "translate:ListTerminologies",
                "resource_mappings": {}
            }
        ],
        "Translate.ListTextTranslationJobs": [
            {
                "action": "translate:ListTextTranslationJobs",
                "resource_mappings": {}
            }
        ],
        "Translate.StartTextTranslationJob": [
            {
                "action": "translate:StartTextTranslationJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataAccessRoleArn}"
                }
            }
        ],
        "Translate.StopTextTranslationJob": [
            {
                "action": "translate:StopTextTranslationJob",
                "resource_mappings": {}
            }
        ],
        "Translate.TranslateText": [
            {
                "action": "translate:TranslateText",
                "resource_mappings": {}
            }
        ],
        "Translate.UpdateParallelData": [
            {
                "action": "translate:UpdateParallelData",
                "resource_mappings": {}
            }
        ],
        "ResourceGroups.CreateGroup": [
            {
                "action": "resource-groups:CreateGroup",
                "resource_mappings": {}
            }
        ],
        "ResourceGroups.DeleteGroup": [
            {
                "action": "resource-groups:DeleteGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "%%regex%${Group}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ResourceGroups.GetGroup": [
            {
                "action": "resource-groups:GetGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "%%regex%${Group}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ResourceGroups.GetGroupConfiguration": [
            {
                "action": "resource-groups:GetGroupConfiguration",
                "resource_mappings": {
                    "GroupName": {
                        "template": "%%regex%${Group}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ResourceGroups.GetGroupQuery": [
            {
                "action": "resource-groups:GetGroupQuery",
                "resource_mappings": {
                    "GroupName": {
                        "template": "%%regex%${Group}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ResourceGroups.GetTags": [
            {
                "action": "resource-groups:GetTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "${Arn}"
                }
            }
        ],
        "ResourceGroups.GroupResources": [
            {
                "action": "resource-groups:GroupResources",
                "resource_mappings": {
                    "GroupName": {
                        "template": "%%regex%${Group}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ResourceGroups.ListGroupResources": [
            {
                "action": "resource-groups:ListGroupResources",
                "resource_mappings": {
                    "GroupName": {
                        "template": "%%regex%${Group}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            },
            {
                "action": "cloudformation:DescribeStacks",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "ResourceGroups.ListGroups": [
            {
                "action": "resource-groups:ListGroups",
                "resource_mappings": {}
            }
        ],
        "ResourceGroups.SearchResources": [
            {
                "action": "resource-groups:SearchResources",
                "resource_mappings": {}
            },
            {
                "action": "cloudformation:DescribeStacks",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "ResourceGroups.Tag": [
            {
                "action": "resource-groups:Tag",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "${Arn}"
                }
            }
        ],
        "ResourceGroups.UngroupResources": [
            {
                "action": "resource-groups:UngroupResources",
                "resource_mappings": {
                    "GroupName": {
                        "template": "%%regex%${Group}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ResourceGroups.Untag": [
            {
                "action": "resource-groups:Untag",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "${Arn}"
                }
            }
        ],
        "ResourceGroups.UpdateGroup": [
            {
                "action": "resource-groups:UpdateGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "%%regex%${Group}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ResourceGroups.UpdateGroupQuery": [
            {
                "action": "resource-groups:UpdateGroupQuery",
                "resource_mappings": {
                    "GroupName": {
                        "template": "%%regex%${Group}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "AlexaForBusiness.ApproveSkill": [
            {
                "action": "a4b:ApproveSkill",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.AssociateContactWithAddressBook": [
            {
                "action": "a4b:AssociateContactWithAddressBook",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "addressbook": "${AddressBookArn}",
                    "contact": "${ContactArn}"
                }
            }
        ],
        "AlexaForBusiness.AssociateDeviceWithRoom": [
            {
                "action": "a4b:AssociateDeviceWithRoom",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${DeviceArn}",
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.AssociateSkillGroupWithRoom": [
            {
                "action": "a4b:AssociateSkillGroupWithRoom",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}",
                    "skillgroup": "${SkillGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.AssociateSkillWithSkillGroup": [
            {
                "action": "a4b:AssociateSkillWithSkillGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "skillgroup": "${SkillGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.AssociateSkillWithUsers": [
            {
                "action": "a4b:AssociateSkillWithUsers",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.CreateAddressBook": [
            {
                "action": "a4b:CreateAddressBook",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.CreateBusinessReportSchedule": [
            {
                "action": "a4b:CreateBusinessReportSchedule",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.CreateConferenceProvider": [
            {
                "action": "a4b:CreateConferenceProvider",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.CreateContact": [
            {
                "action": "a4b:CreateContact",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.CreateProfile": [
            {
                "action": "a4b:CreateProfile",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.CreateRoom": [
            {
                "action": "a4b:CreateRoom",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "profile": "${ProfileArn}"
                }
            }
        ],
        "AlexaForBusiness.CreateSkillGroup": [
            {
                "action": "a4b:CreateSkillGroup",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.CreateUser": [
            {
                "action": "a4b:CreateUser",
                "resource_mappings": {
                    "Resource_id": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "AlexaForBusiness.DeleteAddressBook": [
            {
                "action": "a4b:DeleteAddressBook",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "addressbook": "${AddressBookArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteBusinessReportSchedule": [
            {
                "action": "a4b:DeleteBusinessReportSchedule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "schedule": "${ScheduleArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteConferenceProvider": [
            {
                "action": "a4b:DeleteConferenceProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "conferenceprovider": "${ConferenceProviderArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteContact": [
            {
                "action": "a4b:DeleteContact",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "contact": "${ContactArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteDevice": [
            {
                "action": "a4b:DeleteDevice",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${DeviceArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteProfile": [
            {
                "action": "a4b:DeleteProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "profile": "${ProfileArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteRoom": [
            {
                "action": "a4b:DeleteRoom",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteRoomSkillParameter": [
            {
                "action": "a4b:DeleteRoomSkillParameter",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteSkillAuthorization": [
            {
                "action": "a4b:DeleteSkillAuthorization",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteSkillGroup": [
            {
                "action": "a4b:DeleteSkillGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "skillgroup": "${SkillGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteUser": [
            {
                "action": "a4b:DeleteUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "user": "${UserArn}"
                }
            }
        ],
        "AlexaForBusiness.DisassociateContactFromAddressBook": [
            {
                "action": "a4b:DisassociateContactFromAddressBook",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "addressbook": "${AddressBookArn}",
                    "contact": "${ContactArn}"
                }
            }
        ],
        "AlexaForBusiness.DisassociateDeviceFromRoom": [
            {
                "action": "a4b:DisassociateDeviceFromRoom",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${DeviceArn}"
                }
            }
        ],
        "AlexaForBusiness.DisassociateSkillFromSkillGroup": [
            {
                "action": "a4b:DisassociateSkillFromSkillGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "skillgroup": "${SkillGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.DisassociateSkillFromUsers": [
            {
                "action": "a4b:DisassociateSkillFromUsers",
                "resource_mappings": {
                    "Resource_id": {
                        "template": "*"
                    }
                }
            }
        ],
        "AlexaForBusiness.DisassociateSkillGroupFromRoom": [
            {
                "action": "a4b:DisassociateSkillGroupFromRoom",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}",
                    "skillgroup": "${SkillGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.ForgetSmartHomeAppliances": [
            {
                "action": "a4b:ForgetSmartHomeAppliances",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.GetAddressBook": [
            {
                "action": "a4b:GetAddressBook",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "addressbook": "${AddressBookArn}"
                }
            }
        ],
        "AlexaForBusiness.GetConferencePreference": [
            {
                "action": "a4b:GetConferencePreference",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.GetConferenceProvider": [
            {
                "action": "a4b:GetConferenceProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "conferenceprovider": "${ConferenceProviderArn}"
                }
            }
        ],
        "AlexaForBusiness.GetContact": [
            {
                "action": "a4b:GetContact",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "contact": "${ContactArn}"
                }
            }
        ],
        "AlexaForBusiness.GetDevice": [
            {
                "action": "a4b:GetDevice",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${DeviceArn}"
                }
            }
        ],
        "AlexaForBusiness.GetNetworkProfile": [
            {
                "action": "a4b:GetNetworkProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkprofile": "${NetworkProfileArn}"
                }
            }
        ],
        "AlexaForBusiness.GetProfile": [
            {
                "action": "a4b:GetProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "profile": "${ProfileArn}"
                }
            }
        ],
        "AlexaForBusiness.GetRoom": [
            {
                "action": "a4b:GetRoom",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.GetRoomSkillParameter": [
            {
                "action": "a4b:GetRoomSkillParameter",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.GetSkillGroup": [
            {
                "action": "a4b:GetSkillGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "skillgroup": "${SkillGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.ListBusinessReportSchedules": [
            {
                "action": "a4b:ListBusinessReportSchedules",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.ListConferenceProviders": [
            {
                "action": "a4b:ListConferenceProviders",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.ListDeviceEvents": [
            {
                "action": "a4b:ListDeviceEvents",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${DeviceArn}"
                }
            }
        ],
        "AlexaForBusiness.ListSkills": [
            {
                "action": "a4b:ListSkills",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.ListSkillsStoreCategories": [
            {
                "action": "a4b:ListSkillsStoreCategories",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.ListSkillsStoreSkillsByCategory": [
            {
                "action": "a4b:ListSkillsStoreSkillsByCategory",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.ListSmartHomeAppliances": [
            {
                "action": "a4b:ListSmartHomeAppliances",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.ListTags": [
            {
                "action": "a4b:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${Arn}%%",
                    "room": "%%iftemplatematch%${Arn}%%",
                    "user": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "AlexaForBusiness.PutConferencePreference": [
            {
                "action": "a4b:PutConferencePreference",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.PutRoomSkillParameter": [
            {
                "action": "a4b:PutRoomSkillParameter",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.PutSkillAuthorization": [
            {
                "action": "a4b:PutSkillAuthorization",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.RegisterAVSDevice": [
            {
                "action": "a4b:RegisterAVSDevice",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.RejectSkill": [
            {
                "action": "a4b:RejectSkill",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.ResolveRoom": [
            {
                "action": "a4b:ResolveRoom",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.RevokeInvitation": [
            {
                "action": "a4b:RevokeInvitation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "user": "${UserArn}"
                }
            }
        ],
        "AlexaForBusiness.SearchAddressBooks": [
            {
                "action": "a4b:SearchAddressBooks",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.SearchContacts": [
            {
                "action": "a4b:SearchContacts",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.SearchDevices": [
            {
                "action": "a4b:SearchDevices",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.SearchNetworkProfiles": [
            {
                "action": "a4b:SearchNetworkProfiles",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.SearchProfiles": [
            {
                "action": "a4b:SearchProfiles",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.SearchRooms": [
            {
                "action": "a4b:SearchRooms",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.SearchSkillGroups": [
            {
                "action": "a4b:SearchSkillGroups",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.SearchUsers": [
            {
                "action": "a4b:SearchUsers",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.SendInvitation": [
            {
                "action": "a4b:SendInvitation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "user": "${UserArn}"
                }
            }
        ],
        "AlexaForBusiness.StartDeviceSync": [
            {
                "action": "a4b:StartDeviceSync",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.StartSmartHomeApplianceDiscovery": [
            {
                "action": "a4b:StartSmartHomeApplianceDiscovery",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.TagResource": [
            {
                "action": "a4b:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${Arn}%%",
                    "room": "%%iftemplatematch%${Arn}%%",
                    "user": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "AlexaForBusiness.UntagResource": [
            {
                "action": "a4b:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${Arn}%%",
                    "room": "%%iftemplatematch%${Arn}%%",
                    "user": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "AlexaForBusiness.UpdateAddressBook": [
            {
                "action": "a4b:UpdateAddressBook",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "addressbook": "${AddressBookArn}"
                }
            }
        ],
        "AlexaForBusiness.UpdateBusinessReportSchedule": [
            {
                "action": "a4b:UpdateBusinessReportSchedule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "schedule": "${ScheduleArn}"
                }
            }
        ],
        "AlexaForBusiness.UpdateConferenceProvider": [
            {
                "action": "a4b:UpdateConferenceProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "conferenceprovider": "${ConferenceProviderArn}"
                }
            }
        ],
        "AlexaForBusiness.UpdateContact": [
            {
                "action": "a4b:UpdateContact",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "contact": "${ContactArn}"
                }
            }
        ],
        "AlexaForBusiness.UpdateDevice": [
            {
                "action": "a4b:UpdateDevice",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${DeviceArn}"
                }
            }
        ],
        "AlexaForBusiness.UpdateProfile": [
            {
                "action": "a4b:UpdateProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "profile": "${ProfileArn}"
                }
            }
        ],
        "AlexaForBusiness.UpdateRoom": [
            {
                "action": "a4b:UpdateRoom",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "room": "${RoomArn}"
                }
            }
        ],
        "AlexaForBusiness.UpdateSkillGroup": [
            {
                "action": "a4b:UpdateSkillGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "skillgroup": "${SkillGroupArn}"
                }
            }
        ],
        "Cloud9.CreateEnvironmentEC2": [
            {
                "action": "cloud9:CreateEnvironmentEC2",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            }
        ],
        "Cloud9.CreateEnvironmentMembership": [
            {
                "action": "cloud9:CreateEnvironmentMembership",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${environmentId}"
                    }
                }
            }
        ],
        "Cloud9.DeleteEnvironment": [
            {
                "action": "cloud9:DeleteEnvironment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${environmentId}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Cloud9.DeleteEnvironmentMembership": [
            {
                "action": "cloud9:DeleteEnvironmentMembership",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${environmentId}"
                    }
                }
            }
        ],
        "Cloud9.DescribeEnvironmentMemberships": [
            {
                "action": "cloud9:DescribeEnvironmentMemberships",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${environmentId}"
                    }
                }
            }
        ],
        "Cloud9.DescribeEnvironmentStatus": [
            {
                "action": "cloud9:DescribeEnvironmentStatus",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${environmentId}"
                    }
                }
            }
        ],
        "Cloud9.DescribeEnvironments": [
            {
                "action": "cloud9:DescribeEnvironments",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${environmentIds[]}"
                    }
                }
            }
        ],
        "Cloud9.ListEnvironments": [
            {
                "action": "cloud9:ListEnvironments",
                "resource_mappings": {}
            }
        ],
        "Cloud9.ListTagsForResource": [
            {
                "action": "cloud9:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Cloud9.TagResource": [
            {
                "action": "cloud9:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Cloud9.UntagResource": [
            {
                "action": "cloud9:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Cloud9.UpdateEnvironment": [
            {
                "action": "cloud9:UpdateEnvironment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${environmentId}"
                    }
                }
            }
        ],
        "Cloud9.UpdateEnvironmentMembership": [
            {
                "action": "cloud9:UpdateEnvironmentMembership",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${environmentId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.CreateApplication": [
            {
                "action": "serverlessrepo:CreateApplication",
                "resource_mappings": {}
            }
        ],
        "ServerlessApplicationRepository.CreateApplicationVersion": [
            {
                "action": "serverlessrepo:CreateApplicationVersion",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.CreateCloudFormationChangeSet": [
            {
                "action": "serverlessrepo:CreateCloudFormationChangeSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.CreateCloudFormationTemplate": [
            {
                "action": "serverlessrepo:CreateCloudFormationTemplate",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.DeleteApplication": [
            {
                "action": "serverlessrepo:DeleteApplication",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.GetApplication": [
            {
                "action": "serverlessrepo:GetApplication",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.GetApplicationPolicy": [
            {
                "action": "serverlessrepo:GetApplicationPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.GetCloudFormationTemplate": [
            {
                "action": "serverlessrepo:GetCloudFormationTemplate",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.ListApplicationDependencies": [
            {
                "action": "serverlessrepo:ListApplicationDependencies",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.ListApplicationVersions": [
            {
                "action": "serverlessrepo:ListApplicationVersions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.ListApplications": [
            {
                "action": "serverlessrepo:ListApplications",
                "resource_mappings": {}
            }
        ],
        "ServerlessApplicationRepository.PutApplicationPolicy": [
            {
                "action": "serverlessrepo:PutApplicationPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.UnshareApplication": [
            {
                "action": "serverlessrepo:UnshareApplication",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServerlessApplicationRepository.UpdateApplication": [
            {
                "action": "serverlessrepo:UpdateApplication",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "ServiceDiscovery.CreateHttpNamespace": [
            {
                "action": "servicediscovery:CreateHttpNamespace",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.CreatePrivateDnsNamespace": [
            {
                "action": "servicediscovery:CreatePrivateDnsNamespace",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.CreatePublicDnsNamespace": [
            {
                "action": "servicediscovery:CreatePublicDnsNamespace",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.CreateService": [
            {
                "action": "servicediscovery:CreateService",
                "resource_mappings": {
                    "NamespaceId": {
                        "template": "${NamespaceId}"
                    }
                }
            }
        ],
        "ServiceDiscovery.DeleteNamespace": [
            {
                "action": "servicediscovery:DeleteNamespace",
                "resource_mappings": {
                    "NamespaceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceDiscovery.DeleteService": [
            {
                "action": "servicediscovery:DeleteService",
                "resource_mappings": {
                    "ServiceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceDiscovery.DeregisterInstance": [
            {
                "action": "servicediscovery:DeregisterInstance",
                "resource_mappings": {
                    "ServiceId": {
                        "template": "${ServiceId}"
                    }
                }
            }
        ],
        "ServiceDiscovery.DiscoverInstances": [
            {
                "action": "servicediscovery:DiscoverInstances",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.GetInstance": [
            {
                "action": "servicediscovery:GetInstance",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.GetInstancesHealthStatus": [
            {
                "action": "servicediscovery:GetInstancesHealthStatus",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.GetNamespace": [
            {
                "action": "servicediscovery:GetNamespace",
                "resource_mappings": {
                    "NamespaceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceDiscovery.GetOperation": [
            {
                "action": "servicediscovery:GetOperation",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.GetService": [
            {
                "action": "servicediscovery:GetService",
                "resource_mappings": {
                    "ServiceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceDiscovery.ListInstances": [
            {
                "action": "servicediscovery:ListInstances",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.ListNamespaces": [
            {
                "action": "servicediscovery:ListNamespaces",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.ListOperations": [
            {
                "action": "servicediscovery:ListOperations",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.ListServices": [
            {
                "action": "servicediscovery:ListServices",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.ListTagsForResource": [
            {
                "action": "servicediscovery:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.RegisterInstance": [
            {
                "action": "servicediscovery:RegisterInstance",
                "resource_mappings": {
                    "ServiceId": {
                        "template": "${ServiceId}"
                    }
                }
            }
        ],
        "ServiceDiscovery.TagResource": [
            {
                "action": "servicediscovery:TagResource",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.UntagResource": [
            {
                "action": "servicediscovery:UntagResource",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.UpdateInstanceCustomHealthStatus": [
            {
                "action": "servicediscovery:UpdateInstanceCustomHealthStatus",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.UpdateService": [
            {
                "action": "servicediscovery:UpdateService",
                "resource_mappings": {
                    "ServiceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WorkMail.AssociateDelegateToResource": [
            {
                "action": "workmail:AssociateDelegateToResource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.AssociateMemberToGroup": [
            {
                "action": "workmail:AssociateMemberToGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.CancelMailboxExportJob": [
            {
                "action": "workmail:CancelMailboxExportJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.CreateAlias": [
            {
                "action": "workmail:CreateAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.CreateGroup": [
            {
                "action": "workmail:CreateGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.CreateOrganization": [
            {
                "action": "workmail:CreateOrganization",
                "resource_mappings": {}
            }
        ],
        "WorkMail.CreateResource": [
            {
                "action": "workmail:CreateResource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.CreateUser": [
            {
                "action": "workmail:CreateUser",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteAccessControlRule": [
            {
                "action": "workmail:DeleteAccessControlRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteAlias": [
            {
                "action": "workmail:DeleteAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteGroup": [
            {
                "action": "workmail:DeleteGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteMailboxPermissions": [
            {
                "action": "workmail:DeleteMailboxPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteOrganization": [
            {
                "action": "workmail:DeleteOrganization",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteResource": [
            {
                "action": "workmail:DeleteResource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteRetentionPolicy": [
            {
                "action": "workmail:DeleteRetentionPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteUser": [
            {
                "action": "workmail:DeleteUser",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeregisterFromWorkMail": [
            {
                "action": "workmail:DeregisterFromWorkMail",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DescribeGroup": [
            {
                "action": "workmail:DescribeGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DescribeMailboxExportJob": [
            {
                "action": "workmail:DescribeMailboxExportJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DescribeOrganization": [
            {
                "action": "workmail:DescribeOrganization",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DescribeResource": [
            {
                "action": "workmail:DescribeResource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DescribeUser": [
            {
                "action": "workmail:DescribeUser",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DisassociateDelegateFromResource": [
            {
                "action": "workmail:DisassociateDelegateFromResource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DisassociateMemberFromGroup": [
            {
                "action": "workmail:DisassociateMemberFromGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.GetAccessControlEffect": [
            {
                "action": "workmail:GetAccessControlEffect",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.GetDefaultRetentionPolicy": [
            {
                "action": "workmail:GetDefaultRetentionPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.GetMailboxDetails": [
            {
                "action": "workmail:GetMailboxDetails",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListAccessControlRules": [
            {
                "action": "workmail:ListAccessControlRules",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListAliases": [
            {
                "action": "workmail:ListAliases",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListGroupMembers": [
            {
                "action": "workmail:ListGroupMembers",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListGroups": [
            {
                "action": "workmail:ListGroups",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListMailboxExportJobs": [
            {
                "action": "workmail:ListMailboxExportJobs",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListMailboxPermissions": [
            {
                "action": "workmail:ListMailboxPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListOrganizations": [
            {
                "action": "workmail:ListOrganizations",
                "resource_mappings": {}
            }
        ],
        "WorkMail.ListResourceDelegates": [
            {
                "action": "workmail:ListResourceDelegates",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListResources": [
            {
                "action": "workmail:ListResources",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListTagsForResource": [
            {
                "action": "workmail:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "organization": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WorkMail.ListUsers": [
            {
                "action": "workmail:ListUsers",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.PutAccessControlRule": [
            {
                "action": "workmail:PutAccessControlRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.PutMailboxPermissions": [
            {
                "action": "workmail:PutMailboxPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.PutRetentionPolicy": [
            {
                "action": "workmail:PutRetentionPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.RegisterToWorkMail": [
            {
                "action": "workmail:RegisterToWorkMail",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ResetPassword": [
            {
                "action": "workmail:ResetPassword",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.StartMailboxExportJob": [
            {
                "action": "workmail:StartMailboxExportJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "WorkMail.TagResource": [
            {
                "action": "workmail:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "organization": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WorkMail.UntagResource": [
            {
                "action": "workmail:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "organization": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WorkMail.UpdateMailboxQuota": [
            {
                "action": "workmail:UpdateMailboxQuota",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.UpdatePrimaryEmailAddress": [
            {
                "action": "workmail:UpdatePrimaryEmailAddress",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.UpdateResource": [
            {
                "action": "workmail:UpdateResource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "AutoScalingPlans.CreateScalingPlan": [
            {
                "action": "autoscaling-plans:CreateScalingPlan",
                "resource_mappings": {}
            }
        ],
        "AutoScalingPlans.DeleteScalingPlan": [
            {
                "action": "autoscaling-plans:DeleteScalingPlan",
                "resource_mappings": {}
            }
        ],
        "AutoScalingPlans.DescribeScalingPlanResources": [
            {
                "action": "autoscaling-plans:DescribeScalingPlanResources",
                "resource_mappings": {}
            }
        ],
        "AutoScalingPlans.DescribeScalingPlans": [
            {
                "action": "autoscaling-plans:DescribeScalingPlans",
                "resource_mappings": {}
            }
        ],
        "AutoScalingPlans.GetScalingPlanResourceForecastData": [
            {
                "action": "autoscaling-plans:GetScalingPlanResourceForecastData",
                "resource_mappings": {}
            }
        ],
        "AutoScalingPlans.UpdateScalingPlan": [
            {
                "action": "autoscaling-plans:UpdateScalingPlan",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.CreateLanguageModel": [
            {
                "action": "transcribe:CreateLanguageModel",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "TranscribeService.CreateMedicalVocabulary": [
            {
                "action": "transcribe:CreateMedicalVocabulary",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "TranscribeService.CreateVocabulary": [
            {
                "action": "transcribe:CreateVocabulary",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "TranscribeService.CreateVocabularyFilter": [
            {
                "action": "transcribe:CreateVocabularyFilter",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "TranscribeService.DeleteLanguageModel": [
            {
                "action": "transcribe:DeleteLanguageModel",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.DeleteMedicalTranscriptionJob": [
            {
                "action": "transcribe:DeleteMedicalTranscriptionJob",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.DeleteMedicalVocabulary": [
            {
                "action": "transcribe:DeleteMedicalVocabulary",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.DeleteTranscriptionJob": [
            {
                "action": "transcribe:DeleteTranscriptionJob",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.DeleteVocabulary": [
            {
                "action": "transcribe:DeleteVocabulary",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.DeleteVocabularyFilter": [
            {
                "action": "transcribe:DeleteVocabularyFilter",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.DescribeLanguageModel": [
            {
                "action": "transcribe:DescribeLanguageModel",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.GetMedicalTranscriptionJob": [
            {
                "action": "transcribe:GetMedicalTranscriptionJob",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.GetMedicalVocabulary": [
            {
                "action": "transcribe:GetMedicalVocabulary",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.GetTranscriptionJob": [
            {
                "action": "transcribe:GetTranscriptionJob",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.GetVocabulary": [
            {
                "action": "transcribe:GetVocabulary",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.GetVocabularyFilter": [
            {
                "action": "transcribe:GetVocabularyFilter",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.ListLanguageModels": [
            {
                "action": "transcribe:ListLanguageModels",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.ListMedicalTranscriptionJobs": [
            {
                "action": "transcribe:ListMedicalTranscriptionJobs",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.ListMedicalVocabularies": [
            {
                "action": "transcribe:ListMedicalVocabularies",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.ListTranscriptionJobs": [
            {
                "action": "transcribe:ListTranscriptionJobs",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.ListVocabularies": [
            {
                "action": "transcribe:ListVocabularies",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.ListVocabularyFilters": [
            {
                "action": "transcribe:ListVocabularyFilters",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.StartMedicalTranscriptionJob": [
            {
                "action": "transcribe:StartMedicalTranscriptionJob",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "TranscribeService.StartTranscriptionJob": [
            {
                "action": "transcribe:StartTranscriptionJob",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "TranscribeService.UpdateMedicalVocabulary": [
            {
                "action": "transcribe:UpdateMedicalVocabulary",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "TranscribeService.UpdateVocabulary": [
            {
                "action": "transcribe:UpdateVocabulary",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "TranscribeService.UpdateVocabularyFilter": [
            {
                "action": "transcribe:UpdateVocabularyFilter",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.AssociateApprovedOrigin": [
            {
                "action": "connect:AssociateApprovedOrigin",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.AssociateInstanceStorageConfig": [
            {
                "action": "connect:AssociateInstanceStorageConfig",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "Connect.AssociateLambdaFunction": [
            {
                "action": "connect:AssociateLambdaFunction",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "lambda:AddPermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "function": "${FunctionArn}"
                }
            }
        ],
        "Connect.AssociateLexBot": [
            {
                "action": "connect:AssociateLexBot",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "iam:AttachRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.AssociateQueueQuickConnects": [
            {
                "action": "connect:AssociateQueueQuickConnects",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueId}"
                    },
                    "QuickConnectId": {
                        "template": "${QuickConnectIds[]}"
                    }
                }
            }
        ],
        "Connect.AssociateRoutingProfileQueues": [
            {
                "action": "connect:AssociateRoutingProfileQueues",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueConfigs[].QueueReference.QueueId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    }
                }
            }
        ],
        "Connect.AssociateSecurityKey": [
            {
                "action": "connect:AssociateSecurityKey",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.CreateContactFlow": [
            {
                "action": "connect:CreateContactFlow",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.CreateInstance": [
            {
                "action": "connect:CreateInstance",
                "resource_mappings": {}
            },
            {
                "action": "ds:AuthorizeApplication",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "Connect.CreateQueue": [
            {
                "action": "connect:CreateQueue",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HoursOfOperationId": {
                        "template": "${HoursOfOperationId}"
                    },
                    "QueueId": {
                        "template": "*"
                    },
                    "ContactFlowId": {
                        "template": "${OutboundCallerConfig.OutboundFlowId}"
                    },
                    "PhoneNumberId": {
                        "template": "${OutboundCallerConfig.OutboundCallerIdNumberId}"
                    },
                    "QuickConnectId": {
                        "template": "${QuickConnectIds[]}"
                    }
                }
            }
        ],
        "Connect.CreateQuickConnect": [
            {
                "action": "connect:CreateQuickConnect",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QuickConnectId": {
                        "template": "*"
                    },
                    "ContactFlowId": {
                        "template": "%%many%${QuickConnectConfig.UserConfig.ContactFlowId}%${QuickConnectConfig.QueueConfig.ContactFlowId}%%"
                    },
                    "QueueId": {
                        "template": "${QuickConnectConfig.QueueConfig.QueueId}"
                    },
                    "UserId": {
                        "template": "${QuickConnectConfig.UserConfig.UserId}"
                    }
                }
            }
        ],
        "Connect.CreateRoutingProfile": [
            {
                "action": "connect:CreateRoutingProfile",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueConfigs[].QueueReference.QueueId}"
                    },
                    "RoutingProfileId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.CreateUser": [
            {
                "action": "connect:CreateUser",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    },
                    "SecurityProfileId": {
                        "template": "${SecurityProfileIds[]}"
                    },
                    "UserId": {
                        "template": "*"
                    },
                    "HierarchyGroupId": {
                        "template": "${HierarchyGroupId}"
                    }
                }
            }
        ],
        "Connect.CreateUserHierarchyGroup": [
            {
                "action": "connect:CreateUserHierarchyGroup",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HierarchyGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.DeleteInstance": [
            {
                "action": "connect:DeleteInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DeleteDirectory",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.DeleteQuickConnect": [
            {
                "action": "connect:DeleteQuickConnect",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QuickConnectId": {
                        "template": "${QuickConnectId}"
                    }
                }
            }
        ],
        "Connect.DeleteUser": [
            {
                "action": "connect:DeleteUser",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "Connect.DeleteUserHierarchyGroup": [
            {
                "action": "connect:DeleteUserHierarchyGroup",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HierarchyGroupId": {
                        "template": "${HierarchyGroupId}"
                    }
                }
            }
        ],
        "Connect.DescribeContactFlow": [
            {
                "action": "connect:DescribeContactFlow",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowId": {
                        "template": "${ContactFlowId}"
                    }
                }
            }
        ],
        "Connect.DescribeHoursOfOperation": [
            {
                "action": "connect:DescribeHoursOfOperation",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HoursOfOperationId": {
                        "template": "${HoursOfOperationId}"
                    }
                }
            }
        ],
        "Connect.DescribeInstance": [
            {
                "action": "connect:DescribeInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "Connect.DescribeInstanceAttribute": [
            {
                "action": "connect:DescribeInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.DescribeInstanceStorageConfig": [
            {
                "action": "connect:DescribeInstanceStorageConfig",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.DescribeQueue": [
            {
                "action": "connect:DescribeQueue",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueId}"
                    }
                }
            }
        ],
        "Connect.DescribeQuickConnect": [
            {
                "action": "connect:DescribeQuickConnect",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QuickConnectId": {
                        "template": "${QuickConnectId}"
                    }
                }
            }
        ],
        "Connect.DescribeRoutingProfile": [
            {
                "action": "connect:DescribeRoutingProfile",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    }
                }
            }
        ],
        "Connect.DescribeUser": [
            {
                "action": "connect:DescribeUser",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "Connect.DescribeUserHierarchyGroup": [
            {
                "action": "connect:DescribeUserHierarchyGroup",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HierarchyGroupId": {
                        "template": "${HierarchyGroupId}"
                    }
                }
            }
        ],
        "Connect.DescribeUserHierarchyStructure": [
            {
                "action": "connect:DescribeUserHierarchyStructure",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.DisassociateApprovedOrigin": [
            {
                "action": "connect:DisassociateApprovedOrigin",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.DisassociateInstanceStorageConfig": [
            {
                "action": "connect:DisassociateInstanceStorageConfig",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.DisassociateLambdaFunction": [
            {
                "action": "connect:DisassociateLambdaFunction",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "lambda:RemovePermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "function": "${FunctionArn}"
                }
            }
        ],
        "Connect.DisassociateLexBot": [
            {
                "action": "connect:DisassociateLexBot",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "iam:AttachRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.DisassociateQueueQuickConnects": [
            {
                "action": "connect:DisassociateQueueQuickConnects",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueId}"
                    },
                    "QuickConnectId": {
                        "template": "${QuickConnectIds[]}"
                    }
                }
            }
        ],
        "Connect.DisassociateRoutingProfileQueues": [
            {
                "action": "connect:DisassociateRoutingProfileQueues",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    }
                }
            }
        ],
        "Connect.DisassociateSecurityKey": [
            {
                "action": "connect:DisassociateSecurityKey",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.GetContactAttributes": [
            {
                "action": "connect:GetContactAttributes",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "${InitialContactId}"
                    }
                }
            }
        ],
        "Connect.GetCurrentMetricData": [
            {
                "action": "connect:GetCurrentMetricData",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.GetFederationToken": [
            {
                "action": "connect:GetFederationToken",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.GetMetricData": [
            {
                "action": "connect:GetMetricData",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.ListApprovedOrigins": [
            {
                "action": "connect:ListApprovedOrigins",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListContactFlows": [
            {
                "action": "connect:ListContactFlows",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListHoursOfOperations": [
            {
                "action": "connect:ListHoursOfOperations",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListInstanceAttributes": [
            {
                "action": "connect:ListInstanceAttributes",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListInstanceStorageConfigs": [
            {
                "action": "connect:ListInstanceStorageConfigs",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListInstances": [
            {
                "action": "connect:ListInstances",
                "resource_mappings": {}
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "Connect.ListLambdaFunctions": [
            {
                "action": "connect:ListLambdaFunctions",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListLexBots": [
            {
                "action": "connect:ListLexBots",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListPhoneNumbers": [
            {
                "action": "connect:ListPhoneNumbers",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListPrompts": [
            {
                "action": "connect:ListPrompts",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListQueueQuickConnects": [
            {
                "action": "connect:ListQueueQuickConnects",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueId}"
                    }
                }
            }
        ],
        "Connect.ListQueues": [
            {
                "action": "connect:ListQueues",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListQuickConnects": [
            {
                "action": "connect:ListQuickConnects",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListRoutingProfileQueues": [
            {
                "action": "connect:ListRoutingProfileQueues",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    }
                }
            }
        ],
        "Connect.ListRoutingProfiles": [
            {
                "action": "connect:ListRoutingProfiles",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListSecurityKeys": [
            {
                "action": "connect:ListSecurityKeys",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListSecurityProfiles": [
            {
                "action": "connect:ListSecurityProfiles",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListTagsForResource": [
            {
                "action": "connect:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "contact-flow": "%%iftemplatematch%${resourceArn}%%",
                    "queue": "%%iftemplatematch%${resourceArn}%%",
                    "quick-connect": "%%iftemplatematch%${resourceArn}%%",
                    "routing-profile": "%%iftemplatematch%${resourceArn}%%",
                    "user": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Connect.ListUserHierarchyGroups": [
            {
                "action": "connect:ListUserHierarchyGroups",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListUsers": [
            {
                "action": "connect:ListUsers",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ResumeContactRecording": [
            {
                "action": "connect:ResumeContactRecording",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "${ContactId}"
                    }
                }
            }
        ],
        "Connect.StartChatContact": [
            {
                "action": "connect:StartChatContact",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowId": {
                        "template": "${ContactFlowId}"
                    }
                }
            }
        ],
        "Connect.StartContactRecording": [
            {
                "action": "connect:StartContactRecording",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "%%many%${ContactId}%${InitialContactId}%%"
                    }
                }
            }
        ],
        "Connect.StartOutboundVoiceContact": [
            {
                "action": "connect:StartOutboundVoiceContact",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.StartTaskContact": [
            {
                "action": "connect:StartTaskContact",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowId": {
                        "template": "${ContactFlowId}"
                    }
                }
            }
        ],
        "Connect.StopContact": [
            {
                "action": "connect:StopContact",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "${ContactId}"
                    }
                }
            }
        ],
        "Connect.StopContactRecording": [
            {
                "action": "connect:StopContactRecording",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "%%many%${ContactId}%${InitialContactId}%%"
                    }
                }
            }
        ],
        "Connect.SuspendContactRecording": [
            {
                "action": "connect:SuspendContactRecording",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "%%many%${ContactId}%${InitialContactId}%%"
                    }
                }
            }
        ],
        "Connect.TagResource": [
            {
                "action": "connect:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "contact-flow": "%%iftemplatematch%${resourceArn}%%",
                    "queue": "%%iftemplatematch%${resourceArn}%%",
                    "quick-connect": "%%iftemplatematch%${resourceArn}%%",
                    "routing-profile": "%%iftemplatematch%${resourceArn}%%",
                    "user": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Connect.UntagResource": [
            {
                "action": "connect:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "contact-flow": "%%iftemplatematch%${resourceArn}%%",
                    "queue": "%%iftemplatematch%${resourceArn}%%",
                    "quick-connect": "%%iftemplatematch%${resourceArn}%%",
                    "routing-profile": "%%iftemplatematch%${resourceArn}%%",
                    "user": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Connect.UpdateContactAttributes": [
            {
                "action": "connect:UpdateContactAttributes",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "${InitialContactId}"
                    }
                }
            }
        ],
        "Connect.UpdateContactFlowContent": [
            {
                "action": "connect:UpdateContactFlowContent",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowId": {
                        "template": "${ContactFlowId}"
                    }
                }
            }
        ],
        "Connect.UpdateContactFlowName": [
            {
                "action": "connect:UpdateContactFlowName",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowId": {
                        "template": "${ContactFlowId}"
                    }
                }
            }
        ],
        "Connect.UpdateInstanceAttribute": [
            {
                "action": "connect:UpdateInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "Connect.UpdateInstanceStorageConfig": [
            {
                "action": "connect:UpdateInstanceStorageConfig",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "Connect.UpdateQueueHoursOfOperation": [
            {
                "action": "connect:UpdateQueueHoursOfOperation",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HoursOfOperationId": {
                        "template": "${HoursOfOperationId}"
                    },
                    "QueueId": {
                        "template": "${QueueId}"
                    }
                }
            }
        ],
        "Connect.UpdateQueueMaxContacts": [
            {
                "action": "connect:UpdateQueueMaxContacts",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueId}"
                    }
                }
            }
        ],
        "Connect.UpdateQueueName": [
            {
                "action": "connect:UpdateQueueName",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueId}"
                    }
                }
            }
        ],
        "Connect.UpdateQueueOutboundCallerConfig": [
            {
                "action": "connect:UpdateQueueOutboundCallerConfig",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueId}"
                    },
                    "ContactFlowId": {
                        "template": "${OutboundCallerConfig.OutboundFlowId}"
                    },
                    "PhoneNumberId": {
                        "template": "${OutboundCallerConfig.OutboundCallerIdNumberId}"
                    }
                }
            }
        ],
        "Connect.UpdateQueueStatus": [
            {
                "action": "connect:UpdateQueueStatus",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${QueueId}"
                    }
                }
            }
        ],
        "Connect.UpdateQuickConnectConfig": [
            {
                "action": "connect:UpdateQuickConnectConfig",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QuickConnectId": {
                        "template": "${QuickConnectId}"
                    },
                    "ContactFlowId": {
                        "template": "%%many%${QuickConnectConfig.UserConfig.ContactFlowId}%${QuickConnectConfig.QueueConfig.ContactFlowId}%%"
                    },
                    "QueueId": {
                        "template": "${QuickConnectConfig.QueueConfig.QueueId}"
                    },
                    "UserId": {
                        "template": "${QuickConnectConfig.UserConfig.UserId}"
                    }
                }
            }
        ],
        "Connect.UpdateQuickConnectName": [
            {
                "action": "connect:UpdateQuickConnectName",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QuickConnectId": {
                        "template": "${QuickConnectId}"
                    }
                }
            }
        ],
        "Connect.UpdateRoutingProfileConcurrency": [
            {
                "action": "connect:UpdateRoutingProfileConcurrency",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    }
                }
            }
        ],
        "Connect.UpdateRoutingProfileDefaultOutboundQueue": [
            {
                "action": "connect:UpdateRoutingProfileDefaultOutboundQueue",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "QueueId": {
                        "template": "${DefaultOutboundQueueId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    }
                }
            }
        ],
        "Connect.UpdateRoutingProfileName": [
            {
                "action": "connect:UpdateRoutingProfileName",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    }
                }
            }
        ],
        "Connect.UpdateRoutingProfileQueues": [
            {
                "action": "connect:UpdateRoutingProfileQueues",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    }
                }
            }
        ],
        "Connect.UpdateUserHierarchy": [
            {
                "action": "connect:UpdateUserHierarchy",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "UserId": {
                        "template": "${UserId}"
                    },
                    "HierarchyGroupId": {
                        "template": "${HierarchyGroupId}"
                    }
                }
            }
        ],
        "Connect.UpdateUserHierarchyGroupName": [
            {
                "action": "connect:UpdateUserHierarchyGroupName",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HierarchyGroupId": {
                        "template": "${HierarchyGroupId}"
                    }
                }
            }
        ],
        "Connect.UpdateUserHierarchyStructure": [
            {
                "action": "connect:UpdateUserHierarchyStructure",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.UpdateUserIdentityInfo": [
            {
                "action": "connect:UpdateUserIdentityInfo",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "Connect.UpdateUserPhoneConfig": [
            {
                "action": "connect:UpdateUserPhoneConfig",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "Connect.UpdateUserRoutingProfile": [
            {
                "action": "connect:UpdateUserRoutingProfile",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "RoutingProfileId": {
                        "template": "${RoutingProfileId}"
                    },
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "Connect.UpdateUserSecurityProfiles": [
            {
                "action": "connect:UpdateUserSecurityProfiles",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "SecurityProfileId": {
                        "template": "${SecurityProfileIds[]}"
                    },
                    "UserId": {
                        "template": "${UserId}"
                    }
                }
            }
        ],
        "ACMPCA.CreateCertificateAuthority": [
            {
                "action": "acm-pca:CreateCertificateAuthority",
                "resource_mappings": {}
            }
        ],
        "ACMPCA.CreateCertificateAuthorityAuditReport": [
            {
                "action": "acm-pca:CreateCertificateAuthorityAuditReport",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.CreatePermission": [
            {
                "action": "acm-pca:CreatePermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.DeleteCertificateAuthority": [
            {
                "action": "acm-pca:DeleteCertificateAuthority",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.DeletePermission": [
            {
                "action": "acm-pca:DeletePermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.DeletePolicy": [
            {
                "action": "acm-pca:DeletePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${ResourceArn}"
                }
            }
        ],
        "ACMPCA.DescribeCertificateAuthority": [
            {
                "action": "acm-pca:DescribeCertificateAuthority",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.DescribeCertificateAuthorityAuditReport": [
            {
                "action": "acm-pca:DescribeCertificateAuthorityAuditReport",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.GetCertificate": [
            {
                "action": "acm-pca:GetCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.GetCertificateAuthorityCertificate": [
            {
                "action": "acm-pca:GetCertificateAuthorityCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.GetCertificateAuthorityCsr": [
            {
                "action": "acm-pca:GetCertificateAuthorityCsr",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.GetPolicy": [
            {
                "action": "acm-pca:GetPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${ResourceArn}"
                }
            }
        ],
        "ACMPCA.ImportCertificateAuthorityCertificate": [
            {
                "action": "acm-pca:ImportCertificateAuthorityCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.IssueCertificate": [
            {
                "action": "acm-pca:IssueCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.ListCertificateAuthorities": [
            {
                "action": "acm-pca:ListCertificateAuthorities",
                "resource_mappings": {}
            }
        ],
        "ACMPCA.ListPermissions": [
            {
                "action": "acm-pca:ListPermissions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.ListTags": [
            {
                "action": "acm-pca:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.PutPolicy": [
            {
                "action": "acm-pca:PutPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${ResourceArn}"
                }
            }
        ],
        "ACMPCA.RestoreCertificateAuthority": [
            {
                "action": "acm-pca:RestoreCertificateAuthority",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.RevokeCertificate": [
            {
                "action": "acm-pca:RevokeCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.TagCertificateAuthority": [
            {
                "action": "acm-pca:TagCertificateAuthority",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.UntagCertificateAuthority": [
            {
                "action": "acm-pca:UntagCertificateAuthority",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "ACMPCA.UpdateCertificateAuthority": [
            {
                "action": "acm-pca:UpdateCertificateAuthority",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "certificate-authority": "${CertificateAuthorityArn}"
                }
            }
        ],
        "FMS.AssociateAdminAccount": [
            {
                "action": "fms:AssociateAdminAccount",
                "resource_mappings": {}
            }
        ],
        "FMS.DeleteAppsList": [
            {
                "action": "fms:DeleteAppsList",
                "resource_mappings": {
                    "Id": {
                        "template": "${ListId}"
                    }
                }
            }
        ],
        "FMS.DeleteNotificationChannel": [
            {
                "action": "fms:DeleteNotificationChannel",
                "resource_mappings": {}
            }
        ],
        "FMS.DeletePolicy": [
            {
                "action": "fms:DeletePolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "${PolicyId}"
                    }
                }
            }
        ],
        "FMS.DeleteProtocolsList": [
            {
                "action": "fms:DeleteProtocolsList",
                "resource_mappings": {
                    "Id": {
                        "template": "${ListId}"
                    }
                }
            }
        ],
        "FMS.DisassociateAdminAccount": [
            {
                "action": "fms:DisassociateAdminAccount",
                "resource_mappings": {}
            }
        ],
        "FMS.GetAdminAccount": [
            {
                "action": "fms:GetAdminAccount",
                "resource_mappings": {}
            }
        ],
        "FMS.GetAppsList": [
            {
                "action": "fms:GetAppsList",
                "resource_mappings": {
                    "Id": {
                        "template": "${ListId}"
                    }
                }
            }
        ],
        "FMS.GetComplianceDetail": [
            {
                "action": "fms:GetComplianceDetail",
                "resource_mappings": {
                    "Id": {
                        "template": "${PolicyId}"
                    }
                }
            }
        ],
        "FMS.GetNotificationChannel": [
            {
                "action": "fms:GetNotificationChannel",
                "resource_mappings": {}
            }
        ],
        "FMS.GetPolicy": [
            {
                "action": "fms:GetPolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "${PolicyId}"
                    }
                }
            }
        ],
        "FMS.GetProtectionStatus": [
            {
                "action": "fms:GetProtectionStatus",
                "resource_mappings": {
                    "Id": {
                        "template": "${PolicyId}"
                    }
                }
            }
        ],
        "FMS.GetProtocolsList": [
            {
                "action": "fms:GetProtocolsList",
                "resource_mappings": {
                    "Id": {
                        "template": "${ListId}"
                    }
                }
            }
        ],
        "FMS.GetViolationDetails": [
            {
                "action": "fms:GetViolationDetails",
                "resource_mappings": {
                    "Id": {
                        "template": "${PolicyId}"
                    }
                }
            }
        ],
        "FMS.ListAppsLists": [
            {
                "action": "fms:ListAppsLists",
                "resource_mappings": {}
            }
        ],
        "FMS.ListComplianceStatus": [
            {
                "action": "fms:ListComplianceStatus",
                "resource_mappings": {
                    "Id": {
                        "template": "${PolicyId}"
                    }
                }
            }
        ],
        "FMS.ListMemberAccounts": [
            {
                "action": "fms:ListMemberAccounts",
                "resource_mappings": {}
            }
        ],
        "FMS.ListPolicies": [
            {
                "action": "fms:ListPolicies",
                "resource_mappings": {}
            }
        ],
        "FMS.ListProtocolsLists": [
            {
                "action": "fms:ListProtocolsLists",
                "resource_mappings": {}
            }
        ],
        "FMS.ListTagsForResource": [
            {
                "action": "fms:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "FMS.PutAppsList": [
            {
                "action": "fms:PutAppsList",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "FMS.PutNotificationChannel": [
            {
                "action": "fms:PutNotificationChannel",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${SnsRoleName}"
                }
            }
        ],
        "FMS.PutPolicy": [
            {
                "action": "fms:PutPolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "${Policy.PolicyId}"
                    }
                }
            }
        ],
        "FMS.PutProtocolsList": [
            {
                "action": "fms:PutProtocolsList",
                "resource_mappings": {
                    "Id": {
                        "template": "${ProtocolsList.ListId}"
                    }
                }
            }
        ],
        "FMS.TagResource": [
            {
                "action": "fms:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "FMS.UntagResource": [
            {
                "action": "fms:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SecretsManager.CancelRotateSecret": [
            {
                "action": "secretsmanager:CancelRotateSecret",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.CreateSecret": [
            {
                "action": "secretsmanager:CreateSecret",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.DeleteResourcePolicy": [
            {
                "action": "secretsmanager:DeleteResourcePolicy",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.DeleteSecret": [
            {
                "action": "secretsmanager:DeleteSecret",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.DescribeSecret": [
            {
                "action": "secretsmanager:DescribeSecret",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.GetRandomPassword": [
            {
                "action": "secretsmanager:GetRandomPassword",
                "resource_mappings": {}
            }
        ],
        "SecretsManager.GetResourcePolicy": [
            {
                "action": "secretsmanager:GetResourcePolicy",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.GetSecretValue": [
            {
                "action": "secretsmanager:GetSecretValue",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.ListSecretVersionIds": [
            {
                "action": "secretsmanager:ListSecretVersionIds",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.ListSecrets": [
            {
                "action": "secretsmanager:ListSecrets",
                "resource_mappings": {}
            }
        ],
        "SecretsManager.PutResourcePolicy": [
            {
                "action": "secretsmanager:PutResourcePolicy",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.PutSecretValue": [
            {
                "action": "secretsmanager:PutSecretValue",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.RestoreSecret": [
            {
                "action": "secretsmanager:RestoreSecret",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.RotateSecret": [
            {
                "action": "secretsmanager:RotateSecret",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.TagResource": [
            {
                "action": "secretsmanager:TagResource",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.UntagResource": [
            {
                "action": "secretsmanager:UntagResource",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.UpdateSecret": [
            {
                "action": "secretsmanager:UpdateSecret",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.UpdateSecretVersionStage": [
            {
                "action": "secretsmanager:UpdateSecretVersionStage",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "SecretsManager.ValidateResourcePolicy": [
            {
                "action": "secretsmanager:ValidateResourcePolicy",
                "arn_override": {
                    "template": "arn:${Partition}:secretsmanager:${Region}:${Account}:secret:%%regex%${SecretId}%/(?:arn.*:)?(.+)/g%%"
                }
            }
        ],
        "IoTAnalytics.BatchPutMessage": [
            {
                "action": "iotanalytics:BatchPutMessage",
                "resource_mappings": {
                    "ChannelName": {
                        "template": "${channelName}"
                    }
                }
            }
        ],
        "IoTAnalytics.CancelPipelineReprocessing": [
            {
                "action": "iotanalytics:CancelPipelineReprocessing",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "IoTAnalytics.CreateChannel": [
            {
                "action": "iotanalytics:CreateChannel",
                "resource_mappings": {
                    "ChannelName": {
                        "template": "${channelName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${channelStorage.customerManagedS3.roleArn}"
                }
            }
        ],
        "IoTAnalytics.CreateDataset": [
            {
                "action": "iotanalytics:CreateDataset",
                "resource_mappings": {
                    "DatasetName": {
                        "template": "${datasetName}"
                    }
                }
            }
        ],
        "IoTAnalytics.CreateDatasetContent": [
            {
                "action": "iotanalytics:CreateDatasetContent",
                "resource_mappings": {
                    "DatasetName": {
                        "template": "${datasetName}"
                    }
                }
            }
        ],
        "IoTAnalytics.CreateDatastore": [
            {
                "action": "iotanalytics:CreateDatastore",
                "resource_mappings": {
                    "DatastoreName": {
                        "template": "${datastoreName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${datastoreStorage.customerManagedS3.roleArn}"
                }
            }
        ],
        "IoTAnalytics.CreatePipeline": [
            {
                "action": "iotanalytics:CreatePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "IoTAnalytics.DeleteChannel": [
            {
                "action": "iotanalytics:DeleteChannel",
                "resource_mappings": {
                    "ChannelName": {
                        "template": "${channelName}"
                    }
                }
            }
        ],
        "IoTAnalytics.DeleteDataset": [
            {
                "action": "iotanalytics:DeleteDataset",
                "resource_mappings": {
                    "DatasetName": {
                        "template": "${datasetName}"
                    }
                }
            }
        ],
        "IoTAnalytics.DeleteDatasetContent": [
            {
                "action": "iotanalytics:DeleteDatasetContent",
                "resource_mappings": {
                    "DatasetName": {
                        "template": "${datasetName}"
                    }
                }
            }
        ],
        "IoTAnalytics.DeleteDatastore": [
            {
                "action": "iotanalytics:DeleteDatastore",
                "resource_mappings": {
                    "DatastoreName": {
                        "template": "${datastoreName}"
                    }
                }
            }
        ],
        "IoTAnalytics.DeletePipeline": [
            {
                "action": "iotanalytics:DeletePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "IoTAnalytics.DescribeChannel": [
            {
                "action": "iotanalytics:DescribeChannel",
                "resource_mappings": {
                    "ChannelName": {
                        "template": "${channelName}"
                    }
                }
            }
        ],
        "IoTAnalytics.DescribeDataset": [
            {
                "action": "iotanalytics:DescribeDataset",
                "resource_mappings": {
                    "DatasetName": {
                        "template": "${datasetName}"
                    }
                }
            }
        ],
        "IoTAnalytics.DescribeDatastore": [
            {
                "action": "iotanalytics:DescribeDatastore",
                "resource_mappings": {
                    "DatastoreName": {
                        "template": "${datastoreName}"
                    }
                }
            }
        ],
        "IoTAnalytics.DescribeLoggingOptions": [
            {
                "action": "iotanalytics:DescribeLoggingOptions",
                "resource_mappings": {}
            }
        ],
        "IoTAnalytics.DescribePipeline": [
            {
                "action": "iotanalytics:DescribePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "IoTAnalytics.GetDatasetContent": [
            {
                "action": "iotanalytics:GetDatasetContent",
                "resource_mappings": {
                    "DatasetName": {
                        "template": "${datasetName}"
                    }
                }
            }
        ],
        "IoTAnalytics.ListChannels": [
            {
                "action": "iotanalytics:ListChannels",
                "resource_mappings": {}
            }
        ],
        "IoTAnalytics.ListDatasets": [
            {
                "action": "iotanalytics:ListDatasets",
                "resource_mappings": {}
            }
        ],
        "IoTAnalytics.ListDatastores": [
            {
                "action": "iotanalytics:ListDatastores",
                "resource_mappings": {}
            }
        ],
        "IoTAnalytics.ListPipelines": [
            {
                "action": "iotanalytics:ListPipelines",
                "resource_mappings": {}
            }
        ],
        "IoTAnalytics.ListTagsForResource": [
            {
                "action": "iotanalytics:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftemplatematch%${resourceArn}%%",
                    "dataset": "%%iftemplatematch%${resourceArn}%%",
                    "datastore": "%%iftemplatematch%${resourceArn}%%",
                    "pipeline": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTAnalytics.PutLoggingOptions": [
            {
                "action": "iotanalytics:PutLoggingOptions",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${loggingOptions.roleArn}"
                }
            }
        ],
        "IoTAnalytics.RunPipelineActivity": [
            {
                "action": "iotanalytics:RunPipelineActivity",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${pipelineActivity.deviceRegistryEnrich.roleArn}%${pipelineActivity.deviceShadowEnrich.roleArn}%%"
                }
            }
        ],
        "IoTAnalytics.SampleChannelData": [
            {
                "action": "iotanalytics:SampleChannelData",
                "resource_mappings": {
                    "ChannelName": {
                        "template": "${channelName}"
                    }
                }
            }
        ],
        "IoTAnalytics.StartPipelineReprocessing": [
            {
                "action": "iotanalytics:StartPipelineReprocessing",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "IoTAnalytics.TagResource": [
            {
                "action": "iotanalytics:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftemplatematch%${resourceArn}%%",
                    "dataset": "%%iftemplatematch%${resourceArn}%%",
                    "datastore": "%%iftemplatematch%${resourceArn}%%",
                    "pipeline": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTAnalytics.UntagResource": [
            {
                "action": "iotanalytics:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftemplatematch%${resourceArn}%%",
                    "dataset": "%%iftemplatematch%${resourceArn}%%",
                    "datastore": "%%iftemplatematch%${resourceArn}%%",
                    "pipeline": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTAnalytics.UpdateChannel": [
            {
                "action": "iotanalytics:UpdateChannel",
                "resource_mappings": {
                    "ChannelName": {
                        "template": "${channelName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${channelStorage.customerManagedS3.roleArn}"
                }
            }
        ],
        "IoTAnalytics.UpdateDataset": [
            {
                "action": "iotanalytics:UpdateDataset",
                "resource_mappings": {
                    "DatasetName": {
                        "template": "${datasetName}"
                    }
                }
            }
        ],
        "IoTAnalytics.UpdateDatastore": [
            {
                "action": "iotanalytics:UpdateDatastore",
                "resource_mappings": {
                    "DatastoreName": {
                        "template": "${datastoreName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${datastoreStorage.customerManagedS3.roleArn}"
                }
            }
        ],
        "IoTAnalytics.UpdatePipeline": [
            {
                "action": "iotanalytics:UpdatePipeline",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "${pipelineName}"
                    }
                }
            }
        ],
        "IoT1ClickDevicesService.ClaimDevicesByClaimCode": [
            {
                "action": "iot1click:ClaimDevicesByClaimCode",
                "resource_mappings": {}
            }
        ],
        "IoT1ClickDevicesService.DescribeDevice": [
            {
                "action": "iot1click:DescribeDevice",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "IoT1ClickDevicesService.FinalizeDeviceClaim": [
            {
                "action": "iot1click:FinalizeDeviceClaim",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "IoT1ClickDevicesService.GetDeviceMethods": [
            {
                "action": "iot1click:GetDeviceMethods",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "IoT1ClickDevicesService.InitiateDeviceClaim": [
            {
                "action": "iot1click:InitiateDeviceClaim",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "IoT1ClickDevicesService.InvokeDeviceMethod": [
            {
                "action": "iot1click:InvokeDeviceMethod",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "IoT1ClickDevicesService.ListDeviceEvents": [
            {
                "action": "iot1click:ListDeviceEvents",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "IoT1ClickDevicesService.ListDevices": [
            {
                "action": "iot1click:ListDevices",
                "resource_mappings": {}
            }
        ],
        "IoT1ClickDevicesService.ListTagsForResource": [
            {
                "action": "iot1click:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "project": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "IoT1ClickDevicesService.TagResource": [
            {
                "action": "iot1click:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "project": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "IoT1ClickDevicesService.UnclaimDevice": [
            {
                "action": "iot1click:UnclaimDevice",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "IoT1ClickDevicesService.UntagResource": [
            {
                "action": "iot1click:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "project": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "IoT1ClickDevicesService.UpdateDeviceState": [
            {
                "action": "iot1click:UpdateDeviceState",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.AssociateDeviceWithPlacement": [
            {
                "action": "iot1click:AssociateDeviceWithPlacement",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.CreatePlacement": [
            {
                "action": "iot1click:CreatePlacement",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.CreateProject": [
            {
                "action": "iot1click:CreateProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.DeletePlacement": [
            {
                "action": "iot1click:DeletePlacement",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.DeleteProject": [
            {
                "action": "iot1click:DeleteProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.DescribePlacement": [
            {
                "action": "iot1click:DescribePlacement",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.DescribeProject": [
            {
                "action": "iot1click:DescribeProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.DisassociateDeviceFromPlacement": [
            {
                "action": "iot1click:DisassociateDeviceFromPlacement",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.GetDevicesInPlacement": [
            {
                "action": "iot1click:GetDevicesInPlacement",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.ListPlacements": [
            {
                "action": "iot1click:ListPlacements",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.ListProjects": [
            {
                "action": "iot1click:ListProjects",
                "resource_mappings": {}
            }
        ],
        "IoT1ClickProjects.ListTagsForResource": [
            {
                "action": "iot1click:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${resourceArn}%%",
                    "project": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoT1ClickProjects.TagResource": [
            {
                "action": "iot1click:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${resourceArn}%%",
                    "project": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoT1ClickProjects.UntagResource": [
            {
                "action": "iot1click:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "%%iftemplatematch%${resourceArn}%%",
                    "project": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoT1ClickProjects.UpdatePlacement": [
            {
                "action": "iot1click:UpdatePlacement",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "IoT1ClickProjects.UpdateProject": [
            {
                "action": "iot1click:UpdateProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${projectName}"
                    }
                }
            }
        ],
        "PI.DescribeDimensionKeys": [
            {
                "action": "pi:DescribeDimensionKeys",
                "resource_mappings": {
                    "ServiceType": {
                        "template": "${ServiceType}"
                    },
                    "Identifier": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "PI.GetResourceMetrics": [
            {
                "action": "pi:GetResourceMetrics",
                "resource_mappings": {
                    "ServiceType": {
                        "template": "${ServiceType}"
                    },
                    "Identifier": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "Neptune.AddRoleToDBCluster": [
            {
                "action": "rds:AddRoleToDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Neptune.AddSourceIdentifierToSubscription": [
            {
                "action": "rds:AddSourceIdentifierToSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "Neptune.AddTagsToResource": [
            {
                "action": "rds:AddTagsToResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "%%iftemplatematch%${ResourceName}%%",
                    "es": "%%iftemplatematch%${ResourceName}%%",
                    "og": "%%iftemplatematch%${ResourceName}%%",
                    "pg": "%%iftemplatematch%${ResourceName}%%",
                    "proxy": "%%iftemplatematch%${ResourceName}%%",
                    "ri": "%%iftemplatematch%${ResourceName}%%",
                    "secgrp": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "subgrp": "%%iftemplatematch%${ResourceName}%%",
                    "target-group": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "Neptune.ApplyPendingMaintenanceAction": [
            {
                "action": "rds:ApplyPendingMaintenanceAction",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceIdentifier}%%",
                    "db": "%%iftemplatematch%${ResourceIdentifier}%%"
                }
            }
        ],
        "Neptune.CopyDBClusterParameterGroup": [
            {
                "action": "rds:CopyDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "%%many%${SourceDBClusterParameterGroupIdentifier}%${TargetDBClusterParameterGroupIdentifier}%%"
                    }
                }
            }
        ],
        "Neptune.CopyDBClusterSnapshot": [
            {
                "action": "rds:CopyDBClusterSnapshot",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "%%many%${SourceDBClusterSnapshotIdentifier}%${TargetDBClusterSnapshotIdentifier}%%"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "Neptune.CopyDBParameterGroup": [
            {
                "action": "rds:CopyDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "%%many%${SourceDBParameterGroupIdentifier}%${TargetDBParameterGroupIdentifier}%%"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "Neptune.CreateDBCluster": [
            {
                "action": "rds:CreateDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "Neptune.CreateDBClusterEndpoint": [
            {
                "action": "rds:CreateDBClusterEndpoint",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "DbClusterEndpoint": {
                        "template": "${DBClusterEndpointIdentifier}"
                    }
                }
            }
        ],
        "Neptune.CreateDBClusterParameterGroup": [
            {
                "action": "rds:CreateDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.CreateDBClusterSnapshot": [
            {
                "action": "rds:CreateDBClusterSnapshot",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "Neptune.CreateDBInstance": [
            {
                "action": "rds:CreateDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    },
                    "SecurityGroupName": {
                        "template": "${DBSecurityGroups[]}"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "Neptune.CreateDBParameterGroup": [
            {
                "action": "rds:CreateDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.CreateDBSubnetGroup": [
            {
                "action": "rds:CreateDBSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "Neptune.CreateEventSubscription": [
            {
                "action": "rds:CreateEventSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "Neptune.DeleteDBCluster": [
            {
                "action": "rds:DeleteDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterSnapshotName": {
                        "template": "${FinalDBSnapshotIdentifier}"
                    }
                }
            }
        ],
        "Neptune.DeleteDBClusterEndpoint": [
            {
                "action": "rds:DeleteDBClusterEndpoint",
                "resource_mappings": {
                    "DbClusterEndpoint": {
                        "template": "${DBClusterEndpointIdentifier}"
                    }
                }
            }
        ],
        "Neptune.DeleteDBClusterParameterGroup": [
            {
                "action": "rds:DeleteDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.DeleteDBClusterSnapshot": [
            {
                "action": "rds:DeleteDBClusterSnapshot",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "Neptune.DeleteDBInstance": [
            {
                "action": "rds:DeleteDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "Neptune.DeleteDBParameterGroup": [
            {
                "action": "rds:DeleteDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.DeleteDBSubnetGroup": [
            {
                "action": "rds:DeleteDBSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "Neptune.DeleteEventSubscription": [
            {
                "action": "rds:DeleteEventSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBClusterEndpoints": [
            {
                "action": "rds:DescribeDBClusterEndpoints",
                "resource_mappings": {
                    "DbClusterEndpoint": {
                        "template": "${DBClusterEndpointIdentifier}"
                    },
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBClusterParameterGroups": [
            {
                "action": "rds:DescribeDBClusterParameterGroups",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBClusterParameters": [
            {
                "action": "rds:DescribeDBClusterParameters",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBClusterSnapshotAttributes": [
            {
                "action": "rds:DescribeDBClusterSnapshotAttributes",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBClusterSnapshots": [
            {
                "action": "rds:DescribeDBClusterSnapshots",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBClusters": [
            {
                "action": "rds:DescribeDBClusters",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBEngineVersions": [
            {
                "action": "rds:DescribeDBEngineVersions",
                "resource_mappings": {}
            }
        ],
        "Neptune.DescribeDBInstances": [
            {
                "action": "rds:DescribeDBInstances",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBParameterGroups": [
            {
                "action": "rds:DescribeDBParameterGroups",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBParameters": [
            {
                "action": "rds:DescribeDBParameters",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.DescribeDBSubnetGroups": [
            {
                "action": "rds:DescribeDBSubnetGroups",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "Neptune.DescribeEngineDefaultClusterParameters": [
            {
                "action": "rds:DescribeEngineDefaultClusterParameters",
                "resource_mappings": {}
            }
        ],
        "Neptune.DescribeEngineDefaultParameters": [
            {
                "action": "rds:DescribeEngineDefaultParameters",
                "resource_mappings": {}
            }
        ],
        "Neptune.DescribeEventCategories": [
            {
                "action": "rds:DescribeEventCategories",
                "resource_mappings": {}
            }
        ],
        "Neptune.DescribeEventSubscriptions": [
            {
                "action": "rds:DescribeEventSubscriptions",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "Neptune.DescribeEvents": [
            {
                "action": "rds:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "Neptune.DescribeOrderableDBInstanceOptions": [
            {
                "action": "rds:DescribeOrderableDBInstanceOptions",
                "resource_mappings": {}
            }
        ],
        "Neptune.DescribePendingMaintenanceActions": [
            {
                "action": "rds:DescribePendingMaintenanceActions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceIdentifier}%%",
                    "db": "%%iftemplatematch%${ResourceIdentifier}%%"
                }
            }
        ],
        "Neptune.DescribeValidDBInstanceModifications": [
            {
                "action": "rds:DescribeValidDBInstanceModifications",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "Neptune.FailoverDBCluster": [
            {
                "action": "rds:FailoverDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "Neptune.ListTagsForResource": [
            {
                "action": "rds:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "%%iftemplatematch%${ResourceName}%%",
                    "es": "%%iftemplatematch%${ResourceName}%%",
                    "og": "%%iftemplatematch%${ResourceName}%%",
                    "pg": "%%iftemplatematch%${ResourceName}%%",
                    "proxy": "%%iftemplatematch%${ResourceName}%%",
                    "ri": "%%iftemplatematch%${ResourceName}%%",
                    "secgrp": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "subgrp": "%%iftemplatematch%${ResourceName}%%",
                    "target-group": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "Neptune.ModifyDBCluster": [
            {
                "action": "rds:ModifyDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "%%many%${DBClusterIdentifier}%${NewDBClusterIdentifier}%%"
                    },
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Neptune.ModifyDBClusterEndpoint": [
            {
                "action": "rds:ModifyDBClusterEndpoint",
                "resource_mappings": {
                    "DbClusterEndpoint": {
                        "template": "${DBClusterEndpointIdentifier}"
                    }
                }
            }
        ],
        "Neptune.ModifyDBClusterParameterGroup": [
            {
                "action": "rds:ModifyDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.ModifyDBClusterSnapshotAttribute": [
            {
                "action": "rds:ModifyDBClusterSnapshotAttribute",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "Neptune.ModifyDBInstance": [
            {
                "action": "rds:ModifyDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "%%many%${DBInstanceIdentifier}%${NewDBInstanceIdentifier}%%"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    },
                    "SecurityGroupName": {
                        "template": "${DBSecurityGroups[]}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Neptune.ModifyDBParameterGroup": [
            {
                "action": "rds:ModifyDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.ModifyDBSubnetGroup": [
            {
                "action": "rds:ModifyDBSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "Neptune.ModifyEventSubscription": [
            {
                "action": "rds:ModifyEventSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "Neptune.PromoteReadReplicaDBCluster": [
            {
                "action": "rds:PromoteReadReplicaDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "Neptune.RebootDBInstance": [
            {
                "action": "rds:RebootDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "Neptune.RemoveRoleFromDBCluster": [
            {
                "action": "rds:RemoveRoleFromDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Neptune.RemoveSourceIdentifierFromSubscription": [
            {
                "action": "rds:RemoveSourceIdentifierFromSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "Neptune.RemoveTagsFromResource": [
            {
                "action": "rds:RemoveTagsFromResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "%%iftemplatematch%${ResourceName}%%",
                    "es": "%%iftemplatematch%${ResourceName}%%",
                    "og": "%%iftemplatematch%${ResourceName}%%",
                    "pg": "%%iftemplatematch%${ResourceName}%%",
                    "proxy": "%%iftemplatematch%${ResourceName}%%",
                    "ri": "%%iftemplatematch%${ResourceName}%%",
                    "secgrp": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "subgrp": "%%iftemplatematch%${ResourceName}%%",
                    "target-group": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "Neptune.ResetDBClusterParameterGroup": [
            {
                "action": "rds:ResetDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.ResetDBParameterGroup": [
            {
                "action": "rds:ResetDBParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${DBParameterGroupName}"
                    }
                }
            }
        ],
        "Neptune.RestoreDBClusterFromSnapshot": [
            {
                "action": "rds:RestoreDBClusterFromSnapshot",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterSnapshotName": {
                        "template": "${SnapshotIdentifier}"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "Neptune.RestoreDBClusterToPointInTime": [
            {
                "action": "rds:RestoreDBClusterToPointInTime",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "%%many%${DBClusterIdentifier}%${SourceDBClusterIdentifier}%%"
                    },
                    "OptionGroupName": {
                        "template": "${OptionGroupName}"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "Neptune.StartDBCluster": [
            {
                "action": "rds:StartDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "Neptune.StopDBCluster": [
            {
                "action": "rds:StopDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "MediaTailor.DeletePlaybackConfiguration": [
            {
                "action": "mediatailor:DeletePlaybackConfiguration",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaTailor.GetPlaybackConfiguration": [
            {
                "action": "mediatailor:GetPlaybackConfiguration",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaTailor.ListPlaybackConfigurations": [
            {
                "action": "mediatailor:ListPlaybackConfigurations",
                "resource_mappings": {}
            }
        ],
        "MediaTailor.ListTagsForResource": [
            {
                "action": "mediatailor:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "MediaTailor.PutPlaybackConfiguration": [
            {
                "action": "mediatailor:PutPlaybackConfiguration",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaTailor.TagResource": [
            {
                "action": "mediatailor:TagResource",
                "resource_mappings": {}
            }
        ],
        "MediaTailor.UntagResource": [
            {
                "action": "mediatailor:UntagResource",
                "resource_mappings": {}
            }
        ],
        "EKS.CreateAddon": [
            {
                "action": "eks:CreateAddon",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    }
                }
            }
        ],
        "EKS.CreateCluster": [
            {
                "action": "eks:CreateCluster",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "EKS.CreateFargateProfile": [
            {
                "action": "eks:CreateFargateProfile",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    }
                }
            }
        ],
        "EKS.CreateNodegroup": [
            {
                "action": "eks:CreateNodegroup",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${nodeRole}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${launchTemplate.id}%*%%%"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${launchTemplate.name}%*%%%"
                }
            }
        ],
        "EKS.DeleteAddon": [
            {
                "action": "eks:DeleteAddon",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "AddonName": {
                        "template": "${addonName}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.DeleteCluster": [
            {
                "action": "eks:DeleteCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "EKS.DeleteFargateProfile": [
            {
                "action": "eks:DeleteFargateProfile",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "FargateProfileName": {
                        "template": "${fargateProfileName}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.DeleteNodegroup": [
            {
                "action": "eks:DeleteNodegroup",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "NodegroupName": {
                        "template": "${nodegroupName}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.DescribeAddon": [
            {
                "action": "eks:DescribeAddon",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "AddonName": {
                        "template": "${addonName}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.DescribeAddonVersions": [
            {
                "action": "eks:DescribeAddonVersions",
                "resource_mappings": {}
            }
        ],
        "EKS.DescribeCluster": [
            {
                "action": "eks:DescribeCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "EKS.DescribeFargateProfile": [
            {
                "action": "eks:DescribeFargateProfile",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "FargateProfileName": {
                        "template": "${fargateProfileName}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.DescribeNodegroup": [
            {
                "action": "eks:DescribeNodegroup",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "NodegroupName": {
                        "template": "${nodegroupName}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.DescribeUpdate": [
            {
                "action": "eks:DescribeUpdate",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${name}"
                    },
                    "AddonName": {
                        "template": "${addonName}"
                    },
                    "UUID": {
                        "template": "*"
                    },
                    "NodegroupName": {
                        "template": "${nodegroupName}"
                    }
                }
            }
        ],
        "EKS.ListAddons": [
            {
                "action": "eks:ListAddons",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    }
                }
            }
        ],
        "EKS.ListClusters": [
            {
                "action": "eks:ListClusters",
                "resource_mappings": {}
            }
        ],
        "EKS.ListFargateProfiles": [
            {
                "action": "eks:ListFargateProfiles",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    }
                }
            }
        ],
        "EKS.ListNodegroups": [
            {
                "action": "eks:ListNodegroups",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    }
                }
            }
        ],
        "EKS.ListTagsForResource": [
            {
                "action": "eks:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "addon": "%%iftemplatematch%${resourceArn}%%",
                    "cluster": "%%iftemplatematch%${resourceArn}%%",
                    "fargateprofile": "%%iftemplatematch%${resourceArn}%%",
                    "identityproviderconfig": "%%iftemplatematch%${resourceArn}%%",
                    "nodegroup": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "EKS.ListUpdates": [
            {
                "action": "eks:ListUpdates",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${name}"
                    },
                    "AddonName": {
                        "template": "${addonName}"
                    },
                    "UUID": {
                        "template": "*"
                    },
                    "NodegroupName": {
                        "template": "${nodegroupName}"
                    }
                }
            }
        ],
        "EKS.TagResource": [
            {
                "action": "eks:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "addon": "%%iftemplatematch%${resourceArn}%%",
                    "cluster": "%%iftemplatematch%${resourceArn}%%",
                    "fargateprofile": "%%iftemplatematch%${resourceArn}%%",
                    "identityproviderconfig": "%%iftemplatematch%${resourceArn}%%",
                    "nodegroup": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "EKS.UntagResource": [
            {
                "action": "eks:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "addon": "%%iftemplatematch%${resourceArn}%%",
                    "cluster": "%%iftemplatematch%${resourceArn}%%",
                    "fargateprofile": "%%iftemplatematch%${resourceArn}%%",
                    "identityproviderconfig": "%%iftemplatematch%${resourceArn}%%",
                    "nodegroup": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "EKS.UpdateAddon": [
            {
                "action": "eks:UpdateAddon",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "AddonName": {
                        "template": "${addonName}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.UpdateClusterConfig": [
            {
                "action": "eks:UpdateClusterConfig",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "EKS.UpdateClusterVersion": [
            {
                "action": "eks:UpdateClusterVersion",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "EKS.UpdateNodegroupConfig": [
            {
                "action": "eks:UpdateNodegroupConfig",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "NodegroupName": {
                        "template": "${nodegroupName}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.UpdateNodegroupVersion": [
            {
                "action": "eks:UpdateNodegroupVersion",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "NodegroupName": {
                        "template": "${nodegroupName}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Macie.AssociateMemberAccount": [
            {
                "action": "macie:AssociateMemberAccount",
                "resource_mappings": {}
            }
        ],
        "Macie.AssociateS3Resources": [
            {
                "action": "macie:AssociateS3Resources",
                "resource_mappings": {}
            }
        ],
        "Macie.DisassociateMemberAccount": [
            {
                "action": "macie:DisassociateMemberAccount",
                "resource_mappings": {}
            }
        ],
        "Macie.DisassociateS3Resources": [
            {
                "action": "macie:DisassociateS3Resources",
                "resource_mappings": {}
            }
        ],
        "Macie.ListMemberAccounts": [
            {
                "action": "macie:ListMemberAccounts",
                "resource_mappings": {}
            }
        ],
        "Macie.ListS3Resources": [
            {
                "action": "macie:ListS3Resources",
                "resource_mappings": {}
            }
        ],
        "Macie.UpdateS3Resources": [
            {
                "action": "macie:UpdateS3Resources",
                "resource_mappings": {}
            }
        ],
        "DLM.CreateLifecyclePolicy": [
            {
                "action": "dlm:CreateLifecyclePolicy",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ExecutionRoleArn}"
                }
            }
        ],
        "DLM.DeleteLifecyclePolicy": [
            {
                "action": "dlm:DeleteLifecyclePolicy",
                "resource_mappings": {
                    "ResourceName": {
                        "template": "${PolicyId}"
                    }
                }
            }
        ],
        "DLM.GetLifecyclePolicies": [
            {
                "action": "dlm:GetLifecyclePolicies",
                "resource_mappings": {}
            }
        ],
        "DLM.GetLifecyclePolicy": [
            {
                "action": "dlm:GetLifecyclePolicy",
                "resource_mappings": {
                    "ResourceName": {
                        "template": "${PolicyId}"
                    }
                }
            }
        ],
        "DLM.ListTagsForResource": [
            {
                "action": "dlm:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DLM.TagResource": [
            {
                "action": "dlm:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DLM.UntagResource": [
            {
                "action": "dlm:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DLM.UpdateLifecyclePolicy": [
            {
                "action": "dlm:UpdateLifecyclePolicy",
                "resource_mappings": {
                    "ResourceName": {
                        "template": "${PolicyId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ExecutionRoleArn}"
                }
            }
        ],
        "Signer.AddProfilePermission": [
            {
                "action": "signer:AddProfilePermission",
                "resource_mappings": {
                    "profileName": {
                        "template": "${profileName}"
                    }
                }
            }
        ],
        "Signer.CancelSigningProfile": [
            {
                "action": "signer:CancelSigningProfile",
                "resource_mappings": {
                    "profileName": {
                        "template": "${profileName}"
                    }
                }
            }
        ],
        "Signer.DescribeSigningJob": [
            {
                "action": "signer:DescribeSigningJob",
                "resource_mappings": {
                    "jobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Signer.GetSigningPlatform": [
            {
                "action": "signer:GetSigningPlatform",
                "resource_mappings": {}
            }
        ],
        "Signer.GetSigningProfile": [
            {
                "action": "signer:GetSigningProfile",
                "resource_mappings": {
                    "profileName": {
                        "template": "${profileName}"
                    }
                }
            }
        ],
        "Signer.ListProfilePermissions": [
            {
                "action": "signer:ListProfilePermissions",
                "resource_mappings": {
                    "profileName": {
                        "template": "${profileName}"
                    }
                }
            }
        ],
        "Signer.ListSigningJobs": [
            {
                "action": "signer:ListSigningJobs",
                "resource_mappings": {}
            }
        ],
        "Signer.ListSigningPlatforms": [
            {
                "action": "signer:ListSigningPlatforms",
                "resource_mappings": {}
            }
        ],
        "Signer.ListSigningProfiles": [
            {
                "action": "signer:ListSigningProfiles",
                "resource_mappings": {}
            }
        ],
        "Signer.ListTagsForResource": [
            {
                "action": "signer:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "signing-profile": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Signer.PutSigningProfile": [
            {
                "action": "signer:PutSigningProfile",
                "resource_mappings": {}
            }
        ],
        "Signer.RemoveProfilePermission": [
            {
                "action": "signer:RemoveProfilePermission",
                "resource_mappings": {
                    "profileName": {
                        "template": "${profileName}"
                    }
                }
            }
        ],
        "Signer.RevokeSignature": [
            {
                "action": "signer:RevokeSignature",
                "resource_mappings": {
                    "jobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Signer.RevokeSigningProfile": [
            {
                "action": "signer:RevokeSigningProfile",
                "resource_mappings": {
                    "profileName": {
                        "template": "${profileName}"
                    }
                }
            }
        ],
        "Signer.StartSigningJob": [
            {
                "action": "signer:StartSigningJob",
                "resource_mappings": {
                    "profileName": {
                        "template": "${profileName}"
                    }
                }
            }
        ],
        "Signer.TagResource": [
            {
                "action": "signer:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "signing-profile": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Signer.UntagResource": [
            {
                "action": "signer:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "signing-profile": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Chime.AssociatePhoneNumberWithUser": [
            {
                "action": "chime:AssociatePhoneNumberWithUser",
                "resource_mappings": {}
            }
        ],
        "Chime.AssociatePhoneNumbersWithVoiceConnector": [
            {
                "action": "chime:AssociatePhoneNumbersWithVoiceConnector",
                "resource_mappings": {}
            }
        ],
        "Chime.AssociatePhoneNumbersWithVoiceConnectorGroup": [
            {
                "action": "chime:AssociatePhoneNumbersWithVoiceConnectorGroup",
                "resource_mappings": {}
            }
        ],
        "Chime.AssociateSigninDelegateGroupsWithAccount": [
            {
                "action": "chime:AssociateSigninDelegateGroupsWithAccount",
                "resource_mappings": {}
            }
        ],
        "Chime.BatchCreateAttendee": [
            {
                "action": "chime:BatchCreateAttendee",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.BatchCreateRoomMembership": [
            {
                "action": "chime:BatchCreateRoomMembership",
                "resource_mappings": {}
            }
        ],
        "Chime.BatchDeletePhoneNumber": [
            {
                "action": "chime:BatchDeletePhoneNumber",
                "resource_mappings": {}
            }
        ],
        "Chime.BatchSuspendUser": [
            {
                "action": "chime:BatchSuspendUser",
                "resource_mappings": {}
            }
        ],
        "Chime.BatchUnsuspendUser": [
            {
                "action": "chime:BatchUnsuspendUser",
                "resource_mappings": {}
            }
        ],
        "Chime.BatchUpdatePhoneNumber": [
            {
                "action": "chime:BatchUpdatePhoneNumber",
                "resource_mappings": {}
            }
        ],
        "Chime.BatchUpdateUser": [
            {
                "action": "chime:BatchUpdateUser",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateAccount": [
            {
                "action": "chime:CreateAccount",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateAppInstance": [
            {
                "action": "chime:CreateAppInstance",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateAppInstanceAdmin": [
            {
                "action": "chime:CreateAppInstanceAdmin",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}",
                    "app-instance-user": "${AppInstanceAdminArn}"
                }
            }
        ],
        "Chime.CreateAppInstanceUser": [
            {
                "action": "chime:CreateAppInstanceUser",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateAttendee": [
            {
                "action": "chime:CreateAttendee",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.CreateBot": [
            {
                "action": "chime:CreateBot",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateChannel": [
            {
                "action": "chime:CreateChannel",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "AppInstanceId": {
                        "template": "%%regex%${AppInstanceArn}%/^(?:.+\\/)?(.+)$/g%%"
                    },
                    "AppInstanceUserId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Chime.CreateChannelBan": [
            {
                "action": "chime:CreateChannelBan",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${MemberArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.CreateChannelMembership": [
            {
                "action": "chime:CreateChannelMembership",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${MemberArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.CreateChannelModerator": [
            {
                "action": "chime:CreateChannelModerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChannelModeratorArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.CreateMeeting": [
            {
                "action": "chime:CreateMeeting",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateMeetingDialOut": [
            {
                "action": "chime:CreateMeetingDialOut",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.CreateMeetingWithAttendees": [
            {
                "action": "chime:CreateMeetingWithAttendees",
                "resource_mappings": {}
            }
        ],
        "Chime.CreatePhoneNumberOrder": [
            {
                "action": "chime:CreatePhoneNumberOrder",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateProxySession": [
            {
                "action": "chime:CreateProxySession",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateRoom": [
            {
                "action": "chime:CreateRoom",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateRoomMembership": [
            {
                "action": "chime:CreateRoomMembership",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateSipMediaApplication": [
            {
                "action": "chime:CreateSipMediaApplication",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateSipMediaApplicationCall": [
            {
                "action": "chime:CreateSipMediaApplicationCall",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateSipRule": [
            {
                "action": "chime:CreateSipRule",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateUser": [
            {
                "action": "chime:CreateUser",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateVoiceConnector": [
            {
                "action": "chime:CreateVoiceConnector",
                "resource_mappings": {}
            }
        ],
        "Chime.CreateVoiceConnectorGroup": [
            {
                "action": "chime:CreateVoiceConnectorGroup",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteAccount": [
            {
                "action": "chime:DeleteAccount",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteAppInstance": [
            {
                "action": "chime:DeleteAppInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "Chime.DeleteAppInstanceAdmin": [
            {
                "action": "chime:DeleteAppInstanceAdmin",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}",
                    "app-instance-user": "${AppInstanceAdminArn}"
                }
            }
        ],
        "Chime.DeleteAppInstanceStreamingConfigurations": [
            {
                "action": "chime:DeleteAppInstanceStreamingConfigurations",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "Chime.DeleteAppInstanceUser": [
            {
                "action": "chime:DeleteAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "Chime.DeleteAttendee": [
            {
                "action": "chime:DeleteAttendee",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.DeleteChannel": [
            {
                "action": "chime:DeleteChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DeleteChannelBan": [
            {
                "action": "chime:DeleteChannelBan",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${MemberArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DeleteChannelMembership": [
            {
                "action": "chime:DeleteChannelMembership",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${MemberArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DeleteChannelMessage": [
            {
                "action": "chime:DeleteChannelMessage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DeleteChannelModerator": [
            {
                "action": "chime:DeleteChannelModerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChannelModeratorArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DeleteEventsConfiguration": [
            {
                "action": "chime:DeleteEventsConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteMeeting": [
            {
                "action": "chime:DeleteMeeting",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.DeletePhoneNumber": [
            {
                "action": "chime:DeletePhoneNumber",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteProxySession": [
            {
                "action": "chime:DeleteProxySession",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteRoom": [
            {
                "action": "chime:DeleteRoom",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteRoomMembership": [
            {
                "action": "chime:DeleteRoomMembership",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteSipMediaApplication": [
            {
                "action": "chime:DeleteSipMediaApplication",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteSipRule": [
            {
                "action": "chime:DeleteSipRule",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteVoiceConnector": [
            {
                "action": "chime:DeleteVoiceConnector",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteVoiceConnectorEmergencyCallingConfiguration": [
            {
                "action": "chime:DeleteVoiceConnectorEmergencyCallingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteVoiceConnectorGroup": [
            {
                "action": "chime:DeleteVoiceConnectorGroup",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteVoiceConnectorOrigination": [
            {
                "action": "chime:DeleteVoiceConnectorOrigination",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteVoiceConnectorProxy": [
            {
                "action": "chime:DeleteVoiceConnectorProxy",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteVoiceConnectorStreamingConfiguration": [
            {
                "action": "chime:DeleteVoiceConnectorStreamingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteVoiceConnectorTermination": [
            {
                "action": "chime:DeleteVoiceConnectorTermination",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteVoiceConnectorTerminationCredentials": [
            {
                "action": "chime:DeleteVoiceConnectorTerminationCredentials",
                "resource_mappings": {}
            }
        ],
        "Chime.DescribeAppInstance": [
            {
                "action": "chime:DescribeAppInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "Chime.DescribeAppInstanceAdmin": [
            {
                "action": "chime:DescribeAppInstanceAdmin",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}",
                    "app-instance-user": "${AppInstanceAdminArn}"
                }
            }
        ],
        "Chime.DescribeAppInstanceUser": [
            {
                "action": "chime:DescribeAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "Chime.DescribeChannel": [
            {
                "action": "chime:DescribeChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DescribeChannelBan": [
            {
                "action": "chime:DescribeChannelBan",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${MemberArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DescribeChannelMembership": [
            {
                "action": "chime:DescribeChannelMembership",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${MemberArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DescribeChannelMembershipForAppInstanceUser": [
            {
                "action": "chime:DescribeChannelMembershipForAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DescribeChannelModeratedByAppInstanceUser": [
            {
                "action": "chime:DescribeChannelModeratedByAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DescribeChannelModerator": [
            {
                "action": "chime:DescribeChannelModerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChannelModeratorArn}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.DisassociatePhoneNumberFromUser": [
            {
                "action": "chime:DisassociatePhoneNumberFromUser",
                "resource_mappings": {}
            }
        ],
        "Chime.DisassociatePhoneNumbersFromVoiceConnector": [
            {
                "action": "chime:DisassociatePhoneNumbersFromVoiceConnector",
                "resource_mappings": {}
            }
        ],
        "Chime.DisassociatePhoneNumbersFromVoiceConnectorGroup": [
            {
                "action": "chime:DisassociatePhoneNumbersFromVoiceConnectorGroup",
                "resource_mappings": {}
            }
        ],
        "Chime.DisassociateSigninDelegateGroupsFromAccount": [
            {
                "action": "chime:DisassociateSigninDelegateGroupsFromAccount",
                "resource_mappings": {}
            }
        ],
        "Chime.GetAccount": [
            {
                "action": "chime:GetAccount",
                "resource_mappings": {}
            }
        ],
        "Chime.GetAccountSettings": [
            {
                "action": "chime:GetAccountSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.GetAppInstanceRetentionSettings": [
            {
                "action": "chime:GetAppInstanceRetentionSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "Chime.GetAppInstanceStreamingConfigurations": [
            {
                "action": "chime:GetAppInstanceStreamingConfigurations",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "Chime.GetAttendee": [
            {
                "action": "chime:GetAttendee",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.GetBot": [
            {
                "action": "chime:GetBot",
                "resource_mappings": {}
            }
        ],
        "Chime.GetChannelMessage": [
            {
                "action": "chime:GetChannelMessage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.GetEventsConfiguration": [
            {
                "action": "chime:GetEventsConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.GetGlobalSettings": [
            {
                "action": "chime:GetGlobalSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.GetMeeting": [
            {
                "action": "chime:GetMeeting",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.GetMessagingSessionEndpoint": [
            {
                "action": "chime:GetMessagingSessionEndpoint",
                "resource_mappings": {}
            }
        ],
        "Chime.GetPhoneNumber": [
            {
                "action": "chime:GetPhoneNumber",
                "resource_mappings": {}
            }
        ],
        "Chime.GetPhoneNumberOrder": [
            {
                "action": "chime:GetPhoneNumberOrder",
                "resource_mappings": {}
            }
        ],
        "Chime.GetPhoneNumberSettings": [
            {
                "action": "chime:GetPhoneNumberSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.GetProxySession": [
            {
                "action": "chime:GetProxySession",
                "resource_mappings": {}
            }
        ],
        "Chime.GetRetentionSettings": [
            {
                "action": "chime:GetRetentionSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.GetRoom": [
            {
                "action": "chime:GetRoom",
                "resource_mappings": {}
            }
        ],
        "Chime.GetSipMediaApplication": [
            {
                "action": "chime:GetSipMediaApplication",
                "resource_mappings": {}
            }
        ],
        "Chime.GetSipMediaApplicationLoggingConfiguration": [
            {
                "action": "chime:GetSipMediaApplicationLoggingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.GetSipRule": [
            {
                "action": "chime:GetSipRule",
                "resource_mappings": {}
            }
        ],
        "Chime.GetUser": [
            {
                "action": "chime:GetUser",
                "resource_mappings": {}
            }
        ],
        "Chime.GetUserSettings": [
            {
                "action": "chime:GetUserSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.GetVoiceConnector": [
            {
                "action": "chime:GetVoiceConnector",
                "resource_mappings": {}
            }
        ],
        "Chime.GetVoiceConnectorEmergencyCallingConfiguration": [
            {
                "action": "chime:GetVoiceConnectorEmergencyCallingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.GetVoiceConnectorGroup": [
            {
                "action": "chime:GetVoiceConnectorGroup",
                "resource_mappings": {}
            }
        ],
        "Chime.GetVoiceConnectorLoggingConfiguration": [
            {
                "action": "chime:GetVoiceConnectorLoggingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.GetVoiceConnectorOrigination": [
            {
                "action": "chime:GetVoiceConnectorOrigination",
                "resource_mappings": {}
            }
        ],
        "Chime.GetVoiceConnectorProxy": [
            {
                "action": "chime:GetVoiceConnectorProxy",
                "resource_mappings": {}
            }
        ],
        "Chime.GetVoiceConnectorStreamingConfiguration": [
            {
                "action": "chime:GetVoiceConnectorStreamingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.GetVoiceConnectorTermination": [
            {
                "action": "chime:GetVoiceConnectorTermination",
                "resource_mappings": {}
            }
        ],
        "Chime.GetVoiceConnectorTerminationHealth": [
            {
                "action": "chime:GetVoiceConnectorTerminationHealth",
                "resource_mappings": {}
            }
        ],
        "Chime.InviteUsers": [
            {
                "action": "chime:InviteUsers",
                "resource_mappings": {}
            }
        ],
        "Chime.ListAccounts": [
            {
                "action": "chime:ListAccounts",
                "resource_mappings": {}
            }
        ],
        "Chime.ListAppInstanceAdmins": [
            {
                "action": "chime:ListAppInstanceAdmins",
                "resource_mappings": {
                    "AccountId": {
                        "template": "*"
                    },
                    "AppInstanceId": {
                        "template": "*"
                    },
                    "AppInstanceUserId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "Chime.ListAppInstanceUsers": [
            {
                "action": "chime:ListAppInstanceUsers",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceArn}/user/*"
                }
            }
        ],
        "Chime.ListAppInstances": [
            {
                "action": "chime:ListAppInstances",
                "resource_mappings": {
                    "AccountId": {
                        "template": "*"
                    },
                    "AppInstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Chime.ListAttendeeTags": [
            {
                "action": "chime:ListAttendeeTags",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.ListAttendees": [
            {
                "action": "chime:ListAttendees",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.ListBots": [
            {
                "action": "chime:ListBots",
                "resource_mappings": {}
            }
        ],
        "Chime.ListChannelBans": [
            {
                "action": "chime:ListChannelBans",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.ListChannelMemberships": [
            {
                "action": "chime:ListChannelMemberships",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.ListChannelMembershipsForAppInstanceUser": [
            {
                "action": "chime:ListChannelMembershipsForAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "Chime.ListChannelMessages": [
            {
                "action": "chime:ListChannelMessages",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.ListChannelModerators": [
            {
                "action": "chime:ListChannelModerators",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.ListChannels": [
            {
                "action": "chime:ListChannels",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${AppInstanceArn}/channel/*"
                }
            }
        ],
        "Chime.ListChannelsModeratedByAppInstanceUser": [
            {
                "action": "chime:ListChannelsModeratedByAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "Chime.ListMeetingTags": [
            {
                "action": "chime:ListMeetingTags",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.ListMeetings": [
            {
                "action": "chime:ListMeetings",
                "resource_mappings": {}
            }
        ],
        "Chime.ListPhoneNumberOrders": [
            {
                "action": "chime:ListPhoneNumberOrders",
                "resource_mappings": {}
            }
        ],
        "Chime.ListPhoneNumbers": [
            {
                "action": "chime:ListPhoneNumbers",
                "resource_mappings": {}
            }
        ],
        "Chime.ListProxySessions": [
            {
                "action": "chime:ListProxySessions",
                "resource_mappings": {}
            }
        ],
        "Chime.ListRoomMemberships": [
            {
                "action": "chime:ListRoomMemberships",
                "resource_mappings": {}
            }
        ],
        "Chime.ListRooms": [
            {
                "action": "chime:ListRooms",
                "resource_mappings": {}
            }
        ],
        "Chime.ListSipMediaApplications": [
            {
                "action": "chime:ListSipMediaApplications",
                "resource_mappings": {}
            }
        ],
        "Chime.ListSipRules": [
            {
                "action": "chime:ListSipRules",
                "resource_mappings": {}
            }
        ],
        "Chime.ListTagsForResource": [
            {
                "action": "chime:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Chime.ListUsers": [
            {
                "action": "chime:ListUsers",
                "resource_mappings": {}
            }
        ],
        "Chime.ListVoiceConnectorGroups": [
            {
                "action": "chime:ListVoiceConnectorGroups",
                "resource_mappings": {}
            }
        ],
        "Chime.ListVoiceConnectorTerminationCredentials": [
            {
                "action": "chime:ListVoiceConnectorTerminationCredentials",
                "resource_mappings": {}
            }
        ],
        "Chime.ListVoiceConnectors": [
            {
                "action": "chime:ListVoiceConnectors",
                "resource_mappings": {}
            }
        ],
        "Chime.LogoutUser": [
            {
                "action": "chime:LogoutUser",
                "resource_mappings": {}
            }
        ],
        "Chime.PutAppInstanceRetentionSettings": [
            {
                "action": "chime:PutAppInstanceRetentionSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "Chime.PutAppInstanceStreamingConfigurations": [
            {
                "action": "chime:PutAppInstanceStreamingConfigurations",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "Chime.PutEventsConfiguration": [
            {
                "action": "chime:PutEventsConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.PutRetentionSettings": [
            {
                "action": "chime:PutRetentionSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.PutSipMediaApplicationLoggingConfiguration": [
            {
                "action": "chime:PutSipMediaApplicationLoggingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.PutVoiceConnectorEmergencyCallingConfiguration": [
            {
                "action": "chime:PutVoiceConnectorEmergencyCallingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.PutVoiceConnectorLoggingConfiguration": [
            {
                "action": "chime:PutVoiceConnectorLoggingConfiguration",
                "resource_mappings": {}
            },
            {
                "action": "logs:CreateLogDelivery",
                "resource_mappings": {}
            }
        ],
        "Chime.PutVoiceConnectorOrigination": [
            {
                "action": "chime:PutVoiceConnectorOrigination",
                "resource_mappings": {}
            }
        ],
        "Chime.PutVoiceConnectorProxy": [
            {
                "action": "chime:PutVoiceConnectorProxy",
                "resource_mappings": {}
            }
        ],
        "Chime.PutVoiceConnectorStreamingConfiguration": [
            {
                "action": "chime:PutVoiceConnectorStreamingConfiguration",
                "resource_mappings": {}
            }
        ],
        "Chime.PutVoiceConnectorTermination": [
            {
                "action": "chime:PutVoiceConnectorTermination",
                "resource_mappings": {}
            }
        ],
        "Chime.PutVoiceConnectorTerminationCredentials": [
            {
                "action": "chime:PutVoiceConnectorTerminationCredentials",
                "resource_mappings": {}
            }
        ],
        "Chime.RedactChannelMessage": [
            {
                "action": "chime:RedactChannelMessage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.RedactConversationMessage": [
            {
                "action": "chime:RedactConversationMessage",
                "resource_mappings": {}
            }
        ],
        "Chime.RedactRoomMessage": [
            {
                "action": "chime:RedactRoomMessage",
                "resource_mappings": {}
            }
        ],
        "Chime.RegenerateSecurityToken": [
            {
                "action": "chime:RegenerateSecurityToken",
                "resource_mappings": {}
            }
        ],
        "Chime.ResetPersonalPIN": [
            {
                "action": "chime:ResetPersonalPIN",
                "resource_mappings": {}
            }
        ],
        "Chime.RestorePhoneNumber": [
            {
                "action": "chime:RestorePhoneNumber",
                "resource_mappings": {}
            }
        ],
        "Chime.SearchAvailablePhoneNumbers": [
            {
                "action": "chime:SearchAvailablePhoneNumbers",
                "resource_mappings": {}
            }
        ],
        "Chime.SendChannelMessage": [
            {
                "action": "chime:SendChannelMessage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.TagAttendee": [
            {
                "action": "chime:TagAttendee",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.TagMeeting": [
            {
                "action": "chime:TagMeeting",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.TagResource": [
            {
                "action": "chime:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Chime.UntagAttendee": [
            {
                "action": "chime:UntagAttendee",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.UntagMeeting": [
            {
                "action": "chime:UntagMeeting",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "MeetingId": {
                        "template": "${MeetingId}"
                    }
                }
            }
        ],
        "Chime.UntagResource": [
            {
                "action": "chime:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Chime.UpdateAccount": [
            {
                "action": "chime:UpdateAccount",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateAccountSettings": [
            {
                "action": "chime:UpdateAccountSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateAppInstance": [
            {
                "action": "chime:UpdateAppInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "Chime.UpdateAppInstanceUser": [
            {
                "action": "chime:UpdateAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "Chime.UpdateBot": [
            {
                "action": "chime:UpdateBot",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateChannel": [
            {
                "action": "chime:UpdateChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.UpdateChannelMessage": [
            {
                "action": "chime:UpdateChannelMessage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.UpdateChannelReadMarker": [
            {
                "action": "chime:UpdateChannelReadMarker",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${ChimeBearer}",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Chime.UpdateGlobalSettings": [
            {
                "action": "chime:UpdateGlobalSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdatePhoneNumber": [
            {
                "action": "chime:UpdatePhoneNumber",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdatePhoneNumberSettings": [
            {
                "action": "chime:UpdatePhoneNumberSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateProxySession": [
            {
                "action": "chime:UpdateProxySession",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateRoom": [
            {
                "action": "chime:UpdateRoom",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateRoomMembership": [
            {
                "action": "chime:UpdateRoomMembership",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateSipMediaApplication": [
            {
                "action": "chime:UpdateSipMediaApplication",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateSipRule": [
            {
                "action": "chime:UpdateSipRule",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateUser": [
            {
                "action": "chime:UpdateUser",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateUserSettings": [
            {
                "action": "chime:UpdateUserSettings",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateVoiceConnector": [
            {
                "action": "chime:UpdateVoiceConnector",
                "resource_mappings": {}
            }
        ],
        "Chime.UpdateVoiceConnectorGroup": [
            {
                "action": "chime:UpdateVoiceConnectorGroup",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.CreateConfigurationSet": [
            {
                "action": "ses:CreateConfigurationSet",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "PinpointEmail.CreateConfigurationSetEventDestination": [
            {
                "action": "ses:CreateConfigurationSetEventDestination",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${EventDestination.KinesisFirehoseDestination.IAMRoleARN}"
                }
            }
        ],
        "PinpointEmail.CreateDedicatedIpPool": [
            {
                "action": "ses:CreateDedicatedIpPool",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${PoolName}"
                    }
                }
            }
        ],
        "PinpointEmail.CreateDeliverabilityTestReport": [
            {
                "action": "ses:CreateDeliverabilityTestReport",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "PinpointEmail.CreateEmailIdentity": [
            {
                "action": "ses:CreateEmailIdentity",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "PinpointEmail.DeleteConfigurationSet": [
            {
                "action": "ses:DeleteConfigurationSet",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "PinpointEmail.DeleteConfigurationSetEventDestination": [
            {
                "action": "ses:DeleteConfigurationSetEventDestination",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "PinpointEmail.DeleteDedicatedIpPool": [
            {
                "action": "ses:DeleteDedicatedIpPool",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${PoolName}"
                    }
                }
            }
        ],
        "PinpointEmail.DeleteEmailIdentity": [
            {
                "action": "ses:DeleteEmailIdentity",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "PinpointEmail.GetAccount": [
            {
                "action": "ses:GetAccount",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.GetBlacklistReports": [
            {
                "action": "ses:GetBlacklistReports",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.GetConfigurationSet": [
            {
                "action": "ses:GetConfigurationSet",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "PinpointEmail.GetConfigurationSetEventDestinations": [
            {
                "action": "ses:GetConfigurationSetEventDestinations",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "PinpointEmail.GetDedicatedIp": [
            {
                "action": "ses:GetDedicatedIp",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.GetDedicatedIps": [
            {
                "action": "ses:GetDedicatedIps",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${PoolName}"
                    }
                }
            }
        ],
        "PinpointEmail.GetDeliverabilityDashboardOptions": [
            {
                "action": "ses:GetDeliverabilityDashboardOptions",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.GetDeliverabilityTestReport": [
            {
                "action": "ses:GetDeliverabilityTestReport",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${ReportId}"
                    }
                }
            }
        ],
        "PinpointEmail.GetDomainStatisticsReport": [
            {
                "action": "ses:GetDomainStatisticsReport",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "PinpointEmail.GetEmailIdentity": [
            {
                "action": "ses:GetEmailIdentity",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "PinpointEmail.ListConfigurationSets": [
            {
                "action": "ses:ListConfigurationSets",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.ListDedicatedIpPools": [
            {
                "action": "ses:ListDedicatedIpPools",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.ListDeliverabilityTestReports": [
            {
                "action": "ses:ListDeliverabilityTestReports",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.ListEmailIdentities": [
            {
                "action": "ses:ListEmailIdentities",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.ListTagsForResource": [
            {
                "action": "ses:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "configuration-set": "%%iftemplatematch%${ResourceArn}%%",
                    "dedicated-ip-pool": "%%iftemplatematch%${ResourceArn}%%",
                    "deliverability-test-report": "%%iftemplatematch%${ResourceArn}%%",
                    "identity": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "PinpointEmail.PutAccountDedicatedIpWarmupAttributes": [
            {
                "action": "ses:PutAccountDedicatedIpWarmupAttributes",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.PutAccountSendingAttributes": [
            {
                "action": "ses:PutAccountSendingAttributes",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.PutConfigurationSetDeliveryOptions": [
            {
                "action": "ses:PutConfigurationSetDeliveryOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "PinpointEmail.PutConfigurationSetReputationOptions": [
            {
                "action": "ses:PutConfigurationSetReputationOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "PinpointEmail.PutConfigurationSetSendingOptions": [
            {
                "action": "ses:PutConfigurationSetSendingOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "PinpointEmail.PutConfigurationSetTrackingOptions": [
            {
                "action": "ses:PutConfigurationSetTrackingOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "PinpointEmail.PutDedicatedIpInPool": [
            {
                "action": "ses:PutDedicatedIpInPool",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${DestinationPoolName}"
                    }
                }
            }
        ],
        "PinpointEmail.PutDedicatedIpWarmupAttributes": [
            {
                "action": "ses:PutDedicatedIpWarmupAttributes",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.PutDeliverabilityDashboardOption": [
            {
                "action": "ses:PutDeliverabilityDashboardOption",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.PutEmailIdentityDkimAttributes": [
            {
                "action": "ses:PutEmailIdentityDkimAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "PinpointEmail.PutEmailIdentityFeedbackAttributes": [
            {
                "action": "ses:PutEmailIdentityFeedbackAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "PinpointEmail.PutEmailIdentityMailFromAttributes": [
            {
                "action": "ses:PutEmailIdentityMailFromAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "PinpointEmail.SendEmail": [
            {
                "action": "ses:SendEmail",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "PinpointEmail.TagResource": [
            {
                "action": "ses:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "configuration-set": "%%iftemplatematch%${ResourceArn}%%",
                    "dedicated-ip-pool": "%%iftemplatematch%${ResourceArn}%%",
                    "deliverability-test-report": "%%iftemplatematch%${ResourceArn}%%",
                    "identity": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "PinpointEmail.UntagResource": [
            {
                "action": "ses:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "configuration-set": "%%iftemplatematch%${ResourceArn}%%",
                    "dedicated-ip-pool": "%%iftemplatematch%${ResourceArn}%%",
                    "deliverability-test-report": "%%iftemplatematch%${ResourceArn}%%",
                    "identity": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "PinpointEmail.UpdateConfigurationSetEventDestination": [
            {
                "action": "ses:UpdateConfigurationSetEventDestination",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${EventDestination.KinesisFirehoseDestination.IAMRoleARN}"
                }
            }
        ],
        "RAM.AcceptResourceShareInvitation": [
            {
                "action": "ram:AcceptResourceShareInvitation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share-invitation": "${resourceShareInvitationArn}"
                }
            }
        ],
        "RAM.AssociateResourceShare": [
            {
                "action": "ram:AssociateResourceShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "RAM.AssociateResourceSharePermission": [
            {
                "action": "ram:AssociateResourceSharePermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "permission": "${permissionArn}",
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "RAM.CreateResourceShare": [
            {
                "action": "ram:CreateResourceShare",
                "resource_mappings": {}
            }
        ],
        "RAM.DeleteResourceShare": [
            {
                "action": "ram:DeleteResourceShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "RAM.DisassociateResourceShare": [
            {
                "action": "ram:DisassociateResourceShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "RAM.DisassociateResourceSharePermission": [
            {
                "action": "ram:DisassociateResourceSharePermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "permission": "${permissionArn}",
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "RAM.EnableSharingWithAwsOrganization": [
            {
                "action": "ram:EnableSharingWithAwsOrganization",
                "resource_mappings": {}
            }
        ],
        "RAM.GetPermission": [
            {
                "action": "ram:GetPermission",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "permission": "${permissionArn}"
                }
            }
        ],
        "RAM.GetResourcePolicies": [
            {
                "action": "ram:GetResourcePolicies",
                "resource_mappings": {}
            }
        ],
        "RAM.GetResourceShareAssociations": [
            {
                "action": "ram:GetResourceShareAssociations",
                "resource_mappings": {}
            }
        ],
        "RAM.GetResourceShareInvitations": [
            {
                "action": "ram:GetResourceShareInvitations",
                "resource_mappings": {}
            }
        ],
        "RAM.GetResourceShares": [
            {
                "action": "ram:GetResourceShares",
                "resource_mappings": {}
            }
        ],
        "RAM.ListPendingInvitationResources": [
            {
                "action": "ram:ListPendingInvitationResources",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share-invitation": "${resourceShareInvitationArn}"
                }
            }
        ],
        "RAM.ListPermissions": [
            {
                "action": "ram:ListPermissions",
                "resource_mappings": {}
            }
        ],
        "RAM.ListPrincipals": [
            {
                "action": "ram:ListPrincipals",
                "resource_mappings": {}
            }
        ],
        "RAM.ListResourceSharePermissions": [
            {
                "action": "ram:ListResourceSharePermissions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "RAM.ListResourceTypes": [
            {
                "action": "ram:ListResourceTypes",
                "resource_mappings": {}
            }
        ],
        "RAM.ListResources": [
            {
                "action": "ram:ListResources",
                "resource_mappings": {}
            }
        ],
        "RAM.PromoteResourceShareCreatedFromPolicy": [
            {
                "action": "ram:PromoteResourceShareCreatedFromPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "RAM.RejectResourceShareInvitation": [
            {
                "action": "ram:RejectResourceShareInvitation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share-invitation": "${resourceShareInvitationArn}"
                }
            }
        ],
        "RAM.TagResource": [
            {
                "action": "ram:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "RAM.UntagResource": [
            {
                "action": "ram:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "RAM.UpdateResourceShare": [
            {
                "action": "ram:UpdateResourceShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resource-share": "${resourceShareArn}"
                }
            }
        ],
        "Route53Resolver.AssociateResolverEndpointIpAddress": [
            {
                "action": "route53resolver:AssociateResolverEndpointIpAddress",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverEndpointId}"
                    }
                }
            }
        ],
        "Route53Resolver.AssociateResolverQueryLogConfig": [
            {
                "action": "route53resolver:AssociateResolverQueryLogConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverQueryLogConfigId}"
                    }
                }
            }
        ],
        "Route53Resolver.AssociateResolverRule": [
            {
                "action": "route53resolver:AssociateResolverRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverRuleId}"
                    }
                }
            }
        ],
        "Route53Resolver.CreateResolverEndpoint": [
            {
                "action": "route53resolver:CreateResolverEndpoint",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.CreateResolverQueryLogConfig": [
            {
                "action": "route53resolver:CreateResolverQueryLogConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.CreateResolverRule": [
            {
                "action": "route53resolver:CreateResolverRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.DeleteResolverEndpoint": [
            {
                "action": "route53resolver:DeleteResolverEndpoint",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverEndpointId}"
                    }
                }
            }
        ],
        "Route53Resolver.DeleteResolverQueryLogConfig": [
            {
                "action": "route53resolver:DeleteResolverQueryLogConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverQueryLogConfigId}"
                    }
                }
            }
        ],
        "Route53Resolver.DeleteResolverRule": [
            {
                "action": "route53resolver:DeleteResolverRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverRuleId}"
                    }
                }
            }
        ],
        "Route53Resolver.DisassociateResolverEndpointIpAddress": [
            {
                "action": "route53resolver:DisassociateResolverEndpointIpAddress",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverEndpointId}"
                    }
                }
            }
        ],
        "Route53Resolver.DisassociateResolverQueryLogConfig": [
            {
                "action": "route53resolver:DisassociateResolverQueryLogConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverQueryLogConfigId}"
                    }
                }
            }
        ],
        "Route53Resolver.DisassociateResolverRule": [
            {
                "action": "route53resolver:DisassociateResolverRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverRuleId}"
                    }
                }
            }
        ],
        "Route53Resolver.GetResolverDnssecConfig": [
            {
                "action": "route53resolver:GetResolverDnssecConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.GetResolverEndpoint": [
            {
                "action": "route53resolver:GetResolverEndpoint",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverEndpointId}"
                    }
                }
            }
        ],
        "Route53Resolver.GetResolverQueryLogConfig": [
            {
                "action": "route53resolver:GetResolverQueryLogConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverQueryLogConfigId}"
                    }
                }
            }
        ],
        "Route53Resolver.GetResolverQueryLogConfigAssociation": [
            {
                "action": "route53resolver:GetResolverQueryLogConfigAssociation",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.GetResolverQueryLogConfigPolicy": [
            {
                "action": "route53resolver:GetResolverQueryLogConfigPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resolver-query-log-config": "${Arn}"
                }
            }
        ],
        "Route53Resolver.GetResolverRule": [
            {
                "action": "route53resolver:GetResolverRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverRuleId}"
                    }
                }
            }
        ],
        "Route53Resolver.GetResolverRuleAssociation": [
            {
                "action": "route53resolver:GetResolverRuleAssociation",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.GetResolverRulePolicy": [
            {
                "action": "route53resolver:GetResolverRulePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resolver-rule": "${Arn}"
                }
            }
        ],
        "Route53Resolver.ListResolverDnssecConfigs": [
            {
                "action": "route53resolver:ListResolverDnssecConfigs",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.ListResolverEndpointIpAddresses": [
            {
                "action": "route53resolver:ListResolverEndpointIpAddresses",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverEndpointId}"
                    }
                }
            }
        ],
        "Route53Resolver.ListResolverEndpoints": [
            {
                "action": "route53resolver:ListResolverEndpoints",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.ListResolverQueryLogConfigAssociations": [
            {
                "action": "route53resolver:ListResolverQueryLogConfigAssociations",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.ListResolverQueryLogConfigs": [
            {
                "action": "route53resolver:ListResolverQueryLogConfigs",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.ListResolverRuleAssociations": [
            {
                "action": "route53resolver:ListResolverRuleAssociations",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.ListResolverRules": [
            {
                "action": "route53resolver:ListResolverRules",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.ListTagsForResource": [
            {
                "action": "route53resolver:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resolver-endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "resolver-rule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Route53Resolver.PutResolverQueryLogConfigPolicy": [
            {
                "action": "route53resolver:PutResolverQueryLogConfigPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resolver-query-log-config": "${Arn}"
                }
            }
        ],
        "Route53Resolver.PutResolverRulePolicy": [
            {
                "action": "route53resolver:PutResolverRulePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resolver-rule": "${Arn}"
                }
            }
        ],
        "Route53Resolver.TagResource": [
            {
                "action": "route53resolver:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resolver-endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "resolver-rule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Route53Resolver.UntagResource": [
            {
                "action": "route53resolver:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resolver-endpoint": "%%iftemplatematch%${ResourceArn}%%",
                    "resolver-rule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Route53Resolver.UpdateResolverDnssecConfig": [
            {
                "action": "route53resolver:UpdateResolverDnssecConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.UpdateResolverEndpoint": [
            {
                "action": "route53resolver:UpdateResolverEndpoint",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverEndpointId}"
                    }
                }
            }
        ],
        "Route53Resolver.UpdateResolverRule": [
            {
                "action": "route53resolver:UpdateResolverRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResolverRuleId}"
                    }
                }
            }
        ],
        "PinpointSMSVoice.CreateConfigurationSet": [
            {
                "action": "sms-voice:CreateConfigurationSet",
                "resource_mappings": {}
            }
        ],
        "PinpointSMSVoice.CreateConfigurationSetEventDestination": [
            {
                "action": "sms-voice:CreateConfigurationSetEventDestination",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${EventDestination.CloudWatchLogsDestination.IamRoleArn}%${EventDestination.KinesisFirehoseDestination.IamRoleArn}%%"
                }
            }
        ],
        "PinpointSMSVoice.DeleteConfigurationSet": [
            {
                "action": "sms-voice:DeleteConfigurationSet",
                "resource_mappings": {}
            }
        ],
        "PinpointSMSVoice.DeleteConfigurationSetEventDestination": [
            {
                "action": "sms-voice:DeleteConfigurationSetEventDestination",
                "resource_mappings": {}
            }
        ],
        "PinpointSMSVoice.GetConfigurationSetEventDestinations": [
            {
                "action": "sms-voice:GetConfigurationSetEventDestinations",
                "resource_mappings": {}
            }
        ],
        "PinpointSMSVoice.ListConfigurationSets": [
            {
                "action": "sms-voice:ListConfigurationSets",
                "resource_mappings": {}
            }
        ],
        "PinpointSMSVoice.SendVoiceMessage": [
            {
                "action": "sms-voice:SendVoiceMessage",
                "resource_mappings": {}
            }
        ],
        "PinpointSMSVoice.UpdateConfigurationSetEventDestination": [
            {
                "action": "sms-voice:UpdateConfigurationSetEventDestination",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${EventDestination.CloudWatchLogsDestination.IamRoleArn}%${EventDestination.KinesisFirehoseDestination.IamRoleArn}%%"
                }
            }
        ],
        "QuickSight.CancelIngestion": [
            {
                "action": "quicksight:CancelIngestion",
                "resource_mappings": {
                    "DatasetId": {
                        "template": "${DataSetId}"
                    },
                    "ResourceId": {
                        "template": "${IngestionId}"
                    }
                }
            }
        ],
        "QuickSight.CreateAccountCustomization": [
            {
                "action": "quicksight:CreateAccountCustomization",
                "resource_mappings": {}
            }
        ],
        "QuickSight.CreateAnalysis": [
            {
                "action": "quicksight:CreateAnalysis",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AnalysisId}"
                    }
                }
            }
        ],
        "QuickSight.CreateDashboard": [
            {
                "action": "quicksight:CreateDashboard",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DashboardId}"
                    }
                }
            }
        ],
        "QuickSight.CreateDataSet": [
            {
                "action": "quicksight:CreateDataSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "quicksight:PassDataSource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.CreateDataSource": [
            {
                "action": "quicksight:CreateDataSource",
                "resource_mappings": {}
            }
        ],
        "QuickSight.CreateGroup": [
            {
                "action": "quicksight:CreateGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "QuickSight.CreateGroupMembership": [
            {
                "action": "quicksight:CreateGroupMembership",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "QuickSight.CreateIAMPolicyAssignment": [
            {
                "action": "quicksight:CreateIAMPolicyAssignment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AssignmentName}"
                    }
                }
            }
        ],
        "QuickSight.CreateIngestion": [
            {
                "action": "quicksight:CreateIngestion",
                "resource_mappings": {
                    "DatasetId": {
                        "template": "${DataSetId}"
                    },
                    "ResourceId": {
                        "template": "${IngestionId}"
                    }
                }
            }
        ],
        "QuickSight.CreateNamespace": [
            {
                "action": "quicksight:CreateNamespace",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Namespace}"
                    }
                }
            }
        ],
        "QuickSight.CreateTemplate": [
            {
                "action": "quicksight:CreateTemplate",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.CreateTemplateAlias": [
            {
                "action": "quicksight:CreateTemplateAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.CreateTheme": [
            {
                "action": "quicksight:CreateTheme",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.CreateThemeAlias": [
            {
                "action": "quicksight:CreateThemeAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.DeleteAccountCustomization": [
            {
                "action": "quicksight:DeleteAccountCustomization",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.DeleteAnalysis": [
            {
                "action": "quicksight:DeleteAnalysis",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AnalysisId}"
                    }
                }
            }
        ],
        "QuickSight.DeleteDashboard": [
            {
                "action": "quicksight:DeleteDashboard",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DashboardId}"
                    }
                }
            }
        ],
        "QuickSight.DeleteDataSet": [
            {
                "action": "quicksight:DeleteDataSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DataSetId}"
                    }
                }
            }
        ],
        "QuickSight.DeleteDataSource": [
            {
                "action": "quicksight:DeleteDataSource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "QuickSight.DeleteGroup": [
            {
                "action": "quicksight:DeleteGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "QuickSight.DeleteGroupMembership": [
            {
                "action": "quicksight:DeleteGroupMembership",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "QuickSight.DeleteIAMPolicyAssignment": [
            {
                "action": "quicksight:DeleteIAMPolicyAssignment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AssignmentName}"
                    }
                }
            }
        ],
        "QuickSight.DeleteNamespace": [
            {
                "action": "quicksight:DeleteNamespace",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Namespace}"
                    }
                }
            }
        ],
        "QuickSight.DeleteTemplate": [
            {
                "action": "quicksight:DeleteTemplate",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.DeleteTemplateAlias": [
            {
                "action": "quicksight:DeleteTemplateAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.DeleteTheme": [
            {
                "action": "quicksight:DeleteTheme",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.DeleteThemeAlias": [
            {
                "action": "quicksight:DeleteThemeAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.DeleteUser": [
            {
                "action": "quicksight:DeleteUser",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "QuickSight.DeleteUserByPrincipalId": [
            {
                "action": "quicksight:DeleteUserByPrincipalId",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.DescribeAccountCustomization": [
            {
                "action": "quicksight:DescribeAccountCustomization",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.DescribeAccountSettings": [
            {
                "action": "quicksight:DescribeAccountSettings",
                "resource_mappings": {}
            }
        ],
        "QuickSight.DescribeAnalysis": [
            {
                "action": "quicksight:DescribeAnalysis",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AnalysisId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeAnalysisPermissions": [
            {
                "action": "quicksight:DescribeAnalysisPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AnalysisId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeDashboard": [
            {
                "action": "quicksight:DescribeDashboard",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DashboardId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeDashboardPermissions": [
            {
                "action": "quicksight:DescribeDashboardPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DashboardId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeDataSet": [
            {
                "action": "quicksight:DescribeDataSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DataSetId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeDataSetPermissions": [
            {
                "action": "quicksight:DescribeDataSetPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DataSetId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeDataSource": [
            {
                "action": "quicksight:DescribeDataSource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeDataSourcePermissions": [
            {
                "action": "quicksight:DescribeDataSourcePermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeGroup": [
            {
                "action": "quicksight:DescribeGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "QuickSight.DescribeIAMPolicyAssignment": [
            {
                "action": "quicksight:DescribeIAMPolicyAssignment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AssignmentName}"
                    }
                }
            }
        ],
        "QuickSight.DescribeIngestion": [
            {
                "action": "quicksight:DescribeIngestion",
                "resource_mappings": {
                    "DatasetId": {
                        "template": "${DataSetId}"
                    },
                    "ResourceId": {
                        "template": "${IngestionId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeNamespace": [
            {
                "action": "quicksight:DescribeNamespace",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Namespace}"
                    }
                }
            }
        ],
        "QuickSight.DescribeTemplate": [
            {
                "action": "quicksight:DescribeTemplate",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeTemplateAlias": [
            {
                "action": "quicksight:DescribeTemplateAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeTemplatePermissions": [
            {
                "action": "quicksight:DescribeTemplatePermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeTheme": [
            {
                "action": "quicksight:DescribeTheme",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeThemeAlias": [
            {
                "action": "quicksight:DescribeThemeAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeThemePermissions": [
            {
                "action": "quicksight:DescribeThemePermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeUser": [
            {
                "action": "quicksight:DescribeUser",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "QuickSight.GetDashboardEmbedUrl": [
            {
                "action": "quicksight:GetDashboardEmbedUrl",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DashboardId}"
                    }
                }
            }
        ],
        "QuickSight.GetSessionEmbedUrl": [
            {
                "action": "quicksight:GetSessionEmbedUrl",
                "resource_mappings": {}
            }
        ],
        "QuickSight.ListAnalyses": [
            {
                "action": "quicksight:ListAnalyses",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.ListDashboardVersions": [
            {
                "action": "quicksight:ListDashboardVersions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DashboardId}"
                    }
                }
            }
        ],
        "QuickSight.ListDashboards": [
            {
                "action": "quicksight:ListDashboards",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.ListDataSets": [
            {
                "action": "quicksight:ListDataSets",
                "resource_mappings": {}
            }
        ],
        "QuickSight.ListDataSources": [
            {
                "action": "quicksight:ListDataSources",
                "resource_mappings": {}
            }
        ],
        "QuickSight.ListGroupMemberships": [
            {
                "action": "quicksight:ListGroupMemberships",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "QuickSight.ListGroups": [
            {
                "action": "quicksight:ListGroups",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.ListIAMPolicyAssignments": [
            {
                "action": "quicksight:ListIAMPolicyAssignments",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.ListIAMPolicyAssignmentsForUser": [
            {
                "action": "quicksight:ListIAMPolicyAssignmentsForUser",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.ListIngestions": [
            {
                "action": "quicksight:ListIngestions",
                "resource_mappings": {}
            }
        ],
        "QuickSight.ListNamespaces": [
            {
                "action": "quicksight:ListNamespaces",
                "resource_mappings": {}
            }
        ],
        "QuickSight.ListTagsForResource": [
            {
                "action": "quicksight:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "customization": "%%iftemplatematch%${ResourceArn}%%",
                    "dashboard": "%%iftemplatematch%${ResourceArn}%%",
                    "template": "%%iftemplatematch%${ResourceArn}%%",
                    "theme": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "QuickSight.ListTemplateAliases": [
            {
                "action": "quicksight:ListTemplateAliases",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.ListTemplateVersions": [
            {
                "action": "quicksight:ListTemplateVersions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.ListTemplates": [
            {
                "action": "quicksight:ListTemplates",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.ListThemeAliases": [
            {
                "action": "quicksight:ListThemeAliases",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.ListThemeVersions": [
            {
                "action": "quicksight:ListThemeVersions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.ListThemes": [
            {
                "action": "quicksight:ListThemes",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.ListUserGroups": [
            {
                "action": "quicksight:ListUserGroups",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "QuickSight.ListUsers": [
            {
                "action": "quicksight:ListUsers",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.RegisterUser": [
            {
                "action": "quicksight:RegisterUser",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${UserRole}%${IamArn}%%"
                }
            }
        ],
        "QuickSight.RestoreAnalysis": [
            {
                "action": "quicksight:RestoreAnalysis",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AnalysisId}"
                    }
                }
            }
        ],
        "QuickSight.SearchAnalyses": [
            {
                "action": "quicksight:SearchAnalyses",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.SearchDashboards": [
            {
                "action": "quicksight:SearchDashboards",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.TagResource": [
            {
                "action": "quicksight:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "customization": "%%iftemplatematch%${ResourceArn}%%",
                    "dashboard": "%%iftemplatematch%${ResourceArn}%%",
                    "template": "%%iftemplatematch%${ResourceArn}%%",
                    "theme": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "QuickSight.UntagResource": [
            {
                "action": "quicksight:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "customization": "%%iftemplatematch%${ResourceArn}%%",
                    "dashboard": "%%iftemplatematch%${ResourceArn}%%",
                    "template": "%%iftemplatematch%${ResourceArn}%%",
                    "theme": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "QuickSight.UpdateAccountCustomization": [
            {
                "action": "quicksight:UpdateAccountCustomization",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.UpdateAccountSettings": [
            {
                "action": "quicksight:UpdateAccountSettings",
                "resource_mappings": {}
            }
        ],
        "QuickSight.UpdateAnalysis": [
            {
                "action": "quicksight:UpdateAnalysis",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AnalysisId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateAnalysisPermissions": [
            {
                "action": "quicksight:UpdateAnalysisPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AnalysisId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateDashboard": [
            {
                "action": "quicksight:UpdateDashboard",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DashboardId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateDashboardPermissions": [
            {
                "action": "quicksight:UpdateDashboardPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DashboardId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateDashboardPublishedVersion": [
            {
                "action": "quicksight:UpdateDashboardPublishedVersion",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DashboardId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateDataSet": [
            {
                "action": "quicksight:UpdateDataSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "quicksight:PassDataSource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.UpdateDataSetPermissions": [
            {
                "action": "quicksight:UpdateDataSetPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DataSetId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateDataSource": [
            {
                "action": "quicksight:UpdateDataSource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateDataSourcePermissions": [
            {
                "action": "quicksight:UpdateDataSourcePermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateGroup": [
            {
                "action": "quicksight:UpdateGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GroupName}"
                    }
                }
            }
        ],
        "QuickSight.UpdateIAMPolicyAssignment": [
            {
                "action": "quicksight:UpdateIAMPolicyAssignment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AssignmentName}"
                    }
                }
            }
        ],
        "QuickSight.UpdateTemplate": [
            {
                "action": "quicksight:UpdateTemplate",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateTemplateAlias": [
            {
                "action": "quicksight:UpdateTemplateAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateTemplatePermissions": [
            {
                "action": "quicksight:UpdateTemplatePermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${TemplateId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateTheme": [
            {
                "action": "quicksight:UpdateTheme",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateThemeAlias": [
            {
                "action": "quicksight:UpdateThemeAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateThemePermissions": [
            {
                "action": "quicksight:UpdateThemePermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ThemeId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateUser": [
            {
                "action": "quicksight:UpdateUser",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "Amplify.CreateApp": [
            {
                "action": "amplify:CreateApp",
                "resource_mappings": {
                    "AppId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${iamServiceRoleArn}"
                }
            }
        ],
        "Amplify.CreateBackendEnvironment": [
            {
                "action": "amplify:CreateBackendEnvironment",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.CreateBranch": [
            {
                "action": "amplify:CreateBranch",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.CreateDeployment": [
            {
                "action": "amplify:CreateDeployment",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    }
                }
            }
        ],
        "Amplify.CreateDomainAssociation": [
            {
                "action": "amplify:CreateDomainAssociation",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${autoSubDomainIAMRole}"
                }
            }
        ],
        "Amplify.DeleteApp": [
            {
                "action": "amplify:DeleteApp",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.DeleteBackendEnvironment": [
            {
                "action": "amplify:DeleteBackendEnvironment",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.DeleteBranch": [
            {
                "action": "amplify:DeleteBranch",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    }
                }
            }
        ],
        "Amplify.DeleteDomainAssociation": [
            {
                "action": "amplify:DeleteDomainAssociation",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "DomainName": {
                        "template": "${domainName}"
                    }
                }
            }
        ],
        "Amplify.DeleteJob": [
            {
                "action": "amplify:DeleteJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    },
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Amplify.GenerateAccessLogs": [
            {
                "action": "amplify:GenerateAccessLogs",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.GetApp": [
            {
                "action": "amplify:GetApp",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.GetArtifactUrl": [
            {
                "action": "amplify:GetArtifactUrl",
                "resource_mappings": {
                    "AppId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Amplify.GetBackendEnvironment": [
            {
                "action": "amplify:GetBackendEnvironment",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.GetBranch": [
            {
                "action": "amplify:GetBranch",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    }
                }
            }
        ],
        "Amplify.GetDomainAssociation": [
            {
                "action": "amplify:GetDomainAssociation",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "DomainName": {
                        "template": "${domainName}"
                    }
                }
            }
        ],
        "Amplify.GetJob": [
            {
                "action": "amplify:GetJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    },
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Amplify.ListApps": [
            {
                "action": "amplify:ListApps",
                "resource_mappings": {}
            }
        ],
        "Amplify.ListArtifacts": [
            {
                "action": "amplify:ListArtifacts",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.ListBackendEnvironments": [
            {
                "action": "amplify:ListBackendEnvironments",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.ListBranches": [
            {
                "action": "amplify:ListBranches",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.ListDomainAssociations": [
            {
                "action": "amplify:ListDomainAssociations",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.ListJobs": [
            {
                "action": "amplify:ListJobs",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    }
                }
            }
        ],
        "Amplify.StartDeployment": [
            {
                "action": "amplify:StartDeployment",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    }
                }
            }
        ],
        "Amplify.StartJob": [
            {
                "action": "amplify:StartJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    },
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Amplify.StopJob": [
            {
                "action": "amplify:StopJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    },
                    "JobId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Amplify.TagResource": [
            {
                "action": "amplify:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "apps": "%%iftemplatematch%${resourceArn}%%",
                    "branches": "%%iftemplatematch%${resourceArn}%%",
                    "jobs": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Amplify.UntagResource": [
            {
                "action": "amplify:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "apps": "%%iftemplatematch%${resourceArn}%%",
                    "branches": "%%iftemplatematch%${resourceArn}%%",
                    "jobs": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Amplify.UpdateApp": [
            {
                "action": "amplify:UpdateApp",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${iamServiceRoleArn}"
                }
            }
        ],
        "Amplify.UpdateBranch": [
            {
                "action": "amplify:UpdateBranch",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    }
                }
            }
        ],
        "Amplify.UpdateDomainAssociation": [
            {
                "action": "amplify:UpdateDomainAssociation",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "DomainName": {
                        "template": "${domainName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${autoSubDomainIAMRole}"
                }
            }
        ],
        "DataSync.CancelTaskExecution": [
            {
                "action": "datasync:CancelTaskExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "taskexecution": "${TaskExecutionArn}"
                }
            }
        ],
        "DataSync.CreateAgent": [
            {
                "action": "datasync:CreateAgent",
                "resource_mappings": {}
            }
        ],
        "DataSync.CreateLocationEfs": [
            {
                "action": "datasync:CreateLocationEfs",
                "resource_mappings": {}
            }
        ],
        "DataSync.CreateLocationFsxWindows": [
            {
                "action": "datasync:CreateLocationFsxWindows",
                "resource_mappings": {}
            }
        ],
        "DataSync.CreateLocationNfs": [
            {
                "action": "datasync:CreateLocationNfs",
                "resource_mappings": {}
            }
        ],
        "DataSync.CreateLocationObjectStorage": [
            {
                "action": "datasync:CreateLocationObjectStorage",
                "resource_mappings": {}
            }
        ],
        "DataSync.CreateLocationS3": [
            {
                "action": "datasync:CreateLocationS3",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${S3Config.BucketAccessRoleArn}"
                }
            }
        ],
        "DataSync.CreateLocationSmb": [
            {
                "action": "datasync:CreateLocationSmb",
                "resource_mappings": {}
            }
        ],
        "DataSync.CreateTask": [
            {
                "action": "datasync:CreateTask",
                "resource_mappings": {}
            }
        ],
        "DataSync.DeleteAgent": [
            {
                "action": "datasync:DeleteAgent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "agent": "${AgentArn}"
                }
            }
        ],
        "DataSync.DeleteLocation": [
            {
                "action": "datasync:DeleteLocation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "DataSync.DeleteTask": [
            {
                "action": "datasync:DeleteTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "task": "${TaskArn}"
                }
            }
        ],
        "DataSync.DescribeAgent": [
            {
                "action": "datasync:DescribeAgent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "agent": "${AgentArn}"
                }
            }
        ],
        "DataSync.DescribeLocationEfs": [
            {
                "action": "datasync:DescribeLocationEfs",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "DataSync.DescribeLocationFsxWindows": [
            {
                "action": "datasync:DescribeLocationFsxWindows",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "DataSync.DescribeLocationNfs": [
            {
                "action": "datasync:DescribeLocationNfs",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "DataSync.DescribeLocationObjectStorage": [
            {
                "action": "datasync:DescribeLocationObjectStorage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "DataSync.DescribeLocationS3": [
            {
                "action": "datasync:DescribeLocationS3",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "DataSync.DescribeLocationSmb": [
            {
                "action": "datasync:DescribeLocationSmb",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "DataSync.DescribeTask": [
            {
                "action": "datasync:DescribeTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "task": "${TaskArn}"
                }
            }
        ],
        "DataSync.DescribeTaskExecution": [
            {
                "action": "datasync:DescribeTaskExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "taskexecution": "${TaskExecutionArn}"
                }
            }
        ],
        "DataSync.ListAgents": [
            {
                "action": "datasync:ListAgents",
                "resource_mappings": {}
            }
        ],
        "DataSync.ListLocations": [
            {
                "action": "datasync:ListLocations",
                "resource_mappings": {}
            }
        ],
        "DataSync.ListTagsForResource": [
            {
                "action": "datasync:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "agent": "%%iftemplatematch%${ResourceArn}%%",
                    "location": "%%iftemplatematch%${ResourceArn}%%",
                    "task": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DataSync.ListTaskExecutions": [
            {
                "action": "datasync:ListTaskExecutions",
                "resource_mappings": {}
            }
        ],
        "DataSync.ListTasks": [
            {
                "action": "datasync:ListTasks",
                "resource_mappings": {}
            }
        ],
        "DataSync.StartTaskExecution": [
            {
                "action": "datasync:StartTaskExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "task": "${TaskArn}"
                }
            }
        ],
        "DataSync.TagResource": [
            {
                "action": "datasync:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "agent": "%%iftemplatematch%${ResourceArn}%%",
                    "location": "%%iftemplatematch%${ResourceArn}%%",
                    "task": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DataSync.UntagResource": [
            {
                "action": "datasync:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "agent": "%%iftemplatematch%${ResourceArn}%%",
                    "location": "%%iftemplatematch%${ResourceArn}%%",
                    "task": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DataSync.UpdateAgent": [
            {
                "action": "datasync:UpdateAgent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "agent": "${AgentArn}"
                }
            }
        ],
        "DataSync.UpdateTask": [
            {
                "action": "datasync:UpdateTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "task": "${TaskArn}"
                }
            }
        ],
        "RoboMaker.BatchDeleteWorlds": [
            {
                "action": "robomaker:BatchDeleteWorlds",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.BatchDescribeSimulationJob": [
            {
                "action": "robomaker:BatchDescribeSimulationJob",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.CancelDeploymentJob": [
            {
                "action": "robomaker:CancelDeploymentJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentJob": "${job}"
                }
            }
        ],
        "RoboMaker.CancelSimulationJob": [
            {
                "action": "robomaker:CancelSimulationJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "simulationJob": "${job}"
                }
            }
        ],
        "RoboMaker.CancelSimulationJobBatch": [
            {
                "action": "robomaker:CancelSimulationJobBatch",
                "resource_mappings": {
                    "SimulationJobBatchId": {
                        "template": "${batch}"
                    }
                }
            }
        ],
        "RoboMaker.CancelWorldExportJob": [
            {
                "action": "robomaker:CancelWorldExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "worldExportJob": "${job}"
                }
            }
        ],
        "RoboMaker.CancelWorldGenerationJob": [
            {
                "action": "robomaker:CancelWorldGenerationJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "worldGenerationJob": "${job}"
                }
            }
        ],
        "RoboMaker.CreateDeploymentJob": [
            {
                "action": "robomaker:CreateDeploymentJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "RoboMaker.CreateFleet": [
            {
                "action": "robomaker:CreateFleet",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.CreateRobot": [
            {
                "action": "robomaker:CreateRobot",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "RoboMaker.CreateRobotApplication": [
            {
                "action": "robomaker:CreateRobotApplication",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.CreateRobotApplicationVersion": [
            {
                "action": "robomaker:CreateRobotApplicationVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "robotApplication": "%%iftemplatematch%${application}%%"
                }
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "RoboMaker.CreateSimulationApplication": [
            {
                "action": "robomaker:CreateSimulationApplication",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.CreateSimulationApplicationVersion": [
            {
                "action": "robomaker:CreateSimulationApplicationVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "simulationApplication": "%%iftemplatematch%${application}%%"
                }
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "RoboMaker.CreateSimulationJob": [
            {
                "action": "robomaker:CreateSimulationJob",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${iamRole}"
                }
            }
        ],
        "RoboMaker.CreateWorldExportJob": [
            {
                "action": "robomaker:CreateWorldExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "world": "${worlds[]}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${iamRole}"
                }
            }
        ],
        "RoboMaker.CreateWorldGenerationJob": [
            {
                "action": "robomaker:CreateWorldGenerationJob",
                "resource_mappings": {
                    "WorldTemplateJobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RoboMaker.CreateWorldTemplate": [
            {
                "action": "robomaker:CreateWorldTemplate",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.DeleteFleet": [
            {
                "action": "robomaker:DeleteFleet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentFleet": "${fleet}"
                }
            }
        ],
        "RoboMaker.DeleteRobot": [
            {
                "action": "robomaker:DeleteRobot",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "robot": "${robot}"
                }
            }
        ],
        "RoboMaker.DeleteRobotApplication": [
            {
                "action": "robomaker:DeleteRobotApplication",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "robotApplication": "${application}"
                }
            }
        ],
        "RoboMaker.DeleteSimulationApplication": [
            {
                "action": "robomaker:DeleteSimulationApplication",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "simulationApplication": "%%iftemplatematch%${application}%%"
                }
            }
        ],
        "RoboMaker.DeleteWorldTemplate": [
            {
                "action": "robomaker:DeleteWorldTemplate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "worldTemplate": "${template}"
                }
            }
        ],
        "RoboMaker.DeregisterRobot": [
            {
                "action": "robomaker:DeregisterRobot",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentFleet": "${fleet}",
                    "robot": "${robot}"
                }
            }
        ],
        "RoboMaker.DescribeDeploymentJob": [
            {
                "action": "robomaker:DescribeDeploymentJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentJob": "${job}"
                }
            }
        ],
        "RoboMaker.DescribeFleet": [
            {
                "action": "robomaker:DescribeFleet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentFleet": "${fleet}"
                }
            }
        ],
        "RoboMaker.DescribeRobot": [
            {
                "action": "robomaker:DescribeRobot",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "robot": "${robot}"
                }
            }
        ],
        "RoboMaker.DescribeRobotApplication": [
            {
                "action": "robomaker:DescribeRobotApplication",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "robotApplication": "${application}"
                }
            }
        ],
        "RoboMaker.DescribeSimulationApplication": [
            {
                "action": "robomaker:DescribeSimulationApplication",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "simulationApplication": "%%iftemplatematch%${application}%%"
                }
            }
        ],
        "RoboMaker.DescribeSimulationJob": [
            {
                "action": "robomaker:DescribeSimulationJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "simulationJob": "${job}"
                }
            }
        ],
        "RoboMaker.DescribeSimulationJobBatch": [
            {
                "action": "robomaker:DescribeSimulationJobBatch",
                "resource_mappings": {
                    "SimulationJobBatchId": {
                        "template": "${batch}"
                    }
                }
            }
        ],
        "RoboMaker.DescribeWorld": [
            {
                "action": "robomaker:DescribeWorld",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "world": "${world}"
                }
            }
        ],
        "RoboMaker.DescribeWorldExportJob": [
            {
                "action": "robomaker:DescribeWorldExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "worldExportJob": "${job}"
                }
            }
        ],
        "RoboMaker.DescribeWorldGenerationJob": [
            {
                "action": "robomaker:DescribeWorldGenerationJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "worldGenerationJob": "${job}"
                }
            }
        ],
        "RoboMaker.DescribeWorldTemplate": [
            {
                "action": "robomaker:DescribeWorldTemplate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "worldTemplate": "${template}"
                }
            }
        ],
        "RoboMaker.GetWorldTemplateBody": [
            {
                "action": "robomaker:GetWorldTemplateBody",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "worldTemplate": "${template}"
                }
            }
        ],
        "RoboMaker.ListDeploymentJobs": [
            {
                "action": "robomaker:ListDeploymentJobs",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListFleets": [
            {
                "action": "robomaker:ListFleets",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListRobotApplications": [
            {
                "action": "robomaker:ListRobotApplications",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListRobots": [
            {
                "action": "robomaker:ListRobots",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListSimulationApplications": [
            {
                "action": "robomaker:ListSimulationApplications",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListSimulationJobBatches": [
            {
                "action": "robomaker:ListSimulationJobBatches",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListSimulationJobs": [
            {
                "action": "robomaker:ListSimulationJobs",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListTagsForResource": [
            {
                "action": "robomaker:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentFleet": "%%iftemplatematch%${resourceArn}%%",
                    "deploymentJob": "%%iftemplatematch%${resourceArn}%%",
                    "robot": "%%iftemplatematch%${resourceArn}%%",
                    "robotApplication": "%%iftemplatematch%${resourceArn}%%",
                    "simulationApplication": "%%iftemplatematch%${resourceArn}%%",
                    "simulationJob": "%%iftemplatematch%${resourceArn}%%",
                    "simulationJobBatch": "%%iftemplatematch%${resourceArn}%%",
                    "world": "%%iftemplatematch%${resourceArn}%%",
                    "worldExportJob": "%%iftemplatematch%${resourceArn}%%",
                    "worldGenerationJob": "%%iftemplatematch%${resourceArn}%%",
                    "worldTemplate": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "RoboMaker.ListWorldExportJobs": [
            {
                "action": "robomaker:ListWorldExportJobs",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListWorldGenerationJobs": [
            {
                "action": "robomaker:ListWorldGenerationJobs",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListWorldTemplates": [
            {
                "action": "robomaker:ListWorldTemplates",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.ListWorlds": [
            {
                "action": "robomaker:ListWorlds",
                "resource_mappings": {}
            }
        ],
        "RoboMaker.RegisterRobot": [
            {
                "action": "robomaker:RegisterRobot",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentFleet": "${fleet}",
                    "robot": "${robot}"
                }
            }
        ],
        "RoboMaker.RestartSimulationJob": [
            {
                "action": "robomaker:RestartSimulationJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "simulationJob": "${job}"
                }
            }
        ],
        "RoboMaker.StartSimulationJobBatch": [
            {
                "action": "robomaker:StartSimulationJobBatch",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "RoboMaker.SyncDeploymentJob": [
            {
                "action": "robomaker:SyncDeploymentJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentFleet": "%%iftemplatematch%${fleet}%%"
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "RoboMaker.TagResource": [
            {
                "action": "robomaker:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentFleet": "%%iftemplatematch%${resourceArn}%%",
                    "deploymentJob": "%%iftemplatematch%${resourceArn}%%",
                    "robot": "%%iftemplatematch%${resourceArn}%%",
                    "robotApplication": "%%iftemplatematch%${resourceArn}%%",
                    "simulationApplication": "%%iftemplatematch%${resourceArn}%%",
                    "simulationJob": "%%iftemplatematch%${resourceArn}%%",
                    "simulationJobBatch": "%%iftemplatematch%${resourceArn}%%",
                    "world": "%%iftemplatematch%${resourceArn}%%",
                    "worldExportJob": "%%iftemplatematch%${resourceArn}%%",
                    "worldGenerationJob": "%%iftemplatematch%${resourceArn}%%",
                    "worldTemplate": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "RoboMaker.UntagResource": [
            {
                "action": "robomaker:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "deploymentFleet": "%%iftemplatematch%${resourceArn}%%",
                    "deploymentJob": "%%iftemplatematch%${resourceArn}%%",
                    "robot": "%%iftemplatematch%${resourceArn}%%",
                    "robotApplication": "%%iftemplatematch%${resourceArn}%%",
                    "simulationApplication": "%%iftemplatematch%${resourceArn}%%",
                    "simulationJob": "%%iftemplatematch%${resourceArn}%%",
                    "simulationJobBatch": "%%iftemplatematch%${resourceArn}%%",
                    "world": "%%iftemplatematch%${resourceArn}%%",
                    "worldExportJob": "%%iftemplatematch%${resourceArn}%%",
                    "worldGenerationJob": "%%iftemplatematch%${resourceArn}%%",
                    "worldTemplate": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "RoboMaker.UpdateRobotApplication": [
            {
                "action": "robomaker:UpdateRobotApplication",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "robotApplication": "%%iftemplatematch%${application}%%"
                }
            }
        ],
        "RoboMaker.UpdateSimulationApplication": [
            {
                "action": "robomaker:UpdateSimulationApplication",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "simulationApplication": "%%iftemplatematch%${application}%%"
                }
            }
        ],
        "RoboMaker.UpdateWorldTemplate": [
            {
                "action": "robomaker:UpdateWorldTemplate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "worldTemplate": "${template}"
                }
            }
        ],
        "Transfer.CreateServer": [
            {
                "action": "transfer:CreateServer",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${IdentityProviderDetails.InvocationRole}%${LoggingRole}$$"
                }
            }
        ],
        "Transfer.CreateUser": [
            {
                "action": "transfer:CreateUser",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "Transfer.DeleteServer": [
            {
                "action": "transfer:DeleteServer",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            }
        ],
        "Transfer.DeleteSshPublicKey": [
            {
                "action": "transfer:DeleteSshPublicKey",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    },
                    "username": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "Transfer.DeleteUser": [
            {
                "action": "transfer:DeleteUser",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    },
                    "username": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "Transfer.DescribeSecurityPolicy": [
            {
                "action": "transfer:DescribeSecurityPolicy",
                "resource_mappings": {}
            }
        ],
        "Transfer.DescribeServer": [
            {
                "action": "transfer:DescribeServer",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            }
        ],
        "Transfer.DescribeUser": [
            {
                "action": "transfer:DescribeUser",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    },
                    "username": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "Transfer.ImportSshPublicKey": [
            {
                "action": "transfer:ImportSshPublicKey",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    },
                    "username": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "Transfer.ListSecurityPolicies": [
            {
                "action": "transfer:ListSecurityPolicies",
                "resource_mappings": {}
            }
        ],
        "Transfer.ListServers": [
            {
                "action": "transfer:ListServers",
                "resource_mappings": {}
            }
        ],
        "Transfer.ListTagsForResource": [
            {
                "action": "transfer:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "server": "%%iftemplatematch%${Arn}%%",
                    "user": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "Transfer.ListUsers": [
            {
                "action": "transfer:ListUsers",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            }
        ],
        "Transfer.StartServer": [
            {
                "action": "transfer:StartServer",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            }
        ],
        "Transfer.StopServer": [
            {
                "action": "transfer:StopServer",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            }
        ],
        "Transfer.TagResource": [
            {
                "action": "transfer:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "server": "%%iftemplatematch%${Arn}%%",
                    "user": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "Transfer.TestIdentityProvider": [
            {
                "action": "transfer:TestIdentityProvider",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    },
                    "username": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "Transfer.UntagResource": [
            {
                "action": "transfer:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "server": "%%iftemplatematch%${Arn}%%",
                    "user": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "Transfer.UpdateServer": [
            {
                "action": "transfer:UpdateServer",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${IdentityProviderDetails.InvocationRole}%${LoggingRole}$$"
                }
            }
        ],
        "Transfer.UpdateUser": [
            {
                "action": "transfer:UpdateUser",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    },
                    "username": {
                        "template": "${UserName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Role}"
                }
            }
        ],
        "GlobalAccelerator.AddCustomRoutingEndpoints": [
            {
                "action": "globalaccelerator:AddCustomRoutingEndpoints",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "endpointgroup": "${EndpointGroupArn}"
                }
            }
        ],
        "GlobalAccelerator.AdvertiseByoipCidr": [
            {
                "action": "globalaccelerator:AdvertiseByoipCidr",
                "resource_mappings": {}
            }
        ],
        "GlobalAccelerator.AllowCustomRoutingTraffic": [
            {
                "action": "globalaccelerator:AllowCustomRoutingTraffic",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "endpointgroup": "${EndpointGroupArn}"
                }
            }
        ],
        "GlobalAccelerator.CreateAccelerator": [
            {
                "action": "globalaccelerator:CreateAccelerator",
                "resource_mappings": {}
            }
        ],
        "GlobalAccelerator.CreateCustomRoutingAccelerator": [
            {
                "action": "globalaccelerator:CreateCustomRoutingAccelerator",
                "resource_mappings": {}
            }
        ],
        "GlobalAccelerator.CreateCustomRoutingEndpointGroup": [
            {
                "action": "globalaccelerator:CreateCustomRoutingEndpointGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.CreateCustomRoutingListener": [
            {
                "action": "globalaccelerator:CreateCustomRoutingListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.CreateEndpointGroup": [
            {
                "action": "globalaccelerator:CreateEndpointGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.CreateListener": [
            {
                "action": "globalaccelerator:CreateListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.DeleteAccelerator": [
            {
                "action": "globalaccelerator:DeleteAccelerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.DeleteCustomRoutingAccelerator": [
            {
                "action": "globalaccelerator:DeleteCustomRoutingAccelerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.DeleteCustomRoutingEndpointGroup": [
            {
                "action": "globalaccelerator:DeleteCustomRoutingEndpointGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "endpointgroup": "${EndpointGroupArn}"
                }
            }
        ],
        "GlobalAccelerator.DeleteCustomRoutingListener": [
            {
                "action": "globalaccelerator:DeleteCustomRoutingListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.DeleteEndpointGroup": [
            {
                "action": "globalaccelerator:DeleteEndpointGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "endpointgroup": "${EndpointGroupArn}"
                }
            }
        ],
        "GlobalAccelerator.DeleteListener": [
            {
                "action": "globalaccelerator:DeleteListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.DenyCustomRoutingTraffic": [
            {
                "action": "globalaccelerator:DenyCustomRoutingTraffic",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "endpointgroup": "${EndpointGroupArn}"
                }
            }
        ],
        "GlobalAccelerator.DeprovisionByoipCidr": [
            {
                "action": "globalaccelerator:DeprovisionByoipCidr",
                "resource_mappings": {}
            }
        ],
        "GlobalAccelerator.DescribeAccelerator": [
            {
                "action": "globalaccelerator:DescribeAccelerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.DescribeAcceleratorAttributes": [
            {
                "action": "globalaccelerator:DescribeAcceleratorAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.DescribeCustomRoutingAccelerator": [
            {
                "action": "globalaccelerator:DescribeCustomRoutingAccelerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.DescribeCustomRoutingAcceleratorAttributes": [
            {
                "action": "globalaccelerator:DescribeCustomRoutingAcceleratorAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.DescribeCustomRoutingEndpointGroup": [
            {
                "action": "globalaccelerator:DescribeCustomRoutingEndpointGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "endpointgroup": "${EndpointGroupArn}"
                }
            }
        ],
        "GlobalAccelerator.DescribeCustomRoutingListener": [
            {
                "action": "globalaccelerator:DescribeCustomRoutingListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.DescribeEndpointGroup": [
            {
                "action": "globalaccelerator:DescribeEndpointGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "endpointgroup": "${EndpointGroupArn}"
                }
            }
        ],
        "GlobalAccelerator.DescribeListener": [
            {
                "action": "globalaccelerator:DescribeListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.ListAccelerators": [
            {
                "action": "globalaccelerator:ListAccelerators",
                "resource_mappings": {}
            }
        ],
        "GlobalAccelerator.ListByoipCidrs": [
            {
                "action": "globalaccelerator:ListByoipCidrs",
                "resource_mappings": {}
            }
        ],
        "GlobalAccelerator.ListCustomRoutingAccelerators": [
            {
                "action": "globalaccelerator:ListCustomRoutingAccelerators",
                "resource_mappings": {}
            }
        ],
        "GlobalAccelerator.ListCustomRoutingEndpointGroups": [
            {
                "action": "globalaccelerator:ListCustomRoutingEndpointGroups",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.ListCustomRoutingListeners": [
            {
                "action": "globalaccelerator:ListCustomRoutingListeners",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.ListCustomRoutingPortMappings": [
            {
                "action": "globalaccelerator:ListCustomRoutingPortMappings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.ListCustomRoutingPortMappingsByDestination": [
            {
                "action": "globalaccelerator:ListCustomRoutingPortMappingsByDestination",
                "resource_mappings": {}
            }
        ],
        "GlobalAccelerator.ListEndpointGroups": [
            {
                "action": "globalaccelerator:ListEndpointGroups",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.ListListeners": [
            {
                "action": "globalaccelerator:ListListeners",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.ListTagsForResource": [
            {
                "action": "globalaccelerator:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "GlobalAccelerator.ProvisionByoipCidr": [
            {
                "action": "globalaccelerator:ProvisionByoipCidr",
                "resource_mappings": {}
            }
        ],
        "GlobalAccelerator.RemoveCustomRoutingEndpoints": [
            {
                "action": "globalaccelerator:RemoveCustomRoutingEndpoints",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "endpointgroup": "${EndpointGroupArn}"
                }
            }
        ],
        "GlobalAccelerator.TagResource": [
            {
                "action": "globalaccelerator:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "GlobalAccelerator.UntagResource": [
            {
                "action": "globalaccelerator:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "GlobalAccelerator.UpdateAccelerator": [
            {
                "action": "globalaccelerator:UpdateAccelerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.UpdateAcceleratorAttributes": [
            {
                "action": "globalaccelerator:UpdateAcceleratorAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.UpdateCustomRoutingAccelerator": [
            {
                "action": "globalaccelerator:UpdateCustomRoutingAccelerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.UpdateCustomRoutingAcceleratorAttributes": [
            {
                "action": "globalaccelerator:UpdateCustomRoutingAcceleratorAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "accelerator": "${AcceleratorArn}"
                }
            }
        ],
        "GlobalAccelerator.UpdateCustomRoutingListener": [
            {
                "action": "globalaccelerator:UpdateCustomRoutingListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.UpdateEndpointGroup": [
            {
                "action": "globalaccelerator:UpdateEndpointGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "endpointgroup": "${EndpointGroupArn}"
                }
            }
        ],
        "GlobalAccelerator.UpdateListener": [
            {
                "action": "globalaccelerator:UpdateListener",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "listener": "${ListenerArn}"
                }
            }
        ],
        "GlobalAccelerator.WithdrawByoipCidr": [
            {
                "action": "globalaccelerator:WithdrawByoipCidr",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.DetectEntities": [
            {
                "action": "comprehendmedical:DetectEntities",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.DetectPHI": [
            {
                "action": "comprehendmedical:DetectPHI",
                "resource_mappings": {}
            }
        ],
        "KinesisAnalyticsV2.AddApplicationCloudWatchLoggingOption": [
            {
                "action": "kinesisanalytics:AddApplicationCloudWatchLoggingOption",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.AddApplicationInput": [
            {
                "action": "kinesisanalytics:AddApplicationInput",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.AddApplicationInputProcessingConfiguration": [
            {
                "action": "kinesisanalytics:AddApplicationInputProcessingConfiguration",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.AddApplicationOutput": [
            {
                "action": "kinesisanalytics:AddApplicationOutput",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.AddApplicationReferenceDataSource": [
            {
                "action": "kinesisanalytics:AddApplicationReferenceDataSource",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ReferenceDataSource.S3ReferenceDataSource.ReferenceRoleARN}"
                }
            }
        ],
        "KinesisAnalyticsV2.AddApplicationVpcConfiguration": [
            {
                "action": "kinesisanalytics:AddApplicationVpcConfiguration",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.CreateApplication": [
            {
                "action": "kinesisanalytics:CreateApplication",
                "resource_mappings": {}
            }
        ],
        "KinesisAnalyticsV2.CreateApplicationSnapshot": [
            {
                "action": "kinesisanalytics:CreateApplicationSnapshot",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DeleteApplication": [
            {
                "action": "kinesisanalytics:DeleteApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DeleteApplicationCloudWatchLoggingOption": [
            {
                "action": "kinesisanalytics:DeleteApplicationCloudWatchLoggingOption",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DeleteApplicationInputProcessingConfiguration": [
            {
                "action": "kinesisanalytics:DeleteApplicationInputProcessingConfiguration",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DeleteApplicationOutput": [
            {
                "action": "kinesisanalytics:DeleteApplicationOutput",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DeleteApplicationReferenceDataSource": [
            {
                "action": "kinesisanalytics:DeleteApplicationReferenceDataSource",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DeleteApplicationSnapshot": [
            {
                "action": "kinesisanalytics:DeleteApplicationSnapshot",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DeleteApplicationVpcConfiguration": [
            {
                "action": "kinesisanalytics:DeleteApplicationVpcConfiguration",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DescribeApplication": [
            {
                "action": "kinesisanalytics:DescribeApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DescribeApplicationSnapshot": [
            {
                "action": "kinesisanalytics:DescribeApplicationSnapshot",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DiscoverInputSchema": [
            {
                "action": "kinesisanalytics:DiscoverInputSchema",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${RoleARN}%${S3Configuration.RoleARN}%${InputProcessingConfiguration.InputLambdaProcessor.RoleARN}%%"
                }
            }
        ],
        "KinesisAnalyticsV2.ListApplicationSnapshots": [
            {
                "action": "kinesisanalytics:ListApplicationSnapshots",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.ListApplications": [
            {
                "action": "kinesisanalytics:ListApplications",
                "resource_mappings": {}
            }
        ],
        "KinesisAnalyticsV2.ListTagsForResource": [
            {
                "action": "kinesisanalytics:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "KinesisAnalyticsV2.StartApplication": [
            {
                "action": "kinesisanalytics:StartApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.StopApplication": [
            {
                "action": "kinesisanalytics:StopApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.TagResource": [
            {
                "action": "kinesisanalytics:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "KinesisAnalyticsV2.UntagResource": [
            {
                "action": "kinesisanalytics:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "KinesisAnalyticsV2.UpdateApplication": [
            {
                "action": "kinesisanalytics:UpdateApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "MediaConnect.AddFlowOutputs": [
            {
                "action": "mediaconnect:AddFlowOutputs",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.CreateFlow": [
            {
                "action": "mediaconnect:CreateFlow",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Source.Decryption.RoleArn}"
                }
            }
        ],
        "MediaConnect.DeleteFlow": [
            {
                "action": "mediaconnect:DeleteFlow",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.DescribeFlow": [
            {
                "action": "mediaconnect:DescribeFlow",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.GrantFlowEntitlements": [
            {
                "action": "mediaconnect:GrantFlowEntitlements",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.ListEntitlements": [
            {
                "action": "mediaconnect:ListEntitlements",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.ListFlows": [
            {
                "action": "mediaconnect:ListFlows",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.RemoveFlowOutput": [
            {
                "action": "mediaconnect:RemoveFlowOutput",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.RevokeFlowEntitlement": [
            {
                "action": "mediaconnect:RevokeFlowEntitlement",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.StartFlow": [
            {
                "action": "mediaconnect:StartFlow",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.StopFlow": [
            {
                "action": "mediaconnect:StopFlow",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.UpdateFlowEntitlement": [
            {
                "action": "mediaconnect:UpdateFlowEntitlement",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Encryption.RoleArn}"
                }
            }
        ],
        "MediaConnect.UpdateFlowOutput": [
            {
                "action": "mediaconnect:UpdateFlowOutput",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Encryption.RoleArn}"
                }
            }
        ],
        "MediaConnect.UpdateFlowSource": [
            {
                "action": "mediaconnect:UpdateFlowSource",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Decryption.RoleArn}"
                }
            }
        ],
        "FSx.CancelDataRepositoryTask": [
            {
                "action": "fsx:CancelDataRepositoryTask",
                "resource_mappings": {
                    "TaskId": {
                        "template": "${TaskId}"
                    }
                }
            }
        ],
        "FSx.CreateBackup": [
            {
                "action": "fsx:CreateBackup",
                "resource_mappings": {}
            }
        ],
        "FSx.CreateDataRepositoryTask": [
            {
                "action": "fsx:CreateDataRepositoryTask",
                "resource_mappings": {}
            }
        ],
        "FSx.CreateFileSystem": [
            {
                "action": "fsx:CreateFileSystem",
                "resource_mappings": {}
            }
        ],
        "FSx.CreateFileSystemFromBackup": [
            {
                "action": "fsx:CreateFileSystemFromBackup",
                "resource_mappings": {}
            }
        ],
        "FSx.DeleteBackup": [
            {
                "action": "fsx:DeleteBackup",
                "resource_mappings": {}
            }
        ],
        "FSx.DeleteFileSystem": [
            {
                "action": "fsx:DeleteFileSystem",
                "resource_mappings": {}
            }
        ],
        "FSx.DescribeBackups": [
            {
                "action": "fsx:DescribeBackups",
                "resource_mappings": {}
            }
        ],
        "FSx.DescribeDataRepositoryTasks": [
            {
                "action": "fsx:DescribeDataRepositoryTasks",
                "resource_mappings": {}
            }
        ],
        "FSx.DescribeFileSystems": [
            {
                "action": "fsx:DescribeFileSystems",
                "resource_mappings": {}
            }
        ],
        "FSx.ListTagsForResource": [
            {
                "action": "fsx:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "FSx.TagResource": [
            {
                "action": "fsx:TagResource",
                "resource_mappings": {}
            }
        ],
        "FSx.UntagResource": [
            {
                "action": "fsx:UntagResource",
                "resource_mappings": {}
            }
        ],
        "FSx.UpdateFileSystem": [
            {
                "action": "fsx:UpdateFileSystem",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.AcceptInvitation": [
            {
                "action": "securityhub:AcceptInvitation",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.BatchDisableStandards": [
            {
                "action": "securityhub:BatchDisableStandards",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.BatchEnableStandards": [
            {
                "action": "securityhub:BatchEnableStandards",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.BatchImportFindings": [
            {
                "action": "securityhub:BatchImportFindings",
                "resource_mappings": {
                    "Company": {
                        "template": "*"
                    },
                    "ProductId": {
                        "template": "*"
                    }
                }
            }
        ],
        "SecurityHub.BatchUpdateFindings": [
            {
                "action": "securityhub:BatchUpdateFindings",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.CreateActionTarget": [
            {
                "action": "securityhub:CreateActionTarget",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.CreateInsight": [
            {
                "action": "securityhub:CreateInsight",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "SecurityHub.CreateMembers": [
            {
                "action": "securityhub:CreateMembers",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DeclineInvitations": [
            {
                "action": "securityhub:DeclineInvitations",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DeleteActionTarget": [
            {
                "action": "securityhub:DeleteActionTarget",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DeleteInsight": [
            {
                "action": "securityhub:DeleteInsight",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DeleteInvitations": [
            {
                "action": "securityhub:DeleteInvitations",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DeleteMembers": [
            {
                "action": "securityhub:DeleteMembers",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DescribeActionTargets": [
            {
                "action": "securityhub:DescribeActionTargets",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DescribeHub": [
            {
                "action": "securityhub:DescribeHub",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DescribeOrganizationConfiguration": [
            {
                "action": "securityhub:DescribeOrganizationConfiguration",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DescribeProducts": [
            {
                "action": "securityhub:DescribeProducts",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DescribeStandards": [
            {
                "action": "securityhub:DescribeStandards",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DescribeStandardsControls": [
            {
                "action": "securityhub:DescribeStandardsControls",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DisableImportFindingsForProduct": [
            {
                "action": "securityhub:DisableImportFindingsForProduct",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DisableOrganizationAdminAccount": [
            {
                "action": "securityhub:DisableOrganizationAdminAccount",
                "resource_mappings": {}
            },
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DisableSecurityHub": [
            {
                "action": "securityhub:DisableSecurityHub",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DisassociateFromMasterAccount": [
            {
                "action": "securityhub:DisassociateFromMasterAccount",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DisassociateMembers": [
            {
                "action": "securityhub:DisassociateMembers",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.EnableImportFindingsForProduct": [
            {
                "action": "securityhub:EnableImportFindingsForProduct",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.EnableOrganizationAdminAccount": [
            {
                "action": "securityhub:EnableOrganizationAdminAccount",
                "resource_mappings": {}
            },
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            },
            {
                "action": "organizations:EnableAWSServiceAccess",
                "resource_mappings": {}
            },
            {
                "action": "organizations:RegisterDelegatedAdministrator",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.EnableSecurityHub": [
            {
                "action": "securityhub:EnableSecurityHub",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.GetEnabledStandards": [
            {
                "action": "securityhub:GetEnabledStandards",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.GetFindings": [
            {
                "action": "securityhub:GetFindings",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.GetInsightResults": [
            {
                "action": "securityhub:GetInsightResults",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.GetInsights": [
            {
                "action": "securityhub:GetInsights",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.GetInvitationsCount": [
            {
                "action": "securityhub:GetInvitationsCount",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.GetMasterAccount": [
            {
                "action": "securityhub:GetMasterAccount",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.GetMembers": [
            {
                "action": "securityhub:GetMembers",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.InviteMembers": [
            {
                "action": "securityhub:InviteMembers",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.ListEnabledProductsForImport": [
            {
                "action": "securityhub:ListEnabledProductsForImport",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.ListInvitations": [
            {
                "action": "securityhub:ListInvitations",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.ListMembers": [
            {
                "action": "securityhub:ListMembers",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.ListOrganizationAdminAccounts": [
            {
                "action": "securityhub:ListOrganizationAdminAccounts",
                "resource_mappings": {}
            },
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.ListTagsForResource": [
            {
                "action": "securityhub:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.TagResource": [
            {
                "action": "securityhub:TagResource",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.UntagResource": [
            {
                "action": "securityhub:UntagResource",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.UpdateActionTarget": [
            {
                "action": "securityhub:UpdateActionTarget",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.UpdateFindings": [
            {
                "action": "securityhub:UpdateFindings",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "SecurityHub.UpdateInsight": [
            {
                "action": "securityhub:UpdateInsight",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "SecurityHub.UpdateOrganizationConfiguration": [
            {
                "action": "securityhub:UpdateOrganizationConfiguration",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.UpdateSecurityHubConfiguration": [
            {
                "action": "securityhub:UpdateSecurityHubConfiguration",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.UpdateStandardsControl": [
            {
                "action": "securityhub:UpdateStandardsControl",
                "resource_mappings": {}
            }
        ],
        "AppMesh.CreateGatewayRoute": [
            {
                "action": "appmesh:CreateGatewayRoute",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualGatewayName": {
                        "template": "${virtualGatewayName}"
                    },
                    "GatewayRouteName": {
                        "template": "${gatewayRouteName}"
                    },
                    "VirtualServiceName": {
                        "template": "%%many%${spec.grpcRoute.action.target.virtualService.virtualServiceName}%${spec.http2Route.action.target.virtualService.virtualServiceName}%${spec.httpRoute.action.target.virtualService.virtualServiceName}%%"
                    }
                }
            }
        ],
        "AppMesh.CreateMesh": [
            {
                "action": "appmesh:CreateMesh",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    }
                }
            }
        ],
        "AppMesh.CreateRoute": [
            {
                "action": "appmesh:CreateRoute",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualRouterName": {
                        "template": "${virtualRouterName}"
                    },
                    "RouteName": {
                        "template": "${routeName}"
                    },
                    "VirtualNodeName": {
                        "template": "%%many%${spec.grpcRoute.action.weightedTargets[].virtualNode}%${spec.http2Route.action.weightedTargets[].virtualNode}%${spec.httpRoute.action.weightedTargets[].virtualNode}%${spec.tcpRoute.action.weightedTargets[].virtualNode}%%"
                    }
                }
            }
        ],
        "AppMesh.CreateVirtualGateway": [
            {
                "action": "appmesh:CreateVirtualGateway",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualGatewayName": {
                        "template": "${virtualGatewayName}"
                    }
                }
            }
        ],
        "AppMesh.CreateVirtualNode": [
            {
                "action": "appmesh:CreateVirtualNode",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualNodeName": {
                        "template": "${virtualNodeName}"
                    },
                    "VirtualServiceName": {
                        "template": "${spec.backends[].virtualService.virtualServiceName}"
                    }
                }
            }
        ],
        "AppMesh.CreateVirtualRouter": [
            {
                "action": "appmesh:CreateVirtualRouter",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualRouterName": {
                        "template": "${virtualRouterName}"
                    }
                }
            }
        ],
        "AppMesh.CreateVirtualService": [
            {
                "action": "appmesh:CreateVirtualService",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualServiceName": {
                        "template": "${virtualServiceName}"
                    },
                    "VirtualNodeName": {
                        "template": "${spec.provider.virtualNode.virtualNodeName}"
                    },
                    "VirtualRouterName": {
                        "template": "${spec.provider.virtualRouter.virtualRouterName}"
                    }
                }
            }
        ],
        "AppMesh.DeleteGatewayRoute": [
            {
                "action": "appmesh:DeleteGatewayRoute",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualGatewayName": {
                        "template": "${virtualGatewayName}"
                    },
                    "GatewayRouteName": {
                        "template": "${gatewayRouteName}"
                    }
                }
            }
        ],
        "AppMesh.DeleteMesh": [
            {
                "action": "appmesh:DeleteMesh",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    }
                }
            }
        ],
        "AppMesh.DeleteRoute": [
            {
                "action": "appmesh:DeleteRoute",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualRouterName": {
                        "template": "${virtualRouterName}"
                    },
                    "RouteName": {
                        "template": "${routeName}"
                    }
                }
            }
        ],
        "AppMesh.DeleteVirtualGateway": [
            {
                "action": "appmesh:DeleteVirtualGateway",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualGatewayName": {
                        "template": "${virtualGatewayName}"
                    }
                }
            }
        ],
        "AppMesh.DeleteVirtualNode": [
            {
                "action": "appmesh:DeleteVirtualNode",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualNodeName": {
                        "template": "${virtualNodeName}"
                    }
                }
            }
        ],
        "AppMesh.DeleteVirtualRouter": [
            {
                "action": "appmesh:DeleteVirtualRouter",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualRouterName": {
                        "template": "${virtualRouterName}"
                    }
                }
            }
        ],
        "AppMesh.DeleteVirtualService": [
            {
                "action": "appmesh:DeleteVirtualService",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualServiceName": {
                        "template": "${virtualServiceName}"
                    }
                }
            }
        ],
        "AppMesh.DescribeGatewayRoute": [
            {
                "action": "appmesh:DescribeGatewayRoute",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualGatewayName": {
                        "template": "${virtualGatewayName}"
                    },
                    "GatewayRouteName": {
                        "template": "${gatewayRouteName}"
                    }
                }
            }
        ],
        "AppMesh.DescribeMesh": [
            {
                "action": "appmesh:DescribeMesh",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    }
                }
            }
        ],
        "AppMesh.DescribeRoute": [
            {
                "action": "appmesh:DescribeRoute",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualRouterName": {
                        "template": "${virtualRouterName}"
                    },
                    "RouteName": {
                        "template": "${routeName}"
                    }
                }
            }
        ],
        "AppMesh.DescribeVirtualGateway": [
            {
                "action": "appmesh:DescribeVirtualGateway",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualGatewayName": {
                        "template": "${virtualGatewayName}"
                    }
                }
            }
        ],
        "AppMesh.DescribeVirtualNode": [
            {
                "action": "appmesh:DescribeVirtualNode",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualNodeName": {
                        "template": "${virtualNodeName}"
                    }
                }
            }
        ],
        "AppMesh.DescribeVirtualRouter": [
            {
                "action": "appmesh:DescribeVirtualRouter",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualRouterName": {
                        "template": "${virtualRouterName}"
                    }
                }
            }
        ],
        "AppMesh.DescribeVirtualService": [
            {
                "action": "appmesh:DescribeVirtualService",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualServiceName": {
                        "template": "${virtualServiceName}"
                    }
                }
            }
        ],
        "AppMesh.ListGatewayRoutes": [
            {
                "action": "appmesh:ListGatewayRoutes",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualGatewayName": {
                        "template": "${virtualGatewayName}"
                    }
                }
            }
        ],
        "AppMesh.ListMeshes": [
            {
                "action": "appmesh:ListMeshes",
                "resource_mappings": {}
            }
        ],
        "AppMesh.ListRoutes": [
            {
                "action": "appmesh:ListRoutes",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualRouterName": {
                        "template": "${virtualRouterName}"
                    }
                }
            }
        ],
        "AppMesh.ListTagsForResource": [
            {
                "action": "appmesh:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gatewayRoute": "%%iftemplatematch%${resourceArn}%%",
                    "mesh": "%%iftemplatematch%${resourceArn}%%",
                    "route": "%%iftemplatematch%${resourceArn}%%",
                    "virtualGateway": "%%iftemplatematch%${resourceArn}%%",
                    "virtualNode": "%%iftemplatematch%${resourceArn}%%",
                    "virtualRouter": "%%iftemplatematch%${resourceArn}%%",
                    "virtualService": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AppMesh.ListVirtualGateways": [
            {
                "action": "appmesh:ListVirtualGateways",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    }
                }
            }
        ],
        "AppMesh.ListVirtualNodes": [
            {
                "action": "appmesh:ListVirtualNodes",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    }
                }
            }
        ],
        "AppMesh.ListVirtualRouters": [
            {
                "action": "appmesh:ListVirtualRouters",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    }
                }
            }
        ],
        "AppMesh.ListVirtualServices": [
            {
                "action": "appmesh:ListVirtualServices",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    }
                }
            }
        ],
        "AppMesh.TagResource": [
            {
                "action": "appmesh:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gatewayRoute": "%%iftemplatematch%${resourceArn}%%",
                    "mesh": "%%iftemplatematch%${resourceArn}%%",
                    "route": "%%iftemplatematch%${resourceArn}%%",
                    "virtualGateway": "%%iftemplatematch%${resourceArn}%%",
                    "virtualNode": "%%iftemplatematch%${resourceArn}%%",
                    "virtualRouter": "%%iftemplatematch%${resourceArn}%%",
                    "virtualService": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AppMesh.UntagResource": [
            {
                "action": "appmesh:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gatewayRoute": "%%iftemplatematch%${resourceArn}%%",
                    "mesh": "%%iftemplatematch%${resourceArn}%%",
                    "route": "%%iftemplatematch%${resourceArn}%%",
                    "virtualGateway": "%%iftemplatematch%${resourceArn}%%",
                    "virtualNode": "%%iftemplatematch%${resourceArn}%%",
                    "virtualRouter": "%%iftemplatematch%${resourceArn}%%",
                    "virtualService": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AppMesh.UpdateGatewayRoute": [
            {
                "action": "appmesh:UpdateGatewayRoute",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualGatewayName": {
                        "template": "${virtualGatewayName}"
                    },
                    "GatewayRouteName": {
                        "template": "${gatewayRouteName}"
                    },
                    "VirtualServiceName": {
                        "template": "%%many%${spec.grpcRoute.action.target.virtualService.virtualServiceName}%${spec.http2Route.action.target.virtualService.virtualServiceName}%${spec.httpRoute.action.target.virtualService.virtualServiceName}%%"
                    }
                }
            }
        ],
        "AppMesh.UpdateMesh": [
            {
                "action": "appmesh:UpdateMesh",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    }
                }
            }
        ],
        "AppMesh.UpdateRoute": [
            {
                "action": "appmesh:UpdateRoute",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualRouterName": {
                        "template": "${virtualRouterName}"
                    },
                    "RouteName": {
                        "template": "${routeName}"
                    },
                    "VirtualNodeName": {
                        "template": "%%many%${spec.grpcRoute.action.weightedTargets[].virtualNode}%${spec.http2Route.action.weightedTargets[].virtualNode}%${spec.httpRoute.action.weightedTargets[].virtualNode}%${spec.tcpRoute.action.weightedTargets[].virtualNode}%%"
                    }
                }
            }
        ],
        "AppMesh.UpdateVirtualGateway": [
            {
                "action": "appmesh:UpdateVirtualGateway",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualGatewayName": {
                        "template": "${virtualGatewayName}"
                    }
                }
            }
        ],
        "AppMesh.UpdateVirtualNode": [
            {
                "action": "appmesh:UpdateVirtualNode",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualNodeName": {
                        "template": "${virtualNodeName}"
                    }
                }
            }
        ],
        "AppMesh.UpdateVirtualRouter": [
            {
                "action": "appmesh:UpdateVirtualRouter",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualRouterName": {
                        "template": "${virtualRouterName}"
                    }
                }
            }
        ],
        "AppMesh.UpdateVirtualService": [
            {
                "action": "appmesh:UpdateVirtualService",
                "resource_mappings": {
                    "MeshName": {
                        "template": "${meshName}"
                    },
                    "VirtualNodeName": {
                        "template": "${spec.provider.virtualNode.virtualNodeName}"
                    },
                    "VirtualRouterName": {
                        "template": "${spec.provider.virtualRouter.virtualRouterName}"
                    }
                }
            }
        ],
        "LicenseManager.AcceptGrant": [
            {
                "action": "license-manager:AcceptGrant",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "grant": "${GrantArn}"
                }
            }
        ],
        "LicenseManager.CheckInLicense": [
            {
                "action": "license-manager:CheckInLicense",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.CheckoutBorrowLicense": [
            {
                "action": "license-manager:CheckoutBorrowLicense",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license": "${LicenseArn}"
                }
            }
        ],
        "LicenseManager.CheckoutLicense": [
            {
                "action": "license-manager:CheckoutLicense",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.CreateGrant": [
            {
                "action": "license-manager:CreateGrant",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license": "${LicenseArn}"
                }
            }
        ],
        "LicenseManager.CreateGrantVersion": [
            {
                "action": "license-manager:CreateGrantVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "grant": "${GrantArn}"
                }
            }
        ],
        "LicenseManager.CreateLicense": [
            {
                "action": "license-manager:CreateLicense",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.CreateLicenseConfiguration": [
            {
                "action": "license-manager:CreateLicenseConfiguration",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.CreateLicenseVersion": [
            {
                "action": "license-manager:CreateLicenseVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license": "${LicenseArn}"
                }
            }
        ],
        "LicenseManager.CreateToken": [
            {
                "action": "license-manager:CreateToken",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license": "${LicenseArn}"
                }
            }
        ],
        "LicenseManager.DeleteGrant": [
            {
                "action": "license-manager:DeleteGrant",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "grant": "${GrantArn}"
                }
            }
        ],
        "LicenseManager.DeleteLicense": [
            {
                "action": "license-manager:DeleteLicense",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license": "${LicenseArn}"
                }
            }
        ],
        "LicenseManager.DeleteLicenseConfiguration": [
            {
                "action": "license-manager:DeleteLicenseConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "${LicenseConfigurationArn}"
                }
            }
        ],
        "LicenseManager.DeleteToken": [
            {
                "action": "license-manager:DeleteToken",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ExtendLicenseConsumption": [
            {
                "action": "license-manager:ExtendLicenseConsumption",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.GetAccessToken": [
            {
                "action": "license-manager:GetAccessToken",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.GetGrant": [
            {
                "action": "license-manager:GetGrant",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "grant": "${GrantArn}"
                }
            }
        ],
        "LicenseManager.GetLicense": [
            {
                "action": "license-manager:GetLicense",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license": "${LicenseArn}"
                }
            }
        ],
        "LicenseManager.GetLicenseConfiguration": [
            {
                "action": "license-manager:GetLicenseConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "${LicenseConfigurationArn}"
                }
            }
        ],
        "LicenseManager.GetLicenseUsage": [
            {
                "action": "license-manager:GetLicenseUsage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license": "${LicenseArn}"
                }
            }
        ],
        "LicenseManager.GetServiceSettings": [
            {
                "action": "license-manager:GetServiceSettings",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListAssociationsForLicenseConfiguration": [
            {
                "action": "license-manager:ListAssociationsForLicenseConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "${LicenseConfigurationArn}"
                }
            }
        ],
        "LicenseManager.ListDistributedGrants": [
            {
                "action": "license-manager:ListDistributedGrants",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListFailuresForLicenseConfigurationOperations": [
            {
                "action": "license-manager:ListFailuresForLicenseConfigurationOperations",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "${LicenseConfigurationArn}"
                }
            }
        ],
        "LicenseManager.ListLicenseConfigurations": [
            {
                "action": "license-manager:ListLicenseConfigurations",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListLicenseSpecificationsForResource": [
            {
                "action": "license-manager:ListLicenseSpecificationsForResource",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListLicenseVersions": [
            {
                "action": "license-manager:ListLicenseVersions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license": "${LicenseArn}"
                }
            }
        ],
        "LicenseManager.ListLicenses": [
            {
                "action": "license-manager:ListLicenses",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListReceivedGrants": [
            {
                "action": "license-manager:ListReceivedGrants",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListReceivedLicenses": [
            {
                "action": "license-manager:ListReceivedLicenses",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListResourceInventory": [
            {
                "action": "license-manager:ListResourceInventory",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListTagsForResource": [
            {
                "action": "license-manager:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LicenseManager.ListTokens": [
            {
                "action": "license-manager:ListTokens",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListUsageForLicenseConfiguration": [
            {
                "action": "license-manager:ListUsageForLicenseConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "${LicenseConfigurationArn}"
                }
            }
        ],
        "LicenseManager.RejectGrant": [
            {
                "action": "license-manager:RejectGrant",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "grant": "${GrantArn}"
                }
            }
        ],
        "LicenseManager.TagResource": [
            {
                "action": "license-manager:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LicenseManager.UntagResource": [
            {
                "action": "license-manager:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LicenseManager.UpdateLicenseConfiguration": [
            {
                "action": "license-manager:UpdateLicenseConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "${LicenseConfigurationArn}"
                }
            }
        ],
        "LicenseManager.UpdateLicenseSpecificationsForResource": [
            {
                "action": "license-manager:UpdateLicenseSpecificationsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "license-configuration": "%%many%${AddLicenseSpecifications[].LicenseConfigurationArn}%${RemoveLicenseSpecifications[].LicenseConfigurationArn}%%"
                }
            }
        ],
        "LicenseManager.UpdateServiceSettings": [
            {
                "action": "license-manager:UpdateServiceSettings",
                "resource_mappings": {}
            }
        ],
        "Kafka.BatchAssociateScramSecret": [
            {
                "action": "kafka:BatchAssociateScramSecret",
                "resource_mappings": {}
            }
        ],
        "Kafka.CreateCluster": [
            {
                "action": "kafka:CreateCluster",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            }
        ],
        "Kafka.CreateConfiguration": [
            {
                "action": "kafka:CreateConfiguration",
                "resource_mappings": {}
            }
        ],
        "Kafka.DeleteCluster": [
            {
                "action": "kafka:DeleteCluster",
                "resource_mappings": {}
            }
        ],
        "Kafka.DeleteConfiguration": [
            {
                "action": "kafka:DeleteConfiguration",
                "resource_mappings": {}
            }
        ],
        "Kafka.DescribeCluster": [
            {
                "action": "kafka:DescribeCluster",
                "resource_mappings": {}
            }
        ],
        "Kafka.DescribeClusterOperation": [
            {
                "action": "kafka:DescribeClusterOperation",
                "resource_mappings": {}
            }
        ],
        "Kafka.DescribeConfiguration": [
            {
                "action": "kafka:DescribeConfiguration",
                "resource_mappings": {}
            }
        ],
        "Kafka.DescribeConfigurationRevision": [
            {
                "action": "kafka:DescribeConfigurationRevision",
                "resource_mappings": {}
            }
        ],
        "Kafka.BatchDisassociateScramSecret": [
            {
                "action": "kafka:BatchDisassociateScramSecret",
                "resource_mappings": {}
            },
            {
                "action": "kms:RetireGrant",
                "resource_mappings": {
                    "KeyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Kafka.GetBootstrapBrokers": [
            {
                "action": "kafka:GetBootstrapBrokers",
                "resource_mappings": {}
            }
        ],
        "Kafka.GetCompatibleKafkaVersions": [
            {
                "action": "kafka:GetCompatibleKafkaVersions",
                "resource_mappings": {}
            }
        ],
        "Kafka.ListClusterOperations": [
            {
                "action": "kafka:ListClusterOperations",
                "resource_mappings": {}
            }
        ],
        "Kafka.ListClusters": [
            {
                "action": "kafka:ListClusters",
                "resource_mappings": {}
            }
        ],
        "Kafka.ListConfigurationRevisions": [
            {
                "action": "kafka:ListConfigurationRevisions",
                "resource_mappings": {}
            }
        ],
        "Kafka.ListConfigurations": [
            {
                "action": "kafka:ListConfigurations",
                "resource_mappings": {}
            }
        ],
        "Kafka.ListKafkaVersions": [
            {
                "action": "kafka:ListKafkaVersions",
                "resource_mappings": {}
            }
        ],
        "Kafka.ListNodes": [
            {
                "action": "kafka:ListNodes",
                "resource_mappings": {}
            }
        ],
        "Kafka.ListScramSecrets": [
            {
                "action": "kafka:ListScramSecrets",
                "resource_mappings": {}
            }
        ],
        "Kafka.ListTagsForResource": [
            {
                "action": "kafka:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Kafka.RebootBroker": [
            {
                "action": "kafka:RebootBroker",
                "resource_mappings": {}
            }
        ],
        "Kafka.TagResource": [
            {
                "action": "kafka:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Kafka.UntagResource": [
            {
                "action": "kafka:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Kafka.UpdateBrokerCount": [
            {
                "action": "kafka:UpdateBrokerCount",
                "resource_mappings": {}
            }
        ],
        "Kafka.UpdateBrokerStorage": [
            {
                "action": "kafka:UpdateBrokerStorage",
                "resource_mappings": {}
            }
        ],
        "Kafka.UpdateConfiguration": [
            {
                "action": "kafka:UpdateConfiguration",
                "resource_mappings": {}
            }
        ],
        "Kafka.UpdateClusterConfiguration": [
            {
                "action": "kafka:UpdateClusterConfiguration",
                "resource_mappings": {}
            }
        ],
        "Kafka.UpdateClusterKafkaVersion": [
            {
                "action": "kafka:UpdateClusterKafkaVersion",
                "resource_mappings": {}
            }
        ],
        "Kafka.UpdateMonitoring": [
            {
                "action": "kafka:UpdateMonitoring",
                "resource_mappings": {}
            }
        ],
        "DocDB.AddTagsToResource": [
            {
                "action": "rds:AddTagsToResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "%%iftemplatematch%${ResourceName}%%",
                    "es": "%%iftemplatematch%${ResourceName}%%",
                    "og": "%%iftemplatematch%${ResourceName}%%",
                    "pg": "%%iftemplatematch%${ResourceName}%%",
                    "proxy": "%%iftemplatematch%${ResourceName}%%",
                    "ri": "%%iftemplatematch%${ResourceName}%%",
                    "secgrp": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "subgrp": "%%iftemplatematch%${ResourceName}%%",
                    "target-group": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "DocDB.ApplyPendingMaintenanceAction": [
            {
                "action": "rds:ApplyPendingMaintenanceAction",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceIdentifier}%%",
                    "db": "%%iftemplatematch%${ResourceIdentifier}%%"
                }
            }
        ],
        "DocDB.CopyDBClusterParameterGroup": [
            {
                "action": "rds:CopyDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "%%many%${SourceDBClusterParameterGroupIdentifier}%${TargetDBClusterParameterGroupIdentifier}%%"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "DocDB.CopyDBClusterSnapshot": [
            {
                "action": "rds:CopyDBClusterSnapshot",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "%%many%${SourceDBClusterSnapshotIdentifier}%${TargetDBClusterSnapshotIdentifier}%%"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "DocDB.CreateDBCluster": [
            {
                "action": "rds:CreateDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    },
                    "OptionGroupName": {
                        "template": "%%regex%%/.*/g%%"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "DocDB.CreateDBClusterParameterGroup": [
            {
                "action": "rds:CreateDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "DocDB.CreateDBClusterSnapshot": [
            {
                "action": "rds:CreateDBClusterSnapshot",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "DocDB.CreateDBInstance": [
            {
                "action": "rds:CreateDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    },
                    "OptionGroupName": {
                        "template": "%%regex%%/.*/g%%"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "SecurityGroupName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "DocDB.CreateDBSubnetGroup": [
            {
                "action": "rds:CreateDBSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "DocDB.DeleteDBCluster": [
            {
                "action": "rds:DeleteDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterSnapshotName": {
                        "template": "${FinalDBSnapshotIdentifier}"
                    }
                }
            }
        ],
        "DocDB.DeleteDBClusterParameterGroup": [
            {
                "action": "rds:DeleteDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "DocDB.DeleteDBClusterSnapshot": [
            {
                "action": "rds:DeleteDBClusterSnapshot",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "DocDB.DeleteDBInstance": [
            {
                "action": "rds:DeleteDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "DocDB.DeleteDBSubnetGroup": [
            {
                "action": "rds:DeleteDBSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "DocDB.DescribeCertificates": [
            {
                "action": "rds:DescribeCertificates",
                "resource_mappings": {}
            }
        ],
        "DocDB.DescribeDBClusterParameterGroups": [
            {
                "action": "rds:DescribeDBClusterParameterGroups",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "DocDB.DescribeDBClusterParameters": [
            {
                "action": "rds:DescribeDBClusterParameters",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "DocDB.DescribeDBClusterSnapshotAttributes": [
            {
                "action": "rds:DescribeDBClusterSnapshotAttributes",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "DocDB.DescribeDBClusterSnapshots": [
            {
                "action": "rds:DescribeDBClusterSnapshots",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "DocDB.DescribeDBClusters": [
            {
                "action": "rds:DescribeDBClusters",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "DocDB.DescribeDBEngineVersions": [
            {
                "action": "rds:DescribeDBEngineVersions",
                "resource_mappings": {}
            }
        ],
        "DocDB.DescribeDBInstances": [
            {
                "action": "rds:DescribeDBInstances",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "DocDB.DescribeDBSubnetGroups": [
            {
                "action": "rds:DescribeDBSubnetGroups",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "DocDB.DescribeEngineDefaultClusterParameters": [
            {
                "action": "rds:DescribeEngineDefaultClusterParameters",
                "resource_mappings": {}
            }
        ],
        "DocDB.DescribeEventCategories": [
            {
                "action": "rds:DescribeEventCategories",
                "resource_mappings": {}
            }
        ],
        "DocDB.DescribeEvents": [
            {
                "action": "rds:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "DocDB.DescribeOrderableDBInstanceOptions": [
            {
                "action": "rds:DescribeOrderableDBInstanceOptions",
                "resource_mappings": {}
            }
        ],
        "DocDB.DescribePendingMaintenanceActions": [
            {
                "action": "rds:DescribePendingMaintenanceActions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceIdentifier}%%",
                    "db": "%%iftemplatematch%${ResourceIdentifier}%%"
                }
            }
        ],
        "DocDB.FailoverDBCluster": [
            {
                "action": "rds:FailoverDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "DocDB.ListTagsForResource": [
            {
                "action": "rds:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "%%iftemplatematch%${ResourceName}%%",
                    "es": "%%iftemplatematch%${ResourceName}%%",
                    "og": "%%iftemplatematch%${ResourceName}%%",
                    "pg": "%%iftemplatematch%${ResourceName}%%",
                    "proxy": "%%iftemplatematch%${ResourceName}%%",
                    "ri": "%%iftemplatematch%${ResourceName}%%",
                    "secgrp": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "subgrp": "%%iftemplatematch%${ResourceName}%%",
                    "target-group": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "DocDB.ModifyDBCluster": [
            {
                "action": "rds:ModifyDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "%%many%${DBClusterIdentifier}%${NewDBClusterIdentifier}%%"
                    },
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    },
                    "OptionGroupName": {
                        "template": "%%regex%%/.*/g%%"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "DocDB.ModifyDBClusterParameterGroup": [
            {
                "action": "rds:ModifyDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "DocDB.ModifyDBClusterSnapshotAttribute": [
            {
                "action": "rds:ModifyDBClusterSnapshotAttribute",
                "resource_mappings": {
                    "ClusterSnapshotName": {
                        "template": "${DBClusterSnapshotIdentifier}"
                    }
                }
            }
        ],
        "DocDB.ModifyDBInstance": [
            {
                "action": "rds:ModifyDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "%%many%${DBInstanceIdentifier}%${NewDBInstanceIdentifier}%%"
                    },
                    "OptionGroupName": {
                        "template": "%%regex%%/.*/g%%"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "SecurityGroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "DocDB.ModifyDBSubnetGroup": [
            {
                "action": "rds:ModifyDBSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            }
        ],
        "DocDB.RebootDBInstance": [
            {
                "action": "rds:RebootDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "${DBInstanceIdentifier}"
                    }
                }
            }
        ],
        "DocDB.RemoveTagsFromResource": [
            {
                "action": "rds:RemoveTagsFromResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "%%iftemplatematch%${ResourceName}%%",
                    "es": "%%iftemplatematch%${ResourceName}%%",
                    "og": "%%iftemplatematch%${ResourceName}%%",
                    "pg": "%%iftemplatematch%${ResourceName}%%",
                    "proxy": "%%iftemplatematch%${ResourceName}%%",
                    "ri": "%%iftemplatematch%${ResourceName}%%",
                    "secgrp": "%%iftemplatematch%${ResourceName}%%",
                    "snapshot": "%%iftemplatematch%${ResourceName}%%",
                    "subgrp": "%%iftemplatematch%${ResourceName}%%",
                    "target-group": "%%iftemplatematch%${ResourceName}%%"
                }
            }
        ],
        "DocDB.ResetDBClusterParameterGroup": [
            {
                "action": "rds:ResetDBClusterParameterGroup",
                "resource_mappings": {
                    "ClusterParameterGroupName": {
                        "template": "${DBClusterParameterGroupName}"
                    }
                }
            }
        ],
        "DocDB.RestoreDBClusterFromSnapshot": [
            {
                "action": "rds:RestoreDBClusterFromSnapshot",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    },
                    "ClusterSnapshotName": {
                        "template": "${SnapshotIdentifier}"
                    },
                    "OptionGroupName": {
                        "template": "%%regex%%/.*/g%%"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "DocDB.RestoreDBClusterToPointInTime": [
            {
                "action": "rds:RestoreDBClusterToPointInTime",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "%%many%${DBClusterIdentifier}%${SourceDBClusterIdentifier}%%"
                    },
                    "OptionGroupName": {
                        "template": "%%regex%%/.*/g%%"
                    },
                    "SubnetGroupName": {
                        "template": "${DBSubnetGroupName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "DocDB.StartDBCluster": [
            {
                "action": "rds:StartDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "DocDB.StopDBCluster": [
            {
                "action": "rds:StopDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            }
        ],
        "Backup.CreateBackupPlan": [
            {
                "action": "backup:CreateBackupPlan",
                "resource_mappings": {
                    "BackupPlanId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.CreateBackupSelection": [
            {
                "action": "backup:CreateBackupSelection",
                "resource_mappings": {
                    "BackupPlanId": {
                        "template": "${BackupPlanId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${BackupSelection.IamRoleArn}"
                }
            }
        ],
        "Backup.CreateBackupVault": [
            {
                "action": "backup:CreateBackupVault",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.DeleteBackupPlan": [
            {
                "action": "backup:DeleteBackupPlan",
                "resource_mappings": {
                    "BackupPlanId": {
                        "template": "${BackupPlanId}"
                    }
                }
            }
        ],
        "Backup.DeleteBackupSelection": [
            {
                "action": "backup:DeleteBackupSelection",
                "resource_mappings": {
                    "BackupPlanId": {
                        "template": "${BackupPlanId}"
                    }
                }
            }
        ],
        "Backup.DeleteBackupVault": [
            {
                "action": "backup:DeleteBackupVault",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.DeleteBackupVaultAccessPolicy": [
            {
                "action": "backup:DeleteBackupVaultAccessPolicy",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.DeleteBackupVaultNotifications": [
            {
                "action": "backup:DeleteBackupVaultNotifications",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.DeleteRecoveryPoint": [
            {
                "action": "backup:DeleteRecoveryPoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recoveryPoint": "${RecoveryPointArn}"
                }
            }
        ],
        "Backup.DescribeBackupJob": [
            {
                "action": "backup:DescribeBackupJob",
                "resource_mappings": {}
            }
        ],
        "Backup.DescribeBackupVault": [
            {
                "action": "backup:DescribeBackupVault",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.DescribeCopyJob": [
            {
                "action": "backup:DescribeCopyJob",
                "resource_mappings": {}
            }
        ],
        "Backup.DescribeGlobalSettings": [
            {
                "action": "backup:DescribeGlobalSettings",
                "resource_mappings": {}
            }
        ],
        "Backup.DescribeProtectedResource": [
            {
                "action": "backup:DescribeProtectedResource",
                "resource_mappings": {}
            }
        ],
        "Backup.DescribeRecoveryPoint": [
            {
                "action": "backup:DescribeRecoveryPoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recoveryPoint": "${RecoveryPointArn}"
                }
            }
        ],
        "Backup.DescribeRegionSettings": [
            {
                "action": "backup:DescribeRegionSettings",
                "resource_mappings": {}
            }
        ],
        "Backup.DescribeRestoreJob": [
            {
                "action": "backup:DescribeRestoreJob",
                "resource_mappings": {}
            }
        ],
        "Backup.ExportBackupPlanTemplate": [
            {
                "action": "backup:ExportBackupPlanTemplate",
                "resource_mappings": {}
            }
        ],
        "Backup.GetBackupPlan": [
            {
                "action": "backup:GetBackupPlan",
                "resource_mappings": {
                    "BackupPlanId": {
                        "template": "${BackupPlanId}"
                    }
                }
            }
        ],
        "Backup.GetBackupPlanFromJSON": [
            {
                "action": "backup:GetBackupPlanFromJSON",
                "resource_mappings": {}
            }
        ],
        "Backup.GetBackupPlanFromTemplate": [
            {
                "action": "backup:GetBackupPlanFromTemplate",
                "resource_mappings": {}
            }
        ],
        "Backup.GetBackupSelection": [
            {
                "action": "backup:GetBackupSelection",
                "resource_mappings": {
                    "BackupPlanId": {
                        "template": "${BackupPlanId}"
                    }
                }
            }
        ],
        "Backup.GetBackupVaultAccessPolicy": [
            {
                "action": "backup:GetBackupVaultAccessPolicy",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.GetBackupVaultNotifications": [
            {
                "action": "backup:GetBackupVaultNotifications",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.GetRecoveryPointRestoreMetadata": [
            {
                "action": "backup:GetRecoveryPointRestoreMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recoveryPoint": "${RecoveryPointArn}"
                }
            }
        ],
        "Backup.GetSupportedResourceTypes": [
            {
                "action": "backup:GetSupportedResourceTypes",
                "resource_mappings": {}
            }
        ],
        "Backup.ListBackupJobs": [
            {
                "action": "backup:ListBackupJobs",
                "resource_mappings": {}
            }
        ],
        "Backup.ListBackupPlanTemplates": [
            {
                "action": "backup:ListBackupPlanTemplates",
                "resource_mappings": {}
            }
        ],
        "Backup.ListBackupPlanVersions": [
            {
                "action": "backup:ListBackupPlanVersions",
                "resource_mappings": {
                    "BackupPlanId": {
                        "template": "${BackupPlanId}"
                    }
                }
            }
        ],
        "Backup.ListBackupPlans": [
            {
                "action": "backup:ListBackupPlans",
                "resource_mappings": {}
            }
        ],
        "Backup.ListBackupSelections": [
            {
                "action": "backup:ListBackupSelections",
                "resource_mappings": {
                    "BackupPlanId": {
                        "template": "${BackupPlanId}"
                    }
                }
            }
        ],
        "Backup.ListBackupVaults": [
            {
                "action": "backup:ListBackupVaults",
                "resource_mappings": {}
            }
        ],
        "Backup.ListCopyJobs": [
            {
                "action": "backup:ListCopyJobs",
                "resource_mappings": {}
            }
        ],
        "Backup.ListProtectedResources": [
            {
                "action": "backup:ListProtectedResources",
                "resource_mappings": {}
            }
        ],
        "Backup.ListRecoveryPointsByBackupVault": [
            {
                "action": "backup:ListRecoveryPointsByBackupVault",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.ListRecoveryPointsByResource": [
            {
                "action": "backup:ListRecoveryPointsByResource",
                "resource_mappings": {}
            }
        ],
        "Backup.ListRestoreJobs": [
            {
                "action": "backup:ListRestoreJobs",
                "resource_mappings": {}
            }
        ],
        "Backup.ListTags": [
            {
                "action": "backup:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "backupPlan": "%%iftemplatematch%${ResourceArn}%%",
                    "backupVault": "%%iftemplatematch%${ResourceArn}%%",
                    "recoveryPoint": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Backup.PutBackupVaultAccessPolicy": [
            {
                "action": "backup:PutBackupVaultAccessPolicy",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.PutBackupVaultNotifications": [
            {
                "action": "backup:PutBackupVaultNotifications",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.StartBackupJob": [
            {
                "action": "backup:StartBackupJob",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "Backup.StartCopyJob": [
            {
                "action": "backup:StartCopyJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recoveryPoint": "${RecoveryPointArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "Backup.StartRestoreJob": [
            {
                "action": "backup:StartRestoreJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recoveryPoint": "${RecoveryPointArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${IamRoleArn}"
                }
            }
        ],
        "Backup.StopBackupJob": [
            {
                "action": "backup:StopBackupJob",
                "resource_mappings": {}
            }
        ],
        "Backup.TagResource": [
            {
                "action": "backup:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "backupPlan": "%%iftemplatematch%${ResourceArn}%%",
                    "backupVault": "%%iftemplatematch%${ResourceArn}%%",
                    "recoveryPoint": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Backup.UntagResource": [
            {
                "action": "backup:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "backupPlan": "%%iftemplatematch%${ResourceArn}%%",
                    "backupVault": "%%iftemplatematch%${ResourceArn}%%",
                    "recoveryPoint": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Backup.UpdateBackupPlan": [
            {
                "action": "backup:UpdateBackupPlan",
                "resource_mappings": {
                    "BackupPlanId": {
                        "template": "${BackupPlanId}"
                    }
                }
            }
        ],
        "Backup.UpdateGlobalSettings": [
            {
                "action": "backup:UpdateGlobalSettings",
                "resource_mappings": {}
            }
        ],
        "Backup.UpdateRecoveryPointLifecycle": [
            {
                "action": "backup:UpdateRecoveryPointLifecycle",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recoveryPoint": "${RecoveryPointArn}"
                }
            }
        ],
        "Backup.UpdateRegionSettings": [
            {
                "action": "backup:UpdateRegionSettings",
                "resource_mappings": {}
            }
        ],
        "WorkLink.AssociateDomain": [
            {
                "action": "worklink:AssociateDomain",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.AssociateWebsiteAuthorizationProvider": [
            {
                "action": "worklink:AssociateWebsiteAuthorizationProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.AssociateWebsiteCertificateAuthority": [
            {
                "action": "worklink:AssociateWebsiteCertificateAuthority",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.CreateFleet": [
            {
                "action": "worklink:CreateFleet",
                "resource_mappings": {}
            }
        ],
        "WorkLink.DeleteFleet": [
            {
                "action": "worklink:DeleteFleet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DescribeAuditStreamConfiguration": [
            {
                "action": "worklink:DescribeAuditStreamConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DescribeCompanyNetworkConfiguration": [
            {
                "action": "worklink:DescribeCompanyNetworkConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DescribeDevice": [
            {
                "action": "worklink:DescribeDevice",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DescribeDevicePolicyConfiguration": [
            {
                "action": "worklink:DescribeDevicePolicyConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DescribeDomain": [
            {
                "action": "worklink:DescribeDomain",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DescribeFleetMetadata": [
            {
                "action": "worklink:DescribeFleetMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DescribeIdentityProviderConfiguration": [
            {
                "action": "worklink:DescribeIdentityProviderConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DescribeWebsiteCertificateAuthority": [
            {
                "action": "worklink:DescribeWebsiteCertificateAuthority",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DisassociateDomain": [
            {
                "action": "worklink:DisassociateDomain",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DisassociateWebsiteAuthorizationProvider": [
            {
                "action": "worklink:DisassociateWebsiteAuthorizationProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.DisassociateWebsiteCertificateAuthority": [
            {
                "action": "worklink:DisassociateWebsiteCertificateAuthority",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.ListDevices": [
            {
                "action": "worklink:ListDevices",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.ListDomains": [
            {
                "action": "worklink:ListDomains",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.ListFleets": [
            {
                "action": "worklink:ListFleets",
                "resource_mappings": {}
            }
        ],
        "WorkLink.ListTagsForResource": [
            {
                "action": "worklink:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "WorkLink.ListWebsiteAuthorizationProviders": [
            {
                "action": "worklink:ListWebsiteAuthorizationProviders",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.ListWebsiteCertificateAuthorities": [
            {
                "action": "worklink:ListWebsiteCertificateAuthorities",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.RestoreDomainAccess": [
            {
                "action": "worklink:RestoreDomainAccess",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.RevokeDomainAccess": [
            {
                "action": "worklink:RevokeDomainAccess",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.SignOutUser": [
            {
                "action": "worklink:SignOutUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.TagResource": [
            {
                "action": "worklink:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "WorkLink.UntagResource": [
            {
                "action": "worklink:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "WorkLink.UpdateAuditStreamConfiguration": [
            {
                "action": "worklink:UpdateAuditStreamConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.UpdateCompanyNetworkConfiguration": [
            {
                "action": "worklink:UpdateCompanyNetworkConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.UpdateDevicePolicyConfiguration": [
            {
                "action": "worklink:UpdateDevicePolicyConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.UpdateDomainMetadata": [
            {
                "action": "worklink:UpdateDomainMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.UpdateFleetMetadata": [
            {
                "action": "worklink:UpdateFleetMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "WorkLink.UpdateIdentityProviderConfiguration": [
            {
                "action": "worklink:UpdateIdentityProviderConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fleet": "${FleetArn}"
                }
            }
        ],
        "Textract.AnalyzeDocument": [
            {
                "action": "textract:AnalyzeDocument",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Document.S3Object.Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Document.S3Object.Name}"
                    }
                }
            }
        ],
        "Textract.DetectDocumentText": [
            {
                "action": "textract:DetectDocumentText",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Document.S3Object.Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Document.S3Object.Name}"
                    }
                }
            }
        ],
        "Textract.GetDocumentAnalysis": [
            {
                "action": "textract:GetDocumentAnalysis",
                "resource_mappings": {}
            }
        ],
        "Textract.GetDocumentTextDetection": [
            {
                "action": "textract:GetDocumentTextDetection",
                "resource_mappings": {}
            }
        ],
        "Textract.StartDocumentAnalysis": [
            {
                "action": "textract:StartDocumentAnalysis",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "%%many%${DocumentLocation.S3Object.Bucket}%${OutputConfig.S3Bucket}%%"
                    },
                    "ObjectName": {
                        "template": "%%many%${DocumentLocation.S3Object.Name}%${OutputConfig.S3Prefix}*%%"
                    }
                }
            }
        ],
        "Textract.StartDocumentTextDetection": [
            {
                "action": "textract:StartDocumentTextDetection",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "%%many%${DocumentLocation.S3Object.Bucket}%${OutputConfig.S3Bucket}%%"
                    },
                    "ObjectName": {
                        "template": "%%many%${DocumentLocation.S3Object.Name}%${OutputConfig.S3Prefix}*%%"
                    }
                }
            }
        ],
        "ManagedBlockchain.CreateMember": [
            {
                "action": "managedblockchain:CreateMember",
                "resource_mappings": {
                    "NetworkId": {
                        "template": "${NetworkId}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "ManagedBlockchain.CreateNetwork": [
            {
                "action": "managedblockchain:CreateNetwork",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "ManagedBlockchain.CreateNode": [
            {
                "action": "managedblockchain:CreateNode",
                "resource_mappings": {
                    "MemberId": {
                        "template": "${MemberId}"
                    },
                    "NetworkId": {
                        "template": "${NetworkId}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "ManagedBlockchain.CreateProposal": [
            {
                "action": "managedblockchain:CreateProposal",
                "resource_mappings": {
                    "NetworkId": {
                        "template": "${NetworkId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.DeleteMember": [
            {
                "action": "managedblockchain:DeleteMember",
                "resource_mappings": {
                    "MemberId": {
                        "template": "${MemberId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.DeleteNode": [
            {
                "action": "managedblockchain:DeleteNode",
                "resource_mappings": {
                    "NodeId": {
                        "template": "${NodeId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.GetMember": [
            {
                "action": "managedblockchain:GetMember",
                "resource_mappings": {
                    "MemberId": {
                        "template": "${MemberId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.GetNetwork": [
            {
                "action": "managedblockchain:GetNetwork",
                "resource_mappings": {
                    "NetworkId": {
                        "template": "${NetworkId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.GetNode": [
            {
                "action": "managedblockchain:GetNode",
                "resource_mappings": {
                    "NodeId": {
                        "template": "${NodeId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.GetProposal": [
            {
                "action": "managedblockchain:GetProposal",
                "resource_mappings": {
                    "ProposalId": {
                        "template": "${ProposalId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.ListInvitations": [
            {
                "action": "managedblockchain:ListInvitations",
                "resource_mappings": {}
            }
        ],
        "ManagedBlockchain.ListMembers": [
            {
                "action": "managedblockchain:ListMembers",
                "resource_mappings": {
                    "NetworkId": {
                        "template": "${NetworkId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.ListNetworks": [
            {
                "action": "managedblockchain:ListNetworks",
                "resource_mappings": {}
            }
        ],
        "ManagedBlockchain.ListNodes": [
            {
                "action": "managedblockchain:ListNodes",
                "resource_mappings": {
                    "MemberId": {
                        "template": "${MemberId}"
                    },
                    "NetworkId": {
                        "template": "${NetworkId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.ListProposalVotes": [
            {
                "action": "managedblockchain:ListProposalVotes",
                "resource_mappings": {
                    "ProposalId": {
                        "template": "${ProposalId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.ListProposals": [
            {
                "action": "managedblockchain:ListProposals",
                "resource_mappings": {
                    "NetworkId": {
                        "template": "${NetworkId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.ListTagsForResource": [
            {
                "action": "managedblockchain:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "invitation": "%%iftemplatematch%${ResourceArn}%%",
                    "member": "%%iftemplatematch%${ResourceArn}%%",
                    "network": "%%iftemplatematch%${ResourceArn}%%",
                    "node": "%%iftemplatematch%${ResourceArn}%%",
                    "proposal": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ManagedBlockchain.RejectInvitation": [
            {
                "action": "managedblockchain:RejectInvitation",
                "resource_mappings": {
                    "InvitationId": {
                        "template": "${InvitationId}"
                    }
                }
            }
        ],
        "ManagedBlockchain.TagResource": [
            {
                "action": "managedblockchain:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "invitation": "%%iftemplatematch%${ResourceArn}%%",
                    "member": "%%iftemplatematch%${ResourceArn}%%",
                    "network": "%%iftemplatematch%${ResourceArn}%%",
                    "node": "%%iftemplatematch%${ResourceArn}%%",
                    "proposal": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ManagedBlockchain.UntagResource": [
            {
                "action": "managedblockchain:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "invitation": "%%iftemplatematch%${ResourceArn}%%",
                    "member": "%%iftemplatematch%${ResourceArn}%%",
                    "network": "%%iftemplatematch%${ResourceArn}%%",
                    "node": "%%iftemplatematch%${ResourceArn}%%",
                    "proposal": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ManagedBlockchain.UpdateMember": [
            {
                "action": "managedblockchain:UpdateMember",
                "resource_mappings": {
                    "MemberId": {
                        "template": "${MemberId}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "ManagedBlockchain.UpdateNode": [
            {
                "action": "managedblockchain:UpdateNode",
                "resource_mappings": {
                    "NodeId": {
                        "template": "${NodeId}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "ManagedBlockchain.VoteOnProposal": [
            {
                "action": "managedblockchain:VoteOnProposal",
                "resource_mappings": {
                    "ProposalId": {
                        "template": "${ProposalId}"
                    }
                }
            }
        ],
        "MediaPackageVod.CreateAsset": [
            {
                "action": "mediapackage-vod:CreateAsset",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${SourceRoleArn}"
                }
            }
        ],
        "MediaPackageVod.CreatePackagingConfiguration": [
            {
                "action": "mediapackage-vod:CreatePackagingConfiguration",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${CmafPackage.Encryption.SpekeKeyProvider.RoleArn}%${DashPackage.Encryption.SpekeKeyProvider.RoleArn}%${HlsPackage.Encryption.SpekeKeyProvider.RoleArn}%${MssPackage.Encryption.SpekeKeyProvider.RoleArn}%%"
                }
            }
        ],
        "MediaPackageVod.CreatePackagingGroup": [
            {
                "action": "mediapackage-vod:CreatePackagingGroup",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${Authorization.SecretsRoleArn}"
                }
            }
        ],
        "MediaPackageVod.DeleteAsset": [
            {
                "action": "mediapackage-vod:DeleteAsset",
                "resource_mappings": {
                    "AssetIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackageVod.DeletePackagingConfiguration": [
            {
                "action": "mediapackage-vod:DeletePackagingConfiguration",
                "resource_mappings": {
                    "PackagingConfigurationIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackageVod.DeletePackagingGroup": [
            {
                "action": "mediapackage-vod:DeletePackagingGroup",
                "resource_mappings": {
                    "PackagingGroupIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackageVod.DescribeAsset": [
            {
                "action": "mediapackage-vod:DescribeAsset",
                "resource_mappings": {
                    "AssetIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackageVod.DescribePackagingConfiguration": [
            {
                "action": "mediapackage-vod:DescribePackagingConfiguration",
                "resource_mappings": {
                    "PackagingConfigurationIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackageVod.DescribePackagingGroup": [
            {
                "action": "mediapackage-vod:DescribePackagingGroup",
                "resource_mappings": {
                    "PackagingGroupIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "MediaPackageVod.ListAssets": [
            {
                "action": "mediapackage-vod:ListAssets",
                "resource_mappings": {}
            }
        ],
        "MediaPackageVod.ListPackagingConfigurations": [
            {
                "action": "mediapackage-vod:ListPackagingConfigurations",
                "resource_mappings": {}
            }
        ],
        "MediaPackageVod.ListPackagingGroups": [
            {
                "action": "mediapackage-vod:ListPackagingGroups",
                "resource_mappings": {}
            }
        ],
        "MediaPackageVod.ListTagsForResource": [
            {
                "action": "mediapackage-vod:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "assets": "%%iftemplatematch%${ResourceArn}%%",
                    "packaging-configurations": "%%iftemplatematch%${ResourceArn}%%",
                    "packaging-groups": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MediaPackageVod.TagResource": [
            {
                "action": "mediapackage-vod:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "assets": "%%iftemplatematch%${ResourceArn}%%",
                    "packaging-configurations": "%%iftemplatematch%${ResourceArn}%%",
                    "packaging-groups": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MediaPackageVod.UntagResource": [
            {
                "action": "mediapackage-vod:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "assets": "%%iftemplatematch%${ResourceArn}%%",
                    "packaging-configurations": "%%iftemplatematch%${ResourceArn}%%",
                    "packaging-groups": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "GroundStation.CancelContact": [
            {
                "action": "groundstation:CancelContact",
                "resource_mappings": {
                    "contactId": {
                        "template": "${contactId}"
                    }
                }
            }
        ],
        "GroundStation.CreateConfig": [
            {
                "action": "groundstation:CreateConfig",
                "resource_mappings": {}
            }
        ],
        "GroundStation.CreateDataflowEndpointGroup": [
            {
                "action": "groundstation:CreateDataflowEndpointGroup",
                "resource_mappings": {}
            }
        ],
        "GroundStation.CreateMissionProfile": [
            {
                "action": "groundstation:CreateMissionProfile",
                "resource_mappings": {}
            }
        ],
        "GroundStation.DeleteConfig": [
            {
                "action": "groundstation:DeleteConfig",
                "resource_mappings": {
                    "configType": {
                        "template": "${configType}"
                    },
                    "configId": {
                        "template": "${configId}"
                    }
                }
            }
        ],
        "GroundStation.DeleteDataflowEndpointGroup": [
            {
                "action": "groundstation:DeleteDataflowEndpointGroup",
                "resource_mappings": {
                    "dataflowEndpointGroupId": {
                        "template": "${dataflowEndpointGroupId}"
                    }
                }
            }
        ],
        "GroundStation.DeleteMissionProfile": [
            {
                "action": "groundstation:DeleteMissionProfile",
                "resource_mappings": {
                    "missionProfileId": {
                        "template": "${missionProfileId}"
                    }
                }
            }
        ],
        "GroundStation.DescribeContact": [
            {
                "action": "groundstation:DescribeContact",
                "resource_mappings": {
                    "contactId": {
                        "template": "${contactId}"
                    }
                }
            }
        ],
        "GroundStation.GetConfig": [
            {
                "action": "groundstation:GetConfig",
                "resource_mappings": {
                    "configType": {
                        "template": "${configType}"
                    },
                    "configId": {
                        "template": "${configId}"
                    }
                }
            }
        ],
        "GroundStation.GetDataflowEndpointGroup": [
            {
                "action": "groundstation:GetDataflowEndpointGroup",
                "resource_mappings": {
                    "dataflowEndpointGroupId": {
                        "template": "${dataflowEndpointGroupId}"
                    }
                }
            }
        ],
        "GroundStation.GetMinuteUsage": [
            {
                "action": "groundstation:GetMinuteUsage",
                "resource_mappings": {}
            }
        ],
        "GroundStation.GetMissionProfile": [
            {
                "action": "groundstation:GetMissionProfile",
                "resource_mappings": {
                    "missionProfileId": {
                        "template": "${missionProfileId}"
                    }
                }
            }
        ],
        "GroundStation.GetSatellite": [
            {
                "action": "groundstation:GetSatellite",
                "resource_mappings": {
                    "satelliteId": {
                        "template": "${satelliteId}"
                    }
                }
            }
        ],
        "GroundStation.ListConfigs": [
            {
                "action": "groundstation:ListConfigs",
                "resource_mappings": {}
            }
        ],
        "GroundStation.ListContacts": [
            {
                "action": "groundstation:ListContacts",
                "resource_mappings": {}
            }
        ],
        "GroundStation.ListDataflowEndpointGroups": [
            {
                "action": "groundstation:ListDataflowEndpointGroups",
                "resource_mappings": {}
            }
        ],
        "GroundStation.ListGroundStations": [
            {
                "action": "groundstation:ListGroundStations",
                "resource_mappings": {}
            }
        ],
        "GroundStation.ListMissionProfiles": [
            {
                "action": "groundstation:ListMissionProfiles",
                "resource_mappings": {}
            }
        ],
        "GroundStation.ListSatellites": [
            {
                "action": "groundstation:ListSatellites",
                "resource_mappings": {}
            }
        ],
        "GroundStation.ListTagsForResource": [
            {
                "action": "groundstation:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Config": "%%iftemplatematch%${resourceArn}%%",
                    "Contact": "%%iftemplatematch%${resourceArn}%%",
                    "DataflowEndpointGroup": "%%iftemplatematch%${resourceArn}%%",
                    "MissionProfile": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "GroundStation.ReserveContact": [
            {
                "action": "groundstation:ReserveContact",
                "resource_mappings": {}
            }
        ],
        "GroundStation.TagResource": [
            {
                "action": "groundstation:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Config": "%%iftemplatematch%${resourceArn}%%",
                    "Contact": "%%iftemplatematch%${resourceArn}%%",
                    "DataflowEndpointGroup": "%%iftemplatematch%${resourceArn}%%",
                    "MissionProfile": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "GroundStation.UntagResource": [
            {
                "action": "groundstation:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Config": "%%iftemplatematch%${resourceArn}%%",
                    "Contact": "%%iftemplatematch%${resourceArn}%%",
                    "DataflowEndpointGroup": "%%iftemplatematch%${resourceArn}%%",
                    "MissionProfile": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "GroundStation.UpdateConfig": [
            {
                "action": "groundstation:UpdateConfig",
                "resource_mappings": {
                    "configType": {
                        "template": "${configType}"
                    },
                    "configId": {
                        "template": "${configId}"
                    }
                }
            }
        ],
        "GroundStation.UpdateMissionProfile": [
            {
                "action": "groundstation:UpdateMissionProfile",
                "resource_mappings": {
                    "missionProfileId": {
                        "template": "${missionProfileId}"
                    }
                }
            }
        ],
        "IoTThingsGraph.AssociateEntityToThing": [
            {
                "action": "iotthingsgraph:AssociateEntityToThing",
                "resource_mappings": {}
            },
            {
                "action": "iot:DescribeThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "IoTThingsGraph.CreateFlowTemplate": [
            {
                "action": "iotthingsgraph:CreateFlowTemplate",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.CreateSystemInstance": [
            {
                "action": "iotthingsgraph:CreateSystemInstance",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%many%${metricsConfiguration.metricRuleRoleArn}%${flowActionsRoleArn}%%"
                }
            }
        ],
        "IoTThingsGraph.CreateSystemTemplate": [
            {
                "action": "iotthingsgraph:CreateSystemTemplate",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.DeleteFlowTemplate": [
            {
                "action": "iotthingsgraph:DeleteFlowTemplate",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.DeleteNamespace": [
            {
                "action": "iotthingsgraph:DeleteNamespace",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.DeleteSystemInstance": [
            {
                "action": "iotthingsgraph:DeleteSystemInstance",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.DeleteSystemTemplate": [
            {
                "action": "iotthingsgraph:DeleteSystemTemplate",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.DeploySystemInstance": [
            {
                "action": "iotthingsgraph:DeploySystemInstance",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.DeprecateFlowTemplate": [
            {
                "action": "iotthingsgraph:DeprecateFlowTemplate",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.DeprecateSystemTemplate": [
            {
                "action": "iotthingsgraph:DeprecateSystemTemplate",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.DescribeNamespace": [
            {
                "action": "iotthingsgraph:DescribeNamespace",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.DissociateEntityFromThing": [
            {
                "action": "iotthingsgraph:DissociateEntityFromThing",
                "resource_mappings": {}
            },
            {
                "action": "iot:DescribeThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "IoTThingsGraph.GetEntities": [
            {
                "action": "iotthingsgraph:GetEntities",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.GetFlowTemplate": [
            {
                "action": "iotthingsgraph:GetFlowTemplate",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.GetFlowTemplateRevisions": [
            {
                "action": "iotthingsgraph:GetFlowTemplateRevisions",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.GetNamespaceDeletionStatus": [
            {
                "action": "iotthingsgraph:GetNamespaceDeletionStatus",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.GetSystemInstance": [
            {
                "action": "iotthingsgraph:GetSystemInstance",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.GetSystemTemplate": [
            {
                "action": "iotthingsgraph:GetSystemTemplate",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.GetSystemTemplateRevisions": [
            {
                "action": "iotthingsgraph:GetSystemTemplateRevisions",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.GetUploadStatus": [
            {
                "action": "iotthingsgraph:GetUploadStatus",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.ListFlowExecutionMessages": [
            {
                "action": "iotthingsgraph:ListFlowExecutionMessages",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.ListTagsForResource": [
            {
                "action": "iotthingsgraph:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "SystemInstance": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTThingsGraph.SearchEntities": [
            {
                "action": "iotthingsgraph:SearchEntities",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.SearchFlowExecutions": [
            {
                "action": "iotthingsgraph:SearchFlowExecutions",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${systemInstanceId}"
                    }
                }
            }
        ],
        "IoTThingsGraph.SearchFlowTemplates": [
            {
                "action": "iotthingsgraph:SearchFlowTemplates",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.SearchSystemInstances": [
            {
                "action": "iotthingsgraph:SearchSystemInstances",
                "resource_mappings": {}
            },
            {
                "action": "iotthingsgraph:SearchSystemInstances",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.SearchSystemTemplates": [
            {
                "action": "iotthingsgraph:SearchSystemTemplates",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.SearchThings": [
            {
                "action": "iotthingsgraph:SearchThings",
                "resource_mappings": {}
            }
        ],
        "IoTThingsGraph.TagResource": [
            {
                "action": "iotthingsgraph:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "SystemInstance": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTThingsGraph.UndeploySystemInstance": [
            {
                "action": "iotthingsgraph:UndeploySystemInstance",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.UntagResource": [
            {
                "action": "iotthingsgraph:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "SystemInstance": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTThingsGraph.UpdateFlowTemplate": [
            {
                "action": "iotthingsgraph:UpdateFlowTemplate",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.UpdateSystemTemplate": [
            {
                "action": "iotthingsgraph:UpdateSystemTemplate",
                "resource_mappings": {
                    "NamespacePath": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "IoTThingsGraph.UploadEntityDefinitions": [
            {
                "action": "iotthingsgraph:UploadEntityDefinitions",
                "resource_mappings": {}
            }
        ],
        "IoTEvents.CreateDetectorModel": [
            {
                "action": "iotevents:CreateDetectorModel",
                "resource_mappings": {
                    "DetectorModelName": {
                        "template": "${detectorModelName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "IoTEvents.CreateInput": [
            {
                "action": "iotevents:CreateInput",
                "resource_mappings": {
                    "inputName": {
                        "template": "${inputName}"
                    }
                }
            }
        ],
        "IoTEvents.DeleteDetectorModel": [
            {
                "action": "iotevents:DeleteDetectorModel",
                "resource_mappings": {
                    "DetectorModelName": {
                        "template": "${detectorModelName}"
                    }
                }
            }
        ],
        "IoTEvents.DeleteInput": [
            {
                "action": "iotevents:DeleteInput",
                "resource_mappings": {
                    "inputName": {
                        "template": "${inputName}"
                    }
                }
            }
        ],
        "IoTEvents.DescribeDetectorModel": [
            {
                "action": "iotevents:DescribeDetectorModel",
                "resource_mappings": {
                    "DetectorModelName": {
                        "template": "${detectorModelName}"
                    }
                }
            }
        ],
        "IoTEvents.DescribeInput": [
            {
                "action": "iotevents:DescribeInput",
                "resource_mappings": {
                    "inputName": {
                        "template": "${inputName}"
                    }
                }
            }
        ],
        "IoTEvents.DescribeLoggingOptions": [
            {
                "action": "iotevents:DescribeLoggingOptions",
                "resource_mappings": {}
            }
        ],
        "IoTEvents.ListDetectorModelVersions": [
            {
                "action": "iotevents:ListDetectorModelVersions",
                "resource_mappings": {
                    "DetectorModelName": {
                        "template": "${detectorModelName}"
                    }
                }
            }
        ],
        "IoTEvents.ListDetectorModels": [
            {
                "action": "iotevents:ListDetectorModels",
                "resource_mappings": {}
            }
        ],
        "IoTEvents.ListInputs": [
            {
                "action": "iotevents:ListInputs",
                "resource_mappings": {}
            }
        ],
        "IoTEvents.ListTagsForResource": [
            {
                "action": "iotevents:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "detectorModel": "%%iftemplatematch%${resourceArn}%%",
                    "input": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTEvents.PutLoggingOptions": [
            {
                "action": "iotevents:PutLoggingOptions",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${loggingOptions.roleArn}"
                }
            }
        ],
        "IoTEvents.TagResource": [
            {
                "action": "iotevents:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "detectorModel": "%%iftemplatematch%${resourceArn}%%",
                    "input": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTEvents.UntagResource": [
            {
                "action": "iotevents:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "detectorModel": "%%iftemplatematch%${resourceArn}%%",
                    "input": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTEvents.UpdateDetectorModel": [
            {
                "action": "iotevents:UpdateDetectorModel",
                "resource_mappings": {
                    "DetectorModelName": {
                        "template": "${detectorModelName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "IoTEvents.UpdateInput": [
            {
                "action": "iotevents:UpdateInput",
                "resource_mappings": {
                    "inputName": {
                        "template": "${inputName}"
                    }
                }
            }
        ],
        "IoTEventsData.BatchPutMessage": [
            {
                "action": "iotevents:BatchPutMessage",
                "resource_mappings": {
                    "inputName": {
                        "template": "${messages[].inputName}"
                    }
                }
            }
        ],
        "IoTEventsData.BatchUpdateDetector": [
            {
                "action": "iotevents:BatchUpdateDetector",
                "resource_mappings": {
                    "inputName": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTEventsData.DescribeDetector": [
            {
                "action": "iotevents:DescribeDetector",
                "resource_mappings": {
                    "DetectorModelName": {
                        "template": "${detectorModelName}"
                    }
                }
            }
        ],
        "IoTEventsData.ListDetectors": [
            {
                "action": "iotevents:ListDetectors",
                "resource_mappings": {
                    "DetectorModelName": {
                        "template": "${detectorModelName}"
                    }
                }
            }
        ],
        "Personalize.CreateBatchInferenceJob": [
            {
                "action": "personalize:CreateBatchInferenceJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Personalize.CreateCampaign": [
            {
                "action": "personalize:CreateCampaign",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Personalize.CreateDataset": [
            {
                "action": "personalize:CreateDataset",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Personalize.CreateDatasetGroup": [
            {
                "action": "personalize:CreateDatasetGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Personalize.CreateDatasetImportJob": [
            {
                "action": "personalize:CreateDatasetImportJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "Personalize.CreateEventTracker": [
            {
                "action": "personalize:CreateEventTracker",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Personalize.CreateFilter": [
            {
                "action": "personalize:CreateFilter",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Personalize.CreateSchema": [
            {
                "action": "personalize:CreateSchema",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Personalize.CreateSolution": [
            {
                "action": "personalize:CreateSolution",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Personalize.CreateSolutionVersion": [
            {
                "action": "personalize:CreateSolutionVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "solution": "${solutionArn}"
                }
            }
        ],
        "Personalize.DeleteCampaign": [
            {
                "action": "personalize:DeleteCampaign",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "campaign": "${campaignArn}"
                }
            }
        ],
        "Personalize.DeleteDataset": [
            {
                "action": "personalize:DeleteDataset",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${datasetArn}"
                }
            }
        ],
        "Personalize.DeleteDatasetGroup": [
            {
                "action": "personalize:DeleteDatasetGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datasetGroup": "${datasetGroupArn}"
                }
            }
        ],
        "Personalize.DeleteEventTracker": [
            {
                "action": "personalize:DeleteEventTracker",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "eventTracker": "${eventTrackerArn}"
                }
            }
        ],
        "Personalize.DeleteFilter": [
            {
                "action": "personalize:DeleteFilter",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "filter": "${filterArn}"
                }
            }
        ],
        "Personalize.DeleteSchema": [
            {
                "action": "personalize:DeleteSchema",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "schema": "${schemaArn}"
                }
            }
        ],
        "Personalize.DeleteSolution": [
            {
                "action": "personalize:DeleteSolution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "solution": "${solutionArn}"
                }
            }
        ],
        "Personalize.DescribeAlgorithm": [
            {
                "action": "personalize:DescribeAlgorithm",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "algorithm": "${algorithmArn}"
                }
            }
        ],
        "Personalize.DescribeBatchInferenceJob": [
            {
                "action": "personalize:DescribeBatchInferenceJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "batchInferenceJob": "${batchInferenceJobArn}"
                }
            }
        ],
        "Personalize.DescribeCampaign": [
            {
                "action": "personalize:DescribeCampaign",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "campaign": "${campaignArn}"
                }
            }
        ],
        "Personalize.DescribeDataset": [
            {
                "action": "personalize:DescribeDataset",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${datasetArn}"
                }
            }
        ],
        "Personalize.DescribeDatasetGroup": [
            {
                "action": "personalize:DescribeDatasetGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datasetGroup": "${datasetGroupArn}"
                }
            }
        ],
        "Personalize.DescribeDatasetImportJob": [
            {
                "action": "personalize:DescribeDatasetImportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datasetImportJob": "${datasetImportJobArn}"
                }
            }
        ],
        "Personalize.DescribeEventTracker": [
            {
                "action": "personalize:DescribeEventTracker",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "eventTracker": "${eventTrackerArn}"
                }
            }
        ],
        "Personalize.DescribeFeatureTransformation": [
            {
                "action": "personalize:DescribeFeatureTransformation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "featureTransformation": "${featureTransformationArn}"
                }
            }
        ],
        "Personalize.DescribeFilter": [
            {
                "action": "personalize:DescribeFilter",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "filter": "${filterArn}"
                }
            }
        ],
        "Personalize.DescribeRecipe": [
            {
                "action": "personalize:DescribeRecipe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recipe": "${recipeArn}"
                }
            }
        ],
        "Personalize.DescribeSchema": [
            {
                "action": "personalize:DescribeSchema",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "schema": "${schemaArn}"
                }
            }
        ],
        "Personalize.DescribeSolution": [
            {
                "action": "personalize:DescribeSolution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "solution": "${solutionArn}"
                }
            }
        ],
        "Personalize.DescribeSolutionVersion": [
            {
                "action": "personalize:DescribeSolutionVersion",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "%%regex%${solutionVersionArn}%/^.+\\/(.+?)\\/.+$/g%%"
                    }
                }
            }
        ],
        "Personalize.GetSolutionMetrics": [
            {
                "action": "personalize:GetSolutionMetrics",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "%%regex%${solutionVersionArn}%/^.+\\/(.+?)\\/.+$/g%%"
                    }
                }
            }
        ],
        "Personalize.ListBatchInferenceJobs": [
            {
                "action": "personalize:ListBatchInferenceJobs",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListCampaigns": [
            {
                "action": "personalize:ListCampaigns",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListDatasetGroups": [
            {
                "action": "personalize:ListDatasetGroups",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListDatasetImportJobs": [
            {
                "action": "personalize:ListDatasetImportJobs",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListDatasets": [
            {
                "action": "personalize:ListDatasets",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListEventTrackers": [
            {
                "action": "personalize:ListEventTrackers",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListFilters": [
            {
                "action": "personalize:ListFilters",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListRecipes": [
            {
                "action": "personalize:ListRecipes",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListSchemas": [
            {
                "action": "personalize:ListSchemas",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListSolutionVersions": [
            {
                "action": "personalize:ListSolutionVersions",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListSolutions": [
            {
                "action": "personalize:ListSolutions",
                "resource_mappings": {}
            }
        ],
        "Personalize.UpdateCampaign": [
            {
                "action": "personalize:UpdateCampaign",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "campaign": "${campaignArn}"
                }
            }
        ],
        "PersonalizeEvents.PutEvents": [
            {
                "action": "personalize:PutEvents",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${trackingId}"
                    }
                }
            }
        ],
        "PersonalizeEvents.PutItems": [
            {
                "action": "personalize:PutItems",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${datasetArn}"
                }
            }
        ],
        "PersonalizeEvents.PutUsers": [
            {
                "action": "personalize:PutUsers",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${datasetArn}"
                }
            }
        ],
        "PersonalizeRuntime.GetPersonalizedRanking": [
            {
                "action": "personalize:GetPersonalizedRanking",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "campaign": "${campaignArn}"
                }
            }
        ],
        "PersonalizeRuntime.GetRecommendations": [
            {
                "action": "personalize:GetRecommendations",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "campaign": "${campaignArn}"
                }
            }
        ],
        "ApplicationInsights.CreateApplication": [
            {
                "action": "applicationinsights:CreateApplication",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.CreateComponent": [
            {
                "action": "applicationinsights:CreateComponent",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.CreateLogPattern": [
            {
                "action": "applicationinsights:CreateLogPattern",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DeleteApplication": [
            {
                "action": "applicationinsights:DeleteApplication",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DeleteComponent": [
            {
                "action": "applicationinsights:DeleteComponent",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DeleteLogPattern": [
            {
                "action": "applicationinsights:DeleteLogPattern",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DescribeApplication": [
            {
                "action": "applicationinsights:DescribeApplication",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DescribeComponent": [
            {
                "action": "applicationinsights:DescribeComponent",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DescribeComponentConfiguration": [
            {
                "action": "applicationinsights:DescribeComponentConfiguration",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DescribeComponentConfigurationRecommendation": [
            {
                "action": "applicationinsights:DescribeComponentConfigurationRecommendation",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DescribeLogPattern": [
            {
                "action": "applicationinsights:DescribeLogPattern",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DescribeObservation": [
            {
                "action": "applicationinsights:DescribeObservation",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DescribeProblem": [
            {
                "action": "applicationinsights:DescribeProblem",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.DescribeProblemObservations": [
            {
                "action": "applicationinsights:DescribeProblemObservations",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.ListApplications": [
            {
                "action": "applicationinsights:ListApplications",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.ListComponents": [
            {
                "action": "applicationinsights:ListComponents",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.ListConfigurationHistory": [
            {
                "action": "applicationinsights:ListConfigurationHistory",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.ListLogPatternSets": [
            {
                "action": "applicationinsights:ListLogPatternSets",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.ListLogPatterns": [
            {
                "action": "applicationinsights:ListLogPatterns",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.ListProblems": [
            {
                "action": "applicationinsights:ListProblems",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.ListTagsForResource": [
            {
                "action": "applicationinsights:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.TagResource": [
            {
                "action": "applicationinsights:TagResource",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.UntagResource": [
            {
                "action": "applicationinsights:UntagResource",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.UpdateApplication": [
            {
                "action": "applicationinsights:UpdateApplication",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.UpdateComponent": [
            {
                "action": "applicationinsights:UpdateComponent",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.UpdateComponentConfiguration": [
            {
                "action": "applicationinsights:UpdateComponentConfiguration",
                "resource_mappings": {}
            }
        ],
        "ApplicationInsights.UpdateLogPattern": [
            {
                "action": "applicationinsights:UpdateLogPattern",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.AssociateServiceQuotaTemplate": [
            {
                "action": "servicequotas:AssociateServiceQuotaTemplate",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.DeleteServiceQuotaIncreaseRequestFromTemplate": [
            {
                "action": "servicequotas:DeleteServiceQuotaIncreaseRequestFromTemplate",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.DisassociateServiceQuotaTemplate": [
            {
                "action": "servicequotas:DisassociateServiceQuotaTemplate",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.GetAWSDefaultServiceQuota": [
            {
                "action": "servicequotas:GetAWSDefaultServiceQuota",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.GetAssociationForServiceQuotaTemplate": [
            {
                "action": "servicequotas:GetAssociationForServiceQuotaTemplate",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.GetRequestedServiceQuotaChange": [
            {
                "action": "servicequotas:GetRequestedServiceQuotaChange",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.GetServiceQuota": [
            {
                "action": "servicequotas:GetServiceQuota",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.GetServiceQuotaIncreaseRequestFromTemplate": [
            {
                "action": "servicequotas:GetServiceQuotaIncreaseRequestFromTemplate",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.ListAWSDefaultServiceQuotas": [
            {
                "action": "servicequotas:ListAWSDefaultServiceQuotas",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.ListRequestedServiceQuotaChangeHistory": [
            {
                "action": "servicequotas:ListRequestedServiceQuotaChangeHistory",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.ListRequestedServiceQuotaChangeHistoryByQuota": [
            {
                "action": "servicequotas:ListRequestedServiceQuotaChangeHistoryByQuota",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.ListServiceQuotaIncreaseRequestsInTemplate": [
            {
                "action": "servicequotas:ListServiceQuotaIncreaseRequestsInTemplate",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.ListServiceQuotas": [
            {
                "action": "servicequotas:ListServiceQuotas",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.ListServices": [
            {
                "action": "servicequotas:ListServices",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.ListTagsForResource": [
            {
                "action": "servicequotas:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.PutServiceQuotaIncreaseRequestIntoTemplate": [
            {
                "action": "servicequotas:PutServiceQuotaIncreaseRequestIntoTemplate",
                "resource_mappings": {
                    "ServiceCode": {
                        "template": "${ServiceCode}"
                    },
                    "QuotaCode": {
                        "template": "${QuotaCode}"
                    }
                }
            }
        ],
        "ServiceQuotas.RequestServiceQuotaIncrease": [
            {
                "action": "servicequotas:RequestServiceQuotaIncrease",
                "resource_mappings": {
                    "ServiceCode": {
                        "template": "${ServiceCode}"
                    },
                    "QuotaCode": {
                        "template": "${QuotaCode}"
                    }
                }
            }
        ],
        "ServiceQuotas.TagResource": [
            {
                "action": "servicequotas:TagResource",
                "resource_mappings": {}
            }
        ],
        "ServiceQuotas.UntagResource": [
            {
                "action": "servicequotas:UntagResource",
                "resource_mappings": {}
            }
        ],
        "EC2InstanceConnect.SendSSHPublicKey": [
            {
                "action": "ec2-instance-connect:SendSSHPublicKey",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EventBridge.ActivateEventSource": [
            {
                "action": "events:ActivateEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.CancelReplay": [
            {
                "action": "events:CancelReplay",
                "resource_mappings": {
                    "ReplayName": {
                        "template": "${ReplayName}"
                    }
                }
            }
        ],
        "EventBridge.CreateArchive": [
            {
                "action": "events:CreateArchive",
                "resource_mappings": {
                    "ArchiveName": {
                        "template": "${ArchiveName}"
                    }
                }
            }
        ],
        "EventBridge.CreateEventBus": [
            {
                "action": "events:CreateEventBus",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.CreatePartnerEventSource": [
            {
                "action": "events:CreatePartnerEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DeactivateEventSource": [
            {
                "action": "events:DeactivateEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DeleteArchive": [
            {
                "action": "events:DeleteArchive",
                "resource_mappings": {
                    "ArchiveName": {
                        "template": "${ArchiveName}"
                    }
                }
            }
        ],
        "EventBridge.DeleteEventBus": [
            {
                "action": "events:DeleteEventBus",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DeletePartnerEventSource": [
            {
                "action": "events:DeletePartnerEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DeleteRule": [
            {
                "action": "events:DeleteRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DescribeArchive": [
            {
                "action": "events:DescribeArchive",
                "resource_mappings": {
                    "ArchiveName": {
                        "template": "${ArchiveName}"
                    }
                }
            }
        ],
        "EventBridge.DescribeEventBus": [
            {
                "action": "events:DescribeEventBus",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DescribeEventSource": [
            {
                "action": "events:DescribeEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DescribePartnerEventSource": [
            {
                "action": "events:DescribePartnerEventSource",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DescribeReplay": [
            {
                "action": "events:DescribeReplay",
                "resource_mappings": {
                    "ReplayName": {
                        "template": "${ReplayName}"
                    }
                }
            }
        ],
        "EventBridge.DescribeRule": [
            {
                "action": "events:DescribeRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DisableRule": [
            {
                "action": "events:DisableRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.EnableRule": [
            {
                "action": "events:EnableRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.ListArchives": [
            {
                "action": "events:ListArchives",
                "resource_mappings": {}
            }
        ],
        "EventBridge.ListEventBuses": [
            {
                "action": "events:ListEventBuses",
                "resource_mappings": {}
            }
        ],
        "EventBridge.ListEventSources": [
            {
                "action": "events:ListEventSources",
                "resource_mappings": {}
            }
        ],
        "EventBridge.ListPartnerEventSourceAccounts": [
            {
                "action": "events:ListPartnerEventSourceAccounts",
                "resource_mappings": {
                    "EventSourceName": {
                        "template": "${EventSourceName}"
                    }
                }
            }
        ],
        "EventBridge.ListPartnerEventSources": [
            {
                "action": "events:ListPartnerEventSources",
                "resource_mappings": {}
            }
        ],
        "EventBridge.ListReplays": [
            {
                "action": "events:ListReplays",
                "resource_mappings": {}
            }
        ],
        "EventBridge.ListRuleNamesByTarget": [
            {
                "action": "events:ListRuleNamesByTarget",
                "resource_mappings": {}
            }
        ],
        "EventBridge.ListRules": [
            {
                "action": "events:ListRules",
                "resource_mappings": {}
            }
        ],
        "EventBridge.ListTagsForResource": [
            {
                "action": "events:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-bus": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "EventBridge.ListTargetsByRule": [
            {
                "action": "events:ListTargetsByRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Rule}"
                    }
                }
            }
        ],
        "EventBridge.PutEvents": [
            {
                "action": "events:PutEvents",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${Entries[].EventBusName}"
                    }
                }
            }
        ],
        "EventBridge.PutPartnerEvents": [
            {
                "action": "events:PutPartnerEvents",
                "resource_mappings": {}
            }
        ],
        "EventBridge.PutPermission": [
            {
                "action": "events:PutPermission",
                "resource_mappings": {}
            }
        ],
        "EventBridge.PutRule": [
            {
                "action": "events:PutRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "EventBridge.PutTargets": [
            {
                "action": "events:PutTargets",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Rule}"
                    }
                }
            }
        ],
        "EventBridge.RemovePermission": [
            {
                "action": "events:RemovePermission",
                "resource_mappings": {}
            }
        ],
        "EventBridge.RemoveTargets": [
            {
                "action": "events:RemoveTargets",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "${EventBusName}"
                    },
                    "RuleName": {
                        "template": "${Rule}"
                    }
                }
            }
        ],
        "EventBridge.StartReplay": [
            {
                "action": "events:StartReplay",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "archive": "%%iftemplatematch%${EventSourceArn}%%"
                }
            }
        ],
        "EventBridge.TagResource": [
            {
                "action": "events:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-bus": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "EventBridge.TestEventPattern": [
            {
                "action": "events:TestEventPattern",
                "resource_mappings": {}
            }
        ],
        "EventBridge.UntagResource": [
            {
                "action": "events:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-bus": "%%iftemplatematch%${ResourceARN}%%",
                    "rule": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "EventBridge.UpdateArchive": [
            {
                "action": "events:UpdateArchive",
                "resource_mappings": {
                    "ArchiveName": {
                        "template": "${ArchiveName}"
                    }
                }
            }
        ],
        "LakeFormation.BatchGrantPermissions": [
            {
                "action": "lakeformation:BatchGrantPermissions",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.BatchRevokePermissions": [
            {
                "action": "lakeformation:BatchRevokePermissions",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.DeregisterResource": [
            {
                "action": "lakeformation:DeregisterResource",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.DescribeResource": [
            {
                "action": "lakeformation:DescribeResource",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GetDataLakeSettings": [
            {
                "action": "lakeformation:GetDataLakeSettings",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GetEffectivePermissionsForPath": [
            {
                "action": "lakeformation:GetEffectivePermissionsForPath",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GrantPermissions": [
            {
                "action": "lakeformation:GrantPermissions",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.ListPermissions": [
            {
                "action": "lakeformation:ListPermissions",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.ListResources": [
            {
                "action": "lakeformation:ListResources",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.PutDataLakeSettings": [
            {
                "action": "lakeformation:PutDataLakeSettings",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.RegisterResource": [
            {
                "action": "lakeformation:RegisterResource",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "%%iftruthy%${UseServiceLinkedRole}%arn:${Partition}:iam::${Account}:role/aws-service-role/lakeformation.amazonaws.com/AWSServiceRoleForLakeFormationDataAccess%%%"
                }
            }
        ],
        "LakeFormation.RevokePermissions": [
            {
                "action": "lakeformation:RevokePermissions",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.UpdateResource": [
            {
                "action": "lakeformation:UpdateResource",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "ForecastService.CreateDataset": [
            {
                "action": "forecast:CreateDataset",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${EncryptionConfig.RoleArn}"
                }
            }
        ],
        "ForecastService.CreateDatasetGroup": [
            {
                "action": "forecast:CreateDatasetGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ForecastService.CreateDatasetImportJob": [
            {
                "action": "forecast:CreateDatasetImportJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataSource.S3Config.RoleArn}"
                }
            }
        ],
        "ForecastService.CreateForecast": [
            {
                "action": "forecast:CreateForecast",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "predictor": "${PredictorArn}"
                }
            }
        ],
        "ForecastService.CreateForecastExportJob": [
            {
                "action": "forecast:CreateForecastExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "forecast": "${ForecastArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${DataSource.S3Config.RoleArn}"
                }
            }
        ],
        "ForecastService.CreatePredictor": [
            {
                "action": "forecast:CreatePredictor",
                "arn_override": {
                    "template": "arn:${Partition}:forecast:${Region}:${Account}:predictor/*"
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${EncryptionConfig.RoleArn}"
                }
            }
        ],
        "ForecastService.CreatePredictorBacktestExportJob": [
            {
                "action": "forecast:CreatePredictorBacktestExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "predictor": "${PredictorArn}"
                }
            }
        ],
        "ForecastService.DeleteDataset": [
            {
                "action": "forecast:DeleteDataset",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${DatasetArn}"
                }
            }
        ],
        "ForecastService.DeleteDatasetGroup": [
            {
                "action": "forecast:DeleteDatasetGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datasetGroup": "${DatasetGroupArn}"
                }
            }
        ],
        "ForecastService.DeleteDatasetImportJob": [
            {
                "action": "forecast:DeleteDatasetImportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datasetImportJob": "${DatasetImportJobArn}"
                }
            }
        ],
        "ForecastService.DeleteForecast": [
            {
                "action": "forecast:DeleteForecast",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "forecast": "${ForecastArn}"
                }
            }
        ],
        "ForecastService.DeleteForecastExportJob": [
            {
                "action": "forecast:DeleteForecastExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "forecastExport": "${ForecastExportJobArn}"
                }
            }
        ],
        "ForecastService.DeletePredictor": [
            {
                "action": "forecast:DeletePredictor",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "predictor": "${PredictorArn}"
                }
            }
        ],
        "ForecastService.DeletePredictorBacktestExportJob": [
            {
                "action": "forecast:DeletePredictorBacktestExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "predictorBacktestExportJob": "${PredictorBacktestExportJobArn}"
                }
            }
        ],
        "ForecastService.DescribeDataset": [
            {
                "action": "forecast:DescribeDataset",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${DatasetArn}"
                }
            }
        ],
        "ForecastService.DescribeDatasetGroup": [
            {
                "action": "forecast:DescribeDatasetGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datasetGroup": "${DatasetGroupArn}"
                }
            }
        ],
        "ForecastService.DescribeDatasetImportJob": [
            {
                "action": "forecast:DescribeDatasetImportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datasetImportJob": "${DatasetImportJobArn}"
                }
            }
        ],
        "ForecastService.DescribeForecast": [
            {
                "action": "forecast:DescribeForecast",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "forecast": "${ForecastArn}"
                }
            }
        ],
        "ForecastService.DescribeForecastExportJob": [
            {
                "action": "forecast:DescribeForecastExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "forecastExport": "${ForecastExportJobArn}"
                }
            }
        ],
        "ForecastService.DescribePredictor": [
            {
                "action": "forecast:DescribePredictor",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "predictor": "${PredictorArn}"
                }
            }
        ],
        "ForecastService.DescribePredictorBacktestExportJob": [
            {
                "action": "forecast:DescribePredictorBacktestExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "predictorBacktestExportJob": "${PredictorBacktestExportJobArn}"
                }
            }
        ],
        "ForecastService.GetAccuracyMetrics": [
            {
                "action": "forecast:GetAccuracyMetrics",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "predictor": "${PredictorArn}"
                }
            }
        ],
        "ForecastService.ListDatasetGroups": [
            {
                "action": "forecast:ListDatasetGroups",
                "resource_mappings": {}
            }
        ],
        "ForecastService.ListDatasetImportJobs": [
            {
                "action": "forecast:ListDatasetImportJobs",
                "resource_mappings": {}
            }
        ],
        "ForecastService.ListDatasets": [
            {
                "action": "forecast:ListDatasets",
                "resource_mappings": {}
            }
        ],
        "ForecastService.ListForecastExportJobs": [
            {
                "action": "forecast:ListForecastExportJobs",
                "resource_mappings": {}
            }
        ],
        "ForecastService.ListForecasts": [
            {
                "action": "forecast:ListForecasts",
                "resource_mappings": {}
            }
        ],
        "ForecastService.ListPredictorBacktestExportJobs": [
            {
                "action": "forecast:ListPredictorBacktestExportJobs",
                "resource_mappings": {}
            }
        ],
        "ForecastService.ListPredictors": [
            {
                "action": "forecast:ListPredictors",
                "resource_mappings": {}
            }
        ],
        "ForecastService.ListTagsForResource": [
            {
                "action": "forecast:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "datasetGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "datasetImportJob": "%%iftemplatematch%${ResourceArn}%%",
                    "forecast": "%%iftemplatematch%${ResourceArn}%%",
                    "forecastExport": "%%iftemplatematch%${ResourceArn}%%",
                    "predictor": "%%iftemplatematch%${ResourceArn}%%",
                    "predictorBacktestExportJob": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ForecastService.TagResource": [
            {
                "action": "forecast:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "datasetGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "datasetImportJob": "%%iftemplatematch%${ResourceArn}%%",
                    "forecast": "%%iftemplatematch%${ResourceArn}%%",
                    "forecastExport": "%%iftemplatematch%${ResourceArn}%%",
                    "predictor": "%%iftemplatematch%${ResourceArn}%%",
                    "predictorBacktestExportJob": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ForecastService.UntagResource": [
            {
                "action": "forecast:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "datasetGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "datasetImportJob": "%%iftemplatematch%${ResourceArn}%%",
                    "forecast": "%%iftemplatematch%${ResourceArn}%%",
                    "forecastExport": "%%iftemplatematch%${ResourceArn}%%",
                    "predictor": "%%iftemplatematch%${ResourceArn}%%",
                    "predictorBacktestExportJob": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ForecastService.UpdateDatasetGroup": [
            {
                "action": "forecast:UpdateDatasetGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${DatasetArns[]}",
                    "datasetGroup": "${DatasetGroupArn}"
                }
            }
        ],
        "ForecastQueryService.QueryForecast": [
            {
                "action": "forecast:QueryForecast",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "forecast": "${ForecastArn}"
                }
            }
        ],
        "QLDB.CancelJournalKinesisStream": [
            {
                "action": "qldb:CancelJournalKinesisStream",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${LedgerName}"
                    },
                    "StreamId": {
                        "template": "${StreamId}"
                    }
                }
            }
        ],
        "QLDB.CreateLedger": [
            {
                "action": "qldb:CreateLedger",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "QLDB.DeleteLedger": [
            {
                "action": "qldb:DeleteLedger",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "QLDB.DescribeJournalKinesisStream": [
            {
                "action": "qldb:DescribeJournalKinesisStream",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${LedgerName}"
                    },
                    "StreamId": {
                        "template": "${StreamId}"
                    }
                }
            }
        ],
        "QLDB.DescribeJournalS3Export": [
            {
                "action": "qldb:DescribeJournalS3Export",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "QLDB.DescribeLedger": [
            {
                "action": "qldb:DescribeLedger",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "QLDB.ExportJournalToS3": [
            {
                "action": "qldb:ExportJournalToS3",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "QLDB.GetBlock": [
            {
                "action": "qldb:GetBlock",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "QLDB.GetDigest": [
            {
                "action": "qldb:GetDigest",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "QLDB.GetRevision": [
            {
                "action": "qldb:GetRevision",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "QLDB.ListJournalKinesisStreamsForLedger": [
            {
                "action": "qldb:ListJournalKinesisStreamsForLedger",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${LedgerName}"
                    },
                    "StreamId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QLDB.ListJournalS3Exports": [
            {
                "action": "qldb:ListJournalS3Exports",
                "resource_mappings": {}
            }
        ],
        "QLDB.ListJournalS3ExportsForLedger": [
            {
                "action": "qldb:ListJournalS3ExportsForLedger",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "QLDB.ListLedgers": [
            {
                "action": "qldb:ListLedgers",
                "resource_mappings": {}
            }
        ],
        "QLDB.ListTagsForResource": [
            {
                "action": "qldb:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ledger": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "QLDB.StreamJournalToKinesis": [
            {
                "action": "qldb:StreamJournalToKinesis",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${LedgerName}"
                    },
                    "StreamId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "QLDB.TagResource": [
            {
                "action": "qldb:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ledger": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "QLDB.UntagResource": [
            {
                "action": "qldb:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ledger": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "QLDB.UpdateLedger": [
            {
                "action": "qldb:UpdateLedger",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "QLDBSession.SendCommand": [
            {
                "action": "qldb:SendCommand",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${StartSession.LedgerName}"
                    }
                }
            }
        ],
        "WorkMailMessageFlow.GetRawMessageContent": [
            {
                "action": "workmailmessageflow:GetRawMessageContent",
                "resource_mappings": {
                    "OrganizationId": {
                        "template": "*"
                    },
                    "Context": {
                        "template": "*"
                    },
                    "MessageId": {
                        "template": "${messageId}"
                    }
                }
            }
        ],
        "CodeStarNotifications.CreateNotificationRule": [
            {
                "action": "codestar-notifications:CreateNotificationRule",
                "resource_mappings": {
                    "NotificationRuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeStarNotifications.DeleteNotificationRule": [
            {
                "action": "codestar-notifications:DeleteNotificationRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "notificationrule": "${Arn}"
                }
            }
        ],
        "CodeStarNotifications.DeleteTarget": [
            {
                "action": "codestar-notifications:DeleteTarget",
                "resource_mappings": {}
            }
        ],
        "CodeStarNotifications.DescribeNotificationRule": [
            {
                "action": "codestar-notifications:DescribeNotificationRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "notificationrule": "${Arn}"
                }
            }
        ],
        "CodeStarNotifications.ListEventTypes": [
            {
                "action": "codestar-notifications:ListEventTypes",
                "resource_mappings": {}
            }
        ],
        "CodeStarNotifications.ListNotificationRules": [
            {
                "action": "codestar-notifications:ListNotificationRules",
                "resource_mappings": {}
            }
        ],
        "CodeStarNotifications.ListTagsForResource": [
            {
                "action": "codestar-notifications:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "notificationrule": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "CodeStarNotifications.ListTargets": [
            {
                "action": "codestar-notifications:ListTargets",
                "resource_mappings": {}
            }
        ],
        "CodeStarNotifications.Subscribe": [
            {
                "action": "codestar-notifications:Subscribe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "notificationrule": "${Arn}"
                }
            }
        ],
        "CodeStarNotifications.TagResource": [
            {
                "action": "codestar-notifications:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "notificationrule": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "CodeStarNotifications.Unsubscribe": [
            {
                "action": "codestar-notifications:Unsubscribe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "notificationrule": "${Arn}"
                }
            }
        ],
        "CodeStarNotifications.UntagResource": [
            {
                "action": "codestar-notifications:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "notificationrule": "%%iftemplatematch%${Arn}%%"
                }
            }
        ],
        "CodeStarNotifications.UpdateNotificationRule": [
            {
                "action": "codestar-notifications:UpdateNotificationRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "notificationrule": "${Arn}"
                }
            }
        ],
        "SavingsPlans.CreateSavingsPlan": [
            {
                "action": "savingsplans:CreateSavingsPlan",
                "resource_mappings": {}
            }
        ],
        "SavingsPlans.DeleteQueuedSavingsPlan": [
            {
                "action": "savingsplans:DeleteQueuedSavingsPlan",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${savingsPlanId}"
                    }
                }
            }
        ],
        "SavingsPlans.DescribeSavingsPlanRates": [
            {
                "action": "savingsplans:DescribeSavingsPlanRates",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${savingsPlanId}"
                    }
                }
            }
        ],
        "SavingsPlans.DescribeSavingsPlans": [
            {
                "action": "savingsplans:DescribeSavingsPlans",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "savingsplan": "${savingsPlanArns[]}"
                }
            }
        ],
        "SavingsPlans.DescribeSavingsPlansOfferingRates": [
            {
                "action": "savingsplans:DescribeSavingsPlansOfferingRates",
                "resource_mappings": {}
            }
        ],
        "SavingsPlans.DescribeSavingsPlansOfferings": [
            {
                "action": "savingsplans:DescribeSavingsPlansOfferings",
                "resource_mappings": {}
            }
        ],
        "SavingsPlans.ListTagsForResource": [
            {
                "action": "savingsplans:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "savingsplan": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "SavingsPlans.TagResource": [
            {
                "action": "savingsplans:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "savingsplan": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "SavingsPlans.UntagResource": [
            {
                "action": "savingsplans:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "savingsplan": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "MarketplaceCatalog.CancelChangeSet": [
            {
                "action": "aws-marketplace:CancelChangeSet",
                "resource_mappings": {}
            }
        ],
        "MarketplaceCatalog.DescribeChangeSet": [
            {
                "action": "aws-marketplace:DescribeChangeSet",
                "resource_mappings": {}
            }
        ],
        "MarketplaceCatalog.DescribeEntity": [
            {
                "action": "aws-marketplace:DescribeEntity",
                "resource_mappings": {}
            }
        ],
        "MarketplaceCatalog.ListChangeSets": [
            {
                "action": "aws-marketplace:ListChangeSets",
                "resource_mappings": {}
            }
        ],
        "MarketplaceCatalog.ListEntities": [
            {
                "action": "aws-marketplace:ListEntities",
                "resource_mappings": {}
            }
        ],
        "MarketplaceCatalog.StartChangeSet": [
            {
                "action": "aws-marketplace:StartChangeSet",
                "resource_mappings": {}
            }
        ],
        "DataExchange.CancelJob": [
            {
                "action": "dataexchange:CancelJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "DataExchange.CreateDataSet": [
            {
                "action": "dataexchange:CreateDataSet",
                "resource_mappings": {}
            }
        ],
        "DataExchange.CreateJob": [
            {
                "action": "dataexchange:CreateJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataExchange.CreateRevision": [
            {
                "action": "dataexchange:CreateRevision",
                "resource_mappings": {}
            }
        ],
        "DataExchange.DeleteAsset": [
            {
                "action": "dataexchange:DeleteAsset",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    },
                    "RevisionId": {
                        "template": "${RevisionId}"
                    },
                    "AssetId": {
                        "template": "${AssetId}"
                    }
                }
            }
        ],
        "DataExchange.DeleteDataSet": [
            {
                "action": "dataexchange:DeleteDataSet",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    }
                }
            }
        ],
        "DataExchange.DeleteRevision": [
            {
                "action": "dataexchange:DeleteRevision",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    },
                    "RevisionId": {
                        "template": "${RevisionId}"
                    }
                }
            }
        ],
        "DataExchange.GetAsset": [
            {
                "action": "dataexchange:GetAsset",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    },
                    "RevisionId": {
                        "template": "${RevisionId}"
                    },
                    "AssetId": {
                        "template": "${AssetId}"
                    }
                }
            }
        ],
        "DataExchange.GetDataSet": [
            {
                "action": "dataexchange:GetDataSet",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    }
                }
            }
        ],
        "DataExchange.GetJob": [
            {
                "action": "dataexchange:GetJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "DataExchange.GetRevision": [
            {
                "action": "dataexchange:GetRevision",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    },
                    "RevisionId": {
                        "template": "${RevisionId}"
                    }
                }
            }
        ],
        "DataExchange.ListDataSetRevisions": [
            {
                "action": "dataexchange:ListDataSetRevisions",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    },
                    "RevisionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataExchange.ListDataSets": [
            {
                "action": "dataexchange:ListDataSets",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataExchange.ListJobs": [
            {
                "action": "dataexchange:ListJobs",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataExchange.ListRevisionAssets": [
            {
                "action": "dataexchange:ListRevisionAssets",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    },
                    "RevisionId": {
                        "template": "${RevisionId}"
                    },
                    "AssetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataExchange.ListTagsForResource": [
            {
                "action": "dataexchange:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "data-sets": "%%iftemplatematch%${ResourceArn}%%",
                    "revisions": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DataExchange.StartJob": [
            {
                "action": "dataexchange:StartJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "DataExchange.TagResource": [
            {
                "action": "dataexchange:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "data-sets": "%%iftemplatematch%${ResourceArn}%%",
                    "revisions": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DataExchange.UntagResource": [
            {
                "action": "dataexchange:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "data-sets": "%%iftemplatematch%${ResourceArn}%%",
                    "revisions": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DataExchange.UpdateAsset": [
            {
                "action": "dataexchange:UpdateAsset",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    },
                    "RevisionId": {
                        "template": "${RevisionId}"
                    },
                    "AssetId": {
                        "template": "${AssetId}"
                    }
                }
            }
        ],
        "DataExchange.UpdateDataSet": [
            {
                "action": "dataexchange:UpdateDataSet",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    }
                }
            }
        ],
        "DataExchange.UpdateRevision": [
            {
                "action": "dataexchange:UpdateRevision",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    },
                    "RevisionId": {
                        "template": "${RevisionId}"
                    }
                }
            }
        ],
        "SESV2.CreateConfigurationSet": [
            {
                "action": "ses:CreateConfigurationSet",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.CreateConfigurationSetEventDestination": [
            {
                "action": "ses:CreateConfigurationSetEventDestination",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${EventDestination.KinesisFirehoseDestination.IAMRoleARN}"
                }
            }
        ],
        "SESV2.CreateDedicatedIpPool": [
            {
                "action": "ses:CreateDedicatedIpPool",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${PoolName}"
                    }
                }
            }
        ],
        "SESV2.CreateDeliverabilityTestReport": [
            {
                "action": "ses:CreateDeliverabilityTestReport",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.CreateEmailIdentity": [
            {
                "action": "ses:CreateEmailIdentity",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.DeleteConfigurationSet": [
            {
                "action": "ses:DeleteConfigurationSet",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.DeleteConfigurationSetEventDestination": [
            {
                "action": "ses:DeleteConfigurationSetEventDestination",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.DeleteCustomVerificationEmailTemplate": [
            {
                "action": "ses:DeleteCustomVerificationEmailTemplate",
                "resource_mappings": {}
            }
        ],
        "SESV2.DeleteDedicatedIpPool": [
            {
                "action": "ses:DeleteDedicatedIpPool",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${PoolName}"
                    }
                }
            }
        ],
        "SESV2.DeleteEmailIdentity": [
            {
                "action": "ses:DeleteEmailIdentity",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.GetAccount": [
            {
                "action": "ses:GetAccount",
                "resource_mappings": {}
            }
        ],
        "SESV2.GetBlacklistReports": [
            {
                "action": "ses:GetBlacklistReports",
                "resource_mappings": {}
            }
        ],
        "SESV2.GetConfigurationSet": [
            {
                "action": "ses:GetConfigurationSet",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.GetConfigurationSetEventDestinations": [
            {
                "action": "ses:GetConfigurationSetEventDestinations",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.GetCustomVerificationEmailTemplate": [
            {
                "action": "ses:GetCustomVerificationEmailTemplate",
                "resource_mappings": {}
            }
        ],
        "SESV2.GetDedicatedIp": [
            {
                "action": "ses:GetDedicatedIp",
                "resource_mappings": {}
            }
        ],
        "SESV2.GetDedicatedIps": [
            {
                "action": "ses:GetDedicatedIps",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${PoolName}"
                    }
                }
            }
        ],
        "SESV2.GetDeliverabilityDashboardOptions": [
            {
                "action": "ses:GetDeliverabilityDashboardOptions",
                "resource_mappings": {}
            }
        ],
        "SESV2.GetDeliverabilityTestReport": [
            {
                "action": "ses:GetDeliverabilityTestReport",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${ReportId}"
                    }
                }
            }
        ],
        "SESV2.GetDomainStatisticsReport": [
            {
                "action": "ses:GetDomainStatisticsReport",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.GetEmailIdentity": [
            {
                "action": "ses:GetEmailIdentity",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.ListConfigurationSets": [
            {
                "action": "ses:ListConfigurationSets",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListCustomVerificationEmailTemplates": [
            {
                "action": "ses:ListCustomVerificationEmailTemplates",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListDedicatedIpPools": [
            {
                "action": "ses:ListDedicatedIpPools",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListDeliverabilityTestReports": [
            {
                "action": "ses:ListDeliverabilityTestReports",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListEmailIdentities": [
            {
                "action": "ses:ListEmailIdentities",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListTagsForResource": [
            {
                "action": "ses:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "configuration-set": "%%iftemplatematch%${ResourceArn}%%",
                    "dedicated-ip-pool": "%%iftemplatematch%${ResourceArn}%%",
                    "deliverability-test-report": "%%iftemplatematch%${ResourceArn}%%",
                    "identity": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SESV2.PutAccountDedicatedIpWarmupAttributes": [
            {
                "action": "ses:PutAccountDedicatedIpWarmupAttributes",
                "resource_mappings": {}
            }
        ],
        "SESV2.PutAccountSendingAttributes": [
            {
                "action": "ses:PutAccountSendingAttributes",
                "resource_mappings": {}
            }
        ],
        "SESV2.PutConfigurationSetDeliveryOptions": [
            {
                "action": "ses:PutConfigurationSetDeliveryOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.PutConfigurationSetReputationOptions": [
            {
                "action": "ses:PutConfigurationSetReputationOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.PutConfigurationSetSendingOptions": [
            {
                "action": "ses:PutConfigurationSetSendingOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.PutConfigurationSetTrackingOptions": [
            {
                "action": "ses:PutConfigurationSetTrackingOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.PutDedicatedIpInPool": [
            {
                "action": "ses:PutDedicatedIpInPool",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${DestinationPoolName}"
                    }
                }
            }
        ],
        "SESV2.PutDedicatedIpWarmupAttributes": [
            {
                "action": "ses:PutDedicatedIpWarmupAttributes",
                "resource_mappings": {}
            }
        ],
        "SESV2.PutDeliverabilityDashboardOption": [
            {
                "action": "ses:PutDeliverabilityDashboardOption",
                "resource_mappings": {}
            }
        ],
        "SESV2.PutEmailIdentityDkimAttributes": [
            {
                "action": "ses:PutEmailIdentityDkimAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.PutEmailIdentityFeedbackAttributes": [
            {
                "action": "ses:PutEmailIdentityFeedbackAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.PutEmailIdentityMailFromAttributes": [
            {
                "action": "ses:PutEmailIdentityMailFromAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.SendCustomVerificationEmail": [
            {
                "action": "ses:SendCustomVerificationEmail",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.SendEmail": [
            {
                "action": "ses:SendEmail",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.TagResource": [
            {
                "action": "ses:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "configuration-set": "%%iftemplatematch%${ResourceArn}%%",
                    "dedicated-ip-pool": "%%iftemplatematch%${ResourceArn}%%",
                    "deliverability-test-report": "%%iftemplatematch%${ResourceArn}%%",
                    "identity": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SESV2.UntagResource": [
            {
                "action": "ses:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "configuration-set": "%%iftemplatematch%${ResourceArn}%%",
                    "dedicated-ip-pool": "%%iftemplatematch%${ResourceArn}%%",
                    "deliverability-test-report": "%%iftemplatematch%${ResourceArn}%%",
                    "identity": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SESV2.UpdateConfigurationSetEventDestination": [
            {
                "action": "ses:UpdateConfigurationSetEventDestination",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${EventDestination.KinesisFirehoseDestination.IAMRoleARN}"
                }
            }
        ],
        "SESV2.UpdateCustomVerificationEmailTemplate": [
            {
                "action": "ses:UpdateCustomVerificationEmailTemplate",
                "resource_mappings": {}
            }
        ],
        "MigrationHubConfig.CreateHomeRegionControl": [
            {
                "action": "mgh:CreateHomeRegionControl",
                "resource_mappings": {}
            }
        ],
        "MigrationHubConfig.DescribeHomeRegionControls": [
            {
                "action": "mgh:DescribeHomeRegionControls",
                "resource_mappings": {}
            }
        ],
        "MigrationHubConfig.GetHomeRegion": [
            {
                "action": "mgh:GetHomeRegion",
                "resource_mappings": {}
            }
        ],
        "AppConfig.CreateApplication": [
            {
                "action": "appconfig:CreateApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppConfig.CreateConfigurationProfile": [
            {
                "action": "appconfig:CreateConfigurationProfile",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RetrievalRoleArn}"
                }
            }
        ],
        "AppConfig.CreateDeploymentStrategy": [
            {
                "action": "appconfig:CreateDeploymentStrategy",
                "resource_mappings": {
                    "DeploymentStrategyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppConfig.CreateEnvironment": [
            {
                "action": "appconfig:CreateEnvironment",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "EnvironmentId": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppConfig.CreateHostedConfigurationVersion": [
            {
                "action": "appconfig:CreateHostedConfigurationVersion",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileId}"
                    },
                    "VersionNumber": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppConfig.DeleteApplication": [
            {
                "action": "appconfig:DeleteApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "AppConfig.DeleteConfigurationProfile": [
            {
                "action": "appconfig:DeleteConfigurationProfile",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileId}"
                    }
                }
            }
        ],
        "AppConfig.DeleteDeploymentStrategy": [
            {
                "action": "appconfig:DeleteDeploymentStrategy",
                "resource_mappings": {
                    "DeploymentStrategyId": {
                        "template": "${DeploymentStrategyId}"
                    }
                }
            }
        ],
        "AppConfig.DeleteEnvironment": [
            {
                "action": "appconfig:DeleteEnvironment",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "EnvironmentId": {
                        "template": "${EnvironmentId}"
                    }
                }
            }
        ],
        "AppConfig.DeleteHostedConfigurationVersion": [
            {
                "action": "appconfig:DeleteHostedConfigurationVersion",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileId}"
                    },
                    "VersionNumber": {
                        "template": "${VersionNumber}"
                    }
                }
            }
        ],
        "AppConfig.GetApplication": [
            {
                "action": "appconfig:GetApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "AppConfig.GetConfiguration": [
            {
                "action": "appconfig:GetConfiguration",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    },
                    "ConfigurationProfileId": {
                        "template": "*"
                    },
                    "EnvironmentId": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppConfig.GetConfigurationProfile": [
            {
                "action": "appconfig:GetConfigurationProfile",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileId}"
                    }
                }
            }
        ],
        "AppConfig.GetDeployment": [
            {
                "action": "appconfig:GetDeployment",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "EnvironmentId": {
                        "template": "${EnvironmentId}"
                    },
                    "DeploymentNumber": {
                        "template": "${DeploymentNumber}"
                    }
                }
            }
        ],
        "AppConfig.GetDeploymentStrategy": [
            {
                "action": "appconfig:GetDeploymentStrategy",
                "resource_mappings": {
                    "DeploymentStrategyId": {
                        "template": "${DeploymentStrategyId}"
                    }
                }
            }
        ],
        "AppConfig.GetEnvironment": [
            {
                "action": "appconfig:GetEnvironment",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "EnvironmentId": {
                        "template": "${EnvironmentId}"
                    }
                }
            }
        ],
        "AppConfig.GetHostedConfigurationVersion": [
            {
                "action": "appconfig:GetHostedConfigurationVersion",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileId}"
                    },
                    "VersionNumber": {
                        "template": "${VersionNumber}"
                    }
                }
            }
        ],
        "AppConfig.ListApplications": [
            {
                "action": "appconfig:ListApplications",
                "resource_mappings": {}
            }
        ],
        "AppConfig.ListConfigurationProfiles": [
            {
                "action": "appconfig:ListConfigurationProfiles",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "AppConfig.ListDeploymentStrategies": [
            {
                "action": "appconfig:ListDeploymentStrategies",
                "resource_mappings": {}
            }
        ],
        "AppConfig.ListDeployments": [
            {
                "action": "appconfig:ListDeployments",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "EnvironmentId": {
                        "template": "${EnvironmentId}"
                    }
                }
            }
        ],
        "AppConfig.ListEnvironments": [
            {
                "action": "appconfig:ListEnvironments",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "AppConfig.ListHostedConfigurationVersions": [
            {
                "action": "appconfig:ListHostedConfigurationVersions",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileId}"
                    }
                }
            }
        ],
        "AppConfig.ListTagsForResource": [
            {
                "action": "appconfig:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceArn}%%",
                    "configurationprofile": "%%iftemplatematch%${ResourceArn}%%",
                    "deployment": "%%iftemplatematch%${ResourceArn}%%",
                    "deploymentstrategy": "%%iftemplatematch%${ResourceArn}%%",
                    "environment": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AppConfig.StartDeployment": [
            {
                "action": "appconfig:StartDeployment",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileId}"
                    },
                    "EnvironmentId": {
                        "template": "${EnvironmentId}"
                    },
                    "DeploymentNumber": {
                        "template": "*"
                    },
                    "DeploymentStrategyId": {
                        "template": "${DeploymentStrategyId}"
                    }
                }
            }
        ],
        "AppConfig.StopDeployment": [
            {
                "action": "appconfig:StopDeployment",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "EnvironmentId": {
                        "template": "${EnvironmentId}"
                    },
                    "DeploymentNumber": {
                        "template": "${DeploymentNumber}"
                    }
                }
            }
        ],
        "AppConfig.TagResource": [
            {
                "action": "appconfig:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceArn}%%",
                    "configurationprofile": "%%iftemplatematch%${ResourceArn}%%",
                    "deployment": "%%iftemplatematch%${ResourceArn}%%",
                    "deploymentstrategy": "%%iftemplatematch%${ResourceArn}%%",
                    "environment": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AppConfig.UntagResource": [
            {
                "action": "appconfig:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceArn}%%",
                    "configurationprofile": "%%iftemplatematch%${ResourceArn}%%",
                    "deployment": "%%iftemplatematch%${ResourceArn}%%",
                    "deploymentstrategy": "%%iftemplatematch%${ResourceArn}%%",
                    "environment": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AppConfig.UpdateApplication": [
            {
                "action": "appconfig:UpdateApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "AppConfig.UpdateConfigurationProfile": [
            {
                "action": "appconfig:UpdateConfigurationProfile",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RetrievalRoleArn}"
                }
            }
        ],
        "AppConfig.UpdateDeploymentStrategy": [
            {
                "action": "appconfig:UpdateDeploymentStrategy",
                "resource_mappings": {
                    "DeploymentStrategyId": {
                        "template": "${DeploymentStrategyId}"
                    }
                }
            }
        ],
        "AppConfig.UpdateEnvironment": [
            {
                "action": "appconfig:UpdateEnvironment",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "EnvironmentId": {
                        "template": "${EnvironmentId}"
                    }
                }
            }
        ],
        "AppConfig.ValidateConfiguration": [
            {
                "action": "appconfig:ValidateConfiguration",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationId}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileId}"
                    }
                }
            }
        ],
        "IoTSecureTunneling.CloseTunnel": [
            {
                "action": "iot:CloseTunnel",
                "resource_mappings": {
                    "TunnelId": {
                        "template": "${tunnelId}"
                    }
                }
            }
        ],
        "IoTSecureTunneling.DescribeTunnel": [
            {
                "action": "iot:DescribeTunnel",
                "resource_mappings": {
                    "TunnelId": {
                        "template": "${tunnelId}"
                    }
                }
            }
        ],
        "IoTSecureTunneling.ListTagsForResource": [
            {
                "action": "iot:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "authorizer": "%%iftemplatematch%${resourceArn}%%",
                    "billinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "cacert": "%%iftemplatematch%${resourceArn}%%",
                    "dimension": "%%iftemplatematch%${resourceArn}%%",
                    "domainconfiguration": "%%iftemplatematch%${resourceArn}%%",
                    "dynamicthinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "fleetmetric": "%%iftemplatematch%${resourceArn}%%",
                    "job": "%%iftemplatematch%${resourceArn}%%",
                    "mitigationaction": "%%iftemplatematch%${resourceArn}%%",
                    "otaupdate": "%%iftemplatematch%${resourceArn}%%",
                    "policy": "%%iftemplatematch%${resourceArn}%%",
                    "provisioningtemplate": "%%iftemplatematch%${resourceArn}%%",
                    "rolealias": "%%iftemplatematch%${resourceArn}%%",
                    "rule": "%%iftemplatematch%${resourceArn}%%",
                    "scheduledaudit": "%%iftemplatematch%${resourceArn}%%",
                    "securityprofile": "%%iftemplatematch%${resourceArn}%%",
                    "stream": "%%iftemplatematch%${resourceArn}%%",
                    "thinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "thingtype": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTSecureTunneling.ListTunnels": [
            {
                "action": "iot:ListTunnels",
                "resource_mappings": {}
            }
        ],
        "IoTSecureTunneling.OpenTunnel": [
            {
                "action": "iot:OpenTunnel",
                "resource_mappings": {}
            }
        ],
        "IoTSecureTunneling.TagResource": [
            {
                "action": "iot:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "authorizer": "%%iftemplatematch%${resourceArn}%%",
                    "billinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "cacert": "%%iftemplatematch%${resourceArn}%%",
                    "dimension": "%%iftemplatematch%${resourceArn}%%",
                    "domainconfiguration": "%%iftemplatematch%${resourceArn}%%",
                    "dynamicthinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "fleetmetric": "%%iftemplatematch%${resourceArn}%%",
                    "job": "%%iftemplatematch%${resourceArn}%%",
                    "mitigationaction": "%%iftemplatematch%${resourceArn}%%",
                    "otaupdate": "%%iftemplatematch%${resourceArn}%%",
                    "policy": "%%iftemplatematch%${resourceArn}%%",
                    "provisioningtemplate": "%%iftemplatematch%${resourceArn}%%",
                    "rolealias": "%%iftemplatematch%${resourceArn}%%",
                    "rule": "%%iftemplatematch%${resourceArn}%%",
                    "scheduledaudit": "%%iftemplatematch%${resourceArn}%%",
                    "securityprofile": "%%iftemplatematch%${resourceArn}%%",
                    "stream": "%%iftemplatematch%${resourceArn}%%",
                    "thinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "thingtype": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTSecureTunneling.UntagResource": [
            {
                "action": "iot:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "authorizer": "%%iftemplatematch%${resourceArn}%%",
                    "billinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "cacert": "%%iftemplatematch%${resourceArn}%%",
                    "dimension": "%%iftemplatematch%${resourceArn}%%",
                    "domainconfiguration": "%%iftemplatematch%${resourceArn}%%",
                    "dynamicthinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "fleetmetric": "%%iftemplatematch%${resourceArn}%%",
                    "job": "%%iftemplatematch%${resourceArn}%%",
                    "mitigationaction": "%%iftemplatematch%${resourceArn}%%",
                    "otaupdate": "%%iftemplatematch%${resourceArn}%%",
                    "policy": "%%iftemplatematch%${resourceArn}%%",
                    "provisioningtemplate": "%%iftemplatematch%${resourceArn}%%",
                    "rolealias": "%%iftemplatematch%${resourceArn}%%",
                    "rule": "%%iftemplatematch%${resourceArn}%%",
                    "scheduledaudit": "%%iftemplatematch%${resourceArn}%%",
                    "securityprofile": "%%iftemplatematch%${resourceArn}%%",
                    "stream": "%%iftemplatematch%${resourceArn}%%",
                    "thinggroup": "%%iftemplatematch%${resourceArn}%%",
                    "thingtype": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "WAFV2.AssociateWebACL": [
            {
                "action": "wafv2:AssociateWebACL",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${WebACLArn}",
                    "apigateway": "%%iftemplatematch%${ResourceArn}%%",
                    "appsync": "%%iftemplatematch%${ResourceArn}%%",
                    "loadbalancer/app/": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "WAFV2.CheckCapacity": [
            {
                "action": "wafv2:CheckCapacity",
                "resource_mappings": {}
            }
        ],
        "WAFV2.CreateIPSet": [
            {
                "action": "wafv2:CreateIPSet",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFV2.CreateRegexPatternSet": [
            {
                "action": "wafv2:CreateRegexPatternSet",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFV2.CreateRuleGroup": [
            {
                "action": "wafv2:CreateRuleGroup",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFV2.CreateWebACL": [
            {
                "action": "wafv2:CreateWebACL",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFV2.DeleteFirewallManagerRuleGroups": [
            {
                "action": "wafv2:DeleteFirewallManagerRuleGroups",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${WebACLArn}"
                }
            }
        ],
        "WAFV2.DeleteIPSet": [
            {
                "action": "wafv2:DeleteIPSet",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.DeleteLoggingConfiguration": [
            {
                "action": "wafv2:DeleteLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${ResourceArn}"
                }
            }
        ],
        "WAFV2.DeletePermissionPolicy": [
            {
                "action": "wafv2:DeletePermissionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rulegroup": "${ResourceArn}"
                }
            }
        ],
        "WAFV2.DeleteRegexPatternSet": [
            {
                "action": "wafv2:DeleteRegexPatternSet",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.DeleteRuleGroup": [
            {
                "action": "wafv2:DeleteRuleGroup",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.DeleteWebACL": [
            {
                "action": "wafv2:DeleteWebACL",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.DescribeManagedRuleGroup": [
            {
                "action": "wafv2:DescribeManagedRuleGroup",
                "resource_mappings": {}
            }
        ],
        "WAFV2.DisassociateWebACL": [
            {
                "action": "wafv2:DisassociateWebACL",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "apigateway": "%%iftemplatematch%${ResourceArn}%%",
                    "appsync": "%%iftemplatematch%${ResourceArn}%%",
                    "loadbalancer/app/": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "WAFV2.GetIPSet": [
            {
                "action": "wafv2:GetIPSet",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.GetLoggingConfiguration": [
            {
                "action": "wafv2:GetLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${ResourceArn}"
                }
            }
        ],
        "WAFV2.GetPermissionPolicy": [
            {
                "action": "wafv2:GetPermissionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rulegroup": "${ResourceArn}"
                }
            }
        ],
        "WAFV2.GetRateBasedStatementManagedKeys": [
            {
                "action": "wafv2:GetRateBasedStatementManagedKeys",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${WebACLName}"
                    },
                    "Id": {
                        "template": "${WebACLId}"
                    }
                }
            }
        ],
        "WAFV2.GetRegexPatternSet": [
            {
                "action": "wafv2:GetRegexPatternSet",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.GetRuleGroup": [
            {
                "action": "wafv2:GetRuleGroup",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.GetSampledRequests": [
            {
                "action": "wafv2:GetSampledRequests",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${WebAclArn}"
                }
            }
        ],
        "WAFV2.GetWebACL": [
            {
                "action": "wafv2:GetWebACL",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.GetWebACLForResource": [
            {
                "action": "wafv2:GetWebACLForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "apigateway": "%%iftemplatematch%${ResourceArn}%%",
                    "appsync": "%%iftemplatematch%${ResourceArn}%%",
                    "loadbalancer/app/": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "WAFV2.ListAvailableManagedRuleGroups": [
            {
                "action": "wafv2:ListAvailableManagedRuleGroups",
                "resource_mappings": {}
            }
        ],
        "WAFV2.ListIPSets": [
            {
                "action": "wafv2:ListIPSets",
                "resource_mappings": {}
            }
        ],
        "WAFV2.ListLoggingConfigurations": [
            {
                "action": "wafv2:ListLoggingConfigurations",
                "resource_mappings": {}
            }
        ],
        "WAFV2.ListRegexPatternSets": [
            {
                "action": "wafv2:ListRegexPatternSets",
                "resource_mappings": {}
            }
        ],
        "WAFV2.ListResourcesForWebACL": [
            {
                "action": "wafv2:ListResourcesForWebACL",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${WebACLArn}"
                }
            }
        ],
        "WAFV2.ListRuleGroups": [
            {
                "action": "wafv2:ListRuleGroups",
                "resource_mappings": {}
            }
        ],
        "WAFV2.ListTagsForResource": [
            {
                "action": "wafv2:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ipset": "%%iftemplatematch%${ResourceARN}%%",
                    "regexpatternset": "%%iftemplatematch%${ResourceARN}%%",
                    "rulegroup": "%%iftemplatematch%${ResourceARN}%%",
                    "webacl": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WAFV2.ListWebACLs": [
            {
                "action": "wafv2:ListWebACLs",
                "resource_mappings": {}
            }
        ],
        "WAFV2.PutLoggingConfiguration": [
            {
                "action": "wafv2:PutLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "webacl": "${LoggingConfiguration.ResourceArn}"
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "WAFV2.PutPermissionPolicy": [
            {
                "action": "wafv2:PutPermissionPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rulegroup": "${ResourceArn}"
                }
            }
        ],
        "WAFV2.TagResource": [
            {
                "action": "wafv2:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ipset": "%%iftemplatematch%${ResourceARN}%%",
                    "regexpatternset": "%%iftemplatematch%${ResourceARN}%%",
                    "rulegroup": "%%iftemplatematch%${ResourceARN}%%",
                    "webacl": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WAFV2.UntagResource": [
            {
                "action": "wafv2:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ipset": "%%iftemplatematch%${ResourceARN}%%",
                    "regexpatternset": "%%iftemplatematch%${ResourceARN}%%",
                    "rulegroup": "%%iftemplatematch%${ResourceARN}%%",
                    "webacl": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "WAFV2.UpdateIPSet": [
            {
                "action": "wafv2:UpdateIPSet",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.UpdateRegexPatternSet": [
            {
                "action": "wafv2:UpdateRegexPatternSet",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.UpdateRuleGroup": [
            {
                "action": "wafv2:UpdateRuleGroup",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.UpdateWebACL": [
            {
                "action": "wafv2:UpdateWebACL",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Imagebuilder.CancelImageCreation": [
            {
                "action": "imagebuilder:CancelImageCreation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "image": "${imageBuildVersionArn}"
                }
            }
        ],
        "Imagebuilder.DeleteComponent": [
            {
                "action": "imagebuilder:DeleteComponent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "${componentBuildVersionArn}"
                }
            }
        ],
        "Imagebuilder.DeleteContainerRecipe": [
            {
                "action": "imagebuilder:DeleteContainerRecipe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "containerRecipe": "${containerRecipeArn}"
                }
            }
        ],
        "Imagebuilder.DeleteDistributionConfiguration": [
            {
                "action": "imagebuilder:DeleteDistributionConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "distributionConfiguration": "${distributionConfigurationArn}"
                }
            }
        ],
        "Imagebuilder.DeleteImage": [
            {
                "action": "imagebuilder:DeleteImage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "image": "${imageBuildVersionArn}"
                }
            }
        ],
        "Imagebuilder.DeleteImagePipeline": [
            {
                "action": "imagebuilder:DeleteImagePipeline",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imagePipeline": "${imagePipelineArn}"
                }
            }
        ],
        "Imagebuilder.DeleteImageRecipe": [
            {
                "action": "imagebuilder:DeleteImageRecipe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imageRecipe": "${imageRecipeArn}"
                }
            }
        ],
        "Imagebuilder.DeleteInfrastructureConfiguration": [
            {
                "action": "imagebuilder:DeleteInfrastructureConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "infrastructureConfiguration": "${infrastructureConfigurationArn}"
                }
            }
        ],
        "Imagebuilder.GetComponentPolicy": [
            {
                "action": "imagebuilder:GetComponentPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "${componentArn}"
                }
            }
        ],
        "Imagebuilder.GetContainerRecipe": [
            {
                "action": "imagebuilder:GetContainerRecipe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "containerRecipe": "${containerRecipeArn}"
                }
            }
        ],
        "Imagebuilder.GetContainerRecipePolicy": [
            {
                "action": "imagebuilder:GetContainerRecipePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "containerRecipe": "${containerRecipeArn}"
                }
            }
        ],
        "Imagebuilder.GetDistributionConfiguration": [
            {
                "action": "imagebuilder:GetDistributionConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "distributionConfiguration": "${distributionConfigurationArn}"
                }
            }
        ],
        "Imagebuilder.GetImage": [
            {
                "action": "imagebuilder:GetImage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "image": "${imageBuildVersionArn}"
                }
            }
        ],
        "Imagebuilder.GetImagePipeline": [
            {
                "action": "imagebuilder:GetImagePipeline",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imagePipeline": "${imagePipelineArn}"
                }
            }
        ],
        "Imagebuilder.GetImagePolicy": [
            {
                "action": "imagebuilder:GetImagePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "image": "${imageArn}"
                }
            }
        ],
        "Imagebuilder.GetImageRecipe": [
            {
                "action": "imagebuilder:GetImageRecipe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imageRecipe": "${imageRecipeArn}"
                }
            }
        ],
        "Imagebuilder.GetImageRecipePolicy": [
            {
                "action": "imagebuilder:GetImageRecipePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imageRecipe": "${imageRecipeArn}"
                }
            }
        ],
        "Imagebuilder.GetInfrastructureConfiguration": [
            {
                "action": "imagebuilder:GetInfrastructureConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "infrastructureConfiguration": "${infrastructureConfigurationArn}"
                }
            }
        ],
        "Imagebuilder.ListComponentBuildVersions": [
            {
                "action": "imagebuilder:ListComponentBuildVersions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "componentVersion": "${componentVersionArn}"
                }
            }
        ],
        "Imagebuilder.ListComponents": [
            {
                "action": "imagebuilder:ListComponents",
                "resource_mappings": {}
            }
        ],
        "Imagebuilder.ListContainerRecipes": [
            {
                "action": "imagebuilder:ListContainerRecipes",
                "resource_mappings": {}
            }
        ],
        "Imagebuilder.ListDistributionConfigurations": [
            {
                "action": "imagebuilder:ListDistributionConfigurations",
                "resource_mappings": {}
            }
        ],
        "Imagebuilder.ListImageBuildVersions": [
            {
                "action": "imagebuilder:ListImageBuildVersions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imageVersion": "${imageVersionArn}"
                }
            }
        ],
        "Imagebuilder.ListImagePipelineImages": [
            {
                "action": "imagebuilder:ListImagePipelineImages",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imagePipeline": "${imagePipelineArn}"
                }
            }
        ],
        "Imagebuilder.ListImagePipelines": [
            {
                "action": "imagebuilder:ListImagePipelines",
                "resource_mappings": {}
            }
        ],
        "Imagebuilder.ListImageRecipes": [
            {
                "action": "imagebuilder:ListImageRecipes",
                "resource_mappings": {}
            }
        ],
        "Imagebuilder.ListImages": [
            {
                "action": "imagebuilder:ListImages",
                "resource_mappings": {}
            }
        ],
        "Imagebuilder.ListInfrastructureConfigurations": [
            {
                "action": "imagebuilder:ListInfrastructureConfigurations",
                "resource_mappings": {}
            }
        ],
        "Imagebuilder.ListTagsForResource": [
            {
                "action": "imagebuilder:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "%%iftemplatematch%${resourceArn}%%",
                    "distributionConfiguration": "%%iftemplatematch%${resourceArn}%%",
                    "image": "%%iftemplatematch%${resourceArn}%%",
                    "imagePipeline": "%%iftemplatematch%${resourceArn}%%",
                    "imageRecipe": "%%iftemplatematch%${resourceArn}%%",
                    "infrastructureConfiguration": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Imagebuilder.PutComponentPolicy": [
            {
                "action": "imagebuilder:PutComponentPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "${componentArn}"
                }
            }
        ],
        "Imagebuilder.PutContainerRecipePolicy": [
            {
                "action": "imagebuilder:PutContainerRecipePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "containerRecipe": "${containerRecipeArn}"
                }
            }
        ],
        "Imagebuilder.PutImagePolicy": [
            {
                "action": "imagebuilder:PutImagePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "image": "${imageArn}"
                }
            }
        ],
        "Imagebuilder.PutImageRecipePolicy": [
            {
                "action": "imagebuilder:PutImageRecipePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imageRecipe": "${imageRecipeArn}"
                }
            }
        ],
        "Imagebuilder.TagResource": [
            {
                "action": "imagebuilder:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "%%iftemplatematch%${resourceArn}%%",
                    "containerRecipe": "%%iftemplatematch%${resourceArn}%%",
                    "distributionConfiguration": "%%iftemplatematch%${resourceArn}%%",
                    "image": "%%iftemplatematch%${resourceArn}%%",
                    "imagePipeline": "%%iftemplatematch%${resourceArn}%%",
                    "imageRecipe": "%%iftemplatematch%${resourceArn}%%",
                    "infrastructureConfiguration": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Imagebuilder.UntagResource": [
            {
                "action": "imagebuilder:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "%%iftemplatematch%${resourceArn}%%",
                    "containerRecipe": "%%iftemplatematch%${resourceArn}%%",
                    "distributionConfiguration": "%%iftemplatematch%${resourceArn}%%",
                    "image": "%%iftemplatematch%${resourceArn}%%",
                    "imagePipeline": "%%iftemplatematch%${resourceArn}%%",
                    "imageRecipe": "%%iftemplatematch%${resourceArn}%%",
                    "infrastructureConfiguration": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Imagebuilder.UpdateDistributionConfiguration": [
            {
                "action": "imagebuilder:UpdateDistributionConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "distributionConfiguration": "${distributionConfigurationArn}"
                }
            }
        ],
        "Imagebuilder.UpdateImagePipeline": [
            {
                "action": "imagebuilder:UpdateImagePipeline",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imagePipeline": "${imagePipelineArn}"
                }
            }
        ],
        "Schemas.CreateDiscoverer": [
            {
                "action": "schemas:CreateDiscoverer",
                "resource_mappings": {
                    "DiscovererId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Schemas.CreateRegistry": [
            {
                "action": "schemas:CreateRegistry",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    }
                }
            }
        ],
        "Schemas.CreateSchema": [
            {
                "action": "schemas:CreateSchema",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "Schemas.DeleteDiscoverer": [
            {
                "action": "schemas:DeleteDiscoverer",
                "resource_mappings": {
                    "DiscovererId": {
                        "template": "${DiscovererId}"
                    }
                }
            }
        ],
        "Schemas.DeleteRegistry": [
            {
                "action": "schemas:DeleteRegistry",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    }
                }
            }
        ],
        "Schemas.DeleteResourcePolicy": [
            {
                "action": "schemas:DeleteResourcePolicy",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    }
                }
            }
        ],
        "Schemas.DeleteSchema": [
            {
                "action": "schemas:DeleteSchema",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "Schemas.DeleteSchemaVersion": [
            {
                "action": "schemas:DeleteSchemaVersion",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "Schemas.DescribeCodeBinding": [
            {
                "action": "schemas:DescribeCodeBinding",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "Schemas.DescribeDiscoverer": [
            {
                "action": "schemas:DescribeDiscoverer",
                "resource_mappings": {
                    "DiscovererId": {
                        "template": "${DiscovererId}"
                    }
                }
            }
        ],
        "Schemas.DescribeRegistry": [
            {
                "action": "schemas:DescribeRegistry",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    }
                }
            }
        ],
        "Schemas.DescribeSchema": [
            {
                "action": "schemas:DescribeSchema",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "Schemas.ExportSchema": [
            {
                "action": "schemas:ExportSchema",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "Schemas.GetCodeBindingSource": [
            {
                "action": "schemas:GetCodeBindingSource",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "Schemas.GetDiscoveredSchema": [
            {
                "action": "schemas:GetDiscoveredSchema",
                "resource_mappings": {}
            }
        ],
        "Schemas.GetResourcePolicy": [
            {
                "action": "schemas:GetResourcePolicy",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    }
                }
            }
        ],
        "Schemas.ListDiscoverers": [
            {
                "action": "schemas:ListDiscoverers",
                "resource_mappings": {
                    "DiscovererId": {
                        "template": "${DiscovererIdPrefix}*"
                    }
                }
            }
        ],
        "Schemas.ListRegistries": [
            {
                "action": "schemas:ListRegistries",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryNamePrefix}*"
                    }
                }
            }
        ],
        "Schemas.ListSchemaVersions": [
            {
                "action": "schemas:ListSchemaVersions",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "Schemas.ListSchemas": [
            {
                "action": "schemas:ListSchemas",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaNamePrefix}*"
                    }
                }
            }
        ],
        "Schemas.ListTagsForResource": [
            {
                "action": "schemas:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "discoverer": "%%iftemplatematch%${ResourceArn}%%",
                    "registry": "%%iftemplatematch%${ResourceArn}%%",
                    "schema": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Schemas.PutCodeBinding": [
            {
                "action": "schemas:PutCodeBinding",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "Schemas.PutResourcePolicy": [
            {
                "action": "schemas:PutResourcePolicy",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    }
                }
            }
        ],
        "Schemas.SearchSchemas": [
            {
                "action": "schemas:SearchSchemas",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Schemas.StartDiscoverer": [
            {
                "action": "schemas:StartDiscoverer",
                "resource_mappings": {
                    "DiscovererId": {
                        "template": "${DiscovererId}"
                    }
                }
            }
        ],
        "Schemas.StopDiscoverer": [
            {
                "action": "schemas:StopDiscoverer",
                "resource_mappings": {
                    "DiscovererId": {
                        "template": "${DiscovererId}"
                    }
                }
            }
        ],
        "Schemas.TagResource": [
            {
                "action": "schemas:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "discoverer": "%%iftemplatematch%${ResourceArn}%%",
                    "registry": "%%iftemplatematch%${ResourceArn}%%",
                    "schema": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Schemas.UntagResource": [
            {
                "action": "schemas:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "discoverer": "%%iftemplatematch%${ResourceArn}%%",
                    "registry": "%%iftemplatematch%${ResourceArn}%%",
                    "schema": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Schemas.UpdateDiscoverer": [
            {
                "action": "schemas:UpdateDiscoverer",
                "resource_mappings": {
                    "DiscovererId": {
                        "template": "${DiscovererId}"
                    }
                }
            }
        ],
        "Schemas.UpdateRegistry": [
            {
                "action": "schemas:UpdateRegistry",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    }
                }
            }
        ],
        "Schemas.UpdateSchema": [
            {
                "action": "schemas:UpdateSchema",
                "resource_mappings": {
                    "RegistryName": {
                        "template": "${RegistryName}"
                    },
                    "SchemaName": {
                        "template": "${SchemaName}"
                    }
                }
            }
        ],
        "AccessAnalyzer.ApplyArchiveRule": [
            {
                "action": "access-analyzer:ApplyArchiveRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.CreateAnalyzer": [
            {
                "action": "access-analyzer:CreateAnalyzer",
                "resource_mappings": {
                    "AnalyzerName": {
                        "template": "${analyzerName}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "AccessAnalyzer.CreateArchiveRule": [
            {
                "action": "access-analyzer:CreateArchiveRule",
                "resource_mappings": {
                    "AnalyzerName": {
                        "template": "${analyzerName}"
                    },
                    "RuleName": {
                        "template": "${ruleName}"
                    }
                }
            }
        ],
        "AccessAnalyzer.DeleteAnalyzer": [
            {
                "action": "access-analyzer:DeleteAnalyzer",
                "resource_mappings": {
                    "AnalyzerName": {
                        "template": "${analyzerName}"
                    }
                }
            }
        ],
        "AccessAnalyzer.DeleteArchiveRule": [
            {
                "action": "access-analyzer:DeleteArchiveRule",
                "resource_mappings": {
                    "AnalyzerName": {
                        "template": "${analyzerName}"
                    },
                    "RuleName": {
                        "template": "${ruleName}"
                    }
                }
            }
        ],
        "AccessAnalyzer.GetAnalyzedResource": [
            {
                "action": "access-analyzer:GetAnalyzedResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.GetAnalyzer": [
            {
                "action": "access-analyzer:GetAnalyzer",
                "resource_mappings": {
                    "AnalyzerName": {
                        "template": "${analyzerName}"
                    }
                }
            }
        ],
        "AccessAnalyzer.GetArchiveRule": [
            {
                "action": "access-analyzer:GetArchiveRule",
                "resource_mappings": {
                    "AnalyzerName": {
                        "template": "${analyzerName}"
                    },
                    "RuleName": {
                        "template": "${ruleName}"
                    }
                }
            }
        ],
        "AccessAnalyzer.GetFinding": [
            {
                "action": "access-analyzer:GetFinding",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.ListAnalyzedResources": [
            {
                "action": "access-analyzer:ListAnalyzedResources",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.ListAnalyzers": [
            {
                "action": "access-analyzer:ListAnalyzers",
                "resource_mappings": {}
            }
        ],
        "AccessAnalyzer.ListArchiveRules": [
            {
                "action": "access-analyzer:ListArchiveRules",
                "resource_mappings": {
                    "AnalyzerName": {
                        "template": "${analyzerName}"
                    }
                }
            }
        ],
        "AccessAnalyzer.ListFindings": [
            {
                "action": "access-analyzer:ListFindings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.ListTagsForResource": [
            {
                "action": "access-analyzer:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AccessAnalyzer.StartResourceScan": [
            {
                "action": "access-analyzer:StartResourceScan",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.TagResource": [
            {
                "action": "access-analyzer:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AccessAnalyzer.UntagResource": [
            {
                "action": "access-analyzer:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AccessAnalyzer.UpdateArchiveRule": [
            {
                "action": "access-analyzer:UpdateArchiveRule",
                "resource_mappings": {
                    "AnalyzerName": {
                        "template": "${analyzerName}"
                    },
                    "RuleName": {
                        "template": "${ruleName}"
                    }
                }
            }
        ],
        "AccessAnalyzer.UpdateFindings": [
            {
                "action": "access-analyzer:UpdateFindings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "CodeGuruReviewer.DescribeRepositoryAssociation": [
            {
                "action": "codeguru-reviewer:DescribeRepositoryAssociation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "association": "${AssociationArn}"
                }
            }
        ],
        "CodeGuruReviewer.DisassociateRepository": [
            {
                "action": "codeguru-reviewer:DisassociateRepository",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "association": "${AssociationArn}"
                }
            },
            {
                "action": "codecommit:UntagResource",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeGuruReviewer.ListCodeReviews": [
            {
                "action": "codeguru-reviewer:ListCodeReviews",
                "resource_mappings": {}
            }
        ],
        "CodeGuruReviewer.ListRepositoryAssociations": [
            {
                "action": "codeguru-reviewer:ListRepositoryAssociations",
                "resource_mappings": {}
            }
        ],
        "CodeGuruProfiler.AddNotificationChannels": [
            {
                "action": "codeguru-profiler:AddNotificationChannels",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.BatchGetFrameMetricData": [
            {
                "action": "codeguru-profiler:BatchGetFrameMetricData",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.ConfigureAgent": [
            {
                "action": "codeguru-profiler:ConfigureAgent",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.CreateProfilingGroup": [
            {
                "action": "codeguru-profiler:CreateProfilingGroup",
                "resource_mappings": {}
            }
        ],
        "CodeGuruProfiler.DeleteProfilingGroup": [
            {
                "action": "codeguru-profiler:DeleteProfilingGroup",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.DescribeProfilingGroup": [
            {
                "action": "codeguru-profiler:DescribeProfilingGroup",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.GetFindingsReportAccountSummary": [
            {
                "action": "codeguru-profiler:GetFindingsReportAccountSummary",
                "resource_mappings": {}
            }
        ],
        "CodeGuruProfiler.GetNotificationConfiguration": [
            {
                "action": "codeguru-profiler:GetNotificationConfiguration",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.GetPolicy": [
            {
                "action": "codeguru-profiler:GetPolicy",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.GetProfile": [
            {
                "action": "codeguru-profiler:GetProfile",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.GetRecommendations": [
            {
                "action": "codeguru-profiler:GetRecommendations",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.ListFindingsReports": [
            {
                "action": "codeguru-profiler:ListFindingsReports",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.ListProfileTimes": [
            {
                "action": "codeguru-profiler:ListProfileTimes",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.ListProfilingGroups": [
            {
                "action": "codeguru-profiler:ListProfilingGroups",
                "resource_mappings": {}
            }
        ],
        "CodeGuruProfiler.ListTagsForResource": [
            {
                "action": "codeguru-profiler:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ProfilingGroup": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeGuruProfiler.PostAgentProfile": [
            {
                "action": "codeguru-profiler:PostAgentProfile",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.PutPermission": [
            {
                "action": "codeguru-profiler:PutPermission",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.RemoveNotificationChannel": [
            {
                "action": "codeguru-profiler:RemoveNotificationChannel",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.RemovePermission": [
            {
                "action": "codeguru-profiler:RemovePermission",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.SubmitFeedback": [
            {
                "action": "codeguru-profiler:SubmitFeedback",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "CodeGuruProfiler.TagResource": [
            {
                "action": "codeguru-profiler:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ProfilingGroup": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeGuruProfiler.UntagResource": [
            {
                "action": "codeguru-profiler:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ProfilingGroup": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeGuruProfiler.UpdateProfilingGroup": [
            {
                "action": "codeguru-profiler:UpdateProfilingGroup",
                "resource_mappings": {
                    "profilingGroupName": {
                        "template": "${profilingGroupName}"
                    }
                }
            }
        ],
        "ComputeOptimizer.DescribeRecommendationExportJobs": [
            {
                "action": "compute-optimizer:DescribeRecommendationExportJobs",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.ExportAutoScalingGroupRecommendations": [
            {
                "action": "compute-optimizer:ExportAutoScalingGroupRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "autoscaling:DescribeAutoScalingGroups",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.ExportEC2InstanceRecommendations": [
            {
                "action": "compute-optimizer:ExportEC2InstanceRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "compute-optimizer:GetEC2InstanceRecommendations",
                "documented_dependant_action": true
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.GetAutoScalingGroupRecommendations": [
            {
                "action": "compute-optimizer:GetAutoScalingGroupRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "autoscaling:DescribeAutoScalingGroups",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.GetEBSVolumeRecommendations": [
            {
                "action": "compute-optimizer:GetEBSVolumeRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVolumes",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.GetEC2InstanceRecommendations": [
            {
                "action": "compute-optimizer:GetEC2InstanceRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.GetEC2RecommendationProjectedMetrics": [
            {
                "action": "compute-optimizer:GetEC2RecommendationProjectedMetrics",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.GetEnrollmentStatus": [
            {
                "action": "compute-optimizer:GetEnrollmentStatus",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.GetLambdaFunctionRecommendations": [
            {
                "action": "compute-optimizer:GetLambdaFunctionRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "lambda:ListFunctions",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.GetRecommendationSummaries": [
            {
                "action": "compute-optimizer:GetRecommendationSummaries",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.UpdateEnrollmentStatus": [
            {
                "action": "compute-optimizer:UpdateEnrollmentStatus",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.BatchCreateVariable": [
            {
                "action": "frauddetector:BatchCreateVariable",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.BatchGetVariable": [
            {
                "action": "frauddetector:BatchGetVariable",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${names[]}"
                    }
                }
            }
        ],
        "FraudDetector.CreateDetectorVersion": [
            {
                "action": "frauddetector:CreateDetectorVersion",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${detectorId}"
                    }
                }
            }
        ],
        "FraudDetector.CreateModel": [
            {
                "action": "frauddetector:CreateModel",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${modelId}"
                    }
                }
            }
        ],
        "FraudDetector.CreateModelVersion": [
            {
                "action": "frauddetector:CreateModelVersion",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${modelId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${externalEventsDetail.dataAccessRoleArn}"
                }
            }
        ],
        "FraudDetector.CreateRule": [
            {
                "action": "frauddetector:CreateRule",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${detectorId}"
                    }
                }
            }
        ],
        "FraudDetector.CreateVariable": [
            {
                "action": "frauddetector:CreateVariable",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.DeleteDetector": [
            {
                "action": "frauddetector:DeleteDetector",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${detectorId}"
                    }
                }
            }
        ],
        "FraudDetector.DeleteDetectorVersion": [
            {
                "action": "frauddetector:DeleteDetectorVersion",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.DeleteEntityType": [
            {
                "action": "frauddetector:DeleteEntityType",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.DeleteEvent": [
            {
                "action": "frauddetector:DeleteEvent",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.DeleteEventType": [
            {
                "action": "frauddetector:DeleteEventType",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.DeleteExternalModel": [
            {
                "action": "frauddetector:DeleteExternalModel",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.DeleteLabel": [
            {
                "action": "frauddetector:DeleteLabel",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.DeleteModel": [
            {
                "action": "frauddetector:DeleteModel",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${modelId}"
                    }
                }
            }
        ],
        "FraudDetector.DeleteModelVersion": [
            {
                "action": "frauddetector:DeleteModelVersion",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.DeleteOutcome": [
            {
                "action": "frauddetector:DeleteOutcome",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.DeleteRule": [
            {
                "action": "frauddetector:DeleteRule",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${rule.ruleId}"
                    }
                }
            }
        ],
        "FraudDetector.DeleteVariable": [
            {
                "action": "frauddetector:DeleteVariable",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.DescribeDetector": [
            {
                "action": "frauddetector:DescribeDetector",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${detectorId}"
                    }
                }
            }
        ],
        "FraudDetector.DescribeModelVersions": [
            {
                "action": "frauddetector:DescribeModelVersions",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.GetDetectorVersion": [
            {
                "action": "frauddetector:GetDetectorVersion",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.GetDetectors": [
            {
                "action": "frauddetector:GetDetectors",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${detectorId}"
                    }
                }
            }
        ],
        "FraudDetector.GetEntityTypes": [
            {
                "action": "frauddetector:GetEntityTypes",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.GetEventPrediction": [
            {
                "action": "frauddetector:GetEventPrediction",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.GetEventTypes": [
            {
                "action": "frauddetector:GetEventTypes",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.GetExternalModels": [
            {
                "action": "frauddetector:GetExternalModels",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.GetKMSEncryptionKey": [
            {
                "action": "frauddetector:GetKMSEncryptionKey",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.GetLabels": [
            {
                "action": "frauddetector:GetLabels",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.GetModelVersion": [
            {
                "action": "frauddetector:GetModelVersion",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.GetModels": [
            {
                "action": "frauddetector:GetModels",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${modelId}"
                    }
                }
            }
        ],
        "FraudDetector.GetOutcomes": [
            {
                "action": "frauddetector:GetOutcomes",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.GetRules": [
            {
                "action": "frauddetector:GetRules",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${ruleId}"
                    }
                }
            }
        ],
        "FraudDetector.GetVariables": [
            {
                "action": "frauddetector:GetVariables",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.ListTagsForResource": [
            {
                "action": "frauddetector:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "detector": "%%iftemplatematch%${resourceARN}%%",
                    "detector-version": "%%iftemplatematch%${resourceARN}%%",
                    "entity-type": "%%iftemplatematch%${resourceARN}%%",
                    "event-type": "%%iftemplatematch%${resourceARN}%%",
                    "external-model": "%%iftemplatematch%${resourceARN}%%",
                    "label": "%%iftemplatematch%${resourceARN}%%",
                    "model": "%%iftemplatematch%${resourceARN}%%",
                    "model-version": "%%iftemplatematch%${resourceARN}%%",
                    "outcome": "%%iftemplatematch%${resourceARN}%%",
                    "rule": "%%iftemplatematch%${resourceARN}%%",
                    "variable": "%%iftemplatematch%${resourceARN}%%"
                }
            }
        ],
        "FraudDetector.PutDetector": [
            {
                "action": "frauddetector:PutDetector",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${detectorId}"
                    }
                }
            }
        ],
        "FraudDetector.PutEntityType": [
            {
                "action": "frauddetector:PutEntityType",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.PutEventType": [
            {
                "action": "frauddetector:PutEventType",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.PutExternalModel": [
            {
                "action": "frauddetector:PutExternalModel",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${invokeModelEndpointRoleArn}"
                }
            }
        ],
        "FraudDetector.PutKMSEncryptionKey": [
            {
                "action": "frauddetector:PutKMSEncryptionKey",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.PutLabel": [
            {
                "action": "frauddetector:PutLabel",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.PutOutcome": [
            {
                "action": "frauddetector:PutOutcome",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "FraudDetector.TagResource": [
            {
                "action": "frauddetector:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "detector": "%%iftemplatematch%${resourceARN}%%",
                    "detector-version": "%%iftemplatematch%${resourceARN}%%",
                    "entity-type": "%%iftemplatematch%${resourceARN}%%",
                    "event-type": "%%iftemplatematch%${resourceARN}%%",
                    "external-model": "%%iftemplatematch%${resourceARN}%%",
                    "label": "%%iftemplatematch%${resourceARN}%%",
                    "model": "%%iftemplatematch%${resourceARN}%%",
                    "model-version": "%%iftemplatematch%${resourceARN}%%",
                    "outcome": "%%iftemplatematch%${resourceARN}%%",
                    "rule": "%%iftemplatematch%${resourceARN}%%",
                    "variable": "%%iftemplatematch%${resourceARN}%%"
                }
            }
        ],
        "FraudDetector.UntagResource": [
            {
                "action": "frauddetector:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "detector": "%%iftemplatematch%${resourceARN}%%",
                    "detector-version": "%%iftemplatematch%${resourceARN}%%",
                    "entity-type": "%%iftemplatematch%${resourceARN}%%",
                    "event-type": "%%iftemplatematch%${resourceARN}%%",
                    "external-model": "%%iftemplatematch%${resourceARN}%%",
                    "label": "%%iftemplatematch%${resourceARN}%%",
                    "model": "%%iftemplatematch%${resourceARN}%%",
                    "model-version": "%%iftemplatematch%${resourceARN}%%",
                    "outcome": "%%iftemplatematch%${resourceARN}%%",
                    "rule": "%%iftemplatematch%${resourceARN}%%",
                    "variable": "%%iftemplatematch%${resourceARN}%%"
                }
            }
        ],
        "FraudDetector.UpdateDetectorVersion": [
            {
                "action": "frauddetector:UpdateDetectorVersion",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${detectorId}"
                    }
                }
            }
        ],
        "FraudDetector.UpdateDetectorVersionMetadata": [
            {
                "action": "frauddetector:UpdateDetectorVersionMetadata",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.UpdateDetectorVersionStatus": [
            {
                "action": "frauddetector:UpdateDetectorVersionStatus",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.UpdateModel": [
            {
                "action": "frauddetector:UpdateModel",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${modelId}"
                    }
                }
            }
        ],
        "FraudDetector.UpdateModelVersion": [
            {
                "action": "frauddetector:UpdateModelVersion",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${modelId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${externalEventsDetail.dataAccessRoleArn}"
                }
            }
        ],
        "FraudDetector.UpdateModelVersionStatus": [
            {
                "action": "frauddetector:UpdateModelVersionStatus",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.UpdateRuleMetadata": [
            {
                "action": "frauddetector:UpdateRuleMetadata",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${rule.ruleId}"
                    }
                }
            }
        ],
        "FraudDetector.UpdateRuleVersion": [
            {
                "action": "frauddetector:UpdateRuleVersion",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${rule.ruleId}"
                    }
                }
            }
        ],
        "FraudDetector.UpdateVariable": [
            {
                "action": "frauddetector:UpdateVariable",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Kendra.BatchDeleteDocument": [
            {
                "action": "kendra:BatchDeleteDocument",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.BatchPutDocument": [
            {
                "action": "kendra:BatchPutDocument",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Kendra.CreateDataSource": [
            {
                "action": "kendra:CreateDataSource",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Kendra.CreateFaq": [
            {
                "action": "kendra:CreateFaq",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Kendra.CreateIndex": [
            {
                "action": "kendra:CreateIndex",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Kendra.CreateThesaurus": [
            {
                "action": "kendra:CreateThesaurus",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.DeleteDataSource": [
            {
                "action": "kendra:DeleteDataSource",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DeleteFaq": [
            {
                "action": "kendra:DeleteFaq",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "FaqId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DeleteIndex": [
            {
                "action": "kendra:DeleteIndex",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DeleteThesaurus": [
            {
                "action": "kendra:DeleteThesaurus",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ThesaurusId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DescribeDataSource": [
            {
                "action": "kendra:DescribeDataSource",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DescribeFaq": [
            {
                "action": "kendra:DescribeFaq",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "FaqId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DescribeIndex": [
            {
                "action": "kendra:DescribeIndex",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DescribeThesaurus": [
            {
                "action": "kendra:DescribeThesaurus",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ThesaurusId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.ListDataSourceSyncJobs": [
            {
                "action": "kendra:ListDataSourceSyncJobs",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.ListDataSources": [
            {
                "action": "kendra:ListDataSources",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.ListFaqs": [
            {
                "action": "kendra:ListFaqs",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.ListIndices": [
            {
                "action": "kendra:ListIndices",
                "resource_mappings": {}
            }
        ],
        "Kendra.ListTagsForResource": [
            {
                "action": "kendra:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "data-source": "%%iftemplatematch%${ResourceARN}%%",
                    "faq": "%%iftemplatematch%${ResourceARN}%%",
                    "index": "%%iftemplatematch%${ResourceARN}%%",
                    "thesaurus": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Kendra.ListThesauri": [
            {
                "action": "kendra:ListThesauri",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.StartDataSourceSyncJob": [
            {
                "action": "kendra:Query",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            },
            {
                "action": "kendra:StartDataSourceSyncJob",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.StopDataSourceSyncJob": [
            {
                "action": "kendra:StopDataSourceSyncJob",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.SubmitFeedback": [
            {
                "action": "kendra:SubmitFeedback",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.TagResource": [
            {
                "action": "kendra:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "data-source": "%%iftemplatematch%${ResourceARN}%%",
                    "faq": "%%iftemplatematch%${ResourceARN}%%",
                    "index": "%%iftemplatematch%${ResourceARN}%%",
                    "thesaurus": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Kendra.UntagResource": [
            {
                "action": "kendra:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "data-source": "%%iftemplatematch%${ResourceARN}%%",
                    "faq": "%%iftemplatematch%${ResourceARN}%%",
                    "index": "%%iftemplatematch%${ResourceARN}%%",
                    "thesaurus": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Kendra.UpdateDataSource": [
            {
                "action": "kendra:UpdateDataSource",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${Id}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Kendra.UpdateIndex": [
            {
                "action": "kendra:UpdateIndex",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${Id}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${RoleArn}"
                }
            }
        ],
        "Kendra.UpdateThesaurus": [
            {
                "action": "kendra:UpdateThesaurus",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ThesaurusId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "NetworkManager.AssociateCustomerGateway": [
            {
                "action": "networkmanager:AssociateCustomerGateway",
                "resource_mappings": {
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    },
                    "ResourceId": {
                        "template": "${LinkId}"
                    }
                }
            }
        ],
        "NetworkManager.AssociateLink": [
            {
                "action": "networkmanager:AssociateLink",
                "resource_mappings": {
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    },
                    "ResourceId": {
                        "template": "${LinkId}"
                    }
                }
            }
        ],
        "NetworkManager.AssociateTransitGatewayConnectPeer": [
            {
                "action": "networkmanager:AssociateTransitGatewayConnectPeer",
                "resource_mappings": {
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    },
                    "ResourceId": {
                        "template": "${LinkId}"
                    }
                }
            }
        ],
        "NetworkManager.CreateConnection": [
            {
                "action": "networkmanager:CreateConnection",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.CreateDevice": [
            {
                "action": "networkmanager:CreateDevice",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.CreateGlobalNetwork": [
            {
                "action": "networkmanager:CreateGlobalNetwork",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "NetworkManager.CreateLink": [
            {
                "action": "networkmanager:CreateLink",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SiteId}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.CreateSite": [
            {
                "action": "networkmanager:CreateSite",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteConnection": [
            {
                "action": "networkmanager:DeleteConnection",
                "resource_mappings": {
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    },
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteDevice": [
            {
                "action": "networkmanager:DeleteDevice",
                "resource_mappings": {
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    },
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteGlobalNetwork": [
            {
                "action": "networkmanager:DeleteGlobalNetwork",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteLink": [
            {
                "action": "networkmanager:DeleteLink",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${LinkId}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteSite": [
            {
                "action": "networkmanager:DeleteSite",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SiteId}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DeregisterTransitGateway": [
            {
                "action": "networkmanager:DeregisterTransitGateway",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DescribeGlobalNetworks": [
            {
                "action": "networkmanager:DescribeGlobalNetworks",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkIds[]}"
                    }
                }
            }
        ],
        "NetworkManager.DisassociateCustomerGateway": [
            {
                "action": "networkmanager:DisassociateCustomerGateway",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DisassociateLink": [
            {
                "action": "networkmanager:DisassociateLink",
                "resource_mappings": {
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    },
                    "ResourceId": {
                        "template": "${LinkId}"
                    }
                }
            }
        ],
        "NetworkManager.DisassociateTransitGatewayConnectPeer": [
            {
                "action": "networkmanager:DisassociateTransitGatewayConnectPeer",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetConnections": [
            {
                "action": "networkmanager:GetConnections",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ConnectionIds[]}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetCustomerGatewayAssociations": [
            {
                "action": "networkmanager:GetCustomerGatewayAssociations",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetDevices": [
            {
                "action": "networkmanager:GetDevices",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${DeviceIds[]}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetLinkAssociations": [
            {
                "action": "networkmanager:GetLinkAssociations",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${LinkId}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetLinks": [
            {
                "action": "networkmanager:GetLinks",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${LinkIds[]}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetSites": [
            {
                "action": "networkmanager:GetSites",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SiteIds[]}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetTransitGatewayConnectPeerAssociations": [
            {
                "action": "networkmanager:GetTransitGatewayConnectPeerAssociations",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetTransitGatewayRegistrations": [
            {
                "action": "networkmanager:GetTransitGatewayRegistrations",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.ListTagsForResource": [
            {
                "action": "networkmanager:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "connection": "%%iftemplatematch%${ResourceArn}%%",
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "global-network": "%%iftemplatematch%${ResourceArn}%%",
                    "link": "%%iftemplatematch%${ResourceArn}%%",
                    "site": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "NetworkManager.RegisterTransitGateway": [
            {
                "action": "networkmanager:RegisterTransitGateway",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.TagResource": [
            {
                "action": "networkmanager:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "connection": "%%iftemplatematch%${ResourceArn}%%",
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "global-network": "%%iftemplatematch%${ResourceArn}%%",
                    "link": "%%iftemplatematch%${ResourceArn}%%",
                    "site": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "NetworkManager.UntagResource": [
            {
                "action": "networkmanager:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "connection": "%%iftemplatematch%${ResourceArn}%%",
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "global-network": "%%iftemplatematch%${ResourceArn}%%",
                    "link": "%%iftemplatematch%${ResourceArn}%%",
                    "site": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "NetworkManager.UpdateConnection": [
            {
                "action": "networkmanager:UpdateConnection",
                "resource_mappings": {
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    },
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.UpdateDevice": [
            {
                "action": "networkmanager:UpdateDevice",
                "resource_mappings": {
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    },
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.UpdateGlobalNetwork": [
            {
                "action": "networkmanager:UpdateGlobalNetwork",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.UpdateLink": [
            {
                "action": "networkmanager:UpdateLink",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${LinkId}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.UpdateSite": [
            {
                "action": "networkmanager:UpdateSite",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SiteId}"
                    },
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "Outposts.CreateOutpost": [
            {
                "action": "outposts:CreateOutpost",
                "resource_mappings": {}
            }
        ],
        "Outposts.DeleteOutpost": [
            {
                "action": "outposts:DeleteOutpost",
                "resource_mappings": {}
            }
        ],
        "Outposts.DeleteSite": [
            {
                "action": "outposts:DeleteSite",
                "resource_mappings": {}
            }
        ],
        "Outposts.GetOutpost": [
            {
                "action": "outposts:GetOutpost",
                "resource_mappings": {}
            }
        ],
        "Outposts.GetOutpostInstanceTypes": [
            {
                "action": "outposts:GetOutpostInstanceTypes",
                "resource_mappings": {}
            }
        ],
        "Outposts.ListOutposts": [
            {
                "action": "outposts:ListOutposts",
                "resource_mappings": {}
            }
        ],
        "Outposts.ListSites": [
            {
                "action": "outposts:ListSites",
                "resource_mappings": {}
            }
        ],
        "Outposts.ListTagsForResource": [
            {
                "action": "outposts:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Outposts.TagResource": [
            {
                "action": "outposts:TagResource",
                "resource_mappings": {}
            }
        ],
        "Outposts.UntagResource": [
            {
                "action": "outposts:UntagResource",
                "resource_mappings": {}
            }
        ],
        "AugmentedAIRuntime.DeleteHumanLoop": [
            {
                "action": "sagemaker:DeleteHumanLoop",
                "resource_mappings": {
                    "HumanLoopName": {
                        "template": "${HumanLoopName}"
                    }
                }
            }
        ],
        "AugmentedAIRuntime.DescribeHumanLoop": [
            {
                "action": "sagemaker:DescribeHumanLoop",
                "resource_mappings": {
                    "HumanLoopName": {
                        "template": "${HumanLoopName}"
                    }
                }
            }
        ],
        "AugmentedAIRuntime.ListHumanLoops": [
            {
                "action": "sagemaker:ListHumanLoops",
                "resource_mappings": {}
            }
        ],
        "AugmentedAIRuntime.StartHumanLoop": [
            {
                "action": "sagemaker:StartHumanLoop",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "flow-definition": "${FlowDefinitionArn}"
                }
            }
        ],
        "AugmentedAIRuntime.StopHumanLoop": [
            {
                "action": "sagemaker:StopHumanLoop",
                "resource_mappings": {
                    "HumanLoopName": {
                        "template": "${HumanLoopName}"
                    }
                }
            }
        ],
        "EBS.CompleteSnapshot": [
            {
                "action": "ebs:CompleteSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EBS.GetSnapshotBlock": [
            {
                "action": "ebs:GetSnapshotBlock",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EBS.ListChangedBlocks": [
            {
                "action": "ebs:ListChangedBlocks",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "%%many%${FirstSnapshotId}%${SecondSnapshotId}%%"
                    }
                }
            }
        ],
        "EBS.ListSnapshotBlocks": [
            {
                "action": "ebs:ListSnapshotBlocks",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EBS.PutSnapshotBlock": [
            {
                "action": "ebs:PutSnapshotBlock",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EBS.StartSnapshot": [
            {
                "action": "ebs:StartSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "KinesisVideoSignalingChannels.GetIceServerConfig": [
            {
                "action": "kinesisvideo:GetIceServerConfig",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "${ChannelARN}"
                }
            }
        ],
        "KinesisVideoSignalingChannels.SendAlexaOfferToMaster": [
            {
                "action": "kinesisvideo:SendAlexaOfferToMaster",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "${ChannelARN}"
                }
            }
        ],
        "Detective.CreateGraph": [
            {
                "action": "detective:CreateGraph",
                "resource_mappings": {}
            }
        ],
        "Detective.CreateMembers": [
            {
                "action": "detective:CreateMembers",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "${GraphArn}"
                }
            }
        ],
        "Detective.DeleteGraph": [
            {
                "action": "detective:DeleteGraph",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "${GraphArn}"
                }
            }
        ],
        "Detective.DeleteMembers": [
            {
                "action": "detective:DeleteMembers",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "${GraphArn}"
                }
            }
        ],
        "Detective.GetMembers": [
            {
                "action": "detective:GetMembers",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "${GraphArn}"
                }
            }
        ],
        "Detective.ListGraphs": [
            {
                "action": "detective:ListGraphs",
                "resource_mappings": {}
            }
        ],
        "Detective.ListInvitations": [
            {
                "action": "detective:ListInvitations",
                "resource_mappings": {}
            }
        ],
        "Detective.ListMembers": [
            {
                "action": "detective:ListMembers",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "${GraphArn}"
                }
            }
        ],
        "Detective.StartMonitoringMember": [
            {
                "action": "detective:StartMonitoringMember",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "${GraphArn}"
                }
            }
        ],
        "CodeStarconnections.CreateConnection": [
            {
                "action": "codestar-connections:CreateConnection",
                "resource_mappings": {}
            }
        ],
        "CodeStarconnections.CreateHost": [
            {
                "action": "codestar-connections:CreateHost",
                "resource_mappings": {}
            }
        ],
        "CodeStarconnections.DeleteConnection": [
            {
                "action": "codestar-connections:DeleteConnection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Connection": "${ConnectionArn}"
                }
            }
        ],
        "CodeStarconnections.DeleteHost": [
            {
                "action": "codestar-connections:DeleteHost",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Host": "${HostArn}"
                }
            }
        ],
        "CodeStarconnections.GetConnection": [
            {
                "action": "codestar-connections:GetConnection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Connection": "${ConnectionArn}"
                }
            }
        ],
        "CodeStarconnections.GetHost": [
            {
                "action": "codestar-connections:GetHost",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Host": "${HostArn}"
                }
            }
        ],
        "CodeStarconnections.ListConnections": [
            {
                "action": "codestar-connections:ListConnections",
                "resource_mappings": {}
            }
        ],
        "CodeStarconnections.ListHosts": [
            {
                "action": "codestar-connections:ListHosts",
                "resource_mappings": {}
            }
        ],
        "CodeStarconnections.ListTagsForResource": [
            {
                "action": "codestar-connections:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Connection": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CodeStarconnections.TagResource": [
            {
                "action": "codestar-connections:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Connection": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CodeStarconnections.UntagResource": [
            {
                "action": "codestar-connections:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Connection": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "CodeStarconnections.UpdateHost": [
            {
                "action": "codestar-connections:UpdateHost",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Host": "${HostArn}"
                }
            }
        ],
        "Synthetics.CreateCanary": [
            {
                "action": "synthetics:CreateCanary",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ExecutionRoleArn}"
                }
            }
        ],
        "Synthetics.DeleteCanary": [
            {
                "action": "synthetics:DeleteCanary",
                "resource_mappings": {
                    "CanaryName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Synthetics.DescribeCanaries": [
            {
                "action": "synthetics:DescribeCanaries",
                "resource_mappings": {}
            }
        ],
        "Synthetics.DescribeCanariesLastRun": [
            {
                "action": "synthetics:DescribeCanariesLastRun",
                "resource_mappings": {}
            }
        ],
        "Synthetics.GetCanaryRuns": [
            {
                "action": "synthetics:GetCanaryRuns",
                "resource_mappings": {
                    "CanaryName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Synthetics.ListTagsForResource": [
            {
                "action": "synthetics:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "canary": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Synthetics.StartCanary": [
            {
                "action": "synthetics:StartCanary",
                "resource_mappings": {
                    "CanaryName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Synthetics.StopCanary": [
            {
                "action": "synthetics:StopCanary",
                "resource_mappings": {
                    "CanaryName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Synthetics.TagResource": [
            {
                "action": "synthetics:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "canary": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Synthetics.UntagResource": [
            {
                "action": "synthetics:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "canary": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Synthetics.UpdateCanary": [
            {
                "action": "synthetics:UpdateCanary",
                "resource_mappings": {
                    "CanaryName": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${ExecutionRoleArn}"
                }
            }
        ],
        "IoTSiteWise.AssociateAssets": [
            {
                "action": "iotsitewise:AssociateAssets",
                "resource_mappings": {
                    "AssetId": {
                        "template": "%%many%${assetId}%${childAssetId}%%"
                    }
                }
            }
        ],
        "IoTSiteWise.BatchAssociateProjectAssets": [
            {
                "action": "iotsitewise:BatchAssociateProjectAssets",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "IoTSiteWise.BatchDisassociateProjectAssets": [
            {
                "action": "iotsitewise:BatchDisassociateProjectAssets",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "IoTSiteWise.BatchPutAssetPropertyValue": [
            {
                "action": "iotsitewise:BatchPutAssetPropertyValue",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${entries[].assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.CreateAccessPolicy": [
            {
                "action": "iotsitewise:CreateAccessPolicy",
                "resource_mappings": {
                    "PortalId": {
                        "template": "${accessPolicyResource.portal.id}"
                    },
                    "ProjectId": {
                        "template": "${accessPolicyResource.project.id}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${accessPolicyIdentity.iamUser.arn}"
                }
            }
        ],
        "IoTSiteWise.CreateAsset": [
            {
                "action": "iotsitewise:CreateAsset",
                "resource_mappings": {
                    "AssetModelId": {
                        "template": "${assetModelId}"
                    }
                }
            }
        ],
        "IoTSiteWise.CreateAssetModel": [
            {
                "action": "iotsitewise:CreateAssetModel",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.CreateDashboard": [
            {
                "action": "iotsitewise:CreateDashboard",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "IoTSiteWise.CreateGateway": [
            {
                "action": "iotsitewise:CreateGateway",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.CreatePortal": [
            {
                "action": "iotsitewise:CreatePortal",
                "resource_mappings": {}
            },
            {
                "action": "sso:CreateManagedApplicationInstance",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "IoTSiteWise.CreateProject": [
            {
                "action": "iotsitewise:CreateProject",
                "resource_mappings": {
                    "PortalId": {
                        "template": "${portalId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DeleteAccessPolicy": [
            {
                "action": "iotsitewise:DeleteAccessPolicy",
                "resource_mappings": {
                    "AccessPolicyId": {
                        "template": "${accessPolicyId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DeleteAsset": [
            {
                "action": "iotsitewise:DeleteAsset",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DeleteAssetModel": [
            {
                "action": "iotsitewise:DeleteAssetModel",
                "resource_mappings": {
                    "AssetModelId": {
                        "template": "${assetModelId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DeleteDashboard": [
            {
                "action": "iotsitewise:DeleteDashboard",
                "resource_mappings": {
                    "DashboardId": {
                        "template": "${dashboardId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DeleteGateway": [
            {
                "action": "iotsitewise:DeleteGateway",
                "resource_mappings": {
                    "GatewayId": {
                        "template": "${gatewayId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DeletePortal": [
            {
                "action": "iotsitewise:DeletePortal",
                "resource_mappings": {
                    "PortalId": {
                        "template": "${portalId}"
                    }
                }
            },
            {
                "action": "sso:DeleteManagedApplicationInstance",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.DeleteProject": [
            {
                "action": "iotsitewise:DeleteProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeAccessPolicy": [
            {
                "action": "iotsitewise:DescribeAccessPolicy",
                "resource_mappings": {
                    "AccessPolicyId": {
                        "template": "${accessPolicyId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeAsset": [
            {
                "action": "iotsitewise:DescribeAsset",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeAssetModel": [
            {
                "action": "iotsitewise:DescribeAssetModel",
                "resource_mappings": {
                    "AssetModelId": {
                        "template": "${assetModelId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeAssetProperty": [
            {
                "action": "iotsitewise:DescribeAssetProperty",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeDashboard": [
            {
                "action": "iotsitewise:DescribeDashboard",
                "resource_mappings": {
                    "DashboardId": {
                        "template": "${dashboardId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeGateway": [
            {
                "action": "iotsitewise:DescribeGateway",
                "resource_mappings": {
                    "GatewayId": {
                        "template": "${gatewayId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeGatewayCapabilityConfiguration": [
            {
                "action": "iotsitewise:DescribeGatewayCapabilityConfiguration",
                "resource_mappings": {
                    "GatewayId": {
                        "template": "${gatewayId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeLoggingOptions": [
            {
                "action": "iotsitewise:DescribeLoggingOptions",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.DescribePortal": [
            {
                "action": "iotsitewise:DescribePortal",
                "resource_mappings": {
                    "PortalId": {
                        "template": "${portalId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeProject": [
            {
                "action": "iotsitewise:DescribeProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "IoTSiteWise.DisassociateAssets": [
            {
                "action": "iotsitewise:DisassociateAssets",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.GetAssetPropertyAggregates": [
            {
                "action": "iotsitewise:GetAssetPropertyAggregates",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.GetAssetPropertyValue": [
            {
                "action": "iotsitewise:GetAssetPropertyValue",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.GetAssetPropertyValueHistory": [
            {
                "action": "iotsitewise:GetAssetPropertyValueHistory",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.ListAccessPolicies": [
            {
                "action": "iotsitewise:ListAccessPolicies",
                "resource_mappings": {
                    "PortalId": {
                        "template": "*"
                    },
                    "ProjectId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTSiteWise.ListAssetModels": [
            {
                "action": "iotsitewise:ListAssetModels",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.ListAssetRelationships": [
            {
                "action": "iotsitewise:ListAssetRelationships",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.ListAssets": [
            {
                "action": "iotsitewise:ListAssets",
                "resource_mappings": {
                    "AssetModelId": {
                        "template": "${assetModelId}"
                    }
                }
            }
        ],
        "IoTSiteWise.ListAssociatedAssets": [
            {
                "action": "iotsitewise:ListAssociatedAssets",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.ListDashboards": [
            {
                "action": "iotsitewise:ListDashboards",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "IoTSiteWise.ListGateways": [
            {
                "action": "iotsitewise:ListGateways",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.ListPortals": [
            {
                "action": "iotsitewise:ListPortals",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.ListProjectAssets": [
            {
                "action": "iotsitewise:ListProjectAssets",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "IoTSiteWise.ListProjects": [
            {
                "action": "iotsitewise:ListProjects",
                "resource_mappings": {
                    "PortalId": {
                        "template": "${portalId}"
                    }
                }
            }
        ],
        "IoTSiteWise.ListTagsForResource": [
            {
                "action": "iotsitewise:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "access-policy": "%%iftemplatematch%${resourceArn}%%",
                    "asset": "%%iftemplatematch%${resourceArn}%%",
                    "asset-model": "%%iftemplatematch%${resourceArn}%%",
                    "dashboard": "%%iftemplatematch%${resourceArn}%%",
                    "gateway": "%%iftemplatematch%${resourceArn}%%",
                    "portal": "%%iftemplatematch%${resourceArn}%%",
                    "project": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTSiteWise.PutLoggingOptions": [
            {
                "action": "iotsitewise:PutLoggingOptions",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.TagResource": [
            {
                "action": "iotsitewise:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "access-policy": "%%iftemplatematch%${resourceArn}%%",
                    "asset": "%%iftemplatematch%${resourceArn}%%",
                    "asset-model": "%%iftemplatematch%${resourceArn}%%",
                    "dashboard": "%%iftemplatematch%${resourceArn}%%",
                    "gateway": "%%iftemplatematch%${resourceArn}%%",
                    "portal": "%%iftemplatematch%${resourceArn}%%",
                    "project": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTSiteWise.UntagResource": [
            {
                "action": "iotsitewise:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "access-policy": "%%iftemplatematch%${resourceArn}%%",
                    "asset": "%%iftemplatematch%${resourceArn}%%",
                    "asset-model": "%%iftemplatematch%${resourceArn}%%",
                    "dashboard": "%%iftemplatematch%${resourceArn}%%",
                    "gateway": "%%iftemplatematch%${resourceArn}%%",
                    "portal": "%%iftemplatematch%${resourceArn}%%",
                    "project": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTSiteWise.UpdateAccessPolicy": [
            {
                "action": "iotsitewise:UpdateAccessPolicy",
                "resource_mappings": {
                    "AccessPolicyId": {
                        "template": "${accessPolicyId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${accessPolicyIdentity.iamUser.arn}"
                }
            }
        ],
        "IoTSiteWise.UpdateAsset": [
            {
                "action": "iotsitewise:UpdateAsset",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.UpdateAssetModel": [
            {
                "action": "iotsitewise:UpdateAssetModel",
                "resource_mappings": {
                    "AssetModelId": {
                        "template": "${assetModelId}"
                    }
                }
            }
        ],
        "IoTSiteWise.UpdateAssetProperty": [
            {
                "action": "iotsitewise:UpdateAssetProperty",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IoTSiteWise.UpdateDashboard": [
            {
                "action": "iotsitewise:UpdateDashboard",
                "resource_mappings": {
                    "DashboardId": {
                        "template": "${dashboardId}"
                    }
                }
            }
        ],
        "IoTSiteWise.UpdateGateway": [
            {
                "action": "iotsitewise:UpdateGateway",
                "resource_mappings": {
                    "GatewayId": {
                        "template": "${gatewayId}"
                    }
                }
            }
        ],
        "IoTSiteWise.UpdateGatewayCapabilityConfiguration": [
            {
                "action": "iotsitewise:UpdateGatewayCapabilityConfiguration",
                "resource_mappings": {
                    "GatewayId": {
                        "template": "${gatewayId}"
                    }
                }
            }
        ],
        "IoTSiteWise.UpdatePortal": [
            {
                "action": "iotsitewise:UpdatePortal",
                "resource_mappings": {
                    "PortalId": {
                        "template": "${portalId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${roleArn}"
                }
            }
        ],
        "IoTSiteWise.UpdateProject": [
            {
                "action": "iotsitewise:UpdateProject",
                "resource_mappings": {
                    "ProjectId": {
                        "template": "${projectId}"
                    }
                }
            }
        ],
        "Macie2.AcceptInvitation": [
            {
                "action": "macie2:AcceptInvitation",
                "resource_mappings": {}
            }
        ],
        "Macie2.BatchGetCustomDataIdentifiers": [
            {
                "action": "macie2:BatchGetCustomDataIdentifiers",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ids[]}"
                    }
                }
            }
        ],
        "Macie2.CreateClassificationJob": [
            {
                "action": "macie2:CreateClassificationJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Macie2.CreateCustomDataIdentifier": [
            {
                "action": "macie2:CreateCustomDataIdentifier",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Macie2.CreateFindingsFilter": [
            {
                "action": "macie2:CreateFindingsFilter",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Macie2.CreateInvitations": [
            {
                "action": "macie2:CreateInvitations",
                "resource_mappings": {}
            }
        ],
        "Macie2.CreateMember": [
            {
                "action": "macie2:CreateMember",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Macie2.CreateSampleFindings": [
            {
                "action": "macie2:CreateSampleFindings",
                "resource_mappings": {}
            }
        ],
        "Macie2.DeclineInvitations": [
            {
                "action": "macie2:DeclineInvitations",
                "resource_mappings": {}
            }
        ],
        "Macie2.DeleteCustomDataIdentifier": [
            {
                "action": "macie2:DeleteCustomDataIdentifier",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Macie2.DeleteFindingsFilter": [
            {
                "action": "macie2:DeleteFindingsFilter",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Macie2.DeleteInvitations": [
            {
                "action": "macie2:DeleteInvitations",
                "resource_mappings": {}
            }
        ],
        "Macie2.DeleteMember": [
            {
                "action": "macie2:DeleteMember",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Macie2.DescribeBuckets": [
            {
                "action": "macie2:DescribeBuckets",
                "resource_mappings": {}
            }
        ],
        "Macie2.DescribeClassificationJob": [
            {
                "action": "macie2:DescribeClassificationJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Macie2.DescribeOrganizationConfiguration": [
            {
                "action": "macie2:DescribeOrganizationConfiguration",
                "resource_mappings": {}
            }
        ],
        "Macie2.DisableMacie": [
            {
                "action": "macie2:DisableMacie",
                "resource_mappings": {}
            }
        ],
        "Macie2.DisableOrganizationAdminAccount": [
            {
                "action": "macie2:DisableOrganizationAdminAccount",
                "resource_mappings": {}
            }
        ],
        "Macie2.DisassociateFromMasterAccount": [
            {
                "action": "macie2:DisassociateFromMasterAccount",
                "resource_mappings": {}
            }
        ],
        "Macie2.DisassociateMember": [
            {
                "action": "macie2:DisassociateMember",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Macie2.EnableMacie": [
            {
                "action": "macie2:EnableMacie",
                "resource_mappings": {}
            }
        ],
        "Macie2.EnableOrganizationAdminAccount": [
            {
                "action": "macie2:EnableOrganizationAdminAccount",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetBucketStatistics": [
            {
                "action": "macie2:GetBucketStatistics",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetClassificationExportConfiguration": [
            {
                "action": "macie2:GetClassificationExportConfiguration",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetCustomDataIdentifier": [
            {
                "action": "macie2:GetCustomDataIdentifier",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Macie2.GetFindingStatistics": [
            {
                "action": "macie2:GetFindingStatistics",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetFindings": [
            {
                "action": "macie2:GetFindings",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetFindingsFilter": [
            {
                "action": "macie2:GetFindingsFilter",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Macie2.GetInvitationsCount": [
            {
                "action": "macie2:GetInvitationsCount",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetMacieSession": [
            {
                "action": "macie2:GetMacieSession",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetMasterAccount": [
            {
                "action": "macie2:GetMasterAccount",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetMember": [
            {
                "action": "macie2:GetMember",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Macie2.GetUsageStatistics": [
            {
                "action": "macie2:GetUsageStatistics",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetUsageTotals": [
            {
                "action": "macie2:GetUsageTotals",
                "resource_mappings": {}
            }
        ],
        "Macie2.ListClassificationJobs": [
            {
                "action": "macie2:ListClassificationJobs",
                "resource_mappings": {}
            }
        ],
        "Macie2.ListCustomDataIdentifiers": [
            {
                "action": "macie2:ListCustomDataIdentifiers",
                "resource_mappings": {}
            }
        ],
        "Macie2.ListFindings": [
            {
                "action": "macie2:ListFindings",
                "resource_mappings": {}
            }
        ],
        "Macie2.ListFindingsFilters": [
            {
                "action": "macie2:ListFindingsFilters",
                "resource_mappings": {}
            }
        ],
        "Macie2.ListInvitations": [
            {
                "action": "macie2:ListInvitations",
                "resource_mappings": {}
            }
        ],
        "Macie2.ListMembers": [
            {
                "action": "macie2:ListMembers",
                "resource_mappings": {}
            }
        ],
        "Macie2.ListOrganizationAdminAccounts": [
            {
                "action": "macie2:ListOrganizationAdminAccounts",
                "resource_mappings": {}
            }
        ],
        "Macie2.ListTagsForResource": [
            {
                "action": "macie2:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Macie2.PutClassificationExportConfiguration": [
            {
                "action": "macie2:PutClassificationExportConfiguration",
                "resource_mappings": {}
            }
        ],
        "Macie2.TagResource": [
            {
                "action": "macie2:TagResource",
                "resource_mappings": {}
            }
        ],
        "Macie2.TestCustomDataIdentifier": [
            {
                "action": "macie2:TestCustomDataIdentifier",
                "resource_mappings": {}
            }
        ],
        "Macie2.UntagResource": [
            {
                "action": "macie2:UntagResource",
                "resource_mappings": {}
            }
        ],
        "Macie2.UpdateClassificationJob": [
            {
                "action": "macie2:UpdateClassificationJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "Macie2.UpdateFindingsFilter": [
            {
                "action": "macie2:UpdateFindingsFilter",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Macie2.UpdateMacieSession": [
            {
                "action": "macie2:UpdateMacieSession",
                "resource_mappings": {}
            }
        ],
        "Macie2.UpdateMemberSession": [
            {
                "action": "macie2:UpdateMemberSession",
                "resource_mappings": {}
            }
        ],
        "Macie2.UpdateOrganizationConfiguration": [
            {
                "action": "macie2:UpdateOrganizationConfiguration",
                "resource_mappings": {}
            }
        ],
        "CodeArtifact.AssociateExternalConnection": [
            {
                "action": "codeartifact:AssociateExternalConnection",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "CodeArtifact.CopyPackageVersions": [
            {
                "action": "codeartifact:CopyPackageVersions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "%%many%${sourceRepository}%${destinationRepository}%%"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.CreateDomain": [
            {
                "action": "codeartifact:CreateDomain",
                "resource_mappings": {}
            }
        ],
        "CodeArtifact.CreateRepository": [
            {
                "action": "codeartifact:CreateRepository",
                "resource_mappings": {}
            }
        ],
        "CodeArtifact.DeleteDomain": [
            {
                "action": "codeartifact:DeleteDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "CodeArtifact.DeleteDomainPermissionsPolicy": [
            {
                "action": "codeartifact:DeleteDomainPermissionsPolicy",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "CodeArtifact.DeletePackageVersions": [
            {
                "action": "codeartifact:DeletePackageVersions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.DeleteRepository": [
            {
                "action": "codeartifact:DeleteRepository",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "CodeArtifact.DeleteRepositoryPermissionsPolicy": [
            {
                "action": "codeartifact:DeleteRepositoryPermissionsPolicy",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "CodeArtifact.DescribeDomain": [
            {
                "action": "codeartifact:DescribeDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "CodeArtifact.DescribePackageVersion": [
            {
                "action": "codeartifact:DescribePackageVersion",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.DescribeRepository": [
            {
                "action": "codeartifact:DescribeRepository",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "CodeArtifact.DisassociateExternalConnection": [
            {
                "action": "codeartifact:DisassociateExternalConnection",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "CodeArtifact.DisposePackageVersions": [
            {
                "action": "codeartifact:DisposePackageVersions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.GetAuthorizationToken": [
            {
                "action": "codeartifact:GetAuthorizationToken",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "CodeArtifact.GetDomainPermissionsPolicy": [
            {
                "action": "codeartifact:GetDomainPermissionsPolicy",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "CodeArtifact.GetPackageVersionAsset": [
            {
                "action": "codeartifact:GetPackageVersionAsset",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.GetPackageVersionReadme": [
            {
                "action": "codeartifact:GetPackageVersionReadme",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.GetRepositoryEndpoint": [
            {
                "action": "codeartifact:GetRepositoryEndpoint",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "CodeArtifact.GetRepositoryPermissionsPolicy": [
            {
                "action": "codeartifact:GetRepositoryPermissionsPolicy",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "CodeArtifact.ListDomains": [
            {
                "action": "codeartifact:ListDomains",
                "resource_mappings": {}
            }
        ],
        "CodeArtifact.ListPackageVersionAssets": [
            {
                "action": "codeartifact:ListPackageVersionAssets",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.ListPackageVersionDependencies": [
            {
                "action": "codeartifact:ListPackageVersionDependencies",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.ListPackageVersions": [
            {
                "action": "codeartifact:ListPackageVersions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.ListPackages": [
            {
                "action": "codeartifact:ListPackages",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "CodeArtifact.ListRepositories": [
            {
                "action": "codeartifact:ListRepositories",
                "resource_mappings": {}
            }
        ],
        "CodeArtifact.ListRepositoriesInDomain": [
            {
                "action": "codeartifact:ListRepositoriesInDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "CodeArtifact.ListTagsForResource": [
            {
                "action": "codeartifact:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${resourceArn}%%",
                    "repository": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeArtifact.PutDomainPermissionsPolicy": [
            {
                "action": "codeartifact:PutDomainPermissionsPolicy",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "CodeArtifact.PutRepositoryPermissionsPolicy": [
            {
                "action": "codeartifact:PutRepositoryPermissionsPolicy",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "CodeArtifact.TagResource": [
            {
                "action": "codeartifact:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${resourceArn}%%",
                    "repository": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeArtifact.UntagResource": [
            {
                "action": "codeartifact:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${resourceArn}%%",
                    "repository": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "CodeArtifact.UpdatePackageVersionsStatus": [
            {
                "action": "codeartifact:UpdatePackageVersionsStatus",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    },
                    "PackageFormat": {
                        "template": "${format}"
                    },
                    "PackageNamespace": {
                        "template": "${namespace}"
                    },
                    "PackageName": {
                        "template": "${package}"
                    }
                }
            }
        ],
        "CodeArtifact.UpdateRepository": [
            {
                "action": "codeartifact:UpdateRepository",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    },
                    "RepositoryName": {
                        "template": "${repository}"
                    }
                }
            }
        ],
        "Honeycode.BatchCreateTableRows": [
            {
                "action": "honeycode:BatchCreateTableRows",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "TableId": {
                        "template": "${tableId}"
                    }
                }
            }
        ],
        "Honeycode.BatchDeleteTableRows": [
            {
                "action": "honeycode:BatchDeleteTableRows",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "TableId": {
                        "template": "${tableId}"
                    }
                }
            }
        ],
        "Honeycode.BatchUpdateTableRows": [
            {
                "action": "honeycode:BatchUpdateTableRows",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "TableId": {
                        "template": "${tableId}"
                    }
                }
            }
        ],
        "Honeycode.BatchUpsertTableRows": [
            {
                "action": "honeycode:BatchUpsertTableRows",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "TableId": {
                        "template": "${tableId}"
                    }
                }
            }
        ],
        "Honeycode.DescribeTableDataImportJob": [
            {
                "action": "honeycode:DescribeTableDataImportJob",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "TableId": {
                        "template": "${tableId}"
                    }
                }
            }
        ],
        "Honeycode.GetScreenData": [
            {
                "action": "honeycode:GetScreenData",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "AppId": {
                        "template": "${appId}"
                    },
                    "ScreenId": {
                        "template": "${screenId}"
                    }
                }
            }
        ],
        "Honeycode.InvokeScreenAutomation": [
            {
                "action": "honeycode:InvokeScreenAutomation",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "AppId": {
                        "template": "${appId}"
                    },
                    "ScreenId": {
                        "template": "${screenId}"
                    },
                    "AutomationId": {
                        "template": "${screenAutomationId}"
                    }
                }
            }
        ],
        "Honeycode.ListTableColumns": [
            {
                "action": "honeycode:ListTableColumns",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "TableId": {
                        "template": "${tableId}"
                    }
                }
            }
        ],
        "Honeycode.ListTableRows": [
            {
                "action": "honeycode:ListTableRows",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "TableId": {
                        "template": "${tableId}"
                    }
                }
            }
        ],
        "Honeycode.ListTables": [
            {
                "action": "honeycode:ListTables",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    }
                }
            }
        ],
        "Honeycode.QueryTableRows": [
            {
                "action": "honeycode:QueryTableRows",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "TableId": {
                        "template": "${tableId}"
                    }
                }
            }
        ],
        "Honeycode.StartTableDataImportJob": [
            {
                "action": "honeycode:StartTableDataImportJob",
                "resource_mappings": {
                    "WorkbookId": {
                        "template": "${workbookId}"
                    },
                    "TableId": {
                        "template": "${destinationTableId}"
                    }
                }
            }
        ],
        "IVS.BatchGetChannel": [
            {
                "action": "ivs:BatchGetChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "${arns[]}"
                }
            }
        ],
        "IVS.BatchGetStreamKey": [
            {
                "action": "ivs:BatchGetStreamKey",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Stream-Key": "${arns[]}"
                }
            }
        ],
        "IVS.CreateChannel": [
            {
                "action": "ivs:CreateChannel",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IVS.CreateStreamKey": [
            {
                "action": "ivs:CreateStreamKey",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IVS.DeleteChannel": [
            {
                "action": "ivs:DeleteChannel",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "Channel": "${arn}"
                }
            }
        ],
        "IVS.DeletePlaybackKeyPair": [
            {
                "action": "ivs:DeletePlaybackKeyPair",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Playback-Key-Pair": "${arn}"
                }
            }
        ],
        "IVS.DeleteStreamKey": [
            {
                "action": "ivs:DeleteStreamKey",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Stream-Key": "${arn}"
                }
            }
        ],
        "IVS.GetChannel": [
            {
                "action": "ivs:GetChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "${arn}"
                }
            }
        ],
        "IVS.GetPlaybackKeyPair": [
            {
                "action": "ivs:GetPlaybackKeyPair",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Playback-Key-Pair": "${arn}"
                }
            }
        ],
        "IVS.GetStream": [
            {
                "action": "ivs:GetStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "${channelArn}"
                }
            }
        ],
        "IVS.GetStreamKey": [
            {
                "action": "ivs:GetStreamKey",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Stream-Key": "${arn}"
                }
            }
        ],
        "IVS.ImportPlaybackKeyPair": [
            {
                "action": "ivs:ImportPlaybackKeyPair",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IVS.ListChannels": [
            {
                "action": "ivs:ListChannels",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IVS.ListPlaybackKeyPairs": [
            {
                "action": "ivs:ListPlaybackKeyPairs",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IVS.ListStreamKeys": [
            {
                "action": "ivs:ListStreamKeys",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "Channel": "${channelArn}"
                }
            }
        ],
        "IVS.ListStreams": [
            {
                "action": "ivs:ListStreams",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IVS.ListTagsForResource": [
            {
                "action": "ivs:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "%%iftemplatematch%${resourceArn}%%",
                    "Playback-Key-Pair": "%%iftemplatematch%${resourceArn}%%",
                    "Stream-Key": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IVS.PutMetadata": [
            {
                "action": "ivs:PutMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "${channelArn}"
                }
            }
        ],
        "IVS.StopStream": [
            {
                "action": "ivs:StopStream",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "${channelArn}"
                }
            }
        ],
        "IVS.TagResource": [
            {
                "action": "ivs:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "%%iftemplatematch%${resourceArn}%%",
                    "Playback-Key-Pair": "%%iftemplatematch%${resourceArn}%%",
                    "Stream-Key": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IVS.UntagResource": [
            {
                "action": "ivs:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "%%iftemplatematch%${resourceArn}%%",
                    "Playback-Key-Pair": "%%iftemplatematch%${resourceArn}%%",
                    "Stream-Key": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IVS.UpdateChannel": [
            {
                "action": "ivs:UpdateChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "${arn}"
                }
            }
        ],
        "Braket.CancelQuantumTask": [
            {
                "action": "braket:CancelQuantumTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "quantum-task": "${quantumTaskArn}"
                }
            }
        ],
        "Braket.CreateQuantumTask": [
            {
                "action": "braket:CreateQuantumTask",
                "resource_mappings": {
                    "RandomId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Braket.GetDevice": [
            {
                "action": "braket:GetDevice",
                "resource_mappings": {}
            }
        ],
        "Braket.GetQuantumTask": [
            {
                "action": "braket:GetQuantumTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "quantum-task": "${quantumTaskArn}"
                }
            }
        ],
        "Braket.ListTagsForResource": [
            {
                "action": "braket:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "quantum-task": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Braket.SearchDevices": [
            {
                "action": "braket:SearchDevices",
                "resource_mappings": {}
            }
        ],
        "Braket.SearchQuantumTasks": [
            {
                "action": "braket:SearchQuantumTasks",
                "resource_mappings": {}
            }
        ],
        "Braket.TagResource": [
            {
                "action": "braket:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "quantum-task": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Braket.UntagResource": [
            {
                "action": "braket:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "quantum-task": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IdentityStore.DescribeGroup": [
            {
                "action": "identitystore:DescribeGroup",
                "resource_mappings": {}
            }
        ],
        "IdentityStore.DescribeUser": [
            {
                "action": "identitystore:DescribeUser",
                "resource_mappings": {}
            }
        ],
        "IdentityStore.ListGroups": [
            {
                "action": "identitystore:ListGroups",
                "resource_mappings": {}
            }
        ],
        "IdentityStore.ListUsers": [
            {
                "action": "identitystore:ListUsers",
                "resource_mappings": {}
            }
        ],
        "Appflow.CreateConnectorProfile": [
            {
                "action": "appflow:CreateConnectorProfile",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${connectorProfileConfig.connectorProfileProperties.Redshift.roleArn}"
                }
            }
        ],
        "Appflow.CreateFlow": [
            {
                "action": "appflow:CreateFlow",
                "resource_mappings": {}
            }
        ],
        "Appflow.DeleteConnectorProfile": [
            {
                "action": "appflow:DeleteConnectorProfile",
                "resource_mappings": {
                    "profileName": {
                        "template": "${connectorProfileName}"
                    }
                }
            }
        ],
        "Appflow.DeleteFlow": [
            {
                "action": "appflow:DeleteFlow",
                "resource_mappings": {
                    "flowName": {
                        "template": "${flowName}"
                    }
                }
            }
        ],
        "Appflow.DescribeConnectorEntity": [
            {
                "action": "appflow:DescribeConnectorEntity",
                "resource_mappings": {
                    "profileName": {
                        "template": "${connectorProfileName}"
                    }
                }
            }
        ],
        "Appflow.DescribeConnectorProfiles": [
            {
                "action": "appflow:DescribeConnectorProfiles",
                "resource_mappings": {}
            }
        ],
        "Appflow.DescribeConnectors": [
            {
                "action": "appflow:DescribeConnectors",
                "resource_mappings": {}
            }
        ],
        "Appflow.DescribeFlow": [
            {
                "action": "appflow:DescribeFlow",
                "resource_mappings": {}
            }
        ],
        "Appflow.DescribeFlowExecutionRecords": [
            {
                "action": "appflow:DescribeFlowExecutionRecords",
                "resource_mappings": {
                    "flowName": {
                        "template": "${flowName}"
                    }
                }
            }
        ],
        "Appflow.ListConnectorEntities": [
            {
                "action": "appflow:ListConnectorEntities",
                "resource_mappings": {
                    "profileName": {
                        "template": "${connectorProfileName}"
                    }
                }
            }
        ],
        "Appflow.ListFlows": [
            {
                "action": "appflow:ListFlows",
                "resource_mappings": {
                    "flowName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Appflow.ListTagsForResource": [
            {
                "action": "appflow:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "flow": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Appflow.StartFlow": [
            {
                "action": "appflow:StartFlow",
                "resource_mappings": {
                    "flowName": {
                        "template": "${flowName}"
                    }
                }
            }
        ],
        "Appflow.StopFlow": [
            {
                "action": "appflow:StopFlow",
                "resource_mappings": {
                    "flowName": {
                        "template": "${flowName}"
                    }
                }
            }
        ],
        "Appflow.TagResource": [
            {
                "action": "appflow:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "flow": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Appflow.UntagResource": [
            {
                "action": "appflow:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "flow": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Appflow.UpdateConnectorProfile": [
            {
                "action": "appflow:UpdateConnectorProfile",
                "resource_mappings": {
                    "flowName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "arn_override": {
                    "template": "${connectorProfileConfig.connectorProfileProperties.Redshift.roleArn}"
                }
            }
        ],
        "Appflow.UpdateFlow": [
            {
                "action": "appflow:UpdateFlow",
                "resource_mappings": {
                    "flowName": {
                        "template": "${flowName}"
                    }
                }
            }
        ],
        "RedshiftData.CancelStatement": [
            {
                "action": "redshift-data:CancelStatement",
                "resource_mappings": {}
            }
        ],
        "RedshiftData.DescribeStatement": [
            {
                "action": "redshift-data:DescribeStatement",
                "resource_mappings": {}
            }
        ],
        "RedshiftData.DescribeTable": [
            {
                "action": "redshift-data:DescribeTable",
                "resource_mappings": {}
            }
        ],
        "RedshiftData.ExecuteStatement": [
            {
                "action": "redshift-data:ExecuteStatement",
                "resource_mappings": {}
            }
        ],
        "RedshiftData.GetStatementResult": [
            {
                "action": "redshift-data:GetStatementResult",
                "resource_mappings": {}
            }
        ],
        "RedshiftData.ListDatabases": [
            {
                "action": "redshift-data:ListDatabases",
                "resource_mappings": {}
            }
        ],
        "RedshiftData.ListSchemas": [
            {
                "action": "redshift-data:ListSchemas",
                "resource_mappings": {}
            }
        ],
        "RedshiftData.ListStatements": [
            {
                "action": "redshift-data:ListStatements",
                "resource_mappings": {}
            }
        ],
        "RedshiftData.ListTables": [
            {
                "action": "redshift-data:ListTables",
                "resource_mappings": {}
            }
        ],
        "SSOAdmin.AttachManagedPolicyToPermissionSet": [
            {
                "action": "sso:AttachManagedPolicyToPermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.CreateAccountAssignment": [
            {
                "action": "sso:CreateAccountAssignment",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${TargetId}"
                    }
                },
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.CreateInstanceAccessControlAttributeConfiguration": [
            {
                "action": "sso:CreateInstanceAccessControlAttributeConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.CreatePermissionSet": [
            {
                "action": "sso:CreatePermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.DeleteAccountAssignment": [
            {
                "action": "sso:DeleteAccountAssignment",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${TargetId}"
                    }
                },
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.DeleteInlinePolicyFromPermissionSet": [
            {
                "action": "sso:DeleteInlinePolicyFromPermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.DeleteInstanceAccessControlAttributeConfiguration": [
            {
                "action": "sso:DeleteInstanceAccessControlAttributeConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.DeletePermissionSet": [
            {
                "action": "sso:DeletePermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.DescribeAccountAssignmentCreationStatus": [
            {
                "action": "sso:DescribeAccountAssignmentCreationStatus",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.DescribeAccountAssignmentDeletionStatus": [
            {
                "action": "sso:DescribeAccountAssignmentDeletionStatus",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.DescribeInstanceAccessControlAttributeConfiguration": [
            {
                "action": "sso:DescribeInstanceAccessControlAttributeConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.DescribePermissionSet": [
            {
                "action": "sso:DescribePermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.DescribePermissionSetProvisioningStatus": [
            {
                "action": "sso:DescribePermissionSetProvisioningStatus",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.DetachManagedPolicyFromPermissionSet": [
            {
                "action": "sso:DetachManagedPolicyFromPermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.GetInlinePolicyForPermissionSet": [
            {
                "action": "sso:GetInlinePolicyForPermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.ListAccountAssignmentCreationStatus": [
            {
                "action": "sso:ListAccountAssignmentCreationStatus",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.ListAccountAssignmentDeletionStatus": [
            {
                "action": "sso:ListAccountAssignmentDeletionStatus",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.ListAccountAssignments": [
            {
                "action": "sso:ListAccountAssignments",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${AccountId}"
                    }
                },
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.ListAccountsForProvisionedPermissionSet": [
            {
                "action": "sso:ListAccountsForProvisionedPermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.ListInstances": [
            {
                "action": "sso:ListInstances",
                "resource_mappings": {}
            }
        ],
        "SSOAdmin.ListManagedPoliciesInPermissionSet": [
            {
                "action": "sso:ListManagedPoliciesInPermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.ListPermissionSetProvisioningStatus": [
            {
                "action": "sso:ListPermissionSetProvisioningStatus",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.ListPermissionSets": [
            {
                "action": "sso:ListPermissionSets",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.ListPermissionSetsProvisionedToAccount": [
            {
                "action": "sso:ListPermissionSetsProvisionedToAccount",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${AccountId}"
                    }
                },
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.ListTagsForResource": [
            {
                "action": "sso:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SSOAdmin.ProvisionPermissionSet": [
            {
                "action": "sso:ProvisionPermissionSet",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${TargetId}"
                    }
                },
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.PutInlinePolicyToPermissionSet": [
            {
                "action": "sso:PutInlinePolicyToPermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "SSOAdmin.TagResource": [
            {
                "action": "sso:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SSOAdmin.UntagResource": [
            {
                "action": "sso:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SSOAdmin.UpdateInstanceAccessControlAttributeConfiguration": [
            {
                "action": "sso:UpdateInstanceAccessControlAttributeConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}"
                }
            }
        ],
        "SSOAdmin.UpdatePermissionSet": [
            {
                "action": "sso:UpdatePermissionSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Instance": "${InstanceArn}",
                    "PermissionSet": "${PermissionSetArn}"
                }
            }
        ],
        "TimestreamQuery.CancelQuery": [
            {
                "action": "timestream:CancelQuery",
                "resource_mappings": {}
            }
        ],
        "TimestreamQuery.DescribeEndpoints": [
            {
                "action": "timestream:DescribeEndpoints",
                "resource_mappings": {}
            }
        ],
        "TimestreamWrite.CreateDatabase": [
            {
                "action": "timestream:CreateDatabase",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    }
                }
            }
        ],
        "TimestreamWrite.CreateTable": [
            {
                "action": "timestream:CreateTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "TimestreamWrite.DeleteDatabase": [
            {
                "action": "timestream:DeleteDatabase",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    }
                }
            }
        ],
        "TimestreamWrite.DeleteTable": [
            {
                "action": "timestream:DeleteTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "TimestreamWrite.DescribeDatabase": [
            {
                "action": "timestream:DescribeDatabase",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    }
                }
            }
        ],
        "TimestreamWrite.DescribeEndpoints": [
            {
                "action": "timestream:DescribeEndpoints",
                "resource_mappings": {}
            }
        ],
        "TimestreamWrite.DescribeTable": [
            {
                "action": "timestream:DescribeTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "TimestreamWrite.ListDatabases": [
            {
                "action": "timestream:ListDatabases",
                "resource_mappings": {}
            }
        ],
        "TimestreamWrite.ListTables": [
            {
                "action": "timestream:ListTables",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    }
                }
            }
        ],
        "TimestreamWrite.ListTagsForResource": [
            {
                "action": "timestream:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "database": "%%iftemplatematch%${ResourceARN}%%",
                    "table": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "TimestreamWrite.TagResource": [
            {
                "action": "timestream:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "database": "%%iftemplatematch%${ResourceARN}%%",
                    "table": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "TimestreamWrite.UntagResource": [
            {
                "action": "timestream:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "database": "%%iftemplatematch%${ResourceARN}%%",
                    "table": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "TimestreamWrite.UpdateDatabase": [
            {
                "action": "timestream:UpdateDatabase",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    }
                }
            }
        ],
        "TimestreamWrite.UpdateTable": [
            {
                "action": "timestream:UpdateTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "TimestreamWrite.WriteRecords": [
            {
                "action": "timestream:WriteRecords",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "S3Outposts.CreateEndpoint": [
            {
                "action": "s3-outposts:CreateEndpoint",
                "resource_mappings": {
                    "OutpostId": {
                        "template": "${OutpostId}"
                    },
                    "EndpointId": {
                        "template": "*"
                    }
                }
            }
        ],
        "S3Outposts.DeleteEndpoint": [
            {
                "action": "s3-outposts:DeleteEndpoint",
                "resource_mappings": {
                    "OutpostId": {
                        "template": "${OutpostId}"
                    },
                    "EndpointId": {
                        "template": "${EndpointId}"
                    }
                }
            }
        ],
        "S3Outposts.ListEndpoints": [
            {
                "action": "s3-outposts:ListEndpoints",
                "resource_mappings": {}
            }
        ],
        "DataBrew.BatchDeleteRecipeVersion": [
            {
                "action": "databrew:BatchDeleteRecipeVersion",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.CreateDataset": [
            {
                "action": "databrew:CreateDataset",
                "resource_mappings": {}
            }
        ],
        "DataBrew.CreateProfileJob": [
            {
                "action": "databrew:CreateProfileJob",
                "resource_mappings": {}
            }
        ],
        "DataBrew.CreateProject": [
            {
                "action": "databrew:CreateProject",
                "resource_mappings": {}
            }
        ],
        "DataBrew.CreateRecipe": [
            {
                "action": "databrew:CreateRecipe",
                "resource_mappings": {}
            }
        ],
        "DataBrew.CreateRecipeJob": [
            {
                "action": "databrew:CreateRecipeJob",
                "resource_mappings": {}
            }
        ],
        "DataBrew.CreateSchedule": [
            {
                "action": "databrew:CreateSchedule",
                "resource_mappings": {}
            }
        ],
        "DataBrew.DeleteDataset": [
            {
                "action": "databrew:DeleteDataset",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.DeleteJob": [
            {
                "action": "databrew:DeleteJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.DeleteProject": [
            {
                "action": "databrew:DeleteProject",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.DeleteRecipeVersion": [
            {
                "action": "databrew:DeleteRecipeVersion",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.DeleteSchedule": [
            {
                "action": "databrew:DeleteSchedule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.DescribeDataset": [
            {
                "action": "databrew:DescribeDataset",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.DescribeJob": [
            {
                "action": "databrew:DescribeJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.DescribeProject": [
            {
                "action": "databrew:DescribeProject",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.DescribeRecipe": [
            {
                "action": "databrew:DescribeRecipe",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.DescribeSchedule": [
            {
                "action": "databrew:DescribeSchedule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.ListJobRuns": [
            {
                "action": "databrew:ListJobRuns",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.ListJobs": [
            {
                "action": "databrew:ListJobs",
                "resource_mappings": {}
            }
        ],
        "DataBrew.ListProjects": [
            {
                "action": "databrew:ListProjects",
                "resource_mappings": {}
            }
        ],
        "DataBrew.ListRecipeVersions": [
            {
                "action": "databrew:ListRecipeVersions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.ListRecipes": [
            {
                "action": "databrew:ListRecipes",
                "resource_mappings": {}
            }
        ],
        "DataBrew.ListSchedules": [
            {
                "action": "databrew:ListSchedules",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataBrew.ListTagsForResource": [
            {
                "action": "databrew:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "Job": "%%iftemplatematch%${ResourceArn}%%",
                    "Project": "%%iftemplatematch%${ResourceArn}%%",
                    "Recipe": "%%iftemplatematch%${ResourceArn}%%",
                    "Schedule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DataBrew.PublishRecipe": [
            {
                "action": "databrew:PublishRecipe",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.SendProjectSessionAction": [
            {
                "action": "databrew:SendProjectSessionAction",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.StartJobRun": [
            {
                "action": "databrew:StartJobRun",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.StartProjectSession": [
            {
                "action": "databrew:StartProjectSession",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.StopJobRun": [
            {
                "action": "databrew:StopJobRun",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.TagResource": [
            {
                "action": "databrew:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "Job": "%%iftemplatematch%${ResourceArn}%%",
                    "Project": "%%iftemplatematch%${ResourceArn}%%",
                    "Recipe": "%%iftemplatematch%${ResourceArn}%%",
                    "Schedule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DataBrew.UntagResource": [
            {
                "action": "databrew:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "Job": "%%iftemplatematch%${ResourceArn}%%",
                    "Project": "%%iftemplatematch%${ResourceArn}%%",
                    "Recipe": "%%iftemplatematch%${ResourceArn}%%",
                    "Schedule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "DataBrew.UpdateDataset": [
            {
                "action": "databrew:UpdateDataset",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.UpdateProfileJob": [
            {
                "action": "databrew:UpdateProfileJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.UpdateProject": [
            {
                "action": "databrew:UpdateProject",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.UpdateRecipe": [
            {
                "action": "databrew:UpdateRecipe",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.UpdateRecipeJob": [
            {
                "action": "databrew:UpdateRecipeJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DataBrew.UpdateSchedule": [
            {
                "action": "databrew:UpdateSchedule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.AssociateAttributeGroup": [
            {
                "action": "servicecatalog:AssociateAttributeGroup",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    },
                    "AttributeGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.AssociateResource": [
            {
                "action": "servicecatalog:AssociateResource",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.CreateAttributeGroup": [
            {
                "action": "servicecatalog:CreateAttributeGroup",
                "resource_mappings": {
                    "AttributeGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.DeleteApplication": [
            {
                "action": "servicecatalog:DeleteApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.DeleteAttributeGroup": [
            {
                "action": "servicecatalog:DeleteAttributeGroup",
                "resource_mappings": {
                    "AttributeGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.DisassociateAttributeGroup": [
            {
                "action": "servicecatalog:DisassociateAttributeGroup",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    },
                    "AttributeGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.DisassociateResource": [
            {
                "action": "servicecatalog:DisassociateResource",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.GetApplication": [
            {
                "action": "servicecatalog:GetApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.GetAttributeGroup": [
            {
                "action": "servicecatalog:GetAttributeGroup",
                "resource_mappings": {
                    "AttributeGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.ListApplications": [
            {
                "action": "servicecatalog:ListApplications",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalogAppRegistry.ListAssociatedAttributeGroups": [
            {
                "action": "servicecatalog:ListAssociatedAttributeGroups",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.ListAssociatedResources": [
            {
                "action": "servicecatalog:ListAssociatedResources",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.ListAttributeGroups": [
            {
                "action": "servicecatalog:ListAttributeGroups",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalogAppRegistry.ListTagsForResource": [
            {
                "action": "servicecatalog:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Application": "%%iftemplatematch%${resourceArn}%%",
                    "AttributeGroup": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "ServiceCatalogAppRegistry.SyncResource": [
            {
                "action": "servicecatalog:SyncResource",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalogAppRegistry.TagResource": [
            {
                "action": "servicecatalog:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Application": "%%iftemplatematch%${resourceArn}%%",
                    "AttributeGroup": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "ServiceCatalogAppRegistry.UntagResource": [
            {
                "action": "servicecatalog:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Application": "%%iftemplatematch%${resourceArn}%%",
                    "AttributeGroup": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "ServiceCatalogAppRegistry.UpdateAttributeGroup": [
            {
                "action": "servicecatalog:UpdateAttributeGroup",
                "resource_mappings": {
                    "AttributeGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "NetworkFirewall.AssociateFirewallPolicy": [
            {
                "action": "network-firewall:AssociateFirewallPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}",
                    "FirewallPolicy": "${FirewallPolicyArn}"
                }
            }
        ],
        "NetworkFirewall.AssociateSubnets": [
            {
                "action": "network-firewall:AssociateSubnets",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "NetworkFirewall.CreateFirewall": [
            {
                "action": "network-firewall:CreateFirewall",
                "resource_mappings": {
                    "Name": {
                        "template": "${FirewallName}"
                    }
                },
                "resourcearn_mappings": {
                    "FirewallPolicy": "${FirewallPolicyArn}"
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "NetworkFirewall.CreateFirewallPolicy": [
            {
                "action": "network-firewall:CreateFirewallPolicy",
                "resource_mappings": {
                    "Name": {
                        "template": "${FirewallPolicyName}"
                    }
                },
                "resourcearn_mappings": {
                    "StatefulRuleGroup": "${FirewallPolicy.StatefulRuleGroupReferences[].ResourceArn}",
                    "StatelessRuleGroup": "${FirewallPolicy.StatelessRuleGroupReferences[].ResourceArn}"
                }
            }
        ],
        "NetworkFirewall.CreateRuleGroup": [
            {
                "action": "network-firewall:CreateRuleGroup",
                "resource_mappings": {
                    "Name": {
                        "template": "*"
                    }
                }
            }
        ],
        "NetworkFirewall.DeleteFirewall": [
            {
                "action": "network-firewall:DeleteFirewall",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "NetworkFirewall.DeleteFirewallPolicy": [
            {
                "action": "network-firewall:DeleteFirewallPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "FirewallPolicy": "${FirewallPolicyArn}"
                }
            }
        ],
        "NetworkFirewall.DeleteResourcePolicy": [
            {
                "action": "network-firewall:DeleteResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "FirewallPolicy": "%%iftemplatematch%${ResourceArn}%%",
                    "StatefulRuleGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "NetworkFirewall.DeleteRuleGroup": [
            {
                "action": "network-firewall:DeleteRuleGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "StatefulRuleGroup": "%%iftemplatematch%${RuleGroupArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${RuleGroupArn}%%"
                }
            }
        ],
        "NetworkFirewall.DescribeFirewall": [
            {
                "action": "network-firewall:DescribeFirewall",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "NetworkFirewall.DescribeFirewallPolicy": [
            {
                "action": "network-firewall:DescribeFirewallPolicy",
                "resource_mappings": {
                    "Name": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "FirewallPolicy": "${FirewallPolicyArn}"
                }
            }
        ],
        "NetworkFirewall.DescribeLoggingConfiguration": [
            {
                "action": "network-firewall:DescribeLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "NetworkFirewall.DescribeResourcePolicy": [
            {
                "action": "network-firewall:DescribeResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "FirewallPolicy": "%%iftemplatematch%${ResourceArn}%%",
                    "StatefulRuleGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "NetworkFirewall.DescribeRuleGroup": [
            {
                "action": "network-firewall:DescribeRuleGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "StatefulRuleGroup": "%%iftemplatematch%${RuleGroupArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${RuleGroupArn}%%"
                }
            }
        ],
        "NetworkFirewall.DisassociateSubnets": [
            {
                "action": "network-firewall:DisassociateSubnets",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "NetworkFirewall.ListFirewallPolicies": [
            {
                "action": "network-firewall:ListFirewallPolicies",
                "resource_mappings": {
                    "Name": {
                        "template": "*"
                    }
                }
            }
        ],
        "NetworkFirewall.ListFirewalls": [
            {
                "action": "network-firewall:ListFirewalls",
                "resource_mappings": {
                    "Name": {
                        "template": "*"
                    }
                }
            }
        ],
        "NetworkFirewall.ListRuleGroups": [
            {
                "action": "network-firewall:ListRuleGroups",
                "resource_mappings": {}
            }
        ],
        "NetworkFirewall.ListTagsForResource": [
            {
                "action": "network-firewall:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "%%iftemplatematch%${ResourceArn}%%",
                    "FirewallPolicy": "%%iftemplatematch%${ResourceArn}%%",
                    "StatefulRuleGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "NetworkFirewall.PutResourcePolicy": [
            {
                "action": "network-firewall:PutResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "FirewallPolicy": "%%iftemplatematch%${ResourceArn}%%",
                    "StatefulRuleGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "NetworkFirewall.TagResource": [
            {
                "action": "network-firewall:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "%%iftemplatematch%${ResourceArn}%%",
                    "FirewallPolicy": "%%iftemplatematch%${ResourceArn}%%",
                    "StatefulRuleGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "NetworkFirewall.UntagResource": [
            {
                "action": "network-firewall:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "%%iftemplatematch%${ResourceArn}%%",
                    "FirewallPolicy": "%%iftemplatematch%${ResourceArn}%%",
                    "StatefulRuleGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "NetworkFirewall.UpdateFirewallDeleteProtection": [
            {
                "action": "network-firewall:UpdateFirewallDeleteProtection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "NetworkFirewall.UpdateFirewallDescription": [
            {
                "action": "network-firewall:UpdateFirewallDescription",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "NetworkFirewall.UpdateFirewallPolicy": [
            {
                "action": "network-firewall:UpdateFirewallPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "FirewallPolicy": "${FirewallPolicyArn}",
                    "StatefulRuleGroup": "${FirewallPolicy.StatefulRuleGroupReferences[].ResourceArn}",
                    "StatelessRuleGroup": "${FirewallPolicy.StatelessRuleGroupReferences[].ResourceArn}"
                }
            }
        ],
        "NetworkFirewall.UpdateFirewallPolicyChangeProtection": [
            {
                "action": "network-firewall:UpdateFirewallPolicyChangeProtection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "NetworkFirewall.UpdateLoggingConfiguration": [
            {
                "action": "network-firewall:UpdateLoggingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "NetworkFirewall.UpdateRuleGroup": [
            {
                "action": "network-firewall:UpdateRuleGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "StatefulRuleGroup": "%%iftemplatematch%${RuleGroupArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${RuleGroupArn}%%"
                }
            }
        ],
        "NetworkFirewall.UpdateSubnetChangeProtection": [
            {
                "action": "network-firewall:UpdateSubnetChangeProtection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Firewall": "${FirewallArn}"
                }
            }
        ],
        "MWAA.CreateCliToken": [
            {
                "action": "airflow:CreateCliToken",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MWAA.CreateEnvironment": [
            {
                "action": "airflow:CreateEnvironment",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MWAA.CreateWebLoginToken": [
            {
                "action": "airflow:CreateWebLoginToken",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${Name}"
                    },
                    "RoleName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MWAA.DeleteEnvironment": [
            {
                "action": "airflow:DeleteEnvironment",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MWAA.GetEnvironment": [
            {
                "action": "airflow:GetEnvironment",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MWAA.ListEnvironments": [
            {
                "action": "airflow:ListEnvironments",
                "resource_mappings": {}
            }
        ],
        "MWAA.ListTagsForResource": [
            {
                "action": "airflow:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MWAA.PublishMetrics": [
            {
                "action": "airflow:PublishMetrics",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${EnvironmentName}"
                    }
                }
            }
        ],
        "MWAA.TagResource": [
            {
                "action": "airflow:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MWAA.UntagResource": [
            {
                "action": "airflow:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MWAA.UpdateEnvironment": [
            {
                "action": "airflow:UpdateEnvironment",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AmplifyBackend.CloneBackend": [
            {
                "action": "amplifybackend:CloneBackend",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.CreateBackend": [
            {
                "action": "amplifybackend:CreateBackend",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.CreateBackendAPI": [
            {
                "action": "amplifybackend:CreateBackendAPI",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.CreateBackendAuth": [
            {
                "action": "amplifybackend:CreateBackendAuth",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.CreateBackendConfig": [
            {
                "action": "amplifybackend:CreateBackendConfig",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.CreateToken": [
            {
                "action": "amplifybackend:CreateToken",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.DeleteBackend": [
            {
                "action": "amplifybackend:DeleteBackend",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.DeleteBackendAPI": [
            {
                "action": "amplifybackend:DeleteBackendAPI",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.DeleteBackendAuth": [
            {
                "action": "amplifybackend:DeleteBackendAuth",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.DeleteToken": [
            {
                "action": "amplifybackend:DeleteToken",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.GenerateBackendAPIModels": [
            {
                "action": "amplifybackend:GenerateBackendAPIModels",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.GetBackend": [
            {
                "action": "amplifybackend:GetBackend",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.GetBackendAPI": [
            {
                "action": "amplifybackend:GetBackendAPI",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.GetBackendAPIModels": [
            {
                "action": "amplifybackend:GetBackendAPIModels",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.GetBackendAuth": [
            {
                "action": "amplifybackend:GetBackendAuth",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.GetBackendJob": [
            {
                "action": "amplifybackend:GetBackendJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.GetToken": [
            {
                "action": "amplifybackend:GetToken",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.ListBackendJobs": [
            {
                "action": "amplifybackend:ListBackendJobs",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.RemoveAllBackends": [
            {
                "action": "amplifybackend:RemoveAllBackends",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.RemoveBackendConfig": [
            {
                "action": "amplifybackend:RemoveBackendConfig",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.UpdateBackendAPI": [
            {
                "action": "amplifybackend:UpdateBackendAPI",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.UpdateBackendAuth": [
            {
                "action": "amplifybackend:UpdateBackendAuth",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.UpdateBackendConfig": [
            {
                "action": "amplifybackend:UpdateBackendConfig",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AmplifyBackend.UpdateBackendJob": [
            {
                "action": "amplifybackend:UpdateBackendJob",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "AppIntegrations.CreateEventIntegration": [
            {
                "action": "app-integrations:CreateEventIntegration",
                "resource_mappings": {
                    "EventIntegrationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppIntegrations.DeleteEventIntegration": [
            {
                "action": "app-integrations:DeleteEventIntegration",
                "resource_mappings": {
                    "EventIntegrationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppIntegrations.GetEventIntegration": [
            {
                "action": "app-integrations:GetEventIntegration",
                "resource_mappings": {
                    "EventIntegrationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppIntegrations.ListEventIntegrationAssociations": [
            {
                "action": "app-integrations:ListEventIntegrationAssociations",
                "resource_mappings": {}
            }
        ],
        "AppIntegrations.ListEventIntegrations": [
            {
                "action": "app-integrations:ListEventIntegrations",
                "resource_mappings": {}
            }
        ],
        "AppIntegrations.ListTagsForResource": [
            {
                "action": "app-integrations:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-integration": "%%iftemplatematch%${resourceArn}%%",
                    "event-integration-association": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AppIntegrations.TagResource": [
            {
                "action": "app-integrations:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-integration": "%%iftemplatematch%${resourceArn}%%",
                    "event-integration-association": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AppIntegrations.UntagResource": [
            {
                "action": "app-integrations:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-integration": "%%iftemplatematch%${resourceArn}%%",
                    "event-integration-association": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AppIntegrations.UpdateEventIntegration": [
            {
                "action": "app-integrations:UpdateEventIntegration",
                "resource_mappings": {
                    "EventIntegrationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "DevOpsGuru.AddNotificationChannel": [
            {
                "action": "devops-guru:AddNotificationChannel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${Config.Sns.TopicArn}"
                }
            },
            {
                "action": "sns:GetTopicAttributes",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${Config.Sns.TopicArn}"
                }
            }
        ],
        "DevOpsGuru.DescribeAccountHealth": [
            {
                "action": "devops-guru:DescribeAccountHealth",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.DescribeAccountOverview": [
            {
                "action": "devops-guru:DescribeAccountOverview",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.DescribeAnomaly": [
            {
                "action": "devops-guru:DescribeAnomaly",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.DescribeInsight": [
            {
                "action": "devops-guru:DescribeInsight",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.DescribeResourceCollectionHealth": [
            {
                "action": "devops-guru:DescribeResourceCollectionHealth",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.DescribeServiceIntegration": [
            {
                "action": "devops-guru:DescribeServiceIntegration",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.GetResourceCollection": [
            {
                "action": "devops-guru:GetResourceCollection",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.ListAnomaliesForInsight": [
            {
                "action": "devops-guru:ListAnomaliesForInsight",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.ListEvents": [
            {
                "action": "devops-guru:ListEvents",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.ListInsights": [
            {
                "action": "devops-guru:ListInsights",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.ListNotificationChannels": [
            {
                "action": "devops-guru:ListNotificationChannels",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.ListRecommendations": [
            {
                "action": "devops-guru:ListRecommendations",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.PutFeedback": [
            {
                "action": "devops-guru:PutFeedback",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.RemoveNotificationChannel": [
            {
                "action": "devops-guru:RemoveNotificationChannel",
                "resource_mappings": {
                    "TopicName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "sns:GetTopicAttributes",
                "resource_mappings": {
                    "TopicName": {
                        "template": "*"
                    }
                }
            }
        ],
        "DevOpsGuru.SearchInsights": [
            {
                "action": "devops-guru:SearchInsights",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.UpdateResourceCollection": [
            {
                "action": "devops-guru:UpdateResourceCollection",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.UpdateServiceIntegration": [
            {
                "action": "devops-guru:UpdateServiceIntegration",
                "resource_mappings": {}
            }
        ],
        "ECRPUBLIC.BatchCheckLayerAvailability": [
            {
                "action": "ecr-public:BatchCheckLayerAvailability",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.BatchDeleteImage": [
            {
                "action": "ecr-public:BatchDeleteImage",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.CompleteLayerUpload": [
            {
                "action": "ecr-public:CompleteLayerUpload",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.CreateRepository": [
            {
                "action": "ecr-public:CreateRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.DeleteRepository": [
            {
                "action": "ecr-public:DeleteRepository",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.DeleteRepositoryPolicy": [
            {
                "action": "ecr-public:DeleteRepositoryPolicy",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.DescribeImageTags": [
            {
                "action": "ecr-public:DescribeImageTags",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.DescribeImages": [
            {
                "action": "ecr-public:DescribeImages",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.DescribeRegistries": [
            {
                "action": "ecr-public:DescribeRegistries",
                "resource_mappings": {
                    "RegistryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ECRPUBLIC.DescribeRepositories": [
            {
                "action": "ecr-public:DescribeRepositories",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryNames[]}"
                    }
                }
            }
        ],
        "ECRPUBLIC.GetAuthorizationToken": [
            {
                "action": "ecr-public:GetAuthorizationToken",
                "resource_mappings": {}
            }
        ],
        "ECRPUBLIC.GetRegistryCatalogData": [
            {
                "action": "ecr-public:GetRegistryCatalogData",
                "resource_mappings": {
                    "RegistryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ECRPUBLIC.GetRepositoryCatalogData": [
            {
                "action": "ecr-public:GetRepositoryCatalogData",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.GetRepositoryPolicy": [
            {
                "action": "ecr-public:GetRepositoryPolicy",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.InitiateLayerUpload": [
            {
                "action": "ecr-public:InitiateLayerUpload",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.PutImage": [
            {
                "action": "ecr-public:PutImage",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.PutRegistryCatalogData": [
            {
                "action": "ecr-public:PutRegistryCatalogData",
                "resource_mappings": {
                    "RegistryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ECRPUBLIC.PutRepositoryCatalogData": [
            {
                "action": "ecr-public:PutRepositoryCatalogData",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.SetRepositoryPolicy": [
            {
                "action": "ecr-public:SetRepositoryPolicy",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "ECRPUBLIC.UploadLayerPart": [
            {
                "action": "ecr-public:UploadLayerPart",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "LookoutVision.CreateDataset": [
            {
                "action": "lookoutvision:CreateDataset",
                "resource_mappings": {}
            }
        ],
        "LookoutVision.CreateModel": [
            {
                "action": "lookoutvision:CreateModel",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    },
                    "ModelVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutVision.CreateProject": [
            {
                "action": "lookoutvision:CreateProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    }
                }
            }
        ],
        "LookoutVision.DeleteDataset": [
            {
                "action": "lookoutvision:DeleteDataset",
                "resource_mappings": {}
            }
        ],
        "LookoutVision.DeleteModel": [
            {
                "action": "lookoutvision:DeleteModel",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    },
                    "ModelVersion": {
                        "template": "${ModelVersion}"
                    }
                }
            }
        ],
        "LookoutVision.DeleteProject": [
            {
                "action": "lookoutvision:DeleteProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    }
                }
            }
        ],
        "LookoutVision.DescribeDataset": [
            {
                "action": "lookoutvision:DescribeDataset",
                "resource_mappings": {}
            }
        ],
        "LookoutVision.DescribeModel": [
            {
                "action": "lookoutvision:DescribeModel",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    },
                    "ModelVersion": {
                        "template": "${ModelVersion}"
                    }
                }
            }
        ],
        "LookoutVision.DescribeProject": [
            {
                "action": "lookoutvision:DescribeProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    }
                }
            }
        ],
        "LookoutVision.DetectAnomalies": [
            {
                "action": "lookoutvision:DetectAnomalies",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    },
                    "ModelVersion": {
                        "template": "${ModelVersion}"
                    }
                }
            }
        ],
        "LookoutVision.ListDatasetEntries": [
            {
                "action": "lookoutvision:ListDatasetEntries",
                "resource_mappings": {}
            }
        ],
        "LookoutVision.ListModels": [
            {
                "action": "lookoutvision:ListModels",
                "resource_mappings": {}
            }
        ],
        "LookoutVision.ListProjects": [
            {
                "action": "lookoutvision:ListProjects",
                "resource_mappings": {}
            }
        ],
        "LookoutVision.StartModel": [
            {
                "action": "lookoutvision:StartModel",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    },
                    "ModelVersion": {
                        "template": "${ModelVersion}"
                    }
                }
            }
        ],
        "LookoutVision.StopModel": [
            {
                "action": "lookoutvision:StopModel",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    },
                    "ModelVersion": {
                        "template": "${ModelVersion}"
                    }
                }
            }
        ],
        "LookoutVision.UpdateDatasetEntries": [
            {
                "action": "lookoutvision:UpdateDatasetEntries",
                "resource_mappings": {}
            }
        ],
        "SageMakerFeatureStoreRuntime.DeleteRecord": [
            {
                "action": "sagemaker:DeleteRecord",
                "resource_mappings": {
                    "FeatureGroupName": {
                        "template": "${FeatureGroupName}"
                    }
                }
            }
        ],
        "SageMakerFeatureStoreRuntime.GetRecord": [
            {
                "action": "sagemaker:GetRecord",
                "resource_mappings": {
                    "FeatureGroupName": {
                        "template": "${FeatureGroupName}"
                    }
                }
            }
        ],
        "SageMakerFeatureStoreRuntime.PutRecord": [
            {
                "action": "sagemaker:PutRecord",
                "resource_mappings": {
                    "FeatureGroupName": {
                        "template": "${FeatureGroupName}"
                    }
                }
            }
        ],
        "CustomerProfiles.AddProfileKey": [
            {
                "action": "profile:AddProfileKey",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.CreateDomain": [
            {
                "action": "profile:CreateDomain",
                "resource_mappings": {}
            }
        ],
        "CustomerProfiles.CreateProfile": [
            {
                "action": "profile:CreateProfile",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.DeleteDomain": [
            {
                "action": "profile:DeleteDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.DeleteIntegration": [
            {
                "action": "profile:DeleteIntegration",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    },
                    "Uri": {
                        "template": "${Uri}"
                    }
                }
            }
        ],
        "CustomerProfiles.DeleteProfile": [
            {
                "action": "profile:DeleteProfile",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.DeleteProfileKey": [
            {
                "action": "profile:DeleteProfileKey",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.DeleteProfileObject": [
            {
                "action": "profile:DeleteProfileObject",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    },
                    "ObjectTypeName": {
                        "template": "${ObjectTypeName}"
                    }
                }
            }
        ],
        "CustomerProfiles.DeleteProfileObjectType": [
            {
                "action": "profile:DeleteProfileObjectType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    },
                    "ObjectTypeName": {
                        "template": "${ObjectTypeName}"
                    }
                }
            }
        ],
        "CustomerProfiles.GetDomain": [
            {
                "action": "profile:GetDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.GetIntegration": [
            {
                "action": "profile:GetIntegration",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    },
                    "Uri": {
                        "template": "${Uri}"
                    }
                }
            }
        ],
        "CustomerProfiles.GetProfileObjectType": [
            {
                "action": "profile:GetProfileObjectType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    },
                    "ObjectTypeName": {
                        "template": "${ObjectTypeName}"
                    }
                }
            }
        ],
        "CustomerProfiles.GetProfileObjectTypeTemplate": [
            {
                "action": "profile:GetProfileObjectTypeTemplate",
                "resource_mappings": {}
            }
        ],
        "CustomerProfiles.ListAccountIntegrations": [
            {
                "action": "profile:ListAccountIntegrations",
                "resource_mappings": {}
            }
        ],
        "CustomerProfiles.ListDomains": [
            {
                "action": "profile:ListDomains",
                "resource_mappings": {}
            }
        ],
        "CustomerProfiles.ListIntegrations": [
            {
                "action": "profile:ListIntegrations",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.ListProfileObjectTypeTemplates": [
            {
                "action": "profile:ListProfileObjectTypeTemplates",
                "resource_mappings": {}
            }
        ],
        "CustomerProfiles.ListProfileObjectTypes": [
            {
                "action": "profile:ListProfileObjectTypes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.ListProfileObjects": [
            {
                "action": "profile:ListProfileObjects",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    },
                    "ObjectTypeName": {
                        "template": "${ObjectTypeName}"
                    }
                }
            }
        ],
        "CustomerProfiles.ListTagsForResource": [
            {
                "action": "profile:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "CustomerProfiles.PutIntegration": [
            {
                "action": "profile:PutIntegration",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    },
                    "Uri": {
                        "template": "${Uri}"
                    }
                }
            }
        ],
        "CustomerProfiles.PutProfileObject": [
            {
                "action": "profile:PutProfileObject",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    },
                    "ObjectTypeName": {
                        "template": "${ObjectTypeName}"
                    }
                }
            }
        ],
        "CustomerProfiles.PutProfileObjectType": [
            {
                "action": "profile:PutProfileObjectType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    },
                    "ObjectTypeName": {
                        "template": "${ObjectTypeName}"
                    }
                }
            }
        ],
        "CustomerProfiles.SearchProfiles": [
            {
                "action": "profile:SearchProfiles",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.TagResource": [
            {
                "action": "profile:TagResource",
                "resource_mappings": {}
            }
        ],
        "CustomerProfiles.UntagResource": [
            {
                "action": "profile:UntagResource",
                "resource_mappings": {}
            }
        ],
        "CustomerProfiles.UpdateDomain": [
            {
                "action": "profile:UpdateDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.UpdateProfile": [
            {
                "action": "profile:UpdateProfile",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "AuditManager.AssociateAssessmentReportEvidenceFolder": [
            {
                "action": "auditmanager:AssociateAssessmentReportEvidenceFolder",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.BatchAssociateAssessmentReportEvidence": [
            {
                "action": "auditmanager:BatchAssociateAssessmentReportEvidence",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.BatchCreateDelegationByAssessment": [
            {
                "action": "auditmanager:BatchCreateDelegationByAssessment",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.BatchDeleteDelegationByAssessment": [
            {
                "action": "auditmanager:BatchDeleteDelegationByAssessment",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.BatchDisassociateAssessmentReportEvidence": [
            {
                "action": "auditmanager:BatchDisassociateAssessmentReportEvidence",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.BatchImportEvidenceToAssessmentControl": [
            {
                "action": "auditmanager:BatchImportEvidenceToAssessmentControl",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.CreateAssessment": [
            {
                "action": "auditmanager:CreateAssessment",
                "resource_mappings": {}
            }
        ],
        "AuditManager.CreateAssessmentFramework": [
            {
                "action": "auditmanager:CreateAssessmentFramework",
                "resource_mappings": {}
            }
        ],
        "AuditManager.CreateAssessmentReport": [
            {
                "action": "auditmanager:CreateAssessmentReport",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.CreateControl": [
            {
                "action": "auditmanager:CreateControl",
                "resource_mappings": {}
            }
        ],
        "AuditManager.DeleteAssessment": [
            {
                "action": "auditmanager:DeleteAssessment",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.DeleteAssessmentFramework": [
            {
                "action": "auditmanager:DeleteAssessmentFramework",
                "resource_mappings": {
                    "assessmentFrameworkId": {
                        "template": "${frameworkId}"
                    }
                }
            }
        ],
        "AuditManager.DeleteAssessmentReport": [
            {
                "action": "auditmanager:DeleteAssessmentReport",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.DeleteControl": [
            {
                "action": "auditmanager:DeleteControl",
                "resource_mappings": {
                    "controlId": {
                        "template": "${controlId}"
                    }
                }
            }
        ],
        "AuditManager.DeregisterAccount": [
            {
                "action": "auditmanager:DeregisterAccount",
                "resource_mappings": {}
            }
        ],
        "AuditManager.DeregisterOrganizationAdminAccount": [
            {
                "action": "auditmanager:DeregisterOrganizationAdminAccount",
                "resource_mappings": {}
            }
        ],
        "AuditManager.DisassociateAssessmentReportEvidenceFolder": [
            {
                "action": "auditmanager:DisassociateAssessmentReportEvidenceFolder",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.GetAccountStatus": [
            {
                "action": "auditmanager:GetAccountStatus",
                "resource_mappings": {}
            }
        ],
        "AuditManager.GetAssessment": [
            {
                "action": "auditmanager:GetAssessment",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.GetAssessmentFramework": [
            {
                "action": "auditmanager:GetAssessmentFramework",
                "resource_mappings": {
                    "assessmentFrameworkId": {
                        "template": "${frameworkId}"
                    }
                }
            }
        ],
        "AuditManager.GetAssessmentReportUrl": [
            {
                "action": "auditmanager:GetAssessmentReportUrl",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.GetChangeLogs": [
            {
                "action": "auditmanager:GetChangeLogs",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.GetControl": [
            {
                "action": "auditmanager:GetControl",
                "resource_mappings": {
                    "controlId": {
                        "template": "${controlId}"
                    }
                }
            }
        ],
        "AuditManager.GetDelegations": [
            {
                "action": "auditmanager:GetDelegations",
                "resource_mappings": {}
            }
        ],
        "AuditManager.GetEvidence": [
            {
                "action": "auditmanager:GetEvidence",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.GetEvidenceByEvidenceFolder": [
            {
                "action": "auditmanager:GetEvidenceByEvidenceFolder",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.GetEvidenceFolder": [
            {
                "action": "auditmanager:GetEvidenceFolder",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.GetEvidenceFoldersByAssessment": [
            {
                "action": "auditmanager:GetEvidenceFoldersByAssessment",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.GetEvidenceFoldersByAssessmentControl": [
            {
                "action": "auditmanager:GetEvidenceFoldersByAssessmentControl",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.GetOrganizationAdminAccount": [
            {
                "action": "auditmanager:GetOrganizationAdminAccount",
                "resource_mappings": {}
            }
        ],
        "AuditManager.GetServicesInScope": [
            {
                "action": "auditmanager:GetServicesInScope",
                "resource_mappings": {}
            }
        ],
        "AuditManager.GetSettings": [
            {
                "action": "auditmanager:GetSettings",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListAssessmentFrameworks": [
            {
                "action": "auditmanager:ListAssessmentFrameworks",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListAssessmentReports": [
            {
                "action": "auditmanager:ListAssessmentReports",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListAssessments": [
            {
                "action": "auditmanager:ListAssessments",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListControls": [
            {
                "action": "auditmanager:ListControls",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListKeywordsForDataSource": [
            {
                "action": "auditmanager:ListKeywordsForDataSource",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListNotifications": [
            {
                "action": "auditmanager:ListNotifications",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListTagsForResource": [
            {
                "action": "auditmanager:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "assessment": "%%iftemplatematch%${resourceArn}%%",
                    "control": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AuditManager.RegisterAccount": [
            {
                "action": "auditmanager:RegisterAccount",
                "resource_mappings": {}
            }
        ],
        "AuditManager.RegisterOrganizationAdminAccount": [
            {
                "action": "auditmanager:RegisterOrganizationAdminAccount",
                "resource_mappings": {}
            }
        ],
        "AuditManager.TagResource": [
            {
                "action": "auditmanager:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "assessment": "%%iftemplatematch%${resourceArn}%%",
                    "control": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AuditManager.UntagResource": [
            {
                "action": "auditmanager:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "assessment": "%%iftemplatematch%${resourceArn}%%",
                    "control": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "AuditManager.UpdateAssessment": [
            {
                "action": "auditmanager:UpdateAssessment",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.UpdateAssessmentControl": [
            {
                "action": "auditmanager:UpdateAssessmentControl",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.UpdateAssessmentControlSetStatus": [
            {
                "action": "auditmanager:UpdateAssessmentControlSetStatus",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.UpdateAssessmentFramework": [
            {
                "action": "auditmanager:UpdateAssessmentFramework",
                "resource_mappings": {
                    "assessmentFrameworkId": {
                        "template": "${frameworkId}"
                    }
                }
            }
        ],
        "AuditManager.UpdateAssessmentStatus": [
            {
                "action": "auditmanager:UpdateAssessmentStatus",
                "resource_mappings": {
                    "assessmentId": {
                        "template": "${assessmentId}"
                    }
                }
            }
        ],
        "AuditManager.UpdateControl": [
            {
                "action": "auditmanager:UpdateControl",
                "resource_mappings": {
                    "controlId": {
                        "template": "${controlId}"
                    }
                }
            }
        ],
        "AuditManager.UpdateSettings": [
            {
                "action": "auditmanager:UpdateSettings",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ValidateAssessmentReportIntegrity": [
            {
                "action": "auditmanager:ValidateAssessmentReportIntegrity",
                "resource_mappings": {}
            }
        ],
        "EMRcontainers.CancelJobRun": [
            {
                "action": "emr-containers:CancelJobRun",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${virtualClusterId}"
                    },
                    "jobRunId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "EMRcontainers.CreateVirtualCluster": [
            {
                "action": "emr-containers:CreateVirtualCluster",
                "resource_mappings": {}
            }
        ],
        "EMRcontainers.DeleteVirtualCluster": [
            {
                "action": "emr-containers:DeleteVirtualCluster",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "EMRcontainers.DescribeJobRun": [
            {
                "action": "emr-containers:DescribeJobRun",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${virtualClusterId}"
                    },
                    "jobRunId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "EMRcontainers.DescribeVirtualCluster": [
            {
                "action": "emr-containers:DescribeVirtualCluster",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "EMRcontainers.ListJobRuns": [
            {
                "action": "emr-containers:ListJobRuns",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${virtualClusterId}"
                    }
                }
            }
        ],
        "EMRcontainers.ListVirtualClusters": [
            {
                "action": "emr-containers:ListVirtualClusters",
                "resource_mappings": {}
            }
        ],
        "SagemakerEdge.GetDeviceRegistration": [
            {
                "action": "sagemaker:GetDeviceRegistration",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    },
                    "DeviceName": {
                        "template": "${DeviceName}"
                    }
                }
            }
        ],
        "SagemakerEdge.SendHeartbeat": [
            {
                "action": "sagemaker:SendHeartbeat",
                "resource_mappings": {
                    "DeviceFleetName": {
                        "template": "${DeviceFleetName}"
                    },
                    "DeviceName": {
                        "template": "${DeviceName}"
                    }
                }
            }
        ],
        "Amp.CreateWorkspace": [
            {
                "action": "aps:CreateWorkspace",
                "resource_mappings": {}
            }
        ],
        "Amp.DeleteWorkspace": [
            {
                "action": "aps:DeleteWorkspace",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Amp.DescribeWorkspace": [
            {
                "action": "aps:DescribeWorkspace",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Amp.ListWorkspaces": [
            {
                "action": "aps:ListWorkspaces",
                "resource_mappings": {}
            }
        ],
        "Amp.UpdateWorkspaceAlias": [
            {
                "action": "aps:UpdateWorkspaceAlias",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "GreengrassV2.CancelDeployment": [
            {
                "action": "greengrass:CancelDeployment",
                "resource_mappings": {
                    "DeploymentId": {
                        "template": "${deploymentId}"
                    }
                }
            },
            {
                "action": "iot:CancelJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "GreengrassV2.CreateComponentVersion": [
            {
                "action": "greengrass:CreateComponentVersion",
                "resource_mappings": {
                    "ComponentName": {
                        "template": "${lambdaFunction.componentName}"
                    }
                }
            }
        ],
        "GreengrassV2.CreateDeployment": [
            {
                "action": "greengrass:CreateDeployment",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "%%iftemplatematch%${targetArn}%%"
                }
            },
            {
                "action": "iot:CancelJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "GreengrassV2.DeleteComponent": [
            {
                "action": "greengrass:DeleteComponent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "componentVersion": "${arn}"
                }
            }
        ],
        "GreengrassV2.DeleteCoreDevice": [
            {
                "action": "greengrass:DeleteCoreDevice",
                "resource_mappings": {
                    "CoreDeviceThingName": {
                        "template": "${coreDeviceThingName}"
                    }
                }
            },
            {
                "action": "iot:DescribeJobExecution",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    },
                    "ThingName": {
                        "template": "${coreDeviceThingName}"
                    }
                }
            }
        ],
        "GreengrassV2.DescribeComponent": [
            {
                "action": "greengrass:DescribeComponent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "componentVersion": "${arn}"
                }
            }
        ],
        "GreengrassV2.GetComponent": [
            {
                "action": "greengrass:GetComponent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "componentVersion": "${arn}"
                }
            }
        ],
        "GreengrassV2.GetCoreDevice": [
            {
                "action": "greengrass:GetCoreDevice",
                "resource_mappings": {
                    "CoreDeviceThingName": {
                        "template": "${coreDeviceThingName}"
                    }
                }
            }
        ],
        "GreengrassV2.GetDeployment": [
            {
                "action": "greengrass:GetDeployment",
                "resource_mappings": {
                    "DeploymentId": {
                        "template": "${deploymentId}"
                    }
                }
            },
            {
                "action": "iot:DescribeJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "GreengrassV2.ListComponentVersions": [
            {
                "action": "greengrass:ListComponentVersions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "${arn}"
                }
            }
        ],
        "GreengrassV2.ListComponents": [
            {
                "action": "greengrass:ListComponents",
                "resource_mappings": {}
            }
        ],
        "GreengrassV2.ListCoreDevices": [
            {
                "action": "greengrass:ListCoreDevices",
                "resource_mappings": {}
            }
        ],
        "GreengrassV2.ListDeployments": [
            {
                "action": "greengrass:ListDeployments",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "%%iftemplatematch%${targetArn}%%"
                }
            },
            {
                "action": "iot:DescribeJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "GreengrassV2.ListEffectiveDeployments": [
            {
                "action": "greengrass:ListEffectiveDeployments",
                "resource_mappings": {
                    "CoreDeviceThingName": {
                        "template": "${coreDeviceThingName}"
                    }
                }
            },
            {
                "action": "iot:DescribeJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "*"
                    }
                }
            }
        ],
        "GreengrassV2.ListInstalledComponents": [
            {
                "action": "greengrass:ListInstalledComponents",
                "resource_mappings": {
                    "CoreDeviceThingName": {
                        "template": "${coreDeviceThingName}"
                    }
                }
            }
        ],
        "GreengrassV2.ListTagsForResource": [
            {
                "action": "greengrass:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "%%iftemplatematch%${resourceArn}%%",
                    "componentVersion": "%%iftemplatematch%${resourceArn}%%",
                    "coreDevice": "%%iftemplatematch%${resourceArn}%%",
                    "deployment": "%%iftemplatematch%${resourceArn}%%",
                    "bulkDeployment": "%%iftemplatematch%${resourceArn}%%",
                    "connectorDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "coreDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "deviceDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "functionDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "group": "%%iftemplatematch%${resourceArn}%%",
                    "loggerDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "resourceDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "subscriptionDefinition": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "GreengrassV2.TagResource": [
            {
                "action": "greengrass:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "%%iftemplatematch%${resourceArn}%%",
                    "componentVersion": "%%iftemplatematch%${resourceArn}%%",
                    "coreDevice": "%%iftemplatematch%${resourceArn}%%",
                    "deployment": "%%iftemplatematch%${resourceArn}%%",
                    "bulkDeployment": "%%iftemplatematch%${resourceArn}%%",
                    "connectorDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "coreDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "deviceDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "functionDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "group": "%%iftemplatematch%${resourceArn}%%",
                    "loggerDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "resourceDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "subscriptionDefinition": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "GreengrassV2.UntagResource": [
            {
                "action": "greengrass:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "%%iftemplatematch%${resourceArn}%%",
                    "componentVersion": "%%iftemplatematch%${resourceArn}%%",
                    "coreDevice": "%%iftemplatematch%${resourceArn}%%",
                    "deployment": "%%iftemplatematch%${resourceArn}%%",
                    "bulkDeployment": "%%iftemplatematch%${resourceArn}%%",
                    "connectorDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "coreDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "deviceDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "functionDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "group": "%%iftemplatematch%${resourceArn}%%",
                    "loggerDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "resourceDefinition": "%%iftemplatematch%${resourceArn}%%",
                    "subscriptionDefinition": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IotDeviceAdvisor.CreateSuiteDefinition": [
            {
                "action": "iotdeviceadvisor:CreateSuiteDefinition",
                "resource_mappings": {}
            }
        ],
        "IotDeviceAdvisor.DeleteSuiteDefinition": [
            {
                "action": "iotdeviceadvisor:DeleteSuiteDefinition",
                "resource_mappings": {
                    "suiteDefinitionId": {
                        "template": "${suiteDefinitionId}"
                    }
                }
            }
        ],
        "IotDeviceAdvisor.GetSuiteDefinition": [
            {
                "action": "iotdeviceadvisor:GetSuiteDefinition",
                "resource_mappings": {
                    "suiteDefinitionId": {
                        "template": "${suiteDefinitionId}"
                    }
                }
            }
        ],
        "IotDeviceAdvisor.GetSuiteRun": [
            {
                "action": "iotdeviceadvisor:GetSuiteRun",
                "resource_mappings": {
                    "suiteDefinitionId": {
                        "template": "${suiteDefinitionId}"
                    },
                    "suiteRunId": {
                        "template": "${suiteRunId}"
                    }
                }
            }
        ],
        "IotDeviceAdvisor.GetSuiteRunReport": [
            {
                "action": "iotdeviceadvisor:GetSuiteRunReport",
                "resource_mappings": {
                    "suiteDefinitionId": {
                        "template": "${suiteDefinitionId}"
                    },
                    "suiteRunId": {
                        "template": "${suiteRunId}"
                    }
                }
            }
        ],
        "IotDeviceAdvisor.ListSuiteDefinitions": [
            {
                "action": "iotdeviceadvisor:ListSuiteDefinitions",
                "resource_mappings": {}
            }
        ],
        "IotDeviceAdvisor.ListSuiteRuns": [
            {
                "action": "iotdeviceadvisor:ListSuiteRuns",
                "resource_mappings": {
                    "suiteDefinitionId": {
                        "template": "${suiteDefinitionId}"
                    }
                }
            }
        ],
        "IotDeviceAdvisor.ListTagsForResource": [
            {
                "action": "iotdeviceadvisor:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "suitedefinition": "%%iftemplatematch%${resourceArn}%%",
                    "suiterun": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IotDeviceAdvisor.StartSuiteRun": [
            {
                "action": "iotdeviceadvisor:StartSuiteRun",
                "resource_mappings": {}
            }
        ],
        "IotDeviceAdvisor.TagResource": [
            {
                "action": "iotdeviceadvisor:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "suitedefinition": "%%iftemplatematch%${resourceArn}%%",
                    "suiterun": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IotDeviceAdvisor.UntagResource": [
            {
                "action": "iotdeviceadvisor:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "suitedefinition": "%%iftemplatematch%${resourceArn}%%",
                    "suiterun": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IotDeviceAdvisor.UpdateSuiteDefinition": [
            {
                "action": "iotdeviceadvisor:UpdateSuiteDefinition",
                "resource_mappings": {
                    "suiteDefinitionId": {
                        "template": "${suiteDefinitionId}"
                    }
                }
            }
        ],
        "IoTFleetHub.CreateApplication": [
            {
                "action": "iotfleethub:CreateApplication",
                "resource_mappings": {}
            },
            {
                "action": "sso:CreateManagedApplicationInstance",
                "resource_mappings": {}
            }
        ],
        "IoTFleetHub.DeleteApplication": [
            {
                "action": "iotfleethub:DeleteApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${applicationId}"
                    }
                }
            },
            {
                "action": "sso:DeleteManagedApplicationInstance",
                "resource_mappings": {}
            }
        ],
        "IoTFleetHub.DescribeApplication": [
            {
                "action": "iotfleethub:DescribeApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${applicationId}"
                    }
                }
            }
        ],
        "IoTFleetHub.ListApplications": [
            {
                "action": "iotfleethub:ListApplications",
                "resource_mappings": {}
            }
        ],
        "IoTFleetHub.ListTagsForResource": [
            {
                "action": "iotfleethub:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${resourceArn}%%",
                    "dashboard": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTFleetHub.TagResource": [
            {
                "action": "iotfleethub:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${resourceArn}%%",
                    "dashboard": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTFleetHub.UntagResource": [
            {
                "action": "iotfleethub:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${resourceArn}%%",
                    "dashboard": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "IoTFleetHub.UpdateApplication": [
            {
                "action": "iotfleethub:UpdateApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${applicationId}"
                    }
                }
            }
        ],
        "IoTWireless.AssociateWirelessDeviceWithThing": [
            {
                "action": "iotwireless:AssociateWirelessDeviceWithThing",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "${Id}"
                    }
                },
                "resourcearn_mappings": {
                    "thing": "${ThingArn}"
                }
            },
            {
                "action": "iot:DescribeThing",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "thing": "${ThingArn}"
                }
            }
        ],
        "IoTWireless.AssociateWirelessGatewayWithCertificate": [
            {
                "action": "iotwireless:AssociateWirelessGatewayWithCertificate",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    },
                    "Certificate": {
                        "template": "${IotCertificateId}"
                    }
                }
            }
        ],
        "IoTWireless.AssociateWirelessGatewayWithThing": [
            {
                "action": "iotwireless:AssociateWirelessGatewayWithThing",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    }
                },
                "resourcearn_mappings": {
                    "thing": "${ThingArn}"
                }
            },
            {
                "action": "iot:DescribeThing",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "thing": "${ThingArn}"
                }
            }
        ],
        "IoTWireless.CreateDestination": [
            {
                "action": "iotwireless:CreateDestination",
                "resource_mappings": {
                    "DestinationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "IoTWireless.CreateDeviceProfile": [
            {
                "action": "iotwireless:CreateDeviceProfile",
                "resource_mappings": {
                    "DeviceProfileId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.CreateServiceProfile": [
            {
                "action": "iotwireless:CreateServiceProfile",
                "resource_mappings": {
                    "ServiceProfileId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.CreateWirelessGateway": [
            {
                "action": "iotwireless:CreateWirelessGateway",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.CreateWirelessGatewayTask": [
            {
                "action": "iotwireless:CreateWirelessGatewayTask",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.DeleteDestination": [
            {
                "action": "iotwireless:DeleteDestination",
                "resource_mappings": {
                    "DestinationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "IoTWireless.DeleteDeviceProfile": [
            {
                "action": "iotwireless:DeleteDeviceProfile",
                "resource_mappings": {
                    "DeviceProfileId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.DeleteServiceProfile": [
            {
                "action": "iotwireless:DeleteServiceProfile",
                "resource_mappings": {
                    "ServiceProfileId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.DeleteWirelessDevice": [
            {
                "action": "iotwireless:DeleteWirelessDevice",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.DeleteWirelessGateway": [
            {
                "action": "iotwireless:DeleteWirelessGateway",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.DeleteWirelessGatewayTask": [
            {
                "action": "iotwireless:DeleteWirelessGatewayTask",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.DisassociateWirelessDeviceFromThing": [
            {
                "action": "iotwireless:DisassociateWirelessDeviceFromThing",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "${Id}"
                    },
                    "ThingName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iot:DescribeThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.DisassociateWirelessGatewayFromCertificate": [
            {
                "action": "iotwireless:DisassociateWirelessGatewayFromCertificate",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    },
                    "Certificate": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.DisassociateWirelessGatewayFromThing": [
            {
                "action": "iotwireless:DisassociateWirelessGatewayFromThing",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    },
                    "ThingName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iot:DescribeThing",
                "resource_mappings": {
                    "ThingName": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.GetDestination": [
            {
                "action": "iotwireless:GetDestination",
                "resource_mappings": {
                    "DestinationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "IoTWireless.GetDeviceProfile": [
            {
                "action": "iotwireless:GetDeviceProfile",
                "resource_mappings": {
                    "DeviceProfileId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.GetServiceEndpoint": [
            {
                "action": "iotwireless:GetServiceEndpoint",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.GetServiceProfile": [
            {
                "action": "iotwireless:GetServiceProfile",
                "resource_mappings": {
                    "ServiceProfileId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.GetWirelessDevice": [
            {
                "action": "iotwireless:GetWirelessDevice",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.GetWirelessDeviceStatistics": [
            {
                "action": "iotwireless:GetWirelessDeviceStatistics",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "${WirelessDeviceId}"
                    }
                }
            }
        ],
        "IoTWireless.GetWirelessGateway": [
            {
                "action": "iotwireless:GetWirelessGateway",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.GetWirelessGatewayCertificate": [
            {
                "action": "iotwireless:GetWirelessGatewayCertificate",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.GetWirelessGatewayFirmwareInformation": [
            {
                "action": "iotwireless:GetWirelessGatewayFirmwareInformation",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.GetWirelessGatewayStatistics": [
            {
                "action": "iotwireless:GetWirelessGatewayStatistics",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${WirelessGatewayId}"
                    }
                }
            }
        ],
        "IoTWireless.GetWirelessGatewayTask": [
            {
                "action": "iotwireless:GetWirelessGatewayTask",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.ListDestinations": [
            {
                "action": "iotwireless:ListDestinations",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ListDeviceProfiles": [
            {
                "action": "iotwireless:ListDeviceProfiles",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ListPartnerAccounts": [
            {
                "action": "iotwireless:ListPartnerAccounts",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ListServiceProfiles": [
            {
                "action": "iotwireless:ListServiceProfiles",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ListTagsForResource": [
            {
                "action": "iotwireless:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Destination": "%%iftemplatematch%${ResourceArn}%%",
                    "DeviceProfile": "%%iftemplatematch%${ResourceArn}%%",
                    "ServiceProfile": "%%iftemplatematch%${ResourceArn}%%",
                    "WirelessGateway": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "IoTWireless.ListWirelessDevices": [
            {
                "action": "iotwireless:ListWirelessDevices",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ListWirelessGatewayTaskDefinitions": [
            {
                "action": "iotwireless:ListWirelessGatewayTaskDefinitions",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ListWirelessGateways": [
            {
                "action": "iotwireless:ListWirelessGateways",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.SendDataToWirelessDevice": [
            {
                "action": "iotwireless:SendDataToWirelessDevice",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.TagResource": [
            {
                "action": "iotwireless:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Destination": "%%iftemplatematch%${ResourceArn}%%",
                    "DeviceProfile": "%%iftemplatematch%${ResourceArn}%%",
                    "ServiceProfile": "%%iftemplatematch%${ResourceArn}%%",
                    "WirelessGateway": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "IoTWireless.TestWirelessDevice": [
            {
                "action": "iotwireless:TestWirelessDevice",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.UntagResource": [
            {
                "action": "iotwireless:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Destination": "%%iftemplatematch%${ResourceArn}%%",
                    "DeviceProfile": "%%iftemplatematch%${ResourceArn}%%",
                    "ServiceProfile": "%%iftemplatematch%${ResourceArn}%%",
                    "WirelessGateway": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "IoTWireless.UpdateDestination": [
            {
                "action": "iotwireless:UpdateDestination",
                "resource_mappings": {
                    "DestinationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "IoTWireless.UpdateWirelessDevice": [
            {
                "action": "iotwireless:UpdateWirelessDevice",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.UpdateWirelessGateway": [
            {
                "action": "iotwireless:UpdateWirelessGateway",
                "resource_mappings": {
                    "WirelessGatewayId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Location.AssociateTrackerConsumer": [
            {
                "action": "geo:AssociateTrackerConsumer",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.BatchDeleteGeofence": [
            {
                "action": "geo:BatchDeleteGeofence",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.BatchEvaluateGeofences": [
            {
                "action": "geo:BatchEvaluateGeofences",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.BatchGetDevicePosition": [
            {
                "action": "geo:BatchGetDevicePosition",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.BatchPutGeofence": [
            {
                "action": "geo:BatchPutGeofence",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.BatchUpdateDevicePosition": [
            {
                "action": "geo:BatchUpdateDevicePosition",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.CreateGeofenceCollection": [
            {
                "action": "geo:CreateGeofenceCollection",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.CreateMap": [
            {
                "action": "geo:CreateMap",
                "resource_mappings": {
                    "MapName": {
                        "template": "${MapName}"
                    }
                }
            }
        ],
        "Location.CreatePlaceIndex": [
            {
                "action": "geo:CreatePlaceIndex",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "Location.CreateTracker": [
            {
                "action": "geo:CreateTracker",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.DeleteGeofenceCollection": [
            {
                "action": "geo:DeleteGeofenceCollection",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.DeleteMap": [
            {
                "action": "geo:DeleteMap",
                "resource_mappings": {
                    "MapName": {
                        "template": "${MapName}"
                    }
                }
            }
        ],
        "Location.DeletePlaceIndex": [
            {
                "action": "geo:DeletePlaceIndex",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "Location.DeleteTracker": [
            {
                "action": "geo:DeleteTracker",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.DescribeGeofenceCollection": [
            {
                "action": "geo:DescribeGeofenceCollection",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.DescribeMap": [
            {
                "action": "geo:DescribeMap",
                "resource_mappings": {
                    "MapName": {
                        "template": "${MapName}"
                    }
                }
            }
        ],
        "Location.DescribePlaceIndex": [
            {
                "action": "geo:DescribePlaceIndex",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "Location.DescribeTracker": [
            {
                "action": "geo:DescribeTracker",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.DisassociateTrackerConsumer": [
            {
                "action": "geo:DisassociateTrackerConsumer",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.GetDevicePosition": [
            {
                "action": "geo:GetDevicePosition",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.GetDevicePositionHistory": [
            {
                "action": "geo:GetDevicePositionHistory",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.GetGeofence": [
            {
                "action": "geo:GetGeofence",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.GetMapGlyphs": [
            {
                "action": "geo:GetMapGlyphs",
                "resource_mappings": {
                    "MapName": {
                        "template": "${MapName}"
                    }
                }
            }
        ],
        "Location.GetMapSprites": [
            {
                "action": "geo:GetMapSprites",
                "resource_mappings": {
                    "MapName": {
                        "template": "${MapName}"
                    }
                }
            }
        ],
        "Location.GetMapStyleDescriptor": [
            {
                "action": "geo:GetMapStyleDescriptor",
                "resource_mappings": {
                    "MapName": {
                        "template": "${MapName}"
                    }
                }
            }
        ],
        "Location.GetMapTile": [
            {
                "action": "geo:GetMapTile",
                "resource_mappings": {
                    "MapName": {
                        "template": "${MapName}"
                    }
                }
            }
        ],
        "Location.ListGeofenceCollections": [
            {
                "action": "geo:ListGeofenceCollections",
                "resource_mappings": {}
            }
        ],
        "Location.ListGeofences": [
            {
                "action": "geo:ListGeofences",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.ListMaps": [
            {
                "action": "geo:ListMaps",
                "resource_mappings": {}
            }
        ],
        "Location.ListPlaceIndexes": [
            {
                "action": "geo:ListPlaceIndexes",
                "resource_mappings": {}
            }
        ],
        "Location.ListTrackerConsumers": [
            {
                "action": "geo:ListTrackerConsumers",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.ListTrackers": [
            {
                "action": "geo:ListTrackers",
                "resource_mappings": {}
            }
        ],
        "Location.PutGeofence": [
            {
                "action": "geo:PutGeofence",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.SearchPlaceIndexForPosition": [
            {
                "action": "geo:SearchPlaceIndexForPosition",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "Location.SearchPlaceIndexForText": [
            {
                "action": "geo:SearchPlaceIndexForText",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "WellArchitected.AssociateLenses": [
            {
                "action": "wellarchitected:AssociateLenses",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.CreateMilestone": [
            {
                "action": "wellarchitected:CreateMilestone",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.CreateWorkload": [
            {
                "action": "wellarchitected:CreateWorkload",
                "resource_mappings": {}
            }
        ],
        "WellArchitected.CreateWorkloadShare": [
            {
                "action": "wellarchitected:CreateWorkloadShare",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.DeleteWorkload": [
            {
                "action": "wellarchitected:DeleteWorkload",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.DeleteWorkloadShare": [
            {
                "action": "wellarchitected:DeleteWorkloadShare",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.DisassociateLenses": [
            {
                "action": "wellarchitected:DisassociateLenses",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.GetAnswer": [
            {
                "action": "wellarchitected:GetAnswer",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.GetLensReview": [
            {
                "action": "wellarchitected:GetLensReview",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.GetLensReviewReport": [
            {
                "action": "wellarchitected:GetLensReviewReport",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.GetLensVersionDifference": [
            {
                "action": "wellarchitected:GetLensVersionDifference",
                "resource_mappings": {}
            }
        ],
        "WellArchitected.GetMilestone": [
            {
                "action": "wellarchitected:GetMilestone",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.GetWorkload": [
            {
                "action": "wellarchitected:GetWorkload",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.ListAnswers": [
            {
                "action": "wellarchitected:ListAnswers",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.ListLensReviewImprovements": [
            {
                "action": "wellarchitected:ListLensReviewImprovements",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.ListLensReviews": [
            {
                "action": "wellarchitected:ListLensReviews",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.ListLenses": [
            {
                "action": "wellarchitected:ListLenses",
                "resource_mappings": {}
            }
        ],
        "WellArchitected.ListMilestones": [
            {
                "action": "wellarchitected:ListMilestones",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.ListNotifications": [
            {
                "action": "wellarchitected:ListNotifications",
                "resource_mappings": {}
            }
        ],
        "WellArchitected.ListShareInvitations": [
            {
                "action": "wellarchitected:ListShareInvitations",
                "resource_mappings": {}
            }
        ],
        "WellArchitected.ListWorkloadShares": [
            {
                "action": "wellarchitected:ListWorkloadShares",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.ListWorkloads": [
            {
                "action": "wellarchitected:ListWorkloads",
                "resource_mappings": {}
            }
        ],
        "WellArchitected.UpdateAnswer": [
            {
                "action": "wellarchitected:UpdateAnswer",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.UpdateLensReview": [
            {
                "action": "wellarchitected:UpdateLensReview",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.UpdateShareInvitation": [
            {
                "action": "wellarchitected:UpdateShareInvitation",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "WellArchitected.UpdateWorkload": [
            {
                "action": "wellarchitected:UpdateWorkload",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.UpdateWorkloadShare": [
            {
                "action": "wellarchitected:UpdateWorkloadShare",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "WellArchitected.UpgradeLensReview": [
            {
                "action": "wellarchitected:UpgradeLensReview",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${WorkloadId}"
                    }
                }
            }
        ],
        "LexModelsV2.BuildBotLocale": [
            {
                "action": "lex:BuildBotLocale",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.CreateBotLocale": [
            {
                "action": "lex:CreateBotLocale",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.CreateBotVersion": [
            {
                "action": "lex:CreateBotVersion",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.CreateSlot": [
            {
                "action": "lex:CreateSlot",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteBot": [
            {
                "action": "lex:DeleteBot",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "${botId}"
                    },
                    "BotAliasId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteBotAlias": [
            {
                "action": "lex:DeleteBotAlias",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotAlias": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "${botId}"
                    },
                    "BotAliasId": {
                        "template": "${botAliasId}"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteBotLocale": [
            {
                "action": "lex:DeleteBotLocale",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteBotVersion": [
            {
                "action": "lex:DeleteBotVersion",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "${botVersion}"
                    },
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteIntent": [
            {
                "action": "lex:DeleteIntent",
                "resource_mappings": {
                    "IntentName": {
                        "template": "*"
                    },
                    "IntentVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteSlot": [
            {
                "action": "lex:DeleteSlot",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteSlotType": [
            {
                "action": "lex:DeleteSlotType",
                "resource_mappings": {
                    "SlotName": {
                        "template": "*"
                    },
                    "SlotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeBot": [
            {
                "action": "lex:DescribeBot",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeBotAlias": [
            {
                "action": "lex:DescribeBotAlias",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    },
                    "BotAliasId": {
                        "template": "${botAliasId}"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeBotLocale": [
            {
                "action": "lex:DescribeBotLocale",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeBotVersion": [
            {
                "action": "lex:DescribeBotVersion",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeSlot": [
            {
                "action": "lex:DescribeSlot",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.ListBotAliases": [
            {
                "action": "lex:ListBotAliases",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.ListBotLocales": [
            {
                "action": "lex:ListBotLocales",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.ListSlots": [
            {
                "action": "lex:ListSlots",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.ListTagsForResource": [
            {
                "action": "lex:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceARN}%%",
                    "bot alias": "%%iftemplatematch%${resourceARN}%%",
                    "channel": "%%iftemplatematch%${resourceARN}%%"
                }
            }
        ],
        "LexModelsV2.TagResource": [
            {
                "action": "lex:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceARN}%%",
                    "bot alias": "%%iftemplatematch%${resourceARN}%%",
                    "channel": "%%iftemplatematch%${resourceARN}%%"
                }
            }
        ],
        "LexModelsV2.UntagResource": [
            {
                "action": "lex:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceARN}%%",
                    "bot alias": "%%iftemplatematch%${resourceARN}%%",
                    "channel": "%%iftemplatematch%${resourceARN}%%"
                }
            }
        ],
        "LexModelsV2.UpdateBotLocale": [
            {
                "action": "lex:UpdateBotLocale",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.UpdateSlot": [
            {
                "action": "lex:UpdateSlot",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexRuntimeV2.DeleteSession": [
            {
                "action": "lex:DeleteSession",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotAlias": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "${botId}"
                    },
                    "BotAliasId": {
                        "template": "${botAliasId}"
                    }
                }
            }
        ],
        "LexRuntimeV2.GetSession": [
            {
                "action": "lex:GetSession",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotAlias": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "${botId}"
                    },
                    "BotAliasId": {
                        "template": "${botAliasId}"
                    }
                }
            }
        ],
        "LexRuntimeV2.PutSession": [
            {
                "action": "lex:PutSession",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotAlias": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    },
                    "BotId": {
                        "template": "${botId}"
                    },
                    "BotAliasId": {
                        "template": "${botAliasId}"
                    }
                }
            }
        ],
        "LexRuntimeV2.RecognizeText": [
            {
                "action": "lex:RecognizeText",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    },
                    "BotAliasId": {
                        "template": "${botAliasId}"
                    }
                }
            }
        ],
        "ACM.GetAccountConfiguration": [
            {
                "action": "acm:GetAccountConfiguration",
                "resource_mappings": {}
            }
        ],
        "ACM.PutAccountConfiguration": [
            {
                "action": "acm:PutAccountConfiguration",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeAddressesAttribute": [
            {
                "action": "ec2:DescribeAddressesAttribute",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifyAddressAttribute": [
            {
                "action": "ec2:ModifyAddressAttribute",
                "resource_mappings": {}
            }
        ],
        "EC2.ResetAddressAttribute": [
            {
                "action": "ec2:ResetAddressAttribute",
                "resource_mappings": {}
            }
        ],
        "IAM.ListInstanceProfileTags": [
            {
                "action": "iam:ListInstanceProfileTags",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "${InstanceProfileName}"
                    }
                }
            }
        ],
        "IAM.ListMFADeviceTags": [
            {
                "action": "iam:ListMFADeviceTags",
                "resource_mappings": {
                    "MfaTokenIdWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.ListOpenIDConnectProviderTags": [
            {
                "action": "iam:ListOpenIDConnectProviderTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "oidc-provider": "${OpenIDConnectProviderArn}"
                }
            }
        ],
        "IAM.ListPolicyTags": [
            {
                "action": "iam:ListPolicyTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.ListSAMLProviderTags": [
            {
                "action": "iam:ListSAMLProviderTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "saml-provider": "${SAMLProviderArn}"
                }
            }
        ],
        "IAM.ListServerCertificateTags": [
            {
                "action": "iam:ListServerCertificateTags",
                "resource_mappings": {
                    "CertificateNameWithPath": {
                        "template": "${ServerCertificateName}"
                    }
                }
            }
        ],
        "IAM.TagInstanceProfile": [
            {
                "action": "iam:TagInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "${InstanceProfileName}"
                    }
                }
            }
        ],
        "IAM.TagMFADevice": [
            {
                "action": "iam:TagMFADevice",
                "resource_mappings": {
                    "MfaTokenIdWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.TagOpenIDConnectProvider": [
            {
                "action": "iam:TagOpenIDConnectProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "oidc-provider": "${OpenIDConnectProviderArn}"
                }
            }
        ],
        "IAM.TagPolicy": [
            {
                "action": "iam:TagPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.TagSAMLProvider": [
            {
                "action": "iam:TagSAMLProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "saml-provider": "${SAMLProviderArn}"
                }
            }
        ],
        "IAM.TagServerCertificate": [
            {
                "action": "iam:TagServerCertificate",
                "resource_mappings": {
                    "CertificateNameWithPath": {
                        "template": "${ServerCertificateName}"
                    }
                }
            }
        ],
        "IAM.UntagInstanceProfile": [
            {
                "action": "iam:UntagInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "${InstanceProfileName}"
                    }
                }
            }
        ],
        "IAM.UntagMFADevice": [
            {
                "action": "iam:UntagMFADevice",
                "resource_mappings": {
                    "MfaTokenIdWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IAM.UntagOpenIDConnectProvider": [
            {
                "action": "iam:UntagOpenIDConnectProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "oidc-provider": "${OpenIDConnectProviderArn}"
                }
            }
        ],
        "IAM.UntagPolicy": [
            {
                "action": "iam:UntagPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "policy": "${PolicyArn}"
                }
            }
        ],
        "IAM.UntagSAMLProvider": [
            {
                "action": "iam:UntagSAMLProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "saml-provider": "${SAMLProviderArn}"
                }
            }
        ],
        "IAM.UntagServerCertificate": [
            {
                "action": "iam:UntagServerCertificate",
                "resource_mappings": {
                    "CertificateNameWithPath": {
                        "template": "${ServerCertificateName}"
                    }
                }
            }
        ],
        "Athena.ListEngineVersions": [
            {
                "action": "athena:ListEngineVersions",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ContainsPiiEntities": [
            {
                "action": "comprehend:ContainsPiiEntities",
                "resource_mappings": {}
            }
        ],
        "EKS.AssociateEncryptionConfig": [
            {
                "action": "eks:AssociateEncryptionConfig",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    }
                }
            }
        ],
        "EKS.AssociateIdentityProviderConfig": [
            {
                "action": "eks:AssociateIdentityProviderConfig",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    }
                }
            }
        ],
        "EKS.DescribeIdentityProviderConfig": [
            {
                "action": "eks:DescribeIdentityProviderConfig",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "IdentityProviderType": {
                        "template": "${identityProviderConfig.type}"
                    },
                    "IdentityProviderConfigName": {
                        "template": "${identityProviderConfig.name}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.DisassociateIdentityProviderConfig": [
            {
                "action": "eks:DisassociateIdentityProviderConfig",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    },
                    "IdentityProviderType": {
                        "template": "${identityProviderConfig.type}"
                    },
                    "IdentityProviderConfigName": {
                        "template": "${identityProviderConfig.name}"
                    },
                    "UUID": {
                        "template": "*"
                    }
                }
            }
        ],
        "EKS.ListIdentityProviderConfigs": [
            {
                "action": "eks:ListIdentityProviderConfigs",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${clusterName}"
                    }
                }
            }
        ],
        "Imagebuilder.ListImagePackages": [
            {
                "action": "imagebuilder:ListImagePackages",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "image": "${imageBuildVersionArn}"
                }
            }
        ],
        "LookoutVision.ListTagsForResource": [
            {
                "action": "lookoutvision:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "model": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LookoutVision.TagResource": [
            {
                "action": "lookoutvision:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "model": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LookoutVision.UntagResource": [
            {
                "action": "lookoutvision:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "model": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "WellArchitected.ListTagsForResource": [
            {
                "action": "wellarchitected:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "workload": "${WorkloadArn}"
                }
            }
        ],
        "WellArchitected.TagResource": [
            {
                "action": "wellarchitected:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "workload": "${WorkloadArn}"
                }
            }
        ],
        "WellArchitected.UntagResource": [
            {
                "action": "wellarchitected:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "workload": "${WorkloadArn}"
                }
            }
        ],
        "Fis.DeleteExperimentTemplate": [
            {
                "action": "fis:DeleteExperimentTemplate",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Fis.GetAction": [
            {
                "action": "fis:GetAction",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Fis.GetExperiment": [
            {
                "action": "fis:GetExperiment",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Fis.GetExperimentTemplate": [
            {
                "action": "fis:GetExperimentTemplate",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Fis.ListActions": [
            {
                "action": "fis:ListActions",
                "resource_mappings": {}
            }
        ],
        "Fis.ListExperimentTemplates": [
            {
                "action": "fis:ListExperimentTemplates",
                "resource_mappings": {}
            }
        ],
        "Fis.ListExperiments": [
            {
                "action": "fis:ListExperiments",
                "resource_mappings": {}
            }
        ],
        "Fis.ListTagsForResource": [
            {
                "action": "fis:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "action": "%%iftemplatematch%${resourceArn}%%",
                    "experiment": "%%iftemplatematch%${resourceArn}%%",
                    "experiment-template": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Fis.StartExperiment": [
            {
                "action": "fis:StartExperiment",
                "resource_mappings": {
                    "Id": {
                        "template": "${experimentTemplateId}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Fis.StopExperiment": [
            {
                "action": "fis:StopExperiment",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Fis.TagResource": [
            {
                "action": "fis:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "action": "%%iftemplatematch%${resourceArn}%%",
                    "experiment": "%%iftemplatematch%${resourceArn}%%",
                    "experiment-template": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Fis.UntagResource": [
            {
                "action": "fis:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "action": "%%iftemplatematch%${resourceArn}%%",
                    "experiment": "%%iftemplatematch%${resourceArn}%%",
                    "experiment-template": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "RDS.CreateDBProxyEndpoint": [
            {
                "action": "rds:CreateDBProxyEndpoint",
                "resource_mappings": {
                    "DbProxyId": {
                        "template": "*"
                    },
                    "DbProxyEndpointId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.DeleteDBProxyEndpoint": [
            {
                "action": "rds:DeleteDBProxyEndpoint",
                "resource_mappings": {
                    "DbProxyEndpointId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.DescribeDBProxyEndpoints": [
            {
                "action": "rds:DescribeDBProxyEndpoints",
                "resource_mappings": {
                    "DbProxyId": {
                        "template": "*"
                    },
                    "DbProxyEndpointId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.FailoverGlobalCluster": [
            {
                "action": "rds:FailoverGlobalCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${TargetDbClusterIdentifier}"
                    },
                    "GlobalCluster": {
                        "template": "${GlobalClusterIdentifier}"
                    }
                }
            }
        ],
        "RDS.ModifyDBProxyEndpoint": [
            {
                "action": "rds:ModifyDBProxyEndpoint",
                "resource_mappings": {
                    "DbProxyEndpointId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.DisassociateRecoveryPoint": [
            {
                "action": "backup:DisassociateRecoveryPoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recoveryPoint": "${RecoveryPointArn}"
                }
            }
        ],
        "EC2.AcceptReservedInstancesExchangeQuote": [
            {
                "action": "ec2:AcceptReservedInstancesExchangeQuote",
                "resource_mappings": {
                    "ReservationId": {
                        "template": "${ReservedInstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.DisableSerialConsoleAccess": [
            {
                "action": "ec2:DisableSerialConsoleAccess",
                "resource_mappings": {}
            }
        ],
        "EC2.EnableSerialConsoleAccess": [
            {
                "action": "ec2:EnableSerialConsoleAccess",
                "resource_mappings": {}
            }
        ],
        "EC2.GetSerialConsoleAccessStatus": [
            {
                "action": "ec2:GetSerialConsoleAccessStatus",
                "resource_mappings": {}
            }
        ],
        "ElastiCache.CreateUserGroup": [
            {
                "action": "elasticache:CreateUserGroup",
                "resource_mappings": {
                    "UserId": {
                        "template": "${UserIds[]}"
                    },
                    "UserGroupId": {
                        "template": "${UserGroupId}"
                    }
                }
            },
            {
                "action": "elasticache:AddTagsToResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "*",
                    "parametergroup": "*",
                    "replicationgroup": "*",
                    "reserved-instance": "*",
                    "securitygroup": "*",
                    "snapshot": "*",
                    "subnetgroup": "*",
                    "user": "*",
                    "usergroup": "*"
                }
            }
        ],
        "GameLift.CreateFleetLocations": [
            {
                "action": "gamelift:CreateFleetLocations",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DeleteFleetLocations": [
            {
                "action": "gamelift:DeleteFleetLocations",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DescribeFleetLocationAttributes": [
            {
                "action": "gamelift:DescribeFleetLocationAttributes",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DescribeFleetLocationCapacity": [
            {
                "action": "gamelift:DescribeFleetLocationCapacity",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "GameLift.DescribeFleetLocationUtilization": [
            {
                "action": "gamelift:DescribeFleetLocationUtilization",
                "resource_mappings": {
                    "FleetId": {
                        "template": "${FleetId}"
                    }
                }
            }
        ],
        "Iot.ConfirmTopicRuleDestination": [
            {
                "action": "iot:ConfirmTopicRuleDestination",
                "resource_mappings": {
                    "destinationType": {
                        "template": "*"
                    },
                    "uuid": {
                        "template": "*"
                    }
                }
            }
        ],
        "Iot.CreateProvisioningTemplate": [
            {
                "action": "iot:CreateProvisioningTemplate",
                "resource_mappings": {
                    "provisioningTemplate": {
                        "template": "${templateName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${provisioningRoleArn}"
                }
            }
        ],
        "Iot.CreateRoleAlias": [
            {
                "action": "iot:CreateRoleAlias",
                "resource_mappings": {
                    "RoleAlias": {
                        "template": "${roleAlias}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${roleArn}"
                }
            }
        ],
        "Iot.RegisterCACertificate": [
            {
                "action": "iot:RegisterCACertificate",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${registrationConfig.roleArn}"
                }
            }
        ],
        "Iot.UpdateCACertificate": [
            {
                "action": "iot:UpdateCACertificate",
                "resource_mappings": {
                    "CACertificate": {
                        "template": "${certificateId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${registrationConfig.roleArn}"
                }
            }
        ],
        "Iot.UpdateProvisioningTemplate": [
            {
                "action": "iot:UpdateProvisioningTemplate",
                "resource_mappings": {
                    "provisioningTemplate": {
                        "template": "${templateName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${provisioningRoleArn}"
                }
            }
        ],
        "Iot.UpdateRoleAlias": [
            {
                "action": "iot:UpdateRoleAlias",
                "resource_mappings": {
                    "RoleAlias": {
                        "template": "${roleAlias}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${roleArn}"
                }
            }
        ],
        "Lightsail.CopySnapshot": [
            {
                "action": "lightsail:CopySnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DetachCertificateFromDistribution": [
            {
                "action": "lightsail:DetachCertificateFromDistribution",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Redshift.ModifyAquaConfiguration": [
            {
                "action": "redshift:ModifyAquaConfiguration",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Rekognition.ListTagsForResource": [
            {
                "action": "rekognition:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "projectversion": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Rekognition.TagResource": [
            {
                "action": "rekognition:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "projectversion": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Rekognition.UntagResource": [
            {
                "action": "rekognition:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "projectversion": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Shield.AssociateHealthCheck": [
            {
                "action": "shield:AssociateHealthCheck",
                "resource_mappings": {
                    "Id": {
                        "template": "${ProtectionId}"
                    }
                }
            },
            {
                "action": "route53:GetHealthCheck",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "healthcheck": "${HealthCheckArn}"
                }
            }
        ],
        "Shield.CreateProtection": [
            {
                "action": "shield:CreateProtection",
                "resource_mappings": {}
            }
        ],
        "Shield.DisassociateHealthCheck": [
            {
                "action": "shield:DisassociateHealthCheck",
                "resource_mappings": {
                    "Id": {
                        "template": "${ProtectionId}"
                    }
                }
            }
        ],
        "Shield.ListTagsForResource": [
            {
                "action": "shield:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "protection": "%%iftemplatematch%${ResourceARN}%%",
                    "protection-group": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Shield.TagResource": [
            {
                "action": "shield:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "protection": "%%iftemplatematch%${ResourceARN}%%",
                    "protection-group": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "Shield.UntagResource": [
            {
                "action": "shield:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "protection": "%%iftemplatematch%${ResourceARN}%%",
                    "protection-group": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "StorageGateway.AssociateFileSystem": [
            {
                "action": "storagegateway:AssociateFileSystem",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.DescribeFileSystemAssociations": [
            {
                "action": "storagegateway:DescribeFileSystemAssociations",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fs-association": "${FileSystemAssociationARNList[]}"
                }
            }
        ],
        "StorageGateway.DisassociateFileSystem": [
            {
                "action": "storagegateway:DisassociateFileSystem",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fs-association": "${FileSystemAssociationARN}"
                }
            }
        ],
        "StorageGateway.ListFileSystemAssociations": [
            {
                "action": "storagegateway:ListFileSystemAssociations",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "StorageGateway.UpdateFileSystemAssociation": [
            {
                "action": "storagegateway:UpdateFileSystemAssociation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "fs-association": "${FileSystemAssociationARN}"
                }
            }
        ],
        "Athena.CreatePreparedStatement": [
            {
                "action": "athena:CreatePreparedStatement",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Athena.DeletePreparedStatement": [
            {
                "action": "athena:DeletePreparedStatement",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Athena.GetPreparedStatement": [
            {
                "action": "athena:GetPreparedStatement",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Athena.ListPreparedStatements": [
            {
                "action": "athena:ListPreparedStatements",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Athena.UpdatePreparedStatement": [
            {
                "action": "athena:UpdatePreparedStatement",
                "resource_mappings": {
                    "WorkGroupName": {
                        "template": "${WorkGroup}"
                    }
                }
            }
        ],
        "Route53Resolver.AssociateFirewallRuleGroup": [
            {
                "action": "route53resolver:AssociateFirewallRuleGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.CreateFirewallDomainList": [
            {
                "action": "route53resolver:CreateFirewallDomainList",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.CreateFirewallRule": [
            {
                "action": "route53resolver:CreateFirewallRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallRuleGroupId}"
                    }
                }
            }
        ],
        "Route53Resolver.CreateFirewallRuleGroup": [
            {
                "action": "route53resolver:CreateFirewallRuleGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.DeleteFirewallDomainList": [
            {
                "action": "route53resolver:DeleteFirewallDomainList",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallDomainListId}"
                    }
                }
            }
        ],
        "Route53Resolver.DeleteFirewallRule": [
            {
                "action": "route53resolver:DeleteFirewallRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallRuleGroupId}"
                    }
                }
            }
        ],
        "Route53Resolver.DeleteFirewallRuleGroup": [
            {
                "action": "route53resolver:DeleteFirewallRuleGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallRuleGroupId}"
                    }
                }
            }
        ],
        "Route53Resolver.DisassociateFirewallRuleGroup": [
            {
                "action": "route53resolver:DisassociateFirewallRuleGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallRuleGroupAssociationId}"
                    }
                }
            }
        ],
        "Route53Resolver.GetFirewallConfig": [
            {
                "action": "route53resolver:GetFirewallConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResourceId}"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.GetFirewallDomainList": [
            {
                "action": "route53resolver:GetFirewallDomainList",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallDomainListId}"
                    }
                }
            }
        ],
        "Route53Resolver.GetFirewallRuleGroup": [
            {
                "action": "route53resolver:GetFirewallRuleGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallRuleGroupId}"
                    }
                }
            }
        ],
        "Route53Resolver.GetFirewallRuleGroupAssociation": [
            {
                "action": "route53resolver:GetFirewallRuleGroupAssociation",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallRuleGroupAssociationId}"
                    }
                }
            }
        ],
        "Route53Resolver.GetFirewallRuleGroupPolicy": [
            {
                "action": "route53resolver:GetFirewallRuleGroupPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "firewall-rule-group": "${Arn}"
                }
            }
        ],
        "Route53Resolver.ImportFirewallDomains": [
            {
                "action": "route53resolver:ImportFirewallDomains",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallDomainListId}"
                    }
                }
            }
        ],
        "Route53Resolver.ListFirewallConfigs": [
            {
                "action": "route53resolver:ListFirewallConfigs",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.ListFirewallDomainLists": [
            {
                "action": "route53resolver:ListFirewallDomainLists",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.ListFirewallDomains": [
            {
                "action": "route53resolver:ListFirewallDomains",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallDomainListId}"
                    }
                }
            }
        ],
        "Route53Resolver.ListFirewallRuleGroupAssociations": [
            {
                "action": "route53resolver:ListFirewallRuleGroupAssociations",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.ListFirewallRuleGroups": [
            {
                "action": "route53resolver:ListFirewallRuleGroups",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.ListFirewallRules": [
            {
                "action": "route53resolver:ListFirewallRules",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallRuleGroupId}"
                    }
                }
            }
        ],
        "Route53Resolver.PutFirewallRuleGroupPolicy": [
            {
                "action": "route53resolver:PutFirewallRuleGroupPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "firewall-rule-group": "${Arn}"
                }
            }
        ],
        "Route53Resolver.UpdateFirewallDomains": [
            {
                "action": "route53resolver:UpdateFirewallDomains",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallDomainListId}"
                    }
                }
            }
        ],
        "Route53Resolver.UpdateFirewallRule": [
            {
                "action": "route53resolver:UpdateFirewallRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallRuleGroupId}"
                    }
                }
            }
        ],
        "Route53Resolver.UpdateFirewallRuleGroupAssociation": [
            {
                "action": "route53resolver:UpdateFirewallRuleGroupAssociation",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FirewallRuleGroupAssociationId}"
                    }
                }
            }
        ],
        "FSx.CopyBackup": [
            {
                "action": "fsx:CopyBackup",
                "resource_mappings": {
                    "BackupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "fsx:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "backup": "*",
                    "file-system": "*",
                    "task": "*"
                }
            }
        ],
        "Imagebuilder.CreateComponent": [
            {
                "action": "imagebuilder:CreateComponent",
                "resource_mappings": {
                    "ComponentName": {
                        "template": "${name}"
                    },
                    "ComponentVersion": {
                        "template": "${semanticVersion}"
                    },
                    "ComponentBuildVersion": {
                        "template": "*"
                    },
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "imagebuilder:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "*",
                    "containerRecipe": "*",
                    "distributionConfiguration": "*",
                    "image": "*",
                    "imagePipeline": "*",
                    "imageRecipe": "*",
                    "infrastructureConfiguration": "*"
                }
            },
            {
                "action": "kms:Encrypt",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            },
            {
                "action": "kms:GenerateDataKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            },
            {
                "action": "kms:GenerateDataKeyWithoutPlaintext",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            }
        ],
        "Imagebuilder.CreateContainerRecipe": [
            {
                "action": "imagebuilder:CreateContainerRecipe",
                "resource_mappings": {
                    "ContainerRecipeName": {
                        "template": "${name}"
                    },
                    "ContainerRecipeVersion": {
                        "template": "${semanticVersion}"
                    }
                }
            },
            {
                "action": "ecr:DescribeImages",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${targetRepository.repositoryName}"
                    }
                }
            },
            {
                "action": "ecr:DescribeRepositories",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${targetRepository.repositoryName}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "imagebuilder:GetComponent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "${components[].componentArn}"
                }
            },
            {
                "action": "imagebuilder:GetImage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "image": "${parentImage}"
                }
            },
            {
                "action": "imagebuilder:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "*",
                    "containerRecipe": "*",
                    "distributionConfiguration": "*",
                    "image": "*",
                    "imagePipeline": "*",
                    "imageRecipe": "*",
                    "infrastructureConfiguration": "*"
                }
            },
            {
                "action": "kms:Encrypt",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            },
            {
                "action": "kms:GenerateDataKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            },
            {
                "action": "kms:GenerateDataKeyWithoutPlaintext",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            }
        ],
        "Imagebuilder.CreateDistributionConfiguration": [
            {
                "action": "imagebuilder:CreateDistributionConfiguration",
                "resource_mappings": {
                    "DistributionConfigurationName": {
                        "template": "${name}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "imagebuilder:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "*",
                    "containerRecipe": "*",
                    "distributionConfiguration": "*",
                    "image": "*",
                    "imagePipeline": "*",
                    "imageRecipe": "*",
                    "infrastructureConfiguration": "*"
                }
            }
        ],
        "Imagebuilder.CreateImage": [
            {
                "action": "imagebuilder:CreateImage",
                "resource_mappings": {
                    "ImageName": {
                        "template": "*"
                    },
                    "ImageVersion": {
                        "template": "*"
                    },
                    "ImageBuildVersion": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "imagebuilder:GetContainerRecipe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "containerRecipe": "${containerRecipeArn}"
                }
            },
            {
                "action": "imagebuilder:GetDistributionConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "distributionConfiguration": "${distributionConfigurationArn}"
                }
            },
            {
                "action": "imagebuilder:GetImageRecipe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imageRecipe": "${imageRecipeArn}"
                }
            },
            {
                "action": "imagebuilder:GetInfrastructureConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "infrastructureConfiguration": "${infrastructureConfigurationArn}"
                }
            },
            {
                "action": "imagebuilder:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "*",
                    "containerRecipe": "*",
                    "distributionConfiguration": "*",
                    "image": "*",
                    "imagePipeline": "*",
                    "imageRecipe": "*",
                    "infrastructureConfiguration": "*"
                }
            }
        ],
        "Imagebuilder.CreateImagePipeline": [
            {
                "action": "imagebuilder:CreateImagePipeline",
                "resource_mappings": {
                    "ImagePipelineName": {
                        "template": "${name}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "imagebuilder:GetContainerRecipe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "containerRecipe": "${containerRecipeArn}"
                }
            },
            {
                "action": "imagebuilder:GetImageRecipe",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imageRecipe": "${imageRecipeArn}"
                }
            },
            {
                "action": "imagebuilder:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "*",
                    "containerRecipe": "*",
                    "distributionConfiguration": "*",
                    "image": "*",
                    "imagePipeline": "*",
                    "imageRecipe": "*",
                    "infrastructureConfiguration": "*"
                }
            }
        ],
        "Imagebuilder.CreateImageRecipe": [
            {
                "action": "imagebuilder:CreateImageRecipe",
                "resource_mappings": {
                    "ImageRecipeName": {
                        "template": "${name}"
                    },
                    "ImageRecipeVersion": {
                        "template": "${semanticVersion}"
                    }
                }
            },
            {
                "action": "ec2:DescribeImages",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "imagebuilder:GetComponent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "${components[].componentArn}"
                }
            },
            {
                "action": "imagebuilder:GetImage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "image": "%%iftemplatematch%${parentImage}%%"
                }
            },
            {
                "action": "imagebuilder:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "*",
                    "containerRecipe": "*",
                    "distributionConfiguration": "*",
                    "image": "*",
                    "imagePipeline": "*",
                    "imageRecipe": "*",
                    "infrastructureConfiguration": "*"
                }
            }
        ],
        "Imagebuilder.CreateInfrastructureConfiguration": [
            {
                "action": "imagebuilder:CreateInfrastructureConfiguration",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "imagebuilder:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "*",
                    "containerRecipe": "*",
                    "distributionConfiguration": "*",
                    "image": "*",
                    "imagePipeline": "*",
                    "imageRecipe": "*",
                    "infrastructureConfiguration": "*"
                }
            },
            {
                "action": "sns:Publish",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${snsTopicArn}"
                }
            }
        ],
        "Imagebuilder.GetComponent": [
            {
                "action": "imagebuilder:GetComponent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "${componentBuildVersionArn}"
                }
            },
            {
                "action": "kms:Decrypt",
                "resource_mappings": {
                    "KeyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Imagebuilder.StartImagePipelineExecution": [
            {
                "action": "imagebuilder:StartImagePipelineExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imagePipeline": "${imagePipelineArn}"
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "imagebuilder:GetImagePipeline",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "imagePipeline": "${imagePipelineArn}"
                }
            }
        ],
        "Imagebuilder.UpdateInfrastructureConfiguration": [
            {
                "action": "imagebuilder:UpdateInfrastructureConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "infrastructureConfiguration": "${infrastructureConfigurationArn}"
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "sns:Publish",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "topic": "${snsTopicArn}"
                }
            }
        ],
        "FraudDetector.CreateBatchPredictionJob": [
            {
                "action": "frauddetector:CreateBatchPredictionJob",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.DeleteBatchPredictionJob": [
            {
                "action": "frauddetector:DeleteBatchPredictionJob",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.GetBatchPredictionJobs": [
            {
                "action": "frauddetector:GetBatchPredictionJobs",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Detective.ListTagsForResource": [
            {
                "action": "detective:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Detective.TagResource": [
            {
                "action": "detective:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Detective.UntagResource": [
            {
                "action": "detective:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "IVS.CreateRecordingConfiguration": [
            {
                "action": "ivs:CreateRecordingConfiguration",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IVS.DeleteRecordingConfiguration": [
            {
                "action": "ivs:DeleteRecordingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Recording-Configuration": "${arn}"
                }
            }
        ],
        "IVS.GetRecordingConfiguration": [
            {
                "action": "ivs:GetRecordingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Recording-Configuration": "${arn}"
                }
            }
        ],
        "IVS.ListRecordingConfigurations": [
            {
                "action": "ivs:ListRecordingConfigurations",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataBrew.DescribeJobRun": [
            {
                "action": "databrew:DescribeJobRun",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataBrew.ListDatasets": [
            {
                "action": "databrew:ListDatasets",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.CreateWirelessDevice": [
            {
                "action": "iotwireless:CreateWirelessDevice",
                "resource_mappings": {
                    "DestinationName": {
                        "template": "${DestinationName}"
                    },
                    "WirelessDeviceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.CreateWirelessGatewayTaskDefinition": [
            {
                "action": "iotwireless:CreateWirelessGatewayTaskDefinition",
                "resource_mappings": {
                    "WirelessGatewayTaskDefinitionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.DeleteWirelessGatewayTaskDefinition": [
            {
                "action": "iotwireless:DeleteWirelessGatewayTaskDefinition",
                "resource_mappings": {
                    "WirelessGatewayTaskDefinitionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.DisassociateAwsAccountFromPartnerAccount": [
            {
                "action": "iotwireless:DisassociateAwsAccountFromPartnerAccount",
                "resource_mappings": {
                    "SidewalkId": {
                        "template": "${PartnerAccountId}"
                    }
                }
            }
        ],
        "IoTWireless.GetPartnerAccount": [
            {
                "action": "iotwireless:GetPartnerAccount",
                "resource_mappings": {
                    "SidewalkId": {
                        "template": "${PartnerAccountId}"
                    }
                }
            }
        ],
        "IoTWireless.GetWirelessGatewayTaskDefinition": [
            {
                "action": "iotwireless:GetWirelessGatewayTaskDefinition",
                "resource_mappings": {
                    "WirelessGatewayTaskDefinitionId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.UpdatePartnerAccount": [
            {
                "action": "iotwireless:UpdatePartnerAccount",
                "resource_mappings": {
                    "SidewalkId": {
                        "template": "${PartnerAccountId}"
                    }
                }
            }
        ],
        "Fis.CreateExperimentTemplate": [
            {
                "action": "fis:CreateExperimentTemplate",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Fis.UpdateExperimentTemplate": [
            {
                "action": "fis:UpdateExperimentTemplate",
                "resource_mappings": {
                    "Id": {
                        "template": "${actions[].actionId}"
                    }
                }
            }
        ],
        "LookoutMetrics.ActivateAnomalyDetector": [
            {
                "action": "lookoutmetrics:ActivateAnomalyDetector",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.BackTestAnomalyDetector": [
            {
                "action": "lookoutmetrics:BackTestAnomalyDetector",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.CreateAlert": [
            {
                "action": "lookoutmetrics:CreateAlert",
                "resource_mappings": {
                    "AlertName": {
                        "template": "${AlertName}"
                    }
                },
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.CreateAnomalyDetector": [
            {
                "action": "lookoutmetrics:CreateAnomalyDetector",
                "resource_mappings": {
                    "AnomalyDetectorName": {
                        "template": "${AnomalyDetectorName}"
                    }
                }
            }
        ],
        "LookoutMetrics.CreateMetricSet": [
            {
                "action": "lookoutmetrics:CreateMetricSet",
                "resource_mappings": {
                    "AnomalyDetectorName": {
                        "template": "%%regex%${AnomalyDetectorArn}%/AnomalyDetector:(.+)/g%%"
                    },
                    "MetricSetName": {
                        "template": "${MetricSetName}"
                    }
                },
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.DeleteAlert": [
            {
                "action": "lookoutmetrics:DeleteAlert",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Alert": "${AlertArn}"
                }
            }
        ],
        "LookoutMetrics.DeleteAnomalyDetector": [
            {
                "action": "lookoutmetrics:DeleteAnomalyDetector",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.DescribeAlert": [
            {
                "action": "lookoutmetrics:DescribeAlert",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Alert": "${AlertArn}"
                }
            }
        ],
        "LookoutMetrics.DescribeAnomalyDetectionExecutions": [
            {
                "action": "lookoutmetrics:DescribeAnomalyDetectionExecutions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.DescribeAnomalyDetector": [
            {
                "action": "lookoutmetrics:DescribeAnomalyDetector",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.DescribeMetricSet": [
            {
                "action": "lookoutmetrics:DescribeMetricSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "MetricSet": "${MetricSetArn}"
                }
            }
        ],
        "LookoutMetrics.GetAnomalyGroup": [
            {
                "action": "lookoutmetrics:GetAnomalyGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.GetFeedback": [
            {
                "action": "lookoutmetrics:GetFeedback",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.GetSampleData": [
            {
                "action": "lookoutmetrics:GetSampleData",
                "resource_mappings": {}
            }
        ],
        "LookoutMetrics.ListAlerts": [
            {
                "action": "lookoutmetrics:ListAlerts",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.ListAnomalyDetectors": [
            {
                "action": "lookoutmetrics:ListAnomalyDetectors",
                "resource_mappings": {}
            }
        ],
        "LookoutMetrics.ListAnomalyGroupSummaries": [
            {
                "action": "lookoutmetrics:ListAnomalyGroupSummaries",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.ListAnomalyGroupTimeSeries": [
            {
                "action": "lookoutmetrics:ListAnomalyGroupTimeSeries",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.ListMetricSets": [
            {
                "action": "lookoutmetrics:ListMetricSets",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.ListTagsForResource": [
            {
                "action": "lookoutmetrics:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Alert": "%%iftemplatematch%${ResourceArn}%%",
                    "AnomalyDetector": "%%iftemplatematch%${ResourceArn}%%",
                    "MetricSet": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LookoutMetrics.PutFeedback": [
            {
                "action": "lookoutmetrics:PutFeedback",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.TagResource": [
            {
                "action": "lookoutmetrics:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Alert": "%%iftemplatematch%${ResourceArn}%%",
                    "AnomalyDetector": "%%iftemplatematch%${ResourceArn}%%",
                    "MetricSet": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LookoutMetrics.UntagResource": [
            {
                "action": "lookoutmetrics:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Alert": "%%iftemplatematch%${ResourceArn}%%",
                    "AnomalyDetector": "%%iftemplatematch%${ResourceArn}%%",
                    "MetricSet": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LookoutMetrics.UpdateAnomalyDetector": [
            {
                "action": "lookoutmetrics:UpdateAnomalyDetector",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.UpdateMetricSet": [
            {
                "action": "lookoutmetrics:UpdateMetricSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "MetricSet": "${MetricSetArn}"
                }
            }
        ],
        "Mgn.ChangeServerLifeCycleState": [
            {
                "action": "mgn:ChangeServerLifeCycleState",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.CreateReplicationConfigurationTemplate": [
            {
                "action": "mgn:CreateReplicationConfigurationTemplate",
                "resource_mappings": {}
            }
        ],
        "Mgn.DeleteJob": [
            {
                "action": "mgn:DeleteJob",
                "resource_mappings": {
                    "jobID": {
                        "template": "${jobID}"
                    }
                }
            }
        ],
        "Mgn.DeleteReplicationConfigurationTemplate": [
            {
                "action": "mgn:DeleteReplicationConfigurationTemplate",
                "resource_mappings": {
                    "replicationConfigurationTemplateID": {
                        "template": "${replicationConfigurationTemplateID}"
                    }
                }
            }
        ],
        "Mgn.DeleteSourceServer": [
            {
                "action": "mgn:DeleteSourceServer",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.DescribeJobLogItems": [
            {
                "action": "mgn:DescribeJobLogItems",
                "resource_mappings": {
                    "jobID": {
                        "template": "${jobID}"
                    }
                }
            }
        ],
        "Mgn.DescribeJobs": [
            {
                "action": "mgn:DescribeJobs",
                "resource_mappings": {}
            }
        ],
        "Mgn.DescribeReplicationConfigurationTemplates": [
            {
                "action": "mgn:DescribeReplicationConfigurationTemplates",
                "resource_mappings": {}
            }
        ],
        "Mgn.DescribeSourceServers": [
            {
                "action": "mgn:DescribeSourceServers",
                "resource_mappings": {}
            }
        ],
        "Mgn.DisconnectFromService": [
            {
                "action": "mgn:DisconnectFromService",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.FinalizeCutover": [
            {
                "action": "mgn:FinalizeCutover",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.GetLaunchConfiguration": [
            {
                "action": "mgn:GetLaunchConfiguration",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.GetReplicationConfiguration": [
            {
                "action": "mgn:GetReplicationConfiguration",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.InitializeService": [
            {
                "action": "mgn:InitializeService",
                "resource_mappings": {}
            },
            {
                "action": "iam:AddRoleToInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:GetInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Mgn.ListTagsForResource": [
            {
                "action": "mgn:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Mgn.MarkAsArchived": [
            {
                "action": "mgn:MarkAsArchived",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.RetryDataReplication": [
            {
                "action": "mgn:RetryDataReplication",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.StartCutover": [
            {
                "action": "mgn:StartCutover",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerIDs[]}"
                    }
                }
            },
            {
                "action": "ec2:AttachVolume",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:AuthorizeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:AuthorizeSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateLaunchTemplate",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateLaunchTemplateVersion",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateSecurityGroup",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteLaunchTemplateVersions",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeAccountAttributes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeAvailabilityZones",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeImages",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstanceAttribute",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstanceStatus",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstanceTypes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeLaunchTemplateVersions",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeLaunchTemplates",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSnapshots",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVolumes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DetachVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifyInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifyLaunchTemplate",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ReportInstanceStatus",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:RevokeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:RunInstances",
                "resource_mappings": {
                    "ImageId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "ElasticInferenceAcceleratorId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:StartInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:StopInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:TerminateInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "mgn:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Mgn.StartTest": [
            {
                "action": "mgn:StartTest",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerIDs[]}"
                    }
                }
            },
            {
                "action": "ec2:AttachVolume",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:AuthorizeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:AuthorizeSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateLaunchTemplate",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateLaunchTemplateVersion",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateSecurityGroup",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteLaunchTemplateVersions",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeAccountAttributes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeAvailabilityZones",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeImages",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstanceAttribute",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstanceStatus",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstanceTypes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeLaunchTemplateVersions",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeLaunchTemplates",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSnapshots",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVolumes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DetachVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifyInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifyLaunchTemplate",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ReportInstanceStatus",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:RevokeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:RunInstances",
                "resource_mappings": {
                    "ImageId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "ElasticInferenceAcceleratorId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:StartInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:StopInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:TerminateInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "mgn:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Mgn.TagResource": [
            {
                "action": "mgn:TagResource",
                "resource_mappings": {}
            }
        ],
        "Mgn.TerminateTargetInstances": [
            {
                "action": "mgn:TerminateTargetInstances",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerIDs[]}"
                    }
                }
            },
            {
                "action": "ec2:DeleteVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVolumes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:TerminateInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Mgn.UntagResource": [
            {
                "action": "mgn:UntagResource",
                "resource_mappings": {}
            }
        ],
        "Mgn.UpdateLaunchConfiguration": [
            {
                "action": "mgn:UpdateLaunchConfiguration",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.UpdateReplicationConfiguration": [
            {
                "action": "mgn:UpdateReplicationConfiguration",
                "resource_mappings": {
                    "sourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.UpdateReplicationConfigurationTemplate": [
            {
                "action": "mgn:UpdateReplicationConfigurationTemplate",
                "resource_mappings": {
                    "replicationConfigurationTemplateID": {
                        "template": "${replicationConfigurationTemplateID}"
                    }
                }
            }
        ],
        "LookoutEquipment.CreateInferenceScheduler": [
            {
                "action": "lookoutequipment:CreateInferenceScheduler",
                "resource_mappings": {
                    "InferenceSchedulerName": {
                        "template": "${InferenceSchedulerName}"
                    },
                    "InferenceSchedulerId": {
                        "template": "*"
                    },
                    "ModelName": {
                        "template": "${ModelName}"
                    },
                    "ModelId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.CreateModel": [
            {
                "action": "lookoutequipment:CreateModel",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    },
                    "DatasetId": {
                        "template": "*"
                    },
                    "ModelName": {
                        "template": "${ModelName}"
                    },
                    "ModelId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.DeleteDataset": [
            {
                "action": "lookoutequipment:DeleteDataset",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    },
                    "DatasetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.DeleteInferenceScheduler": [
            {
                "action": "lookoutequipment:DeleteInferenceScheduler",
                "resource_mappings": {
                    "InferenceSchedulerName": {
                        "template": "${InferenceSchedulerName}"
                    },
                    "InferenceSchedulerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.DeleteModel": [
            {
                "action": "lookoutequipment:DeleteModel",
                "resource_mappings": {
                    "ModelName": {
                        "template": "${ModelName}"
                    },
                    "ModelId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.DescribeDataIngestionJob": [
            {
                "action": "lookoutequipment:DescribeDataIngestionJob",
                "resource_mappings": {}
            }
        ],
        "LookoutEquipment.DescribeDataset": [
            {
                "action": "lookoutequipment:DescribeDataset",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    },
                    "DatasetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.DescribeInferenceScheduler": [
            {
                "action": "lookoutequipment:DescribeInferenceScheduler",
                "resource_mappings": {
                    "InferenceSchedulerName": {
                        "template": "${InferenceSchedulerName}"
                    },
                    "InferenceSchedulerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.DescribeModel": [
            {
                "action": "lookoutequipment:DescribeModel",
                "resource_mappings": {
                    "ModelName": {
                        "template": "${ModelName}"
                    },
                    "ModelId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.ListDataIngestionJobs": [
            {
                "action": "lookoutequipment:ListDataIngestionJobs",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    },
                    "DatasetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.ListDatasets": [
            {
                "action": "lookoutequipment:ListDatasets",
                "resource_mappings": {}
            }
        ],
        "LookoutEquipment.ListInferenceExecutions": [
            {
                "action": "lookoutequipment:ListInferenceExecutions",
                "resource_mappings": {
                    "InferenceSchedulerName": {
                        "template": "${InferenceSchedulerName}"
                    },
                    "InferenceSchedulerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.ListInferenceSchedulers": [
            {
                "action": "lookoutequipment:ListInferenceSchedulers",
                "resource_mappings": {}
            }
        ],
        "LookoutEquipment.ListModels": [
            {
                "action": "lookoutequipment:ListModels",
                "resource_mappings": {}
            }
        ],
        "LookoutEquipment.ListTagsForResource": [
            {
                "action": "lookoutequipment:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "inference-scheduler": "%%iftemplatematch%${ResourceArn}%%",
                    "model": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LookoutEquipment.StartDataIngestionJob": [
            {
                "action": "lookoutequipment:StartDataIngestionJob",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    },
                    "DatasetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.StartInferenceScheduler": [
            {
                "action": "lookoutequipment:StartInferenceScheduler",
                "resource_mappings": {
                    "InferenceSchedulerName": {
                        "template": "${InferenceSchedulerName}"
                    },
                    "InferenceSchedulerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.StopInferenceScheduler": [
            {
                "action": "lookoutequipment:StopInferenceScheduler",
                "resource_mappings": {
                    "InferenceSchedulerName": {
                        "template": "${InferenceSchedulerName}"
                    },
                    "InferenceSchedulerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LookoutEquipment.TagResource": [
            {
                "action": "lookoutequipment:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "inference-scheduler": "%%iftemplatematch%${ResourceArn}%%",
                    "model": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LookoutEquipment.UntagResource": [
            {
                "action": "lookoutequipment:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "inference-scheduler": "%%iftemplatematch%${ResourceArn}%%",
                    "model": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LookoutEquipment.UpdateInferenceScheduler": [
            {
                "action": "lookoutequipment:UpdateInferenceScheduler",
                "resource_mappings": {
                    "InferenceSchedulerName": {
                        "template": "${InferenceSchedulerName}"
                    },
                    "InferenceSchedulerId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Resolver.UpdateFirewallConfig": [
            {
                "action": "route53resolver:UpdateFirewallConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.CancelBatchPredictionJob": [
            {
                "action": "frauddetector:CancelBatchPredictionJob",
                "resource_mappings": {
                    "resourcePath": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "IoTWireless.AssociateAwsAccountWithPartnerAccount": [
            {
                "action": "iotwireless:AssociateAwsAccountWithPartnerAccount",
                "resource_mappings": {
                    "SidewalkId": {
                        "template": "${Sidewalk.AmazonId}"
                    }
                }
            }
        ],
        "LookoutEquipment.CreateDataset": [
            {
                "action": "lookoutequipment:CreateDataset",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatasetName": {
                        "template": "${DatasetName}"
                    },
                    "DatasetId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudWatch.DeleteMetricStream": [
            {
                "action": "cloudwatch:DeleteMetricStream",
                "resource_mappings": {
                    "MetricStreamName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatch.GetMetricStream": [
            {
                "action": "cloudwatch:GetMetricStream",
                "resource_mappings": {
                    "MetricStreamName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatch.ListMetricStreams": [
            {
                "action": "cloudwatch:ListMetricStreams",
                "resource_mappings": {}
            }
        ],
        "CloudWatch.PutMetricStream": [
            {
                "action": "cloudwatch:PutMetricStream",
                "resource_mappings": {
                    "MetricStreamName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatch.StartMetricStreams": [
            {
                "action": "cloudwatch:StartMetricStreams",
                "resource_mappings": {
                    "MetricStreamName": {
                        "template": "${Names[]}"
                    }
                }
            }
        ],
        "CloudWatch.StopMetricStreams": [
            {
                "action": "cloudwatch:StopMetricStreams",
                "resource_mappings": {
                    "MetricStreamName": {
                        "template": "${Names[]}"
                    }
                }
            }
        ],
        "SES.CreateCustomVerificationEmailTemplate": [
            {
                "action": "ses:CreateCustomVerificationEmailTemplate",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ses:CreateCustomVerificationEmailTemplate",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.DeleteIdentity": [
            {
                "action": "ses:DeleteIdentity",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.DeleteIdentityPolicy": [
            {
                "action": "ses:DeleteIdentityPolicy",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.DeleteVerifiedEmailAddress": [
            {
                "action": "ses:DeleteVerifiedEmailAddress",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.GetIdentityDkimAttributes": [
            {
                "action": "ses:GetIdentityDkimAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.GetIdentityMailFromDomainAttributes": [
            {
                "action": "ses:GetIdentityMailFromDomainAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.GetIdentityNotificationAttributes": [
            {
                "action": "ses:GetIdentityNotificationAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.GetIdentityVerificationAttributes": [
            {
                "action": "ses:GetIdentityVerificationAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SendBounce": [
            {
                "action": "ses:SendBounce",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SendTemplatedEmail": [
            {
                "action": "ses:SendTemplatedEmail",
                "resource_mappings": {}
            }
        ],
        "SES.SetIdentityDkimEnabled": [
            {
                "action": "ses:SetIdentityDkimEnabled",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SetIdentityFeedbackForwardingEnabled": [
            {
                "action": "ses:SetIdentityFeedbackForwardingEnabled",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SetIdentityHeadersInNotificationsEnabled": [
            {
                "action": "ses:SetIdentityHeadersInNotificationsEnabled",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SetIdentityMailFromDomain": [
            {
                "action": "ses:SetIdentityMailFromDomain",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.SetIdentityNotificationTopic": [
            {
                "action": "ses:SetIdentityNotificationTopic",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SES.VerifyDomainDkim": [
            {
                "action": "ses:VerifyDomainDkim",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "AutoScaling.DeleteWarmPool": [
            {
                "action": "autoscaling:DeleteWarmPool",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "AutoScaling.DescribeWarmPool": [
            {
                "action": "autoscaling:DescribeWarmPool",
                "resource_mappings": {}
            }
        ],
        "AutoScaling.PutWarmPool": [
            {
                "action": "autoscaling:PutWarmPool",
                "resource_mappings": {
                    "GroupId": {
                        "template": "*"
                    },
                    "GroupFriendlyName": {
                        "template": "${AutoScalingGroupName}"
                    }
                }
            }
        ],
        "CloudDirectory.ListManagedSchemaArns": [
            {
                "action": "clouddirectory:ListManagedSchemaArns",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.RecordHandlerProgress": [
            {
                "action": "cloudformation:RecordHandlerProgress",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFront.CreateKeyGroup": [
            {
                "action": "cloudfront:CreateKeyGroup",
                "resource_mappings": {}
            }
        ],
        "CloudFront.CreateMonitoringSubscription": [
            {
                "action": "cloudfront:CreateMonitoringSubscription",
                "resource_mappings": {}
            }
        ],
        "CloudFront.CreateRealtimeLogConfig": [
            {
                "action": "cloudfront:CreateRealtimeLogConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeleteKeyGroup": [
            {
                "action": "cloudfront:DeleteKeyGroup",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeleteMonitoringSubscription": [
            {
                "action": "cloudfront:DeleteMonitoringSubscription",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeleteRealtimeLogConfig": [
            {
                "action": "cloudfront:DeleteRealtimeLogConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetKeyGroup": [
            {
                "action": "cloudfront:GetKeyGroup",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetKeyGroupConfig": [
            {
                "action": "cloudfront:GetKeyGroupConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetMonitoringSubscription": [
            {
                "action": "cloudfront:GetMonitoringSubscription",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetRealtimeLogConfig": [
            {
                "action": "cloudfront:GetRealtimeLogConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListDistributionsByKeyGroup": [
            {
                "action": "cloudfront:ListDistributionsByKeyGroup",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListDistributionsByRealtimeLogConfig": [
            {
                "action": "cloudfront:ListDistributionsByRealtimeLogConfig",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListKeyGroups": [
            {
                "action": "cloudfront:ListKeyGroups",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListRealtimeLogConfigs": [
            {
                "action": "cloudfront:ListRealtimeLogConfigs",
                "resource_mappings": {}
            }
        ],
        "CloudFront.UpdateKeyGroup": [
            {
                "action": "cloudfront:UpdateKeyGroup",
                "resource_mappings": {}
            }
        ],
        "CloudFront.UpdateRealtimeLogConfig": [
            {
                "action": "cloudfront:UpdateRealtimeLogConfig",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.GetReportGroupTrend": [
            {
                "action": "codebuild:GetReportGroupTrend",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "report-group": "${reportGroupArn}"
                }
            }
        ],
        "DMS.DeleteConnection": [
            {
                "action": "dms:DeleteConnection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Endpoint": "${EndpointArn}",
                    "ReplicationInstance": "${ReplicationInstanceArn}"
                }
            }
        ],
        "DMS.MoveReplicationTask": [
            {
                "action": "dms:MoveReplicationTask",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "ReplicationInstance": "${TargetReplicationInstanceArn}",
                    "ReplicationTask": "${ReplicationTaskArn}"
                }
            }
        ],
        "ECS.ExecuteCommand": [
            {
                "action": "ecs:ExecuteCommand",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+?\\/)?(.+)$/g%%"
                    },
                    "TaskId": {
                        "template": "%%regex%${task}%/^(?:.+\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ECS.UpdateCapacityProvider": [
            {
                "action": "ecs:UpdateCapacityProvider",
                "resource_mappings": {
                    "CapacityProviderName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "ECS.UpdateCluster": [
            {
                "action": "ecs:UpdateCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "%%regex%${cluster}%/^(?:.+?\\/)?(.+)$/g%%"
                    }
                }
            }
        ],
        "ES.AssociatePackage": [
            {
                "action": "es:AssociatePackage",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.CancelElasticsearchServiceSoftwareUpdate": [
            {
                "action": "es:CancelElasticsearchServiceSoftwareUpdate",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.CreatePackage": [
            {
                "action": "es:CreatePackage",
                "resource_mappings": {}
            }
        ],
        "ES.DeletePackage": [
            {
                "action": "es:DeletePackage",
                "resource_mappings": {}
            }
        ],
        "ES.DescribePackages": [
            {
                "action": "es:DescribePackages",
                "resource_mappings": {}
            }
        ],
        "ES.DissociatePackage": [
            {
                "action": "es:DissociatePackage",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.GetPackageVersionHistory": [
            {
                "action": "es:GetPackageVersionHistory",
                "resource_mappings": {}
            }
        ],
        "ES.ListDomainsForPackage": [
            {
                "action": "es:ListDomainsForPackage",
                "resource_mappings": {}
            }
        ],
        "ES.ListPackagesForDomain": [
            {
                "action": "es:ListPackagesForDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.StartElasticsearchServiceSoftwareUpdate": [
            {
                "action": "es:StartElasticsearchServiceSoftwareUpdate",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "ES.UpdatePackage": [
            {
                "action": "es:UpdatePackage",
                "resource_mappings": {}
            }
        ],
        "Inspector.CreateExclusionsPreview": [
            {
                "action": "inspector:CreateExclusionsPreview",
                "resource_mappings": {}
            }
        ],
        "Inspector.DescribeExclusions": [
            {
                "action": "inspector:DescribeExclusions",
                "resource_mappings": {}
            }
        ],
        "Inspector.GetAssessmentReport": [
            {
                "action": "inspector:GetAssessmentReport",
                "resource_mappings": {}
            }
        ],
        "Inspector.GetExclusionsPreview": [
            {
                "action": "inspector:GetExclusionsPreview",
                "resource_mappings": {}
            }
        ],
        "Inspector.ListExclusions": [
            {
                "action": "inspector:ListExclusions",
                "resource_mappings": {}
            }
        ],
        "Iot.CancelDetectMitigationActionsTask": [
            {
                "action": "iot:CancelDetectMitigationActionsTask",
                "resource_mappings": {}
            }
        ],
        "Iot.CreateCustomMetric": [
            {
                "action": "iot:CreateCustomMetric",
                "resource_mappings": {
                    "MetricName": {
                        "template": "${metricName}"
                    }
                }
            }
        ],
        "Iot.CreateTopicRuleDestination": [
            {
                "action": "iot:CreateTopicRuleDestination",
                "resource_mappings": {
                    "destinationType": {
                        "template": "*"
                    },
                    "uuid": {
                        "template": "*"
                    }
                }
            }
        ],
        "Iot.DeleteCustomMetric": [
            {
                "action": "iot:DeleteCustomMetric",
                "resource_mappings": {
                    "MetricName": {
                        "template": "${metricName}"
                    }
                }
            }
        ],
        "Iot.DeleteTopicRuleDestination": [
            {
                "action": "iot:DeleteTopicRuleDestination",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "destination": "${arn}"
                }
            }
        ],
        "Iot.DescribeCustomMetric": [
            {
                "action": "iot:DescribeCustomMetric",
                "resource_mappings": {
                    "MetricName": {
                        "template": "${metricName}"
                    }
                }
            }
        ],
        "Iot.DescribeDetectMitigationActionsTask": [
            {
                "action": "iot:DescribeDetectMitigationActionsTask",
                "resource_mappings": {}
            }
        ],
        "Iot.GetBehaviorModelTrainingSummaries": [
            {
                "action": "iot:GetBehaviorModelTrainingSummaries",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${securityProfileName}"
                    }
                }
            }
        ],
        "Iot.GetTopicRuleDestination": [
            {
                "action": "iot:GetTopicRuleDestination",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "destination": "${arn}"
                }
            }
        ],
        "Iot.ListCustomMetrics": [
            {
                "action": "iot:ListCustomMetrics",
                "resource_mappings": {}
            }
        ],
        "Iot.ListDetectMitigationActionsExecutions": [
            {
                "action": "iot:ListDetectMitigationActionsExecutions",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Iot.ListDetectMitigationActionsTasks": [
            {
                "action": "iot:ListDetectMitigationActionsTasks",
                "resource_mappings": {}
            }
        ],
        "Iot.ListTopicRuleDestinations": [
            {
                "action": "iot:ListTopicRuleDestinations",
                "resource_mappings": {}
            }
        ],
        "Iot.StartDetectMitigationActionsTask": [
            {
                "action": "iot:StartDetectMitigationActionsTask",
                "resource_mappings": {
                    "SecurityProfileName": {
                        "template": "${target.securityProfileName}"
                    }
                }
            }
        ],
        "Iot.UpdateCustomMetric": [
            {
                "action": "iot:UpdateCustomMetric",
                "resource_mappings": {
                    "MetricName": {
                        "template": "${metricName}"
                    }
                }
            }
        ],
        "Iot.UpdateTopicRuleDestination": [
            {
                "action": "iot:UpdateTopicRuleDestination",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "destination": "${arn}"
                }
            }
        ],
        "Lightsail.AttachCertificateToDistribution": [
            {
                "action": "lightsail:AttachCertificateToDistribution",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateCertificate": [
            {
                "action": "lightsail:CreateCertificate",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateContactMethod": [
            {
                "action": "lightsail:CreateContactMethod",
                "resource_mappings": {}
            }
        ],
        "Lightsail.CreateContainerService": [
            {
                "action": "lightsail:CreateContainerService",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateContainerServiceDeployment": [
            {
                "action": "lightsail:CreateContainerServiceDeployment",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateContainerServiceRegistryLogin": [
            {
                "action": "lightsail:CreateContainerServiceRegistryLogin",
                "resource_mappings": {}
            }
        ],
        "Lightsail.CreateDistribution": [
            {
                "action": "lightsail:CreateDistribution",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteAlarm": [
            {
                "action": "lightsail:DeleteAlarm",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteAutoSnapshot": [
            {
                "action": "lightsail:DeleteAutoSnapshot",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteCertificate": [
            {
                "action": "lightsail:DeleteCertificate",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteContactMethod": [
            {
                "action": "lightsail:DeleteContactMethod",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteContainerImage": [
            {
                "action": "lightsail:DeleteContainerImage",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteContainerService": [
            {
                "action": "lightsail:DeleteContainerService",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteDistribution": [
            {
                "action": "lightsail:DeleteDistribution",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DisableAddOn": [
            {
                "action": "lightsail:DisableAddOn",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.EnableAddOn": [
            {
                "action": "lightsail:EnableAddOn",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetAlarms": [
            {
                "action": "lightsail:GetAlarms",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetAutoSnapshots": [
            {
                "action": "lightsail:GetAutoSnapshots",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetCertificates": [
            {
                "action": "lightsail:GetCertificates",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetContactMethods": [
            {
                "action": "lightsail:GetContactMethods",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetContainerAPIMetadata": [
            {
                "action": "lightsail:GetContainerAPIMetadata",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetContainerImages": [
            {
                "action": "lightsail:GetContainerImages",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetContainerLog": [
            {
                "action": "lightsail:GetContainerLog",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetContainerServiceDeployments": [
            {
                "action": "lightsail:GetContainerServiceDeployments",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetContainerServiceMetricData": [
            {
                "action": "lightsail:GetContainerServiceMetricData",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetContainerServicePowers": [
            {
                "action": "lightsail:GetContainerServicePowers",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetContainerServices": [
            {
                "action": "lightsail:GetContainerServices",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetDistributionBundles": [
            {
                "action": "lightsail:GetDistributionBundles",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetDistributionLatestCacheReset": [
            {
                "action": "lightsail:GetDistributionLatestCacheReset",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetDistributionMetricData": [
            {
                "action": "lightsail:GetDistributionMetricData",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetDistributions": [
            {
                "action": "lightsail:GetDistributions",
                "resource_mappings": {}
            }
        ],
        "Lightsail.PutAlarm": [
            {
                "action": "lightsail:PutAlarm",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.RegisterContainerImage": [
            {
                "action": "lightsail:RegisterContainerImage",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.ResetDistributionCache": [
            {
                "action": "lightsail:ResetDistributionCache",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.SendContactMethodVerification": [
            {
                "action": "lightsail:SendContactMethodVerification",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.SetIpAddressType": [
            {
                "action": "lightsail:SetIpAddressType",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.TestAlarm": [
            {
                "action": "lightsail:TestAlarm",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.UpdateContainerService": [
            {
                "action": "lightsail:UpdateContainerService",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.UpdateDistribution": [
            {
                "action": "lightsail:UpdateDistribution",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.UpdateDistributionBundle": [
            {
                "action": "lightsail:UpdateDistributionBundle",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "OpsWorks.DescribeOperatingSystems": [
            {
                "action": "opsworks:DescribeOperatingSystems",
                "resource_mappings": {}
            }
        ],
        "RDS.CreateCustomAvailabilityZone": [
            {
                "action": "rds:CreateCustomAvailabilityZone",
                "resource_mappings": {}
            }
        ],
        "RDS.DeleteCustomAvailabilityZone": [
            {
                "action": "rds:DeleteCustomAvailabilityZone",
                "resource_mappings": {}
            }
        ],
        "RDS.DeleteInstallationMedia": [
            {
                "action": "rds:DeleteInstallationMedia",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeCustomAvailabilityZones": [
            {
                "action": "rds:DescribeCustomAvailabilityZones",
                "resource_mappings": {}
            }
        ],
        "RDS.DescribeInstallationMedia": [
            {
                "action": "rds:DescribeInstallationMedia",
                "resource_mappings": {}
            }
        ],
        "RDS.ImportInstallationMedia": [
            {
                "action": "rds:ImportInstallationMedia",
                "resource_mappings": {}
            }
        ],
        "RDS.ModifyCertificates": [
            {
                "action": "rds:ModifyCertificates",
                "resource_mappings": {}
            }
        ],
        "RDS.StartDBInstanceAutomatedBackupsReplication": [
            {
                "action": "rds:StartDBInstanceAutomatedBackupsReplication",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "${SourceDBInstanceArn}"
                }
            }
        ],
        "RDS.StopDBInstanceAutomatedBackupsReplication": [
            {
                "action": "rds:StopDBInstanceAutomatedBackupsReplication",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "db": "${SourceDBInstanceArn}"
                }
            }
        ],
        "Redshift.CreateUsageLimit": [
            {
                "action": "redshift:CreateUsageLimit",
                "resource_mappings": {
                    "UsageLimitId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Redshift.DeleteUsageLimit": [
            {
                "action": "redshift:DeleteUsageLimit",
                "resource_mappings": {
                    "UsageLimitId": {
                        "template": "${UsageLimitId}"
                    }
                }
            }
        ],
        "Redshift.DescribeUsageLimits": [
            {
                "action": "redshift:DescribeUsageLimits",
                "resource_mappings": {
                    "UsageLimitId": {
                        "template": "${UsageLimitId}"
                    }
                }
            }
        ],
        "Redshift.ModifyUsageLimit": [
            {
                "action": "redshift:ModifyUsageLimit",
                "resource_mappings": {
                    "UsageLimitId": {
                        "template": "${UsageLimitId}"
                    }
                }
            }
        ],
        "Route53Domains.AcceptDomainTransferFromAnotherAwsAccount": [
            {
                "action": "route53domains:AcceptDomainTransferFromAnotherAwsAccount",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.CancelDomainTransferToAnotherAwsAccount": [
            {
                "action": "route53domains:CancelDomainTransferToAnotherAwsAccount",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.CheckDomainTransferability": [
            {
                "action": "route53domains:CheckDomainTransferability",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.RejectDomainTransferFromAnotherAwsAccount": [
            {
                "action": "route53domains:RejectDomainTransferFromAnotherAwsAccount",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.TransferDomainToAnotherAwsAccount": [
            {
                "action": "route53domains:TransferDomainToAnotherAwsAccount",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.DescribePortfolioShares": [
            {
                "action": "servicecatalog:DescribePortfolioShares",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "ServiceCatalog.GetProvisionedProductOutputs": [
            {
                "action": "servicecatalog:GetProvisionedProductOutputs",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalog.UpdatePortfolioShare": [
            {
                "action": "servicecatalog:UpdatePortfolioShare",
                "resource_mappings": {
                    "PortfolioId": {
                        "template": "${PortfolioId}"
                    }
                }
            }
        ],
        "Shield.AssociateProactiveEngagementDetails": [
            {
                "action": "shield:AssociateProactiveEngagementDetails",
                "resource_mappings": {}
            }
        ],
        "Shield.CreateProtectionGroup": [
            {
                "action": "shield:CreateProtectionGroup",
                "resource_mappings": {}
            }
        ],
        "Shield.DeleteProtectionGroup": [
            {
                "action": "shield:DeleteProtectionGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${ProtectionGroupId}"
                    }
                }
            }
        ],
        "Shield.DescribeAttackStatistics": [
            {
                "action": "shield:DescribeAttackStatistics",
                "resource_mappings": {}
            }
        ],
        "Shield.DescribeProtectionGroup": [
            {
                "action": "shield:DescribeProtectionGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${ProtectionGroupId}"
                    }
                }
            }
        ],
        "Shield.DisableProactiveEngagement": [
            {
                "action": "shield:DisableProactiveEngagement",
                "resource_mappings": {}
            }
        ],
        "Shield.EnableProactiveEngagement": [
            {
                "action": "shield:EnableProactiveEngagement",
                "resource_mappings": {}
            }
        ],
        "Shield.ListProtectionGroups": [
            {
                "action": "shield:ListProtectionGroups",
                "resource_mappings": {}
            }
        ],
        "Shield.ListResourcesInProtectionGroup": [
            {
                "action": "shield:ListResourcesInProtectionGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${ProtectionGroupId}"
                    }
                }
            }
        ],
        "Shield.UpdateProtectionGroup": [
            {
                "action": "shield:UpdateProtectionGroup",
                "resource_mappings": {
                    "Id": {
                        "template": "${ProtectionGroupId}"
                    }
                }
            }
        ],
        "Snowball.CreateReturnShippingLabel": [
            {
                "action": "snowball:CreateReturnShippingLabel",
                "resource_mappings": {}
            }
        ],
        "Snowball.DescribeReturnShippingLabel": [
            {
                "action": "snowball:DescribeReturnShippingLabel",
                "resource_mappings": {}
            }
        ],
        "Snowball.GetSoftwareUpdates": [
            {
                "action": "snowball:GetSoftwareUpdates",
                "resource_mappings": {}
            }
        ],
        "Snowball.ListCompatibleImages": [
            {
                "action": "snowball:ListCompatibleImages",
                "resource_mappings": {}
            }
        ],
        "Snowball.UpdateJobShipmentState": [
            {
                "action": "snowball:UpdateJobShipmentState",
                "resource_mappings": {}
            }
        ],
        "SSM.AssociateOpsItemRelatedItem": [
            {
                "action": "ssm:AssociateOpsItemRelatedItem",
                "resource_mappings": {}
            }
        ],
        "SSM.DisassociateOpsItemRelatedItem": [
            {
                "action": "ssm:DisassociateOpsItemRelatedItem",
                "resource_mappings": {}
            }
        ],
        "SSM.ListOpsItemRelatedItems": [
            {
                "action": "ssm:ListOpsItemRelatedItems",
                "resource_mappings": {}
            }
        ],
        "SSM.StartAutomationExecution": [
            {
                "action": "ssm:StartAutomationExecution",
                "resource_mappings": {
                    "AutomationDefinitionName": {
                        "template": "*"
                    },
                    "VersionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSM.StartChangeRequestExecution": [
            {
                "action": "ssm:StartChangeRequestExecution",
                "resource_mappings": {
                    "AutomationDefinitionName": {
                        "template": "*"
                    },
                    "VersionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "SWF.UndeprecateActivityType": [
            {
                "action": "swf:UndeprecateActivityType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "SWF.UndeprecateDomain": [
            {
                "action": "swf:UndeprecateDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "SWF.UndeprecateWorkflowType": [
            {
                "action": "swf:UndeprecateWorkflowType",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domain}"
                    }
                }
            }
        ],
        "WorkSpaces.AssociateConnectionAlias": [
            {
                "action": "workspaces:AssociateConnectionAlias",
                "resource_mappings": {
                    "ConnectionAliasId": {
                        "template": "${AliasId}"
                    },
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "WorkSpaces.AssociateIpGroups": [
            {
                "action": "workspaces:AssociateIpGroups",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    },
                    "GroupId": {
                        "template": "${GroupIds}[]"
                    }
                }
            }
        ],
        "WorkSpaces.CopyWorkspaceImage": [
            {
                "action": "workspaces:CopyWorkspaceImage",
                "resource_mappings": {
                    "ImageId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "workspaces:DescribeWorkspaceImages",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.CreateConnectionAlias": [
            {
                "action": "workspaces:CreateConnectionAlias",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.CreateIpGroup": [
            {
                "action": "workspaces:CreateIpGroup",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.CreateWorkspaceBundle": [
            {
                "action": "workspaces:CreateWorkspaceBundle",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            },
            {
                "action": "workspaces:CreateTags",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.CreateWorkspaces": [
            {
                "action": "workspaces:CreateWorkspaces",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${Workspaces[].DirectoryId}"
                    },
                    "BundleId": {
                        "template": "${Workspaces[].BundleId}"
                    }
                }
            }
        ],
        "WorkSpaces.DeleteConnectionAlias": [
            {
                "action": "workspaces:DeleteConnectionAlias",
                "resource_mappings": {
                    "ConnectionAliasId": {
                        "template": "${AliasId}"
                    }
                }
            }
        ],
        "WorkSpaces.DeleteWorkspaceBundle": [
            {
                "action": "workspaces:DeleteWorkspaceBundle",
                "resource_mappings": {
                    "BundleId": {
                        "template": "${BundleId}"
                    }
                }
            }
        ],
        "WorkSpaces.DeleteWorkspaceImage": [
            {
                "action": "workspaces:DeleteWorkspaceImage",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "WorkSpaces.DeregisterWorkspaceDirectory": [
            {
                "action": "workspaces:DeregisterWorkspaceDirectory",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "WorkSpaces.DescribeConnectionAliasPermissions": [
            {
                "action": "workspaces:DescribeConnectionAliasPermissions",
                "resource_mappings": {
                    "ConnectionAliasId": {
                        "template": "${AliasId}"
                    }
                }
            }
        ],
        "WorkSpaces.DescribeConnectionAliases": [
            {
                "action": "workspaces:DescribeConnectionAliases",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DescribeWorkspaceBundles": [
            {
                "action": "workspaces:DescribeWorkspaceBundles",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.DescribeWorkspaceImagePermissions": [
            {
                "action": "workspaces:DescribeWorkspaceImagePermissions",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "WorkSpaces.DescribeWorkspaceSnapshots": [
            {
                "action": "workspaces:DescribeWorkspaceSnapshots",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${WorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.DisassociateConnectionAlias": [
            {
                "action": "workspaces:DisassociateConnectionAlias",
                "resource_mappings": {
                    "ConnectionAliasId": {
                        "template": "${AliasId}"
                    }
                }
            }
        ],
        "WorkSpaces.DisassociateIpGroups": [
            {
                "action": "workspaces:DisassociateIpGroups",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    },
                    "GroupId": {
                        "template": "${GroupIds}[]"
                    }
                }
            }
        ],
        "WorkSpaces.ImportWorkspaceImage": [
            {
                "action": "workspaces:ImportWorkspaceImage",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeImages",
                "resource_mappings": {}
            },
            {
                "action": "ec2:ModifyImageAttribute",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${Ec2ImageId}"
                    }
                }
            }
        ],
        "WorkSpaces.MigrateWorkspace": [
            {
                "action": "workspaces:MigrateWorkspace",
                "resource_mappings": {
                    "BundleId": {
                        "template": "${BundleId}"
                    },
                    "WorkspaceId": {
                        "template": "${SourceWorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.ModifySelfservicePermissions": [
            {
                "action": "workspaces:ModifySelfservicePermissions",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "WorkSpaces.ModifyWorkspaceAccessProperties": [
            {
                "action": "workspaces:ModifyWorkspaceAccessProperties",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "WorkSpaces.ModifyWorkspaceCreationProperties": [
            {
                "action": "workspaces:ModifyWorkspaceCreationProperties",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "WorkSpaces.RegisterWorkspaceDirectory": [
            {
                "action": "workspaces:RegisterWorkspaceDirectory",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "WorkSpaces.RestoreWorkspace": [
            {
                "action": "workspaces:RestoreWorkspace",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${WorkspaceId}"
                    }
                }
            }
        ],
        "WorkSpaces.UpdateConnectionAliasPermission": [
            {
                "action": "workspaces:UpdateConnectionAliasPermission",
                "resource_mappings": {
                    "ConnectionAliasId": {
                        "template": "${AliasId}"
                    }
                }
            }
        ],
        "WorkSpaces.UpdateWorkspaceBundle": [
            {
                "action": "workspaces:UpdateWorkspaceBundle",
                "resource_mappings": {
                    "BundleId": {
                        "template": "${BundleId}"
                    },
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "WorkSpaces.UpdateWorkspaceImagePermission": [
            {
                "action": "workspaces:UpdateWorkspaceImagePermission",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "Greengrass.UpdateThingRuntimeConfiguration": [
            {
                "action": "greengrass:UpdateThingRuntimeConfiguration",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${ThingName}"
                    }
                }
            }
        ],
        "Glue.ResumeWorkflowRun": [
            {
                "action": "glue:ResumeWorkflowRun",
                "resource_mappings": {}
            }
        ],
        "Glue.StopWorkflowRun": [
            {
                "action": "glue:StopWorkflowRun",
                "resource_mappings": {}
            }
        ],
        "MediaPackage.RotateChannelCredentials": [
            {
                "action": "mediapackage:RotateChannelCredentials",
                "resource_mappings": {
                    "ChannelIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "AppSync.CreateApiCache": [
            {
                "action": "appsync:CreateApiCache",
                "resource_mappings": {}
            }
        ],
        "AppSync.DeleteApiCache": [
            {
                "action": "appsync:DeleteApiCache",
                "resource_mappings": {}
            }
        ],
        "AppSync.FlushApiCache": [
            {
                "action": "appsync:FlushApiCache",
                "resource_mappings": {}
            }
        ],
        "AppSync.GetApiCache": [
            {
                "action": "appsync:GetApiCache",
                "resource_mappings": {}
            }
        ],
        "AppSync.UpdateApiCache": [
            {
                "action": "appsync:UpdateApiCache",
                "resource_mappings": {}
            }
        ],
        "GuardDuty.GetMemberDetectors": [
            {
                "action": "guardduty:GetMemberDetectors",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.GetUsageStatistics": [
            {
                "action": "guardduty:GetUsageStatistics",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "GuardDuty.UpdateMemberDetectors": [
            {
                "action": "guardduty:UpdateMemberDetectors",
                "resource_mappings": {
                    "DetectorId": {
                        "template": "${DetectorId}"
                    }
                }
            }
        ],
        "SageMaker.DeleteHumanTaskUi": [
            {
                "action": "sagemaker:DeleteHumanTaskUi",
                "resource_mappings": {
                    "HumanTaskUiName": {
                        "template": "${HumanTaskUiName}"
                    }
                }
            }
        ],
        "WorkMail.CreateMobileDeviceAccessRule": [
            {
                "action": "workmail:CreateMobileDeviceAccessRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteMobileDeviceAccessRule": [
            {
                "action": "workmail:DeleteMobileDeviceAccessRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.GetMobileDeviceAccessEffect": [
            {
                "action": "workmail:GetMobileDeviceAccessEffect",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListMobileDeviceAccessRules": [
            {
                "action": "workmail:ListMobileDeviceAccessRules",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.UpdateMobileDeviceAccessRule": [
            {
                "action": "workmail:UpdateMobileDeviceAccessRule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "Connect.CreateIntegrationAssociation": [
            {
                "action": "connect:CreateIntegrationAssociation",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "IntegrationAssociationId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "app-integrations:CreateEventIntegrationAssociation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "event-integration-association": "${IntegrationArn}"
                }
            },
            {
                "action": "connect:DescribeInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            },
            {
                "action": "events:PutRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "*"
                    },
                    "RuleName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "events:PutTargets",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "*"
                    },
                    "RuleName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.CreateUseCase": [
            {
                "action": "connect:CreateUseCase",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "IntegrationAssociationId": {
                        "template": "${IntegrationAssociationId}"
                    },
                    "UseCaseId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "connect:DescribeInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "Connect.DeleteIntegrationAssociation": [
            {
                "action": "connect:DeleteIntegrationAssociation",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "IntegrationAssociationId": {
                        "template": "${IntegrationAssociationId}"
                    }
                }
            },
            {
                "action": "app-integrations:DeleteEventIntegrationAssociation",
                "resource_mappings": {
                    "EventIntegrationName": {
                        "template": "*"
                    },
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "connect:DescribeInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            },
            {
                "action": "events:DeleteRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "*"
                    },
                    "RuleName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "events:ListTargetsByRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "*"
                    },
                    "RuleName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "events:RemoveTargets",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "*"
                    },
                    "RuleName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.DeleteUseCase": [
            {
                "action": "connect:DeleteUseCase",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "UseCaseId": {
                        "template": "${UseCaseId}"
                    }
                }
            },
            {
                "action": "connect:DescribeInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "Connect.ListIntegrationAssociations": [
            {
                "action": "connect:ListIntegrationAssociations",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "connect:DescribeInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "Connect.ListUseCases": [
            {
                "action": "connect:ListUseCases",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "connect:DescribeInstance",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            }
        ],
        "SecretsManager.RemoveRegionsFromReplication": [
            {
                "action": "secretsmanager:RemoveRegionsFromReplication",
                "resource_mappings": {
                    "SecretId": {
                        "template": "${SecretId}"
                    }
                }
            }
        ],
        "SecretsManager.ReplicateSecretToRegions": [
            {
                "action": "secretsmanager:ReplicateSecretToRegions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Secret": "arn:${Partition}:secretsmanager:${AddReplicaRegions[].Region}:${Account}:secret:${SecretId}"
                }
            }
        ],
        "SecretsManager.StopReplicationToReplica": [
            {
                "action": "secretsmanager:StopReplicationToReplica",
                "resource_mappings": {
                    "SecretId": {
                        "template": "${SecretId}"
                    }
                }
            }
        ],
        "IoTAnalytics.ListDatasetContents": [
            {
                "action": "iotanalytics:ListDatasetContents",
                "resource_mappings": {
                    "DatasetName": {
                        "template": "${datasetName}"
                    }
                }
            }
        ],
        "Chime.ListSupportedPhoneNumberCountries": [
            {
                "action": "chime:ListSupportedPhoneNumberCountries",
                "resource_mappings": {}
            }
        ],
        "Amplify.CreateWebhook": [
            {
                "action": "amplify:CreateWebHook",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "BranchName": {
                        "template": "${branchName}"
                    }
                }
            }
        ],
        "Amplify.DeleteWebhook": [
            {
                "action": "amplify:DeleteWebHook",
                "resource_mappings": {
                    "AppId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Amplify.GetWebhook": [
            {
                "action": "amplify:GetWebHook",
                "resource_mappings": {
                    "AppId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Amplify.ListTagsForResource": [
            {
                "action": "amplify:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "apps": "%%iftemplatematch%${resourceArn}%%",
                    "branches": "%%iftemplatematch%${resourceArn}%%",
                    "jobs": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Amplify.ListWebhooks": [
            {
                "action": "amplify:ListWebHooks",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    }
                }
            }
        ],
        "Amplify.UpdateWebhook": [
            {
                "action": "amplify:UpdateWebHook",
                "resource_mappings": {
                    "AppId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataSync.UpdateTaskExecution": [
            {
                "action": "datasync:UpdateTaskExecution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "taskexecution": "${TaskExecutionArn}"
                }
            }
        ],
        "ComprehendMedical.DescribeEntitiesDetectionV2Job": [
            {
                "action": "comprehendmedical:DescribeEntitiesDetectionV2Job",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.DescribeICD10CMInferenceJob": [
            {
                "action": "comprehendmedical:DescribeICD10CMInferenceJob",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.DescribePHIDetectionJob": [
            {
                "action": "comprehendmedical:DescribePHIDetectionJob",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.DescribeRxNormInferenceJob": [
            {
                "action": "comprehendmedical:DescribeRxNormInferenceJob",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.DetectEntitiesV2": [
            {
                "action": "comprehendmedical:DetectEntitiesV2",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.InferICD10CM": [
            {
                "action": "comprehendmedical:InferICD10CM",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.InferRxNorm": [
            {
                "action": "comprehendmedical:InferRxNorm",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.ListEntitiesDetectionV2Jobs": [
            {
                "action": "comprehendmedical:ListEntitiesDetectionV2Jobs",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.ListICD10CMInferenceJobs": [
            {
                "action": "comprehendmedical:ListICD10CMInferenceJobs",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.ListPHIDetectionJobs": [
            {
                "action": "comprehendmedical:ListPHIDetectionJobs",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.ListRxNormInferenceJobs": [
            {
                "action": "comprehendmedical:ListRxNormInferenceJobs",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.StartEntitiesDetectionV2Job": [
            {
                "action": "comprehendmedical:StartEntitiesDetectionV2Job",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.StartICD10CMInferenceJob": [
            {
                "action": "comprehendmedical:StartICD10CMInferenceJob",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.StartPHIDetectionJob": [
            {
                "action": "comprehendmedical:StartPHIDetectionJob",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.StartRxNormInferenceJob": [
            {
                "action": "comprehendmedical:StartRxNormInferenceJob",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.StopEntitiesDetectionV2Job": [
            {
                "action": "comprehendmedical:StopEntitiesDetectionV2Job",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.StopICD10CMInferenceJob": [
            {
                "action": "comprehendmedical:StopICD10CMInferenceJob",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.StopPHIDetectionJob": [
            {
                "action": "comprehendmedical:StopPHIDetectionJob",
                "resource_mappings": {}
            }
        ],
        "ComprehendMedical.StopRxNormInferenceJob": [
            {
                "action": "comprehendmedical:StopRxNormInferenceJob",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.AddFlowSources": [
            {
                "action": "mediaconnect:AddFlowSources",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.AddFlowVpcInterfaces": [
            {
                "action": "mediaconnect:AddFlowVpcInterfaces",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.DescribeOffering": [
            {
                "action": "mediaconnect:DescribeOffering",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.DescribeReservation": [
            {
                "action": "mediaconnect:DescribeReservation",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.ListOfferings": [
            {
                "action": "mediaconnect:ListOfferings",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.ListReservations": [
            {
                "action": "mediaconnect:ListReservations",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.ListTagsForResource": [
            {
                "action": "mediaconnect:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.PurchaseOffering": [
            {
                "action": "mediaconnect:PurchaseOffering",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.RemoveFlowSource": [
            {
                "action": "mediaconnect:RemoveFlowSource",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.RemoveFlowVpcInterface": [
            {
                "action": "mediaconnect:RemoveFlowVpcInterface",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.TagResource": [
            {
                "action": "mediaconnect:TagResource",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.UntagResource": [
            {
                "action": "mediaconnect:UntagResource",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.UpdateFlow": [
            {
                "action": "mediaconnect:UpdateFlow",
                "resource_mappings": {}
            }
        ],
        "FSx.DescribeFileSystemAliases": [
            {
                "action": "fsx:DescribeFileSystemAliases",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "FSx.DisassociateFileSystemAliases": [
            {
                "action": "fsx:DisassociateFileSystemAliases",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "SecurityHub.AcceptAdministratorInvitation": [
            {
                "action": "securityhub:AcceptAdministratorInvitation",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DisassociateFromAdministratorAccount": [
            {
                "action": "securityhub:DisassociateFromAdministratorAccount",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.GetAdministratorAccount": [
            {
                "action": "securityhub:GetAdministratorAccount",
                "resource_mappings": {}
            }
        ],
        "Kafka.UpdateBrokerType": [
            {
                "action": "kafka:UpdateBrokerType",
                "resource_mappings": {}
            }
        ],
        "Imagebuilder.ImportComponent": [
            {
                "action": "imagebuilder:ImportComponent",
                "resource_mappings": {
                    "ComponentName": {
                        "template": "${name}"
                    },
                    "ComponentVersion": {
                        "template": "*"
                    },
                    "ComponentBuildVersion": {
                        "template": "*"
                    },
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "imagebuilder:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "component": "*",
                    "containerRecipe": "*",
                    "distributionConfiguration": "*",
                    "image": "*",
                    "imagePipeline": "*",
                    "imageRecipe": "*",
                    "infrastructureConfiguration": "*"
                }
            },
            {
                "action": "kms:Encrypt",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            },
            {
                "action": "kms:GenerateDataKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            },
            {
                "action": "kms:GenerateDataKeyWithoutPlaintext",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${kmsKeyId}"
                    }
                }
            }
        ],
        "Detective.AcceptInvitation": [
            {
                "action": "detective:AcceptInvitation",
                "resource_mappings": {}
            }
        ],
        "Detective.DisassociateMembership": [
            {
                "action": "detective:DisassociateMembership",
                "resource_mappings": {}
            }
        ],
        "Detective.RejectInvitation": [
            {
                "action": "detective:RejectInvitation",
                "resource_mappings": {}
            }
        ],
        "Synthetics.DescribeRuntimeVersions": [
            {
                "action": "synthetics:DescribeRuntimeVersions",
                "resource_mappings": {}
            }
        ],
        "Synthetics.GetCanary": [
            {
                "action": "synthetics:GetCanary",
                "resource_mappings": {
                    "CanaryName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeDefaultEncryptionConfiguration": [
            {
                "action": "iotsitewise:DescribeDefaultEncryptionConfiguration",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.PutDefaultEncryptionConfiguration": [
            {
                "action": "iotsitewise:PutDefaultEncryptionConfiguration",
                "resource_mappings": {}
            }
        ],
        "HealthLake.CreateFHIRDatastore": [
            {
                "action": "healthlake:CreateFHIRDatastore",
                "resource_mappings": {}
            }
        ],
        "HealthLake.DeleteFHIRDatastore": [
            {
                "action": "healthlake:DeleteFHIRDatastore",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatastoreId": {
                        "template": "${DatastoreId}"
                    }
                }
            }
        ],
        "HealthLake.DescribeFHIRDatastore": [
            {
                "action": "healthlake:DescribeFHIRDatastore",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatastoreId": {
                        "template": "${DatastoreId}"
                    }
                }
            }
        ],
        "HealthLake.DescribeFHIRExportJob": [
            {
                "action": "healthlake:DescribeFHIRExportJob",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatastoreId": {
                        "template": "${DatastoreId}"
                    }
                }
            }
        ],
        "HealthLake.DescribeFHIRImportJob": [
            {
                "action": "healthlake:DescribeFHIRImportJob",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatastoreId": {
                        "template": "${DatastoreId}"
                    }
                }
            }
        ],
        "HealthLake.ListFHIRDatastores": [
            {
                "action": "healthlake:ListFHIRDatastores",
                "resource_mappings": {}
            }
        ],
        "HealthLake.StartFHIRExportJob": [
            {
                "action": "healthlake:StartFHIRExportJob",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatastoreId": {
                        "template": "${DatastoreId}"
                    }
                }
            }
        ],
        "HealthLake.StartFHIRImportJob": [
            {
                "action": "healthlake:StartFHIRImportJob",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatastoreId": {
                        "template": "${DatastoreId}"
                    }
                }
            }
        ],
        "IotDeviceAdvisor.StopSuiteRun": [
            {
                "action": "iotdeviceadvisor:StopSuiteRun",
                "resource_mappings": {
                    "suiteDefinitionId": {
                        "template": "${suiteDefinitionId}"
                    },
                    "suiteRunId": {
                        "template": "${suiteRunId}"
                    }
                }
            }
        ],
        "Nimble.AcceptEulas": [
            {
                "action": "nimble:AcceptEulas",
                "resource_mappings": {
                    "eulaId": {
                        "template": "${eulaIds}[]"
                    }
                }
            }
        ],
        "Nimble.CreateLaunchProfile": [
            {
                "action": "nimble:CreateLaunchProfile",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterfacePermission",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:RunInstances",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${streamConfiguration.streamingImageIds}[]"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "${ec2SubnetIds}[]"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "ElasticInferenceAcceleratorId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Nimble.CreateStreamingImage": [
            {
                "action": "nimble:CreateStreamingImage",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            },
            {
                "action": "ec2:DescribeImages",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSnapshots",
                "resource_mappings": {}
            },
            {
                "action": "ec2:ModifyInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifySnapshotAttribute",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:RegisterImage",
                "resource_mappings": {}
            }
        ],
        "Nimble.CreateStreamingSession": [
            {
                "action": "nimble:CreateStreamingSession",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterfacePermission",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "nimble:GetLaunchProfile",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            },
            {
                "action": "nimble:GetLaunchProfileInitialization",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            },
            {
                "action": "nimble:ListEulaAcceptances",
                "resource_mappings": {
                    "eulaAcceptanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Nimble.CreateStreamingSessionStream": [
            {
                "action": "nimble:CreateStreamingSessionStream",
                "resource_mappings": {
                    "streamingSessionId": {
                        "template": "${sessionId}"
                    }
                }
            }
        ],
        "Nimble.CreateStudio": [
            {
                "action": "nimble:CreateStudio",
                "resource_mappings": {
                    "studioId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "%%many%${adminRoleArn}%${userRoleArn}%%"
                }
            },
            {
                "action": "sso:CreateManagedApplicationInstance",
                "resource_mappings": {}
            }
        ],
        "Nimble.CreateStudioComponent": [
            {
                "action": "nimble:CreateStudioComponent",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            },
            {
                "action": "ds:AuthorizeApplication",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${configuration.activeDirectoryConfiguration.directoryId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            },
            {
                "action": "fsx:DescribeFileSystems",
                "resource_mappings": {}
            }
        ],
        "Nimble.DeleteLaunchProfile": [
            {
                "action": "nimble:DeleteLaunchProfile",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            }
        ],
        "Nimble.DeleteLaunchProfileMember": [
            {
                "action": "nimble:DeleteLaunchProfileMember",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            }
        ],
        "Nimble.DeleteStreamingImage": [
            {
                "action": "nimble:DeleteStreamingImage",
                "resource_mappings": {
                    "streamingImageId": {
                        "template": "${streamingImageId}"
                    }
                }
            },
            {
                "action": "ec2:DeleteSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeregisterImage",
                "resource_mappings": {
                    "ImageId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifyInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifySnapshotAttribute",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Nimble.DeleteStreamingSession": [
            {
                "action": "nimble:DeleteStreamingSession",
                "resource_mappings": {
                    "streamingSessionId": {
                        "template": "${sessionId}"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Nimble.DeleteStudio": [
            {
                "action": "nimble:DeleteStudio",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            },
            {
                "action": "sso:DeleteManagedApplicationInstance",
                "resource_mappings": {}
            }
        ],
        "Nimble.DeleteStudioComponent": [
            {
                "action": "nimble:DeleteStudioComponent",
                "resource_mappings": {
                    "studioComponentId": {
                        "template": "${studioComponentId}"
                    }
                }
            },
            {
                "action": "ds:UnauthorizeApplication",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Nimble.DeleteStudioMember": [
            {
                "action": "nimble:DeleteStudioMember",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            }
        ],
        "Nimble.GetEula": [
            {
                "action": "nimble:GetEula",
                "resource_mappings": {
                    "eulaId": {
                        "template": "${eulaId}"
                    }
                }
            }
        ],
        "Nimble.GetLaunchProfile": [
            {
                "action": "nimble:GetLaunchProfile",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            }
        ],
        "Nimble.GetLaunchProfileDetails": [
            {
                "action": "nimble:GetLaunchProfileDetails",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            }
        ],
        "Nimble.GetLaunchProfileInitialization": [
            {
                "action": "nimble:GetLaunchProfileInitialization",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            },
            {
                "action": "fsx:DescribeFileSystems",
                "resource_mappings": {}
            }
        ],
        "Nimble.GetLaunchProfileMember": [
            {
                "action": "nimble:GetLaunchProfileMember",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            }
        ],
        "Nimble.GetStreamingImage": [
            {
                "action": "nimble:GetStreamingImage",
                "resource_mappings": {
                    "streamingImageId": {
                        "template": "${streamingImageId}"
                    }
                }
            }
        ],
        "Nimble.GetStreamingSession": [
            {
                "action": "nimble:GetStreamingSession",
                "resource_mappings": {
                    "streamingSessionId": {
                        "template": "${sessionId}"
                    }
                }
            }
        ],
        "Nimble.GetStreamingSessionStream": [
            {
                "action": "nimble:GetStreamingSessionStream",
                "resource_mappings": {
                    "streamingSessionId": {
                        "template": "${sessionId}"
                    }
                }
            }
        ],
        "Nimble.GetStudio": [
            {
                "action": "nimble:GetStudio",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            }
        ],
        "Nimble.GetStudioComponent": [
            {
                "action": "nimble:GetStudioComponent",
                "resource_mappings": {
                    "studioComponentId": {
                        "template": "${studioComponentId}"
                    }
                }
            }
        ],
        "Nimble.GetStudioMember": [
            {
                "action": "nimble:GetStudioMember",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            }
        ],
        "Nimble.ListEulas": [
            {
                "action": "nimble:ListEulas",
                "resource_mappings": {
                    "eulaId": {
                        "template": "${eulaIds}[]"
                    }
                }
            }
        ],
        "Nimble.ListLaunchProfileMembers": [
            {
                "action": "nimble:ListLaunchProfileMembers",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            }
        ],
        "Nimble.ListLaunchProfiles": [
            {
                "action": "nimble:ListLaunchProfiles",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            }
        ],
        "Nimble.ListStreamingImages": [
            {
                "action": "nimble:ListStreamingImages",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            }
        ],
        "Nimble.ListStreamingSessions": [
            {
                "action": "nimble:ListStreamingSessions",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            }
        ],
        "Nimble.ListStudioComponents": [
            {
                "action": "nimble:ListStudioComponents",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            }
        ],
        "Nimble.ListStudioMembers": [
            {
                "action": "nimble:ListStudioMembers",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            }
        ],
        "Nimble.ListStudios": [
            {
                "action": "nimble:ListStudios",
                "resource_mappings": {}
            }
        ],
        "Nimble.ListTagsForResource": [
            {
                "action": "nimble:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "launch-profile": "%%iftemplatematch%${resourceArn}%%",
                    "streaming-image": "%%iftemplatematch%${resourceArn}%%",
                    "streaming-session": "%%iftemplatematch%${resourceArn}%%",
                    "studio": "%%iftemplatematch%${resourceArn}%%",
                    "studio-component": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Nimble.PutLaunchProfileMembers": [
            {
                "action": "nimble:PutLaunchProfileMembers",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            },
            {
                "action": "sso-directory:DescribeUsers",
                "resource_mappings": {}
            }
        ],
        "Nimble.PutStudioMembers": [
            {
                "action": "nimble:PutStudioMembers",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            },
            {
                "action": "sso-directory:DescribeUsers",
                "resource_mappings": {}
            }
        ],
        "Nimble.StartStudioSSOConfigurationRepair": [
            {
                "action": "nimble:StartStudioSSOConfigurationRepair",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            },
            {
                "action": "sso:CreateManagedApplicationInstance",
                "resource_mappings": {}
            },
            {
                "action": "sso:GetManagedApplicationInstance",
                "resource_mappings": {}
            }
        ],
        "Nimble.TagResource": [
            {
                "action": "nimble:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "launch-profile": "%%iftemplatematch%${resourceArn}%%",
                    "streaming-image": "%%iftemplatematch%${resourceArn}%%",
                    "streaming-session": "%%iftemplatematch%${resourceArn}%%",
                    "studio": "%%iftemplatematch%${resourceArn}%%",
                    "studio-component": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Nimble.UntagResource": [
            {
                "action": "nimble:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "launch-profile": "%%iftemplatematch%${resourceArn}%%",
                    "streaming-image": "%%iftemplatematch%${resourceArn}%%",
                    "streaming-session": "%%iftemplatematch%${resourceArn}%%",
                    "studio": "%%iftemplatematch%${resourceArn}%%",
                    "studio-component": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Nimble.UpdateLaunchProfile": [
            {
                "action": "nimble:UpdateLaunchProfile",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            }
        ],
        "Nimble.UpdateLaunchProfileMember": [
            {
                "action": "nimble:UpdateLaunchProfileMember",
                "resource_mappings": {
                    "launchProfileId": {
                        "template": "${launchProfileId}"
                    }
                }
            }
        ],
        "Nimble.UpdateStreamingImage": [
            {
                "action": "nimble:UpdateStreamingImage",
                "resource_mappings": {
                    "streamingImageId": {
                        "template": "${streamingImageId}"
                    }
                }
            }
        ],
        "Nimble.UpdateStudio": [
            {
                "action": "nimble:UpdateStudio",
                "resource_mappings": {
                    "studioId": {
                        "template": "${studioId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "%%many%${adminRoleArn}%${userRoleArn}%%"
                }
            }
        ],
        "Nimble.UpdateStudioComponent": [
            {
                "action": "nimble:UpdateStudioComponent",
                "resource_mappings": {
                    "studioComponentId": {
                        "template": "${studioComponentId}"
                    }
                }
            },
            {
                "action": "ds:AuthorizeApplication",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${configuration.activeDirectoryConfiguration.directoryId}"
                    }
                }
            },
            {
                "action": "ds:DescribeDirectories",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            },
            {
                "action": "fsx:DescribeFileSystems",
                "resource_mappings": {}
            }
        ],
        "AppRunner.AssociateCustomDomain": [
            {
                "action": "apprunner:AssociateCustomDomain",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}"
                }
            }
        ],
        "AppRunner.CreateAutoScalingConfiguration": [
            {
                "action": "apprunner:CreateAutoScalingConfiguration",
                "resource_mappings": {
                    "AutoscalingConfigurationName": {
                        "template": "${AutoScalingConfigurationName}"
                    },
                    "AutoscalingConfigurationVersion": {
                        "template": "*"
                    },
                    "AutoscalingConfigurationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppRunner.CreateConnection": [
            {
                "action": "apprunner:CreateConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${ConnectionName}"
                    },
                    "ConnectionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppRunner.CreateService": [
            {
                "action": "apprunner:CreateService",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${ServiceName}"
                    },
                    "ServiceId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "autoscalingconfiguration": "${AutoScalingConfigurationArn}",
                    "connection": "${SourceConfiguration.AuthenticationConfiguration.ConnectionArn}"
                }
            }
        ],
        "AppRunner.DeleteAutoScalingConfiguration": [
            {
                "action": "apprunner:DeleteAutoScalingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "autoscalingconfiguration": "${AutoScalingConfigurationArn}"
                }
            }
        ],
        "AppRunner.DeleteConnection": [
            {
                "action": "apprunner:DeleteConnection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "connection": "${ConnectionArn}"
                }
            }
        ],
        "AppRunner.DeleteService": [
            {
                "action": "apprunner:DeleteService",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}"
                }
            }
        ],
        "AppRunner.DescribeAutoScalingConfiguration": [
            {
                "action": "apprunner:DescribeAutoScalingConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "autoscalingconfiguration": "${AutoScalingConfigurationArn}"
                }
            }
        ],
        "AppRunner.DescribeCustomDomains": [
            {
                "action": "apprunner:DescribeCustomDomains",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}"
                }
            }
        ],
        "AppRunner.DescribeService": [
            {
                "action": "apprunner:DescribeService",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}"
                }
            }
        ],
        "AppRunner.DisassociateCustomDomain": [
            {
                "action": "apprunner:DisassociateCustomDomain",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}"
                }
            }
        ],
        "AppRunner.ListAutoScalingConfigurations": [
            {
                "action": "apprunner:ListAutoScalingConfigurations",
                "resource_mappings": {}
            }
        ],
        "AppRunner.ListConnections": [
            {
                "action": "apprunner:ListConnections",
                "resource_mappings": {}
            }
        ],
        "AppRunner.ListOperations": [
            {
                "action": "apprunner:ListOperations",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}"
                }
            }
        ],
        "AppRunner.ListServices": [
            {
                "action": "apprunner:ListServices",
                "resource_mappings": {}
            }
        ],
        "AppRunner.ListTagsForResource": [
            {
                "action": "apprunner:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "autoscalingconfiguration": "%%iftemplatematch%${ResourceArn}%%",
                    "connection": "%%iftemplatematch%${ResourceArn}%%",
                    "service": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AppRunner.PauseService": [
            {
                "action": "apprunner:PauseService",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}"
                }
            }
        ],
        "AppRunner.ResumeService": [
            {
                "action": "apprunner:ResumeService",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}"
                }
            }
        ],
        "AppRunner.StartDeployment": [
            {
                "action": "apprunner:StartDeployment",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}"
                }
            }
        ],
        "AppRunner.TagResource": [
            {
                "action": "apprunner:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "autoscalingconfiguration": "%%iftemplatematch%${ResourceArn}%%",
                    "connection": "%%iftemplatematch%${ResourceArn}%%",
                    "service": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AppRunner.UntagResource": [
            {
                "action": "apprunner:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "autoscalingconfiguration": "%%iftemplatematch%${ResourceArn}%%",
                    "connection": "%%iftemplatematch%${ResourceArn}%%",
                    "service": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AppRunner.UpdateService": [
            {
                "action": "apprunner:UpdateService",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "service": "${ServiceArn}",
                    "autoscalingconfiguration": "${AutoScalingConfigurationArn}",
                    "connection": "${SourceConfiguration.AuthenticationConfiguration.ConnectionArn}"
                }
            }
        ],
        "Iot.CreateJobTemplate": [
            {
                "action": "iot:CreateJobTemplate",
                "resource_mappings": {
                    "JobTemplateId": {
                        "template": "${jobTemplateId}"
                    }
                },
                "resourcearn_mappings": {
                    "job": "${jobArn}"
                }
            }
        ],
        "Iot.DeleteJobTemplate": [
            {
                "action": "iot:DeleteJobTemplate",
                "resource_mappings": {
                    "JobTemplateId": {
                        "template": "${jobTemplateId}"
                    }
                }
            }
        ],
        "Iot.DescribeJobTemplate": [
            {
                "action": "iot:DescribeJobTemplate",
                "resource_mappings": {
                    "JobTemplateId": {
                        "template": "${jobTemplateId}"
                    }
                }
            }
        ],
        "Iot.ListJobTemplates": [
            {
                "action": "iot:ListJobTemplates",
                "resource_mappings": {}
            }
        ],
        "IoTEvents.CreateAlarmModel": [
            {
                "action": "iotevents:CreateAlarmModel",
                "resource_mappings": {
                    "AlarmModelName": {
                        "template": "${alarmModelName}"
                    }
                }
            }
        ],
        "IoTEvents.DeleteAlarmModel": [
            {
                "action": "iotevents:DeleteAlarmModel",
                "resource_mappings": {
                    "AlarmModelName": {
                        "template": "${alarmModelName}"
                    }
                }
            }
        ],
        "IoTEvents.DescribeAlarmModel": [
            {
                "action": "iotevents:DescribeAlarmModel",
                "resource_mappings": {
                    "AlarmModelName": {
                        "template": "${alarmModelName}"
                    }
                }
            }
        ],
        "IoTEvents.ListAlarmModelVersions": [
            {
                "action": "iotevents:ListAlarmModelVersions",
                "resource_mappings": {
                    "AlarmModelName": {
                        "template": "${alarmModelName}"
                    }
                }
            }
        ],
        "IoTEvents.ListAlarmModels": [
            {
                "action": "iotevents:ListAlarmModels",
                "resource_mappings": {}
            }
        ],
        "IoTEvents.ListInputRoutings": [
            {
                "action": "iotevents:ListInputRoutings",
                "resource_mappings": {}
            }
        ],
        "IoTEvents.UpdateAlarmModel": [
            {
                "action": "iotevents:UpdateAlarmModel",
                "resource_mappings": {
                    "AlarmModelName": {
                        "template": "${alarmModelName}"
                    }
                }
            }
        ],
        "QLDB.UpdateLedgerPermissionsMode": [
            {
                "action": "qldb:UpdateLedgerPermissionsMode",
                "resource_mappings": {
                    "LedgerName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Kendra.ClearQuerySuggestions": [
            {
                "action": "kendra:ClearQuerySuggestions",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.CreateQuerySuggestionsBlockList": [
            {
                "action": "kendra:CreateQuerySuggestionsBlockList",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.DeleteQuerySuggestionsBlockList": [
            {
                "action": "kendra:DeleteQuerySuggestionsBlockList",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "QuerySuggestionsBlockListId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DescribeQuerySuggestionsBlockList": [
            {
                "action": "kendra:DescribeQuerySuggestionsBlockList",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "QuerySuggestionsBlockListId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DescribeQuerySuggestionsConfig": [
            {
                "action": "kendra:DescribeQuerySuggestionsConfig",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.GetQuerySuggestions": [
            {
                "action": "kendra:GetQuerySuggestions",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.ListQuerySuggestionsBlockLists": [
            {
                "action": "kendra:ListQuerySuggestionsBlockLists",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.UpdateQuerySuggestionsBlockList": [
            {
                "action": "kendra:UpdateQuerySuggestionsBlockList",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "QuerySuggestionsBlockListId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.UpdateQuerySuggestionsConfig": [
            {
                "action": "kendra:UpdateQuerySuggestionsConfig",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Nimble.ListEulaAcceptances": [
            {
                "action": "nimble:ListEulaAcceptances",
                "resource_mappings": {
                    "eulaAcceptanceId": {
                        "template": "${eulaIds}[]"
                    }
                }
            }
        ],
        "CognitoIdentity.GetPrincipalTagAttributeMap": [
            {
                "action": "cognito-identity:GetPrincipalTagAttributeMap",
                "resource_mappings": {
                    "IdentityPoolId": {
                        "template": "${IdentityPoolId}"
                    }
                }
            }
        ],
        "CognitoIdentity.SetPrincipalTagAttributeMap": [
            {
                "action": "cognito-identity:SetPrincipalTagAttributeMap",
                "resource_mappings": {}
            }
        ],
        "OpsWorksCM.ExportServerEngineAttribute": [
            {
                "action": "opsworks-cm:ExportServerEngineAttribute",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.CreateLicenseManagerReportGenerator": [
            {
                "action": "license-manager:CreateLicenseManagerReportGenerator",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.DeleteLicenseManagerReportGenerator": [
            {
                "action": "license-manager:DeleteLicenseManagerReportGenerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "report-generator": "${LicenseManagerReportGeneratorArn}"
                }
            }
        ],
        "LicenseManager.GetLicenseManagerReportGenerator": [
            {
                "action": "license-manager:GetLicenseManagerReportGenerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "report-generator": "${LicenseManagerReportGeneratorArn}"
                }
            }
        ],
        "LicenseManager.ListLicenseManagerReportGenerators": [
            {
                "action": "license-manager:ListLicenseManagerReportGenerators",
                "resource_mappings": {
                    "LicenseConfigurationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LicenseManager.UpdateLicenseManagerReportGenerator": [
            {
                "action": "license-manager:UpdateLicenseManagerReportGenerator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "report-generator": "${LicenseManagerReportGeneratorArn}"
                }
            }
        ],
        "MediaPackageVod.UpdatePackagingGroup": [
            {
                "action": "mediapackage-vod:UpdatePackagingGroup",
                "resource_mappings": {
                    "PackagingGroupIdentifier": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "EC2InstanceConnect.SendSerialConsoleSSHPublicKey": [
            {
                "action": "ec2-instance-connect:SendSerialConsoleSSHPublicKey",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "ElasticInference.DescribeAcceleratorOfferings": [
            {
                "action": "elastic-inference:DescribeAcceleratorOfferings",
                "resource_mappings": {}
            }
        ],
        "ElasticInference.DescribeAcceleratorTypes": [
            {
                "action": "elastic-inference:DescribeAcceleratorTypes",
                "resource_mappings": {}
            }
        ],
        "ElasticInference.DescribeAccelerators": [
            {
                "action": "elastic-inference:DescribeAccelerators",
                "resource_mappings": {}
            }
        ],
        "ElasticInference.ListTagsForResource": [
            {
                "action": "elastic-inference:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "ElasticInference.TagResource": [
            {
                "action": "elastic-inference:TagResource",
                "resource_mappings": {}
            }
        ],
        "ElasticInference.UntagResource": [
            {
                "action": "elastic-inference:UntagResource",
                "resource_mappings": {}
            }
        ],
        "AccessAnalyzer.CancelPolicyGeneration": [
            {
                "action": "access-analyzer:CancelPolicyGeneration",
                "resource_mappings": {}
            }
        ],
        "AccessAnalyzer.CreateAccessPreview": [
            {
                "action": "access-analyzer:CreateAccessPreview",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.GetAccessPreview": [
            {
                "action": "access-analyzer:GetAccessPreview",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.GetGeneratedPolicy": [
            {
                "action": "access-analyzer:GetGeneratedPolicy",
                "resource_mappings": {}
            }
        ],
        "AccessAnalyzer.ListAccessPreviewFindings": [
            {
                "action": "access-analyzer:ListAccessPreviewFindings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.ListAccessPreviews": [
            {
                "action": "access-analyzer:ListAccessPreviews",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Analyzer": "${analyzerArn}"
                }
            }
        ],
        "AccessAnalyzer.ListPolicyGenerations": [
            {
                "action": "access-analyzer:ListPolicyGenerations",
                "resource_mappings": {}
            }
        ],
        "AccessAnalyzer.StartPolicyGeneration": [
            {
                "action": "access-analyzer:StartPolicyGeneration",
                "resource_mappings": {}
            }
        ],
        "AccessAnalyzer.ValidatePolicy": [
            {
                "action": "access-analyzer:ValidatePolicy",
                "resource_mappings": {}
            }
        ],
        "CodeGuruReviewer.AssociateRepository": [
            {
                "action": "codeguru-reviewer:AssociateRepository",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    },
                    "RepositoryName": {
                        "template": "${Repository.CodeCommit.Name}"
                    }
                },
                "resourcearn_mappings": {
                    "connection": "%%many%${Repository.Bitbucket.ConnectionArn}%${Repository.GitHubEnterpriseServer.ConnectionArn}%%"
                }
            },
            {
                "action": "codecommit:ListRepositories",
                "resource_mappings": {}
            },
            {
                "action": "codecommit:TagResource",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${Repository.CodeCommit.Name}"
                    }
                }
            },
            {
                "action": "events:PutRule",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "*"
                    },
                    "RuleName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "events:PutTargets",
                "resource_mappings": {
                    "EventBusName": {
                        "template": "*"
                    },
                    "RuleName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:CreateBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:ListBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:PutBucketPolicy",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:PutLifecycleConfiguration",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeGuruReviewer.CreateCodeReview": [
            {
                "action": "codeguru-reviewer:CreateCodeReview",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "association": "${RepositoryAssociationArn}"
                }
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeGuruReviewer.DescribeCodeReview": [
            {
                "action": "codeguru-reviewer:DescribeCodeReview",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "association": "${CodeReviewArn}"
                }
            }
        ],
        "CodeGuruReviewer.DescribeRecommendationFeedback": [
            {
                "action": "codeguru-reviewer:DescribeRecommendationFeedback",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeGuruReviewer.ListRecommendationFeedback": [
            {
                "action": "codeguru-reviewer:ListRecommendationFeedback",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeGuruReviewer.ListRecommendations": [
            {
                "action": "codeguru-reviewer:ListRecommendations",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeGuruReviewer.ListTagsForResource": [
            {
                "action": "codeguru-reviewer:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "association": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "CodeGuruReviewer.PutRecommendationFeedback": [
            {
                "action": "codeguru-reviewer:PutRecommendationFeedback",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CodeGuruReviewer.TagResource": [
            {
                "action": "codeguru-reviewer:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "association": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "CodeGuruReviewer.UntagResource": [
            {
                "action": "codeguru-reviewer:UnTagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "association": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "DevOpsGuru.DescribeFeedback": [
            {
                "action": "devops-guru:DescribeFeedback",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.GetCostEstimation": [
            {
                "action": "devops-guru:GetCostEstimation",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.StartCostEstimation": [
            {
                "action": "devops-guru:StartCostEstimation",
                "resource_mappings": {}
            }
        ],
        "ECRPUBLIC.ListTagsForResource": [
            {
                "action": "ecr-public:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "repository": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "ECRPUBLIC.TagResource": [
            {
                "action": "ecr-public:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "repository": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "ECRPUBLIC.UntagResource": [
            {
                "action": "ecr-public:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "repository": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "EMRcontainers.DeleteManagedEndpoint": [
            {
                "action": "emr-containers:DeleteManagedEndpoint",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${virtualClusterId}"
                    },
                    "endpointId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "EMRcontainers.DescribeManagedEndpoint": [
            {
                "action": "emr-containers:DescribeManagedEndpoint",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${virtualClusterId}"
                    },
                    "endpointId": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "EMRcontainers.ListManagedEndpoints": [
            {
                "action": "emr-containers:ListManagedEndpoints",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${virtualClusterId}"
                    }
                }
            }
        ],
        "EMRcontainers.ListTagsForResource": [
            {
                "action": "emr-containers:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "jobRun": "%%iftruthy%${resourceArn}%%",
                    "managedEndpoint": "%%iftruthy%${resourceArn}%%",
                    "virtualCluster": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "EMRcontainers.TagResource": [
            {
                "action": "emr-containers:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "jobRun": "%%iftruthy%${resourceArn}%%",
                    "managedEndpoint": "%%iftruthy%${resourceArn}%%",
                    "virtualCluster": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "EMRcontainers.UntagResource": [
            {
                "action": "emr-containers:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "jobRun": "%%iftruthy%${resourceArn}%%",
                    "managedEndpoint": "%%iftruthy%${resourceArn}%%",
                    "virtualCluster": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "SSMContacts.AcceptPage": [
            {
                "action": "ssm-contacts:AcceptPage",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    },
                    "pageId": {
                        "template": "${PageId}"
                    }
                }
            }
        ],
        "SSMContacts.ActivateContactChannel": [
            {
                "action": "ssm-contacts:ActivateContactChannel",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    },
                    "ContactChannelId": {
                        "template": "${ContactChannelId}"
                    }
                }
            }
        ],
        "SSMContacts.CreateContact": [
            {
                "action": "ssm-contacts:CreateContact",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "${Alias}"
                    }
                }
            },
            {
                "action": "ssm-contacts:AssociateContact",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "${Alias}"
                    }
                }
            }
        ],
        "SSMContacts.CreateContactChannel": [
            {
                "action": "ssm-contacts:CreateContactChannel",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSMContacts.DeactivateContactChannel": [
            {
                "action": "ssm-contacts:DeactivateContactChannel",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    },
                    "ContactChannelId": {
                        "template": "${ContactChannelId}"
                    }
                }
            }
        ],
        "SSMContacts.DeleteContact": [
            {
                "action": "ssm-contacts:DeleteContact",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSMContacts.DeleteContactChannel": [
            {
                "action": "ssm-contacts:DeleteContactChannel",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    },
                    "ContactChannelId": {
                        "template": "${ContactChannelId}"
                    }
                }
            }
        ],
        "SSMContacts.DescribeEngagement": [
            {
                "action": "ssm-contacts:DescribeEngagement",
                "resource_mappings": {
                    "EngagementId": {
                        "template": "${EngagementId}"
                    }
                }
            }
        ],
        "SSMContacts.DescribePage": [
            {
                "action": "ssm-contacts:DescribePage",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    },
                    "pageId": {
                        "template": "${PageId}"
                    }
                }
            }
        ],
        "SSMContacts.GetContact": [
            {
                "action": "ssm-contacts:GetContact",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSMContacts.GetContactChannel": [
            {
                "action": "ssm-contacts:GetContactChannel",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    },
                    "ContactChannelId": {
                        "template": "${ContactChannelId}"
                    }
                }
            }
        ],
        "SSMContacts.ListContactChannels": [
            {
                "action": "ssm-contacts:ListContactChannels",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSMContacts.ListContacts": [
            {
                "action": "ssm-contacts:ListContacts",
                "resource_mappings": {}
            }
        ],
        "SSMContacts.ListEngagements": [
            {
                "action": "ssm-contacts:ListEngagements",
                "resource_mappings": {}
            }
        ],
        "SSMContacts.ListPageReceipts": [
            {
                "action": "ssm-contacts:ListPageReceipts",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    },
                    "pageId": {
                        "template": "${PageId}"
                    }
                }
            }
        ],
        "SSMContacts.ListPagesByContact": [
            {
                "action": "ssm-contacts:ListPagesByContact",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSMContacts.ListPagesByEngagement": [
            {
                "action": "ssm-contacts:ListPagesByEngagement",
                "resource_mappings": {
                    "EngagementId": {
                        "template": "${EngagementId}"
                    }
                }
            }
        ],
        "SSMContacts.PutContactPolicy": [
            {
                "action": "ssm-contacts:PutContactPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "contact": "${ContactArn}"
                }
            }
        ],
        "SSMContacts.SendActivationCode": [
            {
                "action": "ssm-contacts:SendActivationCode",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    },
                    "ContactChannelId": {
                        "template": "${ContactChannelId}"
                    }
                }
            }
        ],
        "SSMContacts.StartEngagement": [
            {
                "action": "ssm-contacts:StartEngagement",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSMContacts.StopEngagement": [
            {
                "action": "ssm-contacts:StopEngagement",
                "resource_mappings": {
                    "EngagementId": {
                        "template": "${EngagementId}"
                    }
                }
            }
        ],
        "SSMContacts.UpdateContact": [
            {
                "action": "ssm-contacts:UpdateContact",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ssm-contacts:AssociateContact",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    }
                }
            }
        ],
        "SSMContacts.UpdateContactChannel": [
            {
                "action": "ssm-contacts:UpdateContactChannel",
                "resource_mappings": {
                    "ContactAlias": {
                        "template": "*"
                    },
                    "ContactChannelId": {
                        "template": "${ContactChannelId}"
                    }
                }
            }
        ],
        "SSMIncidents.CreateReplicationSet": [
            {
                "action": "ssm-incidents:CreateReplicationSet",
                "resource_mappings": {}
            }
        ],
        "SSMIncidents.CreateResponsePlan": [
            {
                "action": "ssm-incidents:CreateResponsePlan",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${actions[].ssmAutomation.roleArn}"
                }
            }
        ],
        "SSMIncidents.CreateTimelineEvent": [
            {
                "action": "ssm-incidents:CreateTimelineEvent",
                "resource_mappings": {
                    "ResponsePlan": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "incident-record": "${incidentRecordArn}"
                }
            }
        ],
        "SSMIncidents.DeleteIncidentRecord": [
            {
                "action": "ssm-incidents:DeleteIncidentRecord",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "incident-record": "${arn}"
                }
            }
        ],
        "SSMIncidents.DeleteReplicationSet": [
            {
                "action": "ssm-incidents:DeleteReplicationSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "replication-set": "${arn}"
                }
            }
        ],
        "SSMIncidents.DeleteResourcePolicy": [
            {
                "action": "ssm-incidents:DeleteResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "SSMIncidents.DeleteResponsePlan": [
            {
                "action": "ssm-incidents:DeleteResponsePlan",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "${arn}"
                }
            }
        ],
        "SSMIncidents.DeleteTimelineEvent": [
            {
                "action": "ssm-incidents:DeleteTimelineEvent",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "incident-record": "${incidentRecordArn}"
                }
            }
        ],
        "SSMIncidents.GetIncidentRecord": [
            {
                "action": "ssm-incidents:GetIncidentRecord",
                "resource_mappings": {
                    "ResponsePlan": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "incident-record": "${arn}"
                }
            }
        ],
        "SSMIncidents.GetReplicationSet": [
            {
                "action": "ssm-incidents:GetReplicationSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "replication-set": "${arn}"
                }
            }
        ],
        "SSMIncidents.GetResourcePolicies": [
            {
                "action": "ssm-incidents:GetResourcePolicies",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "${resourceArn}"
                }
            }
        ],
        "SSMIncidents.GetResponsePlan": [
            {
                "action": "ssm-incidents:GetResponsePlan",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "${arn}"
                }
            }
        ],
        "SSMIncidents.GetTimelineEvent": [
            {
                "action": "ssm-incidents:GetTimelineEvent",
                "resource_mappings": {
                    "ResponsePlan": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "incident-record": "${incidentRecordArn}"
                }
            }
        ],
        "SSMIncidents.ListIncidentRecords": [
            {
                "action": "ssm-incidents:ListIncidentRecords",
                "resource_mappings": {}
            }
        ],
        "SSMIncidents.ListRelatedItems": [
            {
                "action": "ssm-incidents:ListRelatedItems",
                "resource_mappings": {
                    "ResponsePlan": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "incident-record": "${incidentRecordArn}"
                }
            }
        ],
        "SSMIncidents.ListReplicationSets": [
            {
                "action": "ssm-incidents:ListReplicationSets",
                "resource_mappings": {}
            }
        ],
        "SSMIncidents.ListResponsePlans": [
            {
                "action": "ssm-incidents:ListResponsePlans",
                "resource_mappings": {}
            }
        ],
        "SSMIncidents.ListTagsForResource": [
            {
                "action": "ssm-incidents:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "SSMIncidents.ListTimelineEvents": [
            {
                "action": "ssm-incidents:ListTimelineEvents",
                "resource_mappings": {
                    "ResponsePlan": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "incident-record": "${incidentRecordArn}"
                }
            }
        ],
        "SSMIncidents.PutResourcePolicy": [
            {
                "action": "ssm-incidents:PutResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "SSMIncidents.StartIncident": [
            {
                "action": "ssm-incidents:StartIncident",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "${responsePlanArn}"
                }
            }
        ],
        "SSMIncidents.TagResource": [
            {
                "action": "ssm-incidents:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "SSMIncidents.UntagResource": [
            {
                "action": "ssm-incidents:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "%%iftruthy%${resourceArn}%%"
                }
            }
        ],
        "SSMIncidents.UpdateDeletionProtection": [
            {
                "action": "ssm-incidents:UpdateDeletionProtection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "replication-set": "${arn}"
                }
            }
        ],
        "SSMIncidents.UpdateIncidentRecord": [
            {
                "action": "ssm-incidents:UpdateIncidentRecord",
                "resource_mappings": {
                    "ResponsePlan": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "incident-record": "${arn}"
                }
            }
        ],
        "SSMIncidents.UpdateRelatedItems": [
            {
                "action": "ssm-incidents:UpdateRelatedItems",
                "resource_mappings": {
                    "ResponsePlan": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "incident-record": "${incidentRecordArn}"
                }
            }
        ],
        "SSMIncidents.UpdateReplicationSet": [
            {
                "action": "ssm-incidents:UpdateReplicationSet",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "replication-set": "${arn}"
                }
            }
        ],
        "SSMIncidents.UpdateResponsePlan": [
            {
                "action": "ssm-incidents:UpdateResponsePlan",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "response-plan": "${arn}"
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${actions[].ssmAutomation.roleArn}"
                }
            }
        ],
        "SSMIncidents.UpdateTimelineEvent": [
            {
                "action": "ssm-incidents:UpdateTimelineEvent",
                "resource_mappings": {
                    "ResponsePlan": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "incident-record": "${incidentRecordArn}"
                }
            }
        ],
        "ApplicationCostProfiler.DeleteReportDefinition": [
            {
                "action": "application-cost-profiler:DeleteReportDefinition",
                "resource_mappings": {}
            }
        ],
        "ApplicationCostProfiler.GetReportDefinition": [
            {
                "action": "application-cost-profiler:GetReportDefinition",
                "resource_mappings": {}
            }
        ],
        "ApplicationCostProfiler.ImportApplicationUsage": [
            {
                "action": "application-cost-profiler:ImportApplicationUsage",
                "resource_mappings": {}
            }
        ],
        "ApplicationCostProfiler.ListReportDefinitions": [
            {
                "action": "application-cost-profiler:ListReportDefinitions",
                "resource_mappings": {}
            }
        ],
        "ApplicationCostProfiler.PutReportDefinition": [
            {
                "action": "application-cost-profiler:PutReportDefinition",
                "resource_mappings": {}
            }
        ],
        "ApplicationCostProfiler.UpdateReportDefinition": [
            {
                "action": "application-cost-profiler:UpdateReportDefinition",
                "resource_mappings": {}
            }
        ],
        "SSMContacts.GetContactPolicy": [
            {
                "action": "ssm-contacts:GetContactPolicy",
                "undocumented": true
            }
        ],
        "SSMContacts.ListTagsForResource": [
            {
                "action": "ssm-contacts:ListTagsForResource",
                "undocumented": true
            }
        ],
        "SSMContacts.TagResource": [
            {
                "action": "ssm-contacts:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "contact": "${ResourceARN}"
                }
            }
        ],
        "SSMContacts.UntagResource": [
            {
                "action": "ssm-contacts:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "contact": "${ResourceARN}"
                }
            }
        ],
        "Finspace.CreateEnvironment": [
            {
                "action": "finspace:CreateEnvironment",
                "resource_mappings": {
                    "environmentId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Finspace.DeleteEnvironment": [
            {
                "action": "finspace:DeleteEnvironment",
                "resource_mappings": {
                    "environmentId": {
                        "template": "${environmentId}"
                    }
                }
            }
        ],
        "Finspace.GetEnvironment": [
            {
                "action": "finspace:GetEnvironment",
                "resource_mappings": {
                    "environmentId": {
                        "template": "${environmentId}"
                    }
                }
            }
        ],
        "Finspace.ListEnvironments": [
            {
                "action": "finspace:ListEnvironments",
                "resource_mappings": {
                    "environmentId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Finspace.ListTagsForResource": [
            {
                "action": "finspace:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "${resourceArn}"
                }
            }
        ],
        "Finspace.TagResource": [
            {
                "action": "finspace:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "${resourceArn}"
                }
            }
        ],
        "Finspace.UntagResource": [
            {
                "action": "finspace:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "${resourceArn}"
                }
            }
        ],
        "Finspace.UpdateEnvironment": [
            {
                "action": "finspace:UpdateEnvironment",
                "resource_mappings": {
                    "environmentId": {
                        "template": "${environmentId}"
                    }
                }
            }
        ],
        "LakeFormation.AddLFTagsToResource": [
            {
                "action": "lakeformation:AddLFTagsToResource",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.CreateLFTag": [
            {
                "action": "lakeformation:CreateLFTag",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.DeleteLFTag": [
            {
                "action": "lakeformation:DeleteLFTag",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GetLFTag": [
            {
                "action": "lakeformation:GetLFTag",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GetResourceLFTags": [
            {
                "action": "lakeformation:GetResourceLFTags",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.ListLFTags": [
            {
                "action": "lakeformation:ListLFTags",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.RemoveLFTagsFromResource": [
            {
                "action": "lakeformation:RemoveLFTagsFromResource",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.SearchDatabasesByLFTags": [
            {
                "action": "lakeformation:SearchDatabasesByLFTags",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.SearchTablesByLFTags": [
            {
                "action": "lakeformation:SearchTablesByLFTags",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.UpdateLFTag": [
            {
                "action": "lakeformation:UpdateLFTag",
                "resource_mappings": {}
            }
        ],
        "Personalize.CreateDatasetExportJob": [
            {
                "action": "personalize:CreateDatasetExportJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${jobName}"
                    }
                }
            }
        ],
        "Personalize.DescribeDatasetExportJob": [
            {
                "action": "personalize:DescribeDatasetExportJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datasetExportJob": "${datasetExportJobArn}"
                }
            }
        ],
        "Personalize.ListDatasetExportJobs": [
            {
                "action": "personalize:ListDatasetExportJobs",
                "resource_mappings": {}
            }
        ],
        "Personalize.StopSolutionVersionCreation": [
            {
                "action": "personalize:StopSolutionVersionCreation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "solution": "${solutionVersionArn}"
                }
            }
        ],
        "Transfer.CreateAccess": [
            {
                "action": "transfer:CreateAccess",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${Role}"
                }
            }
        ],
        "Transfer.DeleteAccess": [
            {
                "action": "transfer:DeleteAccess",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            }
        ],
        "Transfer.DescribeAccess": [
            {
                "action": "transfer:DescribeAccess",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            }
        ],
        "Transfer.ListAccesses": [
            {
                "action": "transfer:ListAccesses",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "serverId": {
                        "template": "${ServerId}"
                    }
                }
            }
        ],
        "Transfer.UpdateAccess": [
            {
                "action": "transfer:UpdateAccess",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${Role}"
                }
            }
        ],
        "MediaTailor.CreateChannel": [
            {
                "action": "mediatailor:CreateChannel",
                "resource_mappings": {}
            }
        ],
        "MediaTailor.CreateProgram": [
            {
                "action": "mediatailor:CreateProgram",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.CreateSourceLocation": [
            {
                "action": "mediatailor:CreateSourceLocation",
                "resource_mappings": {}
            }
        ],
        "MediaTailor.CreateVodSource": [
            {
                "action": "mediatailor:CreateVodSource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SourceLocationName}"
                    }
                }
            }
        ],
        "MediaTailor.DeleteChannel": [
            {
                "action": "mediatailor:DeleteChannel",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.DeleteChannelPolicy": [
            {
                "action": "mediatailor:DeleteChannelPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.DeleteProgram": [
            {
                "action": "mediatailor:DeleteProgram",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ProgramName}"
                    }
                }
            }
        ],
        "MediaTailor.DeleteSourceLocation": [
            {
                "action": "mediatailor:DeleteSourceLocation",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SourceLocationName}"
                    }
                }
            }
        ],
        "MediaTailor.DeleteVodSource": [
            {
                "action": "mediatailor:DeleteVodSource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${VodSourceName}"
                    }
                }
            }
        ],
        "MediaTailor.DescribeChannel": [
            {
                "action": "mediatailor:DescribeChannel",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.DescribeProgram": [
            {
                "action": "mediatailor:DescribeProgram",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ProgramName}"
                    }
                }
            }
        ],
        "MediaTailor.DescribeSourceLocation": [
            {
                "action": "mediatailor:DescribeSourceLocation",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SourceLocationName}"
                    }
                }
            }
        ],
        "MediaTailor.DescribeVodSource": [
            {
                "action": "mediatailor:DescribeVodSource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${VodSourceName}"
                    }
                }
            }
        ],
        "MediaTailor.GetChannelPolicy": [
            {
                "action": "mediatailor:GetChannelPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.GetChannelSchedule": [
            {
                "action": "mediatailor:GetChannelSchedule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.ListChannels": [
            {
                "action": "mediatailor:ListChannels",
                "resource_mappings": {}
            }
        ],
        "MediaTailor.ListSourceLocations": [
            {
                "action": "mediatailor:ListSourceLocations",
                "resource_mappings": {}
            }
        ],
        "MediaTailor.ListVodSources": [
            {
                "action": "mediatailor:ListVodSources",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SourceLocationName}"
                    }
                }
            }
        ],
        "MediaTailor.PutChannelPolicy": [
            {
                "action": "mediatailor:PutChannelPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.StartChannel": [
            {
                "action": "mediatailor:StartChannel",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.StopChannel": [
            {
                "action": "mediatailor:StopChannel",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.UpdateChannel": [
            {
                "action": "mediatailor:UpdateChannel",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ChannelName}"
                    }
                }
            }
        ],
        "MediaTailor.UpdateSourceLocation": [
            {
                "action": "mediatailor:UpdateSourceLocation",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${SourceLocationName}"
                    }
                }
            }
        ],
        "MediaTailor.UpdateVodSource": [
            {
                "action": "mediatailor:UpdateVodSource",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${VodSourceName}"
                    }
                }
            }
        ],
        "Finspacedata.CreateChangeset": [
            {
                "action": "finspace-api:CreateChangeset",
                "undocumented": true
            }
        ],
        "Finspacedata.GetProgrammaticAccessCredentials": [
            {
                "action": "finspace-api:GetProgrammaticAccessCredentials",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/credentials/programmatic"
                }
            }
        ],
        "Finspacedata.GetWorkingLocation": [
            {
                "action": "finspace-api:GetWorkingLocation",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/workingLocationV1"
                }
            }
        ],
        "Snowball.CreateLongTermPricing": [
            {
                "action": "snowball:CreateLongTermPricing",
                "resource_mappings": {}
            }
        ],
        "Snowball.ListLongTermPricing": [
            {
                "action": "snowball:ListLongTermPricing",
                "resource_mappings": {}
            }
        ],
        "Snowball.UpdateLongTermPricing": [
            {
                "action": "snowball:UpdateLongTermPricing",
                "resource_mappings": {}
            }
        ],
        "CloudFront.CreateFunction": [
            {
                "action": "cloudfront:CreateFunction",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeleteFunction": [
            {
                "action": "cloudfront:DeleteFunction",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DescribeFunction": [
            {
                "action": "cloudfront:DescribeFunction",
                "resource_mappings": {}
            }
        ],
        "CloudFront.GetFunction": [
            {
                "action": "cloudfront:GetFunction",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListFunctions": [
            {
                "action": "cloudfront:ListFunctions",
                "resource_mappings": {}
            }
        ],
        "CloudFront.PublishFunction": [
            {
                "action": "cloudfront:PublishFunction",
                "resource_mappings": {}
            }
        ],
        "CloudFront.TestFunction": [
            {
                "action": "cloudfront:TestFunction",
                "resource_mappings": {}
            }
        ],
        "CloudFront.UpdateFunction": [
            {
                "action": "cloudfront:UpdateFunction",
                "resource_mappings": {}
            }
        ],
        "Redshift.AddPartner": [
            {
                "action": "redshift:AddPartner",
                "resource_mappings": {}
            }
        ],
        "Redshift.AuthorizeEndpointAccess": [
            {
                "action": "redshift:AuthorizeEndpointAccess",
                "resource_mappings": {}
            }
        ],
        "Redshift.CreateEndpointAccess": [
            {
                "action": "redshift:CreateEndpointAccess",
                "resource_mappings": {}
            }
        ],
        "Redshift.DeleteEndpointAccess": [
            {
                "action": "redshift:DeleteEndpointAccess",
                "resource_mappings": {}
            }
        ],
        "Redshift.DeletePartner": [
            {
                "action": "redshift:DeletePartner",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeEndpointAccess": [
            {
                "action": "redshift:DescribeEndpointAccess",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeEndpointAuthorization": [
            {
                "action": "redshift:DescribeEndpointAuthorization",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribePartners": [
            {
                "action": "redshift:DescribePartners",
                "resource_mappings": {}
            }
        ],
        "Redshift.ModifyEndpointAccess": [
            {
                "action": "redshift:ModifyEndpointAccess",
                "resource_mappings": {}
            }
        ],
        "Redshift.RevokeEndpointAccess": [
            {
                "action": "redshift:RevokeEndpointAccess",
                "resource_mappings": {}
            }
        ],
        "Redshift.UpdatePartnerStatus": [
            {
                "action": "redshift:UpdatePartnerStatus",
                "resource_mappings": {}
            }
        ],
        "KMS.ReplicateKey": [
            {
                "action": "kms:ReplicateKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            },
            {
                "action": "kms:CreateKey",
                "resource_mappings": {}
            }
        ],
        "KMS.UpdatePrimaryRegion": [
            {
                "action": "kms:UpdatePrimaryRegion",
                "resource_mappings": {
                    "KeyId": {
                        "template": "%%regex%${KeyId}%/^(?:.*\\/)?([0-9a-f-]+)$/g%%"
                    }
                }
            }
        ],
        "SNS.CreateSMSSandboxPhoneNumber": [
            {
                "action": "sns:CreateSMSSandboxPhoneNumber",
                "resource_mappings": {}
            }
        ],
        "SNS.DeleteSMSSandboxPhoneNumber": [
            {
                "action": "sns:DeleteSMSSandboxPhoneNumber",
                "resource_mappings": {}
            }
        ],
        "SNS.GetSMSSandboxAccountStatus": [
            {
                "action": "sns:GetSMSSandboxAccountStatus",
                "resource_mappings": {}
            }
        ],
        "SNS.ListOriginationNumbers": [
            {
                "action": "sns:ListOriginationNumbers",
                "resource_mappings": {}
            }
        ],
        "SNS.ListSMSSandboxPhoneNumbers": [
            {
                "action": "sns:ListSMSSandboxPhoneNumbers",
                "resource_mappings": {}
            }
        ],
        "SNS.VerifySMSSandboxPhoneNumber": [
            {
                "action": "sns:VerifySMSSandboxPhoneNumber",
                "resource_mappings": {}
            }
        ],
        "Connect.AssociateBot": [
            {
                "action": "connect:AssociateBot",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "iam:AttachRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PutRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:GetBot",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "bot alias": "${LexV2Bot.AliasArn}"
                }
            },
            {
                "action": "lex:UpdateResourcePolicy",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    },
                    "BotAliasId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.DisassociateBot": [
            {
                "action": "connect:DisassociateBot",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            },
            {
                "action": "iam:AttachRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PutRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:DeleteResourcePolicy",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "bot alias": "${LexV2Bot.AliasArn}"
                }
            },
            {
                "action": "lex:UpdateResourcePolicy",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    },
                    "BotAliasId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.ListBots": [
            {
                "action": "connect:ListBots",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "PI.GetDimensionKeyDetails": [
            {
                "action": "pi:GetDimensionKeyDetails",
                "resource_mappings": {
                    "ServiceType": {
                        "template": "${ServiceType}"
                    },
                    "Identifier": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "Chime.BatchCreateChannelMembership": [
            {
                "action": "chime:BatchCreateChannelMembership",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${MemberArns}[]",
                    "channel": "${ChannelArn}"
                }
            }
        ],
        "Macie2.DisassociateFromAdministratorAccount": [
            {
                "action": "macie2:DisassociateFromAdministratorAccount",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetAdministratorAccount": [
            {
                "action": "macie2:GetAdministratorAccount",
                "resource_mappings": {}
            }
        ],
        "Macie2.GetFindingsPublicationConfiguration": [
            {
                "action": "macie2:GetFindingsPublicationConfiguration",
                "resource_mappings": {}
            }
        ],
        "Macie2.PutFindingsPublicationConfiguration": [
            {
                "action": "macie2:PutFindingsPublicationConfiguration",
                "resource_mappings": {}
            }
        ],
        "Macie2.SearchResources": [
            {
                "action": "macie2:SearchResources",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.GetLogLevelsByResourceTypes": [
            {
                "action": "iotwireless:GetLogLevelsByResourceTypes",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.GetResourceLogLevel": [
            {
                "action": "iotwireless:GetResourceLogLevel",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "*"
                    },
                    "WirelessGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.PutResourceLogLevel": [
            {
                "action": "iotwireless:PutResourceLogLevel",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "*"
                    },
                    "WirelessGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.ResetAllResourceLogLevels": [
            {
                "action": "iotwireless:ResetAllResourceLogLevels",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ResetResourceLogLevel": [
            {
                "action": "iotwireless:ResetResourceLogLevel",
                "resource_mappings": {
                    "WirelessDeviceId": {
                        "template": "*"
                    },
                    "WirelessGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTWireless.UpdateLogLevelsByResourceTypes": [
            {
                "action": "iotwireless:UpdateLogLevelsByResourceTypes",
                "resource_mappings": {}
            }
        ],
        "Proton.CreateEnvironment": [
            {
                "action": "proton:CreateEnvironment",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${protonServiceRoleArn}"
                }
            }
        ],
        "Proton.CreateEnvironmentTemplate": [
            {
                "action": "proton:CreateEnvironmentTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.CreateService": [
            {
                "action": "proton:CreateService",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${name}"
                    }
                }
            },
            {
                "action": "codestar-connections:PassConnection",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Connection": "${repositoryConnectionArn}"
                }
            }
        ],
        "Proton.CreateServiceTemplate": [
            {
                "action": "proton:CreateServiceTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.DeleteEnvironment": [
            {
                "action": "proton:DeleteEnvironment",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.DeleteEnvironmentTemplate": [
            {
                "action": "proton:DeleteEnvironmentTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.DeleteService": [
            {
                "action": "proton:DeleteService",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.DeleteServiceTemplate": [
            {
                "action": "proton:DeleteServiceTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.GetEnvironment": [
            {
                "action": "proton:GetEnvironment",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.GetEnvironmentTemplate": [
            {
                "action": "proton:GetEnvironmentTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.GetService": [
            {
                "action": "proton:GetService",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.GetServiceInstance": [
            {
                "action": "proton:GetServiceInstance",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${serviceName}"
                    },
                    "ServiceInstanceName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.GetServiceTemplate": [
            {
                "action": "proton:GetServiceTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.ListEnvironmentTemplates": [
            {
                "action": "proton:ListEnvironmentTemplates",
                "resource_mappings": {}
            }
        ],
        "Proton.ListEnvironments": [
            {
                "action": "proton:ListEnvironments",
                "resource_mappings": {}
            }
        ],
        "Proton.ListServiceInstances": [
            {
                "action": "proton:ListServiceInstances",
                "resource_mappings": {}
            }
        ],
        "Proton.ListServiceTemplates": [
            {
                "action": "proton:ListServiceTemplates",
                "resource_mappings": {}
            }
        ],
        "Proton.ListServices": [
            {
                "action": "proton:ListServices",
                "resource_mappings": {}
            }
        ],
        "Proton.ListTagsForResource": [
            {
                "action": "proton:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "%%iftemplatematch%${resourceArn}%%",
                    "environment-template": "%%iftemplatematch%${resourceArn}%%",
                    "environment-template-major-version": "%%iftemplatematch%${resourceArn}%%",
                    "environment-template-minor-version": "%%iftemplatematch%${resourceArn}%%",
                    "service": "%%iftemplatematch%${resourceArn}%%",
                    "service-instance": "%%iftemplatematch%${resourceArn}%%",
                    "service-template": "%%iftemplatematch%${resourceArn}%%",
                    "service-template-major-version": "%%iftemplatematch%${resourceArn}%%",
                    "service-template-minor-version": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Proton.TagResource": [
            {
                "action": "proton:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "%%iftemplatematch%${resourceArn}%%",
                    "environment-template": "%%iftemplatematch%${resourceArn}%%",
                    "environment-template-major-version": "%%iftemplatematch%${resourceArn}%%",
                    "environment-template-minor-version": "%%iftemplatematch%${resourceArn}%%",
                    "service": "%%iftemplatematch%${resourceArn}%%",
                    "service-instance": "%%iftemplatematch%${resourceArn}%%",
                    "service-template": "%%iftemplatematch%${resourceArn}%%",
                    "service-template-major-version": "%%iftemplatematch%${resourceArn}%%",
                    "service-template-minor-version": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Proton.UntagResource": [
            {
                "action": "proton:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "environment": "%%iftemplatematch%${resourceArn}%%",
                    "environment-template": "%%iftemplatematch%${resourceArn}%%",
                    "environment-template-major-version": "%%iftemplatematch%${resourceArn}%%",
                    "environment-template-minor-version": "%%iftemplatematch%${resourceArn}%%",
                    "service": "%%iftemplatematch%${resourceArn}%%",
                    "service-instance": "%%iftemplatematch%${resourceArn}%%",
                    "service-template": "%%iftemplatematch%${resourceArn}%%",
                    "service-template-major-version": "%%iftemplatematch%${resourceArn}%%",
                    "service-template-minor-version": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Proton.UpdateEnvironment": [
            {
                "action": "proton:UpdateEnvironment",
                "resource_mappings": {
                    "EnvironmentName": {
                        "template": "${name}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${protonServiceRoleArn}"
                }
            }
        ],
        "Proton.UpdateEnvironmentTemplate": [
            {
                "action": "proton:UpdateEnvironmentTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.UpdateService": [
            {
                "action": "proton:UpdateService",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.UpdateServiceInstance": [
            {
                "action": "proton:UpdateServiceInstance",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${serviceName}"
                    },
                    "ServiceInstanceName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.UpdateServicePipeline": [
            {
                "action": "proton:UpdateServicePipeline",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${serviceName}"
                    }
                }
            }
        ],
        "Proton.UpdateServiceTemplate": [
            {
                "action": "proton:UpdateServiceTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "EC2.CreateReplaceRootVolumeTask": [
            {
                "action": "ec2:CreateReplaceRootVolumeTask",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EC2.CreateRestoreImageTask": [
            {
                "action": "ec2:CreateRestoreImageTask",
                "resource_mappings": {
                    "ImageId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateStoreImageTask": [
            {
                "action": "ec2:CreateStoreImageTask",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "EC2.DescribeReplaceRootVolumeTasks": [
            {
                "action": "ec2:DescribeReplaceRootVolumeTasks",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeStoreImageTasks": [
            {
                "action": "ec2:DescribeStoreImageTasks",
                "resource_mappings": {}
            }
        ],
        "EC2.GetFlowLogsIntegrationTemplate": [
            {
                "action": "ec2:GetFlowLogsIntegrationTemplate",
                "resource_mappings": {
                    "VpcFlowLogId": {
                        "template": "${FlowLogId}"
                    }
                }
            }
        ],
        "Chime.UpdateSipMediaApplicationCall": [
            {
                "action": "chime:UpdateSipMediaApplicationCall",
                "resource_mappings": {}
            }
        ],
        "EC2.DisableImageDeprecation": [
            {
                "action": "ec2:DisableImageDeprecation",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "EC2.EnableImageDeprecation": [
            {
                "action": "ec2:EnableImageDeprecation",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "Chime.CreateMediaCapturePipeline": [
            {
                "action": "chime:CreateMediaCapturePipeline",
                "resource_mappings": {}
            }
        ],
        "Chime.DeleteMediaCapturePipeline": [
            {
                "action": "chime:DeleteMediaCapturePipeline",
                "resource_mappings": {}
            }
        ],
        "Chime.GetMediaCapturePipeline": [
            {
                "action": "chime:GetMediaCapturePipeline",
                "resource_mappings": {}
            }
        ],
        "Chime.ListMediaCapturePipelines": [
            {
                "action": "chime:ListMediaCapturePipelines",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.AddFlowMediaStreams": [
            {
                "action": "mediaconnect:AddFlowMediaStreams",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.RemoveFlowMediaStream": [
            {
                "action": "mediaconnect:RemoveFlowMediaStream",
                "resource_mappings": {}
            }
        ],
        "MediaConnect.UpdateFlowMediaStream": [
            {
                "action": "mediaconnect:UpdateFlowMediaStream",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.ExportEBSVolumeRecommendations": [
            {
                "action": "compute-optimizer:ExportEBSVolumeRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "compute-optimizer:GetEBSVolumeRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVolumes",
                "resource_mappings": {}
            }
        ],
        "AppStream.CreateUpdatedImage": [
            {
                "action": "appstream:CreateUpdatedImage",
                "resource_mappings": {
                    "ImageName": {
                        "template": "%%many%${existingImageName}%${newImageName}%%"
                    }
                }
            }
        ],
        "CloudFormation.DeactivateType": [
            {
                "action": "cloudformation:DeactivateType",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.DescribePublisher": [
            {
                "action": "cloudformation:DescribePublisher",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.PublishType": [
            {
                "action": "cloudformation:PublishType",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.RegisterPublisher": [
            {
                "action": "cloudformation:RegisterPublisher",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.SetTypeConfiguration": [
            {
                "action": "cloudformation:SetTypeConfiguration",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.TestType": [
            {
                "action": "cloudformation:TestType",
                "resource_mappings": {}
            }
        ],
        "CloudFront.AssociateAlias": [
            {
                "action": "cloudfront:AssociateAlias",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${TargetDistributionId}"
                    }
                }
            }
        ],
        "CloudFront.ListConflictingAliases": [
            {
                "action": "cloudfront:ListConflictingAliases",
                "resource_mappings": {
                    "DistributionId": {
                        "template": "${DistributionId}"
                    }
                }
            }
        ],
        "DirectConnect.AssociateMacSecKey": [
            {
                "action": "directconnect:AssociateMacSecKey",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.DisassociateMacSecKey": [
            {
                "action": "directconnect:DisassociateMacSecKey",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    },
                    "LagId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectConnect.UpdateConnection": [
            {
                "action": "directconnect:UpdateConnection",
                "resource_mappings": {
                    "ConnectionId": {
                        "template": "${connectionId}"
                    }
                }
            }
        ],
        "DMS.DescribeEndpointSettings": [
            {
                "action": "dms:DescribeEndpointSettings",
                "resource_mappings": {}
            }
        ],
        "DMS.DescribePendingMaintenanceActions": [
            {
                "action": "dms:DescribePendingMaintenanceActions",
                "undocumented": true
            }
        ],
        "ES.DescribeDomainAutoTunes": [
            {
                "action": "es:DescribeDomainAutoTunes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "MediaLive.CreatePartnerInput": [
            {
                "action": "medialive:CreatePartnerInput",
                "resource_mappings": {}
            }
        ],
        "MediaTailor.ListAlerts": [
            {
                "action": "mediatailor:ListAlerts",
                "resource_mappings": {}
            }
        ],
        "KinesisAnalyticsV2.ListApplicationVersions": [
            {
                "action": "kinesisanalytics:ListApplicationVersions",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "IoTEvents.DescribeDetectorModelAnalysis": [
            {
                "action": "iotevents:DescribeDetectorModelAnalysis",
                "resource_mappings": {}
            }
        ],
        "IoTEvents.GetDetectorModelAnalysisResults": [
            {
                "action": "iotevents:GetDetectorModelAnalysisResults",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.DescribeStorageConfiguration": [
            {
                "action": "iotsitewise:DescribeStorageConfiguration",
                "resource_mappings": {}
            }
        ],
        "AmplifyBackend.ImportBackendAuth": [
            {
                "action": "amplifybackend:ImportBackendAuth",
                "resource_mappings": {
                    "AppId": {
                        "template": "${AppId}"
                    }
                }
            }
        ],
        "CustomerProfiles.GetMatches": [
            {
                "action": "profile:GetMatches",
                "resource_mappings": {}
            }
        ],
        "GreengrassV2.BatchAssociateClientDeviceWithCoreDevice": [
            {
                "action": "greengrass:BatchAssociateClientDeviceWithCoreDevice",
                "resource_mappings": {
                    "CoreDeviceThingName": {
                        "template": "${coreDeviceThingName}"
                    }
                }
            }
        ],
        "GreengrassV2.BatchDisassociateClientDeviceFromCoreDevice": [
            {
                "action": "greengrass:BatchDisassociateClientDeviceFromCoreDevice",
                "resource_mappings": {
                    "CoreDeviceThingName": {
                        "template": "${coreDeviceThingName}"
                    }
                }
            }
        ],
        "GreengrassV2.ListClientDevicesAssociatedWithCoreDevice": [
            {
                "action": "greengrass:ListClientDevicesAssociatedWithCoreDevice",
                "resource_mappings": {
                    "CoreDeviceThingName": {
                        "template": "${coreDeviceThingName}"
                    }
                }
            }
        ],
        "Proton.CancelEnvironmentDeployment": [
            {
                "action": "proton:CancelEnvironmentDeployment",
                "resource_mappings": {
                    "Name": {
                        "template": "${environmentName}"
                    }
                }
            }
        ],
        "Proton.CancelServiceInstanceDeployment": [
            {
                "action": "proton:CancelServiceInstanceDeployment",
                "resource_mappings": {
                    "ServiceName": {
                        "template": "${serviceName}"
                    },
                    "Name": {
                        "template": "${serviceInstanceName}"
                    }
                }
            }
        ],
        "Proton.CancelServicePipelineDeployment": [
            {
                "action": "proton:CancelServicePipelineDeployment",
                "resource_mappings": {
                    "Name": {
                        "template": "${serviceName}"
                    }
                }
            }
        ],
        "Proton.DeleteEnvironmentTemplateVersion": [
            {
                "action": "proton:DeleteEnvironmentTemplateVersion",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Proton.DeleteServiceTemplateVersion": [
            {
                "action": "proton:DeleteServiceTemplateVersion",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Proton.GetAccountSettings": [
            {
                "action": "proton:GetAccountSettings",
                "resource_mappings": {}
            }
        ],
        "Proton.GetEnvironmentTemplateVersion": [
            {
                "action": "proton:GetEnvironmentTemplateVersion",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Proton.GetServiceTemplateVersion": [
            {
                "action": "proton:GetServiceTemplateVersion",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Proton.ListEnvironmentAccountConnections": [
            {
                "action": "proton:ListEnvironmentAccountConnections",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Proton.ListEnvironmentTemplateVersions": [
            {
                "action": "proton:ListEnvironmentTemplateVersions",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Proton.ListServiceTemplateVersions": [
            {
                "action": "proton:ListServiceTemplateVersions",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Proton.UpdateAccountSettings": [
            {
                "action": "proton:UpdateAccountSettings",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${pipelineServiceRoleArn}"
                }
            }
        ],
        "Proton.UpdateEnvironmentTemplateVersion": [
            {
                "action": "proton:UpdateEnvironmentTemplateVersion",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Proton.UpdateServiceTemplateVersion": [
            {
                "action": "proton:UpdateServiceTemplateVersion",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "CloudWatchEvents.CreateApiDestination": [
            {
                "action": "events:CreateApiDestination",
                "resource_mappings": {
                    "ApiDestinationName": {
                        "template": "${Name}"
                    }
                },
                "resourcearn_mappings": {
                    "connection": "${ConnectionArn}"
                }
            }
        ],
        "CloudWatchEvents.CreateConnection": [
            {
                "action": "events:CreateConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DeauthorizeConnection": [
            {
                "action": "events:DeauthorizeConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DeleteApiDestination": [
            {
                "action": "events:DeleteApiDestination",
                "resource_mappings": {
                    "ApiDestinationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DeleteConnection": [
            {
                "action": "events:DeleteConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.DescribeApiDestination": [
            {
                "action": "events:DescribeApiDestination",
                "resource_mappings": {
                    "ApiDestinationName": {
                        "template": "${Name}"
                    },
                    "ConnectionName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudWatchEvents.DescribeConnection": [
            {
                "action": "events:DescribeConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.ListApiDestinations": [
            {
                "action": "events:ListApiDestinations",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.ListConnections": [
            {
                "action": "events:ListConnections",
                "resource_mappings": {}
            }
        ],
        "CloudWatchEvents.UpdateApiDestination": [
            {
                "action": "events:UpdateApiDestination",
                "resource_mappings": {
                    "ApiDestinationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchEvents.UpdateConnection": [
            {
                "action": "events:UpdateConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "CloudWatchLogs.DeleteQueryDefinition": [
            {
                "action": "logs:DeleteQueryDefinition",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.DescribeQueryDefinitions": [
            {
                "action": "logs:DescribeQueryDefinitions",
                "resource_mappings": {}
            }
        ],
        "CloudWatchLogs.PutQueryDefinition": [
            {
                "action": "logs:PutQueryDefinition",
                "resource_mappings": {}
            }
        ],
        "ConfigService.DescribeAggregateComplianceByConformancePacks": [
            {
                "action": "config:DescribeAggregateComplianceByConformancePacks",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConfigService.GetAggregateConformancePackComplianceSummary": [
            {
                "action": "config:GetAggregateConformancePackComplianceSummary",
                "resource_mappings": {
                    "AggregatorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DirectoryService.AddRegion": [
            {
                "action": "ds:AddRegion",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DescribeRegions": [
            {
                "action": "ds:DescribeRegions",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.DisableClientAuthentication": [
            {
                "action": "ds:DisableClientAuthentication",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.EnableClientAuthentication": [
            {
                "action": "ds:EnableClientAuthentication",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "DirectoryService.RemoveRegion": [
            {
                "action": "ds:RemoveRegion",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "EFS.DescribeAccountPreferences": [
            {
                "action": "elasticfilesystem:DescribeAccountPreferences",
                "resource_mappings": {}
            }
        ],
        "EFS.PutAccountPreferences": [
            {
                "action": "elasticfilesystem:PutAccountPreferences",
                "resource_mappings": {}
            }
        ],
        "EMR.CreateStudio": [
            {
                "action": "elasticmapreduce:CreateStudio",
                "resource_mappings": {}
            }
        ],
        "EMR.CreateStudioSessionMapping": [
            {
                "action": "elasticmapreduce:CreateStudioSessionMapping",
                "resource_mappings": {
                    "StudioId": {
                        "template": "${StudioId}"
                    }
                }
            }
        ],
        "EMR.DeleteStudio": [
            {
                "action": "elasticmapreduce:DeleteStudio",
                "resource_mappings": {
                    "StudioId": {
                        "template": "${StudioId}"
                    }
                }
            }
        ],
        "EMR.DeleteStudioSessionMapping": [
            {
                "action": "elasticmapreduce:DeleteStudioSessionMapping",
                "resource_mappings": {
                    "StudioId": {
                        "template": "${StudioId}"
                    }
                }
            }
        ],
        "EMR.DescribeNotebookExecution": [
            {
                "action": "elasticmapreduce:DescribeNotebookExecution",
                "resource_mappings": {
                    "NotebookExecutionId": {
                        "template": "${NotebookExecutionId}"
                    }
                }
            }
        ],
        "EMR.DescribeStudio": [
            {
                "action": "elasticmapreduce:DescribeStudio",
                "resource_mappings": {
                    "StudioId": {
                        "template": "${StudioId}"
                    }
                }
            }
        ],
        "EMR.GetStudioSessionMapping": [
            {
                "action": "elasticmapreduce:GetStudioSessionMapping",
                "resource_mappings": {
                    "StudioId": {
                        "template": "${StudioId}"
                    }
                }
            }
        ],
        "EMR.ListNotebookExecutions": [
            {
                "action": "elasticmapreduce:ListNotebookExecutions",
                "resource_mappings": {}
            }
        ],
        "EMR.ListStudioSessionMappings": [
            {
                "action": "elasticmapreduce:ListStudioSessionMappings",
                "resource_mappings": {}
            }
        ],
        "EMR.ListStudios": [
            {
                "action": "elasticmapreduce:ListStudios",
                "resource_mappings": {}
            }
        ],
        "EMR.StartNotebookExecution": [
            {
                "action": "elasticmapreduce:StartNotebookExecution",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "*"
                    },
                    "EditorId": {
                        "template": "${EditorId}"
                    }
                }
            }
        ],
        "EMR.StopNotebookExecution": [
            {
                "action": "elasticmapreduce:StopNotebookExecution",
                "resource_mappings": {
                    "NotebookExecutionId": {
                        "template": "${NotebookExecutionId}"
                    }
                }
            }
        ],
        "EMR.UpdateStudio": [
            {
                "action": "elasticmapreduce:UpdateStudio",
                "resource_mappings": {
                    "StudioId": {
                        "template": "${StudioId}"
                    }
                }
            }
        ],
        "EMR.UpdateStudioSessionMapping": [
            {
                "action": "elasticmapreduce:UpdateStudioSessionMapping",
                "resource_mappings": {
                    "StudioId": {
                        "template": "${StudioId}"
                    }
                }
            }
        ],
        "Pinpoint.GetApplicationDateRangeKpi": [
            {
                "action": "mobiletargeting:GetApplicationDateRangeKpi",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetCampaignDateRangeKpi": [
            {
                "action": "mobiletargeting:GetCampaignDateRangeKpi",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "CampaignId": {
                        "template": "${CampaignId}"
                    }
                }
            }
        ],
        "Pinpoint.GetJourneyDateRangeKpi": [
            {
                "action": "mobiletargeting:GetJourneyDateRangeKpi",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "JourneyId": {
                        "template": "${JourneyId}"
                    }
                }
            }
        ],
        "Pinpoint.GetJourneyExecutionActivityMetrics": [
            {
                "action": "mobiletargeting:GetJourneyExecutionActivityMetrics",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "JourneyId": {
                        "template": "${JourneyId}"
                    }
                }
            }
        ],
        "Pinpoint.GetJourneyExecutionMetrics": [
            {
                "action": "mobiletargeting:GetJourneyExecutionMetrics",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    },
                    "JourneyId": {
                        "template": "${JourneyId}"
                    }
                }
            }
        ],
        "Pinpoint.PhoneNumberValidate": [
            {
                "action": "mobiletargeting:PhoneNumberValidate",
                "resource_mappings": {}
            }
        ],
        "MigrationHub.ListApplicationStates": [
            {
                "action": "mgh:ListApplicationStates",
                "resource_mappings": {}
            }
        ],
        "CloudHSMV2.ModifyBackupAttributes": [
            {
                "action": "cloudhsm:ModifyBackupAttributes",
                "resource_mappings": {
                    "CloudHsmBackupInstanceName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudHSMV2.ModifyCluster": [
            {
                "action": "cloudhsm:ModifyCluster",
                "resource_mappings": {
                    "CloudHsmClusterInstanceName": {
                        "template": "*"
                    }
                }
            }
        ],
        "AlexaForBusiness.AssociateDeviceWithNetworkProfile": [
            {
                "action": "a4b:AssociateDeviceWithNetworkProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${DeviceArn}",
                    "networkprofile": "${NetworkProfileArn}"
                }
            }
        ],
        "AlexaForBusiness.CreateGatewayGroup": [
            {
                "action": "a4b:CreateGatewayGroup",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.CreateNetworkProfile": [
            {
                "action": "a4b:CreateNetworkProfile",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.DeleteDeviceUsageData": [
            {
                "action": "a4b:DeleteDeviceUsageData",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "device": "${DeviceArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteGatewayGroup": [
            {
                "action": "a4b:DeleteGatewayGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gatewaygroup": "${GatewayGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.DeleteNetworkProfile": [
            {
                "action": "a4b:DeleteNetworkProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkprofile": "${NetworkProfileArn}"
                }
            }
        ],
        "AlexaForBusiness.GetGateway": [
            {
                "action": "a4b:GetGateway",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayArn}"
                }
            }
        ],
        "AlexaForBusiness.GetGatewayGroup": [
            {
                "action": "a4b:GetGatewayGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gatewaygroup": "${GatewayGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.GetInvitationConfiguration": [
            {
                "action": "a4b:GetInvitationConfiguration",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.ListGatewayGroups": [
            {
                "action": "a4b:ListGatewayGroups",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.ListGateways": [
            {
                "action": "a4b:ListGateways",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gatewaygroup": "${GatewayGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.PutInvitationConfiguration": [
            {
                "action": "a4b:PutInvitationConfiguration",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.SendAnnouncement": [
            {
                "action": "a4b:SendAnnouncement",
                "resource_mappings": {}
            }
        ],
        "AlexaForBusiness.UpdateGateway": [
            {
                "action": "a4b:UpdateGateway",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayArn}"
                }
            }
        ],
        "AlexaForBusiness.UpdateGatewayGroup": [
            {
                "action": "a4b:UpdateGatewayGroup",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gatewaygroup": "${GatewayGroupArn}"
                }
            }
        ],
        "AlexaForBusiness.UpdateNetworkProfile": [
            {
                "action": "a4b:UpdateNetworkProfile",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkprofile": "${NetworkProfileArn}"
                }
            }
        ],
        "PinpointEmail.GetDomainDeliverabilityCampaign": [
            {
                "action": "ses:GetDomainDeliverabilityCampaign",
                "resource_mappings": {}
            },
            {
                "action": "ses:GetDomainDeliverabilityCampaign",
                "resource_mappings": {}
            }
        ],
        "PinpointEmail.ListDomainDeliverabilityCampaigns": [
            {
                "action": "ses:ListDomainDeliverabilityCampaigns",
                "resource_mappings": {}
            },
            {
                "action": "ses:ListDomainDeliverabilityCampaigns",
                "resource_mappings": {}
            }
        ],
        "RDSDataService.BeginTransaction": [
            {
                "action": "rds-data:BeginTransaction",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${resourceArn}"
                }
            }
        ],
        "RDSDataService.CommitTransaction": [
            {
                "action": "rds-data:CommitTransaction",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${resourceArn}"
                }
            },
            {
                "action": "rds-data:BeginTransaction",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${resourceArn}"
                }
            }
        ],
        "RDSDataService.ExecuteSql": [
            {
                "action": "rds-data:ExecuteSql",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${dbClusterOrInstanceArn}%%"
                }
            }
        ],
        "RDSDataService.RollbackTransaction": [
            {
                "action": "rds-data:RollbackTransaction",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${resourceArn}"
                }
            },
            {
                "action": "rds-data:BeginTransaction",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${resourceArn}"
                }
            }
        ],
        "KinesisAnalyticsV2.CreateApplicationPresignedUrl": [
            {
                "action": "kinesisanalytics:CreateApplicationPresignedUrl",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "DocDB.AddSourceIdentifierToSubscription": [
            {
                "action": "rds:AddSourceIdentifierToSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "DocDB.DeleteEventSubscription": [
            {
                "action": "rds:DeleteEventSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "DocDB.DeleteGlobalCluster": [
            {
                "action": "rds:DeleteGlobalCluster",
                "resource_mappings": {
                    "GlobalCluster": {
                        "template": "${GlobalClusterIdentifier}"
                    }
                }
            }
        ],
        "DocDB.DescribeEventSubscriptions": [
            {
                "action": "rds:DescribeEventSubscriptions",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "DocDB.DescribeGlobalClusters": [
            {
                "action": "rds:DescribeGlobalClusters",
                "resource_mappings": {
                    "GlobalCluster": {
                        "template": "${GlobalClusterIdentifier}"
                    }
                }
            }
        ],
        "DocDB.ModifyEventSubscription": [
            {
                "action": "rds:ModifyEventSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "DocDB.RemoveFromGlobalCluster": [
            {
                "action": "rds:RemoveFromGlobalCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DbClusterIdentifier}"
                    },
                    "GlobalCluster": {
                        "template": "${GlobalClusterIdentifier}"
                    }
                }
            }
        ],
        "DocDB.RemoveSourceIdentifierFromSubscription": [
            {
                "action": "rds:RemoveSourceIdentifierFromSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            }
        ],
        "IoTEventsData.DescribeAlarm": [
            {
                "action": "iotevents:DescribeAlarm",
                "resource_mappings": {
                    "AlarmModelName": {
                        "template": "${alarmModelName}"
                    }
                }
            }
        ],
        "IoTEventsData.ListAlarms": [
            {
                "action": "iotevents:ListAlarms",
                "resource_mappings": {
                    "AlarmModelName": {
                        "template": "${alarmModelName}"
                    }
                }
            }
        ],
        "EventBridge.CreateApiDestination": [
            {
                "action": "events:CreateApiDestination",
                "resource_mappings": {
                    "ApiDestinationName": {
                        "template": "${Name}"
                    }
                },
                "resourcearn_mappings": {
                    "connection": "${ConnectionArn}"
                }
            }
        ],
        "EventBridge.CreateConnection": [
            {
                "action": "events:CreateConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DeauthorizeConnection": [
            {
                "action": "events:DeauthorizeConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DeleteApiDestination": [
            {
                "action": "events:DeleteApiDestination",
                "resource_mappings": {
                    "ApiDestinationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DeleteConnection": [
            {
                "action": "events:DeleteConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.DescribeApiDestination": [
            {
                "action": "events:DescribeApiDestination",
                "resource_mappings": {
                    "ApiDestinationName": {
                        "template": "${Name}"
                    },
                    "ConnectionName": {
                        "template": "*"
                    }
                }
            }
        ],
        "EventBridge.DescribeConnection": [
            {
                "action": "events:DescribeConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.ListApiDestinations": [
            {
                "action": "events:ListApiDestinations",
                "resource_mappings": {}
            }
        ],
        "EventBridge.ListConnections": [
            {
                "action": "events:ListConnections",
                "resource_mappings": {}
            }
        ],
        "EventBridge.UpdateApiDestination": [
            {
                "action": "events:UpdateApiDestination",
                "resource_mappings": {
                    "ApiDestinationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "EventBridge.UpdateConnection": [
            {
                "action": "events:UpdateConnection",
                "resource_mappings": {
                    "ConnectionName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SESV2.CreateContact": [
            {
                "action": "ses:CreateContact",
                "resource_mappings": {
                    "ContactListName": {
                        "template": "${ContactListName}"
                    }
                }
            }
        ],
        "SESV2.CreateContactList": [
            {
                "action": "ses:CreateContactList",
                "resource_mappings": {}
            }
        ],
        "SESV2.CreateEmailTemplate": [
            {
                "action": "ses:CreateEmailTemplate",
                "resource_mappings": {}
            }
        ],
        "SESV2.CreateImportJob": [
            {
                "action": "ses:CreateImportJob",
                "resource_mappings": {}
            }
        ],
        "SESV2.DeleteContact": [
            {
                "action": "ses:DeleteContact",
                "resource_mappings": {
                    "ContactListName": {
                        "template": "${ContactListName}"
                    }
                }
            }
        ],
        "SESV2.DeleteContactList": [
            {
                "action": "ses:DeleteContactList",
                "resource_mappings": {
                    "ContactListName": {
                        "template": "${ContactListName}"
                    }
                }
            }
        ],
        "SESV2.DeleteEmailTemplate": [
            {
                "action": "ses:DeleteEmailTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    }
                }
            }
        ],
        "SESV2.DeleteSuppressedDestination": [
            {
                "action": "ses:DeleteSuppressedDestination",
                "resource_mappings": {}
            }
        ],
        "SESV2.GetContact": [
            {
                "action": "ses:GetContact",
                "resource_mappings": {
                    "ContactListName": {
                        "template": "${ContactListName}"
                    }
                }
            }
        ],
        "SESV2.GetContactList": [
            {
                "action": "ses:GetContactList",
                "resource_mappings": {
                    "ContactListName": {
                        "template": "${ContactListName}"
                    }
                }
            }
        ],
        "SESV2.GetDomainDeliverabilityCampaign": [
            {
                "action": "ses:GetDomainDeliverabilityCampaign",
                "resource_mappings": {}
            },
            {
                "action": "ses:GetDomainDeliverabilityCampaign",
                "resource_mappings": {}
            }
        ],
        "SESV2.GetEmailTemplate": [
            {
                "action": "ses:GetEmailTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    }
                }
            }
        ],
        "SESV2.GetImportJob": [
            {
                "action": "ses:GetImportJob",
                "resource_mappings": {
                    "ImportJobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "SESV2.GetSuppressedDestination": [
            {
                "action": "ses:GetSuppressedDestination",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListContactLists": [
            {
                "action": "ses:ListContactLists",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListContacts": [
            {
                "action": "ses:ListContacts",
                "resource_mappings": {
                    "ContactListName": {
                        "template": "${ContactListName}"
                    }
                }
            }
        ],
        "SESV2.ListDomainDeliverabilityCampaigns": [
            {
                "action": "ses:ListDomainDeliverabilityCampaigns",
                "resource_mappings": {}
            },
            {
                "action": "ses:ListDomainDeliverabilityCampaigns",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListEmailTemplates": [
            {
                "action": "ses:ListEmailTemplates",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListImportJobs": [
            {
                "action": "ses:ListImportJobs",
                "resource_mappings": {}
            }
        ],
        "SESV2.ListSuppressedDestinations": [
            {
                "action": "ses:ListSuppressedDestinations",
                "resource_mappings": {}
            }
        ],
        "SESV2.PutAccountDetails": [
            {
                "action": "ses:PutAccountDetails",
                "resource_mappings": {}
            }
        ],
        "SESV2.PutAccountSuppressionAttributes": [
            {
                "action": "ses:PutAccountSuppressionAttributes",
                "resource_mappings": {}
            }
        ],
        "SESV2.PutConfigurationSetSuppressionOptions": [
            {
                "action": "ses:PutConfigurationSetSuppressionOptions",
                "resource_mappings": {
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.PutSuppressedDestination": [
            {
                "action": "ses:PutSuppressedDestination",
                "resource_mappings": {}
            }
        ],
        "SESV2.SendBulkEmail": [
            {
                "action": "ses:SendBulkEmail",
                "resource_mappings": {}
            }
        ],
        "SESV2.TestRenderEmailTemplate": [
            {
                "action": "ses:TestRenderEmailTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    }
                }
            }
        ],
        "SESV2.UpdateContact": [
            {
                "action": "ses:UpdateContact",
                "resource_mappings": {
                    "ContactListName": {
                        "template": "${ContactListName}"
                    }
                }
            }
        ],
        "SESV2.UpdateContactList": [
            {
                "action": "ses:UpdateContactList",
                "resource_mappings": {
                    "ContactListName": {
                        "template": "${ContactListName}"
                    }
                }
            }
        ],
        "SESV2.UpdateEmailTemplate": [
            {
                "action": "ses:UpdateEmailTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.CreateApplication": [
            {
                "action": "servicecatalog:CreateApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "ConnectContactLens.ListRealtimeContactAnalysisSegments": [
            {
                "action": "connect:ListRealtimeContactAnalysisSegments",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "${ContactId}"
                    }
                }
            }
        ],
        "SageMakerFeatureStoreRuntime.BatchGetRecord": [
            {
                "action": "sagemaker:BatchGetRecord",
                "resource_mappings": {
                    "FeatureGroupName": {
                        "template": "${Identifiers[].FeatureGroupName}"
                    }
                }
            }
        ],
        "GreengrassV2.GetComponentVersionArtifact": [
            {
                "action": "greengrass:GetComponentVersionArtifact",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "componentVersion": "${arn}"
                }
            }
        ],
        "GreengrassV2.ResolveComponentCandidates": [
            {
                "action": "greengrass:ResolveComponentCandidates",
                "resource_mappings": {
                    "ComponentName": {
                        "template": "${componentCandidates[].componentName}"
                    },
                    "ComponentVersion": {
                        "template": "${componentCandidates[].componentVersion}"
                    }
                }
            }
        ],
        "Location.BatchDeleteDevicePositionHistory": [
            {
                "action": "geo:BatchDeleteDevicePositionHistory",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.CalculateRoute": [
            {
                "action": "geo:CalculateRoute",
                "resource_mappings": {
                    "CalculatorName": {
                        "template": "${CalculatorName}"
                    }
                }
            }
        ],
        "Location.CreateRouteCalculator": [
            {
                "action": "geo:CreateRouteCalculator",
                "resource_mappings": {
                    "CalculatorName": {
                        "template": "${CalculatorName}"
                    }
                }
            }
        ],
        "Location.DeleteRouteCalculator": [
            {
                "action": "geo:DeleteRouteCalculator",
                "resource_mappings": {
                    "CalculatorName": {
                        "template": "${CalculatorName}"
                    }
                }
            }
        ],
        "Location.DescribeRouteCalculator": [
            {
                "action": "geo:DescribeRouteCalculator",
                "resource_mappings": {
                    "CalculatorName": {
                        "template": "${CalculatorName}"
                    }
                }
            }
        ],
        "Location.ListDevicePositions": [
            {
                "action": "geo:ListDevicePositions",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "Location.ListRouteCalculators": [
            {
                "action": "geo:ListRouteCalculators",
                "resource_mappings": {}
            }
        ],
        "Location.ListTagsForResource": [
            {
                "action": "geo:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "geofence-collection": "%%iftemplatematch%${ResourceArn}%%",
                    "map": "%%iftemplatematch%${ResourceArn}%%",
                    "place-index": "%%iftemplatematch%${ResourceArn}%%",
                    "route-calculator": "%%iftemplatematch%${ResourceArn}%%",
                    "tracker": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Location.TagResource": [
            {
                "action": "geo:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "geofence-collection": "%%iftemplatematch%${ResourceArn}%%",
                    "map": "%%iftemplatematch%${ResourceArn}%%",
                    "place-index": "%%iftemplatematch%${ResourceArn}%%",
                    "route-calculator": "%%iftemplatematch%${ResourceArn}%%",
                    "tracker": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Location.UntagResource": [
            {
                "action": "geo:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "geofence-collection": "%%iftemplatematch%${ResourceArn}%%",
                    "map": "%%iftemplatematch%${ResourceArn}%%",
                    "place-index": "%%iftemplatematch%${ResourceArn}%%",
                    "route-calculator": "%%iftemplatematch%${ResourceArn}%%",
                    "tracker": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "LexModelsV2.CreateUploadUrl": [
            {
                "action": "lex:CreateUploadUrl",
                "resource_mappings": {}
            }
        ],
        "LexModelsV2.ListExports": [
            {
                "action": "lex:ListExports",
                "resource_mappings": {}
            }
        ],
        "LexModelsV2.ListImports": [
            {
                "action": "lex:ListImports",
                "resource_mappings": {}
            }
        ],
        "ServiceDiscovery.UpdatePrivateDnsNamespace": [
            {
                "action": "servicediscovery:UpdatePrivateDnsNamespace",
                "resource_mappings": {
                    "NamespaceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ServiceDiscovery.UpdatePublicDnsNamespace": [
            {
                "action": "servicediscovery:UpdatePublicDnsNamespace",
                "resource_mappings": {
                    "NamespaceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.DescribeApplicationVersion": [
            {
                "action": "kinesisanalytics:DescribeApplicationVersion",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.RollbackApplication": [
            {
                "action": "kinesisanalytics:RollbackApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "Kendra.BatchGetDocumentStatus": [
            {
                "action": "kendra:BatchGetDocumentStatus",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "CustomerProfiles.MergeProfiles": [
            {
                "action": "profile:MergeProfiles",
                "resource_mappings": {}
            }
        ],
        "MediaPackageVod.ConfigureLogs": [
            {
                "action": "mediapackage-vod:ConfigureLogs",
                "resource_mappings": {
                    "PackagingGroupIdentifier": {
                        "template": "${Id}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.DescribeSecurityGroupRules": [
            {
                "action": "ec2:DescribeSecurityGroupRules",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifySecurityGroupRules": [
            {
                "action": "ec2:ModifySecurityGroupRules",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "${GroupId}"
                    },
                    "PrefixListId": {
                        "template": "${SecurityGroupRules[].SecurityGroupRule.PrefixListId}"
                    },
                    "SecurityGroupRuleId": {
                        "template": "${SecurityGroupRules[].SecurityGroupRuleId}"
                    }
                }
            }
        ],
        "DocDB.CreateEventSubscription": [
            {
                "action": "rds:CreateEventSubscription",
                "resource_mappings": {
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    }
                }
            },
            {
                "action": "rds:AddTagsToResource",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "*"
                    },
                    "SubscriptionName": {
                        "template": "${SubscriptionName}"
                    },
                    "OptionGroupName": {
                        "template": "*"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "DbProxyId": {
                        "template": "*"
                    },
                    "DbProxyEndpointId": {
                        "template": "*"
                    },
                    "ReservedDbInstanceName": {
                        "template": "*"
                    },
                    "SecurityGroupName": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    },
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DocDB.CreateGlobalCluster": [
            {
                "action": "rds:CreateGlobalCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${SourceDBClusterIdentifier}"
                    },
                    "GlobalCluster": {
                        "template": "${GlobalClusterIdentifier}"
                    }
                }
            }
        ],
        "DocDB.ModifyGlobalCluster": [
            {
                "action": "rds:ModifyGlobalCluster",
                "resource_mappings": {
                    "GlobalCluster": {
                        "template": "%%many%${GlobalClusterIdentifier}%${NewGlobalClusterIdentifier}%%"
                    }
                }
            }
        ],
        "IoTEventsData.BatchAcknowledgeAlarm": [
            {
                "action": "iotevents:BatchAcknowledgeAlarm",
                "resource_mappings": {
                    "inputName": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTEventsData.BatchDisableAlarm": [
            {
                "action": "iotevents:BatchDisableAlarm",
                "resource_mappings": {
                    "inputName": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTEventsData.BatchEnableAlarm": [
            {
                "action": "iotevents:BatchEnableAlarm",
                "resource_mappings": {
                    "inputName": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTEventsData.BatchResetAlarm": [
            {
                "action": "iotevents:BatchResetAlarm",
                "resource_mappings": {
                    "inputName": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTEventsData.BatchSnoozeAlarm": [
            {
                "action": "iotevents:BatchSnoozeAlarm",
                "resource_mappings": {
                    "inputName": {
                        "template": "*"
                    }
                }
            }
        ],
        "ForecastService.DeleteResourceTree": [
            {
                "action": "forecast:DeleteResourceTree",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "%%iftemplatematch%${ResourceArn}%%",
                    "datasetGroup": "%%iftemplatematch%${ResourceArn}%%",
                    "datasetImportJob": "%%iftemplatematch%${ResourceArn}%%",
                    "forecast": "%%iftemplatematch%${ResourceArn}%%",
                    "forecastExport": "%%iftemplatematch%${ResourceArn}%%",
                    "predictor": "%%iftemplatematch%${ResourceArn}%%",
                    "predictorBacktestExportJob": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "ForecastService.StopResource": [
            {
                "action": "forecast:StopResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datasetImportJob": "%%iftemplatematch%${ResourceArn}%%",
                    "forecast": "%%iftemplatematch%${ResourceArn}%%",
                    "forecastExport": "%%iftemplatematch%${ResourceArn}%%",
                    "predictor": "%%iftemplatematch%${ResourceArn}%%",
                    "predictorBacktestExportJob": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "SESV2.CreateCustomVerificationEmailTemplate": [
            {
                "action": "ses:CreateCustomVerificationEmailTemplate",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ses:CreateCustomVerificationEmailTemplate",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.CreateEmailIdentityPolicy": [
            {
                "action": "ses:CreateEmailIdentityPolicy",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.DeleteEmailIdentityPolicy": [
            {
                "action": "ses:DeleteEmailIdentityPolicy",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.GetEmailIdentityPolicies": [
            {
                "action": "ses:GetEmailIdentityPolicies",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.PutEmailIdentityConfigurationSetAttributes": [
            {
                "action": "ses:PutEmailIdentityConfigurationSetAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    },
                    "ConfigurationSetName": {
                        "template": "${ConfigurationSetName}"
                    }
                }
            }
        ],
        "SESV2.PutEmailIdentityDkimSigningAttributes": [
            {
                "action": "ses:PutEmailIdentityDkimSigningAttributes",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "SESV2.UpdateEmailIdentityPolicy": [
            {
                "action": "ses:UpdateEmailIdentityPolicy",
                "resource_mappings": {
                    "IdentityName": {
                        "template": "*"
                    }
                }
            }
        ],
        "ComputeOptimizer.ExportLambdaFunctionRecommendations": [
            {
                "action": "compute-optimizer:ExportLambdaFunctionRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "compute-optimizer:GetLambdaFunctionRecommendations",
                "resource_mappings": {}
            },
            {
                "action": "lambda:ListFunctions",
                "resource_mappings": {}
            },
            {
                "action": "lambda:ListProvisionedConcurrencyConfigs",
                "resource_mappings": {
                    "FunctionName": {
                        "template": "*"
                    }
                }
            }
        ],
        "ServiceCatalogAppRegistry.UpdateApplication": [
            {
                "action": "servicecatalog:UpdateApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "HealthLake.ListFHIRExportJobs": [
            {
                "action": "healthlake:ListFHIRExportJobs",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatastoreId": {
                        "template": "${DatastoreId}"
                    }
                }
            }
        ],
        "HealthLake.ListFHIRImportJobs": [
            {
                "action": "healthlake:ListFHIRImportJobs",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "DatastoreId": {
                        "template": "${DatastoreId}"
                    }
                }
            }
        ],
        "HealthLake.ListTagsForResource": [
            {
                "action": "healthlake:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datastore": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "HealthLake.TagResource": [
            {
                "action": "healthlake:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datastore": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "HealthLake.UntagResource": [
            {
                "action": "healthlake:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datastore": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "LexModelsV2.CreateExport": [
            {
                "action": "lex:CreateExport",
                "resource_mappings": {
                    "BotId": {
                        "template": "%%many%${resourceSpecification.botExportSpecification.botId}%${resourceSpecification.botLocaleExportSpecification.botId}%%"
                    }
                }
            }
        ],
        "LexModelsV2.CreateResourcePolicy": [
            {
                "action": "lex:CreateResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceArn}%%",
                    "bot alias": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "LexModelsV2.DeleteExport": [
            {
                "action": "lex:DeleteExport",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteImport": [
            {
                "action": "lex:DeleteImport",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteResourcePolicy": [
            {
                "action": "lex:DeleteResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceArn}%%",
                    "bot alias": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "LexModelsV2.DescribeExport": [
            {
                "action": "lex:DescribeExport",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:DescribeBot",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:DescribeBotLocale",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:DescribeIntent",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:DescribeSlot",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:DescribeSlotType",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:ListBotLocales",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:ListIntents",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:ListSlotTypes",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "lex:ListSlots",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeImport": [
            {
                "action": "lex:DescribeImport",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeResourcePolicy": [
            {
                "action": "lex:DescribeResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceArn}%%",
                    "bot alias": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "LexModelsV2.UpdateExport": [
            {
                "action": "lex:UpdateExport",
                "resource_mappings": {
                    "BotId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.UpdateResourcePolicy": [
            {
                "action": "lex:UpdateResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "bot": "%%iftemplatematch%${resourceArn}%%",
                    "bot alias": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Proton.AcceptEnvironmentAccountConnection": [
            {
                "action": "proton:AcceptEnvironmentAccountConnection",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Proton.CreateEnvironmentAccountConnection": [
            {
                "action": "proton:CreateEnvironmentAccountConnection",
                "resource_mappings": {}
            }
        ],
        "Proton.CreateEnvironmentTemplateVersion": [
            {
                "action": "proton:CreateEnvironmentTemplateVersion",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Proton.CreateServiceTemplateVersion": [
            {
                "action": "proton:CreateServiceTemplateVersion",
                "resource_mappings": {
                    "Name": {
                        "template": "${templateName}"
                    }
                }
            }
        ],
        "Proton.DeleteEnvironmentAccountConnection": [
            {
                "action": "proton:DeleteEnvironmentAccountConnection",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Proton.GetEnvironmentAccountConnection": [
            {
                "action": "proton:GetEnvironmentAccountConnection",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Proton.RejectEnvironmentAccountConnection": [
            {
                "action": "proton:RejectEnvironmentAccountConnection",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Proton.UpdateEnvironmentAccountConnection": [
            {
                "action": "proton:UpdateEnvironmentAccountConnection",
                "resource_mappings": {
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "Lightsail.CreateBucket": [
            {
                "action": "lightsail:CreateBucket",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.CreateBucketAccessKey": [
            {
                "action": "lightsail:CreateBucketAccessKey",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteBucket": [
            {
                "action": "lightsail:DeleteBucket",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.DeleteBucketAccessKey": [
            {
                "action": "lightsail:DeleteBucketAccessKey",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.GetBucketAccessKeys": [
            {
                "action": "lightsail:GetBucketAccessKeys",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetBucketBundles": [
            {
                "action": "lightsail:GetBucketBundles",
                "resource_mappings": {}
            }
        ],
        "Lightsail.GetBuckets": [
            {
                "action": "lightsail:GetBuckets",
                "resource_mappings": {}
            }
        ],
        "Lightsail.SetResourceAccessForBucket": [
            {
                "action": "lightsail:SetResourceAccessForBucket",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.UpdateBucket": [
            {
                "action": "lightsail:UpdateBucket",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Lightsail.UpdateBucketBundle": [
            {
                "action": "lightsail:UpdateBucketBundle",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "Redshift.CreateAuthenticationProfile": [
            {
                "action": "redshift:CreateAuthenticationProfile",
                "resource_mappings": {}
            }
        ],
        "Redshift.DeleteAuthenticationProfile": [
            {
                "action": "redshift:DeleteAuthenticationProfile",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeAuthenticationProfiles": [
            {
                "action": "redshift:DescribeAuthenticationProfiles",
                "resource_mappings": {}
            }
        ],
        "Redshift.ModifyAuthenticationProfile": [
            {
                "action": "redshift:ModifyAuthenticationProfile",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetMigration": [
            {
                "action": "lex:GetMigration",
                "resource_mappings": {}
            }
        ],
        "LexModelBuildingService.GetMigrations": [
            {
                "action": "lex:GetMigrations",
                "resource_mappings": {}
            }
        ],
        "Kendra.DeletePrincipalMapping": [
            {
                "action": "kendra:DeletePrincipalMapping",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "Kendra.DescribePrincipalMapping": [
            {
                "action": "kendra:DescribePrincipalMapping",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "Kendra.ListGroupsOlderThanOrderingId": [
            {
                "action": "kendra:ListGroupsOlderThanOrderingId",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "Kendra.PutPrincipalMapping": [
            {
                "action": "kendra:PutPrincipalMapping",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "DataSourceId": {
                        "template": "${DataSourceId}"
                    }
                }
            }
        ],
        "QuickSight.CreateFolder": [
            {
                "action": "quicksight:CreateFolder",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FolderId}"
                    }
                }
            }
        ],
        "QuickSight.ListFolders": [
            {
                "action": "quicksight:ListFolders",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.DeleteFolder": [
            {
                "action": "quicksight:DeleteFolder",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FolderId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeFolder": [
            {
                "action": "quicksight:DescribeFolder",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FolderId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateFolder": [
            {
                "action": "quicksight:UpdateFolder",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FolderId}"
                    }
                }
            }
        ],
        "CloudFormation.ActivateType": [
            {
                "action": "cloudformation:ActivateType",
                "resource_mappings": {}
            }
        ],
        "CloudFormation.BatchDescribeTypeConfigurations": [
            {
                "action": "cloudformation:BatchDescribeTypeConfigurations",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.GetActionType": [
            {
                "action": "codepipeline:GetActionType",
                "resource_mappings": {}
            }
        ],
        "CodePipeline.UpdateActionType": [
            {
                "action": "codepipeline:UpdateActionType",
                "resource_mappings": {
                    "Owner": {
                        "template": "${actionType.id.owner}"
                    },
                    "Category": {
                        "template": "${actionType.id.category}"
                    },
                    "Provider": {
                        "template": "${actionType.id.provider}"
                    },
                    "Version": {
                        "template": "${actionType.id.version}"
                    }
                }
            }
        ],
        "Lightsail.GetBucketMetricData": [
            {
                "action": "lightsail:GetBucketMetricData",
                "resource_mappings": {}
            }
        ],
        "SSM.UnlabelParameterVersion": [
            {
                "action": "ssm:UnlabelParameterVersion",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Glue.UpdateColumnStatisticsForTable": [
            {
                "action": "glue:UpdateColumnStatisticsForTable",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "Glue.UpdateColumnStatisticsForPartition": [
            {
                "action": "glue:UpdateColumnStatisticsForPartition",
                "resource_mappings": {
                    "DatabaseName": {
                        "template": "${DatabaseName}"
                    },
                    "TableName": {
                        "template": "${TableName}"
                    }
                }
            }
        ],
        "DataSync.UpdateLocationNfs": [
            {
                "action": "datasync:UpdateLocationNfs",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "DataSync.UpdateLocationObjectStorage": [
            {
                "action": "datasync:UpdateLocationObjectStorage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "DataSync.UpdateLocationSmb": [
            {
                "action": "datasync:UpdateLocationSmb",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "location": "${LocationArn}"
                }
            }
        ],
        "WorkMailMessageFlow.PutRawMessageContent": [
            {
                "action": "workmailmessageflow:PutRawMessageContent",
                "resource_mappings": {
                    "OrganizationId": {
                        "template": "*"
                    },
                    "Context": {
                        "template": "*"
                    },
                    "MessageId": {
                        "template": "${messageId}"
                    }
                }
            }
        ],
        "IoTSiteWise.GetInterpolatedAssetPropertyValues": [
            {
                "action": "iotsitewise:GetInterpolatedAssetPropertyValues",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    },
                    "TimeSeriesId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTSiteWise.PutStorageConfiguration": [
            {
                "action": "iotsitewise:PutStorageConfiguration",
                "resource_mappings": {}
            }
        ],
        "LexModelsV2.CreateResourcePolicyStatement": [
            {
                "action": "lex:CreateResourcePolicy",
                "undocumented": true,
                "arn_override": {
                    "template": "${resourceArn}"
                }
            }
        ],
        "LexModelsV2.DeleteResourcePolicyStatement": [
            {
                "action": "lex:DeleteResourcePolicy",
                "undocumented": true,
                "arn_override": {
                    "template": "${resourceArn}"
                }
            }
        ],
        "ElasticBeanstalk.UpdateTagsForResource": [
            {
                "action": "elasticbeanstalk:UpdateTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftemplatematch%${ResourceArn}%%",
                    "applicationversion": "%%iftemplatematch%${ResourceArn}%%",
                    "configurationtemplate": "%%iftemplatematch%${ResourceArn}%%",
                    "environment": "%%iftemplatematch%${ResourceArn}%%",
                    "platform": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AutoScaling.GetPredictiveScalingForecast": [
            {
                "action": "autoscaling:GetPredictiveScalingForecast",
                "resource_mappings": {}
            }
        ],
        "SSM.GetInventory": [
            {
                "action": "ssm:GetInventory",
                "resource_mappings": {}
            }
        ],
        "SSM.GetOpsSummary": [
            {
                "action": "ssm:GetOpsSummary",
                "resource_mappings": {
                    "SyncName": {
                        "template": "${SyncName}"
                    }
                }
            }
        ],
        "SageMaker.Search": [
            {
                "action": "sagemaker:Search",
                "resource_mappings": {}
            }
        ],
        "EMRcontainers.CreateManagedEndpoint": [
            {
                "action": "emr-containers:CreateManagedEndpoint",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${virtualClusterId}"
                    }
                }
            }
        ],
        "EMRcontainers.StartJobRun": [
            {
                "action": "emr-containers:StartJobRun",
                "resource_mappings": {
                    "virtualClusterId": {
                        "template": "${virtualClusterId}"
                    }
                }
            }
        ],
        "IoTEvents.StartDetectorModelAnalysis": [
            {
                "action": "iotevents:StartDetectorModelAnalysis",
                "resource_mappings": {}
            }
        ],
        "EMR.AddInstanceFleet": [
            {
                "action": "elasticmapreduce:AddInstanceFleet",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.AddInstanceGroups": [
            {
                "action": "elasticmapreduce:AddInstanceGroups",
                "resource_mappings": {}
            }
        ],
        "EMR.SetVisibleToAllUsers": [
            {
                "action": "elasticmapreduce:SetVisibleToAllUsers",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:elasticmapreduce:${Region}:${Account}:cluster/${JobFlowIds[]}"
                }
            }
        ],
        "S3Control.CreateAccessPointForObjectLambda": [
            {
                "action": "s3:CreateAccessPointForObjectLambda",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.DeleteAccessPointForObjectLambda": [
            {
                "action": "s3:DeleteAccessPointForObjectLambda",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.DeleteAccessPointPolicyForObjectLambda": [
            {
                "action": "s3:DeleteAccessPointPolicyForObjectLambda",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.DescribeJob": [
            {
                "action": "s3:DescribeJob",
                "resource_mappings": {
                    "JobId": {
                        "template": "${JobId}"
                    }
                }
            }
        ],
        "S3Control.GetAccessPointConfigurationForObjectLambda": [
            {
                "action": "s3:GetAccessPointConfigurationForObjectLambda",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.GetAccessPointForObjectLambda": [
            {
                "action": "s3:GetAccessPointForObjectLambda",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.GetAccessPointPolicyForObjectLambda": [
            {
                "action": "s3:GetAccessPointPolicyForObjectLambda",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.GetAccessPointPolicyStatusForObjectLambda": [
            {
                "action": "s3:GetAccessPointPolicyStatusForObjectLambda",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.ListAccessPointsForObjectLambda": [
            {
                "action": "s3:ListAccessPointsForObjectLambda",
                "resource_mappings": {}
            }
        ],
        "S3Control.ListJobs": [
            {
                "action": "s3:ListJobs",
                "resource_mappings": {}
            }
        ],
        "S3Control.PutAccessPointConfigurationForObjectLambda": [
            {
                "action": "s3:PutAccessPointConfigurationForObjectLambda",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.PutAccessPointPolicyForObjectLambda": [
            {
                "action": "s3:PutAccessPointPolicyForObjectLambda",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "ResourceGroups.PutGroupConfiguration": [
            {
                "action": "resource-groups:PutGroupConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "group": "%%iftemplatematch%${Group}%%"
                }
            }
        ],
        "QuickSight.SearchFolders": [
            {
                "action": "quicksight:SearchFolders",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "S3Control.DeletePublicAccessBlock": [
            {
                "action": "s3:PutAccountPublicAccessBlock",
                "resource_mappings": {}
            }
        ],
        "S3Control.GetPublicAccessBlock": [
            {
                "action": "s3:GetAccountPublicAccessBlock",
                "resource_mappings": {}
            }
        ],
        "S3Control.PutBucketLifecycleConfiguration": [
            {
                "action": "s3-outposts:PutLifecycleConfiguration",
                "undocumented": true
            }
        ],
        "S3Control.PutPublicAccessBlock": [
            {
                "action": "s3:PutAccountPublicAccessBlock",
                "resource_mappings": {}
            }
        ],
        "RDSDataService.BatchExecuteStatement": [
            {
                "action": "rds-data:BatchExecuteStatement",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${resourceArn}"
                }
            }
        ],
        "RDSDataService.ExecuteStatement": [
            {
                "action": "rds-data:ExecuteStatement",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${resourceArn}"
                }
            }
        ],
        "CostExplorer.GetCostAndUsage": [
            {
                "action": "ce:GetCostAndUsage",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetCostAndUsageWithResources": [
            {
                "action": "ce:GetCostAndUsageWithResources",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetCostCategories": [
            {
                "action": "ce:GetCostCategories",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetCostForecast": [
            {
                "action": "ce:GetCostForecast",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetDimensionValues": [
            {
                "action": "ce:GetDimensionValues",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetReservationCoverage": [
            {
                "action": "ce:GetReservationCoverage",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetReservationPurchaseRecommendation": [
            {
                "action": "ce:GetReservationPurchaseRecommendation",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetReservationUtilization": [
            {
                "action": "ce:GetReservationUtilization",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetRightsizingRecommendation": [
            {
                "action": "ce:GetRightsizingRecommendation",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetSavingsPlansCoverage": [
            {
                "action": "ce:GetSavingsPlansCoverage",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetSavingsPlansPurchaseRecommendation": [
            {
                "action": "ce:GetSavingsPlansPurchaseRecommendation",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetSavingsPlansUtilization": [
            {
                "action": "ce:GetSavingsPlansUtilization",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetSavingsPlansUtilizationDetails": [
            {
                "action": "ce:GetSavingsPlansUtilizationDetails",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetTags": [
            {
                "action": "ce:GetTags",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.GetUsageForecast": [
            {
                "action": "ce:GetUsageForecast",
                "resource_mappings": {}
            }
        ],
        "Kendra.Query": [
            {
                "action": "kendra:Query",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "CostExplorer.CreateAnomalyMonitor": [
            {
                "action": "ce:CreateAnomalyMonitor",
                "resource_mappings": {}
            }
        ],
        "CostExplorer.CreateCostCategoryDefinition": [
            {
                "action": "ce:CreateCostCategoryDefinition",
                "resource_mappings": {}
            }
        ],
        "S3.WriteGetObjectResponse": [
            {
                "action": "s3-object-lambda:WriteGetObjectResponse",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudDirectory.GetAppliedSchemaVersion": [
            {
                "action": "clouddirectory:GetAppliedSchemaVersion",
                "undocumented": true,
                "arn_override": {
                    "template": "${SchemaArn}"
                }
            }
        ],
        "CloudDirectory.UpgradeAppliedSchema": [
            {
                "action": "clouddirectory:UpgradeAppliedSchema",
                "undocumented": true
            }
        ],
        "CloudDirectory.UpgradePublishedSchema": [
            {
                "action": "clouddirectory:UpgradePublishedSchema",
                "undocumented": true
            }
        ],
        "LexModelBuildingService.StartMigration": [
            {
                "action": "lex:StartMigration",
                "resource_mappings": {
                    "BotName": {
                        "template": "%%many%${v1BotName}%${v2BotName}%%"
                    },
                    "BotVersion": {
                        "template": "${v1BotVersion}"
                    }
                }
            }
        ],
        "ApiGatewayManagementApi.DeleteConnection": [
            {
                "action": "execute-api:ManageConnections",
                "resource_mappings": {
                    "ApiId": {
                        "template": "*"
                    },
                    "Stage": {
                        "template": "*"
                    },
                    "Method": {
                        "template": "POST"
                    },
                    "ApiSpecificResourcePath": {
                        "template": "@connections"
                    }
                }
            }
        ],
        "ApiGatewayManagementApi.GetConnection": [
            {
                "action": "execute-api:ManageConnections",
                "resource_mappings": {
                    "ApiId": {
                        "template": "*"
                    },
                    "Stage": {
                        "template": "*"
                    },
                    "Method": {
                        "template": "POST"
                    },
                    "ApiSpecificResourcePath": {
                        "template": "@connections"
                    }
                }
            }
        ],
        "ApiGatewayManagementApi.PostToConnection": [
            {
                "action": "execute-api:ManageConnections",
                "resource_mappings": {
                    "ApiId": {
                        "template": "*"
                    },
                    "Stage": {
                        "template": "*"
                    },
                    "Method": {
                        "template": "POST"
                    },
                    "ApiSpecificResourcePath": {
                        "template": "@connections"
                    }
                }
            }
        ],
        "QuickSight.CreateFolderMembership": [
            {
                "action": "quicksight:CreateFolderMembership",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.DeleteFolderMembership": [
            {
                "action": "quicksight:DeleteFolderMembership",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.DescribeFolderPermissions": [
            {
                "action": "quicksight:DescribeFolderPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FolderId}"
                    }
                }
            }
        ],
        "QuickSight.DescribeFolderResolvedPermissions": [
            {
                "action": "quicksight:DescribeFolderResolvedPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FolderId}"
                    }
                }
            }
        ],
        "QuickSight.ListFolderMembers": [
            {
                "action": "quicksight:ListFolderMembers",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FolderId}"
                    }
                }
            }
        ],
        "QuickSight.UpdateFolderPermissions": [
            {
                "action": "quicksight:UpdateFolderPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${FolderId}"
                    }
                }
            }
        ],
        "KinesisAnalyticsV2.UpdateApplicationMaintenanceConfiguration": [
            {
                "action": "kinesisanalytics:UpdateApplicationMaintenanceConfiguration",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${ApplicationName}"
                    }
                }
            }
        ],
        "ServiceDiscovery.UpdateHttpNamespace": [
            {
                "action": "servicediscovery:UpdateHttpNamespace",
                "resource_mappings": {
                    "NamespaceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "LexRuntimeV2.RecognizeUtterance": [
            {
                "action": "lex:RecognizeUtterance",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    },
                    "BotAliasId": {
                        "template": "${botAliasId}"
                    }
                }
            }
        ],
        "S3.DeleteBucketIntelligentTieringConfiguration": [
            {
                "action": "s3:DeleteIntelligentTieringConfiguration",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:s3:::${Bucket}"
                }
            }
        ],
        "S3.ListBucketIntelligentTieringConfigurations": [
            {
                "action": "s3:GetIntelligentTieringConfiguration",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:s3:::${Bucket}"
                }
            }
        ],
        "SageMaker.SendPipelineExecutionStepFailure": [
            {
                "action": "sagemaker:SendPipelineExecutionStepFailure",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "*"
                    },
                    "RandomString": {
                        "template": "*"
                    }
                }
            }
        ],
        "SageMaker.SendPipelineExecutionStepSuccess": [
            {
                "action": "sagemaker:SendPipelineExecutionStepSuccess",
                "resource_mappings": {
                    "PipelineName": {
                        "template": "*"
                    },
                    "RandomString": {
                        "template": "*"
                    }
                }
            }
        ],
        "QuickSight.GenerateEmbedUrlForAnonymousUser": [
            {
                "action": "quicksight:GenerateEmbedUrlForAnonymousUser",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Namespace}"
                    }
                }
            }
        ],
        "QuickSight.GenerateEmbedUrlForRegisteredUser": [
            {
                "action": "quicksight:GenerateEmbedUrlForRegisteredUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "user": "${UserArn}"
                }
            }
        ],
        "RedshiftData.BatchExecuteStatement": [
            {
                "action": "redshift-data:BatchExecuteStatement",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterIdentifier}"
                    }
                }
            }
        ],
        "Location.UpdateGeofenceCollection": [
            {
                "action": "geo:UpdateGeofenceCollection",
                "resource_mappings": {
                    "GeofenceCollectionName": {
                        "template": "${CollectionName}"
                    }
                }
            }
        ],
        "Location.UpdateTracker": [
            {
                "action": "geo:UpdateTracker",
                "resource_mappings": {
                    "TrackerName": {
                        "template": "${TrackerName}"
                    }
                }
            }
        ],
        "CloudFormation.ImportStacksToStackSet": [
            {
                "action": "cloudformation:ImportStacksToStackSet",
                "resource_mappings": {
                    "StackSetName": {
                        "template": "${StackSetName}"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.AssociateInstanceEventWindow": [
            {
                "action": "ec2:AssociateInstanceEventWindow",
                "resource_mappings": {
                    "InstanceEventWindowId": {
                        "template": "${InstanceEventWindowId}"
                    },
                    "DedicatedHostId": {
                        "template": "${AssociationTarget.DedicatedHostIds[]}"
                    },
                    "InstanceId": {
                        "template": "${AssociationTarget.InstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.AssociateTrunkInterface": [
            {
                "action": "ec2:AssociateTrunkInterface",
                "resource_mappings": {}
            }
        ],
        "EC2.CreateInstanceEventWindow": [
            {
                "action": "ec2:CreateInstanceEventWindow",
                "resource_mappings": {
                    "InstanceEventWindowId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateSubnetCidrReservation": [
            {
                "action": "ec2:CreateSubnetCidrReservation",
                "resource_mappings": {}
            }
        ],
        "EC2.DeleteInstanceEventWindow": [
            {
                "action": "ec2:DeleteInstanceEventWindow",
                "resource_mappings": {
                    "InstanceEventWindowId": {
                        "template": "${InstanceEventWindowId}"
                    }
                }
            }
        ],
        "EC2.DeleteSubnetCidrReservation": [
            {
                "action": "ec2:DeleteSubnetCidrReservation",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeInstanceEventWindows": [
            {
                "action": "ec2:DescribeInstanceEventWindows",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeTrunkInterfaceAssociations": [
            {
                "action": "ec2:DescribeTrunkInterfaceAssociations",
                "resource_mappings": {}
            }
        ],
        "EC2.DisassociateInstanceEventWindow": [
            {
                "action": "ec2:DisassociateInstanceEventWindow",
                "resource_mappings": {
                    "InstanceEventWindowId": {
                        "template": "${InstanceEventWindowId}"
                    },
                    "DedicatedHostId": {
                        "template": "${AssociationTarget.DedicatedHostIds[]}"
                    },
                    "InstanceId": {
                        "template": "${AssociationTarget.InstanceIds[]}"
                    }
                }
            }
        ],
        "EC2.DisassociateTrunkInterface": [
            {
                "action": "ec2:DisassociateTrunkInterface",
                "resource_mappings": {}
            }
        ],
        "EC2.GetSubnetCidrReservations": [
            {
                "action": "ec2:GetSubnetCidrReservations",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifyInstanceEventWindow": [
            {
                "action": "ec2:ModifyInstanceEventWindow",
                "resource_mappings": {
                    "InstanceEventWindowId": {
                        "template": "${InstanceEventWindowId}"
                    }
                }
            }
        ],
        "Iot.CreateFleetMetric": [
            {
                "action": "iot:CreateFleetMetric",
                "resource_mappings": {
                    "FleetMetricName": {
                        "template": "${metricName}"
                    },
                    "IndexName": {
                        "template": "${indexName}"
                    }
                }
            }
        ],
        "Iot.DeleteFleetMetric": [
            {
                "action": "iot:DeleteFleetMetric",
                "resource_mappings": {
                    "FleetMetricName": {
                        "template": "${metricName}"
                    }
                }
            }
        ],
        "Iot.DescribeFleetMetric": [
            {
                "action": "iot:DescribeFleetMetric",
                "resource_mappings": {
                    "FleetMetricName": {
                        "template": "${metricName}"
                    }
                }
            }
        ],
        "Iot.GetBucketsAggregation": [
            {
                "action": "iot:GetBucketsAggregation",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${indexName}"
                    }
                }
            }
        ],
        "Iot.ListFleetMetrics": [
            {
                "action": "iot:ListFleetMetrics",
                "resource_mappings": {}
            }
        ],
        "Iot.UpdateFleetMetric": [
            {
                "action": "iot:UpdateFleetMetric",
                "resource_mappings": {
                    "FleetMetricName": {
                        "template": "${metricName}"
                    },
                    "IndexName": {
                        "template": "${indexName}"
                    }
                }
            }
        ],
        "IotData.GetRetainedMessage": [
            {
                "action": "iot:GetRetainedMessage",
                "resource_mappings": {
                    "TopicName": {
                        "template": "${topic}"
                    }
                }
            }
        ],
        "IotData.ListRetainedMessages": [
            {
                "action": "iot:ListRetainedMessages",
                "resource_mappings": {}
            }
        ],
        "Redshift.AssociateDataShareConsumer": [
            {
                "action": "redshift:AssociateDataShareConsumer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datashare": "${DataShareArn}"
                }
            }
        ],
        "Redshift.AuthorizeDataShare": [
            {
                "action": "redshift:AuthorizeDataShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datashare": "${DataShareArn}"
                }
            }
        ],
        "Redshift.DeauthorizeDataShare": [
            {
                "action": "redshift:DeauthorizeDataShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datashare": "${DataShareArn}"
                }
            }
        ],
        "Redshift.DescribeDataShares": [
            {
                "action": "redshift:DescribeDataShares",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeDataSharesForConsumer": [
            {
                "action": "redshift:DescribeDataSharesForConsumer",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeDataSharesForProducer": [
            {
                "action": "redshift:DescribeDataSharesForProducer",
                "resource_mappings": {}
            }
        ],
        "Redshift.DisassociateDataShareConsumer": [
            {
                "action": "redshift:DisassociateDataShareConsumer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datashare": "${DataShareArn}"
                }
            }
        ],
        "Redshift.RejectDataShare": [
            {
                "action": "redshift:RejectDataShare",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "datashare": "${DataShareArn}"
                }
            }
        ],
        "TranscribeService.CreateCallAnalyticsCategory": [
            {
                "action": "transcribe:CreateCallAnalyticsCategory",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.DeleteCallAnalyticsCategory": [
            {
                "action": "transcribe:DeleteCallAnalyticsCategory",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.DeleteCallAnalyticsJob": [
            {
                "action": "transcribe:DeleteCallAnalyticsJob",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.GetCallAnalyticsCategory": [
            {
                "action": "transcribe:GetCallAnalyticsCategory",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.GetCallAnalyticsJob": [
            {
                "action": "transcribe:GetCallAnalyticsJob",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.ListCallAnalyticsCategories": [
            {
                "action": "transcribe:ListCallAnalyticsCategories",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.ListCallAnalyticsJobs": [
            {
                "action": "transcribe:ListCallAnalyticsJobs",
                "resource_mappings": {}
            }
        ],
        "TranscribeService.StartCallAnalyticsJob": [
            {
                "action": "transcribe:StartCallAnalyticsJob",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "TranscribeService.UpdateCallAnalyticsCategory": [
            {
                "action": "transcribe:UpdateCallAnalyticsCategory",
                "resource_mappings": {}
            }
        ],
        "Connect.CreateAgentStatus": [
            {
                "action": "connect:CreateAgentStatus",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "AgentStatusId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.CreateHoursOfOperation": [
            {
                "action": "connect:CreateHoursOfOperation",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HoursOfOperationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.DeleteHoursOfOperation": [
            {
                "action": "connect:DeleteHoursOfOperation",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HoursOfOperationId": {
                        "template": "${HoursOfOperationId}"
                    }
                }
            }
        ],
        "Connect.DescribeAgentStatus": [
            {
                "action": "connect:DescribeAgentStatus",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "AgentStatusId": {
                        "template": "${AgentStatusId}"
                    }
                }
            }
        ],
        "Connect.ListAgentStatuses": [
            {
                "action": "connect:ListAgentStatuses",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.UpdateAgentStatus": [
            {
                "action": "connect:UpdateAgentStatus",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "AgentStatusId": {
                        "template": "${AgentStatusId}"
                    }
                }
            }
        ],
        "Connect.UpdateHoursOfOperation": [
            {
                "action": "connect:UpdateHoursOfOperation",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "HoursOfOperationId": {
                        "template": "${HoursOfOperationId}"
                    }
                }
            }
        ],
        "FSx.CreateStorageVirtualMachine": [
            {
                "action": "fsx:CreateStorageVirtualMachine",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    },
                    "StorageVirtualMachineId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "fsx:TagResource",
                "resource_mappings": {
                    "BackupId": {
                        "template": "*"
                    },
                    "FileSystemId": {
                        "template": "*"
                    },
                    "StorageVirtualMachineId": {
                        "template": "*"
                    },
                    "TaskId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            }
        ],
        "FSx.CreateVolume": [
            {
                "action": "fsx:CreateVolume",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "fsx:TagResource",
                "resource_mappings": {
                    "BackupId": {
                        "template": "*"
                    },
                    "FileSystemId": {
                        "template": "*"
                    },
                    "StorageVirtualMachineId": {
                        "template": "*"
                    },
                    "TaskId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            }
        ],
        "FSx.CreateVolumeFromBackup": [
            {
                "action": "fsx:CreateVolumeFromBackup",
                "resource_mappings": {
                    "BackupId": {
                        "template": "${BackupId}"
                    },
                    "FileSystemId": {
                        "template": "*"
                    },
                    "StorageVirtualMachineId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "fsx:TagResource",
                "resource_mappings": {
                    "BackupId": {
                        "template": "*"
                    },
                    "FileSystemId": {
                        "template": "*"
                    },
                    "StorageVirtualMachineId": {
                        "template": "*"
                    },
                    "TaskId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            }
        ],
        "FSx.DeleteStorageVirtualMachine": [
            {
                "action": "fsx:DeleteStorageVirtualMachine",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "*"
                    },
                    "StorageVirtualMachineId": {
                        "template": "${StorageVirtualMachineId}"
                    }
                }
            }
        ],
        "FSx.DeleteVolume": [
            {
                "action": "fsx:DeleteVolume",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "${VolumeId}"
                    }
                }
            }
        ],
        "FSx.DescribeStorageVirtualMachines": [
            {
                "action": "fsx:DescribeStorageVirtualMachines",
                "resource_mappings": {}
            }
        ],
        "FSx.DescribeVolumes": [
            {
                "action": "fsx:DescribeVolumes",
                "resource_mappings": {}
            }
        ],
        "FSx.UpdateStorageVirtualMachine": [
            {
                "action": "fsx:UpdateStorageVirtualMachine",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "*"
                    },
                    "StorageVirtualMachineId": {
                        "template": "${StorageVirtualMachineId}"
                    }
                }
            }
        ],
        "FSx.UpdateVolume": [
            {
                "action": "fsx:UpdateVolume",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "${VolumeId}"
                    }
                }
            }
        ],
        "Backup.CreateFramework": [
            {
                "action": "backup:CreateFramework",
                "resource_mappings": {
                    "FrameworkName": {
                        "template": "${FrameworkName}"
                    },
                    "FrameworkId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.CreateReportPlan": [
            {
                "action": "backup:CreateReportPlan",
                "resource_mappings": {
                    "ReportPlanName": {
                        "template": "${ReportPlanName}"
                    },
                    "ReportPlanId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.DeleteFramework": [
            {
                "action": "backup:DeleteFramework",
                "resource_mappings": {
                    "FrameworkName": {
                        "template": "${FrameworkName}"
                    },
                    "FrameworkId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.DeleteReportPlan": [
            {
                "action": "backup:DeleteReportPlan",
                "resource_mappings": {
                    "ReportPlanName": {
                        "template": "${ReportPlanName}"
                    },
                    "ReportPlanId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.DescribeFramework": [
            {
                "action": "backup:DescribeFramework",
                "resource_mappings": {
                    "FrameworkName": {
                        "template": "${FrameworkName}"
                    },
                    "FrameworkId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.DescribeReportJob": [
            {
                "action": "backup:DescribeReportJob",
                "resource_mappings": {}
            }
        ],
        "Backup.DescribeReportPlan": [
            {
                "action": "backup:DescribeReportPlan",
                "resource_mappings": {
                    "ReportPlanName": {
                        "template": "${ReportPlanName}"
                    },
                    "ReportPlanId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.ListFrameworks": [
            {
                "action": "backup:ListFrameworks",
                "resource_mappings": {}
            }
        ],
        "Backup.ListReportJobs": [
            {
                "action": "backup:ListReportJobs",
                "resource_mappings": {}
            }
        ],
        "Backup.ListReportPlans": [
            {
                "action": "backup:ListReportPlans",
                "resource_mappings": {}
            }
        ],
        "Backup.StartReportJob": [
            {
                "action": "backup:StartReportJob",
                "resource_mappings": {
                    "ReportPlanName": {
                        "template": "${ReportPlanName}"
                    },
                    "ReportPlanId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.UpdateFramework": [
            {
                "action": "backup:UpdateFramework",
                "resource_mappings": {
                    "FrameworkName": {
                        "template": "${FrameworkName}"
                    },
                    "FrameworkId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Backup.UpdateReportPlan": [
            {
                "action": "backup:UpdateReportPlan",
                "resource_mappings": {
                    "ReportPlanName": {
                        "template": "${ReportPlanName}"
                    },
                    "ReportPlanId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ComputeOptimizer.GetEnrollmentStatusesForOrganization": [
            {
                "action": "compute-optimizer:GetEnrollmentStatusesForOrganization",
                "resource_mappings": {}
            }
        ],
        "ServiceCatalogAppRegistry.GetAssociatedResource": [
            {
                "action": "servicecatalog:GetAssociatedResource",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "MemoryDB.CopySnapshot": [
            {
                "action": "memorydb:CopySnapshot",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "%%many%${SourceSnapshotName}%${TargetSnapshotName}%%"
                    }
                }
            },
            {
                "action": "memorydb:TagResource",
                "resource_mappings": {
                    "AclName": {
                        "template": "*"
                    },
                    "ClusterName": {
                        "template": "*"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    },
                    "UserName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:DeleteObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:GetBucketAcl",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MemoryDB.CreateACL": [
            {
                "action": "memorydb:CreateAcl",
                "resource_mappings": {
                    "UserName": {
                        "template": "${UserNames[]}"
                    }
                }
            },
            {
                "action": "memorydb:TagResource",
                "resource_mappings": {
                    "AclName": {
                        "template": "*"
                    },
                    "ClusterName": {
                        "template": "*"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    },
                    "UserName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MemoryDB.CreateCluster": [
            {
                "action": "memorydb:CreateCluster",
                "resource_mappings": {
                    "AclName": {
                        "template": "${ACLName}"
                    },
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    },
                    "SubnetGroupName": {
                        "template": "${SubnetGroupName}"
                    }
                },
                "resourcearn_mappings": {
                    "snapshot": "${SnapshotArns[]}"
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeNetworkInterfaces",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            },
            {
                "action": "memorydb:TagResource",
                "resource_mappings": {
                    "AclName": {
                        "template": "*"
                    },
                    "ClusterName": {
                        "template": "*"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    },
                    "UserName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MemoryDB.CreateParameterGroup": [
            {
                "action": "memorydb:CreateParameterGroup",
                "resource_mappings": {}
            },
            {
                "action": "memorydb:TagResource",
                "resource_mappings": {
                    "AclName": {
                        "template": "*"
                    },
                    "ClusterName": {
                        "template": "*"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    },
                    "UserName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MemoryDB.CreateSnapshot": [
            {
                "action": "memorydb:CreateSnapshot",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    }
                }
            },
            {
                "action": "memorydb:TagResource",
                "resource_mappings": {
                    "AclName": {
                        "template": "*"
                    },
                    "ClusterName": {
                        "template": "*"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    },
                    "UserName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:DeleteObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:GetBucketAcl",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MemoryDB.CreateSubnetGroup": [
            {
                "action": "memorydb:CreateSubnetGroup",
                "resource_mappings": {}
            },
            {
                "action": "memorydb:TagResource",
                "resource_mappings": {
                    "AclName": {
                        "template": "*"
                    },
                    "ClusterName": {
                        "template": "*"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    },
                    "UserName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MemoryDB.CreateUser": [
            {
                "action": "memorydb:CreateUser",
                "resource_mappings": {}
            },
            {
                "action": "memorydb:TagResource",
                "resource_mappings": {
                    "AclName": {
                        "template": "*"
                    },
                    "ClusterName": {
                        "template": "*"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    },
                    "UserName": {
                        "template": "*"
                    }
                }
            }
        ],
        "MemoryDB.DeleteACL": [
            {
                "action": "memorydb:DeleteAcl",
                "resource_mappings": {
                    "AclName": {
                        "template": "${ACLName}"
                    }
                }
            }
        ],
        "MemoryDB.DeleteCluster": [
            {
                "action": "memorydb:DeleteCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    },
                    "SnapshotName": {
                        "template": "${FinalSnapshotName}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeNetworkInterfaces",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "MemoryDB.DeleteParameterGroup": [
            {
                "action": "memorydb:DeleteParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "MemoryDB.DeleteSnapshot": [
            {
                "action": "memorydb:DeleteSnapshot",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${SnapshotName}"
                    }
                }
            }
        ],
        "MemoryDB.DeleteSubnetGroup": [
            {
                "action": "memorydb:DeleteSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${SubnetGroupName}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeNetworkInterfaces",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "MemoryDB.DeleteUser": [
            {
                "action": "memorydb:DeleteUser",
                "resource_mappings": {
                    "UserName": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "MemoryDB.DescribeACLs": [
            {
                "action": "memorydb:DescribeAcls",
                "resource_mappings": {
                    "AclName": {
                        "template": "${ACLName}"
                    }
                }
            }
        ],
        "MemoryDB.DescribeClusters": [
            {
                "action": "memorydb:DescribeClusters",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    }
                }
            }
        ],
        "MemoryDB.DescribeEngineVersions": [
            {
                "action": "memorydb:DescribeEngineVersions",
                "resource_mappings": {}
            }
        ],
        "MemoryDB.DescribeEvents": [
            {
                "action": "memorydb:DescribeEvents",
                "resource_mappings": {}
            }
        ],
        "MemoryDB.DescribeParameterGroups": [
            {
                "action": "memorydb:DescribeParameterGroups",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "MemoryDB.DescribeParameters": [
            {
                "action": "memorydb:DescribeParameters",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "MemoryDB.DescribeServiceUpdates": [
            {
                "action": "memorydb:DescribeServiceUpdates",
                "resource_mappings": {}
            }
        ],
        "MemoryDB.DescribeSnapshots": [
            {
                "action": "memorydb:DescribeSnapshots",
                "resource_mappings": {
                    "SnapshotName": {
                        "template": "${SnapshotName}"
                    }
                }
            }
        ],
        "MemoryDB.DescribeSubnetGroups": [
            {
                "action": "memorydb:DescribeSubnetGroups",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${SubnetGroupName}"
                    }
                }
            }
        ],
        "MemoryDB.DescribeUsers": [
            {
                "action": "memorydb:DescribeUsers",
                "resource_mappings": {
                    "UserName": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "MemoryDB.FailoverShard": [
            {
                "action": "memorydb:FailoverShard",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeNetworkInterfaces",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "MemoryDB.ListTags": [
            {
                "action": "memorydb:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "acl": "%%iftemplatematch%${ResourceArn}%%",
                    "cluster": "%%iftemplatematch%${ResourceArn}%%",
                    "parametergroup": "%%iftemplatematch%${ResourceArn}%%",
                    "snapshot": "%%iftemplatematch%${ResourceArn}%%",
                    "subnetgroup": "%%iftemplatematch%${ResourceArn}%%",
                    "user": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MemoryDB.ResetParameterGroup": [
            {
                "action": "memorydb:ResetParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "MemoryDB.TagResource": [
            {
                "action": "memorydb:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "acl": "%%iftemplatematch%${ResourceArn}%%",
                    "cluster": "%%iftemplatematch%${ResourceArn}%%",
                    "parametergroup": "%%iftemplatematch%${ResourceArn}%%",
                    "snapshot": "%%iftemplatematch%${ResourceArn}%%",
                    "subnetgroup": "%%iftemplatematch%${ResourceArn}%%",
                    "user": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MemoryDB.UntagResource": [
            {
                "action": "memorydb:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "acl": "%%iftemplatematch%${ResourceArn}%%",
                    "cluster": "%%iftemplatematch%${ResourceArn}%%",
                    "parametergroup": "%%iftemplatematch%${ResourceArn}%%",
                    "snapshot": "%%iftemplatematch%${ResourceArn}%%",
                    "subnetgroup": "%%iftemplatematch%${ResourceArn}%%",
                    "user": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "MemoryDB.UpdateACL": [
            {
                "action": "memorydb:UpdateAcl",
                "resource_mappings": {
                    "AclName": {
                        "template": "${ACLName}"
                    },
                    "UserName": {
                        "template": "%%many%${UserNamesToAdd[]}%${UserNamesToRemove[]}%%"
                    }
                }
            }
        ],
        "MemoryDB.UpdateCluster": [
            {
                "action": "memorydb:UpdateCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${ClusterName}"
                    },
                    "AclName": {
                        "template": "${ACLName}"
                    },
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeNetworkInterfaces",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "MemoryDB.UpdateParameterGroup": [
            {
                "action": "memorydb:UpdateParameterGroup",
                "resource_mappings": {
                    "ParameterGroupName": {
                        "template": "${ParameterGroupName}"
                    }
                }
            }
        ],
        "MemoryDB.UpdateSubnetGroup": [
            {
                "action": "memorydb:UpdateSubnetGroup",
                "resource_mappings": {
                    "SubnetGroupName": {
                        "template": "${SubnetGroupName}"
                    }
                }
            }
        ],
        "EMR.DescribeReleaseLabel": [
            {
                "action": "elasticmapreduce:DescribeReleaseLabel",
                "resource_mappings": {}
            }
        ],
        "EMR.GetAutoTerminationPolicy": [
            {
                "action": "elasticmapreduce:GetAutoTerminationPolicy",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.ListReleaseLabels": [
            {
                "action": "elasticmapreduce:ListReleaseLabels",
                "resource_mappings": {}
            }
        ],
        "EMR.PutAutoTerminationPolicy": [
            {
                "action": "elasticmapreduce:PutAutoTerminationPolicy",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "EMR.RemoveAutoTerminationPolicy": [
            {
                "action": "elasticmapreduce:RemoveAutoTerminationPolicy",
                "resource_mappings": {
                    "ClusterId": {
                        "template": "${ClusterId}"
                    }
                }
            }
        ],
        "Glue.CreateBlueprint": [
            {
                "action": "glue:CreateBlueprint",
                "resource_mappings": {}
            }
        ],
        "Glue.DeleteBlueprint": [
            {
                "action": "glue:DeleteBlueprint",
                "resource_mappings": {
                    "BlueprintName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Glue.GetBlueprint": [
            {
                "action": "glue:GetBlueprint",
                "resource_mappings": {
                    "BlueprintName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "Glue.GetBlueprintRun": [
            {
                "action": "glue:GetBlueprintRun",
                "resource_mappings": {
                    "BlueprintName": {
                        "template": "${BlueprintName}"
                    }
                }
            }
        ],
        "Glue.GetBlueprintRuns": [
            {
                "action": "glue:GetBlueprintRuns",
                "resource_mappings": {
                    "BlueprintName": {
                        "template": "${BlueprintName}"
                    }
                }
            }
        ],
        "Glue.StartBlueprintRun": [
            {
                "action": "glue:StartBlueprintRun",
                "resource_mappings": {
                    "BlueprintName": {
                        "template": "${BlueprintName}"
                    }
                }
            }
        ],
        "Glue.UpdateBlueprint": [
            {
                "action": "glue:UpdateBlueprint",
                "resource_mappings": {
                    "BlueprintName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "SageMakerRuntime.InvokeEndpointAsync": [
            {
                "action": "sagemaker:InvokeEndpointAsync",
                "resource_mappings": {
                    "EndpointName": {
                        "template": "${EndpointName}"
                    }
                }
            }
        ],
        "Transfer.CreateWorkflow": [
            {
                "action": "transfer:CreateWorkflow",
                "resource_mappings": {}
            }
        ],
        "Transfer.DeleteWorkflow": [
            {
                "action": "transfer:DeleteWorkflow",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "workflowId": {
                        "template": "${WorkflowId}"
                    }
                }
            }
        ],
        "Transfer.DescribeExecution": [
            {
                "action": "transfer:DescribeExecution",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "workflowId": {
                        "template": "${WorkflowId}"
                    }
                }
            }
        ],
        "Transfer.DescribeWorkflow": [
            {
                "action": "transfer:DescribeWorkflow",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "workflowId": {
                        "template": "${WorkflowId}"
                    }
                }
            }
        ],
        "Transfer.ListExecutions": [
            {
                "action": "transfer:ListExecutions",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "workflowId": {
                        "template": "${WorkflowId}"
                    }
                }
            }
        ],
        "Transfer.ListWorkflows": [
            {
                "action": "transfer:ListWorkflows",
                "resource_mappings": {}
            }
        ],
        "Transfer.SendWorkflowStepState": [
            {
                "action": "transfer:SendWorkflowStepState",
                "resource_mappings": {
                    "region": {
                        "template": "${Region}"
                    },
                    "account": {
                        "template": "${Account}"
                    },
                    "workflowId": {
                        "template": "${WorkflowId}"
                    }
                }
            }
        ],
        "Location.UpdateMap": [
            {
                "action": "geo:UpdateMap",
                "resource_mappings": {
                    "MapName": {
                        "template": "${MapName}"
                    }
                }
            }
        ],
        "Location.UpdatePlaceIndex": [
            {
                "action": "geo:UpdatePlaceIndex",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "Location.UpdateRouteCalculator": [
            {
                "action": "geo:UpdateRouteCalculator",
                "resource_mappings": {
                    "CalculatorName": {
                        "template": "${CalculatorName}"
                    }
                }
            }
        ],
        "MemoryDB.BatchUpdateCluster": [
            {
                "action": "memorydb:BatchUpdateCluster",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:memorydb:${Region}:${Account}:cluster/*"
                }
            }
        ],
        "MemoryDB.ListAllowedNodeTypeUpdates": [
            {
                "action": "memorydb:ListAllowedNodeTypeUpdates",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:memorydb:${Region}:${Account}:cluster/${clustername}"
                }
            }
        ],
        "Glue.BatchGetBlueprints": [
            {
                "action": "glue:BatchGetBlueprints",
                "resource_mappings": {
                    "BlueprintName": {
                        "template": "${Names[]}"
                    }
                }
            }
        ],
        "Glue.ListBlueprints": [
            {
                "action": "glue:ListBlueprints",
                "resource_mappings": {}
            }
        ],
        "Textract.AnalyzeExpense": [
            {
                "action": "textract:AnalyzeExpense",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${Document.S3Object.Bucket}"
                    },
                    "ObjectName": {
                        "template": "${Document.S3Object.Name}"
                    }
                }
            }
        ],
        "S3Control.CreateMultiRegionAccessPoint": [
            {
                "action": "s3:CreateMultiRegionAccessPoint",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Details.Name}"
                    }
                }
            }
        ],
        "S3Control.DeleteMultiRegionAccessPoint": [
            {
                "action": "s3:DeleteMultiRegionAccessPoint",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Details.Name}"
                    }
                }
            }
        ],
        "S3Control.GetMultiRegionAccessPoint": [
            {
                "action": "s3:GetMultiRegionAccessPoint",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.GetMultiRegionAccessPointPolicy": [
            {
                "action": "s3:GetMultiRegionAccessPointPolicy",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.GetMultiRegionAccessPointPolicyStatus": [
            {
                "action": "s3:GetMultiRegionAccessPointPolicyStatus",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "S3Control.ListMultiRegionAccessPoints": [
            {
                "action": "s3:ListMultiRegionAccessPoints",
                "resource_mappings": {}
            }
        ],
        "S3Control.PutMultiRegionAccessPointPolicy": [
            {
                "action": "s3:PutMultiRegionAccessPointPolicy",
                "resource_mappings": {
                    "AccessPointName": {
                        "template": "${Details.Name}"
                    }
                }
            }
        ],
        "Chime.StartMeetingTranscription": [
            {
                "action": "chime:StartMeetingTranscription",
                "resource_mappings": {}
            }
        ],
        "Chime.StopMeetingTranscription": [
            {
                "action": "chime:StopMeetingTranscription",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.AcceptInboundConnection": [
            {
                "action": "es:AcceptInboundConnection",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.AddTags": [
            {
                "action": "es:AddTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "${ARN}"
                }
            }
        ],
        "OpenSearch.AssociatePackage": [
            {
                "action": "es:AssociatePackage",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.CreateDomain": [
            {
                "action": "es:CreateDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.CreateOutboundConnection": [
            {
                "action": "es:CreateOutboundConnection",
                "resource_mappings": {
                    "DomainName": {
                        "template": "%%many%${LocalDomainInfo.AWSDomainInformation.DomainName}%${RemoteDomainInfo.AWSDomainInformation.DomainName}%%"
                    }
                }
            }
        ],
        "OpenSearch.CreatePackage": [
            {
                "action": "es:CreatePackage",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DeleteDomain": [
            {
                "action": "es:DeleteDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.DeleteInboundConnection": [
            {
                "action": "es:DeleteInboundConnection",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DeleteOutboundConnection": [
            {
                "action": "es:DeleteOutboundConnection",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DeletePackage": [
            {
                "action": "es:DeletePackage",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DescribeDomain": [
            {
                "action": "es:DescribeDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.DescribeDomainConfig": [
            {
                "action": "es:DescribeDomainConfig",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.DescribeDomains": [
            {
                "action": "es:DescribeDomains",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainNames[]}"
                    }
                }
            }
        ],
        "OpenSearch.DescribeInboundConnections": [
            {
                "action": "es:DescribeInboundConnections",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DescribeInstanceTypeLimits": [
            {
                "action": "es:DescribeInstanceTypeLimits",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DescribeOutboundConnections": [
            {
                "action": "es:DescribeOutboundConnections",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DescribePackages": [
            {
                "action": "es:DescribePackages",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DescribeReservedInstanceOfferings": [
            {
                "action": "es:DescribeReservedInstanceOfferings",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DescribeReservedInstances": [
            {
                "action": "es:DescribeReservedInstances",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.DissociatePackage": [
            {
                "action": "es:DissociatePackage",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.GetCompatibleVersions": [
            {
                "action": "es:GetCompatibleVersions",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.GetPackageVersionHistory": [
            {
                "action": "es:GetPackageVersionHistory",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.GetUpgradeHistory": [
            {
                "action": "es:GetUpgradeHistory",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.GetUpgradeStatus": [
            {
                "action": "es:GetUpgradeStatus",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.ListDomainNames": [
            {
                "action": "es:ListDomainNames",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.ListDomainsForPackage": [
            {
                "action": "es:ListDomainsForPackage",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.ListInstanceTypeDetails": [
            {
                "action": "es:ListInstanceTypeDetails",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.ListPackagesForDomain": [
            {
                "action": "es:ListPackagesForDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.ListTags": [
            {
                "action": "es:ListTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "${ARN}"
                }
            }
        ],
        "OpenSearch.ListVersions": [
            {
                "action": "es:ListVersions",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.PurchaseReservedInstanceOffering": [
            {
                "action": "es:PurchaseReservedInstanceOffering",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.RejectInboundConnection": [
            {
                "action": "es:RejectInboundConnection",
                "resource_mappings": {}
            }
        ],
        "OpenSearch.RemoveTags": [
            {
                "action": "es:RemoveTags",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "${ARN}"
                }
            }
        ],
        "OpenSearch.UpdateDomainConfig": [
            {
                "action": "es:UpdateDomainConfig",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.UpdatePackage": [
            {
                "action": "es:UpdatePackage",
                "resource_mappings": {}
            }
        ],
        "CodeBuild.UpdateProjectVisibility": [
            {
                "action": "codebuild:UpdateProjectVisibility",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${projectArn}"
                }
            }
        ],
        "Rekognition.DeleteProjectVersion": [
            {
                "action": "rekognition:DeleteProjectVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "projectversion": "${ProjectVersionArn}"
                }
            }
        ],
        "MemoryDB.UpdateUser": [
            {
                "action": "memorydb:UpdateUser",
                "resource_mappings": {
                    "UserName": {
                        "template": "${UserName}"
                    }
                }
            }
        ],
        "CloudFormation.RollbackStack": [
            {
                "action": "cloudformation:RollbackStack",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:cloudformation:${Region}:${Account}:stack/${StackName}/*"
                }
            }
        ],
        "Pinpoint.CreateInAppTemplate": [
            {
                "action": "mobiletargeting:CreateInAppTemplate",
                "resource_mappings": {}
            }
        ],
        "Pinpoint.DeleteInAppTemplate": [
            {
                "action": "mobiletargeting:DeleteInAppTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.GetInAppMessages": [
            {
                "action": "mobiletargeting:GetInAppMessages",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "Pinpoint.GetInAppTemplate": [
            {
                "action": "mobiletargeting:GetInAppTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "Pinpoint.UpdateInAppTemplate": [
            {
                "action": "mobiletargeting:UpdateInAppTemplate",
                "resource_mappings": {
                    "TemplateName": {
                        "template": "${TemplateName}"
                    },
                    "ChannelType": {
                        "template": "*"
                    }
                }
            }
        ],
        "SageMaker.DeleteStudioLifecycleConfig": [
            {
                "action": "sagemaker:DeleteStudioLifecycleConfig",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:sagemaker:${Region}:${Account}:studio-lifecycle-config/${studiolifecycleconfigname}"
                }
            }
        ],
        "SageMaker.DescribeStudioLifecycleConfig": [
            {
                "action": "sagemaker:DescribeStudioLifecycleConfig",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:sagemaker:${Region}:${Account}:studio-lifecycle-config/${studiolifecycleconfigname}"
                }
            }
        ],
        "SageMaker.ListStudioLifecycleConfigs": [
            {
                "action": "sagemaker:ListStudioLifecycleConfigs",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:sagemaker:${Region}:${Account}:studio-lifecycle-config/*"
                }
            }
        ],
        "EKS.DeregisterCluster": [
            {
                "action": "eks:DeregisterCluster",
                "resource_mappings": {
                    "ClusterName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Macie2.ListManagedDataIdentifiers": [
            {
                "action": "macie2:ListManagedDataIdentifiers",
                "resource_mappings": {}
            }
        ],
        "KafkaConnect.CreateWorkerConfiguration": [
            {
                "action": "kafkaconnect:CreateWorkerConfiguration",
                "resource_mappings": {}
            }
        ],
        "KafkaConnect.DeleteConnector": [
            {
                "action": "kafkaconnect:DeleteConnector",
                "resource_mappings": {}
            },
            {
                "action": "logs:DeleteLogDelivery",
                "resource_mappings": {}
            },
            {
                "action": "logs:ListLogDeliveries",
                "resource_mappings": {}
            }
        ],
        "KafkaConnect.DescribeConnector": [
            {
                "action": "kafkaconnect:DescribeConnector",
                "resource_mappings": {}
            }
        ],
        "KafkaConnect.DescribeCustomPlugin": [
            {
                "action": "kafkaconnect:DescribeCustomPlugin",
                "resource_mappings": {}
            }
        ],
        "KafkaConnect.DescribeWorkerConfiguration": [
            {
                "action": "kafkaconnect:DescribeWorkerConfiguration",
                "resource_mappings": {}
            }
        ],
        "KafkaConnect.ListConnectors": [
            {
                "action": "kafkaconnect:ListConnectors",
                "resource_mappings": {}
            }
        ],
        "KafkaConnect.ListCustomPlugins": [
            {
                "action": "kafkaconnect:ListCustomPlugins",
                "resource_mappings": {}
            }
        ],
        "KafkaConnect.ListWorkerConfigurations": [
            {
                "action": "kafkaconnect:ListWorkerConfigurations",
                "resource_mappings": {}
            }
        ],
        "APIGateway.CreateApiKey": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apikeys"
                }
            }
        ],
        "APIGateway.CreateBasePathMapping": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${domainName}/basepathmappings"
                }
            }
        ],
        "APIGateway.CreateDeployment": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/deployments"
                }
            }
        ],
        "APIGateway.CreateDocumentationVersion": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/versions"
                }
            }
        ],
        "APIGateway.CreateDomainName": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames"
                }
            }
        ],
        "APIGateway.CreateModel": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/models"
                }
            }
        ],
        "APIGateway.CreateRequestValidator": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/requestvalidators"
                }
            }
        ],
        "APIGateway.CreateResource": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${parentId}"
                }
            }
        ],
        "APIGateway.CreateRestApi": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis"
                }
            }
        ],
        "APIGateway.CreateStage": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/stages"
                }
            }
        ],
        "APIGateway.CreateUsagePlan": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans"
                }
            }
        ],
        "APIGateway.CreateUsagePlanKey": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans/${usagePlanId}/keys"
                }
            }
        ],
        "APIGateway.CreateVpcLink": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/vpclinks"
                }
            }
        ],
        "APIGateway.DeleteApiKey": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apikeys/${apiKey}"
                }
            }
        ],
        "APIGateway.DeleteAuthorizer": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/authorizers/${authorizerId}"
                }
            }
        ],
        "APIGateway.DeleteBasePathMapping": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${domainName}/basepathmappings/${basePath}"
                }
            }
        ],
        "APIGateway.DeleteClientCertificate": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/clientcertificates/${clientCertificateId}"
                }
            }
        ],
        "APIGateway.DeleteDeployment": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/deployments/${deploymentId}"
                }
            }
        ],
        "APIGateway.DeleteDocumentationPart": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/parts/${documentationPartId}"
                }
            }
        ],
        "APIGateway.DeleteDocumentationVersion": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/versions/${documentationVersion}"
                }
            }
        ],
        "APIGateway.DeleteDomainName": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${domainName}"
                }
            }
        ],
        "APIGateway.DeleteGatewayResponse": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/gatewayresponses/${responseType}"
                }
            }
        ],
        "APIGateway.DeleteIntegration": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/integration"
                }
            }
        ],
        "APIGateway.DeleteIntegrationResponse": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/integration/responses/${statusCode}"
                }
            }
        ],
        "APIGateway.DeleteMethod": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}"
                }
            }
        ],
        "APIGateway.DeleteMethodResponse": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/responses/${statusCode}"
                }
            }
        ],
        "APIGateway.DeleteModel": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/models/${modelName}"
                }
            }
        ],
        "APIGateway.DeleteRequestValidator": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/requestvalidators/${requestValidatorId}"
                }
            }
        ],
        "APIGateway.DeleteResource": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}"
                }
            }
        ],
        "APIGateway.DeleteRestApi": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}"
                }
            }
        ],
        "APIGateway.DeleteStage": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/stages/${stageName}"
                }
            }
        ],
        "APIGateway.DeleteUsagePlan": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans/${usagePlanId}"
                }
            }
        ],
        "APIGateway.DeleteUsagePlanKey": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans/${usagePlanId}/keys/${keyId}"
                }
            }
        ],
        "APIGateway.DeleteVpcLink": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/vpclinks/${vpcLinkId}"
                }
            }
        ],
        "APIGateway.FlushStageAuthorizersCache": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/stages/${stageName}/cache/authorizers"
                }
            }
        ],
        "APIGateway.FlushStageCache": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/stages/${stageName}/cache/data"
                }
            }
        ],
        "APIGateway.GenerateClientCertificate": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/clientcertificates"
                }
            }
        ],
        "APIGateway.GetAccount": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/account"
                }
            }
        ],
        "APIGateway.GetApiKey": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apikeys/${apiKey}"
                }
            }
        ],
        "APIGateway.GetApiKeys": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apikeys"
                }
            }
        ],
        "APIGateway.GetAuthorizer": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/authorizers/${authorizerId}"
                }
            }
        ],
        "APIGateway.GetAuthorizers": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/authorizers"
                }
            }
        ],
        "APIGateway.GetBasePathMapping": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${domainName}/basepathmappings/${basePath}"
                }
            }
        ],
        "APIGateway.GetBasePathMappings": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${domainName}/basepathmappings"
                }
            }
        ],
        "APIGateway.GetClientCertificate": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/clientcertificates/${clientCertificateId}"
                }
            }
        ],
        "APIGateway.GetClientCertificates": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/clientcertificates"
                }
            }
        ],
        "APIGateway.GetDeployment": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/deployments/${deploymentId}"
                }
            }
        ],
        "APIGateway.GetDeployments": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/deployments"
                }
            }
        ],
        "APIGateway.GetDocumentationPart": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/parts/${documentationPartId}"
                }
            }
        ],
        "APIGateway.GetDocumentationParts": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/parts"
                }
            }
        ],
        "APIGateway.GetDocumentationVersion": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/versions/${documentationVersion}"
                }
            }
        ],
        "APIGateway.GetDocumentationVersions": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/versions"
                }
            }
        ],
        "APIGateway.GetDomainName": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${domainName}"
                }
            }
        ],
        "APIGateway.GetDomainNames": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames"
                }
            }
        ],
        "APIGateway.GetExport": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/stages/${stageName}/exports/${exportType}"
                }
            }
        ],
        "APIGateway.GetGatewayResponse": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/gatewayresponses/${responseType}"
                }
            }
        ],
        "APIGateway.GetGatewayResponses": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/gatewayresponses"
                }
            }
        ],
        "APIGateway.GetIntegration": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/integration"
                }
            }
        ],
        "APIGateway.GetIntegrationResponse": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/integration/responses/${statusCode}"
                }
            }
        ],
        "APIGateway.GetMethod": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}"
                }
            }
        ],
        "APIGateway.GetMethodResponse": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/responses/${statusCode}"
                }
            }
        ],
        "APIGateway.GetModel": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/models/${modelName}"
                }
            }
        ],
        "APIGateway.GetModelTemplate": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/models/${modelName}/default_template"
                }
            }
        ],
        "APIGateway.GetModels": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/models"
                }
            }
        ],
        "APIGateway.GetRequestValidator": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/requestvalidators/${requestValidatorId}"
                }
            }
        ],
        "APIGateway.GetRequestValidators": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/requestvalidators"
                }
            }
        ],
        "APIGateway.GetResource": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}"
                }
            }
        ],
        "APIGateway.GetResources": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources"
                }
            }
        ],
        "APIGateway.GetRestApi": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}"
                }
            }
        ],
        "APIGateway.GetRestApis": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis"
                }
            }
        ],
        "APIGateway.GetSdk": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/stages/${stageName}/sdks/${sdkType}"
                }
            }
        ],
        "APIGateway.GetSdkType": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/sdktypes/${id}"
                }
            }
        ],
        "APIGateway.GetSdkTypes": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/sdktypes"
                }
            }
        ],
        "APIGateway.GetStage": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/stages/${stageName}"
                }
            }
        ],
        "APIGateway.GetStages": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/stages"
                }
            }
        ],
        "APIGateway.GetTags": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/tags/${resourceArn}"
                }
            }
        ],
        "APIGateway.GetUsage": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans/${usagePlanId}/usage"
                }
            }
        ],
        "APIGateway.GetUsagePlan": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans/${usagePlanId}"
                }
            }
        ],
        "APIGateway.GetUsagePlanKey": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans/${usagePlanId}/keys/${keyId}"
                }
            }
        ],
        "APIGateway.GetUsagePlanKeys": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans/${usagePlanId}/keys"
                }
            }
        ],
        "APIGateway.GetUsagePlans": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans"
                }
            }
        ],
        "APIGateway.GetVpcLink": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/vpclinks/${vpcLinkId}"
                }
            }
        ],
        "APIGateway.GetVpcLinks": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/vpclinks"
                }
            }
        ],
        "APIGateway.ImportApiKeys": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apikeys"
                }
            }
        ],
        "APIGateway.ImportDocumentationParts": [
            {
                "action": "apigateway:PUT",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/parts"
                }
            }
        ],
        "APIGateway.PutGatewayResponse": [
            {
                "action": "apigateway:PUT",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/gatewayresponses/${responseType}"
                }
            }
        ],
        "APIGateway.PutIntegration": [
            {
                "action": "apigateway:PUT",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/integration"
                }
            }
        ],
        "APIGateway.PutIntegrationResponse": [
            {
                "action": "apigateway:PUT",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/integration/responses/${statusCode}"
                }
            }
        ],
        "APIGateway.PutMethod": [
            {
                "action": "apigateway:PUT",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}"
                }
            }
        ],
        "APIGateway.PutMethodResponse": [
            {
                "action": "apigateway:PUT",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/responses/${statusCode}"
                }
            }
        ],
        "APIGateway.TestInvokeAuthorizer": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/authorizers/${authorizerId}"
                }
            }
        ],
        "APIGateway.TestInvokeMethod": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}"
                }
            }
        ],
        "APIGateway.UntagResource": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/tags/${resourceArn}"
                }
            }
        ],
        "APIGateway.UpdateAccount": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/account"
                }
            }
        ],
        "APIGateway.UpdateApiKey": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apikeys/${apiKey}"
                }
            }
        ],
        "APIGateway.UpdateAuthorizer": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/authorizers/${authorizerId}"
                }
            }
        ],
        "APIGateway.UpdateBasePathMapping": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${domainName}/basepathmappings/${basePath}"
                }
            }
        ],
        "APIGateway.UpdateClientCertificate": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/clientcertificates/${clientCertificateId}"
                }
            }
        ],
        "APIGateway.UpdateDeployment": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/deployments/${deploymentId}"
                }
            }
        ],
        "APIGateway.UpdateDocumentationPart": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/parts/${documentationPartId}"
                }
            }
        ],
        "APIGateway.UpdateDocumentationVersion": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/documentation/versions/${documentationVersion}"
                }
            }
        ],
        "APIGateway.UpdateDomainName": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${domainName}"
                }
            }
        ],
        "APIGateway.UpdateGatewayResponse": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/gatewayresponses/${responseType}"
                }
            }
        ],
        "APIGateway.UpdateIntegration": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/integration"
                }
            }
        ],
        "APIGateway.UpdateIntegrationResponse": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/integration/responses/${statusCode}"
                }
            }
        ],
        "APIGateway.UpdateMethod": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}"
                }
            }
        ],
        "APIGateway.UpdateMethodResponse": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}/methods/${httpMethod}/responses/${statusCode}"
                }
            }
        ],
        "APIGateway.UpdateModel": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/models/${modelName}"
                }
            }
        ],
        "APIGateway.UpdateRequestValidator": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/requestvalidators/${requestValidatorId}"
                }
            }
        ],
        "APIGateway.UpdateResource": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/resources/${resourceId}"
                }
            }
        ],
        "APIGateway.UpdateStage": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/restapis/${restApiId}/stages/${stageName}"
                }
            }
        ],
        "APIGateway.UpdateUsage": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans/${usagePlanId}/keys/${keyId}/usage"
                }
            }
        ],
        "APIGateway.UpdateUsagePlan": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/usageplans/${usagePlanId}"
                }
            }
        ],
        "APIGateway.UpdateVpcLink": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/vpclinks/${vpcLinkId}"
                }
            }
        ],
        "ApiGatewayV2.CreateApi": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis"
                }
            }
        ],
        "ApiGatewayV2.CreateApiMapping": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${DomainName}/apimappings"
                }
            }
        ],
        "ApiGatewayV2.CreateDeployment": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/deployments"
                }
            }
        ],
        "ApiGatewayV2.CreateDomainName": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames"
                }
            }
        ],
        "ApiGatewayV2.CreateIntegration": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations"
                }
            }
        ],
        "ApiGatewayV2.CreateIntegrationResponse": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations/${IntegrationId}/integrationresponses"
                }
            }
        ],
        "ApiGatewayV2.CreateModel": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/models"
                }
            }
        ],
        "ApiGatewayV2.CreateRoute": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes"
                }
            }
        ],
        "ApiGatewayV2.CreateRouteResponse": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes/${RouteId}/routeresponses"
                }
            }
        ],
        "ApiGatewayV2.CreateStage": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/stages"
                }
            }
        ],
        "ApiGatewayV2.DeleteAccessLogSettings": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/stages/${StageName}/accesslogsettings"
                }
            }
        ],
        "ApiGatewayV2.DeleteApi": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}"
                }
            }
        ],
        "ApiGatewayV2.DeleteApiMapping": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${DomainName}/apimappings/${ApiMappingId}"
                }
            }
        ],
        "ApiGatewayV2.DeleteAuthorizer": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/authorizers/${AuthorizerId}"
                }
            }
        ],
        "ApiGatewayV2.DeleteCorsConfiguration": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/cors"
                }
            }
        ],
        "ApiGatewayV2.DeleteDeployment": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/deployments/${DeploymentId}"
                }
            }
        ],
        "ApiGatewayV2.DeleteDomainName": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${DomainName}"
                }
            }
        ],
        "ApiGatewayV2.DeleteIntegration": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations/${IntegrationId}"
                }
            }
        ],
        "ApiGatewayV2.DeleteIntegrationResponse": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations/${IntegrationId}/integrationresponses/${IntegrationResponseId}"
                }
            }
        ],
        "ApiGatewayV2.DeleteModel": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/models/${ModelId}"
                }
            }
        ],
        "ApiGatewayV2.DeleteRoute": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes/${RouteId}"
                }
            }
        ],
        "ApiGatewayV2.DeleteRouteRequestParameter": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes/${RouteId}/requestparameters/${RequestParameterKey}"
                }
            }
        ],
        "ApiGatewayV2.DeleteRouteResponse": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes/${RouteId}/routeresponses/${RouteResponseId}"
                }
            }
        ],
        "ApiGatewayV2.DeleteRouteSettings": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/stages/${StageName}/routesettings/${RouteKey}"
                }
            }
        ],
        "ApiGatewayV2.DeleteStage": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/stages/${StageName}"
                }
            }
        ],
        "ApiGatewayV2.DeleteVpcLink": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/vpclinks/${VpcLinkId}"
                }
            }
        ],
        "ApiGatewayV2.ExportApi": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/exports/${Specification}"
                }
            }
        ],
        "ApiGatewayV2.ResetAuthorizersCache": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/stages/${StageName}/cache/authorizers"
                }
            }
        ],
        "ApiGatewayV2.GetApi": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}"
                }
            }
        ],
        "ApiGatewayV2.GetApiMapping": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${DomainName}/apimappings/${ApiMappingId}"
                }
            }
        ],
        "ApiGatewayV2.GetApiMappings": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${DomainName}/apimappings"
                }
            }
        ],
        "ApiGatewayV2.GetApis": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis"
                }
            }
        ],
        "ApiGatewayV2.GetAuthorizer": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/authorizers/${AuthorizerId}"
                }
            }
        ],
        "ApiGatewayV2.GetAuthorizers": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/authorizers"
                }
            }
        ],
        "ApiGatewayV2.GetDeployment": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/deployments/${DeploymentId}"
                }
            }
        ],
        "ApiGatewayV2.GetDeployments": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/deployments"
                }
            }
        ],
        "ApiGatewayV2.GetDomainName": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${DomainName}"
                }
            }
        ],
        "ApiGatewayV2.GetDomainNames": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames"
                }
            }
        ],
        "ApiGatewayV2.GetIntegration": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations/${IntegrationId}"
                }
            }
        ],
        "ApiGatewayV2.GetIntegrationResponse": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations/${IntegrationId}/integrationresponses/${IntegrationResponseId}"
                }
            }
        ],
        "ApiGatewayV2.GetIntegrationResponses": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations/${IntegrationId}/integrationresponses"
                }
            }
        ],
        "ApiGatewayV2.GetIntegrations": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations"
                }
            }
        ],
        "ApiGatewayV2.GetModel": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/models/${ModelId}"
                }
            }
        ],
        "ApiGatewayV2.GetModelTemplate": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/models/${ModelId}/template"
                }
            }
        ],
        "ApiGatewayV2.GetModels": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/models"
                }
            }
        ],
        "ApiGatewayV2.GetRoute": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes/${RouteId}"
                }
            }
        ],
        "ApiGatewayV2.GetRouteResponse": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes/${RouteId}/routeresponses/${RouteResponseId}"
                }
            }
        ],
        "ApiGatewayV2.GetRouteResponses": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes/${RouteId}/routeresponses"
                }
            }
        ],
        "ApiGatewayV2.GetRoutes": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes"
                }
            }
        ],
        "ApiGatewayV2.GetStage": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/stages/${StageName}"
                }
            }
        ],
        "ApiGatewayV2.GetStages": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/stages"
                }
            }
        ],
        "ApiGatewayV2.GetTags": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/tags/${ResourceArn}"
                }
            }
        ],
        "ApiGatewayV2.GetVpcLink": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/vpclinks/${VpcLinkId}"
                }
            }
        ],
        "ApiGatewayV2.GetVpcLinks": [
            {
                "action": "apigateway:GET",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/vpclinks"
                }
            }
        ],
        "ApiGatewayV2.ImportApi": [
            {
                "action": "apigateway:PUT",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis"
                }
            }
        ],
        "ApiGatewayV2.ReimportApi": [
            {
                "action": "apigateway:PUT",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}"
                }
            }
        ],
        "ApiGatewayV2.TagResource": [
            {
                "action": "apigateway:POST",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/tags/${ResourceArn}"
                }
            }
        ],
        "ApiGatewayV2.UntagResource": [
            {
                "action": "apigateway:DELETE",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/tags/${ResourceArn}"
                }
            }
        ],
        "ApiGatewayV2.UpdateApi": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}"
                }
            }
        ],
        "ApiGatewayV2.UpdateApiMapping": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${DomainName}/apimappings/${ApiMappingId}"
                }
            }
        ],
        "ApiGatewayV2.UpdateAuthorizer": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/authorizers/${AuthorizerId}"
                }
            }
        ],
        "ApiGatewayV2.UpdateDeployment": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/deployments/${DeploymentId}"
                }
            }
        ],
        "ApiGatewayV2.UpdateDomainName": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/domainnames/${DomainName}"
                }
            }
        ],
        "ApiGatewayV2.UpdateIntegration": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations/${IntegrationId}"
                }
            }
        ],
        "ApiGatewayV2.UpdateIntegrationResponse": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/integrations/${IntegrationId}/integrationresponses/${IntegrationResponseId}"
                }
            }
        ],
        "ApiGatewayV2.UpdateModel": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/models/${ModelId}"
                }
            }
        ],
        "ApiGatewayV2.UpdateRoute": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes/${RouteId}"
                }
            }
        ],
        "ApiGatewayV2.UpdateRouteResponse": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/routes/${RouteId}/routeresponses/${RouteResponseId}"
                }
            }
        ],
        "ApiGatewayV2.UpdateStage": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/apis/${ApiId}/stages/${StageName}"
                }
            }
        ],
        "ApiGatewayV2.UpdateVpcLink": [
            {
                "action": "apigateway:PATCH",
                "arn_override": {
                    "template": "arn:${Partition}:apigateway:${Region}::/vpclinks/${VpcLinkId}"
                }
            }
        ],
        "Kinesis.StartStreamEncryption": [
            {
                "action": "kinesis:StartStreamEncryption",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${KeyId}"
                    },
                    "StreamName": {
                        "template": "${StreamName}"
                    }
                }
            }
        ],
        "Rekognition.DeleteProject": [
            {
                "action": "rekognition:DeleteProject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${ProjectArn}"
                }
            }
        ],
        "Kafka.UpdateSecurity": [
            {
                "action": "kafka:UpdateSecurity",
                "resource_mappings": {}
            },
            {
                "action": "kms:RetireGrant",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${EncryptionInfo.EncryptionAtRest.DataVolumeKMSKeyId}"
                    }
                }
            }
        ],
        "Amp.ListTagsForResource": [
            {
                "action": "aps:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "workspace": "${resourceArn}"
                }
            }
        ],
        "Amp.TagResource": [
            {
                "action": "aps:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "workspace": "${resourceArn}"
                }
            }
        ],
        "Amp.UntagResource": [
            {
                "action": "aps:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "workspace": "${resourceArn}"
                }
            }
        ],
        "OpenSearch.CancelServiceSoftwareUpdate": [
            {
                "action": "es:CancelServiceSoftwareUpdate",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.DescribeDomainAutoTunes": [
            {
                "action": "es:DescribeDomainAutoTunes",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.StartServiceSoftwareUpdate": [
            {
                "action": "es:StartServiceSoftwareUpdate",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "OpenSearch.UpgradeDomain": [
            {
                "action": "es:UpgradeDomain",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "KafkaConnect.CreateConnector": [
            {
                "action": "kafkaconnect:CreateConnector",
                "resource_mappings": {}
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "${kafkaCluster.apacheKafkaCluster.vpc.subnets[]}"
                    },
                    "SecurityGroupId": {
                        "template": "${kafkaCluster.apacheKafkaCluster.vpc.securityGroups[]}"
                    }
                }
            },
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            },
            {
                "action": "firehose:TagDeliveryStream",
                "resource_mappings": {
                    "DeliveryStreamName": {
                        "template": "${logDelivery.workerLogDelivery.firehose.deliveryStream}"
                    }
                }
            },
            {
                "action": "iam:AttachRolePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${serviceExecutionRoleArn}"
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${serviceExecutionRoleArn}"
                }
            },
            {
                "action": "iam:PutRolePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${serviceExecutionRoleArn}"
                }
            },
            {
                "action": "logs:CreateLogDelivery",
                "resource_mappings": {}
            },
            {
                "action": "logs:DescribeLogGroups",
                "resource_mappings": {
                    "LogGroupName": {
                        "template": "${logDelivery.workerLogDelivery.cloudWatchLogs.logGroup}"
                    }
                }
            },
            {
                "action": "logs:DescribeResourcePolicies",
                "resource_mappings": {}
            },
            {
                "action": "logs:GetLogDelivery",
                "resource_mappings": {}
            },
            {
                "action": "logs:ListLogDeliveries",
                "resource_mappings": {}
            },
            {
                "action": "logs:PutResourcePolicy",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetBucketPolicy",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${logDelivery.workerLogDelivery.s3.bucket}"
                    }
                }
            },
            {
                "action": "s3:PutBucketPolicy",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${logDelivery.workerLogDelivery.s3.bucket}"
                    }
                }
            }
        ],
        "KafkaConnect.CreateCustomPlugin": [
            {
                "action": "kafkaconnect:CreateCustomPlugin",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "object": "${location.s3Location.bucketArn}/${location.s3Location.fileKey}"
                }
            }
        ],
        "KafkaConnect.UpdateConnector": [
            {
                "action": "kafkaconnect:UpdateConnector",
                "resource_mappings": {}
            }
        ],
        "ECR.DescribeImageReplicationStatus": [
            {
                "action": "ecr:DescribeImageReplicationStatus",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryName}"
                    }
                }
            }
        ],
        "S3Control.DescribeMultiRegionAccessPointOperation": [
            {
                "action": "s3:DescribeMultiRegionAccessPointOperation",
                "resource_mappings": {
                    "Operation": {
                        "template": "DescribeMultiRegionAccessPointOperation"
                    },
                    "Token": {
                        "template": "${RequestTokenARN}"
                    }
                }
            }
        ],
        "Comprehend.ListDocumentClassifierSummaries": [
            {
                "action": "comprehend:ListDocumentClassifierSummaries",
                "resource_mappings": {}
            }
        ],
        "Comprehend.ListEntityRecognizerSummaries": [
            {
                "action": "comprehend:ListEntityRecognizerSummaries",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.CreateLicenseConversionTaskForResource": [
            {
                "action": "license-manager:CreateLicenseConversionTaskForResource",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.GetLicenseConversionTask": [
            {
                "action": "license-manager:GetLicenseConversionTask",
                "resource_mappings": {}
            }
        ],
        "LicenseManager.ListLicenseConversionTasks": [
            {
                "action": "license-manager:ListLicenseConversionTasks",
                "resource_mappings": {}
            }
        ],
        "DataExchange.CreateEventAction": [
            {
                "action": "dataexchange:CreateEventAction",
                "resource_mappings": {
                    "EventActionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataExchange.DeleteEventAction": [
            {
                "action": "dataexchange:DeleteEventAction",
                "resource_mappings": {
                    "EventActionId": {
                        "template": "${EventActionId}"
                    }
                }
            }
        ],
        "DataExchange.GetEventAction": [
            {
                "action": "dataexchange:GetEventAction",
                "resource_mappings": {
                    "EventActionId": {
                        "template": "${EventActionId}"
                    }
                }
            }
        ],
        "DataExchange.ListEventActions": [
            {
                "action": "dataexchange:ListEventActions",
                "resource_mappings": {
                    "EventActionId": {
                        "template": "${EventSourceId}"
                    }
                }
            }
        ],
        "DataExchange.UpdateEventAction": [
            {
                "action": "dataexchange:UpdateEventAction",
                "resource_mappings": {
                    "EventActionId": {
                        "template": "${EventActionId}"
                    }
                }
            }
        ],
        "AppIntegrations.CreateDataIntegration": [
            {
                "action": "app-integrations:CreateDataIntegration",
                "resource_mappings": {
                    "DataIntegrationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppIntegrations.DeleteDataIntegration": [
            {
                "action": "app-integrations:DeleteDataIntegration",
                "resource_mappings": {
                    "DataIntegrationId": {
                        "template": "${DataIntegrationIdentifier}"
                    }
                }
            }
        ],
        "AppIntegrations.GetDataIntegration": [
            {
                "action": "app-integrations:GetDataIntegration",
                "resource_mappings": {
                    "DataIntegrationId": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "AppIntegrations.ListDataIntegrationAssociations": [
            {
                "action": "app-integrations:ListDataIntegrationAssociations",
                "resource_mappings": {}
            }
        ],
        "AppIntegrations.ListDataIntegrations": [
            {
                "action": "app-integrations:ListDataIntegrations",
                "resource_mappings": {}
            }
        ],
        "AppIntegrations.UpdateDataIntegration": [
            {
                "action": "app-integrations:UpdateDataIntegration",
                "resource_mappings": {
                    "DataIntegrationId": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "Amp.CreateAlertManagerDefinition": [
            {
                "action": "aps:CreateAlertManagerDefinition",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Amp.CreateRuleGroupsNamespace": [
            {
                "action": "aps:CreateRuleGroupsNamespace",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "Namespace": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Amp.DeleteAlertManagerDefinition": [
            {
                "action": "aps:DeleteAlertManagerDefinition",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Amp.DeleteRuleGroupsNamespace": [
            {
                "action": "aps:DeleteRuleGroupsNamespace",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "Namespace": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Amp.DescribeAlertManagerDefinition": [
            {
                "action": "aps:DescribeAlertManagerDefinition",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Amp.DescribeRuleGroupsNamespace": [
            {
                "action": "aps:DescribeRuleGroupsNamespace",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "Namespace": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Amp.ListRuleGroupsNamespaces": [
            {
                "action": "aps:ListRuleGroupsNamespaces",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Amp.PutAlertManagerDefinition": [
            {
                "action": "aps:PutAlertManagerDefinition",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Amp.PutRuleGroupsNamespace": [
            {
                "action": "aps:PutRuleGroupsNamespace",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "Namespace": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Wisdom.CreateAssistant": [
            {
                "action": "wisdom:CreateAssistant",
                "resource_mappings": {}
            }
        ],
        "Wisdom.CreateAssistantAssociation": [
            {
                "action": "wisdom:CreateAssistantAssociation",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    }
                }
            }
        ],
        "Wisdom.CreateContent": [
            {
                "action": "wisdom:CreateContent",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    }
                }
            }
        ],
        "Wisdom.CreateKnowledgeBase": [
            {
                "action": "wisdom:CreateKnowledgeBase",
                "resource_mappings": {}
            }
        ],
        "Wisdom.CreateSession": [
            {
                "action": "wisdom:CreateSession",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    }
                }
            }
        ],
        "Wisdom.DeleteAssistant": [
            {
                "action": "wisdom:DeleteAssistant",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    }
                }
            }
        ],
        "Wisdom.DeleteAssistantAssociation": [
            {
                "action": "wisdom:DeleteAssistantAssociation",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    },
                    "AssistantAssociationId": {
                        "template": "${assistantAssociationId}"
                    }
                }
            }
        ],
        "Wisdom.DeleteContent": [
            {
                "action": "wisdom:DeleteContent",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    },
                    "ContentId": {
                        "template": "${contentId}"
                    }
                }
            }
        ],
        "Wisdom.DeleteKnowledgeBase": [
            {
                "action": "wisdom:DeleteKnowledgeBase",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    }
                }
            }
        ],
        "Wisdom.GetAssistant": [
            {
                "action": "wisdom:GetAssistant",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    }
                }
            }
        ],
        "Wisdom.GetAssistantAssociation": [
            {
                "action": "wisdom:GetAssistantAssociation",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    },
                    "AssistantAssociationId": {
                        "template": "${assistantAssociationId}"
                    }
                }
            }
        ],
        "Wisdom.GetContent": [
            {
                "action": "wisdom:GetContent",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    },
                    "ContentId": {
                        "template": "${contentId}"
                    }
                }
            }
        ],
        "Wisdom.GetContentSummary": [
            {
                "action": "wisdom:GetContentSummary",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    },
                    "ContentId": {
                        "template": "${contentId}"
                    }
                }
            }
        ],
        "Wisdom.GetKnowledgeBase": [
            {
                "action": "wisdom:GetKnowledgeBase",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    }
                }
            }
        ],
        "Wisdom.GetRecommendations": [
            {
                "action": "wisdom:GetRecommendations",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    }
                }
            }
        ],
        "Wisdom.GetSession": [
            {
                "action": "wisdom:GetSession",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    },
                    "SessionId": {
                        "template": "${sessionId}"
                    }
                }
            }
        ],
        "Wisdom.ListAssistantAssociations": [
            {
                "action": "wisdom:ListAssistantAssociations",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    }
                }
            }
        ],
        "Wisdom.ListAssistants": [
            {
                "action": "wisdom:ListAssistants",
                "resource_mappings": {}
            }
        ],
        "Wisdom.ListContents": [
            {
                "action": "wisdom:ListContents",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    }
                }
            }
        ],
        "Wisdom.ListKnowledgeBases": [
            {
                "action": "wisdom:ListKnowledgeBases",
                "resource_mappings": {}
            }
        ],
        "Wisdom.ListTagsForResource": [
            {
                "action": "wisdom:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Wisdom.NotifyRecommendationsReceived": [
            {
                "action": "wisdom:NotifyRecommendationsReceived",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    }
                }
            }
        ],
        "Wisdom.QueryAssistant": [
            {
                "action": "wisdom:QueryAssistant",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    }
                }
            }
        ],
        "Wisdom.RemoveKnowledgeBaseTemplateUri": [
            {
                "action": "wisdom:RemoveKnowledgeBaseTemplateUri",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    }
                }
            }
        ],
        "Wisdom.SearchContent": [
            {
                "action": "wisdom:SearchContent",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    }
                }
            }
        ],
        "Wisdom.SearchSessions": [
            {
                "action": "wisdom:SearchSessions",
                "resource_mappings": {
                    "AssistantId": {
                        "template": "${assistantId}"
                    }
                }
            }
        ],
        "Wisdom.StartContentUpload": [
            {
                "action": "wisdom:StartContentUpload",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    }
                }
            }
        ],
        "Wisdom.TagResource": [
            {
                "action": "wisdom:TagResource",
                "resource_mappings": {}
            }
        ],
        "Wisdom.UntagResource": [
            {
                "action": "wisdom:UntagResource",
                "resource_mappings": {}
            }
        ],
        "Wisdom.UpdateContent": [
            {
                "action": "wisdom:UpdateContent",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    },
                    "ContentId": {
                        "template": "${contentId}"
                    }
                }
            }
        ],
        "Wisdom.UpdateKnowledgeBaseTemplateUri": [
            {
                "action": "wisdom:UpdateKnowledgeBaseTemplateUri",
                "resource_mappings": {
                    "KnowledgeBaseId": {
                        "template": "${knowledgeBaseId}"
                    }
                }
            }
        ],
        "Iot.PutVerificationStateOnViolation": [
            {
                "action": "iot:PutVerificationStateOnViolation",
                "resource_mappings": {}
            }
        ],
        "CloudControl.CancelResourceRequest": [
            {
                "action": "cloudformation:CancelResourceRequest",
                "resource_mappings": {}
            }
        ],
        "CloudControl.CreateResource": [
            {
                "action": "cloudformation:CreateResource",
                "resource_mappings": {}
            }
        ],
        "CloudControl.DeleteResource": [
            {
                "action": "cloudformation:DeleteResource",
                "resource_mappings": {}
            }
        ],
        "CloudControl.GetResource": [
            {
                "action": "cloudformation:GetResource",
                "resource_mappings": {}
            }
        ],
        "CloudControl.GetResourceRequestStatus": [
            {
                "action": "cloudformation:GetResourceRequestStatus",
                "resource_mappings": {}
            }
        ],
        "CloudControl.ListResourceRequests": [
            {
                "action": "cloudformation:ListResourceRequests",
                "resource_mappings": {}
            }
        ],
        "CloudControl.ListResources": [
            {
                "action": "cloudformation:ListResources",
                "resource_mappings": {}
            }
        ],
        "CloudControl.UpdateResource": [
            {
                "action": "cloudformation:UpdateResource",
                "resource_mappings": {}
            }
        ],
        "WorkSpaces.CreateUpdatedWorkspaceImage": [
            {
                "action": "workspaces:CreateUpdatedWorkspaceImage",
                "resource_mappings": {
                    "ImageId": {
                        "template": "*"
                    }
                }
            }
        ],
        "WorkMail.DescribeInboundDmarcSettings": [
            {
                "action": "workmail:DescribeInboundDmarcSettings",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.PutInboundDmarcSettings": [
            {
                "action": "workmail:PutInboundDmarcSettings",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "Backup.DeleteBackupVaultLockConfiguration": [
            {
                "action": "backup:DeleteBackupVaultLockConfiguration",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "Backup.PutBackupVaultLockConfiguration": [
            {
                "action": "backup:PutBackupVaultLockConfiguration",
                "resource_mappings": {
                    "BackupVaultName": {
                        "template": "${BackupVaultName}"
                    }
                }
            }
        ],
        "FraudDetector.CancelBatchImportJob": [
            {
                "action": "frauddetector:CancelBatchImportJob",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "FraudDetector.CreateBatchImportJob": [
            {
                "action": "frauddetector:CreateBatchImportJob",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "${eventTypeName}"
                    }
                }
            }
        ],
        "FraudDetector.DeleteBatchImportJob": [
            {
                "action": "frauddetector:DeleteBatchImportJob",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "FraudDetector.DeleteEventsByEventType": [
            {
                "action": "frauddetector:DeleteEventsByEventType",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "${eventTypeName}"
                    }
                }
            }
        ],
        "FraudDetector.GetBatchImportJobs": [
            {
                "action": "frauddetector:GetBatchImportJobs",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "${jobId}"
                    }
                }
            }
        ],
        "FraudDetector.GetDeleteEventsByEventTypeStatus": [
            {
                "action": "frauddetector:GetDeleteEventsByEventTypeStatus",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "${eventTypeName}"
                    }
                }
            }
        ],
        "FraudDetector.GetEvent": [
            {
                "action": "frauddetector:GetEvent",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "${eventTypeName}"
                    }
                }
            }
        ],
        "FraudDetector.SendEvent": [
            {
                "action": "frauddetector:SendEvent",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "${eventTypeName}"
                    }
                }
            }
        ],
        "FraudDetector.UpdateEventLabel": [
            {
                "action": "frauddetector:UpdateEventLabel",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "${eventTypeName}"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteUtterances": [
            {
                "action": "lex:DeleteUtterances",
                "resource_mappings": {
                    "BotName": {
                        "template": "*"
                    },
                    "BotVersion": {
                        "template": "*"
                    }
                }
            }
        ],
        "Account.DeleteAlternateContact": [
            {
                "action": "account:DeleteAlternateContact",
                "resource_mappings": {
                    "ManagementAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "MemberAccountId": {
                        "template": "${AccountId}"
                    }
                }
            }
        ],
        "Account.GetAlternateContact": [
            {
                "action": "account:GetAlternateContact",
                "resource_mappings": {
                    "ManagementAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "MemberAccountId": {
                        "template": "${AccountId}"
                    }
                }
            }
        ],
        "Account.PutAlternateContact": [
            {
                "action": "account:PutAlternateContact",
                "resource_mappings": {
                    "ManagementAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "MemberAccountId": {
                        "template": "${AccountId}"
                    }
                }
            }
        ],
        "Grafana.AssociateLicense": [
            {
                "action": "grafana:AssociateLicense",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            },
            {
                "action": "aws-marketplace:ViewSubscriptions",
                "resource_mappings": {}
            }
        ],
        "Grafana.CreateWorkspace": [
            {
                "action": "grafana:CreateWorkspace",
                "resource_mappings": {}
            },
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            },
            {
                "action": "sso:CreateManagedApplicationInstance",
                "resource_mappings": {}
            },
            {
                "action": "sso:DescribeRegisteredRegions",
                "resource_mappings": {}
            },
            {
                "action": "sso:GetSharedSsoConfiguration",
                "resource_mappings": {}
            }
        ],
        "Grafana.DeleteWorkspace": [
            {
                "action": "grafana:DeleteWorkspace",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            },
            {
                "action": "sso:DeleteManagedApplicationInstance",
                "resource_mappings": {}
            }
        ],
        "Grafana.DescribeWorkspace": [
            {
                "action": "grafana:DescribeWorkspace",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Grafana.DescribeWorkspaceAuthentication": [
            {
                "action": "grafana:DescribeWorkspaceAuthentication",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Grafana.DisassociateLicense": [
            {
                "action": "grafana:DisassociateLicense",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Grafana.ListPermissions": [
            {
                "action": "grafana:ListPermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Grafana.ListWorkspaces": [
            {
                "action": "grafana:ListWorkspaces",
                "resource_mappings": {}
            }
        ],
        "Grafana.UpdatePermissions": [
            {
                "action": "grafana:UpdatePermissions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Grafana.UpdateWorkspace": [
            {
                "action": "grafana:UpdateWorkspace",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "Grafana.UpdateWorkspaceAuthentication": [
            {
                "action": "grafana:UpdateWorkspaceAuthentication",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "EC2.CancelCapacityReservationFleets": [
            {
                "action": "ec2:CancelCapacityReservationFleets",
                "resource_mappings": {
                    "CapacityReservationFleetId": {
                        "template": "${CapacityReservationFleetIds[]}"
                    }
                }
            }
        ],
        "EC2.CreateCapacityReservationFleet": [
            {
                "action": "ec2:CreateCapacityReservationFleet",
                "resource_mappings": {
                    "CapacityReservationFleetId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.GetVpnConnectionDeviceSampleConfiguration": [
            {
                "action": "ec2:GetVpnConnectionDeviceSampleConfiguration",
                "resource_mappings": {
                    "VpnConnectionId": {
                        "template": "${VpnConnectionId}"
                    },
                    "VpnConnectionDeviceTypeId": {
                        "template": "${VpnConnectionDeviceTypeId}"
                    }
                }
            }
        ],
        "EC2.GetVpnConnectionDeviceTypes": [
            {
                "action": "ec2:GetVpnConnectionDeviceTypes",
                "resource_mappings": {}
            }
        ],
        "EC2.ModifyCapacityReservationFleet": [
            {
                "action": "ec2:ModifyCapacityReservationFleet",
                "resource_mappings": {
                    "CapacityReservationFleetId": {
                        "template": "${CapacityReservationFleetId}"
                    }
                }
            }
        ],
        "RDS.DeleteCustomDBEngineVersion": [
            {
                "action": "rds:DeleteCustomDBEngineVersion",
                "resource_mappings": {
                    "Engine": {
                        "template": "${Engine}"
                    },
                    "EngineVersion": {
                        "template": "${EngineVersion}"
                    },
                    "CustomDbEngineVersionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.ModifyCustomDBEngineVersion": [
            {
                "action": "rds:ModifyCustomDBEngineVersion",
                "resource_mappings": {
                    "Engine": {
                        "template": "${Engine}"
                    },
                    "EngineVersion": {
                        "template": "${EngineVersion}"
                    },
                    "CustomDbEngineVersionId": {
                        "template": "*"
                    }
                }
            }
        ],
        "MediaConvert.DeletePolicy": [
            {
                "action": "mediaconvert:DeletePolicy",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.GetPolicy": [
            {
                "action": "mediaconvert:GetPolicy",
                "resource_mappings": {}
            }
        ],
        "MediaConvert.PutPolicy": [
            {
                "action": "mediaconvert:PutPolicy",
                "resource_mappings": {}
            }
        ],
        "QuickSight.DescribeIpRestriction": [
            {
                "action": "quicksight:DescribeIpRestriction",
                "resource_mappings": {}
            }
        ],
        "QuickSight.UpdateIpRestriction": [
            {
                "action": "quicksight:UpdateIpRestriction",
                "resource_mappings": {}
            }
        ],
        "Textract.GetExpenseAnalysis": [
            {
                "action": "textract:GetExpenseAnalysis",
                "resource_mappings": {}
            }
        ],
        "Textract.StartExpenseAnalysis": [
            {
                "action": "textract:StartExpenseAnalysis",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${DocumentLocation.S3Object.Bucket}"
                    },
                    "ObjectName": {
                        "template": "${DocumentLocation.S3Object.Name}"
                    }
                }
            }
        ],
        "AuditManager.DeleteAssessmentFrameworkShare": [
            {
                "action": "auditmanager:DeleteAssessmentFrameworkShare",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListAssessmentFrameworkShareRequests": [
            {
                "action": "auditmanager:ListAssessmentFrameworkShareRequests",
                "resource_mappings": {}
            }
        ],
        "AuditManager.StartAssessmentFrameworkShare": [
            {
                "action": "auditmanager:StartAssessmentFrameworkShare",
                "resource_mappings": {
                    "AssessmentFrameworkId": {
                        "template": "${frameworkId}"
                    }
                }
            }
        ],
        "AuditManager.UpdateAssessmentFrameworkShare": [
            {
                "action": "auditmanager:UpdateAssessmentFrameworkShare",
                "resource_mappings": {}
            }
        ],
        "Panorama.CreateApplicationInstance": [
            {
                "action": "panorama:CreateApplicationInstance",
                "resource_mappings": {}
            }
        ],
        "Panorama.CreateJobForDevices": [
            {
                "action": "panorama:CreateJobForDevices",
                "resource_mappings": {}
            }
        ],
        "Panorama.CreateNodeFromTemplateJob": [
            {
                "action": "panorama:CreateNodeFromTemplateJob",
                "resource_mappings": {}
            }
        ],
        "Panorama.CreatePackage": [
            {
                "action": "panorama:CreatePackage",
                "resource_mappings": {}
            }
        ],
        "Panorama.CreatePackageImportJob": [
            {
                "action": "panorama:CreatePackageImportJob",
                "resource_mappings": {}
            }
        ],
        "Panorama.DeleteDevice": [
            {
                "action": "panorama:DeleteDevice",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "Panorama.DeletePackage": [
            {
                "action": "panorama:DeletePackage",
                "resource_mappings": {
                    "PackageId": {
                        "template": "${PackageId}"
                    }
                }
            }
        ],
        "Panorama.DeregisterPackageVersion": [
            {
                "action": "panorama:DeregisterPackageVersion",
                "resource_mappings": {}
            }
        ],
        "Panorama.DescribeApplicationInstance": [
            {
                "action": "panorama:DescribeApplicationInstance",
                "resource_mappings": {
                    "ApplicationInstanceId": {
                        "template": "${ApplicationInstanceId}"
                    }
                }
            }
        ],
        "Panorama.DescribeApplicationInstanceDetails": [
            {
                "action": "panorama:DescribeApplicationInstanceDetails",
                "resource_mappings": {
                    "ApplicationInstanceId": {
                        "template": "${ApplicationInstanceId}"
                    }
                }
            }
        ],
        "Panorama.DescribeDevice": [
            {
                "action": "panorama:DescribeDevice",
                "resource_mappings": {
                    "DeviceId": {
                        "template": "${DeviceId}"
                    }
                }
            }
        ],
        "Panorama.DescribeDeviceJob": [
            {
                "action": "panorama:DescribeDeviceJob",
                "resource_mappings": {}
            }
        ],
        "Panorama.DescribeNode": [
            {
                "action": "panorama:DescribeNode",
                "resource_mappings": {}
            }
        ],
        "Panorama.DescribeNodeFromTemplateJob": [
            {
                "action": "panorama:DescribeNodeFromTemplateJob",
                "resource_mappings": {}
            }
        ],
        "Panorama.DescribePackage": [
            {
                "action": "panorama:DescribePackage",
                "resource_mappings": {
                    "PackageId": {
                        "template": "${PackageId}"
                    }
                }
            }
        ],
        "Panorama.DescribePackageImportJob": [
            {
                "action": "panorama:DescribePackageImportJob",
                "resource_mappings": {}
            }
        ],
        "Panorama.DescribePackageVersion": [
            {
                "action": "panorama:DescribePackageVersion",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListApplicationInstanceDependencies": [
            {
                "action": "panorama:ListApplicationInstanceDependencies",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListApplicationInstanceNodeInstances": [
            {
                "action": "panorama:ListApplicationInstanceNodeInstances",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListApplicationInstances": [
            {
                "action": "panorama:ListApplicationInstances",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListDevices": [
            {
                "action": "panorama:ListDevices",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListDevicesJobs": [
            {
                "action": "panorama:ListDevicesJobs",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListNodeFromTemplateJobs": [
            {
                "action": "panorama:ListNodeFromTemplateJobs",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListNodes": [
            {
                "action": "panorama:ListNodes",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListPackageImportJobs": [
            {
                "action": "panorama:ListPackageImportJobs",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListPackages": [
            {
                "action": "panorama:ListPackages",
                "resource_mappings": {}
            }
        ],
        "Panorama.ListTagsForResource": [
            {
                "action": "panorama:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app": "%%iftemplatematch%${ResourceArn}%%",
                    "dataSource": "%%iftemplatematch%${ResourceArn}%%",
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "model": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Panorama.ProvisionDevice": [
            {
                "action": "panorama:ProvisionDevice",
                "resource_mappings": {}
            }
        ],
        "Panorama.RegisterPackageVersion": [
            {
                "action": "panorama:RegisterPackageVersion",
                "resource_mappings": {}
            }
        ],
        "Panorama.RemoveApplicationInstance": [
            {
                "action": "panorama:RemoveApplicationInstance",
                "resource_mappings": {
                    "ApplicationInstanceId": {
                        "template": "${ApplicationInstanceId}"
                    }
                }
            }
        ],
        "Panorama.TagResource": [
            {
                "action": "panorama:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app": "%%iftemplatematch%${ResourceArn}%%",
                    "dataSource": "%%iftemplatematch%${ResourceArn}%%",
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "model": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Panorama.UntagResource": [
            {
                "action": "panorama:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app": "%%iftemplatematch%${ResourceArn}%%",
                    "dataSource": "%%iftemplatematch%${ResourceArn}%%",
                    "device": "%%iftemplatematch%${ResourceArn}%%",
                    "model": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Panorama.UpdateDeviceMetadata": [
            {
                "action": "panorama:UpdateDeviceMetadata",
                "resource_mappings": {}
            }
        ],
        "DirectConnect.ConfirmCustomerAgreement": [
            {
                "action": "directconnect:ConfirmCustomerAgreement",
                "resource_mappings": {}
            }
        ],
        "DirectConnect.DescribeCustomerMetadata": [
            {
                "action": "directconnect:DescribeCustomerMetadata",
                "resource_mappings": {}
            }
        ],
        "DirectConnect.DescribeRouterConfiguration": [
            {
                "action": "directconnect:DescribeRouterConfiguration",
                "resource_mappings": {
                    "VirtualInterfaceId": {
                        "template": "${virtualInterfaceId}"
                    }
                }
            }
        ],
        "DirectConnect.UpdateDirectConnectGateway": [
            {
                "action": "directconnect:UpdateDirectConnectGateway",
                "resource_mappings": {
                    "DirectConnectGatewayId": {
                        "template": "${directConnectGatewayId}"
                    }
                }
            }
        ],
        "MediaLive.ClaimDevice": [
            {
                "action": "medialive:ClaimDevice",
                "resource_mappings": {}
            }
        ],
        "SageMaker.UpdateProject": [
            {
                "action": "sagemaker:UpdateProject",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    }
                }
            }
        ],
        "Connect.StopContactStreaming": [
            {
                "action": "connect:StopContactStreaming",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "MediaTailor.DeletePrefetchSchedule": [
            {
                "action": "mediatailor:DeletePrefetchSchedule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaTailor.GetPrefetchSchedule": [
            {
                "action": "mediatailor:GetPrefetchSchedule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "MediaTailor.ListPrefetchSchedules": [
            {
                "action": "mediatailor:ListPrefetchSchedules",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${PlaybackConfigurationName}"
                    }
                }
            }
        ],
        "Route53Resolver.GetResolverConfig": [
            {
                "action": "route53resolver:GetResolverConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResourceId}"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.ListResolverConfigs": [
            {
                "action": "route53resolver:ListResolverConfigs",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "Route53Resolver.UpdateResolverConfig": [
            {
                "action": "route53resolver:UpdateResolverConfig",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ResourceId}"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.CreateFindingAggregator": [
            {
                "action": "securityhub:CreateFindingAggregator",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.DeleteFindingAggregator": [
            {
                "action": "securityhub:DeleteFindingAggregator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "finding-aggregator": "${FindingAggregatorArn}"
                }
            }
        ],
        "SecurityHub.GetFindingAggregator": [
            {
                "action": "securityhub:GetFindingAggregator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "finding-aggregator": "${FindingAggregatorArn}"
                }
            }
        ],
        "SecurityHub.ListFindingAggregators": [
            {
                "action": "securityhub:ListFindingAggregators",
                "resource_mappings": {}
            }
        ],
        "SecurityHub.UpdateFindingAggregator": [
            {
                "action": "securityhub:UpdateFindingAggregator",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "finding-aggregator": "${FindingAggregatorArn}"
                }
            }
        ],
        "AppStream.AssociateApplicationFleet": [
            {
                "action": "appstream:AssociateApplicationFleet",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${FleetName}"
                    }
                },
                "resourcearn_mappings": {
                    "application": "${ApplicationArn}"
                }
            }
        ],
        "AppStream.CreateAppBlock": [
            {
                "action": "appstream:CreateAppBlock",
                "resource_mappings": {
                    "AppBlockName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.CreateApplication": [
            {
                "action": "appstream:CreateApplication",
                "resource_mappings": {
                    "AppBlockName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.DeleteAppBlock": [
            {
                "action": "appstream:DeleteAppBlock",
                "resource_mappings": {
                    "AppBlockName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.DeleteApplication": [
            {
                "action": "appstream:DeleteApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "AppStream.DescribeAppBlocks": [
            {
                "action": "appstream:DescribeAppBlocks",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-block": "${Arns[]}"
                }
            }
        ],
        "AppStream.DescribeApplicationFleetAssociations": [
            {
                "action": "appstream:DescribeApplicationFleetAssociations",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${FleetName}"
                    }
                },
                "resourcearn_mappings": {
                    "application": "${ApplicationArn}"
                }
            }
        ],
        "AppStream.DescribeApplications": [
            {
                "action": "appstream:DescribeApplications",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${Arns[]}"
                }
            }
        ],
        "AppStream.DisassociateApplicationFleet": [
            {
                "action": "appstream:DisassociateApplicationFleet",
                "resource_mappings": {
                    "FleetName": {
                        "template": "${FleetName}"
                    }
                },
                "resourcearn_mappings": {
                    "application": "${ApplicationArn}"
                }
            }
        ],
        "AppStream.UpdateApplication": [
            {
                "action": "appstream:UpdateApplication",
                "resource_mappings": {
                    "ApplicationName": {
                        "template": "${Name}"
                    }
                },
                "resourcearn_mappings": {
                    "app-block": "${AppBlockArn}"
                }
            }
        ],
        "Batch.CreateSchedulingPolicy": [
            {
                "action": "batch:CreateSchedulingPolicy",
                "resource_mappings": {
                    "SchedulingPolicyName": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Batch.DeleteSchedulingPolicy": [
            {
                "action": "batch:DeleteSchedulingPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "scheduling-policy": "${arn}"
                }
            }
        ],
        "Batch.DescribeSchedulingPolicies": [
            {
                "action": "batch:DescribeSchedulingPolicies",
                "resource_mappings": {}
            }
        ],
        "Batch.ListSchedulingPolicies": [
            {
                "action": "batch:ListSchedulingPolicies",
                "resource_mappings": {}
            }
        ],
        "Batch.UpdateSchedulingPolicy": [
            {
                "action": "batch:UpdateSchedulingPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "scheduling-policy": "${arn}"
                }
            }
        ],
        "EC2.DescribeCapacityReservationFleets": [
            {
                "action": "ec2:DescribeCapacityReservationFleets",
                "resource_mappings": {}
            }
        ],
        "ECR.BatchGetRepositoryScanningConfiguration": [
            {
                "action": "ecr:BatchGetRepositoryScanningConfiguration",
                "resource_mappings": {
                    "RepositoryName": {
                        "template": "${repositoryNames[]}"
                    }
                }
            }
        ],
        "ECR.CreatePullThroughCacheRule": [
            {
                "action": "ecr:CreatePullThroughCacheRule",
                "resource_mappings": {}
            }
        ],
        "ECR.DeletePullThroughCacheRule": [
            {
                "action": "ecr:DeletePullThroughCacheRule",
                "resource_mappings": {}
            }
        ],
        "ECR.DescribePullThroughCacheRules": [
            {
                "action": "ecr:DescribePullThroughCacheRules",
                "resource_mappings": {}
            }
        ],
        "ECR.GetRegistryScanningConfiguration": [
            {
                "action": "ecr:GetRegistryScanningConfiguration",
                "resource_mappings": {}
            }
        ],
        "ECR.PutRegistryScanningConfiguration": [
            {
                "action": "ecr:PutRegistryScanningConfiguration",
                "resource_mappings": {}
            }
        ],
        "Iot.DescribeManagedJobTemplate": [
            {
                "action": "iot:DescribeManagedJobTemplate",
                "resource_mappings": {
                    "JobTemplateId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Iot.ListManagedJobTemplates": [
            {
                "action": "iot:ListManagedJobTemplates",
                "resource_mappings": {}
            }
        ],
        "RDS.CreateCustomDBEngineVersion": [
            {
                "action": "rds:CreateCustomDBEngineVersion",
                "resource_mappings": {
                    "Engine": {
                        "template": "${Engine}"
                    },
                    "EngineVersion": {
                        "template": "${EngineVersion}"
                    },
                    "CustomDbEngineVersionId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "mediaimport:CreateDatabaseBinarySnapshot",
                "resource_mappings": {}
            },
            {
                "action": "rds:AddTagsToResource",
                "resource_mappings": {
                    "Engine": {
                        "template": "${Engine}"
                    },
                    "EngineVersion": {
                        "template": "${EngineVersion}"
                    },
                    "CustomDbEngineVersionId": {
                        "template": "*"
                    },
                    "DbClusterInstanceName": {
                        "template": "*"
                    },
                    "DbClusterEndpoint": {
                        "template": "*"
                    },
                    "ClusterParameterGroupName": {
                        "template": "*"
                    },
                    "ClusterSnapshotName": {
                        "template": "*"
                    },
                    "DbInstanceName": {
                        "template": "*"
                    },
                    "SubscriptionName": {
                        "template": "*"
                    },
                    "OptionGroupName": {
                        "template": "*"
                    },
                    "ParameterGroupName": {
                        "template": "*"
                    },
                    "DbProxyId": {
                        "template": "*"
                    },
                    "DbProxyEndpointId": {
                        "template": "*"
                    },
                    "ReservedDbInstanceName": {
                        "template": "*"
                    },
                    "SecurityGroupName": {
                        "template": "*"
                    },
                    "SnapshotName": {
                        "template": "*"
                    },
                    "SubnetGroupName": {
                        "template": "*"
                    },
                    "TargetGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "RDS.RebootDBCluster": [
            {
                "action": "rds:RebootDBCluster",
                "resource_mappings": {
                    "DbClusterInstanceName": {
                        "template": "${DBClusterIdentifier}"
                    }
                }
            },
            {
                "action": "rds:RebootDBInstance",
                "resource_mappings": {
                    "DbInstanceName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Rekognition.CreateDataset": [
            {
                "action": "rekognition:CreateDataset",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "project": "${ProjectArn}"
                }
            }
        ],
        "Rekognition.DeleteDataset": [
            {
                "action": "rekognition:DeleteDataset",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${DatasetArn}"
                }
            }
        ],
        "Rekognition.DescribeDataset": [
            {
                "action": "rekognition:DescribeDataset",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${DatasetArn}"
                }
            }
        ],
        "Rekognition.DistributeDatasetEntries": [
            {
                "action": "rekognition:DistributeDatasetEntries",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${Datasets[].Arn}"
                }
            }
        ],
        "Rekognition.ListDatasetEntries": [
            {
                "action": "rekognition:ListDatasetEntries",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${DatasetArn}"
                }
            }
        ],
        "Rekognition.ListDatasetLabels": [
            {
                "action": "rekognition:ListDatasetLabels",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${DatasetArn}"
                }
            }
        ],
        "Rekognition.UpdateDatasetEntries": [
            {
                "action": "rekognition:UpdateDatasetEntries",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "dataset": "${DatasetArn}"
                }
            }
        ],
        "SageMaker.BatchDescribeModelPackage": [
            {
                "action": "sagemaker:BatchDescribeModelPackage",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "model-package": "${ModelPackageArnList[]}"
                }
            }
        ],
        "SageMaker.CreateInferenceRecommendationsJob": [
            {
                "action": "sagemaker:CreateInferenceRecommendationsJob",
                "resource_mappings": {
                    "InferenceRecommendationsJobName": {
                        "template": "${JobName}"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${RoleArn}"
                }
            }
        ],
        "SageMaker.DescribeInferenceRecommendationsJob": [
            {
                "action": "sagemaker:DescribeInferenceRecommendationsJob",
                "resource_mappings": {
                    "InferenceRecommendationsJobName": {
                        "template": "${JobName}"
                    }
                }
            }
        ],
        "SageMaker.DescribeLineageGroup": [
            {
                "action": "sagemaker:DescribeLineageGroup",
                "resource_mappings": {}
            }
        ],
        "SageMaker.GetLineageGroupPolicy": [
            {
                "action": "sagemaker:GetLineageGroupPolicy",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListInferenceRecommendationsJobs": [
            {
                "action": "sagemaker:ListInferenceRecommendationsJobs",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListLineageGroups": [
            {
                "action": "sagemaker:ListLineageGroups",
                "resource_mappings": {}
            }
        ],
        "SageMaker.ListModelMetadata": [
            {
                "action": "sagemaker:ListModelMetadata",
                "resource_mappings": {}
            }
        ],
        "SageMaker.QueryLineage": [
            {
                "action": "sagemaker:QueryLineage",
                "resource_mappings": {}
            }
        ],
        "SageMaker.StopInferenceRecommendationsJob": [
            {
                "action": "sagemaker:StopInferenceRecommendationsJob",
                "resource_mappings": {
                    "InferenceRecommendationsJobName": {
                        "template": "${JobName}"
                    }
                }
            }
        ],
        "WorkMail.DeleteMobileDeviceAccessOverride": [
            {
                "action": "workmail:DeleteMobileDeviceAccessOverride",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DeregisterMailDomain": [
            {
                "action": "workmail:DeregisterMailDomain",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.GetMailDomain": [
            {
                "action": "workmail:GetMailDomain",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.GetMobileDeviceAccessOverride": [
            {
                "action": "workmail:GetMobileDeviceAccessOverride",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListMailDomains": [
            {
                "action": "workmail:ListMailDomains",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.ListMobileDeviceAccessOverrides": [
            {
                "action": "workmail:ListMobileDeviceAccessOverrides",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.PutMobileDeviceAccessOverride": [
            {
                "action": "workmail:PutMobileDeviceAccessOverride",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.RegisterMailDomain": [
            {
                "action": "workmail:RegisterMailDomain",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.UpdateDefaultMailDomain": [
            {
                "action": "workmail:UpdateDefaultMailDomain",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "Connect.CreateContactFlowModule": [
            {
                "action": "connect:CreateContactFlowModule",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowModuleId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.CreateSecurityProfile": [
            {
                "action": "connect:CreateSecurityProfile",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "SecurityProfileId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.DeleteContactFlow": [
            {
                "action": "connect:DeleteContactFlow",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowId": {
                        "template": "${ContactFlowId}"
                    }
                }
            }
        ],
        "Connect.DeleteContactFlowModule": [
            {
                "action": "connect:DeleteContactFlowModule",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowModuleId": {
                        "template": "${ContactFlowModuleId}"
                    }
                }
            }
        ],
        "Connect.DeleteSecurityProfile": [
            {
                "action": "connect:DeleteSecurityProfile",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "SecurityProfileId": {
                        "template": "${SecurityProfileId}"
                    }
                }
            }
        ],
        "Connect.DescribeContact": [
            {
                "action": "connect:DescribeContact",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "${ContactId}"
                    }
                }
            }
        ],
        "Connect.DescribeContactFlowModule": [
            {
                "action": "connect:DescribeContactFlowModule",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowModuleId": {
                        "template": "${ContactFlowModuleId}"
                    }
                }
            }
        ],
        "Connect.DescribeSecurityProfile": [
            {
                "action": "connect:DescribeSecurityProfile",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "SecurityProfileId": {
                        "template": "${SecurityProfileId}"
                    }
                }
            }
        ],
        "Connect.ListContactFlowModules": [
            {
                "action": "connect:ListContactFlowModules",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.ListContactReferences": [
            {
                "action": "connect:ListContactReferences",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "${ContactId}"
                    }
                }
            }
        ],
        "Connect.ListSecurityProfilePermissions": [
            {
                "action": "connect:ListSecurityProfilePermissions",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "SecurityProfileId": {
                        "template": "${SecurityProfileId}"
                    }
                }
            }
        ],
        "Connect.UpdateContact": [
            {
                "action": "connect:UpdateContact",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "${ContactId}"
                    }
                }
            }
        ],
        "Connect.UpdateContactFlowMetadata": [
            {
                "action": "connect:UpdateContactFlowMetadata",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowId": {
                        "template": "${ContactFlowId}"
                    }
                }
            }
        ],
        "Connect.UpdateContactFlowModuleMetadata": [
            {
                "action": "connect:UpdateContactFlowModuleMetadata",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactFlowModuleId": {
                        "template": "${ContactFlowModuleId}"
                    }
                }
            }
        ],
        "Connect.UpdateContactSchedule": [
            {
                "action": "connect:UpdateContactSchedule",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "ContactId": {
                        "template": "${ContactId}"
                    }
                }
            }
        ],
        "Connect.UpdateSecurityProfile": [
            {
                "action": "connect:UpdateSecurityProfile",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "SecurityProfileId": {
                        "template": "${SecurityProfileId}"
                    }
                }
            }
        ],
        "FSx.CreateDataRepositoryAssociation": [
            {
                "action": "fsx:CreateDataRepositoryAssociation",
                "resource_mappings": {
                    "DataRepositoryAssociationId": {
                        "template": "*"
                    },
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            },
            {
                "action": "fsx:TagResource",
                "resource_mappings": {
                    "DataRepositoryAssociationId": {
                        "template": "*"
                    },
                    "BackupId": {
                        "template": "*"
                    },
                    "FileSystemId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "StorageVirtualMachineId": {
                        "template": "*"
                    },
                    "TaskId": {
                        "template": "*"
                    }
                }
            }
        ],
        "FSx.CreateSnapshot": [
            {
                "action": "fsx:CreateSnapshot",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "${VolumeId}"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "FileSystemId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "fsx:TagResource",
                "resource_mappings": {
                    "DataRepositoryAssociationId": {
                        "template": "*"
                    },
                    "BackupId": {
                        "template": "*"
                    },
                    "FileSystemId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "${VolumeId}"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "StorageVirtualMachineId": {
                        "template": "*"
                    },
                    "TaskId": {
                        "template": "*"
                    }
                }
            }
        ],
        "FSx.DeleteDataRepositoryAssociation": [
            {
                "action": "fsx:DeleteDataRepositoryAssociation",
                "resource_mappings": {
                    "DataRepositoryAssociationId": {
                        "template": "${AssociationId}"
                    }
                }
            }
        ],
        "FSx.DeleteSnapshot": [
            {
                "action": "fsx:DeleteSnapshot",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "FSx.DescribeDataRepositoryAssociations": [
            {
                "action": "fsx:DescribeDataRepositoryAssociations",
                "resource_mappings": {}
            }
        ],
        "FSx.DescribeSnapshots": [
            {
                "action": "fsx:DescribeSnapshots",
                "resource_mappings": {}
            }
        ],
        "FSx.RestoreVolumeFromSnapshot": [
            {
                "action": "fsx:RestoreVolumeFromSnapshot",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "${VolumeId}"
                    },
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    },
                    "FileSystemId": {
                        "template": "*"
                    }
                }
            }
        ],
        "FSx.UpdateDataRepositoryAssociation": [
            {
                "action": "fsx:UpdateDataRepositoryAssociation",
                "resource_mappings": {
                    "DataRepositoryAssociationId": {
                        "template": "${AssociationId}"
                    }
                }
            }
        ],
        "FSx.UpdateSnapshot": [
            {
                "action": "fsx:UpdateSnapshot",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "Kafka.UpdateConnectivity": [
            {
                "action": "kafka:UpdateConnectivity",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeRouteTables",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            }
        ],
        "Personalize.CreateBatchSegmentJob": [
            {
                "action": "personalize:CreateBatchSegmentJob",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Personalize.CreateRecommender": [
            {
                "action": "personalize:CreateRecommender",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Personalize.DeleteRecommender": [
            {
                "action": "personalize:DeleteRecommender",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recommender": "${recommenderArn}"
                }
            }
        ],
        "Personalize.DescribeBatchSegmentJob": [
            {
                "action": "personalize:DescribeBatchSegmentJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "batchSegmentJob": "${batchSegmentJobArn}"
                }
            }
        ],
        "Personalize.DescribeRecommender": [
            {
                "action": "personalize:DescribeRecommender",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recommender": "${recommenderArn}"
                }
            }
        ],
        "Personalize.ListBatchSegmentJobs": [
            {
                "action": "personalize:ListBatchSegmentJobs",
                "resource_mappings": {}
            }
        ],
        "Personalize.ListRecommenders": [
            {
                "action": "personalize:ListRecommenders",
                "resource_mappings": {}
            }
        ],
        "Personalize.UpdateRecommender": [
            {
                "action": "personalize:UpdateRecommender",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "recommender": "${recommenderArn}"
                }
            }
        ],
        "ForecastService.CreateAutoPredictor": [
            {
                "action": "forecast:CreateAutoPredictor",
                "resource_mappings": {}
            }
        ],
        "ForecastService.CreateExplainability": [
            {
                "action": "forecast:CreateExplainability",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "forecast": "${ResourceArn}"
                }
            }
        ],
        "ForecastService.CreateExplainabilityExport": [
            {
                "action": "forecast:CreateExplainabilityExport",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "explainability": "${ExplainabilityArn}"
                }
            }
        ],
        "ForecastService.DeleteExplainability": [
            {
                "action": "forecast:DeleteExplainability",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "explainability": "${ExplainabilityArn}"
                }
            }
        ],
        "ForecastService.DeleteExplainabilityExport": [
            {
                "action": "forecast:DeleteExplainabilityExport",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "explainabilityExport": "${ExplainabilityExportArn}"
                }
            }
        ],
        "ForecastService.DescribeAutoPredictor": [
            {
                "action": "forecast:DescribeAutoPredictor",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "predictor": "${PredictorArn}"
                }
            }
        ],
        "ForecastService.DescribeExplainabilityExport": [
            {
                "action": "forecast:DescribeExplainabilityExport",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "explainabilityExport": "${ExplainabilityExportArn}"
                }
            }
        ],
        "ForecastService.ListExplainabilities": [
            {
                "action": "forecast:ListExplainabilities",
                "resource_mappings": {}
            }
        ],
        "ForecastService.ListExplainabilityExports": [
            {
                "action": "forecast:ListExplainabilityExports",
                "resource_mappings": {}
            }
        ],
        "DataExchange.SendApiAsset": [
            {
                "action": "dataexchange:SendApiAsset",
                "resource_mappings": {
                    "DataSetId": {
                        "template": "${DataSetId}"
                    },
                    "RevisionId": {
                        "template": "${RevisionId}"
                    },
                    "AssetId": {
                        "template": "${AssetId}"
                    }
                }
            }
        ],
        "WAFV2.GetManagedRuleSet": [
            {
                "action": "wafv2:GetManagedRuleSet",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.ListManagedRuleSets": [
            {
                "action": "wafv2:ListManagedRuleSets",
                "resource_mappings": {}
            }
        ],
        "WAFV2.PutManagedRuleSetVersions": [
            {
                "action": "wafv2:PutManagedRuleSetVersions",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "WAFV2.UpdateManagedRuleSetVersionExpiryDate": [
            {
                "action": "wafv2:UpdateManagedRuleSetVersionExpiryDate",
                "resource_mappings": {
                    "Scope": {
                        "template": "${Scope}"
                    },
                    "Name": {
                        "template": "${Name}"
                    },
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "ComputeOptimizer.DeleteRecommendationPreferences": [
            {
                "action": "compute-optimizer:DeleteRecommendationPreferences",
                "resource_mappings": {}
            },
            {
                "action": "autoscaling:DescribeAutoScalingGroups",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.GetEffectiveRecommendationPreferences": [
            {
                "action": "compute-optimizer:GetEffectiveRecommendationPreferences",
                "resource_mappings": {}
            },
            {
                "action": "autoscaling:DescribeAutoScalingGroups",
                "resource_mappings": {}
            },
            {
                "action": "autoscaling:DescribeAutoScalingInstances",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.GetRecommendationPreferences": [
            {
                "action": "compute-optimizer:GetRecommendationPreferences",
                "resource_mappings": {}
            }
        ],
        "ComputeOptimizer.PutRecommendationPreferences": [
            {
                "action": "compute-optimizer:PutRecommendationPreferences",
                "resource_mappings": {}
            },
            {
                "action": "autoscaling:DescribeAutoScalingGroups",
                "resource_mappings": {}
            },
            {
                "action": "autoscaling:DescribeAutoScalingInstances",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            }
        ],
        "NetworkManager.AcceptAttachment": [
            {
                "action": "networkmanager:AcceptAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AttachmentId}"
                    }
                }
            }
        ],
        "NetworkManager.AssociateConnectPeer": [
            {
                "action": "networkmanager:AssociateConnectPeer",
                "resource_mappings": {
                    "GlobalNetworkId": {
                        "template": "${GlobalNetworkId}"
                    },
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.CreateConnectAttachment": [
            {
                "action": "networkmanager:CreateConnectAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.CreateConnectPeer": [
            {
                "action": "networkmanager:CreateConnectPeer",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ConnectAttachmentId}"
                    }
                }
            }
        ],
        "NetworkManager.CreateCoreNetwork": [
            {
                "action": "networkmanager:CreateCoreNetwork",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.CreateSiteToSiteVpnAttachment": [
            {
                "action": "networkmanager:CreateSiteToSiteVpnAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.CreateVpcAttachment": [
            {
                "action": "networkmanager:CreateVpcAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteAttachment": [
            {
                "action": "networkmanager:DeleteAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AttachmentId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteConnectPeer": [
            {
                "action": "networkmanager:DeleteConnectPeer",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ConnectPeerId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteCoreNetwork": [
            {
                "action": "networkmanager:DeleteCoreNetwork",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteCoreNetworkPolicyVersion": [
            {
                "action": "networkmanager:DeleteCoreNetworkPolicyVersion",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.DeleteResourcePolicy": [
            {
                "action": "networkmanager:DeleteResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "core-network": "${ResourceArn}"
                }
            }
        ],
        "NetworkManager.DisassociateConnectPeer": [
            {
                "action": "networkmanager:DisassociateConnectPeer",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.ExecuteCoreNetworkChangeSet": [
            {
                "action": "networkmanager:ExecuteCoreNetworkChangeSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetConnectAttachment": [
            {
                "action": "networkmanager:GetConnectAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AttachmentId}"
                    }
                }
            }
        ],
        "NetworkManager.GetConnectPeer": [
            {
                "action": "networkmanager:GetConnectPeer",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ConnectPeerId}"
                    }
                }
            }
        ],
        "NetworkManager.GetConnectPeerAssociations": [
            {
                "action": "networkmanager:GetConnectPeerAssociations",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetCoreNetwork": [
            {
                "action": "networkmanager:GetCoreNetwork",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetCoreNetworkChangeSet": [
            {
                "action": "networkmanager:GetCoreNetworkChangeSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetCoreNetworkPolicy": [
            {
                "action": "networkmanager:GetCoreNetworkPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetNetworkResourceCounts": [
            {
                "action": "networkmanager:GetNetworkResourceCounts",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetNetworkResourceRelationships": [
            {
                "action": "networkmanager:GetNetworkResourceRelationships",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetNetworkResources": [
            {
                "action": "networkmanager:GetNetworkResources",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetNetworkRoutes": [
            {
                "action": "networkmanager:GetNetworkRoutes",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetNetworkTelemetry": [
            {
                "action": "networkmanager:GetNetworkTelemetry",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetResourcePolicy": [
            {
                "action": "networkmanager:GetResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "core-network": "${ResourceArn}"
                }
            }
        ],
        "NetworkManager.GetRouteAnalysis": [
            {
                "action": "networkmanager:GetRouteAnalysis",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.GetSiteToSiteVpnAttachment": [
            {
                "action": "networkmanager:GetSiteToSiteVpnAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AttachmentId}"
                    }
                }
            }
        ],
        "NetworkManager.GetVpcAttachment": [
            {
                "action": "networkmanager:GetVpcAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AttachmentId}"
                    }
                }
            }
        ],
        "NetworkManager.ListAttachments": [
            {
                "action": "networkmanager:ListAttachments",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "NetworkManager.ListConnectPeers": [
            {
                "action": "networkmanager:ListConnectPeers",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "NetworkManager.ListCoreNetworkPolicyVersions": [
            {
                "action": "networkmanager:ListCoreNetworkPolicyVersions",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.ListCoreNetworks": [
            {
                "action": "networkmanager:ListCoreNetworks",
                "resource_mappings": {}
            }
        ],
        "NetworkManager.PutCoreNetworkPolicy": [
            {
                "action": "networkmanager:PutCoreNetworkPolicy",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.PutResourcePolicy": [
            {
                "action": "networkmanager:PutResourcePolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "core-network": "${ResourceArn}"
                }
            }
        ],
        "NetworkManager.RejectAttachment": [
            {
                "action": "networkmanager:RejectAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AttachmentId}"
                    }
                }
            }
        ],
        "NetworkManager.RestoreCoreNetworkPolicyVersion": [
            {
                "action": "networkmanager:RestoreCoreNetworkPolicyVersion",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.StartRouteAnalysis": [
            {
                "action": "networkmanager:StartRouteAnalysis",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.UpdateCoreNetwork": [
            {
                "action": "networkmanager:UpdateCoreNetwork",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${CoreNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.UpdateNetworkResourceMetadata": [
            {
                "action": "networkmanager:UpdateNetworkResourceMetadata",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${GlobalNetworkId}"
                    }
                }
            }
        ],
        "NetworkManager.UpdateVpcAttachment": [
            {
                "action": "networkmanager:UpdateVpcAttachment",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${AttachmentId}"
                    }
                }
            }
        ],
        "Outposts.CreateOrder": [
            {
                "action": "outposts:CreateOrder",
                "resource_mappings": {}
            }
        ],
        "IoTSiteWise.AssociateTimeSeriesToAssetProperty": [
            {
                "action": "iotsitewise:AssociateTimeSeriesToAssetProperty",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    },
                    "TimeSeriesId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTSiteWise.DeleteTimeSeries": [
            {
                "action": "iotsitewise:DeleteTimeSeries",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    },
                    "TimeSeriesId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTSiteWise.DescribeTimeSeries": [
            {
                "action": "iotsitewise:DescribeTimeSeries",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    },
                    "TimeSeriesId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTSiteWise.DisassociateTimeSeriesFromAssetProperty": [
            {
                "action": "iotsitewise:DisassociateTimeSeriesFromAssetProperty",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    },
                    "TimeSeriesId": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTSiteWise.ListTimeSeries": [
            {
                "action": "iotsitewise:ListTimeSeries",
                "resource_mappings": {
                    "AssetId": {
                        "template": "${assetId}"
                    }
                }
            }
        ],
        "IVS.GetStreamSession": [
            {
                "action": "ivs:GetStreamSession",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "${channelArn}"
                }
            }
        ],
        "IVS.ListStreamSessions": [
            {
                "action": "ivs:ListStreamSessions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Channel": "${channelArn}"
                }
            }
        ],
        "Braket.CancelJob": [
            {
                "action": "braket:CancelJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "job": "${jobArn}"
                }
            }
        ],
        "Braket.CreateJob": [
            {
                "action": "braket:CreateJob",
                "resource_mappings": {}
            }
        ],
        "Braket.GetJob": [
            {
                "action": "braket:GetJob",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "job": "${jobArn}"
                }
            }
        ],
        "Braket.SearchJobs": [
            {
                "action": "braket:SearchJobs",
                "resource_mappings": {}
            }
        ],
        "TimestreamQuery.CreateScheduledQuery": [
            {
                "action": "timestream:CreateScheduledQuery",
                "resource_mappings": {}
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "role": "${ScheduledQueryExecutionRoleArn}"
                }
            }
        ],
        "TimestreamQuery.DeleteScheduledQuery": [
            {
                "action": "timestream:DeleteScheduledQuery",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "scheduled-query": "${ScheduledQueryArn}"
                }
            }
        ],
        "TimestreamQuery.DescribeScheduledQuery": [
            {
                "action": "timestream:DescribeScheduledQuery",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "scheduled-query": "${ScheduledQueryArn}"
                }
            }
        ],
        "TimestreamQuery.ExecuteScheduledQuery": [
            {
                "action": "timestream:ExecuteScheduledQuery",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "scheduled-query": "${ScheduledQueryArn}"
                }
            }
        ],
        "TimestreamQuery.ListScheduledQueries": [
            {
                "action": "timestream:ListScheduledQueries",
                "resource_mappings": {}
            }
        ],
        "TimestreamQuery.ListTagsForResource": [
            {
                "action": "timestream:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "database": "%%iftemplatematch%${ResourceARN}%%",
                    "scheduled-query": "%%iftemplatematch%${ResourceARN}%%",
                    "table": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "TimestreamQuery.TagResource": [
            {
                "action": "timestream:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "database": "%%iftemplatematch%${ResourceARN}%%",
                    "scheduled-query": "%%iftemplatematch%${ResourceARN}%%",
                    "table": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "TimestreamQuery.UntagResource": [
            {
                "action": "timestream:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "database": "%%iftemplatematch%${ResourceARN}%%",
                    "scheduled-query": "%%iftemplatematch%${ResourceARN}%%",
                    "table": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "TimestreamQuery.UpdateScheduledQuery": [
            {
                "action": "timestream:UpdateScheduledQuery",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "scheduled-query": "${ScheduledQueryArn}"
                }
            }
        ],
        "DataBrew.CreateRuleset": [
            {
                "action": "databrew:CreateRuleset",
                "resource_mappings": {}
            }
        ],
        "DataBrew.DeleteRuleset": [
            {
                "action": "databrew:DeleteRuleset",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataBrew.DescribeRuleset": [
            {
                "action": "databrew:DescribeRuleset",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DataBrew.ListRulesets": [
            {
                "action": "databrew:ListRulesets",
                "resource_mappings": {}
            }
        ],
        "DataBrew.UpdateRuleset": [
            {
                "action": "databrew:UpdateRuleset",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "DevOpsGuru.DescribeOrganizationHealth": [
            {
                "action": "devops-guru:DescribeOrganizationHealth",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.DescribeOrganizationOverview": [
            {
                "action": "devops-guru:DescribeOrganizationOverview",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.DescribeOrganizationResourceCollectionHealth": [
            {
                "action": "devops-guru:DescribeOrganizationResourceCollectionHealth",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.ListOrganizationInsights": [
            {
                "action": "devops-guru:ListOrganizationInsights",
                "resource_mappings": {}
            }
        ],
        "DevOpsGuru.SearchOrganizationInsights": [
            {
                "action": "devops-guru:SearchOrganizationInsights",
                "resource_mappings": {}
            }
        ],
        "CustomerProfiles.GetAutoMergingPreview": [
            {
                "action": "profile:GetAutoMergingPreview",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.GetIdentityResolutionJob": [
            {
                "action": "profile:GetIdentityResolutionJob",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "CustomerProfiles.ListIdentityResolutionJobs": [
            {
                "action": "profile:ListIdentityResolutionJobs",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "AuditManager.GetInsights": [
            {
                "action": "auditmanager:GetInsights",
                "resource_mappings": {}
            }
        ],
        "AuditManager.GetInsightsByAssessment": [
            {
                "action": "auditmanager:GetInsightsByAssessment",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListAssessmentControlInsightsByControlDomain": [
            {
                "action": "auditmanager:ListAssessmentControlInsightsByControlDomain",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListControlDomainInsights": [
            {
                "action": "auditmanager:ListControlDomainInsights",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListControlDomainInsightsByAssessment": [
            {
                "action": "auditmanager:ListControlDomainInsightsByAssessment",
                "resource_mappings": {}
            }
        ],
        "AuditManager.ListControlInsightsByControlDomain": [
            {
                "action": "auditmanager:ListControlInsightsByControlDomain",
                "resource_mappings": {}
            }
        ],
        "WellArchitected.CreateLensShare": [
            {
                "action": "wellarchitected:CreateLensShare",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "WellArchitected.CreateLensVersion": [
            {
                "action": "wellarchitected:CreateLensVersion",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "WellArchitected.DeleteLens": [
            {
                "action": "wellarchitected:DeleteLens",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "WellArchitected.DeleteLensShare": [
            {
                "action": "wellarchitected:DeleteLensShare",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "WellArchitected.ExportLens": [
            {
                "action": "wellarchitected:ExportLens",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "WellArchitected.GetLens": [
            {
                "action": "wellarchitected:GetLens",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "WellArchitected.ImportLens": [
            {
                "action": "wellarchitected:ImportLens",
                "resource_mappings": {}
            }
        ],
        "WellArchitected.ListLensShares": [
            {
                "action": "wellarchitected:ListLensShares",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeBotRecommendation": [
            {
                "action": "lex:DescribeBotRecommendation",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.ListAggregatedUtterances": [
            {
                "action": "lex:ListAggregatedUtterances",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.ListBotRecommendations": [
            {
                "action": "lex:ListBotRecommendations",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.ListRecommendedIntents": [
            {
                "action": "lex:ListRecommendedIntents",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.SearchAssociatedTranscripts": [
            {
                "action": "lex:SearchAssociatedTranscripts",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.StartBotRecommendation": [
            {
                "action": "lex:StartBotRecommendation",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.UpdateBotRecommendation": [
            {
                "action": "lex:UpdateBotRecommendation",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "Mgn.DeleteVcenterClient": [
            {
                "action": "mgn:DeleteVcenterClient",
                "resource_mappings": {
                    "VcenterClientID": {
                        "template": "${vcenterClientID}"
                    }
                }
            }
        ],
        "Mgn.DescribeVcenterClients": [
            {
                "action": "mgn:DescribeVcenterClients",
                "resource_mappings": {}
            }
        ],
        "Mgn.StartReplication": [
            {
                "action": "mgn:StartReplication",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Mgn.UpdateSourceServerReplicationType": [
            {
                "action": "mgn:UpdateSourceServerReplicationType",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Nimble.StartStreamingSession": [
            {
                "action": "nimble:StartStreamingSession",
                "resource_mappings": {
                    "StreamingSessionId": {
                        "template": "${sessionId}"
                    }
                }
            },
            {
                "action": "nimble:GetLaunchProfile",
                "resource_mappings": {
                    "LaunchProfileId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "nimble:GetLaunchProfileMember",
                "resource_mappings": {
                    "LaunchProfileId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Nimble.StopStreamingSession": [
            {
                "action": "nimble:StopStreamingSession",
                "resource_mappings": {
                    "StreamingSessionId": {
                        "template": "${sessionId}"
                    }
                }
            },
            {
                "action": "nimble:GetLaunchProfile",
                "resource_mappings": {
                    "LaunchProfileId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.AddDraftAppVersionResourceMappings": [
            {
                "action": "resiliencehub:AddDraftAppVersionResourceMappings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            },
            {
                "action": "cloudformation:DescribeStacks",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "cloudformation:ListStackResources",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "resource-groups:GetGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "resource-groups:ListGroupResources",
                "resource_mappings": {
                    "GroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "servicecatalog:GetApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "servicecatalog:ListAssociatedResources",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.CreateApp": [
            {
                "action": "resiliencehub:CreateApp",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resiliency-policy": "${policyArn}"
                }
            }
        ],
        "Resiliencehub.CreateRecommendationTemplate": [
            {
                "action": "resiliencehub:CreateRecommendationTemplate",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:CreateBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:ListBucket",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "s3:PutObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "*"
                    },
                    "ObjectName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.CreateResiliencyPolicy": [
            {
                "action": "resiliencehub:CreateResiliencyPolicy",
                "resource_mappings": {}
            }
        ],
        "Resiliencehub.DeleteApp": [
            {
                "action": "resiliencehub:DeleteApp",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.DeleteAppAssessment": [
            {
                "action": "resiliencehub:DeleteAppAssessment",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.DeleteRecommendationTemplate": [
            {
                "action": "resiliencehub:DeleteRecommendationTemplate",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.DeleteResiliencyPolicy": [
            {
                "action": "resiliencehub:DeleteResiliencyPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resiliency-policy": "${policyArn}"
                }
            }
        ],
        "Resiliencehub.DescribeApp": [
            {
                "action": "resiliencehub:DescribeApp",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.DescribeAppAssessment": [
            {
                "action": "resiliencehub:DescribeAppAssessment",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.DescribeAppVersionResourcesResolutionStatus": [
            {
                "action": "resiliencehub:DescribeAppVersionResourcesResolutionStatus",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.DescribeAppVersionTemplate": [
            {
                "action": "resiliencehub:DescribeAppVersionTemplate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.DescribeDraftAppVersionResourcesImportStatus": [
            {
                "action": "resiliencehub:DescribeDraftAppVersionResourcesImportStatus",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.DescribeResiliencyPolicy": [
            {
                "action": "resiliencehub:DescribeResiliencyPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resiliency-policy": "${policyArn}"
                }
            }
        ],
        "Resiliencehub.ImportResourcesToDraftAppVersion": [
            {
                "action": "resiliencehub:ImportResourcesToDraftAppVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            },
            {
                "action": "cloudformation:DescribeStacks",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "cloudformation:ListStackResources",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "resource-groups:GetGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "resource-groups:ListGroupResources",
                "resource_mappings": {
                    "GroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "servicecatalog:GetApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "servicecatalog:ListAssociatedResources",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.ListAlarmRecommendations": [
            {
                "action": "resiliencehub:ListAlarmRecommendations",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.ListAppAssessments": [
            {
                "action": "resiliencehub:ListAppAssessments",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.ListAppComponentCompliances": [
            {
                "action": "resiliencehub:ListAppComponentCompliances",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.ListAppComponentRecommendations": [
            {
                "action": "resiliencehub:ListAppComponentRecommendations",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.ListAppVersionResourceMappings": [
            {
                "action": "resiliencehub:ListAppVersionResourceMappings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.ListAppVersionResources": [
            {
                "action": "resiliencehub:ListAppVersionResources",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.ListAppVersions": [
            {
                "action": "resiliencehub:ListAppVersions",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.ListApps": [
            {
                "action": "resiliencehub:ListApps",
                "resource_mappings": {}
            }
        ],
        "Resiliencehub.ListRecommendationTemplates": [
            {
                "action": "resiliencehub:ListRecommendationTemplates",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.ListResiliencyPolicies": [
            {
                "action": "resiliencehub:ListResiliencyPolicies",
                "resource_mappings": {}
            }
        ],
        "Resiliencehub.ListSopRecommendations": [
            {
                "action": "resiliencehub:ListSopRecommendations",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.ListSuggestedResiliencyPolicies": [
            {
                "action": "resiliencehub:ListSuggestedResiliencyPolicies",
                "resource_mappings": {}
            }
        ],
        "Resiliencehub.ListTagsForResource": [
            {
                "action": "resiliencehub:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Resiliencehub.ListTestRecommendations": [
            {
                "action": "resiliencehub:ListTestRecommendations",
                "resource_mappings": {
                    "AppID": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.ListUnsupportedAppVersionResources": [
            {
                "action": "resiliencehub:ListUnsupportedAppVersionResources",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.PublishAppVersion": [
            {
                "action": "resiliencehub:PublishAppVersion",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.PutDraftAppVersionTemplate": [
            {
                "action": "resiliencehub:PutDraftAppVersionTemplate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.RemoveDraftAppVersionResourceMappings": [
            {
                "action": "resiliencehub:RemoveDraftAppVersionResourceMappings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.ResolveAppVersionResources": [
            {
                "action": "resiliencehub:ResolveAppVersionResources",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            },
            {
                "action": "cloudformation:DescribeStacks",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "cloudformation:ListStackResources",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "resource-groups:GetGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "resource-groups:ListGroupResources",
                "resource_mappings": {
                    "GroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "servicecatalog:GetApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "servicecatalog:ListAssociatedResources",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.StartAppAssessment": [
            {
                "action": "resiliencehub:StartAppAssessment",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            },
            {
                "action": "cloudformation:DescribeStacks",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "cloudformation:ListStackResources",
                "resource_mappings": {
                    "StackName": {
                        "template": "*"
                    },
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "cloudwatch:DescribeAlarms",
                "resource_mappings": {
                    "AlarmName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "cloudwatch:GetMetricData",
                "resource_mappings": {}
            },
            {
                "action": "cloudwatch:GetMetricStatistics",
                "resource_mappings": {}
            },
            {
                "action": "cloudwatch:PutMetricData",
                "resource_mappings": {}
            },
            {
                "action": "fis:GetExperimentTemplate",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "fis:ListExperimentTemplates",
                "resource_mappings": {}
            },
            {
                "action": "fis:ListExperiments",
                "resource_mappings": {}
            },
            {
                "action": "resource-groups:GetGroup",
                "resource_mappings": {
                    "GroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "resource-groups:ListGroupResources",
                "resource_mappings": {
                    "GroupName": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "servicecatalog:GetApplication",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "servicecatalog:ListAssociatedResources",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ssm:GetParametersByPath",
                "resource_mappings": {
                    "ParameterNameWithoutLeadingSlash": {
                        "template": "*"
                    }
                }
            }
        ],
        "Resiliencehub.TagResource": [
            {
                "action": "resiliencehub:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-assessment": "%%iftemplatematch%${resourceArn}%%",
                    "application": "%%iftemplatematch%${resourceArn}%%",
                    "recommendation-template": "%%iftemplatematch%${resourceArn}%%",
                    "resiliency-policy": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Resiliencehub.UntagResource": [
            {
                "action": "resiliencehub:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-assessment": "%%iftemplatematch%${resourceArn}%%",
                    "application": "%%iftemplatematch%${resourceArn}%%",
                    "recommendation-template": "%%iftemplatematch%${resourceArn}%%",
                    "resiliency-policy": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "Resiliencehub.UpdateApp": [
            {
                "action": "resiliencehub:UpdateApp",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "${appArn}"
                }
            }
        ],
        "Resiliencehub.UpdateResiliencyPolicy": [
            {
                "action": "resiliencehub:UpdateResiliencyPolicy",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "resiliency-policy": "${policyArn}"
                }
            }
        ],
        "MigrationHubStrategy.GetApplicationComponentDetails": [
            {
                "action": "migrationhub-strategy:GetApplicationComponentDetails",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.GetApplicationComponentStrategies": [
            {
                "action": "migrationhub-strategy:GetApplicationComponentStrategies",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.GetAssessment": [
            {
                "action": "migrationhub-strategy:GetAssessment",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.GetImportFileTask": [
            {
                "action": "migrationhub-strategy:GetImportFileTask",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.GetPortfolioPreferences": [
            {
                "action": "migrationhub-strategy:GetPortfolioPreferences",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.GetPortfolioSummary": [
            {
                "action": "migrationhub-strategy:GetPortfolioSummary",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.GetRecommendationReportDetails": [
            {
                "action": "migrationhub-strategy:GetRecommendationReportDetails",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.GetServerDetails": [
            {
                "action": "migrationhub-strategy:GetServerDetails",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.GetServerStrategies": [
            {
                "action": "migrationhub-strategy:GetServerStrategies",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.ListApplicationComponents": [
            {
                "action": "migrationhub-strategy:ListApplicationComponents",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.ListCollectors": [
            {
                "action": "migrationhub-strategy:ListCollectors",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.ListImportFileTask": [
            {
                "action": "migrationhub-strategy:ListImportFileTask",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.ListServers": [
            {
                "action": "migrationhub-strategy:ListServers",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.PutPortfolioPreferences": [
            {
                "action": "migrationhub-strategy:PutPortfolioPreferences",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.StartAssessment": [
            {
                "action": "migrationhub-strategy:StartAssessment",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.StartImportFileTask": [
            {
                "action": "migrationhub-strategy:StartImportFileTask",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.StartRecommendationReportGeneration": [
            {
                "action": "migrationhub-strategy:StartRecommendationReportGeneration",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.StopAssessment": [
            {
                "action": "migrationhub-strategy:StopAssessment",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.UpdateApplicationComponentConfig": [
            {
                "action": "migrationhub-strategy:UpdateApplicationComponentConfig",
                "resource_mappings": {}
            }
        ],
        "MigrationHubStrategy.UpdateServerConfig": [
            {
                "action": "migrationhub-strategy:UpdateServerConfig",
                "resource_mappings": {}
            }
        ],
        "Drs.CreateReplicationConfigurationTemplate": [
            {
                "action": "drs:CreateReplicationConfigurationTemplate",
                "resource_mappings": {}
            }
        ],
        "Drs.DeleteJob": [
            {
                "action": "drs:DeleteJob",
                "resource_mappings": {
                    "JobID": {
                        "template": "${jobID}"
                    }
                }
            }
        ],
        "Drs.DeleteRecoveryInstance": [
            {
                "action": "drs:DeleteRecoveryInstance",
                "resource_mappings": {
                    "RecoveryInstanceID": {
                        "template": "${recoveryInstanceID}"
                    }
                }
            }
        ],
        "Drs.DeleteReplicationConfigurationTemplate": [
            {
                "action": "drs:DeleteReplicationConfigurationTemplate",
                "resource_mappings": {
                    "ReplicationConfigurationTemplateID": {
                        "template": "${replicationConfigurationTemplateID}"
                    }
                }
            }
        ],
        "Drs.DeleteSourceServer": [
            {
                "action": "drs:DeleteSourceServer",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Drs.DescribeJobLogItems": [
            {
                "action": "drs:DescribeJobLogItems",
                "resource_mappings": {
                    "JobID": {
                        "template": "${jobID}"
                    }
                }
            }
        ],
        "Drs.DescribeJobs": [
            {
                "action": "drs:DescribeJobs",
                "resource_mappings": {}
            }
        ],
        "Drs.DescribeRecoveryInstances": [
            {
                "action": "drs:DescribeRecoveryInstances",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            }
        ],
        "Drs.DescribeRecoverySnapshots": [
            {
                "action": "drs:DescribeRecoverySnapshots",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Drs.DescribeReplicationConfigurationTemplates": [
            {
                "action": "drs:DescribeReplicationConfigurationTemplates",
                "resource_mappings": {}
            }
        ],
        "Drs.DescribeSourceServers": [
            {
                "action": "drs:DescribeSourceServers",
                "resource_mappings": {}
            }
        ],
        "Drs.DisconnectRecoveryInstance": [
            {
                "action": "drs:DisconnectRecoveryInstance",
                "resource_mappings": {
                    "RecoveryInstanceID": {
                        "template": "${recoveryInstanceID}"
                    }
                }
            }
        ],
        "Drs.DisconnectSourceServer": [
            {
                "action": "drs:DisconnectSourceServer",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Drs.GetFailbackReplicationConfiguration": [
            {
                "action": "drs:GetFailbackReplicationConfiguration",
                "resource_mappings": {
                    "RecoveryInstanceID": {
                        "template": "${recoveryInstanceID}"
                    }
                }
            }
        ],
        "Drs.GetLaunchConfiguration": [
            {
                "action": "drs:GetLaunchConfiguration",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Drs.GetReplicationConfiguration": [
            {
                "action": "drs:GetReplicationConfiguration",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Drs.InitializeService": [
            {
                "action": "drs:InitializeService",
                "resource_mappings": {}
            },
            {
                "action": "iam:AddRoleToInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:GetInstanceProfile",
                "resource_mappings": {
                    "InstanceProfileNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Drs.ListTagsForResource": [
            {
                "action": "drs:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Drs.RetryDataReplication": [
            {
                "action": "drs:RetryDataReplication",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Drs.StartFailbackLaunch": [
            {
                "action": "drs:StartFailbackLaunch",
                "resource_mappings": {
                    "RecoveryInstanceID": {
                        "template": "${recoveryInstanceIDs[]}"
                    }
                }
            }
        ],
        "Drs.StartRecovery": [
            {
                "action": "drs:StartRecovery",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServers[].sourceServerID}"
                    }
                }
            },
            {
                "action": "drs:CreateRecoveryInstanceForDrs",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServers[].sourceServerID}"
                    }
                }
            },
            {
                "action": "drs:ListTagsForResource",
                "resource_mappings": {}
            },
            {
                "action": "ec2:AttachVolume",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:AuthorizeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:AuthorizeSecurityGroupIngress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateLaunchTemplate",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateLaunchTemplateVersion",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteLaunchTemplateVersions",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteSnapshot",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeAccountAttributes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeAvailabilityZones",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeImages",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeInstanceStatus",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstanceTypes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeLaunchTemplateVersions",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeLaunchTemplates",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSnapshots",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVolumes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DetachVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifyInstanceAttribute",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifyLaunchTemplate",
                "resource_mappings": {
                    "LaunchTemplateId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:RevokeSecurityGroupEgress",
                "resource_mappings": {
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:RunInstances",
                "resource_mappings": {
                    "ImageId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "ElasticInferenceAcceleratorId": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:StartInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:StopInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:TerminateInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PassRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Drs.StopFailback": [
            {
                "action": "drs:StopFailback",
                "resource_mappings": {
                    "RecoveryInstanceID": {
                        "template": "${recoveryInstanceID}"
                    }
                }
            }
        ],
        "Drs.TagResource": [
            {
                "action": "drs:TagResource",
                "resource_mappings": {}
            }
        ],
        "Drs.TerminateRecoveryInstances": [
            {
                "action": "drs:TerminateRecoveryInstances",
                "resource_mappings": {
                    "RecoveryInstanceID": {
                        "template": "${recoveryInstanceIDs[]}"
                    }
                }
            },
            {
                "action": "ec2:DeleteVolume",
                "resource_mappings": {
                    "VolumeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeInstances",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVolumes",
                "resource_mappings": {}
            },
            {
                "action": "ec2:TerminateInstances",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Drs.UntagResource": [
            {
                "action": "drs:UntagResource",
                "resource_mappings": {}
            }
        ],
        "Drs.UpdateFailbackReplicationConfiguration": [
            {
                "action": "drs:UpdateFailbackReplicationConfiguration",
                "resource_mappings": {
                    "RecoveryInstanceID": {
                        "template": "${recoveryInstanceID}"
                    }
                }
            }
        ],
        "Drs.UpdateLaunchConfiguration": [
            {
                "action": "drs:UpdateLaunchConfiguration",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Drs.UpdateReplicationConfiguration": [
            {
                "action": "drs:UpdateReplicationConfiguration",
                "resource_mappings": {
                    "SourceServerID": {
                        "template": "${sourceServerID}"
                    }
                }
            }
        ],
        "Drs.UpdateReplicationConfigurationTemplate": [
            {
                "action": "drs:UpdateReplicationConfigurationTemplate",
                "resource_mappings": {
                    "ReplicationConfigurationTemplateID": {
                        "template": "${replicationConfigurationTemplateID}"
                    }
                }
            }
        ],
        "Evidently.CreateExperiment": [
            {
                "action": "evidently:CreateExperiment",
                "resource_mappings": {}
            }
        ],
        "Evidently.CreateFeature": [
            {
                "action": "evidently:CreateFeature",
                "resource_mappings": {}
            }
        ],
        "Evidently.CreateLaunch": [
            {
                "action": "evidently:CreateLaunch",
                "resource_mappings": {}
            }
        ],
        "Evidently.CreateProject": [
            {
                "action": "evidently:CreateProject",
                "resource_mappings": {}
            }
        ],
        "Evidently.DeleteExperiment": [
            {
                "action": "evidently:DeleteExperiment",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "ExperimentName": {
                        "template": "${experiment}"
                    }
                }
            }
        ],
        "Evidently.DeleteFeature": [
            {
                "action": "evidently:DeleteFeature",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "FeatureName": {
                        "template": "${feature}"
                    }
                }
            }
        ],
        "Evidently.DeleteLaunch": [
            {
                "action": "evidently:DeleteLaunch",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "LaunchName": {
                        "template": "${launch}"
                    }
                }
            }
        ],
        "Evidently.DeleteProject": [
            {
                "action": "evidently:DeleteProject",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    }
                }
            }
        ],
        "Evidently.GetExperiment": [
            {
                "action": "evidently:GetExperiment",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "ExperimentName": {
                        "template": "${experiment}"
                    }
                }
            }
        ],
        "Evidently.GetExperimentResults": [
            {
                "action": "evidently:GetExperimentResults",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "ExperimentName": {
                        "template": "${experiment}"
                    }
                }
            }
        ],
        "Evidently.GetFeature": [
            {
                "action": "evidently:GetFeature",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "FeatureName": {
                        "template": "${feature}"
                    }
                }
            }
        ],
        "Evidently.GetLaunch": [
            {
                "action": "evidently:GetLaunch",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "LaunchName": {
                        "template": "${launch}"
                    }
                }
            }
        ],
        "Evidently.GetProject": [
            {
                "action": "evidently:GetProject",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    }
                }
            }
        ],
        "Evidently.ListExperiments": [
            {
                "action": "evidently:ListExperiments",
                "resource_mappings": {}
            }
        ],
        "Evidently.ListFeatures": [
            {
                "action": "evidently:ListFeatures",
                "resource_mappings": {}
            }
        ],
        "Evidently.ListLaunches": [
            {
                "action": "evidently:ListLaunches",
                "resource_mappings": {}
            }
        ],
        "Evidently.ListProjects": [
            {
                "action": "evidently:ListProjects",
                "resource_mappings": {}
            }
        ],
        "Evidently.StartExperiment": [
            {
                "action": "evidently:StartExperiment",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "ExperimentName": {
                        "template": "${experiment}"
                    }
                }
            }
        ],
        "Evidently.StartLaunch": [
            {
                "action": "evidently:StartLaunch",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "LaunchName": {
                        "template": "${launch}"
                    }
                }
            }
        ],
        "Evidently.StopExperiment": [
            {
                "action": "evidently:StopExperiment",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "ExperimentName": {
                        "template": "${experiment}"
                    }
                }
            }
        ],
        "Evidently.StopLaunch": [
            {
                "action": "evidently:StopLaunch",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "LaunchName": {
                        "template": "${launch}"
                    }
                }
            }
        ],
        "Evidently.UpdateExperiment": [
            {
                "action": "evidently:UpdateExperiment",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "ExperimentName": {
                        "template": "${experiment}"
                    }
                }
            }
        ],
        "Evidently.UpdateFeature": [
            {
                "action": "evidently:UpdateFeature",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "FeatureName": {
                        "template": "${feature}"
                    }
                }
            }
        ],
        "Evidently.UpdateLaunch": [
            {
                "action": "evidently:UpdateLaunch",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    },
                    "LaunchName": {
                        "template": "${launch}"
                    }
                }
            }
        ],
        "Evidently.UpdateProject": [
            {
                "action": "evidently:UpdateProject",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    }
                }
            }
        ],
        "Evidently.UpdateProjectDataDelivery": [
            {
                "action": "evidently:UpdateProjectDataDelivery",
                "resource_mappings": {
                    "OwnerAccountId": {
                        "template": "${Account}"
                    },
                    "ProjectName": {
                        "template": "${project}"
                    }
                }
            }
        ],
        "Inspector2.AssociateMember": [
            {
                "action": "inspector2:AssociateMember",
                "resource_mappings": {}
            }
        ],
        "Inspector2.BatchGetAccountStatus": [
            {
                "action": "inspector2:BatchGetAccountStatus",
                "resource_mappings": {}
            }
        ],
        "Inspector2.BatchGetFreeTrialInfo": [
            {
                "action": "inspector2:BatchGetFreeTrialInfo",
                "resource_mappings": {}
            }
        ],
        "Inspector2.CancelFindingsReport": [
            {
                "action": "inspector2:CancelFindingsReport",
                "resource_mappings": {}
            }
        ],
        "Inspector2.CreateFilter": [
            {
                "action": "inspector2:CreateFilter",
                "resource_mappings": {
                    "OwnerId": {
                        "template": "*"
                    },
                    "FilterId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Inspector2.CreateFindingsReport": [
            {
                "action": "inspector2:CreateFindingsReport",
                "resource_mappings": {}
            }
        ],
        "Inspector2.DeleteFilter": [
            {
                "action": "inspector2:DeleteFilter",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Filter": "${arn}"
                }
            }
        ],
        "Inspector2.DescribeOrganizationConfiguration": [
            {
                "action": "inspector2:DescribeOrganizationConfiguration",
                "resource_mappings": {}
            }
        ],
        "Inspector2.Disable": [
            {
                "action": "inspector2:Disable",
                "resource_mappings": {}
            }
        ],
        "Inspector2.DisableDelegatedAdminAccount": [
            {
                "action": "inspector2:DisableDelegatedAdminAccount",
                "resource_mappings": {}
            }
        ],
        "Inspector2.DisassociateMember": [
            {
                "action": "inspector2:DisassociateMember",
                "resource_mappings": {}
            }
        ],
        "Inspector2.Enable": [
            {
                "action": "inspector2:Enable",
                "resource_mappings": {}
            }
        ],
        "Inspector2.EnableDelegatedAdminAccount": [
            {
                "action": "inspector2:EnableDelegatedAdminAccount",
                "resource_mappings": {}
            }
        ],
        "Inspector2.GetDelegatedAdminAccount": [
            {
                "action": "inspector2:GetDelegatedAdminAccount",
                "resource_mappings": {}
            }
        ],
        "Inspector2.GetFindingsReportStatus": [
            {
                "action": "inspector2:GetFindingsReportStatus",
                "resource_mappings": {}
            }
        ],
        "Inspector2.GetMember": [
            {
                "action": "inspector2:GetMember",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListAccountPermissions": [
            {
                "action": "inspector2:ListAccountPermissions",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListCoverage": [
            {
                "action": "inspector2:ListCoverage",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListCoverageStatistics": [
            {
                "action": "inspector2:ListCoverageStatistics",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListDelegatedAdminAccounts": [
            {
                "action": "inspector2:ListDelegatedAdminAccounts",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListFilters": [
            {
                "action": "inspector2:ListFilters",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListFindingAggregations": [
            {
                "action": "inspector2:ListFindingAggregations",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListFindings": [
            {
                "action": "inspector2:ListFindings",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListMembers": [
            {
                "action": "inspector2:ListMembers",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListTagsForResource": [
            {
                "action": "inspector2:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Inspector2.ListUsageTotals": [
            {
                "action": "inspector2:ListUsageTotals",
                "resource_mappings": {}
            }
        ],
        "Inspector2.TagResource": [
            {
                "action": "inspector2:TagResource",
                "resource_mappings": {}
            }
        ],
        "Inspector2.UntagResource": [
            {
                "action": "inspector2:UntagResource",
                "resource_mappings": {}
            }
        ],
        "Inspector2.UpdateFilter": [
            {
                "action": "inspector2:UpdateFilter",
                "resource_mappings": {
                    "OwnerId": {
                        "template": "*"
                    },
                    "FilterId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Inspector2.UpdateOrganizationConfiguration": [
            {
                "action": "inspector2:UpdateOrganizationConfiguration",
                "resource_mappings": {}
            }
        ],
        "Rbin.CreateRule": [
            {
                "action": "rbin:CreateRule",
                "resource_mappings": {
                    "ResourceName": {
                        "template": "*"
                    }
                }
            }
        ],
        "Rbin.DeleteRule": [
            {
                "action": "rbin:DeleteRule",
                "resource_mappings": {
                    "ResourceName": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "Rbin.GetRule": [
            {
                "action": "rbin:GetRule",
                "resource_mappings": {
                    "ResourceName": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "Rbin.ListRules": [
            {
                "action": "rbin:ListRules",
                "resource_mappings": {}
            }
        ],
        "Rbin.ListTagsForResource": [
            {
                "action": "rbin:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Rbin.TagResource": [
            {
                "action": "rbin:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Rbin.UntagResource": [
            {
                "action": "rbin:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "rule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Rbin.UpdateRule": [
            {
                "action": "rbin:UpdateRule",
                "resource_mappings": {
                    "ResourceName": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "RUM.CreateAppMonitor": [
            {
                "action": "rum:CreateAppMonitor",
                "resource_mappings": {
                    "Name": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:GetRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "RUM.DeleteAppMonitor": [
            {
                "action": "rum:DeleteAppMonitor",
                "resource_mappings": {
                    "Name": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "RUM.GetAppMonitor": [
            {
                "action": "rum:GetAppMonitor",
                "resource_mappings": {
                    "Name": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "RUM.GetAppMonitorData": [
            {
                "action": "rum:GetAppMonitorData",
                "resource_mappings": {
                    "Name": {
                        "template": "${Name}"
                    }
                }
            }
        ],
        "RUM.ListAppMonitors": [
            {
                "action": "rum:ListAppMonitors",
                "resource_mappings": {}
            }
        ],
        "RUM.ListTagsForResource": [
            {
                "action": "rum:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "RUM.PutRumEvents": [
            {
                "action": "rum:PutRumEvents",
                "resource_mappings": {}
            }
        ],
        "RUM.TagResource": [
            {
                "action": "rum:TagResource",
                "resource_mappings": {}
            }
        ],
        "RUM.UntagResource": [
            {
                "action": "rum:UntagResource",
                "resource_mappings": {}
            }
        ],
        "RUM.UpdateAppMonitor": [
            {
                "action": "rum:UpdateAppMonitor",
                "resource_mappings": {
                    "Name": {
                        "template": "${Name}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:GetRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "IoTTwinMaker.CreateComponentType": [
            {
                "action": "iottwinmaker:CreateComponentType",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.CreateEntity": [
            {
                "action": "iottwinmaker:CreateEntity",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.CreateScene": [
            {
                "action": "iottwinmaker:CreateScene",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.CreateWorkspace": [
            {
                "action": "iottwinmaker:CreateWorkspace",
                "resource_mappings": {}
            }
        ],
        "IoTTwinMaker.DeleteComponentType": [
            {
                "action": "iottwinmaker:DeleteComponentType",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "ComponentTypeId": {
                        "template": "${componentTypeId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.DeleteEntity": [
            {
                "action": "iottwinmaker:DeleteEntity",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "EntityId": {
                        "template": "${entityId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.DeleteScene": [
            {
                "action": "iottwinmaker:DeleteScene",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "SceneId": {
                        "template": "${sceneId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.DeleteWorkspace": [
            {
                "action": "iottwinmaker:DeleteWorkspace",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.GetComponentType": [
            {
                "action": "iottwinmaker:GetComponentType",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "ComponentTypeId": {
                        "template": "${componentTypeId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.GetEntity": [
            {
                "action": "iottwinmaker:GetEntity",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "EntityId": {
                        "template": "${entityId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.GetPropertyValue": [
            {
                "action": "iottwinmaker:GetPropertyValue",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "ComponentTypeId": {
                        "template": "${componentTypeId}"
                    },
                    "EntityId": {
                        "template": "${entityId}"
                    }
                }
            },
            {
                "action": "iottwinmaker:GetComponentType",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "ComponentTypeId": {
                        "template": "${componentTypeId}"
                    }
                }
            },
            {
                "action": "iottwinmaker:GetEntity",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "EntityId": {
                        "template": "${entityId}"
                    }
                }
            },
            {
                "action": "iottwinmaker:GetWorkspace",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.GetScene": [
            {
                "action": "iottwinmaker:GetScene",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "SceneId": {
                        "template": "${sceneId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.GetWorkspace": [
            {
                "action": "iottwinmaker:GetWorkspace",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.ListComponentTypes": [
            {
                "action": "iottwinmaker:ListComponentTypes",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.ListEntities": [
            {
                "action": "iottwinmaker:ListEntities",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.ListScenes": [
            {
                "action": "iottwinmaker:ListScenes",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.ListTagsForResource": [
            {
                "action": "iottwinmaker:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "componentType": "%%iftemplatematch%${resourceARN}%%",
                    "entity": "%%iftemplatematch%${resourceARN}%%",
                    "scene": "%%iftemplatematch%${resourceARN}%%",
                    "workspace": "%%iftemplatematch%${resourceARN}%%"
                }
            }
        ],
        "IoTTwinMaker.ListWorkspaces": [
            {
                "action": "iottwinmaker:ListWorkspaces",
                "resource_mappings": {}
            }
        ],
        "IoTTwinMaker.TagResource": [
            {
                "action": "iottwinmaker:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "componentType": "%%iftemplatematch%${resourceARN}%%",
                    "entity": "%%iftemplatematch%${resourceARN}%%",
                    "scene": "%%iftemplatematch%${resourceARN}%%",
                    "workspace": "%%iftemplatematch%${resourceARN}%%"
                }
            }
        ],
        "IoTTwinMaker.UntagResource": [
            {
                "action": "iottwinmaker:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "componentType": "%%iftemplatematch%${resourceARN}%%",
                    "entity": "%%iftemplatematch%${resourceARN}%%",
                    "scene": "%%iftemplatematch%${resourceARN}%%",
                    "workspace": "%%iftemplatematch%${resourceARN}%%"
                }
            }
        ],
        "IoTTwinMaker.UpdateComponentType": [
            {
                "action": "iottwinmaker:UpdateComponentType",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "ComponentTypeId": {
                        "template": "${componentTypeId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.UpdateEntity": [
            {
                "action": "iottwinmaker:UpdateEntity",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "EntityId": {
                        "template": "${entityId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.UpdateScene": [
            {
                "action": "iottwinmaker:UpdateScene",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    },
                    "SceneId": {
                        "template": "${sceneId}"
                    }
                }
            }
        ],
        "IoTTwinMaker.UpdateWorkspace": [
            {
                "action": "iottwinmaker:UpdateWorkspace",
                "resource_mappings": {
                    "WorkspaceId": {
                        "template": "${workspaceId}"
                    }
                }
            }
        ],
        "AmplifyUIBuilder.DeleteComponent": [
            {
                "action": "amplifyuibuilder:DeleteComponent",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "EnvironmentName": {
                        "template": "${environmentName}"
                    },
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "AmplifyUIBuilder.DeleteTheme": [
            {
                "action": "amplifyuibuilder:DeleteTheme",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "EnvironmentName": {
                        "template": "${environmentName}"
                    },
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "AmplifyUIBuilder.ExchangeCodeForToken": [
            {
                "action": "amplifyuibuilder:ExchangeCodeForToken",
                "resource_mappings": {}
            }
        ],
        "AmplifyUIBuilder.ExportComponents": [
            {
                "action": "amplifyuibuilder:ExportComponents",
                "resource_mappings": {}
            }
        ],
        "AmplifyUIBuilder.ExportThemes": [
            {
                "action": "amplifyuibuilder:ExportThemes",
                "resource_mappings": {}
            }
        ],
        "AmplifyUIBuilder.GetComponent": [
            {
                "action": "amplifyuibuilder:GetComponent",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "EnvironmentName": {
                        "template": "${environmentName}"
                    },
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "AmplifyUIBuilder.GetTheme": [
            {
                "action": "amplifyuibuilder:GetTheme",
                "resource_mappings": {
                    "AppId": {
                        "template": "${appId}"
                    },
                    "EnvironmentName": {
                        "template": "${environmentName}"
                    },
                    "Id": {
                        "template": "${id}"
                    }
                }
            }
        ],
        "AmplifyUIBuilder.ListComponents": [
            {
                "action": "amplifyuibuilder:ListComponents",
                "resource_mappings": {}
            }
        ],
        "AmplifyUIBuilder.ListThemes": [
            {
                "action": "amplifyuibuilder:ListThemes",
                "resource_mappings": {}
            }
        ],
        "AmplifyUIBuilder.RefreshToken": [
            {
                "action": "amplifyuibuilder:RefreshToken",
                "resource_mappings": {}
            }
        ],
        "CloudFront.DeleteResponseHeadersPolicy": [
            {
                "action": "cloudfront:DeleteResponseHeadersPolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.GetResponseHeadersPolicy": [
            {
                "action": "cloudfront:GetResponseHeadersPolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.GetResponseHeadersPolicyConfig": [
            {
                "action": "cloudfront:GetResponseHeadersPolicyConfig",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudFront.ListDistributionsByResponseHeadersPolicyId": [
            {
                "action": "cloudfront:ListDistributionsByResponseHeadersPolicyId",
                "resource_mappings": {}
            }
        ],
        "CloudFront.ListResponseHeadersPolicies": [
            {
                "action": "cloudfront:ListResponseHeadersPolicies",
                "resource_mappings": {}
            }
        ],
        "Redshift.DescribeReservedNodeExchangeStatus": [
            {
                "action": "redshift:DescribeReservedNodeExchangeStatus",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "Redshift.GetReservedNodeExchangeConfigurationOptions": [
            {
                "action": "redshift:GetReservedNodeExchangeConfigurationOptions",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "Connect.UpdateContactFlowModuleContent": [
            {
                "action": "connect:UpdateContactFlowModuleContent",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:connect:${Region}:${Account}:instance/${InstanceId}/flow-module/${ContactFlowModuleId}"
                }
            }
        ],
        "Kafka.CreateClusterV2": [
            {
                "action": "kafka:CreateClusterV2",
                "resource_mappings": {}
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "IpamId": {
                        "template": "*"
                    },
                    "IpamPoolId": {
                        "template": "*"
                    },
                    "IpamScopeId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeAnalysisId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateVpcEndpoint",
                "resource_mappings": {
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteVpcEndpoints",
                "resource_mappings": {
                    "VpcEndpointId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeSecurityGroups",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeSubnets",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVpcAttribute",
                "resource_mappings": {
                    "VpcId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeVpcEndpoints",
                "resource_mappings": {}
            },
            {
                "action": "ec2:DescribeVpcs",
                "resource_mappings": {}
            },
            {
                "action": "iam:AttachRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:PutRolePolicy",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "kms:CreateGrant",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${Provisioned.EncryptionInfo.EncryptionAtRest.DataVolumeKMSKeyId}"
                    }
                }
            },
            {
                "action": "kms:DescribeKey",
                "resource_mappings": {
                    "KeyId": {
                        "template": "${Provisioned.EncryptionInfo.EncryptionAtRest.DataVolumeKMSKeyId}"
                    }
                }
            }
        ],
        "Kafka.DescribeClusterV2": [
            {
                "action": "kafka:DescribeClusterV2",
                "resource_mappings": {}
            }
        ],
        "Kafka.ListClustersV2": [
            {
                "action": "kafka:ListClustersV2",
                "resource_mappings": {}
            }
        ],
        "Textract.AnalyzeID": [
            {
                "action": "textract:AnalyzeID",
                "resource_mappings": {}
            },
            {
                "action": "s3:GetObject",
                "resource_mappings": {
                    "BucketName": {
                        "template": "${DocumentPages[].S3Object.Bucket}"
                    },
                    "ObjectName": {
                        "template": "${DocumentPages[].S3Object.Name}"
                    }
                }
            }
        ],
        "LakeFormation.CancelTransaction": [
            {
                "action": "lakeformation:CancelTransaction",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.CommitTransaction": [
            {
                "action": "lakeformation:CommitTransaction",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.DeleteObjectsOnCancel": [
            {
                "action": "lakeformation:DeleteObjectsOnCancel",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.DescribeTransaction": [
            {
                "action": "lakeformation:DescribeTransaction",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.ExtendTransaction": [
            {
                "action": "lakeformation:ExtendTransaction",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GetQueryState": [
            {
                "action": "lakeformation:GetQueryState",
                "resource_mappings": {}
            },
            {
                "action": "lakeformation:StartQueryPlanning",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GetQueryStatistics": [
            {
                "action": "lakeformation:GetQueryStatistics",
                "resource_mappings": {}
            },
            {
                "action": "lakeformation:StartQueryPlanning",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GetTableObjects": [
            {
                "action": "lakeformation:GetTableObjects",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GetWorkUnits": [
            {
                "action": "lakeformation:GetWorkUnits",
                "resource_mappings": {}
            },
            {
                "action": "lakeaformation:StartQueryPlanning",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.ListDataCellsFilter": [
            {
                "action": "lakeformation:ListDataCellsFilter",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.ListTableStorageOptimizers": [
            {
                "action": "lakeformation:ListTableStorageOptimizers",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.ListTransactions": [
            {
                "action": "lakeformation:ListTransactions",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.StartTransaction": [
            {
                "action": "lakeformation:StartTransaction",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.UpdateTableObjects": [
            {
                "action": "lakeformation:UpdateTableObjects",
                "resource_mappings": {}
            }
        ],
        "Kendra.AssociateEntitiesToExperience": [
            {
                "action": "kendra:AssociateEntitiesToExperience",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ExperienceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.AssociatePersonasToEntities": [
            {
                "action": "kendra:AssociatePersonasToEntities",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ExperienceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.CreateExperience": [
            {
                "action": "kendra:CreateExperience",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.DeleteExperience": [
            {
                "action": "kendra:DeleteExperience",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ExperienceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DescribeExperience": [
            {
                "action": "kendra:DescribeExperience",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ExperienceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DisassociateEntitiesFromExperience": [
            {
                "action": "kendra:DisassociateEntitiesFromExperience",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ExperienceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.DisassociatePersonasFromEntities": [
            {
                "action": "kendra:DisassociatePersonasFromEntities",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ExperienceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.GetSnapshots": [
            {
                "action": "kendra:GetSnapshots",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.ListEntityPersonas": [
            {
                "action": "kendra:ListEntityPersonas",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ExperienceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.ListExperienceEntities": [
            {
                "action": "kendra:ListExperienceEntities",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    },
                    "ExperienceId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "Kendra.ListExperiences": [
            {
                "action": "kendra:ListExperiences",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Kendra.UpdateExperience": [
            {
                "action": "kendra:UpdateExperience",
                "resource_mappings": {
                    "IndexId": {
                        "template": "${IndexId}"
                    }
                }
            }
        ],
        "Outposts.CancelOrder": [
            {
                "action": "outposts:CancelOrder",
                "resource_mappings": {}
            }
        ],
        "Outposts.CreateSite": [
            {
                "action": "outposts:CreateSite",
                "resource_mappings": {}
            }
        ],
        "Outposts.GetCatalogItem": [
            {
                "action": "outposts:GetCatalogItem",
                "resource_mappings": {}
            }
        ],
        "Outposts.GetOrder": [
            {
                "action": "outposts:GetOrder",
                "resource_mappings": {}
            }
        ],
        "Outposts.GetSite": [
            {
                "action": "outposts:GetSite",
                "resource_mappings": {}
            }
        ],
        "Outposts.GetSiteAddress": [
            {
                "action": "outposts:GetSiteAddress",
                "resource_mappings": {}
            }
        ],
        "Outposts.ListCatalogItems": [
            {
                "action": "outposts:ListCatalogItems",
                "resource_mappings": {}
            }
        ],
        "Outposts.ListOrders": [
            {
                "action": "outposts:ListOrders",
                "resource_mappings": {}
            }
        ],
        "Outposts.UpdateSite": [
            {
                "action": "outposts:UpdateSite",
                "resource_mappings": {}
            }
        ],
        "Outposts.UpdateSiteRackPhysicalProperties": [
            {
                "action": "outposts:UpdateSiteRackPhysicalProperties",
                "resource_mappings": {}
            }
        ],
        "AmplifyBackend.DeleteBackendStorage": [
            {
                "action": "amplifybackend:DeleteBackendStorage",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:amplifybackend:${Region}:${Account}:/backend/${AppId}/storage/${BackendEnvironmentName}/remove/*"
                }
            }
        ],
        "AmplifyBackend.GetBackendStorage": [
            {
                "action": "amplifybackend:GetBackendStorage",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:amplifybackend:${Region}:${Account}:/backend/${AppId}/storage/${BackendEnvironmentName}/details/*"
                }
            }
        ],
        "AmplifyBackend.ImportBackendStorage": [
            {
                "action": "amplifybackend:ImportBackendStorage",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:amplifybackend:${Region}:${Account}:/backend/${AppId}/storage/${BackendEnvironmentName}/import/*"
                }
            }
        ],
        "AmplifyBackend.ListS3Buckets": [
            {
                "action": "amplifybackend:ListS3Buckets",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:amplifybackend:${Region}:${Account}:/s3Buckets"
                }
            }
        ],
        "IotDeviceAdvisor.GetEndpoint": [
            {
                "action": "iotdeviceadvisor:GetEndpoint",
                "resource_mappings": {}
            }
        ],
        "Finspacedata.DeleteDataset": [
            {
                "action": "finspace-api:DeleteDatasetV2",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/datasetsv2/${datasetId}"
                }
            }
        ],
        "Finspacedata.GetChangeset": [
            {
                "action": "finspace-api:GetChangesetV2",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/datasets/${datasetId}/changesetsv2/${changesetId}"
                }
            }
        ],
        "Finspacedata.GetDataView": [
            {
                "action": "finspace-api:GetDataViewV2",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/datasets/${datasetId}/dataviewsv2/${dataViewId}"
                }
            }
        ],
        "Finspacedata.GetDataset": [
            {
                "action": "finspace-api:GetDatasetV2",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/datasetsv2/${datasetId}"
                }
            }
        ],
        "Finspacedata.ListChangesets": [
            {
                "action": "finspace-api:ListChangesetsV2",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/datasets/${datasetId}/changesetsv2"
                }
            }
        ],
        "Finspacedata.ListDataViews": [
            {
                "action": "finspace-api:ListDataViewsV2",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/datasets/${datasetId}/dataviewsv2"
                }
            }
        ],
        "Finspacedata.ListDatasets": [
            {
                "action": "finspace-api:ListDatasetsV2",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/datasetsv2"
                }
            }
        ],
        "Finspacedata.UpdateDataset": [
            {
                "action": "finspace-api:UpdateDatasetV2",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/datasetsv2/${datasetId}"
                }
            }
        ],
        "Proton.ListEnvironmentOutputs": [
            {
                "action": "proton:ListEnvironmentOutputs",
                "resource_mappings": {
                    "Name": {
                        "template": "${environmentName}"
                    }
                }
            }
        ],
        "Proton.ListEnvironmentProvisionedResources": [
            {
                "action": "proton:ListEnvironmentProvisionedResources",
                "resource_mappings": {
                    "Name": {
                        "template": "${environmentName}"
                    }
                }
            }
        ],
        "Proton.ListRepositories": [
            {
                "action": "proton:ListRepositories",
                "resource_mappings": {}
            }
        ],
        "Proton.ListServiceInstanceOutputs": [
            {
                "action": "proton:ListServiceInstanceOutputs",
                "resource_mappings": {
                    "Name": {
                        "template": "${serviceInstanceName}"
                    },
                    "ServiceName": {
                        "template": "${serviceName}"
                    }
                }
            }
        ],
        "Proton.ListServiceInstanceProvisionedResources": [
            {
                "action": "proton:ListServiceInstanceProvisionedResources",
                "resource_mappings": {
                    "Name": {
                        "template": "${serviceInstanceName}"
                    },
                    "ServiceName": {
                        "template": "${serviceName}"
                    }
                }
            }
        ],
        "Proton.ListServicePipelineOutputs": [
            {
                "action": "proton:ListServicePipelineOutputs",
                "resource_mappings": {
                    "Name": {
                        "template": "${serviceName}"
                    }
                }
            }
        ],
        "Proton.ListServicePipelineProvisionedResources": [
            {
                "action": "proton:ListServicePipelineProvisionedResources",
                "resource_mappings": {
                    "Name": {
                        "template": "${serviceName}"
                    }
                }
            }
        ],
        "AppConfigData.StartConfigurationSession": [
            {
                "action": "appconfig:StartConfigurationSession",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "${ApplicationIdentifier}"
                    },
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    },
                    "ConfigurationProfileId": {
                        "template": "${ConfigurationProfileIdentifier}"
                    }
                }
            }
        ],
        "Evidently.BatchEvaluateFeature": [
            {
                "action": "evidently:BatchEvaluateFeature",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:evidently:${Region}:${Account}:project/${project}"
                }
            }
        ],
        "Evidently.EvaluateFeature": [
            {
                "action": "evidently:EvaluateFeature",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:evidently:${Region}:${Account}:project/${project}"
                }
            }
        ],
        "Evidently.ListTagsForResource": [
            {
                "action": "evidently:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Evidently.UntagResource": [
            {
                "action": "evidently:UntagResource",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryCluster.GetRoutingControlState": [
            {
                "action": "route53-recovery-cluster:GetRoutingControlState",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "routingcontrol": "${RoutingControlArn}"
                }
            }
        ],
        "Route53RecoveryCluster.UpdateRoutingControlState": [
            {
                "action": "route53-recovery-cluster:UpdateRoutingControlState",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "routingcontrol": "${RoutingControlArn}"
                }
            }
        ],
        "Route53RecoveryCluster.UpdateRoutingControlStates": [
            {
                "action": "route53-recovery-cluster:UpdateRoutingControlStates",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "routingcontrol": "${UpdateRoutingControlStateEntries[].RoutingControlArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.CreateCluster": [
            {
                "action": "route53-recovery-control-config:CreateCluster",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${ClusterName}"
                    }
                }
            }
        ],
        "Route53RecoveryControlConfig.CreateControlPanel": [
            {
                "action": "route53-recovery-control-config:CreateControlPanel",
                "resource_mappings": {
                    "ControlPanelId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryControlConfig.CreateRoutingControl": [
            {
                "action": "route53-recovery-control-config:CreateRoutingControl",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "routingcontrol": "${ControlPanelArn}/routingcontrol/*"
                }
            }
        ],
        "Route53RecoveryControlConfig.CreateSafetyRule": [
            {
                "action": "route53-recovery-control-config:CreateSafetyRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "safetyrule": "${AssertionRule.ControlPanelArn}/safetyrule/*"
                }
            }
        ],
        "Route53RecoveryControlConfig.DeleteCluster": [
            {
                "action": "route53-recovery-control-config:DeleteCluster",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${ClusterArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.DeleteControlPanel": [
            {
                "action": "route53-recovery-control-config:DeleteControlPanel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "controlpanel": "${ControlPanelArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.DeleteRoutingControl": [
            {
                "action": "route53-recovery-control-config:DeleteRoutingControl",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "routingcontrol": "${RoutingControlArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.DeleteSafetyRule": [
            {
                "action": "route53-recovery-control-config:DeleteSafetyRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "safetyrule": "${SafetyRuleArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.DescribeCluster": [
            {
                "action": "route53-recovery-control-config:DescribeCluster",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "${ClusterArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.DescribeControlPanel": [
            {
                "action": "route53-recovery-control-config:DescribeControlPanel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "controlpanel": "${ControlPanelArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.DescribeRoutingControl": [
            {
                "action": "route53-recovery-control-config:DescribeRoutingControl",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "routingcontrol": "${RoutingControlArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.DescribeSafetyRule": [
            {
                "action": "route53-recovery-control-config:DescribeSafetyRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "safetyrule": "${SafetyRuleArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.ListAssociatedRoute53HealthChecks": [
            {
                "action": "route53-recovery-control-config:ListAssociatedRoute53HealthChecks",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryControlConfig.ListClusters": [
            {
                "action": "route53-recovery-control-config:ListClusters",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryControlConfig.ListControlPanels": [
            {
                "action": "route53-recovery-control-config:ListControlPanels",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryControlConfig.ListRoutingControls": [
            {
                "action": "route53-recovery-control-config:ListRoutingControls",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryControlConfig.ListSafetyRules": [
            {
                "action": "route53-recovery-control-config:ListSafetyRules",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "controlpanel": "${ControlPanelArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.UpdateControlPanel": [
            {
                "action": "route53-recovery-control-config:UpdateControlPanel",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "controlpanel": "${ControlPanelArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.UpdateRoutingControl": [
            {
                "action": "route53-recovery-control-config:UpdateRoutingControl",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "routingcontrol": "${RoutingControlArn}"
                }
            }
        ],
        "Route53RecoveryControlConfig.UpdateSafetyRule": [
            {
                "action": "route53-recovery-control-config:UpdateSafetyRule",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "safetyrule": "%%many%${AssertionRuleUpdate.SafetyRuleArn}%${GatingRuleUpdate.SafetyRuleArn}%%"
                }
            }
        ],
        "Route53RecoveryReadiness.CreateCell": [
            {
                "action": "route53-recovery-readiness:CreateCell",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.CreateCrossAccountAuthorization": [
            {
                "action": "route53-recovery-readiness:CreateCrossAccountAuthorization",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryReadiness.CreateReadinessCheck": [
            {
                "action": "route53-recovery-readiness:CreateReadinessCheck",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.CreateRecoveryGroup": [
            {
                "action": "route53-recovery-readiness:CreateRecoveryGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.CreateResourceSet": [
            {
                "action": "route53-recovery-readiness:CreateResourceSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.DeleteCell": [
            {
                "action": "route53-recovery-readiness:DeleteCell",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.DeleteCrossAccountAuthorization": [
            {
                "action": "route53-recovery-readiness:DeleteCrossAccountAuthorization",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryReadiness.DeleteReadinessCheck": [
            {
                "action": "route53-recovery-readiness:DeleteReadinessCheck",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.DeleteRecoveryGroup": [
            {
                "action": "route53-recovery-readiness:DeleteRecoveryGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.DeleteResourceSet": [
            {
                "action": "route53-recovery-readiness:DeleteResourceSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.GetArchitectureRecommendations": [
            {
                "action": "route53-recovery-readiness:GetArchitectureRecommendations",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.GetCell": [
            {
                "action": "route53-recovery-readiness:GetCell",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.GetCellReadinessSummary": [
            {
                "action": "route53-recovery-readiness:GetCellReadinessSummary",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.GetReadinessCheck": [
            {
                "action": "route53-recovery-readiness:GetReadinessCheck",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.GetReadinessCheckResourceStatus": [
            {
                "action": "route53-recovery-readiness:GetReadinessCheckResourceStatus",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.GetReadinessCheckStatus": [
            {
                "action": "route53-recovery-readiness:GetReadinessCheckStatus",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.GetRecoveryGroup": [
            {
                "action": "route53-recovery-readiness:GetRecoveryGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.GetRecoveryGroupReadinessSummary": [
            {
                "action": "route53-recovery-readiness:GetRecoveryGroupReadinessSummary",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.GetResourceSet": [
            {
                "action": "route53-recovery-readiness:GetResourceSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.ListCells": [
            {
                "action": "route53-recovery-readiness:ListCells",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryReadiness.ListCrossAccountAuthorizations": [
            {
                "action": "route53-recovery-readiness:ListCrossAccountAuthorizations",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryReadiness.ListReadinessChecks": [
            {
                "action": "route53-recovery-readiness:ListReadinessChecks",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryReadiness.ListRecoveryGroups": [
            {
                "action": "route53-recovery-readiness:ListRecoveryGroups",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryReadiness.ListResourceSets": [
            {
                "action": "route53-recovery-readiness:ListResourceSets",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryReadiness.ListRules": [
            {
                "action": "route53-recovery-readiness:ListRules",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryReadiness.ListTagsForResources": [
            {
                "action": "route53-recovery-readiness:ListTagsForResources",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryReadiness.TagResource": [
            {
                "action": "route53-recovery-readiness:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cell": "%%iftemplatematch%${ResourceArn}%%",
                    "readinesscheck": "%%iftemplatematch%${ResourceArn}%%",
                    "recoverygroup": "%%iftemplatematch%${ResourceArn}%%",
                    "resourceset": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Route53RecoveryReadiness.UntagResource": [
            {
                "action": "route53-recovery-readiness:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cell": "%%iftemplatematch%${ResourceArn}%%",
                    "readinesscheck": "%%iftemplatematch%${ResourceArn}%%",
                    "recoverygroup": "%%iftemplatematch%${ResourceArn}%%",
                    "resourceset": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Route53RecoveryReadiness.UpdateCell": [
            {
                "action": "route53-recovery-readiness:UpdateCell",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.UpdateReadinessCheck": [
            {
                "action": "route53-recovery-readiness:UpdateReadinessCheck",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.UpdateRecoveryGroup": [
            {
                "action": "route53-recovery-readiness:UpdateRecoveryGroup",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53RecoveryReadiness.UpdateResourceSet": [
            {
                "action": "route53-recovery-readiness:UpdateResourceSet",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "SnowDeviceManagement.CancelTask": [
            {
                "action": "snow-device-management:CancelTask",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${taskId}"
                    }
                }
            }
        ],
        "SnowDeviceManagement.CreateTask": [
            {
                "action": "snow-device-management:CreateTask",
                "resource_mappings": {}
            }
        ],
        "SnowDeviceManagement.DescribeDevice": [
            {
                "action": "snow-device-management:DescribeDevice",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${managedDeviceId}"
                    }
                }
            }
        ],
        "SnowDeviceManagement.DescribeDeviceEc2Instances": [
            {
                "action": "snow-device-management:DescribeDeviceEc2Instances",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${managedDeviceId}"
                    }
                }
            }
        ],
        "SnowDeviceManagement.DescribeExecution": [
            {
                "action": "snow-device-management:DescribeExecution",
                "resource_mappings": {}
            }
        ],
        "SnowDeviceManagement.DescribeTask": [
            {
                "action": "snow-device-management:DescribeTask",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${taskId}"
                    }
                }
            }
        ],
        "SnowDeviceManagement.ListDeviceResources": [
            {
                "action": "snow-device-management:ListDeviceResources",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${managedDeviceId}"
                    }
                }
            }
        ],
        "SnowDeviceManagement.ListDevices": [
            {
                "action": "snow-device-management:ListDevices",
                "resource_mappings": {}
            }
        ],
        "SnowDeviceManagement.ListExecutions": [
            {
                "action": "snow-device-management:ListExecutions",
                "resource_mappings": {}
            }
        ],
        "SnowDeviceManagement.ListTagsForResource": [
            {
                "action": "snow-device-management:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "SnowDeviceManagement.ListTasks": [
            {
                "action": "snow-device-management:ListTasks",
                "resource_mappings": {}
            }
        ],
        "SnowDeviceManagement.TagResource": [
            {
                "action": "snow-device-management:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "managed-device": "%%iftemplatematch%${resourceArn}%%",
                    "task": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "SnowDeviceManagement.UntagResource": [
            {
                "action": "snow-device-management:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "managed-device": "%%iftemplatematch%${resourceArn}%%",
                    "task": "%%iftemplatematch%${resourceArn}%%"
                }
            }
        ],
        "VoiceID.CreateDomain": [
            {
                "action": "voiceid:CreateDomain",
                "resource_mappings": {}
            }
        ],
        "VoiceID.DeleteDomain": [
            {
                "action": "voiceid:DeleteDomain",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.DeleteFraudster": [
            {
                "action": "voiceid:DeleteFraudster",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.DeleteSpeaker": [
            {
                "action": "voiceid:DeleteSpeaker",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.DescribeDomain": [
            {
                "action": "voiceid:DescribeDomain",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.DescribeFraudster": [
            {
                "action": "voiceid:DescribeFraudster",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.DescribeFraudsterRegistrationJob": [
            {
                "action": "voiceid:DescribeFraudsterRegistrationJob",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.DescribeSpeaker": [
            {
                "action": "voiceid:DescribeSpeaker",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.DescribeSpeakerEnrollmentJob": [
            {
                "action": "voiceid:DescribeSpeakerEnrollmentJob",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.EvaluateSession": [
            {
                "action": "voiceid:EvaluateSession",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.ListDomains": [
            {
                "action": "voiceid:ListDomains",
                "resource_mappings": {}
            }
        ],
        "VoiceID.ListFraudsterRegistrationJobs": [
            {
                "action": "voiceid:ListFraudsterRegistrationJobs",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.ListSpeakerEnrollmentJobs": [
            {
                "action": "voiceid:ListSpeakerEnrollmentJobs",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.ListSpeakers": [
            {
                "action": "voiceid:ListSpeakers",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.ListTagsForResource": [
            {
                "action": "voiceid:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "VoiceID.OptOutSpeaker": [
            {
                "action": "voiceid:OptOutSpeaker",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.StartFraudsterRegistrationJob": [
            {
                "action": "voiceid:StartFraudsterRegistrationJob",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.StartSpeakerEnrollmentJob": [
            {
                "action": "voiceid:StartSpeakerEnrollmentJob",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "VoiceID.TagResource": [
            {
                "action": "voiceid:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "VoiceID.UntagResource": [
            {
                "action": "voiceid:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "domain": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "VoiceID.UpdateDomain": [
            {
                "action": "voiceid:UpdateDomain",
                "resource_mappings": {
                    "DomainId": {
                        "template": "${DomainId}"
                    }
                }
            }
        ],
        "BackupGateway.AssociateGatewayToServer": [
            {
                "action": "backup-gateway:AssociateGatewayToServer",
                "resource_mappings": {
                    "HypervisorId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "gateway": "${GatewayArn}"
                }
            }
        ],
        "BackupGateway.CreateGateway": [
            {
                "action": "backup-gateway:CreateGateway",
                "resource_mappings": {}
            }
        ],
        "BackupGateway.DeleteGateway": [
            {
                "action": "backup-gateway:DeleteGateway",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayArn}"
                }
            }
        ],
        "BackupGateway.DeleteHypervisor": [
            {
                "action": "backup-gateway:DeleteHypervisor",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "hypervisor": "${HypervisorArn}"
                }
            }
        ],
        "BackupGateway.DisassociateGatewayFromServer": [
            {
                "action": "backup-gateway:DisassociateGatewayFromServer",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayArn}"
                }
            }
        ],
        "BackupGateway.ImportHypervisorConfiguration": [
            {
                "action": "backup-gateway:ImportHypervisorConfiguration",
                "resource_mappings": {
                    "HypervisorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "BackupGateway.ListGateways": [
            {
                "action": "backup-gateway:ListGateways",
                "resource_mappings": {}
            }
        ],
        "BackupGateway.ListHypervisors": [
            {
                "action": "backup-gateway:ListHypervisors",
                "resource_mappings": {}
            }
        ],
        "BackupGateway.ListTagsForResource": [
            {
                "action": "backup-gateway:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "%%iftemplatematch%${ResourceArn}%%",
                    "hypervisor": "%%iftemplatematch%${ResourceArn}%%",
                    "virtualmachine": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "BackupGateway.ListVirtualMachines": [
            {
                "action": "backup-gateway:ListVirtualMachines",
                "resource_mappings": {}
            }
        ],
        "BackupGateway.PutMaintenanceStartTime": [
            {
                "action": "backup-gateway:PutMaintenanceStartTime",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayArn}"
                }
            }
        ],
        "BackupGateway.TagResource": [
            {
                "action": "backup-gateway:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "%%iftemplatematch%${ResourceARN}%%",
                    "hypervisor": "%%iftemplatematch%${ResourceARN}%%",
                    "virtualmachine": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "BackupGateway.TestHypervisorConfiguration": [
            {
                "action": "backup-gateway:TestHypervisorConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayArn}"
                }
            }
        ],
        "BackupGateway.UntagResource": [
            {
                "action": "backup-gateway:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "%%iftemplatematch%${ResourceARN}%%",
                    "hypervisor": "%%iftemplatematch%${ResourceARN}%%",
                    "virtualmachine": "%%iftemplatematch%${ResourceARN}%%"
                }
            }
        ],
        "BackupGateway.UpdateGatewayInformation": [
            {
                "action": "backup-gateway:UpdateGatewayInformation",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayArn}"
                }
            }
        ],
        "BackupGateway.UpdateHypervisor": [
            {
                "action": "backup-gateway:UpdateHypervisor",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${HypervisorArn}"
                }
            }
        ],
        "WorkSpacesWeb.AssociateBrowserSettings": [
            {
                "action": "workspaces-web:AssociateBrowserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "browserSettings": "${browserSettingsArn}",
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.AssociateNetworkSettings": [
            {
                "action": "workspaces-web:AssociateNetworkSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkSettings": "${networkSettingsArn}",
                    "portal": "${portalArn}"
                }
            },
            {
                "action": "ec2:CreateNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateNetworkInterfacePermission",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterface",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DeleteNetworkInterfacePermission",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:ModifyNetworkInterfaceAttribute",
                "resource_mappings": {
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    }
                }
            }
        ],
        "WorkSpacesWeb.AssociateTrustStore": [
            {
                "action": "workspaces-web:AssociateTrustStore",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}",
                    "trustStore": "${trustStoreArn}"
                }
            }
        ],
        "WorkSpacesWeb.AssociateUserSettings": [
            {
                "action": "workspaces-web:AssociateUserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}",
                    "userSettings": "${userSettingsArn}"
                }
            }
        ],
        "WorkSpacesWeb.CreateBrowserSettings": [
            {
                "action": "workspaces-web:CreateBrowserSettings",
                "resource_mappings": {}
            },
            {
                "action": "kms:CreateGrant",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "key": "${customerManagedKey}"
                }
            },
            {
                "action": "kms:Decrypt",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "key": "${customerManagedKey}"
                }
            },
            {
                "action": "kms:DescribeKey",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "key": "${customerManagedKey}"
                }
            },
            {
                "action": "kms:GenerateDataKey",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "key": "${customerManagedKey}"
                }
            }
        ],
        "WorkSpacesWeb.CreateIdentityProvider": [
            {
                "action": "workspaces-web:CreateIdentityProvider",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.CreateNetworkSettings": [
            {
                "action": "workspaces-web:CreateNetworkSettings",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.CreatePortal": [
            {
                "action": "workspaces-web:CreatePortal",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "kms:CreateGrant",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "key": "${customerManagedKey}"
                }
            },
            {
                "action": "kms:Decrypt",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "key": "${customerManagedKey}"
                }
            },
            {
                "action": "kms:DescribeKey",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "key": "${customerManagedKey}"
                }
            },
            {
                "action": "kms:GenerateDataKey",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "key": "${customerManagedKey}"
                }
            }
        ],
        "WorkSpacesWeb.CreateTrustStore": [
            {
                "action": "workspaces-web:CreateTrustStore",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.CreateUserSettings": [
            {
                "action": "workspaces-web:CreateUserSettings",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.DeleteBrowserSettings": [
            {
                "action": "workspaces-web:DeleteBrowserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "browserSettings": "${browserSettingsArn}"
                }
            }
        ],
        "WorkSpacesWeb.DeleteIdentityProvider": [
            {
                "action": "workspaces-web:DeleteIdentityProvider",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.DeleteNetworkSettings": [
            {
                "action": "workspaces-web:DeleteNetworkSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkSettings": "${networkSettingsArn}"
                }
            }
        ],
        "WorkSpacesWeb.DeletePortal": [
            {
                "action": "workspaces-web:DeletePortal",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.DeleteTrustStore": [
            {
                "action": "workspaces-web:DeleteTrustStore",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "trustStore": "${trustStoreArn}"
                }
            }
        ],
        "WorkSpacesWeb.DeleteUserSettings": [
            {
                "action": "workspaces-web:DeleteUserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "userSettings": "${userSettingsArn}"
                }
            }
        ],
        "WorkSpacesWeb.DisassociateBrowserSettings": [
            {
                "action": "workspaces-web:DisassociateBrowserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.DisassociateNetworkSettings": [
            {
                "action": "workspaces-web:DisassociateNetworkSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.DisassociateTrustStore": [
            {
                "action": "workspaces-web:DisassociateTrustStore",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.DisassociateUserSettings": [
            {
                "action": "workspaces-web:DisassociateUserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.GetBrowserSettings": [
            {
                "action": "workspaces-web:GetBrowserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "browserSettings": "${browserSettingsArn}"
                }
            }
        ],
        "WorkSpacesWeb.GetIdentityProvider": [
            {
                "action": "workspaces-web:GetIdentityProvider",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.GetNetworkSettings": [
            {
                "action": "workspaces-web:GetNetworkSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkSettings": "${networkSettingsArn}"
                }
            }
        ],
        "WorkSpacesWeb.GetPortal": [
            {
                "action": "workspaces-web:GetPortal",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.GetPortalServiceProviderMetadata": [
            {
                "action": "workspaces-web:GetPortalServiceProviderMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.GetTrustStore": [
            {
                "action": "workspaces-web:GetTrustStore",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "trustStore": "${trustStoreArn}"
                }
            }
        ],
        "WorkSpacesWeb.GetTrustStoreCertificate": [
            {
                "action": "workspaces-web:GetTrustStoreCertificate",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "trustStore": "${trustStoreArn}"
                }
            }
        ],
        "WorkSpacesWeb.GetUserSettings": [
            {
                "action": "workspaces-web:GetUserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "userSettings": "${userSettingsArn}"
                }
            }
        ],
        "WorkSpacesWeb.ListBrowserSettings": [
            {
                "action": "workspaces-web:ListBrowserSettings",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.ListIdentityProviders": [
            {
                "action": "workspaces-web:ListIdentityProviders",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.ListNetworkSettings": [
            {
                "action": "workspaces-web:ListNetworkSettings",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.ListPortals": [
            {
                "action": "workspaces-web:ListPortals",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.ListTagsForResource": [
            {
                "action": "workspaces-web:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.ListTrustStoreCertificates": [
            {
                "action": "workspaces-web:ListTrustStoreCertificates",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.ListTrustStores": [
            {
                "action": "workspaces-web:ListTrustStores",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.ListUserSettings": [
            {
                "action": "workspaces-web:ListUserSettings",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.TagResource": [
            {
                "action": "workspaces-web:TagResource",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.UntagResource": [
            {
                "action": "workspaces-web:UntagResource",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.UpdateBrowserSettings": [
            {
                "action": "workspaces-web:UpdateBrowserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "browserSettings": "${browserSettingsArn}"
                }
            }
        ],
        "WorkSpacesWeb.UpdateIdentityProvider": [
            {
                "action": "workspaces-web:UpdateIdentityProvider",
                "resource_mappings": {}
            }
        ],
        "WorkSpacesWeb.UpdateNetworkSettings": [
            {
                "action": "workspaces-web:UpdateNetworkSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "networkSettings": "${networkSettingsArn}"
                }
            }
        ],
        "WorkSpacesWeb.UpdatePortal": [
            {
                "action": "workspaces-web:UpdatePortal",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "portal": "${portalArn}"
                }
            }
        ],
        "WorkSpacesWeb.UpdateTrustStore": [
            {
                "action": "workspaces-web:UpdateTrustStore",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "trustStore": "${trustStoreArn}"
                }
            }
        ],
        "WorkSpacesWeb.UpdateUserSettings": [
            {
                "action": "workspaces-web:UpdateUserSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "userSettings": "${userSettingsArn}"
                }
            }
        ],
        "AppStream.CreateEntitlement": [
            {
                "action": "appstream:CreateEntitlement",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.DeleteEntitlement": [
            {
                "action": "appstream:DeleteEntitlement",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.DescribeEntitlements": [
            {
                "action": "appstream:DescribeEntitlements",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.ListEntitledApplications": [
            {
                "action": "appstream:ListEntitledApplications",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.UpdateEntitlement": [
            {
                "action": "appstream:UpdateEntitlement",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "CloudFront.CreateResponseHeadersPolicy": [
            {
                "action": "cloudfront:CreateResponseHeadersPolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudFront.UpdateResponseHeadersPolicy": [
            {
                "action": "cloudfront:UpdateResponseHeadersPolicy",
                "resource_mappings": {
                    "Id": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "CloudTrail.CancelQuery": [
            {
                "action": "cloudtrail:CancelQuery",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.CreateEventDataStore": [
            {
                "action": "cloudtrail:CreateEventDataStore",
                "resource_mappings": {
                    "EventDataStoreId": {
                        "template": "*"
                    }
                }
            }
        ],
        "CloudTrail.DeleteEventDataStore": [
            {
                "action": "cloudtrail:DeleteEventDataStore",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "eventdatastore": "${EventDataStore}"
                }
            }
        ],
        "CloudTrail.DescribeQuery": [
            {
                "action": "cloudtrail:DescribeQuery",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.GetEventDataStore": [
            {
                "action": "cloudtrail:GetEventDataStore",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.GetQueryResults": [
            {
                "action": "cloudtrail:GetQueryResults",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.ListEventDataStores": [
            {
                "action": "cloudtrail:ListEventDataStores",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.ListQueries": [
            {
                "action": "cloudtrail:ListQueries",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.RestoreEventDataStore": [
            {
                "action": "cloudtrail:RestoreEventDataStore",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "eventdatastore": "${EventDataStore}"
                }
            }
        ],
        "CloudTrail.StartQuery": [
            {
                "action": "cloudtrail:StartQuery",
                "resource_mappings": {}
            }
        ],
        "CloudTrail.UpdateEventDataStore": [
            {
                "action": "cloudtrail:UpdateEventDataStore",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "eventdatastore": "${EventDataStore}"
                }
            }
        ],
        "EC2.AllocateIpamPoolCidr": [
            {
                "action": "ec2:AllocateIpamPoolCidr",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    }
                }
            }
        ],
        "EC2.CreateIpam": [
            {
                "action": "ec2:CreateIpam",
                "resource_mappings": {
                    "IpamId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "IpamId": {
                        "template": "*"
                    },
                    "IpamPoolId": {
                        "template": "*"
                    },
                    "IpamScopeId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeAnalysisId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateIpamPool": [
            {
                "action": "ec2:CreateIpamPool",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "*"
                    },
                    "IpamScopeId": {
                        "template": "${IpamScopeId}"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "IpamId": {
                        "template": "*"
                    },
                    "IpamPoolId": {
                        "template": "*"
                    },
                    "IpamScopeId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeAnalysisId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateIpamScope": [
            {
                "action": "ec2:CreateIpamScope",
                "resource_mappings": {
                    "IpamId": {
                        "template": "${IpamId}"
                    },
                    "IpamScopeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "IpamId": {
                        "template": "*"
                    },
                    "IpamPoolId": {
                        "template": "*"
                    },
                    "IpamScopeId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeAnalysisId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreateNetworkInsightsAccessScope": [
            {
                "action": "ec2:CreateNetworkInsightsAccessScope",
                "resource_mappings": {
                    "NetworkInsightsAccessScopeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "IpamId": {
                        "template": "*"
                    },
                    "IpamPoolId": {
                        "template": "*"
                    },
                    "IpamScopeId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeAnalysisId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.CreatePublicIpv4Pool": [
            {
                "action": "ec2:CreatePublicIpv4Pool",
                "resource_mappings": {
                    "NetworkInsightsAccessScopeId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "IpamId": {
                        "template": "*"
                    },
                    "IpamPoolId": {
                        "template": "*"
                    },
                    "IpamScopeId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeAnalysisId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.DeleteIpam": [
            {
                "action": "ec2:DeleteIpam",
                "resource_mappings": {
                    "IpamId": {
                        "template": "${IpamId}"
                    }
                }
            }
        ],
        "EC2.DeleteIpamPool": [
            {
                "action": "ec2:DeleteIpamPool",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    }
                }
            }
        ],
        "EC2.DeleteIpamScope": [
            {
                "action": "ec2:DeleteIpamScope",
                "resource_mappings": {
                    "IpamScopeId": {
                        "template": "${IpamScopeId}"
                    }
                }
            }
        ],
        "EC2.DeleteNetworkInsightsAccessScope": [
            {
                "action": "ec2:DeleteNetworkInsightsAccessScope",
                "resource_mappings": {
                    "NetworkInsightsAccessScopeId": {
                        "template": "${NetworkInsightsAccessScopeId}"
                    }
                }
            }
        ],
        "EC2.DeleteNetworkInsightsAccessScopeAnalysis": [
            {
                "action": "ec2:DeleteNetworkInsightsAccessScopeAnalysis",
                "resource_mappings": {
                    "NetworkInsightsAccessScopeAnalysisId": {
                        "template": "${NetworkInsightsAccessScopeAnalysisId}"
                    }
                }
            }
        ],
        "EC2.DeletePublicIpv4Pool": [
            {
                "action": "ec2:DeletePublicIpv4Pool",
                "resource_mappings": {
                    "Ipv4PoolEc2Id": {
                        "template": "${PoolId}"
                    }
                }
            }
        ],
        "EC2.DeprovisionIpamPoolCidr": [
            {
                "action": "ec2:DeprovisionIpamPoolCidr",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    }
                }
            }
        ],
        "EC2.DeprovisionPublicIpv4PoolCidr": [
            {
                "action": "ec2:DeprovisionPublicIpv4PoolCidr",
                "resource_mappings": {
                    "Ipv4PoolEc2Id": {
                        "template": "${PoolId}"
                    }
                }
            }
        ],
        "EC2.DescribeFastLaunchImages": [
            {
                "action": "ec2:DescribeFastLaunchImages",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageIds[]}"
                    }
                }
            }
        ],
        "EC2.DescribeIpamPools": [
            {
                "action": "ec2:DescribeIpamPools",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeIpamScopes": [
            {
                "action": "ec2:DescribeIpamScopes",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeIpams": [
            {
                "action": "ec2:DescribeIpams",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeNetworkInsightsAccessScopeAnalyses": [
            {
                "action": "ec2:DescribeNetworkInsightsAccessScopeAnalyses",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeNetworkInsightsAccessScopes": [
            {
                "action": "ec2:DescribeNetworkInsightsAccessScopes",
                "resource_mappings": {}
            }
        ],
        "EC2.DescribeSnapshotTierStatus": [
            {
                "action": "ec2:DescribeSnapshotTierStatus",
                "resource_mappings": {}
            }
        ],
        "EC2.DisableFastLaunch": [
            {
                "action": "ec2:DisableFastLaunch",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    }
                }
            }
        ],
        "EC2.DisableIpamOrganizationAdminAccount": [
            {
                "action": "ec2:DisableIpamOrganizationAdminAccount",
                "resource_mappings": {}
            },
            {
                "action": "organizations:DeregisterDelegatedAdministrator",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.EnableFastLaunch": [
            {
                "action": "ec2:EnableFastLaunch",
                "resource_mappings": {
                    "ImageId": {
                        "template": "${ImageId}"
                    },
                    "LaunchTemplateId": {
                        "template": "${LaunchTemplate.LaunchTemplateId}"
                    }
                }
            }
        ],
        "EC2.EnableIpamOrganizationAdminAccount": [
            {
                "action": "ec2:EnableIpamOrganizationAdminAccount",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "organizations:EnableAWSServiceAccess",
                "resource_mappings": {}
            },
            {
                "action": "organizations:RegisterDelegatedAdministrator",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    }
                }
            }
        ],
        "EC2.GetInstanceTypesFromInstanceRequirements": [
            {
                "action": "ec2:GetInstanceTypesFromInstanceRequirements",
                "resource_mappings": {}
            }
        ],
        "EC2.GetIpamAddressHistory": [
            {
                "action": "ec2:GetIpamAddressHistory",
                "resource_mappings": {
                    "IpamScopeId": {
                        "template": "${IpamScopeId}"
                    }
                }
            }
        ],
        "EC2.GetIpamPoolAllocations": [
            {
                "action": "ec2:GetIpamPoolAllocations",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    }
                }
            }
        ],
        "EC2.GetIpamPoolCidrs": [
            {
                "action": "ec2:GetIpamPoolCidrs",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    }
                }
            }
        ],
        "EC2.GetIpamResourceCidrs": [
            {
                "action": "ec2:GetIpamResourceCidrs",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    },
                    "IpamScopeId": {
                        "template": "${IpamScopeId}"
                    }
                }
            }
        ],
        "EC2.GetNetworkInsightsAccessScopeAnalysisFindings": [
            {
                "action": "ec2:GetNetworkInsightsAccessScopeAnalysisFindings",
                "resource_mappings": {}
            }
        ],
        "EC2.GetNetworkInsightsAccessScopeContent": [
            {
                "action": "ec2:GetNetworkInsightsAccessScopeContent",
                "resource_mappings": {}
            }
        ],
        "EC2.GetSpotPlacementScores": [
            {
                "action": "ec2:GetSpotPlacementScores",
                "resource_mappings": {}
            }
        ],
        "EC2.ListSnapshotsInRecycleBin": [
            {
                "action": "ec2:ListSnapshotsInRecycleBin",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotIds[]}"
                    }
                }
            }
        ],
        "EC2.ModifyIpam": [
            {
                "action": "ec2:ModifyIpam",
                "resource_mappings": {
                    "IpamId": {
                        "template": "${IpamId}"
                    }
                }
            }
        ],
        "EC2.ModifyIpamPool": [
            {
                "action": "ec2:ModifyIpamPool",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    }
                }
            }
        ],
        "EC2.ModifyIpamResourceCidr": [
            {
                "action": "ec2:ModifyIpamResourceCidr",
                "resource_mappings": {
                    "IpamScopeId": {
                        "template": "%%many%${CurrentIpamScopeId}%${DestinationIpamScopeId}%%"
                    }
                }
            }
        ],
        "EC2.ModifyIpamScope": [
            {
                "action": "ec2:ModifyIpamScope",
                "resource_mappings": {
                    "IpamScopeId": {
                        "template": "${IpamScopeId}"
                    }
                }
            }
        ],
        "EC2.ModifyPrivateDnsNameOptions": [
            {
                "action": "ec2:ModifyPrivateDnsNameOptions",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "EC2.ModifySnapshotTier": [
            {
                "action": "ec2:ModifySnapshotTier",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EC2.ModifyVpcEndpointServicePayerResponsibility": [
            {
                "action": "ec2:ModifyVpcEndpointServicePayerResponsibility",
                "resource_mappings": {
                    "VpcEndpointServiceId": {
                        "template": "${ServiceId}"
                    }
                }
            }
        ],
        "EC2.MoveByoipCidrToIpam": [
            {
                "action": "ec2:MoveByoipCidrToIpam",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    }
                }
            }
        ],
        "EC2.ProvisionIpamPoolCidr": [
            {
                "action": "ec2:ProvisionIpamPoolCidr",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    }
                }
            }
        ],
        "EC2.ProvisionPublicIpv4PoolCidr": [
            {
                "action": "ec2:ProvisionPublicIpv4PoolCidr",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "${PoolId}"
                    }
                }
            }
        ],
        "EC2.ReleaseIpamPoolAllocation": [
            {
                "action": "ec2:ReleaseIpamPoolAllocation",
                "resource_mappings": {
                    "IpamPoolId": {
                        "template": "${IpamPoolId}"
                    }
                }
            }
        ],
        "EC2.RestoreSnapshotFromRecycleBin": [
            {
                "action": "ec2:RestoreSnapshotFromRecycleBin",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EC2.RestoreSnapshotTier": [
            {
                "action": "ec2:RestoreSnapshotTier",
                "resource_mappings": {
                    "SnapshotId": {
                        "template": "${SnapshotId}"
                    }
                }
            }
        ],
        "EC2.StartNetworkInsightsAccessScopeAnalysis": [
            {
                "action": "ec2:StartNetworkInsightsAccessScopeAnalysis",
                "resource_mappings": {
                    "NetworkInsightsAccessScopeId": {
                        "template": "${NetworkInsightsAccessScopeId}"
                    }
                }
            },
            {
                "action": "ec2:CreateTags",
                "resource_mappings": {
                    "CapacityReservationId": {
                        "template": "*"
                    },
                    "CapacityReservationFleetId": {
                        "template": "*"
                    },
                    "ClientVpnEndpointId": {
                        "template": "*"
                    },
                    "CustomerGatewayId": {
                        "template": "*"
                    },
                    "DedicatedHostId": {
                        "template": "*"
                    },
                    "DhcpOptionsId": {
                        "template": "*"
                    },
                    "EgressOnlyInternetGatewayId": {
                        "template": "*"
                    },
                    "ElasticGpuId": {
                        "template": "*"
                    },
                    "AllocationId": {
                        "template": "*"
                    },
                    "ExportImageTaskId": {
                        "template": "*"
                    },
                    "ExportTaskId": {
                        "template": "*"
                    },
                    "FleetId": {
                        "template": "*"
                    },
                    "FpgaImageId": {
                        "template": "*"
                    },
                    "HostReservationId": {
                        "template": "*"
                    },
                    "ImageId": {
                        "template": "*"
                    },
                    "ImportImageTaskId": {
                        "template": "*"
                    },
                    "ImportSnapshotTaskId": {
                        "template": "*"
                    },
                    "InstanceId": {
                        "template": "*"
                    },
                    "InstanceEventWindowId": {
                        "template": "*"
                    },
                    "InternetGatewayId": {
                        "template": "*"
                    },
                    "IpamId": {
                        "template": "*"
                    },
                    "IpamPoolId": {
                        "template": "*"
                    },
                    "IpamScopeId": {
                        "template": "*"
                    },
                    "Ipv4PoolEc2Id": {
                        "template": "*"
                    },
                    "Ipv6PoolEc2Id": {
                        "template": "*"
                    },
                    "KeyPairName": {
                        "template": "*"
                    },
                    "LaunchTemplateId": {
                        "template": "*"
                    },
                    "LocalGatewayId": {
                        "template": "*"
                    },
                    "LocalGatewayRoutetableId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayRouteTableVpcAssociationId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceId": {
                        "template": "*"
                    },
                    "LocalGatewayVirtualInterfaceGroupId": {
                        "template": "*"
                    },
                    "NatGatewayId": {
                        "template": "*"
                    },
                    "NaclId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeId": {
                        "template": "*"
                    },
                    "NetworkInsightsAccessScopeAnalysisId": {
                        "template": "*"
                    },
                    "NetworkInterfaceId": {
                        "template": "*"
                    },
                    "PlacementGroupName": {
                        "template": "*"
                    },
                    "PrefixListId": {
                        "template": "*"
                    },
                    "ReplaceRootVolumeTaskId": {
                        "template": "*"
                    },
                    "ReservationId": {
                        "template": "*"
                    },
                    "RouteTableId": {
                        "template": "*"
                    },
                    "SecurityGroupId": {
                        "template": "*"
                    },
                    "SecurityGroupRuleId": {
                        "template": "*"
                    },
                    "SnapshotId": {
                        "template": "*"
                    },
                    "SpotFleetRequestId": {
                        "template": "*"
                    },
                    "SpotInstanceRequestId": {
                        "template": "*"
                    },
                    "SubnetId": {
                        "template": "*"
                    },
                    "TrafficMirrorFilterId": {
                        "template": "*"
                    },
                    "TrafficMirrorSessionId": {
                        "template": "*"
                    },
                    "TrafficMirrorTargetId": {
                        "template": "*"
                    },
                    "TransitGatewayId": {
                        "template": "*"
                    },
                    "TransitGatewayAttachmentId": {
                        "template": "*"
                    },
                    "TransitGatewayConnectPeerId": {
                        "template": "*"
                    },
                    "TransitGatewayMulticastDomainId": {
                        "template": "*"
                    },
                    "TransitGatewayRouteTableId": {
                        "template": "*"
                    },
                    "VolumeId": {
                        "template": "*"
                    },
                    "VpcId": {
                        "template": "*"
                    },
                    "VpcEndpointId": {
                        "template": "*"
                    },
                    "VpcEndpointServiceId": {
                        "template": "*"
                    },
                    "VpcFlowLogId": {
                        "template": "*"
                    },
                    "VpcPeeringConnectionId": {
                        "template": "*"
                    },
                    "VpnConnectionId": {
                        "template": "*"
                    },
                    "VpnGatewayId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Route53Domains.DeleteDomain": [
            {
                "action": "route53domains:DeleteDomain",
                "resource_mappings": {}
            }
        ],
        "Route53Domains.ListPrices": [
            {
                "action": "route53domains:ListPrices",
                "resource_mappings": {}
            }
        ],
        "Shield.DisableApplicationLayerAutomaticResponse": [
            {
                "action": "shield:DisableApplicationLayerAutomaticResponse",
                "resource_mappings": {}
            }
        ],
        "Shield.EnableApplicationLayerAutomaticResponse": [
            {
                "action": "shield:EnableApplicationLayerAutomaticResponse",
                "resource_mappings": {}
            },
            {
                "action": "cloudfront:GetDistribution",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "distribution": "%%iftemplatematch%${ResourceArn}%%"
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "iam:GetRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Shield.UpdateApplicationLayerAutomaticResponse": [
            {
                "action": "shield:UpdateApplicationLayerAutomaticResponse",
                "resource_mappings": {}
            }
        ],
        "AppSync.AssociateApi": [
            {
                "action": "appsync:AssociateApi",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domainName}"
                    }
                }
            }
        ],
        "AppSync.CreateDomainName": [
            {
                "action": "appsync:CreateDomainName",
                "resource_mappings": {}
            }
        ],
        "AppSync.DeleteDomainName": [
            {
                "action": "appsync:DeleteDomainName",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domainName}"
                    }
                }
            }
        ],
        "AppSync.DisassociateApi": [
            {
                "action": "appsync:DisassociateApi",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domainName}"
                    }
                }
            }
        ],
        "AppSync.GetApiAssociation": [
            {
                "action": "appsync:GetApiAssociation",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domainName}"
                    }
                }
            }
        ],
        "AppSync.GetDomainName": [
            {
                "action": "appsync:GetDomainName",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domainName}"
                    }
                }
            }
        ],
        "AppSync.ListDomainNames": [
            {
                "action": "appsync:ListDomainNames",
                "resource_mappings": {}
            }
        ],
        "AppSync.UpdateDomainName": [
            {
                "action": "appsync:UpdateDomainName",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${domainName}"
                    }
                }
            }
        ],
        "PI.GetResourceMetadata": [
            {
                "action": "pi:GetResourceMetadata",
                "resource_mappings": {
                    "ServiceType": {
                        "template": "${ServiceType}"
                    },
                    "Identifier": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "PI.ListAvailableResourceDimensions": [
            {
                "action": "pi:ListAvailableResourceDimensions",
                "resource_mappings": {
                    "ServiceType": {
                        "template": "${ServiceType}"
                    },
                    "Identifier": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "PI.ListAvailableResourceMetrics": [
            {
                "action": "pi:ListAvailableResourceMetrics",
                "resource_mappings": {
                    "ServiceType": {
                        "template": "${ServiceType}"
                    },
                    "Identifier": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "EKS.RegisterCluster": [
            {
                "action": "eks:RegisterCluster",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.CreateDataCellsFilter": [
            {
                "action": "lakeformation:CreateDataCellsFilter",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.DeleteDataCellsFilter": [
            {
                "action": "lakeformation:DeleteDataCellsFilter",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.GetWorkUnitResults": [
            {
                "action": "lakeformation:GetWorkUnitResults",
                "resource_mappings": {}
            },
            {
                "action": "lakeformation:GetWorkUnits",
                "resource_mappings": {}
            },
            {
                "action": "lakeformation:StartQueryPlanning",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.StartQueryPlanning": [
            {
                "action": "lakeformation:StartQueryPlanning",
                "resource_mappings": {}
            }
        ],
        "LakeFormation.UpdateTableStorageOptimizer": [
            {
                "action": "lakeformation:UpdateTableStorageOptimizer",
                "resource_mappings": {}
            }
        ],
        "Outposts.UpdateOutpost": [
            {
                "action": "outposts:UpdateOutpost",
                "resource_mappings": {}
            }
        ],
        "Outposts.UpdateSiteAddress": [
            {
                "action": "outposts:UpdateSiteAddress",
                "resource_mappings": {}
            }
        ],
        "Detective.DescribeOrganizationConfiguration": [
            {
                "action": "detective:DescribeOrganizationConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "${GraphArn}"
                }
            },
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            }
        ],
        "Detective.DisableOrganizationAdminAccount": [
            {
                "action": "detective:DisableOrganizationAdminAccount",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            }
        ],
        "Detective.EnableOrganizationAdminAccount": [
            {
                "action": "detective:EnableOrganizationAdminAccount",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            },
            {
                "action": "organizations:EnableAWSServiceAccess",
                "resource_mappings": {}
            },
            {
                "action": "organizations:RegisterDelegatedAdministrator",
                "resource_mappings": {
                    "MasterAccountId": {
                        "template": "*"
                    },
                    "OrganizationId": {
                        "template": "*"
                    },
                    "AccountId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Detective.ListOrganizationAdminAccounts": [
            {
                "action": "detective:ListOrganizationAdminAccounts",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            }
        ],
        "Detective.UpdateOrganizationConfiguration": [
            {
                "action": "detective:UpdateOrganizationConfiguration",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "Graph": "${GraphArn}"
                }
            },
            {
                "action": "organizations:DescribeOrganization",
                "resource_mappings": {}
            }
        ],
        "NetworkFirewall.DescribeRuleGroupMetadata": [
            {
                "action": "network-firewall:DescribeRuleGroupMetadata",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "StatefulRuleGroup": "%%iftemplatematch%${RuleGroupArn}%%",
                    "StatelessRuleGroup": "%%iftemplatematch%${RuleGroupArn}%%"
                }
            }
        ],
        "LookoutVision.DescribeModelPackagingJob": [
            {
                "action": "lookoutvision:DescribeModelPackagingJob",
                "resource_mappings": {}
            }
        ],
        "LookoutVision.ListModelPackagingJobs": [
            {
                "action": "lookoutvision:ListModelPackagingJobs",
                "resource_mappings": {}
            }
        ],
        "LookoutVision.StartModelPackagingJob": [
            {
                "action": "lookoutvision:StartModelPackagingJob",
                "resource_mappings": {
                    "ProjectName": {
                        "template": "${ProjectName}"
                    },
                    "ModelVersion": {
                        "template": "${ModelVersion}"
                    }
                }
            }
        ],
        "GreengrassV2.AssociateServiceRoleToAccount": [
            {
                "action": "greengrass:AssociateServiceRoleToAccount",
                "resource_mappings": {}
            }
        ],
        "GreengrassV2.DisassociateServiceRoleFromAccount": [
            {
                "action": "greengrass:DisassociateServiceRoleFromAccount",
                "resource_mappings": {}
            }
        ],
        "GreengrassV2.GetConnectivityInfo": [
            {
                "action": "greengrass:GetConnectivityInfo",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "GreengrassV2.GetServiceRoleForAccount": [
            {
                "action": "greengrass:GetServiceRoleForAccount",
                "resource_mappings": {}
            }
        ],
        "GreengrassV2.UpdateConnectivityInfo": [
            {
                "action": "greengrass:UpdateConnectivityInfo",
                "resource_mappings": {
                    "ThingName": {
                        "template": "${thingName}"
                    }
                }
            }
        ],
        "Location.SearchPlaceIndexForSuggestions": [
            {
                "action": "geo:SearchPlaceIndexForSuggestions",
                "resource_mappings": {
                    "IndexName": {
                        "template": "${IndexName}"
                    }
                }
            }
        ],
        "LexModelsV2.DeleteCustomVocabulary": [
            {
                "action": "lex:DeleteCustomVocabulary",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LexModelsV2.DescribeCustomVocabularyMetadata": [
            {
                "action": "lex:DescribeCustomVocabularyMetadata",
                "resource_mappings": {
                    "BotId": {
                        "template": "${botId}"
                    }
                }
            }
        ],
        "LookoutMetrics.DeactivateAnomalyDetector": [
            {
                "action": "lookoutmetrics:DeactivateAnomalyDetector",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "LookoutMetrics.ListAnomalyGroupRelatedMetrics": [
            {
                "action": "lookoutmetrics:ListAnomalyGroupRelatedMetrics",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "AnomalyDetector": "${AnomalyDetectorArn}"
                }
            }
        ],
        "Proton.CreateRepository": [
            {
                "action": "proton:CreateRepository",
                "resource_mappings": {
                    "Provider": {
                        "template": "${provider}"
                    },
                    "Name": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.CreateTemplateSyncConfig": [
            {
                "action": "proton:CreateTemplateSyncConfig",
                "resource_mappings": {}
            }
        ],
        "Proton.DeleteRepository": [
            {
                "action": "proton:DeleteRepository",
                "resource_mappings": {
                    "Provider": {
                        "template": "${provider}"
                    },
                    "Name": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.DeleteTemplateSyncConfig": [
            {
                "action": "proton:DeleteTemplateSyncConfig",
                "resource_mappings": {}
            }
        ],
        "Proton.GetRepository": [
            {
                "action": "proton:GetRepository",
                "resource_mappings": {
                    "Provider": {
                        "template": "${provider}"
                    },
                    "Name": {
                        "template": "${name}"
                    }
                }
            }
        ],
        "Proton.GetRepositorySyncStatus": [
            {
                "action": "proton:GetRepositorySyncStatus",
                "resource_mappings": {}
            }
        ],
        "Proton.GetTemplateSyncConfig": [
            {
                "action": "proton:GetTemplateSyncConfig",
                "resource_mappings": {}
            }
        ],
        "Proton.GetTemplateSyncStatus": [
            {
                "action": "proton:GetTemplateSyncStatus",
                "resource_mappings": {}
            }
        ],
        "Proton.ListRepositorySyncDefinitions": [
            {
                "action": "proton:ListRepositorySyncDefinitions",
                "resource_mappings": {}
            }
        ],
        "Proton.UpdateTemplateSyncConfig": [
            {
                "action": "proton:UpdateTemplateSyncConfig",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryControlConfig.ListTagsForResource": [
            {
                "action": "route53-recovery-control-config:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Route53RecoveryControlConfig.TagResource": [
            {
                "action": "route53-recovery-control-config:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceArn}%%",
                    "controlpanel": "%%iftemplatematch%${ResourceArn}%%",
                    "safetyrule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "Route53RecoveryControlConfig.UntagResource": [
            {
                "action": "route53-recovery-control-config:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "cluster": "%%iftemplatematch%${ResourceArn}%%",
                    "controlpanel": "%%iftemplatematch%${ResourceArn}%%",
                    "safetyrule": "%%iftemplatematch%${ResourceArn}%%"
                }
            }
        ],
        "AppConfigData.GetLatestConfiguration": [
            {
                "action": "appconfig:GetLatestConfiguration",
                "resource_mappings": {
                    "ApplicationId": {
                        "template": "*"
                    },
                    "EnvironmentId": {
                        "template": "*"
                    },
                    "ConfigurationProfileId": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppStream.AssociateApplicationToEntitlement": [
            {
                "action": "appstream:AssociateApplicationToEntitlement",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "AppStream.DisassociateApplicationFromEntitlement": [
            {
                "action": "appstream:DisassociateApplicationFromEntitlement",
                "resource_mappings": {
                    "StackName": {
                        "template": "${StackName}"
                    }
                }
            }
        ],
        "RAM.ListPermissionVersions": [
            {
                "action": "ram:ListPermissionVersions",
                "resource_mappings": {}
            }
        ],
        "DataSync.CreateLocationFsxLustre": [
            {
                "action": "datasync:CreateLocationFsxLustre",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:datasync:${Region}:${Account}:*"
                }
            }
        ],
        "Imagebuilder.ImportVmImage": [
            {
                "action": "imagebuilder:ImportVmImage",
                "resource_mappings": {
                    "ImageName": {
                        "template": "${name}"
                    },
                    "ImageVersion": {
                        "template": "${semanticVersion}"
                    },
                    "ImageBuildVersion": {
                        "template": "*"
                    }
                }
            },
            {
                "action": "ec2:DescribeImportImageTasks",
                "resource_mappings": {}
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Finspacedata.CreateDataset": [
            {
                "action": "finspace-api:CreateDatasetV2",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:finspace-api:${Region}:${Account}:/datasetsv2"
                }
            }
        ],
        "ComprehendMedical.DescribeSNOMEDCTInferenceJob": [
            {
                "action": "comprehendmedical:DescribeSNOMEDCTInferenceJob",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "ComprehendMedical.InferSNOMEDCT": [
            {
                "action": "comprehendmedical:InferSNOMEDCT",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "ComprehendMedical.ListSNOMEDCTInferenceJobs": [
            {
                "action": "comprehendmedical:ListSNOMEDCTInferenceJobs",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "ComprehendMedical.StopSNOMEDCTInferenceJob": [
            {
                "action": "comprehendmedical:StopSNOMEDCTInferenceJob",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "TimestreamQuery.PrepareQuery": [
            {
                "action": "timestream:DescribeEndpoints",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "IoTWireless.CreateMulticastGroup": [
            {
                "action": "iotwireless:CreateMulticastGroup",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.DeleteQueuedMessages": [
            {
                "action": "iotwireless:DeleteQueuedMessages",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.GetNetworkAnalyzerConfiguration": [
            {
                "action": "iotwireless:GetNetworkAnalyzerConfiguration",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ListFuotaTasks": [
            {
                "action": "iotwireless:ListFuotaTasks",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ListMulticastGroups": [
            {
                "action": "iotwireless:ListMulticastGroups",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.ListQueuedMessages": [
            {
                "action": "iotwireless:ListQueuedMessages",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.UpdateNetworkAnalyzerConfiguration": [
            {
                "action": "iotwireless:UpdateNetworkAnalyzerConfiguration",
                "resource_mappings": {}
            }
        ],
        "ChimeSDKIdentity.CreateAppInstance": [
            {
                "action": "chime:CreateAppInstance",
                "resource_mappings": {}
            }
        ],
        "ChimeSDKIdentity.ListAppInstances": [
            {
                "action": "chime:ListAppInstances",
                "resource_mappings": {
                    "AccountId": {
                        "template": "${Account}"
                    },
                    "AppInstanceId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ChimeSDKMessaging.GetMessagingSessionEndpoint": [
            {
                "action": "chime:GetMessagingSessionEndpoint",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "ChimeSDKMeetings.BatchCreateAttendee": [
            {
                "action": "chime:BatchCreateAttendee",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:chime:${Region}:${Account}:meeting/${MeetingId}"
                }
            }
        ],
        "ChimeSDKMeetings.CreateAttendee": [
            {
                "action": "chime:CreateAttendee",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:chime:${Region}:${Account}:meeting/${MeetingId}"
                }
            }
        ],
        "ChimeSDKMeetings.CreateMeeting": [
            {
                "action": "chime:CreateMeeting",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:chime:${Region}:${Account}:meeting/*"
                }
            }
        ],
        "ChimeSDKMeetings.CreateMeetingWithAttendees": [
            {
                "action": "chime:CreateMeetingWithAttendees",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "ChimeSDKMeetings.DeleteAttendee": [
            {
                "action": "chime:DeleteAttendee",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:chime:${Region}:${Account}:meeting/${MeetingId}"
                }
            }
        ],
        "ChimeSDKMeetings.DeleteMeeting": [
            {
                "action": "chime:DeleteMeeting",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:chime:${Region}:${Account}:meeting/${MeetingId}"
                }
            }
        ],
        "ChimeSDKMeetings.GetAttendee": [
            {
                "action": "chime:GetAttendee",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:chime:${Region}:${Account}:meeting/${MeetingId}"
                }
            }
        ],
        "ChimeSDKMeetings.GetMeeting": [
            {
                "action": "chime:GetMeeting",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:chime:${Region}:${Account}:meeting/${MeetingId}"
                }
            }
        ],
        "ChimeSDKMeetings.ListAttendees": [
            {
                "action": "chime:ListAttendees",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:chime:${Region}:${Account}:meeting/${MeetingId}"
                }
            }
        ],
        "ChimeSDKMeetings.StartMeetingTranscription": [
            {
                "action": "chime:StartMeetingTranscription",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "ChimeSDKMeetings.StopMeetingTranscription": [
            {
                "action": "chime:StopMeetingTranscription",
                "undocumented": true,
                "arn_override": {
                    "template": "*"
                }
            }
        ],
        "MigrationHubRefactorSpaces.CreateApplication": [
            {
                "action": "refactor-spaces:CreateApplication",
                "resource_mappings": {}
            }
        ],
        "MigrationHubRefactorSpaces.CreateEnvironment": [
            {
                "action": "refactor-spaces:CreateEnvironment",
                "resource_mappings": {}
            }
        ],
        "MigrationHubRefactorSpaces.CreateRoute": [
            {
                "action": "refactor-spaces:CreateRoute",
                "resource_mappings": {}
            }
        ],
        "MigrationHubRefactorSpaces.CreateService": [
            {
                "action": "refactor-spaces:CreateService",
                "resource_mappings": {}
            }
        ],
        "MigrationHubRefactorSpaces.DeleteApplication": [
            {
                "action": "refactor-spaces:DeleteApplication",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    },
                    "ApplicationId": {
                        "template": "${ApplicationIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.DeleteEnvironment": [
            {
                "action": "refactor-spaces:DeleteEnvironment",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.DeleteResourcePolicy": [
            {
                "action": "refactor-spaces:DeleteResourcePolicy",
                "resource_mappings": {}
            }
        ],
        "MigrationHubRefactorSpaces.DeleteRoute": [
            {
                "action": "refactor-spaces:DeleteRoute",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    },
                    "ApplicationId": {
                        "template": "${ApplicationIdentifier}"
                    },
                    "RouteId": {
                        "template": "${RouteIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.DeleteService": [
            {
                "action": "refactor-spaces:DeleteService",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    },
                    "ApplicationId": {
                        "template": "${ApplicationIdentifier}"
                    },
                    "ServiceId": {
                        "template": "${ServiceIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.GetApplication": [
            {
                "action": "refactor-spaces:GetApplication",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    },
                    "ApplicationId": {
                        "template": "${ApplicationIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.GetEnvironment": [
            {
                "action": "refactor-spaces:GetEnvironment",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.GetResourcePolicy": [
            {
                "action": "refactor-spaces:GetResourcePolicy",
                "resource_mappings": {}
            }
        ],
        "MigrationHubRefactorSpaces.GetRoute": [
            {
                "action": "refactor-spaces:GetRoute",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    },
                    "ApplicationId": {
                        "template": "${ApplicationIdentifier}"
                    },
                    "RouteId": {
                        "template": "${RouteIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.GetService": [
            {
                "action": "refactor-spaces:GetService",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    },
                    "ApplicationId": {
                        "template": "${ApplicationIdentifier}"
                    },
                    "ServiceId": {
                        "template": "${ServiceIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.ListApplications": [
            {
                "action": "refactor-spaces:ListApplications",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.ListEnvironmentVpcs": [
            {
                "action": "refactor-spaces:ListEnvironmentVpcs",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.ListEnvironments": [
            {
                "action": "refactor-spaces:ListEnvironments",
                "resource_mappings": {}
            }
        ],
        "MigrationHubRefactorSpaces.ListRoutes": [
            {
                "action": "refactor-spaces:ListRoutes",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.ListServices": [
            {
                "action": "refactor-spaces:ListServices",
                "resource_mappings": {
                    "EnvironmentId": {
                        "template": "${EnvironmentIdentifier}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.PutResourcePolicy": [
            {
                "action": "refactor-spaces:PutResourcePolicy",
                "resource_mappings": {}
            }
        ],
        "AmplifyUIBuilder.UpdateComponent": [
            {
                "action": "amplifyuibuilder:UpdateComponent",
                "undocumented": true,
                "arn_override": {
                    "template": "arn:${Partition}:amplifyuibuilder:${Region}:${Account}:component/${id}"
                }
            }
        ],
        "CognitoIdentityServiceProvider.RevokeToken": [
            {
                "action": "cognito-idp:RevokeToken",
                "resource_mappings": {}
            },
            {
                "action": "cognito-idp:RevokeToken",
                "resource_mappings": {}
            }
        ],
        "DirectoryService.DescribeClientAuthenticationSettings": [
            {
                "action": "ds:DescribeClientAuthenticationSettings",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${DirectoryId}"
                    }
                }
            }
        ],
        "EFS.CreateReplicationConfiguration": [
            {
                "action": "elasticfilesystem:CreateReplicationConfiguration",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${SourceFileSystemId}"
                    }
                }
            }
        ],
        "EFS.DeleteReplicationConfiguration": [
            {
                "action": "elasticfilesystem:DeleteReplicationConfiguration",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${SourceFileSystemId}"
                    }
                }
            }
        ],
        "EFS.DescribeReplicationConfigurations": [
            {
                "action": "elasticfilesystem:DescribeReplicationConfigurations",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "ES.DescribeDomainChangeProgress": [
            {
                "action": "es:DescribeDomainChangeProgress",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "Kinesis.UpdateStreamMode": [
            {
                "action": "kinesis:UpdateStreamMode",
                "resource_mappings": {}
            }
        ],
        "Pinpoint.VerifyOTPMessage": [
            {
                "action": "mobiletargeting:VerifyOTPMessage",
                "resource_mappings": {
                    "AppId": {
                        "template": "${ApplicationId}"
                    }
                }
            }
        ],
        "StorageGateway.UpdateSMBLocalGroups": [
            {
                "action": "storagegateway:UpdateSMBLocalGroups",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "gateway": "${GatewayARN}"
                }
            }
        ],
        "WorkSpaces.CreateConnectClientAddIn": [
            {
                "action": "workspaces:CreateConnectClientAddIn",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "WorkSpaces.DeleteConnectClientAddIn": [
            {
                "action": "workspaces:DeleteConnectClientAddIn",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "WorkSpaces.DescribeConnectClientAddIns": [
            {
                "action": "workspaces:DescribeConnectClientAddIns",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "WorkSpaces.UpdateConnectClientAddIn": [
            {
                "action": "workspaces:UpdateConnectClientAddIn",
                "resource_mappings": {
                    "DirectoryId": {
                        "template": "${ResourceId}"
                    }
                }
            }
        ],
        "WorkMail.DeleteEmailMonitoringConfiguration": [
            {
                "action": "workmail:DeleteEmailMonitoringConfiguration",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.DescribeEmailMonitoringConfiguration": [
            {
                "action": "workmail:DescribeEmailMonitoringConfiguration",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "WorkMail.PutEmailMonitoringConfiguration": [
            {
                "action": "workmail:PutEmailMonitoringConfiguration",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${OrganizationId}"
                    }
                }
            }
        ],
        "Connect.AssociateDefaultVocabulary": [
            {
                "action": "connect:AssociateDefaultVocabulary",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.CreateVocabulary": [
            {
                "action": "connect:CreateVocabulary",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "VocabularyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.DeleteVocabulary": [
            {
                "action": "connect:DeleteVocabulary",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "VocabularyId": {
                        "template": "${VocabularyId}"
                    }
                }
            }
        ],
        "Connect.DescribeVocabulary": [
            {
                "action": "connect:DescribeVocabulary",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "VocabularyId": {
                        "template": "${VocabularyId}"
                    }
                }
            }
        ],
        "Connect.ListDefaultVocabularies": [
            {
                "action": "connect:ListDefaultVocabularies",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "Connect.SearchVocabularies": [
            {
                "action": "connect:SearchVocabularies",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    },
                    "VocabularyId": {
                        "template": "*"
                    }
                }
            }
        ],
        "Connect.StartContactStreaming": [
            {
                "action": "connect:StartContactStreaming",
                "resource_mappings": {
                    "InstanceId": {
                        "template": "${InstanceId}"
                    }
                }
            }
        ],
        "MediaTailor.ConfigureLogsForPlaybackConfiguration": [
            {
                "action": "mediatailor:ConfigureLogsForPlaybackConfiguration",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${PlaybackConfigurationName}"
                    }
                }
            },
            {
                "action": "iam:CreateServiceLinkedRole",
                "resource_mappings": {
                    "RoleNameWithPath": {
                        "template": "*"
                    }
                }
            }
        ],
        "MediaTailor.CreatePrefetchSchedule": [
            {
                "action": "mediatailor:CreatePrefetchSchedule",
                "resource_mappings": {
                    "ResourceId": {
                        "template": "${PlaybackConfigurationName}"
                    }
                }
            }
        ],
        "FSx.ReleaseFileSystemNfsV3Locks": [
            {
                "action": "fsx:ReleaseFileSystemNfsV3Locks",
                "resource_mappings": {
                    "FileSystemId": {
                        "template": "${FileSystemId}"
                    }
                }
            }
        ],
        "ForecastService.DescribeExplainability": [
            {
                "action": "forecast:DescribeExplainability",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "explainability": "${ExplainabilityArn}"
                }
            }
        ],
        "WAFV2.ListAvailableManagedRuleGroupVersions": [
            {
                "action": "wafv2:ListAvailableManagedRuleGroupVersions",
                "resource_mappings": {}
            }
        ],
        "FraudDetector.GetEventPredictionMetadata": [
            {
                "action": "frauddetector:GetEventPredictionMetadata",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "FraudDetector.ListEventPredictions": [
            {
                "action": "frauddetector:ListEventPredictions",
                "resource_mappings": {
                    "ResourcePath": {
                        "template": "*"
                    }
                }
            }
        ],
        "Honeycode.ListTagsForResource": [
            {
                "action": "honeycode:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "Honeycode.TagResource": [
            {
                "action": "honeycode:TagResource",
                "resource_mappings": {}
            }
        ],
        "Honeycode.UntagResource": [
            {
                "action": "honeycode:UntagResource",
                "resource_mappings": {}
            }
        ],
        "Appflow.DescribeConnector": [
            {
                "action": "appflow:DescribeConnector",
                "resource_mappings": {
                    "ConnectorLabel": {
                        "template": "${connectorLabel}"
                    }
                }
            }
        ],
        "Appflow.ListConnectors": [
            {
                "action": "appflow:ListConnectors",
                "resource_mappings": {
                    "ConnectorLabel": {
                        "template": "*"
                    }
                }
            }
        ],
        "Appflow.RegisterConnector": [
            {
                "action": "appflow:RegisterConnector",
                "resource_mappings": {}
            }
        ],
        "Appflow.UnregisterConnector": [
            {
                "action": "appflow:UnRegisterConnector",
                "resource_mappings": {
                    "ConnectorLabel": {
                        "template": "${connectorLabel}"
                    }
                }
            }
        ],
        "IoTWireless.AssociateMulticastGroupWithFuotaTask": [
            {
                "action": "iotwireless:AssociateMulticastGroupWithFuotaTask",
                "resource_mappings": {
                    "FuotaTaskId": {
                        "template": "${Id}"
                    },
                    "MulticastGroupId": {
                        "template": "${MulticastGroupId}"
                    }
                }
            }
        ],
        "IoTWireless.AssociateWirelessDeviceWithFuotaTask": [
            {
                "action": "iotwireless:AssociateWirelessDeviceWithFuotaTask",
                "resource_mappings": {
                    "FuotaTaskId": {
                        "template": "${Id}"
                    },
                    "WirelessDeviceId": {
                        "template": "${WirelessDeviceId}"
                    }
                }
            }
        ],
        "IoTWireless.AssociateWirelessDeviceWithMulticastGroup": [
            {
                "action": "iotwireless:AssociateWirelessDeviceWithMulticastGroup",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    },
                    "WirelessDeviceId": {
                        "template": "${WirelessDeviceId}"
                    }
                }
            }
        ],
        "IoTWireless.CancelMulticastGroupSession": [
            {
                "action": "iotwireless:CancelMulticastGroupSession",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.CreateFuotaTask": [
            {
                "action": "iotwireless:CreateFuotaTask",
                "resource_mappings": {}
            }
        ],
        "IoTWireless.DeleteFuotaTask": [
            {
                "action": "iotwireless:DeleteFuotaTask",
                "resource_mappings": {
                    "FuotaTaskId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.DeleteMulticastGroup": [
            {
                "action": "iotwireless:DeleteMulticastGroup",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.DisassociateMulticastGroupFromFuotaTask": [
            {
                "action": "iotwireless:DisassociateMulticastGroupFromFuotaTask",
                "resource_mappings": {
                    "FuotaTaskId": {
                        "template": "${Id}"
                    },
                    "MulticastGroupId": {
                        "template": "${MulticastGroupId}"
                    }
                }
            }
        ],
        "IoTWireless.DisassociateWirelessDeviceFromFuotaTask": [
            {
                "action": "iotwireless:DisassociateWirelessDeviceFromFuotaTask",
                "resource_mappings": {
                    "FuotaTaskId": {
                        "template": "${Id}"
                    },
                    "WirelessDeviceId": {
                        "template": "${WirelessDeviceId}"
                    }
                }
            }
        ],
        "IoTWireless.DisassociateWirelessDeviceFromMulticastGroup": [
            {
                "action": "iotwireless:DisassociateWirelessDeviceFromMulticastGroup",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    },
                    "WirelessDeviceId": {
                        "template": "${WirelessDeviceId}"
                    }
                }
            }
        ],
        "IoTWireless.GetFuotaTask": [
            {
                "action": "iotwireless:GetFuotaTask",
                "resource_mappings": {
                    "FuotaTaskId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.GetMulticastGroup": [
            {
                "action": "iotwireless:GetMulticastGroup",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.GetMulticastGroupSession": [
            {
                "action": "iotwireless:GetMulticastGroupSession",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.GetResourceEventConfiguration": [
            {
                "action": "iotwireless:GetResourceEventConfiguration",
                "resource_mappings": {
                    "SidewalkAccountId": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "IoTWireless.ListMulticastGroupsByFuotaTask": [
            {
                "action": "iotwireless:ListMulticastGroupsByFuotaTask",
                "resource_mappings": {
                    "FuotaTaskId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.SendDataToMulticastGroup": [
            {
                "action": "iotwireless:SendDataToMulticastGroup",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.StartBulkAssociateWirelessDeviceWithMulticastGroup": [
            {
                "action": "iotwireless:StartBulkAssociateWirelessDeviceWithMulticastGroup",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.StartBulkDisassociateWirelessDeviceFromMulticastGroup": [
            {
                "action": "iotwireless:StartBulkDisassociateWirelessDeviceFromMulticastGroup",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.StartFuotaTask": [
            {
                "action": "iotwireless:StartFuotaTask",
                "resource_mappings": {
                    "FuotaTaskId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.StartMulticastGroupSession": [
            {
                "action": "iotwireless:StartMulticastGroupSession",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.UpdateFuotaTask": [
            {
                "action": "iotwireless:UpdateFuotaTask",
                "resource_mappings": {
                    "FuotaTaskId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.UpdateMulticastGroup": [
            {
                "action": "iotwireless:UpdateMulticastGroup",
                "resource_mappings": {
                    "MulticastGroupId": {
                        "template": "${Id}"
                    }
                }
            }
        ],
        "IoTWireless.UpdateResourceEventConfiguration": [
            {
                "action": "iotwireless:UpdateResourceEventConfiguration",
                "resource_mappings": {
                    "SidewalkAccountId": {
                        "template": "${Identifier}"
                    }
                }
            }
        ],
        "Location.CalculateRouteMatrix": [
            {
                "action": "geo:CalculateRouteMatrix",
                "resource_mappings": {
                    "CalculatorName": {
                        "template": "${CalculatorName}"
                    }
                }
            }
        ],
        "Fis.GetTargetResourceType": [
            {
                "action": "fis:GetTargetResourceType",
                "resource_mappings": {}
            }
        ],
        "Fis.ListTargetResourceTypes": [
            {
                "action": "fis:ListTargetResourceTypes",
                "resource_mappings": {}
            }
        ],
        "AppRunner.CreateVpcConnector": [
            {
                "action": "apprunner:CreateVpcConnector",
                "resource_mappings": {
                    "VpcConnectorName": {
                        "template": "${VpcConnectorName}"
                    },
                    "VpcConnectorVersion": {
                        "template": "*"
                    },
                    "VpcConnectorId": {
                        "template": "*"
                    }
                }
            }
        ],
        "AppRunner.DeleteVpcConnector": [
            {
                "action": "apprunner:DeleteVpcConnector",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "vpcconnector": "${VpcConnectorArn}"
                }
            }
        ],
        "AppRunner.DescribeVpcConnector": [
            {
                "action": "apprunner:DescribeVpcConnector",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "vpcconnector": "${VpcConnectorArn}"
                }
            }
        ],
        "AppRunner.ListVpcConnectors": [
            {
                "action": "apprunner:ListVpcConnectors",
                "resource_mappings": {}
            }
        ],
        "ChimeSDKIdentity.CreateAppInstanceAdmin": [
            {
                "action": "chime:CreateAppInstanceAdmin",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}",
                    "app-instance-user": "${AppInstanceAdminArn}"
                }
            }
        ],
        "ChimeSDKIdentity.CreateAppInstanceUser": [
            {
                "action": "chime:CreateAppInstanceUser",
                "resource_mappings": {}
            }
        ],
        "ChimeSDKIdentity.DeleteAppInstance": [
            {
                "action": "chime:DeleteAppInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "ChimeSDKIdentity.DeleteAppInstanceAdmin": [
            {
                "action": "chime:DeleteAppInstanceAdmin",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}",
                    "app-instance-user": "${AppInstanceAdminArn}"
                }
            }
        ],
        "ChimeSDKIdentity.DeleteAppInstanceUser": [
            {
                "action": "chime:DeleteAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "ChimeSDKIdentity.DeregisterAppInstanceUserEndpoint": [
            {
                "action": "chime:DeregisterAppInstanceUserEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "ChimeSDKIdentity.DescribeAppInstance": [
            {
                "action": "chime:DescribeAppInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "ChimeSDKIdentity.DescribeAppInstanceAdmin": [
            {
                "action": "chime:DescribeAppInstanceAdmin",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}",
                    "app-instance-user": "${AppInstanceAdminArn}"
                }
            }
        ],
        "ChimeSDKIdentity.DescribeAppInstanceUser": [
            {
                "action": "chime:DescribeAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "ChimeSDKIdentity.DescribeAppInstanceUserEndpoint": [
            {
                "action": "chime:DescribeAppInstanceUserEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "ChimeSDKIdentity.GetAppInstanceRetentionSettings": [
            {
                "action": "chime:GetAppInstanceRetentionSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "ChimeSDKIdentity.ListAppInstanceAdmins": [
            {
                "action": "chime:ListAppInstanceAdmins",
                "resource_mappings": {
                    "AccountId": {
                        "template": "*"
                    },
                    "AppInstanceId": {
                        "template": "*"
                    },
                    "AppInstanceUserId": {
                        "template": "*"
                    }
                },
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "ChimeSDKIdentity.ListAppInstanceUserEndpoints": [
            {
                "action": "chime:ListAppInstanceUserEndpoints",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "ChimeSDKIdentity.ListAppInstanceUsers": [
            {
                "action": "chime:ListAppInstanceUsers",
                "resource_mappings": {
                    "AccountId": {
                        "template": "*"
                    },
                    "AppInstanceId": {
                        "template": "*"
                    },
                    "AppInstanceUserId": {
                        "template": "*"
                    }
                }
            }
        ],
        "ChimeSDKIdentity.ListTagsForResource": [
            {
                "action": "chime:ListTagsForResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftruthy%${ResourceARN}%%"
                }
            }
        ],
        "ChimeSDKIdentity.PutAppInstanceRetentionSettings": [
            {
                "action": "chime:PutAppInstanceRetentionSettings",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "ChimeSDKIdentity.RegisterAppInstanceUserEndpoint": [
            {
                "action": "chime:RegisterAppInstanceUserEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "ChimeSDKIdentity.TagResource": [
            {
                "action": "chime:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftruthy%${ResourceARN}%%"
                }
            }
        ],
        "ChimeSDKIdentity.UntagResource": [
            {
                "action": "chime:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "channel": "%%iftruthy%${ResourceARN}%%"
                }
            }
        ],
        "ChimeSDKIdentity.UpdateAppInstance": [
            {
                "action": "chime:UpdateAppInstance",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance": "${AppInstanceArn}"
                }
            }
        ],
        "ChimeSDKIdentity.UpdateAppInstanceUser": [
            {
                "action": "chime:UpdateAppInstanceUser",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "ChimeSDKIdentity.UpdateAppInstanceUserEndpoint": [
            {
                "action": "chime:UpdateAppInstanceUserEndpoint",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "app-instance-user": "${AppInstanceUserArn}"
                }
            }
        ],
        "OpenSearch.DescribeDomainChangeProgress": [
            {
                "action": "es:DescribeDomainChangeProgress",
                "resource_mappings": {
                    "DomainName": {
                        "template": "${DomainName}"
                    }
                }
            }
        ],
        "MigrationHubRefactorSpaces.ListTagsForResource": [
            {
                "action": "refactor-spaces:ListTagsForResource",
                "resource_mappings": {}
            }
        ],
        "MigrationHubRefactorSpaces.TagResource": [
            {
                "action": "refactor-spaces:TagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftruthy%${ResourceArn}%%",
                    "environment": "%%iftruthy%${ResourceArn}%%",
                    "route": "%%iftruthy%${ResourceArn}%%",
                    "service": "%%iftruthy%${ResourceArn}%%"
                }
            }
        ],
        "MigrationHubRefactorSpaces.UntagResource": [
            {
                "action": "refactor-spaces:UntagResource",
                "resource_mappings": {},
                "resourcearn_mappings": {
                    "application": "%%iftruthy%${ResourceArn}%%",
                    "environment": "%%iftruthy%${ResourceArn}%%",
                    "route": "%%iftruthy%${ResourceArn}%%",
                    "service": "%%iftruthy%${ResourceArn}%%"
                }
            }
        ],
        "Evidently.TagResource": [
            {
                "action": "evidently:TagResource",
                "resource_mappings": {}
            }
        ]
    },
    "sdk_service_mappings": {
        "ACM PCA": "acm-pca",
        "ACMPCA": "acm-pca",
        "AccessAnalyzer": "access-analyzer",
        "Alexa For Business": "a4b",
        "AlexaForBusiness": "a4b",
        "Amp": "aps",
        "Amplify": "amplify",
        "AmplifyBackend": "amplifybackend",
        "AmplifyUIBuilder": "amplifyuibuilder",
        "API Gateway": "apigateway",
        "ApiGatewayManagementApi": "apigateway",
        "API Gateway V2": "apigateway",
        "ApiGatewayV2": "apigateway",
        "App Mesh": "appmesh",
        "AppConfig": "appconfig",
        "AppConfigData": "appconfig",
        "AppIntegrations": "app-integrations",
        "AppStream": "appstream",
        "AppSync": "appsync",
        "Appflow": "appflow",
        "Application Auto Scaling": "application-autoscaling",
        "Application Discovery Service": "discovery",
        "Application Insights": "applicationinsights",
        "ApplicationAutoScaling": "application-autoscaling",
        "ApplicationCostProfiler": "application-cost-profiler",
        "AuditManager": "auditmanager",
        "AugmentedAIRuntime": "sagemaker",
        "Auto Scaling": "autoscaling",
        "Auto Scaling Plans": "autoscaling-plans",
        "AutoScalingPlans": "autoscaling-plans",
        "BackupGateway": "backup-gateway",
        "Braket": "braket",
        "ChimeSDKIdentity": "chime",
        "CloudControl": "cloudformation",
        "CloudDirectory": "clouddirectory",
        "CloudHSM V2": "cloudhsm",
        "CloudHSMV2": "cloudhsm",
        "CloudSearch Domain": "cloudsearch",
        "CloudSearchDomain": "cloudsearch",
        "CloudWatchEvents": "events",
        "CloudWatch Events": "events",
        "CloudWatchLogs": "logs",
        "CloudWatch Logs": "logs",
        "Cloudwatch Logs": "logs",
        "CodeGuru Reviewer": "codeguru-reviewer",
        "CodeGuruProfiler": "codeguru-profiler",
        "CodeGuruReviewer": "codeguru-reviewer",
        "codestar notifications": "codestar-notifications",
        "CodeStar connections": "codestar-connections",
        "CodeStarNotifications": "codestar-notifications",
        "CodeStarconnections": "codestar-connections",
        "Cognito Identity": "cognito-identity",
        "CognitoIdentity": "cognito-identity",
        "Cognito Identity Provider": "cognito-idp",
        "CognitoIdentityServiceProvider": "cognito-idp",
        "Cognito Sync": "cognito-sync",
        "CognitoSync": "cognito-sync",
        "Comprehend": "comprehend",
        "ComprehendMedical": "comprehendmedical",
        "Compute Optimizer": "compute-optimizer",
        "ComputeOptimizer": "compute-optimizer",
        "Config Service": "config",
        "ConfigService": "config",
        "Connect Contact Lens": "connect",
        "Connect": "connect",
        "ConnectContactLens": "connect",
        "ConnectParticipant": "execute-api",
        "Cost Explorer": "ce",
        "Cost and Usage Report Service": "cur",
        "CostExplorer": "ce",
        "Customer Profiles": "profile",
        "CustomerProfiles": "profile",
        "DLM": "dlm",
        "DataBrew": "databrew",
        "DataExchange": "dataexchange",
        "Data Migration Service": "dms",
        "Data Pipeline": "datapipeline",
        "DataSync": "datasync",
        "Detective": "detective",
        "DevOps Guru": "devops-guru",
        "DevOpsGuru": "devops-guru",
        "Device Farm": "devicefarm",
        "Direct Connect": "directconnect",
        "Directory Service": "ds",
        "DirectoryService": "ds",
        "DocDB": "rds",
        "DynamoDB Streams": "dynamodb",
        "DynamoDBStreams": "dynamodb",
        "EC2InstanceConnect": "ec2-instance-connect",
        "EC2 Instance Connect": "ec2-instance-connect",
        "ECR PUBLIC": "ecr-public",
        "ECR": "ecr",
        "ECRPUBLIC": "ecr-public",
        "EFS": "elasticfilesystem",
        "EKS": "eks",
        "ELB": "elasticloadbalancing",
        "ELBv2": "elasticloadbalancing",
        "EMR containers": "emr-containers",
        "EMR": "elasticmapreduce",
        "EMRcontainers": "emr-containers",
        "Elasticsearch Service": "es",
        "Elastic Beanstalk": "elasticbeanstalk",
        "Elastic Load Balancing": "elasticloadbalancing",
        "Elastic Load Balancing v2": "elasticloadbalancing",
        "Elastic Inference": "elastic-inference",
        "ElasticInference": "elastic-inference",
        "Elastic Transcoder": "elastictranscoder",
        "EventBridge": "events",
        "Finspacedata": "finspace-api",
        "FSx": "fsx",
        "forecastquery": "forecast",
        "ForecastQueryService": "forecast",
        "ForecastService": "forecast",
        "Global Accelerator": "globalaccelerator",
        "Greengrass": "greengrass",
        "GreengrassV2": "greengrass",
        "GroundStation": "groundstation",
        "GuardDuty": "guardduty",
        "HealthLake": "healthlake",
        "Honeycode": "honeycode",
        "IoT 1Click Devices Service": "iot1click",
        "IoT 1Click Projects": "iot1click",
        "IoT Data Plane": "iot",
        "IoT Events Data": "iotevents",
        "IoT Events": "iotevents",
        "IoT Jobs Data Plane": "iot",
        "IoTWireless": "iotwireless",
        "IoT Wireless": "iot",
        "IoT": "iot",
        "IoT1ClickDevicesService": "iot1click",
        "IoT1ClickProjects": "iot1click",
        "IoTAnalytics": "iotanalytics",
        "IoTEventsData": "iotevents",
        "IoTFleetHub": "iotfleethub",
        "IoTJobsDataPlane": "iot",
        "IoTSecureTunneling": "iot",
        "IoTSiteWise": "iotsitewise",
        "IoTThingsGraph": "iotthingsgraph",
        "IotData": "iot",
        "IotDeviceAdvisor": "iotdeviceadvisor",
        "Kafka": "kafka",
        "Kinesis Analytics": "kinesisanalytics",
        "Kinesis Analytics V2": "kinesisanalytics",
        "KinesisAnalyticsV2": "kinesisanalytics",
        "KinesisVideoArchivedMedia": "kinesisvideo",
        "KinesisVideoMedia": "kinesisvideo",
        "Kinesis Video": "kinesisvideo",
        "Kinesis Video Archived Media": "kinesisvideo",
        "Kinesis Video Media": "kinesisvideo",
        "Kinesis Video Signaling": "kinesisvideo",
        "KinesisVideoSignalingChannels": "kinesisvideo",
        "LakeFormation": "lakeformation",
        "Lex Model Building Service": "lex",
        "Lex Models V2": "lex",
        "Lex Runtime Service": "lex",
        "Lex Runtime V2": "lex",
        "LexModelBuildingService": "lex",
        "LexModelsV2": "lex",
        "LexRuntime": "lex",
        "LexRuntimeV2": "lex",
        "License Manager": "license-manager",
        "LicenseManager": "license-manager",
        "Location": "geo",
        "LookoutVision": "lookoutvision",
        "MTurk": "mechanicalturk",
        "MWAA": "airflow",
        "Macie2": "macie2",
        "ManagedBlockchain": "managedblockchain",
        "Machine Learning": "machinelearning",
        "Marketplace Catalog": "aws-marketplace",
        "Marketplace Commerce Analytics": "marketplacecommerceanalytics",
        "Marketplace Entitlement Service": "aws-marketplace",
        "Marketplace Metering": "aws-marketplace",
        "MarketplaceCatalog": "aws-marketplace",
        "MarketplaceEntitlementService": "aws-marketplace",
        "MarketplaceMetering": "aws-marketplace",
        "MediaConnect": "mediaconnect",
        "MediaConvert": "mediaconvert",
        "MediaLive": "medialive",
        "MediaPackage Vod": "mediapackage-vod",
        "MediaPackage": "mediapackage",
        "MediaPackageVod": "mediapackage-vod",
        "MediaStore Data": "mediastore",
        "MediaStore": "mediastore",
        "MediaStoreData": "mediastore",
        "MediaTailor": "mediatailor",
        "MigrationHub Config": "mgh",
        "MigrationHub": "mgh",
        "Migration Hub": "mgh",
        "MigrationHubConfig": "mgh",
        "MigrationHubRefactorSpaces": "refactor-spaces",
        "MigrationHubStrategy": "migrationhub-strategy",
        "Mobile": "mobilehub",
        "Neptune": "rds",
        "Network Firewall": "network-firewall",
        "NetworkFirewall": "network-firewall",
        "NetworkManager": "networkmanager",
        "OpenSearch": "es",
        "OpsWorksCM": "opsworks-cm",
        "Outposts": "outposts",
        "PI": "pi",
        "Personalize Events": "personalize",
        "Personalize Runtime": "personalize",
        "Personalize": "personalize",
        "PersonalizeEvents": "personalize",
        "PersonalizeRuntime": "personalize",
        "Pinpoint Email": "ses",
        "Pinpoint SMS Voice": "sms-voice",
        "Pinpoint": "mobiletargeting",
        "PinpointEmail": "ses",
        "PinpointSMSVoice": "sms-voice",
        "Pricing": "pricing",
        "QLDB Session": "qldb",
        "QLDB": "qldb",
        "QLDBSession": "qldb",
        "RDS Data": "rds-data",
        "RDSDataService": "rds-data",
        "Redshift Data": "redshift-data",
        "RedshiftData": "redshift-data",
        "Resource Groups": "resource-groups",
        "ResourceGroups": "resource-groups",
        "ResourceGroupsTaggingAPI": "tag",
        "Resource Groups Tagging API": "tag",
        "Route 53": "route53",
        "Route 53 Domains": "route53domains",
        "Route53RecoveryCluster": "route53-recovery-cluster",
        "Route53RecoveryControlConfig": "route53-recovery-control-config",
        "Route53RecoveryReadiness": "route53-recovery-readiness",
        "RoboMaker": "robomaker",
        "S3": "s3",
        "S3 Control": "s3",
        "S3Control": "s3",
        "S3Outposts": "s3-outposts",
        "Service Catalog": "servicecatalog",
        "SES": "ses",
        "SESV2": "ses",
        "SESv2": "ses",
        "SSMContacts": "ssm-contacts",
        "SSMIncidents": "ssm-incidents",
        "SSO Admin": "sso",
        "SSO OIDC": "sso-directory",
        "SSO": "sso",
        "SSOAdmin": "sso",
        "SSOOIDC": "sso-directory",
        "SageMaker A2I Runtime": "sagemaker",
        "SageMaker FeatureStore Runtime": "sagemaker",
        "SageMaker Runtime": "sagemaker",
        "SageMaker": "sagemaker",
        "SageMakerFeatureStoreRuntime": "sagemaker",
        "SageMakerRuntime": "sagemaker",
        "Sagemaker Edge": "sagemaker",
        "SagemakerEdge": "sagemaker",
        "Secrets Manager": "secretsmanager",
        "SecurityHub": "securityhub",
        "ServerlessApplicationRepository": "serverlessrepo",
        "Service Quotas": "servicequotas",
        "Service Catalog AppRegistry": "servicecatalog",
        "ServiceCatalogAppRegistry": "servicecatalog",
        "SimpleDB": "sdb",
        "SimpleWorkflow": "swf",
        "SnowDeviceManagement": "snow-device-management",
        "StepFunctions": "states",
        "Storage Gateway": "storagegateway",
        "Timestream Query": "timestream",
        "Timestream Write": "timestream",
        "TimestreamQuery": "timestream",
        "TimestreamWrite": "timestream",
        "Transcribe": "transcribe",
        "TranscribeService": "transcribe",
        "Transfer": "transfer",
        "Translate": "translate",
        "WAFRegional": "waf-regional",
        "WellArchitected": "wellarchitected",
        "WorkLink": "worklink",
        "WorkSpacesWeb": "workspaces-web"
    },
    "service_sdk_mappings": {
        "a4b": [
            "AlexaForBusiness"
        ],
        "access-analyzer": [
            "AccessAnalyzer"
        ],
        "account": [
            "Account"
        ],
        "acm": [
            "ACM"
        ],
        "acm-pca": [
            "ACMPCA"
        ],
        "airflow": [
            "MWAA"
        ],
        "amplify": [
            "Amplify"
        ],
        "amplifybackend": [
            "AmplifyBackend"
        ],
        "amplifyuibuilder": [
            "AmplifyUIBuilder"
        ],
        "apigateway": [
            "ApiGatewayManagementApi",
            "ApiGatewayV2"
        ],
        "app-integrations": [
            "AppIntegrations"
        ],
        "appconfig": [
            "AppConfig"
        ],
        "appflow": [
            "Appflow"
        ],
        "application-autoscaling": [
            "ApplicationAutoScaling"
        ],
        "application-cost-profiler": [
            "ApplicationCostProfiler"
        ],
        "applicationinsights": [
            "ApplicationInsights"
        ],
        "appmesh": [
            "AppMesh"
        ],
        "apprunner": [
            "AppRunner"
        ],
        "appstream": [
            "AppStream"
        ],
        "appsync": [
            "AppSync"
        ],
        "aps": [
            "Amp"
        ],
        "athena": [
            "Athena"
        ],
        "auditmanager": [
            "AuditManager"
        ],
        "autoscaling": [
            "AutoScaling"
        ],
        "autoscaling-plans": [
            "AutoScalingPlans"
        ],
        "aws-marketplace": [
            "MarketplaceCatalog",
            "MarketplaceEntitlementService",
            "MarketplaceMetering"
        ],
        "backup": [
            "Backup"
        ],
        "backup-gateway": [
            "BackupGateway"
        ],
        "batch": [
            "Batch"
        ],
        "braket": [
            "Braket"
        ],
        "budgets": [
            "Budgets"
        ],
        "ce": [
            "CostExplorer"
        ],
        "chime": [
            "Chime",
            "ChimeSDKIdentity"
        ],
        "cloud9": [
            "Cloud9"
        ],
        "clouddirectory": [
            "CloudDirectory"
        ],
        "cloudformation": [
            "CloudFormation"
        ],
        "cloudfront": [
            "CloudFront"
        ],
        "cloudhsm": [
            "CloudHSMV2"
        ],
        "cloudsearch": [
            "CloudSearchDomain"
        ],
        "cloudtrail": [
            "CloudTrail"
        ],
        "cloudwatch": [
            "CloudWatch"
        ],
        "codeartifact": [
            "CodeArtifact"
        ],
        "codebuild": [
            "CodeBuild"
        ],
        "codecommit": [
            "CodeCommit"
        ],
        "codedeploy": [
            "CodeDeploy"
        ],
        "codeguru-profiler": [
            "CodeGuruProfiler"
        ],
        "codeguru-reviewer": [
            "CodeGuruReviewer"
        ],
        "codepipeline": [
            "CodePipeline"
        ],
        "codestar": [
            "CodeStar"
        ],
        "codestar-connections": [
            "CodeStarconnections"
        ],
        "codestar-notifications": [
            "CodeStarNotifications"
        ],
        "cognito-identity": [
            "CognitoIdentity"
        ],
        "cognito-idp": [
            "CognitoIdentityServiceProvider"
        ],
        "cognito-sync": [
            "CognitoSync"
        ],
        "comprehend": [
            "Comprehend"
        ],
        "comprehendmedical": [
            "ComprehendMedical"
        ],
        "compute-optimizer": [
            "ComputeOptimizer"
        ],
        "config": [
            "ConfigService"
        ],
        "connect": [
            "Connect",
            "ConnectContactLens"
        ],
        "cur": [
            "CUR"
        ],
        "databrew": [
            "DataBrew"
        ],
        "dataexchange": [
            "DataExchange"
        ],
        "datapipeline": [
            "DataPipeline"
        ],
        "datasync": [
            "DataSync"
        ],
        "dax": [
            "DAX"
        ],
        "detective": [
            "Detective"
        ],
        "devicefarm": [
            "DeviceFarm"
        ],
        "devops-guru": [
            "DevOpsGuru"
        ],
        "directconnect": [
            "DirectConnect"
        ],
        "discovery": [
            "Discovery"
        ],
        "dlm": [
            "DLM"
        ],
        "dms": [
            "DMS"
        ],
        "drs": [
            "Drs"
        ],
        "ds": [
            "DirectoryService"
        ],
        "dynamodb": [
            "DynamoDBStreams"
        ],
        "ebs": [
            "EBS"
        ],
        "ec2": [
            "EC2"
        ],
        "ec2-instance-connect": [
            "EC2InstanceConnect"
        ],
        "ecr": [
            "ECR"
        ],
        "ecr-public": [
            "ECRPUBLIC"
        ],
        "ecs": [
            "ECS"
        ],
        "eks": [
            "EKS"
        ],
        "elastic-inference": [
            "ElasticInference"
        ],
        "elasticache": [
            "ElastiCache"
        ],
        "elasticbeanstalk": [
            "ElasticBeanstalk"
        ],
        "elasticfilesystem": [
            "EFS"
        ],
        "elasticloadbalancing": [
            "ELB",
            "ELBv2"
        ],
        "elasticmapreduce": [
            "EMR"
        ],
        "elastictranscoder": [
            "ElasticTranscoder"
        ],
        "emr-containers": [
            "EMRcontainers"
        ],
        "es": [
            "OpenSearch"
        ],
        "events": [
            "CloudWatchEvents",
            "EventBridge"
        ],
        "evidently": [
            "Evidently"
        ],
        "execute-api": [
            "ConnectParticipant"
        ],
        "finspace": [
            "Finspace"
        ],
        "finspace-api": [
            "Finspacedata"
        ],
        "firehose": [
            "Firehose"
        ],
        "fis": [
            "Fis"
        ],
        "fms": [
            "FMS"
        ],
        "forecast": [
            "forecastquery",
            "ForecastQueryService",
            "ForecastService"
        ],
        "frauddetector": [
            "FraudDetector"
        ],
        "fsx": [
            "FSx"
        ],
        "gamelift": [
            "GameLift"
        ],
        "geo": [
            "Location"
        ],
        "glacier": [
            "Glacier"
        ],
        "globalaccelerator": [
            "GlobalAccelerator"
        ],
        "glue": [
            "Glue"
        ],
        "grafana": [
            "Grafana"
        ],
        "greengrass": [
            "Greengrass",
            "GreengrassV2"
        ],
        "groundstation": [
            "GroundStation"
        ],
        "guardduty": [
            "GuardDuty"
        ],
        "health": [
            "Health"
        ],
        "healthlake": [
            "HealthLake"
        ],
        "honeycode": [
            "Honeycode"
        ],
        "iam": [
            "IAM"
        ],
        "identitystore": [
            "IdentityStore"
        ],
        "imagebuilder": [
            "Imagebuilder"
        ],
        "importexport": [
            "ImportExport"
        ],
        "inspector": [
            "Inspector"
        ],
        "inspector2": [
            "Inspector2"
        ],
        "iot": [
            "IoTWireless",
            "IoT",
            "IoTJobsDataPlane",
            "IoTSecureTunneling",
            "IotData"
        ],
        "iot1click": [
            "IoT1ClickDevicesService",
            "IoT1ClickProjects"
        ],
        "iotanalytics": [
            "IoTAnalytics"
        ],
        "iotdeviceadvisor": [
            "IotDeviceAdvisor"
        ],
        "iotevents": [
            "IoTEventsData"
        ],
        "iotfleethub": [
            "IoTFleetHub"
        ],
        "iotsitewise": [
            "IoTSiteWise"
        ],
        "iotthingsgraph": [
            "IoTThingsGraph"
        ],
        "iottwinmaker": [
            "IoTTwinMaker"
        ],
        "iotwireless": [
            "IoTWireless"
        ],
        "ivs": [
            "IVS"
        ],
        "kafka": [
            "Kafka"
        ],
        "kafkaconnect": [
            "KafkaConnect"
        ],
        "kendra": [
            "Kendra"
        ],
        "kinesis": [
            "Kinesis"
        ],
        "kinesisanalytics": [
            "KinesisAnalyticsV2"
        ],
        "kinesisvideo": [
            "KinesisVideoArchivedMedia",
            "KinesisVideoMedia",
            "KinesisVideoSignalingChannels"
        ],
        "kms": [
            "KMS"
        ],
        "lakeformation": [
            "LakeFormation"
        ],
        "lambda": [
            "Lambda"
        ],
        "lex": [
            "LexModelBuildingService",
            "LexModelsV2",
            "LexRuntime",
            "LexRuntimeV2"
        ],
        "license-manager": [
            "LicenseManager"
        ],
        "lightsail": [
            "Lightsail"
        ],
        "logs": [
            "CloudWatchLogs"
        ],
        "lookoutequipment": [
            "LookoutEquipment"
        ],
        "lookoutmetrics": [
            "LookoutMetrics"
        ],
        "lookoutvision": [
            "LookoutVision"
        ],
        "machinelearning": [
            "MachineLearning"
        ],
        "macie": [
            "Macie"
        ],
        "macie2": [
            "Macie2"
        ],
        "managedblockchain": [
            "ManagedBlockchain"
        ],
        "marketplacecommerceanalytics": [
            "MarketplaceCommerceAnalytics"
        ],
        "mechanicalturk": [
            "MTurk"
        ],
        "mediaconnect": [
            "MediaConnect"
        ],
        "mediaconvert": [
            "MediaConvert"
        ],
        "medialive": [
            "MediaLive"
        ],
        "mediapackage": [
            "MediaPackage"
        ],
        "mediapackage-vod": [
            "MediaPackageVod"
        ],
        "mediastore": [
            "MediaStore",
            "MediaStoreData"
        ],
        "mediatailor": [
            "MediaTailor"
        ],
        "memorydb": [
            "MemoryDB"
        ],
        "mgh": [
            "MigrationHub",
            "MigrationHubConfig"
        ],
        "mgn": [
            "Mgn"
        ],
        "migrationhub-strategy": [
            "MigrationHubStrategy"
        ],
        "mobileanalytics": [
            "MobileAnalytics"
        ],
        "mobilehub": [
            "Mobile"
        ],
        "mobiletargeting": [
            "Pinpoint"
        ],
        "mq": [
            "MQ"
        ],
        "network-firewall": [
            "NetworkFirewall"
        ],
        "networkmanager": [
            "NetworkManager"
        ],
        "nimble": [
            "Nimble"
        ],
        "opsworks": [
            "OpsWorks"
        ],
        "opsworks-cm": [
            "OpsWorksCM"
        ],
        "organizations": [
            "Organizations"
        ],
        "outposts": [
            "Outposts"
        ],
        "panorama": [
            "Panorama"
        ],
        "personalize": [
            "Personalize",
            "PersonalizeEvents",
            "PersonalizeRuntime"
        ],
        "pi": [
            "PI"
        ],
        "polly": [
            "Polly"
        ],
        "pricing": [
            "Pricing"
        ],
        "profile": [
            "CustomerProfiles"
        ],
        "proton": [
            "Proton"
        ],
        "qldb": [
            "QLDB",
            "QLDBSession"
        ],
        "quicksight": [
            "QuickSight"
        ],
        "ram": [
            "RAM"
        ],
        "rbin": [
            "Rbin"
        ],
        "rds": [
            "DocDB",
            "Neptune"
        ],
        "rds-data": [
            "RDSDataService"
        ],
        "redshift": [
            "Redshift"
        ],
        "redshift-data": [
            "RedshiftData"
        ],
        "refactor-spaces": [
            "MigrationHubRefactorSpaces"
        ],
        "rekognition": [
            "Rekognition"
        ],
        "resiliencehub": [
            "Resiliencehub"
        ],
        "resource-groups": [
            "ResourceGroups"
        ],
        "robomaker": [
            "RoboMaker"
        ],
        "route53": [
            "Route53"
        ],
        "route53-recovery-cluster": [
            "Route53RecoveryCluster"
        ],
        "route53-recovery-control-config": [
            "Route53RecoveryControlConfig"
        ],
        "route53-recovery-readiness": [
            "Route53RecoveryReadiness"
        ],
        "route53domains": [
            "Route53Domains"
        ],
        "route53resolver": [
            "Route53Resolver"
        ],
        "rum": [
            "RUM"
        ],
        "s3": [
            "S3",
            "S3Control"
        ],
        "s3-object-lambda": [
            "S3"
        ],
        "s3-outposts": [
            "S3Outposts"
        ],
        "sagemaker": [
            "AugmentedAIRuntime",
            "SageMaker",
            "SageMakerFeatureStoreRuntime",
            "SageMakerRuntime",
            "SagemakerEdge"
        ],
        "savingsplans": [
            "SavingsPlans"
        ],
        "schemas": [
            "Schemas"
        ],
        "sdb": [
            "SimpleDB"
        ],
        "secretsmanager": [
            "SecretsManager"
        ],
        "securityhub": [
            "SecurityHub"
        ],
        "serverlessrepo": [
            "ServerlessApplicationRepository"
        ],
        "servicecatalog": [
            "ServiceCatalogAppRegistry"
        ],
        "servicediscovery": [
            "ServiceDiscovery"
        ],
        "servicequotas": [
            "ServiceQuotas"
        ],
        "ses": [
            "PinpointEmail",
            "SES",
            "SESV2",
            "SESv2"
        ],
        "shield": [
            "Shield"
        ],
        "signer": [
            "Signer"
        ],
        "sms": [
            "SMS"
        ],
        "sms-voice": [
            "PinpointSMSVoice"
        ],
        "snow-device-management": [
            "SnowDeviceManagement"
        ],
        "snowball": [
            "Snowball"
        ],
        "sns": [
            "SNS"
        ],
        "sqs": [
            "SQS"
        ],
        "ssm": [
            "SSM"
        ],
        "ssm-contacts": [
            "SSMContacts"
        ],
        "ssm-incidents": [
            "SSMIncidents"
        ],
        "sso": [
            "SSO",
            "SSOAdmin"
        ],
        "sso-directory": [
            "SSOOIDC"
        ],
        "states": [
            "StepFunctions"
        ],
        "storagegateway": [
            "StorageGateway"
        ],
        "sts": [
            "STS"
        ],
        "support": [
            "Support"
        ],
        "swf": [
            "SimpleWorkflow"
        ],
        "synthetics": [
            "Synthetics"
        ],
        "tag": [
            "ResourceGroupsTaggingAPI"
        ],
        "textract": [
            "Textract"
        ],
        "timestream": [
            "TimestreamQuery",
            "TimestreamWrite"
        ],
        "transcribe": [
            "Transcribe",
            "TranscribeService"
        ],
        "transfer": [
            "Transfer"
        ],
        "translate": [
            "Translate"
        ],
        "voiceid": [
            "VoiceID"
        ],
        "waf": [
            "WAF"
        ],
        "waf-regional": [
            "WAFRegional"
        ],
        "wafv2": [
            "WAFV2"
        ],
        "wellarchitected": [
            "WellArchitected"
        ],
        "wisdom": [
            "Wisdom"
        ],
        "workdocs": [
            "WorkDocs"
        ],
        "worklink": [
            "WorkLink"
        ],
        "workmail": [
            "WorkMail"
        ],
        "workmailmessageflow": [
            "WorkMailMessageFlow"
        ],
        "workspaces": [
            "WorkSpaces"
        ],
        "workspaces-web": [
            "WorkSpacesWeb"
        ],
        "xray": [
            "XRay"
        ]
    }
}